ObjectModel Help

ObjectModel COM
ObjectModel COM
Remarks

This document offers help for the ObjectModel. This model is equally valid for VBA, VSTA, PCE and the extern COM interface.


Constants
ObjectModel COM [image] Constants
Overview

Name

tpAdrMode
tpALCGroundFaultMode
tpALCGroundFaultType
tpALCShortFaultType
tpALCType
tpArvVarCal
tpBatchBoolValue
tpBatchCRState
tpBatchCRStateFilter
tpBatchExecutionMode
tpBatchExecutionState
tpBatchMRState
tpBatchPhaseCommunicationErrorState
tpBatchPhaseEscapeState
tpBatchPhaseExecutionError
tpBatchPhasePlcErrorState
tpBatchPhaseRuntimeEvent
tpBatchPhaseState
tpBatchTagDataType
tpBatchTagType
tpBuildMethod
tpCRCreateResult
tpDatatypes
tpDebugPrintStyle
tpDriverMode
tpDriverStatus
tpDynPicturesTypes
tpFunctionTypes
tpHardcopyOutput
tpKanaltypes
tpLockResult
tpLoginType
tpModulePaths
tpMsgCtrlCelDetail
tpNetSendType
tpPfsData
tpPfsDefaultDays
tpPfsEventTypes
tpPfsLinkTypes
tpPfsTimeTypes
tpProjectNetTypes
tpRecipeRenameResult
tpRema
tpRemoteTransportType
tpRTCustomAction
tpSapActivity
tpSapError
tpScheduleDayType
tpScreenRawEventRouting
tpShiftBreakDeleteResult
tpShiftCalendarSelection
tpShiftDeleteResult
tpShiftModelInsertResult
tpShiftSaveResult
tpStateBit
tpStyleType
tpTaskStatus
tpTaskTyp
tpZenMenus
tpZenPathType
AlarmEventMode
AlarmEventReason
AlcDrainLoadType
AlcLimitCurrentCarryingCapacityType
ArchiveRecordingType
BackgroundGraphicAlignment
CelEventMode
CelEventReason
FrameBorderStyle
IEC_TYPES
ImportArchiveTemplateResult
ImportMdiTemplateItemsResult
LicenseDriver
LicenseLogicDriver
LicenseModule
MessageControlGroupSendingMethod
MessageControlRecipientType
MessageControlSendingMode
RGMRecipeImportCancelStyle
ShowCreateDriverDialogReturnResult
ShowCreateFunctionDialogReturnResult
ShowCreateScreenDialogReturnResult
ShowCreateVariableDialogReturnResult
tpElementTypes
tpGlobalMultiTouchMode
tpLoginResult
tpPfsDayLink
tpRGMRecipeImport
tpRunStates
tpVariableEventModes
tpVisibilityType
UserAdministrationUserType


tpAdrMode
ObjectModel COM [image] Constants [image] tpAdrMode
Overview
Name | Value | Description
tpAdrPacked | 1 | Packed
tpAdrAccType | 2 | Acc Type
tpAdrManual | 3 | Manual


tpALCGroundFaultMode
ObjectModel COM [image] Constants [image] tpALCGroundFaultMode
Overview
Name | Value | Description
tpALCGroundFaultModePart | 0 | Part
tpALCGroundFaultModeFull | 1 | Full


tpALCGroundFaultType
ObjectModel COM [image] Constants [image] tpALCGroundFaultType
Overview
Name | Value | Description
tpALCGroundFaultTypeNone | 0 | None
tpALCGroundFaultTypeTransAdv | 1 | Adv
tpALCGroundFaultTypeTransLag | 2 | Lag
tpALCGroundFaultTypePermAdv | 3 | Perm Adv
tpALCGroundFaultTypePermLag | 4 | Perm Lag


tpALCShortFaultType
ObjectModel COM [image] Constants [image] tpALCShortFaultType
Overview
Name | Value | Description
tpALCShortFaultTypeNone | 0 | None
tpALCShortFaultTypePermAdv | 1 | Perm Adv
tpALCShortFaultTypePermLag | 2 | Perm Lag


tpALCType
ObjectModel COM [image] Constants [image] tpALCType
Overview
Name | Value | Description
tpALCTypeNone | 0 | None
tpALCTypeSource | 1 | Source
tpALCTypeSwitch | 2 | Switch
tpALCTypeSink | 3 | Sink
tpALCTypeTrafo | 4 | Trafo
tpALCTypeLink | 5 | Link
tpALCType_Generator | 6 |
tpALCType_Disconnector | 7 |
tpALCType_Valve | 8 |
tpALCType_Terminator | 9 |
tpALCType_CheckValve | 10 |
tpALCType_Capacitor | 11 |


tpArvVarCal
ObjectModel COM [image] Constants [image] tpArvVarCal
Overview
Name | Value | Description
tpCalc_All | 0 |
tpCalc_Sum | 1 |
tpCalc_Mean | 2 |
tpCalc_Min | 3 |
tpCalc_Max | 4 |


tpBatchBoolValue
ObjectModel COM [image] Constants [image] tpBatchBoolValue
Overview
Name | Value | Description
tpBatchBoolFalse | 0 | Set to false
tpBatchBoolTrue | 1 | Set to true
tpBatchBoolToggle | 2 | Toggle value


tpBatchCRState
ObjectModel COM [image] Constants [image] tpBatchCRState
Overview
Name | Value | Description
tpCRStateCreating | 1 | Creating
tpCRStatePrepared | 2 | Prepared
tpCRStateExecuting | 3 | Executing
tpCRStateExecuted | 4 | Executed,
tpCRStateTerminated | 5 | Terminated
tpCRStateOutdated | 7 | Outdated


tpBatchCRStateFilter
ObjectModel COM [image] Constants [image] tpBatchCRStateFilter
Overview
Name | Value | Description
tpCRStateFilterPrepared | 1 | Prepared
tpCRStateFilterExecuting | 2 | Executing
tpCRStateFilterFinished | 4 | Executed or Terminated
tpCRStateFilterOutdated | 8 | Outdated
tpCRStateFilterAll | 65535 | All


tpBatchExecutionMode
ObjectModel COM [image] Constants [image] tpBatchExecutionMode
Overview
Name | Value | Description
tpExecutionModeAutomatic | 1 | Automatisch
tpExecutionModeSemiAutomatic | 2 | Halbautomatisch
tpExecutionModeManual | 3 | Manuell


tpBatchExecutionState
ObjectModel COM [image] Constants [image] tpBatchExecutionState
Overview
Name | Value | Description
tpExecutionStateIdle | 0 | resetted or aborted or never started
tpExecutionStateRunning | 1 | running the sequence
tpExecutionStateComplete | 2 | sequence is finished
tpExecutionStateStopping | 3 | processing stop
tpExecutionStateStopped | 4 | stopped
tpExecutionStatePausing | 5 | processing pause
tpExecutionStatePaused | 6 | paused
tpExecutionStateHolding | 7 | processing hold
tpExecutionStateHeld | 8 | held
tpExecutionStateAborting | 9 | abort in progress
tpExecutionStateAborted | 10 | aborted
tpExecutionStateRestarting | 11 | restart in progress


tpBatchMRState
ObjectModel COM [image] Constants [image] tpBatchMRState
Overview
Name | Value | Description
tpMRStateCreating | 0 | Erzeugung
tpMRStateEditing | 1 | Editiermodus
tpMRStateApproved | 2 | Freigegeben
tpMRStateTesting | 3 | Testmodus
tpMRStateExecutingTest | 4 | Ausf�hrungsmodus
tpMRStateTerminated | 5 | Abgeschlossen
tpMRStateOutdated | 8 | Veraltet


tpBatchPhaseCommunicationErrorState
ObjectModel COM [image] Constants [image] tpBatchPhaseCommunicationErrorState
Overview
Name | Value | Description
tpCommunicationErrorPending | 0 | The communication error condition of the phase is true - The communication is interrupted
tpCommunicationErrorFixed | 1 | The communication error condition of the phase switched back from true to false, but has not yet been acknowledged
tpCommunicationErrorAcknowledged | 2 | A no longer active communication error has been acknowledged


tpBatchPhaseEscapeState
ObjectModel COM [image] Constants [image] tpBatchPhaseEscapeState
Overview
Name | Value | Description
tpEscapeStarted | 0 | The escape process for the phase has been started
tpEscapeCompleted | 1 | The escape process for the phase has been finished


tpBatchPhaseExecutionError
ObjectModel COM [image] Constants [image] tpBatchPhaseExecutionError
Overview
Name | Value | Description
tpExecutionErrorAllocationTimeout | 0 | Unit allocation was not possible within the timeout
tpExecutionErrorMultipleExecution | 1 | The same phase was started twice
tpExecutionErrorInterlockingTimeout | 2 | The interlocking condition could not be passed within the timeout
tpExecutionErrorWriteCommandTagsTimeout | 3 | Writing the commantags was not possible within the timeout
tpExecutionErrorDoneTimeout | 4 | The done condition could not be passsed within the timeout
tpExecutionErrorFollowingConditionTimeout | 5 | The phase was not deactivated within the timeout
tpExecutionErrorVariableInterruption | 6 | A needed variable was interrupted


tpBatchPhasePlcErrorState
ObjectModel COM [image] Constants [image] tpBatchPhasePlcErrorState
Overview
Name | Value | Description
tpPlcErrorPending | 0 | The PLC error condition is true - The PLC reported an error
tpPlcErrorFixed | 1 | The PlC error condition switched back from true to false - there is no longer an error in the PLC
tpPlcErrorFixedByDeactivation | 2 | The Phase was deactivated while the PLC Error was still active


tpBatchPhaseRuntimeEvent
ObjectModel COM [image] Constants [image] tpBatchPhaseRuntimeEvent
Overview
Name | Value | Description
tpRuntimeShutdown | 0 | A runtime shutdown was triggert while the phase was active
tpRuntimeRestart | 1 | The runtime was started and the execution of this phase was continued, because it was active before shutown


tpBatchPhaseState
ObjectModel COM [image] Constants [image] tpBatchPhaseState
Overview
Name | Value | Description
tpPhaseStateActivated | 0 | Phase was activated
tpPhaseStateUnitAllocationFailed | 1 | First unit allocation failed
tpPhaseStateStarted | 2 | Phase was started - active for the PLC
tpPhaseStateInterlockingBlocked | 3 | Interlocking condition was blocked the first time
tpPhaseStateInterlockingCompleted | 4 | Interlocking condition was passed
tpPhaseStateWritingCommandTagsCompleted | 5 | Writing Command Tags was finished
tpPhaseStateDoneCompleted | 6 | Done condition was passed
tpPhaseStateDeactivated | 7 | Phase was deactivated


tpBatchTagDataType
ObjectModel COM [image] Constants [image] tpBatchTagDataType
Overview
Name | Value | Description
tpTagDataTypeBool | 0 | Bool tag
tpTagDataTypeString | 1 | String tag
tpTagDataTypeNumeric | 2 | Numerical tag
tpTagDataTypeDuration | 3 | Duration tag


tpBatchTagType
ObjectModel COM [image] Constants [image] tpBatchTagType
Overview
Name | Value | Description
tpTagTypeReturn | 0 | Return tag
tpTagTypeInitial | 1 | Inital tag
tpTagTypeValue | 2 | Value Tag


tpBuildMethod
ObjectModel COM [image] Constants [image] tpBuildMethod
Overview
Name | Value | Description
tpAll | 0 | All
tpIncremental | 1 | Incremental


tpCRCreateResult
ObjectModel COM [image] Constants [image] tpCRCreateResult
Overview
Name | Value | Description
tpCRCreateSuccess | 0 | The recipe was created successfully.
tpCRCreateOtherError | 1 | A general error has occured.
tpCRCreateWrongLicense | 2 | You do not have the required license for the operation.
tpCRCreateRecipeNotFound | 3 | The master recipe was not found.
tpCRCreateRecipeWrongState | 4 | The master recipe is in the wrong state. It needs to be "approved" to allow the creation of control recipes.
tpCRCreateRecipeInvalid | 5 | The master recipe is invalid.
tpCRCreateInvalidJobIdVariable | 6 | The job id variable is invalid.
tpCRCreateInvalidJobId | 7 | The job id variable has an invalid value.


tpDatatypes
ObjectModel COM [image] Constants [image] tpDatatypes
Overview
Name | Value | Description
tptypeBIT | 8 | BOOL
tptypeINT_8 | 10 | SINT
tptypeUINT_8 | 9 | USINT
tptypeINT_16 | 1 | INT
tptypeUINT_16 | 2 | UINT
tptypeINT_32 | 3 | DINT
tptypeUINT_32 | 4 | UDINT
tptypeINT_64 | 26 | LINT
tptypeUINT_64 | 27 | ULINT
tptypeFLOAT_REAL | 5 | REAL
tptypeSTRING | 12 | STRING


tpDebugPrintStyle
ObjectModel COM [image] Constants [image] tpDebugPrintStyle
Overview
Name | Value | Description
tpNrm | 16777216 | Show message (black)
tpWarn | 33554432 | Display warning (orange)
tpErr | 67108864 | Show errors (red)
tpMsg | 134217728 | Default style (blue)


tpDriverMode
ObjectModel COM [image] Constants [image] tpDriverMode
Overview
Name | Value | Description
tpSimul | 0 | Simulation
tpHardware | 1 | Hardware


tpDriverStatus
ObjectModel COM [image] Constants [image] tpDriverStatus
Overview
Name | Value | Description
tpStop | 0 | Stop
tpStart | 1 | Start


tpDynPicturesTypes
ObjectModel COM [image] Constants [image] tpDynPicturesTypes
Overview
Name | Value | Description
tpStandard | 0 | Standard
tpListWindow | 1 | Nodepad
tpAML | 2 | Alarm message list
tpArchEdit | 3 | Archive revision
tpCEL | 4 | Chronologic event list
tpETM | 5 | Extended trend
tpVideo | 6 | Video
tpReports | 7 | Report Generator
tpBefehl | 8 | DBAG Command (Sicam 230)
tpBefehlsgabe | 9 | DBAG Command(Sicam 230)
tpStatus | 10 | State (Sicam230)
tpHelp | 11 | Peak Load Projection
tpRGM | 12 | RGM
tpLogin | 13 | Login
tpHTML | 14 | HTML
tpKeyboard | 15 | Keyboard
tpPFS | 16 | Production & Facility Scheduler
tpRezepturen | 17 | Recipe
tpZustand | 18 | State protocol (Sicam 230)
tpWeltbild | 19 | World view
tpBefBewag | 20 | Scripting command output (Sicam 230)
tpVarStatus | 21 | Variable diagnosis
tpSea | 22 | Switching sequence (Sicam 230)
tpASM | 23 | Industrie Performance Analyzer
tpAlmMgmt | 24 | Alarm management (Sicam 230)
tpIMM | 25 | Industrie Maintainance Manager
tpEnergy | 26 | Command input
tpEMS | 27 | Last-Management
tpTimeFilter | 28 | Time filter
tpAlarmFilter | 29 | Alarm Message List Filter
tpCELFilter | 30 | Chronological Event List
tpGraph7 | 31 | S7 graph
tpBatchControl | 32 | Batch
tpReportViewer | 33 | Report viewer
tpMessageControl | 34 | Message control
tpFaceplate | 35 | Faceplate
tpSystemModel | 36 | System Model
tpADUA | 37 | Active Directory User Administration
tpUserList | 38 | Benutzerliste
tpEditUser | 39 | Benutzer editieren
tpGroupList | 40 | Benutzergruppenliste
tpShiftManagement | 41 | Schichtverwaltung
tpSchaltfolgen | 42 | Schaltfolgen
tpMessageBox | 43 | MessageBox
tpTextList | 44 | TextList
tpProcessRecorder | 45 | ProcessRecorder
tpDynPicturesTypes_LoadFlowNMinus1Calculation | 46 |


tpFunctionTypes
ObjectModel COM [image] Constants [image] tpFunctionTypes
Overview
Name | Value | Description
tpPicture | 3 | Screen switch
tpLastPicture | 4 | Screen: Return to last
tpPrintAmlCel | 5 | Print AML or CEL
tpExportAmlCel | 6 | Export AML
tpPrintHardCopy | 8 | Print screenshot
tpAlarmAckBlink | 10 | Alarms: acknowledge flashing
tpExit | 12 | Exit Runtime
tpSendVal | 13 | Write set value
tpPlaySound | 14 | Play audio file
tpExecute | 15 | Start program
tpCloseTemplate | 17 | Close fram
tpReadDBaseFile | 18 | Read dBase file
tpSelectScript | 19 | select online
tpExecuteScript | 20 | execute
tpSwitchOnlinePrint | 22 | Switch online printing onoff
tpPrintActual | 23 | Print current values
tpClosePicture | 26 | Close screen
tpExportData | 29 | Export data
tpSelectRecipeOffline | 30 | Standard recipe single with dialog
tpSelectRecipeOnline | 31 | Standard recipe single with online dialog
tpSelectRecipeDirect | 32 | Standard recipe single directly
tpRedundancySwitch | 33 | Redundancy switch
tpActivateAlarm | 34 | Alarm Message List active
tpDeactivateAlarm | 35 | Alarm Message List inactive
tpActDeactAlarm | 38 | Alarm Message List activeinactive
tpFunctionsOnOff | 42 | Functions activeinactive at limit
tpTrendOnOff | 43 | HD administration inactiveactive
tpTrendOn | 44 | HD administration active
tpTrendOff | 45 | HD administration inactive
tpArchiveStart | 46 | Archive: Start
tpArchiveStop | 47 | Archive: Stop
tpListActiveArchive | 48 | Display open archives
tpFunctionsOn | 51 | Functions active at limit
tpFunctionsOff | 52 | Functions inactive at limit
tpCommandOutput | 60 | SAT function
tpCreateSCProtocol | 61 | SAT function
tpFuncLogin | 70 | Log in with dialog
tpFuncLogout | 71 | Log out
tpChangePassword | 72 | Change password
tpBeepStart | 73 | Start continuous tone
tpBeepFinish | 74 | Stop continuous tone
tpExportCel | 76 | Export CEL
tpPrintReport | 77 | Print Report Generator
tpLoginNoPassword | 78 | Login without password
tpReadTextlist | 79 | Language change
tpExportReport | 80 | Export Report Generator
tpCreateProtocol | 81 | Online printing start new page
tpFileOperation | 82 | File operations
tpDriverCommand | 83 | Driver Commands
tpAlarmAck | 84 | Alarms: acknowledge
tpWindowToBack | 85 | Window to the background
tpWindowToFront | 86 | Window to the foreground
tpTemplateFocusOn | 87 | Set focus to the frame
tpTemplateFocusOff | 88 | Take focus away from frame
tpActivateInput | 91 | Activate input to the element with the focus
tpExecReport | 92 | Report Generator: execute
tpRecipeGroupManager | 93 | Recipegroup Manager
tpExportArchive | 95 | Export archives
tpOverviewWindow | 96 | Show overview window
tpUserEdit | 97 | Change user
tpMonitorAssign | 98 | Monitor assign
tpAlarmsGroupsClasses | 99 | Activatedeactivate Alarm Message List, alarmevent groupsclasses
tpSendMessage | 100 | Send a Message
tpVBAEditor | 101 | Open VBA editor
tpVBAMacroDialog | 102 | Show VBA macro dialog
tpShowPCE | 103 | Open PCE editor
tpVBAExecMacro | 104 | Execute VBA macro
tpNetAuth | 105 | Authorization in the network
tpReloadProject | 106 | Reload project online
tpShowRecipeDB | 107 | Show receiving database
tpSaveAlarms | 108 | Save AML and CEL memory buffer
tpSetFocus | 109 | Move focus
tpPictureIndex | 110 | Screen with index
tpAlarmgroupOnOff | 111 | Alarmevent group log inlog off
tpWriteTime | 112 | Write time to variable
tpReadTime | 113 | Read time from variable
tpDeleteAlarm | 114 | Alarms: delete
tpSendMessageAct | 115 | Send Message: activate
tpSendMessageDeact | 116 | Send Message: deactivate
tpExecPFSEvent | 117 | PFS - execute user-defined event
tpVSTAEditor | 130 | Open VSTA editor
tpVSTAExecMacro | 131 | Execute VSTA macro
tpVSTAMacroDialog | 132 | Show VSTA macro dialog
tpAlignVmImage | 139 | Transfer driver simulation image to the standby
tpSimulation | 141 | Activatedeactivate project simulation
tpSapCallFunction | 149 | Execute SAP function
tpEarthfault | 150 | Earthfault search
tpMsgSuppress | 151 | Groupclassareaequipment suppressed
tpMsgSaveQueue | 152 | Save current queue
tpReportViewerPrint | 153 | Report Viewer: export print
tpBatchStateModeCmd | 154 | Execute recipe command changemode change
tpBatchCreateCr | 155 | Create control recipe
tpTemplateToFront | 156 | Funktion "Schablone in Vordergrund bringen"
tpNewAnalyzerReport | 157 | Create analyzer report
tpDeletePicBackPath | 158 | Delete "picture back" path
tpBatchRcpImportXML | 159 | Import recipes from XML
tpBatchRcpExportXML | 160 | Export selected recipes as XML
tpSequencerCmd | 161 | Perform sequencer command
tpSequencesExportXML | 162 | Export selected command sequences as XML
tpSequencesImportXML | 163 | Import command sequences from XML
tpSequencerTeaching | 164 | Start stop teaching a command sequence
tpMtConcurrentExecution | 165 | Execute parallel commands
tpPRPlaybackMode | 166 | PlaybackMode enabledisable
tpSmSqlExport | 167 | Shift calender SQL export
tpExecuteAddInWizard | 168 | Execute AddIn Wizard
tpManageAddInServices | 169 | Manage AddIn Services
tpFunctionTypes_DisplayLicense | 170 | Display information about the licence
tpFunctionTypes_BatchMasterRecipeRelease | 171 |


tpHardcopyOutput
ObjectModel COM [image] Constants [image] tpHardcopyOutput
Overview
Name | Value | Description
tpBMP | 0 | Imagetype BMP of dynpicture hardcopy(...)


tpKanaltypes
ObjectModel COM [image] Constants [image] tpKanaltypes
Overview
Name | Value | Description
tpControlStatus | 0 | Control Status
tpAdChan | 1 | AdChan
tpDaChan | 2 | DaChan
tpDigital | 3 | Digital
tpFilter | 4 | Filter
tpStrings | 5 | Strings
tpConfigDef | 6 | Congif Def
tpVirtuell | 7 | Virtuell
tpSPSMerker | 8 | SPSMerker
tpSonderMerker | 9 | SonderMerker
tpSPSEingang | 10 | SPSEingang
tpSPSAusgang | 11 | SPSAusgang
tpTimerEvent | 12 | Timer Event
tpTriggerEvent | 13 | Trigger Event
tpInitFile | 14 | Init File
tpDatenbaustein | 15 | Datenbaustein
tpTerminal | 16 | Terminal
tpVirtuellOnlBerechnen | 17 | Calculate Virtuell Online
tpDataTakerChan | 18 | Data Taker Change
tpProgram | 19 | Program
tpSPSDatenRegister | 20 | SPSDatenRegister
tpSPSFileRegister | 21 | SPSFileRegister
tpSPSTimer | 22 | SPSTimer
tpSPSZaehler | 23 | SPSCounter
tpHWStatus | 24 | Hardware State
tpDataBlock | 25 | DataBlock
tpEzObjekt | 32 | EzObject
tpSystemVariable | 33 | SystemVariable
tpExBaustein | 34 | ExBaustein
tpDriverVariable | 35 | DriverVariable
tpSonderMerker1 | 36 | SonderMerker1
tpCsFirst | 64 | CsFirst
tpCsLast | 79 | CsLast
tpCsDialog | 80 | CsDialog
tpCsDaialogLast | 95 | CsDialogLast
tpCsDbFirst | 96 | CsDbFirst
tpCsDbLast | 127 | CsDbLast


tpLockResult
ObjectModel COM [image] Constants [image] tpLockResult
Overview
Name | Value | Description
tpAllowed | 0 | Allowed
tpLocked | 1 | Locked
tpBusy | 2 | Busy


tpLoginType
ObjectModel COM [image] Constants [image] tpLoginType
Overview
Name | Value | Description
tpLoginExternal | 2 | external Login
tpLoginExternalNoLock | 3 | external login without user lockout
tpLoginExternalNoLockNoCel | 4 | silent external login without user lockout


tpModulePaths
ObjectModel COM [image] Constants [image] tpModulePaths
Overview
Name | Value | Description
tpPathGraphic | 0 | Graphic
tpPathExport | 1 | Export
tpPathBMP | 2 | BMP
tpPathAlloc | 3 | Alloc
tpPathList | 4 | List
tpPathMedia | 5 | Media
tpPathReport | 6 | Report
tpPathBackup | 7 | Backup
tpPathExpArchives | 8 | ExpArchives
tpPathLanguage | 9 | Language
tpPathHelp | 10 | Help
tpPathPictures | 11 | Pictures
tpPathPCE | 12 | PCE
tpPathSystem | 13 | System
tpPathVideos | 14 | Videos
tpPathDrivers | 15 | Drivers
tpPathAdditional | 17 | Additional
tpPathRDLC | 18 | RDLC


tpMsgCtrlCelDetail
ObjectModel COM [image] Constants [image] tpMsgCtrlCelDetail
Overview
Name | Value | Description
tpCelDetailAll | 0 | All
tpCelDetailPositiv | 1 | Positive
tpCelDetailNegative | 2 | Negative
tpCelDetailNone | 3 | None


tpNetSendType
ObjectModel COM [image] Constants [image] tpNetSendType
Overview
Name | Value | Description
tpToServer | 0 | To server
tpToStandby | 1 | To standby
tpToAllClients | 2 | To all clients
tpToSpecificClient | 3 | To specific client


tpPfsData
ObjectModel COM [image] Constants [image] tpPfsData
Overview
Name | Value | Description
tpPfsStoredData | 1 |
tpPfsEditData | 2 |


tpPfsDefaultDays
ObjectModel COM [image] Constants [image] tpPfsDefaultDays
Overview
Name | Value | Description
tpPfsMonday | 2 | Monday
tpPfsTuesday | 3 | Tuesday
tpPfsWednesday | 4 | Wednesday
tpPfsThursday | 5 | Thursday
tpPfsFriday | 6 | Friday
tpPfsSaturday | 7 | Saturday
tpPfsSunday | 1 | Sunday
tpPfsHoliday | 8 | Holiday


tpPfsEventTypes
ObjectModel COM [image] Constants [image] tpPfsEventTypes
Overview
Name | Value | Description
tpPfsCycleStart | 1 | Cyclestart
tpPfsCycleStartWithProduction | 2 | Cyclestart with production
tpPfsCycleStartWithoutProduction | 3 | Cyclestart without production
tpPfsProductionStart | 4 | Production start
tpPfsProductionEnd | 5 | Production end
tpPfsShiftStart | 6 | Shift start
tpPfsShiftEnd | 7 | Shift end
tpPfsBreakStart | 8 | Break start
tpPfsBreakEnd | 9 | Break end
tpPfsUserEvent | 10 | User event
tpPfsShiftStartFirstDay | 11 | Shift start first day
tpPfsShiftEndLastDay | 12 | Shift start last day
tpPfsShiftFreeStart | 13 | Shift free start
tpPfsShiftFreeEnd | 14 | Shift free end
tpPfsShiftFreeWithoutProductionEnd | 15 | Shift free without production end
tpPfsShiftFreeWithoutProductionStart | 16 | Shift free without production start
tpPfsShiftFirstDayWithoutProductionStart | 17 | Shift start on first day without production
tpPfsShiftLastDayWithoutProductionEnd | 18 | Shift end on last day without production
tpPfsShiftWithoutProductionStart | 19 | Shift without production start
tpPfsShiftWithoutProductionEnd | 20 | Shift without production end


tpPfsLinkTypes
ObjectModel COM [image] Constants [image] tpPfsLinkTypes
Overview
Name | Value | Description
tpPfsVariable | 32 | Variable
tpPfsFunction | 33 | Function
tpPfsVariableWithMacro | 34 | Variable with Macro
tpPfsFunctionWithMacro | 35 | Function with Macro


tpPfsTimeTypes
ObjectModel COM [image] Constants [image] tpPfsTimeTypes
Overview
Name | Value | Description
tpPfsAbsoluteTime | 149 | PFS Timemodel absolute
tpPfsRelativeTime | 150 | PFS Timemodel relative


tpProjectNetTypes
ObjectModel COM [image] Constants [image] tpProjectNetTypes
Overview
Name | Value | Description
tpMainstation | 0 | Mainstation
tpServer | 1 | Server
tpStandBy | 2 | StandBy
tpClient | 3 | Client


tpRecipeRenameResult
ObjectModel COM [image] Constants [image] tpRecipeRenameResult
Overview
Name | Value | Description
tpRecipeRenameSuccess | 0 | The recipe was renamed successfully.
tpRecipeRenameOtherError | 1 | A general error has occured.
tpRecipeRenameInvalidName | 2 | The new name is not a valid batch recipe name.
tpRecipeRenameDuplicateName | 3 | A recipe with the new name already exists.
tpRecipeRenameRecipeWrongState | 4 | The recipe is not in a state that allows it to be renamed.
tpRecipeRenameNotVersionOne | 5 | It is not the first version of the master recipe, so the name cannot be changed.


tpRema
ObjectModel COM [image] Constants [image] tpRema
Overview
Name | Value | Description
tpBinaer | 1 | Binary
tpAnalog | 2 | Numeric
tpMultiBinaer | 3 | Multi binary
tpMultiAnalog | 4 | Multi numeric
tpString | 5 | String


tpRemoteTransportType
ObjectModel COM [image] Constants [image] tpRemoteTransportType
Overview
Name | Value | Description
tpSerial | 0 | Serial
tpTCP | 1 | TCP


tpRTCustomAction
ObjectModel COM [image] Constants [image] tpRTCustomAction
Overview
Name | Value | Description
tpCopy | 0 | Copy
tpCopyRegister | 1 | Copy Register
tpCopyExecute | 2 | Copy Execute


tpSapActivity
ObjectModel COM [image] Constants [image] tpSapActivity
Overview
Name | Value | Description
tpSapActivity_inactive | 0 | Function not called
tpSapActivity_inqueue | 1 | Function waiting
tpSapActivity_active | 2 | Function active


tpSapError
ObjectModel COM [image] Constants [image] tpSapError
Overview
Name | Value | Description
tpSapError_No_Connection | -1 | No connection to SAP-System
tpSapError_Ok | 0 | OK
tpSapError_Failure | 1 | Error occurred
tpSapError_Exception | 2 | Exception raised
tpSapError_Sys_Exception | 3 | System exception raised, connection closed
tpSapError_Call | 4 | Call received
tpSapError_Internal_Com | 5 | Internal communication, repeat (internal use only)
tpSapError_Closed | 6 | Connection closed by the other side
tpSapError_Retry | 7 | No data yet (RfcListen or RfcWaitForRequest only)
tpSapError_No_Tid | 8 | No Transaction ID available
tpSapError_Executed | 9 | Function already executed
tpSapError_Synchronize | 10 | Synchronous Call in Progress (only for Windows)
tpSapError_Memory_Insufficient | 11 | Memory insufficient
tpSapError_Version_Mismatch | 12 | Version mismatch
tpSapError_Not_found | 13 | Function not found (internal use only)
tpSapError_Call_Not_Supported | 14 | This call is not supported
tpSapError_Not_Owner | 15 | Caller does not own the specified handle
tpSapError_Not_Initialized | 16 | RFC not yet initialized
tpSapError_System_Called | 17 | A system call such as RFC_PING for connection test is executed
tpSapError_Invalid_Handle | 18 | An invalid handle was passed to an API call
tpSapError_Invalid_Parameter | 19 | An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.
tpSapError_Canceled | 20 | An rfc call has been canceled by user
tpSapError_Conversion | 21 | An error during conversion has been detected
tpSapError_Invalid_Protocol | 22 | The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format
tpSapError_Timeout | 23 | Timeout


tpScheduleDayType
ObjectModel COM [image] Constants [image] tpScheduleDayType
Overview
Name | Value | Description
tpScheduleMonday | 0 | Monday
tpScheduleTuesday | 1 | Tuesday
tpScheduleWednesday | 2 | Wednesday
tpScheduleThursday | 3 | Thursday
tpScheduleFriday | 4 | Friday
tpScheduleSaturday | 5 | Saturday
tpScheduleSunday | 6 | Sunday
tpScheduleSpecialDay | 7 | Special Day


tpScreenRawEventRouting
ObjectModel COM [image] Constants [image] tpScreenRawEventRouting
Overview
Name | Value | Description
tpScreenRawEventRoutingDeactivated | 0 | Deactivated
tpScreenRawEventRoutingAllEvents | 1 | All events
tpScreenRawEventRoutingSelectedEvents | 2 | Selected events


tpShiftBreakDeleteResult
ObjectModel COM [image] Constants [image] tpShiftBreakDeleteResult
Overview
Name | Value | Description
tpShiftBreakDeleteSuccess | 0 | The shift break has been deleted successfully.
tpShiftBreakDeleteError | 1 | A general error has occured.
tpShiftBreakDeleteNotFoundError | 2 | The shift break can not be found


tpShiftCalendarSelection
ObjectModel COM [image] Constants [image] tpShiftCalendarSelection
Overview
Name | Value | Description
tpShiftCalendarSelectionNone | 0 | Nothing is selected.
tpShiftCalendarSelectionRange | 1 | The calendar cells are selected.
tpShiftCalendarSelectionShifts | 2 | The calendar shifts are selected.


tpShiftDeleteResult
ObjectModel COM [image] Constants [image] tpShiftDeleteResult
Overview
Name | Value | Description
tpShiftDeleteSuccess | 0 | The shift has been deleted successfully.
tpShiftDeleteError | 1 | A general error has occured.
tpShiftDeleteNotFoundError | 2 | The shift can not be found


tpShiftModelInsertResult
ObjectModel COM [image] Constants [image] tpShiftModelInsertResult
Overview
Name | Value | Description
tpShiftModelInsertSuccess | 0 | The model has been instanciated successfully
tpShiftModelInsertSelectedTimeRangeInvalid | 1 | The selected time range in the calendar is invalid
tpShiftModelInsertModelDoesNotExist | 2 | model does not exist
tpShiftModelInsertTimeout | 3 | acessor to shiftmodels failed to connect
tpShiftModelInsertAtlLeastOneShiftFailed | 4 | one or more shifts failed to create
tpShiftModelInsertSettingsObjectEmpty | 5 | pointer object is null


tpShiftSaveResult
ObjectModel COM [image] Constants [image] tpShiftSaveResult
Overview
Name | Value | Description
tpShiftSaveSuccess | 0 | The shift has been saved successfully.
tpShiftSaveError | 1 | A general error has occured.
tpShiftSaveNameError | 2 | Invalid name
tpShiftSaveRangeError | 3 | Invalid range
tpShiftSaveNotFoundError | 4 | The shift can not be found
tpShiftAtLeastOneBreakIsWrong | 5 | A minimum of one break is not valid


tpStateBit
ObjectModel COM [image] Constants [image] tpStateBit
Overview
Name | Value | Description
tpBitAlarm | 1 | Alarm
tpBitPrint | 4 | Print
tpBitBlink | 8 | Blink
tpBitFkt | 16 | Execute function
tpBitFktQuery | 32 | Execute function query
tpBitNoQuit | 128 | No Quit
tpBitDelete | 256 | Delete
tpBitBtb | 512 | Not real-time
tpBitBtbRt | 1024 | Real-time
tpBitTransparent | 2048 | Transparent
tpBitFktServer | 4096 | Execute function on server
tpBitFktClient | 8192 | Execute function on client
tpBitQuitAlarm | 16384 | Protocol alarm accepted
tpBitOutAlarm | 32768 | Alarm on outgoing alarm


tpStyleType
ObjectModel COM [image] Constants [image] tpStyleType
Overview
Name | Value | Description
tpStyleGroup | 1 | Style group
tpStyleTypeLine | 101 | Style type "Line"
tpStyleTypeFill | 102 | Style type "Fill"
tpStyleTypeRoundCorner | 103 | Style type "Rounding"
tpStyleTypeGlowEffect | 104 | Style type "Glow Effect"
tpStyleTypeText | 105 | Style type "Text"
tpStyleTypeShadow | 106 | tpStyleTypeShadow
tpStyleTypeFrame | 107 | Style type "Frame"
tpStyleTypeScale | 108 | tpStyleTypeScale
tpStyleTypePadding | 109 | tpStyleTypePadding
tpStyleTypeTime | 110 | Style type "Time"
tpStyleTypeValue | 111 | Style type "Value"
tpStyleTypeUniversalSlider | 112 | Style type "Universal Slider"
tpStyleType_Curve | 113 |


tpTaskStatus
ObjectModel COM [image] Constants [image] tpTaskStatus
Overview
Name | Value | Description
tpStopTask | 0 | Stop
tpInitTask | 1 | Initialize
tpRunTask | 2 | Run


tpTaskTyp
ObjectModel COM [image] Constants [image] tpTaskTyp
Overview
Name | Value | Description
tpCycleTask | 0 | Cyclic
tpCallTask | 1 | Once


tpZenMenus
ObjectModel COM [image] Constants [image] tpZenMenus
Overview
Name | Value | Description
tpVariable | 2 | Variable
tpRtFunction | 1 | RtFunction
tpVbaMacro | 3 | VbaMacro
tpZenHelp | 6 | ZenHelp


tpZenPathType
ObjectModel COM [image] Constants [image] tpZenPathType
Overview
Name | Value | Description
tpzenOnIniPath | 0 | Ini Path
tpzenOnExePath | 1 | Exe Path
tpzenOnUserPath | 2 | User Path
tpzenOnAppDataPath | 3 | AppData Path


AlarmEventMode
ObjectModel COM [image] Constants [image] AlarmEventMode
Overview
Name | Value | Description
AlarmEventMode_Single | 0 | each change is reported separately
AlarmEventMode_BulkAsXml | 1 | changes as reported as bulk formatted in XML


AlarmEventReason
ObjectModel COM [image] Constants [image] AlarmEventReason
Overview
Name | Value | Description
AlarmEventReason_New | 0 | alarm entry is new
AlarmEventReason_Changed | 1 | alarm entry is changed
AlarmEventReason_Deleted | 2 | alarm entry is deleted


AlcDrainLoadType
ObjectModel COM [image] Constants [image] AlcDrainLoadType
Overview
Name | Value | Description
AlcDrainLoadType_HistoricMaximum | 0 |
AlcDrainLoadType_HistoricAverage | 1 |
AlcDrainLoadType_Actual | 2 |


AlcLimitCurrentCarryingCapacityType
ObjectModel COM [image] Constants [image] AlcLimitCurrentCarryingCapacityType
Overview
Name | Value | Description
AlcLimitCurrentCarryingCapacityType_Static | 0 |
AlcLimitCurrentCarryingCapacityType_Dynamic | 1 |


ArchiveRecordingType
ObjectModel COM [image] Constants [image] ArchiveRecordingType
Overview
Name | Value | Description
ArchiveRecordingType_Invalid | 0 |
ArchiveRecordingType_Cyclic | 1 |
ArchiveRecordingType_EventTriggered | 2 |
ArchiveRecordingType_OnChange | 3 |


BackgroundGraphicAlignment
ObjectModel COM [image] Constants [image] BackgroundGraphicAlignment
Overview
Name | Value | Description
BackgroundGraphicAlignment_Normal | 0 |
BackgroundGraphicAlignment_Adjust | 1 |
BackgroundGraphicAlignment_Tiled | 2 |
BackgroundGraphicAlignment_Centered | 3 |


CelEventMode
ObjectModel COM [image] Constants [image] CelEventMode
Overview
Name | Value | Description
CelEventMode_Single | 0 | each change is reported separately
CelEventMode_BulkAsXml | 1 | changes as reported as bulk formatted in XML


CelEventReason
ObjectModel COM [image] Constants [image] CelEventReason
Overview
Name | Value | Description
CelEventReason_New | 0 | cel entry is new
CelEventReason_Changed | 1 | cel entry is changed
CelEventReason_Deleted | 2 | cel entry is deleted


FrameBorderStyle
ObjectModel COM [image] Constants [image] FrameBorderStyle
Overview
Name | Value | Description
FrameBorderStyle_NoBorder | 0 |
FrameBorderStyle_SizeAdjustable | 1 |
FrameBorderStyle_SizeFixed | 2 |


IEC_TYPES
ObjectModel COM [image] Constants [image] IEC_TYPES
Overview
Name | Value | Description
IEC_BOOL | 8 |
IEC_SINT | 10 |
IEC_INT | 1 |
IEC_DINT | 3 |
IEC_LINT | 26 |
IEC_USINT | 9 |
IEC_UINT | 2 |
IEC_UDINT | 4 |
IEC_ULINT | 27 |
IEC_REAL | 5 |
IEC_LREAL | 6 |
IEC_TIME | 17 |
IEC_DATE | 18 |
IEC_TOD | 19 |
IEC_DT | 20 |
IEC_STRING | 12 |
IEC_BYTE | 22 |
IEC_WORD | 23 |
IEC_DWORD | 24 |
IEC_LWORD | 25 |
IEC_WSTRING | 21 |
CD_FLOAT_LONG | 7 |
CD_FLOAT_IEEE | 11 |
CD_ARCHIVDATENART | 13 |
CD_VOIDARRAY | 14 |
SAT_TOP_WORT_4 | 15 |
SAT_TOP_STRANG_WORT_4 | 16 |


ImportArchiveTemplateResult
ObjectModel COM [image] Constants [image] ImportArchiveTemplateResult
Overview
Name | Value | Description
ImportArchiveTemplateResult_Successful | 0 |
ImportArchiveTemplateResult_ArchiveInvalid | -1 |
ImportArchiveTemplateResult_FileNotFound | -3 |
ImportArchiveTemplateResult_ImportFailed | -4 |
ImportArchiveTemplateResult_LanguageMismatch | -5 |


ImportMdiTemplateItemsResult
ObjectModel COM [image] Constants [image] ImportMdiTemplateItemsResult
Overview
Name | Value | Description
ImportMdiTemplateItemsResult_Successful | 0 |
ImportMdiTemplateItemsResult_ScreenNotFound | -1 |
ImportMdiTemplateItemsResult_NoMdiScreen | -2 |
ImportMdiTemplateItemsResult_FileNotFound | -3 |
ImportMdiTemplateItemsResult_ImportFailed | -4 |
ImportMdiTemplateItemsResult_FileNameScreenTypeOrLanguageDifferent | -5 |
ImportMdiTemplateItemsResult_CommonErrorOccurred | -6 |
ImportMdiTemplateItemsResult_NotSupported | -7 |


LicenseDriver
ObjectModel COM [image] Constants [image] LicenseDriver
Overview
Name | Value | Description
LicenseDriver_Driver3964R32 | 72 |
LicenseDriver_Driver3S_32 | 23 |
LicenseDriver_Driver3S_Arti | 24 |
LicenseDriver_Driver3S_Arti_NG | 168 |
LicenseDriver_Driver3S_V3 | 254 |
LicenseDriver_DriverADP | 284 |
LicenseDriver_DriverAIOLED32 | 116 |
LicenseDriver_DriverAK_DRV | 113 |
LicenseDriver_DriverALLANBNT | 4 |
LicenseDriver_DriverAllenDF1 | 5 |
LicenseDriver_DriverAMISTS | 244 |
LicenseDriver_DriverAPLCOM32 | 9 |
LicenseDriver_DriverArchDRV | 11 |
LicenseDriver_DriverARCNET_95 | 117 |
LicenseDriver_DriverARCNET_NT | 2 |
LicenseDriver_DriverAzureDrv | 265 |
LicenseDriver_DriverBachmann | 12 |
LicenseDriver_DriverBACnet32 | 106 |
LicenseDriver_DriverBACnetNG | 197 |
LicenseDriver_DriverBCI_32 | 13 |
LicenseDriver_DriverBECKH_32 | 16 |
LicenseDriver_DriverBeckhBc32 | 105 |
LicenseDriver_DriverBeckhNG | 164 |
LicenseDriver_DriverBeckhTc32 | 15 |
LicenseDriver_DriverBiffiDCM32 | 181 |
LicenseDriver_DriverBQLJX00 | 206 |
LicenseDriver_DriverBQLSX00 | 205 |
LicenseDriver_DriverBrmDrv32 | 211 |
LicenseDriver_DriverBrTcp32 | 19 |
LicenseDriver_DriverBuderus32 | 22 |
LicenseDriver_DriverBUR20032 | 18 |
LicenseDriver_DriverBuR41xx32 | 201 |
LicenseDriver_DriverBURPVI | 198 |
LicenseDriver_DriverCAN | 279 |
LicenseDriver_DriverCAS50032 | 185 |
LicenseDriver_DriverCCF | 118 |
LicenseDriver_DriverCEMPI32 | 75 |
LicenseDriver_DriverCIF32 | 114 |
LicenseDriver_DriverCIFMPI32 | 36 |
LicenseDriver_DriverCOMLI | 276 |
LicenseDriver_DriverCommend32 | 119 |
LicenseDriver_DriverCP001_32 | 48 |
LicenseDriver_DriverCS31_32 | 1 |
LicenseDriver_DriverCTI | 200 |
LicenseDriver_DriverDanfoss_32 | 26 |
LicenseDriver_DriverDAQ2K32 | 46 |
LicenseDriver_DriverdataTaker32 | 25 |
LicenseDriver_DriverDATEI32 | 27 |
LicenseDriver_DriverDCA_MW32 | 210 |
LicenseDriver_DriverDCFDRV | 120 |
LicenseDriver_DriverDDE_Client32 | 97 |
LicenseDriver_DriverDMX512 | 30 |
LicenseDriver_DriverDNP3_NG | 248 |
LicenseDriver_DriverDNP3_TG | 262 |
LicenseDriver_DriverDNP332 | 167 |
LicenseDriver_DriverDprVis32 | 7 |
LicenseDriver_DriverDPUNI32 | 67 |
LicenseDriver_DriverEasy32 | 166 |
LicenseDriver_DriverECSGW32 | 28 |
LicenseDriver_DriverEibus_32 | 121 |
LicenseDriver_DriverEIBV2_32 | 88 |
LicenseDriver_DriverElrest32 | 31 |
LicenseDriver_DriverESA32 | 163 |
LicenseDriver_DriverESSER32 | 100 |
LicenseDriver_DriverEUCHNER32 | 29 |
LicenseDriver_DriverExportSQL32 | 216 |
LicenseDriver_DriverFefDrv32 | 32 |
LicenseDriver_DriverFFCDRV32 | 39 |
LicenseDriver_DriverFMS_95 | 122 |
LicenseDriver_DriverFMS_NT | 66 |
LicenseDriver_DriverFOPDRV32 | 40 |
LicenseDriver_DriverFpcDrv32 | 33 |
LicenseDriver_DriverFRAPORT | 208 |
LicenseDriver_Driverfuturit32 | 101 |
LicenseDriver_DriverFWP223_32 | 148 |
LicenseDriver_DriverGE_SRTP | 280 |
LicenseDriver_DriverHeka_32 | 92 |
LicenseDriver_DriverHITACHI | 37 |
LicenseDriver_DriverHMI32 | 35 |
LicenseDriver_DriverHOFBUS | 253 |
LicenseDriver_DriverHuberDKZ32 | 123 |
LicenseDriver_DriverHuberMT32 | 124 |
LicenseDriver_DriverHuberPls32 | 125 |
LicenseDriver_DriverHydrometer32 | 209 |
LicenseDriver_DriverIBHRTSPS | 45 |
LicenseDriver_DriverIdec32 | 42 |
LicenseDriver_DriverIEC61499 | 202 |
LicenseDriver_DriverIEC61850 | 195 |
LicenseDriver_DriverIEC62056 | 183 |
LicenseDriver_DriverIEC850 | 169 |
LicenseDriver_DriverIEC870 | 38 |
LicenseDriver_DriverIEC870_10332 | 180 |
LicenseDriver_DriverILON100 | 90 |
LicenseDriver_DriverINTEGRA | 267 |
LicenseDriver_DriverInter_95 | 126 |
LicenseDriver_DriverINTER_NT | 47 |
LicenseDriver_DriverIntern | 115 |
LicenseDriver_DriverISPIP | 290 |
LicenseDriver_DriverJETTER | 194 |
LicenseDriver_DriverKabaDPServer | 266 |
LicenseDriver_DriverKDNP1 | 275 |
LicenseDriver_DriverKemroUserID32 | 182 |
LicenseDriver_DriverKetop | 49 |
LicenseDriver_DriverKieback | 93 |
LicenseDriver_DriverKOYO32 | 51 |
LicenseDriver_DriverKuka32 | 247 |
LicenseDriver_Driverlambda | 127 |
LicenseDriver_DriverLogiCAD_32 | 50 |
LicenseDriver_DriverLOGIX_ODVA | 193 |
LicenseDriver_DriverLogix32 | 6 |
LicenseDriver_DriverLON_32 | 89 |
LicenseDriver_DriverLS_XGT32 | 215 |
LicenseDriver_DriverMasterbus32 | 274 |
LicenseDriver_DriverMATHDR32 | 96 |
LicenseDriver_DriverMATSU32 | 55 |
LicenseDriver_DriverMATSUTCP32 | 56 |
LicenseDriver_DriverMB_32 | 59 |
LicenseDriver_DriverMBUS32 | 91 |
LicenseDriver_DriverMC_MTRL_01 | 107 |
LicenseDriver_DriverMELSECA | 57 |
LicenseDriver_DriverMEMORY32 | 108 |
LicenseDriver_DriverMETRAWATT | 246 |
LicenseDriver_DriverMINI32 | 17 |
LicenseDriver_DriverMITSUBISHI_FX32 | 58 |
LicenseDriver_DriverMODBUS_ENERGY | 192 |
LicenseDriver_DriverModicon32 | 60 |
LicenseDriver_DriverMODRTU32 | 34 |
LicenseDriver_DriverMODRTU32LISTEN | 109 |
LicenseDriver_DriverMPC_PCI_32 | 173 |
LicenseDriver_DriverMPC32 | 128 |
LicenseDriver_DriverMtoM32 | 129 |
LicenseDriver_DriverMvled32 | 130 |
LicenseDriver_DriverNMEA2000 | 277 |
LicenseDriver_DriverNwmDRV | 131 |
LicenseDriver_DriverOMR_FINS | 63 |
LicenseDriver_DriverOMRON32 | 62 |
LicenseDriver_DriverOmronEIP | 291 |
LicenseDriver_DriverOpc2Cli32 | 64 |
LicenseDriver_DriverOpcCli32 | 132 |
LicenseDriver_DriverOPCUA32 | 191 |
LicenseDriver_DriverOsai32 | 188 |
LicenseDriver_DriverOTIS | 99 |
LicenseDriver_DriverPadNetNT | 3 |
LicenseDriver_DriverPadNetPciNT | 8 |
LicenseDriver_DriverPCS807_32 | 53 |
LicenseDriver_DriverPCS812 | 52 |
LicenseDriver_DriverPhloem | 285 |
LicenseDriver_DriverPhoenix32 | 190 |
LicenseDriver_DriverPIO16 | 133 |
LicenseDriver_DriverPIO16PCI | 134 |
LicenseDriver_DriverPIO32 | 135 |
LicenseDriver_DriverPio8 | 136 |
LicenseDriver_DriverPK_DRV32 | 137 |
LicenseDriver_DriverPOZYTON | 287 |
LicenseDriver_DriverPrismic | 283 |
LicenseDriver_DriverPSS32 | 65 |
LicenseDriver_DriverPSUNI32 | 61 |
LicenseDriver_DriverReflect | 204 |
LicenseDriver_DriverREIS32 | 110 |
LicenseDriver_DriverRemoteRT | 264 |
LicenseDriver_DriverRTK900032 | 184 |
LicenseDriver_DriverS432 | 70 |
LicenseDriver_DriverS5ARC32 | 10 |
LicenseDriver_DriverS5H1_NT | 43 |
LicenseDriver_DriverS5PG32 | 73 |
LicenseDriver_DriverS5TCP32 | 44 |
LicenseDriver_DriverS7_200 | 80 |
LicenseDriver_DriverS7_32 | 138 |
LicenseDriver_DriverS7_MPIISA | 54 |
LicenseDriver_DriverS7_NT | 77 |
LicenseDriver_DriverS7AC41x32 | 78 |
LicenseDriver_DriverS7DCOS | 111 |
LicenseDriver_DriverS7MPI_95 | 147 |
LicenseDriver_DriverS7PC32 | 157 |
LicenseDriver_DriverS7SPONT | 219 |
LicenseDriver_DriverS7TCP32 | 76 |
LicenseDriver_DriverS7TIA | 273 |
LicenseDriver_DriverS800_32 | 71 |
LicenseDriver_DriverSAIA_Directly32 | 69 |
LicenseDriver_DriverSAIA_Slave | 146 |
LicenseDriver_DriverSAIA2ND32 | 68 |
LicenseDriver_DriverSAIA32 | 98 |
LicenseDriver_DriverSample32 | 286 |
LicenseDriver_DriverSanors32 | 162 |
LicenseDriver_DriverSAPP32 | 82 |
LicenseDriver_DriverSE_32 | 139 |
LicenseDriver_DriverSEL | 278 |
LicenseDriver_DriverSIGMA32 | 81 |
LicenseDriver_DriverSigmaLasal32 | 158 |
LicenseDriver_DriverSigmasys | 104 |
LicenseDriver_DriverSimotion | 172 |
LicenseDriver_DriverSIMUL32 | 95 |
LicenseDriver_DriverSipa_32 | 112 |
LicenseDriver_DriverSnmp32 | 83 |
LicenseDriver_DriverSNMPNG32 | 261 |
LicenseDriver_DriverSPC_95 | 140 |
LicenseDriver_DriverSPC_NT | 86 |
LicenseDriver_DriverSPRECON870 | 207 |
LicenseDriver_DriverSQIDrv | 141 |
LicenseDriver_DriverSQLDRV | 84 |
LicenseDriver_DriverSST32 | 85 |
LicenseDriver_DriverSTERIFLOW | 245 |
LicenseDriver_Driverstraton32 | 74 |
LicenseDriver_DriverstratonNG | 199 |
LicenseDriver_DriverSYS2000 | 20 |
LicenseDriver_DriverSYS2000LOG | 21 |
LicenseDriver_DriverSYSDRV | 94 |
LicenseDriver_DriverSyskron_LDS | 103 |
LicenseDriver_DriverTelco_32 | 142 |
LicenseDriver_DriverTELEKOM32 | 143 |
LicenseDriver_DriverTELEPERM_32 | 79 |
LicenseDriver_DriverTI5_32 | 102 |
LicenseDriver_DriverTLS32 | 220 |
LicenseDriver_DriverTrend32 | 87 |
LicenseDriver_DriverTrendNG | 203 |
LicenseDriver_DriverUPM_32 | 14 |
LicenseDriver_DriverVDMALaetus | 196 |
LicenseDriver_DriverVIPA32 | 165 |
LicenseDriver_DriverVipDrv32 | 41 |
LicenseDriver_DriverVMS_INDUS | 144 |
LicenseDriver_DriverWayPhone | 145 |


LicenseLogicDriver
ObjectModel COM [image] Constants [image] LicenseLogicDriver
Overview
Name | Value | Description
LicenseLogicDriver_DriverK5Bus62056 | 255 |
LicenseLogicDriver_DriverK5Bus850_90_5 | 268 |
LicenseLogicDriver_DriverK5Bus870S101 | 176 |
LicenseLogicDriver_DriverK5Bus870S104 | 177 |
LicenseLogicDriver_DriverK5Bus870Slave | 189 |
LicenseLogicDriver_DriverK5BusAdam | 221 |
LicenseLogicDriver_DriverK5BusAnyCompactCom | 222 |
LicenseLogicDriver_DriverK5BusApax | 223 |
LicenseLogicDriver_DriverK5BusAppIO | 150 |
LicenseLogicDriver_DriverK5BusAsi | 151 |
LicenseLogicDriver_DriverK5BusBeckAds | 251 |
LicenseLogicDriver_DriverK5BusBNMSTPS | 224 |
LicenseLogicDriver_DriverK5BusCAN | 225 |
LicenseLogicDriver_DriverK5BusCANOpen | 226 |
LicenseLogicDriver_DriverK5BusCX1100 | 179 |
LicenseLogicDriver_DriverK5BusDF1Half | 256 |
LicenseLogicDriver_DriverK5BusDNP3M | 227 |
LicenseLogicDriver_DriverK5BusDNP3MCD | 288 |
LicenseLogicDriver_DriverK5BusDNP3S | 228 |
LicenseLogicDriver_DriverK5BusDNP3SCD | 289 |
LicenseLogicDriver_DriverK5BusDNP3SL3 | 214 |
LicenseLogicDriver_DriverK5BusDNP3SL3V2 | 229 |
LicenseLogicDriver_DriverK5BusEIPC | 230 |
LicenseLogicDriver_DriverK5BusEIPFIO | 231 |
LicenseLogicDriver_DriverK5BusEIPS | 232 |
LicenseLogicDriver_DriverK5BusEIPTag | 233 |
LicenseLogicDriver_DriverK5BusEther | 234 |
LicenseLogicDriver_DriverK5busethercat | 282 |
LicenseLogicDriver_DriverK5BusEV3 | 263 |
LicenseLogicDriver_DriverK5BusEXGIO | 269 |
LicenseLogicDriver_DriverK5BusExI2C | 270 |
LicenseLogicDriver_DriverK5BusExPBCIFXSLV | 271 |
LicenseLogicDriver_DriverK5BusGPIO | 257 |
LicenseLogicDriver_DriverK5BusHMS | 159 |
LicenseLogicDriver_DriverK5BusIec850m | 187 |
LicenseLogicDriver_DriverK5BusIec850s | 186 |
LicenseLogicDriver_DriverK5BusIec870m | 212 |
LicenseLogicDriver_DriverK5BusINTERBUS | 161 |
LicenseLogicDriver_DriverK5BusIOTools | 152 |
LicenseLogicDriver_Driverk5busj1939 | 281 |
LicenseLogicDriver_DriverK5BusMailbox | 272 |
LicenseLogicDriver_DriverK5BusMBMaster | 155 |
LicenseLogicDriver_DriverK5BusMBSlave | 156 |
LicenseLogicDriver_DriverK5BusMdio | 259 |
LicenseLogicDriver_DriverK5BusMECS7 | 260 |
LicenseLogicDriver_DriverK5BusNetX | 178 |
LicenseLogicDriver_DriverK5BusNXT20 | 249 |
LicenseLogicDriver_DriverK5BusOPC | 235 |
LicenseLogicDriver_DriverK5BusOPCUA_s | 292 |
LicenseLogicDriver_DriverK5BusOPCUASrv | 241 |
LicenseLogicDriver_DriverK5BusOpenEPL | 236 |
LicenseLogicDriver_DriverK5BusPhasor | 213 |
LicenseLogicDriver_DriverK5BusPNIODev | 243 |
LicenseLogicDriver_DriverK5BusProfCifx | 252 |
LicenseLogicDriver_DriverK5BusProfDP | 149 |
LicenseLogicDriver_DriverK5BusProfNetIO | 174 |
LicenseLogicDriver_DriverK5BusQBF | 218 |
LicenseLogicDriver_DriverK5BusS7mEC | 217 |
LicenseLogicDriver_DriverK5BusSCADOC | 258 |
LicenseLogicDriver_DriverK5BusShm | 170 |
LicenseLogicDriver_DriverK5BusShm2 | 250 |
LicenseLogicDriver_DriverK5BusSoftNet | 171 |
LicenseLogicDriver_DriverK5BusSycon | 153 |
LicenseLogicDriver_DriverK5BusSyconUni | 175 |
LicenseLogicDriver_DriverK5BusWago | 237 |
LicenseLogicDriver_DriverK5BusWinPac | 238 |
LicenseLogicDriver_DriverK5BusWSM | 242 |
LicenseLogicDriver_DriverK5BusXFLOW | 239 |
LicenseLogicDriver_DriverK5ThinkIO | 160 |
LicenseLogicDriver_DriverK5WagoTools | 240 |
LicenseLogicDriver_DriverK5ZenOnRT | 154 |


LicenseModule
ObjectModel COM [image] Constants [image] LicenseModule
Overview
Name | Value | Description
LicenseModule_Edition | 0 |
LicenseModule_DemoConfigurationLevel | 1 |
LicenseModule_ScadaVersion | 2 |
LicenseModule_NumberOfRuntimeTags | 3 |
LicenseModule_ClientOnly | 4 |
LicenseModule_NoClient | 5 |
LicenseModule_SingleProcessScreen | 6 |
LicenseModule_AutomaticLineColoringWithLoadFlowCalculation | 7 |
LicenseModule_MessageControl | 8 |
LicenseModule_RecipeGroupManager | 9 |
LicenseModule_ProcessRecorder | 10 |
LicenseModule_Integration3D | 11 |
LicenseModule_ExtendedTrend | 12 |
LicenseModule_Historian | 13 |
LicenseModule_HistorianAndExtendedTrendStarterEdition | 14 |
LicenseModule_ReportGeneratorAndReportViewer | 15 |
LicenseModule_SapInterface | 16 |
LicenseModule_SqlExport | 17 |
LicenseModule_HistorianSqlServerInterface | 18 |
LicenseModule_IndustrialMaintenanceManager | 19 |
LicenseModule_IndustrialPerformanceAnalyzer | 20 |
LicenseModule_PlcDiagnosis | 21 |
LicenseModule_AutomaticLineColoring | 22 |
LicenseModule_ProductionAndFacilityScheduler | 23 |
LicenseModule_BatchControlMatrixView | 24 |
LicenseModule_CommandSequencer | 25 |
LicenseModule_LoadManagement | 26 |
LicenseModule_LogicWorkbenchEdition | 27 |
LicenseModule_AutomaticLineColoringWithStateEstimator | 28 |
LicenseModule_AutomaticLineColoringForEnergyEdition | 29 |
LicenseModule_AutomaticLineColoringWithTopologyPackage | 30 |
LicenseModule_GeoInformationSystemsIntegration | 31 |
LicenseModule_EverywhereServerStandard | 32 |
LicenseModule_NumberOfDriversInPriceGroupsABCR | 33 |
LicenseModule_NumberOfDriversInPriceGroupsABC | 34 |
LicenseModule_NumberOfDriversInPriceGroupA | 35 |
LicenseModule_NumberOfDriversInPriceGroupB | 36 |
LicenseModule_NumberOfDriversInPriceGroupC | 37 |
LicenseModule_NumberOfDriversInPriceGroupR | 38 |
LicenseModule_NumberOfLogicTags | 39 |
LicenseModule_NumberOfDriversInPriceGroupsSTU | 40 |
LicenseModule_NumberOfDriversInPriceGroupS | 41 |
LicenseModule_NumberOfDriversInPriceGroupT | 42 |
LicenseModule_NumberOfDriversInPriceGroupU | 43 |
LicenseModule_Sicam230Topology | 44 |
LicenseModule_Sicam230CommandSequencesSimulation | 45 |
LicenseModule_Sicam230AlarmManagement | 46 |
LicenseModule_Sicam230FailureLocationFromProtection | 47 |
LicenseModule_Sicam230PowerDistributionCalculation | 48 |
LicenseModule_Sicam230ManagementOfSwitchingRequests | 49 |
LicenseModule_Sicam230EasyEnergyReports | 50 |
LicenseModule_ProcessGatewayOpcUaServer | 51 |
LicenseModule_ProcessGatewayModbusSlave | 52 |
LicenseModule_ProcessGatewaySqlOnline | 53 |
LicenseModule_ProcessGatewayDecSlave | 54 |
LicenseModule_ProcessGatewayDnp3SlaveOutstation | 55 |
LicenseModule_ProcessGatewaySnmpServerAgent | 56 |
LicenseModule_ProcessGatewayAzure | 57 |
LicenseModule_ProcessGatewayIec60870Slave | 58 |
LicenseModule_ProcessGatewayIccpIec60870Part6Tase2 | 59 |
LicenseModule_ProcessGatewayDcaDanieliGatewayFull | 60 |
LicenseModule_ProcessGatewayOpcDaServer | 61 |
LicenseModule_ProcessGatewayDcaDanieliGatewayLight | 62 |
LicenseModule_WebServerConfigurationLevel | 63 |
LicenseModule_WebServerNumberOfClients | 64 |
LicenseModule_WebEngineConfigurationLevel | 65 |
LicenseModule_WebEngineNumberOfInstances | 66 |
LicenseModule_AnalyzerNumberOfClients | 67 |
LicenseModule_AnalyzerVersion | 68 |
LicenseModule_AnalyzerHistorianAnalysis | 69 |
LicenseModule_AnalyzerAlarmAndEventAnalysis | 70 |
LicenseModule_AnalyzerOeeAnalysis | 71 |
LicenseModule_AnalyzerExtendedHistorianAnalysis | 72 |
LicenseModule_AnalyzerCustomFormulaAnalysis | 73 |
LicenseModule_AnalyzerIso50001Analysis | 74 |
LicenseModule_AnalyzerProductionAnalysisMachineBased | 75 |
LicenseModule_AnalyzerTargetActualAnalysis | 76 |
LicenseModule_AnalyzerHydroelectricPowerPlantAnalysis | 77 |
LicenseModule_AnalyzerProductionAnalysisLineBased | 78 |
LicenseModule_AnalyzerEfficiencyClassAnalysis | 79 |
LicenseModule_AnalyzerEnergyDataManagementAnalysis | 80 |
LicenseModule_AnalyzerWindPowerPlantAnalysis | 81 |
LicenseModule_AnalyzerStatisticalAnalysis | 82 |
LicenseModule_AnalyzerPredictiveAnalytics | 83 |
LicenseModule_Custom0 | 84 |
LicenseModule_Custom1 | 85 |
LicenseModule_Custom2 | 86 |
LicenseModule_BatchControlProceduralFunctionChartView | 87 |
LicenseModule_Sicam230EegManager | 88 |


MessageControlGroupSendingMethod
ObjectModel COM [image] Constants [image] MessageControlGroupSendingMethod
Overview
Name | Value | Description
MessageControlGroupSendingMethod_GroupCall | 0 |
MessageControlGroupSendingMethod_FollowingCall | 1 |
MessageControlGroupSendingMethod_EndlessFollowingCall | 2 |


MessageControlRecipientType
ObjectModel COM [image] Constants [image] MessageControlRecipientType
Overview
Name | Value | Description
MessageControlRecipientType_UserGroup | 2 |
MessageControlRecipientType_User | 3 |
MessageControlRecipientType_UserGroupWithShiftFilter | 7 |


MessageControlSendingMode
ObjectModel COM [image] Constants [image] MessageControlSendingMode
Overview
Name | Value | Description
MessageControlSendingMode_Undefined | 0 |
MessageControlSendingMode_MailViaOutlook | 1 |
MessageControlSendingMode_VoiceAudioFileViaModem | 3 |
MessageControlSendingMode_SMSViaGSMModem | 5 |
MessageControlSendingMode_VoiceTextToSpeechViaModem | 6 |
MessageControlSendingMode_SMSViaSMSServer | 8 |
MessageControlSendingMode_MailViaSMTP | 9 |
MessageControlSendingMode_VoiceOverIPAudio | 10 |
MessageControlSendingMode_VoiceOverIPTextToSpeech | 11 |


RGMRecipeImportCancelStyle
ObjectModel COM [image] Constants [image] RGMRecipeImportCancelStyle
Overview
Name | Value | Description
RGMRecipeImportCancelStyle_Import | 0 |
RGMRecipeImportCancelStyle_CancelRecipeImport | 1 |
RGMRecipeImportCancelStyle_CancelRecipeGroupImport | 2 |


ShowCreateDriverDialogReturnResult
ObjectModel COM [image] Constants [image] ShowCreateDriverDialogReturnResult
Overview
Name | Value | Description
ShowCreateDriverDialogReturnResult_Successful | 0 |
ShowCreateDriverDialogReturnResult_UndefinedError | 1 |


ShowCreateFunctionDialogReturnResult
ObjectModel COM [image] Constants [image] ShowCreateFunctionDialogReturnResult
Overview
Name | Value | Description
ShowCreateFunctionDialogReturnResult_Successful | 0 |
ShowCreateFunctionDialogReturnResult_UndefinedError | 1 |


ShowCreateScreenDialogReturnResult
ObjectModel COM [image] Constants [image] ShowCreateScreenDialogReturnResult
Overview
Name | Value | Description
ShowCreateScreenDialogReturnResult_Successful | 0 |
ShowCreateScreenDialogReturnResult_UndefinedError | 1 |


ShowCreateVariableDialogReturnResult
ObjectModel COM [image] Constants [image] ShowCreateVariableDialogReturnResult
Overview
Name | Value | Description
ShowCreateVariableDialogReturnResult_Successful | 0 |
ShowCreateVariableDialogReturnResult_UndefinedError | 1 |


tpElementTypes
ObjectModel COM [image] Constants [image] tpElementTypes
Overview
Name | Value | Description
tpDynBargraph | 0 | Bar display
tpDynZahlenElem | 1 | Numerical value
tpDynText | 2 | Dynamic text
tpDynTrend | 4 | Trend element
tpDynZeiger | 5 | Pointer instrument
tpDynBewegt | 6 | Only for compatibility
tpDynBinaer | 7 | Status element
tpDynBitmap | 8 | Only for compatibility
tpDynVerkn | 9 | Only for compatibility
tpDynButton | 10 | Button
tpDynSchalter | 11 | Switch
tpDynMultibin | 12 | Multibin
tpDynMeldung | 13 | Message element
tpDynUhr | 14 | Clock
tpDynBefMdi | 15 | Only for compatibility
tpDynStatus | 16 | Combined Element
tpDynBaButton | 17 | Only for compatibility
tpDynControl | 18 | Only for compatibility
tpDynAegel | 19 | Only for compatibility
tpDynActiveX | 20 | ActiveX
tpDynTopLgt | 21 | Only for compatibility
tpDynTopStrg | 22 | Only for compatibility
tpDynInstrument | 23 | Universal slider
tpDynCombiList | 24 | tpDynCombiList
tpDynWindows | 25 | Only for compatibility
tpDynListbox | 26 | Only for compatibility
tpDynCombobox | 27 | Only for compatibility
tpDynListCtrl | 28 | Only for compatibility
tpDynWPF | 29 | WPF element
tpDynGFXListCtrl | 30 | Only for compatibility
tpDynListCtrlNoH | 31 | Only for compatibility
tpDynMarker | 32 | Only for compatibility
tpDynBatchParamList | 33 | Batch Param List
tpDynBatchRecipeFrame | 34 | Batch Recipe Frame
tpDynPictureContainer | 35 | Picture Container
tpElementTypes_ShiftCalendar | 36 |
tpElementTypes_ReportViewer | 37 |
tpDot | 100 | Only for compatibility
tpLine | 101 | Line
tpRectangle | 102 | Rectangle
tpCircle | 103 | EllipseCircle
tpPolyLine | 104 | Polyline
tpText | 107 | Static text
tpArc | 108 | Arc of a circle
tpSolid | 109 | Only for compatibility
tpTraceDr | 111 | Only for compatibility
tpKegel | 114 | Only for compatibility
tpFillPara | 115 | Only for compatibility
tpFillTria | 116 | Only for compatibility
tpFillBlock | 117 | Only for compatibility
tpPie | 121 | Only for compatibility
tpRoundRect | 127 | Only for compatibility
tpPolygon | 128 | Polygon
tpSymbol | 129 | Embedded symbol
tpSymbolLnk | 130 | Linked symbol
tpSegme_Dxf | 131 | Segment of a circle
tpWMF | 133 | Only for compatibility
tpEMF | 134 | Only for compatibility
tpWinkel | 135 | Only for compatibility
tpPipe | 136 | Pipe


tpGlobalMultiTouchMode
ObjectModel COM [image] Constants [image] tpGlobalMultiTouchMode
Overview
Name | Value | Description
tpGMTNone | 0 | Multi-Touch recognition: deactivated
tpGMTWindows7 | 1 | Multi-Touch recoginition: Windows 7
tpGMTWindows8 | 2 | Multi-Touch recognition: Windows8


tpLoginResult
ObjectModel COM [image] Constants [image] tpLoginResult
Overview
Name | Value | Description
tpLoginOk | 0 | Login Ok
tpWrongUser | 1 | Wrong user
tpWrongPassword | 2 | Wrong password
tpWrongUserSystemLocked | 3 | Wrong user - System locked
tpSystemLocked | 4 | System locked
tpUserLocked | 5 | User locked
tpWrongPasswordUserLocked | 6 | Wrong password - User locked
tpPasswordExpired | 7 | Password expired
tpUserDeactivated | 8 | User deactivated
tpSamePassword | 9 | Same Password
tpInvalidConfirmation | 10 | Invalid Confirmation
tpPasswordTooShort | 11 | Password Too Short
tpDefaultError | 255 | Default Error


tpPfsDayLink
ObjectModel COM [image] Constants [image] tpPfsDayLink
Overview
Name | Value | Description
tpPfsExecute | 48 | Execute
tpPfsSkip | 49 | Skip
tpPfsDefaultDay | 50 | Default day
tpPfsDefaultHDay | 51 | Default HDay
tpPfsUnused | 52 | Unused


tpRGMRecipeImport
ObjectModel COM [image] Constants [image] tpRGMRecipeImport
Overview
Name | Value | Description
tpOverwriteRecipe | 0 | Overwrite Recipe
tpCreateNewRecipe | 1 | Create New Recipe
tpValuesDiffer | 2 | Values Differ


tpRunStates
ObjectModel COM [image] Constants [image] tpRunStates
Overview
Name | Value | Description
tpRS_proc | 0 | Proc
tpRS_2proc | 1 | To proc
tpRS_2sim | 2 | To sim
tpRS_simul | 3 | Simul
tpRS_sim2sim | 4 | Sim to Sim
tpRS_PrPlayback | 5 | Process Recorder Playback


tpVariableEventModes
ObjectModel COM [image] Constants [image] tpVariableEventModes
Overview
Name | Value | Description
tpEvmSingle | 0 |
tpEvmSharedMemory | 1 |
tpEvmBulk | 2 |


tpVisibilityType
ObjectModel COM [image] Constants [image] tpVisibilityType
Overview
Name | Value | Description
tpFromVariable | 0 | Visibility FromVariable
tpFromInterlocking | 1 | Visibility FromInterlocking


UserAdministrationUserType
ObjectModel COM [image] Constants [image] UserAdministrationUserType
Overview
Name | Value | Description
UserAdministrationUserType_User | 0 |
UserAdministrationUserType_Administrator | 1 |
UserAdministrationUserType_PowerUser | 2 |


Alarm
ObjectModel COM [image] Alarm
Remarks

Provides access to the alarm control system, active alarms and their current status. alarm events can be used to directly react toany occuring new alarm messages.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
void ThisProject_Active()
{
    //Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

    //Assign the alarm object and init event handlers
    this.zenonAlarm = this.Alarm();
    this.zenonAlarm.AlarmComes += new AlarmComesEventHandler(zenonAlarm_AlarmComes);
    this.zenonAlarm.AlarmGoes += new AlarmGoesEventHandler(zenonAlarm_AlarmGoes);
    this.zenonAlarm.AlarmAcknowledged += new AlarmAcknowledgedEventHandler(zenonAlarm_AlarmAcknowledged);
}

void ThisProject_Inactive()
{
    //Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

    //Unregister any previously registered event
    zenonAlarm.AlarmAcknowledged -= new AlarmAcknowledgedEventHandler(zenonAlarm_AlarmAcknowledged);
    zenonAlarm.AlarmComes -= new AlarmComesEventHandler(zenonAlarm_AlarmComes);
    zenonAlarm.AlarmGoes -= new AlarmGoesEventHandler(zenonAlarm_AlarmGoes);

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}

//procedure is executed when an Alarm comes
void zenonAlarm_AlarmComes(IAlarmItem obItem)
{
    //print specific information to Debug window...
    Debug.Print("{0} > {1}", obItem.Timecomes, obItem.Text);
}

//procedure is executed when an Alarm has gone
void zenonAlarm_AlarmAcknowledged(IAlarmItem obItem)
{
    //print specific information to Debug window
    Debug.Print("{0} < {1}", obItem.TimeAcknowledged, obItem.Text);
}

//procedure is executed when an Alarm was acknowledged by a user
void zenonAlarm_AlarmGoes(IAlarmItem obItem)
{
    //print specific information to Debug window
    Debug.Print("{0} | {1}", obItem.Timegoes, obItem.Text);
}
VB.NET
Copy
Private zenonAlarm As IAlarm

Private Sub ThisProject_Active()
    'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )
    ' << TODO: Add Initialization code here >>

    'Assign the alarm object and init event handlers
    Me.zenonAlarm = Me.Alarm()
    AddHandler Me.zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes
    AddHandler Me.zenonAlarm.AlarmGoes, AddressOf zenonAlarm_AlarmGoes
    AddHandler Me.zenonAlarm.AlarmAcknowledged, AddressOf zenonAlarm_AlarmAcknowledged
End Sub

Private Sub ThisProject_Inactive()
    'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    ' << TODO: Add Clean-up code here >>

    'Unregister any previously registered event
    RemoveHandler zenonAlarm.AlarmAcknowledged, AddressOf zenonAlarm_AlarmAcknowledged
    RemoveHandler zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes
    RemoveHandler zenonAlarm.AlarmGoes, AddressOf zenonAlarm_AlarmGoes

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub
'procedure is executed when an Alarm comes
Private Sub zenonAlarm_AlarmComes(ByVal obItem As IAlarmItem)
    'print specific information to Debug window...
    Debug.Print("{0} > {1}", obItem.Timecomes, obItem.Text)
End Sub

'procedure is executed when an Alarm has gone
Private Sub zenonAlarm_AlarmAcknowledged(ByVal obItem As IAlarmItem)
    'print specific information to Debug window
    Debug.Print("{0} < {1}", obItem.TimeAcknowledged, obItem.Text)
End Sub

'procedure is executed when an Alarm was acknowledged by a user
Private Sub zenonAlarm_AlarmGoes(ByVal obItem As IAlarmItem)
    'print specific information to Debug window
    Debug.Print("{0} | {1}", obItem.Timegoes, obItem.Text)
End Sub
VBA
Copy
Dim WithEvents zAlarm As Alarm
'procedure is executed on startup of the zenOn runtime
Private Sub Project_Active()
'init the alarm object for events
Set zAlarm = thisProject.Alarm
End Sub
'procedure is executed when an Alarm comes
Private Sub zAlarm_AlarmComes(ByVal obItem As IAlarmItem)
'print specific information to Debug window...
Debug.Print obItem.Timecomes & " > " & obItem.Text
End Sub
'procedure is executed when an Alarm has gone
Private Sub zAlarm_AlarmGoes(ByVal obItem As IAlarmItem)
'print specific information to Debug window...
Debug.Print obItem.Timegoes & " < " & obItem.Text
End Sub
'procedure is executed when an Alarm was acknowledged by a user
Private Sub zAlarm_AlarmAcknowledged(ByVal obItem As IAlarmItem)
'print specific information to Debug window...
Debug.Print obItem.TimeAcknowledged & " | " & obItem.Text
End Sub
'procedure is executed on terminating the zenOn Runtime
Private Sub Project_Inactive()
'free the alarm object
Set zAlarm = Nothing
End Sub


Properties
ObjectModel COM [image] Alarm [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Aktiv | variant_bool | Alarm-module in-/active | Unused | Readonly | Available | Available
Parent | iproject | Parent-object | Readonly | Readonly | Available | Available


Aktiv
ObjectModel COM [image] Alarm [image] Properties [image] Aktiv
Remarks

Returns the status of the alarm administration. If the value is True, the alarms administration is active. If it is not active the alarm buffer cannot be extended, i.e. no further alarms occur. It does not influence clearing existing alarms. De/activating the alarms administration is possible with the following functions of the control system: · Alarms active · Alarms inactive · Alarms active/inactive · Alarms/groups/classes

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Alarm [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Alarm [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AlarmAcknowledge | variant_bool | Acknowledge alarm with given parameters | Unused | Available | Available | Available
AlarmItems | ialarmitems | Returns the alarm-items objects | Unused | Readonly | Available | Available
AlarmItemsAsXml | bstr | Returns the alarm-items as XML | Unused | Readonly | Available | Available
DynProperties [GET] | variant | <span"></span> | Available | Available | Available | Available
DynProperties [PUT] | void | With DynProperties it is possible to get access to additional Properties/Methods of Objects. | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | Returns a StringArray of all Dynproperties available for this Object. | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available
OnlineAlarmCollection [GET] | ionlinealarmcollection | Returns the OnlineAlarms object. | Unused | Readonly | Available | Available
ResetQueryFilter | void | Resets the QueryFilter | Unused | Readonly | Available | Available


AlarmAcknowledge
ObjectModel COM [image] Alarm [image] Methods [image] AlarmAcknowledge
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
szAmlKey as BSTR

szUser as BSTR

szComputer as BSTR


AlarmItems
ObjectModel COM [image] Alarm [image] Methods [image] AlarmItems
Remarks

This method returns the object AlarmItems of the alarming module. In this collection all existing alarms are listed. With the method Item you can access single alarms. The single alarm entries contain information on the alarms.Filter String:If the string is not "*", then the string should represent the name (case sensitive) of a zenon function.If a function with the given name exists, the filter settings within this function will be used.--> only version 6.51 and above.

Datatype
IAlarmItems

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
strFilter as BSTR

Example
C#
Copy
public void MacroGetAlarmItems()
{
    IAlarm zenonAlarm = this.Alarm();
    IAlarmItems zenonAlarmItems = zenonAlarm.AlarmItems("*");
    for (int i = 0; i < zenonAlarmItems.Count; ++i)
    {
        IAlarmItem zenonAlarmItem = zenonAlarmItems.Item(i);
        PrintAlarm(zenonAlarmItem);
    }
}

private void PrintAlarm(IAlarmItem alarm)
{
    Debug.Print("TimeComes : " + alarm.Timecomes);
    Debug.Print("TimeGoes : " + alarm.Timegoes);
    Debug.Print("TimeAcknowledged : " + alarm.TimeAcknowledged);
    Debug.Print("Text : " + alarm.Text);
    Debug.Print("Variable : " + alarm.Variable().Name);
    Debug.Print("Value : " + alarm.Value);
}
VB.NET
Copy
'  Displays the amount of alarms currently in memory and
' *  the alarm text of all the different alarms.
'

Public Sub MacroGetAlarmItems()
    'Get alarm object(s) from active project
    Dim zenonAlarm As IAlarm = Me.Alarm()
    Dim zenonAlarmItems As IAlarmItems = zenonAlarm.AlarmItems("*")

    MessageBox.Show(String.Format("{0} Alarms in memory...", zenonAlarmItems.Count))

    'get text of active alarms...
    For i As Integer = 0 To zenonAlarmItems.Count - 1
        Dim zenonAlarmItem As IAlarmItem = zenonAlarmItems.Item(i)
        Debug.Print(zenonAlarmItem.Text)
    Next
End Sub
VBA
Copy
Public Sub GetAlarmItems()
Dim zAML As Alarm
Dim zAML_Items As AlarmItems
Dim zAML_Item As AlarmItem
Dim i As Integer
'set alarm objects
Set zAML = thisProject.Alarm
   'get all items
Set zAML_Items = zAML.AlarmItems("*")
   'get specific item using the screen switch function as filter
   '
Set zAML_Items = zAML.AlarmItems("myFunction")
'get count of active alarms...
MsgBox zAML_Items.Count & " Alarms in memory..."
'get text of active alarms...
For i = 0 To zAML_Items.Count - 1

Set zAML_Item = zAML_Items.Item(i)

Debug.Print zAML_Item.Text
Next i
End Sub


AlarmItemsAsXml
ObjectModel COM [image] Alarm [image] Methods [image] AlarmItemsAsXml
Remarks

Returns an XML encoded string of the AlarmItems

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
strFilter as BSTR


DynProperties [GET]
ObjectModel COM [image] Alarm [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] Alarm [image] Methods [image] DynProperties [PUT]
Remarks

With DynProperties it is possible to get access to additional Properties/Methods of Objects.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property. Example: "NetActive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

Example
VBA
Copy
Sub SetDynProp()
'Sample: Set the Network Aktive Flag of the Project. MyWorkspace.ActiveDocument.DynProperties("NetActive") = True 'also set a computer as server... MyWorkspace.ActiveDocument.DynProperties("NetServer") = "COMPUTERNAME"
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] Alarm [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Returns a StringArray of all Dynproperties available for this Object.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the entry point to get out all available properties of the object.

Example
VBA
Copy
Sub ReadDynProps() Dim vProps As VariantDim i As Integer'get all

DynProperties of the actual object (DynPicture, Element, ...) vProps = zenOnObject.DynPropertiesEnum("")
'Print informations of DynProperties into output window
For i = 0

To UBound(vProps) Debug.Print vProps(i)
Next i
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] Alarm [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.


OnlineAlarmCollection [GET]
ObjectModel COM [image] Alarm [image] Methods [image] OnlineAlarmCollection [GET]
Remarks

Returns the OnlineAlarms object.

Datatype
IOnlineAlarmCollection

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ResetQueryFilter
ObjectModel COM [image] Alarm [image] Methods [image] ResetQueryFilter
Remarks

Specify AML filter or set default value.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
//Manipulation using the query filter
Project.Aml.ResetQueryFilter()
Project.Aml.SetDynProp(„QueryFilter.XXX", ZZZ)
//get items using the query filter
Project.Aml.AmlItems(„.")


Events
ObjectModel COM [image] Alarm [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AlarmAcknowledged | void | Event: Is fired by alarm acknowledged... | Unused | Available | Available | Available
AlarmComes | void | Event: Is fired by alarm coming... | Unused | Available | Available | Available
AlarmGoes | void | Event: Is fired by alarm going... | Unused | Available | Available | Available
AlarmListSelectionChanged | void | Event: Is fired when the selection in the alarmlist has changed... | Unused | Available | Available | Available
AlarmUsertextChanged | void | Event: Is fired when the usertext has changed... | Unused | Available | Available | Available
SelectionChangedEx | void | Event: selection array in the alarm list has been changed... | Unused | Readonly | Available | Available


AlarmAcknowledged
ObjectModel COM [image] Alarm [image] Events [image] AlarmAcknowledged
Remarks

This Event is fired when an alarm was acknowledged by a user.To get these Event, an Object has to be declared and initialised

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obItem as IAlarmItem

The returned object is an object of type AlarmItem and has all properties and methods like the original AlarmItem object.

Example
C#
Copy
private IAlarm zenonAlarm;

void zenonAlarm_AlarmAcknowledged(IAlarmItem obItem)
{
    //print specific information to Debug window
    Debug.Print("{0} < {1}", obItem.TimeAcknowledged, obItem.Text);
}

void ThisProject_Inactive()
{
    //Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    // << TODO: Add Clean-up code here >>
    //Unregister previously registered event handler
    zenonAlarm.AlarmAcknowledged -= zenonAlarm_AlarmAcknowledged;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}

void ThisProject_Active()
{
    //Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )
    // << TODO: Add Initialization code here >>
    //Assign the alarm object and init event handler
    this.zenonAlarm = this.Alarm();
    this.zenonAlarm.AlarmAcknowledged += new AlarmAcknowledgedEventHandler(zenonAlarm_AlarmAcknowledged);
}
VB.NET
Copy
Private zenonAlarm As IAlarm

Private Sub zenonAlarm_AlarmAcknowledged(obItem As IAlarmItem)
    'print specific information to Debug window
    Debug.Print("{0} < {1}", obItem.TimeAcknowledged, obItem.Text)
End Sub

Private Sub ThisProject_Inactive()
    'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    ' << TODO: Add Clean-up code here >>
    'Unregister previously registered event handler
    RemoveHandler zenonAlarm.AlarmAcknowledged, AddressOf zenonAlarm_AlarmAcknowledged

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub

Private Sub ThisProject_Active()
    'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )
    ' << TODO: Add Initialization code here >>
    'Assign the alarm object and init event handler
    Me.zenonAlarm = Me.Alarm()
    AddHandler Me.zenonAlarm.AlarmAcknowledged AddressOf zenonAlarm_AlarmAcknowledged
End Sub
VBA
Copy
Dim WithEvents zAlarm As Alarm
Private Sub Project_Active()
Set zAlarm = thisProject.Alarm
End Sub
Private Sub zAlarm_AlarmAcknowledged(ByVal obItem As IAlarmItem)
Debug.Print obItem.Text
End Sub


AlarmComes
ObjectModel COM [image] Alarm [image] Events [image] AlarmComes
Remarks

Returns the alarm-items objects, Event is fired when an Alarm comes up...To get these Event, an Object has to be declared and initialised

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obItem as IAlarmItem

Returns an Object of Type AlarmItem (The AlarmItem which comes up)

Example
C#
Copy
private IAlarm zenonAlarm;

void zenonAlarm_AlarmComes(IAlarmItem obItem)
{
    //print specific information to Debug window...
    Debug.Print("{0} > {1}", obItem.Timecomes, obItem.Text);
}

void ThisProject_Active()
{
    //Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )
    //Assign the alarm object and init event handler
    this.zenonAlarm = this.Alarm();
    this.zenonAlarm.AlarmComes += new AlarmComesEventHandler(zenonAlarm_AlarmComes);
}

void ThisProject_Inactive()
{
    //Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    //Unregister previously registered event handler
    zenonAlarm.AlarmComes -= new AlarmComesEventHandler(zenonAlarm_AlarmComes);

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}
VB.NET
Copy
Private zenonAlarm As IAlarm

Private Sub zenonAlarm_AlarmComes(obItem As IAlarmItem)
    'print specific information to Debug window...
    Debug.Print("{0} > {1}", obItem.Timecomes, obItem.Text)
End Sub

Private Sub ThisProject_Active()
    'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )
    ' << TODO: Add Initialization code here >>

    'Assign the alarm object and init event handler
    Me.zenonAlarm = Me.Alarm()
    AddHandler Me.zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes
End Sub

Private Sub ThisProject_Inactive()
    'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    ' << TODO: Add Clean-up code here >>

    'Unregister previously registered event handler
    RemoveHandler zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub
VBA
Copy
Dim WithEvents zAlarm As Alarm
Private Sub Project_Active()
Set zAlarm = thisProject.Alarm
End Sub
Private Sub zAlarm_AlarmComes(ByVal obItem As IAlarmItem)
Debug.Print obItem.Text
End Sub


AlarmGoes
ObjectModel COM [image] Alarm [image] Events [image] AlarmGoes
Remarks

This Event is fired when an alarm has been gone.To get these Event, an Object has to be declared and initialised.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obItem as IAlarmItem

Returns an Object of Type AlarmItem (The AlarmItem which has gone)

Example
C#
Copy
private IAlarm zenonAlarm;

void zenonAlarm_AlarmGoes(IAlarmItem obItem)
{
    //print specific information to Debug window
    Debug.Print("{0} | {1}", obItem.Timegoes, obItem.Text);
}

void ThisProject_Inactive()
{
    //Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

    //Unregister previously registered event handler
    zenonAlarm.AlarmGoes -= new AlarmGoesEventHandler(zenonAlarm_AlarmGoes);

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}

void ThisProject_Active()
{
    //Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

    //Assign the alarm object and init event handler
    this.zenonAlarm = this.Alarm();
    this.zenonAlarm.AlarmGoes += new AlarmGoesEventHandler(zenonAlarm_AlarmGoes);
}
VB.NET
Copy
Private zenonAlarm As IAlarm

Private Sub zenonAlarm_AlarmGoes(obItem As IAlarmItem)
    'print specific information to Debug window
    Debug.Print("{0} | {1}", obItem.Timegoes, obItem.Text)
End Sub

Private Sub ThisProject_Inactive()
    'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

    'Unregister previously registered event handler
    RemoveHandler zenonAlarm.AlarmGoes, AddressOf zenonAlarm_AlarmGoes

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub

Private Sub ThisProject_Active()
    'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

    'Assign the alarm object and init event handler
    Me.zenonAlarm = Me.Alarm()
    AddHandler Me.zenonAlarm.AlarmGoes, AddressOf zenonAlarm_AlarmGoes
End Sub
VBA
Copy
Dim WithEvents zAlarm As Alarm
Private Sub Project_Active()
Set zAlarm = thisProject.Alarm
End Sub
Private Sub zAlarm_AlarmGoes(ByVal obItem As IAlarmItem)
Debug.Print obItem.Text
End Sub


AlarmListSelectionChanged
ObjectModel COM [image] Alarm [image] Events [image] AlarmListSelectionChanged
Remarks

The event will be fired whenever the Selection in the list is changed, when an item is selected the Entry will be passed on through the zenon-API. When an item has been deselected, the eventparameter will be "Nothing".Additionally the event will be triggered whenever an AML/CEL picture is closed. (This could lead the event being triggered twice with "Nothing").NOTE: When the Property "hide current selection" has been set at the listcontrol, the event will/should not be fired(!)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obItem as IAlarmItem

The returned object is an object of type AlarmItem and has all properties and methods like the original AlarmItem object.

Example
C#
Copy
private IAlarm zenonAlarm;

void ThisProject_Active()
{
    //Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

    //Assign the alarm object and init event handlers
    this.zenonAlarm = this.Alarm();
    this.zenonAlarm.AlarmListSelectionChanged += new AlarmListSelectionChangedEventHandler(zenonAlarm_AlarmListSelectionChanged);
}

void ThisProject_Inactive()
{
    //Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    this.zenonAlarm.AlarmListSelectionChanged -= zenonAlarm_AlarmListSelectionChanged;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}

void zenonAlarm_AlarmListSelectionChanged(IAlarmItem obItem)
{
    if (obItem != null) //Note: If the parameter object ist null an object was deselected
    {
        Debug.Print("AlarmListSelectionChanged: {0}", obItem.Text);
    }
}
VB.NET
Copy
Private zenonAlarm As IAlarm

Private Sub ThisProject_Active()
    'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

    'Assign the alarm object and init event handlers
    Me.zenonAlarm = Me.Alarm()
    AddHandler Me.zenonAlarm.AlarmListSelectionChanged, AddressOf zenonAlarm_AlarmListSelectionChanged
End Sub

Private Sub ThisProject_Inactive()
    'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    RemoveHandler Me.zenonAlarm.AlarmListSelectionChanged, AddressOf zenonAlarm_AlarmListSelectionChanged

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub

Private Sub zenonAlarm_AlarmListSelectionChanged(obItem As IAlarmItem)
    If obItem IsNot Nothing Then
        'Note: If the parameter object ist null an object was deselected
        Debug.Print("AlarmListSelectionChanged: {0}", obItem.Text)
    End If
End Sub
VBA
Copy
Private Sub zAMLPIC_Open()
'boolen flag to remember the open event
bAML = True
'init AML Object to get the AlarmListSelectionChanged event
Set zAML = thisProject.Alarm
End Sub
Private Sub zAMLPIC_Close()
'release object
Set zAML = Nothing
End Sub
Private Sub zAML_AlarmListSelectionChanged(ByVal obItem As IAlarmItem)
'If the boolen is TRUE, the first events can be ignored
'because in this case the events returns the default
'selection on opening the picture
If bAML = True Then

bAML = False
Else

If obItem Is Nothing Then Exit Sub

Debug.Print "A_Changed - " & obItem.Text
End If
End Sub


AlarmUsertextChanged
ObjectModel COM [image] Alarm [image] Events [image] AlarmUsertextChanged
Remarks

Event is triggered if an entry is made in the AML list in the column for comments. The entried string is transferred to the event, where it can be manipulated and is afterwards entried in the column for comments. For CEL comments, an event should be analogically built in, as well.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsText as BSTR

Example
C#
Copy
private IAlarm zenonAlarm;

void ThisProject_Active()
{
    //Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

    //Assign the alarm object and init event handlers
    this.zenonAlarm = this.Alarm();
    this.zenonAlarm.AlarmUsertextChanged += new AlarmUsertextChangedEventHandler(zenonAlarm_AlarmUsertextChanged);
}

void ThisProject_Inactive()
{
    //Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    this.zenonAlarm.AlarmUsertextChanged -= zenonAlarm_AlarmUsertextChanged;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}
void zenonAlarm_AlarmUsertextChanged(ref string bsText)
{
    //Just print out the new text
    Debug.Print(bsText);
}
VB.NET
Copy
Private zenonAlarm As IAlarm

Private Sub ThisProject_Active()
    'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

    'Assign the alarm object and init event handlers
    Me.zenonAlarm = Me.Alarm()
    AddHandler Me.zenonAlarm.AlarmUsertextChanged, AddressOf zenonAlarm_AlarmUsertextChanged
End Sub

Private Sub ThisProject_Inactive()
    'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    RemoveHandler Me.zenonAlarm.AlarmUsertextChanged, AddressOf zenonAlarm_AlarmUsertextChanged

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub
Private Sub zenonAlarm_AlarmUsertextChanged(ByRef bsText As String)
    'Just print out the new text
    Debug.Print(bsText)
End Sub
VBA
Copy
Dim WithEvents zAlarm As Alarm
Private Sub Project_Active()
    Set zAlarm = thisProject.Alarm
End Sub
Private Sub zAlarm_AlarmUsertextChanged(bsText As String)
    bsText = bsText & "Projekt-Zeit"
End Sub


SelectionChangedEx
ObjectModel COM [image] Alarm [image] Events [image] SelectionChangedEx
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
arrSelection as LPVARIANT


DynProperties
ObjectModel COM [image] Alarm [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Alarm


Alarm
ObjectModel COM [image] Alarm [image] DynProperties [image] Alarm
Overview
External Name | Type | Display Name | Description
QueryFilter |  | QueryFilter |


AlarmItem
ObjectModel COM [image] AlarmItem
Remarks

The object AlarmItem contains information on an alarm. The different items can be accessed with the method Alarm of the current project. The returned object contains the collection AlarmItems, which lists every single alarm in the project.If the object Alarm was defined with WithEvents (Or has assigned event handlers in C#), the events for received/cleared/acknowledged alarms are executed. Those events have a AlarmItem object as a parameter.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroGetAlarmItems()
{
    IAlarm zenonAlarm = this.Alarm();
    IAlarmItems zenonAlarmItems = zenonAlarm.AlarmItems("*");
    for (int i = 0; i < zenonAlarmItems.Count; ++i)
    {
        IAlarmItem zenonAlarmItem = zenonAlarmItems.Item(i);
        PrintAlarm(zenonAlarmItem);
    }
}

private void PrintAlarm(IAlarmItem alarm)
{
    Debug.Print("TimeComes : " + alarm.Timecomes);
    Debug.Print("TimeGoes : " + alarm.Timegoes);
    Debug.Print("TimeAcknowledged : " + alarm.TimeAcknowledged);
    Debug.Print("Text : " + alarm.Text);
    Debug.Print("Variable : " + alarm.Variable().Name);
    Debug.Print("Value : " + alarm.Value);
}
VB.NET
Copy
Public Sub MacroGetAlarmItems()
    Dim zenonAlarm As IAlarm = Me.Alarm()
    Dim zenonAlarmItems As IAlarmItems = zenonAlarm.AlarmItems("*")
    For i As Integer = 0 To zenonAlarmItems.Count - 1
        Dim zenonAlarmItem As IAlarmItem = zenonAlarmItems.Item(i)
        PrintAlarm(zenonAlarmItem)
    Next
End Sub

Private Sub PrintAlarm(alarm As IAlarmItem)
    Debug.Print("TimeComes : " & Convert.ToString(alarm.Timecomes))
    Debug.Print("TimeGoes : " & Convert.ToString(alarm.Timegoes))
    Debug.Print("TimeAcknowledged : " & Convert.ToString(alarm.TimeAcknowledged))
    Debug.Print("Text : " & Convert.ToString(alarm.Text))
    Debug.Print("Variable : " + alarm.Variable().Name)
    Debug.Print("Value : " & Convert.ToString(alarm.Value))
End Sub
VBA
Copy
Public Sub GetAlarmItems()
Dim zAML As Alarm
Dim zAML_Items As AlarmItems
Dim zAML_Item As AlarmItem
Dim i As Integer
'set alarm objects
Set zAML = thisProject.Alarm
Set zAML_Items = zAML.AlarmItems("*")
'get text of active alarms...
For i = 0 To zAML_Items.Count - 1
Set zAML_Item = zAML_Items.Item(i)
Call PrintAlarm(zAML_Item)
Next i
End Sub
Sub PrintAlarm(YourAlarmItem As AlarmItem)
'this procedure will print out a set of informations
'depending to the given AlarmItem...
Debug.Print "TimeComes : " & YourAlarmItem.Timecomes
Debug.Print "TimeGoes : " & YourAlarmItem.Timegoes
Debug.Print "TimeAcknowledged: " & YourAlarmItem.TimeAcknowledged
Debug.Print "Text : " & YourAlarmItem.Text
Debug.Print "Variable : " & YourAlarmItem.Variable.Name
Debug.Print "Value : " & YourAlarmItem.Value
End Sub


Properties
ObjectModel COM [image] AlarmItem [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AlarmClass | short | Returns the defined alarm class. | Unused | Readonly | Available | Available
AlarmGroup | short | Returns the defined alarm group. | Unused | Readonly | Available | Available
Cause | bstr | Cause of the alarm. | Unused | Available | Available | Available
Computer | bstr | Returns the name of the computer, on which the action occurred. | Unused | Readonly | Available | Available
Countreactivated | long | Returns the number of the reactivations of the alarm. | Unused | Readonly | Available | Available
Index | long | Index of the alarm in the variable limits list or conditions in reaction matrix | Unused | Readonly | Available | Available
Name | bstr | This property returns the name of the variable linked to the alarm entry. | Unused | Readonly | Available | Available
Parent | ialarmitems | Returns the parent object. | Readonly | Readonly | Available | Available
Projectname | bstr | Returns the name of the project in which the alarm occurred. | Unused | Readonly | Available | Available
Status | long | Status of the variable | Unused | Readonly | Available | Available
Statusreactivated | long | Returns the status of the reactivated, violated value. | Unused | Readonly | Available | Available
Tagname | bstr | TagName of the linked variable | Unused | Readonly | Available | Available
Text | bstr | Alarmtext of the variable (limit/rema) | Unused | Readonly | Available | Available
TimeAcknowledged | date | Contains the time stamp of the event „acknowledged“. | Unused | Readonly | Available | Available
Timecomes | date | Time of the alarm | Unused | Readonly | Available | Available
Timegoes | date | Contains the time stamp of the event „cleared“. | Unused | Readonly | Available | Available
Timequitted | date | For internal use only | Unused | Unused | Available | Available
Timereactivated | date | Contains the time stamp of the last event „received“. | Unused | Readonly | Available | Available
User | bstr | Returns the identification of the user that acknowledged the current alarm. | Unused | Readonly | Available | Available
Usertext | bstr | Additional text defined by the user. | Unused | Available | Available | Available
Value | variant | Value of the variable | Unused | Readonly | Available | Available


AlarmClass
ObjectModel COM [image] AlarmItem [image] Properties [image] AlarmClass
Remarks

Returns the defined alarm class. A limit or a status in a REMA can be linked with an alarm class.As a default no alarm class is linked.A maximum of 8 different alarm classes can be defined. The alarm classes have the following tasks:- Priorityfor picture alarming- Colour switching- Definition of alarm colours in the alarms list and for picture alarming- Filter criteria in the alarms list and chronologic events list- Function calling- Execution of e.g. acoustic alarming

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


AlarmGroup
ObjectModel COM [image] AlarmItem [image] Properties [image] AlarmGroup
Remarks

Returns the defined alarm group. A limit or a status in a REMA can be linked with an alarm class.As a default no alarm group is linked.A maximum of 256 different alarm groups can be defined. The alarm groups serve for the object orientated technological differenciation:- Group 1 = pumps- Group 2 = electricity- Group 3 = ...

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Cause
ObjectModel COM [image] AlarmItem [image] Properties [image] Cause
Remarks

Cause of the alarm.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Computer
ObjectModel COM [image] AlarmItem [image] Properties [image] Computer
Remarks

Returns the name of the computer, on which the action occurred, e.g. acknowledging an alarm. The field for the computer name is limited to 47 characters.If the project runs stand-alone (without network), this property returns the name of the computer, where the project runs. In a network this name can be a client, a server or a stand-by.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Countreactivated
ObjectModel COM [image] AlarmItem [image] Properties [image] Countreactivated
Remarks

Returns the number of the reactivations of the alarm. In the project configuration the option with time reactivated can be set. So a received and not acknowledged alarm only generates one entry. A new occuarance of the alarm only sets a counter, updates the time received and the status.If this option is not used every occurance of the alarm generates a new entry.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Index
ObjectModel COM [image] AlarmItem [image] Properties [image] Index
Remarks

Returns the index of the alarm in the alarm collection.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] AlarmItem [image] Properties [image] Name
Remarks

This property returns the name of the variable linked to the alarm entry. This variable can also be found with the method Variable of this object.The variable was defined as an alarm variable in the limit/REMA definition.The name of the variable is unique. With this name the variable can be found in the central variables list of the project.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] AlarmItem [image] Properties [image] Parent
Remarks

Returns the parent object.

Datatype
IAlarmItems

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Projectname
ObjectModel COM [image] AlarmItem [image] Properties [image] Projectname
Remarks

Returns the name of the project in which the alarm occurred. Since the object Alarm is always executed in the current project, this property is always the same as Project.Name and thisProject.Name in VBA.With this name the project can be found in the central project list of the application.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Status
ObjectModel COM [image] AlarmItem [image] Properties [image] Status
Remarks

This property returns the status of the value, that executed the alarm, e.g. the variable Heating_1 has a maximum limit of 10. The value is set to 15 on error. In this case the property contains the status of the value 15. The returned value contains the status in bit code. The following stati are possible in the control system: · Invalid (I-Bit) · Not actualized · Alternate value (EWERT) · General request (GA) · Spontan · Summer/Winter time · Switched off (N_AKT) · Realtime external · Realtime internal · Wintertime · Hand value · User flag 1 .. 8 (ST_M1 .. ST_M8) · Select (SELEC) · Revision (REV) · Run contact (LAUF) · Runtime overflow (LZÜ) · Fail Trafo (SM_TR) · NS · INFO · Set direction

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Statusreactivated
ObjectModel COM [image] AlarmItem [image] Properties [image] Statusreactivated
Remarks

Returns the status of the reactivated, violated value. Usually this is the property of the current status.If the option with time reactivated in the alarm configuration is set, this property returns the status of the newest violation. With this setting a received unacknowledged alarm only generates one entry. On the next occurence a counter is increased and the time received and the status of the value is updated.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Tagname
ObjectModel COM [image] AlarmItem [image] Properties [image] Tagname
Remarks

This property returns the identification of the variable that executed the alarm. Further properties of the linked variable can be found out with the method Variable. In this case the object Variable is returned.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Text
ObjectModel COM [image] AlarmItem [image] Properties [image] Text
Remarks

Alarmtext of the variable (limit/rema)

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


TimeAcknowledged
ObjectModel COM [image] AlarmItem [image] Properties [image] TimeAcknowledged
Remarks

This property contains the time stamp of the event „acknowledged“. Acknowledging an alarm means, that the user read the entry and reacted. Acknowledging is always done by a user.On acknowledging the fields computer and user are set to the current computer and user. This action closes the alarm entry.

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Timecomes
ObjectModel COM [image] AlarmItem [image] Properties [image] Timecomes
Remarks

This property contains the time stamp of the first event „received“. If the option with time reactivated in the alarm configuration is set, this alarm entry is also used for the next violation (unless it is acknowledged). Thereby the time received, the number of reactivations and the status of the value is updated. The property Timereactivated returns the time of the last event „received“. If this option is not set each event „received“ creates an own alarm entry with the appropriate information.

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Timegoes
ObjectModel COM [image] AlarmItem [image] Properties [image] Timegoes
Remarks

This property contains the time stamp of the event „cleared“. The event „cleared“ is executed an the end of the alarm, i.e. the limit violation no longer exists. The time stamp of the event „cleared“ always is greater than that of the event „received“ (see Timecomes).If the option with time reactivated in the alarm configuration is set, it is possible that the time cleared is smaller than the time reactivated (see Timereactived).

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Timequitted
ObjectModel COM [image] AlarmItem [image] Properties [image] Timequitted
Remarks

This property contains the time stamp of the event „acknowledged“. Acknowledging an alarm means, that the user read the entry and reacted. Acknowledging is always done by a user. On acknowledging the fields computer and user are set to the current computer and user. This action closes the alarm entry.

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


Timereactivated
ObjectModel COM [image] AlarmItem [image] Properties [image] Timereactivated
Remarks

This property contains the time stamp of the last event „received“. Usually this is the property Timecomes.If the option with time reactivated in the alarm configuration is set, this entry is updated the next time the alarm occurs (unless it is acknowledged). Thereby the time received, the number of reactivations and the status of the value is updated.

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


User
ObjectModel COM [image] AlarmItem [image] Properties [image] User
Remarks

Returns the identification of the user that acknowledged the current alarm. The user logged in at that time is found out and his identification is read. This is transferred to the object Alarm. If no user is logged in, the user SYSTEM is automatically logged in.With this identification the user can be located in the central user administration of the process control system.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Usertext
ObjectModel COM [image] AlarmItem [image] Properties [image] Usertext
Remarks

Additional text defined by the user.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Value
ObjectModel COM [image] AlarmItem [image] Properties [image] Value
Remarks

This property returns the „invalid“ value responsible for the occurence of the alarm. The current value was changed from the raw value to a zenOn value. The property value is set on the first event „received“ of the alarm entry. If the alarm is reactivated, only the number of reactivations, the time received and the status of the value is updated.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] AlarmItem [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Acknowledge | variant_bool | Set an Alarm as "acknowledged". | Unused | Available | Available | Available
Delete | variant_bool | Delete the Alarm | Unused | Available | Available | Available
Quit | variant_bool | For internal use only | Unused | Unused | Available | Available
Variable | ivariable | Returns the linked variable | Unused | Readonly | Available | Available


Acknowledge
ObjectModel COM [image] AlarmItem [image] Methods [image] Acknowledge
Remarks

Method to set an Alarm as "acknowledged"

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
private IAlarm zenonAlarm;

void ThisProject_Active()
{
    //Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )
    this.zenonAlarm = this.Alarm();
    zenonAlarm.AlarmComes += new AlarmComesEventHandler(zenonAlarm_AlarmComes);
}

void ThisProject_Inactive()
{
    //Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    this.zenonAlarm.AlarmComes -= new AlarmComesEventHandler(zenonAlarm_AlarmComes);
    this.zenonAlarm = null;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}

void zenonAlarm_AlarmComes(IAlarmItem obItem)
{
    //As soon as a new alarm occurs it will be acknowledged without any user interaction
    obItem.Acknowledge();
}
VB.NET
Copy
Private zenonAlarm As IAlarm

Private Sub ThisProject_Active()
    'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )
    Me.zenonAlarm = Me.Alarm()
    AddHandler zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes
End Sub

Private Sub ThisProject_Inactive()
    'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    RemoveHandler Me.zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes
    Me.zenonAlarm = Nothing

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub

Private Sub zenonAlarm_AlarmComes(obItem As IAlarmItem)
    'As soon as a new alarm occurs it will be acknowledged without any user interaction
    obItem.Acknowledge()
End Sub


Delete
ObjectModel COM [image] AlarmItem [image] Methods [image] Delete
Remarks

Method to set an Alarm as "deleted"

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
private IAlarm zenonAlarm;

void ThisProject_Active()
{
    //Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )
    this.zenonAlarm = this.Alarm();
    zenonAlarm.AlarmComes += new AlarmComesEventHandler(zenonAlarm_AlarmComes);
}

void ThisProject_Inactive()
{
    //Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    this.zenonAlarm.AlarmComes -= new AlarmComesEventHandler(zenonAlarm_AlarmComes);
    this.zenonAlarm = null;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}

void zenonAlarm_AlarmComes(IAlarmItem obItem)
{
    //As soon as a new alarm occurs it will be deleted without any user interaction
    obItem.Delete();
}
VB.NET
Copy
Private zenonAlarm As IAlarm

Private Sub ThisProject_Active()
    'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )
    Me.zenonAlarm = Me.Alarm()
    AddHandler zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes
End Sub

Private Sub ThisProject_Inactive()
    'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    RemoveHandler zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes
    Me.zenonAlarm = Nothing

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub

Private Sub zenonAlarm_AlarmComes(obItem As IAlarmItem)
    'As soon as a new alarm occurs it will be deleted without any user interaction
    obItem.Delete()
End Sub


Quit
ObjectModel COM [image] AlarmItem [image] Methods [image] Quit
Remarks

Method to set an Alarm as "quitted"

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
private IAlarm zenonAlarm;

void ThisProject_Active()
{
    //Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )
    this.zenonAlarm = this.Alarm();
    zenonAlarm.AlarmComes += new AlarmComesEventHandler(zenonAlarm_AlarmComes);
}

void ThisProject_Inactive()
{
    //Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    this.zenonAlarm.AlarmComes -= new AlarmComesEventHandler(zenonAlarm_AlarmComes);
    this.zenonAlarm = null;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}

void zenonAlarm_AlarmComes(IAlarmItem obItem)
{
    //As soon as a new alarm occurs it will be quitted without any user interaction
    obItem.Quit();
}
VB.NET
Copy
Private zenonAlarm As IAlarm

Private Sub ThisProject_Active()
    'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )
    Me.zenonAlarm = Me.Alarm()
    AddHandler zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes
End Sub

Private Sub ThisProject_Inactive()
    'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    RemoveHandler Me.zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes
    Me.zenonAlarm = Nothing

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub

Private Sub zenonAlarm_AlarmComes(obItem As IAlarmItem)
    'As soon as a new alarm occurs it will be quitted without any user interaction
    obItem.Quit()
End Sub


Variable
ObjectModel COM [image] AlarmItem [image] Methods [image] Variable
Remarks

Returns the variable linked to the alarm entry. The variable contains general process information, whereas the alarm entry contains information on the alarm.Refer to the chapter Variable for more detailled information.Hint: The variable should be checked on Nothing.

Datatype
IVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
private IAlarm zenonAlarm;

void ThisProject_Active()
{
    //Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )
    this.zenonAlarm = this.Alarm();
    zenonAlarm.AlarmComes += new AlarmComesEventHandler(zenonAlarm_AlarmComes);
}

void zenonAlarm_AlarmComes(IAlarmItem obItem)
{
    //Read the name of the corresponding alarm variable and its datatype - print both to the CEL
    //Check if the variable is null first.
    if(obItem.Variable() != null)
    {
    this.Cel().WriteCelString(string.Format("An alarm for {0} has gone off, the variable has data type {1}",
                                            obItem.Variable().Name, obItem.Variable().DataType));
    }
}

void ThisProject_Inactive()
{
    //Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    this.zenonAlarm.AlarmComes -= new AlarmComesEventHandler(zenonAlarm_AlarmComes);
    this.zenonAlarm = null;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}
VB.NET
Copy
Private zenonAlarm As IAlarm

Private Sub ThisProject_Active()
    'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )
    Me.zenonAlarm = Me.Alarm()
    AddHandler zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes
End Sub

Private Sub zenonAlarm_AlarmComes(obItem As IAlarmItem)
    'Read the name of the corresponding alarm variable and its datatype - print both to the CEL
    'Check if the variable is null first.
    If obItem.Variable() IsNot Nothing Then
        Me.Cel().WriteCelString(String.Format("An alarm for {0} has gone off, the variable has data type {1}", obItem.Variable().Name, obItem.Variable().DataType))
    End If
End Sub

Private Sub ThisProject_Inactive()
    'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
    RemoveHandler Me.zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes
    Me.zenonAlarm = Nothing

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub


AlarmItems
ObjectModel COM [image] AlarmItems
Remarks

The alarm entries are administered in this collection. If a new alarm occurs, it is added to this collection.The single alarm entries contain information on the alarm, e.g. name, variable, alarm group, alarm class, ...

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
/*  Displays the amount of alarms currently in memory and
 *  the alarm text of all the different alarms.
 */
public void MacroGetAlarmItems()
{
    //Get alarm object(s) from active project
    IAlarm zenonAlarm = this.Alarm();
    IAlarmItems zenonAlarmItems = zenonAlarm.AlarmItems("*");

    MessageBox.Show(string.Format("{0} Alarms in memory...", zenonAlarmItems.Count));

    //get text of active alarms...
    for(int i = 0; i < zenonAlarmItems.Count; ++i)
    {
        IAlarmItem zenonAlarmItem = zenonAlarmItems.Item(i);
        Debug.Print(zenonAlarmItem.Text);
    }
}
VB.NET
Copy
'  Displays the amount of alarms currently in memory and
' *  the alarm text of all the different alarms.
'

Public Sub MacroGetAlarmItems()
    'Get alarm object(s) from active project
    Dim zenonAlarm As IAlarm = Me.Alarm()
    Dim zenonAlarmItems As IAlarmItems = zenonAlarm.AlarmItems("*")

    MessageBox.Show(String.Format("{0} Alarms in memory...", zenonAlarmItems.Count))

    'get text of active alarms...
    For i As Integer = 0 To zenonAlarmItems.Count - 1
        Dim zenonAlarmItem As IAlarmItem = zenonAlarmItems.Item(i)
        Debug.Print(zenonAlarmItem.Text)
    Next
End Sub
VBA
Copy
'*** In this example all alarm entries are read and displayed in the Output window of VBA.
'*** Run Aml_Items and write information of the items to the debug-window of the VBA-IDE
Public Sub Aml_Items()
Dim obAml As Alarm
Dim obAmlItem As AlarmItem
'*** Get Alarm-object of the current project
Set obAml = thisProject.Alarm
'*** Write information to debug-window of the VBA-IDE
For nIndex = 0 To obAml.AlarmItems.Count - 1
Set obAmlItem = obAml.AlarmItems.Item(nIndex)
If Not obAmlItem Is Nothing Then

Debug.Print "Alarm: " & obAmlItem.Name & _

" Variable: " & obAmlItem.Variable.Name & _

" AmlGroup: " & CStr(obAmlItem.AlarmGroup) & _

" AmlClass: " & CStr(AlarmItem.AlarmClass)
End If
Next nIndex
End Sub
'**********************************************************************
'* This codesample browses all alarms and searches in the alargroups *
'* 1-3 for non acknowledged alarms. *
'* ------------------------------------------------------------------ *
'* Autor: Mark Clemens Support, COPA-DATA GmbH *
'**********************************************************************
Dim obAml As Alarm
Dim obAmlItem As AlarmItem
Dim obAmlItems As AlarmItems
Dim nIndex As Variant
Dim obVariable As Variable
Dim nAcknowledged1, nAcknowledged2, nAcknowledged3 As Boolean
Sub Aml_Items()
'*** Reset internal variables
nAcknowledged1 = False
nAcknowledged2 = False
nAcknowledged3 = False
'*** Get Alarm-object of the current project
Set obAml = thisProject.Alarm
'*** Get all alarmitems
Set obAmlItems = obAml.AlarmItems("*")
   'get specific item using the screen switch function as filter
   'Set obAmlItems = obAml.AlarmItems("myFunction")
For nIndex = 0 To obAmlItems.Count - 1
Set obAmlItem = obAmlItems.Item(nIndex)
If (Not obAmlItem Is Nothing) Then

'*** Define which alarmgroups should be searched

Select Case obAmlItem.AlarmGroup

Case 1

'*** Search for non acknowledged alarms by comparing the
TimeAcknowledged Date

If obAmlItem.TimeAcknowledged = "01.01.1970 01:00:00" Then

nAcknowledged1 = True
End If
Case 2
'*** Search for non acknowledged alarms by comparing the

timeacknowledged Date
If obAmlItem.TimeAcknowledged = "01.01.1970 01:00:00" Then

nAcknowledged2 = True
End If
Case 3
'*** Search for non acknowledged alarms by comparing the

timeacknowledged Date
If obAmlItem.TimeAcknowledged = "01.01.1970 01:00:00" Then

nAcknowledged3 = True
End If
End Select
End If
Next nIndex
'*** After all Alarms have been analyzed set the processvariables
'***Group 1
Set obVariable = thisProject.Variables.Item("group1_not_acknowledged")
If Not (obVariable Is Nothing) Then

If nAcknowledged1 = True Then

obVariable.Value = 1

Else

obVariable.Value = 0

End If
End If
'***Group 2
Set obVariable = thisProject.Variables.Item("group2_not_acknowledged")
If Not (obVariable Is Nothing) Then

If nAcknowledged2 = True Then

obVariable.Value = 1

Else

obVariable.Value = 0

End If
End If
'***Group 3
Set obVariable = thisProject.Variables.Item("group3_not_acknowledged")
If Not (obVariable Is Nothing) Then

If nAcknowledged3 = True Then

obVariable.Value = 1

Else

obVariable.Value = 0

End If
End If
End Sub


Properties
ObjectModel COM [image] AlarmItems [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Aktiv | variant_bool | Alarm-module in-/active | Unused | Readonly | Available | Available
Count | long | Count of the alarm-items | Readonly | Readonly | Available | Available
Parent | ialarm | Returns the parent object. | Readonly | Readonly | Available | Available


Aktiv
ObjectModel COM [image] AlarmItems [image] Properties [image] Aktiv
Remarks

Returns the status of the alarm administration. If the value is True, the alarms administration is active. If it is not active the alarm buffer cannot be extended, i.e. no further alarms occur. It does not influence clearing existing alarms. De/activating the alarms administration is possible with the following functions of the control system: · Alarms active · Alarms inactive · Alarms active/inactive · Alarms/groups/classes

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Count
ObjectModel COM [image] AlarmItems [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] AlarmItems [image] Properties [image] Parent
Remarks

Returns the parent object.

Datatype
IAlarm

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] AlarmItems [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Item | ialarmitem | Returns the alarm-item on the given position | Available | Available | Available | Available


Item
ObjectModel COM [image] AlarmItems [image] Methods [image] Item
Remarks

Returns the object for the alarm entry at the position vID. All existing alarms of the project are in this collection. The returned object Alarmitem contains important information on the alarm.This method Item only allows accessing with the index.Hint: Check the returned object on Nothing, if no object for the search creteria was found.

Datatype
IAlarmItem

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT

Unique index for the position of the element in the list. Care that the index is < Count, i.e. for nIndex = 0 to Count-1

Example
VBA
Copy
'*** In this example all alarm entries are read and displayed in the Output window of VBA.
'*** Run Aml_Items and write information of the items to the debug-window of the VBA-IDE
Public Sub Aml_Items()
Dim obAml As Alarm
Dim obAmlItem As AlarmItem
'*** Get Alarm-object of the current project
Set obAml = thisProject.Alarm
'*** Write information to debug-window of the VBA-IDE
For nIndex = 0 To obAml.AlarmItems.Count - 1

Set obAmlItem = obAml.AlarmItems.Item(nIndex)

If Not obAmlItem Is Nothing Then

Debug.Print "Alarm: " & obAmlItem.Name & _

" Variable: " & obAmlItem.Variable.Name & _

" AmlGroup: " & CStr(obAmlItem.AlarmGroup) & _

" AmlClass: " & CStr(AlarmItem.AlarmClass)

End If
Next nIndex
End Sub
'**********************************************************************
'* This codesample browses all alarms and searches in the alargroups *
'* 1-3 for non acknowledged alarms. *
'* ------------------------------------------------------------------ *
'* Autor: Mark Clemens Support, COPA-DATA GmbH *
'**********************************************************************
Dim obAml As Alarm
Dim obAmlItem As AlarmItem
Dim obAmlItems As AlarmItems
Dim nIndex As Variant
Dim obVariable As Variable
Dim nAcknowledged1, nAcknowledged2, nAcknowledged3 As Boolean
Sub Aml_Items()
'*** Reset internal variables
nAcknowledged1 = False
nAcknowledged2 = False
nAcknowledged3 = False
'*** Get Alarm-object of the current project
Set obAml = thisProject.Alarm
'*** Get all alarmitems
Set obAmlItems = obAml.AlarmItems("*")

For nIndex = 0 To obAmlItems.Count - 1

Set obAmlItem = obAmlItems.Item(nIndex)

If (Not obAmlItem Is Nothing) Then

'*** Define which alarmgroups should be searched

Select Case obAmlItem.AlarmGroup

Case 1

'*** Search for non acknowledged alarms by comparing the TimeAcknowledged Date

If obAmlItem.TimeAcknowledged = "01.01.1970 01:00:00" Then

nAcknowledged1 = True

End If

Case 2

'*** Search for non acknowledged alarms by comparing the timeacknowledged Date

If obAmlItem.TimeAcknowledged = "01.01.1970 01:00:00" Then

nAcknowledged2 = True

End If

Case 3

'*** Search for non acknowledged alarms by comparing the timeacknowledged Date

If obAmlItem.TimeAcknowledged = "01.01.1970 01:00:00" Then

nAcknowledged3 = True

End If

End Select

End If
Next nIndex
'*** After all Alarms have been analyzed set the processvariables
'***Group 1
Set obVariable = thisProject.Variables.Item("group1_not_acknowledged")
If Not (obVariable Is Nothing) Then

If nAcknowledged1 = True Then

obVariable.Value = 1

Else

obVariable.Value = 0

End If
End If
'***Group 2
Set obVariable = thisProject.Variables.Item("group2_not_acknowledged")
If Not (obVariable Is Nothing) Then

If nAcknowledged2 = True Then

obVariable.Value = 1

Else

obVariable.Value = 0

End If
End If
'***Group 3
Set obVariable = thisProject.Variables.Item("group3_not_acknowledged")
If Not (obVariable Is Nothing) Then

If nAcknowledged3 = True Then

obVariable.Value = 1

Else

obVariable.Value = 0

End If
End If
End Sub


ALCEdge
ObjectModel COM [image] ALCEdge
Remarks

With this object you have the opportunity to get informations about a selected procedural element.

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroALCEdge()
{
    //Get ALC engine and child objects
    IALCEngine zenonAlcEngine = this.ALCEngine();
    IALCEdge zenonAlcEdge = zenonAlcEngine.EdgeItem(0);
    IALCNode zenonAlcNodeOne = zenonAlcEdge.Node1;
    IALCNode zenonAlcNodeTwo = zenonAlcEdge.Node2;

    //Returns the ID of the procedural element on the screen
    MessageBox.Show("ElementID of the procedural element: " + zenonAlcEdge.ElementID);

    //Returns the screen in which the procedural element is used
    MessageBox.Show("Screen: " + zenonAlcEdge.Picture);

    //Returns the ID of the ALC source (the list of these ids is available from the project property "Automatic line coloring")
    MessageBox.Show("Source ID: " + zenonAlcEdge.SourceID);

    //Returns the internal name of the procedural elements type
    MessageBox.Show(zenonAlcEdge.Type.ToString());

    MessageBox.Show("Linked variable: " + zenonAlcEdge.Variable);

    //Returns the ID of the procedural elements node on the screen
    //Note: Not all procedural elements contain two nodes
    MessageBox.Show("Link ID Node1: " + zenonAlcNodeOne.LinkID);

    //Returns the ID of the procedural elements second node on the screen
    MessageBox.Show("Link ID Node2: " + zenonAlcNodeTwo.LinkID);
}
VB.NET
Copy
PublicSub MacroALCEdge()
'Get ALC engine and child objects
Dim zenonAlcEngine As IALCEngine = Me.ALCEngine()
Dim zenonAlcEdge As IALCEdge = zenonAlcEngine.EdgeItem(0)
Dim zenonAlcNodeOne As IALCNode = zenonAlcEdge.Node1
Dim zenonAlcNodeTwo As IALCNode = zenonAlcEdge.Node2

'Returns the ID of the procedural element on the screen
    MessageBox.Show("ElementID of the procedural element: " + zenonAlcEdge.ElementID)

'Returns the screen in which the procedural element is used
    MessageBox.Show("Screen: " + zenonAlcEdge.Picture)

'Returns the ID of the ALC source (the list of these ids is available from the project property "Automatic line coloring")
    MessageBox.Show("Source ID: " + zenonAlcEdge.SourceID)

'Returns the internal name of the procedural elements type
    MessageBox.Show(zenonAlcEdge.Type.ToString())

    MessageBox.Show("Linked variable: " + zenonAlcEdge.Variable)

'Returns the ID of the procedural elements node on the screen
'Note: Not all procedural elements contain two nodes
    MessageBox.Show("Link ID Node1: " + zenonAlcNodeOne.LinkID)

'Returns the ID of the procedural elements second node on the screen
    MessageBox.Show("Link ID Node2: " + zenonAlcNodeTwo.LinkID)
EndSub
VBA
Copy
Sub ALCEdge()
Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcEdge As ALCEdge 'Child object from type ALCEngine
Dim zAlcNode1 As ALCNode 'Child object from type ALCEngine
Dim zAlcNode2 As ALCNode 'Child object from type ALCEngine
'Get ALCEngine data from the project
Set zAlcEngine = thisProject.ALCEngine
'Get the first procedural element of the project
Set zAlcEdge = zAlcEngine.EdgeItem(0)
'Returns the ID of the procedural element in the screen
MsgBox "ElementID of the procedural element = " & zAlcEdge.ElementID
'Returns the screen in which the procedural element is used
MsgBox "Screen = " & zAlcEdge.Picture
'Returns the ID of the ALC source (the list of these Ids is available at the project property "Automatic line coloring")
MsgBox "Source ID = " & zAlcEdge.SourceID
'Returns the type of procedural element
If zAlcEdge.Type = 0 Then

MsgBox "Type = tpALCTypeNode"

ElseIf zAlcEdge.Type = 1 Then

MsgBox "Type = tpALCTypeSource"

ElseIf zAlcEdge.Type = 2 Then

MsgBox "Type = tpALCTypeSwitch"

ElseIf zAlcEdge.Type = 3 Then

MsgBox "Type = tpALCTypeSink"

ElseIf zAlcEdge.Type = 4 Then

MsgBox "Type = tpALCTypeTrafo"

ElseIf zAlcEdge.Type = 5 Then

MsgBox "Type = tpALCTypeLink"
End If
'Returns the variable which is linked to the procedural element
MsgBox "Linkes variable = " & zAlcEdge.Variable.Name
'Returns the first connected node (HINT:Not all procedural elements include two Nodes!)
Set zAlcNode1 = zAlcEdge.Node1
'Returns the ID of the node in the screen
MsgBox "Link ID Node1 = " & zAlcNode1.LinkID
'Returns the second connected node
Set zAlcNode2 = zAlcEdge.Node2
'Returns the ID of the node in the screen
MsgBox "Link ID Node2 = " & zAlcNode2.LinkID

End Sub


Properties
ObjectModel COM [image] ALCEdge [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ElementID | long | Returns the ID of the element the edge is connected with. | Readonly | Readonly | Available | Available
ElementRef | bstr | Returns the reference name of the element the edge is connected with. | Unused | Available | Available | Available
GroundFaultType | tpalcgroundfaulttype | Returns the ground fault detection type if the edge is of type Switch. | Unused | Available | Available | Available
GroundFaultVarDisp | ivariable | Returns the attached ground fault display Variable if ground fault detection is enabled. | Unused | Available | Available | Available
GroundFaultVarFwd | ivariable | Returns the attached ground fault forward Variable if ground fault detection is enabled. | Unused | Available | Available | Available
GroundFaultVarRev | ivariable | Returns the attached ground fault reverse Variable if ground fault detection is enabled. | Unused | Available | Available | Available
GroundFaultVarTrg | ivariable | Returns the attached ground fault trigger Variable if ground fault detection is enabled. | Unused | Available | Available | Available
Node1 | ialcnode | Returns the first ALC node. | Readonly | Readonly | Available | Available
Node2 | ialcnode | Returns the second ALC node. | Readonly | Readonly | Available | Available
Picture | bstr | Returns the name of the picture the element is located in. | Readonly | Readonly | Available | Available
ReverseSourceID | long | Returns the reverse Source ID if the edge is of type Trafo. | Unused | Available | Available | Available
ShortFaultType | tpalcshortfaulttype | Returns the short fault detection type if the edge is of type Switch. | Unused | Available | Available | Available
ShortFaultVarDisp | ivariable | Returns the attached short fault display Variable if short fault detection is enabled. | Unused | Available | Available | Available
ShortFaultVarFwd | ivariable | Returns the attached short fault forward Variable if short fault detection is enabled. | Unused | Available | Available | Available
ShortFaultVarRev | ivariable | Returns the attached short fault reverse Variable if short fault detection is enabled. | Unused | Available | Available | Available
ShortFaultVarTrg | ivariable | Returns the attached short fault trigger Variable if short fault detection is enabled. | Unused | Available | Available | Available
SourceID | long | Returns the Source ID if the edge is of type Source or Trafo. | Readonly | Readonly | Available | Available
Type | tpalctype | Returns the type of this ALC edge. | Readonly | Readonly | Available | Available
Variable | ivariable | Returns the attached Variable if the edge is of type Source or Switch. | Readonly | Readonly | Available | Available


ElementID
ObjectModel COM [image] ALCEdge [image] Properties [image] ElementID
Remarks

Returns the ID of the procedural element in the picture.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ElementRef
ObjectModel COM [image] ALCEdge [image] Properties [image] ElementRef
Remarks

Returns the reference name of the element the edge is connected with.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


GroundFaultType
ObjectModel COM [image] ALCEdge [image] Properties [image] GroundFaultType
Remarks

Returns the ground fault detection type if the edge is of type Switch.

Datatype
tpALCGroundFaultType

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


GroundFaultVarDisp
ObjectModel COM [image] ALCEdge [image] Properties [image] GroundFaultVarDisp
Remarks

Returns the attached ground fault display Variable if ground fault detection is enabled.

Datatype
IVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


GroundFaultVarFwd
ObjectModel COM [image] ALCEdge [image] Properties [image] GroundFaultVarFwd
Remarks

Returns the attached ground fault forward Variable if ground fault detection is enabled.

Datatype
IVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


GroundFaultVarRev
ObjectModel COM [image] ALCEdge [image] Properties [image] GroundFaultVarRev
Remarks

Returns the attached ground fault reverse Variable if ground fault detection is enabled.

Datatype
IVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


GroundFaultVarTrg
ObjectModel COM [image] ALCEdge [image] Properties [image] GroundFaultVarTrg
Remarks

Returns the attached ground fault trigger Variable if ground fault detection is enabled.

Datatype
IVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Node1
ObjectModel COM [image] ALCEdge [image] Properties [image] Node1
Remarks

Returns an object from type "ALCNode". It represents a node which is connected to the procedural element. Hint: It is also possible that only one of the two nodes is connected to the procedural element.

Datatype
IALCNode

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Node2
ObjectModel COM [image] ALCEdge [image] Properties [image] Node2
Remarks

Returns an object from type "ALCNode". It represents a node which is connected to the procedural element. Hint: It is also possible that only one of the two nodes is connected to the procedural element.

Datatype
IALCNode

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Picture
ObjectModel COM [image] ALCEdge [image] Properties [image] Picture
Remarks

Returns the picture in which the procedural element is used.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ReverseSourceID
ObjectModel COM [image] ALCEdge [image] Properties [image] ReverseSourceID
Remarks

Returns the reverse Source ID if the edge is of type Trafo.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ShortFaultType
ObjectModel COM [image] ALCEdge [image] Properties [image] ShortFaultType
Remarks

eturns the short fault detection type if the edge is of type Switch.

Datatype
tpALCShortFaultType

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ShortFaultVarDisp
ObjectModel COM [image] ALCEdge [image] Properties [image] ShortFaultVarDisp
Remarks

Returns the attached short fault display Variable if short fault detection is enabled.

Datatype
IVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ShortFaultVarFwd
ObjectModel COM [image] ALCEdge [image] Properties [image] ShortFaultVarFwd
Remarks

Returns the attached short fault forward Variable if short fault detection is enabled.

Datatype
IVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ShortFaultVarRev
ObjectModel COM [image] ALCEdge [image] Properties [image] ShortFaultVarRev
Remarks

Returns the attached short fault reverse Variable if short fault detection is enabled.

Datatype
IVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ShortFaultVarTrg
ObjectModel COM [image] ALCEdge [image] Properties [image] ShortFaultVarTrg
Remarks

Returns the attached short fault trigger Variable if short fault detection is enabled.

Datatype
IVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


SourceID
ObjectModel COM [image] ALCEdge [image] Properties [image] SourceID
Remarks

Returns the ID of the ALC source (the list of these IDs is available at the zenOn project property "Automatic line coloring")

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] ALCEdge [image] Properties [image] Type
Remarks

Returns the type of this ALC edge.

Datatype
tpALCType

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Variable
ObjectModel COM [image] ALCEdge [image] Properties [image] Variable
Remarks

Returns an object from type "Variable". It represents the variable which is linked to the procedural element.

Datatype
IVariable

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ALCEngine
ObjectModel COM [image] ALCEngine
Remarks

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] ALCEngine [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
EdgeCount | long | Returns the number of ALC edges. | Readonly | Readonly | Available | Available
GraphAliasCount | long | Returns the number of ALC alias elements. | Readonly | Readonly | Available | Available
GraphElemCount | long | Returns the number of ALC elements. | Readonly | Readonly | Available | Available
GroundFaultMode | tpalcgroundfaultmode | Get/Set the ground fault mode. | Unused | Available | Available | Available
MaxOverload | double |  | Unused | Readonly | Available | Available
NodeCount | long | Returns the number of ALC nodes. | Readonly | Readonly | Available | Available
Parent | iproject | Returns the parent of the ALCEngine Object. | Readonly | Readonly | Available | Available


EdgeCount
ObjectModel COM [image] ALCEngine [image] Properties [image] EdgeCount
Remarks

Returns the number of procedural elements (generator, source, switch, disconnector, drain, transformator, link) from a project.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


GraphAliasCount
ObjectModel COM [image] ALCEngine [image] Properties [image] GraphAliasCount
Remarks

The method returns the number of available objects.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


GraphElemCount
ObjectModel COM [image] ALCEngine [image] Properties [image] GraphElemCount
Remarks

The method returns the number of available objects.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


GroundFaultMode
ObjectModel COM [image] ALCEngine [image] Properties [image] GroundFaultMode
Remarks

Get/Set the ground fault mode.

Datatype
tpALCGroundFaultMode

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


MaxOverload
ObjectModel COM [image] ALCEngine [image] Properties [image] MaxOverload
Remarks

Datatype
double

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


NodeCount
ObjectModel COM [image] ALCEngine [image] Properties [image] NodeCount
Remarks

Returns the number of nodes in a project.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] ALCEngine [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ALCEngine [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AckGroundFault | void | Acknowledges a ground fault detection. | Unused | Available | Available | Available
AckShortFault | void | Acknowledges a short fault detection. | Unused | Available | Available | Available
EdgeItem | ialcedge | Returns the ALC edge at the given index. | Readonly | Readonly | Available | Available
FindEdge | ialcedge | Returns the ALC edge associated to the given element. | Readonly | Readonly | Available | Available
FindEdgeByRef | ialcedge | Returns the ALC edge associated to the given element. | Unused | Readonly | Available | Available
FindNode | ialcnode | Returns the ALC node associated to the given element. | Readonly | Readonly | Available | Available
FindNodeByRef | ialcnode | Returns the ALC node associated to the given element. | Unused | Readonly | Available | Available
GraphAliasItem | ialcgraphalias | Returns the ALC alias element at the given index. | Readonly | Readonly | Available | Available
GraphElemItem | ialcgraphelem | Returns the ALC element at the given index. | Readonly | Readonly | Available | Available
NodeItem | ialcnode | Returns the ALC node at the given index. | Readonly | Readonly | Available | Available


AckGroundFault
ObjectModel COM [image] ALCEngine [image] Methods [image] AckGroundFault
Remarks

Acknowledges a ground fault detection.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
pVariable as IVariable


AckShortFault
ObjectModel COM [image] ALCEngine [image] Methods [image] AckShortFault
Remarks

Acknowledges a short fault detection.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
pVariable as IVariable


EdgeItem
ObjectModel COM [image] ALCEngine [image] Methods [image] EdgeItem
Remarks

This method returns a procedural element (generator, source, switch, disconnector, drain, transformator, link) from the project. Such an element is from type ALCEdge.

Datatype
IALCEdge

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lIndex as long

Position of the element in the project.

Example
VBA
Copy
Sub GetEdgeItem()
Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcEdge As ALCEdge 'Child object from type ALCEngine
'Get ALCEngine data from the project
Set zAlcEngine = MyWorkspace.ActiveDocument.ALCEngine
'Get the first ALC procedural element of the project
Set zAlcEdge = zAlcEngine.EdgeItem(0)
MsgBox "Element is in picture = " & zAlcEdge.Picture

End Sub


FindEdge
ObjectModel COM [image] ALCEngine [image] Methods [image] FindEdge
Remarks

This method returns a procedural element (generator, source, switch, disconnector, drain, transformator, link) from a specific picture with a specific ID (ID of the element in the picture).

Datatype
IALCEdge

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPicture as BSTR

ID of the element in the Screen.

lElementID as long

String that defines the Screen in which the ALC element is used.

Example
VBA
Copy
Sub FindEdge()
Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcEdge As ALCEdge 'Child object from type ALCEngine
'Get ALCEngine data from the project
Set zAlcEngine = MyWorkspace.ActiveDocument.ALCEngine
'Returns an ALC procedural element with a specific ID (element ID in the picture) from a specific picture
Set zAlcEdge = zAlcEngine.FindEdge("BILD3", 17)
'Show the ALC ID if the element
MsgBox "Source ID of the element = " & zAlcEdge.SourceID

End Sub


FindEdgeByRef
ObjectModel COM [image] ALCEngine [image] Methods [image] FindEdgeByRef
Remarks

Returns the ALC edge associated to the given element.

Datatype
IALCEdge

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsElemRef as BSTR


FindNode
ObjectModel COM [image] ALCEngine [image] Methods [image] FindNode
Remarks

This method returns an ALC node from a specific picture with a specific ID (ID of the element in the picture).

Datatype
IALCNode

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPicture as BSTR

String that defines the Screen in which the ALC element is used.

lElementID as long

ID from one of the line elements which is connected to the node.

Example
VBA
Copy
Sub FindNode()
Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcNode As ALCNode 'Child object from type ALCEngine
'Get ALCEngine data from the project
Set zAlcEngine = thisProject.ALCEngine
'Returns a ALC node with a specific ID (ID from one of the connected line elements) from a specific picture
Set zAlcNode = zAlcEngine.FindNode("BILD3", 18)
'Returns the number of procedural elements which are connected to the line element
MsgBox "Number of connected procedural elements = " & zAlcNode.EdgeCount

End Sub


FindNodeByRef
ObjectModel COM [image] ALCEngine [image] Methods [image] FindNodeByRef
Remarks

Returns the ALC node associated to the given element.

Datatype
IALCNode

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsElemRef as BSTR


GraphAliasItem
ObjectModel COM [image] ALCEngine [image] Methods [image] GraphAliasItem
Remarks

Gets a ALCAlias item of a ALCElement.

Datatype
IALCGraphAlias

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lIndex as long

Position of the element in the project.

Example
C#
Copy
//Iterate all ALCGraph aliases using the GraphAliasCount property. this.ActiveDocument is the active workspace
 //Create an instance of the zenOn.IALCGraphAlias to collect a Graph element on index
 //Print the output using the output window, use: this.Parent.DebugPrint().
 public void Macro_GraphAlias()
        {
 for (int i = 0; i < this.ActiveDocument.ALCEngine().GraphAliasCount; i++)
            {
                zenOn.IALCGraphAlias AlcAlias = this.ActiveDocument.ALCEngine().GraphElemItem(i);
 this.Parent.DebugPrint(string.Format("ID: {0}; Type: {1}; Picture: {2}", AlcAlias.ElementID, AlcAlias.Type, AlcAlias.Picture), zenOn.tpDebugPrintStyle.tpNrm);
            }
        }
VB.NET
Copy
//Iterate all ALCGraph aliases using the GraphAliasCount property. this.ActiveDocument is the active workspace
 //Create an instance of the zenOn.IALCGraphAlias to collect a Graph element on index
 //Print the output using the output window, use: this.Parent.DebugPrint().
        Public Sub Macro_GraphAlias()
            For i As Integer = 0 To Me.ActiveDocument.ALCEngine().GraphAliasCount - 1
                Dim AlcAlias As zenOn.IALCGraphAlias = Me.ActiveDocument.ALCEngine().GraphElemItem(i)
                Me.Parent.DebugPrint(String.Format("ID: {0}; Type: {1}; Picture: {2}", AlcAlias.ElementID, AlcAlias.Type, AlcAlias.Picture), zenOn.tpDebugPrintStyle.tpNrm)
            Next
        End Sub


GraphElemItem
ObjectModel COM [image] ALCEngine [image] Methods [image] GraphElemItem
Remarks

Gets a ALCElement item.

Datatype
IALCGraphElem

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lIndex as long

Position of the element in the project.

Example
C#
Copy
//Iterate all ALCGraph elements using the GraphElemCount property. this.ActiveDocument is the active workspace
 //Create an instance of the zenOn.IALCGraphElem to collect a Graph element on index
 //Print the output using the output window, use: this.Parent.DebugPrint().
 public void Macro_GraphElem()
        {
 for (int i = 0; i < this.ActiveDocument.ALCEngine().GraphElemCount; i++)
            {
                zenOn.IALCGraphElem AlcElem = this.ActiveDocument.ALCEngine().GraphElemItem(i);
 this.Parent.DebugPrint(string.Format("ID: {0}; Type: {1}; Picture: {2}", AlcElem.ElementID, AlcElem.Type, AlcElem.Picture), zenOn.tpDebugPrintStyle.tpNrm);
            }
        }
VB.NET
Copy
//Iterate all ALCGraph elements using the GraphElemCount property. this.ActiveDocument is the active workspace
 //Create an instance of the zenOn.IALCGraphElem to collect a Graph element on index
 //Print the output using the output window, use: this.Parent.DebugPrint().
        Public Sub Macro_GraphElem()
            For i As Integer = 0 To Me.ActiveDocument.ALCEngine().GraphElemCount - 1
                Dim AlcElem As zenOn.IALCGraphElem = Me.ActiveDocument.ALCEngine().GraphElemItem(i)
                Me.Parent.DebugPrint(String.Format("ID: {0}; Type: {1}; Picture: {2}", AlcElem.ElementID, AlcElem.Type, AlcElem.Picture), zenOn.tpDebugPrintStyle.tpNrm)
            Next
        End Sub


NodeItem
ObjectModel COM [image] ALCEngine [image] Methods [image] NodeItem
Remarks

This method returns a node from the project. Such an element is from object type "ALCNode".

Datatype
IALCNode

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lIndex as long

Position of the element in the project.

Example
VBA
Copy
Sub NodeItem()
Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcNode As ALCNode 'Child object from type ALCEngine
'Get ALCEngine data from the project
Set zAlcEngine = MyWorkspace.ActiveDocument.ALCEngine
'Get the first node of the picture
Set zAlcNode = zAlcEngine.NodeItem(0)
'Returns the number of procedural elements which are connected to the line element
MsgBox "Number of edges = " & zAlcNode.EdgeCount

End Sub


Events
ObjectModel COM [image] ALCEngine [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckInterlocking | void | Event: Is fired to check interlockings. | Unused | Available | Available | Available
LoadFlowCalculated | void |  | Unused | Available | Available | Available
NMinus1Calculated | void |  | Unused | Available | Available | Available
Updated | void |  | Unused | Available | Available | Available


CheckInterlocking
ObjectModel COM [image] ALCEngine [image] Events [image] CheckInterlocking
Remarks

Is fired to check topological interlockings. The operated switch and also the new condition are assigned.The event uses LockResult, bUnlockable or bsText to indicate a violated lock condition. If the Lockresult is tpBusy the event will be fired until the result is no longer tpBusy for a maximum of 10 sec. After the elapsed time the locking will be activ. BsText and bUnlockable apply information concerning the locking text and the unlocking conditions.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
pALCEdge as IALCEdge

nNewState as long

LockResult as tpLockResult

bsText as BSTR

bUnlockable as VARIANT_BOOL


LoadFlowCalculated
ObjectModel COM [image] ALCEngine [image] Events [image] LoadFlowCalculated
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


NMinus1Calculated
ObjectModel COM [image] ALCEngine [image] Events [image] NMinus1Calculated
Remarks

Is then always triggered in zenon Runtime if the N-1 calculation has completed calculations.Note: The N-1 analysis of the interlocking check does not trigger this event.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Updated
ObjectModel COM [image] ALCEngine [image] Events [image] Updated
Remarks

Is triggered in Runtime each time the ALCEngine has completed calculations. (start of the calculation is always the value or status change of a variable)Is then always triggered in zenon Runtime if the calculation of the ALCEngine has been completed.Note: Recalculation is triggered when a variable changes value or status.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ALCGraphAlias
ObjectModel COM [image] ALCGraphAlias
Remarks

With this object you have the opportunity to get line and procedural elements via an index or from specific Screens and specific Element IDs.

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
/*
    * Iterate all ALCGraph aliases using the GraphAliasCount property. this.ActiveDocument is the active workspace
    * Create an instance of the zenOn.IALCGraphAlias to collect a Graph element on index
    * Print the output using the output window, use: this.Parent.DebugPrint().*/

public void Macro_GraphAlias()
{
    for (int i = 0; i < this.ActiveDocument.ALCEngine().GraphAliasCount; i++)
    {
        zenOn.IALCGraphAlias alcAlias = this.ActiveDocument.ALCEngine().GraphAliasItem(i);
        this.Parent.DebugPrint(string.Format("ID: {0}; Type: {1}; Picture: {2}", alcAlias.ElementID, alcAlias.Type, alcAlias.Picture), zenOn.tpDebugPrintStyle.tpNrm);
    }
}
VB.NET
Copy
'
'    * Iterate all ALCGraph aliases using the GraphAliasCount property. this.ActiveDocument is the active workspace
'    * Create an instance of the zenOn.IALCGraphAlias to collect a Graph element on index
'    * Print the output using the output window, use: this.Parent.DebugPrint().
'

Public Sub Macro_GraphAlias()
    For i As Integer = 0 To Me.ActiveDocument.ALCEngine().GraphAliasCount - 1
        Dim alcAlias As zenOn.IALCGraphAlias = Me.ActiveDocument.ALCEngine().GraphAliasItem(i)
        Me.Parent.DebugPrint(String.Format("ID: {0}; Type: {1}; Picture: {2}", alcAlias.ElementID, alcAlias.Type, alcAlias.Picture), zenOn.tpDebugPrintStyle.tpNrm)
    Next
End Sub


Properties
ObjectModel COM [image] ALCGraphAlias [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ElementID | long | Returns the ID of the element the edge is connected with. | Readonly | Readonly | Available | Available
ElementRef | bstr | Returns the reference name of the element the edge is connected with. | Readonly | Readonly | Available | Available
OriginalGraphElem | ialcgraphelem | Returns the original ALC element. | Readonly | Readonly | Available | Available
Picture | bstr | Returns the name of the picture the element is located in. | Readonly | Readonly | Available | Available
Type | tpalctype | Returns the type of this ALC edge. | Readonly | Readonly | Available | Available


ElementID
ObjectModel COM [image] ALCGraphAlias [image] Properties [image] ElementID
Remarks

Returns the ID of the element the edge is connected with.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ElementRef
ObjectModel COM [image] ALCGraphAlias [image] Properties [image] ElementRef
Remarks

Returns the reference name of the element the edge is connected with.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


OriginalGraphElem
ObjectModel COM [image] ALCGraphAlias [image] Properties [image] OriginalGraphElem
Remarks

Returns the original ALC element.

Datatype
IALCGraphElem

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Picture
ObjectModel COM [image] ALCGraphAlias [image] Properties [image] Picture
Remarks

Returns the name of the picture the element is located in.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] ALCGraphAlias [image] Properties [image] Type
Remarks

Returns the type of this ALC edge.

Datatype
tpALCType

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ALCGraphElem
ObjectModel COM [image] ALCGraphElem
Remarks

With this object you have the opportunity to get line and procedural elements via an index or from specific Screens and specific Element IDs.

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
/*
    * Iterate all ALCGraph elements using the GraphElemCount property. this.ActiveDocument is the active workspace
    * Create an instance of the zenOn.IALCGraphElem to collect a Graph element on index
    * Print the output using the output window, use: this.Parent.DebugPrint().*/

public void Macro_GraphElem()
{
    for (int i = 0; i < this.ActiveDocument.ALCEngine().GraphElemCount; i++)
    {
        zenOn.IALCGraphElem alcElem = this.ActiveDocument.ALCEngine().GraphElemItem(i);
        this.Parent.DebugPrint(string.Format("ID: {0}; Type: {1}; Picture: {2}", alcElem.ElementID, alcElem.Type, alcElem.Picture), zenOn.tpDebugPrintStyle.tpNrm);
    }
}
VB.NET
Copy
'
'    * Iterate all ALCGraph elements using the GraphElemCount property. this.ActiveDocument is the active workspace
'    * Create an instance of the zenOn.IALCGraphElem to collect a Graph element on index
'    * Print the output using the output window, use: this.Parent.DebugPrint().
'

Public Sub Macro_GraphElem()
    For i As Integer = 0 To Me.ActiveDocument.ALCEngine().GraphElemCount - 1
        Dim alcElem As zenOn.IALCGraphElem = Me.ActiveDocument.ALCEngine().GraphElemItem(i)
        Me.Parent.DebugPrint(String.Format("ID: {0}; Type: {1}; Picture: {2}", alcElem.ElementID, alcElem.Type, alcElem.Picture), zenOn.tpDebugPrintStyle.tpNrm)
    Next
End Sub


Properties
ObjectModel COM [image] ALCGraphElem [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ElementID | long | Returns the ID of the element the edge is connected with. | Readonly | Readonly | Available | Available
ElementRef | bstr | Returns the reference name of the element the edge is connected with. | Readonly | Readonly | Available | Available
Length | double | Returns the length | Readonly | Readonly | Available | Available
LoadType | long | Returns the load type | Readonly | Readonly | Available | Available
LoadVal | double | Returns the fixed load value | Readonly | Readonly | Available | Available
MaxIType | long | Returns the maximal current type | Readonly | Readonly | Available | Available
MaxIVal | double | Returns the fixed maximal current | Readonly | Readonly | Available | Available
Node1Count | long | Returns the number of elements connected to first node. | Readonly | Readonly | Available | Available
Node2Count | long | Returns the number of elements connected to second node. | Readonly | Readonly | Available | Available
Picture | bstr | Returns the name of the picture the element is located in. | Readonly | Readonly | Available | Available
React | double | Returns the reactance | Readonly | Readonly | Available | Available
Resist | double | Returns the resistance | Readonly | Readonly | Available | Available
ReverseSourceID | long | Returns the reverse Source ID if the edge is of type Trafo. | Readonly | Readonly | Available | Available
SourceID | long | Returns the Source ID if the edge is of type Source or Trafo. | Readonly | Readonly | Available | Available
Type | tpalctype | Returns the type of this ALC edge. | Readonly | Readonly | Available | Available
VarCalcI | ivariable | Returns the variable for calculated current | Readonly | Readonly | Available | Available
VarCurI | ivariable | Returns the variable for actual current | Readonly | Readonly | Available | Available
VarCurP | ivariable | Returns the variable for actual power | Readonly | Readonly | Available | Available
Variable | ivariable | Returns the attached Variable if the edge is of type Source or Switch. | Readonly | Readonly | Available | Available
VarLoad | ivariable | Returns the variable for load value | Readonly | Readonly | Available | Available
VarMaxI | ivariable | Returns the variable for maximal current | Readonly | Readonly | Available | Available
VarProtReact | ivariable | Returns the variable for protection reactance | Readonly | Readonly | Available | Available


ElementID
ObjectModel COM [image] ALCGraphElem [image] Properties [image] ElementID
Remarks

Returns the ID of the element the edge is connected with.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ElementRef
ObjectModel COM [image] ALCGraphElem [image] Properties [image] ElementRef
Remarks

Returns the reference name of the element the edge is connected with.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Length
ObjectModel COM [image] ALCGraphElem [image] Properties [image] Length
Remarks

Returns the length

Datatype
double

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


LoadType
ObjectModel COM [image] ALCGraphElem [image] Properties [image] LoadType
Remarks

Returns the load type

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


LoadVal
ObjectModel COM [image] ALCGraphElem [image] Properties [image] LoadVal
Remarks

Returns the fixed load value

Datatype
double

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


MaxIType
ObjectModel COM [image] ALCGraphElem [image] Properties [image] MaxIType
Remarks

Returns the maximal current type

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


MaxIVal
ObjectModel COM [image] ALCGraphElem [image] Properties [image] MaxIVal
Remarks

Returns the fixed maximal current

Datatype
double

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Node1Count
ObjectModel COM [image] ALCGraphElem [image] Properties [image] Node1Count
Remarks

Returns the number of elements connected to first node.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Node2Count
ObjectModel COM [image] ALCGraphElem [image] Properties [image] Node2Count
Remarks

Returns the number of elements connected to second node.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Picture
ObjectModel COM [image] ALCGraphElem [image] Properties [image] Picture
Remarks

Returns the name of the picture the element is located in.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


React
ObjectModel COM [image] ALCGraphElem [image] Properties [image] React
Remarks

Returns the reactance

Datatype
double

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Resist
ObjectModel COM [image] ALCGraphElem [image] Properties [image] Resist
Remarks

Returns the resistance

Datatype
double

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ReverseSourceID
ObjectModel COM [image] ALCGraphElem [image] Properties [image] ReverseSourceID
Remarks

Returns the reverse Source ID if the edge is of type Trafo.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


SourceID
ObjectModel COM [image] ALCGraphElem [image] Properties [image] SourceID
Remarks

Returns the Source ID if the edge is of type Source or Trafo.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] ALCGraphElem [image] Properties [image] Type
Remarks

Returns the type of this ALC edge.

Datatype
tpALCType

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


VarCalcI
ObjectModel COM [image] ALCGraphElem [image] Properties [image] VarCalcI
Remarks

Returns the variable for calculated current

Datatype
IVariable

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


VarCurI
ObjectModel COM [image] ALCGraphElem [image] Properties [image] VarCurI
Remarks

Returns the variable for actual current

Datatype
IVariable

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


VarCurP
ObjectModel COM [image] ALCGraphElem [image] Properties [image] VarCurP
Remarks

Returns the variable for actual power

Datatype
IVariable

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Variable
ObjectModel COM [image] ALCGraphElem [image] Properties [image] Variable
Remarks

Returns the attached Variable if the edge is of type Source or Switch.

Datatype
IVariable

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


VarLoad
ObjectModel COM [image] ALCGraphElem [image] Properties [image] VarLoad
Remarks

Returns the variable for load value

Datatype
IVariable

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


VarMaxI
ObjectModel COM [image] ALCGraphElem [image] Properties [image] VarMaxI
Remarks

Returns the variable for maximal current

Datatype
IVariable

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


VarProtReact
ObjectModel COM [image] ALCGraphElem [image] Properties [image] VarProtReact
Remarks

Returns the variable for protection reactance

Datatype
IVariable

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ALCGraphElem [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AlcDrainLoadType [GET] | alcdrainloadtype |  | Readonly | Readonly | Available | Available
AlcLimitCurrentCarryingCapacityType [GET] | alclimitcurrentcarryingcapacitytype |  | Readonly | Readonly | Available | Available
Node1Item | ialcgraphelem | Returns the the element connected to first node at the given index. | Readonly | Readonly | Available | Available
Node2Item | ialcgraphelem | Returns the the element connected to second node at the given index. | Readonly | Readonly | Available | Available


AlcDrainLoadType [GET]
ObjectModel COM [image] ALCGraphElem [image] Methods [image] AlcDrainLoadType [GET]
Remarks

Datatype
AlcDrainLoadType

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


AlcLimitCurrentCarryingCapacityType [GET]
ObjectModel COM [image] ALCGraphElem [image] Methods [image] AlcLimitCurrentCarryingCapacityType [GET]
Remarks

Datatype
AlcLimitCurrentCarryingCapacityType

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Node1Item
ObjectModel COM [image] ALCGraphElem [image] Methods [image] Node1Item
Remarks

Returns the the element connected to first node at the given index.

Datatype
IALCGraphElem

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lIndex as long


Node2Item
ObjectModel COM [image] ALCGraphElem [image] Methods [image] Node2Item
Remarks

Returns the the element connected to second node at the given index.

Datatype
IALCGraphElem

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lIndex as long


ALCNode
ObjectModel COM [image] ALCNode
Remarks

With this object you have the opportunity to get informations about the line and procedural elements of a single node in your topology.

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroAlcNode()
{
    IALCEngine zenonAlcEngine = this.ALCEngine();

    //Get the first node of the project
    IALCNode zenonAlcNode = zenonAlcEngine.NodeItem(2);

    //Return the number of procedural devices which are connected to the node
    MessageBox.Show("Number of connected procedural elements: " + zenonAlcNode.EdgeCount);

    //Return one of the connected procedural elements
    IALCEdge zenonAlcEdge = zenonAlcNode.EdgeItem(0);

    //Return type of the connected procedural element
    MessageBox.Show(zenonAlcEdge.Type.ToString());

    //Return ID of the link connected to the node
    MessageBox.Show("Link iD: " + zenonAlcNode.LinkID);
}
VB.NET
Copy
Public Sub MacroAlcNode()
    Dim zenonAlcEngine As IALCEngine = Me.ALCEngine()

    'Get the first node of the project
    Dim zenonAlcNode As IALCNode = zenonAlcEngine.NodeItem(2)

    'Return the number of procedural devices which are connected to the node
    MessageBox.Show("Number of connected procedural elements: " + zenonAlcNode.EdgeCount)

    'Return one of the connected procedural elements
    Dim zenonAlcEdge As IALCEdge = zenonAlcNode.EdgeItem(0)

    'Return type of the connected procedural element
    MessageBox.Show(zenonAlcEdge.Type.ToString())

    'Return ID of the link connected to the node
    MessageBox.Show("Link iD: " + zenonAlcNode.LinkID)
End Sub
VBA
Copy
Sub ALCNode()
Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcNode As ALCNode 'Child object from type ALCEngine
Dim zAlcEdge As ALCEdge 'Child object from type ALCEngine
Dim CountElements As Long
Dim LineStates As Variant
Dim i As Integer
'Get ALCEngine data from the project
Set zAlcEngine = thisProject.ALCEngine
'Get the first node of the project
Set zAlcNode = zAlcEngine.NodeItem(2)
'Return the number of procedural devices which are connected to the node
MsgBox "Number of connected procedural elements = " & zAlcNode.EdgeCount
'Return one of the connected procedural elements
Set zAlcEdge = zAlcNode.EdgeItem(0)
'Return type of connected procedural element
If zAlcEdge.Type = 0 Then

MsgBox "Type = tpALCTypeNode"

ElseIf zAlcEdge.Type = 1 Then

MsgBox "Type = tpALCTypeSource"

ElseIf zAlcEdge.Type = 2 Then

MsgBox "Type = tpALCTypeSwitch"

ElseIf zAlcEdge.Type = 3 Then

MsgBox "Type = tpALCTypeSink"

ElseIf zAlcEdge.Type = 4 Then

MsgBox "Type = tpALCTypeTrafo"

ElseIf zAlcEdge.Type = 5 Then

MsgBox "Type = tpALCTypeLink"
End If
'Return number of line elements which are connected to the node
CountElements = UBound(zAlcNode.ElementIDs)
MsgBox "Number of connected line elements = " & CountElements
'Print current states of a node
If (IsEmpty(zAlcNode.LineStates)) Then

Debug.Print "No line state active"
Else

LineStates = zAlcNode.LineStates

For i = 0 To UBound(LineStates)

Debug.Print "State " & i & " = " & LineStates(i)

Next i
End If
'Return link ID if a link (procedural element) is connected to the node
MsgBox "Link ID = " & zAlcNode.LinkID

End Sub


Properties
ObjectModel COM [image] ALCNode [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
EdgeCount | long | Returns the number of edges connected to this node. | Readonly | Readonly | Available | Available
ElementIDs | variant | Returns the IDs of the elements the Node is connected with. | Readonly | Readonly | Available | Available
ElementRefs | variant | Returns the reference names of the elements the Node is connected with. | Unused | Available | Available | Available
LineStates | variant | Returns the all line states at this node. | Unused | Readonly | Available | Available
LinkID | long | Returns the ID of the linked Source. | Readonly | Readonly | Available | Available
Pictures | variant | Returns the names of the pictures the Node is in. | Readonly | Readonly | Available | Available


EdgeCount
ObjectModel COM [image] ALCNode [image] Properties [image] EdgeCount
Remarks

Returns the number of procedural devices which are connected to the node.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ElementIDs
ObjectModel COM [image] ALCNode [image] Properties [image] ElementIDs
Remarks

Returns a set of IDs of the line elements which are connected to the node.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ElementRefs
ObjectModel COM [image] ALCNode [image] Properties [image] ElementRefs
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


LineStates
ObjectModel COM [image] ALCNode [image] Properties [image] LineStates
Remarks

Returns a set of ALC states which are currently active in runtime. These states are a declared in the zenOn project settings at the "Automatic Line Coloring" property.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


LinkID
ObjectModel COM [image] ALCNode [image] Properties [image] LinkID
Remarks

Returns the ID of a projected link (procedural element) which is available for this node.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Pictures
ObjectModel COM [image] ALCNode [image] Properties [image] Pictures
Remarks

Returns a set of pictures where the line elements of the node are projected. This is helpful when links (procedural elements) are projected and so one node is extracted over many pictures.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ALCNode [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
EdgeItem | ialcedge | Returns the ALC edge at the given index. | Available | Available | Available | Available


EdgeItem
ObjectModel COM [image] ALCNode [image] Methods [image] EdgeItem
Remarks

This method returns an object from type "ALCEdge". You have the opportunity to get one of the procedural elements which are connected to the node.

Datatype
IALCEdge

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lIndex as long

Index of a connected procedural elements.

Example
VBA
Copy
Sub EdgeItem()
Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcNode As ALCNode 'Child object from type ALCEngine
Dim zAlcEdge As ALCEdge 'Child object from type ALCEngine
'Get ALCEngine data from the project
Set zAlcEngine = thisProject.ALCEngine
'Get the first line element of the project
Set zAlcNode = zAlcEngine.NodeItem(0)
'Return the number of procedural devices which are connected to the node
MsgBox "Number of connected procedural elements = " & zAlcNode.EdgeCount
'Return one of the connected procedural elements
Set zAlcEdge = zAlcNode.EdgeItem(0)
'Return type of connected procedural element
If zAlcEdge.Type = 0 Then

MsgBox "Type = tpALCTypeNode"
ElseIf zAlcEdge.Type = 1 Then

MsgBox "Type = tpALCTypeSource"
ElseIf zAlcEdge.Type = 2 Then

MsgBox "Type = tpALCTypeSwitch"
ElseIf zAlcEdge.Type = 3 Then

MsgBox "Type = tpALCTypeSink"
ElseIf zAlcEdge.Type = 4 Then

MsgBox "Type = tpALCTypeTrafo"
ElseIf zAlcEdge.Type = 5 Then

MsgBox "Type = tpALCTypeLink"
End If

End Sub


Application
ObjectModel COM [image] Application
Remarks

Includes the whole application of the control system. This is the only object in the hierarchy, that can be used by the internal function GetObject of Visual Basic. You can only use GetObject, if the Runtime of the control system is already running.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
/* NOTE:
 * Uses Reference System.Windows.Forms to display messages via System.Windows.Forms.MessageBox
 * Make sure the reference is added and the namespace is included for the working code file*/

public void MacroGetProjects()
{
    //Use a string builder to generate a list of gathered information
    StringBuilder buildResult = new StringBuilder();
    buildResult.AppendLine(string.Format("Active Project: {0}", this.ActiveDocument.Name));
    buildResult.AppendLine("Projects in Workspace:");

    //Iterate through every single project and add its name to the string builder
    for(int i = 0; i < Application.Projects().Count; ++i)
    {
        zenOn.IProject zenonProject = Application.Projects().Item(i);
        if (zenonProject != null)
            buildResult.AppendLine(zenonProject.Name);
    }

    MessageBox.Show(buildResult.ToString(), "GetProjects", MessageBoxButtons.OK);
}
VB.NET
Copy
' NOTE:
' * Uses Reference System.Windows.Forms to display messages via System.Windows.Forms.MessageBox
' * Make sure the reference is added and the namespace is included for the working code file
'

Public Sub MacroGetProjects()
    'Use a string builder to generate a list of gathered information
    Dim buildResult As New StringBuilder()
    buildResult.AppendLine(String.Format("Active Project: {0}", Me.ActiveDocument.Name))
    buildResult.AppendLine("Projects in Workspace:")

    'Iterate through every single project and add its name to the string builder
    For i As Integer = 0 To Application.Projects().Count - 1
        Dim zenonProject As zenOn.IProject = Application.Projects().Item(i)
        If zenonProject IsNot Nothing Then
            buildResult.AppendLine(zenonProject.Name)
        End If
    Next

    MessageBox.Show(buildResult.ToString(), "GetProjects", MessageBoxButtons.OK)
End Sub
VBA
Copy
Public Sub GetProjects()
Dim strResult As String
Dim zPROJECT As Project
Dim i As Integer
'get active project...
strResult = "Active Project: " & MyWorkspace.ActiveDocument.Name & vbCrLf & vbCrLf
'get projects in workspace...
strResult = strResult & "Projects in Workspace:" & vbCrLf
For i = 0 To ApplicationED.Projects.Count - 1
Set zPROJECT = ApplicationED.Projects.Item(i)
If Not zPROJECT Is Nothing Then

strResult = strResult & zPROJECT.Name & vbCrLf
End If
Next i
'Show Result in a Messagebox
 MsgBox strResult, vbInformation, "GetProjects"
End Sub


Properties
ObjectModel COM [image] Application [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Computer | bstr | Returns the name of the computer on which the Runtime is running. | Available | Available | Available | Available
Enabled | variant_bool | Sets the visibility of the application main window. | Available | Available | Available | Available
Hide | variant_bool | This property returns/sets the visibility of the main window. | Available | Available | Available | Available
hWnd | ole_handle | Returns the handle of the main window of the application. | Available | Available | Available | Available
IsElementWizard | variant_bool | For internal use only | Unused | Unused | Available | Available
MyWorkspace | izenworkspace | Returns the ZenWorkspace object (Editor Only). | Readonly | Unused | Available | Available
Name | bstr | Returns the name of the application. | Available | Available | Available | Available
Path | bstr | Returns the path from which the application was started. | Available | Available | Available | Available
RunState | long | Returns the Application run state. | Readonly | Readonly | Available | Available
Version | bstr | Returns the version of the application. | Available | Available | Available | Available
VersionNumber | long | Returns the Application version. | Readonly | Readonly | Available | Available
WizardResult | variant | For internal use only | Unused | Unused | Available | Available


Computer
ObjectModel COM [image] Application [image] Properties [image] Computer
Remarks

This property returns the name of the computer on which the Runtime is running.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Enabled
ObjectModel COM [image] Application [image] Properties [image] Enabled
Remarks

Sets the visibility of the application main window. This property can be read as well as written. If the value is set to False, the window is deactivated. Thus online operation, e.g. switching pictures in the Runtime, is prevented.As a default the value is set to True. In this case online operation is possible.The example listed below accesses the object Application of the control system from an external application and de/activates the main window depending of the status.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Hide
ObjectModel COM [image] Application [image] Properties [image] Hide
Remarks

This property returns/sets the visibility of the main window. If the value is True, the main window is hidden. With the value False the main window is shown again.The sample listed below accesses the object Application of the control system from an external application and hides/shows the main window depending of the status.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


hWnd
ObjectModel COM [image] Application [image] Properties [image] hWnd
Remarks

This property returns the handle of the main window of the application. The handle mostly is needed for API calls, e.g. to send messages to the window.

Datatype
OLE_HANDLE

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


IsElementWizard
ObjectModel COM [image] Application [image] Properties [image] IsElementWizard
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


MyWorkspace
ObjectModel COM [image] Application [image] Properties [image] MyWorkspace
Remarks

Returns the Workspace object.

Datatype
IZenWorkspace

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] Application [image] Properties [image] Name
Remarks

This property returns the name of the application.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Path
ObjectModel COM [image] Application [image] Properties [image] Path
Remarks

This property returns the path from which the application was started. The name of the application is added to the path.For Example:C:\Program Files\COPA-DATA\zenOn620\zenrt32.exe

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


RunState
ObjectModel COM [image] Application [image] Properties [image] RunState
Remarks

Returns the Application run state.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Version
ObjectModel COM [image] Application [image] Properties [image] Version
Remarks

This property returns the version of the application.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


VersionNumber
ObjectModel COM [image] Application [image] Properties [image] VersionNumber
Remarks

Returns the Application version.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


WizardResult
ObjectModel COM [image] Application [image] Properties [image] WizardResult
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Application [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Activate | void | Switches the main window of the application to the foreground. | Available | Available | Available | Available
Close | void | Closes the application. | Available | Available | Available | Available
DebugPrint | void | Sends a message to the output window of the editor. | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
License [GET] | ilicense |  | Readonly | Readonly | Available | Available
Projects | iprojects | Returns the collection of projects loaded in the Runtime. | Available | Available | Available | Available
zenOnPath [GET] | bstr | Gets the absolute path of the specified directory. | Readonly | Readonly | Available | Available


Activate
ObjectModel COM [image] Application [image] Methods [image] Activate
Remarks

This method switches the main window of the application to the foreground (if this is not already the case).

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
/* NOTE:
 * Uses Reference System.Windows.Forms to display messages via System.Windows.Forms.MessageBox
 * Make sure the reference is added and the namespace is included for the working code file*/

void ThisProject_Active()
{
    this.Alarm().AlarmComes += new AlarmComesEventHandler(ThisProject_AlarmComes);
}

void ThisProject_AlarmComes(IAlarmItem obItem)
{
    //this.Parent.Parent is the actual Application object. for further details check the
    //class diagram for the zenOn API object model
    this.Parent.Parent.Activate();
}

void ThisProject_Inactive()
{
    this.Alarm().AlarmComes -= new AlarmComesEventHandler(ThisProject_AlarmComes);
    FreeObjects();
}
VB.NET
Copy
' NOTE:
' * Uses Reference System.Windows.Forms to display messages via System.Windows.Forms.MessageBox
' * Make sure the reference is added and the namespace is included for the working code file
'

Private Sub ThisProject_Active()
    Me.Alarm().AlarmComes += New AlarmComesEventHandler(AddressOf ThisProject_AlarmComes)
End Sub

Private Sub ThisProject_AlarmComes(obItem As IAlarmItem)
    'this.Parent.Parent is the actual Application object. for further details check the
    'class diagram for the zenOn API object model
    Me.Parent.Parent.Activate()
End Sub

Private Sub ThisProject_Inactive()
    Me.Alarm().AlarmComes -= New AlarmComesEventHandler(AddressOf ThisProject_AlarmComes)
    FreeObjects()
End Sub


Close
ObjectModel COM [image] Application [image] Methods [image] Close
Remarks

Closes the application.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
//This Macro will simply close the zenon application
public void MacroCloseApplication()
{
    Application.Close();
}
VB.NET
Copy
'This Macro will simply close the zenon application
Public Sub MacroCloseApplication()
    Application.Close()
End Sub


DebugPrint
ObjectModel COM [image] Application [image] Methods [image] DebugPrint
Remarks

Sends a message to the output window of the editor.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsText as BSTR

Message to be printed.

tpStyle as tpDebugPrintStyle

Defines the message catagory: normal, warning, informative or error.

Example
C#
Copy
public void MacroDebugPrintExample()
{
    //Use different channels of the debug output to print some text
    this.Application.DebugPrint("this is a normal text", tpDebugPrintStyle.tpNrm);
    this.Application.DebugPrint("this is a warning", tpDebugPrintStyle.tpWarn);
    this.Application.DebugPrint("this is an informative text", tpDebugPrintStyle.tpMsg);
    this.Application.DebugPrint("this is an error", tpDebugPrintStyle.tpErr);
}
VB.NET
Copy
Public Sub MacroDebugPrintExample()
    'Use different channels of the debug output to print some text
    Me.Application.DebugPrint("this is a normal text", tpDebugPrintStyle.tpNrm)
    Me.Application.DebugPrint("this is a warning", tpDebugPrintStyle.tpWarn)
    Me.Application.DebugPrint("this is an informative text", tpDebugPrintStyle.tpMsg)
    Me.Application.DebugPrint("this is an error", tpDebugPrintStyle.tpErr)
End Sub


DynProperties [GET]
ObjectModel COM [image] Application [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property, Example: "NetActive"

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] Application [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property, Example: "NetActive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.


DynPropertiesEnum [GET]
ObjectModel COM [image] Application [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the entry point to get out all available properties of the object.


DynPropertyParam [GET]
ObjectModel COM [image] Application [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the entry point to get out all available properties of the object.


License [GET]
ObjectModel COM [image] Application [image] Methods [image] License [GET]
Remarks

Datatype
ILicense

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Projects
ObjectModel COM [image] Application [image] Methods [image] Projects
Remarks

Returns the collection of projects loaded in the Runtime (object Application). With this projectlist the loaded projects can be accessed. The collection Projects can be accessed directly or it can be stored in a temporary variable.Each project is offered as Project object in VBA (IProject in VSTA).

Datatype
IProjects

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
//Iterate through all projects and create the runtime files
public void MacroCreateAllRuntimeFiles()
{
    for (int i = 0; i < Application.Projects().Count; ++i)
    {
        zenOn.IProject zenonProject = Application.Projects().Item(i);
        try
        {
            //tpAll re-creates every single runtime file in the project
            zenonProject.Build(zenOn.tpBuildMethod.tpAll);
        }
        catch (Exception ex)
        {
            this.Parent.DebugPrint(string.Format("Error while creating project {0} | Error Message: {1}",
                zenonProject.Name, ex.Message), zenOn.tpDebugPrintStyle.tpErr);
            throw;
        }
    }
}
VB.NET
Copy
'Iterate through all projects and create the runtime files
Public Sub MacroCreateAllRuntimeFiles()
    For i As Integer = 0 To Application.Projects().Count - 1
        Dim zenonProject As zenOn.IProject = Application.Projects().Item(i)
        Try
            'tpAll re-creates every single runtime file in the project
            zenonProject.Build(zenOn.tpBuildMethod.tpAll)
        Catch ex As Exception
            Me.Parent.DebugPrint(String.Format("Error while creating project {0} | Error Message: {1}", zenonProject.Name, ex.Message), zenOn.tpDebugPrintStyle.tpErr)
            Throw
        End Try
    Next
End Sub
VBA
Copy
'create all runtime files for all projects in the workspace...
Public Sub CreateAllRuntimeFiles()
Dim i As Integer
On Error Resume Next
For i = 0 To ApplicationED.Projects.Count - 1

ApplicationED.Projects.Item(i).Build tpAll
Next i
End Sub


zenOnPath [GET]
ObjectModel COM [image] Application [image] Methods [image] zenOnPath [GET]
Remarks

Gets the absolute path of the specified directory (tpZenPathType)

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lPath as tpZenPathType

Number or Constant

Example
C#
Copy
public void MacroOpenZenonFolder()
{
    //Gets the (user) path of the zenOn application
    string folder = this.Application.get_zenOnPath(tpZenPathType.tpzenOnUserPath);
    //Opens the folder in a new explorer window or prints an error.
    try
    {
        System.Diagnostics.Process.Start(folder);
    }
    catch (Exception ex)
    {
        this.Application.DebugPrint("Error opening user path: " + ex.Message, tpDebugPrintStyle.tpErr);
    }
}
VB.NET
Copy
Public Sub MacroOpenZenonFolder()
    'Gets the (user) path of the zenOn application
    Dim folder As String = Me.Application.get_zenOnPath(tpZenPathType.tpzenOnUserPath)
    'Opens the folder in a new explorer window or prints an error.
    Try
        System.Diagnostics.Process.Start(folder)
    Catch ex As Exception
        Me.Application.DebugPrint("Error opening user path: " + ex.Message, tpDebugPrintStyle.tpErr)
    End Try
End Sub


Events
ObjectModel COM [image] Application [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
OnClose | void | This event is fired when the application is about to be closed. | Available | Available | Available | Available


OnClose
ObjectModel COM [image] Application [image] Events [image] OnClose
Remarks

This event is fired when the application is about to be closed (before it is closed)

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
/* NOTE:
 * Uses Reference System.Windows.Forms to display messages via System.Windows.Forms.MessageBox
 * Make sure the reference is added and the namespace is included for the working code file*/

void ThisProject_Active()
{
    this.Parent.Parent.OnClose += new OnCloseEventHandler(Parent_OnClose);
}

void Parent_OnClose()
{
    //When the runtime is about to be closed a message box will be displayed.
    MessageBox.Show("The application is about to be closed!");
}

void ThisProject_Inactive()
{
    this.Parent.Parent.OnClose -= new OnCloseEventHandler(Parent_OnClose);
    FreeObjects();
}
VB.NET
Copy
Imports System.Windows.Forms 'NOTE: The reference System.Windows.Forms has to be included into the reference list.

Private Sub ThisProject_Active()
    AddHandler Me.Parent.OnClose, AddressOf Parent_OnClose
End Sub

Private Sub Parent_OnClose()
    'When the runtime is about to be closed a message box will be displayed.
    MessageBox.Show("The application is about to be closed!")
End Sub

Private Sub ThisProject_Inactive()
    RemoveHandler Me.Parent.OnClose, AddressOf Parent_OnClose
    FreeObjects()
End Sub


Archive
ObjectModel COM [image] Archive
Remarks

The "Archive" object contains project information like the name, the source archive and other properties. The archive also is the basis for "ArchiveVariables" and "ArchiveFilters".The "ArchiveVariables" object contains all archive variables. Each archive variable contains further projecting information.With the "ArchiveFilters" object you can define and execute dynamic filters. In a filter you can define the variables from which you need the values. Additionally you can define the time period and the status. On executing the filter you get a list with all Runtime variables for that filter.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroZenOnArchive()
{
    //Gets the first archive of the project
    IArchive zenonArchive = this.Archives().Item(0);
    if (zenonArchive == null)
    {
        //There is no archive, the user will be informed...
        this.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr);
        return;
    }
    //There is an archive, output some details on it
    this.Parent.Parent.DebugPrint("Name: " + zenonArchive.Name, tpDebugPrintStyle.tpMsg);
    this.Parent.Parent.DebugPrint("Type: " + zenonArchive.Type.ToString(), tpDebugPrintStyle.tpMsg);
    this.Parent.Parent.DebugPrint("Term: " + zenonArchive.LongName,tpDebugPrintStyle.tpMsg);
    this.Parent.Parent.DebugPrint("ID:   " + zenonArchive.ID, tpDebugPrintStyle.tpMsg);
}
VB.NET
Copy
Public Sub MacroZenOnArchive()
    'Gets the first archive of the project
    Dim zenonArchive As IArchive = Me.Archives().Item(0)
    If zenonArchive Is Nothing Then
        'There is no archive, the user will be informed...
        Me.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr)
        Return
    End If
    'There is an archive, output some details on it
    Me.Parent.Parent.DebugPrint("Name: " + zenonArchive.Name, tpDebugPrintStyle.tpMsg)
    Me.Parent.Parent.DebugPrint("Type: " & zenonArchive.Type.ToString(), tpDebugPrintStyle.tpMsg)
    Me.Parent.Parent.DebugPrint("Term: " + zenonArchive.LongName, tpDebugPrintStyle.tpMsg)
    Me.Parent.Parent.DebugPrint("ID:   " + zenonArchive.ID, tpDebugPrintStyle.tpMsg)
End Sub
VBA
Copy
Sub zenOn_Archive()
'Declarations
Dim zArchive As Archive
'Initialize zArchive with the first available archive
Set zArchive = thisProject.Archives.Item(0)
'If no archive is available ...
If zArchive Is Nothing Then

'... then inform the user

MsgBox ("No archive available!")

'Otherwise, output some details on the archive
Else

'Output the name

Debug.Print "Name: " & zArchive.Name

'Output the type

Select Case zArchive.Type

Case Is = 1

Debug.Print vbTab & "Type: Cyclic scanning"

'Output the cycle rate, if the archive is cyclic

Debug.Print vbTab & "Cycle rate: " & zArchive.Cycle

Case Is = 2

Debug.Print vbTab & "Type: Event-triggered scanning"

Case Is = 3

Debug.Print vbTab & "Type: Spontaneous scanning"

End Select

'Output the term

Debug.Print vbTab & "Term: " & zArchive.LongName

'Output the ID

Debug.Print vbTab & "ID: " & zArchive.ID
End If
End Sub


Properties
ObjectModel COM [image] Archive [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Cycle | long | Reading in of the values is done cyclically by the system (days, hours, minutes and seconds) | Unused | Readonly | Available | Available
ID | long | Returns the unique ID of the current archive. | Unused | Readonly | Available | Available
Identifier | bstr | Returns the archive identifier. | Unused | Readonly | Available | Available
LongName | bstr | For internal use only | Unused | Readonly | Available | Available
Name | bstr | Returns the name of the current "Archive" object. | Unused | Readonly | Available | Available
Parent | iarchives | Returns the parent object. | Unused | Readonly | Available | Available
Type | short |  | Unused | Readonly | Available | Available


Cycle
ObjectModel COM [image] Archive [image] Properties [image] Cycle
Remarks

Returns the cycle rate of the current archive in seconds. Hint: In the case of an event-triggered or spontaneous scanning archive, this property will return 0.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ID
ObjectModel COM [image] Archive [image] Properties [image] ID
Remarks

Returns the unique ID of the current archive.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Identifier
ObjectModel COM [image] Archive [image] Properties [image] Identifier
Remarks

Returns the identificator, also called "term" within zenOn, of the current archive.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


LongName
ObjectModel COM [image] Archive [image] Properties [image] LongName
Remarks

Returns the identificator, also called "term" within zenOn, of the current archive.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] Archive [image] Properties [image] Name
Remarks

wo-character unique short identifier of the archive; Relevant for automatic issuing of names with export functions; (CAUTION: Release of the other input fields occurs only after input of the short identifier)

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Archive [image] Properties [image] Parent
Remarks

Returns the parent object.

Datatype
IArchives

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] Archive [image] Properties [image] Type
Remarks

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Archive [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ArchiveFilters | iarchivefilters | Returns a collection ("ArchiveFilters" object) of all available filters. | Unused | Available | Available | Available
ArchiveRecordingType [GET] | archiverecordingtype |  | Unused | Readonly | Available | Available
ArchiveVariables | iarchivevariables | Returns a collection ("ArchiveVariables" object) with all assigned archive variables. | Unused | Available | Available | Available
BatchIndex [GET] | variant | Returns the batchinformation of the archive. | Unused | Readonly | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available


ArchiveFilters
ObjectModel COM [image] Archive [image] Methods [image] ArchiveFilters
Remarks

Returns a collection ("ArchiveFilters" object) of all available filters. It is also possible to create new filters and delete existing ones.Hint: For further information, please have a look at the "ArchiveFilters" part.

Datatype
IArchiveFilters

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ArchiveRecordingType [GET]
ObjectModel COM [image] Archive [image] Methods [image] ArchiveRecordingType [GET]
Remarks

Datatype
ArchiveRecordingType

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ArchiveVariables
ObjectModel COM [image] Archive [image] Methods [image] ArchiveVariables
Remarks

Returns a collection ("ArchiveVariables" object) with all assigned archive variables.Hint: For further information, please have a look, at the "ArchiveVariables" part.

Datatype
IArchiveVariables

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


BatchIndex [GET]
ObjectModel COM [image] Archive [image] Methods [image] BatchIndex [GET]
Remarks

Returns the index of the archive.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


DynProperties [GET]
ObjectModel COM [image] Archive [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property, Example: "NetActive"

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] Archive [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property, Example: "NetActive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.


DynPropertiesEnum [GET]
ObjectModel COM [image] Archive [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property, Example: "NetActive"


DynPropertyParam [GET]
ObjectModel COM [image] Archive [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property, Example: "NetActive"


ArchiveED
ObjectModel COM [image] ArchiveED
Remarks

The "ArchiveED" object contains project information like the name, the source archive and other properties.It is used within the editor in order to initialize the archive. Hence, the object won't be available in the runtime. In the "Archive" object, which will be available in the runtime, some properties will be set to read-only. Therefore all important initialization should be done by means of the "ArchiveED" object.

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroZenOnArchiveEd()
{
    IArchiveED zenonArchiveEd = this.ActiveDocument.ArchivesED().Item("01");
    /* if there is no such archive available create it with
     * the given identification name "01" and the name
     * "zenon_ArchiveED"
     */
    if (zenonArchiveEd == null)
    {
        zenonArchiveEd = this.ActiveDocument.ArchivesED().
            CreateArchive("01", "zenOn_ArchiveED", null);
    }
    //Create some settings for the Archive
    zenonArchiveEd.set_DynProperties("Cyclic", 1);
    zenonArchiveEd.set_DynProperties("TimeGap", 5);
    zenonArchiveEd.set_DynProperties("Offset", 0);
    zenonArchiveEd.set_DynProperties("Cycle", 60);
    //Set the Cycle Start to 12:00 local time on the 30th of July 2007
    zenonArchiveEd.set_DynProperties("CycleStart",
        TimeConversion.SystemToZenOn(
        new DateTime(2007, 07, 30, 12, 0, 0)));
    zenonArchiveEd.AddVariable("WIZ_VAR_12", tpArvVarCal.tpCalc_All, null);

    //Output the new configuration (To Debug, for example)
    this.Parent.
        DebugPrint("Name: " +
        zenonArchiveEd.get_DynProperties("ShortName") + " - "
        + zenonArchiveEd.get_DynProperties("LongName"),
        tpDebugPrintStyle.tpNrm);

    this.Parent.DebugPrint("Cyclic: " +
        zenonArchiveEd.get_DynProperties("Cyclic"),
        tpDebugPrintStyle.tpNrm);

    this.Parent.DebugPrint("Scanning cycle: " +
        zenonArchiveEd.get_DynProperties("TimeGap"),
        tpDebugPrintStyle.tpNrm);

    this.Parent.DebugPrint("Offset: "
        + zenonArchiveEd.get_DynProperties("Offset") + " sec",
        tpDebugPrintStyle.tpNrm);

    this.Parent.DebugPrint("Save Cycle: " +
        zenonArchiveEd.get_DynProperties("Cycle"),
        tpDebugPrintStyle.tpNrm);

    //We have to reconvert the internally used time stamp format to a human readable format
    this.Parent.DebugPrint("Cycle start: " +
        TimeConversion.ZenOnToSystem((uint)zenonArchiveEd.get_DynProperties("CycleStart")).ToString(),
        tpDebugPrintStyle.tpNrm);
}
VB.NET
Copy
Public Sub MacroZenOnArchiveEd()
    Dim zenonArchiveEd As IArchiveED = Me.ActiveDocument.ArchivesED().Item("01")
    ' if there is no such archive available create it with
'     * the given identification name "01" and the name
'     * "zenon_ArchiveED"
'

    If zenonArchiveEd Is Nothing Then
        zenonArchiveEd = Me.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", Nothing)
    End If
    'Create some settings for the Archive
    zenonArchiveEd.set_DynProperties("Cyclic", 1)
    zenonArchiveEd.set_DynProperties("TimeGap", 5)
    zenonArchiveEd.set_DynProperties("Offset", 0)
    zenonArchiveEd.set_DynProperties("Cycle", 60)
    'Set the Cycle Start to 12:00 local time on the 30th of July 2007
    zenonArchiveEd.set_DynProperties("CycleStart", TimeConversion.SystemToZenOn(New DateTime(2007, 7, 30, 12, 0, 0)))
    zenonArchiveEd.AddVariable("WIZ_VAR_12", tpArvVarCal.tpCalc_All, Nothing)

    'Output the new configuration (To Debug, for example)
    Me.Parent.DebugPrint("Name: " & zenonArchiveEd.get_DynProperties("ShortName") & " - " & zenonArchiveEd.get_DynProperties("LongName"), tpDebugPrintStyle.tpNrm)

    Me.Parent.DebugPrint("Cyclic: " & zenonArchiveEd.get_DynProperties("Cyclic"), tpDebugPrintStyle.tpNrm)

    Me.Parent.DebugPrint("Scanning cycle: " & zenonArchiveEd.get_DynProperties("TimeGap"), tpDebugPrintStyle.tpNrm)

    Me.Parent.DebugPrint("Offset: " & zenonArchiveEd.get_DynProperties("Offset") & " sec", tpDebugPrintStyle.tpNrm)

    Me.Parent.DebugPrint("Save Cycle: " & zenonArchiveEd.get_DynProperties("Cycle"), tpDebugPrintStyle.tpNrm)

    'We have to reconvert the internally used time stamp format to a human readable format
    Me.Parent.DebugPrint("Cycle start: " & TimeConversion.ZenOnToSystem(CUInt(zenonArchiveEd.get_DynProperties("CycleStart"))).ToString(), tpDebugPrintStyle.tpNrm)
End Sub
VBA
Copy
Sub zenOn_ArchiveED()
'Declarations
Dim zArchiveED As ArchiveED
Dim zTimeConvert As clsTimeConvert
Dim i As Integer
'Initialize zArchiveED with the archive selected by the identification name "01"
Set zArchiveED = MyWorkspace.ActiveDocument.ArchivesED.Item("01")
'If no such archive is available ...
If zArchiveED Is Nothing Then

'... then create a whole new archive with the identification name "01" and the name "zenOn_ArchiveED"

Set zArchiveED = MyWorkspace.ActiveDocument.ArchivesED.CreateArchive("01",
"zenOn_ArchiveED", Nothing)
End If
'Initialize zTimeConvert by creating a new instance of the zenOn

"clsTimeConvert" macro
Set zTimeConvert = New clsTimeConvert
With zArchiveED

'Set the scanning mode: Cyclic scanning

.DynProperties("Cyclic") = 1

'Set the scanning cycle rate: 5 seconds

.DynProperties("TimeGap") = 5

'Set the offset: 0 seconds

.DynProperties("Offset") = 0

'Set the saving cycle: 60 seconds

.DynProperties("Cycle") = 60

'Set the start time of the cycle: 2007-07-30 12:00:00

.DynProperties("CycleStart") = zTimeConvert.System2zenOn(CDbl(CDate("30.07.2007 12:00:00")))

'Add the "WIZ_VAR_12" variable to the archive

.AddVariable "WIZ_VAR_12", 0, Nothing
End With
'Output the configuration
With zArchiveED

'Output the identifier and the name

Debug.Print "Name: " & .DynProperties("ShortName") & " - " &
.DynProperties("LongName")

'Output the scanning mode

Debug.Print vbTab & "Cyclic: " & .DynProperties("Cyclic")

'Output the scanning cycle

Debug.Print vbTab & "Scanning cycle: " & .DynProperties("TimeGap") & " sec."

'Output the offset

Debug.Print vbTab & "Offset: " & .DynProperties("Offset") & " sec."

'Output the archive saving cycle

Debug.Print vbTab & "Save cycle: " & .DynProperties("Cycle") & " sec."

'Output the start time of the cycle

Debug.Print vbTab & "Cycle start: " &
Format(zTimeConvert.zenOn2System(CDbl(.DynProperties("CycleStart"))), "yyyy-mm-dd hh:mm:ss")
End With

End Sub


Properties
ObjectModel COM [image] ArchiveED [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Readonly | Available | Available
Parent | iarchivesed | Returns the parent object | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] ArchiveED [image] Properties [image] Count
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] ArchiveED [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IArchivesED

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ArchiveED [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AddVariable | iarchivevared | Adds a new Variable to the collection. | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available
ImportArchiveTemplate | importarchivetemplateresult |  | Available | Unused | Available | Available
ImportArvTemplate | short |  | Available | Unused | Available | Available
Item | iarchivevared | Returns an "ArchiveVarED" object from the collection, which is identified by the parameter vNameOrPos. | Available | Unused | Available | Available
RemoveVariable | variant_bool | Removes an assigned "Variable" object from the collection. | Available | Unused | Available | Available


AddVariable
ObjectModel COM [image] ArchiveED [image] Methods [image] AddVariable
Remarks

Adds a new Variable to the collection. The variable is identified by its name or ID.

Datatype
IArchiveVarED

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vNameOrID as VARIANT

tpCalculation as tpArvVarCal

Set the calculation type.

pSourceArchive as IArchiveED

The ArchiveED object.

Example
C#
Copy
public void MacroAddVariableArchiveED()
{
    IArchiveED zenonArchiveED = this.ActiveDocument.ArchivesED().Item("01");
    if (zenonArchiveED == null)
    {
        /* if there is no such archive available create it with
         * the given identification name "01" and the name
         * "zenon_ArchiveED"
         */
        zenonArchiveED = this.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", null);
    }
    /* Add a variable to a given ArchiveED object
     * Set the calculation type to All
     * Set the source Archive to NULL
     */
    IArchiveVarED zenonArchVar = zenonArchiveED.AddVariable("WIZ_VAR_12", tpArvVarCal.tpCalc_All, null);
    if (zenonArchiveED == null)
    {
        //The variable "WIZ_VAR_12" is non-existant
        this.Parent.DebugPrint("Variable not found!", tpDebugPrintStyle.tpMsg);
    }
}
VB.NET
Copy
Public Sub MacroAddVariableArchiveED()
    Dim zenonArchiveED As IArchiveED = Me.ActiveDocument.ArchivesED().Item("01")
    If zenonArchiveED Is Nothing Then
        ' if there is no such archive available create it with
'         * the given identification name "01" and the name
'         * "zenon_ArchiveED"
'

        zenonArchiveED = Me.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", Nothing)
    End If
    ' Add a variable to a given ArchiveED object
'     * Set the calculation type to All
'     * Set the source Archive to NULL
'

    Dim zenonArchVar As IArchiveVarED = zenonArchiveED.AddVariable("WIZ_VAR_12", tpArvVarCal.tpCalc_All, Nothing)
    If zenonArchiveED Is Nothing Then
        'The variable "WIZ_VAR_12" is non-existant
        Me.Parent.DebugPrint("Variable not found!", tpDebugPrintStyle.tpMsg)
    End If
End Sub


DynProperties [GET]
ObjectModel COM [image] ArchiveED [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property, Example: "NetActive"


DynProperties [PUT]
ObjectModel COM [image] ArchiveED [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property, Example: "NetActive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.


DynPropertiesEnum [GET]
ObjectModel COM [image] ArchiveED [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the entry point to get out all available properties of the object.

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] ArchiveED [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property, Example: "NetActive"


ImportArchiveTemplate
ObjectModel COM [image] ArchiveED [image] Methods [image] ImportArchiveTemplate
Remarks

Datatype
ImportArchiveTemplateResult

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
p_filePath as BSTR


ImportArvTemplate
ObjectModel COM [image] ArchiveED [image] Methods [image] ImportArvTemplate
Remarks

Imports the archive from an XML file.

Datatype
short

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
FileName as BSTR

Path to the XML file.

Example
VBA
Copy
Private Sub ImportArvTemplate()
Dim obArchsED As ArchivesED
Dim obArchED As ArchiveED
Dim iRet As Integer

 Set obArchsED = MyWorkspace.ActiveDocument.ArchivesED
 Set obArchED = obArchsED.Item(0)
 If Not obArchED Is Nothing Then
 iRet = obArchED.ImportArvTemplate("C:\ProgramData\COPA-DATA\zenon711\Templates\Archives\GERMAN\6eeae916-0098-40ab-9dc9-a9ce1dcf4bb5.xml", True)
 End If
End Sub


Item
ObjectModel COM [image] ArchiveED [image] Methods [image] Item
Remarks

Returns an "ArchiveVarED" object from the collection, which is identified by the parameter vNameOrPos.The parameter vNameOrPos can have two values:

  • Element name:The element can be accessed with the unique name of the corresponding "Variable" object that was assigned to the "ArchiveVarED" object.
  • Index:Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveVarED" object in the list.
Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IArchiveVarED

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT

The variable is identified by its name or index.

Example
C#
Copy
public void MacroIterateArchiveED()
{
    IArchiveED zenonArchiveED = this.ActiveDocument.ArchivesED().Item("01");
    if (zenonArchiveED == null)
    {
        /* if there is no such archive available create it with
         * the given identification name "01" and the name
         * "zenon_ArchiveED"
         */
        zenonArchiveED = this.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", null);
    }
    //Iterate through all archive variables and print their names
    for (int i = 0; i < zenonArchiveED.Count(); ++i)
    {
        this.Parent.DebugPrint("Variable " + ((IVariable)zenonArchiveED.Item(i).
            get_DynProperties("Variable")).Name +
                " is in " + zenonArchiveED.get_DynProperties("LongName"), tpDebugPrintStyle.tpMsg);
    }
}
VB.NET
Copy
Public Sub MacroIterateArchiveED()
    Dim zenonArchiveED As IArchiveED = Me.ActiveDocument.ArchivesED().Item("01")
    If zenonArchiveED Is Nothing Then
        ' if there is no such archive available create it with
'         * the given identification name "01" and the name
'         * "zenon_ArchiveED"
'

        zenonArchiveED = Me.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", Nothing)
    End If
    'Iterate through all archive variables and print their names
    For i As Integer = 0 To zenonArchiveED.Count() - 1
        Me.Parent.DebugPrint("Variable " + DirectCast(zenonArchiveED.Item(i).get_DynProperties("Variable"), IVariable).Name & " is in " & zenonArchiveED.get_DynProperties("LongName"), tpDebugPrintStyle.tpMsg)
    Next
End Sub


RemoveVariable
ObjectModel COM [image] ArchiveED [image] Methods [image] RemoveVariable
Remarks

Removes an assigned "Variable" object from the collection. The variable is identified by its name or ID.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vNameOrID as VARIANT

The variable is identified by its name or ID.

Example
C#
Copy
public void MacroRemoveVariableArchiveED()
{
    IArchiveED zenonArchiveED = this.ActiveDocument.ArchivesED().Item("01");
    if (zenonArchiveED == null)
    {
        /* if there is no such archive available create it with
         * the given identification name "01" and the name
         * "zenon_ArchiveED"
         */
        zenonArchiveED = this.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", null);
    }

    if (zenonArchiveED.RemoveVariable("WIZ_VAR_12"))
    {
        //The variable was removed correctly
        this.Parent.DebugPrint("Variable removed from archive!", tpDebugPrintStyle.tpMsg);
    }
    else
    {
        //The variable was not removed correctly i.e. not found
        this.Parent.DebugPrint("Variable was not found!", tpDebugPrintStyle.tpMsg);
    }
}
VB.NET
Copy
Public Sub MacroRemoveVariableArchiveED()
    Dim zenonArchiveED As IArchiveED = Me.ActiveDocument.ArchivesED().Item("01")
    If zenonArchiveED Is Nothing Then
        ' if there is no such archive available create it with
'         * the given identification name "01" and the name
'         * "zenon_ArchiveED"
'

        zenonArchiveED = Me.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", Nothing)
    End If

    If zenonArchiveED.RemoveVariable("WIZ_VAR_12") Then
        'The variable was removed correctly
        Me.Parent.DebugPrint("Variable removed from archive!", tpDebugPrintStyle.tpMsg)
    Else
        'The variable was not removed correctly i.e. not found
        Me.Parent.DebugPrint("Variable was not found!", tpDebugPrintStyle.tpMsg)
    End If
End Sub


DynProperties
ObjectModel COM [image] ArchiveED [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Archive


Archive
ObjectModel COM [image] ArchiveED [image] DynProperties [image] Archive
Overview
External Name | Type | Display Name | Description
AuslUnicode | Bool | AuslUnicode | This property returns if the archive is evacuated in unicode when the evacuation via ASCII is selected.
AzureConnection | String | AzureConnection | Description
BeginTime | UInt32 | BeginTime | Returns the time an archive file is created.
ChargeVar | CProjektVariable | ChargeVar | This property gets/sets the variable which is used as batch variable.
Count | UInt16 | Count | This property gets/sets the number of archive files which are evacuated. For example: Scan cycle of 10 minutes and an evacuation storage time of 2 hours sets the count property on value 6.
Cycle | UInt32 | Cycle | This property gets/sets the number of values which are arranged in an archive file. For example: Scan cycle of 1 second and cyclic file creation every 30 seconds sets the cycle property on value 30.
CycleStart | UInt32 | CycleStart | This property gets/sets the cycle start time.
Cyclic | Byte | Cyclic | "This property gets/sets the scanning settings of an archive. Cyclic scanning, Cycle = 9 Cyclic scanning, Monthly = 13 Event triggered scanning, Internal = 7 Event triggered scanning, External = 15 Spontaneous scanning = 14"
DataSource | String | DataSource | This property gets/sets the database provider string for the sql evacuation of the archives.
EvacuationStatusVar | CProjektVariable | EvacuationStatusVar | Description
EventVar | CProjektVariable | EventVar | This property gets/sets the trigger variable of an archive.
FileFormat | UInt32 | FileFormat | "This property gets/sets the kind of archive saving format. Internal database (*.arx), no evacuation = 9 Internal database (*.arx), evacuation in internal format (*.arx) = 2049 Internal database (*.arx), evacuation in SQL database (*.arx) = 1025 Internal database (*.arx), evacuation in XML format (*.xml) = 513 Internal database (*.arx), evacuation in ASCII format (*.txt) = 33 Internal database (*.arx), evacuation in dBase IV format (*.dbf) = 33 dBase IV format (*.dbf), no evacuation = 10 ASCII file (*.txt), no evacuation = 10 XML file (*.xml), no evacuation = 264 "
FilterHierarchic | Bool | FilterHierarchic | Description
FktEnd | UInt32 | FktEnd | This property gets/sets the function which is linked as end function via its function ID.
FktStart | UInt32 | FktStart | This property gets/sets the function which is linked as end function via its function ID.
Flags | UInt32 | Flags | "This property gets/sets the ""option"" settings of an archive via a bit coded value."
Format | String | Format | This property gets/sets the format of ASCII/dBase evacuation files.
IsChargeIdx | Bool | IsChargeIdx | "This property gets/sets the ""index batches"" option of an batch archive. "
LastIndex | UInt32 | LastIndex |
LongName | String | LongName | This property gets/sets the name of the archive.
Modus | UInt16 | Modus | This property gets/sets the kind of start and stop of an archive. At start and end of runtime = 3 User defined = 2 RDA block archive = 0
Offset | UInt32 | Offset | This property gets/sets the offset time (in sec) when cyclic scanning is used.
RunningStatusVar | CProjektVariable | RunningStatusVar | Description
ShortName | String | ShortName | This property gets/sets the identificator of an archive.
SourceShortName | String | SourceShortName | This property gets the identificatior of the head archive. It is only set when a follow archive is available.
StateActiveF | UInt64 | StateActiveF |
StateActiveFBanned | UInt64 | StateActiveFBanned |
StateF | UInt64 | StateF |
StateFBanned | UInt64 | StateFBanned |
SystemModelGroup | CD_CMemFile | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
TimeGap | UInt32 | TimeGap |
Unicode | Bool | Unicode | This property gets/sets the unicode flag when the saving format ASCII is used for archives.
UseAzureServiceBus | Bool | UseAzureServiceBus | Description


ArchiveFilter
ObjectModel COM [image] ArchiveFilter
Remarks

The "ArchiveFilter" object is used to filter archive entries by a specified date / time and state.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MarcroZenOnArchiveFilter()
{
    //Gets the first archive of the project
    IArchive zenonArchive = this.Archives().Item(0);
    if (zenonArchive == null)
    {
        //There is no archive, the user will be informed...
        this.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr);
        return;
    }
    IArchiveFilter zenonArchiveFilter = zenonArchive.ArchiveFilters().CreateArchiveFilter();
    for (int i = 0; i < zenonArchive.ArchiveVariables().Count; ++i)
    {
        //Add every archive variable to the archive filter
        zenonArchiveFilter.AddArchiveVariable(zenonArchive.ArchiveVariables().Item(i));
    }

    //Set the StartTime to 14:00 on the 30th of july 2007
    zenonArchiveFilter.StartTime = (int)TimeConversion.
        SystemToZenOn(new DateTime(2007, 07, 30, 14, 0, 0));

    //Set the EndTime to 11:15 on the 31st of july 2007
    zenonArchiveFilter.EndTime = (int)TimeConversion.
        SystemToZenOn(new DateTime(2007,07,31,11,15,00));

    zenonArchiveFilter.StatusMask = 0x41000; //Check only I-BIT + HWERT
    zenonArchiveFilter.StatusBit = 0x41000; //Return data if one of those bit is true or both

    //Initiate a filter query
    IArchiveFilterVariables zenonArchiveVariables = zenonArchiveFilter.Query();
    for (int i = 0; i < zenonArchiveVariables.Count; ++i)
    {
        this.Parent.Parent.DebugPrint("Variable: " + zenonArchiveVariables.Item(i).ArchiveVariable().Name, tpDebugPrintStyle.tpNrm);
        this.Parent.Parent.DebugPrint("I-BIT + HWERT: " + zenonArchiveVariables.Item(i).ArchiveValues().Count, tpDebugPrintStyle.tpNrm);
    }
}
VB.NET
Copy
Public Sub MarcrozenOnArchiveFilter()
    'Gets the first archive of the project
    Dim zenonArchive As IArchive = Me.Archives().Item(0)
    If zenonArchive Is Nothing Then
        'There is no archive, the user will be informed...
        Me.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr)
        Return
    End If
    Dim zenonArchiveFilter As IArchiveFilter = zenonArchive.ArchiveFilters().CreateArchiveFilter()
    For i As Integer = 0 To zenonArchive.ArchiveVariables().Count - 1
        'Add every archive variable to the archive filter
        zenonArchiveFilter.AddArchiveVariable(zenonArchive.ArchiveVariables().Item(i))
    Next

    'Set the StartTime to 14:00 on the 30th of july 2007
    zenonArchiveFilter.StartTime = CInt(TimeConversion.SystemToZenOn(New DateTime(2007, 7, 30, 14, 0, 0)))

    'Set the EndTime to 11:15 on the 31st of july 2007
    zenonArchiveFilter.EndTime = CInt(TimeConversion.SystemToZenOn(New DateTime(2007, 7, 31, 11, 15, 0)))

    zenonArchiveFilter.StatusMask = &H41000
    'Check only I-BIT + HWERT
    zenonArchiveFilter.StatusBit = &H41000
    'Return data if one of those bit is true or both
    'Initiate a filter query
    Dim zenonArchiveVariables As IArchiveFilterVariables = zenonArchiveFilter.Query()
    For i As Integer = 0 To zenonArchiveVariables.Count - 1
        Me.Parent.Parent.DebugPrint("Variable: " + zenonArchiveVariables.Item(i).ArchiveVariable().Name, tpDebugPrintStyle.tpNrm)
        Me.Parent.Parent.DebugPrint("I-BIT + HWERT: " + zenonArchiveVariables.Item(i).ArchiveValues().Count, tpDebugPrintStyle.tpNrm)
    Next
End Sub
VBA
Copy
Sub zenOn_ArchiveFilter()
'Declarations
Dim zArchive As Archive
Dim zArvFilter As ArchiveFilter
Dim zArvVars As ArchiveFilterVariables
Dim zTimeConvert As clsTimeConvert
Dim dTime As Double
Dim i As Integer
'Initialize zArchive with the first available archive
Set zArchive = thisProject.Archives.Item(0)
'If no archive is availabe, then ...
If zArchive Is Nothing Then

'... inform the user

MsgBox ("No archive available!")

Else

'Initialize zArvFilter by creating a new archive filter

Set zArvFilter = zArchive.ArchiveFilters.CreateArchiveFilter

'Every archive variable within the collection...

For i = 0 To zArchive.ArchiveVariables.Count - 1

'... will be added to the archive filter

zArvFilter.AddArchiveVariable zArchive.ArchiveVariables.Item(i)
Next i

'Initialize zTimeConvert by creating a new instance of the zenOn
"clsTimeConvert" macro

Set zTimeConvert = New clsTimeConvert

'Set dTime by converting the desired system time into the zenOn
compatible UTC time

dTime = zTimeConvert.System2zenOn(CDbl(CDate("30.07.2007 14:00:00")))

'Set the converted time as the start time for the filter

zArvFilter.StartTime = dTime

'Set dTime by converting the desired system time into the zenOn compatible UTC time

dTime = zTimeConvert.System2zenOn(CDbl(CDate("31.07.2007 11:15:00")))

'Set the converted time as the end time for the filter

zArvFilter.EndTime = dTime

'All I-BIT and HWERT bits

zArvFilter.StatusMask = &H41000 'Check only I-BIT + HWERT

zArvFilter.StatusBit = &H41000 'Return data if one of those bits are TRUE or both

'Initialize zArvVars by initiating a new filter query

Set zArvVars = zArvFilter.Query

'For every filtered variable within the result...

For i = 0 To zArvVars.Count - 1

With zArvVars.Item(i)

'... output the name of the variable ...

Debug.Print "Variable: " & .ArchiveVariable.Name

'... and the amount of I-BIT and HWERT bits within the specified time range

Debug.Print vbTab & "I-BIT + HWERT: " & .ArchiveValues.Count & vbNewLine

End With

Next i
End If
End Sub


Properties
ObjectModel COM [image] ArchiveFilter [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CountArchiveVariables | long | Returns the amount of "ArchiveVariable" objects within the collection.Returns the amount of "ArchiveVariable" objects within the collection. | Unused | Readonly | Available | Available
EndTime | long | Gets or sets the end time of the filter. | Unused | Available | Available | Available
Parent | iarchivefilters | Returns the parent object | Unused | Readonly | Available | Available
Raster | long | Returns archive entries according to the set raster:3 means every third entry is returned. | Unused | Available | Available | Available
ReadOnlyVarsInFilter | variant_bool | Load only in the filter defined variables. | Unused | Available | Available | Available
StartTime | long | Gets or sets the start time of the filter as long. | Unused | Available | Available | Available
StatusBit | long |  | Unused | Available | Available | Available
StatusMask | long |  | Unused | Available | Available | Available


CountArchiveVariables
ObjectModel COM [image] ArchiveFilter [image] Properties [image] CountArchiveVariables
Remarks

Returns the amount of "ArchiveVariable" objects within the collection.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


EndTime
ObjectModel COM [image] ArchiveFilter [image] Properties [image] EndTime
Remarks

Gets or sets the end time of the filter.

Every data that is within the range of the "StartTime" and "EndTime" properties, will not be filtered out and therefore returned.

Hint: For further information, please have a look at the StartTime property part.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] ArchiveFilter [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IArchiveFilters

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Raster
ObjectModel COM [image] ArchiveFilter [image] Properties [image] Raster
Remarks

If the utilized archive type is none cyclic and this property is set to 0, then all archive entries between the start- and the end time will be returned.Otherwise (i.e. "Raster" property set greater than 0 and the archive type is cyclic) not all archive entries will be returned, but beginning with the start time each N-th (N="Raster") entry is returned.Example: Cyclic archive with an cylic rate of 15 minutes (900 seconds) Entries are recorded every 15 minutes (e.g. 07:45, 08:00, 08:15, ...)"StartTime" is 12:15 and the "Raster" property is set to 3 every third entry is returned (e.g. 12:15, 13:00, 13:45, 14:30, ...)ATTENTION: If the start time doesn't match the archive cyle time then no data entries will be returned.e.g. Archive entries are 12:15, 12:30, 12:45, 13:00, ..."Raster" is set to 3, but "Start-Time" is set to 12:16 It would return 12:16, 13:01, 13:46 but archive cycle is lagging one minute behind No entries will be returned!

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ReadOnlyVarsInFilter
ObjectModel COM [image] ArchiveFilter [image] Properties [image] ReadOnlyVarsInFilter
Remarks

Load only in the filter defined variables.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


StartTime
ObjectModel COM [image] ArchiveFilter [image] Properties [image] StartTime
Remarks

Gets or sets the start time of the filter as long.

Every data that is within the range of the "StartTime" and "EndTime" properties, will not be filtered out and therefore returned.

ATTENTION: zenOn uses UTC time internally, hence the desired start time has to be converted from the local time zone into UTC.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


StatusBit
ObjectModel COM [image] ArchiveFilter [image] Properties [image] StatusBit
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


StatusMask
ObjectModel COM [image] ArchiveFilter [image] Properties [image] StatusMask
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ArchiveFilter [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AddArchiveVariable | variant_bool | Adds an existing archive variable ("ArchiveVariable" object) to the filter. | Unused | Available | Available | Available
ApplyChanges | variant_bool | Apply changes on the filter. | Unused | Available | Available | Available
ArchiveFilterVariables | iarchivefiltervariables | Returns an "ArchiveFilterVariables" object, containing a collection of all filtered archive variables. | Unused | Available | Available | Available
ArchiveFilterVariablesInfo | variant_bool | Return arrays with the information to all the defined variables in the filter. | Unused | Available | Available | Available
ArchiveFilterVariablesInfoEx | variant_bool | Return arrays with the information to all the defined variables in the filter. Works cross-project. | Unused | Available | Available | Available
ItemArchiveVariable | iarchivevariable | Returns an "ArchiveVariable" object (which was formerly added to the filter) from the collection. | Unused | Available | Available | Available
Query | iarchivefiltervariables | Initiates the filtering of the data.Returns an "ArchiveFilterVariables" object, if data matched the filter query. | Unused | Available | Available | Available
QueryBlock | variant_bool | Initiates the filtering of the data. | Unused | Available | Available | Available
QueryBlockEx | variant_bool | Initiates the filtering of the data and also returns the project name and the utilized calculation modes in addition to the "QueryBlock" results. | Unused | Available | Available | Available
RemoveArchiveVariable | variant_bool | Removes an "ArchiveVariable" object (which was formerly added to the filter) from the filter. | Unused | Available | Available | Available


AddArchiveVariable
ObjectModel COM [image] ArchiveFilter [image] Methods [image] AddArchiveVariable
Remarks

Adds an existing archive variable ("ArchiveVariable" object) to the filter. Thus, the data of the variable will be returned after the filtering.The following code initiates that all assigned archive variables will be added to the archive filter.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
ArchiveVariable as IArchiveVariable

"ArchiveVariable" object that should be added to the filter.

Example
C#
Copy
public void MacroAddAllVariables()
{
    //Gets the first archive of the project
    IArchive zenonArchive = this.Archives().Item(0);
    if (zenonArchive == null)
    {
        //There is no archive, the user will be informed...
        this.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr);
        return;
    }
    //Create an archive filter and add any available variable to it
    IArchiveFilter zenonArchiveFilter = zenonArchive.ArchiveFilters().CreateArchiveFilter();
    for (int i = 0; i < zenonArchive.ArchiveVariables().Count; ++i)
    {
        zenonArchiveFilter.AddArchiveVariable(zenonArchive.ArchiveVariables().Item(i));
    }
}
VB.NET
Copy
Public Sub MacroAddAllVariables()
    'Gets the first archive of the project
    Dim zenonArchive As IArchive = Me.Archives().Item(0)
    If zenonArchive Is Nothing Then
        'There is no archive, the user will be informed...
        Me.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr)
        Return
    End If
    'Create an archive filter and add any available variable to it
    Dim zenonArchiveFilter As IArchiveFilter = zenonArchive.ArchiveFilters().CreateArchiveFilter()
    For i As Integer = 0 To zenonArchive.ArchiveVariables().Count - 1
        zenonArchiveFilter.AddArchiveVariable(zenonArchive.ArchiveVariables().Item(i))
    Next
End Sub
VBA
Copy
Sub zenOn_AddArchiveVariable(ByRef zArchive As Archive)
'Declarations
Dim zArFilter As ArchiveFilter
Dim i As Integer
'Initialize zArFilter by creating a new archive filter
Set zArFilter = zArchive.ArchiveFilters.CreateArchiveFilter
'Every archive variable within the collection...
For i = 0 To zArchive.ArchiveVariables.Count - 1

'... will be added to the archive filter

zArFilter.AddArchiveVariable zArchive.ArchiveVariables.Item(i)

'Output the name of the added variable

Debug.Print "Variable """ & zArchive.ArchiveVariables.Item(i).Name & """ added!"
Next i

End Sub


ApplyChanges
ObjectModel COM [image] ArchiveFilter [image] Methods [image] ApplyChanges
Remarks

Apply changes on the filter.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ArchiveFilterVariables
ObjectModel COM [image] ArchiveFilter [image] Methods [image] ArchiveFilterVariables
Remarks

Returns an "ArchiveFilterVariables" object, containing a collection of all filtered archive variables. For futher information please have a look at the ArchiveFilterVariables topic.

Datatype
IArchiveFilterVariables

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ArchiveFilterVariablesInfo
ObjectModel COM [image] ArchiveFilter [image] Methods [image] ArchiveFilterVariablesInfo
Remarks

Returns information on the assigned archive filter variables.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Count as long

"Variant" variable passed to the "ArchiveFilterVariablesInfo" method, in order to return the amount of archive filter variables.

vIDs as LPVARIANT

"Variant" variable passed to the "ArchiveFilterVariablesInfo" method, in order to return the IDs of the archive filter variables.

vNames as LPVARIANT

"Variant" variable passed to the "ArchiveFilterVariablesInfo" method, in order to return the names of the archive filter variables.

Example
C#
Copy
public void zenonArchiveFilterArchiveVariablesInfo(ref IArchiveFilter zenonArchiveFilter)
{
    int count = 0;
    object idsReturn = null;
    object namesReturn = null;

    zenonArchiveFilter.ArchiveFilterVariablesInfo(ref count, ref idsReturn, ref namesReturn);
    int[] ids = (int[])idsReturn;
    string[] names = (string[])namesReturn;
    for (int i = 0; i < count; ++i)
    {
        //Print the number of the variable
        System.Diagnostics.Debug.Print("{0}. Variable", i + i);
        //Print the name of the variable
        System.Diagnostics.Debug.Print("Name: {0}", names[i]);
        //Print the ID of the variable
        System.Diagnostics.Debug.Print("ID: {0}", ids[i]);
    }
}
VB.NET
Copy
Public Sub zenonArchiveFilterArchiveVariablesInfo(ByRef zenonArchiveFilter As IArchiveFilter)
    Dim count As Integer = 0
    Dim idsReturn As Object = Nothing
    Dim namesReturn As Object = Nothing

    zenonArchiveFilter.ArchiveFilterVariablesInfo(count, idsReturn, namesReturn)
    Dim ids As Integer() = DirectCast(idsReturn, Integer())
    Dim names As String() = DirectCast(namesReturn, String())
    For i As Integer = 0 To count - 1
        'Print the number of the variable
        System.Diagnostics.Debug.Print("{0}. Variable", i + i)
        'Print the name of the variable
        System.Diagnostics.Debug.Print("Name: {0}", names(i))
        'Print the ID of the variable
        System.Diagnostics.Debug.Print("ID: {0}", ids(i))
    Next
End Sub
VBA
Copy
Public Sub zenOn_ArchiveFilter_ArchiveFilterVariablesInfo(ByRef zArvFilter As ArchiveFilter)
'Declarations
Dim zCount As Long
Dim zIDs As Variant
Dim zNames As Variant
'Initiate the information query
zArvFilter.ArchiveFilterVariablesInfo zCount, zIDs, zNames
'For every archive filter variable within the collection...
For i = 0 To zCount - 1

'... output the variable count

Debug.Print i + 1 & ". Variable"

'... output the name

Debug.Print vbTab & "Name: " & zNames(i)

'... output the ID

Debug.Print vbTab & "ID" & vbTab & ": " & zIDs(i)
Next i

End Sub


ArchiveFilterVariablesInfoEx
ObjectModel COM [image] ArchiveFilter [image] Methods [image] ArchiveFilterVariablesInfoEx
Remarks

Like the "ArchiveFilterVariablesInfo" method, this command returns information on the assigned archive filter variables.Additionally it will also return information on the project name and the utilized calculation mode, if it is a following archive.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Count as long

Returns the amount of archive filter variables.

vIDs as LPVARIANT

Returns the IDs of the archive filter variables.

vNames as LPVARIANT

Returns the names of the archive filter variables.

vProjects as LPVARIANT

Returns the project name.

vCalculations as LPVARIANT

Returns the calculation mode, if it is a following archive.


ItemArchiveVariable
ObjectModel COM [image] ArchiveFilter [image] Methods [image] ItemArchiveVariable
Remarks

Returns an "ArchiveVariable" object (which was formerly added to the filter) from the collection. Hint: The returned object should be checked on Nothing, if no object for the search criteria was found. For further information please have a look at the ArchiveVariable topic itself.

Datatype
IArchiveVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT

The object is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:Element name: The element can be accessed with its unique name.Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveVariable" object in the list.

Example
C#
Copy
public void MarcoGetVariablesInArchiveFilter()
{
    //At first the archive is created
    IArchive zenonArchive = this.Archives().Item(0);
    if (zenonArchive == null)
    {
        //There is no archive, the user will be informed...
        this.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr);
        return;
    }
    //Get the first available archivefilter
    IArchiveFilter filter = zenonArchive.ArchiveFilters().Item(0);
    //Iterates through all ArchiveVariable objects
    for (int i = 0; i < filter.CountArchiveVariables; ++i)
    {
        IArchiveVariable zenonFilterVariable =
            filter.ItemArchiveVariable(i);
        //Do something with the current variable
    }
}
VB.NET
Copy
Public Sub MarcoGetVariablesInArchiveFilter()
    'At first the archive is created
    Dim zenonArchive As IArchive = Me.Archives().Item(0)
    If zenonArchive Is Nothing Then
        'There is no archive, the user will be informed...
        Me.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr)
        Return
    End If
    'Get the first available archivefilter
    Dim filter As IArchiveFilter = zenonArchive.ArchiveFilters().Item(0)
    'Iterates through all ArchiveVariable objects
    For i As Integer = 0 To filter.CountArchiveVariables - 1
            'Do something with the current variable
        Dim zenonFilterVariable As IArchiveVariable = filter.ItemArchiveVariable(i)
    Next
End Sub


Query
ObjectModel COM [image] ArchiveFilter [image] Methods [image] Query
Remarks

Initiates the filtering of the data.Returns an "ArchiveFilterVariables" object, if data matched the filter query. Hence, the returned object will contain the filtered data.Otherwise, this method will return "Nothing", if no data was matched. A full example can be found in the ArchiveFilter main topic: Creating a filter, executing a query and gathering data.

Datatype
IArchiveFilterVariables

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
//For information on how to query a filter have a look at the main topic "ArchiveFilter"
VB.NET
Copy
'For information on how to query a filter have a look at the main topic "Archive Filter"
VBA
Copy
'For information on how to query a filter have a look at the main topic "Archive Filter"


QueryBlock
ObjectModel COM [image] ArchiveFilter [image] Methods [image] QueryBlock
Remarks

Like the "Query" method, the "QueryBlock" command initiates the filtering of the data.

The difference between these two methods is, that the "QueryBlock" method is dedicated for performance oriented tasks, because the usage of arrays is faster than the approach of the "Query" method with the collections. The drawback of the "QueryBlock" method is the increased complexity of coding.

The "QueryBlock" command requires two parameters: vPvIDs: A variant variable which will constitute an array containing all IDs of the filtered variables.
vValues: A variant variable which will store an cascaded array designed the following way:Level: Return type, e.g.'Declaration
Dim zValues As Variant
'Initiates the filtering
zArvFilter.QueryBlock zPvIDs, zValues
'zValues is the return type, which contains all variables and the corresponding values
Level: Variable, e.g.'Declaration
Dim vVarTemp As Variant
'Assign the first variable within the cascaded "zValues" array to "vVarTemp"
vVarTemp = zValues(0)Level: Variable values, e.g.'Declaration
Dim vValTemp As Variant
'Assign the the third value within the vVarTemp variable to "vValTemp"
vValTemp = vVarTemp(2)
'Alternatively: Third value of the first variable within "zValues"
vValTemp = zValues(0)(2)Level: Value parametersvValTemp (0) 'Returns the date and time when the value was recorded
'Hint: The time has to be converted from zenOn internally UTC into local time.
'Use the zenOn "clsTimeConvert" macro to do so.
zValues (0)(2)(0) 'Alternatively

vValTemp (1) 'Returns the milliseconds, in addition to the time, when the value was recorded
zValues (0)(2)(1) 'Alternatively

vValTemp (2) 'Returns the value that was recorded at the specified time and date
zValues (0)(2)(1) 'Alternatively

vValTemp (3) 'Returns the state type, e.g. &H40000 -> I-BIT
zValues (0)(2)(1) 'Alternatively

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPvIDs as LPVARIANT

"Variant" variable for the "QueryBlock" method, in order to store an array of IDs of the corresponding filtered archive variables.
The array is returned by the method, hence the user has only to pass an "Variant" variable.

vValues as LPVARIANT

"Variant" variable for the "QueryBlock" method, in order to store a cascaded array which is filled with the filtered variables and the recorded values.
The array is returned by the method, hence the user has only to pass an "Variant" variable.

Example
C#
Copy
public void zenonArchiveFilterQueryBlock(ref IArchiveFilter zenonArchiveFilter)
{
    object zenonPvIds = null;
    object zenonValues = null;
    zenonArchiveFilter.QueryBlock(ref zenonPvIds, ref zenonValues);
    int[] zenonQueriedPvIds = (int[])zenonPvIds;
    object[] zenonQueriedValues = (object[])zenonValues;
    for (int i = 0; i < zenonQueriedValues.Length; ++i)
    {
        object[] currentValue = (object[])zenonQueriedValues[i];
        for (int j = 0; i < currentValue.Length; ++j)
        {
            object[] specificValues = (object[])currentValue[j];
            System.Diagnostics.Debug.Print("{0}. Value", j + 1);
            System.Diagnostics.Debug.Print("Variable Name: {0}", zenonArchiveFilter.
                ArchiveFilterVariables().ItemById(zenonQueriedPvIds[i]).
                ArchiveVariable().Name);

            System.Diagnostics.Debug.Print("Variable ID: {0}", zenonQueriedPvIds[i]);
            int time = (int)specificValues[0];
            System.Diagnostics.Debug.Print("Time: {0}", TimeConversion.
                ZenOnToSystem((uint)time).ToString());

            System.Diagnostics.Debug.Print("Milliseconds: {0}", specificValues[1]);
            System.Diagnostics.Debug.Print("Value: {0}", specificValues[2]);
            System.Diagnostics.Debug.Print("State: 0x{0}", ((int)specificValues[3]).ToString("X"));
        }
    }
}
VB.NET
Copy
Public Sub zenonArchiveFilterQueryBlock(ByRef zenonArchiveFilter As IArchiveFilter)
    Dim zenonPvIds As Object = Nothing
    Dim zenonValues As Object = Nothing
    zenonArchiveFilter.QueryBlock(zenonPvIds, zenonValues)
    Dim zenonQueriedPvIds As Integer() = DirectCast(zenonPvIds, Integer())
    Dim zenonQueriedValues As Object() = DirectCast(zenonValues, Object())
    For i As Integer = 0 To zenonQueriedValues.Length - 1
        Dim currentValue As Object() = DirectCast(zenonQueriedValues(i), Object())
        Dim j As Integer = 0
        While i < currentValue.Length
            Dim specificValues As Object() = DirectCast(currentValue(j), Object())
            System.Diagnostics.Debug.Print("{0}. Value", j + 1)
            System.Diagnostics.Debug.Print("Variable Name: {0}", zenonArchiveFilter.ArchiveFilterVariables().ItemById(zenonQueriedPvIds(i)).ArchiveVariable().Name)

            System.Diagnostics.Debug.Print("Variable ID: {0}", zenonQueriedPvIds(i))
            Dim time As Integer = CInt(specificValues(0))
            System.Diagnostics.Debug.Print("Time: {0}", TimeConversion.ZenOnToSystem(CUInt(time)).ToString())

            System.Diagnostics.Debug.Print("Milliseconds: {0}", specificValues(1))
            System.Diagnostics.Debug.Print("Value: {0}", specificValues(2))
            System.Diagnostics.Debug.Print("State: 0x{0}", CInt(specificValues(3)).ToString("X"))
            j += 1
        End While
    Next
End Sub
VBA
Copy
Public Sub zenOn_ArchiveFilter_QueryBlock(ByRef zArvFilter As ArchiveFilter)
'Declarations
Dim zTimeConvert As clsTimeConvert
Dim zPvIDs As Variant
Dim zValues As Variant
Dim i As Integer
Dim j As Integer
Dim vVarTemp As Variant
Dim vValTemp As Variant
Dim nVarCount As Integer
Dim nValCount As Integer
'Initialize zTimeConvert by creating a new instance of the zenOn "clsTimeConvert" macro
Set zTimeConvert = New clsTimeConvert
zArvFilter.QueryBlock zPvIDs, zValues
'Get the number of variables and assign it to "nVarCount"
nVarCount = UBound(zValues, 1)
'For every filtered variable output the recorded values
For i = 0 To nVarCount

'Assign the current variable to "vVarTemp"

vVarTemp = zValues(i)

'Get the number of values within the variable and assign it to "nValCount"

nValCount = UBound(vVarTemp, 1)

'For every value within the filtered variable output the recorded details

For j = 0 To nValCount

'Assign the current value to "vValTemp"

vValTemp = vVarTemp(j)

'Output the count number of the current value

Debug.Print j + 1 & ". Value"

'Output the variable name to which the value belongs

Debug.Print vbTab & "Var-Name: " & zArvFilter.ArchiveFilterVariables.ItemById(zPvIDs(i)).ArchiveVariable.Name

'Output the ID of the variable

Debug.Print vbTab & "Var-ID" & vbTab & ": " & CStr(zPvIDs(i))

'Output the date and time when the value was recorded -> Format: year-month-day hour:minute:second.millisecond

Debug.Print vbTab & "Time" & vbTab & ": " & Format(zTimeConvert.zenOn2System((vValTemp(0))), "yyyy-mm-dd hh:mm:ss") & "." & CStr(vValTemp(1))

'Output the value that was recorded

Debug.Print vbTab & "Value" & vbTab & ": " & CStr(vValTemp(2))

'Output the state of the value

Debug.Print vbTab & "State" & vbTab & ": &H" & Hex(vValTemp(3))

Next j
Next i

End Sub


QueryBlockEx
ObjectModel COM [image] ArchiveFilter [image] Methods [image] QueryBlockEx
Remarks

Like the "QueryBlock" method, the "QueryBlockEx" command initiates the filtering of the data.

The difference between these two methods is, that the "QuerBlockEx" command will also return the project name and the utilized calculation modes (if it is a following archive) in addition to the "QueryBlock" results.

Hint: For further information, please have a look at the QueryBlock part.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vProjects as LPVARIANT

"Variant" variable for the "QueryBlockEx" method, in order to store an array of project names, where the filter was applied.
The array is returned by the method, hence the user has only to pass an "Variant" variable.

vPvIDs as LPVARIANT

"Variant" variable for the "QueryBlockEx" method, in order to store an array of IDs of the corresponding filtered archive variables.
The array is returned by the method, hence the user has only to pass an "Variant" variable.

vCalculations as LPVARIANT

"Variant" variable for the "QueryBlockEx" method, in order to store an array of calculation modes, which were utilized by the recorded values.
The array is returned by the method, hence the user has only to pass an "Variant" variable.
Hint: For further information on calculation modes, please have a look at the Calculation property within the "ArchiveVariable" object.

vValues as LPVARIANT

"Variant" variable for the "QueryBlockEx" method, in order to store a cascaded array which is filled with the filtered variables and the recorded values.
The array is returned by the method, hence the user has only to pass an "Variant" variable.

Example
VBA
Copy
Public Sub zenOn_ArchiveFilter_QueryBlockEx(ByRef zArvFilter As ArchiveFilter)
'Declarations
Dim zPvIDs As Variant
Dim zValues As Variant
Dim zProjects As Variant
Dim zCalculations As Variant
Dim i As Integer
'Initiate the filtering
Debug.Print zArvFilter.QueryBlockEx(zProjects, zPvIDs, zCalculations, zValues)
'Output every project name
For i = 0 To UBound(zProjects, 1)

Debug.Print CStr(zProjects(i))
Next i
'Output every calculation mode
For i = 0 To UBound(zCalculations, 1)

Debug.Print CStr(zCalculations(i))
Next i

End Sub


RemoveArchiveVariable
ObjectModel COM [image] ArchiveFilter [image] Methods [image] RemoveArchiveVariable
Remarks

Removes an "ArchiveVariable" object (which was formerly added to the filter) from the filter.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT

The object is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveVariable" object in the list.

Example
C#
Copy
public void MacroRemoveAllVariables()
{
    //Gets the first archive of the project
    IArchive zenonArchive = this.Archives().Item(0);
    if (zenonArchive == null)
    {
        //There is no archive, the user will be informed...
        this.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr);
        return;
    }
    //Get the first archive filter of the archive
    IArchiveFilter zenonArchiveFilter = zenonArchive.ArchiveFilters().Item(0);

    if (zenonArchiveFilter == null)
    {
        //There is no filter, the user will be informed
        this.Parent.Parent.DebugPrint("No filter available!", tpDebugPrintStyle.tpErr);
        return;
    }

    //Remove all variables from the filter
    while (zenonArchiveFilter.ArchiveFilterVariables().Count > 0)
    {
        zenonArchiveFilter.RemoveArchiveVariable(0);
    }
}
VB.NET
Copy
Public Sub MacroRemoveAllVariables()
    'Gets the first archive of the project
    Dim zenonArchive As IArchive = Me.Archives().Item(0)
    If zenonArchive Is Nothing Then
        'There is no archive, the user will be informed...
        Me.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr)
        Return
    End If
    'Get the first archive filter of the archive
    Dim zenonArchiveFilter As IArchiveFilter = zenonArchive.ArchiveFilters().Item(0)

    If zenonArchiveFilter Is Nothing Then
        'There is no filter, the user will be informed
        Me.Parent.Parent.DebugPrint("No filter available!", tpDebugPrintStyle.tpErr)
        Return
    End If

    'Remove all variables from the filter
    While zenonArchiveFilter.ArchiveFilterVariables().Count > 0
        zenonArchiveFilter.RemoveArchiveVariable(0)
    End While
End Sub


ArchiveFilters
ObjectModel COM [image] ArchiveFilters
Remarks

This collection administers all filter objects.HINT:As a default there are no filters. You can administer any number of filters.With "CreateArchiveFilter" you can create a new filter. On the contrary, you can delete an existing filter with "DeleteArchiveFilter".Like in any other collection you can access an ArchiveFilter object with the "Item" method.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroQueryAllFilters()
{
    //Executes a query on all filters currently in the first archive of the project
    IArchiveFilters zenonFilters = this.Archives().Item(0).ArchiveFilters();
    for (int i = 0; i < zenonFilters.Count; ++i)
    {
        IArchiveFilter zenonFilter = zenonFilters.Item(i);
        if (zenonFilter != null)
            zenonFilter.Query();
    }
}
VB.NET
Copy
Public Sub MacroQueryAllFilters()
    'Executes a query on all filters currently in the first archive of the project
    Dim zenonFilters As IArchiveFilters = Me.Archives().Item(0).ArchiveFilters()
    For i As Integer = 0 To zenonFilters.Count - 1
        Dim zenonFilter As IArchiveFilter = zenonFilters.Item(i)
        If zenonFilter IsNot Nothing Then
            zenonFilter.Query()
        End If
    Next
End Sub
VBA
Copy
Sub zenOn_ArchiveFilters()
'Declarations
Dim zArvFilters As ArchiveFilters
Dim zArvFilter As ArchiveFilter
Dim i As Integer
'Initialize zArvFilters with the archive filter collection of the first available archive
Set zArvFilters = thisProject.Archives.Item(0).ArchiveFilters
'For every archive filter within the collection ...
For i = 0 To zArvFilters.Count - 1
'... assign it to zArvFilter
Set zArvFilter = zArvFilters.Item(i)
'If the filter is available (zArvFilter is not "Nothing")...
If Not (zArvFilter Is Nothing) Then

'... then initiate the filtering

zArvFilter.Query
End If
Next i

End Sub


Properties
ObjectModel COM [image] ArchiveFilters [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | The method returns the number of available objects | Unused | Readonly | Available | Available
Parent | iarchive | Returns the parent object | Unused | Readonly | Available | Available


Count
ObjectModel COM [image] ArchiveFilters [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] ArchiveFilters [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IArchive

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ArchiveFilters [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateArchiveFilter | iarchivefilter | creates a new "ArchiveFilter" object. | Unused | Available | Available | Available
DeleteArchiveFilter | variant_bool | Removes an existing filter ("ArchiveFilter" object) from the collection | Unused | Available | Available | Available
Item | iarchivefilter | Returns an "ArchiveFilter" object from the collection, which is identified by the parameter vNameOrPos. | Available | Available | Available | Available


CreateArchiveFilter
ObjectModel COM [image] ArchiveFilters [image] Methods [image] CreateArchiveFilter
Remarks

This method creates a new "ArchiveFilter" object. Afterwards, the filter is configurable in order to return the required data.

Datatype
IArchiveFilter

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MarcroZenOnArchiveFilter()
{
    //Gets the first archive of the project
    IArchive zenonArchive = this.Archives().Item(0);
    if (zenonArchive == null)
    {
        //There is no archive, the user will be informed...
        this.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr);
        return;
    }
    IArchiveFilter zenonArchiveFilter = zenonArchive.ArchiveFilters().CreateArchiveFilter();
    for (int i = 0; i < zenonArchive.ArchiveVariables().Count; ++i)
    {
        //Add every archive variable to the archive filter
        zenonArchiveFilter.AddArchiveVariable(zenonArchive.ArchiveVariables().Item(i));
    }

    //Set the StartTime to 14:00 on the 30th of july 2007
    zenonArchiveFilter.StartTime = (int)TimeConversion.
        SystemToZenOn(new DateTime(2007, 07, 30, 14, 0, 0));

    //Set the EndTime to 11:15 on the 31st of july 2007
    zenonArchiveFilter.EndTime = (int)TimeConversion.
        SystemToZenOn(new DateTime(2007,07,31,11,15,00));

    zenonArchiveFilter.StatusMask = 0x41000; //Check only I-BIT + HWERT
    zenonArchiveFilter.StatusBit = 0x41000; //Return data if one of those bit is true or both

    //Initiate a filter query
    IArchiveFilterVariables zenonArchiveVariables = zenonArchiveFilter.Query();
    for (int i = 0; i < zenonArchiveVariables.Count; ++i)
    {
        this.Parent.Parent.DebugPrint("Variable: " + zenonArchiveVariables.Item(i).ArchiveVariable().Name, tpDebugPrintStyle.tpNrm);
        this.Parent.Parent.DebugPrint("I-BIT + HWERT: " + zenonArchiveVariables.Item(i).ArchiveValues().Count, tpDebugPrintStyle.tpNrm);
    }
}
VB.NET
Copy
public void MarcrozenOnArchiveFilter()
{
    //Gets the first archive of the project
    IArchive zenonArchive = this.Archives().Item(0);
    if (zenonArchive == null)
    {
        //There is no archive, the user will be informed...
        this.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr);
        return;
    }
    IArchiveFilter zenonArchiveFilter = zenonArchive.ArchiveFilters().CreateArchiveFilter();
    for (int i = 0; i < zenonArchive.ArchiveVariables().Count; ++i)
    {
        //Add every archive variable to the archive filter
        zenonArchiveFilter.AddArchiveVariable(zenonArchive.ArchiveVariables().Item(i));
    }

    //Set the StartTime to 14:00 on the 30th of july 2007
    zenonArchiveFilter.StartTime = (int)TimeConversion.
        SystemToZenOn(new DateTime(2007, 07, 30, 14, 0, 0));

    //Set the EndTime to 11:15 on the 31st of july 2007
    zenonArchiveFilter.EndTime = (int)TimeConversion.
        SystemToZenOn(new DateTime(2007,07,31,11,15,00));

    zenonArchiveFilter.StatusMask = 0x41000; //Check only I-BIT + HWERT
    zenonArchiveFilter.StatusBit = 0x41000; //Return data if one of those bit is true or both

    //Initiate a filter query
    IArchiveFilterVariables zenonArchiveVariables = zenonArchiveFilter.Query();
    for (int i = 0; i < zenonArchiveVariables.Count; ++i)
    {
        this.Parent.Parent.DebugPrint("Variable: " + zenonArchiveVariables.Item(i).ArchiveVariable().Name, tpDebugPrintStyle.tpNrm);
        this.Parent.Parent.DebugPrint("I-BIT + HWERT: " + zenonArchiveVariables.Item(i).ArchiveValues().Count, tpDebugPrintStyle.tpNrm);
    }
}


DeleteArchiveFilter
ObjectModel COM [image] ArchiveFilters [image] Methods [image] DeleteArchiveFilter
Remarks

This method removes an existing filter ("ArchiveFilter" object) from the collection.Subsequently, the filter won't be available any more. Trying to access it, will return an incorrect filter or a segmentation fault.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT

Example
C#
Copy
public void MacroDeleteAllFilters()
{
    //Deletes all filters on the first archive of the project
    IArchiveFilters zenonFilters = this.Archives().Item(0).ArchiveFilters();
    for (int i = 0; i < zenonFilters.Count; ++i)
    {
        zenonFilters.DeleteArchiveFilter(i);
    }
}
VB.NET
Copy
Public Sub MacroDeleteAllFilters()
    'Deletes all filters on the first archive of the project
    Dim zenonFilters As IArchiveFilters = Me.Archives().Item(0).ArchiveFilters()
    For i As Integer = 0 To zenonFilters.Count - 1
        zenonFilters.DeleteArchiveFilter(i)
    Next
End Sub


Item
ObjectModel COM [image] ArchiveFilters [image] Methods [image] Item
Remarks

Returns an "ArchiveFilter" object from the collection, which is identified by the parameter vNameOrPos.

Datatype
IArchiveFilter

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT

Identfies ArchiveFilter object in the collection. The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveFilter" object in the list.
Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.


ArchiveFilterVariable
ObjectModel COM [image] ArchiveFilterVariable
Remarks

The "ArchiveFilterVariable" object contains the filtered archive variable for the "ArchiveFilter" object.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
//This method gathers some information on a variable in the passed IArchiveFilter object.
//The information is then sent to the standard debug output of the zenOn editor.
public void ZenOnArchiveFilterVariable(ref IArchiveFilter zenonArchiveFilter)
{
    //Get the first available filtered variable
    IArchiveFilterVariable zenonArchiveFilterVariable = zenonArchiveFilter.ArchiveFilterVariables().Item(0);
    if (zenonArchiveFilterVariable == null)
    {
        //If there is no variable available, inform the user

//NOTE: The variable will not be available if there was no filter query executed
        this.Parent.Parent.DebugPrint("No filtered archive variable available!", tpDebugPrintStyle.tpNrm);
        return;
    }
    //And if there is, output some details
    this.Parent.Parent.DebugPrint("Variable: " +
        zenonArchiveFilterVariable.ArchiveVariable().Name, tpDebugPrintStyle.tpNrm);
    for (int i = 0; i < zenonArchiveFilterVariable.ArchiveValues().Count; ++i)
    {
        this.Parent.Parent.DebugPrint((i + 1) + ". Value: " +
            zenonArchiveFilterVariable.ArchiveValues().Item(i).Value, tpDebugPrintStyle.tpNrm);
    }
}
VB.NET
Copy
'This method gathers some information on a variable in the passed IArchiveFilter object.
'The information is then sent to the standard debug output of the zenOn editor.
Public Sub ZenOnArchiveFilterVariable(ByRef zenonArchiveFilter As IArchiveFilter)
    'Get the first available filtered variable
    Dim zenonArchiveFilterVariable__1 As IArchiveFilterVariable = zenonArchiveFilter.ArchiveFilterVariables().Item(0)
    If zenonArchiveFilterVariable__1 Is Nothing Then
        'If there is no variable available, inform the user
        Me.Parent.Parent.DebugPrint("No filtered archive variable available!", tpDebugPrintStyle.tpNrm)
        Return
    End If
    'And if there is, output some details
    Me.Parent.Parent.DebugPrint("Variable: " + zenonArchiveFilterVariable__1.ArchiveVariable().Name, tpDebugPrintStyle.tpNrm)
    For i As Integer = 0 To zenonArchiveFilterVariable__1.ArchiveValues().Count - 1
        Me.Parent.Parent.DebugPrint(((i + 1) & ". Value: ") + zenonArchiveFilterVariable__1.ArchiveValues().Item(i).Value, tpDebugPrintStyle.tpNrm)
    Next
End Sub
VBA
Copy
Sub zenOn_ArchiveFilterVariable(ByRef zArvFilter As ArchiveFilter)
'Declarations
Dim zArvFilterVar As ArchiveFilterVariable
Dim i As Integer
'Initialize zArvFilterVar with the first available filtered archive variable
Set zArvFilterVar = zArvFilter.ArchiveFilterVariables.Item(0)
'If no filtered archive variable is available ...
'HINT: Filtered archive variables are only availabe after a archive filter query was initiated
If zArvFilterVar Is Nothing Then

'... then inform the user

MsgBox ("No filtered archive variable available!")

'Otherwise, output some details
Else

'Output the variable name

Debug.Print "Variable: " & zArvFilterVar.ArchiveVariable.Name

With zArvFilterVar.ArchiveValues

'For every archive value within "zArvFilterVar" ...

For i = 0 To .Count - 1

'... output the recorded value

Debug.Print vbTab & i + 1 & ".Value: " & .Item(i).Value

Next i

End With
End If
End Sub


Properties
ObjectModel COM [image] ArchiveFilterVariable [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Parent | iarchivefiltervariables | Returns the parent object | Unused | Readonly | Available | Available


Parent
ObjectModel COM [image] ArchiveFilterVariable [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IArchiveFilterVariables

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ArchiveFilterVariable [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ArchiveValues | iarchivevalues |  | Unused | Available | Available | Available
ArchiveValuesBlock | variant | Returns an array of values for the actual ArchiveFilterVariable object. | Unused | Readonly | Available | Available
ArchiveVariable | iarchivevariable | Returns an "ArchiveVarible" object, which constitutes the assigned archive variable. | Unused | Available | Available | Available


ArchiveValues
ObjectModel COM [image] ArchiveFilterVariable [image] Methods [image] ArchiveValues
Remarks

Datatype
IArchiveValues

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ArchiveValuesBlock
ObjectModel COM [image] ArchiveFilterVariable [image] Methods [image] ArchiveValuesBlock
Remarks

Returns an array of values for the actual ArchiveFilterVariable object.This works only when a query has already been executed.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ArchiveVariable
ObjectModel COM [image] ArchiveFilterVariable [image] Methods [image] ArchiveVariable
Remarks

Returns an "ArchiveVarible" object, which constitutes the assigned archive variable. For further information, please have a look at the "ArchiveVariable" part.

Datatype
IArchiveVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ArchiveFilterVariables
ObjectModel COM [image] ArchiveFilterVariables
Remarks

Returns an "ArchiveFilterVariables" object, containing a collection of the filtered archive variables.This object is utilized by the "ArchiveFilter" object, in order to access the collection of "ArchiveFilterVariable" objects.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
//This method gathers some information on a variable in the passed IArchiveFilter object.
//The information is then sent to the standard debug output of the zenOn editor.
public void ZenOnArchiveFilterVariable(ref IArchiveFilter zenonArchiveFilter)
{
    //Get the first available filtered variable
    IArchiveFilterVariable zenonArchiveFilterVariable = zenonArchiveFilter.ArchiveFilterVariables().Item(0);
    if (zenonArchiveFilterVariable == null)
    {
        //If there is no variable available, inform the user
        this.Parent.Parent.DebugPrint("No filtered archive variable available!", tpDebugPrintStyle.tpNrm);
        return;
    }
    //And if there is, output some details
    this.Parent.Parent.DebugPrint("Variable: " +
        zenonArchiveFilterVariable.ArchiveVariable().Name, tpDebugPrintStyle.tpNrm);
    for (int i = 0; i < zenonArchiveFilterVariable.ArchiveValues().Count; ++i)
    {
        this.Parent.Parent.DebugPrint((i + 1) + ". Value: " +
            zenonArchiveFilterVariable.ArchiveValues().Item(i).Value, tpDebugPrintStyle.tpNrm);
    }
}
VB.NET
Copy
'This method gathers some information on a variable in the passed IArchiveFilter object.
'The information is then sent to the standard debug output of the zenOn editor.
Public Sub ZenOnArchiveFilterVariable(ByRef zenonArchiveFilter As IArchiveFilter)
    'Get the first available filtered variable
    Dim zenonArchiveFilterVariable__1 As IArchiveFilterVariable = zenonArchiveFilter.ArchiveFilterVariables().Item(0)
    If zenonArchiveFilterVariable__1 Is Nothing Then
        'If there is no variable available, inform the user
        Me.Parent.Parent.DebugPrint("No filtered archive variable available!", tpDebugPrintStyle.tpNrm)
        Return
    End If
    'And if there is, output some details
    Me.Parent.Parent.DebugPrint("Variable: " + zenonArchiveFilterVariable__1.ArchiveVariable().Name, tpDebugPrintStyle.tpNrm)
    For i As Integer = 0 To zenonArchiveFilterVariable__1.ArchiveValues().Count - 1
        Me.Parent.Parent.DebugPrint(((i + 1) & ". Value: ") + zenonArchiveFilterVariable__1.ArchiveValues().Item(i).Value, tpDebugPrintStyle.tpNrm)
    Next
End Sub
VBA
Copy
Sub zenOn_ArchiveFilterVariables(ByRef zArvFilter As ArchiveFilter)
'Declarations
Dim zArvFilterVars As ArchiveFilterVariables
Dim i As Integer
'Initialize zArvFilterVars with the filtered archive variable collection of the current archive
Set zArvFilterVars = zArvFilter.ArchiveFilterVariables
'If no filtered archive variables are available ...
'HINT: Filtered archive variables are only availabe after a archive

filter query was initiated
If zArvFilterVars Is Nothing Then

'... then inform the user

MsgBox ("No filtered archive variables available!")

'Otherwise:
Else

'For every filtered archive variable ...

For i = 0 To zArvFilterVars.Count - 1

'... output the name

Debug.Print i + 1 & ". Variable: " & zArvFilterVars.Item(i).ArchiveVariable.Name

Next i
End If
End Sub


Properties
ObjectModel COM [image] ArchiveFilterVariables [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the number of available objects. | Unused | Readonly | Available | Available
Parent | iarchivefilter | Returns the parent object | Unused | Readonly | Available | Available


Count
ObjectModel COM [image] ArchiveFilterVariables [image] Properties [image] Count
Remarks

The property returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] ArchiveFilterVariables [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IArchiveFilter

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ArchiveFilterVariables [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Item | iarchivefiltervariable | Returns an "ArchiveFilterVariable" object from the collection, which is identified by the parameter vNameOrPos. | Available | Unused | Available | Available
ItemById | iarchivefiltervariable | Returns an "ArchiveFilterVariable" object from the collection specified by its internal uniqe ID. | Unused | Available | Available | Available
ItemByIdEx | iarchivefiltervariable | Returns an object of type ArchiveFilterVariable. | Unused | Readonly | Available | Available


Item
ObjectModel COM [image] ArchiveFilterVariables [image] Methods [image] Item
Remarks

Returns an "ArchiveFilterVariable" object from the collection, which is identified by the parameter vNameOrPos. Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IArchiveFilterVariable

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT

The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveFilterVariable" object in the list.


ItemById
ObjectModel COM [image] ArchiveFilterVariables [image] Methods [image] ItemById
Remarks

Returns an "ArchiveFilterVariable" object from the collection specified by its internal uniqe ID, which is identified by the parameter vVariableId.Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IArchiveFilterVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vVariableId as VARIANT

Internal uniqe ID, which is identifies an "ArchiveFilterVariable" object from the collection.


ItemByIdEx
ObjectModel COM [image] ArchiveFilterVariables [image] Methods [image] ItemByIdEx
Remarks

Returns an object of type ArchiveFilterVariable.

Datatype
IArchiveFilterVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
vVariableId as VARIANT

Uniqe PvID of linked zenOn Variable

vProjectName as VARIANT

Project name

vCalculation as VARIANT

Type of claculation

Example
VBA
Copy
Sub GetArchiveFilterVariable(zArvFilter As ArchiveFilter)
Dim zVariable As Variable
Dim zFilterVar As ArchiveFilterVariable
'get variable object to read the PvID!
Set zVariable = thisProject.Variables.Item("WIZ_VAR_10")
'get the filtervariable with SUM calculation
Set zFilterVar = zArvFilter.ArchiveFilterVariables.ItemByIdEx(zVariable.PvID, thisProject.Name, 1)
End Sub


Archives
ObjectModel COM [image] Archives
Remarks

The object is a collection of all existing archives.With the property "Parent" you come to the parent of the object. The parent of the Archives object is a Project. In the Project most of the modules are anchored.With the property "Item" you can search for an archive. As search criteria you can enter the position of the archive in the list or the name.With the property "Count" you find out the number of elements in the list. With a loop you then can iterate through all elements and e.g display them.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
//The Macro lists any Archive in the current project and prints its name
//as well as the names of any contained variable
public void MacroZenOnArchives()
{
    IProject zenonProject = this.Project;
    IArchives zenonArchives = zenonProject.Archives();
    for (int i = 0; i < zenonArchives.Count; ++i)
    {
        this.Parent.Parent.DebugPrint(i + ". Archive: " + zenonArchives.Item(i).Name,
            tpDebugPrintStyle.tpMsg);
    }
}

public void zenOnArchiveVariables(ref IArchiveVariables zenonArchiveVariables)
{
    for (int i = 0; i < zenonArchiveVariables.Count; ++i)
    {
        this.Parent.Parent.DebugPrint(i + zenonArchiveVariables.Item(i).Name,
            tpDebugPrintStyle.tpMsg);
    }
}
VB.NET
Copy
'The Macro lists any Archive in the current project and prints its name
'as well as the names of any contained variable
Public Sub MacroZenOnArchives()
    Dim zenonProject As IProject = Me.Project
    Dim zenonArchives As IArchives = zenonProject.Archives()
    For i As Integer = 0 To zenonArchives.Count - 1
        Me.Parent.Parent.DebugPrint((i & ". Archive: ") + zenonArchives.Item(i).Name, tpDebugPrintStyle.tpMsg)
    Next
End Sub

Public Sub zenOnArchiveVariables(ByRef zenonArchiveVariables__1 As IArchiveVariables)
    For i As Integer = 0 To zenonArchiveVariables__1.Count - 1
        Me.Parent.Parent.DebugPrint(i + zenonArchiveVariables__1.Item(i).Name, tpDebugPrintStyle.tpMsg)
    Next
End Sub
VBA
Copy
Sub zenOn_Archives()
'Declarations
Dim zProject As Project
Dim zArchives As Archives
Dim i As Integer
'Initialize zProject with the current project
Set zProject = thisProject
'Initialize zArchives with the current "Archive" object collection
Set zArchives = zProject.Archives
'For every "Archive" object within the collection...
For i = 0 To zArchives.Count - 1

'... output the name ...

Debug.Print i + 1 & ". Archive: " & zArchives.Item(i).Name

'... and the name of the included variables

Call zenOn_ArchiveVariables(zArchives.Item(i).ArchiveVariables)
Next i

End Sub
Sub zenOn_ArchiveVariables(ByRef zArchiveVars As ArchiveVariables)
'Declarations
Dim i As Integer
'For every "ArchiveVariable" object within the collection...
For i = 0 To zArchiveVars.Count - 1

'... output the name of the variable

Debug.Print vbTab & i + 1 & ". Var: " & zArchiveVars.Item(i).Name
Next i

End Sub


Properties
ObjectModel COM [image] Archives [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Unused | Readonly | Available | Available
Parent | iproject |  | Unused | Readonly | Available | Available


Count
ObjectModel COM [image] Archives [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Archives [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Archives [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Item | iarchive | Returns an "Archive" object from the collection, which is identified by the parameter vNameOrPos. | Available | Unused | Available | Available


Item
ObjectModel COM [image] Archives [image] Methods [image] Item
Remarks

Returns an "Archive" object from the collection, which is identified by the parameter vNameOrPos. Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IArchive

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT

The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "Archive" object in the list.

Example
C#
Copy
//The Macro lists any Archive in the current project and prints its name
//as well as the names of any contained variable
public void MacroZenOnArchives()
{
    IProject zenonProject = this.Project;
    IArchives zenonArchives = zenonProject.Archives();
    for (int i = 0; i < zenonArchives.Count; ++i)
    {
        this.Parent.Parent.DebugPrint(i + ". Archive: " + zenonArchives.Item(i).Name,
            tpDebugPrintStyle.tpMsg);
    }
}

public void zenOnArchiveVariables(ref IArchiveVariables zenonArchiveVariables)
{
    for (int i = 0; i < zenonArchiveVariables.Count; ++i)
    {
        this.Parent.Parent.DebugPrint(i + zenonArchiveVariables.Item(i).Name,
            tpDebugPrintStyle.tpMsg);
    }
}


ArchivesED
ObjectModel COM [image] ArchivesED
Remarks

The "ArchivesED" object manages the collection of "ArchiveED" objects.

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroArchivesED()
{
    IArchivesED zenonArchivesED = this.ActiveDocument.ArchivesED();
    //For each archiveED in the project, output identification name and name
    for (int i = 0; i < zenonArchivesED.Count; ++i)
    {
        this.Parent.DebugPrint(zenonArchivesED.Item(i).get_DynProperties("ShortName") +
            " - " + zenonArchivesED.Item(i).get_DynProperties("LongName"),
            tpDebugPrintStyle.tpMsg);
    }
}
VB.NET
Copy
Public Sub MacroArchivesED()
    Dim zenonArchivesED As IArchivesED = Me.ActiveDocument.ArchivesED()
    'For each archiveED in the project, output identification name and name
    For i As Integer = 0 To zenonArchivesED.Count - 1
        Me.Parent.DebugPrint(zenonArchivesED.Item(i).get_DynProperties("ShortName") & " - " & zenonArchivesED.Item(i).get_DynProperties("LongName"), tpDebugPrintStyle.tpMsg)
    Next
End Sub
VBA
Copy
Sub zenOn_ArchivesED()
'Declarations
Dim zArchivesED As ArchivesED
Dim i As Integer
'Initialize zArchivesED with the archives of the current editor project
Set zArchivesED = MyWorkspace.ActiveDocument.ArchivesED
'For every archive within the collection ...
For i = 0 To zArchivesED.Count - 1

With zArchivesED.Item(i)

'... output the identifier and the name

Debug.Print .DynProperties("ShortName") & " - " & .DynProperties("LongName")

End With
Next i

End Sub


Properties
ObjectModel COM [image] ArchivesED [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the number of available objects. | Readonly | Unused | Available | Available
Parent | iproject | Returns the parent object | Readonly | Unused | Available | Available


Count
ObjectModel COM [image] ArchivesED [image] Properties [image] Count
Remarks

The property returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] ArchivesED [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ArchivesED [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
CreateArchive | iarchiveed | Creates a new archive ("ArchiveED" object). | Available | Unused | Available | Available
DelArchive | variant_bool | Delete an existing archive ("ArchiveED" object) by its name. | Available | Unused | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
Item | iarchiveed | Returns an "ArchiveED" object from the collection, which is identified by the parameter vNameOrPos. | Available | Unused | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index | Available | Unused | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


CheckIn
ObjectModel COM [image] ArchivesED [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
/* In case of a multiuser project you need to checkout your ArchiveEd object
 * before editing it and you have to check it in again as soon as you're done.
 * To do soyou can use the provided methods CheckIn and CheckOut of the ArchiveED
 * object.
 */
public void MacroServerArchiveEd()
{
    IArchivesED zenonArchives = this.ActiveDocument.ArchivesED();
    if (!zenonArchives.CheckOut())
    {
        //Some error occured, the user will be informed
        this.Parent.DebugPrint("Error while checking out archives",
            tpDebugPrintStyle.tpErr);
    }
    //Do something with the archives in the collection object
    //Code...
    zenonArchives.CheckIn();
}
VB.NET
Copy
' In case of a multiuser project you need to checkout your ArchiveEd object
' * before editing it and you have to check it in again as soon as you're done.
' * To do soyou can use the provided methods CheckIn and CheckOut of the ArchiveED
' * object.
'

Public Sub MacroServerArchiveEd()
    Dim zenonArchives As IArchivesED = Me.ActiveDocument.ArchivesED()
    If Not zenonArchives.CheckOut() Then
        'Some error occured, the user will be informed
        Me.Parent.DebugPrint("Error while checking out archives", tpDebugPrintStyle.tpErr)
    End If
    'Do something with the archives in the collection object
    'Code...
    zenonArchives.CheckIn()
End Sub


CheckOut
ObjectModel COM [image] ArchivesED [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
/* In case of a multiuser project you need to checkout your ArchiveEd object
 * before editing it and you have to check it in again as soon as you're done.
 * To do soyou can use the provided methods CheckIn and CheckOut of the ArchiveED
 * object.
 */
public void MacroServerArchiveEd()
{
    IArchivesED zenonArchives = this.ActiveDocument.ArchivesED();
    if (!zenonArchives.CheckOut())
    {
        //Some error occured, the user will be informed
        this.Parent.DebugPrint("Error while checking out archives",
            tpDebugPrintStyle.tpErr);
    }
    //Do something with the archives in the collection object
    //Code...
    zenonArchives.CheckIn();
}
VB.NET
Copy
' In case of a multiuser project you need to checkout your ArchiveEd object
' * before editing it and you have to check it in again as soon as you're done.
' * To do soyou can use the provided methods CheckIn and CheckOut of the ArchiveED
' * object.
'

Public Sub MacroServerArchiveEd()
    Dim zenonArchives As IArchivesED = Me.ActiveDocument.ArchivesED()
    If Not zenonArchives.CheckOut() Then
        'Some error occured, the user will be informed
        Me.Parent.DebugPrint("Error while checking out archives", tpDebugPrintStyle.tpErr)
    End If
    'Do something with the archives in the collection object
    'Code...
    zenonArchives.CheckIn()
End Sub


CreateArchive
ObjectModel COM [image] ArchivesED [image] Methods [image] CreateArchive
Remarks

Creates a new archive ("ArchiveED" object) by its term, the name and optionally the source archive, if the new archive should be the following archive of the specified one.

Datatype
IArchiveED

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bstrShortName as BSTR

bstrLongName as BSTR

pSourceArchive as IArchiveED

Example
C#
Copy
public void MacroCreateArchive()
{
    IArchiveED zenonArchiveED = this.ActiveDocument.ArchivesED().Item("01");
    if (zenonArchiveED == null)
    {
        /* if there is no such archive available create it with
         * the given identification name "01" and the name
         * "zenon_ArchiveED"
         */
        zenonArchiveED = this.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", null);
    }
}
VB.NET
Copy
Public Sub MacroCreateArchive()
    Dim zenonArchiveED As IArchiveED = Me.ActiveDocument.ArchivesED().Item("01")
    If zenonArchiveED Is Nothing Then
        ' if there is no such archive available create it with
'         * the given identification name "01" and the name
'         * "zenon_ArchiveED"
'

        zenonArchiveED = Me.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", Nothing)
    End If
End Sub


DelArchive
ObjectModel COM [image] ArchivesED [image] Methods [image] DelArchive
Remarks

Delete an existing archive ("ArchiveED" object) by its name.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bstrShortName as BSTR

Short name of the archive to delete.

Example
C#
Copy
public void MacroDelArchive()
{
    IArchiveED zenonArchiveED = this.ActiveDocument.ArchivesED().Item("01");
    if (zenonArchiveED != null)
    {
        //If there is an archive of given criteria - delete it
        this.ActiveDocument.ArchivesED().DelArchive("01");
    }
}
VB.NET
Copy
Public Sub MacroDelArchive()
    Dim zenonArchiveED As IArchiveED = Me.ActiveDocument.ArchivesED().Item("01")
    If zenonArchiveED IsNot Nothing Then
        'If there is an archive of given criteria - delete it
        Me.ActiveDocument.ArchivesED().DelArchive("01")
    End If
End Sub


Export
ObjectModel COM [image] ArchivesED [image] Methods [image] Export
Remarks

Export settings to an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Filename (path) as string of the xml file to export.

Example
VBA
Copy
Public Sub ExportEquipmentModel()

Dim Exported As Boolean
Exported = MyWorkspace.ActiveDocument.SystemModelManager.Export("C:\Equipment.xml")

End Sub


Get
ObjectModel COM [image] ArchivesED [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroGetArchive()
{
    //NOTE: This will not be functional in a non-multiuser project
    this.ActiveDocument.ArchivesED().Get();
    //The Archive is now up to date and can be used
}
VB.NET
Copy
Public Sub MacroGetArchive()
    'NOTE: This will not be functional in a non-multiuser project
    Me.ActiveDocument.ArchivesED().[Get]()
    'The Archive is now up to date and can be used
End Sub


Import
ObjectModel COM [image] ArchivesED [image] Methods [image] Import
Remarks

Import settings from an xml file. Existing settings will be replaced/merged.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Filename (path) as string of the xml file to import.

Example
VBA
Copy
Private Sub Project Active()
Set mypicevents = thisProject.Dynpictures
Stop
thisProject.SystemModelManager.Export("AnlagenmodellEditorB.xml")
thisProject.SystemModelManager.Import("AnlagenmodellEditorB.xml")
End Sub


IsCheckedOut
ObjectModel COM [image] ArchivesED [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroCheckedOut()
{
    //NOTE: This will not be functional in a non-multiuser project
    if (this.ActiveDocument.ArchivesED().IsCheckedOut())
    {
        //The archives are currently checked out
        this.Parent.DebugPrint("Archives are checked out", tpDebugPrintStyle.tpWarn);
    }
}
VB.NET
Copy
Public Sub MacroCheckedOut()
    'NOTE: This will not be functional in a non-multiuser project
    If Me.ActiveDocument.ArchivesED().IsCheckedOut() Then
        'The archives are currently checked out
        Me.Parent.DebugPrint("Archives are checked out", tpDebugPrintStyle.tpWarn)
    End If
End Sub


IsDifferent
ObjectModel COM [image] ArchivesED [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroIsDifferent()
{
    //NOTE: This will not be functional in a non-multiuser project
    //Checks if there are differences between local and server file
    if (this.ActiveDocument.ArchivesED().IsDifferent())
    {
        this.Parent.DebugPrint("Differences between local and server version.",
            tpDebugPrintStyle.tpMsg);
    }
    else
    {
        this.Parent.DebugPrint("No differences between local and server version",
            tpDebugPrintStyle.tpMsg);
    }
}
VB.NET
Copy
Public Sub MacroIsDifferent()
    'NOTE: This will not be functional in a non-multiuser project
    'Checks if there are differences between local and server file
    If Me.ActiveDocument.ArchivesED().IsDifferent() Then
        Me.Parent.DebugPrint("Differences between local and server version.", tpDebugPrintStyle.tpMsg)
    Else
        Me.Parent.DebugPrint("No differences between local and server version", tpDebugPrintStyle.tpMsg)
    End If
End Sub


IsLocked
ObjectModel COM [image] ArchivesED [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroLocked()
{
    //NOTE: This will not be functional in a non-multiuser project
    if (this.ActiveDocument.ArchivesED().IsLocked())
    {
        //The archives are currently locked
        this.Parent.DebugPrint("Archives are locked", tpDebugPrintStyle.tpWarn);
    }
}
VB.NET
Copy
Public Sub MacroLocked()
    'NOTE: This will not be functional in a non-multiuser project
    If Me.ActiveDocument.ArchivesED().IsLocked() Then
        'The archives are currently locked
        Me.Parent.DebugPrint("Archives are locked", tpDebugPrintStyle.tpWarn)
    End If
End Sub


Item
ObjectModel COM [image] ArchivesED [image] Methods [image] Item
Remarks

  • Returns an "ArchiveED" object from the collection, which is identified by the parameter vNameOrPos.
Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IArchiveED

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT

The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique identification name (ShortName).
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveED" object in the list.

Example
C#
Copy
public void MacroArchivesED()
{
    IArchivesED zenonArchivesED = this.ActiveDocument.ArchivesED();
    //For each archiveED in the project, output identification name and name
    for (int i = 0; i < zenonArchivesED.Count; ++i)
    {
        this.Parent.DebugPrint(zenonArchivesED.Item(i).get_DynProperties("ShortName") +
            " - " + zenonArchivesED.Item(i).get_DynProperties("LongName"),
            tpDebugPrintStyle.tpMsg);
    }
}
VB.NET
Copy
Public Sub MacroArchivesED()
    Dim zenonArchivesED As IArchivesED = Me.ActiveDocument.ArchivesED()
    'For each archiveED in the project, output identification name and name
    For i As Integer = 0 To zenonArchivesED.Count - 1
        Me.Parent.DebugPrint(zenonArchivesED.Item(i).get_DynProperties("ShortName") & " - " & zenonArchivesED.Item(i).get_DynProperties("LongName"), tpDebugPrintStyle.tpMsg)
    Next
End Sub


SingleExport
ObjectModel COM [image] ArchivesED [image] Methods [image] SingleExport
Remarks

Exports the Item with given Name oder Index

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR


UndoCheckOut
ObjectModel COM [image] ArchivesED [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


ArchiveValue
ObjectModel COM [image] ArchiveValue
Remarks

The "ArchiveValue" object contains the value parameters for the "ArchiveFilterVariable" object.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
//This method will output information of the passed ArchiveFilterVariable object
public void ArchiveValue(IArchiveFilterVariable zenonArvFilterVariable)
{
    IArchiveValue zenonArvValue = zenonArvFilterVariable.
        ArchiveValues().Item(0);
    if (zenonArvValue == null)
    {
        //No value available
    }
    else
    {
        //Output some information of the value
        this.Parent.Parent.DebugPrint("Date / Time: " +
            TimeConversion.ZenOnToSystem((uint)zenonArvValue.Time).ToString(),
             tpDebugPrintStyle.tpMsg);

        this.Parent.Parent.DebugPrint("Recorded Value: " + zenonArvValue.Value,
            tpDebugPrintStyle.tpMsg);

        this.Parent.Parent.DebugPrint("State: &H" + zenonArvValue.Status.ToString("X"),
            tpDebugPrintStyle.tpMsg);
    }
}
VB.NET
Copy
'This method will output information of the passed ArchiveFilterVariable object
Public Sub ArchiveValue(zenonArvFilterVariable As IArchiveFilterVariable)
    Dim zenonArvValue As IArchiveValue = zenonArvFilterVariable.ArchiveValues().Item(0)
            'No value available
    If zenonArvValue Is Nothing Then
    Else
        'Output some information of the value
        Me.Parent.Parent.DebugPrint("Date / Time: " & TimeConversion.ZenOnToSystem(CUInt(zenonArvValue.Time)).ToString(), tpDebugPrintStyle.tpMsg)

        Me.Parent.Parent.DebugPrint("Recorded Value: " + zenonArvValue.Value, tpDebugPrintStyle.tpMsg)

        Me.Parent.Parent.DebugPrint("State: &H" & zenonArvValue.Status.ToString("X"), tpDebugPrintStyle.tpMsg)
    End If
End Sub
VBA
Copy
Sub zenOn_ArchiveValue(ByRef zArvFilterVar As ArchiveFilterVariable)
'Declarations
Dim zArvValue As ArchiveValue
Dim zTimeConvert As clsTimeConvert
'Initialize zArvValue with the first available value within the current archive variable
Set zArvValue = zArvFilterVar.ArchiveValues.Item(0)
'Initialize zTimeConvert by creating a new instance of the zenOn

"clsTimeConvert" macro
Set zTimeConvert = New clsTimeConvert
'If no value is available ...
If zArvValue Is Nothing Then

'... then inform the user

MsgBox ("No value available!")

'Otherwise:
Else

'Output the date and time when the value was recorded

Debug.Print "Date / Time: " &
Format(zTimeConvert.zenOn2System(CDbl(zArvValue.Time)), "yyyy-mm-dd hh:mm:ss") & "." & zArvValue.TimeMilliSec

'Output the recorded value

Debug.Print "Recorded value: " & zArvValue.Value

'Output the state of the value

Debug.Print "State: &H" & Hex(zArvValue.Status)
End If

End Sub


Properties
ObjectModel COM [image] ArchiveValue [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Parent | iarchivevalues | Returns the parent object | Unused | Readonly | Available | Available
Status | long |  | Unused | Available | Available | Available
StatusEx | long |  | Unused | Available | Available | Available
Time | long | Gets or modifies the time when the value was recorded. | Unused | Available | Available | Available
TimeMilliSec | long | Gets or modifies the milliseconds, in addition to the time, when the value was recorded. | Unused | Available | Available | Available
Value | variant | Gets or modifies the value that was recorded. | Unused | Available | Available | Available


Parent
ObjectModel COM [image] ArchiveValue [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IArchiveValues

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Status
ObjectModel COM [image] ArchiveValue [image] Properties [image] Status
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


StatusEx
ObjectModel COM [image] ArchiveValue [image] Properties [image] StatusEx
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] ArchiveValue [image] Properties [image] Time
Remarks

Gets or modifies the time when the value was recorded.

ATTENTION: zenOn uses UTC time internally, hence the desired start time has to be converted from the local time zone into UTC.

Please use the zenOn "clsTimeConvert" macro do that correctly.
For the macro code and further information on the zenOn "clsTimeConvert" macro, please have a look at the StartTime property within the "Archive Filter" object.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


TimeMilliSec
ObjectModel COM [image] ArchiveValue [image] Properties [image] TimeMilliSec
Remarks

Gets or modifies the milliseconds, in addition to the time, when the value was recorded.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Value
ObjectModel COM [image] ArchiveValue [image] Properties [image] Value
Remarks

Gets or modifies the value that was recorded.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ArchiveValue [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
SetModified | variant_bool | Set this method, in order to adopt parameter modifications. | Unused | Available | Available | Available


DynProperties [GET]
ObjectModel COM [image] ArchiveValue [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property, Example: "NetAktive"


DynProperties [PUT]
ObjectModel COM [image] ArchiveValue [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property, Example: "NetAktive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] ArchiveValue [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property, Example: "NetAktive"

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] ArchiveValue [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


SetModified
ObjectModel COM [image] ArchiveValue [image] Methods [image] SetModified
Remarks

Use this method, in order to adopt parameter modifications.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ArchiveValues
ObjectModel COM [image] ArchiveValues
Remarks

The "ArchiveValues" object manages the "ArchiveValue" objects.This object is utilized by the "ArchiveFilterVariable" object, in order to access the collection of "ArchiveValue" objects.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void ArchiveValues(IArchiveFilterVariable zenonArvFilterVariable)
{
    IArchiveValues zenonArvValues = zenonArvFilterVariable.ArchiveValues();
    if (zenonArvValues == null)
    {
        //There are no archive values, inform the user
        this.Parent.Parent.DebugPrint("There are no archive values",
            tpDebugPrintStyle.tpErr);
        return;
    }
    //Create a new archive value
    /* ##############################################################
     * #                           Attention                        #
     * #   This code is designed for spontaneous archive types.     #
     * #   If it is used in combination with a cyclic archive, the  #
     * #   code may corrupt the archive which results in a loss of  #
     * #   data.                                                    #
     * #                                                            #
     * #   Use at your own risk                                     #
     * ##############################################################
     */
    IArchiveValue zenonArvValue = zenonArvValues.CreateArchiveValue();
    zenonArvValue.Status = 0x1000;
    zenonArvValue.Time = (int)TimeConversion.SystemToZenOn(
        new DateTime(2007, 07, 30, 12, 0, 0));
    zenonArvValue.TimeMilliSec = 0;

    //Set your desired value
    zenonArvValue.Value = 1531;
    //Apply changes to the value
    zenonArvValue.SetModified();

    //For every archive value within the collection
    for (int i = 0; i < zenonArvValues.Count; ++i)
    {
        zenonArvValue = zenonArvValues.Item(i);

        //Print the current objects value
        this.Parent.Parent.DebugPrint(i + 1 + ". Value", tpDebugPrintStyle.tpMsg);

        //Print the current objects recording time
        this.Parent.Parent.DebugPrint("Date / Time: " +
            TimeConversion.ZenOnToSystem((uint)zenonArvValue.Time).ToString(),
            tpDebugPrintStyle.tpMsg);

        //Print the current objects recorded value
        this.Parent.Parent.DebugPrint("Recorded value: " + zenonArvValue.Value,
            tpDebugPrintStyle.tpMsg);

        //Print the current objects state
        this.Parent.Parent.DebugPrint("State: &H" + zenonArvValue.Status.ToString("X"),
            tpDebugPrintStyle.tpMsg);
    }
}
VB.NET
Copy
Public Sub ArchiveValues(zenonArvFilterVariable As IArchiveFilterVariable)
    Dim zenonArvValues As IArchiveValues = zenonArvFilterVariable.ArchiveValues()
    If zenonArvValues Is Nothing Then
        'There are no archive values, inform the user
        Me.Parent.Parent.DebugPrint("There are no archive values", tpDebugPrintStyle.tpErr)
        Return
    End If
    'Create a new archive value
    ' ##############################################################
'     * #                           Attention                        #
'     * #   This code is designed for spontaneous archive types.     #
'     * #   If it is used in combination with a cyclic archive, the  #
'     * #   code may corrupt the archive which results in a loss of  #
'     * #   data.                                                    #
'     * #                                                            #
'     * #   Use at your own risk                                     #
'     * ##############################################################
'

    Dim zenonArvValue As IArchiveValue = zenonArvValues.CreateArchiveValue()
    zenonArvValue.Status = &H1000
    zenonArvValue.Time = CInt(TimeConversion.SystemToZenOn(New DateTime(2007, 7, 30, 12, 0, 0)))
    zenonArvValue.TimeMilliSec = 0

    'Set your desired value
    zenonArvValue.Value = 1531
    'Apply changes to the value
    zenonArvValue.SetModified()

    'For every archive value within the collection
    For i As Integer = 0 To zenonArvValues.Count - 1
        zenonArvValue = zenonArvValues.Item(i)

        'Print the current objects value
        Me.Parent.Parent.DebugPrint(i + 1 & ". Value", tpDebugPrintStyle.tpMsg)

        'Print the current objects recording time
        Me.Parent.Parent.DebugPrint("Date / Time: " & TimeConversion.ZenOnToSystem(CUInt(zenonArvValue.Time)).ToString(), tpDebugPrintStyle.tpMsg)

        'Print the current objects recorded value
        Me.Parent.Parent.DebugPrint("Recorded value: " + zenonArvValue.Value, tpDebugPrintStyle.tpMsg)

        'Print the current objects state
        Me.Parent.Parent.DebugPrint("State: &H" & zenonArvValue.Status.ToString("X"), tpDebugPrintStyle.tpMsg)
    Next
End Sub
VBA
Copy
Sub zenOn_ArchiveValues(ByRef zArvFilterVar As ArchiveFilterVariable)
'Declarations
Dim zArvValues As ArchiveValues
Dim zArvValue As ArchiveValue
Dim zTimeConvert As clsTimeConvert
Dim i As Integer
'Initialize zArvValue with the archive values collection of the current archive variable
Set zArvValues = zArvFilterVar.ArchiveValues
'Initialize zTimeConvert by creating a new instance of the zenOn "clsTimeConvert" macro
Set zTimeConvert = New clsTimeConvert
'If no value is available ...
If zArvValues Is Nothing Then

'... then inform the user

MsgBox ("No archive values available!")

'Otherwise:
Else

'Create a new archive value

'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

'!! ATTENTION: !!

'!! This code is designed for spontaneous archive types. !!

'!! If it is used in combination with a cyclic archive, this !!

'!! code may corrupt the archive, which results in an loss of !!

'!! data. !!

'!! !!

'!! USE AT YOUR OWN RISK !!

'!! !!

'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

'Initialize zArvValue by creating a new value entry

Set zArvValue = zArvValues.CreateArchiveValue

'Set the state of the value to a manual entry

zArvValue.Status = &H1000

'Set the time when the value was entered

zArvValue.Time = zTimeConvert.System2zenOn(CDbl(CDate("30.07.2007 12:00:00")))

'Set the milliseconds, in addition to the time

zArvValue.TimeMilliSec = 0

'Set the desired value

zArvValue.Value = 1531

'Apply the modifications to the value

zArvValue.SetModified

'For every archive value within the collection

For i = 0 To zArvValues.Count - 1

'Assign the current archive value to zArvValue

Set zArvValue = zArvValues.Item(i)

'Output the count of the value

Debug.Print i + 1 & ". Value"

'Output the date and time when the value was recorded

Debug.Print vbTab & "Date / Time: " &

Format(zTimeConvert.zenOn2System(CDbl(zArvValue.Time)), "yyyy-mm-dd hh:mm:ss") & "." & zArvValue.TimeMilliSec

'Output the recorded value

Debug.Print vbTab & "Recorded value: " & zArvValue.Value

'Output the state of the value

Debug.Print vbTab & "State: &H" & Hex(zArvValue.Status)

Next i
End If
End Sub


Properties
ObjectModel COM [image] ArchiveValues [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the number of available objects. | Unused | Readonly | Available | Available
Parent | iarchivefiltervariable | Returns the parent object | Unused | Readonly | Available | Available


Count
ObjectModel COM [image] ArchiveValues [image] Properties [image] Count
Remarks

The property returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] ArchiveValues [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IArchiveFilterVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ArchiveValues [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateArchiveValue | iarchivevalue | Creates a new "ArchiveValue" object. | Unused | Available | Available | Available
DeleteArchiveValue | variant_bool | Removes an existing archive value ("ArchiveValue" object) from the collection. | Unused | Available | Available | Available
Item | iarchivevalue | Returns an "ArchiveValue" object from the collection, which is identified by the parameter vNameOrPos. | Available | Available | Available | Available


CreateArchiveValue
ObjectModel COM [image] ArchiveValues [image] Methods [image] CreateArchiveValue
Remarks

This method creates a new "ArchiveValue" object.

Datatype
IArchiveValue

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


DeleteArchiveValue
ObjectModel COM [image] ArchiveValues [image] Methods [image] DeleteArchiveValue
Remarks

This method removes an existing archive value ("ArchiveValue" object) from the collection.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT

The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveValue" object in the list.

Example
C#
Copy
public void MacroDeleteArchiveValues()
{
    /*
     * Gets the first ArchiveFilterVariable object in the first filter of
     * the first archive, NOTE: Those are required to exist in order for the
     * macro to work.
     */
    IArchiveFilterVariable zenonArvVariable = this.Archives().Item(0)
        .ArchiveFilters()
        .Item(0).ArchiveFilterVariables()
        .Item(0);
    IArchiveValues zenonArchiveValues = zenonArvVariable.ArchiveValues();

    //Deletes any ArchiveValue in the collection
    while (zenonArchiveValues.Count > 0)
    {
        zenonArchiveValues.DeleteArchiveValue(0);
    }
}
VB.NET
Copy
Public Sub MacroDeleteArchiveValues()
    '
'     * Gets the first ArchiveFilterVariable object in the first filter of
'     * the first archive, NOTE: Those are required to exist in order for the
'     * macro to work.
'

    Dim zenonArvVariable As IArchiveFilterVariable = Me.Archives().Item(0).ArchiveFilters().Item(0).ArchiveFilterVariables().Item(0)
    Dim zenonArchiveValues As IArchiveValues = zenonArvVariable.ArchiveValues()

    'Deletes any ArchiveValue in the collection
    While zenonArchiveValues.Count > 0
        zenonArchiveValues.DeleteArchiveValue(0)
    End While
End Sub


Item
ObjectModel COM [image] ArchiveValues [image] Methods [image] Item
Remarks

Returns an "ArchiveValue" object from the collection, which is identified by the parameter vNameOrPos. Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IArchiveValue

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT

The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveValue" object in the list.


ArchiveVarED
ObjectModel COM [image] ArchiveVarED
Remarks

The "ArchiveVarED" object contains the assigned "Variable" object and projecting information on the calculation mode.The object is utilized by the "ArchiveED" object.

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroArchiveVarEd()
{
    IArchiveED zenonArchiveEd = this.ActiveDocument.ArchivesED().Item("01");
    /* if there is no such archive available create it with
     * the given identification name "01" and the name
     * "zenon_ArchiveED"
     */
    if (zenonArchiveEd == null)
    {
        zenonArchiveEd = this.ActiveDocument.ArchivesED().
            CreateArchive("01", "zenOn_ArchiveED", null);
    }

    IArchiveVarED zenonArvVarEd = zenonArchiveEd.Item("WIZ_VAR_10");
    if (zenonArvVarEd == null)
    {
        //If the variable is not assigned to the archive, add it
        zenonArvVarEd = zenonArchiveEd.AddVariable("WIZ_VAR_10", tpArvVarCal.tpCalc_All, null);
    }

    //Output the name of the variable
    this.Parent.DebugPrint("Variable Name: " +
        ((IVariable)zenonArvVarEd.get_DynProperties("Variable")).Name,
        tpDebugPrintStyle.tpMsg);

    //Output the calculation mode
    this.Parent.DebugPrint("Calculation mode " +
        Enum.GetName(typeof(tpArvVarCal),
            zenonArvVarEd.get_DynProperties("Calculation")),
        tpDebugPrintStyle.tpMsg);
}
VB.NET
Copy
Public Sub MacroArchiveVarEd()
    Dim zenonArchiveEd As IArchiveED = Me.ActiveDocument.ArchivesED().Item("01")
    ' if there is no such archive available create it with
'     * the given identification name "01" and the name
'     * "zenon_ArchiveED"
'

    If zenonArchiveEd Is Nothing Then
        zenonArchiveEd = Me.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", Nothing)
    End If

    Dim zenonArvVarEd As IArchiveVarED = zenonArchiveEd.Item("WIZ_VAR_10")
    If zenonArvVarEd Is Nothing Then
        'If the variable is not assigned to the archive, add it
        zenonArvVarEd = zenonArchiveEd.AddVariable("WIZ_VAR_10", tpArvVarCal.tpCalc_All, Nothing)
    End If

    'Output the name of the variable
    Me.Parent.DebugPrint("Variable Name: " + DirectCast(zenonArvVarEd.get_DynProperties("Variable"), IVariable).Name, tpDebugPrintStyle.tpMsg)

    'Output the calculation mode
    Me.Parent.DebugPrint("Calculation mode " & [Enum].GetName(GetType(tpArvVarCal), zenonArvVarEd.get_DynProperties("Calculation")), tpDebugPrintStyle.tpMsg)
End Sub
VBA
Copy
Sub zenOn_ArchiveVarED(ByRef zArchiveED As ArchiveED)
'Declarations
Dim zArvVarED As ArchiveVarED
'Initialize zArvVarED with the "ArchiveVarED" object, where the variable named "WIZ_VAR_10" is assigned to it.
Set zArvVarED = zArchiveED.Item("WIZ_VAR_10")
'If the variable is not assigned to it ...
If zArvVarED Is Nothing Then

'... then add it to the archive

Set zArvVarED = zArchiveED.AddVariable("WIZ_VAR_10", 0, Nothing)
End If
'Output the variable name
Debug.Print "Variable name: " & zArvVarED.DynProperties("Variable").Name
'Output the calculation mode
Select Case zArvVarED.DynProperties("Calculation")

Case 0

Debug.Print "Calculation mode: All values"

Case 1

Debug.Print "Calculation mode: Sum"

Case 2

Debug.Print "Calculation mode: Average"

Case 3

Debug.Print "Calculation mode: Minimum"

Case 4

Debug.Print "Calculation mode: Maximum"
End Select

End Sub


Methods
ObjectModel COM [image] ArchiveVarED [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void |  | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available


DynProperties [GET]
ObjectModel COM [image] ArchiveVarED [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties [PUT]
ObjectModel COM [image] ArchiveVarED [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT


DynPropertiesEnum [GET]
ObjectModel COM [image] ArchiveVarED [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynPropertyParam [GET]
ObjectModel COM [image] ArchiveVarED [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties
ObjectModel COM [image] ArchiveVarED [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Variable archive


Variable archive
ObjectModel COM [image] ArchiveVarED [image] DynProperties [image] Variable archive
Overview
External Name | Type | Display Name | Description
Calculation | SByte | Calculation |
Variable | CProjektVariable | Variable |


ArchiveVariable
ObjectModel COM [image] ArchiveVariable
Remarks

This object is an archive variable containing the projecting information. "ArchiveVariable" objects are assigned to "Archive" objects.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroArchiveVariable()
{
    //Gets the first archive of the project
    IArchive zenonArchive = this.Archives().Item(0);
    if (zenonArchive == null)
    {
        //There is no archive, the user will be informed...
        this.Parent.Parent.DebugPrint("No archive available!",
            tpDebugPrintStyle.tpErr);
        return;
    }
    IArchiveVariable zenonArvVar = zenonArchive.ArchiveVariables().Item(0);
    if (zenonArvVar == null)
    {
        //There is no variable available
        this.Parent.Parent.DebugPrint("No variable available",
            tpDebugPrintStyle.tpErr);
        return;
    }
    //Output the name of the assigned variable
    this.Parent.Parent.DebugPrint("Name: " + zenonArvVar.Name,
        tpDebugPrintStyle.tpMsg);

    //Output the ID of the variable
    this.Parent.Parent.DebugPrint("ID: " + zenonArvVar.ID,
        tpDebugPrintStyle.tpMsg);

    //Output the utilized unit
    this.Parent.Parent.DebugPrint("Unit: " + zenonArvVar.Unit,
        tpDebugPrintStyle.tpMsg);

    //Output the calculation mode, if it is a following archive
    this.Parent.Parent.DebugPrint("Calculation mode: " + zenonArvVar.Calculation,
        tpDebugPrintStyle.tpMsg);
}
VB.NET
Copy
Public Sub MacroArchiveVariable()
    'Gets the first archive of the project
    Dim zenonArchive As IArchive = Me.Archives().Item(0)
    If zenonArchive Is Nothing Then
        'There is no archive, the user will be informed...
        Me.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr)
        Return
    End If
    Dim zenonArvVar As IArchiveVariable = zenonArchive.ArchiveVariables().Item(0)
    If zenonArvVar Is Nothing Then
        'There is no variable available
        Me.Parent.Parent.DebugPrint("No variable available", tpDebugPrintStyle.tpErr)
        Return
    End If
    'Output the name of the assigned variable
    Me.Parent.Parent.DebugPrint("Name: " + zenonArvVar.Name, tpDebugPrintStyle.tpMsg)

    'Output the ID of the variable
    Me.Parent.Parent.DebugPrint("ID: " + zenonArvVar.ID, tpDebugPrintStyle.tpMsg)

    'Output the utilized unit
    Me.Parent.Parent.DebugPrint("Unit: " + zenonArvVar.Unit, tpDebugPrintStyle.tpMsg)

    'Output the calculation mode, if it is a following archive
    Me.Parent.Parent.DebugPrint("Calculation mode: " + zenonArvVar.Calculation, tpDebugPrintStyle.tpMsg)
End Sub
VBA
Copy
Sub zenOn_ArchiveVariable(ByRef zArchive As Archive)
'Declarations
Dim zArvVar As ArchiveVariable
'Initialize zArvVar with the first available archive variable within the collection
Set zArvVar = zArchive.ArchiveVariables.Item(0)
'If no archive variable is available ...
If zArvVar Is Nothing Then

'... then inform the user

MsgBox ("No archive variable available!")

'Otherwise, output some details
Else

'Output the name of the assigned variable

Debug.Print "Name: " & zArvVar.Name

'Output the ID

Debug.Print "ID: " & zArvVar.ID

'Output the utilized unit

Debug.Print "Unit: " & zArvVar.Unit

'Output the utilized calculation mode, if it is a following archive

Debug.Print "Calculation mode: " & zArvVar.Calculation
End If
End Sub


Properties
ObjectModel COM [image] ArchiveVariable [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Calculation | long |  | Unused | Readonly | Available | Available
ID | long | Returns the unique ID of the current "ArchiveVariable" object. | Unused | Readonly | Available | Available
LongText | bstr | Returns the identifier of the current "ArchiveVariable" object. | Unused | Readonly | Available | Available
Name | bstr | Returns the name of the current "ArchiveVariable" object. | Unused | Readonly | Available | Available
Parent | iarchivevariables | Returns the parent object | Unused | Readonly | Available | Available
SourceVariable | iarchivevariable | Gets the SourceVariable As ArchiveVariable | Unused | Readonly | Available | Available
Unit | bstr | Returns the unit (as string) of the current "ArchiveVariable" object. | Unused | Readonly | Available | Available


Calculation
ObjectModel COM [image] ArchiveVariable [image] Properties [image] Calculation
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ID
ObjectModel COM [image] ArchiveVariable [image] Properties [image] ID
Remarks

Returns the unique ID of the current "ArchiveVariable" object.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


LongText
ObjectModel COM [image] ArchiveVariable [image] Properties [image] LongText
Remarks

Returns the identifier of the current "ArchiveVariable" object.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] ArchiveVariable [image] Properties [image] Name
Remarks

Returns the name of the current "ArchiveVariable" object.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] ArchiveVariable [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IArchiveVariables

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


SourceVariable
ObjectModel COM [image] ArchiveVariable [image] Properties [image] SourceVariable
Remarks

To get the SourceVariable As ArchiveVariable

Datatype
IArchiveVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Unit
ObjectModel COM [image] ArchiveVariable [image] Properties [image] Unit
Remarks

Returns the unit (as string) of the current "ArchiveVariable" object.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ArchiveVariable [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Variable | ivariable | Returns the assigned variable as "Variable" object. | Unused | Available | Available | Available


Variable
ObjectModel COM [image] ArchiveVariable [image] Methods [image] Variable
Remarks

Returns the assigned variable as "Variable" object.

Datatype
IVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub zenOn_ArchiveVariable(ByRef zArchive As Archive)
'Declarations
Dim zArvVar As ArchiveVariable
'Initialize zArvVar with the first available archive variable within the collection
Set zArvVar = zArchive.ArchiveVariables.Item(0)
'If no archive variable is available ...
If zArvVar Is Nothing Then

'... then inform the user

MsgBox ("No archive variable available!")

'Otherwise, output some details
Else

'Output the name of the assigned variable

Debug.Print "Name: " & zArvVar.Name

'Output the ID

Debug.Print "ID: " & zArvVar.ID

'Output the utilized unit

Debug.Print "Unit: " & zArvVar.Unit

'Output the utilized calculation mode, if it is a following archive

Debug.Print "Calculation mode: " & zArvVar.Calculation
End If
End Sub


ArchiveVariables
ObjectModel COM [image] ArchiveVariables
Remarks

The "ArchiveVariables" object is a collection of all defined "ArchiveVariable" objects.This object is utilized by the "Archive" object, in order to access the collection of "ArchiveVariable" objects.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroArchiveVariables()
{
    //Gets the first archive of the project
    IArchive zenonArchive = this.Archives().Item(0);
    if (zenonArchive == null)
    {
        //There is no archive, the user will be informed...
        this.Parent.Parent.DebugPrint("No archive available!",
            tpDebugPrintStyle.tpErr);
        return;
    }
    IArchiveVariables zenonArvVariables = zenonArchive.ArchiveVariables();
    for (int i = 0; i < zenonArvVariables.Count; ++i)
    {
        //Output the name of the variable for each variable in the collection
        this.Parent.Parent.DebugPrint(i + 1 + ". Variable: " + zenonArvVariables.Item(i).Name,
            tpDebugPrintStyle.tpMsg);
    }
}
VB.NET
Copy
Public Sub MacroArchiveVariables()
    'Gets the first archive of the project
    Dim zenonArchive As IArchive = Me.Archives().Item(0)
    If zenonArchive Is Nothing Then
        'There is no archive, the user will be informed...
        Me.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr)
        Return
    End If
    Dim zenonArvVariables As IArchiveVariables = zenonArchive.ArchiveVariables()
    For i As Integer = 0 To zenonArvVariables.Count - 1
        'Output the name of the variable for each variable in the collection
        Me.Parent.Parent.DebugPrint((i + 1 & ". Variable: ") + zenonArvVariables.Item(i).Name, tpDebugPrintStyle.tpMsg)
    Next
End Sub
VBA
Copy
Sub zenOn_ArchiveVariables(ByRef zArchive As Archive)
'Declarations
Dim zArVars As ArchiveVariables
Dim i As Integer
'Initialize zArVars with the variable collection of the passed archive
Set zArVars = zArchive.ArchiveVariables
'For every variable within the collection...
For i = 0 To zArVars.Count - 1

'... output the name of the variable

Debug.Print i + 1 & ". Variable: " & zArVars.Item(i).Name
Next i

End Sub


Properties
ObjectModel COM [image] ArchiveVariables [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the number of available objects. | Unused | Readonly | Available | Available
Parent | iarchive | Returns the parent object | Unused | Readonly | Available | Available


Count
ObjectModel COM [image] ArchiveVariables [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] ArchiveVariables [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IArchive

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ArchiveVariables [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Item | iarchivevariable | Returns an "ArchiveVariable" object from the collection, which is identified by the parameter vNameOrPos. | Available | Available | Available | Available
ItemById | iarchivevariable | Returns an "ArchiveVariable" object from the collection specified by its internal uniqe ID, which is identified by the parameter vVariableId. | Unused | Available | Available | Available
ItemByIdEx | iarchivevariable | Returns an object of type ArchiveFilterVariable. | Unused | Readonly | Available | Available


Item
ObjectModel COM [image] ArchiveVariables [image] Methods [image] Item
Remarks

Returns an "ArchiveVariable" object from the collection, which is identified by the parameter vNameOrPos. Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IArchiveVariable

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT

The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveVariable" object in the list.

Example
C#
Copy
//For details on how to get a specific variable by its collection Id have a look at the main topic "ArchiveVariables"
VB.NET
Copy
'For details on how to get a specific variable by its collection Id have a look at the main topic "ArchiveVariables"
VBA
Copy
'For details on how to get a specific variable by its collection Id have a look at the main topic "ArchiveVariables"


ItemById
ObjectModel COM [image] ArchiveVariables [image] Methods [image] ItemById
Remarks

Returns an "ArchiveVariable" object from the collection specified by its internal uniqe ID, which is identified by the parameter vVariableId.Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IArchiveVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vVariableId as VARIANT

Uniqe PvID of linked zenOn Variable


ItemByIdEx
ObjectModel COM [image] ArchiveVariables [image] Methods [image] ItemByIdEx
Remarks

Returns an object of type ArchiveFilterVariable.

Datatype
IArchiveVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
vVariableId as VARIANT

Uniqe PvID of linked zenOn Variable

vProjectName as VARIANT

Projectname as string

vCalculation as VARIANT

Type of calculation as long Calculation Types.

Example
VBA
Copy
Sub GetArchiveVariable(zArchive As Archive)
Dim zVariable As Variable
Dim zArvVar As ArchiveVariable
'get variable object to read the PvID!
Set zVariable = thisProject.Variables.Item("WIZ_VAR_10")
'get the archivevariable with SUM calculation
Set zArvVar = zArchive.ArchiveVariables.ItemByIdEx(zVariable.PvID,

thisProject.Name, 1)
End Sub


ArvTemplate
ObjectModel COM [image] ArvTemplate
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroGetTemplates()
{
    IArvTemplates zenonArvTemplates = this.GetArvTemplates();
    if (zenonArvTemplates != null)
    {
        //Get the first template if the collection is not a null pointer
        IArvTemplate zenonArvTemplate = zenonArvTemplates.Item(0);
        if (zenonArvTemplate != null)
        {
            this.Parent.DebugPrint("Name: " + zenonArvTemplate.get_DynProperties("Name"),
                tpDebugPrintStyle.tpMsg);

            this.Parent.DebugPrint("GUID: " + zenonArvTemplate.get_DynProperties("GUID"),
                tpDebugPrintStyle.tpMsg);

            this.Parent.DebugPrint("ImportPath: " + zenonArvTemplate.get_DynProperties("ImportPath"),
                tpDebugPrintStyle.tpMsg);

            this.Parent.DebugPrint("Folder: " + zenonArvTemplate.get_DynProperties("Folder"),
                tpDebugPrintStyle.tpMsg);

            this.Parent.DebugPrint("Language: " + zenonArvTemplate.get_DynProperties("Language"),
                tpDebugPrintStyle.tpMsg);

            this.Parent.DebugPrint("Description: " + zenonArvTemplate.get_DynProperties("Description"),
                tpDebugPrintStyle.tpMsg);

            this.Parent.DebugPrint("CopaDataTemplate: " + zenonArvTemplate.get_DynProperties("CopaDataTemplate"),
                tpDebugPrintStyle.tpMsg);
        }
    }
}
VB.NET
Copy
Public Sub MacroGetTemplates()
    Dim zenonArvTemplates As IArvTemplates = Me.GetArvTemplates()
    If zenonArvTemplates IsNot Nothing Then
        'Get the first template if the collection is not a null pointer
        Dim zenonArvTemplate As IArvTemplate = zenonArvTemplates.Item(0)
        If zenonArvTemplate IsNot Nothing Then
            Me.Parent.DebugPrint("Name: " & zenonArvTemplate.get_DynProperties("Name"), tpDebugPrintStyle.tpMsg)

            Me.Parent.DebugPrint("GUID: " & zenonArvTemplate.get_DynProperties("GUID"), tpDebugPrintStyle.tpMsg)

            Me.Parent.DebugPrint("ImportPath: " & zenonArvTemplate.get_DynProperties("ImportPath"), tpDebugPrintStyle.tpMsg)

            Me.Parent.DebugPrint("Folder: " & zenonArvTemplate.get_DynProperties("Folder"), tpDebugPrintStyle.tpMsg)

            Me.Parent.DebugPrint("Language: " & zenonArvTemplate.get_DynProperties("Language"), tpDebugPrintStyle.tpMsg)

            Me.Parent.DebugPrint("Description: " & zenonArvTemplate.get_DynProperties("Description"), tpDebugPrintStyle.tpMsg)

            Me.Parent.DebugPrint("CopaDataTemplate: " & zenonArvTemplate.get_DynProperties("CopaDataTemplate"), tpDebugPrintStyle.tpMsg)
        End If
    End If
End Sub
VBA
Copy
Private Sub GetTemplates()
    Dim IArvTemplates As ArvTemplates
    Dim IArvTemplate As ArvTemplate
    Dim Count As Integer
    Dim Ok As Boolean
    ' --- Auswahl über den Namen
    Set IArvTemplates = MyWorkspace.GetArvTemplates()
    If Not IArvTemplates Is Nothing Then
        Set IArvTemplate = IArvTemplates.Item("Test 3")
        Ok = PrintTemplate(IArvTemplate)
    End If
    ' --- Auswahl über den Index
    Set IArvTemplates = MyWorkspace.GetArvTemplates()
    If Not IArvTemplates Is Nothing Then
        Count = IArvTemplates.Count
        For i = 0 To Count - 1
            Set IArvTemplate = IArvTemplates.Item(i)
            Ok = PrintTemplate(IArvTemplate)
        Next
    End If
End Sub
Private Function PrintTemplate(IArvTemplate As ArvTemplate) As Boolean
    If Not IArvTemplate Is Nothing Then
        Debug.Print ("Name: " & IArvTemplate.DynProperties("Name"))
        Debug.Print ("GUID: " & IArvTemplate.DynProperties("GUID"))
        Debug.Print ("ImportPath: " & IArvTemplate.DynProperties("ImportPath"))
        Debug.Print ("Folder: " & IArvTemplate.DynProperties("Folder"))
        Debug.Print ("Language: " & IArvTemplate.DynProperties("Language"))
        Debug.Print ("Description: " & IArvTemplate.DynProperties("Description"))
        Debug.Print ("CopaDataTemplate: " & IArvTemplate.DynProperties("CopaDataTemplate"))
        PrintTemplate = True
    Else
        PrintTemplate = False
    End If
End Function


Methods
ObjectModel COM [image] ArvTemplate [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant |  | Readonly | Unused | Available | Available
DynPropertiesEnum [GET] | variant |  | Readonly | Unused | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available


DynProperties [GET]
ObjectModel COM [image] ArvTemplate [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynPropertiesEnum [GET]
ObjectModel COM [image] ArvTemplate [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynPropertyParam [GET]
ObjectModel COM [image] ArvTemplate [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties
ObjectModel COM [image] ArvTemplate [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Archive template


Archive template
ObjectModel COM [image] ArvTemplate [image] DynProperties [image] Archive template
Overview
External Name | Type | Display Name | Description
CopaDataTemplate | Bool | CopaDataTemplate | Description
Description | String | Description | Description
Folder | String | Folder | Description
GUID | String | GUID | Description
ImportPath | String | ImportPath | Description
Language | String | Language | Description
Name | String | Name | Description


ArvTemplates
ObjectModel COM [image] ArvTemplates
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroGetTemplates()
{
    IArvTemplates zenonArvTemplates = this.GetArvTemplates();
    if (zenonArvTemplates != null)
    {
        //Get the first template if the collection is not a null pointer
        IArvTemplate zenonArvTemplate = zenonArvTemplates.Item(0);
        if (zenonArvTemplate != null)
        {
            this.Parent.DebugPrint("Name: " + zenonArvTemplate.get_DynProperties("Name"),
                tpDebugPrintStyle.tpMsg);

            this.Parent.DebugPrint("GUID: " + zenonArvTemplate.get_DynProperties("GUID"),
                tpDebugPrintStyle.tpMsg);

            this.Parent.DebugPrint("ImportPath: " + zenonArvTemplate.get_DynProperties("ImportPath"),
                tpDebugPrintStyle.tpMsg);

            this.Parent.DebugPrint("Folder: " + zenonArvTemplate.get_DynProperties("Folder"),
                tpDebugPrintStyle.tpMsg);

            this.Parent.DebugPrint("Language: " + zenonArvTemplate.get_DynProperties("Language"),
                tpDebugPrintStyle.tpMsg);

            this.Parent.DebugPrint("Description: " + zenonArvTemplate.get_DynProperties("Description"),
                tpDebugPrintStyle.tpMsg);

            this.Parent.DebugPrint("CopaDataTemplate: " + zenonArvTemplate.get_DynProperties("CopaDataTemplate"),
                tpDebugPrintStyle.tpMsg);
        }
    }
}
VB.NET
Copy
Public Sub MacroGetTemplates()
    Dim zenonArvTemplates As IArvTemplates = Me.GetArvTemplates()
    If zenonArvTemplates IsNot Nothing Then
        'Get the first template if the collection is not a null pointer
        Dim zenonArvTemplate As IArvTemplate = zenonArvTemplates.Item(0)
        If zenonArvTemplate IsNot Nothing Then
            Me.Parent.DebugPrint("Name: " & zenonArvTemplate.get_DynProperties("Name"), tpDebugPrintStyle.tpMsg)

            Me.Parent.DebugPrint("GUID: " & zenonArvTemplate.get_DynProperties("GUID"), tpDebugPrintStyle.tpMsg)

            Me.Parent.DebugPrint("ImportPath: " & zenonArvTemplate.get_DynProperties("ImportPath"), tpDebugPrintStyle.tpMsg)

            Me.Parent.DebugPrint("Folder: " & zenonArvTemplate.get_DynProperties("Folder"), tpDebugPrintStyle.tpMsg)

            Me.Parent.DebugPrint("Language: " & zenonArvTemplate.get_DynProperties("Language"), tpDebugPrintStyle.tpMsg)

            Me.Parent.DebugPrint("Description: " & zenonArvTemplate.get_DynProperties("Description"), tpDebugPrintStyle.tpMsg)

            Me.Parent.DebugPrint("CopaDataTemplate: " & zenonArvTemplate.get_DynProperties("CopaDataTemplate"), tpDebugPrintStyle.tpMsg)
        End If
    End If
End Sub
VBA
Copy
Private Sub GetTemplates()
    Dim IArvTemplates As ArvTemplates
    Dim IArvTemplate As ArvTemplate
    Dim Count As Integer
    Dim Ok As Boolean
    ' --- Auswahl über den Namen
    Set IArvTemplates = MyWorkspace.GetArvTemplates()
    If Not IArvTemplates Is Nothing Then
        Set IArvTemplate = IArvTemplates.Item("Test 3")
        Ok = PrintTemplate(IArvTemplate)
    End If
    ' --- Auswahl über den Index
    Set IArvTemplates = MyWorkspace.GetArvTemplates()
    If Not IArvTemplates Is Nothing Then
        Count = IArvTemplates.Count
        For i = 0 To Count - 1
            Set IArvTemplate = IArvTemplates.Item(i)
            Ok = PrintTemplate(IArvTemplate)
        Next
    End If
End Sub
Private Function PrintTemplate(IArvTemplate As ArvTemplate) As Boolean
    If Not IArvTemplate Is Nothing Then
        Debug.Print ("Name: " & IArvTemplate.DynProperties("Name"))
        Debug.Print ("GUID: " & IArvTemplate.DynProperties("GUID"))
        Debug.Print ("ImportPath: " & IArvTemplate.DynProperties("ImportPath"))
        Debug.Print ("Folder: " & IArvTemplate.DynProperties("Folder"))
        Debug.Print ("Language: " & IArvTemplate.DynProperties("Language"))
        Debug.Print ("Description: " & IArvTemplate.DynProperties("Description"))
        Debug.Print ("CopaDataTemplate: " & IArvTemplate.DynProperties("CopaDataTemplate"))
        PrintTemplate = True
    Else
        PrintTemplate = False
    End If
End Function


Properties
ObjectModel COM [image] ArvTemplates [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Count of Archive Templates in the Collection | Available | Unused | Available | Available


Count
ObjectModel COM [image] ArvTemplates [image] Properties [image] Count
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ArvTemplates [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Item | iarvtemplate | Returns the Archive Template by Name or Position | Available | Unused | Available | Available


Item
ObjectModel COM [image] ArvTemplates [image] Methods [image] Item
Remarks

Returns the Archive Template by Name or Position

Datatype
IArvTemplate

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vPosOrName as VARIANT

The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveVariable" object in the list.


BatchConfig
ObjectModel COM [image] BatchConfig
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchConfig [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Units | ibatchunitsconfig | Returns the units configuration | Available | Readonly | Available | Available


Units
ObjectModel COM [image] BatchConfig [image] Properties [image] Units
Remarks

Returns the units configuration

Datatype
IBatchUnitsConfig

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] BatchConfig [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module is checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


CheckIn
ObjectModel COM [image] BatchConfig [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor).

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckOut
ObjectModel COM [image] BatchConfig [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor).

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Get
ObjectModel COM [image] BatchConfig [image] Methods [image] Get
Remarks

Get the latest version from the server (editor).

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IsCheckedOut
ObjectModel COM [image] BatchConfig [image] Methods [image] IsCheckedOut
Remarks

Returns true when the current module is checked out by the current user (editor).

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDifferent
ObjectModel COM [image] BatchConfig [image] Methods [image] IsDifferent
Remarks

Returns true when the local and server version are different (editor).

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] BatchConfig [image] Methods [image] IsLocked
Remarks

Returns true when the current module is Locked by another user (editor).

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


UndoCheckOut
ObjectModel COM [image] BatchConfig [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor).

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


BatchControlRecipe
ObjectModel COM [image] BatchControlRecipe
Remarks

A batch control recipe is an instance of a batch master recipe created for a single execution.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchControlRecipe [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ApprovedTime | date | Returns the approved time of the master recipe | Unused | Readonly | Available | Available
ApprovedUserId | bstr | Returns the approved user id of the master recipe | Unused | Readonly | Available | Available
ApprovedUserName | bstr | Returns the approved user name of the master recipe | Unused | Readonly | Available | Available
CreatedTime | date | Returns the creation time of the control recipe | Unused | Readonly | Available | Available
CreatedUserId | bstr | Returns the creation user id of the control recipe | Unused | Readonly | Available | Available
CreatedUserName | bstr | Returns the creation user name of the control recipe | Unused | Readonly | Available | Available
CRState | tpbatchcrstate | Returns the state the control recipe | Unused | Readonly | Available | Available
Description | bstr | Returns the description of the control recipe | Unused | Readonly | Available | Available
ExecutionMode | tpbatchexecutionmode | Returns the mode of the recipe | Unused | Readonly | Available | Available
ExecutionState | tpbatchexecutionstate | Returns the state of the recipe engine | Unused | Readonly | Available | Available
ID | long | Returns the Id of the control recipe | Unused | Readonly | Available | Available
JobId | bstr | Returns the job id the control recipe | Unused | Readonly | Available | Available
JobVariable | ivariable | Returns the job variable of the control recipe | Unused | Readonly | Available | Available
MRDescription | bstr | Returns the description of the master recipe | Unused | Readonly | Available | Available
MRId | long | Returns the Id of the master recipe | Unused | Readonly | Available | Available
MRName | bstr | Returns the name of the master recipe | Unused | Readonly | Available | Available
MRSourceVersion | long | Returns the version of the source master recipe | Unused | Readonly | Available | Available
MRState | tpbatchmrstate | Returns the state of the master recipe | Unused | Readonly | Available | Available
MRVersion | long | Returns the version of the master recipe | Unused | Readonly | Available | Available
Name | bstr | Returns the name of the control recipe | Unused | Readonly | Available | Available
OutdatedTime | date | Returns the outdated time of the master recipe | Unused | Readonly | Available | Available
OutdatedUserId | bstr | Returns the outdated user id of the master recipe | Unused | Readonly | Available | Available
OutdatedUserName | bstr | Returns the outdated user name of the master recipe | Unused | Readonly | Available | Available
StartedOnHost | bstr |  | Unused | Readonly | Available | Available
StartedTime | date | Returns the started time of the control recipes | Unused | Readonly | Available | Available
StartedUserId | bstr | Returns the started user id of the control recipe | Unused | Readonly | Available | Available
StartedUserName | bstr | Returns the started user name of the control recipe | Unused | Readonly | Available | Available
Type | bstr | Returns the type of the recipe | Unused | Readonly | Available | Available


ApprovedTime
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] ApprovedTime
Remarks

Returns the approved time of the master recipe

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ApprovedUserId
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] ApprovedUserId
Remarks

Returns the approved user id of the master recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ApprovedUserName
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] ApprovedUserName
Remarks

Returns the approved user name of the master recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


CreatedTime
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] CreatedTime
Remarks

Returns the creation time of the control recipe

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


CreatedUserId
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] CreatedUserId
Remarks

Returns the creation user id of the control recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


CreatedUserName
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] CreatedUserName
Remarks

Returns the creation user name of the control recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


CRState
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] CRState
Remarks

Returns the state the control recipe

Datatype
tpBatchCRState

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Description
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] Description
Remarks

Returns the description of the control recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ExecutionMode
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] ExecutionMode
Remarks

Returns the mode of the recipe

Datatype
tpBatchExecutionMode

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ExecutionState
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] ExecutionState
Remarks

Returns the state of the recipe engine

Datatype
tpBatchExecutionState

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ID
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] ID
Remarks

Returns the Id of the control recipe

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


JobId
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] JobId
Remarks

Returns the job id the control recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


JobVariable
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] JobVariable
Remarks

Returns the job variable of the control recipe

Datatype
IVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MRDescription
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] MRDescription
Remarks

Returns the description of the master recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MRId
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] MRId
Remarks

Returns the Id of the master recipe

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MRName
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] MRName
Remarks

Returns the name of the master recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MRSourceVersion
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] MRSourceVersion
Remarks

Version number of the source recipe.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MRState
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] MRState
Remarks

Returns the state of the master recipe

Datatype
tpBatchMRState

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MRVersion
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] MRVersion
Remarks

Version number of the template recipe.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] Name
Remarks

Returns the name of the control recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


OutdatedTime
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] OutdatedTime
Remarks

Returns the outdated time of the master recipe

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


OutdatedUserId
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] OutdatedUserId
Remarks

Returns the outdated user id of the master recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


OutdatedUserName
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] OutdatedUserName
Remarks

Returns the outdated user name of the master recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


StartedOnHost
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] StartedOnHost
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


StartedTime
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] StartedTime
Remarks

Returns the started time of the control recipes

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


StartedUserId
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] StartedUserId
Remarks

Returns the started user id of the control recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


StartedUserName
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] StartedUserName
Remarks

Returns the started user name of the control recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] BatchControlRecipe [image] Properties [image] Type
Remarks

Returns the type of the recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] BatchControlRecipe [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
SetNameAndDescription | tpreciperenameresult | Tries to rename the recipe and sets the description. Returns a result code whether the operation was successful or not. | Unused | Readonly | Available | Available


SetNameAndDescription
ObjectModel COM [image] BatchControlRecipe [image] Methods [image] SetNameAndDescription
Remarks

This method changes the name and the description of the control recipe if possible. The method returns a result code for the operation. Note, that the control recipe instance you are working on is a copy of the original data. To get an updated version of the control recipe you have to get it again from the control recipes container.

Datatype
tpRecipeRenameResult

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
newName as BSTR

Name of the recipe.

newDescription as BSTR

Dercription of the recipe.

Example
C#
Copy
//Function to rename a control recipe and set its description
public void Macro_SetControlRecipeNameAndDescription()
{
    //Get the control recipe that is to be renamed
    IBatchControlRecipe cr = BatchManager().MasterRecipes().Item("masterRecipeName", 1).
        ControlRecipes(tpBatchCRStateFilter.tpCRStateFilterAll).ItemByName("oldControlRecipeName");

    //rename the control recipe and set its description
    tpRecipeRenameResult result = cr.SetNameAndDescription("newName", "newDescription");

    //Output result if the operation failed
    if (result != tpRecipeRenameResult.tpRecipeRenameSuccess)
    {
        MessageBox.Show(null, "Rename Failed. Error Code: " + result.ToString(), "rename master recipe result", MessageBoxButtons.OK, MessageBoxIcon.None);
    }
}
VB.NET
Copy
'Function to rename a control recipe and set its description
Public Sub Macro_SetControlRecipeNameAndDescription()
    'Get the control recipe that is to be renamed
    Dim cr As IBatchControlRecipe = BatchManager().MasterRecipes().Item("masterRecipeName", 1).ControlRecipes(tpBatchCRStateFilter.tpCRStateFilterAll).ItemByName("oldControlRecipeName")

    'rename the control recipe and set its description
    Dim result As tpRecipeRenameResult = cr.SetNameAndDescription("newName", "newDescription")

    'Output result if the operation failed
    If result <> tpRecipeRenameResult.tpRecipeRenameSuccess Then
        MessageBox.Show(Nothing, "Rename Failed. Error Code: " & result.ToString(), "rename master recipe result", MessageBoxButtons.OK, MessageBoxIcon.None)
    End If
End Sub
VBA
Copy
'Function to rename a control recipe and set its description
Public Sub SetControlRecipeNameAndDescription()
    'Get the control recipe that is to be renamed
    Dim cr As BatchControlRecipe
    Set cr = thisProject.BatchManager.MasterRecipes.Item("masterRecipeName", 1).ControlRecipes(tpCRStateFilterAll).ItemByName("oldControlRecipeName")
    'rename the control recipe and set its description
    Dim result As tpRecipeRenameResult  'resultcode for the operation
    result = cr.SetNameAndDescription("newName", "newDescription")
    'Output result if the operation failed
    If result <> tpRecipeRenameSuccess Then
        MsgBox ("Rename Failed. Error Code: " & CStr(result))
    End If
End Sub


BatchControlRecipePhaseEditedEventData
ObjectModel COM [image] BatchControlRecipePhaseEditedEventData
Remarks

The data class that gets passed when the ControlRecipePhaseEdited Event of the BatchManager is fired. It contains all relevant information for this event.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
void ThisProject_Active()
{
    //Check in the ControlRecipePhaseEdited Event
    BatchManager().ControlRecipePhaseEdited += new ControlRecipePhaseEditedEventHandler(ThisProject_ControlRecipePhaseEdited);
}

void ThisProject_ControlRecipePhaseEdited(IBatchControlRecipePhaseEditedEventData eventData)
{
    //Get the ID of the changed tags from the event data changes collection
    string additionalInformation = "Changes[Tag-ID]: ";

    for (var index = 0; index < eventData.Changes.TagIdCount; index++)
    {
        additionalInformation += "" + eventData.Changes.TagIdByIndex(index) + "; ";
    }

    additionalInformation += "   --   Comment:\"" + eventData.Comment + "\"";

    //Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] Control Recipe Edited. >> " + additionalInformation);
}

void ThisProject_Inactive()
{
    //Check out the ControlRecipePhaseEdited Event
    BatchManager().ControlRecipePhaseEdited -= ThisProject_ControlRecipePhaseEdited;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    'Check in the ControlRecipePhaseEdited Event
    AddHandler BatchManager().ControlRecipePhaseEdited, AddressOf ThisProject_ControlRecipePhaseEdited
End Sub

Private Sub ThisProject_ControlRecipePhaseEdited(eventData As IBatchControlRecipePhaseEditedEventData)
    'Get the ID of the changed tags from the event data changes collection
    Dim additionalInformation As String = "Changes[Tag-ID]: "

    For index As var = 0 To eventData.Changes.TagIdCount - 1
        additionalInformation += "" & eventData.Changes.TagIdByIndex(index) & "; "
    Next

    additionalInformation += "   --   Comment:""" & Convert.ToString(eventData.Comment) & """"

    'Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] Control Recipe Edited. >> " & additionalInformation)
End Sub

Private Sub ThisProject_Inactive()
    'Check out the ControlRecipePhaseEdited Event
    RemoveHandler BatchManager().ControlRecipePhaseEdited, AddressOf ThisProject_ControlRecipePhaseEdited

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub


Properties
ObjectModel COM [image] BatchControlRecipePhaseEditedEventData [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Changes | ibatchphasechanges | Ids of the changed Tags | Unused | Readonly | Available | Available
Comment | bstr | User Comment for the change | Unused | Readonly | Available | Available
ControlRecipe | ibatchcontrolrecipe | Control recipe for which the event was fired | Unused | Readonly | Available | Available
NewPhase | ibatchphase | Phase after the change | Unused | Readonly | Available | Available
OldPhase | ibatchphase | Phase before the change | Unused | Readonly | Available | Available
Operation | ibatchoperation | Operation that contains the phase that fired the event. null if the phase is in no operation | Unused | Readonly | Available | Available
Time | date | Time when the event was fired | Unused | Readonly | Available | Available
User | iuser | Logged in user | Unused | Readonly | Available | Available


Changes
ObjectModel COM [image] BatchControlRecipePhaseEditedEventData [image] Properties [image] Changes
Remarks

Object that contains information what parts of the phase where changed.

Datatype
IBatchPhaseChanges

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Comment
ObjectModel COM [image] BatchControlRecipePhaseEditedEventData [image] Properties [image] Comment
Remarks

Edit comment the user has entered for the change. Empty if change comments are disabled.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ControlRecipe
ObjectModel COM [image] BatchControlRecipePhaseEditedEventData [image] Properties [image] ControlRecipe
Remarks

Control recipe that contains the phase that has been changed.

Datatype
IBatchControlRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


NewPhase
ObjectModel COM [image] BatchControlRecipePhaseEditedEventData [image] Properties [image] NewPhase
Remarks

Phase configuration after the change.

Datatype
IBatchPhase

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


OldPhase
ObjectModel COM [image] BatchControlRecipePhaseEditedEventData [image] Properties [image] OldPhase
Remarks

): Phase configuration from before the change

Datatype
IBatchPhase

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Operation
ObjectModel COM [image] BatchControlRecipePhaseEditedEventData [image] Properties [image] Operation
Remarks

Operation that contains the changed phase that fired the event. Null if the phase is not located in an operation.

Datatype
IBatchOperation

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] BatchControlRecipePhaseEditedEventData [image] Properties [image] Time
Remarks

Timestamp at which the event was fired

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


User
ObjectModel COM [image] BatchControlRecipePhaseEditedEventData [image] Properties [image] User
Remarks

User that has changed the phase

Datatype
IUser

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchControlRecipes
ObjectModel COM [image] BatchControlRecipes
Remarks

A collection of the batch control recipes. It is used to iterate and get the control recipes.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroBatchControlRecipes()
{
    //Get all BatchControlRecipes of a specific masterRecipe "masterRecipeName"
    IBatchControlRecipes recipes = BatchManager()
        .MasterRecipes().Item("masterRecipeName", 1)
        .ControlRecipes(tpBatchCRStateFilter.tpCRStateFilterAll);
    //Print the name of all BatchControlRecipe objects inside the BatchControlRecipes collection
    for (int i = 0; i < recipes.Count; i++)
        this.Parent.Parent.DebugPrint(recipes.ItemByIndex(i).Name, tpDebugPrintStyle.tpMsg);
}
VB.NET
Copy
Public Sub MacroBatchControlRecipes()
    'Get all BatchControlRecipes of a specific masterRecipe "masterRecipeName"
    Dim recipes As IBatchControlRecipes = BatchManager().MasterRecipes().Item("masterRecipeName", 1).ControlRecipes(tpBatchCRStateFilter.tpCRStateFilterAll)
    'Print the name of all BatchControlRecipe objects inside the BatchControlRecipes collection
    For i As Integer = 0 To recipes.Count - 1
        Me.Parent.Parent.DebugPrint(recipes.ItemByIndex(i).Name, tpDebugPrintStyle.tpMsg)
    Next
End Sub


Properties
ObjectModel COM [image] BatchControlRecipes [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the count of items in the collection of control recipes | Unused | Readonly | Available | Available


Count
ObjectModel COM [image] BatchControlRecipes [image] Properties [image] Count
Remarks

Returns the count of items in the collection of control recipes

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] BatchControlRecipes [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | ibatchrecipeid | Creates a new control recipe. Returns the Id of the new Recipe or an empty Id if no recipe could be created. | Unused | Readonly | Available | Available
GetItem | ibatchcontrolrecipe | Returns the control recipe item at the given index | Unused | Readonly | Available | Available
GetItemById | ibatchcontrolrecipe | Returns the control recipe item with the specified Id | Unused | Readonly | Available | Available
GetItemByName | ibatchcontrolrecipe | Returns the control recipe item with the specified name | Unused | Readonly | Available | Available


Create
ObjectModel COM [image] BatchControlRecipes [image] Methods [image] Create
Remarks

This method creates a new control recipe for the master recipe to which this control recipe container belongs.

Datatype
IBatchRecipeId

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
p_result as tpCRCreateResult

Example
C#
Copy
//Function to create a new control recipe
public void Macro_NewControlRecipe()
{
    //Get a the control recipes container for the master recipe for which we want to create a new control recipe
    IBatchMasterRecipe mr = BatchManager().MasterRecipes().Item("someMasterRecipe", 1);
    IBatchControlRecipes crs = mr.ControlRecipes(tpBatchCRStateFilter.tpCRStateFilterAll);

    //Create a new control recipe
    tpCRCreateResult result;    //Variable for the result code of the create operation
    IBatchRecipeId newId;       //Variable for the Id of the new control recipe
    newId = crs.Create(out result);

    //Output the result of the operation
    string output = "MrId:" + newId.MRId.ToString() +
        " CrId:" + newId.CRId.ToString() +
        " result:" + result.ToString();
    MessageBox.Show(null, output, "Create control recipe result", MessageBoxButtons.OK, MessageBoxIcon.None);
}
VB.NET
Copy
'Function to create a new control recipe
Public Sub Macro_NewControlRecipe()
    'Get a the control recipes container for the master recipe for which we want to create a new control recipe
    Dim mr As IBatchMasterRecipe = BatchManager().MasterRecipes().Item("someMasterRecipe", 1)
    Dim crs As IBatchControlRecipes = mr.ControlRecipes(tpBatchCRStateFilter.tpCRStateFilterAll)

    'Create a new control recipe
    Dim result As tpCRCreateResult
    'Variable for the result code of the create operation
    Dim newId As IBatchRecipeId
    'Variable for the Id of the new control recipe
    newId = crs.Create(result)

    'Output the result of the operation
    Dim output As String = "MrId:" & newId.MRId.ToString() & " CrId:" & newId.CRId.ToString() & " result:" & result.ToString()
    MessageBox.Show(Nothing, output, "Create control recipe result", MessageBoxButtons.OK, MessageBoxIcon.None)
End Sub
VBA
Copy
'Function to create a new control recipe
Public Sub NewControlRecipe()
    'Get a the control recipes container for the master recipe for which we want to create a new control recipe
    Dim mr As BatchMasterRecipe
    Set mr = thisProject.BatchManager.MasterRecipes.Item("someMasterRecipe", 1)
    Dim crs As BatchControlRecipes
    Set crs = mr.ControlRecipes(tpCRStateFilterAll)
    'Create a new control recipe
    Dim result As tpCRCreateResult  'Variable for the result code of the create operation
    Dim newId As BatchRecipeId      'Variable for the Id of the new control recipe
    Set newId = crs.Create(result)
    'Output the result of the operation
    Dim output As String
    output = "MrId:" & newId.MRId & " CrId:" & newId.CRId & " result:" & CStr(result)
    MsgBox (output)
End Sub


GetItem
ObjectModel COM [image] BatchControlRecipes [image] Methods [image] GetItem
Remarks

Returns the control recipe item at the given index

Datatype
IBatchControlRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lIndex as long


GetItemById
ObjectModel COM [image] BatchControlRecipes [image] Methods [image] GetItemById
Remarks

Returns the control recipe item with the specified Id

Datatype
IBatchControlRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lId as long


GetItemByName
ObjectModel COM [image] BatchControlRecipes [image] Methods [image] GetItemByName
Remarks

Returns the control recipe item with the specified name

Datatype
IBatchControlRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bstrName as BSTR


BatchControlStrategy
ObjectModel COM [image] BatchControlStrategy
Remarks

A control strategy used in batch phases. Control strategies are used to configure the command tags of a phase.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchControlStrategy [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Description | bstr | Description of the control strategy | Unused | Readonly | Available | Available
Name | bstr | Name of the control strategy | Unused | Readonly | Available | Available
Number | long | Strategy number of the control strategy | Unused | Readonly | Available | Available


Description
ObjectModel COM [image] BatchControlStrategy [image] Properties [image] Description
Remarks

Description of the control strategy.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] BatchControlStrategy [image] Properties [image] Name
Remarks

Name of the control strategy.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Number
ObjectModel COM [image] BatchControlStrategy [image] Properties [image] Number
Remarks

Strategy number of the control strategy.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchCRSelectionChangedEventData
ObjectModel COM [image] BatchCRSelectionChangedEventData
Remarks

An object of this type is passed as a parameter in the CRSelectionChangedEventstring ScreenName; Name of the Picture, in which the selection was changed

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
// instance variable for the _batchManager to register the events
private IBatchManager _batchManager;

void ThisProject_Active()
{
    _batchManager = this.BatchManager();
    // Register event
    _batchManager.CRSelectionChanged += new CRSelectionChangedEventHandler(ThisProject_CRSelectionChanged);
}

void ThisProject_Inactive()
{
    // Unregister Event
    _batchManager.CRSelectionChanged -= new CRSelectionChangedEventHandler(ThisProject_CRSelectionChanged);
}

void ThisProject_CRSelectionChanged(IBatchCRSelectionChangedEventData eventData)
{
    // Get control recipe selection for the screen in which the selection has changed
    object[] selectedCRIds = (object[])_batchManager.SelectedCRIds(eventData.ScreenName);

    // Build an output string
    string selectedCRIdsInfo = "Selected CRIds[CRId | MRId): ";
    foreach (object selectedCRId in selectedCRIds)
    {
        IBatchRecipeId crId = (IBatchRecipeId)selectedCRId;
        selectedCRIdsInfo += crId.CRId + " | " + crId.MRId + "; ";
    }

    // Write an output message
    System.Diagnostics.Debug.Print("\n" + selectedCRIdsInfo);
}
VB.NET
Copy
' instance variable for the _batchManager to register the events
Private _batchManager As IBatchManager

Private Sub ThisProject_Active()
    _batchManager = Me.BatchManager()
    ' Register event
    AddHandler _batchManager.CRSelectionChanged, AddressOf ThisProject_CRSelectionChanged
End Sub

Private Sub ThisProject_Inactive()
    ' Unregister Event
    RemoveHandler _batchManager.CRSelectionChanged, AddressOf ThisProject_CRSelectionChanged
End Sub

Private Sub ThisProject_CRSelectionChanged(eventData As IBatchCRSelectionChangedEventData)
    ' Get control recipe selection for the screen in which the selection has changed
    Dim selectedCRIds As Object() = DirectCast(_batchManager.SelectedCRIds(eventData.ScreenName), Object())

    ' Build an output string
    Dim selectedCRIdsInfo As String = "Selected CRIds[CRId | MRId): "
    For Each selectedCRId As Object In selectedCRIds
        Dim crId As IBatchRecipeId = DirectCast(selectedCRId, IBatchRecipeId)
        selectedCRIdsInfo += crId.CRId + " | " + crId.MRId & "; "
    Next

    ' Write an output message
    System.Diagnostics.Debug.Print(vbLf & selectedCRIdsInfo)
End Sub
VBA
Copy
Dim WithEvents zBatchManager As BatchManager
Private Sub Project_Active()
    'Register events
    Set zBatchManager = thisProject.BatchManager
End Sub
Private Sub Project_Inactive()
    'Unregister events
    Set zBatchManager = Nothing
End Sub

Private Sub zBatchManager_CRSelectionChanged(ByVal eventData As IBatchCRSelectionChangedEventData)
    'Get the CRs of the calling screen
    Dim selectedCRIds() As BatchRecipeId
    selectedCRIds = zBatchManager.selectedCRIds(eventData.ScreenName)
    Dim selectedCRIdsInfo As String
    selectedCRIdsInfo = "Selected CRIds[CRId | MRId): "
    'Get the CR Ids data
    For i = 0 To UBound(selectedCRIds)
        selectedCRIdsInfo = selectedCRIdsInfo & selectedCRIds(i).CRId & " | " & selectedCRIds(i).MRId & "; "
    Next i
    'Show messagebox with recipe Id
    MsgBox (selectedCRIdsInfo)
End Sub


Properties
ObjectModel COM [image] BatchCRSelectionChangedEventData [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ScreenName | bstr | Name of the screen in which the selection of the recipe list was changed | Unused | Readonly | Available | Available


ScreenName
ObjectModel COM [image] BatchCRSelectionChangedEventData [image] Properties [image] ScreenName
Remarks

Name of the Picture, in which the selection was changed

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchManager
ObjectModel COM [image] BatchManager
Remarks

Used to get the template recipe collection.

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroBatchManager()
{
    IBatchManager batchManager = this.BatchManager();
    //Get a master recipe over its index
    int mrIndex = 0;
    IBatchMasterRecipe masterRecipe = batchManager.MasterRecipes().ItemByIndex(mrIndex);

    // Get a master recipe over its ID
    int mrId = 42;
    masterRecipe = batchManager.MasterRecipes().ItemById(mrId);

    //Get the data of a master recipe over its name
    string mrName = "TestMR1";
    masterRecipe = batchManager.MasterRecipes().Item(mrName, 1);

    //Do something with the BatchMaterRecipe
}
VB.NET
Copy
Public Sub MacroBatchManager()
    Dim batchManager As IBatchManager = Me.BatchManager()
    'Get a master recipe over its index
    Dim mrIndex As Integer = 0
    Dim masterRecipe As IBatchMasterRecipe = batchManager.MasterRecipes().ItemByIndex(mrIndex)

    ' Get a master recipe over its ID
    Dim mrId As Integer = 42
    masterRecipe = batchManager.MasterRecipes().ItemById(mrId)

    'Get the data of a master recipe over its name
    Dim mrName As String = "TestMR1"
    masterRecipe = batchManager.MasterRecipes().Item(mrName, 1)

    'Do something with the BatchMaterRecipe
End Sub
VBA
Copy
Public Sub test()
// Get a master recipe over its ID
Set masterRecipe = thisProject.batchManager.MasterRecipes. ItemById (10)
//Get the data of a master recipe over its name
Set masterRecipe = thisProject.batchManager.MasterRecipes. ItemByName ("TestMR1")
//Get a master recipe over its index
Set masterRecipe = thisProject.batchManager.MasterRecipes.ItemByIndex(10)
'print text and approved time to debug window
Debug.Print ("ApprovedTime: " & masterrecipe.ApprovedTime)
End Sub


Properties
ObjectModel COM [image] BatchManager [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Config | ibatchconfig | Returns the Batch configuration | Available | Readonly | Available | Available
Project | iproject |  | Unused | Readonly | Available | Available


Config
ObjectModel COM [image] BatchManager [image] Properties [image] Config
Remarks

Returns the Batch configuration

Datatype
IBatchConfig

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Project
ObjectModel COM [image] BatchManager [image] Properties [image] Project
Remarks

Datatype
IProject

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] BatchManager [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
MasterRecipes | ibatchmasterrecipes | Returns the collection of MasterRecipes | Unused | Readonly | Available | Available
SelectedCRIds | variant | Returns the Ids of the selected control recipes | Unused | Readonly | Available | Available
SelectedMRIds | variant | Returns the Ids of the selected master recipes | Unused | Readonly | Available | Available


MasterRecipes
ObjectModel COM [image] BatchManager [image] Methods [image] MasterRecipes
Remarks

Returns the collection of MasterRecipes.

Datatype
IBatchMasterRecipes

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
/* NOTE: This example is to be seen in context of a windows forms environment and
 * will not work if such is not given.
 */

private IBatchManager _batchManager;

public BatchControlViewer(IBatchManager batchManager)
{
    _batchManager = batchManager;
    InitializeComponent();
}

private void BatchControlViewer_Load(object sender, EventArgs e)
{
    _batchManager.PhaseCommErrorEvent += new PhaseCommErrorEventEventHandler(_batchManager_PhaseCommErrorEvent);
    _batchManager.PhaseEscapeEvent += new PhaseEscapeEventEventHandler(_batchManager_PhaseEscapeEvent);
    _batchManager.PhaseExecErrorEvent += new PhaseExecErrorEventEventHandler(_batchManager_PhaseExecErrorEvent);
    _batchManager.PhaseModeChangedEvent += new PhaseModeChangedEventEventHandler(_batchManager_PhaseModeChangedEvent);
    _batchManager.PhasePlcErrorEvent += new PhasePlcErrorEventEventHandler(_batchManager_PhasePlcErrorEvent);
    _batchManager.PhaseProgressEvent += new PhaseProgressEventEventHandler(_batchManager_PhaseProgressEvent);
    _batchManager.PhaseRtEvent += new PhaseRtEventEventHandler(_batchManager_PhaseRtEvent);
    _batchManager.PhaseStateChangedEvent += new PhaseStateChangedEventEventHandler(_batchManager_PhaseStateChangedEvent);
}

void _batchManager_PhaseStateChangedEvent(IBatchStateChangedEventData eventData)
{
    AddEventTextToList("[" + eventData.Time.ToString() + "] PhaseStateChangedEvent: " + eventData.OldState + " -> " + eventData.NewState);
}

void _batchManager_PhaseRtEvent(IBatchRtEventData eventData)
{
    AddEventTextToList("[" + eventData.Time.ToString() + "] PhaseRtEvent");
}

void _batchManager_PhaseProgressEvent(IBatchProgressEventData eventData)
{
    AddEventTextToList("[" + eventData.Time.ToString() + "] PhaseProgressEvent");
}

void _batchManager_PhasePlcErrorEvent(IBatchPlcErrorEventData eventData)
{
    AddEventTextToList("[" + eventData.Time.ToString() + "] PhasePlcErrorEvent");
}

void _batchManager_PhaseModeChangedEvent(IBatchModeChangedEventData eventData)
{
    AddEventTextToList("[" + eventData.Time.ToString() + "] PhaseModeChangedEvent: " + eventData.OldMode + " -> " + eventData.NewMode);
}

void _batchManager_PhaseExecErrorEvent(IBatchExecErrorEventData eventData)
{
    AddEventTextToList("[" + eventData.Time.ToString() + "] PhaseExecErrorEvent");
}

void _batchManager_PhaseEscapeEvent(IBatchEscapeEventData eventData)
{
    AddEventTextToList("[" + eventData.Time.ToString() + "] PhaseEscapeEvent");
}

void _batchManager_PhaseCommErrorEvent(IBatchCommErrorEventData eventData)
{
    AddEventTextToList("[" + eventData.Time.ToString() + "] PhaseCommErrorEvent");
}

private void AddEventTextToList(string eventText)
{
    _listBox_events.Items.Add(eventText);
    _listBox_events.SelectedIndex = _listBox_events.Items.Count - 1;
}

private void _button_clearEventList_Click(object sender, EventArgs e)
{
    _listBox_events.Items.Clear();
}

private void _button_clearErrorList_Click(object sender, EventArgs e)
{
    _listBox_errors.Items.Clear();
}

private void _button_reloadMR_Click(object sender, EventArgs e)
{
    _dataGridView_MR.Rows.Clear();

    List<int> mrIDList = new List<int>();
    int mrCnt = _batchManager.MasterRecipes().Count;
    for (var index = 0; index < mrCnt; index++)
    {
        IBatchMasterRecipe masterRecipe_temp = _batchManager.MasterRecipes().ItemByIndex(index);
        if(masterRecipe_temp!= null)
            mrIDList.Add(Convert.ToInt32(masterRecipe_temp.ID));
    }

    List<string> mrNameList = new List<string>();
    foreach (var mrID in mrIDList)
        mrNameList.Add(_batchManager.MasterRecipes().ItemById(mrID).Name);

    foreach(string mrName in mrNameList)
    {
        IBatchMasterRecipe masterRecipe = _batchManager.MasterRecipes().ItemByName(mrName);

        _dataGridView_MR.Rows.Add(masterRecipe.ApprovedTime,
                                  masterRecipe.ApprovedUserId,
                                  masterRecipe.ApprovedUserName,
                                  masterRecipe.Description,
                                  masterRecipe.ID,
                                  masterRecipe.MrState,
                                  masterRecipe.Name,
                                  masterRecipe.OutdatedTime,
                                  masterRecipe.OutdatedUserId,
                                  masterRecipe.OutdatedUserName,
                                  masterRecipe.ReeMode,
                                  masterRecipe.ReeState,
                                  masterRecipe.Type
                                  );
    }

    Test(new Action<bool>((x) => { BatchMasterRecipe mr = new BatchMasterRecipe(); }));
    Test(new Action<bool>((x) => { new BatchMasterRecipe().ApprovedTime = DateTime.Now; }));
    Test(new Action<bool>((x) => { new BatchMasterRecipe().ApprovedUserId = "0"; }));
    Test(new Action<bool>((x) => { new BatchMasterRecipe().ApprovedUserName = "0"; }));
    Test(new Action<bool>((x) => { new BatchMasterRecipe().Description = "0"; }));
    Test(new Action<bool>((x) => { new BatchMasterRecipe().ID = 0; }));
    Test(new Action<bool>((x) => { new BatchMasterRecipe().MrState = tpBatchMrState.tpMRState_Creating; }));
    Test(new Action<bool>((x) => { new BatchMasterRecipe().Name = "0"; }));
    Test(new Action<bool>((x) => { new BatchMasterRecipe().OutdatedTime = DateTime.Now; }));
    Test(new Action<bool>((x) => { new BatchMasterRecipe().OutdatedUserId = "0"; }));
    Test(new Action<bool>((x) => { new BatchMasterRecipe().OutdatedUserName = "0"; }));
    Test(new Action<bool>((x) => { new BatchMasterRecipe().Parent = null; }));
    Test(new Action<bool>((x) => { new BatchMasterRecipe().ReeMode = tpBatchREEMode.tpRM_Automatic; }));
    Test(new Action<bool>((x) => { new BatchMasterRecipe().ReeState = tpBatchREEState.tpRS_ABORTED; }));
    Test(new Action<bool>((x) => { new BatchMasterRecipe().Type = "0"; }));
}

private void Test(Delegate d)
{
    try
    {
        d.DynamicInvoke(false);
    }
    catch (Exception ex)
    {
        _listBox_errors.Items.Add(ex.InnerException.Message + " -> " + ex.InnerException.TargetSite);
    }
}
VB.NET
Copy
' NOTE: This example is to be seen in context of a windows forms environment and
' * will not work if such is not given.
'

Private _batchManager As IBatchManager

Public Sub New(batchManager As IBatchManager)
    _batchManager = batchManager
    InitializeComponent()
End Sub

Private Sub BatchControlViewer_Load(sender As Object, e As EventArgs)
    AddHandler _batchManager.PhaseCommErrorEvent, AddressOf _batchManager_PhaseCommErrorEvent
    AddHandler _batchManager.PhaseEscapeEvent, AddressOf _batchManager_PhaseEscapeEvent
    AddHandler _batchManager.PhaseExecErrorEvent, AddressOf _batchManager_PhaseExecErrorEvent
    AddHandler _batchManager.PhaseModeChangedEvent, AddressOf _batchManager_PhaseModeChangedEvent
    AddHandler _batchManager.PhasePlcErrorEvent, AddressOf _batchManager_PhasePlcErrorEvent
    AddHandler _batchManager.PhaseProgressEvent, AddressOf _batchManager_PhaseProgressEvent
    AddHandler _batchManager.PhaseRtEvent, AddressOf _batchManager_PhaseRtEvent
    AddHandler _batchManager.PhaseStateChangedEvent, _batchManager_PhaseStateChangedEvent
End Sub

Private Sub _batchManager_PhaseStateChangedEvent(eventData As IBatchStateChangedEventData)
    AddEventTextToList("[" & eventData.Time.ToString() & "] PhaseStateChangedEvent: " & Convert.ToString(eventData.OldState) & " -> " & Convert.ToString(eventData.NewState))
End Sub

Private Sub _batchManager_PhaseRtEvent(eventData As IBatchRtEventData)
    AddEventTextToList("[" & eventData.Time.ToString() & "] PhaseRtEvent")
End Sub

Private Sub _batchManager_PhaseProgressEvent(eventData As IBatchProgressEventData)
    AddEventTextToList("[" & eventData.Time.ToString() & "] PhaseProgressEvent")
End Sub

Private Sub _batchManager_PhasePlcErrorEvent(eventData As IBatchPlcErrorEventData)
    AddEventTextToList("[" & eventData.Time.ToString() & "] PhasePlcErrorEvent")
End Sub

Private Sub _batchManager_PhaseModeChangedEvent(eventData As IBatchModeChangedEventData)
    AddEventTextToList("[" & eventData.Time.ToString() & "] PhaseModeChangedEvent: " & Convert.ToString(eventData.OldMode) & " -> " & Convert.ToString(eventData.NewMode))
End Sub

Private Sub _batchManager_PhaseExecErrorEvent(eventData As IBatchExecErrorEventData)
    AddEventTextToList("[" & eventData.Time.ToString() & "] PhaseExecErrorEvent")
End Sub

Private Sub _batchManager_PhaseEscapeEvent(eventData As IBatchEscapeEventData)
    AddEventTextToList("[" & eventData.Time.ToString() & "] PhaseEscapeEvent")
End Sub

Private Sub _batchManager_PhaseCommErrorEvent(eventData As IBatchCommErrorEventData)
    AddEventTextToList("[" & eventData.Time.ToString() & "] PhaseCommErrorEvent")
End Sub

Private Sub AddEventTextToList(eventText As String)
    _listBox_events.Items.Add(eventText)
    _listBox_events.SelectedIndex = _listBox_events.Items.Count - 1
End Sub

Private Sub _button_clearEventList_Click(sender As Object, e As EventArgs)
    _listBox_events.Items.Clear()
End Sub

Private Sub _button_clearErrorList_Click(sender As Object, e As EventArgs)
    _listBox_errors.Items.Clear()
End Sub

Private Sub _button_reloadMR_Click(sender As Object, e As EventArgs)
    _dataGridView_MR.Rows.Clear()

    Dim mrIDList As New List(Of Integer)()
    Dim mrCnt As Integer = _batchManager.MasterRecipes().Count
    For index As var = 0 To mrCnt - 1
        Dim masterRecipe_temp As IBatchMasterRecipe = _batchManager.MasterRecipes().ItemByIndex(index)
        If masterRecipe_temp IsNot Nothing Then
            mrIDList.Add(Convert.ToInt32(masterRecipe_temp.ID))
        End If
    Next

    Dim mrNameList As New List(Of String)()
    For Each mrID As var In mrIDList
        mrNameList.Add(_batchManager.MasterRecipes().ItemById(mrID).Name)
    Next

    For Each mrName As String In mrNameList
        Dim masterRecipe As IBatchMasterRecipe = _batchManager.MasterRecipes().ItemByName(mrName)

        _dataGridView_MR.Rows.Add(masterRecipe.ApprovedTime, masterRecipe.ApprovedUserId, masterRecipe.ApprovedUserName, masterRecipe.Description, masterRecipe.ID, masterRecipe.MrState, _
            masterRecipe.Name, masterRecipe.OutdatedTime, masterRecipe.OutdatedUserId, masterRecipe.OutdatedUserName, masterRecipe.ReeMode, masterRecipe.ReeState, _
            masterRecipe.Type)
    Next
End Sub


SelectedCRIds
ObjectModel COM [image] BatchManager [image] Methods [image] SelectedCRIds
Remarks

Gets all the id's of the selected control recipes in the recipelist in the „bstrScreenName". If a Batchscreen ist found a BatchRecipeId [] is returned with the id's of the selected control recipes.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bstrScreenName as BSTR

Example
C#
Copy
void ThisProject_Active()
{
      //When a element ist clicked a event is fired

this.DynPictures().ElementLeftButtonDown += new ElementLeftButtonDownEventHandler(ThisProject_ElementLeftButtonDown);
}

void ThisProject_ElementLeftButtonDown(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
      //Get the current name of the screen

currentPictureName = obDynPicture.Name;
}

void ThisProject_Inactive()
{

this.DynPictures().ElementLeftButtonDown -= new ElementLeftButtonDownEventHandler(ThisProject_ElementLeftButtonDown);

FreeObjects();
}

#region Macros (Add macros in this region)

publicvoid Macro_ShowSelectedRecipes()
{

if (currentPictureName == "")

return;

      //Definition of the selected recipe Ids buffers

int[] selectedMRIds =(int[])this.BatchManager().SelectedMRIds(currentPictureName);

object[] selectedCRIds = (object[])this.BatchManager().SelectedCRIds(currentPictureName);

     //Get MR Ids data

string selectedMRIdsInfo = "Selected MRIds: ";

foreach (int selectedMRId in selectedMRIds)

selectedMRIdsInfo += selectedMRId + "; ";

//Get CR Ids data

string selectedCRIdsInfo = "Selected CRIds[CRId | MRId): ";

foreach (object selectedCRId in selectedCRIds)

{

IBatchRecipeId crId = (IBatchRecipeId)selectedCRId;

selectedCRIdsInfo += crId.CRId + " | " + crId.MRId + "; ";

}

      //Show messagebox with selected recipe Ids

MessageBox.Show(null, selectedMRIdsInfo + "\n" + selectedCRIdsInfo, "Selected Recipe Ids", MessageBoxButtons.OK, MessageBoxIcon.None);
}

#endregion
VBA
Copy
Public Sub ShowSelectedRecipes()
 'Definition of the screen name
    Dim dynPictureName As String
    dynPictureName = "MainWindow"
 'Get the MRs of the calling screen
    Dim selectedMRIds() As Long
    selectedMRIds = thisProject.BatchManager.selectedMRIds(dynPictureName)
  'Get the CRs of the calling screen
    Dim selectedCRIds() As BatchRecipeId
    selectedCRIds = thisProject.BatchManager.selectedCRIds(dynPictureName)
    Dim selectedMRIdsInfo As String
    selectedMRIdsInfo = "Selected MRIds: "
 'Get the MR Ids data
    For i = 0 To UBound(selectedMRIds)
        selectedMRIdsInfo = selectedMRIdsInfo & selectedMRIds(i) & "; "
    Next i
    selectedMRIdsInfo = selectedMRIdsInfo & vbCrLf
    Dim selectedCRIdsInfo As String
    selectedCRIdsInfo = "Selected CRIds[CRId | MRId): "
  'Get the CR Ids data
    For i = 0 To UBound(selectedCRIds)
        selectedCRIdsInfo = selectedCRIdsInfo & selectedCRIds(i).CRId & " | " & selectedCRIds(i).MRId & "; "
    Next i
    'Show messagebox with selected recipe Ids
    MsgBox (selectedMRIdsInfo + selectedCRIdsInfo)
End Sub


SelectedMRIds
ObjectModel COM [image] BatchManager [image] Methods [image] SelectedMRIds
Remarks

Gets all the id's of the selected recipes in the recipelist in the „bstrScreenName". If a Batchscreen ist found a INT [] is returned with the id's of the selected recipes.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bstrScreenName as BSTR

Example
C#
Copy
void ThisProject_Active()
{
      //When a element ist clicked a event is fired
      this.DynPictures().ElementLeftButtonDown += new ElementLeftButtonDownEventHandler(ThisProject_ElementLeftButtonDown);
}

void ThisProject_ElementLeftButtonDown(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
      //Get the current name of the screen
      currentPictureName = obDynPicture.Name;
}

void ThisProject_Inactive()
{
      this.DynPictures().ElementLeftButtonDown -= new ElementLeftButtonDownEventHandler(ThisProject_ElementLeftButtonDown);
      FreeObjects();
}

#region Macros (Add macros in this region)

public void Macro_ShowSelectedRecipes()
{
      if (currentPictureName == "")
            return;

      //Definition of the selected recipe Ids buffers
      int[] selectedMRIds =(int[])this.BatchManager().SelectedMRIds(currentPictureName);
      object[] selectedCRIds = (object[])this.BatchManager().SelectedCRIds(currentPictureName);

     //Get MR Ids data
      string selectedMRIdsInfo = "Selected MRIds: ";
      foreach (int selectedMRId in selectedMRIds)
            selectedMRIdsInfo += selectedMRId + "; ";

                //Get CR Ids data
      string selectedCRIdsInfo = "Selected CRIds[CRId | MRId): ";
      foreach (object selectedCRId in selectedCRIds)
      {
            IBatchRecipeId crId = (IBatchRecipeId)selectedCRId;
            selectedCRIdsInfo += crId.CRId + " | " + crId.MRId + "; ";
      }

      //Show messagebox with selected recipe Ids
      MessageBox.Show(null, selectedMRIdsInfo + "\n" + selectedCRIdsInfo, "Selected Recipe Ids", MessageBoxButtons.OK, MessageBoxIcon.None);
}

#endregion
VB.NET
Copy
Private Sub ThisProject_Active()
    'When a element ist clicked a event is fired
    AddHandler Me.DynPictures().ElementLeftButtonDown, AddressOf ThisProject_ElementLeftButtonDown
End Sub

Private Sub ThisProject_ElementLeftButtonDown(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Get the current name of the screen
    currentPictureName = obDynPicture.Name
End Sub

Private Sub ThisProject_Inactive()
    RemoveHandler Me.DynPictures().ElementLeftButtonDown, AddressOf ThisProject_ElementLeftButtonDown
    FreeObjects()
End Sub

#Region "Macros (Add macros in this region)"

Public Sub Macro_ShowSelectedRecipes()
    If currentPictureName = "" Then
        Return
    End If

    'Definition of the selected recipe Ids buffers
    Dim selectedMRIds As Integer() = DirectCast(Me.BatchManager().SelectedMRIds(currentPictureName), Integer())
    Dim selectedCRIds As Object() = DirectCast(Me.BatchManager().SelectedCRIds(currentPictureName), Object())

    'Get MR Ids data
    Dim selectedMRIdsInfo As String = "Selected MRIds: "
    For Each selectedMRId As Integer In selectedMRIds
        selectedMRIdsInfo += selectedMRId & "; "
    Next

    'Get CR Ids data
    Dim selectedCRIdsInfo As String = "Selected CRIds[CRId | MRId): "
    For Each selectedCRId As Object In selectedCRIds
        Dim crId As IBatchRecipeId = DirectCast(selectedCRId, IBatchRecipeId)
        selectedCRIdsInfo += crId.CRId + " | " + crId.MRId & "; "
    Next

    'Show messagebox with selected recipe Ids
    MessageBox.Show(Nothing, selectedMRIdsInfo & vbLf & selectedCRIdsInfo, "Selected Recipe Ids", MessageBoxButtons.OK, MessageBoxIcon.None)
End Sub

#End Region
VBA
Copy
Public Sub ShowSelectedRecipes()
 'Definition of the screen name
    Dim dynPictureName As String
    dynPictureName = "MainWindow"
 'Get the MRs of the calling screen
    Dim selectedMRIds() As Long
    selectedMRIds = thisProject.BatchManager.selectedMRIds(dynPictureName)
  'Get the CRs of the calling screen
    Dim selectedCRIds() As BatchRecipeId
    selectedCRIds = thisProject.BatchManager.selectedCRIds(dynPictureName)
    Dim selectedMRIdsInfo As String
    selectedMRIdsInfo = "Selected MRIds: "
 'Get the MR Ids data
    For i = 0 To UBound(selectedMRIds)
        selectedMRIdsInfo = selectedMRIdsInfo & selectedMRIds(i) & "; "
    Next i
    selectedMRIdsInfo = selectedMRIdsInfo & vbCrLf
    Dim selectedCRIdsInfo As String
    selectedCRIdsInfo = "Selected CRIds[CRId | MRId): "
  'Get the CR Ids data
    For i = 0 To UBound(selectedCRIds)
        selectedCRIdsInfo = selectedCRIdsInfo & selectedCRIds(i).CRId & " | " & selectedCRIds(i).MRId & "; "
    Next i
    'Show messagebox with selected recipe Ids
    MsgBox (selectedMRIdsInfo + selectedCRIdsInfo)
End Sub


Events
ObjectModel COM [image] BatchManager [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ControlRecipePhaseEdited | void | Event is fired when a phase in a control recipe gets edited | Unused | Readonly | Available | Available
CRSelectionChanged | void | Event is fired when the selection in a Control Recipe List is changed | Unused | Readonly | Available | Available
MRSelectionChanged | void | Event is fired when the selection in a Master Recipe List is changed | Unused | Readonly | Available | Available
PhaseCommunicationError | void | Event is fired when the communication error state of a phase is changed | Unused | Readonly | Available | Available
PhaseEscape | void | Event is fired when the escape state of a phase is changed | Unused | Readonly | Available | Available
PhaseExecutionError | void | Event is fired when an execution error occures in a phase (Timeouts, etc.) | Unused | Readonly | Available | Available
PhaseModeChanged | void | Event is fired when the execution mode of a phase is changed | Unused | Readonly | Available | Available
PhasePlcError | void | Event is fired when the plc error state of a phase is changed | Unused | Readonly | Available | Available
PhaseProgress | void | Event is fired when there is a significant change to the internal State of a phase in during execution | Unused | Readonly | Available | Available
PhaseRuntimeEvent | void | Event is fired when runtime events are triggered during the execution of a phase | Unused | Readonly | Available | Available
PhaseStateChanged | void | Event is fired when the execution state of a phase is changed | Unused | Readonly | Available | Available
RecipeModeChanged | void | Event is fired when the execution mode of a recipe is changed | Unused | Readonly | Available | Available
RecipeStateChanged | void | Event is fired when the execution state of a recipe is changed | Unused | Readonly | Available | Available


ControlRecipePhaseEdited
ObjectModel COM [image] BatchManager [image] Events [image] ControlRecipePhaseEdited
Remarks

The event gets fired, when a phase in a control recipe is edited. The eventData object contains all information about the change that was made.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
eventData as IBatchControlRecipePhaseEditedEventData

Example
C#
Copy
void ThisProject_Active()
{
    //Check in the ControlRecipePhaseEdited Event
    BatchManager().ControlRecipePhaseEdited += new ControlRecipePhaseEditedEventHandler(ThisProject_ControlRecipePhaseEdited);
}

void ThisProject_ControlRecipePhaseEdited(IBatchControlRecipePhaseEditedEventData eventData)
{
    //Get the ID of the changed tags from the event data changes collection
    string additionalInformation = "Changes[Tag-ID]: ";

    for (var index = 0; index < eventData.Changes.TagIdCount; index++)
    {
        additionalInformation += "" + eventData.Changes.TagIdByIndex(index) + "; ";
    }

    additionalInformation += "   --   Comment:\"" + eventData.Comment + "\"";

    //Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] Control Recipe Edited. >> " + additionalInformation);
}

void ThisProject_Inactive()
{
    //Check out the ControlRecipePhaseEdited Event
    BatchManager().ControlRecipePhaseEdited -= ThisProject_ControlRecipePhaseEdited;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    'Check in the ControlRecipePhaseEdited Event
    AddHandler BatchManager().ControlRecipePhaseEdited, AddressOf ThisProject_ControlRecipePhaseEdited
End Sub

Private Sub ThisProject_ControlRecipePhaseEdited(eventData As IBatchControlRecipePhaseEditedEventData)
    'Get the ID of the changed tags from the event data changes collection
    Dim additionalInformation As String = "Changes[Tag-ID]: "

    For index As var = 0 To eventData.Changes.TagIdCount - 1
        additionalInformation += "" & eventData.Changes.TagIdByIndex(index) & "; "
    Next

    additionalInformation += "   --   Comment:""" & Convert.ToString(eventData.Comment) & """"

    'Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] Control Recipe Edited. >> " & additionalInformation)
End Sub

Private Sub ThisProject_Inactive()
    'Check out the ControlRecipePhaseEdited Event
    RemoveHandler BatchManager().ControlRecipePhaseEdited, AddressOf ThisProject_ControlRecipePhaseEdited

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub


CRSelectionChanged
ObjectModel COM [image] BatchManager [image] Events [image] CRSelectionChanged
Remarks

This event is fired when the selection in the screen element control recipe list changes.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
eventData as IBatchCRSelectionChangedEventData

Example
C#
Copy
// local variable for the batchManager to register the events
private IBatchManager batchManager = null;

void ThisProject_Active()
        {
// Register event
            batchManager.CRSelectionChanged += new CRSelectionChangedEventHandler(ThisProject_CRSelectionChanged);
        }

void ThisProject_Inactive()
        {
// unregister Event
            batchManager.CRSelectionChanged -= new CRSelectionChangedEventHandler(ThisProject_CRSelectionChanged);
        }

void ThisProject_CRSelectionChanged(IBatchCRSelectionChangedEventData eventData)
        {
// Get control recipe selection for the screen in which the selection has changed
object[] selectedCRIds = (object[])batchManager.SelectedCRIds(eventData.ScreenName);

// Build an output string
string selectedCRIdsInfo = "Selected CRIds[CRId | MRId): ";
foreach (object selectedCRId in selectedCRIds)
            {
                IBatchRecipeId crId = (IBatchRecipeId)selectedCRId;
                selectedCRIdsInfo += crId.CRId + " | " + crId.MRId + "; ";
            }

// Write an output message
            System.Diagnostics.Debug.Print("\n" + selectedCRIdsInfo);
        }
VBA
Copy
Dim WithEvents zBatchManager As BatchManager
Private Sub Project_Active()
    'Register events
    Set zBatchManager = thisProject.BatchManager
End Sub
Private Sub Project_Inactive()
    'Unregister events
    Set zBatchManager = Nothing
End Sub

Private Sub zBatchManager_CRSelectionChanged(ByVal eventData As IBatchCRSelectionChangedEventData)
    'Get the CRs of the calling screen
    Dim selectedCRIds() As BatchRecipeId
    selectedCRIds = zBatchManager.selectedCRIds(eventData.ScreenName)
    Dim selectedCRIdsInfo As String
    selectedCRIdsInfo = "Selected CRIds[CRId | MRId): "
    'Get the CR Ids data
    For i = 0 To UBound(selectedCRIds)
        selectedCRIdsInfo = selectedCRIdsInfo & selectedCRIds(i).CRId & " | " & selectedCRIds(i).MRId & "; "
    Next i
    'Show messagebox with recipe Id
    MsgBox (selectedCRIdsInfo)
End Sub


MRSelectionChanged
ObjectModel COM [image] BatchManager [image] Events [image] MRSelectionChanged
Remarks

This event is fired when the selection in the screen element master recipe list changes.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
eventData as IBatchMRSelectionChangedEventData

Example
C#
Copy
// local variable for the batchManager to register the events
private IBatchManager batchManager = null;

void ThisProject_Active()
        {
// Register event
            batchManager.MRSelectionChanged += new MRSelectionChangedEventHandler(ThisProject_MRSelectionChanged);
        }
void ThisProject_Inactive()
        {
// unregister Event
            batchManager.MRSelectionChanged -= new MRSelectionChangedEventHandler(ThisProject_MRSelectionChanged);
        }

void ThisProject_MRSelectionChanged(IBatchMRSelectionChangedEventData eventData)
        {
// Get master recipe selection for the screen in which the selection has changed
int[] selectedMRIds = (int[])batchManager.SelectedMRIds(eventData.ScreenName);

// Build an output string
string selectedMRIdsInfo = "Selected MRIds: ";
foreach (int selectedMRId in selectedMRIds)
                selectedMRIdsInfo += selectedMRId + "; ";

// Write an output message
            System.Diagnostics.Debug.Print("\n" + selectedMRIdsInfo);
        }
VBA
Copy
Dim WithEvents zBatchManager As BatchManager
Private Sub Project_Active()
    'Register events
    Set zBatchManager = thisProject.BatchManager
End Sub
Private Sub Project_Inactive()
    'Unregister events
    Set zBatchManager = Nothing
End Sub
Private Sub zBatchManager_MRSelectionChanged(ByVal eventData As IBatchMRSelectionChangedEventData)
    'Get the MRs of the calling screen
    Dim selectedMRIds() As Long
    selectedMRIds = zBatchManager.selectedMRIds(eventData.ScreenName)
    Dim selectedMRIdsInfo As String
    selectedMRIdsInfo = "Selected MRIds: "
    'Get the MR Ids data
    For i = 0 To UBound(selectedMRIds)
        selectedMRIdsInfo = selectedMRIdsInfo & selectedMRIds(i) & "; "
    Next i
    'Show messagebox with recipe Ids
    MsgBox (selectedMRIdsInfo)
End Sub


PhaseCommunicationError
ObjectModel COM [image] BatchManager [image] Events [image] PhaseCommunicationError
Remarks

Fired in case of a communication error, or the communication state changes.List of events:

  • Loss of communication
  • Loss of communication fixed
  • Loss of communication acknowledged

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
eventData as IBatchPhaseCommunicationErrorEventData

Example
C#
Copy
void ThisProject_Active()
{
    //Check in the PhaseCommunicationError Event
    BatchManager().PhaseCommunicationError += new PhaseCommunicationErrorEventHandler(
    ThisProject_PhaseCommunicationError);
}

void ThisProject_PhaseCommunicationError(IBatchPhaseCommunicationErrorEventData eventData)
{
    //Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseCommunicationError: " + eventData.CommunicationErrorState);
}

void ThisProject_Inactive()
{
    //Check out the PhaseCommunicationError Event
    BatchManager().PhaseCommunicationError -= ThisProject_PhaseCommunicationError;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    'Check in the PhaseCommunicationError Event
    AddHandler BatchManager().PhaseCommunicationError, AddressOf ThisProject_PhaseCommunicationError
End Sub

Private Sub ThisProject_PhaseCommunicationError(eventData As IBatchPhaseCommunicationErrorEventData)
    'Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] PhaseCommunicationError: " & Convert.ToString(eventData.CommunicationErrorState))
End Sub

Private Sub ThisProject_Inactive()
    'Check out the PhaseCommunicationError Event
    RemoveHandler BatchManager().PhaseCommunicationError, AddressOf ThisProject_PhaseCommunicationError

    'Final release and garbage collection of any API-Objects.
    FreeObjects
End Sub
VBA
Copy
Dim WithEvents zBatchManager As batchManager
'procedure is executed on startup of the zenOn runtime
Private Sub Project_Active()
'init the Batchmanager object for events
    Set zBatchManager = thisProject.batchManager
End Sub
'procedure is executed on terminating the zenOn Runtime
Private Sub Project_Inactive()
'free the batchmanager object
    Set zBatchManager = Nothing
End Sub
'procedure is executed when a active phase gets a communication error or the error state gets changed
Private Sub zBatchManager_PhaseCommunicationError(ByVal eventData As IBatchPhaseCommunicationErrorEventData)
    'print time and specific information to debug window
    Debug.Print (eventData.Time & " VBA-Event: Communication error")
End Sub


PhaseEscape
ObjectModel COM [image] BatchManager [image] Events [image] PhaseEscape
Remarks

Fired when closing/leaving a phase.List of events:

  • Escape condition started
  • Escape condition fulfilled

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
eventData as IBatchPhaseEscapeEventData

Example
C#
Copy
void ThisProject_Active()
{
    //Check in the PhaseEscape Event
    BatchManager().PhaseEscape += new PhaseEscapeEventHandler(
    ThisProject_PhaseEscape);
}

void ThisProject_PhaseEscape (IBatchPhaseEscapeEventData eventData)
{
    //Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseEscape: "
    + eventData.EscapeState);
}

void ThisProject_Inactive()
{
    //Check out the PhaseEscape Event
    BatchManager().PhaseEscape -= ThisProject_PhaseEscape;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    'Check in the PhaseEscape Event
    AddHandler BatchManager().PhaseEscape, AddressOf ThisProject_PhaseEscape
End Sub

Private Sub ThisProject_PhaseEscape(eventData As IBatchPhaseEscapeEventData)
    'Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseEscape: " + eventData.EscapeState)
End Sub

Private Sub ThisProject_Inactive()
    'Check out the PhaseEscape Event
    RemoveHandler BatchManager().PhaseEscape, AddressOf ThisProject_PhaseEscape

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub
VBA
Copy
Dim WithEvents zBatchManager As batchManager
'procedure is executed on startup of the zenOn runtime
Private Sub Project_Active()
'init the Batchmanager object for events
    Set zBatchManager = thisProject.batchManager
End Sub
'procedure is executed on terminating the zenOn Runtime
Private Sub Project_Inactive()
'free the batchmanager object
    Set zBatchManager = Nothing
End Sub
'procedure is executed when a phase gets or is escaped
Private Sub zBatchManager_PhaseEscape(ByVal eventData As IBatchPhaseEscapeEventData)
    'print time and specific information to debug window
    Debug.Print (eventData.Time & " VBA-Event: Escape")
End Sub


PhaseExecutionError
ObjectModel COM [image] BatchManager [image] Events [image] PhaseExecutionError
Remarks

Fired when execution error occurs.List of events:

  • Phase started multiple times
  • Waiting period unit allocation exceeded
  • Waiting period input interlocking exceeded
  • Command tag without value

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
eventData as IBatchPhaseExecutionErrorEventData

Example
C#
Copy
void ThisProject_Active()
{
    //Check in the PhaseExecutionError Event
    BatchManager().PhaseExecutionError += new PhaseExecutionErrorEventHandler(
    ThisProject_PhaseExecutionError);
}

void ThisProject_PhaseExecutionError(IBatchPhaseExecutionErrorEventData eventData)
{
    //Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseExecutionError: " + eventData.ExecutionErrorState);
}

void ThisProject_Inactive()
{
    //Check out the PhaseExecutionError Event
    BatchManager().PhaseExecutionError -= ThisProject_PhaseExecutionError;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    'Check in the PhaseExecutionError Event
    AddHandler BatchManager().PhaseExecutionError, AddressOf ThisProject_PhaseExecutionError
End Sub

Private Sub ThisProject_PhaseExecutionError(eventData As IBatchPhaseExecutionErrorEventData)
    'Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] PhaseExecutionError: " & Convert.ToString(eventData.ExecutionErrorState))
End Sub

Private Sub ThisProject_Inactive()
    'Check out the PhaseExecutionError Event
    RemoveHandler BatchManager().PhaseExecutionError, AddressOf ThisProject_PhaseExecutionError

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub
VBA
Copy
Dim WithEvents zBatchManager As batchManager
'procedure is executed on startup of the zenOn runtime
Private Sub Project_Active()
'init the batchmanager object for events
    Set zBatchManager = thisProject.batchManager
End Sub
'procedure is executed on terminating the zenOn Runtime
Private Sub Project_Inactive()
'free the batchmanager object
    Set zBatchManager = Nothing
End Sub
'procedure is executed when a phase gets an error
Private Sub zBatchManager_PhaseExecutionError(ByVal eventData As IBatchPhaseExecutionErrorEventData)
    'print time and specific information to debug window
    Debug.Print (eventData.Time & " VBA-Event: Execution Error")
End Sub


PhaseModeChanged
ObjectModel COM [image] BatchManager [image] Events [image] PhaseModeChanged
Remarks

Fired when a execution mode changes (manual, semi-automatic, automatic), during a active phase.List of events

  • REE mode change: automatic
  • REE mode change: semi-automatic
  • REE mode change: manual

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
eventData as IBatchPhaseModeChangedEventData

Example
C#
Copy
void ThisProject_Active()
{
    //Check in the PhaseModeChanged Event
    BatchManager().PhaseModeChanged += new PhaseModeChangedEventHandler(ThisProject_PhaseModeChanged);
}

void ThisProject_PhaseModeChanged(IBatchPhaseModeChangedEventData eventData)
{
    //Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseModeChanged: " + eventData.OldExecutionMode + " -> " + eventData.NewExecutionMode);
}

void ThisProject_Inactive()
{
    //Check out the PhaseModeChanged Event
    BatchManager().PhaseModeChanged -= ThisProject_PhaseModeChanged;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    'Check in the PhaseModeChanged Event
    AddHandler BatchManager().PhaseModeChanged, AddressOf ThisProject_PhaseModeChanged
End Sub

Private Sub ThisProject_PhaseModeChanged(eventData As IBatchPhaseModeChangedEventData)
    'Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] PhaseModeChanged: " & Convert.ToString(eventData.OldExecutionMode) & " -> " & Convert.ToString(eventData.NewExecutionMode))
End Sub

Private Sub ThisProject_Inactive()
    'Check out the PhaseModeChanged Event
    RemoveHandler BatchManager().PhaseModeChanged, AddressOf ThisProject_PhaseModeChanged

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub
VBA
Copy
Dim WithEvents zBatchManager As batchManager
'procedure is executed on startup of the zenOn runtime
Private Sub Project_Active()
'init the Batchmanager object for events
    Set zBatchManager = thisProject.batchManager
End Sub
'procedure is executed on terminating the zenOn Runtime
Private Sub Project_Inactive()
'free the batchmanager object
    Set zBatchManager = Nothing
End Sub
'procedure is executed when the execution mode gets changed while a phase is active
Private Sub zBatchManager_PhaseModeChanged(ByVal eventData As IBatchPhaseModeChangedEventData)
    'print time and specific information to debug window
    Debug.Print (eventData.Time & " VBA-Event: Phase Mode changed")
End Sub


PhasePlcError
ObjectModel COM [image] BatchManager [image] Events [image] PhasePlcError
Remarks

Fired when a plc error enters or leaves.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
eventData as IBatchPhasePlcErrorEventData

Example
C#
Copy
void ThisProject_Active()
{
    //Check in the PhasePlcError Event
    BatchManager().PhasePlcError += new PhasePlcErrorEventHandler(
    ThisProject_PhasePlcError);
}

void ThisProject_PhasePlcError(IBatchPhasePlcErrorEventData eventData)
{
    //Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhasePlcError: " + eventData.PlcErrorState);
}

void ThisProject_Inactive()
{
    //Check out the PhasePlcError Event
    BatchManager().PhasePlcError -= ThisProject_PhasePlcError;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    'Check in the PhasePlcError Event
    AddHandler BatchManager().PhasePlcError, AddressOf ThisProject_PhasePlcError
End Sub

Private Sub ThisProject_PhasePlcError(eventData As IBatchPhasePlcErrorEventData)
    'Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] PhasePlcError: " & Convert.ToString(eventData.PlcErrorState))
End Sub

Private Sub ThisProject_Inactive()
    'Check out the PhasePlcError Event
    RemoveHandler BatchManager().PhasePlcError, AddressOf ThisProject_PhasePlcError

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub
VBA
Copy
Dim WithEvents zBatchManager As batchManager
'procedure is executed on startup of the zenOn runtime
Private Sub Project_Active()
'init the Batchmanager object for events
    Set zBatchManager = thisProject.batchManager
End Sub
'procedure is executed on terminating the zenOn Runtime
Private Sub Project_Inactive()
'free the batchmanager object
    Set zBatchManager = Nothing
End Sub
'procedure is executed when the PLC gets an error or the error is gone while a phase is active
Private Sub zBatchManager_PhasePlcError(ByVal eventData As IBatchPhasePlcErrorEventData)
    'print time and specific information to debug window
    Debug.Print (eventData.Time & " VBA-Event: PLC error")
End Sub


PhaseProgress
ObjectModel COM [image] BatchManager [image] Events [image] PhaseProgress
Remarks

Is fired when the phase progress changes.List of events:

  • Phase activated
  • Unit allocation not possible
  • Phase started
  • Input interlocking blocked
  • Waiting period unit allocation exceeded
  • Waiting period input interlocking exceeded
  • Finished writing command tags
  • Maximum waiting period phase done condition exceeded
  • Phase done condition completed
  • Phase deactivated
IBatchPhaseProgressEventData contains a enum property which contains the event type.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
eventData as IBatchPhaseProgressEventData

Example
C#
Copy
void ThisProject_Active()
{
    //Check in the PhaseProgress Event
    BatchManager().PhaseProgress += new PhaseProgressEventHandler(
    ThisProject_PhaseProgress);
}

void ThisProject_PhaseProgress(IBatchPhaseProgressEventData eventData)
{
    //Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseProgress: " + eventData.PhaseState);
}

void ThisProject_Inactive()
{
    //Check out the PhaseProgress Event
    BatchManager().PhaseProgress -= ThisProject_PhaseProgress;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    'Check in the PhaseProgress Event
    AddHandler BatchManager().PhaseProgress, AddressOf ThisProject_PhaseProgress
End Sub

Private Sub ThisProject_PhaseProgress(eventData As IBatchPhaseProgressEventData)
    'Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] PhaseProgress: " & Convert.ToString(eventData.PhaseState))
End Sub

Private Sub ThisProject_Inactive()
    'Check out the PhaseProgress Event
    RemoveHandler BatchManager().PhaseProgress, AddressOf ThisProject_PhaseProgress

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub
VBA
Copy
Dim WithEvents zBatchManager As batchManager
'procedure is executed on startup of the zenOn runtime
Private Sub Project_Active()
'init the Batchmanager object for events
    Set zBatchManager = thisProject.batchManager
End Sub
'procedure is executed on terminating the zenOn Runtime
Private Sub Project_Inactive()
'free the batchmanager object
    Set zBatchManager = Nothing
End Sub
'procedure is executed when a phase is in progress
Private Sub zBatchManager_PhaseProgress(ByVal eventData As IBatchPhaseProgressEventData)
    'print time and specific information to debug window
    Debug.Print (eventData.Time & " VBA-Event: Phase in Progress")
End Sub


PhaseRuntimeEvent
ObjectModel COM [image] BatchManager [image] Events [image] PhaseRuntimeEvent
Remarks

Fired when closing or restarting the runtime, during a active phase.List of events:

  • Runtime closing
  • Runtime restart

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
eventData as IBatchPhaseRuntimeEventData

Example
C#
Copy
void ThisProject_Active()
{
    //Check in the PhaseRuntime Event
    BatchManager().PhaseRuntimeEvent += new PhaseRuntimeEventEventHandler(
    ThisProject_PhaseRuntimeEvent);
}

void ThisProject_PhaseRuntimeEvent(IBatchPhaseRuntimeEventData eventData)
{
    //Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseRuntimeEvent: "
    + eventData.RuntimeEvent);
}

void ThisProject_Inactive()
{
    //Check out the PhaseRuntime Event
    BatchManager().PhaseRuntimeEvent -= ThisProject_PhaseRuntimeEvent;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    'Check in the PhaseRuntime Event
    AddHandler BatchManager().PhaseRuntimeEvent, AddressOf ThisProject_PhaseRuntimeEvent
End Sub

Private Sub ThisProject_PhaseRuntimeEvent(eventData As IBatchPhaseRuntimeEventData)
    'Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseRuntimeEvent: " + eventData.RuntimeEvent)
End Sub

Private Sub ThisProject_Inactive()
    'Check out the PhaseRuntime Event
    RemoveHandler BatchManager().PhaseRuntimeEvent, AddressOf ThisProject_PhaseRuntimeEvent

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub
VBA
Copy
Dim WithEvents zBatchManager As batchManager
'procedure is executed on startup of the zenOn runtime
Private Sub Project_Active()
'init the Batchmanager object for events
    Set zBatchManager = thisProject.batchManager
End Sub
'procedure is executed on terminating the zenOn Runtime
Private Sub Project_Inactive()
'free the batchmanager object
    Set zBatchManager = Nothing
End Sub
'procedure is executed when the RT gets started or closed while a phase is active
Private Sub zBatchManager_PhaseRuntimeEvent(ByVal eventData As IBatchPhaseRuntimeEventData)
    'print time and specific information to debug window
    Debug.Print (eventData.Time & " VBA-Event: RT event")
End Sub


PhaseStateChanged
ObjectModel COM [image] BatchManager [image] Events [image] PhaseStateChanged
Remarks

Fired when the phase state changes (running, paused, etc...).List of displayed execution events:

  • State change: In execution
  • State change: Pausing
  • State change: Paused
  • State change:Finished
  • State change: Restart
  • State change: Holding
  • State change: Held
  • State change: Stopping
  • State change: Stopped
  • State change: Aborting
  • State change: Aborted
  • State change: Continue

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
eventData as IBatchPhaseStateChangedEventData

Example
C#
Copy
void ThisProject_Active()
{
    //Check in the PhaseStateChanged Event
    BatchManager().PhaseStateChanged += new PhaseStateChangedEventHandler(
    ThisProject_PhaseStateChanged);
}

void ThisProject_PhaseStateChanged(IBatchPhaseStateChangedEventData eventData)
{
    //Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseStateChanged: " + eventData.OldSExecutiontate + " -> " + eventData.NewExecutionState);
}

void ThisProject_Inactive()
{
    //Check out the PhaseStateChanged Event
    BatchManager().PhaseStateChanged -= ThisProject_PhaseStateChanged;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    'Check in the PhaseStateChanged Event
    AddHandler BatchManager().PhaseStateChanged, AddressOf ThisProject_PhaseStateChanged
End Sub

Private Sub ThisProject_PhaseStateChanged(eventData As IBatchPhaseStateChangedEventData)
    'Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] PhaseStateChanged: " & Convert.ToString(eventData.OldSExecutiontate) & " -> " & Convert.ToString(eventData.NewExecutionState))
End Sub

Private Sub ThisProject_Inactive()
    'Check out the PhaseStateChanged Event
    RemoveHandler BatchManager().PhaseStateChanged, AddressOf ThisProject_PhaseStateChanged

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub
VBA
Copy
Dim WithEvents zBatchManager As batchManager
'procedure is executed on startup of the zenOn runtime
Private Sub Project_Active()
'init the Batchmanager object for events
    Set zBatchManager = thisProject.batchManager
End Sub
'procedure is executed on terminating the zenOn Runtime
Private Sub Project_Inactive()
'free the batchmanager object
    Set zBatchManager = Nothing
End Sub
'procedure is executed when the state of the phase gets changed
Private Sub zBatchManager_PhaseStateChanged(ByVal eventData As IBatchPhaseStateChangedEventData)
    'print time and specific information to debug window
    Debug.Print (eventData.Time & " Phase state changed")
End Sub


RecipeModeChanged
ObjectModel COM [image] BatchManager [image] Events [image] RecipeModeChanged
Remarks

This event is fired if the execution mode of a recipe is changed during its execution. Additionally it is fired once at the start of the recipe with the initial mode as old and as new mode.Changes to the execution mode that cause this event:

  • Mode Change: automatic
  • Mode Change: semi-automatic
  • Mode Change: manual

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
eventData as IBatchRecipeModeChangedEventData

Example
C#
Copy
void ThisProject_Active()
{
    //Check in the RecipeModeChanged Event
    BatchManager().RecipeModeChanged += new RecipeModeChangedEventHandler (
    ThisProject_RecipeModeChanged);
}

void ThisProject_RecipeModeChanged(IBatchRecipeModeChangedEventData eventData)
{
    //Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] RecipeModeChanged: " + eventData.OldExecutionMode + " -> " + eventData.NewExecutionMode);
}

void ThisProject_Inactive()
{
    //Check out the RecipeModeChanged Event
    BatchManager().RecipeModeChanged -= ThisProject_RecipeModeChanged;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    'Check in the RecipeModeChanged Event
    AddHandler BatchManager().RecipeModeChanged, AddressOf ThisProject_RecipeModeChanged
End Sub

Private Sub ThisProject_RecipeModeChanged(eventData As IBatchRecipeModeChangedEventData)
    'Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] RecipeModeChanged: " & Convert.ToString(eventData.OldExecutionMode) & " -> " & Convert.ToString(eventData.NewExecutionMode))
End Sub

Private Sub ThisProject_Inactive()
    'Check out the RecipeModeChanged Event
    RemoveHandler BatchManager().RecipeModeChanged, AddressOf ThisProject_RecipeModeChanged

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub
VBA
Copy
Dim WithEvents zBatchManager As batchManager
'procedure is executed on startup of the zenOn runtime
Private Sub Project_Active()
'init the Batchmanager object for events
    Set zBatchManager = thisProject.batchManager
End Sub
'procedure is executed on terminating the zenOn Runtime
Private Sub Project_Inactive()
'free the batchmanager object
    Set zBatchManager = Nothing
End Sub

'procedure is executed when a recipe changes its mode
Private Sub zBatchManager_ RecipeModeChanged (ByVal eventData As IBatchRecipeModeChangedEventData)
'print time and specific information to debug window
    Debug.Print (eventData.Time & " VBA-Event: Recipe Mode change")
End Sub


RecipeStateChanged
ObjectModel COM [image] BatchManager [image] Events [image] RecipeStateChanged
Remarks

This event is fired when the execution state of a recipe changesChanges to the recipe execution state that cause this event:

  • State change: running
  • State change: pausing
  • State change: paused
  • State change: resume
  • State change: holding
  • State change: held
  • State change: restarting
  • State change: stopping
  • State change: stopped
  • State change: aborting
  • State change: aborted
  • State change: complete

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
eventData as IBatchRecipeStateChangedEventData

Example
C#
Copy
void ThisProject_Active()
{
    //Check in the RecipeStateChanged Event
    BatchManager().RecipeStateChanged += new RecipeStateChangedEventHandler (
    ThisProject_RecipeStateChanged);
}

void ThisProject_RecipeStateChanged(IBatchRecipeStateChangedEventData eventData)
{
    //Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] RecipeStateChanged: " + eventData.OldExecutionState + " -> " + eventData.NewExecutionState);
}

void ThisProject_Inactive()
{
    //Check out the RecipeStateChanged Event
    BatchManager().RecipeStateChanged -= ThisProject_RecipeStateChanged;

    //Final release and garbage collection of any API-Objects.
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    'Check in the RecipeStateChanged Event
    AddHandler BatchManager().RecipeStateChanged, AddressOf ThisProject_RecipeStateChanged
End Sub

Private Sub ThisProject_RecipeStateChanged(eventData As IBatchRecipeStateChangedEventData)
    'Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] RecipeStateChanged: " & Convert.ToString(eventData.OldExecutionState) & " -> " & Convert.ToString(eventData.NewExecutionState))
End Sub

Private Sub ThisProject_Inactive()
    'Check out the RecipeStateChanged Event
    RemoveHandler BatchManager().RecipeStateChanged, AddressOf ThisProject_RecipeStateChanged

    'Final release and garbage collection of any API-Objects.
    FreeObjects()
End Sub
VBA
Copy
Dim WithEvents zBatchManager As batchManager
'procedure is executed on startup of the zenOn runtime
Private Sub Project_Active()
'init the Batchmanager object for events
    Set zBatchManager = thisProject.batchManager
End Sub
'procedure is executed on terminating the zenOn Runtime
Private Sub Project_Inactive()
'free the batchmanager object
    Set zBatchManager = Nothing
End Sub

'procedure is executed when a recipe changes its state
Private Sub zBatchManager_ RecipeStateChanged (ByVal eventData As IBatchRecipeStateChangedEventData)
    'print time and specific information to debug window
    Debug.Print (eventData.Time & " VBA-Event: Recipe State change")
End Sub


BatchMasterRecipe
ObjectModel COM [image] BatchMasterRecipe
Remarks

Object with the properties for the recipe.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroBatchMasterRecipe()
{
    IBatchManager batchManager = this.BatchManager();

    //Get a master recipe over its index
    int mrIndex = 0;
    IBatchMasterRecipe masterRecipe = batchManager.MasterRecipes().ItemByIndex(mrIndex);

    // Get a master recipe over its ID
    int mrId = 42;
    masterRecipe = batchManager.MasterRecipes().ItemById(mrId);

    //Get the data of a master recipe over its name
    string mrName = "TestMR1";
    masterRecipe = batchManager.MasterRecipes().Item(mrName, 1);
    //Do something with the BatchMasterRecipe
}
VB.NET
Copy
Public Sub MacroBatchMasterRecipe()
    Dim batchManager As IBatchManager = Me.BatchManager()

    'Get a master recipe over its index
    Dim mrIndex As Integer = 0
    Dim masterRecipe As IBatchMasterRecipe = batchManager.MasterRecipes().ItemByIndex(mrIndex)

    ' Get a master recipe over its ID
    Dim mrId As Integer = 42
    masterRecipe = batchManager.MasterRecipes().ItemById(mrId)

    'Get the data of a master recipe over its name
    Dim mrName As String = "TestMR1"
    masterRecipe = batchManager.MasterRecipes().Item(mrName, 1)
    'Do something with the BatchMasterRecipe
End Sub
VBA
Copy
Public Sub test()
// Get a master recipe over its ID
Set masterRecipe = thisProject.batchManager.MasterRecipes. ItemById (10)
//Get the data of a master recipe over its name
Set masterRecipe = thisProject.batchManager.MasterRecipes. ItemByName ("TestMR1")
//Get a master recipe over its index
Set masterRecipe = thisProject.batchManager.MasterRecipes.ItemByIndex(10)
'print text and approved time to debug window
Debug.Print ("ApprovedTime: " & masterrecipe.ApprovedTime)
End Sub


Properties
ObjectModel COM [image] BatchMasterRecipe [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ApprovedTime | date | Returns the approved time of the recipe | Unused | Readonly | Available | Available
ApprovedUserId | bstr | Returns the approved user id of the recipe | Unused | Readonly | Available | Available
ApprovedUserName | bstr | Returns the approved user name of the recipe | Unused | Readonly | Available | Available
Description | bstr | Returns the description of the recipe | Unused | Readonly | Available | Available
ExecutionMode | tpbatchexecutionmode | Returns the mode of the recipe | Unused | Readonly | Available | Available
ExecutionState | tpbatchexecutionstate | Returns the state of the recipe engine | Unused | Readonly | Available | Available
ID | long | Returns the Id of the recipe | Unused | Readonly | Available | Available
MRState | tpbatchmrstate | Returns the state of the recipe | Unused | Readonly | Available | Available
Name | bstr | Returns the name of the recipe | Unused | Readonly | Available | Available
OutdatedTime | date | Returns the outdated time of the recipe | Unused | Readonly | Available | Available
OutdatedUserId | bstr | Returns the outdated user id of the recipe | Unused | Readonly | Available | Available
OutdatedUserName | bstr | Returns the outdated user name of the recipe | Unused | Readonly | Available | Available
SourceVersion | long | Returns the version of the source recipe | Unused | Readonly | Available | Available
StartedOnHost | bstr |  | Unused | Readonly | Available | Available
Type | bstr | Returns the type of the recipe | Unused | Readonly | Available | Available
Version | long | Returns the version of recipe | Unused | Readonly | Available | Available


ApprovedTime
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] ApprovedTime
Remarks

Returns the approved time of the recipe

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ApprovedUserId
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] ApprovedUserId
Remarks

Returns the approved user id of the recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ApprovedUserName
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] ApprovedUserName
Remarks

Returns the approved user name of the recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Description
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] Description
Remarks

Returns the description of the recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ExecutionMode
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] ExecutionMode
Remarks

Returns the mode of the recipe

Datatype
tpBatchExecutionMode

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ExecutionState
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] ExecutionState
Remarks

Returns the state of the recipe engine

Datatype
tpBatchExecutionState

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ID
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] ID
Remarks

Returns the Id of the recipe

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MRState
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] MRState
Remarks

Returns the state of the recipe

Datatype
tpBatchMRState

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] Name
Remarks

Returns the name of the recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


OutdatedTime
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] OutdatedTime
Remarks

Returns the outdated time of the recipe

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


OutdatedUserId
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] OutdatedUserId
Remarks

Returns the outdated user id of the recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


OutdatedUserName
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] OutdatedUserName
Remarks

Returns the outdated user name of the recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


SourceVersion
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] SourceVersion
Remarks

Version number of the source recipe.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


StartedOnHost
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] StartedOnHost
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] Type
Remarks

Returns the type of the recipe

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Version
ObjectModel COM [image] BatchMasterRecipe [image] Properties [image] Version
Remarks

Version number of the template recipe.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] BatchMasterRecipe [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ControlRecipes | ibatchcontrolrecipes | Returns the collection of control recipes | Unused | Readonly | Available | Available
SetNameAndDescription | tpreciperenameresult | Tries to rename the recipe and sets the description. Returns a result code whether the operation was successful or not. | Unused | Readonly | Available | Available


ControlRecipes
ObjectModel COM [image] BatchMasterRecipe [image] Methods [image] ControlRecipes
Remarks

Returns the collection of control recipes

Datatype
IBatchControlRecipes

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
eFilter as tpBatchCRStateFilter


SetNameAndDescription
ObjectModel COM [image] BatchMasterRecipe [image] Methods [image] SetNameAndDescription
Remarks

This method changes the name and the description of the master recipe if possible. The method returns a result code for the operation. Note, that the master recipe instance you are working on is a copy of the original data. To get an updated version of the master recipe you have to get it again from the master recipes container.

Datatype
tpRecipeRenameResult

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
newName as BSTR

Recipe name

newDescription as BSTR

Recipe description

Example
C#
Copy
//Function to rename a master recipe and set its description
public void Macro_SetMasterRecipeNameAndDescription()
{
    //Get the master recipe that is to be renamed
    IBatchMasterRecipe mr = BatchManager().MasterRecipes().Item("oldMasterRecipeName", 1);

    //rename the master recipe and set its description
    tpRecipeRenameResult result = mr.SetNameAndDescription("newName", "newDescription");

    //Output result if the operation failed
    if (result != tpRecipeRenameResult.tpRecipeRenameSuccess)
    {
        MessageBox.Show(null, "Rename Failed. Error Code: " + result.ToString(), "rename master recipe result", MessageBoxButtons.OK, MessageBoxIcon.None);
    }
}
VB.NET
Copy
'Function to rename a master recipe and set its description
Public Sub Macro_SetMasterRecipeNameAndDescription()
    'Get the master recipe that is to be renamed
    Dim mr As IBatchMasterRecipe = BatchManager().MasterRecipes().Item("oldMasterRecipeName", 1)

    'rename the master recipe and set its description
    Dim result As tpRecipeRenameResult = mr.SetNameAndDescription("newName", "newDescription")

    'Output result if the operation failed
    If result <> tpRecipeRenameResult.tpRecipeRenameSuccess Then
        MessageBox.Show(Nothing, "Rename Failed. Error Code: " & result.ToString(), "rename master recipe result", MessageBoxButtons.OK, MessageBoxIcon.None)
    End If
End Sub
VBA
Copy
'Function to rename a master recipe and set its description
Public Sub SetMasterRecipeNameAndDescription()
    'Get the master recipe that is to be renamed
    Dim mr As BatchMasterRecipe
    Set mr = thisProject.BatchManager.MasterRecipes.Item("oldMasterRecipeName", 1)
    'rename the master recipe and set its description
    Dim result As tpRecipeRenameResult  'resultcode for the operation
    result = mr.SetNameAndDescription("newName", "newDescription")
    'Output result if the operation failed
    If result <> tpRecipeRenameSuccess Then
        MsgBox ("Rename Failed. Error Code: " & CStr(result))
    End If
End Sub


BatchMasterRecipes
ObjectModel COM [image] BatchMasterRecipes
Remarks

Lists all template recipes. Specific recipes can be read from the collection.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroBatchMasterRecipe()
{
    IBatchManager batchManager = this.BatchManager();

    //Get a master recipe over its index
    int mrIndex = 0;
    IBatchMasterRecipe masterRecipe = batchManager.MasterRecipes().ItemByIndex(mrIndex);

    // Get a master recipe over its ID
    int mrId = 42;
    masterRecipe = batchManager.MasterRecipes().ItemById(mrId);

    //Get the data of a master recipe over its name
    string mrName = "TestMR1";
    masterRecipe = batchManager.MasterRecipes().Item(mrName, 1);
    //Do something with the BatchMasterRecipe
}
VB.NET
Copy
Public Sub MacroBatchMasterRecipe()
    Dim batchManager As IBatchManager = Me.BatchManager()

    'Get a master recipe over its index
    Dim mrIndex As Integer = 0
    Dim masterRecipe As IBatchMasterRecipe = batchManager.MasterRecipes().ItemByIndex(mrIndex)

    ' Get a master recipe over its ID
    Dim mrId As Integer = 42
    masterRecipe = batchManager.MasterRecipes().ItemById(mrId)

    'Get the data of a master recipe over its name
    Dim mrName As String = "TestMR1"
    masterRecipe = batchManager.MasterRecipes().Item(mrName, 1)
    'Do something with the BatchMasterRecipe
End Sub
VBA
Copy
Public Sub test()
// Get a master recipe over its ID
Set masterRecipe = thisProject.batchManager.MasterRecipes. ItemById (10)
//Get the data of a master recipe over its name
Set masterRecipe = thisProject.batchManager.MasterRecipes. ItemByName ("TestMR1")
//Get a master recipe over its index
Set masterRecipe = thisProject.batchManager.MasterRecipes.ItemByIndex(10)
'print text and approved time to debug window
Debug.Print ("ApprovedTime: " & masterrecipe.ApprovedTime)
End Sub


Properties
ObjectModel COM [image] BatchMasterRecipes [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the amount of items in the collection. | Unused | Readonly | Available | Available


Count
ObjectModel COM [image] BatchMasterRecipes [image] Properties [image] Count
Remarks

Returns the amount of items in the collection of master recipes.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] BatchMasterRecipes [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
GetItem | ibatchmasterrecipe | Returns the master recipe item at the given index. | Unused | Readonly | Available | Available
GetItemById | ibatchmasterrecipe | Returns the master recipe item with the specified Id | Unused | Readonly | Available | Available
GetItemByName | ibatchmasterrecipe | Returns the master recipe item with the specified name | Unused | Readonly | Available | Available


GetItem
ObjectModel COM [image] BatchMasterRecipes [image] Methods [image] GetItem
Remarks

Returns the master recipe item at the given index.

Datatype
IBatchMasterRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lIndex as long

Index of the master recipe.


GetItemById
ObjectModel COM [image] BatchMasterRecipes [image] Methods [image] GetItemById
Remarks

Returns the master recipe item with the specified Id

Datatype
IBatchMasterRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lId as long

ID of the master recipe.


GetItemByName
ObjectModel COM [image] BatchMasterRecipes [image] Methods [image] GetItemByName
Remarks

Returns the master recipe item with the specified name

Datatype
IBatchMasterRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bstrName as BSTR

Name of the master recipe.

lVersion as long


BatchMRSelectionChangedEventData
ObjectModel COM [image] BatchMRSelectionChangedEventData
Remarks

An object of this type is passed as a parameter in the MRSelectionChangedEvent

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
// local variable for the batchManager to register the events
private IBatchManager batchManager = null;

void ThisProject_Active()
{
    // Register event
    batchManager.MRSelectionChanged += new MRSelectionChangedEventHandler(ThisProject_MRSelectionChanged);
}
void ThisProject_Inactive()
{
    // unregister Event
    batchManager.MRSelectionChanged -= new MRSelectionChangedEventHandler(ThisProject_MRSelectionChanged);
}

void ThisProject_MRSelectionChanged(IBatchMRSelectionChangedEventData eventData)
{
    // Get master recipe selection for the screen in which the selection has changed
    int[] selectedMRIds = (int[])batchManager.SelectedMRIds(eventData.ScreenName);

    // Build an output string
    string selectedMRIdsInfo = "Selected MRIds: ";
    foreach (int selectedMRId in selectedMRIds)
        selectedMRIdsInfo += selectedMRId + "; ";

    // Write an output message
    System.Diagnostics.Debug.Print("\n" + selectedMRIdsInfo);
}
VB.NET
Copy
' local variable for the batchManager to register the events
Private batchManager As IBatchManager = Nothing

Private Sub ThisProject_Active()
    ' Register event
    AddHandler batchManager.MRSelectionChanged, AddressOf ThisProject_MRSelectionChanged
End Sub
Private Sub ThisProject_Inactive()
    ' unregister Event
    RemoveHandler batchManager.MRSelectionChanged, AddressOf ThisProject_MRSelectionChanged
End Sub

Private Sub ThisProject_MRSelectionChanged(eventData As IBatchMRSelectionChangedEventData)
    ' Get master recipe selection for the screen in which the selection has changed
    Dim selectedMRIds As Integer() = DirectCast(batchManager.SelectedMRIds(eventData.ScreenName), Integer())

    ' Build an output string
    Dim selectedMRIdsInfo As String = "Selected MRIds: "
    For Each selectedMRId As Integer In selectedMRIds
        selectedMRIdsInfo += selectedMRId & "; "
    Next

    ' Write an output message
    System.Diagnostics.Debug.Print(vbLf & selectedMRIdsInfo)
End Sub
VBA
Copy
Dim WithEvents zBatchManager As BatchManager
Private Sub Project_Active()
    'Register events
    Set zBatchManager = thisProject.BatchManager
End Sub
Private Sub Project_Inactive()
    'Unregister events
    Set zBatchManager = Nothing
End Sub
Private Sub zBatchManager_MRSelectionChanged(ByVal eventData As IBatchMRSelectionChangedEventData)
    'Get the MRs of the calling screen
    Dim selectedMRIds() As Long
    selectedMRIds = zBatchManager.selectedMRIds(eventData.ScreenName)
    Dim selectedMRIdsInfo As String
    selectedMRIdsInfo = "Selected MRIds: "
    'Get the MR Ids data
    For i = 0 To UBound(selectedMRIds)
        selectedMRIdsInfo = selectedMRIdsInfo & selectedMRIds(i) & "; "
    Next i
    'Show messagebox with recipe Ids
    MsgBox (selectedMRIdsInfo)
End Sub


Properties
ObjectModel COM [image] BatchMRSelectionChangedEventData [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ScreenName | bstr | Name of the screen in which the selection of the recipe list was changed | Unused | Readonly | Available | Available


ScreenName
ObjectModel COM [image] BatchMRSelectionChangedEventData [image] Properties [image] ScreenName
Remarks

Name of the Picture, in which the selection was changed

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchOperation
ObjectModel COM [image] BatchOperation
Remarks

A sub-recipe, that can then be used in master recipes.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchOperation [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ChartId | long | Id of the chart operation object in the recipe | Unused | Readonly | Available | Available
Description | bstr | Description of the operation | Unused | Readonly | Available | Available
Name | bstr | Name of the operation | Unused | Readonly | Available | Available


ChartId
ObjectModel COM [image] BatchOperation [image] Properties [image] ChartId
Remarks

Id of the chart operation object in the recipe.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Description
ObjectModel COM [image] BatchOperation [image] Properties [image] Description
Remarks

Description of the operation.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] BatchOperation [image] Properties [image] Name
Remarks

Name of the operation.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchPhase
ObjectModel COM [image] BatchPhase
Remarks

A functional block, that encapsulates the communication with the plc for a specific procedure.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchPhase [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ChartId | long | Id of the chart phase object in the recipe or operation | Unused | Readonly | Available | Available
ControlStrategy | ibatchcontrolstrategy | Currently active control strategy | Unused | Readonly | Available | Available
Description | bstr | Description of the phase | Unused | Readonly | Available | Available
ExecutionCounter | long | Execution counter of the phase | Unused | Readonly | Available | Available
Name | bstr | Name of the phase | Unused | Readonly | Available | Available
PhaseState | tpbatchexecutionstate | Execution state of the phase | Unused | Readonly | Available | Available
Tags | ibatchtags | Collection for the tags of the phase. | Unused | Readonly | Available | Available


ChartId
ObjectModel COM [image] BatchPhase [image] Properties [image] ChartId
Remarks

Id of the chart phase object in the recipe or operation.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ControlStrategy
ObjectModel COM [image] BatchPhase [image] Properties [image] ControlStrategy
Remarks

Currently active control strategy.

Datatype
IBatchControlStrategy

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Description
ObjectModel COM [image] BatchPhase [image] Properties [image] Description
Remarks

Description of the phase.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ExecutionCounter
ObjectModel COM [image] BatchPhase [image] Properties [image] ExecutionCounter
Remarks

Execution counter of the phase.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] BatchPhase [image] Properties [image] Name
Remarks

Name of the phase.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


PhaseState
ObjectModel COM [image] BatchPhase [image] Properties [image] PhaseState
Remarks

Execution state of the phase.

Datatype
tpBatchExecutionState

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Tags
ObjectModel COM [image] BatchPhase [image] Properties [image] Tags
Remarks

Collection for the tags of the phase.

Datatype
IBatchTags

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchPhaseChanges
ObjectModel COM [image] BatchPhaseChanges
Remarks

Object that contains what changes were made in the phase (contains the IDs of the changed tags)

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchPhaseChanges [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
TagIdCount | long | Count of tag ids in the collection | Unused | Readonly | Available | Available


TagIdCount
ObjectModel COM [image] BatchPhaseChanges [image] Properties [image] TagIdCount
Remarks

Count of the IDs for the changed tags.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] BatchPhaseChanges [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
TagIdByIndex | long | Gets a tag id from the collection by its index | Unused | Readonly | Available | Available


TagIdByIndex
ObjectModel COM [image] BatchPhaseChanges [image] Methods [image] TagIdByIndex
Remarks

Returns an ID of a changed Tag for lIndex. lIndex has to lie between 0 and TagIdCount-1. If it does not, the Method will return 0.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lIndex as long

Example
C#
Copy
void ThisProject_Active()
{
//Check in the ControlRecipePhaseEdited Event
    BatchManager().ControlRecipePhaseEdited += new    ControlRecipePhaseEditedEventHandler(ThisProject_ControlRecipePhaseEdited);
}

void ThisProject_ControlRecipePhaseEdited(IBatchControlRecipePhaseEditedEventData eventData)
{
//Get the ID of the changed tags from the event data changes collection
string additionalInformation = "Changes[Tag-ID]: ";

for (var index = 0; index < eventData.Changes.TagIdCount; index++)
    {
        additionalInformation += "" + eventData.Changes.TagIdByIndex(index) + "; ";
    }

    additionalInformation += "   --   Comment:\"" + eventData.Comment + "\"";

//Write debug message to the listener when event is fired.
    System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] Control Recipe
    Edited. >> " + additionalInformation);
}

void ThisProject_Inactive()
{
//Check out the ControlRecipePhaseEdited Event
    BatchManager().ControlRecipePhaseEdited -= ThisProject_ControlRecipePhaseEdited;

//Final release and garbage collection of any API-Objects.
    FreeObjects();
}


BatchPhaseCommunicationErrorEventData
ObjectModel COM [image] BatchPhaseCommunicationErrorEventData
Remarks

The data class that gets passed when the PhaseCommunicationError Event of the BatchManager is fired. It contains all relevant information for this event.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchPhaseCommunicationErrorEventData [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CommunicationErrorState | tpbatchphasecommunicationerrorstate | New state of the communication error | Unused | Readonly | Available | Available
ControlRecipe | ibatchcontrolrecipe | Control recipe for which the event was fired | Unused | Readonly | Available | Available
MasterRecipe | ibatchmasterrecipe | Master recipe for which the event was fired | Unused | Readonly | Available | Available
Operation | ibatchoperation | Operation that contains the phase that fired the event. null if the phase is in no operation | Unused | Readonly | Available | Available
Phase | ibatchphase | Phase for which the event was fired | Unused | Readonly | Available | Available
Time | date | Time when the event was fired | Unused | Readonly | Available | Available


CommunicationErrorState
ObjectModel COM [image] BatchPhaseCommunicationErrorEventData [image] Properties [image] CommunicationErrorState
Remarks

New state for the communication error.

Datatype
tpBatchPhaseCommunicationErrorState

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ControlRecipe
ObjectModel COM [image] BatchPhaseCommunicationErrorEventData [image] Properties [image] ControlRecipe
Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype
IBatchControlRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MasterRecipe
ObjectModel COM [image] BatchPhaseCommunicationErrorEventData [image] Properties [image] MasterRecipe
Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype
IBatchMasterRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Operation
ObjectModel COM [image] BatchPhaseCommunicationErrorEventData [image] Properties [image] Operation
Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype
IBatchOperation

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Phase
ObjectModel COM [image] BatchPhaseCommunicationErrorEventData [image] Properties [image] Phase
Remarks

Phase that fired the event.

Datatype
IBatchPhase

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] BatchPhaseCommunicationErrorEventData [image] Properties [image] Time
Remarks

Timestamp at which the event was fired.

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchPhaseConfig
ObjectModel COM [image] BatchPhaseConfig
Remarks

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchPhaseConfig [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Description | bstr | Returns the phase description | Readonly | Readonly | Available | Available
ID | long | Returns the phase ID | Readonly | Readonly | Available | Available
Name | bstr | Returns the phase name | Readonly | Readonly | Available | Available


Description
ObjectModel COM [image] BatchPhaseConfig [image] Properties [image] Description
Remarks

Phase description

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ID
ObjectModel COM [image] BatchPhaseConfig [image] Properties [image] ID
Remarks

Phase ID

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] BatchPhaseConfig [image] Properties [image] Name
Remarks

Phase name

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


BatchPhaseEscapeEventData
ObjectModel COM [image] BatchPhaseEscapeEventData
Remarks

The data class that gets passed when the PhaseEscape Event of the BatchManager is fired. It contains all relevant information for this event.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchPhaseEscapeEventData [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ControlRecipe | ibatchcontrolrecipe | Control recipe for which the event was fired | Unused | Readonly | Available | Available
EscapeState | tpbatchphaseescapestate | New internal execution position of the phase | Unused | Readonly | Available | Available
MasterRecipe | ibatchmasterrecipe | Master recipe for which the event was fired | Unused | Readonly | Available | Available
Operation | ibatchoperation | Operation that contains the phase that fired the event. null if the phase is in no operation | Unused | Readonly | Available | Available
Phase | ibatchphase | Phase for which the event was fired | Unused | Readonly | Available | Available
Time | date | Time when the event was fired | Unused | Readonly | Available | Available


ControlRecipe
ObjectModel COM [image] BatchPhaseEscapeEventData [image] Properties [image] ControlRecipe
Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype
IBatchControlRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


EscapeState
ObjectModel COM [image] BatchPhaseEscapeEventData [image] Properties [image] EscapeState
Remarks

New escape state.

Datatype
tpBatchPhaseEscapeState

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MasterRecipe
ObjectModel COM [image] BatchPhaseEscapeEventData [image] Properties [image] MasterRecipe
Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype
IBatchMasterRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Operation
ObjectModel COM [image] BatchPhaseEscapeEventData [image] Properties [image] Operation
Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype
IBatchOperation

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Phase
ObjectModel COM [image] BatchPhaseEscapeEventData [image] Properties [image] Phase
Remarks

Phase that fired the event.

Datatype
IBatchPhase

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] BatchPhaseEscapeEventData [image] Properties [image] Time
Remarks

Timestamp at which the event was fired.

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchPhaseExecutionErrorEventData
ObjectModel COM [image] BatchPhaseExecutionErrorEventData
Remarks

The data class that gets passed when the PhaseExecutionError Event of the BatchManager is fired. It contains all relevant information for this event.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchPhaseExecutionErrorEventData [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ControlRecipe | ibatchcontrolrecipe | Control recipe for which the event was fired | Unused | Readonly | Available | Available
ExecutionError | tpbatchphaseexecutionerror | Type of the error that occured | Unused | Readonly | Available | Available
MasterRecipe | ibatchmasterrecipe | Master recipe for which the event was fired | Unused | Readonly | Available | Available
Operation | ibatchoperation | Operation that contains the phase that fired the event. null if the phase is in no operation | Unused | Readonly | Available | Available
Phase | ibatchphase | Phase for which the event was fired | Unused | Readonly | Available | Available
Time | date | Time when the event was fired | Unused | Readonly | Available | Available


ControlRecipe
ObjectModel COM [image] BatchPhaseExecutionErrorEventData [image] Properties [image] ControlRecipe
Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype
IBatchControlRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ExecutionError
ObjectModel COM [image] BatchPhaseExecutionErrorEventData [image] Properties [image] ExecutionError
Remarks

Type of the execution error of the phase that triggered this event.

Datatype
tpBatchPhaseExecutionError

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MasterRecipe
ObjectModel COM [image] BatchPhaseExecutionErrorEventData [image] Properties [image] MasterRecipe
Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype
IBatchMasterRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Operation
ObjectModel COM [image] BatchPhaseExecutionErrorEventData [image] Properties [image] Operation
Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype
IBatchOperation

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Phase
ObjectModel COM [image] BatchPhaseExecutionErrorEventData [image] Properties [image] Phase
Remarks

Phase that fired the event.

Datatype
IBatchPhase

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] BatchPhaseExecutionErrorEventData [image] Properties [image] Time
Remarks

Timestamp at which the event was fired.

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchPhaseModeChangedEventData
ObjectModel COM [image] BatchPhaseModeChangedEventData
Remarks

The data class that gets passed when the PhaseModeChanged Event of the BatchManager is fired. It contains all relevant information for this event.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchPhaseModeChangedEventData [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ControlRecipe | ibatchcontrolrecipe | Control recipe for which the event was fired | Unused | Readonly | Available | Available
MasterRecipe | ibatchmasterrecipe | Master recipe for which the event was fired | Unused | Readonly | Available | Available
NewExecutionMode | tpbatchexecutionmode | Execution mode after the change | Unused | Readonly | Available | Available
OldExecutionMode | tpbatchexecutionmode | Execution mode before the change | Unused | Readonly | Available | Available
Operation | ibatchoperation | Operation that contains the phase that fired the event. null if the phase is in no operation | Unused | Readonly | Available | Available
Phase | ibatchphase | Phase for which the event was fired | Unused | Readonly | Available | Available
Time | date | Time when the event was fired | Unused | Readonly | Available | Available
User | iuser | Logged in user | Unused | Readonly | Available | Available


ControlRecipe
ObjectModel COM [image] BatchPhaseModeChangedEventData [image] Properties [image] ControlRecipe
Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype
IBatchControlRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MasterRecipe
ObjectModel COM [image] BatchPhaseModeChangedEventData [image] Properties [image] MasterRecipe
Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype
IBatchMasterRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


NewExecutionMode
ObjectModel COM [image] BatchPhaseModeChangedEventData [image] Properties [image] NewExecutionMode
Remarks

New mode from after the change.

Datatype
tpBatchExecutionMode

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


OldExecutionMode
ObjectModel COM [image] BatchPhaseModeChangedEventData [image] Properties [image] OldExecutionMode
Remarks

Mode from before the change.

Datatype
tpBatchExecutionMode

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Operation
ObjectModel COM [image] BatchPhaseModeChangedEventData [image] Properties [image] Operation
Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype
IBatchOperation

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Phase
ObjectModel COM [image] BatchPhaseModeChangedEventData [image] Properties [image] Phase
Remarks

Phase that fired the event.

Datatype
IBatchPhase

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] BatchPhaseModeChangedEventData [image] Properties [image] Time
Remarks

Timestamp at which the event was fired.

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


User
ObjectModel COM [image] BatchPhaseModeChangedEventData [image] Properties [image] User
Remarks

Copy of the user that triggered the mode change. If it is triggered by toolbar button or zenon button with a batch recipe commando, the user is the currently logged in user at the moment and client the mode change is triggered. If the mode change is triggered by reaction of a phase or an automated function call (etc.) a copy of the SYSTEM user will be sent.This user is for information only. Trying to change its password or Name or anything else will have no effect on the real user, because this is a copy. The original user may even no longer exist due to the delay in a network

Datatype
IUser

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchPhasePlcErrorEventData
ObjectModel COM [image] BatchPhasePlcErrorEventData
Remarks

The data class that gets passed when the PhasePlcError Event of the BatchManager is fired. It contains all relevant information for this event.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchPhasePlcErrorEventData [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ControlRecipe | ibatchcontrolrecipe | Control recipe for which the event was fired | Unused | Readonly | Available | Available
MasterRecipe | ibatchmasterrecipe | Master recipe for which the event was fired | Unused | Readonly | Available | Available
Operation | ibatchoperation | Operation that contains the phase that fired the event. null if the phase is in no operation | Unused | Readonly | Available | Available
Phase | ibatchphase | Phase for which the event was fired. | Unused | Readonly | Available | Available
PlcErrorState | tpbatchphaseplcerrorstate | New state of the PLC error | Unused | Readonly | Available | Available
Time | date | Time when the event was fired | Unused | Readonly | Available | Available


ControlRecipe
ObjectModel COM [image] BatchPhasePlcErrorEventData [image] Properties [image] ControlRecipe
Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype
IBatchControlRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MasterRecipe
ObjectModel COM [image] BatchPhasePlcErrorEventData [image] Properties [image] MasterRecipe
Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype
IBatchMasterRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Operation
ObjectModel COM [image] BatchPhasePlcErrorEventData [image] Properties [image] Operation
Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype
IBatchOperation

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Phase
ObjectModel COM [image] BatchPhasePlcErrorEventData [image] Properties [image] Phase
Remarks

Phase for which the event was fired.

Datatype
IBatchPhase

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


PlcErrorState
ObjectModel COM [image] BatchPhasePlcErrorEventData [image] Properties [image] PlcErrorState
Remarks

New escape state.

Datatype
tpBatchPhasePlcErrorState

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] BatchPhasePlcErrorEventData [image] Properties [image] Time
Remarks

Timestamp at which the event was fired.

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchPhaseProgressEventData
ObjectModel COM [image] BatchPhaseProgressEventData
Remarks

The data class that gets passed when the PhaseProgress Event of the BatchManager is fired. It contains all relevant information for this event.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchPhaseProgressEventData [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ControlRecipe | ibatchcontrolrecipe | Control recipe for which the event was fired | Unused | Readonly | Available | Available
MasterRecipe | ibatchmasterrecipe | Master recipe for which the event was fired | Unused | Readonly | Available | Available
Operation | ibatchoperation | Operation that contains the phase that fired the event. null if the phase is in no operation | Unused | Readonly | Available | Available
Phase | ibatchphase | Phase for which the event was fired | Unused | Readonly | Available | Available
PhaseState | tpbatchphasestate | New internal execution position of the phase | Unused | Readonly | Available | Available
Time | date | Time when the event was fired | Unused | Readonly | Available | Available


ControlRecipe
ObjectModel COM [image] BatchPhaseProgressEventData [image] Properties [image] ControlRecipe
Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype
IBatchControlRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MasterRecipe
ObjectModel COM [image] BatchPhaseProgressEventData [image] Properties [image] MasterRecipe
Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype
IBatchMasterRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Operation
ObjectModel COM [image] BatchPhaseProgressEventData [image] Properties [image] Operation
Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype
IBatchOperation

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Phase
ObjectModel COM [image] BatchPhaseProgressEventData [image] Properties [image] Phase
Remarks

Phase that fired the event.

Datatype
IBatchPhase

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


PhaseState
ObjectModel COM [image] BatchPhaseProgressEventData [image] Properties [image] PhaseState
Remarks

New internal state for the phase execution. The change of this state triggered this event.

Datatype
tpBatchPhaseState

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] BatchPhaseProgressEventData [image] Properties [image] Time
Remarks

Timestamp at which the event was fired.

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchPhaseRuntimeEventData
ObjectModel COM [image] BatchPhaseRuntimeEventData
Remarks

The data class that gets passed when the PhaseRuntimeEvent Event of the BatchManager is fired. It contains all relevant information for this event.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchPhaseRuntimeEventData [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ControlRecipe | ibatchcontrolrecipe | Control recipe for which the event was fired | Unused | Readonly | Available | Available
MasterRecipe | ibatchmasterrecipe | Master recipe for which the event was fired | Unused | Readonly | Available | Available
Operation | ibatchoperation | Operation that contains the phase that fired the event. null if the phase is in no operation | Unused | Readonly | Available | Available
Phase | ibatchphase | Phase for which the event was fired | Unused | Readonly | Available | Available
RuntimeEventType | tpbatchphaseruntimeevent | Type of the Runtime event that occured | Unused | Readonly | Available | Available
Time | date | Time when the event was fired | Unused | Readonly | Available | Available


ControlRecipe
ObjectModel COM [image] BatchPhaseRuntimeEventData [image] Properties [image] ControlRecipe
Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype
IBatchControlRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MasterRecipe
ObjectModel COM [image] BatchPhaseRuntimeEventData [image] Properties [image] MasterRecipe
Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype
IBatchMasterRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Operation
ObjectModel COM [image] BatchPhaseRuntimeEventData [image] Properties [image] Operation
Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype
IBatchOperation

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Phase
ObjectModel COM [image] BatchPhaseRuntimeEventData [image] Properties [image] Phase
Remarks

Phase that fired the event.

Datatype
IBatchPhase

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


RuntimeEventType
ObjectModel COM [image] BatchPhaseRuntimeEventData [image] Properties [image] RuntimeEventType
Remarks

Type of runtime event that triggered this event.

Datatype
tpBatchPhaseRuntimeEvent

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] BatchPhaseRuntimeEventData [image] Properties [image] Time
Remarks

Timestamp at which the event was fired.

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchPhasesConfig
ObjectModel COM [image] BatchPhasesConfig
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchPhasesConfig [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the number of phases. | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] BatchPhasesConfig [image] Properties [image] Count
Remarks

Returns the number of phases.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] BatchPhasesConfig [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DeleteById | variant_bool | Deletes a phase via ID. | Available | Unused | Available | Available
DeleteByIndex | variant_bool | Deletes a phase via index | Available | Unused | Available | Available
DeleteByName | variant_bool | Deletes a phase via name. | Available | Unused | Available | Available
Export | variant_bool | Exports all phases to file. | Available | Available | Available | Available
GetItem | ibatchphaseconfig | Returns a phase via index. | Available | Available | Available | Available
GetItemById | ibatchphaseconfig | Returns a phase via ID. | Available | Available | Available | Available
GetItemByName | ibatchphaseconfig | Returns a phase via name. | Available | Available | Available | Available
Import | variant_bool | Imports the phases from file. | Available | Unused | Available | Available
SingleExportById | variant_bool | Exports a phase via ID. | Available | Available | Available | Available
SingleExportByIndex | variant_bool | Exports a phase via index. | Available | Available | Available | Available
SingleExportByName | variant_bool | Exports a phase via name. | Available | Available | Available | Available


DeleteById
ObjectModel COM [image] BatchPhasesConfig [image] Methods [image] DeleteById
Remarks

Deletes a phase via ID.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lPhaseId as long

ID of the phase to be deleted.


DeleteByIndex
ObjectModel COM [image] BatchPhasesConfig [image] Methods [image] DeleteByIndex
Remarks

Deletes a phase via index

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lPhaseIndex as long

Index of the phase to be deleted.


DeleteByName
ObjectModel COM [image] BatchPhasesConfig [image] Methods [image] DeleteByName
Remarks

Deletes a phase via name.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bstrPhaseName as BSTR

Name of the phase to be deleted.


Export
ObjectModel COM [image] BatchPhasesConfig [image] Methods [image] Export
Remarks

Exports all phases to file.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrXmlFileName as BSTR


GetItem
ObjectModel COM [image] BatchPhasesConfig [image] Methods [image] GetItem
Remarks

Returns a phase via index.

Datatype
IBatchPhaseConfig

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lPhaseIndex as long

Index of the phase to be returned.


GetItemById
ObjectModel COM [image] BatchPhasesConfig [image] Methods [image] GetItemById
Remarks

Returns a phase via ID.

Datatype
IBatchPhaseConfig

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lPhaseId as long

ID of the phase to be returned.


GetItemByName
ObjectModel COM [image] BatchPhasesConfig [image] Methods [image] GetItemByName
Remarks

Returns a phase via name.

Datatype
IBatchPhaseConfig

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrPhaseName as BSTR

Name of the phase to be returned.


Import
ObjectModel COM [image] BatchPhasesConfig [image] Methods [image] Import
Remarks

Imports the phases from file.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bstrXmlFileName as BSTR


SingleExportById
ObjectModel COM [image] BatchPhasesConfig [image] Methods [image] SingleExportById
Remarks

Exports a phase via ID.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lPhaseId as long

bstrXmlFileName as BSTR


SingleExportByIndex
ObjectModel COM [image] BatchPhasesConfig [image] Methods [image] SingleExportByIndex
Remarks

Exports a phase via index.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lPhaseIndex as long

bstrXmlFileName as BSTR


SingleExportByName
ObjectModel COM [image] BatchPhasesConfig [image] Methods [image] SingleExportByName
Remarks

Exports a phase via name.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrPhaseName as BSTR

bstrXmlFileName as BSTR


BatchPhaseStateChangedEventData
ObjectModel COM [image] BatchPhaseStateChangedEventData
Remarks

The data class that gets passed when the PhaseStateChanged Event of the BatchManager is fired. It contains all relevant information for this event.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchPhaseStateChangedEventData [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ControlRecipe | ibatchcontrolrecipe | Control recipe for which the event was fired | Unused | Readonly | Available | Available
MasterRecipe | ibatchmasterrecipe | Master recipe for which the event was fired | Unused | Readonly | Available | Available
NewExecutionState | tpbatchexecutionstate | Execution state after the change | Unused | Readonly | Available | Available
OldExecutionState | tpbatchexecutionstate | Execution state before the change | Unused | Readonly | Available | Available
Operation | ibatchoperation | Operation that contains the phase that fired the event. null if the phase is in no operation | Unused | Readonly | Available | Available
Phase | ibatchphase | Phase for which the event was fired | Unused | Readonly | Available | Available
Time | date | Time when the event was fired | Unused | Readonly | Available | Available
User | iuser | Logged in user. | Unused | Readonly | Available | Available


ControlRecipe
ObjectModel COM [image] BatchPhaseStateChangedEventData [image] Properties [image] ControlRecipe
Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype
IBatchControlRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MasterRecipe
ObjectModel COM [image] BatchPhaseStateChangedEventData [image] Properties [image] MasterRecipe
Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype
IBatchMasterRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


NewExecutionState
ObjectModel COM [image] BatchPhaseStateChangedEventData [image] Properties [image] NewExecutionState
Remarks

New state from after the change.

Datatype
tpBatchExecutionState

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


OldExecutionState
ObjectModel COM [image] BatchPhaseStateChangedEventData [image] Properties [image] OldExecutionState
Remarks

Mode from before the change.

Datatype
tpBatchExecutionState

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Operation
ObjectModel COM [image] BatchPhaseStateChangedEventData [image] Properties [image] Operation
Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype
IBatchOperation

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Phase
ObjectModel COM [image] BatchPhaseStateChangedEventData [image] Properties [image] Phase
Remarks

Phase that fired the event.

Datatype
IBatchPhase

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] BatchPhaseStateChangedEventData [image] Properties [image] Time
Remarks

Timestamp at which the event was fired.

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


User
ObjectModel COM [image] BatchPhaseStateChangedEventData [image] Properties [image] User
Remarks

Logged in user.

Datatype
IUser

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchRecipeId
ObjectModel COM [image] BatchRecipeId
Remarks

Contains both the master recipe Id and the control recipe Id for a recipe.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchRecipeId [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CRId | long | Control recipe Id of the recipe. | Unused | Readonly | Available | Available
MRId | long | Master recipe Id of the recipe. | Unused | Readonly | Available | Available


CRId
ObjectModel COM [image] BatchRecipeId [image] Properties [image] CRId
Remarks

Control recipe Id of the recipe.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MRId
ObjectModel COM [image] BatchRecipeId [image] Properties [image] MRId
Remarks

Master recipe Id of the recipe.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchRecipeModeChangedEventData
ObjectModel COM [image] BatchRecipeModeChangedEventData
Remarks

The data class that gets passed when the RecipeModeChanged Event of the BatchManager is fired. It contains all relevant information for this event.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchRecipeModeChangedEventData [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ControlRecipe | ibatchcontrolrecipe | Control recipe for which the event was fired | Unused | Readonly | Available | Available
MasterRecipe | ibatchmasterrecipe | Master recipe for which the event was fired | Unused | Readonly | Available | Available
NewExecutionMode | tpbatchexecutionmode | Execution mode after the change. | Unused | Readonly | Available | Available
OldExecutionMode | tpbatchexecutionmode | Execution mode before the change. | Unused | Readonly | Available | Available
Time | date | Time when the event was fired | Unused | Readonly | Available | Available
User | iuser | Logged in user. | Unused | Readonly | Available | Available


ControlRecipe
ObjectModel COM [image] BatchRecipeModeChangedEventData [image] Properties [image] ControlRecipe
Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype
IBatchControlRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MasterRecipe
ObjectModel COM [image] BatchRecipeModeChangedEventData [image] Properties [image] MasterRecipe
Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype
IBatchMasterRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


NewExecutionMode
ObjectModel COM [image] BatchRecipeModeChangedEventData [image] Properties [image] NewExecutionMode
Remarks

Execution mode after the change.

Datatype
tpBatchExecutionMode

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


OldExecutionMode
ObjectModel COM [image] BatchRecipeModeChangedEventData [image] Properties [image] OldExecutionMode
Remarks

Execution mode before the change.

Datatype
tpBatchExecutionMode

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] BatchRecipeModeChangedEventData [image] Properties [image] Time
Remarks

Timestamp of the value

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


User
ObjectModel COM [image] BatchRecipeModeChangedEventData [image] Properties [image] User
Remarks

Logged in user.

Datatype
IUser

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchRecipeStateChangedEventData
ObjectModel COM [image] BatchRecipeStateChangedEventData
Remarks

The data class that gets passed when the RecipeStateChanged Event of the BatchManager is fired. It contains all relevant information for this event.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchRecipeStateChangedEventData [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ControlRecipe | ibatchcontrolrecipe | Control recipe for which the event was fired | Unused | Readonly | Available | Available
MasterRecipe | ibatchmasterrecipe | Master recipe for which the event was fired | Unused | Readonly | Available | Available
NewExecutionState | tpbatchexecutionstate | Execution state after the change | Unused | Readonly | Available | Available
OldExecutionState | tpbatchexecutionstate | Execution state before the change | Unused | Readonly | Available | Available
Time | date | Time when the event was fired | Unused | Readonly | Available | Available
User | iuser | Logged in user | Unused | Readonly | Available | Available


ControlRecipe
ObjectModel COM [image] BatchRecipeStateChangedEventData [image] Properties [image] ControlRecipe
Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype
IBatchControlRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MasterRecipe
ObjectModel COM [image] BatchRecipeStateChangedEventData [image] Properties [image] MasterRecipe
Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype
IBatchMasterRecipe

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


NewExecutionState
ObjectModel COM [image] BatchRecipeStateChangedEventData [image] Properties [image] NewExecutionState
Remarks

New execution state after the event.

Datatype
tpBatchExecutionState

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


OldExecutionState
ObjectModel COM [image] BatchRecipeStateChangedEventData [image] Properties [image] OldExecutionState
Remarks

Old execution state before the event.

Datatype
tpBatchExecutionState

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] BatchRecipeStateChangedEventData [image] Properties [image] Time
Remarks

Timestamp of the value

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


User
ObjectModel COM [image] BatchRecipeStateChangedEventData [image] Properties [image] User
Remarks

Copy of the user that triggered the event. For user-triggered changes Only, this is the currently logged user at the time of the change is performed. The logged user is only used for the switch to the direct resulting transient state: Start(IDLE->RUNNING), resume(PAUSED->RUNNING) and switches to transient states. For the other changes to the absolute states the SYSTEM user is used, because they are triggered by the execution itself. Also all automated changes (reactions, automatically executed zenon functions) use the SYSTEM user.NOTE: All actions from reactions are logged in the CEL. As user "System" is registered.

Datatype
IUser

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchTag
ObjectModel COM [image] BatchTag
Remarks

The object that encapsulates a variable for the purposes of the batch execution.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchTag [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CurrentValue | ivariablevalue | Current value of the variable linked as the current value variable on the tag | Unused | Readonly | Available | Available
CurrentValueVariable | ivariable | For command tags this is the variable that shows the current value for the tag on the PLC. | Unused | Readonly | Available | Available
DataType | tpbatchtagdatatype | Data type for the tag | Unused | Readonly | Available | Available
Description | bstr | Description of the tag | Unused | Readonly | Available | Available
ID | long | ID of the tag | Unused | Readonly | Available | Available
Name | bstr | Name of the tag | Unused | Readonly | Available | Available
TagType | tpbatchtagtype | Type of the tag | Unused | Readonly | Available | Available
TagValue | ibatchtagvalue | Value that is to be written on the tag variable | Unused | Readonly | Available | Available
TagVariable | ivariable | Main Variable of the tag. For command tags the value is written onto this variable. | Unused | Readonly | Available | Available
TagVariableValue | ivariablevalue | Current value of the variable linked as the tag variable on the tag | Unused | Readonly | Available | Available
Unit | bstr | Unit of the tag | Unused | Readonly | Available | Available


CurrentValue
ObjectModel COM [image] BatchTag [image] Properties [image] CurrentValue
Remarks

Current value of the variable linked as the current value variable on the tag .

Datatype
IVariableValue

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


CurrentValueVariable
ObjectModel COM [image] BatchTag [image] Properties [image] CurrentValueVariable
Remarks

If the readable datapoint differs from the writeable one for a command tag, the readable one can be linked here. It is null for tags on which it is not linked.

Datatype
IVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


DataType
ObjectModel COM [image] BatchTag [image] Properties [image] DataType
Remarks

Datatype of the tag.

Datatype
tpBatchTagDataType

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Description
ObjectModel COM [image] BatchTag [image] Properties [image] Description
Remarks

Description of the tag.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ID
ObjectModel COM [image] BatchTag [image] Properties [image] ID
Remarks

ID of the tag.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] BatchTag [image] Properties [image] Name
Remarks

Name of the tag.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


TagType
ObjectModel COM [image] BatchTag [image] Properties [image] TagType
Remarks

Type of the tag (initial, value, return).

Datatype
tpBatchTagType

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


TagValue
ObjectModel COM [image] BatchTag [image] Properties [image] TagValue
Remarks

Value that is written on the tag variable.

Datatype
IBatchTagValue

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


TagVariable
ObjectModel COM [image] BatchTag [image] Properties [image] TagVariable
Remarks

Variable that is linked on the Tag. For command tags this is the one that has the values written to it.

Datatype
IVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


TagVariableValue
ObjectModel COM [image] BatchTag [image] Properties [image] TagVariableValue
Remarks

Current value of thje variable linked as tag varaible.

Datatype
IVariableValue

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Unit
ObjectModel COM [image] BatchTag [image] Properties [image] Unit
Remarks

Unit of the tag.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchTags
ObjectModel COM [image] BatchTags
Remarks

A collection of tags. Allows you to iterate and get tags.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchTags [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Number of tags in the collection. | Unused | Readonly | Available | Available


Count
ObjectModel COM [image] BatchTags [image] Properties [image] Count
Remarks

Number of tags in the collection.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] BatchTags [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
GetItem | ibatchtag | Gets a tag by its index in the collection. | Unused | Readonly | Available | Available
GetItemById | ibatchtag | Gets a tag by its ID. | Unused | Readonly | Available | Available
GetItemByName | ibatchtag | Gets a tag by its name. | Unused | Readonly | Available | Available


GetItem
ObjectModel COM [image] BatchTags [image] Methods [image] GetItem
Remarks

Gets a tag by its index in the collection.

Datatype
IBatchTag

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lIndex as long

Index of the tag to be returned.


GetItemById
ObjectModel COM [image] BatchTags [image] Methods [image] GetItemById
Remarks

Gets a tag by its ID.

Datatype
IBatchTag

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lId as long

ID of the tag to be returned.


GetItemByName
ObjectModel COM [image] BatchTags [image] Methods [image] GetItemByName
Remarks

Gets a tag by its name.

Datatype
IBatchTag

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bstrName as BSTR

Name of the tag to be returned.


BatchTagValue
ObjectModel COM [image] BatchTagValue
Remarks

Value of a tag that is written to the variable of the tag. It contains fields for all possible data types of the tag.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchTagValue [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Bool | tpbatchboolvalue | Bool value | Unused | Readonly | Available | Available
Duration | long | Duration value in seconds | Unused | Readonly | Available | Available
Numeric | double | Numerical value | Unused | Readonly | Available | Available
String | bstr | String value | Unused | Readonly | Available | Available


Bool
ObjectModel COM [image] BatchTagValue [image] Properties [image] Bool
Remarks

Bool value for the tag.

Datatype
tpBatchBoolValue

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Duration
ObjectModel COM [image] BatchTagValue [image] Properties [image] Duration
Remarks

Duration value for the tag.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Numeric
ObjectModel COM [image] BatchTagValue [image] Properties [image] Numeric
Remarks

Numerical value for the tag.

Datatype
double

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


String
ObjectModel COM [image] BatchTagValue [image] Properties [image] String
Remarks

String value for the tag.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


BatchUnitConfig
ObjectModel COM [image] BatchUnitConfig
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchUnitConfig [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Description | bstr | Returns the unit description. | Readonly | Readonly | Available | Available
ID | long | Returns the unit ID. | Readonly | Readonly | Available | Available
Name | bstr | Returns the unit name. | Readonly | Readonly | Available | Available
Phases | ibatchphasesconfig | List of unit phases. | Available | Readonly | Available | Available


Description
ObjectModel COM [image] BatchUnitConfig [image] Properties [image] Description
Remarks

Returns the unit description.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ID
ObjectModel COM [image] BatchUnitConfig [image] Properties [image] ID
Remarks

Returns the unit ID.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] BatchUnitConfig [image] Properties [image] Name
Remarks

Returns the unit name.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Phases
ObjectModel COM [image] BatchUnitConfig [image] Properties [image] Phases
Remarks

List of unit phases.

Datatype
IBatchPhasesConfig

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


BatchUnitsConfig
ObjectModel COM [image] BatchUnitsConfig
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] BatchUnitsConfig [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the number of units. | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] BatchUnitsConfig [image] Properties [image] Count
Remarks

Returns the number of units.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] BatchUnitsConfig [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DeleteById | variant_bool | Deletes a unit via ID. | Available | Unused | Available | Available
DeleteByIndex | variant_bool | Deletes a unit via index. | Available | Unused | Available | Available
DeleteByName | variant_bool | Deletes a unit via name. | Available | Unused | Available | Available
Export | variant_bool | Exports all units to file. | Available | Available | Available | Available
GetItem | ibatchunitconfig | Returns a unit via index. | Available | Available | Available | Available
GetItemById | ibatchunitconfig | Returns a unit via ID. | Available | Available | Available | Available
GetItemByName | ibatchunitconfig | Returns a unit via name. | Available | Available | Available | Available
Import | variant_bool | Imports the units from file. | Available | Unused | Available | Available
SingleExportById | variant_bool | Exports a unit via ID. | Available | Available | Available | Available
SingleExportByIndex | variant_bool | Exports a unit via index. | Available | Available | Available | Available
SingleExportByName | variant_bool | Exports a unit via name. | Available | Available | Available | Available


DeleteById
ObjectModel COM [image] BatchUnitsConfig [image] Methods [image] DeleteById
Remarks

Deletes a unit via ID.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lUnitId as long

ID of the unit to be deleted.


DeleteByIndex
ObjectModel COM [image] BatchUnitsConfig [image] Methods [image] DeleteByIndex
Remarks

Deletes a unit via index.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lUnitIndex as long

Index of the unit to be deleted.


DeleteByName
ObjectModel COM [image] BatchUnitsConfig [image] Methods [image] DeleteByName
Remarks

Deletes a unit via name.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bstrUnitName as BSTR

Name of the unit to be deleted.


Export
ObjectModel COM [image] BatchUnitsConfig [image] Methods [image] Export
Remarks

Exports all units to file.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrXmlFileName as BSTR


GetItem
ObjectModel COM [image] BatchUnitsConfig [image] Methods [image] GetItem
Remarks

Returns a unit via index.

Datatype
IBatchUnitConfig

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lUnitIndex as long

Index of the unit to be returned.


GetItemById
ObjectModel COM [image] BatchUnitsConfig [image] Methods [image] GetItemById
Remarks

Returns a unit via ID.

Datatype
IBatchUnitConfig

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lUnitId as long

ID of the unit to be returned.


GetItemByName
ObjectModel COM [image] BatchUnitsConfig [image] Methods [image] GetItemByName
Remarks

Returns a unit via name.

Datatype
IBatchUnitConfig

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrUnitName as BSTR

Name of the unit to be returned.


Import
ObjectModel COM [image] BatchUnitsConfig [image] Methods [image] Import
Remarks

Imports the units from file.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bstrXmlFileName as BSTR


SingleExportById
ObjectModel COM [image] BatchUnitsConfig [image] Methods [image] SingleExportById
Remarks

Exports a unit via ID.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lUnitId as long

ID of the unit to be exported.

bstrXmlFileName as BSTR


SingleExportByIndex
ObjectModel COM [image] BatchUnitsConfig [image] Methods [image] SingleExportByIndex
Remarks

Exports a unit via index.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lUnitIndex as long

Index of the unit to be exported.

bstrXmlFileName as BSTR


SingleExportByName
ObjectModel COM [image] BatchUnitsConfig [image] Methods [image] SingleExportByName
Remarks

Exports a unit via name.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrUnitName as BSTR

Name of the unit to be exported.

bstrXmlFileName as BSTR


Cel
ObjectModel COM [image] Cel
Remarks

The CEL Object represents the "Chronological Event List" an offers the feature to write user defined Events into the list or react on entries in the list...There are some methods and events implemented, to see how they are working look at the Sample below or take a detailed look at the objects properties...

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
private ICel zenonCel;
private IDynPicture zenonCelPicture;
private bool celFlag = false;

void ThisProject_Inactive()
{
    this.zenonCelPicture.Open -= new OpenEventHandler(zenonCelPicture_Open);
    this.zenonCelPicture = null;
    if (this.zenonCel != null)
    {
        this.zenonCel.CelListSelectionChanged -= new CelListSelectionChangedEventHandler(zenonCel_CelListSelectionChanged);
        this.zenonCel = null;
    }
    FreeObjects();
}

void zenonCelPicture_Open()
{
    celFlag = true;
    zenonCel = this.Cel();
    zenonCel.CelListSelectionChanged += new CelListSelectionChangedEventHandler(zenonCel_CelListSelectionChanged);
}

void zenonCel_CelListSelectionChanged(ICelItem obItem)
{
    if (celFlag == true)
        celFlag = false;
    else
        System.Diagnostics.Debug.Print("C_Changed - " + obItem.Text);
}

void ThisProject_Active()
{
    //Initialize screen objects to get Open/Close events of the screen
    this.zenonCelPicture = this.DynPictures().Item("CEL");
    this.zenonCelPicture.Open += new OpenEventHandler(zenonCelPicture_Open);
}
VB.NET
Copy
Private zenonCel As ICel
Private zenonCelPicture As IDynPicture
Private celFlag As Boolean = False

Private Sub ThisProject_Inactive()
    RemoveHandler Me.zenonCelPicture.Open, AddressOf zenonCelPicture_Open
    Me.zenonCelPicture = Nothing
    If Me.zenonCel IsNot Nothing Then
        RemoveHandler Me.zenonCel.CelListSelectionChanged, AddressOf zenonCel_CelListSelectionChanged
        Me.zenonCel = Nothing
    End If
    FreeObjects()
End Sub

Private Sub zenonCelPicture_Open()
    celFlag = True
    zenonCel = Me.Cel()
    AddHandler Me.zenonCel.CelListSelectionChanged, AddressOf zenonCel_CelListSelectionChanged
End Sub

Private Sub zenonCel_CelListSelectionChanged(obItem As ICelItem)
    If celFlag = True Then
        celFlag = False
    Else
        System.Diagnostics.Debug.Print("C_Changed - " & Convert.ToString(obItem.Text))
    End If
End Sub

Private Sub ThisProject_Active()
    'Initialize screen objects to get Open/Close events of the screen
    Me.zenonCelPicture = Me.DynPictures().Item("CEL")
    AddHandler Me.zenonCelPicture.Open, AddressOf zenonCelPicture_Open
End Sub
VBA
Copy
'##########################################################
'### this Code can be used within the 'thisProject' ###
'### object class, because of the project events! ###
'##########################################################
'Declare Objects to get the Events...
Dim WithEvents zCEL As Cel
Dim WithEvents zCELPIC As DynPicture
Dim bCEL As Boolean
'##########################################################
'### Project Events - START/END of the zenOn Runtime ###
'##########################################################
Private Sub Project_Active()
'Init screen pbjects to get Open/Close events of the screens
Set zCELPIC = thisProject.DynPictures.Item("CEL")
End Sub
Private Sub Project_Inactive()
'release objects
Set zCELPIC = Nothing
End Sub
'##########################################################
'### Procedures/Events for the Chronological event list ###
'##########################################################
Private Sub zCELPIC_Open()
'boolen flag to remember the open event
bCEL = True
'init CEL Object to get the CelListSelectionChanged event
Set zCEL = thisProject.Cel
End Sub
Private Sub zCELPIC_Close()
'release object
Set zCEL = Nothing
End Sub
Private Sub zCEL_CelListSelectionChanged(ByVal obItem As ICelItem)
'If the boolen is TRUE, the first events can be ignored
'because in this case the events returns the default
'selection on opening the screen
If bCEL = True Then

bCEL = False
Else

Debug.Print "C_Changed - " & obItem.Text
End If
End Sub


Properties
ObjectModel COM [image] Cel [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Parent | iproject | Parent-object | Readonly | Readonly | Available | Available


Parent
ObjectModel COM [image] Cel [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Cel [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CelItems | icelitems | Return the CelItems | Unused | Readonly | Available | Available
CelItemsAsXml | bstr | Return the CelItems as XML | Unused | Readonly | Available | Available
DynProperties [GET] | variant |  | Available | Available | Available | Available
DynProperties [PUT] | void |  | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant |  | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available
OnlineCelCollection [GET] | ionlinecelcollection | Returns the OnlineCels object. | Unused | Readonly | Available | Available
ResetQueryFilter | void | Resets the QueryFilter | Unused | Readonly | Available | Available
WriteCelString | void | Creates a new cel-item (only runtime) | Unused | Available | Available | Available
WriteCelStringEx | void | Creates a new extended cel-item (only runtime) | Unused | Available | Available | Available
WriteCelStringTimestamp | void | Creates a new extended cel-item including timestamp (Runtime only) | Unused | Available | Available | Available


CelItems
ObjectModel COM [image] Cel [image] Methods [image] CelItems
Remarks

Object to get all Items are actually in memory...Filter String: If the string is not "*", then the string should represent the name (case sensitive) of a zenon function.If a function with the given name exists, the filter settings within this function will be used. --> only version 6.51 and above

Datatype
ICelItems

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
strFilter as BSTR

Example
C#
Copy
public void MacroGetAllCelItems()
{
    //Print text for each item
    for (int i = 0; i < this.Cel().CelItems("*").Count; ++i )
        System.Diagnostics.Debug.Print(this.Cel().CelItems("*").Item(i).Text);
}
VB.NET
Copy
Public Sub MacroGetAllCelItems()
    'Print text for each item
    For i As Integer = 0 To Me.Cel().CelItems("*").Count - 1
        System.Diagnostics.Debug.Print(Me.Cel().CelItems("*").Item(i).Text)
    Next
End Sub
VBA
Copy
'##########################################################
'### Get all CEL Items of the project ###
'##########################################################
Public Sub GetAllItems()
Dim i As Integer
'get all items in memory...
For i = 0 To thisProject.Cel.CelItems("*").Count - 1

'print text of item to outputwindow

Debug.Print thisProject.Cel.CelItems("*").Item(i).Text
Next i
End Sub
'get specific item using the screen switch function as filter
'thisProject.Cel.CelItems("myFunction").Count - 1


CelItemsAsXml
ObjectModel COM [image] Cel [image] Methods [image] CelItemsAsXml
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
strFilter as BSTR


DynProperties [GET]
ObjectModel COM [image] Cel [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties [PUT]
ObjectModel COM [image] Cel [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT


DynPropertiesEnum [GET]
ObjectModel COM [image] Cel [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynPropertyParam [GET]
ObjectModel COM [image] Cel [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


OnlineCelCollection [GET]
ObjectModel COM [image] Cel [image] Methods [image] OnlineCelCollection [GET]
Remarks

Returns the OnlineCels object.

Datatype
IOnlineCelCollection

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ResetQueryFilter
ObjectModel COM [image] Cel [image] Methods [image] ResetQueryFilter
Remarks

Specify Cel filter or set default value.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
//Manipulation using the query filter
Project.Cel.ResetQueryFilter()
Project.Cel.SetDynProp(„QueryFilter.XXX", ZZZ)
//get items using the query filter
Project.Cel.AmlItems(„.")


WriteCelString
ObjectModel COM [image] Cel [image] Methods [image] WriteCelString
Remarks

Creates a new cel-item (only runtime)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strCelString as BSTR

The given String will be written into the chronological event list (actual Timestamp)

Example
C#
Copy
public void WriteStringToCel(string text)
{
    //Writes a new standard CEL entry
    this.Cel().WriteCelString(text);
}
VB.NET
Copy
Public Sub WriteStringToCel(text As String)
    'Writes a new standard CEL entry
    Me.Cel().WriteCelString(text)
End Sub
VBA
Copy
Public Sub WriteString2CEL(YourText As String)
'a new entry will be generated in the CEL with the actual timestamp...
thisProject.Cel.WriteCelString YourText
End Sub


WriteCelStringEx
ObjectModel COM [image] Cel [image] Methods [image] WriteCelStringEx
Remarks

Creates a new extended cel-item (only runtime)StatusValue contains all actual status information as single bits.

Status Bits:

Status | Bit | Value (DEC) | Value (HEX)
ST_M1 / Status1 | 0 | 1 | 1
ST_M2 / Status2 | 1 | 2 | 2
ST_M3 / Status3 | 2 | 4 | 4
ST_M4 / Status4 | 3 | 8 | 8
ST_M5 / Status5 | 4 | 16 | 10
ST_M6 / Status6 | 5 | 32 | 20
ST_M7 / Status7 | 6 | 64 | 40
ST_M8 / Status8 | 7 | 128 | 80
SELEC / Select | 8 | 256 | 100
REV / Revision | 9 | 512 | 200
DIREC / Desired direction | 10 | 1.024 | 400
RTE / Runtime exceeded | 11 | 2.048 | 800
MVALUE / Manual value | 12 | 4.096 | 1000
ST_M14 / Status14 | 13 | 8.192 | 2000
ST_M15 / Status15 | 14 | 16.384 | 4000
ST_M16 / Status16 | 15 | 32.768 | 8000
GR / General request | 16 | 65.536 | 10000
SPONT / Spontaneous | 17 | 131.072 | 20000
I-BIT / Invalid | 18 | 262.144 | 40000
SU/WI / Summer/winter time announcement | 19 | 524.288 | 80000
N_UPDATE / switched off | 20 | 1.048.576 | 100000
RT_E / Realtime external | 21 | 2.097.152 | 200000
RT_I / Realtime internal | 22 | 4.194.304 | 400000
NSORT / Not sortable | 23 | 8.388.608 | 800000
DM_TR / Default message trafo value | 24 | 16.777.216 | 1000000
RM_TR / Running message trafo value | 25 | 33.554.432 | 2000000
INFO / Info for variable | 26 | 67.108.864 | 4000000
AVALUE / Alternative value | 27 | 134.217.728 | 8000000
ACTUAL / Not updated | 29 | 536.870.912 | 20000000
WINTER / Winter time | 30 | 1.073.741.824 | 40000000
BLINK / Blink | 31 | 2.147.483.648 | 80000000

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strCelString as BSTR

The given String will be written into the chronological event list (actual Timestamp).

szPvName as BSTR

Name of a variable, the variable will be listed in the chronological event list.

iGroup as long

ID of AlarmGroup for filtering within the chronological event list.

iClass as long

ID of AlarmClass for filtering within the chronological event list.

Value as VARIANT

Value as Variant, means the value entry within the chronological event list.

Status as long

StatusValue contains all actual status information as single bits.

Example
C#
Copy
public void WriteExStringToCel(string text, string variableName,
    int groupNumber, int classNumber, object vValue, int status)
{
    //Writes a new extended CEL entry with given names, grpNr, clsNr, value and status bits
    this.Cel().WriteCelStringEx(text, variableName, groupNumber, classNumber, vValue, status);
}
VB.NET
Copy
Public Sub WriteExStringToCel(text As String, variableName As String, groupNumber As Integer, classNumber As Integer, vValue As Object, status As Integer)
    'Writes a new extended CEL entry with given names, grpNr, clsNr, value and status bits
    Me.Cel().WriteCelStringEx(text, variableName, groupNumber, classNumber, vValue, status)
End Sub
VBA
Copy
Public Sub WriteExString2CEL(YourText As String, VarName As String, _
GroupNr As Long, ClassNr As Long, _
vValue As Variant, lStatus As Long)
'a new entry will be generated in the CEL with the actual timestamp...
Call thisProject.Cel.WriteCelStringEx(YourText, VarName, GroupNr, _
ClassNr, vValue, lStatus)
End Sub


WriteCelStringTimestamp
ObjectModel COM [image] Cel [image] Methods [image] WriteCelStringTimestamp
Remarks

Creates a new cel-item + timestamp (only runtime)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strCelString as BSTR

szPvName as BSTR

iGroup as long

iClass as long

Value as VARIANT

Status as long

Time as long

TimeMilliSec as short

Example
C#
Copy
public void WriteTimeStampToCel(string text, string variableName,
    int groupNumber, int classNumber, object vValue, int status, int time, short milliseconds)
{   //Writes a new extended CEL entry with the given names, grpNr, clsNr, value, status bits and time
    //NOTE: zenon time format necessary for the time parameter
    this.Cel().WriteCelStringTimestamp(text, variableName, groupNumber, classNumber, vValue, status,
        time, milliseconds);
}
VB.NET
Copy
Public Sub WriteTimeStampToCel(text As String, variableName As String, groupNumber As Integer, classNumber As Integer, vValue As Object, status As Integer, _
    time As Integer, milliseconds As Short)
    'Writes a new extended CEL entry with the given names, grpNr, clsNr, value, status bits and time
    'NOTE: Zenon time format necessary for the time parameter
    Me.Cel().WriteCelStringTimestamp(text, variableName, groupNumber, classNumber, vValue, status, _
        time, milliseconds)
End Sub
VBA
Copy
Public Sub writeCel()
Call thisProject.Cel.WriteCelStringTimestamp("Mytext", "RGM_visible", 1, 1, 0, 0, 123, 456)
End Sub


Events
ObjectModel COM [image] Cel [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CelItemAdded | void | Event is fired when a new entry has been added to the CEL | Unused | Available | Available | Available
CelItemCommentChanged | void |  | Unused | Available | Available | Available
CelListSelectionChanged | void | Fired whenever the Selection in the list is changed. | Unused | Readonly | Available | Available
SelectionChangedEx | void | Event: selection array in the event list has been changed... | Unused | Readonly | Available | Available


CelItemAdded
ObjectModel COM [image] Cel [image] Events [image] CelItemAdded
Remarks

Event is fired, when a new item was added...

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obItem as ICelItem

Returns the added CelItem as Object.

Example
VBA
Copy
Dim WithEvents zCEL As Cel
'##########################################################
'### Procedures/Events of the Project ###
'##########################################################
Private Sub Project_Active()
'init CEL Object to get the CelItemAdded event
Set zCEL = thisProject.Cel
End Sub
Private Sub Project_Inactive()
'release object
Set zCEL = Nothing
End Sub
'##########################################################
'### Procedures/Events for the CEL DynPicture ###
'##########################################################
Private Sub zCEL_CelItemAdded(ByVal obItem As ICelItem)
'when a new entry was generated....
Debug.Print "CelItemAdded - " & obItem.Text
End Sub


CelItemCommentChanged
ObjectModel COM [image] Cel [image] Events [image] CelItemCommentChanged
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsText as BSTR

Example
C#
Copy
private ICel zenonCel;

void ThisProject_Active()
{
    this.zenonCel = this.Cel();
    this.zenonCel.CelItemCommentChanged += new CelItemCommentChangedEventHandler(zenonCel_CelItemCommentChanged);
}

void zenonCel_CelItemCommentChanged(ref string bsText)
{
    System.Diagnostics.Debug.Print("New CEL Comment: " + bsText);
    //Note: bsText may be edited in this method since its passed by reference
}

void ThisProject_Inactive()
{
    this.zenonCel.CelItemCommentChanged -= new CelItemCommentChangedEventHandler(zenonCel_CelItemCommentChanged);
    this.zenonCel = null;
    FreeObjects();
}
VB.NET
Copy
Private zenonCel As ICel

Private Sub ThisProject_Active()
    Me.zenonCel = Me.Cel()
    AddHandler Me.zenonCel.CelItemCommentChanged, AddressOf zenonCel_CelItemCommentChanged
End Sub

Private Sub zenonCel_CelItemCommentChanged(ByRef bsText As String)
    System.Diagnostics.Debug.Print("New CEL Comment: " & bsText)
    'Note: bsText may be edited in this method since its passed by reference
End Sub

Private Sub ThisProject_Inactive()
    RemoveHandler Me.zenonCel.CelItemCommentChanged, AddressOf zenonCel_CelItemCommentChanged
    Me.zenonCel = Nothing
    FreeObjects()
End Sub


CelListSelectionChanged
ObjectModel COM [image] Cel [image] Events [image] CelListSelectionChanged
Remarks

The event will be fired whenever the Selection in the list is changed, when an item is selected the Entry will be passed on through the zenon-API. When an item has been deselected, the eventparameter will be "Nothing".Additionally the event will be triggered whenever an AML/CEL picture is closed. (This could lead the event being triggered twice with "Nothing").NOTE: When the Property "hide current selection" has been set at the listcontrol, the event will/should not be fired(!)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
obItem as ICelItem

Returns the added CelItem as Object.

Example
C#
Copy
private ICel zenonCel;
private IDynPicture zenonCelPicture;
private bool celFlag = false;

void ThisProject_Inactive()
{
    this.zenonCelPicture.Open -= new OpenEventHandler(zenonCelPicture_Open);
    this.zenonCelPicture = null;
    if (this.zenonCel != null)
    {
        this.zenonCel.CelListSelectionChanged -= new CelListSelectionChangedEventHandler(zenonCel_CelListSelectionChanged);
        this.zenonCel = null;
    }
    FreeObjects();
}

void zenonCelPicture_Open()
{
    celFlag = true;
    zenonCel = this.Cel();
    zenonCel.CelListSelectionChanged += new CelListSelectionChangedEventHandler(zenonCel_CelListSelectionChanged);
}

void zenonCel_CelListSelectionChanged(ICelItem obItem)
{
    if (celFlag == true)
        celFlag = false;
    else
        System.Diagnostics.Debug.Print("C_Changed - " + obItem.Text);
}

void ThisProject_Active()
{
    //Initialize screen objects to get Open/Close events of the screen
    this.zenonCelPicture = this.DynPictures().Item("CEL");
    this.zenonCelPicture.Open += new OpenEventHandler(zenonCelPicture_Open);
}
VB.NET
Copy
Private zenonCel As ICel
Private zenonCelPicture As IDynPicture
Private celFlag As Boolean = False

Private Sub ThisProject_Inactive()
    RemoveHandler Me.zenonCelPicture.Open, AddressOf zenonCelPicture_Open
    Me.zenonCelPicture = Nothing
    If Me.zenonCel IsNot Nothing Then
        RemoveHandler Me.zenonCel.CelListSelectionChanged, AddressOf zenonCel_CelListSelectionChanged
        Me.zenonCel = Nothing
    End If
    FreeObjects()
End Sub

Private Sub zenonCelPicture_Open()
    celFlag = True
    zenonCel = Me.Cel()
    AddHandler Me.zenonCel.CelListSelectionChanged, AddressOf zenonCel_CelListSelectionChanged
End Sub

Private Sub zenonCel_CelListSelectionChanged(obItem As ICelItem)
    If celFlag = True Then
        celFlag = False
    Else
        System.Diagnostics.Debug.Print("C_Changed - " & Convert.ToString(obItem.Text))
    End If
End Sub

Private Sub ThisProject_Active()
    'Initialize screen objects to get Open/Close events of the screen
    Me.zenonCelPicture = Me.DynPictures().Item("CEL")
    AddHandler Me.zenonCelPicture.Open, AddressOf zenonCelPicture_Open
End Sub
VBA
Copy
Dim WithEvents zCELPIC As DynPicture
Dim WithEvents zCEL As Cel
Dim bCEL As Boolean
'##########################################################
'### Procedures/Events of the Project ###
'##########################################################
Private Sub Project_Active()
'set this object to get the Picture Open/Close Events...
Set zCELPIC = thisProject.DynPictures.Item("CELPICTURENAME")
End Sub
Private Sub Project_Inactive()
'release object
Set zCELPIC = Nothing
End Sub
'##########################################################
'### Procedures/Events for the CEL DynPicture ###
'##########################################################
Private Sub zCELPIC_Open()
'boolen flag to remember the open event
bCEL = True
'init CEL Object to get the CelListSelectionChanged event
Set zCEL = thisProject.Cel
End Sub
Private Sub zCELPIC_Close()
'release object
Set zCEL = Nothing
End Sub
'##########################################################
'### Procedures/Events for the ChronologicalEventList ###
'##########################################################
Private Sub zCEL_CelListSelectionChanged(ByVal obItem As ICelItem)
'If the boolen is TRUE, the first events can be ignored
'because in this case the events returns the default
'selection on opening the picture
If bCEL = True Then

bCEL = False
Else

If obItem Is Nothing Then Exit Sub

Debug.Print "SelectionChanged - " & obItem.Text
End If
End Sub


SelectionChangedEx
ObjectModel COM [image] Cel [image] Events [image] SelectionChangedEx
Remarks

Fired when the selection changes in CEL.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
arrSelection as LPVARIANT

Example
C#
Copy
void ThisProject_Active()
{
    this.zenonCel = this.Cel();
    this.zenonCel.SelectionChangedEx += new SelectionChangedExEventHandler(zenonCel_SelectionChangedEx);
}

void zenonCel_SelectionChangedEx(ref object arrSelection)
{
    if (arrSelection == null)
        return;

    //One or more items have been selected
    object[] selectedItems = (object[]) arrSelection;
    for (int i = 0; i < selectedItems.Length; ++i)
    {
        ICelItem item = (ICelItem)selectedItems[i];
        System.Diagnostics.Debug.Print(item.Text);
    }

}

void ThisProject_Inactive()
{
    this.zenonCel.SelectionChangedEx -= new SelectionChangedExEventHandler(zenonCel_SelectionChangedEx);
    this.zenonCel = null;
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    Me.zenonCel = Me.Cel()
    AddHandler Me.zenonCel.SelectionChangedEx, AddressOf zenonCel_SelectionChangedEx
End Sub

Private Sub zenonCel_SelectionChangedEx(ByRef arrSelection As Object)
    If arrSelection Is Nothing Then
        Return
    End If

    'One or more items have been selected
    Dim selectedItems As Object() = DirectCast(arrSelection, Object())
    For i As Integer = 0 To selectedItems.Length - 1
        Dim item As ICelItem = DirectCast(selectedItems(i), ICelItem)
        System.Diagnostics.Debug.Print(item.Text)
    Next

End Sub

Private Sub ThisProject_Inactive()
    RemoveHandler Me.zenonCel.SelectionChangedEx, AddressOf zenonCel_SelectionChangedEx
    Me.zenonCel = Nothing
    FreeObjects()
End Sub
VBA
Copy
Private WithEvents MyEvents As Cel
Private Sub MyEvents_SelectionChangedEx(arrSelection As Variant)
Dim i As Integer
Dim zCelEntry As CelItem
Stop
If IsEmpty(arrSelection) Then Exit Sub
For i = 0 To UBound(arrSelection)
    Set zCelEntry = arrSelection(i)
    Debug.Print zCelEntry.Text
Next i
End Sub
Private Sub Project_Active()
Set MyEvents = thisProject.Cel
End Sub


DynProperties
ObjectModel COM [image] Cel [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

CEL


CEL
ObjectModel COM [image] Cel [image] DynProperties [image] CEL
Overview
External Name | Type | Display Name | Description
QueryFilter | Node | QueryFilter | Node


CD_CCelFilter
ObjectModel COM [image] Cel [image] DynProperties [image] CEL [image] CD_CCelFilter
Overview
External Name | Type | Display Name | Description
Areas | String | Areas |
Classes | String | Classes | "Filters for alarm classes, where system messages are marked out, as they are not linked to a variable. Multiple class numbers have to be seperated with a semicolon. zFct.DynProperties(""PictFilter.Classes"") = ""1;2;"""
EditableInRT | Bool | EditableInRT | Description as text.
EntriesCount | UInt16 | EntriesCount | "Specifies the maximum amount of entries that should be filtered from a file. Hint: Only available, if the DynProperty ""IsFromFiles"" is set TRUE."
FileName | String | FileName | With this property you get/set the file name for the different export mechanism.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
FilterTitel | String | FilterTitel | "Filters for the identifictaion of variables, where system messages are masked out, as they are not linked to a variable. Wildcards can be used here. Default = ""*"""
Font | UInt16 | Font | "Specifies the font that should be used. The parameter that is passed, is the index of the font within the specified font list. 0 = Standard font 1 = Default font 1 ... 5 = Default font 5 6 = User specified font 1 ... = etc. "
Groups | String | Groups | "Filters for alarm groups, where system messages are marked out, as they are not linked to a variable. Multiple group numbers have to be seperated with a semicolon. zFct.DynProperties(""PictFilter.Groups"") = ""1;2;"""
IncTime | UInt32 | IncTime | "Gets or sets the minimal time for current alarms in seconds. Hint: Milliseconds can be specified with the ""mSeconds"" DynProperty."
IsAcknowledged | Bool | IsAcknowledged | "Filters unacknowledged alarms, if set TRUE."
IsAML | Bool | IsAML | "Prints the alarm list, if set TRUE. Otherwise the CEL list will be printed."
IsAscentOnly | Bool | IsAscentOnly | "Prints only current alarms, if set TRUE."
IsAutoName | Bool | IsAutoName |
IsDBASE | Bool | IsDBASE |
IsFilterExp | Bool | IsFilterExp | "Opens the list stopped, if set TRUE. "
IsFilterRT | Bool | IsFilterRT | "Displays the configuration dialog within the runtime, if set TRUE."
IsFromFiles | Bool | IsFromFiles | "Filter is applied to file entries, if set TRUE. Otherwise, the filter is applied to the entries from the memory. Hint: The maximum amount of entries which should be filtered from the file is specified by the ""EntriesCount"" DynProperty."
IsGoneOnly | Bool | IsGoneOnly |
IsIncremental | Bool | IsIncremental |
IsMatchCase | Bool | IsMatchCase | "Filter is case sensitive, if set TRUE. Otherwise the case sensitivity is ignored."
IsReadAll | Bool | IsReadAll |
IsRelationTime | Bool | IsRelationTime | "Display of relative times (relative to selected entries), if set TRUE."
IsSQL | Bool | IsSQL |
IsUnicode | Bool | IsUnicode |
IsXML | Bool | IsXML |
ListInfo | Node | ListInfo | Node
mSeconds | UInt16 | mSeconds | "Gets or sets the milliseconds in addition to the ""IncTime"" DynProperty."
NeedAlarmCause | Bool | NeedAlarmCause | Description
NeedComment | Bool | NeedComment |
ProjectNames | String | ProjectNames | "Specifies the names of the projects. Multiple project names are seperated with a semicolon. zFct.DynProperties(""PictFilter.ProjectNames"") = ""PROJECT1;PROJECT2;"""
ResString | String | ResString |
RTMDIFilterScreen | Node | RTMDIFilterScreen | Node
ShowSysEntriesForever | Bool | ShowSysEntriesForever | Description
SQLBase | String | SQLBase |
SQLTable | String | SQLTable |
StatusFilter | Node | StatusFilter | Node
SystemModelGroup | Node | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
TextFilter | Node | TextFilter | Node
TimeFilter | Node | TimeFilter | Node
VarFilter | String | VarFilter | "Filters for variable names, where system messages are masked out, as they are not linked to a variable. Wildcards can be used here. Default = ""*"" (All variables)"


CD_CAmlCelListInfo
ObjectModel COM [image] Cel [image] DynProperties [image] CEL [image] CD_CCelFilter [image] CD_CAmlCelListInfo
Overview
External Name | Type | Display Name | Description
Acknowledged | String | Acknowledged | "Specifies the header text (column title) for the option ""Time acknowledged"" (DynProperty ""Entry"" option ""5"")."
AktText | String | AktText | "Specifies the header text (column title) for the option ""User text"" (DynProperty ""Entry"" option ""D"")."
AlarmCount | Int16 | AlarmCount | "Specifies the number of characters for text entries, for the option ""Text"" (DynProperty ""Entry"" option ""2"")."
Area | String | Area |
AreaAnz | Int16 | AreaAnz |
AreaNr | String | AreaNr |
AreaNrAnz | Int16 | AreaNrAnz |
Cause | String | Cause | Description
CauseAnz | Int16 | CauseAnz | Description
Class | String | Class | "Specifies the header text (column title) for the option ""Class"" (DynProperty ""Entry"" option ""F"")."
ClassCount | Int16 | ClassCount | "Specifies the number of characters for text entries, for the option ""Class"" (DynProperty ""Entry"" option ""F"")."
ClassNr | String | ClassNr | "Specifies the header text (column title) for the option ""ClassNr"" (DynProperty ""Entry"" option ""J"")."
ClassNrCount | Int16 | ClassNrCount | "Specifies the number of characters for text entries, for the option ""ClassNo"" (DynProperty ""Entry"" option ""J"")."
ClassSymbol | String | ClassSymbol |
ClassSymbolAnz | Int16 | ClassSymbolAnz |
ClassSymbolStyle | Int16 | ClassSymbolStyle |
Color1 | UInt32 | Color1 |
Color2 | UInt32 | Color2 |
Comes | String | Comes | "Specifies the header text (column title) for the option ""Time received"" (DynProperty ""Entry"" option ""3"")."
ComesAnz | Int16 | ComesAnz |
ComingTimeExtern | String | ComingTimeExtern | Description
ComingTimeExternWidth | Int16 | ComingTimeExternWidth | Description
ComingTimeIntern | String | ComingTimeIntern | Description
ComingTimeInternWidth | Int16 | ComingTimeInternWidth | Description
CompCount | Int16 | CompCount | "Specifies the number of characters for text entries, for the option ""Computer"" (DynProperty ""Entry"" option ""9"")."
Computer | String | Computer | "Specifies the header text (column title) for the option ""Computer"" (DynProperty ""Entry"" option ""9"")."
EditableInRT | Bool | EditableInRT | Description as text.
Entry | String | Entry | "Defines which formatting options are activated. Activation is done by passing a string with the corresponding option values (see table). ATTENTION: The formatting is produced in the sequence of the option activation, i.e. as specified within the string from left to right. Activate formatting options in following order: Variable name, Time received, Value, Text, User text zFct.DynProperties(""PictFilter.ListInfo.Entry"") = ""0372D"""
EntryAll | String | EntryAll |
EquipmentModelGroup | String | EquipmentModelGroup | Description
EquipmentModelGroupWidth | Int16 | EquipmentModelGroupWidth | Description
FilterPartGUID | Guid | FilterPartGUID | Description as text.
Goes | String | Goes | "Specifies the header text (column title) for the option ""Time cleared"" (DynProperty ""Entry"" option ""4"")."
GoesAnz | Int16 | GoesAnz |
Group | String | Group | "Specifies the header text (column title) for the option ""Group"" (DynProperty ""Entry"" option ""G"")."
GroupCount | Int16 | GroupCount | "Specifies the number of characters for text entries, for the option ""Group"" (DynProperty ""Entry"" option ""G"")."
GroupNr | String | GroupNr | "Specifies the header text (column title) for the option ""GroupNr"" (DynProperty ""Entry"" option ""I"")."
GroupNrCount | Int16 | GroupNrCount | "Specifies the number of characters for text entries, for the option ""GroupNo"" (DynProperty ""Entry"" option ""I"")."
GroupsSymbol | String | GroupsSymbol |
GroupSymbolAnz | Int16 | GroupSymbolAnz |
GroupSymbolStyle | Int16 | GroupSymbolStyle |
IsDate | Bool | IsDate | "Specifies, if the time options should be displayed with the date, when the values were recorded. Hint:Only available, if one of the following options has been enabled within DynProperty ""Entry"": ""Time received"", ""Time cleared"", ""Time acknowledged"" and/or ""Time reactivated"""
IsDynLimitFile | Bool | IsDynLimitFile |
IsMicroSeconds | Bool | IsMicroSeconds | Description
IsMilliseconds | Bool | IsMilliseconds | "Specifies, if the time options should be displayed with the milliseconds, when the values were recorded. Hint:Only available, if one of the following options has been enabled within DynProperty ""Entry"": ""Time received"", ""Time cleared"", ""Time acknowledged"" and/or ""Time reactivated"""
IsTime | Bool | IsTime | "Specifies, if the time options should be displayed with the time, when the values were recorded. Hint:Only available, if one of the following options has been enabled within DynProperty ""Entry"": ""Time received"", ""Time cleared"", ""Time acknowledged"" and/or ""Time reactivated"""
LeavingTimeExtern | String | LeavingTimeExtern | Description
LeavingTimeExternWidth | Int16 | LeavingTimeExternWidth | Description
LeavingTimeIntern | String | LeavingTimeIntern | Description
LeavingTimeInternWidth | Int16 | LeavingTimeInternWidth | Description
Name | String | Name | "Specifies the header text (column title) for the option ""Variable name"" (DynProperty ""Entry"" option ""0"")."
Project | String | Project | "Specifies the header text (column title) for the option ""Project name"" (DynProperty ""Entry"" option ""E"")."
ProjectCount | Int16 | ProjectCount | "Specifies the number of characters for text entries, for the option ""Project name"" (DynProperty ""Entry"" option ""E"")."
QuitAnz | Int16 | QuitAnz |
ReactionCountAnz | Int16 | ReactionCountAnz |
ReactionStatAnz | Int16 | ReactionStatAnz |
ReactionTimeAnz | Int16 | ReactionTimeAnz |
ReactivationTimeExtern | String | ReactivationTimeExtern | Description
ReactivationTimeExternWidth | Int16 | ReactivationTimeExternWidth | Description
ReactivationTimeIntern | String | ReactivationTimeIntern | Description
ReactivationTimeInternWidth | Int16 | ReactivationTimeInternWidth | Description
ReaktCount | String | ReaktCount | "Specifies the header text (column title) for the option ""Number reactivated"" (DynProperty ""Entry"" option ""B"")."
ReaktStat | String | ReaktStat | "Specifies the header text (column title) for the option ""State reactivated"" (DynProperty ""Entry"" option ""C"")."
ReaktTime | String | ReaktTime | "Specifies the header text (column title) for the option ""Time reactivated"" (DynProperty ""Entry"" option ""A"")."
ResourceLabel | String | ResourceLabel |
ResourceLabelAnz | Int16 | ResourceLabelAnz |
RTextCount | Int16 | RTextCount | "Specifies the number of characters for text entries, for the option ""User text"" (DynProperty ""Entry"" option ""D"")."
ShowGrid | Bool | ShowGrid |
SortDescending | Bool | SortDescending |
StatCount | Int16 | StatCount | "Specifies the number of characters for text entries, for the option ""Status"" (DynProperty ""Entry"" option ""6"")."
Status | String | Status | "Specifies the header text (column title) for the option ""Status"" (DynProperty ""Entry"" option ""6"")."
StatusCaption | String | StatusCaption |
StatusCaptionNr | Int16 | StatusCaptionNr |
StatusStyle | Int16 | StatusStyle |
Stop | String | Stop | "Specifies the header text (column title) for the option ""Time active"" (DynProperty ""Entry"" option ""H"")."
SystemModel | String | SystemModel | Description
TagCount | Int16 | TagCount | "Specifies the number of characters for text entries, for the option ""Identification"" (DynProperty ""Entry"" option ""1"")."
TagNr | String | TagNr | "Specifies the header text (column title) for the option ""Identification"" (DynProperty ""Entry"" option ""1"")."
Text | String | Text | "Specifies the header text (column title) for the option ""Text"" (DynProperty ""Entry"" option ""2"")."
TimeLastingAnz | Int16 | TimeLastingAnz |
Unit | String | Unit |
UnitAnz | Int16 | UnitAnz |
UseOptionalColors | Bool | UseOptionalColors |
User | String | User | "Specifies the header text (column title) for the option ""User identifier"" (DynProperty ""Entry"" option ""8"")."
UserCount | Int16 | UserCount | "Specifies the number of characters for text entries, for the option ""User identifier"" (DynProperty ""Entry"" option ""8"")."
UserName | String | UserName | "Specifies the header text (column title) for the option ""Complete name"" (DynProperty ""Entry"" option ""K"")."
UserNameCount | Int16 | UserNameCount | "Specifies the number of characters for text entries, for the option ""Complete name"" (DynProperty ""Entry"" option ""K"")."
ValCount | Int16 | ValCount | "Specifies the number of characters for text entries, for the option ""Value"" (DynProperty ""Entry"" option ""7"")."
Value | String | Value | "Specifies the header text (column title) for the option ""Value"" (DynProperty ""Entry"" option ""7"")."
VarCount | Int16 | VarCount | "Specifies the number of characters for text entries, for the option ""Variable name"" (DynProperty ""Entry"" option ""0"")."


CD_CZeitFilter
ObjectModel COM [image] Cel [image] DynProperties [image] CEL [image] CD_CCelFilter [image] CD_CZeitFilter
Overview
External Name | Type | Display Name | Description
AddLen | UInt16 | AddLen | "Specifies if the length value (""Length"" DynProperty) should be added or subtracted. 0 = Subtract length 1 = Add length "
ARVTime1 | UInt32 | ARVTime1 | "Specifies the start time of the filter. zFct.DynProperties(""Filter.TimeFilter.ARVTime1"") = CDate(""30.07.2007 12:00:00"")"
ARVTime2 | UInt32 | ARVTime2 | Specifies the end time of the filter.
BoxenType | UInt16 | BoxenType |
ChargeFilter | Node | ChargeFilter | Batch filter settings
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
Length | UInt32 | Length | "Specifies the value of the length (in seconds) that should be added or subtracted (see ""AddLen"" DynProperty)."
ModifyTimePeriod | Bool | ModifyTimePeriod |
Offset | UInt32 | Offset | "Specifies the offset (in seconds) for the ""BoxType"" DynProperty option 1 to 8."
Options | UInt16 | Options |
ResString | String | ResString |
ShiftFilter | Node | ShiftFilter | Description
TimeFormat | UInt16 | TimeFormat | "Specifies the time format for the filter. ATTENTION: Can only be used, if ""BoxType"" DynProperty is set to 0. 10 = Time relative 12 = Absolute time 14 = From the specified day 20 = From month 22 = From year 25 = All "


CD_CChargenFilter
ObjectModel COM [image] Cel [image] DynProperties [image] CEL [image] CD_CCelFilter [image] CD_CZeitFilter [image] CD_CChargenFilter
Overview
External Name | Type | Display Name | Description
ArchiveName | String | ArchiveName |
ArchiveNameFilterType | UInt16 | ArchiveNameFilterType |
ArchiveNameFilterVar | CProjektVariable | ArchiveNameFilterVar | Description as text.
ArvLotList | String | ArvLotList | In the runtime you can access the lot filter via the zenon API using the DynProperty "ArvLotList". It is available on the AML, CEL, Reportviewer and Reportgenerator screen. It returns an array which includes the filtered lots and the equipment model formatted as follows:{{lot-name1;archive-name1;start1;end1;{equipment11;equipment12;…}};{{lot-name2;archive-name2;start2;end2;{equipment21;equipment22;…}};…}.
ChargenNameFilterType | UInt16 | ChargenNameFilterType | Description as text.
ChargenNameFilterVar | CProjektVariable | ChargenNameFilterVar | Description as text.
ChargeRelative | Bool | ChargeRelative |
Count | UInt32 | Count | "Specifies how many last closed batches are displayed. Hint: Only available, if DynProperty ""LastCharge"" is set to 1."
DoneLots | Bool | DoneLots |
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
LotName | String | LotName |
OpenLots | Bool | OpenLots |
RTMDIFilterScreen | Node | RTMDIFilterScreen | Description
State | SByte | State |
TimeFilterType | SByte | TimeFilterType |
TimeLimits | UInt16 | TimeLimits | "Specifies the time limits for the batches: 0 = Outside: Batches that only lie partially within the time limit are fully enclosed. 1 = Inside: Batches that only lie partially within the time limit are not enclosed. 2 = From outside: Batches that started before the time limit are fully enclosed. Batches that end after the time limit are not enclosed. 3 = To outside: Batches that end after the time limit are fully enclosed. Batches that started before the time limit are not enclosed. 4 = Cut: Variables of batches that only partially lie within the time. Hint: Only available, if DynProperty ""LastCharge"" is set to 0."


CRelPicItem
ObjectModel COM [image] Cel [image] DynProperties [image] CEL [image] CD_CCelFilter [image] CD_CZeitFilter [image] CD_CChargenFilter [image] CRelPicItem
Overview
External Name | Type | Display Name | Description
RelatedPicture | String | Screen for time filter |


CShiftFilter
ObjectModel COM [image] Cel [image] DynProperties [image] CEL [image] CD_CCelFilter [image] CD_CZeitFilter [image] CShiftFilter
Overview
External Name | Type | Display Name | Description
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.


CSystemModelFilter
ObjectModel COM [image] Cel [image] DynProperties [image] CEL [image] CD_CCelFilter [image] CD_CZeitFilter [image] CShiftFilter [image] CSystemModelFilter
Overview
External Name | Type | Display Name | Description
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
SystemModelGroup | CD_CMemFile | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .


CRelPicItem
ObjectModel COM [image] Cel [image] DynProperties [image] CEL [image] CD_CCelFilter [image] CRelPicItem
Overview
External Name | Type | Display Name | Description
RelatedPicture | String | Screen for time filter |


CStatusFilter
ObjectModel COM [image] Cel [image] DynProperties [image] CEL [image] CD_CCelFilter [image] CStatusFilter
Overview
External Name | Type | Display Name | Description
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
Status | UInt64 | Status |
StatusMask | UInt64 | StatusMask |


CSystemModelFilter
ObjectModel COM [image] Cel [image] DynProperties [image] CEL [image] CD_CCelFilter [image] CSystemModelFilter
Overview
External Name | Type | Display Name | Description
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
SystemModelGroup | CD_CMemFile | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .


CTextFilter
ObjectModel COM [image] Cel [image] DynProperties [image] CEL [image] CD_CCelFilter [image] CTextFilter
Overview
External Name | Type | Display Name | Description
Condition | UInt16 | Condition |
EditableInRT | Bool | EditableInRT | Description as text.
Expression | String | Expression |
FilterPartGUID | Guid | FilterPartGUID | Description as text.
IsFilterActive | Bool | IsFilterActive |
IsMatchCase | Bool | IsMatchCase |
IsSubFind | Bool | IsSubFind |


CelItem
ObjectModel COM [image] CelItem
Remarks

This object deliveres all information stored with the cel item...You can read this like shown in the Sample, but ther some more, like the Username, the Computer, Value or something else...

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroGetAllCelItems()
{
    //Print text for each item
    for (int i = 0; i < this.Cel().CelItems("*").Count; ++i )
        System.Diagnostics.Debug.Print(this.Cel().CelItems("*").Item(i).Text);
}
VB.NET
Copy
Public Sub MacroGetAllCelItems()
    'Print text for each item
    For i As Integer = 0 To Me.Cel().CelItems("*").Count - 1
        System.Diagnostics.Debug.Print(Me.Cel().CelItems("*").Item(i).Text)
    Next
End Sub
VBA
Copy
'##########################################################
'### Get all CEL Items of the project ###
'##########################################################
Public Sub GetAllItems()
Dim i As Integer
Dim zCItem As CelItem
'get all items in memory...
For i = 0 To thisProject.Cel.CelItems("*").Count - 1

'set object to a specific item...

Set zCItem = thisProject.Cel.CelItems("*").Item(i)

'print time, text, Variablename and User-Comment of item to outputwindow

Debug.Print "Time: " & zCItem.Time

Debug.Print "Text: " & zCItem.Text

Debug.Print "Variable: " & zCItem.VariableName

Debug.Print "Comment: " & zCItem.Comment

Debug.Print "-----------------------------"
Next i
End Sub


Properties
ObjectModel COM [image] CelItem [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Class | short | Returns the class | Unused | Readonly | Available | Available
Comment | bstr | Returns the comment | Unused | Available | Available | Available
Computer | bstr | Returns the computer name | Unused | Readonly | Available | Available
Group | short | Returns the group | Unused | Readonly | Available | Available
Status | long | Returns the status. | Unused | Readonly | Available | Available
Tagname | bstr | Returns the tag name of the variable. | Unused | Readonly | Available | Available
Text | bstr | Returns the text | Unused | Readonly | Available | Available
Time | date | Returns the time | Unused | Readonly | Available | Available
User | bstr | Returns the user | Unused | Readonly | Available | Available
Value | variant | Returns the value | Unused | Readonly | Available | Available
VariableName | bstr | Returns the name of the variable | Unused | Readonly | Available | Available


Class
ObjectModel COM [image] CelItem [image] Properties [image] Class
Remarks

Alarm/CEL class as number (the number which was set in the Alarm/CEL configuration...

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Comment
ObjectModel COM [image] CelItem [image] Properties [image] Comment
Remarks

A comment which can be changed by the user...

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Computer
ObjectModel COM [image] CelItem [image] Properties [image] Computer
Remarks

The Computername, where the Entry was raised...

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Group
ObjectModel COM [image] CelItem [image] Properties [image] Group
Remarks

Alarm/CEL group as number (the number which was set in the Alarm/CEL configuration...

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Status
ObjectModel COM [image] CelItem [image] Properties [image] Status
Remarks

Returns the status.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Tagname
ObjectModel COM [image] CelItem [image] Properties [image] Tagname
Remarks

Returns the tag name of the variable.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Text
ObjectModel COM [image] CelItem [image] Properties [image] Text
Remarks

The Text of the actual entry...

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] CelItem [image] Properties [image] Time
Remarks

The time when the entry was created... The Time is given as Double, but if you print it out, you will get the Date/Time format of the system...

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


User
ObjectModel COM [image] CelItem [image] Properties [image] User
Remarks

The user who was logged in during the entry has been added....

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Value
ObjectModel COM [image] CelItem [image] Properties [image] Value
Remarks

The Value of the Variable...

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


VariableName
ObjectModel COM [image] CelItem [image] Properties [image] VariableName
Remarks

The Name of the Variable as string

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


CelItems
ObjectModel COM [image] CelItems
Remarks

With this object it is possible to get all CEL entries which are in memory. You are able to read all properties of each item...Hint:The Filter should be set always like "*", because this feature is implemented for future and does not work for now.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroGetAllCelItems()
{
    //Print text for each item
    for (int i = 0; i < this.Cel().CelItems("*").Count; ++i )
        System.Diagnostics.Debug.Print(this.Cel().CelItems("*").Item(i).Text);
}
VB.NET
Copy
Public Sub MacroGetAllCelItems()
    'Print text for each item
    For i As Integer = 0 To Me.Cel().CelItems("*").Count - 1
        System.Diagnostics.Debug.Print(Me.Cel().CelItems("*").Item(i).Text)
    Next
End Sub
VBA
Copy
'##########################################################
'### Get all CEL Items of the project ###
'##########################################################
Public Sub GetAllItems()
Dim i As Integer
'get all items in memory...
For i = 0 To thisProject.Cel.CelItems("*").Count - 1

'print text of item to outputwindow

Debug.Print thisProject.Cel.CelItems("*").Item(i).Text
Next i
End Sub
'get specific item using the screen switch function as filter
'thisProject.Cel.CelItems("myFunction").Count - 1


Properties
ObjectModel COM [image] CelItems [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the amount of CelItems | Readonly | Readonly | Available | Available
Parent | icel | Parent-object | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] CelItems [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] CelItems [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
ICel

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] CelItems [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Item | icelitem | Returns the CelItem at the given index. | Available | Unused | Available | Available


Item
ObjectModel COM [image] CelItems [image] Methods [image] Item
Remarks

To get a defined entry of the List.You can read all available properties like the Text or the Name of the linked Variable, the Username and so on...

Datatype
ICelItem

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT

Index of the Celitem to be returned.


ColorPalettes
ObjectModel COM [image] ColorPalettes
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroReadColorPaletteDynProperties()
{
    /*
     * ColorPalettes are accessed via DynamicProperties, a list of those can be found in the help file
     * Or you can display them via the Method get_DynPropertiesEnum("name");
     * The following example shows how to read some of the dynamic properties
     */

    IColorPalettes zenonPalettes = this.ActiveDocument.ColorPalettes();
    uint count = (uint)zenonPalettes.get_DynProperties("Palette[-1]");
    for (int i = 0; i < count; ++i)
    {
        //Get the palette name as string
        string name = (string)zenonPalettes.get_DynProperties("Palette[" + i.ToString() + "].PaletteName");
        //Get the palette entries as string
        string entries = (string)zenonPalettes.get_DynProperties("Palette[" + i.ToString() + "].PaletteColors");
        //Print result
        System.Diagnostics.Debug.Print("{0}: {1}", name, entries);
    }
}

public void MacroWriteColorPaletteDynProperties()
{
    /*
     * ColorPalettes are accessed via DynamicProperties, a list of those can be found in the help file
     * Or you can display them via the Method get_DynPropertiesEnum("name");
     * The following example shows how to write some of the dynamic properties
     */

    IColorPalettes zenonPalettes = this.ActiveDocument.ColorPalettes();
    //Create a new palette for example
    zenonPalettes.CreateDynProperty("Palette");
    //Define two colors for the new palette
    string colors = "#FF0000;#0000FF";
    uint count = (uint)zenonPalettes.get_DynProperties("Palette[-1]");
    zenonPalettes.set_DynProperties("Palette[" + (count - 1).ToString() + "].PaletteColors", colors);
    zenonPalettes.set_DynProperties("Palette[" + (count - 1).ToString() + "].PaletteName", "VSTA_Test_Palette");
}
VB.NET
Copy
Public Sub MacroReadColorPaletteDynProperties()
    '
'     * ColorPalettes are accessed via DynamicProperties, a list of those can be found in the help file
'     * Or you can display them via the Method get_DynPropertiesEnum("name");
'     * The following example shows how to read some of the dynamic properties
'

    Dim zenonPalettes As IColorPalettes = Me.ActiveDocument.ColorPalettes()
    Dim count As UInteger = CUInt(zenonPalettes.get_DynProperties("Palette[-1]"))
    For i As Integer = 0 To count - 1
        'Get the palette name as string
        Dim name As String = DirectCast(zenonPalettes.get_DynProperties("Palette[" & i.ToString() & "].PaletteName"), String)
        'Get the palette entries as string
        Dim entries As String = DirectCast(zenonPalettes.get_DynProperties("Palette[" & i.ToString() & "].PaletteColors"), String)
        'Print result
        System.Diagnostics.Debug.Print("{0}: {1}", name, entries)
    Next
End Sub

Public Sub MacroWriteColorPaletteDynProperties()
    '
'     * ColorPalettes are accessed via DynamicProperties, a list of those can be found in the help file
'     * Or you can display them via the Method get_DynPropertiesEnum("name");
'     * The following example shows how to write some of the dynamic properties
'

    Dim zenonPalettes As IColorPalettes = Me.ActiveDocument.ColorPalettes()
    'Create a new palette for example
    zenonPalettes.CreateDynProperty("Palette")
    'Define two colors for the new palette
    Dim colors As String = "#FF0000;#0000FF"
    Dim count As UInteger = CUInt(zenonPalettes.get_DynProperties("Palette[-1]"))
    zenonPalettes.set_DynProperties("Palette[" & (count - 1).ToString() & "].PaletteColors", colors)
    zenonPalettes.set_DynProperties("Palette[" & (count - 1).ToString() & "].PaletteName", "VSTA_Test_Palette")
End Sub
VBA
Copy
Sub Read_ColorPalettes_DynProps()
Dim zPRJ As Project
Dim vProps As Variant
Dim i As Integer
Set zPRJ = MyWorkspace.ActiveDocument
'get all DynProperties of the actual object (ColorPalettes)
vProps = zPRJ.ColorPalettes.DynPropertiesEnum("")
'Print informations of DynProperties into output window
For i = 0 To UBound(vProps)

Debug.Print vProps(i)
Next i
'Result:
'Palette,SUBITEM,Palette,
'ColorNames,String,Color name,
vProps = zPRJ.ColorPalettes.DynPropertiesEnum("Palette")
'Print informations of DynProperties into output window
For i = 0 To UBound(vProps)

Debug.Print vProps(i)
Next i
'Result:
'PaletteColors,String,Colors of the palette,
'PaletteName,String,Palette name,
Debug.Print zPRJ.ColorPalettes.DynProperties("ColorNames")
'Result:
'Color_01;Color_02;Color_03;Color_04;Colo5_05;
For i = 0 To zPRJ.ColorPalettes.DynProperties("Palette[-1]")

Debug.Print zPRJ.ColorPalettes.DynProperties("Palette[" & i & "].PaletteName")

Debug.Print zPRJ.ColorPalettes.DynProperties("Palette[" & i & "].PaletteColors")
Next i
'Result:
'Light
'#FFFFFF;#FFFF00;#FFC0CB;#AFEEEE;#00005E;
'Dark
'#000000;#0000FF;#8B0000;#388E8E;#E6E6FA;
'In the sample Project there were 2 colorpalettes with 5 colors each...
End Sub
Sub Write_ColorPalettes_DynProps()
Dim zPRJ As Project
Dim strColors As String
Dim nCount As Integer
Set zPRJ = MyWorkspace.ActiveDocument
'create a new ColorPalette
Call zPRJ.ColorPalettes.CreateDynProperty("Palette")
'define a set of 5 colors as a string...
strColors = "#FFEEDD;#FF8800;#FFC5DB;#AFFE12;#01205F;"
'get number of ColorPalettes
nCount = zPRJ.ColorPalettes.DynProperties("Palette[-1]")
'set name of Palette...
zPRJ.ColorPalettes.DynProperties("Palette[" & nCount - 1 & "].PaletteName") =

"VBA_Colors_" & nCount
'set defined colors...
zPRJ.ColorPalettes.DynProperties("Palette[" & nCount - 1 & "].PaletteColors") =

strColors

End Sub

Sub AddNewColor()
Dim zPRJ As Project
Dim vColors As Variant
Dim i As Integer
Dim strColor As String
Set zPRJ = MyWorkspace.ActiveDocument
'get actual color-names
vColors = Split(zPRJ.ColorPalettes.DynProperties("ColorNames"), ";")
For i = 0 To UBound(vColors) - 1

Debug.Print i & ": " & vColors(i)
Next i
'add a new Color...
strColor = zPRJ.ColorPalettes.DynProperties("ColorNames")
strColor = strColor & "Color_" & Format(UBound(vColors) + 1, "00") & ";"
zPRJ.ColorPalettes.DynProperties("ColorNames") = strColor

End Sub


Properties
ObjectModel COM [image] ColorPalettes [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the number of color palettes. | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] ColorPalettes [image] Properties [image] Count
Remarks

Returns the number of color palettes.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ColorPalettes [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateDynProperty | variant_bool |  | Available | Unused | Available | Available
DynProperties [GET] | variant |  | Available | Available | Available | Available
DynProperties [PUT] | void |  | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant |  | Readonly | Available | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Available | Available | Available
Export | variant_bool | Exports the selected object to a XML file. | Available | Unused | Available | Available
GetActivePaletteIndex | long | Returns the index of the currently active color palette. | Readonly | Readonly | Available | Available
GetPaletteColor | ole_color | Determines the value of the color of a color palette. | Available | Readonly | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index | Available | Unused | Available | Available


CreateDynProperty
ObjectModel COM [image] ColorPalettes [image] Methods [image] CreateDynProperty
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.
Example: "Palette"

Example
VBA
Copy
Sub Write_ColorPalettes_DynProps()
Dim zPRJ As Project
Dim strColors As String
Dim nCount As Integer
Set zPRJ = MyWorkspace.ActiveDocument
'create a new ColorPalette
Call zPRJ.ColorPalettes.CreateDynProperty("Palette")
'define a set of 5 colors as a string...
strColors = "#FFEEDD;#FF8800;#FFC5DB;#AFFE12;#01205F;"
'get number of ColorPalettes
nCount = zPRJ.ColorPalettes.DynProperties("Palette[-1]")
'set name of Palette...
zPRJ.ColorPalettes.DynProperties("Palette[" & nCount - 1 & "].PaletteName") = "VBA_Colors_" & nCount
'set defined colors...
zPRJ.ColorPalettes.DynProperties("Palette[" & nCount - 1 & "].PaletteColors") = strColors

End Sub

Sub AddNewColor()
Dim zPRJ As Project
Dim vColors As Variant
Dim i As Integer
Dim strColor As String
Set zPRJ = MyWorkspace.ActiveDocument
'get actual color-names
vColors = Split(zPRJ.ColorPalettes.DynProperties("ColorNames"), ";")
For i = 0 To UBound(vColors) - 1

Debug.Print i & ": " & vColors(i)
Next i
'add a new Color...
strColor = zPRJ.ColorPalettes.DynProperties("ColorNames")
strColor = strColor & "Color_" & Format(UBound(vColors) + 1, "00") & ";"
zPRJ.ColorPalettes.DynProperties("ColorNames") = strColor

End Sub


DynProperties [GET]
ObjectModel COM [image] ColorPalettes [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.
Example: "ColorNames"

Example
VBA
Copy
Sub Read_ColorPalettes_DynProps()
Dim zPRJ As Project
Dim vProps As Variant
Dim i As Integer
Set zPRJ = MyWorkspace.ActiveDocument
'get all DynProperties of the actual object (ColorPalettes)
vProps = zPRJ.ColorPalettes.DynPropertiesEnum("")
'Print informations of DynProperties into output window
For i = 0 To UBound(vProps)

Debug.Print vProps(i)
Next i
'Result:
'Palette,SUBITEM,Palette,
'ColorNames,String,Color name,
vProps = zPRJ.ColorPalettes.DynPropertiesEnum("Palette")
'Print informations of DynProperties into output window
For i = 0 To UBound(vProps)

Debug.Print vProps(i)
Next i
'Result:
'PaletteColors,String,Colors of the palette,
'PaletteName,String,Palette name,
Debug.Print zPRJ.ColorPalettes.DynProperties("ColorNames")
'Result:
'Color_01;Color_02;Color_03;Color_04;Colo5_05;
For i = 0 To zPRJ.ColorPalettes.DynProperties("Palette[-1]")

Debug.Print zPRJ.ColorPalettes.DynProperties("Palette[" & i & "].PaletteName")

Debug.Print zPRJ.ColorPalettes.DynProperties("Palette[" & i & "].PaletteColors")
Next i
'Result:
'Light
'#FFFFFF;#FFFF00;#FFC0CB;#AFEEEE;#00005E;
'Dark
'#000000;#0000FF;#8B0000;#388E8E;#E6E6FA;
'In the sample Project there were 2 colorpalettes with 5 colors each...
End Sub


DynProperties [PUT]
ObjectModel COM [image] ColorPalettes [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.
Example: "ColorNames"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

Example
VBA
Copy
Sub Write_ColorPalettes_DynProps()
Dim zPRJ As Project
Dim strColors As String
Dim nCount As Integer
Set zPRJ = MyWorkspace.ActiveDocument
'create a new ColorPalette
Call zPRJ.ColorPalettes.CreateDynProperty("Palette")
'define a set of 5 colors as a string...
strColors = "#FFEEDD;#FF8800;#FFC5DB;#AFFE12;#01205F;"
'get number of ColorPalettes
nCount = zPRJ.ColorPalettes.DynProperties("Palette[-1]")
'set name of Palette...
zPRJ.ColorPalettes.DynProperties("Palette[" & nCount - 1 & "].PaletteName") = "VBA_Colors_" & nCount
'set defined colors...
zPRJ.ColorPalettes.DynProperties("Palette[" & nCount - 1 & "].PaletteColors") = strColors

End Sub

Sub AddNewColor()
Dim zPRJ As Project
Dim vColors As Variant
Dim i As Integer
Dim strColor As String
Set zPRJ = MyWorkspace.ActiveDocument
'get actual color-names
vColors = Split(zPRJ.ColorPalettes.DynProperties("ColorNames"), ";")
For i = 0 To UBound(vColors) - 1

Debug.Print i & ": " & vColors(i)
Next i
'add a new Color...
strColor = zPRJ.ColorPalettes.DynProperties("ColorNames")
strColor = strColor & "Color_" & Format(UBound(vColors) + 1, "00") & ";"
zPRJ.ColorPalettes.DynProperties("ColorNames") = strColor

End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] ColorPalettes [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the entry point to get out all available properties of the object.
A blank String like that returns the first layer of properties: DynPropertiesEnum("")

Example
VBA
Copy
Sub Read_ColorPalettes_DynProps()
Dim zPRJ As Project
Dim vProps As Variant
Dim i As Integer
Set zPRJ = MyWorkspace.ActiveDocument
'get all DynProperties of the actual object (ColorPalettes)
vProps = zPRJ.ColorPalettes.DynPropertiesEnum("")
'Print informations of DynProperties into output window
For i = 0 To UBound(vProps)

Debug.Print vProps(i)
Next i
'Result:
'Palette,SUBITEM,Palette,
'ColorNames,String,Color name,
vProps = zPRJ.ColorPalettes.DynPropertiesEnum("Palette")
'Print informations of DynProperties into output window
For i = 0 To UBound(vProps)

Debug.Print vProps(i)
Next i
'Result:
'PaletteColors,String,Colors of the palette,
'PaletteName,String,Palette name,
Debug.Print zPRJ.ColorPalettes.DynProperties("ColorNames")
'Result:
'Color_01;Color_02;Color_03;Color_04;Colo5_05;
For i = 0 To zPRJ.ColorPalettes.DynProperties("Palette[-1]")

Debug.Print zPRJ.ColorPalettes.DynProperties("Palette[" & i & "].PaletteName")

Debug.Print zPRJ.ColorPalettes.DynProperties("Palette[" & i & "].PaletteColors")
Next i
'Result:
'Light
'#FFFFFF;#FFFF00;#FFC0CB;#AFEEEE;#00005E;
'Dark
'#000000;#0000FF;#8B0000;#388E8E;#E6E6FA;
'In the sample Project there were 2 colorpalettes with 5 colors each...
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] ColorPalettes [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Export
ObjectModel COM [image] ColorPalettes [image] Methods [image] Export
Remarks

Exports the selected object to a XML file.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Filename (path) as string of the xml file to export.

Example
C#
Copy
public void MacroExportColorPalettes()
{
    IProject zenonProject = this.ActiveDocument;
    if(zenonProject.ColorPalettes().Export(@"C:\Temp\ColorPalettes.xml"))
        System.Diagnostics.Debug.Print("Export successful");
    else
        System.Diagnostics.Debug.Print("Export failed");
}
VB.NET
Copy
Public Sub MacroExportColorPalettes()
    Dim zenonProject As IProject = Me.ActiveDocument
    If zenonProject.ColorPalettes().Export("C:\Temp\ColorPalettes.xml") Then
        System.Diagnostics.Debug.Print("Export successful")
    Else
        System.Diagnostics.Debug.Print("Export failed")
    End If
End Sub
VBA
Copy
Private Sub ExportColorPalettes()
Dim zPRJ As Project
Dim bResult As Boolean
'get active project...
Set zPRJ = MyWorkspace.ActiveDocument
'export color palettes...
bResult = zPRJ.ColorPalettes.Export("C:\Temp\ColorPalettes.xml")
'check result, write to output-window...
If bResult = False Then

ApplicationED.DebugPrint "VBA Export of ColorPalettes failed.", tpErr
Else

ApplicationED.DebugPrint "VBA ColorPalettes exported.", tpMsg
End If

End Sub


GetActivePaletteIndex
ObjectModel COM [image] ColorPalettes [image] Methods [image] GetActivePaletteIndex
Remarks

The method GetActivePaletteIndex (RT & Editor) will return the index of the currently active color palette.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using zenOn;
namespace WorkspaceAddin
{
    class FarbPalette
    {
        private int colorindex = 0;
        public void ColorTest(zenOn.IProject zenonproject)
        {
            if (zenonproject!=null)
            {
                int PaletteCount = zenonproject.ColorPalettes().Count;
                int index = zenonproject.ColorPalettes().GetActivePaletteIndex();
                System.Diagnostics.Debug.WriteLine("Palette count: " + PaletteCount.ToString());
                System.Diagnostics.Debug.WriteLine("Active Palette Index: : " + index.ToString() + " Name: " + zenonproject.ColorPalettes().get_DynProperties("Palette[" + index.ToString() + "].PaletteName"));

            }
        }
        public void ColorCycle(zenOn.IProject zenonproject)
        {
            if (zenonproject != null)
            {
                int index = zenonproject.ColorPalettes().GetActivePaletteIndex();
                uint uiColor = zenonproject.ColorPalettes().GetPaletteColor(index, colorindex);
                colorindex++;
                if (colorindex > 4)
                {
                    colorindex = 0;
                }
                zenonproject.DynPictures().Item(0).Elements().Item(0).BackColor = uiColor;
            }
        }
    }
}
VBA
Copy
Attribute VB_Name = "FarbPalette" Option Explicit Private m_ColorIndex As Long Public Sub m_ColorTest(zenonproject As IProject) If (zenonproject Is Nothing) Then Exit Sub If (zenonproject.Parent.Parent.Name <> "zenon Supervisor") Then Stop Dim index As Long Debug.Print "Palette Count: " + Trim(Str(zenonproject.ColorPalettes.Count)) index = zenonproject.ColorPalettes.GetActivePaletteIndex() Debug.Print "Active Palette Index: " + Trim(Str(index)) + " Name: "; zenonproject.ColorPalettes.DynProperties("Palette[" & Trim(Str(index)) & "].PaletteName") End Sub Public Sub m_CycleColor(zenonproject As IProject) Dim color As OLE_COLOR Dim index As Long If (zenonproject Is Nothing) Then Exit Sub If (zenonproject.Parent.Parent.Name <> "zenon Supervisor") Then Stop index = zenonproject.ColorPalettes.GetActivePaletteIndex() color = zenonproject.ColorPalettes.GetPaletteColor(index, m_ColorIndex) m_ColorIndex = m_ColorIndex + 1 If (m_ColorIndex > 4) Then m_ColorIndex = 0 zenonproject.DynPictures.Item(0).Elements.Item(0).BackColor = color End Sub


GetPaletteColor
ObjectModel COM [image] ColorPalettes [image] Methods [image] GetPaletteColor
Remarks

The method GetPaletteColor can be used (RT & Editor) to determine the value of the color of a color palette. The color palette parameter is from type variant and can be filled with either an index or the name of the color palette. The returned color will represent the color value. NOTE: If either the given color palette (name or index) or the ColorIndex are incorrect or not existing the returned value will be RGB(0,0,0) = White.

Datatype
OLE_COLOR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

ColorIndex as long

Example
C#
Copy
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using zenOn;
namespace WorkspaceAddin
{
    class FarbPalette
    {
        private int colorindex = 0;
        public void ColorTest(zenOn.IProject zenonproject)
        {
            if (zenonproject!=null)
            {
                int PaletteCount = zenonproject.ColorPalettes().Count;
                int index = zenonproject.ColorPalettes().GetActivePaletteIndex();
                System.Diagnostics.Debug.WriteLine("Palette count: " + PaletteCount.ToString());
                System.Diagnostics.Debug.WriteLine("Active Palette Index: : " + index.ToString() + " Name: " + zenonproject.ColorPalettes().get_DynProperties("Palette[" + index.ToString() + "].PaletteName"));

            }
        }
        public void ColorCycle(zenOn.IProject zenonproject)
        {
            if (zenonproject != null)
            {
                int index = zenonproject.ColorPalettes().GetActivePaletteIndex();
                uint uiColor = zenonproject.ColorPalettes().GetPaletteColor(index, colorindex);
                colorindex++;
                if (colorindex > 4)
                {
                    colorindex = 0;
                }
                zenonproject.DynPictures().Item(0).Elements().Item(0).BackColor = uiColor;
            }
        }
    }
}
VBA
Copy
Attribute VB_Name = "FarbPalette" Option Explicit Private m_ColorIndex As Long Public Sub m_ColorTest(zenonproject As IProject) If (zenonproject Is Nothing) Then Exit Sub If (zenonproject.Parent.Parent.Name <> "zenon Supervisor") Then Stop Dim index As Long Debug.Print "Palette Count: " + Trim(Str(zenonproject.ColorPalettes.Count)) index = zenonproject.ColorPalettes.GetActivePaletteIndex() Debug.Print "Active Palette Index: " + Trim(Str(index)) + " Name: "; zenonproject.ColorPalettes.DynProperties("Palette[" & Trim(Str(index)) & "].PaletteName") End Sub Public Sub m_CycleColor(zenonproject As IProject) Dim color As OLE_COLOR Dim index As Long If (zenonproject Is Nothing) Then Exit Sub If (zenonproject.Parent.Parent.Name <> "zenon Supervisor") Then Stop index = zenonproject.ColorPalettes.GetActivePaletteIndex() color = zenonproject.ColorPalettes.GetPaletteColor(index, m_ColorIndex) m_ColorIndex = m_ColorIndex + 1 If (m_ColorIndex > 4) Then m_ColorIndex = 0 zenonproject.DynPictures.Item(0).Elements.Item(0).BackColor = color End Sub


Import
ObjectModel COM [image] ColorPalettes [image] Methods [image] Import
Remarks

Imports settings using a xml file. New settings are added, existing settings will be replaced.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Filename (path) as string of the xml file to import.

Example
C#
Copy
public void MacroImportColorPalettes()
{
    IProject zenonProject = this.ActiveDocument;
    if (zenonProject.ColorPalettes().Import(@"C:\Temp\ColorPalettes.xml"))
        System.Diagnostics.Debug.Print("Import successful");
    else
        System.Diagnostics.Debug.Print("Import failed");
}
VB.NET
Copy
Public Sub MacroImportColorPalettes()
    Dim zenonProject As IProject = Me.ActiveDocument
    If zenonProject.ColorPalettes().Import("C:\Temp\ColorPalettes.xml") Then
        System.Diagnostics.Debug.Print("Import successful")
    Else
        System.Diagnostics.Debug.Print("Import failed")
    End If
End Sub
VBA
Copy
Private Sub ImportColorPalettes()
Dim zPRJ As Project
Dim bResult As Boolean
'get active project...
Set zPRJ = MyWorkspace.ActiveDocument
'import color palettes...
bResult = zPRJ.ColorPalettes.Import("C:\Temp\ColorPalettes.xml")
'check result, write to output-window...
If bResult = False Then

ApplicationED.DebugPrint "VBA Import of ColorPalettes failed.", tpErr
Else

ApplicationED.DebugPrint "VBA ColorPalettes imported.", tpMsg
End If

End Sub


SingleExport
ObjectModel COM [image] ColorPalettes [image] Methods [image] SingleExport
Remarks

Export a single ColorPalette to an XML File.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR

Filename (path) as string of the xml file to import.


Events
ObjectModel COM [image] ColorPalettes [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ColorPaletteSwitched | void | This event is fired when the active color palette has been switched. | Unused | Available | Available | Available


ColorPaletteSwitched
ObjectModel COM [image] ColorPalettes [image] Events [image] ColorPaletteSwitched
Remarks

This event includes the index of the color palette which is now active. This index can be used to update the colors of any custom coded objects.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
NewActivePaletteIndex as long


DynProperties
ObjectModel COM [image] ColorPalettes [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Color palettes


Color palettes
ObjectModel COM [image] ColorPalettes [image] DynProperties [image] Color palettes
Overview
External Name | Type | Display Name | Description
ColorNames | String | Color name |
Palette | Node | Color Palette | Node


CD_CPalette
ObjectModel COM [image] ColorPalettes [image] DynProperties [image] Color palettes [image] CD_CPalette
Overview
External Name | Type | Display Name | Description
PaletteColors | String | Colors of the palette |
PaletteName | String | Palette name | Name of palette.Default: Color palette plus Index number , for example Color palette 1 .


ComplexItem
ObjectModel COM [image] ComplexItem
Remarks

This object represents the items of a structure datatype.

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroComplexItem()
{
    IVarTypes zenonVarTypes = this.ActiveDocument.VarTypes();
    for (int i = 0; i < zenonVarTypes.Count; ++i)
    {
        //Check if the Datatype has a complex sub-element
        if (zenonVarTypes.Item(i).IsSimple() == 0 && zenonVarTypes.Item(i).SubItemCount() > 0)
        {
            for(int j = 0; j < zenonVarTypes.Item(i).SubItemCount(); ++j)
            {
                //If so, print every sub elements name, NOTE: Other dynamic properties can be
                //seen at the dynamic properties page of this object
                IComplexItem zenonComplexItem = zenonVarTypes.Item(i).SubItem(j);
                System.Diagnostics.Debug.Print(zenonComplexItem.get_DynProperties("Name").ToString());
            }
        }
    }
}
VB.NET
Copy
Public Sub MacroComplexItem()
    Dim zenonVarTypes As IVarTypes = Me.ActiveDocument.VarTypes()
    For i As Integer = 0 To zenonVarTypes.Count - 1
        'Check if the Datatype has a complex sub-element
        If zenonVarTypes.Item(i).IsSimple() = 0 AndAlso zenonVarTypes.Item(i).SubItemCount() > 0 Then
            For j As Integer = 0 To zenonVarTypes.Item(i).SubItemCount() - 1
                'If so, print every sub elements name, NOTE: Other dynamic properties can be
                'seen at the dynamic properties page of this object
                Dim zenonComplexItem As IComplexItem = zenonVarTypes.Item(i).SubItem(j)
                System.Diagnostics.Debug.Print(zenonComplexItem.get_DynProperties("Name").ToString())
            Next
        End If
    Next
End Sub
VBA
Copy
Public Sub test_IComplexItem()
Dim zComplexItem As ComplexItem
Dim zVarTypes As VarTypes
Dim i As Integer, j As Variant, k As Long
Set zVarTypes = thisProject.VarTypes
For i = 0 To zVarTypes.Count - 1

If (zVarTypes.Item(i).IsSimple = 0 And zVarTypes.Item(i).SubItemCount > 1) Then

Set zComplexItem = zVarTypes.Item(i).SubItem(1)

'write properties

zComplexItem.DynProperties("BitOffset") = 2 'EDwriteable

zComplexItem.DynProperties("Description") = "YourDescr..." 'EDwriteable

zComplexItem.DynProperties("Dim1") = 2 'EDwriteable

zComplexItem.DynProperties("Dim2") = 2 'EDwriteable

zComplexItem.DynProperties("Dim3") = 2 'EDwriteable

Debug.Print zComplexItem.DynProperties("HasRef") 'ReadOnly

zComplexItem.DynProperties("ID_DataTyp") = 19 'EDwriteable

Debug.Print zComplexItem.DynProperties("ItemIndex") 'ReadOnly

zComplexItem.DynProperties("Name") = "YourName" 'EDwriteable

zComplexItem.DynProperties("Offset") = 10 'EDwriteable

'read properties

Debug.Print zComplexItem.DynProperties("BitOffset")

Debug.Print zComplexItem.DynProperties("Description")

Debug.Print zComplexItem.DynProperties("Dim1")

Debug.Print zComplexItem.DynProperties("Dim2")

Debug.Print zComplexItem.DynProperties("Dim3")

Debug.Print zComplexItem.DynProperties("HasRef")

Debug.Print zComplexItem.DynProperties("ID_DataTyp")

Debug.Print zComplexItem.DynProperties("ItemIndex")

Debug.Print zComplexItem.DynProperties("Name")

Debug.Print zComplexItem.DynProperties("Offset")

'Methods

zComplexItem.MoveItemDown

zComplexItem.MoveItemUp

End If
Next i
End Sub


Properties
ObjectModel COM [image] ComplexItem [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Parent | ivartype | Returns the parent object. | Readonly | Readonly | Available | Available


Parent
ObjectModel COM [image] ComplexItem [image] Properties [image] Parent
Remarks

Returns the parent object.

Datatype
IVarType

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ComplexItem [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant |  | Available | Available | Available | Available
DynProperties [PUT] | void |  | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant |  | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available
MoveItemDown | variant_bool | Move the ComplexItem one down in the Tree. | Available | Unused | Available | Available
MoveItemUp | variant_bool | Move the ComplexItem one up in the Tree. | Available | Unused | Available | Available


DynProperties [GET]
ObjectModel COM [image] ComplexItem [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.
Example: "NetAktive"

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] ComplexItem [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.
Example: "NetAktive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.


DynPropertiesEnum [GET]
ObjectModel COM [image] ComplexItem [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Defines the entry point to get out all available properties of the object.
A blank String like that returns the first layer of properties: DynPropertiesEnum("")


DynPropertyParam [GET]
ObjectModel COM [image] ComplexItem [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


MoveItemDown
ObjectModel COM [image] ComplexItem [image] Methods [image] MoveItemDown
Remarks

move the ComplexItem one down in the Tree.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


MoveItemUp
ObjectModel COM [image] ComplexItem [image] Methods [image] MoveItemUp
Remarks

Move the ComplexItem one up in the Tree.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroComplexItemMoveDown()
{
    IVarTypes zenonVarTypes = this.ActiveDocument.VarTypes();
    for (int i = 0; i < zenonVarTypes.Count; ++i)
    {
        //Check if the Datatype has a complex sub-element
        if (zenonVarTypes.Item(i).IsSimple() == 0 && zenonVarTypes.Item(i).SubItemCount() > 0)
        {
            for (int j = 0; j < zenonVarTypes.Item(i).SubItemCount(); ++j)
            {
                //If so, move it down once in the tree
                IComplexItem zenonComplexItem = zenonVarTypes.Item(i).SubItem(j);
                zenonComplexItem.MoveItemDown();
            }
        }
    }
}
VB.NET
Copy
Public Sub MacroComplexItemMoveDown()
    Dim zenonVarTypes As IVarTypes = Me.ActiveDocument.VarTypes()
    For i As Integer = 0 To zenonVarTypes.Count - 1
        'Check if the Datatype has a complex sub-element
        If zenonVarTypes.Item(i).IsSimple() = 0 AndAlso zenonVarTypes.Item(i).SubItemCount() > 0 Then
            For j As Integer = 0 To zenonVarTypes.Item(i).SubItemCount() - 1
                'If so, move it down once in the tree
                Dim zenonComplexItem As IComplexItem = zenonVarTypes.Item(i).SubItem(j)
                zenonComplexItem.MoveItemDown()
            Next
        End If
    Next
End Sub


DynProperties
ObjectModel COM [image] ComplexItem [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Complextype item


Complextype item
ObjectModel COM [image] ComplexItem [image] DynProperties [image] Complextype item
Overview
External Name | Type | Display Name | Description
BitOffset | UInt16 | Bit offset | Bit number of the structure element in the structure. .
Description | String | Description | Description of the data type. .
Dim1 | UInt32 | Dim 1 | Size of the first dimension of the array. .
Dim2 | UInt32 | Dim 2 | Size of the second dimension of the array. .
Dim3 | UInt32 | Dim 3 | Size of the third dimension of the array. .
ExternalReference | String | External reference | In doing so, note:If a simple data type or a structure data type is created using copy&paste , this property is empty.If a new structure data type is created on the basis of an existing data type, the value of the property is not forwarded by the original data type.Is not forwarded for embedded structure elements.If the data type is changed with an embedded structure type, the value from the previous one is taken to the new data type.
HasRef | Bool | linked with data type | Active: The element is linked to the basic data type. Changes to the basic data type have a direct effect on the element. Properties of the element can no longer be edited. Inactive: The element is no longer linked to the basic data type. .
ID_DataTyp | UInt32 | IEC data type | Basic data type. Attention : If the basic data type is subsequently changed, all other properties of the data type must be checked and amended if necessary. .
ItemIndex | UInt32 | Pos. in structure | Position of the variable in the structure. .
LBound | UInt16 | Start index | Select the start index of the array from the dropdown list. .
Name | String | Name | Name of the data types. Maximum length: 128 characters .
Offset | UInt32 | Offset | Offset of the structure element in the structure. .
TypeID | UInt32 | TypeID |


Driver
ObjectModel COM [image] Driver
Remarks

The object Driver includes important information on the defined drivers, e.g. name, driver, status and mode.

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroDriver()
{
    //Get a driver object or create a new one if it does not exist
    //NOTE: The user might have to fill in settings for the driver, depending on its type
    IDrivers zenonDrivers = this.ActiveDocument.Drivers();
    IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");
    if (zenonDriver == null)
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");
    //Use the driver object to access its methods etc.
}
VB.NET
Copy
Public Sub MacroDriver()
    'Get a driver object or create a new one if it does not exist
    'NOTE: The user might have to fill in settings for the driver, depending on its type
    Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()
    Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")
    If zenonDriver Is Nothing Then
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")
    End If
    'Use the driver object to access its methods etc.
End Sub
VBA
Copy
Public Sub DriversSample()
Dim zDrivers As Drivers
Dim zDriver As Driver
Dim i As Integer
'get drivers collection
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
'Enumerate existing drivers in the project
For i = 0 To zDrivers.Count - 1

Debug.Print zDrivers.Item(i).Name
Next i
'Create a new driver and check if already exists
Set zDriver = zDrivers.Item("NewSimulationDriver")
If zDriver Is Nothing Then

Set zDriver = zDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")
End If

End Sub


Properties
ObjectModel COM [image] Driver [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Identification | bstr | Name | Available | Readonly | Available | Available
Name | bstr | Returns the name (EXE) of the driver. | Available | Readonly | Available | Available
Parent | idrivers | Parent-object | Readonly | Readonly | Available | Available


Identification
ObjectModel COM [image] Driver [image] Properties [image] Identification
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] Driver [image] Properties [image] Name
Remarks

Returns the name (EXE) of the driver.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Driver [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IDrivers

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Driver [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Browse | variant_bool | Imports variables from PLC or file. | Available | Unused | Available | Available
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
CloseConfig | variant_bool | Closes driver config and stops driver. | Available | Unused | Available | Available
CreateDynProperty | variant_bool |  | Available | Unused | Available | Available
DynProperties [GET] | variant |  | Available | Available | Available | Available
DynProperties [PUT] | void |  | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | <span"></span> | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available
Export | variant_bool |  | Available | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
Import | variant_bool |  | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
OpenConfig | variant_bool | Starts driver and opens driver config for access via properties. | Available | Unused | Available | Available
SupportsChannel | variant_bool | Returns True when the given channeltype is supported for the given datatype. | Available | Unused | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


Browse
ObjectModel COM [image] Driver [image] Methods [image] Browse
Remarks

Imports variables from PLC or file.Driver specific filterstrings for online import of variables:
IEC870: Net=NetAddress;Filter={Address="Filterstring1";Type="Filterstring2";}; Logix32: Net=NetAddress;Struct="Filterstring1";Name="Filterstring2"; The Filterstrings must be used as in the dialog when importing manually in the editor.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFilter as BSTR

Driver specific filterstring for online import of variables.

bsResult as BSTR

Returns a message as String like you can see in the LogViewer.


CheckIn
ObjectModel COM [image] Driver [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroDriverMultiuser()
{
    //Get a driver object or create a new one if it does not exist
    //NOTE: The user might have to fill in settings for the driver, depending on its type
    IDrivers zenonDrivers = this.ActiveDocument.Drivers();
    IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");
    if (zenonDriver == null)
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");
    if (!zenonDriver.IsCheckedOut())
    {
        if (zenonDriver.CheckOut())
        {
            //The driver was checked out by the user who executed this macro
            if (zenonDriver.Get())
            {
                //Got the latest version of the driver
                //Edit some properties of the driver
                zenonDriver.Name = "NewName";

                //Check the driver in again so others can check it out
                zenonDriver.CheckIn();

            }
            else
            {
                zenonDriver.UndoCheckOut();
                //The latest version could not be received, undo the checkout
            }
        }
        else
        {
            //The driver can't currently be checked out
        }
    }
    else
    {
        //Someone else has the object checked out!
    }
}
VB.NET
Copy
Public Sub MacroDriverMultiuser()
    'Get a driver object or create a new one if it does not exist
    'NOTE: The user might have to fill in settings for the driver, depending on its type
    Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()
    Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")
    If zenonDriver Is Nothing Then
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")
    End If
    If Not zenonDriver.IsCheckedOut() Then
        If zenonDriver.CheckOut() Then
            'The driver was checked out by the user who executed this macro
            If zenonDriver.[Get]() Then
                'Got the latest version of the driver
                'Edit some properties of the driver
                zenonDriver.Name = "NewName"

                'Check the driver in again so others can check it out

                zenonDriver.CheckIn()
            Else
                    'The latest version could not be received, undo the checkout
                zenonDriver.UndoCheckOut()
            End If
                'The driver can't currently be checked out
        Else
        End If
            'Someone else has the object checked out!
    Else
    End If
End Sub


CheckOut
ObjectModel COM [image] Driver [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroDriverMultiuser()
{
    //Get a driver object or create a new one if it does not exist
    //NOTE: The user might have to fill in settings for the driver, depending on its type
    IDrivers zenonDrivers = this.ActiveDocument.Drivers();
    IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");
    if (zenonDriver == null)
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");
    if (!zenonDriver.IsCheckedOut())
    {
        if (zenonDriver.CheckOut())
        {
            //The driver was checked out by the user who executed this macro
            if (zenonDriver.Get())
            {
                //Got the latest version of the driver
                //Edit some properties of the driver
                zenonDriver.Name = "NewName";

                //Check the driver in again so others can check it out
                zenonDriver.CheckIn();

            }
            else
            {
                zenonDriver.UndoCheckOut();
                //The latest version could not be received, undo the checkout
            }
        }
        else
        {
            //The driver can't currently be checked out
        }
    }
    else
    {
        //Someone else has the object checked out!
    }
}
VB.NET
Copy
Public Sub MacroDriverMultiuser()
    'Get a driver object or create a new one if it does not exist
    'NOTE: The user might have to fill in settings for the driver, depending on its type
    Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()
    Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")
    If zenonDriver Is Nothing Then
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")
    End If
    If Not zenonDriver.IsCheckedOut() Then
        If zenonDriver.CheckOut() Then
            'The driver was checked out by the user who executed this macro
            If zenonDriver.[Get]() Then
                'Got the latest version of the driver
                'Edit some properties of the driver
                zenonDriver.Name = "NewName"

                'Check the driver in again so others can check it out

                zenonDriver.CheckIn()
            Else
                    'The latest version could not be received, undo the checkout
                zenonDriver.UndoCheckOut()
            End If
                'The driver can't currently be checked out
        Else
        End If
            'Someone else has the object checked out!
    Else
    End If
End Sub


CloseConfig
ObjectModel COM [image] Driver [image] Methods [image] CloseConfig
Remarks

Closes driver config and stops driver.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bSave as VARIANT_BOOL

Defines wether to save (True) the actual driver configuration or not (False).


CreateDynProperty
ObjectModel COM [image] Driver [image] Methods [image] CreateDynProperty
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties [GET]
ObjectModel COM [image] Driver [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.
Example: "NetAktive"

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] Driver [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.
Example: "NetAktive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.


DynPropertiesEnum [GET]
ObjectModel COM [image] Driver [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the entry point to get out all available properties of the object.
A blank String like that returns the first layer of properties: DynPropertiesEnum("")


DynPropertyParam [GET]
ObjectModel COM [image] Driver [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Export
ObjectModel COM [image] Driver [image] Methods [image] Export
Remarks

The Export function exports ALL properties of the driver in an XML file whose name is specified when called up. If there is already a file before the export, it is deleted.if there is no directory stated in the file name lpszFilename, the export directory from the INI file of the project is used. If this is not specified, the current working directory is used.The use of these API functions without implementation of the explicit import or export creates or reads an XML file with the following constant content (irrespective of the version number):<?xml version="1.0" encoding="utf-16"?><Subject ShortName="zenOn(R) exported project" MainVersion="7600"/>The export of the driver configuration creates the following XML file:<?xml version="1.0" encoding="utf-16"?><Subject ShortName="zenOn(R) exported project" MainVersion="7600"> <Apartment ShortName="zenOn(R) driver configuration" Version="7600"> <Driver NODE="zenOn(R) embedded object" DriverID="4" Modul="3S_V3" Name="3S v3 Treiber"> ……. </Driver> </Apartment></Subject>The Driver node then contains a list of all configuration properties that are available in the XML import or XML export. In addition, the attribute module and name of the Driver node allow unique identification of the driver assignment for the import.The driver properties are then exported in accordance with the following: <DrvConfig NODE="zenOn(R) embedded object"> <ComByteSize>0</ComByteSize> <Connection_0 NODE="zenOn(R) embedded object"> <GWAddress>localhost</GWAddress> <GWPort>1210</GWPort> </Connection_0> <Connection_2 NODE="zenOn(R) embedded object"> <GWAddress>localhost</GWAddress> <GWPort>1210</GWPort> </Connection_2> <GenGlobalUpdateTime>1000</GenGlobalUpdateTime> <GenPrioUpdateTime3>100</GenPrioUpdateTime3> <GenPrioUpdateTime2>300</GenPrioUpdateTime2> <GenPrioUpdateTime1>500</GenPrioUpdateTime1> <GenPrioUpdateTime0>1000</GenPrioUpdateTime0> </DrvConfig>It should be noted that node properties always have the NODE attribute with the ZenOn(R) embedded object value and the name of the node property features a unique index. Property containers (in this example: Connection) are thus uniquely identified and handled.Simple properties are shown as simple nodes with values (Example: im Beispiel:ComByteSize, GenGlobalUpdateTime, GWAddress, GWPort, ...).Drivers that can be exported via the API:

  • 3S_V3
  • BACnetNG
  • BECKHNG
  • BURPVI
  • CIFMPI32
  • FRAPORT
  • IEC850
  • IEC870
  • LOGIX32
  • MODBUS_ENERGY
  • MODRTU32
  • OPCUA32
  • PHLOEM
  • SPRECON870
  • S7TCP32
  • STRATON32
  • StratonNG
  • STERIFLOW

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lpszFilename as BSTR


Get
ObjectModel COM [image] Driver [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroDriverMultiuser()
{
    //Get a driver object or create a new one if it does not exist
    //NOTE: The user might have to fill in settings for the driver, depending on its type
    IDrivers zenonDrivers = this.ActiveDocument.Drivers();
    IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");
    if (zenonDriver == null)
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");
    if (!zenonDriver.IsCheckedOut())
    {
        if (zenonDriver.CheckOut())
        {
            //The driver was checked out by the user who executed this macro
            if (zenonDriver.Get())
            {
                //Got the latest version of the driver
                //Edit some properties of the driver
                zenonDriver.Name = "NewName";

                //Check the driver in again so others can check it out
                zenonDriver.CheckIn();

            }
            else
            {
                zenonDriver.UndoCheckOut();
                //The latest version could not be received, undo the checkout
            }
        }
        else
        {
            //The driver can't currently be checked out
        }
    }
    else
    {
        //Someone else has the object checked out!
    }
}
VB.NET
Copy
Public Sub MacroDriverMultiuser()
    'Get a driver object or create a new one if it does not exist
    'NOTE: The user might have to fill in settings for the driver, depending on its type
    Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()
    Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")
    If zenonDriver Is Nothing Then
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")
    End If
    If Not zenonDriver.IsCheckedOut() Then
        If zenonDriver.CheckOut() Then
            'The driver was checked out by the user who executed this macro
            If zenonDriver.[Get]() Then
                'Got the latest version of the driver
                'Edit some properties of the driver
                zenonDriver.Name = "NewName"

                'Check the driver in again so others can check it out

                zenonDriver.CheckIn()
            Else
                    'The latest version could not be received, undo the checkout
                zenonDriver.UndoCheckOut()
            End If
                'The driver can't currently be checked out
        Else
        End If
            'Someone else has the object checked out!
    Else
    End If
End Sub


Import
ObjectModel COM [image] Driver [image] Methods [image] Import
Remarks

The Import function imports the driver properties from an XML file. The file name is specified during the call. The function is closed with FALSE if this file does not exist.During import, the XML file is read in according to the import, whereby the following requirements must be met (in sequence):

  • The driver must be checked out in multi-user operation.
  • The properties of the driver configuration must be loaded.
  • The XML file must have a corresponding header (restrictive)
  • The value of the attribute module of the Driver node from the XML file must correspond to the driver's module description.
If these requirements are met, the individual XML nodes are read in recursively and assigned to the driver properties accordingly. However, before this action starts, all subnodes (Connection for example) of the DrvConfig driver property are deleted completely; this means:All content of the base property or the DrvConfig node is retained or is modified in the event of changes.All subnodes and content of the DrvConfig property is recreated. If the content of one of these subnodes is missing, the details are added here.The process of the import and the conclusion of the import is logged in the change history.Drivers can be imported via the API:
  • 3S_V3
  • BACnetNG
  • BECKHNG
  • BURPVI
  • CIFMPI32
  • FRAPORT
  • IEC850
  • IEC870
  • LOGIX32
  • MODBUS_ENERGY
  • MODRTU32
  • OPCUA32
  • PHLOEM
  • SPRECON870
  • S7TCP32
  • STRATON32
  • StratonNG
  • STERIFLOW

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lpszFilename as BSTR


IsCheckedOut
ObjectModel COM [image] Driver [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void DriverTryCheckOut(IDriver zenonDriver)
{
    //Checks if the passed object is checked out before performing a checkout
    if(!zenonDriver.IsCheckedOut())
    {
        zenonDriver.CheckOut();
        //Object can be used for further purposes
    }
    else
    {
        //The object is already checked out and cannot be checked out again
    }
}
VB.NET
Copy
Public Sub DriverTryCheckOut(zenonDriver As IDriver)
    'Checks if the passed object is checked out before performing a checkout
    If Not zenonDriver.IsCheckedOut() Then
            'Object can be used for further purposes
        zenonDriver.CheckOut()
            'The object is already checked out and cannot be checked out again
    Else
    End If
End Sub


IsDifferent
ObjectModel COM [image] Driver [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void CheckInChanges(IDriver zenonDriver)
{
    //Checks if any changes occured on the driver object and if so, updates it
    if(zenonDriver.IsDifferent())
    {
        if(zenonDriver.Get())
        {
            //Driver object is up to date
        }
        else
        {
            //An error occured while getting the newest version of the object
        }
    }
    else
    {
        //No pending changes
    }
}
VB.NET
Copy
Public Sub CheckInChanges(zenonDriver As IDriver)
    'Checks if any changes occured on the driver object and if so, updates it
    If zenonDriver.IsDifferent() Then
                'Driver object is up to date
        If zenonDriver.[Get]() Then
                'An error occured while getting the newest version of the object
        Else
        End If
            'No pending changes
    Else
    End If
End Sub


IsLocked
ObjectModel COM [image] Driver [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroDriver()
{
    //Get a driver object or create a new one if it does not exist
    //NOTE: The user might have to fill in settings for the driver, depending on its type
    IDrivers zenonDrivers = this.ActiveDocument.Drivers();
    IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");
    if (zenonDriver == null)
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");
    if (zenonDriver.IsLocked())
    {
        //Modification Changes are currently locked due to a checkout
    }
    else
    {
        //Use the driver object to access its methods etc.
    }
}
VB.NET
Copy
Public Sub MacroDriver()
    'Get a driver object or create a new one if it does not exist
    'NOTE: The user might have to fill in settings for the driver, depending on its type
    Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()
    Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")
    If zenonDriver = Nothing Then
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")
    End If
            'Modification Changes are currently locked due to a checkout
    If zenonDriver.IsLocked() Then
            'Use the driver object to access its methods etc.
    Else
    End If
End Sub


OpenConfig
ObjectModel COM [image] Driver [image] Methods [image] OpenConfig
Remarks

Access via API to the driver configuration. Available only for the following drivers:

  • Fraport
  • IEC870
  • IEC 850
  • Logix32
  • S7TCP32
  • Sprecon870
  • Steriflow
  • Straton32
The access to the configuration settings is possible by using the DynProperties. In the example shown below the DynProperties for S7TCP32, IEC870, Logix3 are used.The Steriflow driver uses only the ynProperty "CfgFileTransferDirectory". This property requires the transfer directory as parameter.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub CreateDriverS7TCP_Dyn()
    Dim zDrivers As Drivers
    Dim zDriver As Driver
    Dim zDriverS7TCP As Driver
    Dim vProps As Variant
    Dim vValue As Variant
    Dim inti As Integer
    Dim intj As Integer
    Dim sDateiname As String
    Dim sBezeichnung As String
    sDateiname = "S7TCP32"
    sBezeichnung = "S7_Test_1"
    'show all exist
    Set zDrivers = MyWorkspace.ActiveDocument.Drivers
    'Enumerate existing drivers in the project
    For inti = 0 To zDrivers.Count - 1
        Debug.Print zDrivers.Item(inti).Name
    Next inti
    Debug.Print "================================================="
    'Create a new driver  without dirver configuration dialog and check if already exists
    Set zDriver = zDrivers.Item(sBezeichnung)
    If zDriver Is Nothing Then
        'Set zDriver = zDrivers.CreateDriver(sBezeichnung, sDateiname)
        Set zDriver = zDrivers.CreateDriverEx(sBezeichnung, sDateiname, False)
    End If
    Set zDriverS7TCP = zDrivers.Item(sBezeichnung)
    Debug.Print zDriverS7TCP.Name
    Call zDriverS7TCP.OpenConfig
    vProps = zDriverS7TCP.DynPropertiesEnum("")
    Debug.Print "==========       DynProperties     =============="
    For intj = 0 To UBound(vProps)
        Debug.Print vProps(intj)
    Next intj
    Debug.Print "============================================================================================="
    Call zDriverS7TCP.CloseConfig(False)
    'Change some configuration on the driver
    Call zDriverS7TCP.OpenConfig
    Debug.Print "Modus (General Driver Mode) :" & zDriverS7TCP.DynProperties("GenDriverMode")
    'Change General Driver mode from Hardware to Simulation-counter
    zDriverS7TCP.DynProperties("GenDriverMode") = 1
    'Show some DynProperties
    Debug.Print "======================================_General_=========================================="
    Debug.Print "Modus (General Driver Mode) :      " & zDriverS7TCP.DynProperties("GenDriverMode")
    Debug.Print "Update-Liste im Speicher Halten :  " & zDriverS7TCP.DynProperties("GenKeepUpdatelist")
    Debug.Print "Ausgänge schreibbar :              " & zDriverS7TCP.DynProperties("GenOutputWriteable")
    Debug.Print "Variablenabbild remanent :         " & zDriverS7TCP.DynProperties("GenRemanentImage")
    Debug.Print "Update Zeit Clobal :               " & zDriverS7TCP.DynProperties("GenUseGlobalUpdateTime")
    Debug.Print "Clobale Updatezeit in ms :         " & zDriverS7TCP.DynProperties("GenGlobalUpdateTime")
    Debug.Print "Priorität normal :                 " & zDriverS7TCP.DynProperties("GenPrioUpdateTime0")
    Debug.Print "Priorität erhöht :                 " & zDriverS7TCP.DynProperties("GenPrioUpdateTime1")
    Debug.Print "Priorität hoch:                    " & zDriverS7TCP.DynProperties("GenPrioUpdateTime2")
    Debug.Print "Priorität höchste :                " & zDriverS7TCP.DynProperties("GenPrioUpdateTime3")
    Debug.Print "===============================_S7- TCP Configuration_==================================="
    Debug.Print "TCP- Konfiguration :               " & zDriverS7TCP.DynProperties("CfgConfFileName")
    Debug.Print "Fehlerwartezeit :                  " & zDriverS7TCP.DynProperties("CfgErrorWaitTime")
    Debug.Print "Char-String ohne Header :          " & zDriverS7TCP.DynProperties("CfgStringWithoutHeader")
    Debug.Print "==============================_S7- TCP Connection_======================================="
    Debug.Print "This settings must be set in the configuration file ."
    Debug.Print "========================================================================================="
    Debug.Print "Name  :      " & zDriverS7TCP.DynProperties("Name")
    Debug.Print "DriverId  :      " & zDriverS7TCP.DynProperties("DriverId")
    Debug.Print "NameFile  :      " & zDriverS7TCP.DynProperties("NameFile")
    Debug.Print "========================================================================================="
    Call zDriverS7TCP.CloseConfig(True)
End Sub

'Extra für Steriflow
Public Sub BrowseProperties()
Dim drv As Driver
Dim PropertyList As Variant
Dim i As Integer
'Zuweisen des Treibers mit der Bezeichnung Steriflow driver
Set drv = MyWorkspace.ActiveDocument.Drivers.Item("Steriflow driver")
'über DynPropertiesEnum bekommen wir eine Liste aller Properties, die die API des Treibers implementiert
drv.OpenConfig
PropertyList = drv.DynPropertiesEnum("")

'in dieser For-Schleife gehen wir die Properties durch und schreiben sie zeilenweise ins Ausgabefenster des zenon Editors
For i = 0 To UBound(PropertyList) - 1
    ApplicationED.DebugPrint PropertyList(i), tpMsg
Next i
End Sub


SupportsChannel
ObjectModel COM [image] Driver [image] Methods [image] SupportsChannel
Remarks

Returns "True" when the actual driver object supports the given VarType and ChannelType combination.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
ChannelType as tpKanaltypes

ChannelType (constant) to be checked.

ObVarType as IVarType

VarType object to be checked.

Example
C#
Copy
public void MacroChannelSupport()
{
    IVarType zenonVarType = this.ActiveDocument.VarTypes().Item("UINT");
    IDrivers zenonDrivers = this.ActiveDocument.Drivers();
    IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");
    if (zenonDriver == null)
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");
    if(zenonDriver.SupportsChannel(tpKanaltypes.tpSPSMerker, zenonVarType))
        System.Diagnostics.Debug.Print("Supported by the driver");
    else
        System.Diagnostics.Debug.Print("Not supported by the driver");
}
VB.NET
Copy
Public Sub MacroChannelSupport()
    Dim zenonVarType As IVarType = Me.ActiveDocument.VarTypes().Item("UINT")
    Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()
    Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")
    If zenonDriver Is Nothing Then
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")
    End If
    If zenonDriver.SupportsChannel(tpKanaltypes.tpSPSMerker, zenonVarType) Then
        System.Diagnostics.Debug.Print("Supported by the driver")
    Else
        System.Diagnostics.Debug.Print("Not supported by the driver")
    End If
End Sub
VBA
Copy
Sub Channelsupport()
Dim zDRV As Driver
Dim zVTP As VarType
'get a Driver object for Simulation-Driver
Set zDRV = MyWorkspace.ActiveDocument.Drivers.Item("SIMUL_WIZ")
'get a VarType object for UINT
Set zVTP = MyWorkspace.ActiveDocument.VarTypes.Item("UINT")
If zDRV.SupportsChannel(tpSPSMerker, zVTP) = True Then

Debug.Print "This combination is supported by the driver."
Else

Debug.Print "NOT supported by this driver!"
End If
End Sub


UndoCheckOut
ObjectModel COM [image] Driver [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroDriverMultiuser()
{
    //Get a driver object or create a new one if it does not exist
    //NOTE: The user might have to fill in settings for the driver, depending on its type
    IDrivers zenonDrivers = this.ActiveDocument.Drivers();
    IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");
    if (zenonDriver == null)
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");
    if (!zenonDriver.IsCheckedOut())
    {
        if (zenonDriver.CheckOut())
        {
            //The driver was checked out by the user who executed this macro
            if (zenonDriver.Get())
            {
                //Got the latest version of the driver
                //Edit some properties of the driver
                zenonDriver.Name = "NewName";

                //Check the driver in again so others can check it out
                zenonDriver.CheckIn();

            }
            else
            {
                zenonDriver.UndoCheckOut();
                //The latest version could not be received, undo the checkout
            }
        }
        else
        {
            //The driver can't currently be checked out
        }
    }
    else
    {
        //Someone else has the object checked out!
    }
}
VB.NET
Copy
Public Sub MacroDriverMultiuser()
    'Get a driver object or create a new one if it does not exist
    'NOTE: The user might have to fill in settings for the driver, depending on its type
    Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()
    Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")
    If zenonDriver Is Nothing Then
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")
    End If
    If Not zenonDriver.IsCheckedOut() Then
        If zenonDriver.CheckOut() Then
            'The driver was checked out by the user who executed this macro
            If zenonDriver.[Get]() Then
                'Got the latest version of the driver
                'Edit some properties of the driver
                zenonDriver.Name = "NewName"

                'Check the driver in again so others can check it out

                zenonDriver.CheckIn()
            Else
                    'The latest version could not be received, undo the checkout
                zenonDriver.UndoCheckOut()
            End If
                'The driver can't currently be checked out
        Else
        End If
            'Someone else has the object checked out!
    Else
    End If
End Sub


DynProperties
ObjectModel COM [image] Driver [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

3S_V3
ALLANBNT
BACNetNG
BeckhNG
BURPVI
CIFMPI
DATEI32
DNP3_TG
Driver
DriverCommon
FraPort
IEC850
IEC870
ISPIP
Logix32
MODBUS_ENERGY
MODRTU32
OmronEIP
OPCUA
OPCUA32
PHLOEM
POZYTON
S7TCP32
Sprecon870
Steriflow
Straton32
STRATONNG


3S_V3
ObjectModel COM [image] Driver [image] DynProperties [image] 3S_V3
Overview

DriverGroupEntry

DrvConfig.Connection
DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] 3S_V3 [image] DrvConfig.Options
Overview

External Name

Type

Description

LogEnable

bool

LogfileCount

UInt16

LogfileStoragePath

String

LogLevel

ePLCHandler_loglevel

SymbVarName

UInt16

Options field to select which source is used for the symbolic addressing of the variables:

  • Variable identification
    Symbolic addressing of variables is carried out using the variable identification.
  • Symbolic addressing
    Symbolic addressing of the variables is carried out using the symbolic address.
Note: This selection can be made from zenon version 7.10 onwards.The variable identification is always used up to and including version 7.00. In this case, the options variable identification and symbolic address are not displayed.

Timestamp

UInt16

Options field to select how the time stamp of new variable values is determined:

  • PLC:
    Time stamp of the controller is used
  • Driver:
    Time stamp of the driver is used


DrvConfig.Connection
ObjectModel COM [image] Driver [image] DynProperties [image] 3S_V3 [image] DrvConfig.Connection
Overview

External Name

Type

Description

Address

String

  • Node address or node name of the controller.
    For redundant communication: Node address or node name of the primary controller.    Entry of node address or node name in the field or select from a drop-down list. Clicking on the ... button opens the dialog to select a PLC.Attention: This search for a controller is not available for the V2.3 communication. The search through the network is not possible with V2.3.When opened, a search for controllers in the network that can be contacted using the selected connection type is carried out. If the search for a controller is not possible, because the project computer and controller are in different networks, the address must be entered manually.Redundancy:The driver connects to the primary connection by default. If this cannot be established or fails, an attempt to switch to the secondary connection is made. The primary connection always has higher priority in the process. If both are available, communication is always via the primary address.Note: In doing so, all variables are always only signed in for the active connection. Values are always only read by the active connection. Values are however written to both controllers if the connections are available.Node address and node name
    • The node address can be different for different connection types. However it is always unique for the selected connection type.
      Note: A controller may get a new node address after a restart, because the original address is issued.
    • The node name is not unique There can be several controllers on one device for example. These can then only be identified via the node address.

AddressSecondary

String

Node address or node name of the redundant controller.Entry of a node address or a node name in the field or select from a drop-down list. Clicking on the ... button opens the dialog to select a PLC.Note: The secondary node address can also remain empty. In this case, in the event of a failure of the primary connection, no redundancy switching is carried out.

Alias

String

An alias can be entered for each connection. This serves as a prefix for the names of the variables that are imported from the driver.If this alias is empty, the node address is used as a prefix.Maximum length: 8 charactersNote: Entry of more than 8 characters is not possible.

BufferSize

UInt32

ConnectionType

UInt16

Selection of the connection type from drop-down list:

  • Gateway:
    The communication to the PLC is by means of a gateway to the local or a remote computer
    You can find further configuration possibilities for the gateway connection type in the Gateway configuration group.
  • ARTI:
    Direct communication to the PLC by means of the local network card (peer-to-peer connection)
Default: Gateway

GWAddress

String

Input field for the address of the gateway.The address can be configured as both numerical (192.168.1.1) and alphanumerical (e.g.: localhost).A check to see if the input is valid is not carried out.Note: Only available if TCP/IP is configured as a connection.

GWConnection

UInt16

Selection of the connection type from the PLC handler to the gateway via a drop-down list:

  • TCP/IP:
    TCP/IP connection
  • Shared Memory:
    Use of the shared memory on the local computer
Default: TCP/IP

GWPassword

String

Password of the gateway (optional).Note: Only available if TCP/IP is configured as a connection.

GWPort

UInt32

Port of the gateway.Note: Only available if TCP/IP is configured as a connection.
Default: 1217

HostAddress

String

HostAddressSecondary

String

HWAddress

UInt16

Entry of the net address.
The net address must be unique and must not be used twice. If a net address has already been issued, this is shown by a notice dialog.The entry is checked after clicking on the button OK. In case of failure, a warning dialog pops up.Attention: If a numerical figure outside the value range is entered, the net address is configured with the value -1.Default: The lowest net address that has not yet been issued is preset as a default.This net address corresponds to the zenon Net address property.

NodeAddress

String

  • Node address or node name of the controller.
    For redundant communication: Node address or node name of the primary controller.    Entry of node address or node name in the field or select from a drop-down list. Clicking on the ... button opens the dialog to select a PLC.Attention: This search for a controller is not available for the V2.3 communication. The search through the network is not possible with V2.3.When opened, a search for controllers in the network that can be contacted using the selected connection type is carried out. If the search for a controller is not possible, because the project computer and controller are in different networks, the address must be entered manually.Redundancy:The driver connects to the primary connection by default. If this cannot be established or fails, an attempt to switch to the secondary connection is made. The primary connection always has higher priority in the process. If both are available, communication is always via the primary address.Note: In doing so, all variables are always only signed in for the active connection. Values are always only read by the active connection. Values are however written to both controllers if the connections are available.Node address and node name
    • The node address can be different for different connection types. However it is always unique for the selected connection type.
      Note: A controller may get a new node address after a restart, because the original address is issued.
    • The node name is not unique There can be several controllers on one device for example. These can then only be identified via the node address.

NodeAddressSecondary

String

PLCVersion

UInt16

Selection of the version to be used from a drop-down list:

  • V3
  • V2.3
    You can find further configuration possibilities for the use of V2.3 in the V2.3 PLC configuration configuration group.
Default: V3

Retries

UInt32

Defines the number of repeat attempts when receiving incoming data before a COMM_FATAL error is signalized.Permitted settings for this value are in the range of 1 to 10.Default: 3

SelectedConnectionVarName

String

Name of the variable with which the communication connection is selected.
This variable must be configured by the connection status in the zenon Editor.Note:

  • Enter the symbolic address of the variable.
    This corresponds to the Symbolic address variable property in the <CD_PRODUCDTNAME> Editor.
    In principle, it is sufficient if this variable is configured on both controllers.
  • The variable must be of the data type BOOL.
If the secondary node address is empty, this option has no meaning.

Timeout

UInt32

Defines the timeout of the communication in ms.Permitted settings for this timeout are in the area from 1ms to 1000000ms.Default: 5000ms

V23BufferSize

UInt16

Buffer size of the TCP L2 protocol.Is only used for the TCP L2 communication protocols. This property has no effect on TCP L4.Default: 1500The entry is checked after clicking on the button OK. In case of failure, a warning dialog pops up.

V23Motorola

UInt16

Byte sequence for the receiving or sending of data

  • Activated:
    Data is processed in Big-Endian (Motorola) format.
  • Not activated:
    Data is processed in Little-Endian (Intel) format.
Note: The byte order is also automatically detected on the basis of the RDA type. You can find further information on this in the Byte sequence chapter.

V23Port

UInt16

Communication port number.Default: 5000The entry is checked after clicking on the button OK. In case of failure, a warning dialog pops up.

V23Target

UInt16

Unique ID of the target device.Default: 0The entry is checked after clicking on the button OK. In case of failure, a warning dialog pops up.

V23Transport

UInt16

Drop-down list for the selection of the communication protocol.

  • TCP L4
  • TCP L2 Route
  • TCP L2
  • TCP L2ABB
    Note: Only supports ABB controllers. For the configuration, GDrvABBTcpIpL2X.dll must be present on the system and in the same folder as Gateway.exe. The DLL must be obtained from the manufacturer, ABB, directly. For further notes, see also the checklist.
Default: TCP L4


ALLANBNT
ObjectModel COM [image] Driver [image] DynProperties [image] ALLANBNT
Overview

DriverGroupEntry

DrvConfig.Options
DrvConfig.Routing
DrvConfig.UnsolMessages


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] ALLANBNT [image] DrvConfig.Options
Overview
External Name | Type | Description
PLCType | UInt16 | Type of the used PLC. Select from drop-down list.Note: Is ignored when routing is used.
RSLinxName | String | Label of the RS-LINX driver. Enter it in the field manually or select it via the drop-down list. It contains the drivers available in RS-LINX.


DrvConfig.UnsolMessages
ObjectModel COM [image] Driver [image] DynProperties [image] ALLANBNT [image] DrvConfig.UnsolMessages
Overview
External Name | Type | Description
DataNumber | UInt32 | File number.
DataTableAddress | UInt32 | Data table address of the PLC2.
DrvObjType | UInt32 | Selection of the type from the drop-down list.
ElementOffset | UInt32 | Element number.
NetAddress | UInt32 | Network address of variables.


DrvConfig.Routing
ObjectModel COM [image] Driver [image] DynProperties [image] ALLANBNT [image] DrvConfig.Routing
Overview

External Name

Type

Description

Channel

char

Selected channel.

DHRIOSlot

Byte

Number of the slot in the rack in which the DHRIO module is located.

IPAddress

UInt32

IP address of the gateway controller.

PLCType

UInt16

Type of target PLC.Note: If a different PLC has been selected in the Settings tab, the PLC selected here is used for routing.

RemoteLinkID

Byte

ID of the station.

  • 0: Local.
  • >0: Link ID of the connection configuration in RSLinx

RemoteStation

Byte

Number of the remote station.

VariableAddress

UInt32

Net address of the variable.


BACNetNG
ObjectModel COM [image] Driver [image] DynProperties [image] BACNetNG
Overview

DriverGroupEntry

DrvConfig.Connections
DrvConfig.Options


DrvConfig.Connections
ObjectModel COM [image] Driver [image] DynProperties [image] BACNetNG [image] DrvConfig.Connections
Overview

External Name

Type

Description

APDURetries

cs::A_BYTE

Request retries in case of a timeout.Default: 3

APDUSegmentTimeout

cs::A_DWORD

Timeout for the acknowledgment of one or several segments of a request.Default 2000

APDUTimeout

cs::A_DWORD

Timeout for the acknowledgment of a request.Default 3000

CharacterEncoding

cs::A_BYTE

  • Used character set. Select from drop-down list:
    • ANSI X3.4
    • ISO 10646 (UCS-4)
    • ISO 10646 (UCS-2)
    • ISO 8859-1

COVLifetime

cs::A_DWORD

Life time of COV subscriptions.Default: 60

COVResubscriptionConst

cs::A_DWORD

Additional parameter to determine when the renewed subscription is sent. Prevents, with a delayed BACnet reaction, the loss of sent values through a timeout.Default: 0Formula:(APDU_timeout*(APDU_retries+1))- COV_additional_overlapping

DeviceAddress

String

BACnet MAC address of the device.For BACnet/IP devices, it consists of the IP address and the UDP port (see Router address), for example 192.168.0.5:47808.For all other BACnet devices it consists of a byte sequence in hexadecimal format separated by : (e.g. 06:0A:67:EE).

DeviceName

String

Name of the BACnet device (name of the device object).

LocalTime

bool

ManualAddress

bool

Active: The address is not determined automatically via broadcast and the device name but can be entered manually via Router address, Network number and Device address.

MaxAPDUSize

cs::A_WORD

MaxConcurrentRequests

cs::A_WORD

NetworkNumber

cs::A_WORD

BACnet network number of the device.

ProcessId

cs::A_DWORD

Unique identification for the assignment of incoming COV-Notifications or Event-Notifications.Incoming COV-Notifications and Event-Notifications are assigned to a configured device using the value configured in this option.Default: 1For this, the following applies:

  • The Process ID must be unique per connection.
  • This ID is automatically used for COV-Subscriptions.
Note: For Event-Notifications, this process ID in the Notification-Class Objekt in the BACnet Device must correspond to the configuration configured in the driver.

ReadAPDUTimeouts

bool

Active: The APDU timeout settings are read by the device and the timeouts set for the device applies.

RouterAddress

String

BACnet MAC address of the router. It consists of the IP address of the router and the UDP port; e.g. in the following format 192.168.0.5:47808.Note: not active if the Manual address configuration property is inactive.

RPMDisable

bool

TrendLogPollingInterval

cs::A_DWORD

Interval for the polling query of Trendlog driver object type variables.Default: 10

WPMEnable

bool


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] BACNetNG [image] DrvConfig.Options
Overview

External Name

Type

Description

AddressingMode

UInt16

APDURetries

UInt16

Maximum number of recurrences for APDUs that are requested by a BACnet Device. This is applicable for APDUs that need a confirmation but for which no confirmation has yet been received.

APDUSegmentTimeout

UInt16

Time in milliseconds between the recurrences of APDU segments if the driver responds as a BACnet device.

Connection

String

  • Name of the network connection or IP address which should be used for the BACnet/IP communication.Selection from drop-down list:
    The name matches the name which is displayed under Control Panel -> Network connections.    Configuration and behavior:
    • The drop-down list contains the names of all connections available at the system. As an alternative you can enter any name. Instead of a name, an IP address can also be entered manually.
    • If you do not enter a name, the first network adapter of the system is used.
      Note: With systems with several network cards, always enter the connection name.
    • If there is no adapter with a name that corresponds to the Network connection setting, the IP addresses of all adapters are searched. If a match is found, this address is used.

DeviceIDServer1

UInt16

BACnetObjectIdentifier of the driver on the primary server or the standalone zenon Runtime. Numeric value in order to identify the Device Object uniquely in the network.Default: 4193284

DeviceIDServer2

UInt16

BACnetObjectIdentifier of the driver on the standby server. Numeric value in order to identify the Device Object uniquely in the network.Default: 4193285

DeviceNameServer1

String

Name of the Device Object in the driver on the primary server or the standalone Runtime. Is to allow the Device Object to be identified uniquely in the network.
Entry of an alphanumeric value. Only ANSI characters are permitted. At least one character must be entered.Default: BacNetNG Driver 1

DeviceNameServer2

String

Name of the Device object in the driver on the standby server. Is to allow the device object to be identified uniquely in the network.
Entry of an alphanumeric value. Only ANSI characters are permitted. At least one character must be entered.Default: BacNetNG Driver 2

ErrorWaitTime_ms

UInt32

Error wait time in milliseconds.Default: 20000 ms

ForeignDeviceBBMDAddress

String

Host name or IP address of the BBMD to which the foreign device registration of the driver is sent.Attention: If a host name is used here, this can lead to problems with the current BACnet communication in the event of invalid naming.

ForeignDeviceBBMDPort

UInt16

Port for communication to the BACnet Broadcast Management Device.Default: 47808

ForeignDeviceRegistrationLifeTime_s

UInt16

Repetition rate in seconds for cyclical registration of the driver on the foreign device.Default: 30 s

ForeignDeviceRegistrationRetries

UInt32

Repetition of the registration if no confirmation has been received within the configured timeout time. If the number of repetitions has been completed, this is considered an error.Note: After an error, a new registration is only attempted once the error wait time configured in the Error wait time option has expired.Default: 3

ForeignDeviceRegistrationTimeout_ms

UInt32

Time limitation for registration in milliseconds. If no confirmation for registration is received within the configured time, a repetition is sent.Default: 3000 ms

NetworkNumber

UInt16

BACnet network number of the local BACnet network.Default: 1

ObjectSeperator

String

Entry of the separator for variable name, identification or symbolic address, in order to separate the device name from the object name.Default: Dot (.)Note: The characters @ and # are not permitted as separators. If one of the two characters is used, communication is not possible.

PropertySeparator

String

Entry of the separator in variable name, identification or symbolic address, in order to separate the object name from the property name.Default: Dot (.)Note: The characters @ and # are not permitted as separators. If one of the two characters is used, communication is not possible.

RegisterAsForeignDevice

bool

Checkbox for the activation of communication to a BBMD:

  • active: The BACnetNG driver registers itself on the configured BBMD (BACnet Broadcast Management Device) as a foreign device.
  • Inactive: The driver does not communicate to a BBMD
Default: Inactive

SymAddressSourceProperty

UInt16

  • Selection of addressing from drop-down list:
    • Name:
      Corresponds to the Name variable property in the zenon Editor.
    • Identification:
      Corresponds to the Identification variable property in the zenon Editor.
    • Symbolic address:
      Corresponds to the Symbolic address variable property in the zenon Editor.
    Default: NameNote: This option is only available if the Addressing mode is configured with Symbolic, Property ID or Symbolic.

UDPBroadcastPorts

String

In addition to the BACnet/IP port standard (0xBAC0 or 47808) BACnet/IP broadcasts can be directed to further UDP ports.
Example: 47809; 47810Note: Only available if Register as foreign device has been activated.

UDPPort

UInt16

Local UDP port which should be used for the communicationDefault: 47808


BeckhNG
ObjectModel COM [image] Driver [image] DynProperties [image] BeckhNG
Overview

DriverGroupEntry

DrvConfig.Connections
DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] BeckhNG [image] DrvConfig.Options
Overview

External Name

Type

Description

SymbVarName

UInt16

Defines from where the variable addressing via symbol name receives its symbol information.
Selection by means of radio buttons:

  • Variable name :
    Symbol information comes from the Name property of the variables
  • Variable identification:
    Symbol information comes from the Identification property of the zenon variables. To do this, the symbol name must have the same prefix as the variable name. E.g.: S0_.Symbol name
    where S0_ stands for Station number0 .
  • Symbolic address:
    Symbol information comes from the Symbolic address property of the variables.
Default: Variable nameNote: This setting is also considered for the online import.For details see Addressing chapter.

Timeout

long

Entry of the AMS timeout time in milliseconds.
The timeout can be set to 2000 ms for AMS routers.Default: 2000If there is an error during the communication with the TwinCAT PLC (e.g. the PLC does not respond), the communication will be interrupted after that time and the driver status will be set to invalid status.Refer to chapter Requirements.


DrvConfig.Connections
ObjectModel COM [image] Driver [image] DynProperties [image] BeckhNG [image] DrvConfig.Connections
Overview
External Name | Type | Description
NetAddress | UInt32 |
NetID | String | Entry of the net address with ID.
Port | UInt32 | Entry of the port.


BURPVI
ObjectModel COM [image] Driver [image] DynProperties [image] BURPVI
Overview

DriverGroupEntry

DrvConfig.Connections
DrvConfig.Options
DrvConfig.PVIInit


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] BURPVI [image] DrvConfig.Options
Overview
External Name | Type | Description
BAImportMode | UInt16 | General descriptionValue 0 Active: Only individual variables are created and no nodes are displayed.Default setting.Value 1: Active: For arrays and structures, only block variables are created, but no variables that represent individual variables of structures/arrays. This option has no influence on top level variables.Value 2Active: For arrays and structures, both individual elements and blocks that represent the whole structure are represented.
BAItemsAsBlockArray | BOOL | Active: At the import of array elements select Driver object typesRead in a request - exception for arrays in structures.
BASuffix | String | Suffix for the zenon names of variables that were created as block array - variables that represent a whole structure or complete array.
KonfDatei | String | File in which the configuration of connections and the global settings are saved. Click on ... in order to open the Windows Explorer.Note the hints in chapter: Configuration file in redundant operation.
StructItemsAsBlockArray | BOOL | Active: At the import of array elements select Driver object typesRead in a request - also for arrays in structures.


DrvConfig.PVIInit
ObjectModel COM [image] Driver [image] DynProperties [image] BURPVI [image] DrvConfig.PVIInit
Overview
External Name | Type | Description
Event | bool | Active: All PVI variables are requested via event mode (PVI command AT=rwe HY=0).Inactive: PVI variables are read cyclically with the setting of the global update time (AT=rw, RF=global update time in ms).
Linie | String |
LM | UInt16 |
PT | UInt16 |
Remote | bool | Active: Connection to a remote PVI system via TCP/IP is established. The communication takes place exclusively via this gateway. A local PVI installation is always necessary.In addition to the settings for the driver, you must configure the setting for the remote communication via TCP/IP on the PVI itself (PVI client/Manager) - locally and on the remote system.
RemoteIP | String | Computer name or IP address on which the remote PVI system is installed and runs.
RemotePort | UInt16 | TSP/IP port number of the remote PVI system.Note: Any firewall that may be present must be configured so that the target port can be reached.
Timeout | UInt32 | Timeout or PVI communication in seconds. PviInitialize (dwTimeout, …)


DrvConfig.Connections
ObjectModel COM [image] Driver [image] DynProperties [image] BURPVI [image] DrvConfig.Connections
Overview
External Name | Type | Description
CPUParameter | String | Direct input of the PVI CPU parameter. This is the station address of the CPU. For serial connections no station address is needed.Ethernet default: /DA=2Serial default: -
DeviceParameter | String | Direct input of the PVI device parameter. If you carry out the setting for the connection with the configuration dialog for Ethernet or Serial, the settings are overwritten here.Ethernet default: /IF=TCPIP /SA=1Serial default: /IF=COM1 /BD=57600 /PA=2 /IT=1You can find the settings for the single communication types in chapter Device parameter - INA2000 device object
Name | String | Symbolic connection name. This name is used as a prefix for the variable name.
NetAddress | UInt32 | Net address of the connection for the allocation of variables. Attention: If you change the net address here, you must also change the net address of all other variables of the connection. Otherwise the allocation is no longer correct and variables cannot communicate in the Runtime!
PathTarget | String | Direct input of a routing path for the routing via PLC stations. See description for routing further down.


CIFMPI
ObjectModel COM [image] Driver [image] DynProperties [image] CIFMPI
Overview

DriverGroupEntry

DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] CIFMPI [image] DrvConfig.Options
Overview
External Name | Type | Description
Adresse | Byte | MPI address of the CIF card in the MPI net. Here you can also change the MPI address of the card. The MPI address has already been assigned in the MPI network. Every MPI station must have a unique number.
Baudrate | Byte | Speef factor of the communication; must be set at the card with the included software.
IPAdresse | UInt32 | TCP/IP address of the communicating NetLink adapter.
Karte | Byte | Number of the CIF communication card (board number). In CE, that will be 0 most of the time.
KartenVerbindung | Byte |
MultiMPI | Byte | Value 0Select this option to access a PLC with several PCs via the NetLink adapterValue 1Select this option to communicate with several PLCs on one PC.Attention:If you select this option, you can only access with one PC. If you use another one, this may lead to a failure of the NetLink adapter.
StringHeader | BOOL | Method of saving a String variable in the PLC.
Timeout | UInt16 | Timeout in milliseconds for the internal communication with the PLC.
Version | UInt32 |


DATEI32
ObjectModel COM [image] Driver [image] DynProperties [image] DATEI32
Overview

DriverGroupEntry

DrvConfig.NetAddrMap
DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] DATEI32 [image] DrvConfig.Options
Overview
External Name | Type | Description
FileFormat | UInt32 |
NetAddrFile | String |
ReadDir | String |
Seperator | String |
WriteDir | String |


DrvConfig.NetAddrMap
ObjectModel COM [image] Driver [image] DynProperties [image] DATEI32 [image] DrvConfig.NetAddrMap
Overview
External Name | Type | Description
AsciiName | String |
BusNr | UInt32 |


DNP3_TG
ObjectModel COM [image] Driver [image] DynProperties [image] DNP3_TG
Overview

DriverGroupEntry

DrvConfig.Connections
DrvConfig.LinkConfig
DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] DNP3_TG [image] DrvConfig.Options
Overview

External Name

Type

Description

BroadcastAddress

String

BroadcastPort

UInt16

CloseOffTime

UInt32

  • Pulse duration close:
    • On time:
      Period of time in milliseconds in which the output is ON
      Default: 1000
    • Off time:
      Period of time in milliseconds in which the output is OFF
      Default: 1000

CloseOnTime

UInt32

  • Pulse duration close:
    • On time:
      Period of time in milliseconds in which the output is ON
      Default: 1000
    • Off time:
      Period of time in milliseconds in which the output is OFF
      Default: 1000

DoublePointMapping

UInt16

Selection of Double Point Mapping to an integer value. Select from drop-down list:

  • SCADA default mapping
  • DNP3 binary mapping
  • Custom legacy mapping
Default: SCADA default mapping

EnableDualEndpoint

BOOL

Active: TCP Dual-Endpoint Mode is used.
In this mode, a controller can initiate a TCP connection if required.

EnableUDP

BOOL

Active: The UDP protocol can be used for communication with the controllers.

HalfDuplex

BOOL

Active: A telegram is sent again if a response has been received for the telegram that was last sent on the interface.

LocalUDPPort

UInt16

Local UDP port. This is used for all UDP connections.Default: 20000

NetworkAdapter

String

Selection of the network connection that is used for communication. Entry in the field or selection from a drop-down list from:

  • Name
    or
  • Network connection
    or
  • IP address.
The names of the network connections available on the local computer are shown in the drop-down list.For remote Runtime computers, enter the name of the network card or the IP address of the remote computer.This setting is active for UDP communication and TCP dual endpoint communication. If the opening of the LISTENING ports for UDP / TCP for the network configuration is unsuccessful, the driver creates a LISTENING port for all network cards in the system.

NULOffTime

UInt32

  • Corresponds to NUL:Pulse duration norm:
    • On time:
      Period of time in milliseconds in which the Output is ON
      Default: 1000
    • Off time:
      Period of time in milliseconds in which the output is OFF
      Default: 1000

NULOnTime

UInt32

  • Corresponds to NUL:Pulse duration norm:
    • On time:
      Period of time in milliseconds in which the Output is ON
      Default: 1000
    • Off time:
      Period of time in milliseconds in which the output is OFF
      Default: 1000

RCVTimeout

UInt32

Timeout in milliseconds for the receipt of a complete telegram. The start time is the first character of the telegram.Default: 1000

SendTimeout

UInt32

Timeout in milliseconds for the sending of a telegram. If the serial output buffer is filled for longer than this time period, this is considered a transmission error.Default: 5000

Serial

UInt16

Active: Communication is via the serial interface.

TCPListenerPort

UInt16

Port that is used for TCP Dual-Endpoint operation.Note: This port is used for all connections.Default: 20000

TripOffTime

UInt32

  • Pulse duration trip:
    • On time:
      Period of time in milliseconds in which the output is ON
      Default: 1000
    • Off time:
      Period of time in milliseconds in which the output is OFF
      Default: 1000

TripOnTime

UInt32

  • Pulse duration trip:
    • On time:
      Period of time in milliseconds in which the output is ON
      Default: 1000
    • Off time:
      Period of time in milliseconds in which the output is OFF
      Default: 1000

UTCTime

BOOL

Active: All times from and to the PLC are treated as UTC and not as local time.Default: active


DrvConfig.LinkConfig
ObjectModel COM [image] Driver [image] DynProperties [image] DNP3_TG [image] DrvConfig.LinkConfig
Overview

External Name

Type

Description

DisconnectDelay

UInt32

If no data is sent or received over the given time period, the TCP connection is disconnected automatically.Can also be used without TCP Dual-Endpoint. In this case, the Polling intervals must also be configured accordingly.

  • 0: deactivated

ID

A_DWORD

IPAddressPrimary

String

Entry of the primary IP address.

IPAddressSecondary

String

Backup address for redundant connection to the PLC.Only permitted for TCP connections. Not possible in combination with TCP Dual-Endpoint.

PortPrimary

UInt16

Primary UDP/TCP port of the controller.Default: 20000

PortSecondary

UInt16

Port of the backup address.

ReconnectDelay

UInt32

Minimum time period in seconds that must be between two TCP connection attempts.

Type

UInt16

Selection of connection type.


DrvConfig.Connections
ObjectModel COM [image] Driver [image] DynProperties [image] DNP3_TG [image] DrvConfig.Connections
Overview

External Name

Type

Description

AuthAggressiveMode

UInt16

Active: Authentication is carried out in the aggressive mode.

AuthErrorCounter

Byte

AuthHMACType

UInt16

  • Type of HMAC (HASH function) used if the driver sends Authentication Requests. Select from drop-down list:
    • HMAC SHA-1 4 byte
      Only permitted with SAv2 comp. authentication method. For serial connections only. Session timer must be selected as less than 1800 seconds (30 minutes).
    • HMAC SHA-1 8 Byte
    • HMAC SHA-1 10 Byte
    • HMAC SHA-256 8 Byte
    • HMAC SHA-256 16 Byte

AuthKeyWrapType

UInt16

  • Keywrap algorithm to be applied. Select from drop-down list:
    • AES-128
    • AES-256

AuthResponse

UInt16

Only permitted with SAv5 authentication method.

  • Active: The driver sends Authentication Requests for responses from the Outstation and Unsolicited Responses.
Default: not active.

AuthSessionCounter

UInt32

Select how often a session key may be used.Value: <10000 sDefault: 1000

AuthSessionTimer

UInt32

Validity of the session key in seconds.Value: <700000 sDefault: 900 s

AuthUpdateKey

String

Authentication key for secure communication. Entry in the field or automatic generation by clicking on the Generate button.It is expected for:

  • AES-128 Keywrap: 32 hexadecimal digits
  • AES-256 Keywrap: 64 hexadecimal digits
Permitted characters:
  • Digits: 0 to 9
  • Letters: a to f and A to F
  • Special characters: Space, points and colon
All remaining letters: Are interpreted as 0 and will possibly fail during generating the session key.

AuthUse

UInt16

Value 0Active: No authentication filter is used.Value 1Active: Authentication in compatibility mode for version 2.Value 2Active: Authentication for version 5.

DstAddress

UInt32

ErrorWaitTime

UInt32

Error waiting time in seconds. After an error, the given time is waited before another attempt at establishing a connection is made

  • 0: deactivated

EvIv1

UInt32

Specific interval for the respective class for the Polling of Events in seconds.Value: 0 to 99999

  • 0: no Polling
Default: 0

EvIv2

UInt32

Specific interval for the respective class for the Polling of Events in seconds.Value: 0 to 99999

  • 0: no Polling
Default: 0

EvIv3

UInt32

Specific interval for the respective class for the Polling of Events in seconds.Value: 0 to 99999

  • 0: no Polling
Default: 0

FileTransferDir

String

Folder for file transfer (read).Specify the folder on the Runtime computer in which files for File transfer are to be stored. The data is copied from the outstation to the master. The computer on which zenon Runtime runs is designated as the master.This path must be entered manually. Note that this path must also be present on the target system. If this path does not exist on the target system, the file transfer will not be successful. Only the entry of an absolute path is permitted.The entry is checked. A corresponding warning dialog is shown in the event of an incorrect configuration.Ensure that there are the corresponding access rights.Note: For File transfer directory and Reverse file transfer directory, the same directory can also be used.

FileTransferRevDir

String

Specify the folder on the Runtime computer in which the files for transfer in write direction are stored.The files that are to be sent by the master (zenon) to the outstation are stored in this folder.This path must be entered manually. Note that this path must also be present on the target system. If this path does not exist on the target system, the file transfer will not be successful. Only the entry of an absolute path is permitted.The entry is checked. A corresponding warning dialog is shown in the event of an incorrect configuration.Ensure that there are the corresponding access rights.Note: For File transfer directory and Reverse file transfer directory, the same directory can also be used.

FileTransferTimeout

UInt16

Time period in which an attempt is made to conclude the file transfer.
Once this time has expired, the file transfer is canceled with an error on the master.Default: 5 seconds

FriendlyName

String

Name of connection. Freely selectable.

InitialWaitTime

UInt32

Initial waiting time before another attempt to establish a connectionCan be used to stagger the establishment of a connection to different Outstations.Default: 0

IntIv

UInt32

Integrity poll of the driver in seconds.Default: 3600

Keepalive

UInt32

If data is received or sent beyond the given time, a LINK_STATUS_REQUEST telegram is sent.

  • 0: deactivated

LinkId

UInt32

Selection of the TCP/UDP channel via which communication with this Outstation takes place.With virtual Outstations, it is possible that several stations share one channel.(Not available for serial communication.)

MaxAPDUSize

UInt32

NetAddress

UInt32

Net address of the connection.Value between 0 and 255.
Corresponds to the Net address property for the variable.

NoAutoIIN_ClassPoll

UInt16

Active: Driver ignores Internal Indication Flags IIN1.1, IIN1.2 and IIN 1.3
Compatibility setting. Ensure that polling for events is carried out regularly in order to avoid possible buffer overflows in the Outstation.

NoAutoIIN_IntPoll

UInt16

Active: Driver ignores the Internal Indication Flag IIN2.3 (Buffer Overflow). Compatibility setting.

NoAutoIIN_TimeSync

UInt16

Active: The driver ignores the internal indication flag IIN1.4.
Compatibility setting. Time synchronization required.

ReplyTimeout

UInt32

Time in milliseconds that is waited for a response from the controller. If this time has expired, a repetition is sent.If a fragment of a multi-part response is received. The interval starts over with each fragment received.Default: 10000 ms

Retries

UInt32

Number of communication retries after timeouts.

  • 0: deactivated

SrcAddress

UInt32

The driver's own address (DNP3 Master).

TimeSyncDelayMeasure

UInt16

If active, the driver carries out a Delay Measurement when time synchronizing.Active if:

  • Connection type Serial
  • IP connection type (TCP/UDP) andTimesync LAN not active.
Note: With a serial connection, Timesync_LAN is active by default and grayed out, Delay Measurement (Timesync) can however be selected.

TimesyncLAN

UInt16

  • Active: Time synchronization via the LAN.
Can only be configured for TCP connection.
If serial connection type is selected, the property in the driver dialog is automatically activated and grayed out.Note: Use variation 3 of the time object. This is not accepted by all stations.

Unsol1

UInt16

Active: For this class, Unsolicited Events are accepted. (See also chapter adressing .)

Unsol2

UInt16

Active: For this class, Unsolicited Events are accepted. (See also chapter adressing .)

Unsol3

UInt16

Active: For this class, Unsolicited Events are accepted. (See also chapter adressing .)


Driver
ObjectModel COM [image] Driver [image] DynProperties [image] Driver
Overview
External Name | Type | Display Name | Description
Description | String | Description | Description of the driver. .
DriverId | UInt32 | Driver Id |
ExternalReference | String | External reference | Note: If a driver is replaced, the content of the property is transferred to the new driver. If two drivers are united into one as a result of the replacement, the value for this property is taken from the driver that continues to exist.
Name | String | Identification | .
NameFile | String | File name | File name of the driver. The file is located in program folder of the control system. .
SimulEvPort | UInt16 | Event port | Only available if a simulation project has been created.TCP/IP port for spontaneous data exchange. The port number must be distinct, not used in the project and available on the computer on which the driver runs At creating the simulation project a distinct port number is assigned automatically.Note: An automatically assigned port number is only unique for the respective project. In multi-hierarchic projects you must check this in order to avoid communication errors with the zenon Logic Workbench/Runtime.Minimum: 6001 (with automatic allocation, manually: recommended)Maximum: 6998 (with automatic allocation, manually: recommended)Default: 6001 .
SimulName | String | Name | Name of the simulation project. If there is no valid name available at the start of the zenon Logic Workbench, a name is assigned automatically. The name consists of the driver name and its description.Conditions for valid names:- must not be empty- must be distinct in the project- may only consist of characters which are allowed in zenon Logic; forbidden are: /\:*?<>!|"Minimum: 1 charactersMaximum: 15 characters. .
SimulPort | UInt16 | Standard port | Only available if a simulation project has been created.TCP/IP port for the communication with the zenon Logic Workbench. Permitted port numbers:Minimum: 6000 (with automatic allocation, manually: recommended)Maximum: 6999 (with automatic allocation, manually: recommended)Default: 6000 The port number must:Be free in the projectBe unique for all projects that run in RuntimeBe available on the computer on which the driver runs.When creating the simulation project, a unique port number is assigned automatically.Note: An automatically assigned port number is only unique for the respective project. In multi-hierarchic projects you must check this in order to avoid communication errors with the zenon Logic Workbench/Runtime. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .


DriverCommon
ObjectModel COM [image] Driver [image] DynProperties [image] DriverCommon
Overview

DriverGroupEntry

DrvConfig
DrvConfig.Com


DrvConfig
ObjectModel COM [image] Driver [image] DynProperties [image] DriverCommon [image] DrvConfig
Overview

External Name

Type

Description

GenDriverMode

Byte

  • Allows to switch between hardware mode and simulation mode
    • Hardware:
      A connection to the control is established.
    • Simulation - static:
      No communication between to the control is established, the values are simulated by the driver. In this modus the values remain constant or the variables keep the values which were set by zenon Logic. Each variable has its own memory area. E.g. two variables of the type marker with offset 79 can have different values in the Runtime and do not influence each other. Exception: The simulator driver.
    • Simulation - counting:
      No communication between to the control is established, the values are simulated by the driver. In this modus the driver increments the values within a value range automatically.
    • Simulation - programmed:
      No communication is established to the PLC. The values are calculated by a freely programmable simulation project. The simulation project is created with the help of the zenon Logic Workbench and runs in a zenon Logic Runtime which is integrated in the driver.
      For details see chapter Driver simulation.

GenGlobalUpdateTime

UInt32

Setting for the global update times in milliseconds:

  • Active:
    The set Global update time is used for all variables in the project. The priority set at the variables is not used.
  • Inactive:
    The set priorities are used for the individual variables.
Exceptions: Spontaneous drivers ignore this option. They generally use the shortest possible update time.
For details, see the Spontaneous driver update time section.

GenKeepUpdateList

bool

Variables which were requested once are still requested from the control even if they are currently not needed.
This has the advantage that e.g. multiple screen switches after the screen was opened for the first time are executed faster because the variables need not be requested again. The disadvantage is a higher load for the communication to the control.

GenOutputWriteable

bool

GenPrioUpdateTime0

UInt32

The polling times for the individual priority classes are set here. All variables with the according priority are polled in the set time.The variables are allocated separately in the settings of the variable properties.
The communication of the individual variables can be graded according to importance or required topicality using the priority classes. Thus the communication load is distributed better.Attention: Priority classes are not supported by each driver, e.g. spontaneously communicating zenon drivers.

GenPrioUpdateTime1

UInt32

The polling times for the individual priority classes are set here. All variables with the according priority are polled in the set time.The variables are allocated separately in the settings of the variable properties.
The communication of the individual variables can be graded according to importance or required topicality using the priority classes. Thus the communication load is distributed better.Attention: Priority classes are not supported by each driver, e.g. spontaneously communicating zenon drivers.

GenPrioUpdateTime2

UInt32

The polling times for the individual priority classes are set here. All variables with the according priority are polled in the set time.The variables are allocated separately in the settings of the variable properties.
The communication of the individual variables can be graded according to importance or required topicality using the priority classes. Thus the communication load is distributed better.Attention: Priority classes are not supported by each driver, e.g. spontaneously communicating zenon drivers.

GenPrioUpdateTime3

UInt32

The polling times for the individual priority classes are set here. All variables with the according priority are polled in the set time.The variables are allocated separately in the settings of the variable properties.
The communication of the individual variables can be graded according to importance or required topicality using the priority classes. Thus the communication load is distributed better.Attention: Priority classes are not supported by each driver, e.g. spontaneously communicating zenon drivers.

GenRemanentImage

bool

This option saves and restores the current value, time stamp and the states of a data point.Fundamental requirement: The variable must have a valid value and time stamp.The variable image is saved in mode hardware if:

  • one of the states S_MERKER_1(0) up to S_MERKER8(7), REVISION(9), AUS(20) or ERSATZWERT(27) is active
The variable image is always saved if:
  • the variable is of the object type Driver variable
  • the driver runs in simulation mode. (not programmed simulation)
The following states are not restored at the start of the Runtime:
  • SELECT(8)
  • WR-ACK(40)
  • WR-SUC(41)
The mode Simulation - programmed at the driver start is not a criterion in order to restore the remanent variable image.

GenStopPassiveDrv

bool

Setting for redundancy at drivers which allow only one communication connection. For this the driver is stopped at the Standby Server and only started at the upgrade.Attention: If this option is active, the gapless archiving is no longer guaranteed.

  • Active:
    Sets the driver at the not-process-leading Server automatically in a stop-like state. In contrast to stopping via driver command, the variable does not receive status switched off but an empty value. This prevents that at the upgrade to the Server irrelevant values are created in the AML, CEL and Historian.
Default: InactiveHinweis: Nicht verfügbar, wenn CE Terminal als Datenserver dient. Weitere Informationen dazu erhalten Sie im Handbuch zenon Operator im Kapitel CE Terminal als Datenserver.

GenUseGlobalUpdateTime

bool

Setting for the global update times in milliseconds:

  • Active:
    The set Global update time is used for all variables in the project. The priority set at the variables is not used.
  • Inactive:
    The set priorities are used for the individual variables.
Exceptions: Spontaneous drivers ignore this option. They generally use the shortest possible update time.
For details, see the Spontaneous driver update time section.


DrvConfig.Com
ObjectModel COM [image] Driver [image] DynProperties [image] DriverCommon [image] DrvConfig.Com
Overview

External Name

Type

Description

AutoConnect

bool

BaudRate

UInt32

Selection of the Baud rate for the communication to the PLC.
The Baud rate must be amended to the controller.
Selection from drop-down list:
110 to 1152000Default: 9600

ByteSize

Byte

Number of data bits (data word length in bits) for communication to the PLC.
The data bit rate must be amended to the controller.
Select from drop-down list:
5, 6, 7, 8Default: 8

Callback

bool

ConnectTime

UInt16

Device

String

Selection of the serial interface (com port) on the computer.
Select from drop-down list:
COM 1 to COM 256Default: 1

Modem

bool

NetAddress

UInt32

Parity

Byte

Selection of the parity for the communication to the PLC.
The parity must be amended to the controller. Amend to PLC.
Select from drop-down list:

  • No
  • Odd
  • Even
Default: No

PhoneNumber

String

PortID

UInt32

Selection of the serial interface (com port) on the computer.
Select from drop-down list:
COM 1 to COM 256Default: 1

Protocol

UInt32

Selection of the protocol for communication to the PLC.
The protocol must be amended to the controller.
Select from drop-down list:

  • No
  • Rts/CTS
Default: No

ReCallIdleTime

UInt16

RxIdleTime

UInt16

StopBits

Byte

Selection of the stop bit for communication to the PLC.
The stop bit must be amended to the controller.Select from drop-down list:

  • 1
  • 1.5
  • 2
Default: 1


FraPort
ObjectModel COM [image] Driver [image] DynProperties [image] FraPort
Overview

DriverGroupEntry

DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] FraPort [image] DrvConfig.Options
Overview
External Name | Type | Description
StationNumberServer | UInt16 | Station number of the zenon server.
StationNumberStandBy | UInt16 | Station number of the zenon standby server.
UseIdentification | BOOL | Active: The identification instead of the name is used for symbolic addressing.


IEC850
ObjectModel COM [image] Driver [image] DynProperties [image] IEC850
Overview

DriverGroupEntry

DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] IEC850 [image] DrvConfig.Options
Overview

External Name

Type

Description

ConfigurationFileName

String

Name of the file in which the driver-specific configurations are saved. Click on the ... button to open the dialog for selecting a drop folder.Note: You can read about the structure of this configuration file in the Driver configuration file chapter.

DeactivateDoublePointMapping

BOOL

  • Inactive: The values of Double Point Values are adjusted to the operating elements of zenon. Use this configuration if you want to use the modules of the zenon Energy Edition.
    You can find details in the Double Point Value Mapping chapter.
  • Active: The values of the Double Point Values are forwarded to zenon as they are. In this case, you cannot use the command processing function of zenon Energy or ALC for example.
Default: Inactive

DirectoryForFileTransfer

String

Directory for file transfer. All files loaded are saved in this folder.More in the Filetransfer chapter.

DoNotPurgeBRCB

BOOL

  • Active: The buffer of the BRCBs are not deleted on the IED when the connection is first established after Runtime has started.
    Requirements: For this BRCB , the last EntryID received has been saved. If no EntryID has been saved yet, the property is ignored and the driver sets BRCB.PurgeBuf=TRUE.
Only has an effect after the first attempt to activate a BRCB after Runtime has been restarted.Is ignored with repeated attempts to set a BRCB.RptEna=TRUE - if the RCBs enable retries time has expired.Note: If Runtime has not been stopped and only the connection to the IED has been disconnected, the setting is irrelevant. After reconnection, the driver attempts to get the buffered values again; the driver does not delete the values.More in the Buffered reporting chapter.

IdentificationForExternalName

UInt16

States which variable property is used in the driver for the addressing (ObjectReference ).

  • Variable name (Name)
  • Variable identification (Identification)
  • Symbolic address (Symbolic address)
Default: Symbolic addressNote: When importing the variables, the driver fills all three variable properties with valid references. You can rename the properties that the driver does not then use for addressing.

OriginatorCategory

UInt16

The driver sends the configured orCat value in commands - in SBOw and Oper structures - that it writes to the IED .Possible settings:

  • 1 - Bay-control
  • 2 - Station-control
  • 3 - Remote-control
  • 4 - Automatic-bay
  • 5 - Automatic-station
  • 6 - Automatic-remote
  • 7 - Maintenance
Default: 2 - Station-control


IEC870
ObjectModel COM [image] Driver [image] DynProperties [image] IEC870
Overview

DriverGroupEntry

DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] IEC870 [image] DrvConfig.Options
Overview

External Name

Type

Description

ConfFileName

String

Enter the name of the configuration file here. This file is required for the definition of the driver connection.

FileDir

String

Here, enter the folder in the Runtime computer in which the "file transfer" files are to be stored.
In this folder, there are the files that are received by the IEC60870 slave (GET).

FileDirCtrlDir

String

Path of the directory in which the files for file transfer are located.
In this folder, the files that are sent to the IEC60870 slave are stored(PUT).

MaxTimeDiff

UInt32

These parameters define a maximum time limit up to which the time synchronizations in reverse direction will be performed automatically by the system. If the difference is bigger than the configured duration, the synchronization will not be performed.Default: 60 s

NoRemapDP

BOOL

Inactive(default): The values of double messages (DPI and DCS) are adjusted to the operating elements of zenon. Use this configuration if you want to use the modules of zenon Energy.The driver converts the values of double messages (DPI and DCS) for the Runtime:

  • intermediate | off | on | fault
    to: 2 | 0 | 1 | 3,
    so that in Runtime, for example, the value 0 means OFF and 1 means ON.
Active: The values of double messages are forwarded to zenon exactly as they are:
  • intermediate | off | on | fault
    = 0 | 1 | 2 | 3).
    However, in this case you cannot use the command processing, for example, to write double messages.
Note: The driver only converts a value of the variable that corresponds to the DPI/DCS value range. DPI/DCS consists, according to the standard, of 2 bits; all other bits of the variable are not transferred.


ISPIP
ObjectModel COM [image] Driver [image] DynProperties [image] ISPIP
Overview

DriverGroupEntry

DrvConfig.Connections
DrvConfig.Options


DrvConfig.Connections
ObjectModel COM [image] Driver [image] DynProperties [image] ISPIP [image] DrvConfig.Connections
Overview
External Name | Type | Description
ConnectionName | String |
DirectConnectedNetwork | UInt16 |
IPAddress | String |
NetAddress | UInt32 |
Password | String |
Port | UInt32 |
Username | String |


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] ISPIP [image] DrvConfig.Options
Overview

External Name

Type

Description


Logix32
ObjectModel COM [image] Driver [image] DynProperties [image] Logix32
Overview

DriverGroupEntry

DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] Logix32 [image] DrvConfig.Options
Overview
External Name | Type | Description
ConfFileName | String | The file Default.lix is set by default and has to be in the current project directory. The filename Default.lix can be changed for a project by simply overwriting it.
ErrorWaitTime | UInt32 | If the connection fails, the driver will take this amount of time between re-attempts to establish communication. Shorter times result in a higher need of network resources.
UseKennung | BOOL | The name of the variable is not resolved via the name but via the identification.


MODBUS_ENERGY
ObjectModel COM [image] Driver [image] DynProperties [image] MODBUS_ENERGY
Overview

DriverGroupEntry

DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] MODBUS_ENERGY [image] DrvConfig.Options
Overview

External Name

Type

Description

ConnectionRetries

UInt32

Number of send repetitions when there is no answer from the slave after the set communication timeout.

  • 1: a connection attempt, no repetitions
  • 0: constant repetition
Default: 6

ConnectionTimeout

UInt32

Time in milliseconds to wait for a response from the Slave. A communication error will be displayed if there is no response within this time.Default: 3000 ms

DWORDByteOrder

UInt16

Defines the sequence of lower-value and higher-value words for double word objects (DINT/UDINT). You can choose between Motorola (Big-Endian) and Intel (Little-Endian).

FileTransferDirectory

String

Folder for file transfer.

FLOATByteOrder

UInt16

Defines the sequence of lower-value and higher-value words for FLOAT objects (REAL). You can choose between Modbus Standard (Big-Endian) and HB-Controller (Little-Endian).

JoinConnections

BOOL

Active: Connections with the same IP address and port number will be grouped.If you want to establish only one TCP connection to a gateway, activate this option.

MaxBlockSize

Byte

Defines the maximum number of registers that can be queried or written using a data telegram. The configured value applies for both read and write requests. If you configure a value bigger than 100, a maximum number of 100 registers will be used for write requests.Allowed value range: 1 - 125.

Offset1

BOOL

Active: The driver subtracts 1 when the variable addresses (coils, register) are sent and adds 1 when they are received.Affects the addressing of all variables.

ReConnectTimeout

UInt32

Time in milliseconds to wait after a communication error before trying to reestablish the connection.Default: 20000 ms

STRINGByteOrder

UInt16

Defines display of the byte sequence.Note: If there is relevant information in the documentation of a PLC the following is usually applicable:MSB-first =

  • Motorola = Big-Endian = Modbus.
  • Intel = Little-Endian = PC.
This can be handled differently in some documentation however.


MODRTU32
ObjectModel COM [image] Driver [image] DynProperties [image] MODRTU32
Overview

DriverGroupEntry

DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] MODRTU32 [image] DrvConfig.Options
Overview

External Name

Type

Description

ASCII

BOOL

    • Active:
      The driver communicates using the Modbus ASCII protocol.
    • Inactive:
      The driver communicates using Modbus RTU.

HuBFloat

BOOL

Defines the sequence of lower-value and higher-value words for FLOAT objects (REAL). You can choose between Modbus Standard (Big-Endian) and HB-Controller (Little-Endian).

KonfDatei

String

The name of the TCP configuration file is defined here.Default: MODRTU32_[Treiberbezeichnung].txt

MaxPage

UInt32

Maximum block size of a data telegram in WORDs.Attention zenon before 5.50 SP6: Block size must be less than 64. (1-125, Default 32)

ModbusString

short

Defines display of the byte sequence.Note: If there is relevant information in the documentation of a PLC the following is usually applicable: MSB-first = Motorola = Big-Endian = Modbus. And: Intel = Little-Endian = PC. This can be handled differently in some documentation however.

MotorolaDWORD

UInt32

Defines the sequence of lower-value and higher-value words for double word objects (DINT/UDINT). You can choose between Motorola (Big-Endian) and Intel (Little-Endian).

Offset

Byte

The "Offset 1" affects the addressing of all variables.Active: The driver subtracts 1 when the variable addresses (coils, register) are sent and adds 1 when they are received.

ReconnectTimeout

UInt32

Time in milliseconds to wait after a communication error has occured before trying to re-establish the connection.Default: 20000 ms

Retries

short

Number of send repetitions when there is no answer from the slave after the set communication timeout.1: a connection attempt, no repetitions0: constant repetitionDefault: 6

RTS

BOOL

Some PLCs need the RTS handshake forcorrect communication.

RTUFrame

BOOL

Active: Serial information is transferred to the TCP protocol exactly.

SendDelay

UInt32

Time delay in milliseconds for "send" orders. Affects the whole driver.Can only be selected with a serial connection.

SkipRegisters

BOOL

The driver reads data in a block. If there is no data between two address areas close to each other, the driver will still try to access these non-existent areas. This option will avoid that.

TCPIP

BOOL

Value FALSEFor serial mode, both Modbus RTU and Modbus ASCII can be selected.Value TRUERequires a configuration file. This file stores the TCP/IP settings.

Timeout

UInt32

Time in milliseconds to wait for a response from the slave. A communication error will be displayed if there is no response within this time.Only available with serial connection.Note: The communication timeout time must at any rate be higher than the maximum response time of the Modbus RTU Slave. Otherwise misinterpretation of the responses can occur.Default: 3000 ms


OmronEIP
ObjectModel COM [image] Driver [image] DynProperties [image] OmronEIP
Overview

DriverGroupEntry

DrvConfig.Connections
DrvConfig.Options


DrvConfig.Connections
ObjectModel COM [image] Driver [image] DynProperties [image] OmronEIP [image] DrvConfig.Connections
Overview
External Name | Type | Description
ConnectionName | String |
IPAddress | String |
NetAddress | UInt32 |
Port | UInt32 |
UnitID | UInt32 |


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] OmronEIP [image] DrvConfig.Options
Overview
External Name | Type | Description
ErrorWaitTime | UInt32 |


OPCUA
ObjectModel COM [image] Driver [image] DynProperties [image] OPCUA
Overview

DriverGroupEntry

DrvConfig.Server
DrvConfig.Server.Certificate
DrvConfig.Server.CompatibilityOptions
DrvConfig.Server.OperationLimits
DrvConfig.Server.Protocol


DrvConfig.Server
ObjectModel COM [image] Driver [image] DynProperties [image] OPCUA [image] DrvConfig.Server
Overview
External Name | Type | Description
DiscoveryURL | String |
InstanceName | String | Test
NetAddress | UInt32 |
Password | String |
SecurityMode | UInt32 |
SecurityPolicy | UInt32 |
ServerName | String |
ServerURL | String |
Username | String |


DrvConfig.Server.Certificate
ObjectModel COM [image] Driver [image] DynProperties [image] OPCUA [image] DrvConfig.Server.Certificate
Overview
External Name | Type | Description
ClientLocation | NSCS::COEMString |
ClientPrivateKeyLocation | NSCS::COEMString |
IssuerStoreLocation | NSCS::COEMString |
Path | NSCS::COEMString |
RevokedIssuerListLocation | NSCS::COEMString |
RevokedListLocation | NSCS::COEMString |
ServerLocation | NSCS::COEMString |
ServerPrivateKeyLocation | NSCS::COEMString |
TrustedListLocation | NSCS::COEMString |


DrvConfig.Server.Protocol
ObjectModel COM [image] Driver [image] DynProperties [image] OPCUA [image] DrvConfig.Server.Protocol
Overview
External Name | Type | Description
AbsoluteDeadband | bool |
ArraysOnIndexBasis | bool |
DataChangeFilter | UInt32 |
ExtensionObjects | bool |
KeepAliveCount | UInt32 |
LifeTimeCount | UInt32 |
PersistentNodeIDs | bool |
PublishInterval | double |
ReadInitialValues | bool |
SamplingInterval | double |


DrvConfig.Server.OperationLimits
ObjectModel COM [image] Driver [image] DynProperties [image] OPCUA [image] DrvConfig.Server.OperationLimits
Overview
External Name | Type | Description
MaxMonitoredItemsPerCall | UInt32 | Maximum number of Nodes that are included in a corresponding Request during the creation or deletion of Monitored Items.Default: 500Minimum: 1 Maximum: 4294967295
MaxNodesPerBrowse | UInt32 |
MaxNodesPerRead | UInt32 | Maximum number of Nodes that are taken into account in a BrowseRequest.Default: 500Minimum: 1 Maximum: 4294967295
MaxNodesPerTranslate | UInt32 | Maximum number of Nodes that are taken into account in a TranslateBrowsePathRequest.Default: 500Minimum: 1 Maximum: 4294967295
MaxNodesPerWrite | UInt32 | Maximum number of Nodes that are taken into account in a WriteRequest.Default: 500Minimum: 1 Maximum: 4294967295
UseServerOperationLimits | bool |


DrvConfig.Server.CompatibilityOptions
ObjectModel COM [image] Driver [image] DynProperties [image] OPCUA [image] DrvConfig.Server.CompatibilityOptions
Overview
External Name | Type | Description
Allow1024BitRSAKey | bool |
AllowHostnameMismatch | bool |
AllowInvalidCertificate | bool |
AllowUriMismatch | bool |


OPCUA32
ObjectModel COM [image] Driver [image] DynProperties [image] OPCUA32
Overview

DriverGroupEntry

DrvConfig


DrvConfig
ObjectModel COM [image] Driver [image] DynProperties [image] OPCUA32 [image] DrvConfig
Overview

External Name

Type

Description


PHLOEM
ObjectModel COM [image] Driver [image] DynProperties [image] PHLOEM
Overview

DriverGroupEntry

DrvConfig.Connections
DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] PHLOEM [image] DrvConfig.Options
Overview
External Name | Type | Description
Serial | bool | Value FALSEThe connection to the engine control unit is made by means of TCP/IP.The parameters for the IP address and the port number of an engine control unit are set in the corresponding option fields in the Edit connection area.Value TRUEThe connection to the engine control unit is set up using a serial interface.The connection parameters for the serial interface are configured in the COM tab.


DrvConfig.Connections
ObjectModel COM [image] Driver [image] DynProperties [image] PHLOEM [image] DrvConfig.Connections
Overview

External Name

Type

Description

ConnectionName

String

IPAddress

String

IPPort

UInt32

IP port number of an end point.This field is only available if TCP/IP has been selected as a connection type.Default: Empty
Input range: 1 - 65535

KnownID

LONG

Unique ID of the engine control unit.Offers the possibility to define an ID that is different from the net address.Example:

  • The Known ID of the engine control unit has been changed
and
  • The variables already configured in the zenon Editor should not be subsequently edited.

NetAddress

UInt32

Unique address of the connection to an engine control unit and serves for the unique assignment of the variables to this control unit.Default: First unused serial number
Input range: 0 - 255


POZYTON
ObjectModel COM [image] Driver [image] DynProperties [image] POZYTON
Overview

DriverGroupEntry

DrvConfig.Connections
DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] POZYTON [image] DrvConfig.Options
Overview

External Name

Type

Description


DrvConfig.Connections
ObjectModel COM [image] Driver [image] DynProperties [image] POZYTON [image] DrvConfig.Connections
Overview
External Name | Type | Description
ConnectionName | String | Connection name; is used in order to be able to distinguish between the configured devices better.
NetAddress | UInt32 | Net address; is used for the assignment of the information received from a meter to the configured zenon variables.
SerialNumber | String | Unique address of a meter; is used to establish communication, disconnect communication and to read the meter data.


S7TCP32
ObjectModel COM [image] Driver [image] DynProperties [image] S7TCP32
Overview

DriverGroupEntry

DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] S7TCP32 [image] DrvConfig.Options
Overview

External Name

Type

Description

ConfFileName

String

The configuration file must be in the current project directory. The file name can be freely defined.Default: S7TCP32_S7 TCP-IP driver.txtNote: The proposed name of the file consists of the driver names and their description.A change in this input field also has effects on the list of connections and its configuration in the TCP/IP connection tab.

ErrorWaitTime

UInt32

If the connection fails, the driver will take the set amount of time between re-attempts to establish communication.Default: 20000 ms

FloatIsKGFormat

BOOL

StringWithoutHeader

BOOL

The type of String variables in the PLC
S7 strings with or without header information:

  • Inactive: STRING
  • Active: ARRAY (CHAR)
Default: Inactive


Sprecon870
ObjectModel COM [image] Driver [image] DynProperties [image] Sprecon870
Overview

DriverGroupEntry

DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] Sprecon870 [image] DrvConfig.Options
Overview

External Name

Type

Description

ConfigFile

String

FileDir

String

Specify the directory on the Runtime computer, in which you want to store file transfer data.

MaxTimeDiff

UInt32

These parameters define a time limit up to which the time synchronizations in reverse direction will be performed automatically by the system. If the difference is bigger than the configured duration, the synchronization will not be performed.

NoRemapDP

BOOL

Inactive(default): The values of double messages (DPI and DCS) are adjusted to the operating elements of zenon. Use this configuration if you want to use the modules of zenon Energy.The driver converts the values of double messages (DPI and DCS) for the Runtime: intermediate | off | on | faultto: 2 | 0 | 1 | 3; thus in the Runtime e.g. value 0 means OFF and 1 means ON.Active: The values of double messages are passed 1:1 to zenon (intermediate | off | on | fault = 0 | 1 | 2 | 3). In this case you cannot however use for example the command processing in order to write double messages.Note: The driver only converts the value of the variable which conforms the DPI/DCS range of values.
DPI/DCS consists of 2 bits according to the standard; all other bits of the variable are not transferred.

RevDirCOA

UInt16

Entry of the COA for the following functions:

  • If the establishment of the connection has finished for all PLCs, (either failed or successful), the driver sends a M_EI_NA_1 telegram in Reverse direction with the COA configured here.
  • If the driver receives a Counter Interrogation command (C_CI_NA_1) with broadcast COA, it responds with ACTCON/ACTTERM with the configured COA
  • If the driver receives a general query (C_IC_NA_1), it is guaranteed that an ACTCON/ACTTERM with the COA configured here is sent in Reverse direction.

RevDirOrigAddr

Byte

In all telegrams sent in Reverse direction, the Originator address given here is entered if the COT size has been configured accordingly.
In all telegrams not sent in Reverse direction the Originator address0 continues to be entered.


Steriflow
ObjectModel COM [image] Driver [image] DynProperties [image] Steriflow
Overview

DriverGroupEntry

DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] Steriflow [image] DrvConfig.Options
Overview

External Name

Type

Description

FileTransferDirectory

String

Folder for file transfer.

ProtocolLengthField

UInt16

  • Selection of field lengths by activating the respective radio buttons:
    • 3 bytes
    • 4 bytes


Straton32
ObjectModel COM [image] Driver [image] DynProperties [image] Straton32
Overview

DriverGroupEntry

DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] Straton32 [image] DrvConfig.Options
Overview

External Name

Type

Description

CaseSens

BOOL

Active: You can also use variable in lower case writing.Hint: Always activate this option. Also, in the Project Compiler of the zenon Logic Workbench, activate the option Keep case of embedded symbols.

EventMode

BOOL

Active: Driver is used in spontaneous mode.Runtime versions prior to 6.20 do not support spontaneous mode. Therefore the option must be deactivated then.If event mode is activated the status bits of a zenon Logic variable (if available) are transferred to the zenon variable. Transferred are:

  • I-Bit
  • Bits 32 to 63

IgnorePLCTimeStamps

BOOL

Can only be activated if use event mode is activated.Active: Time stamp is set by zenon.inactive: Time stamp is set by target device.Default: Inactive

IP

String

IP address or PC name of the target system (PC with zenon Logic Runtime).

IP2

String

Configuration of the alternative IP address analog to the first address.If the connection to the first IP address fails, the alternative IP address will be used after the net error waiting time has passed (20-30 sec., depending on the network). The alternative address will be kept until the driver is restarted (via driver functions or restart of the zenon Logic Runtime) or until the connection fails. Then, the first IP address will be used again.

PortAdr

UInt32

Standard port which is opened by the zenon Logic Runtime for communication. Generally, this is the same port as the RT Port of the zenon Logic project.

PortAdr2

UInt32

Standard port which is opened by the zenon Logic Runtime for communication. Generally, this is the same port as the RT Port of the zenon Logic project.

Timeout

UInt32

Is not used.


STRATONNG
ObjectModel COM [image] Driver [image] DynProperties [image] STRATONNG
Overview

DriverGroupEntry

DrvConfig.Connections
DrvConfig.Options


DrvConfig.Options
ObjectModel COM [image] Driver [image] DynProperties [image] STRATONNG [image] DrvConfig.Options
Overview

External Name

Type

Description

SymbolVarName

UInt16

Selection by means of radio buttons:

  • Variable name:
    Corresponds to the Name variable properties in the zenon Editor.
  • Variable identification:
    Corresponds to the identification variable property in the zenon Editor.
  • Symbolic address:
    Corresponds to the symbolic address variable property in the zenon Editor.


DrvConfig.Connections
ObjectModel COM [image] Driver [image] DynProperties [image] STRATONNG [image] DrvConfig.Connections
Overview

External Name

Type

Description

ConnectionName

String

Lists all configured connections.

ErrorWaitTime

UInt32

Reconnect delay after connection loss (Communication timeout).After a connection error the set time period is waited until a new connection try is started.Default 20000

EventConnection

BOOL

States if an event connection should be established to the zenon Logic Runtime.

  • Enabled (spontaneous and polling): Activate event connection; variables can be polled or read via events.
  • Disabled (polling only): Event connection deactivated; variables can only be polled.
Default: Enabled (spontaneous and polling)If event mode is activated the status bits of a zenon Logic variable (if available) are transferred to the zenon variable. Transferred are:
  • I-Bit
  • Bits 32 to 63

IgnorePLCTimestamps

BOOL

Active: Time stamps which are sent by the zenon Logic Runtime are ignored. The time stamps of zenon are set.

MaxWriteRequestLen

UInt16

MultipleConnections

UInt32

Defines if several TCP connections should be established to the control in order to make a fast communication possible.

  • No (single connection): No multi-connections
  • 2 connections: 2 connections
  • - > up to 16 connections possible
Default: 2 connectionsAttention: How many simultaneous connections are supported by a zenon Logic Runtime depends on the zenon Logic Runtime. Note: If several drivers or the Workbench try to connect to the Runtime at the same time, all drivers and the Workbench must share the available connections.The COPA-DATA Runtime supports 16 simultaneous connections.

PrimaryIPAdr

String

Address of the PLC (IP address or host name).

PrimaryTCPPort

UInt16

TCP portDefault: 1200

SecondaryIPAdr

String

Address of the secondary connection to the PLC (IP address or host name).
If the first connection cannot or cannot be longer reached, it tries to reach the second address. At successful connection establishment this address is used for communication. Only after a renewed connection breakup or a driver restart, a connection to the primary address is tried again.

SecondaryTCPPort

UInt16

Secondary TCP portDefault: 1200

Timeout

UInt32

Communication timeout.If the controller is not contacted within the set time, all variables are set to the status of Invalid. A renewed connection try ensues only after the set delay time (Reconnect delay) after a connection breakup.Default: 2000


Drivers
ObjectModel COM [image] Drivers
Remarks

The object Drivers, is a collection which contains the defined drivers of the project.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroDrivers()
{
    IDrivers zenonDrivers = this.ActiveDocument.Drivers();
    for (int i = 0; i < zenonDrivers.Count; ++i)
    {
        //Print the name of each driver in the active project
        System.Diagnostics.Debug.Print(zenonDrivers.Item(i).Name);
    }
    //Get a driver object by its name instead of its ID
    IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");
    //If the driver does not exist we create it
    if (zenonDriver == null)
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");
}
VB.NET
Copy
Public Sub MacroDrivers()
    Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()
    Dim i As Integer = 0
    While i < zenonDrivers.Count
        'Print the name of each driver in the active project
        System.Diagnostics.Debug.Print(zenonDrivers.Item(i).Name)
        System.Threading.Interlocked.Increment(i)
    End While
    'Get a driver object by its name instead of its ID
    Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")
    'If the driver does not exist we create it
    If zenonDriver = Nothing Then
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")
    End If
End Sub
VBA
Copy
Public Sub DriversSample()
Dim zDrivers As Drivers
Dim zDriver As Driver
Dim i As Integer
'get drivers collection
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
'Enumerate existing drivers in the project
For i = 0 To zDrivers.Count - 1

Debug.Print zDrivers.Item(i).Name
Next i
'Create a new driver and check if already exists
Set zDriver = zDrivers.Item("NewSimulationDriver")
If zDriver Is Nothing Then

Set zDriver = zDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")
End If

End Sub


Properties
ObjectModel COM [image] Drivers [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Count of defined drivers | Readonly | Readonly | Available | Available
Parent | iproject | Parent-object | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] Drivers [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Drivers [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Drivers [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateDriver | idriver | Creates a new driver | Available | Unused | Available | Available
CreateDriverEx | idriver | Creates a new driver | Available | Unused | Available | Available
DeleteDriver | variant_bool | Deletes the given driver | Available | Unused | Available | Available
Item | idriver | Returns driver by position or name | Available | Available | Available | Available
ShowCreateDialog | ishowcreatedriverdialogresult | Opens the zenon standard dialog "Create driver". | Available | Unused | Available | Available


CreateDriver
ObjectModel COM [image] Drivers [image] Methods [image] CreateDriver
Remarks

Creates a new driver and returns the created driver as Driver object.

Datatype
IDriver

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
strName as BSTR

strEXEName as BSTR

Example
C#
Copy
public void MacroDrivers()
{
    IDrivers zenonDrivers = this.ActiveDocument.Drivers();

    //Get a driver object
    IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");
    //If the driver does not exist we create it
    if (zenonDriver == null)
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");
}
VB.NET
Copy
Public Sub MacroDrivers()
    Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()

    'Get a driver object
    Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")
    'If the driver does not exist we create it
    If zenonDriver = Nothing Then
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")
    End If
End Sub


CreateDriverEx
ObjectModel COM [image] Drivers [image] Methods [image] CreateDriverEx
Remarks

Creates a new driver and returns the created driver as Driver object. If the parameter bShowDlg is true the driver creation dialog is shown to the user.

Datatype
IDriver

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
strName as BSTR

strEXEName as BSTR

bShowDlg as VARIANT_BOOL

Example
C#
Copy
public void MacroCreateDriverEx()
{
    IDrivers zenonDrivers = this.ActiveDocument.Drivers();

    //Get a driver object by its name
    IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");
    //If the driver does not exist we create it
    if (zenonDriver == null)
        zenonDriver = zenonDrivers.CreateDriverEx("NewSimulationDriver", "SIMUL32", true);
}
VB.NET
Copy
Public Sub MacroCreateDriverEx()
    Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()

    'Get a driver object by its name
    Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")
    'If the driver does not exist we create it
    If zenonDriver = Nothing Then
        zenonDriver = zenonDrivers.CreateDriverEx("NewSimulationDriver", "SIMUL32", True)
    End If
End Sub


DeleteDriver
ObjectModel COM [image] Drivers [image] Methods [image] DeleteDriver
Remarks

Deletes the given driver by its name

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
strName as BSTR

Example
C#
Copy
public void MacroDeleteDriver()
{
    //This Macro will delete all drivers in the current active project
    //NOTE: The driver will not be deleted instantly, therefore avoid using
    //      IDrivers.Count directly in the for condition
    IDrivers zenonDrivers = this.ActiveDocument.Drivers();
    for (int i = zenonDrivers.Count - 1; i >= 0; --i)
    {
        zenonDrivers.DeleteDriver(zenonDrivers.Item(i).Identification);
    }
}
VB.NET
Copy
Public Sub MacroDeleteDriver()
    'This Macro will delete all drivers in the current active project
    'NOTE: The driver will not be deleted instantly, therefore avoid using
    '      IDrivers.Count directly in the for condition
    Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()
    Dim i As Integer = zenonDrivers.Count - 1
    While i >= 0
        zenonDrivers.DeleteDriver(zenonDrivers.Item(i).Identification)
        System.Threading.Interlocked.Decrement(i)
    End While
End Sub


Item
ObjectModel COM [image] Drivers [image] Methods [image] Item
Remarks

Returns the object Driver from the collection, which is identified by the parameter vID.vID As Variant Index or name. If the parameter is a numerical value, the driver is searched by its index (>= 0 and <= Count-1).
If it is an alphanumerical value, the driver is searched by its name.

Datatype
IDriver

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vID as VARIANT

vID As Variant Index or name.

Example
C#
Copy
public void MacroDrivers()
{
    IDrivers zenonDrivers = this.ActiveDocument.Drivers();
    for (int i = 0; i < zenonDrivers.Count; ++i)
    {
        //Print the name of each driver in the active project
        System.Diagnostics.Debug.Print(zenonDrivers.Item(i).Name);
    }
    //Get a driver object by its name instead of its ID
    IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");
    //If the driver does not exist we create it
    if (zenonDriver == null)
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");
}
VB.NET
Copy
Public Sub MacroDrivers()
    Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()
    Dim i As Integer = 0
    While i < zenonDrivers.Count
        'Print the name of each driver in the active project
        System.Diagnostics.Debug.Print(zenonDrivers.Item(i).Name)
        System.Threading.Interlocked.Increment(i)
    End While
    'Get a driver object by its name instead of its ID
    Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")
    'If the driver does not exist we create it
    If zenonDriver = Nothing Then
        zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")
    End If
End Sub


ShowCreateDialog
ObjectModel COM [image] Drivers [image] Methods [image] ShowCreateDialog
Remarks

Opens the zenon standard dialog "Create driver". After the dialog is closed the object ShowCreateDriverDialogResult is returned which contains an enumerator (ShowCreateDriverDialogReturnResult) – returns if successful or notdriver object (Driver) – created driver object (if successful)

Datatype
IShowCreateDriverDialogResult

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub showDriverDialog()
Dim obDrivers As Drivers
Dim obDriver As Driver
Dim enumDrvRet As ShowCreateDriverDialogReturnResult
Dim obDrvResult As ShowCreateDriverDialogResult
    Set obDrivers = MyWorkspace.ActiveDocument.Drivers
    Set obDrvResult = obDrivers.ShowCreateDialog
    enumDrvRet = obDrvResult.ShowCreateDriverDialogReturnResult
    If enumDrvRet = ShowCreateDriverDialogReturnResult_Successful Then
        Set obDriver = obDrvResult.Driver
        Debug.Print "Driver " & obDriver.Name & " successfully created"
    ElseIf enumDrvRet = ShowCreateDriverDialogReturnResult_UndefinedFailure Then
    'just to test the enum (elseif instead of else)
        Debug.Print "Aborted or unkown error occured"
    End If
End Sub


DynPicture
ObjectModel COM [image] DynPicture
Remarks

This collection contains the defined Screens. The single Screens can contain different dynamic elements. Each Screen is linked to a Frame, that contains general information on the outer appearance.Screens always come from the current project – the global project is ignored, as Screens are not supported in global projects.The single Screens can be found in the collection by their unique name or by the index. Each Screen is identified by an unique name.Hint:For the use of events in an object DynPicture an object DynPicture of this Screen must be defined with WithEvents.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
private IDynPicture _zenonPicture;

void ThisProject_Active()
{
    //Initialize the instance variable with the screen of name "Start"
    _zenonPicture = this.DynPictures().Item("Start");
    //Attach the event handler
    _zenonPicture.Open += new OpenEventHandler(_zenonPicture_Open);
}

void _zenonPicture_Open()
{
    //Everytime the dynPicture Start is opened a message is written to the CEL
    this.Cel().WriteCelString(_zenonPicture.Name + " was opened.");
}

void ThisProject_Inactive()
{
    //Detach the event handler
    _zenonPicture.Open -= new OpenEventHandler(_zenonPicture_Open);
    FreeObjects();
}
VB.NET
Copy
Private _zenonPicture As IDynPicture

Private Sub ThisProject_Active()
    'Initialize the instance variable with the screen of name "Start"
    _zenonPicture = Me.DynPictures().Item("Start")
    'Attach the event handler
    AddHandler _zenonPicture.Open, AddressOf _zenonPicture_Open
    _zenonPicture.Open += New OpenEventHandler(_zenonPicture_Open)
End Sub

Private Sub _zenonPicture_Open()
    'Everytime the dynPicture Start is opened a message is written to the CEL
    Me.Cel().WriteCelString(_zenonPicture.Name + " was opened.")
End Sub

Private Sub ThisProject_Inactive()
    'Detach the event handler
    RemoveHandler _zenonPicture.Open, AddressOf _zenonPicture_Open
    FreeObjects()
End Sub
VBA
Copy
'##############################################
'## VBA Code in the Module "ModuleElement" ##
'## ---------------------------------------- ##
'## LeftClickUp - Event has to be created in ##
'## the Editor with the Name "PopUp"... ##
'## (Scripting - VBA Makros - ModuleElement) ##
'##############################################
'event for clicking on a element
Public Sub LeftClickUp_PopUp(obElem As Element)
'save the position information of the element to public
'member variables in the thisProject Classmodule...
thisProject.lLeft = obElem.Left
thisProject.lTop = obElem.Top
'execute different functions depending to the element name...
'Example for FuntionName: POPUP_Valve001
'>> Valve001 ist the Objectname of the Element!
thisProject.RtFunctions.Item("POPUP_" & obElem.Name).Start
End Sub
'###############################################
'## VBA Code in the ClassModule "thisProject" ##
'## ----------------------------------------- ##
'## When the POPUP Screen opens, the Open - ##
'## Event is executed and the new positions ##
'## will be set with the Move - Method ##
'###############################################
'declaration of the position members...
Public lLeft As Long
Public lTop As Long
'declaring the DynPicture Object for the OPEN event...
Dim WithEvents dynPicPOPUP As DynPicture
'on project startup...
Private Sub Project_Active()
'setting the Dynpicture object to the "POPUP" Screen...
Set dynPicPOPUP = thisProject.DynPictures.Item("POPUP")
'check if there was a problem an initializing the DynPicture Object...
If dynPicPOPUP Is Nothing Then

MsgBox "moving the Screen is not possible..."
End If
End Sub
'when the Screen opens...
Private Sub dynPicPOPUP_Open()
'moving the Screen...
dynPicPOPUP.Move lLeft, lTop, dynPicPOPUP.Width, dynPicPOPUP.Height
End Sub
'on project exit...
Private Sub Project_Inactive()
If dynPicPOPUP Is Nothing Then Exit Sub

'release the object...

Set dynPicPOPUP = Nothing
End Sub


Properties
ObjectModel COM [image] DynPicture [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AutoKBLayout | variant_bool | Use regional settings for keyboard layout | Available | Readonly | Available | Available
BackColor | ole_color |  | Available | Readonly | Available | Available
BackgroundGraphicAlignment | backgroundgraphicalignment |  | Available | Unused | Available | Available
BackgroundImage | bstr | Background image for the picture | Available | Readonly | Available | Available
BackgroundImageStyle | long | Style for the background image. | Available | Unused | Available | Available
Bottom | long | Bottom-coordinate of the picture | Readonly | Unused | Available | Available
DynPictureContainer | ielement | Returns the container element in which the DynPicture is contained, or NULL when the DynPicture is not inside a container. (RT-Only) | Unused | Readonly | Available | Available
Enable | variant_bool | This property de/activates the current picture. | Available | Available | Available | Available
EndFunction | long | Rt-Function by closing the picture | Available | Readonly | Available | Available
Height | long | Height of the picture | Available | Readonly | Available | Available
Hide | variant_bool | Sets the visibility of the picture. | Available | Available | Available | Available
InstanceId | long | Returns the template instance ID of the DynPicture. (RT-Only) | Unused | Readonly | Available | Available
Instances | idynpictureinstances | Returns a collection containing all instances of the DynPicture. (RT-Only) | Unused | Readonly | Available | Available
Left | long | Left-coordinate of the picture | Readonly | Readonly | Available | Available
MonitorId | short | Returns the ID of the Monitor on which the picture is opened. (RT-Only) | Unused | Readonly | Available | Available
Name | bstr | The unique name of the current picture. | Available | Readonly | Available | Available
Online | variant_bool | Checks, if the current picture is open. | Unused | Readonly | Available | Available
Parent | idynpictures | Returns the parent object. | Readonly | Readonly | Available | Available
PictureFilter | ipicturefilter | Returns the current picture filter. (RT-Only) | Unused | Available | Available | Available
Right | long | Right-coordinate of the picture | Readonly | Unused | Available | Available
ShowInCE | variant_bool | Use picture in CE-projects | Available | Unused | Available | Available
ShowModal | variant_bool | Show picture as modal dialog | Available | Unused | Available | Available
StartFunction | long | Rt-Function by showing the picture | Available | Unused | Available | Available
Template | bstr |  | Available | Readonly | Available | Available
Top | long | Top-coordinate of the picture. | Readonly | Readonly | Available | Available
Type | long |  | Available | Unused | Available | Available
UseTemplateSize | variant_bool | Use size-properties of the linked template. | Available | Unused | Available | Available
Width | long | Width of the picture. | Available | Readonly | Available | Available
ZoomLevel | long | Zoom level of a world picture (RT-Only) | Unused | Readonly | Available | Available


AutoKBLayout
ObjectModel COM [image] DynPicture [image] Properties [image] AutoKBLayout
Remarks

Enables or disables the automatic keyboard layout functionality. Hint: Only available for pictures of type "Keyboard".

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


BackColor
ObjectModel COM [image] DynPicture [image] Properties [image] BackColor
Remarks

Datatype
OLE_COLOR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


BackgroundGraphicAlignment
ObjectModel COM [image] DynPicture [image] Properties [image] BackgroundGraphicAlignment
Remarks

Datatype
BackgroundGraphicAlignment

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


BackgroundImage
ObjectModel COM [image] DynPicture [image] Properties [image] BackgroundImage
Remarks

Gets or sets the path to the background image for the DynPicture.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


BackgroundImageStyle
ObjectModel COM [image] DynPicture [image] Properties [image] BackgroundImageStyle
Remarks

Style for the background image.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Bottom
ObjectModel COM [image] DynPicture [image] Properties [image] Bottom
Remarks

Returns the position of the bottom picture border in pixel. The value defines the distance from the top border of the screen.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


DynPictureContainer
ObjectModel COM [image] DynPicture [image] Properties [image] DynPictureContainer
Remarks

Returns the container element in which the DynPicture is contained, or NULL when the DynPicture is not inside a container. (RT-Only).

Datatype
IElement

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Enable
ObjectModel COM [image] DynPicture [image] Properties [image] Enable
Remarks

This property de/activates the current picture. Usually this property returns True, i.e. operation of the picture is allowed.If this property returns False, the picture is deactivated. In this case the elements of the picture cannot be operated, e.g. clicking on dynamic elements.The picture stays inactive, until this property is set back to True.Hint: Reopening the picture does not change this setting.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


EndFunction
ObjectModel COM [image] DynPicture [image] Properties [image] EndFunction
Remarks

Gets or sets the name of the function that should be executed automatically when the picture is closed in the Runtime. Hint: If more than one function should be executed, then a script with all the desired functions has to be created and the function for executing the script has to be linked here.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Height
ObjectModel COM [image] DynPicture [image] Properties [image] Height
Remarks

Returns the defined height of the picture in pixels. The height of the picture is the difference between the bottom and the top border.Hint: This property cannot be set, if the property "UseTemplateSize" is set TRUE.The following VBA example moves the current picture to the bottom and to the right by 10 pixels.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Hide
ObjectModel COM [image] DynPicture [image] Properties [image] Hide
Remarks

This property can influence the visibility of the picture. Usually this property returns False, i.e. the picture is displayed.If the property is set to True, the picture is displayed invisibly. The picture stays invisible, until this property is set back to False.Hint: Reopening the picture does not change this setting.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


InstanceId
ObjectModel COM [image] DynPicture [image] Properties [image] InstanceId
Remarks

Returns the template instance ID of the DynPicture. (RT-Only).

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Instances
ObjectModel COM [image] DynPicture [image] Properties [image] Instances
Remarks

Returns a collection containing all instances of the DynPicture. (RT-Only).

Datatype
IDynPictureInstances

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Left
ObjectModel COM [image] DynPicture [image] Properties [image] Left
Remarks

Returns the position of the left picture border in pixel. The value defines the distance from the left border of the screen.The following VBA example moves the current picture to the bottom and to the right by 10 pixels.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


MonitorId
ObjectModel COM [image] DynPicture [image] Properties [image] MonitorId
Remarks

Returns the ID of the Monitor on which the picture is opened. (RT-Only)

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] DynPicture [image] Properties [image] Name
Remarks

Returns the unique name of the current picture. With this name the picture can be found in the central pictures list of the project.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Online
ObjectModel COM [image] DynPicture [image] Properties [image] Online
Remarks

This property checks, if the current picture is open.The following example searches for the picture START. If it is found, a MsgBox informs the user, whether or not the picture is corrently opened.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] DynPicture [image] Properties [image] Parent
Remarks

Returns the parent object.

Datatype
IDynPictures

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


PictureFilter
ObjectModel COM [image] DynPicture [image] Properties [image] PictureFilter
Remarks

Returns the current picture filter. (RT-Only)

Datatype
IPictureFilter

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Right
ObjectModel COM [image] DynPicture [image] Properties [image] Right
Remarks

Returns the position of the right picture border in pixel. The value defines the distance from the left border of the screen.The following VBA example moves the current picture to the bottom and to the right by 10 pixels.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


ShowInCE
ObjectModel COM [image] DynPicture [image] Properties [image] ShowInCE
Remarks

The picture is also displayed under Windows CE, if set TRUE. Thus in networks with PCs and CE devices, functionalities, which are not supported by Windows CE, can be used on the PCs without having problems on the CE devices.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


ShowModal
ObjectModel COM [image] DynPicture [image] Properties [image] ShowModal
Remarks

Show picture as modal dialog, if set TRUE. As long as this picture is open in the Runtime, no other picture beside it can be operated (e.g. for a login picture). Other pictures that were opened out of this picture can be operated.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


StartFunction
ObjectModel COM [image] DynPicture [image] Properties [image] StartFunction
Remarks

Gets or sets the name of the function that should be executed automatically when the picture is opened in the Runtime. Hint: If more than one function should be executed, then a script with all the desired functions has to be created and the function for executing the script has to be linked here.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Template
ObjectModel COM [image] DynPicture [image] Properties [image] Template
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Top
ObjectModel COM [image] DynPicture [image] Properties [image] Top
Remarks

Top-coordinate of the picture.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] DynPicture [image] Properties [image] Type
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


UseTemplateSize
ObjectModel COM [image] DynPicture [image] Properties [image] UseTemplateSize
Remarks

Use size-properties of the linked template.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Width
ObjectModel COM [image] DynPicture [image] Properties [image] Width
Remarks

Width of the picture.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ZoomLevel
ObjectModel COM [image] DynPicture [image] Properties [image] ZoomLevel
Remarks

Zoom level of a world picture (RT-Only)

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] DynPicture [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Activate | void | Activates the picture (only runtime) | Available | Available | Available | Available
BringToTop | void | Brings picture to top of Z-order | Unused | Available | Available | Available
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
CloseDynPicture | variant_bool | Closes the Screen when its currently opened (RT-Only) | Unused | Available | Available | Available
Copy | variant_bool | Copies the picture | Available | Unused | Available | Available
CreateMdiDefaultElements | variant_bool | Create the MDI-Default elements (only with MDI-Windows) | Available | Unused | Available | Available
CreateMDIScreenTemplate | imditemplates |  | Available | Unused | Available | Available
CreateScreenTemplate | imditemplates |  | Available | Unused | Available | Available
DeselectElements | void | Deselects all currently selected Elements | Unused | Available | Available | Available
DynProperties [GET] | variant |  | Available | Available | Available | Available
DynProperties [PUT] | void |  | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant |  | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available
Elements | ielements | Returns the Elements-list | Available | Available | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
Hardcopy | variant_bool | Creates a Bitmap of the picture, with the appearance as shown in the editor. | Available | Unused | Available | Available
ImportMdiElements | short | Imports the MDI-Default elements from a template (only with MDI-Windows) | Available | Unused | Available | Available
ImportMdiTemplateItems | importmditemplateitemsresult |  | Available | Unused | Available | Available
InsertSymbol | ielement | Insert a symbol from the symbol-library | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
MdiElements | imdielements | Returns the list of the available MDI-controls | Available | Unused | Available | Available
Move | void | Updates the position of a DynPicture object. | Available | Available | Available | Available
Save | variant_bool | Method to save the picture (changes in this collection) | Available | Unused | Available | Available
SelElements | ielements | Returns the list of selected Elements | Unused | Available | Available | Available
SetZoomAndPos | void | Sets zoom factors and position of a world picture (RT-Only) | Unused | Available | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available
Update | void | Redraws a certain area of the picture. | Unused | Available | Available | Available
UpdateAll | void | Update the picture | Unused | Available | Available | Available


Activate
ObjectModel COM [image] DynPicture [image] Methods [image] Activate
Remarks

This method brings the current picture to the foreground – if it is overlapped by another picture.Be aware, that the according picture has to be opened before.The picture „Dialog“ will be switched to the foreground. If the picture is not open yet, a MsgBox shall inform the user. By switching to another picture the picture is brought to the background – but not closed. The example was written in zenOn-VBA.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroActivate()
{
    //NOTE: This macro will only bring the picture with name "Start"
    //      to the foreground - it will not perform a screen switch as
    //      if a screen switch function was used
    IDynPicture zenonPicture = this.DynPictures().Item("Start");
    zenonPicture.Activate();
}
VB.NET
Copy
Public Sub MacroActivate()
    'NOTE: This macro will only bring the picture with name "Start"
    '      to the foreground - it will not perform a screen switch as
    '      if a screen switch function was used
    Dim zenonPicture As IDynPicture = Me.DynPictures().Item("Start")
    zenonPicture.Activate()
End Sub


BringToTop
ObjectModel COM [image] DynPicture [image] Methods [image] BringToTop
Remarks

Calling this method will bring a picture without "always on top" to the highest z order of all pictures without "always on top" and a picture with "always on top" on the highest z-order of all pictures with "always on top". Pictures without "always on top" therefore will not cover pictures with "always on top".

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroBringToTop()
{
    //NOTE: This like the activate method is not a substitute for a screen switch
    //      A screen switch function should be used to switch between two pictures

    IDynPicture zenonPicture = this.DynPictures().Item("Start");
    zenonPicture.UpdateAll();
}
VB.NET
Copy
Public Sub MacroBringToTop()
    'NOTE: This like the activate method is not a substitute for a screen switch
    '      A screen switch function should be used to switch between two pictures

    Dim zenonPicture As IDynPicture = Me.DynPictures().Item("Start")
    zenonPicture.UpdateAll()
End Sub


CheckIn
ObjectModel COM [image] DynPicture [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void CheckIn(IDynPicture zenonPicture)
{
    //Checks in the DynPicture object iff it is not locked and it does differ from the server version
    if (!zenonPicture.IsLocked())
    {
        if (zenonPicture.IsDifferent())
        {
            zenonPicture.CheckIn();
        }
    }
}

public void MacroDynPictureMultiuser()
{
    //Get an object of the "Start" picture in the current active document
    IDynPicture zenonPicture = this.ActiveDocument.DynPictures().Item("Start");

    if (!zenonPicture.IsCheckedOut())
    {
        if (zenonPicture.CheckOut())
        {
            //The driver was checked out by the user who executed this macro
            if (zenonPicture.Get())
            {
                //Got the latest version of the driver
                //Edit some properties of the driver
                zenonPicture.Name = "NewName";

                //Check the DynPicture in again so others can check it out
                CheckIn(zenonPicture);

            }
            else
            {
                zenonPicture.UndoCheckOut();
                //The latest version could not be received, undo the checkout (Inform Error)
            }
        }
        else
        {
            //The DynPicture can't currently be checked out (Inform Error)
        }
    }
    else
    {
        //Someone else has the object checked out! (Inform Error)
    }
}
VB.NET
Copy
Public Sub CheckIn(zenonPicture As IDynPicture)
    'Checks in the DynPicture object iff it is not locked and it does differ from the server version
    If Not zenonPicture.IsLocked() Then
        If zenonPicture.IsDifferent() Then
            zenonPicture.CheckIn()
        End If
    End If
End Sub

Public Sub MacroDynPictureMultiuser()
    'Get an object of the "Start" picture in the current active document
    Dim zenonPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item("Start")

    If Not zenonPicture.IsCheckedOut() Then
        If zenonPicture.CheckOut() Then
            'The driver was checked out by the user who executed this macro
            If zenonPicture.[Get]() Then
                'Got the latest version of the driver
                'Edit some properties of the driver
                zenonPicture.Name = "NewName"

                'Check the DynPicture in again so others can check it out

                CheckIn(zenonPicture)
            Else
                    'The latest version could not be received, undo the checkout (Inform Error)
                zenonPicture.UndoCheckOut()
            End If
                'The DynPicture can't currently be checked out (Inform Error)
        Else
        End If
            'Someone else has the object checked out! (Inform Error)
    Else
    End If
End Sub


CheckOut
ObjectModel COM [image] DynPicture [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void CheckIn(IDynPicture zenonPicture)
{
    //Checks in the DynPicture object iff it is not locked and it does differ from the server version
    if (!zenonPicture.IsLocked())
    {
        if (zenonPicture.IsDifferent())
        {
            zenonPicture.CheckIn();
        }
    }
}

public void MacroDynPictureMultiuser()
{
    //Get an object of the "Start" picture in the current active document
    IDynPicture zenonPicture = this.ActiveDocument.DynPictures().Item("Start");

    if (!zenonPicture.IsCheckedOut())
    {
        if (zenonPicture.CheckOut())
        {
            //The driver was checked out by the user who executed this macro
            if (zenonPicture.Get())
            {
                //Got the latest version of the driver
                //Edit some properties of the driver
                zenonPicture.Name = "NewName";

                //Check the DynPicture in again so others can check it out
                CheckIn(zenonPicture);

            }
            else
            {
                zenonPicture.UndoCheckOut();
                //The latest version could not be received, undo the checkout (Inform Error)
            }
        }
        else
        {
            //The DynPicture can't currently be checked out (Inform Error)
        }
    }
    else
    {
        //Someone else has the object checked out! (Inform Error)
    }
}
VB.NET
Copy
Public Sub CheckIn(zenonPicture As IDynPicture)
    'Checks in the DynPicture object iff it is not locked and it does differ from the server version
    If Not zenonPicture.IsLocked() Then
        If zenonPicture.IsDifferent() Then
            zenonPicture.CheckIn()
        End If
    End If
End Sub

Public Sub MacroDynPictureMultiuser()
    'Get an object of the "Start" picture in the current active document
    Dim zenonPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item("Start")

    If Not zenonPicture.IsCheckedOut() Then
        If zenonPicture.CheckOut() Then
            'The driver was checked out by the user who executed this macro
            If zenonPicture.[Get]() Then
                'Got the latest version of the driver
                'Edit some properties of the driver
                zenonPicture.Name = "NewName"

                'Check the DynPicture in again so others can check it out

                CheckIn(zenonPicture)
            Else
                    'The latest version could not be received, undo the checkout (Inform Error)
                zenonPicture.UndoCheckOut()
            End If
                'The DynPicture can't currently be checked out (Inform Error)
        Else
        End If
            'Someone else has the object checked out! (Inform Error)
    Else
    End If
End Sub


CloseDynPicture
ObjectModel COM [image] DynPicture [image] Methods [image] CloseDynPicture
Remarks

Closes a opened screen. In case the screen is not open, the return value of the function = FALSE.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
//This function closes a specific screen.
 public void Macro_Test_CloseDynpicture()
        {
 //The function returns true: screen is open
 //The function returns false: screen not open
 if (!this.DynPictures().Item("Screen 2").CloseDynPicture())
            {
                System.Windows.Forms.MessageBox.Show("Couldn't close, no window with assigned name is open!");
            }
 else
            {
                System.Windows.Forms.MessageBox.Show("Closed window");
            }
        }
VB.NET
Copy
'This function closes a specific screen.
 Public Sub Macro_Test_CloseDynpicture()
 'The function returns true: screen is open
 'The function returns false: screen not open
 If Not Me.DynPictures().Item("Screen 2").CloseDynPicture() Then
            System.Windows.Forms.MessageBox.Show("Couldn't close, no window with assigned name is open!")
 Else
            System.Windows.Forms.MessageBox.Show("Closed window")
 End If
 End Sub


Copy
ObjectModel COM [image] DynPicture [image] Methods [image] Copy
Remarks

Copies the settings of an existing "DynPicture" object to the current object.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
PictureSource as IDynPicture

"DynPicture" object from which the settings should be copied from.

Example
C#
Copy
public void MacroCreateCopy()
{
    //This macro creates a copy of the start picture
    IDynPicture zenonPictureStart = this.ActiveDocument.DynPictures().Item("Start");
    //First create a new picture which we will copy our settings to
    IDynPicture zenonPictureCopy = this.ActiveDocument.DynPictures().Create("copiedPicture", "MAIN", 0);
    //Call the copy method to actually copy the settings
    zenonPictureStart.Copy(zenonPictureCopy);
}
VB.NET
Copy
Public Sub MacroCreateCopy()
    'This macro creates a copy of the start picture
    Dim zenonPictureStart As IDynPicture = Me.ActiveDocument.DynPictures().Item("Start")
    'First create a new picture which we will copy our settings to
    Dim zenonPictureCopy As IDynPicture = Me.ActiveDocument.DynPictures().Create("copiedPicture", "MAIN", 0)
    'Call the copy method to actually copy the settings
    zenonPictureStart.Copy(zenonPictureCopy)
End Sub
VBA
Copy
Sub zenOn_CopyDynPicture()
'Declarations
Dim zPic As DynPicture
Dim zPicCopy As DynPicture
'Initialize zPic with the start picture
Set zPic = MyWorkspace.ActiveDocument.DynPictures.Item("START")
'Initialize zPicCopy by creating a new picture linked to Frame "MAIN_WIZARD" as standard picture type
Set zPicCopy = MyWorkspace.ActiveDocument.DynPictures.Create("zPicCopy", "MAIN_WIZARD", 0)
'Copy the settings from zPic to zPicCopy
zPicCopy.Copy zPic

End Sub


CreateMdiDefaultElements
ObjectModel COM [image] DynPicture [image] Methods [image] CreateMdiDefaultElements
Remarks

Create the MDI-Default elements (only by MDI-Windows)

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CreateMDIScreenTemplate
ObjectModel COM [image] DynPicture [image] Methods [image] CreateMDIScreenTemplate
Remarks

Creats a template of a screen.

Datatype
IMDITemplates

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

bsGroup as BSTR

bsDescription as BSTR

bOverwrite as BOOL

Example
VBA
Copy
Private Sub CreateMDIScreenTemplate()
Dim Picture As DynPicture
Dim Template
Set Picture = MyWorkspace.ActiveDocument.DynPictures.Item("Screen 0")
' * This function creates a template from a screen *
' * The first two parameters must also be transferred, otherwise there will be an error *
' * The third parameter is optional and is the description for the template *
' * The fourth parameter denotes whether an existing template *
' * is to be overwritten if it is not a CD template *
' * The finished MDI template is returned *
Set Template = Picture.CreateMDIScreenTemplate("TemplateBild0", "Schablonen.Copadata", "Short desciption text for this template", True)
If Not Template Is Nothing Then
‘ It works
Else
' Error
End If
End Sub


CreateScreenTemplate
ObjectModel COM [image] DynPicture [image] Methods [image] CreateScreenTemplate
Remarks

Datatype
IMDITemplates

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
p_filePath as BSTR

p_group as BSTR

p_description as BSTR

p_replaceExistingTemplate as VARIANT_BOOL


DeselectElements
ObjectModel COM [image] DynPicture [image] Methods [image] DeselectElements
Remarks

Deselects all selected elements in the corresponding picture.Hint: Only available, if the lasso selection is activated within the project -> MyWorkspace.ActiveDocument.DynProperties("RuntimeLasso")

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroListSelectionAndDeselect()
{
    //This Macro will list all selected elements on the start screen and deselect them
    //NOTE: Only works if "RuntimeLasso" is set to true on project

    IDynPicture zenonPicture = this.DynPictures().Item("Start");
    IElements zenonSelectedElements = zenonPicture.SelElements();
    //Loop through the selected elements and print their names
    for (int i = 0; i < zenonSelectedElements.Count; ++i)
    {
        IElement currentElement = zenonSelectedElements.Item(i);
        System.Diagnostics.Debug.Print(currentElement.Name);
    }

    //Deselect all elements
    zenonPicture.DeselectElements();
}
VB.NET
Copy
Public Sub MacroListSelectionAndDeselect()
    'This Macro will list all selected elements on the start screen and deselect them
    'NOTE: Only works if "RuntimeLasso" is set to true on project

    Dim zenonPicture As IDynPicture = Me.DynPictures().Item("Start")
    Dim zenonSelectedElements As IElements = zenonPicture.SelElements()
    'Loop through the selected elements and print their names
    Dim i As Integer = 0
    While i < zenonSelectedElements.Count
        Dim currentElement As IElement = zenonSelectedElements.Item(i)
        System.Diagnostics.Debug.Print(currentElement.Name)
        System.Threading.Interlocked.Increment(i)
    End While

    'Deselect all elements
    zenonPicture.DeselectElements()
End Sub


DynProperties [GET]
ObjectModel COM [image] DynPicture [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.
Example: "NetAktive"

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] DynPicture [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.
Example: "NetAktive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.


DynPropertiesEnum [GET]
ObjectModel COM [image] DynPicture [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties: DynPropertiesEnum("")


DynPropertyParam [GET]
ObjectModel COM [image] DynPicture [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Elements
ObjectModel COM [image] DynPicture [image] Methods [image] Elements
Remarks

Returns the collection of the defined dynamic elements contained in the picture.Each defined dynamic element is available as an object Element. The defined dynamic elements can be accessed in the collection by their unique names or by their indices.The name has to be given to the element explicitely by the user. For more detailed information have a look at the Element and Elements parts. For further information have a look at the Elements part.

Datatype
IElements

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Get
ObjectModel COM [image] DynPicture [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void CheckIn(IDynPicture zenonPicture)
{
    //Checks in the DynPicture object iff it is not locked and it does differ from the server version
    if (!zenonPicture.IsLocked())
    {
        if (zenonPicture.IsDifferent())
        {
            zenonPicture.CheckIn();
        }
    }
}

public void MacroDynPictureMultiuser()
{
    //Get an object of the "Start" picture in the current active document
    IDynPicture zenonPicture = this.ActiveDocument.DynPictures().Item("Start");

    if (!zenonPicture.IsCheckedOut())
    {
        if (zenonPicture.CheckOut())
        {
            //The driver was checked out by the user who executed this macro
            if (zenonPicture.Get())
            {
                //Got the latest version of the driver
                //Edit some properties of the driver
                zenonPicture.Name = "NewName";

                //Check the DynPicture in again so others can check it out
                CheckIn(zenonPicture);

            }
            else
            {
                zenonPicture.UndoCheckOut();
                //The latest version could not be received, undo the checkout (Inform Error)
            }
        }
        else
        {
            //The DynPicture can't currently be checked out (Inform Error)
        }
    }
    else
    {
        //Someone else has the object checked out! (Inform Error)
    }
}
VB.NET
Copy
Public Sub CheckIn(zenonPicture As IDynPicture)
    'Checks in the DynPicture object iff it is not locked and it does differ from the server version
    If Not zenonPicture.IsLocked() Then
        If zenonPicture.IsDifferent() Then
            zenonPicture.CheckIn()
        End If
    End If
End Sub

Public Sub MacroDynPictureMultiuser()
    'Get an object of the "Start" picture in the current active document
    Dim zenonPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item("Start")

    If Not zenonPicture.IsCheckedOut() Then
        If zenonPicture.CheckOut() Then
            'The driver was checked out by the user who executed this macro
            If zenonPicture.[Get]() Then
                'Got the latest version of the driver
                'Edit some properties of the driver
                zenonPicture.Name = "NewName"

                'Check the DynPicture in again so others can check it out

                CheckIn(zenonPicture)
            Else
                    'The latest version could not be received, undo the checkout (Inform Error)
                zenonPicture.UndoCheckOut()
            End If
                'The DynPicture can't currently be checked out (Inform Error)
        Else
        End If
            'Someone else has the object checked out! (Inform Error)
    Else
    End If
End Sub


Hardcopy
ObjectModel COM [image] DynPicture [image] Methods [image] Hardcopy
Remarks

Exports the picture into a file. Currently only the export as a bitmap file is available.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

lOutputFormat as tpHardcopyOutput

Example
C#
Copy
public void MacroExportPictures()
{
    //This Macro will export pictures of all pictures in the active document to bmp files
    for (int i = 0; i < this.ActiveDocument.DynPictures().Count; ++i)
    {
        IDynPicture zenonPicture = this.ActiveDocument.DynPictures().Item(i);
        zenonPicture.Hardcopy(string.Format(@"C:\zenon_pictures\picture_{0}.bmp", zenonPicture.Name), tpHardcopyOutput.tpBMP);
    }
}
VB.NET
Copy
Public Sub MacroExportPictures()
    'This Macro will export pictures of all pictures in the active document to bmp files
    Dim i As Integer = 0
    While i < Me.ActiveDocument.DynPictures().Count
        Dim zenonPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item(i)
        zenonPicture.Hardcopy(String.Format("C:\zenon_pictures\picture_{0}.bmp", zenonPicture.Name), tpHardcopyOutput.tpBMP)
        System.Threading.Interlocked.Increment(i)
    End While
End Sub


ImportMdiElements
ObjectModel COM [image] DynPicture [image] Methods [image] ImportMdiElements
Remarks

Imports the MDI-Default elements from a template (only with MDI-Windows). Use the Boolean DelElements) to define the replacement of existing settings.

The method returns an error code on the result of the import can be evaluated:
0 = OK
-1 = Screen not loaded
-2 = No screen type
-3 = The specified file does not exist
-4 = Import failed
-5 = Type of template and screen type do not match
-6 = Error loading screen

Datatype
short

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
FileName as BSTR

The parameter specifies whether to override a existing items with the same file name.
True = Override
False = none

DelElements as VARIANT_BOOL

Specifies the file name which the template is stored.
If an empty file name ("") specified, the default elements of the MDI type of screen to be created.
In this case behaves the method (almost) the same as the method "CreateMdiDefaultElements"

Example
C#
Copy
public void MacroImportMdiTemplate()
{
    IDynPicture zenonDynPicture = this.ActiveDocument.DynPictures().Item("Bild 2");
    if(zenonDynPicture != null)
    {
        short res = zenonDynPicture.ImportMdiElements(@"C:\ProgramData\COPA-DATA\zenon700\Templates\ ScreenTypes\Keyboard\6eeae916-0098-40ab-9dc9-a9ce1dcf4bb5.zip", true);
        if(res == 0)
            zenonDynPicture.Save();
    }
}
VB.NET
Copy
Public Sub MacroImportMdiTemplate()
    Dim zenonDynPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item("Bild 2")
    If zenonDynPicture IsNot Nothing Then
        Dim res As Short = zenonDynPicture.ImportMdiElements("C:\ProgramData\COPA-DATA\zenon700\Templates\ ScreenTypes\Keyboard\6eeae916-0098-40ab-9dc9-a9ce1dcf4bb5.zip", True)
        If res = 0 Then
            zenonDynPicture.Save()
        End If
    End If
End Sub
VBA
Copy
Private Sub ImportMdiTemplate()
Dim Picture As DynPicture
Dim Res As Integer
Set Picture = MyWorkspace.ActiveDocument.DynPictures.Item("Bild 2")
If Not Picture Is Nothing Then
Res = Picture.ImportMdiElements("C:\ProgramData\COPA-DATA\zenon700\Templates\ ScreenTypes\Keyboard\6eeae916-0098-40ab-9dc9-a9ce1dcf4bb5.zip", True)
If Res = 0 Then
Picture.Save
End If
End Sub


ImportMdiTemplateItems
ObjectModel COM [image] DynPicture [image] Methods [image] ImportMdiTemplateItems
Remarks

Datatype
ImportMdiTemplateItemsResult

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
p_filePath as BSTR

p_deleteExistingElements as VARIANT_BOOL


InsertSymbol
ObjectModel COM [image] DynPicture [image] Methods [image] InsertSymbol
Remarks

Insert a symbol from the symbol-library by its name and symbol group name.

Datatype
IElement

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

Name of the symbol within the library.

bsLibrary as BSTR

- "" (Emtpy string) if from the local project - "SymbolGroupName" if from the General symbol library - "~|GPLN|~" if from the library in the global project

bLinked as VARIANT_BOOL

If set TRUE the symbol constitutes a linked symbol. Otherwise the symbol will be embedded.

Example
C#
Copy
public void MacroInsertSymbol()
{
    //This macro demonstrates how to insert a symbol via the VSTA API
    IDynPicture zenonPictureStart = this.ActiveDocument.DynPictures().Item("Start");

    //Insert the symbol "battery_charging" from group "batteries_16_9" to the start picture linked
    zenonPictureStart.InsertSymbol("battery_charging", "batteries_16_9", true);
}
VB.NET
Copy
Public Sub MacroInsertSymbol()
    'This macro demonstrates how to insert a symbol via the VSTA API
    Dim zenonPictureStart As IDynPicture = Me.ActiveDocument.DynPictures().Item("Start")

    'Insert the symbol "battery_charging" from group "batteries_16_9" to the start picture linked
    zenonPictureStart.InsertSymbol("battery_charging", "batteries_16_9", True)
End Sub
VBA
Copy
Sub zenOn_DynPicture_InsertSymbol()
'Declarations
Dim zPic As DynPicture
'Initialize zPic with the start picture
Set zPic = MyWorkspace.ActiveDocument.DynPictures.Item("START")
'Insert linked symbol "Brake motor" from the category "F_Motors" to the start picture
zPic.InsertSymbol "Brake motor", "F_Motors", True

End Sub


IsCheckedOut
ObjectModel COM [image] DynPicture [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void CheckIn(IDynPicture zenonPicture)
{
    //Checks in the DynPicture object iff it is not locked and it does differ from the server version
    if (!zenonPicture.IsLocked())
    {
        if (zenonPicture.IsDifferent())
        {
            zenonPicture.CheckIn();
        }
    }
}

public void MacroDynPictureMultiuser()
{
    //Get an object of the "Start" picture in the current active document
    IDynPicture zenonPicture = this.ActiveDocument.DynPictures().Item("Start");

    if (!zenonPicture.IsCheckedOut())
    {
        if (zenonPicture.CheckOut())
        {
            //The driver was checked out by the user who executed this macro
            if (zenonPicture.Get())
            {
                //Got the latest version of the driver
                //Edit some properties of the driver
                zenonPicture.Name = "NewName";

                //Check the DynPicture in again so others can check it out
                CheckIn(zenonPicture);

            }
            else
            {
                zenonPicture.UndoCheckOut();
                //The latest version could not be received, undo the checkout (Inform Error)
            }
        }
        else
        {
            //The DynPicture can't currently be checked out (Inform Error)
        }
    }
    else
    {
        //Someone else has the object checked out! (Inform Error)
    }
}
VB.NET
Copy
Public Sub CheckIn(zenonPicture As IDynPicture)
    'Checks in the DynPicture object iff it is not locked and it does differ from the server version
    If Not zenonPicture.IsLocked() Then
        If zenonPicture.IsDifferent() Then
            zenonPicture.CheckIn()
        End If
    End If
End Sub

Public Sub MacroDynPictureMultiuser()
    'Get an object of the "Start" picture in the current active document
    Dim zenonPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item("Start")

    If Not zenonPicture.IsCheckedOut() Then
        If zenonPicture.CheckOut() Then
            'The driver was checked out by the user who executed this macro
            If zenonPicture.[Get]() Then
                'Got the latest version of the driver
                'Edit some properties of the driver
                zenonPicture.Name = "NewName"

                'Check the DynPicture in again so others can check it out

                CheckIn(zenonPicture)
            Else
                    'The latest version could not be received, undo the checkout (Inform Error)
                zenonPicture.UndoCheckOut()
            End If
                'The DynPicture can't currently be checked out (Inform Error)
        Else
        End If
            'Someone else has the object checked out! (Inform Error)
    Else
    End If
End Sub


IsDifferent
ObjectModel COM [image] DynPicture [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void CheckIn(IDynPicture zenonPicture)
{
    //Checks in the DynPicture object iff it is not locked and it does differ from the server version
    if (!zenonPicture.IsLocked())
    {
        if (zenonPicture.IsDifferent())
        {
            zenonPicture.CheckIn();
        }
    }
}

public void MacroDynPictureMultiuser()
{
    //Get an object of the "Start" picture in the current active document
    IDynPicture zenonPicture = this.ActiveDocument.DynPictures().Item("Start");

    if (!zenonPicture.IsCheckedOut())
    {
        if (zenonPicture.CheckOut())
        {
            //The driver was checked out by the user who executed this macro
            if (zenonPicture.Get())
            {
                //Got the latest version of the driver
                //Edit some properties of the driver
                zenonPicture.Name = "NewName";

                //Check the DynPicture in again so others can check it out
                CheckIn(zenonPicture);

            }
            else
            {
                zenonPicture.UndoCheckOut();
                //The latest version could not be received, undo the checkout (Inform Error)
            }
        }
        else
        {
            //The DynPicture can't currently be checked out (Inform Error)
        }
    }
    else
    {
        //Someone else has the object checked out! (Inform Error)
    }
}
VB.NET
Copy
Public Sub CheckIn(zenonPicture As IDynPicture)
    'Checks in the DynPicture object iff it is not locked and it does differ from the server version
    If Not zenonPicture.IsLocked() Then
        If zenonPicture.IsDifferent() Then
            zenonPicture.CheckIn()
        End If
    End If
End Sub

Public Sub MacroDynPictureMultiuser()
    'Get an object of the "Start" picture in the current active document
    Dim zenonPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item("Start")

    If Not zenonPicture.IsCheckedOut() Then
        If zenonPicture.CheckOut() Then
            'The driver was checked out by the user who executed this macro
            If zenonPicture.[Get]() Then
                'Got the latest version of the driver
                'Edit some properties of the driver
                zenonPicture.Name = "NewName"

                'Check the DynPicture in again so others can check it out

                CheckIn(zenonPicture)
            Else
                    'The latest version could not be received, undo the checkout (Inform Error)
                zenonPicture.UndoCheckOut()
            End If
                'The DynPicture can't currently be checked out (Inform Error)
        Else
        End If
            'Someone else has the object checked out! (Inform Error)
    Else
    End If
End Sub


IsLocked
ObjectModel COM [image] DynPicture [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects. NOTE: In a multiu-user project it is recommended to check for IsLocked == false before performing any modification changes at all.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void CheckIn(IDynPicture zenonPicture)
{
    //Checks in the DynPicture object iff it is not locked and it does differ from the server version
    if (!zenonPicture.IsLocked())
    {
        if (zenonPicture.IsDifferent())
        {
            zenonPicture.CheckIn();
        }
    }
}

public void MacroDynPictureMultiuser()
{
    //Get an object of the "Start" picture in the current active document
    IDynPicture zenonPicture = this.ActiveDocument.DynPictures().Item("Start");

    if (!zenonPicture.IsCheckedOut())
    {
        if (zenonPicture.CheckOut())
        {
            //The driver was checked out by the user who executed this macro
            if (zenonPicture.Get())
            {
                //Got the latest version of the driver
                //Edit some properties of the driver
                zenonPicture.Name = "NewName";

                //Check the DynPicture in again so others can check it out
                CheckIn(zenonPicture);

            }
            else
            {
                zenonPicture.UndoCheckOut();
                //The latest version could not be received, undo the checkout (Inform Error)
            }
        }
        else
        {
            //The DynPicture can't currently be checked out (Inform Error)
        }
    }
    else
    {
        //Someone else has the object checked out! (Inform Error)
    }
}
VB.NET
Copy
Public Sub CheckIn(zenonPicture As IDynPicture)
    'Checks in the DynPicture object iff it is not locked and it does differ from the server version
    If Not zenonPicture.IsLocked() Then
        If zenonPicture.IsDifferent() Then
            zenonPicture.CheckIn()
        End If
    End If
End Sub

Public Sub MacroDynPictureMultiuser()
    'Get an object of the "Start" picture in the current active document
    Dim zenonPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item("Start")

    If Not zenonPicture.IsCheckedOut() Then
        If zenonPicture.CheckOut() Then
            'The driver was checked out by the user who executed this macro
            If zenonPicture.[Get]() Then
                'Got the latest version of the driver
                'Edit some properties of the driver
                zenonPicture.Name = "NewName"

                'Check the DynPicture in again so others can check it out

                CheckIn(zenonPicture)
            Else
                    'The latest version could not be received, undo the checkout (Inform Error)
                zenonPicture.UndoCheckOut()
            End If
                'The DynPicture can't currently be checked out (Inform Error)
        Else
        End If
            'Someone else has the object checked out! (Inform Error)
    Else
    End If
End Sub


MdiElements
ObjectModel COM [image] DynPicture [image] Methods [image] MdiElements
Remarks

Returns the list ("MdiElements" object) of the available MDI-controls.

Datatype
IMdiElements

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Move
ObjectModel COM [image] DynPicture [image] Methods [image] Move
Remarks

Updates the position of a DynPicture object. In order to ensure the new position is visualized make sure to call the UpdateAll method of the DynPicture object.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Left as long

Top as long

Width as long

Height as long

Example
C#
Copy
public void MacroMovePicture()
{
    //This macro moves the picture start to the left by 10 pixels
    IDynPicture zenonPicture = this.DynPictures().Item("Start");
    zenonPicture.Move(zenonPicture.Left + 10, zenonPicture.Top, zenonPicture.Width, zenonPicture.Height);

    //Call UpdateAll to ensure the pictures new position and all relative elements are updated
    zenonPicture.UpdateAll();
}
VB.NET
Copy
PublicSub MacroMovePicture()
    'This macro moves the picture start to the left by 10 pixels
    Dim zenonPicture As IDynPicture = Me.DynPictures().Item("Start")
    zenonPicture.Move(zenonPicture.Left + 10, zenonPicture.Top, zenonPicture.Width, zenonPicture.Height)

    'Call UpdateAll to ensure the pictures new position and all relative elements are updated
    zenonPicture.UpdateAll()
EndSub
VBA
Copy
Sub
'*** The current picture is moved by 10 pixel/side (top,bottom,left,right)
Public Sub LeftClickUp_Picture_Move(obElem As Element)
Dim obPicture As DynPicture
'*** Get picture-object
Set obPicture = obElem.Parent.Parent
If (obPicture Is Nothing) Then

MsgBox "Error: Picture-object is invalid..."

Exit Sub
End If
'*** De/-activate the current picture
obPicture.Move obPicture.Left + 10, obPicture.Top + 10, obPicture.Width, obPicture.Height
obElem.LeftClickUp
End Sub


Save
ObjectModel COM [image] DynPicture [image] Methods [image] Save
Remarks

Method to save the picture (changes in this collection)

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


SelElements
ObjectModel COM [image] DynPicture [image] Methods [image] SelElements
Remarks

Returns a list ("Elements" object) of selected "Element" objects within the picture.Hint: Only available, if the lasso selection is activated within the project-> MyWorkspace.ActiveDocument.DynProperties("RuntimeLasso")

Datatype
IElements

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroListSelectionAndDeselect()
{
    //This Macro will list all selected elements on the start screen and deselect them
    //NOTE: Only works if "RuntimeLasso" is set to true on project

    IDynPicture zenonPicture = this.DynPictures().Item("Start");
    IElements zenonSelectedElements = zenonPicture.SelElements();
    //Loop through the selected elements and print their names
    for (int i = 0; i < zenonSelectedElements.Count; ++i)
    {
        IElement currentElement = zenonSelectedElements.Item(i);
        System.Diagnostics.Debug.Print(currentElement.Name);
    }

    //Deselect all elements
    zenonPicture.DeselectElements();
}
VB.NET
Copy
Public Sub MacroListSelectionAndDeselect()
    'This Macro will list all selected elements on the start screen and deselect them
    'NOTE: Only works if "RuntimeLasso" is set to true on project

    Dim zenonPicture As IDynPicture = Me.DynPictures().Item("Start")
    Dim zenonSelectedElements As IElements = zenonPicture.SelElements()
    'Loop through the selected elements and print their names
    Dim i As Integer = 0
    While i < zenonSelectedElements.Count
        Dim currentElement As IElement = zenonSelectedElements.Item(i)
        System.Diagnostics.Debug.Print(currentElement.Name)
        System.Threading.Interlocked.Increment(i)
    End While

    'Deselect all elements
    zenonPicture.DeselectElements()
End Sub
VBA
Copy
Sub zenOn_DynPicture_ListSelection()
'Declarations
Dim zPic As DynPicture
Dim i As Integer
'Initialize zPic with the start picture
Set zPic = thisProject.DynPictures.Item("START")
'For every selected element in the start picture...
For i = 0 To zPic.SelElements.Count - 1

'...output the name

Debug.Print i + 1 & ". item: " & zPic.SelElements.Item(i).Name
Next i
'Deselect all selected elements
zPic.DeselectElements

End Sub


SetZoomAndPos
ObjectModel COM [image] DynPicture [image] Methods [image] SetZoomAndPos
Remarks

Updates the Zoom and position of a dynamic picture, like the internal function would.PosMode - Determines how PosX and PosY are interpreted-1 = PosX, PosY are ignored0 = Set the center point and use original coordinates1 = Set the center point and use new coordinates2 = From the top left, use original coordinates3 = From the top left, use zoomed coordinates 4 = Use the zoomed coordinates of the cursor from the top left, the window position is changed so that the cursor stays in the same position.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
ZoomX as FLOAT

ZoomX - New zoom factor in x direction (-1 if not used)

ZoomY as FLOAT

ZoomY - New zoom factor in y direction (-1 if not used)

ZoomLevel as long

ZoomLevel - Cannot be used with ZoomX and ZoomY (0 if not used)

CursorX as long

CursorY as long

PosX as long

PosX - New x position according to PosMode

PosY as long

PosY - New y position according to PosMode

iPosMode as long

Determines how PosX and PosY are interpreted


UndoCheckOut
ObjectModel COM [image] DynPicture [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void CheckIn(IDynPicture zenonPicture)
{
    //Checks in the DynPicture object iff it is not locked and it does differ from the server version
    if (!zenonPicture.IsLocked())
    {
        if (zenonPicture.IsDifferent())
        {
            zenonPicture.CheckIn();
        }
    }
}

public void MacroDynPictureMultiuser()
{
    //Get an object of the "Start" picture in the current active document
    IDynPicture zenonPicture = this.ActiveDocument.DynPictures().Item("Start");

    if (!zenonPicture.IsCheckedOut())
    {
        if (zenonPicture.CheckOut())
        {
            //The driver was checked out by the user who executed this macro
            if (zenonPicture.Get())
            {
                //Got the latest version of the driver
                //Edit some properties of the driver
                zenonPicture.Name = "NewName";

                //Check the DynPicture in again so others can check it out
                CheckIn(zenonPicture);

            }
            else
            {
                zenonPicture.UndoCheckOut();
                //The latest version could not be received, undo the checkout (Inform Error)
            }
        }
        else
        {
            //The DynPicture can't currently be checked out (Inform Error)
        }
    }
    else
    {
        //Someone else has the object checked out! (Inform Error)
    }
}
VB.NET
Copy
Public Sub CheckIn(zenonPicture As IDynPicture)
    'Checks in the DynPicture object iff it is not locked and it does differ from the server version
    If Not zenonPicture.IsLocked() Then
        If zenonPicture.IsDifferent() Then
            zenonPicture.CheckIn()
        End If
    End If
End Sub

Public Sub MacroDynPictureMultiuser()
    'Get an object of the "Start" picture in the current active document
    Dim zenonPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item("Start")

    If Not zenonPicture.IsCheckedOut() Then
        If zenonPicture.CheckOut() Then
            'The driver was checked out by the user who executed this macro
            If zenonPicture.[Get]() Then
                'Got the latest version of the driver
                'Edit some properties of the driver
                zenonPicture.Name = "NewName"

                'Check the DynPicture in again so others can check it out

                CheckIn(zenonPicture)
            Else
                    'The latest version could not be received, undo the checkout (Inform Error)
                zenonPicture.UndoCheckOut()
            End If
                'The DynPicture can't currently be checked out (Inform Error)
        Else
        End If
            'Someone else has the object checked out! (Inform Error)
    Else
    End If
End Sub


Update
ObjectModel COM [image] DynPicture [image] Methods [image] Update
Remarks

This method redraws a certain area of the picture. The user has to know which part of the picture should be redrawn. The parameters include the corners of the rectangular area that should be redrawn.Hint: Use UpdateAll to redraw the entire picture.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Left as long

Top as long

Bottom as long

Right as long

Example
C#
Copy
public void MacroUpdate()
{
    //This macro will update (redraw) the rectangular area as specified
    IDynPicture zenonPicture = this.DynPictures().Item("Start");
    zenonPicture.Update(0, 0, 0, 500);
}
VB.NET
Copy
Public Sub MacroUpdate()
    'This macro will update (redraw) the rectangular area as specified
    Dim zenonPicture As IDynPicture = Me.DynPictures().Item("Start")
    zenonPicture.Update(0, 0, 0, 500)
End Sub


UpdateAll
ObjectModel COM [image] DynPicture [image] Methods [image] UpdateAll
Remarks

This method redraws the entire picture. All elements in the picture are redrawn.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroUpdateAll()
{
    //This macro will update (redraw) all elements of the start picture
    //An element has to be updated for example if its color changed due to some other
    //event
    IDynPicture zenonPicture = this.DynPictures().Item("Start");
    zenonPicture.UpdateAll();
}
VB.NET
Copy
Public Sub MacroUpdateAll()
    'This macro will update (redraw) all elements of the start picture
    'An element has to be updated for example if its color changed due to some other
    'event
    Dim zenonPicture As IDynPicture = Me.DynPictures().Item("Start")
    zenonPicture.UpdateAll()
End Sub


Events
ObjectModel COM [image] DynPicture [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Close | void | Event is fired by closing the picture | Unused | Available | Available | Available
Open | void | Event is fired by opening the picture | Unused | Available | Available | Available
Timer | void | This event is executed in a cyclic interval – depending on the flash frequency set in the project. | Unused | Available | Available | Available


Close
ObjectModel COM [image] DynPicture [image] Events [image] Close
Remarks

This event is executed on closing the current picture.Hint: For the use of events, the "DynPicture" object must be defined with WithEvents.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
private IDynPicture _zenonPicture;

void ThisProject_Active()
{
    //Initialize the instance variable with the screen of name "Start"
    _zenonPicture = this.DynPictures().Item("Start");
    //Attach the event handler
    _zenonPicture.Close += new CloseEventHandler(_zenonPicture_Close);
}

void _zenonPicture_Close()
{
    //Everytime the dynPicture Start is closed a message is written to the CEL
    this.Cel().WriteCelString(_zenonPicture.Name + " was closed.");
}

void ThisProject_Inactive()
{
    //Detach the event handler
    _zenonPicture.Close -= new CloseEventHandler(_zenonPicture_Close);
    FreeObjects();
}
VB.NET
Copy
Private _zenonPicture As IDynPicture

Private Sub ThisProject_Active()
    'Initialize the instance variable with the screen of name "Start"
    _zenonPicture = Me.DynPictures().Item("Start")
    'Attach the event handler

AddHandler _zenonPicture.Close, AddressOf _zenonPicture_Close
End Sub

Private Sub _zenonPicture_Close()
    'Everytime the dynPicture Start is closed a message is written to the CEL
    Me.Cel().WriteCelString(_zenonPicture.Name + " was closed.")
End Sub

Private Sub ThisProject_Inactive()
    'Detach the event handler
    RemoveHandler _zenonPicture.Close, AddressOf _zenonPicture_Close
    FreeObjects()
End Sub
VBA
Copy
'Declaration of zPIC, in order to use it with events
Dim WithEvents zPIC As dynpicture
'Event is fired, when project is opened
Private Sub Project_Active()
'Initialize zPIC with the start picture
Set zPIC = thisProject.DynPictures.Item("START")
End Sub
'Event is fired, when picture is closed
Private Sub zPIC_Close()
'Output the time when the picture was closed
Debug.Print Now & " Picture CLOSED!"
End Sub
'Event is fired, when project is closed
Private Sub Project_Inactive()
'Deinitialize zPIC on project close
Set zPIC = Nothing
End Sub


Open
ObjectModel COM [image] DynPicture [image] Events [image] Open
Remarks

This event is executed, when the current picture is opened.Hint: For the use of events, the "DynPicture" object must be defined with WithEvents.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
private IDynPicture _zenonPicture;

void ThisProject_Active()
{
    //Initialize the instance variable with the screen of name "Start"
    _zenonPicture = this.DynPictures().Item("Start");
    //Attach the event handler
    _zenonPicture.Open += new OpenEventHandler(_zenonPicture_Open);
}

void _zenonPicture_Open()
{
    //Everytime the dynPicture Start is opened a message is written to the CEL
    this.Cel().WriteCelString(_zenonPicture.Name + " was opened.");
}

void ThisProject_Inactive()
{
    //Detach the event handler
    _zenonPicture.Open -= new OpenEventHandler(_zenonPicture_Open);
    FreeObjects();
}
VB.NET
Copy
Private _zenonPicture As IDynPicture

Private Sub ThisProject_Active()
    'Initialize the instance variable with the screen of name "Start"
    _zenonPicture = Me.DynPictures().Item("Start")
    'Attach the event handler
    AddHandler _zenonPicture.Open, AddressOf _zenonPicture_Open
End Sub

Private Sub _zenonPicture_Open()
    'Everytime the dynPicture Start is opened a message is written to the CEL
    Me.Cel().WriteCelString(_zenonPicture.Name + " was opened.")
End Sub

Private Sub ThisProject_Inactive()
    'Detach the event handler
    RemoveHandler _zenonPicture.Open, AddressOf _zenonPicture_Open
    FreeObjects()
End Sub
VBA
Copy
'Declaration of zPIC, in order to use it with events
Dim WithEvents zPIC As dynpicture
'Event is fired, when project is opened
Private Sub Project_Active()
'Initialize zPIC with the start picture
Set zPIC = thisProject.DynPictures.Item("START")
End Sub
'Event is fired, when picture is opened
Private Sub zPIC_Open()
'Output the time when the picture was opened
Debug.Print Now & " Picture OPENED!"
End Sub
'Event is fired, when project is closed
Private Sub Project_Inactive()
'Deinitialize zPIC on project close
Set zPIC = Nothing
End Sub


Timer
ObjectModel COM [image] DynPicture [image] Events [image] Timer
Remarks

This event is executed in a cyclic interval – depending on the flash frequency set in the project. In this event extended visualization effects can be realized, e.g. mini animations.Hint: For the use of events, the "DynPicture" object must be defined with WithEvents.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
private IDynPicture _zenonPicture;
private IElement _zenonElement;
void ThisProject_Active()
{
    //Initialize the instance variable with the screen of name "Start"
    _zenonPicture = this.DynPictures().Item("Start");
    //Attach the event handler
    _zenonPicture.Timer += new TimerEventHandler(_zenonPicture_Timer);
}

void _zenonPicture_Timer()
{
    //This event is executed cyclicly, depending on the projects flash frequency
    //Here it is used to animate a sample object in a very simple way
    //NOTE: Refreshing an element too often might cause screen flickering, this
    //      is just for demonstration purposes.
    _zenonElement = _zenonPicture.Elements().Item("test_object");
    _zenonElement.BackColor = _zenonElement.BackColor - 1;
    _zenonElement.Update();
}

void ThisProject_Inactive()
{
    //Detach the event handler
    _zenonPicture.Timer -= new TimerEventHandler(_zenonPicture_Timer);
    FreeObjects();
}
VB.NET
Copy
Private _zenonPicture As IDynPicture
Private _zenonElement As IElement
Private Sub ThisProject_Active()
    'Initialize the instance variable with the screen of name "Start"
    _zenonPicture = Me.DynPictures().Item("Start")
    'Attach the event handler
    AddHandler _zenonPicture.Timer, AddressOf _zenonPicture_Timer
End Sub

Private Sub _zenonPicture_Timer()
    'This event is executed cyclicly, depending on the projects flash frequency
    'Here it is used to animate a sample object in a very simple way
    'NOTE: Refreshing an element too often might cause screen flickering, this
    '      is just for demonstration purposes.
    _zenonElement = _zenonPicture.Elements().Item("test_object")
    _zenonElement.BackColor = _zenonElement.BackColor - 1
    _zenonElement.Update()
End Sub

Private Sub ThisProject_Inactive()
    'Detach the event handler
    RemoveHandler _zenonPicture.Timer, AddressOf _zenonPicture_Timer
    FreeObjects()
End Sub


DynPictureInstances
ObjectModel COM [image] DynPictureInstances
Remarks

Used to check if a screen is displayed in the runtime. With the Count() property the amount of screens is determined. The Item() property is used to determine the Dynpicture object for each instance.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroGetInstances()
{
    IDynPicture zenonPicture = this.DynPictures().Item("Start");

    //Loop through any instance of the picture "start" and print name + id
    for (int i = 0; i < zenonPicture.Instances.Count; ++i)
    {
        IDynPicture currentPicture = zenonPicture.Instances.Item(i);
        if (currentPicture != null)
            System.Diagnostics.Debug.Print(currentPicture.Name + " " + currentPicture.InstanceId);
    }
}
VB.NET
Copy
Public Sub MacroGetInstances()
    Dim zenonPicture As IDynPicture = Me.DynPictures().Item("Start")

    'Loop through any instance of the picture "start" and print name + id
    Dim i As Integer = 0
    While i < zenonPicture.Instances.Count
        Dim currentPicture As IDynPicture = zenonPicture.Instances.Item(i)
        If not (currentPicture  is nothing)  Then
            System.Diagnostics.Debug.Print(currentPicture.Name + " " + currentPicture.InstanceId)
        End If
        System.Threading.Interlocked.Increment(i)
    End While
End Sub
VBA
Copy
Public Sub LeftClickUp_Default(obElem As Element)
Dim FacePlate As DynPicture
Dim DynPictureContainer As Element
Dim strTrace As String
strTrace = "Das Element befindet sich auf Bild:" & obElem.Parent.Parent.Name & " mit InstanzID:" & obElem.Parent.Parent.InstanceId
If Not obElem.Parent.Parent.DynPictureContainer Is Nothing Then
    strTrace = strTrace & " in einen BildContainer:" & obElem.Parent.Parent.DynPictureContainer.Name
    strTrace = strTrace & ", welches sich auf Bild:" & obElem.Parent.Parent.DynPictureContainer.Parent.Parent.Name & " mit InstanzId:" & obElem.Parent.Parent.DynPictureContainer.Parent.Parent.InstanceId & "befindet."
End If
MsgBox strTrace
Dim myPiccheck As DynPicture
Set myPiccheck = thisProject.DynPictures.ItemOnMonitor(obElem.Parent.Parent.Name, obElem.Parent.Parent.MonitorId)
Debug.Print myPiccheck.Name
End Sub
Public Sub GetScreens()
Dim myinstances As DynPictureInstances
Dim myDynPicture As DynPicture
Stop
Set myinstances = thisProject.DynPictures.Item("Bild 2").Instances
If (myinstances.Count > 0) Then
    For i = 0 To myinstances.Count - 1
       Set myDynPicture = myinstances.Item(i)
       If (Not myDynPicture Is Nothing) Then
        Debug.Print "instance:" & myDynPicture.Name & " " & myDynPicture.InstanceId
       End If
    Next
End If
End Sub


Properties
ObjectModel COM [image] DynPictureInstances [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the amount of instances of the given DynPicture object. (RT-Only) | Unused | Readonly | Available | Available


Count
ObjectModel COM [image] DynPictureInstances [image] Properties [image] Count
Remarks

Returns the amount of instances of the given DynPicture object. (RT-Only).

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] DynPictureInstances [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Item | idynpicture | Returns instances at the given index. (RT-Only) | Unused | Readonly | Available | Available


Item
ObjectModel COM [image] DynPictureInstances [image] Methods [image] Item
Remarks

Returns instances at the given index. (RT-Only).

Datatype
IDynPicture

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lIndex as long

Index of the instance to be returned.

Example
C#
Copy
public void MacroGetInstances()
{
    IDynPicture zenonPicture = this.DynPictures().Item("Start");

    //Loop through any instance of the picture "start" and print name + id
    for (int i = 0; i < zenonPicture.Instances.Count; ++i)
    {
        IDynPicture currentPicture = zenonPicture.Instances.Item(i);
        if (currentPicture != null)
            System.Diagnostics.Debug.Print(currentPicture.Name + " " + currentPicture.InstanceId);
    }
}
VB.NET
Copy
Public Sub MacroGetInstances()
    Dim zenonPicture As IDynPicture = Me.DynPictures().Item("Start")

    'Loop through any instance of the picture "start" and print name + id
    Dim i As Integer = 0
    While i < zenonPicture.Instances.Count
        Dim currentPicture As IDynPicture = zenonPicture.Instances.Item(i)
        If not (currentPicture  is nothing)  Then
            System.Diagnostics.Debug.Print(currentPicture.Name + " " + currentPicture.InstanceId)
        End If
        System.Threading.Interlocked.Increment(i)
    End While
End Sub
VBA
Copy
Public Sub LeftClickUp_Default(obElem As Element)
Dim FacePlate As DynPicture
Dim DynPictureContainer As Element
Dim strTrace As String
strTrace = "Das Element befindet sich auf Bild:" & obElem.Parent.Parent.Name & " mit InstanzID:" & obElem.Parent.Parent.InstanceId
If Not obElem.Parent.Parent.DynPictureContainer Is Nothing Then
    strTrace = strTrace & " in einen BildContainer:" & obElem.Parent.Parent.DynPictureContainer.Name
    strTrace = strTrace & ", welches sich auf Bild:" & obElem.Parent.Parent.DynPictureContainer.Parent.Parent.Name & " mit InstanzId:" & obElem.Parent.Parent.DynPictureContainer.Parent.Parent.InstanceId & "befindet."
End If
MsgBox strTrace
Dim myPiccheck As DynPicture
Set myPiccheck = thisProject.DynPictures.ItemOnMonitor(obElem.Parent.Parent.Name, obElem.Parent.Parent.MonitorId)
Debug.Print myPiccheck.Name
End Sub
Public Sub GetScreens()
Dim myinstances As DynPictureInstances
Dim myDynPicture As DynPicture
Stop
Set myinstances = thisProject.DynPictures.Item("Bild 2").Instances
If (myinstances.Count > 0) Then
    For i = 0 To myinstances.Count - 1
       Set myDynPicture = myinstances.Item(i)
       If (Not myDynPicture Is Nothing) Then
        Debug.Print "instance:" & myDynPicture.Name & " " & myDynPicture.InstanceId
       End If
    Next
End If
End Sub


DynPictures
ObjectModel COM [image] DynPictures
Remarks

This collection contains the defined Screens. The single Screens can contain different dynamic elements. Each Screen is linked to a Frame, that contains general information on the outer appearance.Screens always come from the current project – the global project is ignored, as Screens are not supported in global projects.The single Screens can be found in the collection by their unique name or by the index. Each Screen is identified by an unique name.

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroCreateScreen()
{
    IDynPicture zenonNewPicture = this.ActiveDocument.DynPictures().Item("NEW_SCREEN");
    //Create the screen if it does not exist
    if (zenonNewPicture == null)
    {
        zenonNewPicture = this.ActiveDocument.DynPictures().Create("NEW_SCREEN", "MAIN", tpDynPicturesTypes.tpStandard);
        //Set the BackColor to red (255R,0G,0B)
        zenonNewPicture.BackColor = 0x0000FF;
    }
}
VB.NET
Copy
Public Sub MacroCreateScreen()
    Dim zenonNewPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item("NEW_SCREEN")
    'Create the screen if it does not exist
    If zenonNewPicture = Nothing Then
        zenonNewPicture = Me.ActiveDocument.DynPictures().Create("NEW_SCREEN", "MAIN", tpDynPicturesTypes.tpStandard)
        'Set the BackColor to red (255R,0G,0B)
        zenonNewPicture.BackColor = &Hff
    End If
End Sub
VBA
Copy
Sub CreateScreen()
Dim zPIC As DynPicture
Const ScreenName As String = "Alarm-Screen"
Const TemplateName As String = "MAIN"
'check if Screen already exists...
Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Item(ScreenName)
If zPIC Is Nothing Then

'create new Screen if not existing...

Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Create(ScreenName,
TemplateName, tpAML)

'set the backcolor and create Default MDI Elements

With zPIC

.BackColor = vbRed

.CreateMdiDefaultElements

End With
End If
End Sub
Sub ScreenList()
Dim i, n As Integer
Dim zProject As Project
Dim zPicture As DynPicture
'use this in VBA at zenOn Runtime...
'Set zProject = thisproject
'or use this in the zenOn Editor...
Set zProject = MyWorkspace.ActiveDocument
'run trough all screens of the project...
For i = 0 To zProject.DynPictures.Count - 1

Set zPicture = zProject.DynPictures.Item(i)

Debug.Print zPicture.Name

'get count of elements within the actual screen

Debug.Print zPicture.Elements.Count & " Elements in this Screen..."
Next i
End Sub


Properties
ObjectModel COM [image] DynPictures [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns number of the elements | Readonly | Readonly | Available | Available
Parent | iproject | The parent object of the current object | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] DynPictures [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] DynPictures [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] DynPictures [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AddMarker | bstr | Adds a marker into a screen | Unused | Available | Available | Available
Create | idynpicture | Creates and returns a new Object. | Available | Unused | Available | Available
Delete | variant_bool | Deletes the objects from collection | Available | Unused | Available | Available
DelMarker | variant_bool | Deletes a marker from a screen | Unused | Available | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
GetPointerInfo | variant | Gets the information for the specified pointer associated with the current message. | Unused | Available | Unused | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
Item | idynpicture | Returns a object at a position or by a specified key | Available | Available | Available | Available
ItemOnMonitor | idynpicture | Returns a screen with given name on the given monitor.(RT-Only) | Unused | Available | Available | Available
SetupTouchInertia | variant_bool | Setup inertia settings for multitouch manipulation | Unused | Available | Available | Available
ShowCreateDialog | ishowcreatescreendialogresult | Opens the zenon standard dialog "New screen". | Available | Unused | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index. | Available | Unused | Available | Available


AddMarker
ObjectModel COM [image] DynPictures [image] Methods [image] AddMarker
Remarks

Adds a marker into the screen. The GUID of the marker, which is provided by the AddMarker(), is the explicit id as well as the element name, with the following prefix: $MARKER_.It is also used as key to delete the marker using: DelMarker(). Those markers that are inserted using the API are stored imaged-based in the project. This is non-retentive beyond Runtime restart. The markers are handled internally as a normal picture elements, therefore mouse events are called. Siehe auch: Konfiguration der Bildmarker

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsScreenName as BSTR

nElementID as long

nPosition as short

nLineColorIndex as short

nFillColorIndex as short

Example
C#
Copy
/* Use only for Runtime, that means use the VSTA/VBA editor for the activated project to create your macro.
         * This example will place a marker on a line element.
         */
 public void Macro_AddMarker()
        {
 //Get the screen with your elements, in this case: line, button and a numeric value
            zenOn.IDynPicture screen = this.DynPictures().Item("Screen 0");
 //Get the  line element from the screen
            zenOn.IElement lineElement = screen.Elements().Item("Line_3");
 //To add the marker we have to assign following properties:
 //- the screen with the according element
 //- the element ID
 //- the position of the marker on the line, in this case 20% of the total lenght.
 //- the color index of the border line
 //- the color index of the filling
 //the color index can be defined in the editor under: Project properties->ALC->ALC configuration.
 //this will open a dialog, choose the Screen marker TAB and define your colors. Use the corresponding
 //index 0... for your properties.
 this.DynPictures().AddMarker("Screen 0", lineElement.ID, 20, 1, 2);
        }
VB.NET
Copy
Use only for Runtime, that means use the VSTA/VBA editor for the activated project to create your macro.
This example will place a marker on a line element.
Public Sub Macro_AddMarker()
    //Get the screen with your elements, in this case: line, button and a numeric value
    Dim screen As zenOn.IDynPicture = Me.DynPictures().Item("Screen 0")
    //Get the  line element from the screen
    Dim lineElement As zenOn.IElement = screen.Elements().Item("Line_3")
    //To add the marker we have to assign following properties:
    //- the screen with the according element
    //- the element ID
    //- the position of the marker on the line, in this case 20% of the total lenght.
    //- the color index of the border line
    //- the color index of the filling
    //the color index can be defined in the editor under: Project properties->ALC->ALC configuration.
    //this will open a dialog, choose the Screen marker TAB and define your colors. Use the corresponding
    //index 0... for your properties.
    Me.DynPictures().AddMarker("Screen 0", lineElement.ID, 20, 1, 2)
End Sub


Create
ObjectModel COM [image] DynPictures [image] Methods [image] Create
Remarks

Creates and returns a new Object.

Datatype
IDynPicture

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

bsTemplate as BSTR

tpType as tpDynPicturesTypes

Example
C#
Copy
public void MacroCreateScreen()
{
    IDynPicture zenonNewPicture = this.ActiveDocument.DynPictures().Item("NEW_SCREEN");
    //Create the screen if it does not exist
    if (zenonNewPicture == null)
    {
        zenonNewPicture = this.ActiveDocument.DynPictures().Create("NEW_SCREEN", "MAIN", tpDynPicturesTypes.tpStandard);
        //Set the BackColor to red (255R,0G,0B)
        zenonNewPicture.BackColor = 0x0000FF;
    }
}
VB.NET
Copy
Public Sub MacroCreateScreen()
    Dim zenonNewPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item("NEW_SCREEN")
    'Create the screen if it does not exist
    If zenonNewPicture = Nothing Then
        zenonNewPicture = Me.ActiveDocument.DynPictures().Create("NEW_SCREEN", "MAIN", tpDynPicturesTypes.tpStandard)
        'Set the BackColor to red (255R,0G,0B)
        zenonNewPicture.BackColor = &Hff
    End If
End Sub


Delete
ObjectModel COM [image] DynPictures [image] Methods [image] Delete
Remarks

Deletes the corresponding "DynPicture" object from the collection by its unique name.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

Example
C#
Copy
using System.Text.RegularExpressions;

private const string DUMMY_REGEX = @"[\s\S]*dummy[\s\S]*";

public void MacroDeletePictureRegEx()
{
    //Uses a regular expression to delete any picture that
    //has the name "dummy" in its name
    for (int i = 0; i < this.ActiveDocument.DynPictures().Count; ++i)
    {
        IDynPicture currentPicture = this.ActiveDocument.DynPictures().Item(i);
        if (Regex.IsMatch(currentPicture.Name, DUMMY_REGEX))
            this.ActiveDocument.DynPictures().Delete(currentPicture.Name);
    }
}
VB.NET
Copy
Imports System.Text.RegularExpressions

Private Const DUMMY_REGEX As String = "[\s\S]*dummy[\s\S]*"

Public Sub MacroDeletePictureRegEx()
    'Uses a regular expression to delete any picture that
    'has the name "dummy" in its name
    For i As Integer = 0 To Me.ActiveDocument.DynPictures().Count - 1
        Dim currentPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item(i)
        If Regex.IsMatch(currentPicture.Name, DUMMY_REGEX) Then
            Me.ActiveDocument.DynPictures().Delete(currentPicture.Name)
        End If
    Next
End Sub


DelMarker
ObjectModel COM [image] DynPictures [image] Methods [image] DelMarker
Remarks

Deletes a marker from a screen. The ID is provided by the AddMarker().

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsID as BSTR

Example
C#
Copy
/* Use only for Runtime, that means use the VSTA/VBA editor for the activated project to create your macro.
                 * This example will first place a marker on a line element and then delete it.
                 * using the specific ID of the marker.
                 */
 public void Macro_DelMarker()
        {
 //Get the screen with your elements, in this case: line, button and a numeric value
            zenOn.IDynPicture screen = this.DynPictures().Item("Screen 0");
 //Get the  line element from the screen
            zenOn.IElement lineElement = screen.Elements().Item("Line_3");
 //The return value from the AddMarker() is the specific ID of this marker.
 string markerId = this.DynPictures().AddMarker("Screen 0", lineElement.ID, 20, 1, 2);
 //To delelete this marker we have to assign the specific ID
 bool isDeleted = this.DynPictures().DelMarker(markerId);
 //Use the return value to check if the marker was deleted
 if (isDeleted == true) MessageBox.Show("Marker: " + markerId + " deleted!");
        }
VB.NET
Copy
// Use only for Runtime, that means use the VSTA/VBA editor for the activated project to create your macro.
//This example will first place a marker on a line element and then delete it.
//using the specific ID of the marker.
Public Sub Macro_DelMarker()
    //Get the screen with your elements, in this case: line, button and a numeric value
    Dim screen As zenOn.IDynPicture = Me.DynPictures().Item("Screen 0")
    //Get the  line element from the screen
    Dim lineElement As zenOn.IElement = screen.Elements().Item("Line_3")
    //The return value from the AddMarker() is the specific ID of this marker.
    Dim markerId As String = Me.DynPictures().AddMarker("Screen 0", lineElement.ID, 20, 1, 2)
    //To delelete this marker we have to assign the specific ID
    Dim isDeleted As Boolean = Me.DynPictures().DelMarker(markerId)
    //Use the return value to check if the marker was deleted
    If isDeleted = True Then
     MessageBox.Show("Marker: " & markerId & " deleted!")
    End If
End Sub


Export
ObjectModel COM [image] DynPictures [image] Methods [image] Export
Remarks

Export settings to an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
C#
Copy
public void MacroExportDynPictures()
{
    //Export all dynpictures to C:\Test\test.xml
    this.ActiveDocument.DynPictures().Export(@"C:\Test\test.xml");
}
VB.NET
Copy
Public Sub MacroExportDynPictures()
    'Export all dynpictures to C:\Test\test.xml
    Me.ActiveDocument.DynPictures().Export("C:\Test\test.xml")
End Sub


GetPointerInfo
ObjectModel COM [image] DynPictures [image] Methods [image] GetPointerInfo
Remarks

Gets the information for the specified pointer associated with the current message. //Layout of the pointer_info structuretypedef struct tagPOINTER_INFO { POINTER_INPUT_TYPE pointerType; UINT32 pointerId; UINT32 frameId; POINTER_FLAGS pointerFlags; HANDLE sourceDevice; HWND hwndTarget; POINT ptPixelLocation; POINT ptHimetricLocation; POINT ptPixelLocationRaw; POINT ptHimetricLocationRaw; DWORD dwTime; UINT32 historyCount; INT32 inputData; DWORD dwKeyStates; UINT64 PerformanceCount; POINTER_BUTTON_CHANGE_TYPE ButtonChangeType;} POINTER_INFO;See also: GetPointerInfo (msdn)

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Unused
VSTA | Available
Parameters
vPointerId as VARIANT

Example
C#
Copy
/// <summary>
        /// Helper function that takes a screen and a pointer ID and writes information about the pointer into the CEL
        /// </summary>
        /// <param name="obDynPicture">the zenon screen</param>
        /// <param name="vPointerId">the pointer object</param>
 private void GetPointerInfo(zenOn.IDynPicture obDynPicture, object vPointerId)
        {
 //get method name and print in CEL
 string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);
            Cel().WriteCelString(CelString);

 //get pointer infos
 try
            {
 //cast this on an object array
 object[] PointerInfo = (object[])DynPics.GetPointerInfo(vPointerId);

 //iterate through all
 for (int i = 0; i < PointerInfo.Length; i++)
                {
 //if the type of the object is an array, we suppose it is the POINT type - which has definition for x and y position
 if (PointerInfo[i] is System.Object[])
                    {
 //to get the information, we have to cast it first to object[] because the compiler would not accept the index otherwise and convert it to a string then
                        Cel().WriteCelString(Pointer_Info_Definition[i] + " for x has value " + Convert.ToString(((object[])(PointerInfo[i]))[0]));
                        Cel().WriteCelString(Pointer_Info_Definition[i] + " for y has value " + Convert.ToString(((object[])(PointerInfo[i]))[1]));
                    }
 else
                    {
 //if it's not object[], simply cast it to string and write an CEL entry
 switch (i)
                        {
 case 0:
 PointerType pt = (PointerType)(Convert.ToUInt32(PointerInfo[i]));
                                Cel().WriteCelString("PointerType: " + pt.ToString());
 break;
 case 3:
 PointerFlags pf = (PointerFlags)(Convert.ToUInt32(PointerInfo[i]));
                                Cel().WriteCelString("PointerFlags: " + pf.ToString());
 break;
 default:
                                Cel().WriteCelString(Pointer_Info_Definition[i] + " has value " + PointerInfo[i].ToString());
 break;
                        }
                    }
                }
            }
 catch (Exception ex)
            {
                Cel().WriteCelString("Can't get PointerInfo: " + ex.Message);
            }
        }
VB.NET
Copy
/// <summary>
        /// Helper function that takes a screen and a pointer ID and writes information about the pointer into the CEL
        /// </summary>
        /// <param name="obDynPicture">the zenon screen</param>
        /// <param name="vPointerId">the pointer object</param>
Private Sub GetPointerInfo(obDynPicture As zenOn.IDynPicture, vPointerId As Object)
    'get method name and print in CEL
    Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)
    Cel().WriteCelString(CelString)

    'get pointer infos
    Try
     'cast this on an object array
        Dim PointerInfo As Object() = DirectCast(DynPics.GetPointerInfo(vPointerId), Object())

     'iterate through all
        For i As Integer = 0 To PointerInfo.Length - 1
     'if the type of the object is an array, we suppose it is the POINT type - which has definition for x and y position
            If TypeOf PointerInfo(i) Is System.Object() Then
     'to get the information, we have to cast it first to object[] because the compiler would not accept the index otherwise and convert it to a string then
                Cel().WriteCelString(Pointer_Info_Definition(i) + " for x has value " & Convert.ToString(DirectCast(PointerInfo(i), Object())(0)))
                Cel().WriteCelString(Pointer_Info_Definition(i) + " for y has value " & Convert.ToString(DirectCast(PointerInfo(i), Object())(1)))
            Else
     'if it's not object[], simply cast it to string and write an CEL entry
                Select Case i
                    Case 0
                        Dim pt As PointerType = DirectCast(Convert.ToUInt32(PointerInfo(i)), PointerType)
                        Cel().WriteCelString("PointerType: " & pt.ToString())
                        Exit Select
                    Case 3
                        Dim pf As PointerFlags = DirectCast(Convert.ToUInt32(PointerInfo(i)), PointerFlags)
                        Cel().WriteCelString("PointerFlags: " & pf.ToString())
                        Exit Select
                    Case Else
                        Cel().WriteCelString(Pointer_Info_Definition(i) + " has value " & PointerInfo(i).ToString())
                        Exit Select
                End Select
            End If
        Next
    Catch ex As Exception
        Cel().WriteCelString("Can't get PointerInfo: " + ex.Message)
    End Try
End Sub


Import
ObjectModel COM [image] DynPictures [image] Methods [image] Import
Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced. Note: One xml file may contain more than one picture.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
C#
Copy
private const string XML_PATH = @"C:\test\";

public void MacroImportPictures()
{
    foreach (string s in Directory.GetFiles(XML_PATH))
    {
        //Loop through the whole specified directory
        //And import the dynpicture settings found
        //First check if the file is an xml file
        if(Path.GetExtension(s) == ".xml")
            this.ActiveDocument.DynPictures().Import(s);
    }
}
VB.NET
Copy
Private Const XML_PATH As String = "C:\test\"

Public Sub MacroImportPictures()
    For Each s As String In Directory.GetFiles(XML_PATH)
        'Loop through the whole specified directory
        'And import the dynpicture settings found
        'First check if the file is an xml file
        If Path.GetExtension(s) = ".xml" Then
            Me.ActiveDocument.DynPictures().Import(s)
        End If
    Next
End Sub
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Item
ObjectModel COM [image] DynPictures [image] Methods [image] Item
Remarks

Returns the object "DynPicture" from the collection, which is identified by the parameter vID.The parameter vID can have two values:<ul><li>Index: Access with an index mostly is used in combination with the property Count to find out the position of the variable object in the list.</li><li>Picture name: The picture can also be accessed with its unique name.</li></ul>Hint:The returned object should always be checked on Nothing, in case no object was found for the search criteria.

Datatype
IDynPicture

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vDynPictureID as VARIANT

Example
C#
Copy
public void MacroListDynPictures()
{
    //Print the name of every DynPicture in the collection
    for (int i = 0; i < this.ActiveDocument.DynPictures().Count; ++i)
    {
        IDynPicture zenonPicture = this.ActiveDocument.DynPictures().Item(i);
        System.Diagnostics.Debug.Print(zenonPicture.Name);
    }
}
VB.NET
Copy
Public Sub MacroListDynPictures()
    'Print the name of every DynPicture in the collection
    Dim i As Integer = 0
    While i < Me.ActiveDocument.DynPictures().Count
        Dim zenonPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item(i)
        System.Diagnostics.Debug.Print(zenonPicture.Name)
        System.Threading.Interlocked.Increment(i)
    End While
End Sub


ItemOnMonitor
ObjectModel COM [image] DynPictures [image] Methods [image] ItemOnMonitor
Remarks

Returns a screen with given name on the given monitor.(RT-Only)

Datatype
IDynPicture

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsSName as BSTR

MonitorId as short


SetupTouchInertia
ObjectModel COM [image] DynPictures [image] Methods [image] SetupTouchInertia
Remarks

Setup inertia settings for multitouch manipulation.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Deceleration as FLOAT

AngularDeceleration as FLOAT

ExpansionDeceleration as FLOAT


ShowCreateDialog
ObjectModel COM [image] DynPictures [image] Methods [image] ShowCreateDialog
Remarks

Opens the zenon standard dialog "New screen". After the dialog is closed the object ShowCreateScreenDialogResult is returned which contains an enumerator (ShowCreateScreenDialogReturnResult) – returns if successful or notscreen object (Screen) – created screen object (if successful)

Datatype
IShowCreateScreenDialogResult

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub showScreenDialog()
Dim obScreens As Screens
Dim obScreen As Screen
Dim enumScrRet As ShowCreateScreenDialogReturnResult
Dim obScrResult As ShowCreateScreenDialogResult
    Set obScreens = MyWorkspace.ActiveDocument.Screens
    Set obScrResult = obScreens.ShowCreateDialog
    enumScrRet = obScrResult.ShowCreateScreenDialogReturnResult
    If enumScrRet = ShowCreateScreenDialogReturnResult_Successful Then
        Set obScreen = obScrResult.Screen
        Debug.Print "Screen " & obScreen.Name & " successfully created"
    ElseIf enumScrRet = ShowCreateScreenDialogReturnResult_UndefinedFailure Then
    'just to test the enum (elseif instead of else)
        Debug.Print "Aborted or unkown error occured"
    End If
End Sub


SingleExport
ObjectModel COM [image] DynPictures [image] Methods [image] SingleExport
Remarks

Exports the Item with given Name oder Index.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR

Example
C#
Copy
public void MacroExportPicturesToFiles()
{
    for (int i = 0; i < this.ActiveDocument.DynPictures().Count; ++i)
    {
        //Generates a new XML file for each picture instead of one big xml file
        this.ActiveDocument.DynPictures()
            .SingleExport(i, @"C:\Test\picture_"
            + this.ActiveDocument.DynPictures().Item(i).Name + ".xml");
    }
}
VB.NET
Copy
Public Sub MacroExportPicturesToFiles()
    Dim i As Integer = 0
    While i < Me.ActiveDocument.DynPictures().Count
        'Generates a new XML file for each picture instead of one big xml file
        Me.ActiveDocument.DynPictures().SingleExport(i, "C:\Test\picture_" + Me.ActiveDocument.DynPictures().Item(i).Name + ".xml")
        System.Threading.Interlocked.Increment(i)
    End While
End Sub


Events
ObjectModel COM [image] DynPictures [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Close | void | Event is fired when a screen is closed. | Unused | Available | Available | Available
ElementGesture | void | Defines the output of the Interaction Context object. | Unused | Available | Unused | Available
ElementInit | void | Event is fired when an element is initialized.(RT-Only) | Unused | Available | Available | Available
ElementLeftButtonDblClick | void | Event is fired when an element is double clicked with the left mouse button.(RT-Only) | Unused | Available | Available | Available
ElementLeftButtonDown | void | Event is fired when the left mouse button is pushed down on an element.(RT-Only) | Unused | Available | Available | Available
ElementLeftButtonUp | void | Event is fired when the right mouse button is released on an element.(RT-Only) | Unused | Available | Available | Available
ElementMouseOver | void | Event is fired when the mouse is moved over an element.(RT-Only) | Unused | Available | Available | Available
ElementRightButtonDblClk | void | Event is fired when an element is double clicked with the right mouse button.(RT-Only) | Unused | Available | Available | Available
ElementRightButtonDown | void | Event is fired when the right mouse button is pushed down on an element.(RT-Only) | Unused | Available | Available | Available
ElementRightButtonUp | void | Event is fired when the right mouse button is released on an element.(RT-Only) | Unused | Available | Available | Available
NCPointerDown | void | Posted when a pointer makes contact over the non-client area of a window. | Unused | Available | Unused | Available
NCPointerUp | void | Posted when a pointer that made contact over the non-client area of a window breaks contact. | Unused | Available | Unused | Available
NCPointerUpdate | void | Posted to provide an update on a pointer that made contact over the non-client area of a window or when a hovering uncaptured contact moves over the non-client area of a window. | Unused | Available | Unused | Available
Open | void | Event is fired when a screen is opened. | Unused | Available | Available | Available
PictureGesture | void | Defines the output of the Interaction Context object. | Unused | Available | Unused | Available
PointerActivate | void |  | Unused | Available | Unused | Available
PointerCaptureChanged | void | Sent to a window that is losing capture of an input pointer. | Unused | Available | Unused | Available
PointerDown | void | Posted when a pointer makes contact over the client area of a window. | Unused | Available | Unused | Available
PointerEnter | void | Sent to a window when a new pointer enters detection range over the window (hover) or when an existing pointer moves within the boundaries of the window. | Unused | Available | Unused | Available
PointerHWheel | void | Posted to the window with foreground keyboard focus when a horizontal scroll wheel is rotated. | Unused | Available | Unused | Available
PointerLeave | void | Sent to a window when a pointer leaves detection range over the window (hover) or when a pointer moves outside the boundaries of the window. | Unused | Available | Unused | Available
PointerUp | void |  | Unused | Available | Unused | Available
PointerUpdate | void |  | Unused | Available | Unused | Available
PointerWheel | void | Posted to the window with foreground keyboard focus when a horizontal scroll wheel is rotated. | Unused | Available | Unused | Available
TouchEvent | void | Event is fired for all touch events.(RT-Only) | Unused | Available | Available | Available
TouchManipulationCompleteEvent | void | Event is fired when a touch manipulation ends.(RT-Only) | Unused | Available | Available | Available
TouchManipulationDeltaEvent | void | Event is fired when a touch manipulation is in progress.(RT-Only) | Unused | Available | Available | Available
TouchManipulationStartEvent | void | Event is fired when a touch manipulation starts.(RT-Only) | Unused | Available | Available | Available
WindowPosChanged | void | Event is fired when a screen is moved or resized.(RT-Only) | Unused | Available | Available | Available


Close
ObjectModel COM [image] DynPictures [image] Events [image] Close
Remarks

Event is fired when a screen is closed.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obDynPicture as IDynPicture

Example
C#
Copy
void ThisProject_Active()
{
    this.DynPictures().Open += new DDynPicturesEvents_OpenEventHandler(ThisProject_Open);
    this.DynPictures().Close += new DDynPicturesEvents_CloseEventHandler(ThisProject_Close);
}

void ThisProject_Close(IDynPicture obDynPicture)
{
    //Logs the Close event on the CEL; Once a screen is closed it will be written
    //to the chronological Event List
    this.Cel().WriteCelString(obDynPicture.Name + " was closed");
}

void ThisProject_Open(IDynPicture obDynPicture)
{
    //Logs the Open event on the CEL; Once a screen is open it will be written
    //to the chronological Event List
    this.Cel().WriteCelString(obDynPicture.Name + " was opened");
}

void ThisProject_Inactive()
{
    this.DynPictures().Open -= new DDynPicturesEvents_OpenEventHandler(ThisProject_Open);
    this.DynPictures().Close -= new DDynPicturesEvents_CloseEventHandler(ThisProject_Close);
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    Me.DynPictures().Open += New DDynPicturesEvents_OpenEventHandler(ThisProject_Open)
    Me.DynPictures().Close += New DDynPicturesEvents_CloseEventHandler(ThisProject_Close)
End Sub

Private Sub ThisProject_Close(obDynPicture As IDynPicture)
    'Logs the Close event on the CEL; Once a screen is closed it will be written
    'to the chronological Event List
    Me.Cel().WriteCelString(obDynPicture.Name + " was closed")
End Sub

Private Sub ThisProject_Open(obDynPicture As IDynPicture)
    'Logs the Open event on the CEL; Once a screen is open it will be written
    'to the chronological Event List
    Me.Cel().WriteCelString(obDynPicture.Name + " was opened")
End Sub

Private Sub ThisProject_Inactive()
    Me.DynPictures().Open -= New DDynPicturesEvents_OpenEventHandler(ThisProject_Open)
    Me.DynPictures().Close -= New DDynPicturesEvents_CloseEventHandler(ThisProject_Close)
    FreeObjects()
End Sub


ElementGesture
ObjectModel COM [image] DynPictures [image] Events [image] ElementGesture
Remarks

Defines the output of the Interaction Context object. See also: interaction_context_output (msdn)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Unused
VSTA | Available
Parameters
obElement as IElement

interactionContextOutput as VARIANT

Example
C#
Copy
/// <summary>
        /// event handler for the ElementGesture event
        /// </summary>
        /// <param name="obElement">element on which the event occured</param>
        /// <param name="interactionContextOutput">object that contains the information about the gesture</param>
 void DynPics_ElementGesture(zenOn.IElement obElement, object interactionContextOutput)
        {
            CELMakeSeperator();
 string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obElement.Name);
            Cel().WriteCelString(CelString);

            WriteInteractionContextOutputToCEL(interactionContextOutput);
        }
VB.NET
Copy
/// <summary>
        /// event handler for the ElementGesture event
        /// </summary>
        /// <param name="obElement">element on which the event occured</param>
        /// <param name="interactionContextOutput">object that contains the information about the gesture</param>
Private Sub DynPics_ElementGesture(obElement As zenOn.IElement, interactionContextOutput As Object)
    CELMakeSeperator()
    Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obElement.Name)
    Cel().WriteCelString(CelString)

    WriteInteractionContextOutputToCEL(interactionContextOutput)
End Sub


ElementInit
ObjectModel COM [image] DynPictures [image] Events [image] ElementInit
Remarks

Event is fired when an element is initialized.(RT-Only)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obElement as IElement

Example
C#
Copy
void ThisProject_Active()
{
    this.DynPictures().ElementInit += new ElementInitEventHandler(ThisProject_ElementInit);
}

void ThisProject_ElementInit(IElement obElement)
{
    /*Event is fired once an element is initialized by the runtime.
    **To demonstrate the name of the element is printed on the CEL.
     */
    this.Cel().WriteCelString("Element " + obElement.Name + " was initialized");
}

void ThisProject_Inactive()
{
    this.DynPictures().ElementInit -= ThisProject_ElementInit;
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    Me.DynPictures().ElementInit += New ElementInitEventHandler(AddressOf ThisProject_ElementInit)
End Sub

Private Sub ThisProject_ElementInit(obElement As IElement)
    'Event is fired once an element is initialized by the runtime.
'    **To demonstrate the name of the element is printed on the CEL.
'

    Me.Cel().WriteCelString("Element " + obElement.Name + " was initialized")
End Sub

Private Sub ThisProject_Inactive()
    RemoveHandler Me.DynPictures().ElementInit, AddressOf ThisProject_ElementInit
    FreeObjects()
End Sub
VBA
Copy
'Declaration of DynPictures, in order to use it with events
Dim WithEvents zDynPictures As DynPictures
Private Sub Project_Active()
'Reference to the zenon Project DynPictures
Set zDynPictures = thisProject.DynPictures
End Sub
'This event is triggered when an element is initialized
Private Sub zDynPictures_ElementInit(ByVal obElement As IElement)
Debug.Print ("Element name: " & obElement.Name)
End Sub


ElementLeftButtonDblClick
ObjectModel COM [image] DynPictures [image] Events [image] ElementLeftButtonDblClick
Remarks

Event is fired when an element is double clicked with the left mouse button.(RT-Only)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obDynPicture as IDynPicture

obElement as IElement

lPosX as long

lPosY as long

lButton as long

Example
C#
Copy
//Initialize event handlers
void ThisProject_Active()
{
    this.DynPictures().ElementLeftButtonDblClick += new ElementLeftButtonDblClickEventHandler(ThisProject_ElementLeftButtonDblClick);
    this.DynPictures().ElementRightButtonDblClk += new ElementRightButtonDblClkEventHandler(ThisProject_ElementRightButtonDblClk);
}

void ThisProject_ElementRightButtonDblClk(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Right Click Event
    System.Diagnostics.Debug.Print("Double Right Click on " + lPosX + " / " + lPosY);
    if(obElement != null)
        System.Diagnostics.Debug.Print("Double Right Click on " + obElement.Name);
}

void ThisProject_ElementLeftButtonDblClick(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Left Click event
    System.Diagnostics.Debug.Print("Double Left Click on " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Double Left Click on " + obElement.Name);
}

//Deinitialize event handlers
void ThisProject_Inactive()
{
    this.DynPictures().ElementLeftButtonDblClick += new ElementLeftButtonDblClickEventHandler(ThisProject_ElementLeftButtonDblClick);
    this.DynPictures().ElementRightButtonDblClk += new ElementRightButtonDblClkEventHandler(ThisProject_ElementRightButtonDblClk);
    FreeObjects();
}
VB.NET
Copy
'Initialize event handlers
Private Sub ThisProject_Active()
    Me.DynPictures().ElementLeftButtonDblClick += New ElementLeftButtonDblClickEventHandler(ThisProject_ElementLeftButtonDblClick)
    Me.DynPictures().ElementRightButtonDblClk += New ElementRightButtonDblClkEventHandler(ThisProject_ElementRightButtonDblClk)
End Sub

Private Sub ThisProject_ElementRightButtonDblClk(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Right Click Event
    System.Diagnostics.Debug.Print("Double Right Click on " + lPosX + " / " + lPosY)
    If not (obElement  is nothing)  Then
        System.Diagnostics.Debug.Print("Double Right Click on " + obElement.Name)
    End If
End Sub

Private Sub ThisProject_ElementLeftButtonDblClick(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Left Click event
    System.Diagnostics.Debug.Print("Double Left Click on " + lPosX + " / " + lPosY)
    If not (obElement  is nothing)  Then
        System.Diagnostics.Debug.Print("Double Left Click on " + obElement.Name)
    End If
End Sub

'Deinitialize event handlers
Private Sub ThisProject_Inactive()
    Me.DynPictures().ElementLeftButtonDblClick += New ElementLeftButtonDblClickEventHandler(ThisProject_ElementLeftButtonDblClick)
    Me.DynPictures().ElementRightButtonDblClk += New ElementRightButtonDblClkEventHandler(ThisProject_ElementRightButtonDblClk)
    FreeObjects()
End Sub


ElementLeftButtonDown
ObjectModel COM [image] DynPictures [image] Events [image] ElementLeftButtonDown
Remarks

Event is fired when the left mouse button is pushed down on an element.(RT-Only)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obDynPicture as IDynPicture

obElement as IElement

lPosX as long

lPosY as long

lButton as long

Example
C#
Copy
/*
**In this example the mouse interaction events are triggered. Note that the obElement parameter is in fact nullable if
**the cursor is not hovering an element during the click / move event and therefore has to be checked against null
**In the example some values given by the function are written to the debug command line.*/

void ThisProject_Active()
{
    //Event handler initialization
    this.DynPictures().ElementLeftButtonDblClick += new ElementLeftButtonDblClickEventHandler(ThisProject_ElementLeftButtonDblClick);
    this.DynPictures().ElementRightButtonDblClk += new ElementRightButtonDblClkEventHandler(ThisProject_ElementRightButtonDblClk);
    this.DynPictures().ElementLeftButtonDown += new ElementLeftButtonDownEventHandler(ThisProject_ElementLeftButtonDown);
    this.DynPictures().ElementLeftButtonUp += new ElementLeftButtonUpEventHandler(ThisProject_ElementLeftButtonUp);
    this.DynPictures().ElementRightButtonDown += new ElementRightButtonDownEventHandler(ThisProject_ElementRightButtonDown);
    this.DynPictures().ElementRightButtonUp += new ElementRightButtonUpEventHandler(ThisProject_ElementRightButtonUp);
    this.DynPictures().ElementMouseOver += new ElementMouseOverEventHandler(ThisProject_ElementMouseOver);
}

void ThisProject_ElementMouseOver(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse over event
    System.Diagnostics.Debug.Print("Mouse over event on " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Mouse over event on element '" + obElement.Name + "'");
}

void ThisProject_ElementRightButtonUp(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button up event
    System.Diagnostics.Debug.Print("Right mouse button up event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Right mouse button up event '" + obElement.Name + "'");
}

void ThisProject_ElementRightButtonDown(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button down event
    System.Diagnostics.Debug.Print("Right mouse button down event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Right mouse button down event '" + obElement.Name + "'");

}

void ThisProject_ElementLeftButtonUp(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button up event
    System.Diagnostics.Debug.Print("Left mouse button up event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Left mouse button up event '" + obElement.Name + "'");

}

void ThisProject_ElementLeftButtonDown(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button down event
    System.Diagnostics.Debug.Print("Left mouse button down event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Left mouse button down event '" + obElement.Name + "'");

}

void ThisProject_ElementRightButtonDblClk(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log    Right    Click    Event
    System.Diagnostics.Debug.Print("Double    Right    Click    on    " + lPosX + "    /    " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Double    Right    Click    on    " + obElement.Name);
}

void ThisProject_ElementLeftButtonDblClick(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log    Left    Click    event
    System.Diagnostics.Debug.Print("Double    Left    Click    on    " + lPosX + "    /    " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Double    Left    Click    on    " + obElement.Name);
}

void ThisProject_Inactive()
{
    //Event handler cleanup
    this.DynPictures().ElementLeftButtonDblClick -= ThisProject_ElementLeftButtonDblClick;
    this.DynPictures().ElementRightButtonDblClk -= ThisProject_ElementRightButtonDblClk;
    this.DynPictures().ElementLeftButtonDown -= ThisProject_ElementLeftButtonDown;
    this.DynPictures().ElementLeftButtonUp -= ThisProject_ElementLeftButtonUp;
    this.DynPictures().ElementRightButtonDown -= ThisProject_ElementRightButtonDown;
    this.DynPictures().ElementRightButtonUp -= ThisProject_ElementRightButtonUp;
    this.DynPictures().ElementMouseOver -= ThisProject_ElementMouseOver;
    FreeObjects();
}
VB.NET
Copy
'
'**In this example the mouse interaction events are triggered. Note that the obElement parameter is in fact nullable if
'**the cursor is not hovering an element during the click / move event and therefore has to be checked against null
'**In the example some values given by the function are written to the debug command line.
'

Private Sub ThisProject_Active()
    'Event handler initialization
    Me.DynPictures().ElementLeftButtonDblClick += New ElementLeftButtonDblClickEventHandler(AddressOf ThisProject_ElementLeftButtonDblClick)
    Me.DynPictures().ElementRightButtonDblClk += New ElementRightButtonDblClkEventHandler(AddressOf ThisProject_ElementRightButtonDblClk)
    Me.DynPictures().ElementLeftButtonDown += New ElementLeftButtonDownEventHandler(AddressOf ThisProject_ElementLeftButtonDown)
    Me.DynPictures().ElementLeftButtonUp += New ElementLeftButtonUpEventHandler(AddressOf ThisProject_ElementLeftButtonUp)
    Me.DynPictures().ElementRightButtonDown += New ElementRightButtonDownEventHandler(AddressOf ThisProject_ElementRightButtonDown)
    Me.DynPictures().ElementRightButtonUp += New ElementRightButtonUpEventHandler(AddressOf ThisProject_ElementRightButtonUp)
    Me.DynPictures().ElementMouseOver += New ElementMouseOverEventHandler(AddressOf ThisProject_ElementMouseOver)
End Sub

Private Sub ThisProject_ElementMouseOver(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse over event
    System.Diagnostics.Debug.Print("Mouse over event on " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Mouse over event on element '" + obElement.Name + "'")
    End If
End Sub

Private Sub ThisProject_ElementRightButtonUp(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button up event
    System.Diagnostics.Debug.Print("Right mouse button up event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Right mouse button up event '" + obElement.Name + "'")
    End If
End Sub

Private Sub ThisProject_ElementRightButtonDown(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button down event
    System.Diagnostics.Debug.Print("Right mouse button down event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Right mouse button down event '" + obElement.Name + "'")
    End If

End Sub

Private Sub ThisProject_ElementLeftButtonUp(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button up event
    System.Diagnostics.Debug.Print("Left mouse button up event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Left mouse button up event '" + obElement.Name + "'")
    End If

End Sub

Private Sub ThisProject_ElementLeftButtonDown(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button down event
    System.Diagnostics.Debug.Print("Left mouse button down event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Left mouse button down event '" + obElement.Name + "'")
    End If

End Sub

Private Sub ThisProject_ElementRightButtonDblClk(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Right Click Event
    System.Diagnostics.Debug.Print("Double Right Click on " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Double Right Click on " + obElement.Name)
    End If
End Sub

Private Sub ThisProject_ElementLeftButtonDblClick(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Left Click event
    System.Diagnostics.Debug.Print("Double Left Click on " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Double Left Click on " + obElement.Name)
    End If
End Sub

Private Sub ThisProject_Inactive()
    'Event handler cleanup
    RemoveHandler Me.DynPictures().ElementLeftButtonDblClick, AddressOf ThisProject_ElementLeftButtonDblClick
    RemoveHandler Me.DynPictures().ElementRightButtonDblClk, AddressOf ThisProject_ElementRightButtonDblClk
    RemoveHandler Me.DynPictures().ElementLeftButtonDown, AddressOf ThisProject_ElementLeftButtonDown
    RemoveHandler Me.DynPictures().ElementLeftButtonUp, AddressOf ThisProject_ElementLeftButtonUp
    RemoveHandler Me.DynPictures().ElementRightButtonDown, AddressOf ThisProject_ElementRightButtonDown
    RemoveHandler Me.DynPictures().ElementRightButtonUp, AddressOf ThisProject_ElementRightButtonUp
    RemoveHandler Me.DynPictures().ElementMouseOver, AddressOf ThisProject_ElementMouseOver
    FreeObjects()
End Sub


ElementLeftButtonUp
ObjectModel COM [image] DynPictures [image] Events [image] ElementLeftButtonUp
Remarks

Event is fired when the right mouse button is released on an element.(RT-Only)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obDynPicture as IDynPicture

obElement as IElement

lPosX as long

lPosY as long

lButton as long

Example
C#
Copy
/*
**In this example the mouse interaction events are triggered. Note that the obElement parameter is in fact nullable if
**the cursor is not hovering an element during the click / move event and therefore has to be checked against null
**In the example some values given by the function are written to the debug command line.*/

void ThisProject_Active()
{
    //Event handler initialization
    this.DynPictures().ElementLeftButtonDblClick += new ElementLeftButtonDblClickEventHandler(ThisProject_ElementLeftButtonDblClick);
    this.DynPictures().ElementRightButtonDblClk += new ElementRightButtonDblClkEventHandler(ThisProject_ElementRightButtonDblClk);
    this.DynPictures().ElementLeftButtonDown += new ElementLeftButtonDownEventHandler(ThisProject_ElementLeftButtonDown);
    this.DynPictures().ElementLeftButtonUp += new ElementLeftButtonUpEventHandler(ThisProject_ElementLeftButtonUp);
    this.DynPictures().ElementRightButtonDown += new ElementRightButtonDownEventHandler(ThisProject_ElementRightButtonDown);
    this.DynPictures().ElementRightButtonUp += new ElementRightButtonUpEventHandler(ThisProject_ElementRightButtonUp);
    this.DynPictures().ElementMouseOver += new ElementMouseOverEventHandler(ThisProject_ElementMouseOver);
}

void ThisProject_ElementMouseOver(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse over event
    System.Diagnostics.Debug.Print("Mouse over event on " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Mouse over event on element '" + obElement.Name + "'");
}

void ThisProject_ElementRightButtonUp(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button up event
    System.Diagnostics.Debug.Print("Right mouse button up event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Right mouse button up event '" + obElement.Name + "'");
}

void ThisProject_ElementRightButtonDown(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button down event
    System.Diagnostics.Debug.Print("Right mouse button down event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Right mouse button down event '" + obElement.Name + "'");

}

void ThisProject_ElementLeftButtonUp(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button up event
    System.Diagnostics.Debug.Print("Left mouse button up event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Left mouse button up event '" + obElement.Name + "'");

}

void ThisProject_ElementLeftButtonDown(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button down event
    System.Diagnostics.Debug.Print("Left mouse button down event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Left mouse button down event '" + obElement.Name + "'");

}

void ThisProject_ElementRightButtonDblClk(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log    Right    Click    Event
    System.Diagnostics.Debug.Print("Double    Right    Click    on    " + lPosX + "    /    " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Double    Right    Click    on    " + obElement.Name);
}

void ThisProject_ElementLeftButtonDblClick(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log    Left    Click    event
    System.Diagnostics.Debug.Print("Double    Left    Click    on    " + lPosX + "    /    " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Double    Left    Click    on    " + obElement.Name);
}

void ThisProject_Inactive()
{
    //Event handler cleanup
    this.DynPictures().ElementLeftButtonDblClick -= ThisProject_ElementLeftButtonDblClick;
    this.DynPictures().ElementRightButtonDblClk -= ThisProject_ElementRightButtonDblClk;
    this.DynPictures().ElementLeftButtonDown -= ThisProject_ElementLeftButtonDown;
    this.DynPictures().ElementLeftButtonUp -= ThisProject_ElementLeftButtonUp;
    this.DynPictures().ElementRightButtonDown -= ThisProject_ElementRightButtonDown;
    this.DynPictures().ElementRightButtonUp -= ThisProject_ElementRightButtonUp;
    this.DynPictures().ElementMouseOver -= ThisProject_ElementMouseOver;
    FreeObjects();
}
VB.NET
Copy
'
'**In this example the mouse interaction events are triggered. Note that the obElement parameter is in fact nullable if
'**the cursor is not hovering an element during the click / move event and therefore has to be checked against null
'**In the example some values given by the function are written to the debug command line.
'

Private Sub ThisProject_Active()
    'Event handler initialization
    Me.DynPictures().ElementLeftButtonDblClick += New ElementLeftButtonDblClickEventHandler(AddressOf ThisProject_ElementLeftButtonDblClick)
    Me.DynPictures().ElementRightButtonDblClk += New ElementRightButtonDblClkEventHandler(AddressOf ThisProject_ElementRightButtonDblClk)
    Me.DynPictures().ElementLeftButtonDown += New ElementLeftButtonDownEventHandler(AddressOf ThisProject_ElementLeftButtonDown)
    Me.DynPictures().ElementLeftButtonUp += New ElementLeftButtonUpEventHandler(AddressOf ThisProject_ElementLeftButtonUp)
    Me.DynPictures().ElementRightButtonDown += New ElementRightButtonDownEventHandler(AddressOf ThisProject_ElementRightButtonDown)
    Me.DynPictures().ElementRightButtonUp += New ElementRightButtonUpEventHandler(AddressOf ThisProject_ElementRightButtonUp)
    Me.DynPictures().ElementMouseOver += New ElementMouseOverEventHandler(AddressOf ThisProject_ElementMouseOver)
End Sub

Private Sub ThisProject_ElementMouseOver(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse over event
    System.Diagnostics.Debug.Print("Mouse over event on " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Mouse over event on element '" + obElement.Name + "'")
    End If
End Sub

Private Sub ThisProject_ElementRightButtonUp(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button up event
    System.Diagnostics.Debug.Print("Right mouse button up event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Right mouse button up event '" + obElement.Name + "'")
    End If
End Sub

Private Sub ThisProject_ElementRightButtonDown(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button down event
    System.Diagnostics.Debug.Print("Right mouse button down event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Right mouse button down event '" + obElement.Name + "'")
    End If

End Sub

Private Sub ThisProject_ElementLeftButtonUp(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button up event
    System.Diagnostics.Debug.Print("Left mouse button up event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Left mouse button up event '" + obElement.Name + "'")
    End If

End Sub

Private Sub ThisProject_ElementLeftButtonDown(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button down event
    System.Diagnostics.Debug.Print("Left mouse button down event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Left mouse button down event '" + obElement.Name + "'")
    End If

End Sub

Private Sub ThisProject_ElementRightButtonDblClk(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Right Click Event
    System.Diagnostics.Debug.Print("Double Right Click on " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Double Right Click on " + obElement.Name)
    End If
End Sub

Private Sub ThisProject_ElementLeftButtonDblClick(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Left Click event
    System.Diagnostics.Debug.Print("Double Left Click on " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Double Left Click on " + obElement.Name)
    End If
End Sub

Private Sub ThisProject_Inactive()
    'Event handler cleanup
    RemoveHandler Me.DynPictures().ElementLeftButtonDblClick, AddressOf ThisProject_ElementLeftButtonDblClick
    RemoveHandler Me.DynPictures().ElementRightButtonDblClk, AddressOf ThisProject_ElementRightButtonDblClk
    RemoveHandler Me.DynPictures().ElementLeftButtonDown, AddressOf ThisProject_ElementLeftButtonDown
    RemoveHandler Me.DynPictures().ElementLeftButtonUp, AddressOf ThisProject_ElementLeftButtonUp
    RemoveHandler Me.DynPictures().ElementRightButtonDown, AddressOf ThisProject_ElementRightButtonDown
    RemoveHandler Me.DynPictures().ElementRightButtonUp, AddressOf ThisProject_ElementRightButtonUp
    RemoveHandler Me.DynPictures().ElementMouseOver, AddressOf ThisProject_ElementMouseOver
    FreeObjects()
End Sub


ElementMouseOver
ObjectModel COM [image] DynPictures [image] Events [image] ElementMouseOver
Remarks

Event is fired when the mouse is moved over an element.(RT-Only)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obDynPicture as IDynPicture

obElement as IElement

lPosX as long

lPosY as long

lButton as long

Example
C#
Copy
/*
**In this example the mouse interaction events are triggered. Note that the obElement parameter is in fact nullable if
**the cursor is not hovering an element during the click / move event and therefore has to be checked against null
**In the example some values given by the function are written to the debug command line.*/

void ThisProject_Active()
{
    //Event handler initialization
    this.DynPictures().ElementLeftButtonDblClick += new ElementLeftButtonDblClickEventHandler(ThisProject_ElementLeftButtonDblClick);
    this.DynPictures().ElementRightButtonDblClk += new ElementRightButtonDblClkEventHandler(ThisProject_ElementRightButtonDblClk);
    this.DynPictures().ElementLeftButtonDown += new ElementLeftButtonDownEventHandler(ThisProject_ElementLeftButtonDown);
    this.DynPictures().ElementLeftButtonUp += new ElementLeftButtonUpEventHandler(ThisProject_ElementLeftButtonUp);
    this.DynPictures().ElementRightButtonDown += new ElementRightButtonDownEventHandler(ThisProject_ElementRightButtonDown);
    this.DynPictures().ElementRightButtonUp += new ElementRightButtonUpEventHandler(ThisProject_ElementRightButtonUp);
    this.DynPictures().ElementMouseOver += new ElementMouseOverEventHandler(ThisProject_ElementMouseOver);
}

void ThisProject_ElementMouseOver(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse over event
    System.Diagnostics.Debug.Print("Mouse over event on " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Mouse over event on element '" + obElement.Name + "'");
}

void ThisProject_ElementRightButtonUp(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button up event
    System.Diagnostics.Debug.Print("Right mouse button up event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Right mouse button up event '" + obElement.Name + "'");
}

void ThisProject_ElementRightButtonDown(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button down event
    System.Diagnostics.Debug.Print("Right mouse button down event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Right mouse button down event '" + obElement.Name + "'");

}

void ThisProject_ElementLeftButtonUp(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button up event
    System.Diagnostics.Debug.Print("Left mouse button up event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Left mouse button up event '" + obElement.Name + "'");

}

void ThisProject_ElementLeftButtonDown(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button down event
    System.Diagnostics.Debug.Print("Left mouse button down event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Left mouse button down event '" + obElement.Name + "'");

}

void ThisProject_ElementRightButtonDblClk(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log    Right    Click    Event
    System.Diagnostics.Debug.Print("Double    Right    Click    on    " + lPosX + "    /    " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Double    Right    Click    on    " + obElement.Name);
}

void ThisProject_ElementLeftButtonDblClick(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log    Left    Click    event
    System.Diagnostics.Debug.Print("Double    Left    Click    on    " + lPosX + "    /    " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Double    Left    Click    on    " + obElement.Name);
}

void ThisProject_Inactive()
{
    //Event handler cleanup
    this.DynPictures().ElementLeftButtonDblClick -= ThisProject_ElementLeftButtonDblClick;
    this.DynPictures().ElementRightButtonDblClk -= ThisProject_ElementRightButtonDblClk;
    this.DynPictures().ElementLeftButtonDown -= ThisProject_ElementLeftButtonDown;
    this.DynPictures().ElementLeftButtonUp -= ThisProject_ElementLeftButtonUp;
    this.DynPictures().ElementRightButtonDown -= ThisProject_ElementRightButtonDown;
    this.DynPictures().ElementRightButtonUp -= ThisProject_ElementRightButtonUp;
    this.DynPictures().ElementMouseOver -= ThisProject_ElementMouseOver;
    FreeObjects();
}
VB.NET
Copy
'
'**In this example the mouse interaction events are triggered. Note that the obElement parameter is in fact nullable if
'**the cursor is not hovering an element during the click / move event and therefore has to be checked against null
'**In the example some values given by the function are written to the debug command line.
'

Private Sub ThisProject_Active()
    'Event handler initialization
    Me.DynPictures().ElementLeftButtonDblClick += New ElementLeftButtonDblClickEventHandler(AddressOf ThisProject_ElementLeftButtonDblClick)
    Me.DynPictures().ElementRightButtonDblClk += New ElementRightButtonDblClkEventHandler(AddressOf ThisProject_ElementRightButtonDblClk)
    Me.DynPictures().ElementLeftButtonDown += New ElementLeftButtonDownEventHandler(AddressOf ThisProject_ElementLeftButtonDown)
    Me.DynPictures().ElementLeftButtonUp += New ElementLeftButtonUpEventHandler(AddressOf ThisProject_ElementLeftButtonUp)
    Me.DynPictures().ElementRightButtonDown += New ElementRightButtonDownEventHandler(AddressOf ThisProject_ElementRightButtonDown)
    Me.DynPictures().ElementRightButtonUp += New ElementRightButtonUpEventHandler(AddressOf ThisProject_ElementRightButtonUp)
    Me.DynPictures().ElementMouseOver += New ElementMouseOverEventHandler(AddressOf ThisProject_ElementMouseOver)
End Sub

Private Sub ThisProject_ElementMouseOver(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse over event
    System.Diagnostics.Debug.Print("Mouse over event on " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Mouse over event on element '" + obElement.Name + "'")
    End If
End Sub

Private Sub ThisProject_ElementRightButtonUp(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button up event
    System.Diagnostics.Debug.Print("Right mouse button up event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Right mouse button up event '" + obElement.Name + "'")
    End If
End Sub

Private Sub ThisProject_ElementRightButtonDown(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button down event
    System.Diagnostics.Debug.Print("Right mouse button down event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Right mouse button down event '" + obElement.Name + "'")
    End If

End Sub

Private Sub ThisProject_ElementLeftButtonUp(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button up event
    System.Diagnostics.Debug.Print("Left mouse button up event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Left mouse button up event '" + obElement.Name + "'")
    End If

End Sub

Private Sub ThisProject_ElementLeftButtonDown(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button down event
    System.Diagnostics.Debug.Print("Left mouse button down event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Left mouse button down event '" + obElement.Name + "'")
    End If

End Sub

Private Sub ThisProject_ElementRightButtonDblClk(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Right Click Event
    System.Diagnostics.Debug.Print("Double Right Click on " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Double Right Click on " + obElement.Name)
    End If
End Sub

Private Sub ThisProject_ElementLeftButtonDblClick(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Left Click event
    System.Diagnostics.Debug.Print("Double Left Click on " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Double Left Click on " + obElement.Name)
    End If
End Sub

Private Sub ThisProject_Inactive()
    'Event handler cleanup
    RemoveHandler Me.DynPictures().ElementLeftButtonDblClick, AddressOf ThisProject_ElementLeftButtonDblClick
    RemoveHandler Me.DynPictures().ElementRightButtonDblClk, AddressOf ThisProject_ElementRightButtonDblClk
    RemoveHandler Me.DynPictures().ElementLeftButtonDown, AddressOf ThisProject_ElementLeftButtonDown
    RemoveHandler Me.DynPictures().ElementLeftButtonUp, AddressOf ThisProject_ElementLeftButtonUp
    RemoveHandler Me.DynPictures().ElementRightButtonDown, AddressOf ThisProject_ElementRightButtonDown
    RemoveHandler Me.DynPictures().ElementRightButtonUp, AddressOf ThisProject_ElementRightButtonUp
    RemoveHandler Me.DynPictures().ElementMouseOver, AddressOf ThisProject_ElementMouseOver
    FreeObjects()
End Sub


ElementRightButtonDblClk
ObjectModel COM [image] DynPictures [image] Events [image] ElementRightButtonDblClk
Remarks

Event is fired when an element is double clicked with the right mouse button.(RT-Only)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obDynPicture as IDynPicture

obElement as IElement

lPosX as long

lPosY as long

lButton as long

Example
C#
Copy
//Initialize event handlers
void ThisProject_Active()
{
    this.DynPictures().ElementLeftButtonDblClick += new ElementLeftButtonDblClickEventHandler(ThisProject_ElementLeftButtonDblClick);
    this.DynPictures().ElementRightButtonDblClk += new ElementRightButtonDblClkEventHandler(ThisProject_ElementRightButtonDblClk);
}

void ThisProject_ElementRightButtonDblClk(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Right Click Event
    System.Diagnostics.Debug.Print("Double Right Click on " + lPosX + " / " + lPosY);
    if(obElement != null)
        System.Diagnostics.Debug.Print("Double Right Click on " + obElement.Name);
}

void ThisProject_ElementLeftButtonDblClick(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Left Click event
    System.Diagnostics.Debug.Print("Double Left Click on " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Double Left Click on " + obElement.Name);
}

//Deinitialize event handlers
void ThisProject_Inactive()
{
    this.DynPictures().ElementLeftButtonDblClick += new ElementLeftButtonDblClickEventHandler(ThisProject_ElementLeftButtonDblClick);
    this.DynPictures().ElementRightButtonDblClk += new ElementRightButtonDblClkEventHandler(ThisProject_ElementRightButtonDblClk);
    FreeObjects();
}
VB.NET
Copy
'Initialize event handlers
Private Sub ThisProject_Active()
    Me.DynPictures().ElementLeftButtonDblClick += New ElementLeftButtonDblClickEventHandler(ThisProject_ElementLeftButtonDblClick)
    Me.DynPictures().ElementRightButtonDblClk += New ElementRightButtonDblClkEventHandler(ThisProject_ElementRightButtonDblClk)
End Sub

Private Sub ThisProject_ElementRightButtonDblClk(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Right Click Event
    System.Diagnostics.Debug.Print("Double Right Click on " + lPosX + " / " + lPosY)
    If not (obElement  is nothing)  Then
        System.Diagnostics.Debug.Print("Double Right Click on " + obElement.Name)
    End If
End Sub

Private Sub ThisProject_ElementLeftButtonDblClick(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Left Click event
    System.Diagnostics.Debug.Print("Double Left Click on " + lPosX + " / " + lPosY)
    If not (obElement  is nothing)  Then
        System.Diagnostics.Debug.Print("Double Left Click on " + obElement.Name)
    End If
End Sub

'Deinitialize event handlers
Private Sub ThisProject_Inactive()
    Me.DynPictures().ElementLeftButtonDblClick += New ElementLeftButtonDblClickEventHandler(ThisProject_ElementLeftButtonDblClick)
    Me.DynPictures().ElementRightButtonDblClk += New ElementRightButtonDblClkEventHandler(ThisProject_ElementRightButtonDblClk)
    FreeObjects()
End Sub


ElementRightButtonDown
ObjectModel COM [image] DynPictures [image] Events [image] ElementRightButtonDown
Remarks

Event is fired when the right mouse button is pushed down on an element.(RT-Only)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obDynPicture as IDynPicture

obElement as IElement

lPosX as long

lPosY as long

lButton as long

Example
C#
Copy
/*
**In this example the mouse interaction events are triggered. Note that the obElement parameter is in fact nullable if
**the cursor is not hovering an element during the click / move event and therefore has to be checked against null
**In the example some values given by the function are written to the debug command line.*/

void ThisProject_Active()
{
    //Event handler initialization
    this.DynPictures().ElementLeftButtonDblClick += new ElementLeftButtonDblClickEventHandler(ThisProject_ElementLeftButtonDblClick);
    this.DynPictures().ElementRightButtonDblClk += new ElementRightButtonDblClkEventHandler(ThisProject_ElementRightButtonDblClk);
    this.DynPictures().ElementLeftButtonDown += new ElementLeftButtonDownEventHandler(ThisProject_ElementLeftButtonDown);
    this.DynPictures().ElementLeftButtonUp += new ElementLeftButtonUpEventHandler(ThisProject_ElementLeftButtonUp);
    this.DynPictures().ElementRightButtonDown += new ElementRightButtonDownEventHandler(ThisProject_ElementRightButtonDown);
    this.DynPictures().ElementRightButtonUp += new ElementRightButtonUpEventHandler(ThisProject_ElementRightButtonUp);
    this.DynPictures().ElementMouseOver += new ElementMouseOverEventHandler(ThisProject_ElementMouseOver);
}

void ThisProject_ElementMouseOver(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse over event
    System.Diagnostics.Debug.Print("Mouse over event on " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Mouse over event on element '" + obElement.Name + "'");
}

void ThisProject_ElementRightButtonUp(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button up event
    System.Diagnostics.Debug.Print("Right mouse button up event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Right mouse button up event '" + obElement.Name + "'");
}

void ThisProject_ElementRightButtonDown(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button down event
    System.Diagnostics.Debug.Print("Right mouse button down event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Right mouse button down event '" + obElement.Name + "'");

}

void ThisProject_ElementLeftButtonUp(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button up event
    System.Diagnostics.Debug.Print("Left mouse button up event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Left mouse button up event '" + obElement.Name + "'");

}

void ThisProject_ElementLeftButtonDown(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button down event
    System.Diagnostics.Debug.Print("Left mouse button down event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Left mouse button down event '" + obElement.Name + "'");

}

void ThisProject_ElementRightButtonDblClk(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log    Right    Click    Event
    System.Diagnostics.Debug.Print("Double    Right    Click    on    " + lPosX + "    /    " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Double    Right    Click    on    " + obElement.Name);
}

void ThisProject_ElementLeftButtonDblClick(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log    Left    Click    event
    System.Diagnostics.Debug.Print("Double    Left    Click    on    " + lPosX + "    /    " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Double    Left    Click    on    " + obElement.Name);
}

void ThisProject_Inactive()
{
    //Event handler cleanup
    this.DynPictures().ElementLeftButtonDblClick -= ThisProject_ElementLeftButtonDblClick;
    this.DynPictures().ElementRightButtonDblClk -= ThisProject_ElementRightButtonDblClk;
    this.DynPictures().ElementLeftButtonDown -= ThisProject_ElementLeftButtonDown;
    this.DynPictures().ElementLeftButtonUp -= ThisProject_ElementLeftButtonUp;
    this.DynPictures().ElementRightButtonDown -= ThisProject_ElementRightButtonDown;
    this.DynPictures().ElementRightButtonUp -= ThisProject_ElementRightButtonUp;
    this.DynPictures().ElementMouseOver -= ThisProject_ElementMouseOver;
    FreeObjects();
}
VB.NET
Copy
'
'**In this example the mouse interaction events are triggered. Note that the obElement parameter is in fact nullable if
'**the cursor is not hovering an element during the click / move event and therefore has to be checked against null
'**In the example some values given by the function are written to the debug command line.
'

Private Sub ThisProject_Active()
    'Event handler initialization
    Me.DynPictures().ElementLeftButtonDblClick += New ElementLeftButtonDblClickEventHandler(AddressOf ThisProject_ElementLeftButtonDblClick)
    Me.DynPictures().ElementRightButtonDblClk += New ElementRightButtonDblClkEventHandler(AddressOf ThisProject_ElementRightButtonDblClk)
    Me.DynPictures().ElementLeftButtonDown += New ElementLeftButtonDownEventHandler(AddressOf ThisProject_ElementLeftButtonDown)
    Me.DynPictures().ElementLeftButtonUp += New ElementLeftButtonUpEventHandler(AddressOf ThisProject_ElementLeftButtonUp)
    Me.DynPictures().ElementRightButtonDown += New ElementRightButtonDownEventHandler(AddressOf ThisProject_ElementRightButtonDown)
    Me.DynPictures().ElementRightButtonUp += New ElementRightButtonUpEventHandler(AddressOf ThisProject_ElementRightButtonUp)
    Me.DynPictures().ElementMouseOver += New ElementMouseOverEventHandler(AddressOf ThisProject_ElementMouseOver)
End Sub

Private Sub ThisProject_ElementMouseOver(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse over event
    System.Diagnostics.Debug.Print("Mouse over event on " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Mouse over event on element '" + obElement.Name + "'")
    End If
End Sub

Private Sub ThisProject_ElementRightButtonUp(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button up event
    System.Diagnostics.Debug.Print("Right mouse button up event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Right mouse button up event '" + obElement.Name + "'")
    End If
End Sub

Private Sub ThisProject_ElementRightButtonDown(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button down event
    System.Diagnostics.Debug.Print("Right mouse button down event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Right mouse button down event '" + obElement.Name + "'")
    End If

End Sub

Private Sub ThisProject_ElementLeftButtonUp(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button up event
    System.Diagnostics.Debug.Print("Left mouse button up event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Left mouse button up event '" + obElement.Name + "'")
    End If

End Sub

Private Sub ThisProject_ElementLeftButtonDown(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button down event
    System.Diagnostics.Debug.Print("Left mouse button down event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Left mouse button down event '" + obElement.Name + "'")
    End If

End Sub

Private Sub ThisProject_ElementRightButtonDblClk(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Right Click Event
    System.Diagnostics.Debug.Print("Double Right Click on " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Double Right Click on " + obElement.Name)
    End If
End Sub

Private Sub ThisProject_ElementLeftButtonDblClick(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Left Click event
    System.Diagnostics.Debug.Print("Double Left Click on " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Double Left Click on " + obElement.Name)
    End If
End Sub

Private Sub ThisProject_Inactive()
    'Event handler cleanup
    RemoveHandler Me.DynPictures().ElementLeftButtonDblClick, AddressOf ThisProject_ElementLeftButtonDblClick
    RemoveHandler Me.DynPictures().ElementRightButtonDblClk, AddressOf ThisProject_ElementRightButtonDblClk
    RemoveHandler Me.DynPictures().ElementLeftButtonDown, AddressOf ThisProject_ElementLeftButtonDown
    RemoveHandler Me.DynPictures().ElementLeftButtonUp, AddressOf ThisProject_ElementLeftButtonUp
    RemoveHandler Me.DynPictures().ElementRightButtonDown, AddressOf ThisProject_ElementRightButtonDown
    RemoveHandler Me.DynPictures().ElementRightButtonUp, AddressOf ThisProject_ElementRightButtonUp
    RemoveHandler Me.DynPictures().ElementMouseOver, AddressOf ThisProject_ElementMouseOver
    FreeObjects()
End Sub


ElementRightButtonUp
ObjectModel COM [image] DynPictures [image] Events [image] ElementRightButtonUp
Remarks

Event is fired when the right mouse button is released on an element.(RT-Only)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obDynPicture as IDynPicture

obElement as IElement

lPosX as long

lPosY as long

lButton as long

Example
C#
Copy
/*
**In this example the mouse interaction events are triggered. Note that the obElement parameter is in fact nullable if
**the cursor is not hovering an element during the click / move event and therefore has to be checked against null
**In the example some values given by the function are written to the debug command line.*/

void ThisProject_Active()
{
    //Event handler initialization
    this.DynPictures().ElementLeftButtonDblClick += new ElementLeftButtonDblClickEventHandler(ThisProject_ElementLeftButtonDblClick);
    this.DynPictures().ElementRightButtonDblClk += new ElementRightButtonDblClkEventHandler(ThisProject_ElementRightButtonDblClk);
    this.DynPictures().ElementLeftButtonDown += new ElementLeftButtonDownEventHandler(ThisProject_ElementLeftButtonDown);
    this.DynPictures().ElementLeftButtonUp += new ElementLeftButtonUpEventHandler(ThisProject_ElementLeftButtonUp);
    this.DynPictures().ElementRightButtonDown += new ElementRightButtonDownEventHandler(ThisProject_ElementRightButtonDown);
    this.DynPictures().ElementRightButtonUp += new ElementRightButtonUpEventHandler(ThisProject_ElementRightButtonUp);
    this.DynPictures().ElementMouseOver += new ElementMouseOverEventHandler(ThisProject_ElementMouseOver);
}

void ThisProject_ElementMouseOver(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse over event
    System.Diagnostics.Debug.Print("Mouse over event on " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Mouse over event on element '" + obElement.Name + "'");
}

void ThisProject_ElementRightButtonUp(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button up event
    System.Diagnostics.Debug.Print("Right mouse button up event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Right mouse button up event '" + obElement.Name + "'");
}

void ThisProject_ElementRightButtonDown(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button down event
    System.Diagnostics.Debug.Print("Right mouse button down event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Right mouse button down event '" + obElement.Name + "'");

}

void ThisProject_ElementLeftButtonUp(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button up event
    System.Diagnostics.Debug.Print("Left mouse button up event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Left mouse button up event '" + obElement.Name + "'");

}

void ThisProject_ElementLeftButtonDown(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log Mouse button down event
    System.Diagnostics.Debug.Print("Left mouse button down event " + lPosX + " / " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Left mouse button down event '" + obElement.Name + "'");

}

void ThisProject_ElementRightButtonDblClk(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log    Right    Click    Event
    System.Diagnostics.Debug.Print("Double    Right    Click    on    " + lPosX + "    /    " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Double    Right    Click    on    " + obElement.Name);
}

void ThisProject_ElementLeftButtonDblClick(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)
{
    //Log    Left    Click    event
    System.Diagnostics.Debug.Print("Double    Left    Click    on    " + lPosX + "    /    " + lPosY);
    if (obElement != null)
        System.Diagnostics.Debug.Print("Double    Left    Click    on    " + obElement.Name);
}

void ThisProject_Inactive()
{
    //Event handler cleanup
    this.DynPictures().ElementLeftButtonDblClick -= ThisProject_ElementLeftButtonDblClick;
    this.DynPictures().ElementRightButtonDblClk -= ThisProject_ElementRightButtonDblClk;
    this.DynPictures().ElementLeftButtonDown -= ThisProject_ElementLeftButtonDown;
    this.DynPictures().ElementLeftButtonUp -= ThisProject_ElementLeftButtonUp;
    this.DynPictures().ElementRightButtonDown -= ThisProject_ElementRightButtonDown;
    this.DynPictures().ElementRightButtonUp -= ThisProject_ElementRightButtonUp;
    this.DynPictures().ElementMouseOver -= ThisProject_ElementMouseOver;
    FreeObjects();
}
VB.NET
Copy
'
'**In this example the mouse interaction events are triggered. Note that the obElement parameter is in fact nullable if
'**the cursor is not hovering an element during the click / move event and therefore has to be checked against null
'**In the example some values given by the function are written to the debug command line.
'

Private Sub ThisProject_Active()
    'Event handler initialization
    Me.DynPictures().ElementLeftButtonDblClick += New ElementLeftButtonDblClickEventHandler(AddressOf ThisProject_ElementLeftButtonDblClick)
    Me.DynPictures().ElementRightButtonDblClk += New ElementRightButtonDblClkEventHandler(AddressOf ThisProject_ElementRightButtonDblClk)
    Me.DynPictures().ElementLeftButtonDown += New ElementLeftButtonDownEventHandler(AddressOf ThisProject_ElementLeftButtonDown)
    Me.DynPictures().ElementLeftButtonUp += New ElementLeftButtonUpEventHandler(AddressOf ThisProject_ElementLeftButtonUp)
    Me.DynPictures().ElementRightButtonDown += New ElementRightButtonDownEventHandler(AddressOf ThisProject_ElementRightButtonDown)
    Me.DynPictures().ElementRightButtonUp += New ElementRightButtonUpEventHandler(AddressOf ThisProject_ElementRightButtonUp)
    Me.DynPictures().ElementMouseOver += New ElementMouseOverEventHandler(AddressOf ThisProject_ElementMouseOver)
End Sub

Private Sub ThisProject_ElementMouseOver(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse over event
    System.Diagnostics.Debug.Print("Mouse over event on " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Mouse over event on element '" + obElement.Name + "'")
    End If
End Sub

Private Sub ThisProject_ElementRightButtonUp(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button up event
    System.Diagnostics.Debug.Print("Right mouse button up event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Right mouse button up event '" + obElement.Name + "'")
    End If
End Sub

Private Sub ThisProject_ElementRightButtonDown(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button down event
    System.Diagnostics.Debug.Print("Right mouse button down event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Right mouse button down event '" + obElement.Name + "'")
    End If

End Sub

Private Sub ThisProject_ElementLeftButtonUp(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button up event
    System.Diagnostics.Debug.Print("Left mouse button up event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Left mouse button up event '" + obElement.Name + "'")
    End If

End Sub

Private Sub ThisProject_ElementLeftButtonDown(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Mouse button down event
    System.Diagnostics.Debug.Print("Left mouse button down event " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Left mouse button down event '" + obElement.Name + "'")
    End If

End Sub

Private Sub ThisProject_ElementRightButtonDblClk(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Right Click Event
    System.Diagnostics.Debug.Print("Double Right Click on " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Double Right Click on " + obElement.Name)
    End If
End Sub

Private Sub ThisProject_ElementLeftButtonDblClick(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)
    'Log Left Click event
    System.Diagnostics.Debug.Print("Double Left Click on " + lPosX + " / " + lPosY)
    If obElement IsNot Nothing Then
        System.Diagnostics.Debug.Print("Double Left Click on " + obElement.Name)
    End If
End Sub

Private Sub ThisProject_Inactive()
    'Event handler cleanup
    RemoveHandler Me.DynPictures().ElementLeftButtonDblClick, AddressOf ThisProject_ElementLeftButtonDblClick
    RemoveHandler Me.DynPictures().ElementRightButtonDblClk, AddressOf ThisProject_ElementRightButtonDblClk
    RemoveHandler Me.DynPictures().ElementLeftButtonDown, AddressOf ThisProject_ElementLeftButtonDown
    RemoveHandler Me.DynPictures().ElementLeftButtonUp, AddressOf ThisProject_ElementLeftButtonUp
    RemoveHandler Me.DynPictures().ElementRightButtonDown, AddressOf ThisProject_ElementRightButtonDown
    RemoveHandler Me.DynPictures().ElementRightButtonUp, AddressOf ThisProject_ElementRightButtonUp
    RemoveHandler Me.DynPictures().ElementMouseOver, AddressOf ThisProject_ElementMouseOver
    FreeObjects()
End Sub


NCPointerDown
ObjectModel COM [image] DynPictures [image] Events [image] NCPointerDown
Remarks

Posted when a pointer makes contact over the non-client area of a window. The message targets the window over which the pointer makes contact. The pointer is implicitly captured to the window so that the window continues to receive input for the pointer until it breaks contact. If a window has captured this pointer, this message is not posted. Instead, a NCPointerDown is posted to the window that has captured this pointer. If the application does not process this message, DefWindowProc may perform one or more system actions depending on the hit-test result included in the message. Typically, applications should not need to handle this message.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Unused
VSTA | Available
Parameters
obDynPicture as IDynPicture

vPointerId as VARIANT

lHitTestResult as long

lX as long

lY as long

Example
C#
Copy
void DynPics_NCPointerDown(zenOn.IDynPicture obDynPicture, int lPointerId, int lHitTestResult, int lX, int lY)
        {
 string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);
            CelString += string.Format("pointer-id: {0}, hit-test-result: {1}, [X,Y]: {2}, {3}", lPointerId, lHitTestResult, lX, lY);

            Cel().WriteCelString(CelString);
        }
VB.NET
Copy
Private Sub DynPics_NCPointerDown(obDynPicture As zenOn.IDynPicture, lPointerId As Integer, lHitTestResult As Integer, lX As Integer, lY As Integer)
    Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)
    CelString += String.Format("pointer-id: {0}, hit-test-result: {1}, [X,Y]: {2}, {3}", lPointerId, lHitTestResult, lX, lY)

    Cel().WriteCelString(CelString)
End Sub


NCPointerUp
ObjectModel COM [image] DynPictures [image] Events [image] NCPointerUp
Remarks

Posted when a pointer that made contact over the non-client area of a window breaks contact. The message targets the window over which the pointer makes contact and the pointer is, at that point, implicitly captured to the window so that the window continues to receive input for the pointer until it breaks contact, including the NCPointerUp notification. If a window has captured this pointer, this message is not posted. Instead, a NCPointerUp is posted to the window that has captured this pointer.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Unused
VSTA | Available
Parameters
obDynPicture as IDynPicture

vPointerId as VARIANT

lX as long

lY as long

Example
C#
Copy
void DynPics_NCPointerUp(zenOn.IDynPicture obDynPicture, int lPointerId, int lX, int lY)
        {
 string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);
            CelString += string.Format("pointer-id: {0}, [X,Y]: {1}, {2}", lPointerId, lX, lY);

            Cel().WriteCelString(CelString);
        }
VB.NET
Copy
Private Sub DynPics_NCPointerUp(obDynPicture As zenOn.IDynPicture, lPointerId As Integer, lX As Integer, lY As Integer)
    Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)
    CelString += String.Format("pointer-id: {0}, [X,Y]: {1}, {2}", lPointerId, lX, lY)

    Cel().WriteCelString(CelString)
End Sub


NCPointerUpdate
ObjectModel COM [image] DynPictures [image] Events [image] NCPointerUpdate
Remarks

Posted to provide an update on a pointer that made contact over the non-client area of a window or when a hovering uncaptured contact moves over the non-client area of a window. While the pointer is hovering, the message targets whichever window the pointer happens to be over. While the pointer is in contact with the surface, the pointer is implicitly captured to the window over which the pointer made contact and that window continues to receive input for the pointer until it breaks contact. If a window has captured this pointer, this message is not posted. Instead, a NCPointerUpdateis posted to the window that has captured this pointer.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Unused
VSTA | Available
Parameters
obDynPicture as IDynPicture

vPointerId as VARIANT

lHitTestResult as long

lX as long

lY as long

Example
C#
Copy
void DynPics_NCPointerUpdate(zenOn.IDynPicture obDynPicture, int lPointerId, int lHitTestResult, int lX, int lY)
        {
 string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);
            CelString += string.Format("pointer-id: {0}, hit-test-result: {1}, [X,Y]: {2}, {3}", lPointerId, lHitTestResult, lX, lY);

            Cel().WriteCelString(CelString);
        }
VB.NET
Copy
Private Sub DynPics_NCPointerUpdate(obDynPicture As zenOn.IDynPicture, lPointerId As Integer, lHitTestResult As Integer, lX As Integer, lY As Integer)
    Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)
    CelString += String.Format("pointer-id: {0}, hit-test-result: {1}, [X,Y]: {2}, {3}", lPointerId, lHitTestResult, lX, lY)

    Cel().WriteCelString(CelString)
End Sub


Open
ObjectModel COM [image] DynPictures [image] Events [image] Open
Remarks

Event is fired when a screen is opened.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obDynPicture as IDynPicture

Example
C#
Copy
void ThisProject_Active()
{
    this.DynPictures().Open += new DDynPicturesEvents_OpenEventHandler(ThisProject_Open);
    this.DynPictures().Close += new DDynPicturesEvents_CloseEventHandler(ThisProject_Close);
}

void ThisProject_Close(IDynPicture obDynPicture)
{
    //Logs the Close event on the CEL; Once a screen is closed it will be written
    //to the chronological Event List
    this.Cel().WriteCelString(obDynPicture.Name + " was closed");
}

void ThisProject_Open(IDynPicture obDynPicture)
{
    //Logs the Open event on the CEL; Once a screen is open it will be written
    //to the chronological Event List
    this.Cel().WriteCelString(obDynPicture.Name + " was opened");
}

void ThisProject_Inactive()
{
    this.DynPictures().Open -= new DDynPicturesEvents_OpenEventHandler(ThisProject_Open);
    this.DynPictures().Close -= new DDynPicturesEvents_CloseEventHandler(ThisProject_Close);
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    Me.DynPictures().Open += New DDynPicturesEvents_OpenEventHandler(ThisProject_Open)
    Me.DynPictures().Close += New DDynPicturesEvents_CloseEventHandler(ThisProject_Close)
End Sub

Private Sub ThisProject_Close(obDynPicture As IDynPicture)
    'Logs the Close event on the CEL; Once a screen is closed it will be written
    'to the chronological Event List
    Me.Cel().WriteCelString(obDynPicture.Name + " was closed")
End Sub

Private Sub ThisProject_Open(obDynPicture As IDynPicture)
    'Logs the Open event on the CEL; Once a screen is open it will be written
    'to the chronological Event List
    Me.Cel().WriteCelString(obDynPicture.Name + " was opened")
End Sub

Private Sub ThisProject_Inactive()
    Me.DynPictures().Open -= New DDynPicturesEvents_OpenEventHandler(ThisProject_Open)
    Me.DynPictures().Close -= New DDynPicturesEvents_CloseEventHandler(ThisProject_Close)
    FreeObjects()
End Sub


PictureGesture
ObjectModel COM [image] DynPictures [image] Events [image] PictureGesture
Remarks

Defines the output of the Interaction Context object. See also: INTERACTION_CONTEXT_OUTPUTinteraction_context_output (msdn)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Unused
VSTA | Available
Parameters
obDynPicture as IDynPicture

interactionContextOutput as VARIANT

Example
C#
Copy
/// <summary>
        /// event handler for the PictureGesture event
        /// </summary>
        /// <param name="obDynPicture">screen on which the event occured</param>
        /// <param name="interactionContextOutput">object that contains the information about the gesture</param>
 void DynPics_PictureGesture(zenOn.IDynPicture obDynPicture, object interactionContextOutput)
        {
            CELMakeSeperator();
 string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);
            Cel().WriteCelString(CelString);

            WriteInteractionContextOutputToCEL(interactionContextOutput);
        }
VB.NET
Copy
/// <summary>
        /// event handler for the PictureGesture event
        /// </summary>
        /// <param name="obDynPicture">screen on which the event occured</param>
        /// <param name="interactionContextOutput">object that contains the information about the gesture</param>
Private Sub DynPics_PictureGesture(obDynPicture As zenOn.IDynPicture, interactionContextOutput As Object)
    CELMakeSeperator()
    Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)
    Cel().WriteCelString(CelString)

    WriteInteractionContextOutputToCEL(interactionContextOutput)
End Sub


PointerActivate
ObjectModel COM [image] DynPictures [image] Events [image] PointerActivate
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Unused
VSTA | Available
Parameters
obDynPicture as IDynPicture

hWnd as OLE_HANDLE

lHitTestResult as long

vPointerId as VARIANT


PointerCaptureChanged
ObjectModel COM [image] DynPictures [image] Events [image] PointerCaptureChanged
Remarks

Sent to a window that is losing capture of an input pointer. A window should use this notification to stop processing subsequent messages and initiate any cleanup required for the pointer being lost. Processing of gestures associated with the pointer should also be terminated and remaining contacts re-associated with the window.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Unused
VSTA | Available
Parameters
obDynPicture as IDynPicture

vPointerId as VARIANT

hWnd as OLE_HANDLE

Example
C#
Copy
void DynPics_PointerCaptureChanged(zenOn.IDynPicture obDynPicture, object vPointerId, int hWnd)
        {
 string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);
            CelString += string.Format("pointer-id: {0}", Convert.ToString(vPointerId));

            Cel().WriteCelString(CelString);
        }
VB.NET
Copy
Private Sub DynPics_PointerCaptureChanged(obDynPicture As zenOn.IDynPicture, vPointerId As Object, hWnd As Integer)
    Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)
    CelString += String.Format("pointer-id: {0}", Convert.ToString(vPointerId))

    Cel().WriteCelString(CelString)
End Sub


PointerDown
ObjectModel COM [image] DynPictures [image] Events [image] PointerDown
Remarks

Posted when a pointer makes contact over the client area of a window. This input message targets the window over which the pointer makes contact, and the pointer is implicitly captured to the window so that the window continues to receive input for the pointer until it breaks contact.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Unused
VSTA | Available
Parameters
obDynPicture as IDynPicture

obElement as IElement

vPointerId as VARIANT

bNew as VARIANT_BOOL

bInRange as VARIANT_BOOL

bInContact as VARIANT_BOOL

bPrimary as VARIANT_BOOL

bFirstButton as VARIANT_BOOL

bSecondButton as VARIANT_BOOL

bThirdButton as VARIANT_BOOL

bFourthButton as VARIANT_BOOL

bFifthButton as VARIANT_BOOL

lX as long

lY as long

Example
C#
Copy
void DynPics_PointerDown(zenOn.IDynPicture obDynPicture, zenOn.IElement obElement, object vPointerId, bool bNew, bool bInRange, bool bInContact, bool bPrimary, bool bFirstButton, bool bSecondButton, bool bThirdButton, bool bFourthButton, bool bFifthButton, int lX, int lY)
        {
 string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);

 string ButtonMatrix = "";
            ButtonMatrix += (bFirstButton == true) ? "[1]" : "[x]";
            ButtonMatrix += (bSecondButton == true) ? "[2]" : "[x]";
            ButtonMatrix += (bThirdButton == true) ? "[3]" : "[x]";
            ButtonMatrix += (bFourthButton == true) ? "[4]" : "[x]";
            ButtonMatrix += (bFifthButton == true) ? "[5]" : "[x]";

            CelString += string.Format("pointer-id: {0}, is-new: {1}, is-in-range: {2}, is-in-contact: {3}, is-primary: {4}, buttons: {5}, [X, Y]: {6},{7}", Convert.ToString(vPointerId), bNew, bInRange, bInContact, bPrimary, ButtonMatrix, lX, lY);
            Cel().WriteCelString(CelString);
        }
VB.NET
Copy
Private Sub DynPics_PointerDown(obDynPicture As zenOn.IDynPicture, obElement As zenOn.IElement, vPointerId As Object, bNew As Boolean, bInRange As Boolean, bInContact As Boolean, _
    bPrimary As Boolean, bFirstButton As Boolean, bSecondButton As Boolean, bThirdButton As Boolean, bFourthButton As Boolean, bFifthButton As Boolean, _
    lX As Integer, lY As Integer)
    Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)

    Dim ButtonMatrix As String = ""
    ButtonMatrix += If((bFirstButton = True), "[1]", "[x]")
    ButtonMatrix += If((bSecondButton = True), "[2]", "[x]")
    ButtonMatrix += If((bThirdButton = True), "[3]", "[x]")
    ButtonMatrix += If((bFourthButton = True), "[4]", "[x]")
    ButtonMatrix += If((bFifthButton = True), "[5]", "[x]")

    CelString += String.Format("pointer-id: {0}, is-new: {1}, is-in-range: {2}, is-in-contact: {3}, is-primary: {4}, buttons: {5}, [X, Y]: {6},{7}", Convert.ToString(vPointerId), bNew, bInRange, bInContact, bPrimary, _
        ButtonMatrix, lX, lY)
    Cel().WriteCelString(CelString)
End Sub


PointerEnter
ObjectModel COM [image] DynPictures [image] Events [image] PointerEnter
Remarks

Sent to a window when a new pointer enters detection range over the window (hover) or when an existing pointer moves within the boundaries of the window. The PointerEnter notification can be used by a window to provide feedback to the user while the pointer is over its surface or to otherwise react to the presence of a pointer over its surface.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Unused
VSTA | Available
Parameters
obDynPicture as IDynPicture

obElement as IElement

vPointerId as VARIANT

bNew as VARIANT_BOOL

bInRange as VARIANT_BOOL

bInContact as VARIANT_BOOL

Example
C#
Copy
void DynPics_PointerEnter(zenOn.IDynPicture obDynPicture, zenOn.IElement obElement, object vPointerId, bool bNew, bool bInRange, bool bInContact)
        {
 string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);
 if (obElement != null)
            {
                CelString += string.Format("on element {0}, ", obElement.Name);
            }
            CelString += string.Format("pointer-id: {0}, is-new: {1}, is-in-range: {2}, is-in-contact: {3}", Convert.ToString(vPointerId), bNew, bInRange, bInContact);

            Cel().WriteCelString(CelString);
        }
VB.NET
Copy
Private Sub DynPics_PointerEnter(obDynPicture As zenOn.IDynPicture, obElement As zenOn.IElement, vPointerId As Object, bNew As Boolean, bInRange As Boolean, bInContact As Boolean)
    Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)
    If obElement IsNot Nothing Then
        CelString += String.Format("on element {0}, ", obElement.Name)
    End If
    CelString += String.Format("pointer-id: {0}, is-new: {1}, is-in-range: {2}, is-in-contact: {3}", Convert.ToString(vPointerId), bNew, bInRange, bInContact)

    Cel().WriteCelString(CelString)
End Sub


PointerHWheel
ObjectModel COM [image] DynPictures [image] Events [image] PointerHWheel
Remarks

Posted to the window with foreground keyboard focus when a horizontal scroll wheel is rotated. To retrieve the wheel scroll units, use the inputData filed of the POINTER_INFO structure returned by calling GetPointerInfo function. This field contains a signed value and is expressed in a multiple of WHEEL_DELTA. A positive value indicates a rotation forward and a negative value indicates a rotation backward. Note that the wheel inputs may be delivered even if the mouse cursor is located outside of application’s window. The wheel messages are delivered in a way very similar to the keyboard inputs. The focus window of the foregournd message queue receives the wheel messages.POINTER_INFO structure://Helper array that stores the definition of the POINTER_INFO so we can have a look at it more nicely in the CELstring[] Pointer_Info_Definition = {"PointerType","PointerID", "FrameID","PointerFlags","SourceDevice","hwndTarget","PixelLocation","HimetricLocation","PixelLocationRaw","HimetricLocationRaw","Time","historyCount","inputData","KeyStates","PerformanceCount","ButtonChangeType" };

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Unused
VSTA | Available
Parameters
obDynPicture as IDynPicture

obElement as IElement

vPointerId as VARIANT

lWheelDelta as long

lX as long

lY as long

Example
C#
Copy
void DynPics_PointerHWheel(zenOn.IDynPicture obDynPicture, zenOn.IElement obElement, object vPointerId, int lWheelDelta, int lX, int lY)
        {
 string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);
            CelString += string.Format("pointer-id: {0}, wheel-delta: {1}, [X,Y]; {2}, {3}", Convert.ToString(vPointerId), lWheelDelta, lX, lY);

            Cel().WriteCelString(CelString);
        }
VB.NET
Copy
Private Sub DynPics_PointerHWheel(obDynPicture As zenOn.IDynPicture, obElement As zenOn.IElement, vPointerId As Object, lWheelDelta As Integer, lX As Integer, lY As Integer)
    Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)
    CelString += String.Format("pointer-id: {0}, wheel-delta: {1}, [X,Y]; {2}, {3}", Convert.ToString(vPointerId), lWheelDelta, lX, lY)

    Cel().WriteCelString(CelString)
End Sub


PointerLeave
ObjectModel COM [image] DynPictures [image] Events [image] PointerLeave
Remarks

Sent to a window when a pointer leaves detection range over the window (hover) or when a pointer moves outside the boundaries of the window. The PointerLeave notification can be used by a window to change mode or stop any feedback to the user while the pointer is over the window surface.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Unused
VSTA | Available
Parameters
obDynPicture as IDynPicture

obElement as IElement

vPointerId as VARIANT

bInRange as VARIANT_BOOL

bInContact as VARIANT_BOOL

Example
C#
Copy
void DynPics_PointerLeave(zenOn.IDynPicture obDynPicture, zenOn.IElement obElement, object vPointerId, bool bInRange, bool bInContact)
        {
 string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);
            CelString += string.Format("pointer-id: {0}, is-in-range: {1}, is-in-contact: {2}", Convert.ToString(vPointerId), bInRange, bInContact);

            Cel().WriteCelString(CelString);
        }
VB.NET
Copy
Private Sub DynPics_PointerLeave(obDynPicture As zenOn.IDynPicture, obElement As zenOn.IElement, vPointerId As Object, bInRange As Boolean, bInContact As Boolean)
    Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)
    CelString += String.Format("pointer-id: {0}, is-in-range: {1}, is-in-contact: {2}", Convert.ToString(vPointerId), bInRange, bInContact)

    Cel().WriteCelString(CelString)
End Sub


PointerUp
ObjectModel COM [image] DynPictures [image] Events [image] PointerUp
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Unused
VSTA | Available
Parameters
obDynPicture as IDynPicture

obElement as IElement

vPointerId as VARIANT

bIsCanceled as VARIANT_BOOL

bInRange as VARIANT_BOOL

bInContact as VARIANT_BOOL

bPrimary as VARIANT_BOOL

bFirstButton as VARIANT_BOOL

bSecondButton as VARIANT_BOOL

bThirdButton as VARIANT_BOOL

bFourthButton as VARIANT_BOOL

bFifthButton as VARIANT_BOOL

lX as long

lY as long


PointerUpdate
ObjectModel COM [image] DynPictures [image] Events [image] PointerUpdate
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Unused
VSTA | Available
Parameters
obDynPicture as IDynPicture

obElement as IElement

vPointerId as VARIANT

bNew as VARIANT_BOOL

bInRange as VARIANT_BOOL

bInContact as VARIANT_BOOL

bPrimary as VARIANT_BOOL

bFirstButton as VARIANT_BOOL

bSecondButton as VARIANT_BOOL

bThirdButton as VARIANT_BOOL

bFourthButton as VARIANT_BOOL

bFifthButton as VARIANT_BOOL

lX as long

lY as long


PointerWheel
ObjectModel COM [image] DynPictures [image] Events [image] PointerWheel
Remarks

Posted to the window with foreground keyboard focus when a horizontal scroll wheel is rotated. To retrieve the wheel scroll units, use the inputData filed of the POINTER_INFO structure returned by calling GetPointerInfo function. This field contains a signed value and is expressed in a multiple of WHEEL_DELTA. A positive value indicates a rotation forward and a negative value indicates a rotation backward. Note that the wheel inputs may be delivered even if the mouse cursor is located outside of application’s window. The wheel messages are delivered in a way very similar to the keyboard inputs. The focus window of the foregournd message queue receives the wheel messages.POINTER_INFO structure://Helper array that stores the definition of the POINTER_INFO so we can have a look at it more nicely in the CELstring[] Pointer_Info_Definition = {"PointerType","PointerID", "FrameID","PointerFlags","SourceDevice","hwndTarget","PixelLocation","HimetricLocation","PixelLocationRaw","HimetricLocationRaw","Time","historyCount","inputData","KeyStates","PerformanceCount","ButtonChangeType" };

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Unused
VSTA | Available
Parameters
obDynPicture as IDynPicture

obElement as IElement

vPointerId as VARIANT

lWheelDelta as long

lX as long

lY as long

Example
C#
Copy
void DynPics_PointerWheel(zenOn.IDynPicture obDynPicture, zenOn.IElement obElement, object vPointerId, int lWheelDelta, int lX, int lY)
        {
 string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);
            CelString += string.Format("pointer-id: {0}, wheel-delta: {1}, [X,Y]; {2}, {3}", Convert.ToString(vPointerId), lWheelDelta, lX, lY);

            Cel().WriteCelString(CelString);
        }
VB.NET
Copy
Private Sub DynPics_PointerWheel(obDynPicture As zenOn.IDynPicture, obElement As zenOn.IElement, vPointerId As Object, lWheelDelta As Integer, lX As Integer, lY As Integer)
                Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)
                CelString += String.Format("pointer-id: {0}, wheel-delta: {1}, [X,Y]; {2}, {3}", Convert.ToString(vPointerId), lWheelDelta, lX, lY)

                Cel().WriteCelString(CelString)
        End Sub


TouchEvent
ObjectModel COM [image] DynPictures [image] Events [image] TouchEvent
Remarks

Event is fired for all touch events.(RT-Only)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
pvX as SAFEARRAY(long)

pvY as SAFEARRAY(long)

pvSource as SAFEARRAY(OLE_HANDLE)

PvID as SAFEARRAY(long)

pvFlags as SAFEARRAY(long)

pvMask as SAFEARRAY(long)

pvTime as SAFEARRAY(long)

pvExtraInfo as SAFEARRAY(long)

pvXContact as SAFEARRAY(long)

pvYContact as SAFEARRAY(long)


TouchManipulationCompleteEvent
ObjectModel COM [image] DynPictures [image] Events [image] TouchManipulationCompleteEvent
Remarks

This event is triggered when ending an action. The parameter indicate the changes since the start of the action. If the idle processor is active, the event is triggered two times.When the action ends (bInertia = FALSE), the parameter indicate the changes since the start of the action. After the idle calculation (bInertia = TRUE), the parameter indicate the changes since the start of the idle calculation. (since the end of the action)lX: X-Koordinate in PixellY: Y-Koordinate in PixellTransX: Translation X-Achse in PixellTransY: Translation Y-Ache in PixelfScaleFactor: Skalierungsfaktor (1=100%)fRotation: Rotation in RadiantenbInertia: Gibt an ob der Event durch den Trägheitsprozessor oder die Geste selbst verursacht wurde

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lX as long

lY as long

lTransX as long

lTransY as long

fScaleFactor as FLOAT

fRotation as FLOAT

lContacts as long

Example
VBA
Copy
If Not obDynPictures.SetupTouchInertia(0, 0, 0) Then
    Debug.Print "Error setting up inertia"
    End If
Private Sub obDynPictures_TouchManipulationStartEvent(ByVal lX As Long, ByVal lY As Long)
End Sub

Private Sub obDynPictures_TouchManipulationDeltaEvent(ByVal lX As Long, ByVal lY As Long, ByVal lTransX As Long, ByVal lTransY As Long, ByVal fScaleFactor As Single, ByVal fRotation As Single, ByVal bInertia As Boolean)
End Sub

Private Sub obDynPictures_TouchManipulationCompleteEvent(ByVal lX As Long, ByVal lY As Long, ByVal lTransX As Long, ByVal lTransY As Long, ByVal fScaleFactor As Single, ByVal fRotation As Single, ByVal bInertia As Boolean)
 End Sub


TouchManipulationDeltaEvent
ObjectModel COM [image] DynPictures [image] Events [image] TouchManipulationDeltaEvent
Remarks

This event is triggered regularly when executing an action. The parameter indicate the changes since the last delta event and/or the start event. lX: X-Koordinate in PixellY: Y-Koordinate in PixellTransX: Translation X-Achse in PixellTransY: Translation Y-Ache in PixelfScaleFactor: Skalierungsfaktor (1=100%)fRotation: Rotation in RadiantenbInertia: Gibt an ob der Event durch den Trägheitsprozessor oder die Geste selbst verursacht wurde

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lX as long

lY as long

lTransX as long

lTransY as long

fScaleFactor as FLOAT

fRotation as FLOAT

lContacts as long

Example
VBA
Copy
If Not obDynPictures.SetupTouchInertia(0, 0, 0) Then
    Debug.Print "Error setting up inertia"
    End If
Private Sub obDynPictures_TouchManipulationStartEvent(ByVal lX As Long, ByVal lY As Long)
End Sub
Private Sub obDynPictures_TouchManipulationDeltaEvent(ByVal lX As Long, ByVal lY As Long, ByVal lTransX As Long, ByVal lTransY As Long, ByVal fScaleFactor As Single, ByVal fRotation As Single, ByVal bInertia As Boolean)
End Sub

Private Sub obDynPictures_TouchManipulationCompleteEvent(ByVal lX As Long, ByVal lY As Long, ByVal lTransX As Long, ByVal lTransY As Long, ByVal fScaleFactor As Single, ByVal fRotation As Single, ByVal bInertia As Boolean)
 End Sub


TouchManipulationStartEvent
ObjectModel COM [image] DynPictures [image] Events [image] TouchManipulationStartEvent
Remarks

Event is fired when a touch manipulation starts.(RT-Only)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lX as long

lY as long


WindowPosChanged
ObjectModel COM [image] DynPictures [image] Events [image] WindowPosChanged
Remarks

Event is fired when a screen is moved or resized.(RT-Only)

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obDynPicture as IDynPicture


EdLimit
ObjectModel COM [image] EdLimit
Remarks

The object EDLimit is only availaible within the zenOn Editor and is not usable during Runtime. It represents the limits from the variables as well as from the datatypes.

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroEdLimit()
{
    IVariable zenonVariable = this.ActiveDocument.Variables().Item("WIZ_VAR_10");

    //Get the EdLimit of a given variable...
    IEdLimit zenonEdLimit = zenonVariable.EdLimitItem(0);
    //... and print some of its properties
    System.Diagnostics.Debug.Print("Active: " + zenonEdLimit.Active.ToString());
    System.Diagnostics.Debug.Print("Alarm: " + zenonEdLimit.Alarm.ToString());
    System.Diagnostics.Debug.Print("AlarmAck: " + zenonEdLimit.AlarmAck.ToString());
    System.Diagnostics.Debug.Print("AlarmDelete: " + zenonEdLimit.AlarmDelete.ToString());
    System.Diagnostics.Debug.Print("Blinking: " + zenonEdLimit.Cel.ToString());
    System.Diagnostics.Debug.Print("Cel: " + zenonEdLimit.Active.ToString());
    System.Diagnostics.Debug.Print("Color: " + zenonEdLimit.Color.ToString("X6"));
    System.Diagnostics.Debug.Print("Delay: " + zenonEdLimit.Delay.ToString());
    System.Diagnostics.Debug.Print("Group: " + zenonEdLimit.Group.ToString());
    System.Diagnostics.Debug.Print("HelpCapture: " + zenonEdLimit.HelpCapture.ToString());
    System.Diagnostics.Debug.Print("HelpFile: " + zenonEdLimit.HelpFile.ToString());
    System.Diagnostics.Debug.Print("Invisible: " + zenonEdLimit.Invisible.ToString());
    System.Diagnostics.Debug.Print("IsMax: " + zenonEdLimit.IsMax.ToString());
    System.Diagnostics.Debug.Print("IsSimple: " + zenonEdLimit.IsSimple.ToString());
    System.Diagnostics.Debug.Print("IsVariable: " + zenonEdLimit.IsVariable.ToString());
    System.Diagnostics.Debug.Print("LimitValue: " + zenonEdLimit.LimitValue.ToString());
    System.Diagnostics.Debug.Print("ParentID: " + zenonEdLimit.ParentID.ToString());
    System.Diagnostics.Debug.Print("Print: " + zenonEdLimit.Print.ToString());
    System.Diagnostics.Debug.Print("Text: " + zenonEdLimit.Text.ToString());
    System.Diagnostics.Debug.Print("ThreshholdValue: " + zenonEdLimit.ThresholdValue.ToString());

    //Read the dynproperties of the EdLimit object
    var dynProperties = zenonEdLimit.get_DynPropertiesEnum("");
    string[] castProperties = (string[])dynProperties;
    foreach (string item in castProperties)
    {
        System.Diagnostics.Debug.Print("-----------------");
        string propName = item.Substring(0, item.IndexOf(',', 0));
        System.Diagnostics.Debug.Print(propName);
        var obj = zenonEdLimit.get_DynProperties(propName);
        if (obj != null)
        {
            System.Diagnostics.Debug.Print("Value: " + obj.ToString());
        }
        else
        {
            System.Diagnostics.Debug.Print("Value: Null");
        }

    }
}
VB.NET
Copy
Public Sub MacroEdLimit()
    Dim zenonVariable As IVariable = Me.ActiveDocument.Variables().Item("WIZ_VAR_10")

    'Get the EdLimit of a given variable...
    Dim zenonEdLimit As IEdLimit = zenonVariable.EdLimitItem(0)
    '... and print some of its properties
    System.Diagnostics.Debug.Print("Active: " + zenonEdLimit.Active.ToString())
    System.Diagnostics.Debug.Print("Alarm: " + zenonEdLimit.Alarm.ToString())
    System.Diagnostics.Debug.Print("AlarmAck: " + zenonEdLimit.AlarmAck.ToString())
    System.Diagnostics.Debug.Print("AlarmDelete: " + zenonEdLimit.AlarmDelete.ToString())
    System.Diagnostics.Debug.Print("Blinking: " + zenonEdLimit.Cel.ToString())
    System.Diagnostics.Debug.Print("Cel: " + zenonEdLimit.Active.ToString())
    System.Diagnostics.Debug.Print("Color: " + zenonEdLimit.Color.ToString("X6"))
    System.Diagnostics.Debug.Print("Delay: " + zenonEdLimit.Delay.ToString())
    System.Diagnostics.Debug.Print("Group: " + zenonEdLimit.Group.ToString())
    System.Diagnostics.Debug.Print("HelpCapture: " + zenonEdLimit.HelpCapture.ToString())
    System.Diagnostics.Debug.Print("HelpFile: " + zenonEdLimit.HelpFile.ToString())
    System.Diagnostics.Debug.Print("Invisible: " + zenonEdLimit.Invisible.ToString())
    System.Diagnostics.Debug.Print("IsMax: " + zenonEdLimit.IsMax.ToString())
    System.Diagnostics.Debug.Print("IsSimple: " + zenonEdLimit.IsSimple.ToString())
    System.Diagnostics.Debug.Print("IsVariable: " + zenonEdLimit.IsVariable.ToString())
    System.Diagnostics.Debug.Print("LimitValue: " + zenonEdLimit.LimitValue.ToString())
    System.Diagnostics.Debug.Print("ParentID: " + zenonEdLimit.ParentID.ToString())
    System.Diagnostics.Debug.Print("Print: " + zenonEdLimit.Print.ToString())
    System.Diagnostics.Debug.Print("Text: " + zenonEdLimit.Text.ToString())
    System.Diagnostics.Debug.Print("ThreshholdValue: " + zenonEdLimit.ThresholdValue.ToString())

    'Read the dynproperties of the EdLimit object
    Dim dynProperties = zenonEdLimit.get_DynPropertiesEnum("")
    Dim castProperties As String() = DirectCast(dynProperties, String())
    For Each item As String In castProperties
        System.Diagnostics.Debug.Print("-----------------")
        Dim propName As String = item.Substring(0, item.IndexOf(","C, 0))
        System.Diagnostics.Debug.Print(propName)
        Dim obj = zenonEdLimit.get_DynProperties(propName)
        If obj IsNot Nothing Then
            System.Diagnostics.Debug.Print("Value: " + obj.ToString())
        Else
            System.Diagnostics.Debug.Print("Value: Null")

        End If
    Next
End Sub
VBA
Copy
Public Sub test_EDLimit()
Dim zEDLimit As EdLimit
Dim zVAR As Variable
Dim vDynProps As Variant
Dim strDynProp As String
'FROM DataType
'Set zEDLimit =

Myworkspace.ActiveDocument.VarTypes.Item("UINT").EdLimitItem(0)
'FROM Variable
Set zVAR = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_10")
Set zEDLimit = zVAR.EdLimitItem(0)
'READ SETTINGS of EDLimit for Variable and Datatype
Debug.Print "Active : " & zEDLimit.Active
Debug.Print "Alarm : " & zEDLimit.Alarm
Debug.Print "AlarmAck : " & zEDLimit.AlarmAck
Debug.Print "AlarmDelete : " & zEDLimit.AlarmDelete
Debug.Print "Blinking : " & zEDLimit.Blinking
Debug.Print "Cel : " & zEDLimit.Cel
Debug.Print "Class : " & zEDLimit.Class
Debug.Print "Color : " & zEDLimit.color
Debug.Print "Delay : " & zEDLimit.Delay
Debug.Print "Group : " & zEDLimit.Group
Debug.Print "HelpCapture : " & zEDLimit.HelpCapture
Debug.Print "HelpFile : " & zEDLimit.HelpFile
Debug.Print "Invisible : " & zEDLimit.Invisible
Debug.Print "IsMax : " & zEDLimit.IsMax
Debug.Print "IsSimple : " & zEDLimit.IsSimple
Debug.Print "IsVariable : " & zEDLimit.IsVariable
Debug.Print "LimitValue : " & zEDLimit.LimitValue
Debug.Print "ParentID : " & zEDLimit.ParentID
Debug.Print "Print : " & zEDLimit.Print
Debug.Print "Text : " & zEDLimit.Text
Debug.Print "ThresholdValue: " & zEDLimit.ThresholdValue
'READ DYNPROPERTIES of EDLimit for Variable and Datatype
vDynProps = zEDLimit.DynPropertiesEnum("")
For Each strItem In vDynProps
strDynProp = Mid(strItem, 1, InStr(1, strItem, ",") - 1)
Debug.Print "--------------------"
Debug.Print strItem
Debug.Print zEDLimit.DynProperties(strDynProp)
Next

End Sub


Properties
ObjectModel COM [image] EdLimit [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Active | variant_bool | Limit in/-active | Available | Unused | Available | Available
Alarm | variant_bool | Should the Limit raise an Alarm. | Available | Unused | Available | Available
AlarmAck | variant_bool | The Alarm has to be acknowledged by the user whe n this flag is set to true. | Available | Unused | Available | Available
AlarmCause | variant_bool |  | Available | Unused | Available | Available
AlarmComment | variant_bool |  | Available | Unused | Available | Available
AlarmDelete | variant_bool | The Alarm has to be deleted by the user when this flag is set to true. | Available | Unused | Available | Available
Blinking | variant_bool | Blinking will be enabled if this flag is set to true. | Available | Unused | Available | Available
Cel | variant_bool | Write into CEL. | Available | Unused | Available | Available
Class | short | Class of this Limit. | Available | Unused | Available | Available
Color | long | Color of this Limit. | Available | Unused | Available | Available
Delay | long | Delay of this Limit in seconds. | Available | Unused | Available | Available
Group | short | Group number of this Limit. | Available | Unused | Available | Available
HelpCapture | bstr | Represents the HelpCapture if you use the embedded help features of zenOn. | Available | Unused | Available | Available
HelpFile | bstr | Represents the HelpFile if you use the embedded help features of zenOn. | Available | Unused | Available | Available
Invisible | variant_bool | Invisible Flag can be used with the 'Status' element for example. | Available | Unused | Available | Available
IsMax | variant_bool | MIN or MAXLimit will be reached on underrun the limit or on overflow the setting. | Available | Unused | Available | Available
IsSimple | variant_bool | This method returns -1 when the datatype is a simple datatype and 0 when it is a complex datatype. | Available | Unused | Available | Available
IsVariable | variant_bool | The limit value is not defined through a fixed technical assignment of value, but through the technical value of another variable.A 'Variable' has to be linked also with this limit. | Available | Unused | Available | Available
LimitValue | double | Value when the Limit is reached. | Available | Unused | Available | Available
Parent | idispatch | Parent-object | Readonly | Readonly | Available | Available
ParentID | long | ID of the variable | Available | Unused | Available | Available
Print | variant_bool | Alarm or limit violation (with set option "in CEL") is printed online. | Available | Unused | Available | Available
Text | bstr | Text of the limit as it is displayed in lists, in the status line, and in dynamic elements on a limit violation. | Available | Unused | Available | Available
ThresholdValue | double | Is used for the releasing of the limit violation. | Available | Unused | Available | Available
Variable | ivariable | Variable as object, which should be used as dynamic limit value.Only available, if the dynamic limit is active! | Available | Unused | Available | Available


Active
ObjectModel COM [image] EdLimit [image] Properties [image] Active
Remarks

Limit in/-active

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Alarm
ObjectModel COM [image] EdLimit [image] Properties [image] Alarm
Remarks

Should the Limit raise an Alarm.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


AlarmAck
ObjectModel COM [image] EdLimit [image] Properties [image] AlarmAck
Remarks

The Alarm has to be acknowledged by the user whe n this flag is set to true.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


AlarmCause
ObjectModel COM [image] EdLimit [image] Properties [image] AlarmCause
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


AlarmComment
ObjectModel COM [image] EdLimit [image] Properties [image] AlarmComment
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


AlarmDelete
ObjectModel COM [image] EdLimit [image] Properties [image] AlarmDelete
Remarks

The Alarm has to be deleted by the user when this flag is set to true.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Blinking
ObjectModel COM [image] EdLimit [image] Properties [image] Blinking
Remarks

Blinking will be enabled if this flag is set to true.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Cel
ObjectModel COM [image] EdLimit [image] Properties [image] Cel
Remarks

Write into CEL.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Class
ObjectModel COM [image] EdLimit [image] Properties [image] Class
Remarks

Class of this Limit.

Datatype
short

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Color
ObjectModel COM [image] EdLimit [image] Properties [image] Color
Remarks

Color of this Limit.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Delay
ObjectModel COM [image] EdLimit [image] Properties [image] Delay
Remarks

Delay of this Limit in seconds.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Group
ObjectModel COM [image] EdLimit [image] Properties [image] Group
Remarks

Group number of this Limit.

Datatype
short

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


HelpCapture
ObjectModel COM [image] EdLimit [image] Properties [image] HelpCapture
Remarks

Represents the HelpCapture if you use the embedded help features of zenOn.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


HelpFile
ObjectModel COM [image] EdLimit [image] Properties [image] HelpFile
Remarks

Represents the HelpFile if you use the embedded help features of zenOn.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Invisible
ObjectModel COM [image] EdLimit [image] Properties [image] Invisible
Remarks

Invisible Flag can be used with the 'Status' element for example.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IsMax
ObjectModel COM [image] EdLimit [image] Properties [image] IsMax
Remarks

MIN or MAXLimit will be reached on underrun the limit or on overflow the setting.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IsSimple
ObjectModel COM [image] EdLimit [image] Properties [image] IsSimple
Remarks

This method returns -1 when the datatype is a simple datatype and 0 when it is a complex datatype.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IsVariable
ObjectModel COM [image] EdLimit [image] Properties [image] IsVariable
Remarks

The limit value is not defined through a fixed technical assignment of value, but through the technical value of another variable.A 'Variable' has to be linked also with this limit.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


LimitValue
ObjectModel COM [image] EdLimit [image] Properties [image] LimitValue
Remarks

Value when the Limit is reached.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] EdLimit [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IDispatch

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ParentID
ObjectModel COM [image] EdLimit [image] Properties [image] ParentID
Remarks

ID of the variable or datatype

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Print
ObjectModel COM [image] EdLimit [image] Properties [image] Print
Remarks

Alarm or limit violation (with set option "in CEL") is printed online.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Text
ObjectModel COM [image] EdLimit [image] Properties [image] Text
Remarks

Text of the limit as it is displayed in lists, in the status line, and in dynamic elements on a limit violation.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


ThresholdValue
ObjectModel COM [image] EdLimit [image] Properties [image] ThresholdValue
Remarks

A threshold value can be defined, that is used for the releasing of the limit violation. So undesired reactions on quick series of alarms for analog values can be avoided.Example 1: Maximum value = 900, threshold = 10 makes 890Limit is violated above 900 and violation is released under 890.Example 2: Minimum value = 900, threshold = 10 makes 910Limit is violated below 900 and violation is released over 910.In differnce to the hysteresis this property does not influence the display of the value but only the alarm behaviour.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Variable
ObjectModel COM [image] EdLimit [image] Properties [image] Variable
Remarks

Variable as object, which should be used as dynamic limit value.Only available, if the dynamic limit is active!

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] EdLimit [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant |  | Available | Available | Available | Available
DynProperties [PUT] | void |  | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant |  | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available


DynProperties [GET]
ObjectModel COM [image] EdLimit [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] EdLimit [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.


DynPropertiesEnum [GET]
ObjectModel COM [image] EdLimit [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties: DynPropertiesEnum("")


DynPropertyParam [GET]
ObjectModel COM [image] EdLimit [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties
ObjectModel COM [image] EdLimit [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Limit
Limit settings


Limit
ObjectModel COM [image] EdLimit [image] DynProperties [image] Limit
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

FlagACause

Bool

FlagACause

Description

FlagAColor

Bool

FlagAColor

FlagAComment

Bool

FlagAComment

FlagActiv

Bool

FlagActiv

FlagAlarm

Bool

FlagAlarm

FlagAlarmPrt

Bool

FlagAlarmPrt

FlagAQuit

Bool

FlagAQuit

FlagBlinking

Bool

FlagBlinking

FlagClassID

Bool

FlagClassID

FlagDelay

Bool

FlagDelay

FlagFunction

Bool

FlagFunction

FlagGroup

Bool

FlagGroup

FlagHelpCapture

Bool

FlagHelpCapture

FlagHelpFile

Bool

FlagHelpFile

FlagInvisible

Bool

FlagInvisible

FlagIsAlarm

Bool

FlagIsAlarm

FlagLimitIsMax

Bool

FlagLimitIsMax

FlagLimitVar

Bool

FlagLimitVar

FlagLimitVariable

Bool

FlagLimitVariable

FlagMessage

Bool

FlagMessage

FlagQuest

Bool

FlagQuest

FlagToCEL

Bool

FlagToCEL

FlagToDelete

Bool

FlagToDelete

FlagTreshold

Bool

FlagTreshold

FlagUser1

Bool

FlagUser1

FlagUser2

Bool

FlagUser2

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Limit settings
ObjectModel COM [image] EdLimit [image] DynProperties [image] Limit settings
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Element
ObjectModel COM [image] Element
Remarks

This object contains the most important information on a defined dynamic element, e.g. type, position, colour, ...

Dynamic elements are created in the Editor of the contol system. With a DynPicture you get the list of the defined elements. In the project the central list of the defined Screens is available.
Most of the dynamic elements can be linked to variables or functions. Additionally these elements can be linked to different VBA macros. The VBA macros are managed in the Macro Browser of the Editor and liked to the properties of the elements.

Hint:
The VBA macros are only available within the control system. External applications have no access to the defined macros.

The following VBA macros are available:

  • Init: available
  • LeftClickUp: available
  • LeftClickDown: Executed on releasing the left mouse button
  • LeftDClick: Executed on doubleclicking the left mouse button
  • RightClickUp: Executed on clicking the right mouse button
  • RightClickDown: Executed on releasing the right mouse button
  • RightDClick: Executed on doubleclicking the right mouse button
  • SetFocus: Executed on activating the element
  • KillFocus: Executed on leaving the element
  • Draw: Executed on drawing the element

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
//Reads all elements of a (defined) screen
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.ActiveDocument.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}

//Print all the element names on the start screen to the debugger output
public void MacroElements()
{

    IElements zenonElements = GetElementsOnScreen("Start");
    for (int i = 0; i < zenonElements.Count; ++i)
    {
        IElement zenonElement = zenonElements.Item(i);
        //Print some properties
        System.Diagnostics.Debug.Print(
            "Name: {0} - Width: {1} - Height: {2}",
            zenonElement.Name, zenonElement.Width.ToString(),
            zenonElement.Height.ToString());
    }
}
VB.NET
Copy
'Reads all elements of a (defined) screen
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.ActiveDocument.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function

'Print all the element names on the start screen to the debugger output
Public Sub MacroElements()

    Dim zenonElements As IElements = GetElementsOnScreen("Start")
    For i As Integer = 0 To zenonElements.Count - 1
        Dim zenonElement As IElement = zenonElements.Item(i)
        'Print some properties
        System.Diagnostics.Debug.Print("Name: {0} - Width: {1} - Height: {2}", zenonElement.Name, zenonElement.Width.ToString(), zenonElement.Height.ToString())
    Next
End Sub
VBA
Copy
'Sample how to get all elements within a symbol...
Sub GetItAll()
'Define objects...
Dim zPIC As DynPicture
Dim zELE As Element
'allocate the Screen
Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Item("ScreenName")
'check if Screen object is valid...
If zPIC Is Nothing Then Exit Sub

'allocate the element

Set zELE = zPIC.Elements.Item("SymbolName")

'check if element object is valid...

If zELE Is Nothing Then Exit Sub

'get all elements within the symbol an its sub symbols...

Call GetElements(zELE)
End Sub
'Procedure with recursive calls to get all subsymbols...
Sub GetElements(zElem As Element)
Dim i As Integer
For i = 0 To zElem.Elements.Count - 1

'check if element is of type symbol

If zElem.Elements.Item(i).Type = tpSymbol Then

'recursiv call

Call GetElements(zElem.Elements.Item(i))

Else

'print the name of each element...

Debug.Print i & ": " & zElem.Elements.Item(i).Name

End If
Next i
End Sub


Properties
ObjectModel COM [image] Element [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
BackColor | ole_color | Background-Color. | Available | Available | Available | Available
BackColorVariable | ivariable | Name (as string) of the variable, whose limit colors should influence the background/filling color of the element. | Available | Unused | Available | Available
Bottom | long | Returns the position of the bottom window border of the dynamic element in pixel. | Available | Readonly | Available | Available
CountVariable | long | Number of linked variables | Readonly | Readonly | Available | Available
Elements | isymbolelements | Returns the list of linked symbols | Available | Unused | Available | Available
Enable | variant_bool | De/-Activates the element (only runtime) | Readonly | Available | Available | Available
Focus | variant_bool | Sets the focus to the element | Readonly | Readonly | Available | Available
ForeColor | ole_color | Text-Color | Available | Readonly | Available | Available
Function | irtfunction | Returns the linked Function. | Readonly | Readonly | Available | Available
Height | long | Height of the element | Available | Unused | Available | Available
HelpCapture | bstr | Help-Index in the helpfile for context-sensitive help | Available | Readonly | Available | Available
HelpFile | bstr | Name of the linked helpfile | Available | Readonly | Available | Available
Hide | variant_bool | Show/Hide the element (only runtime) | Unused | Available | Available | Available
HorizontalOrigin | byte |  | Available | Readonly | Available | Available
HotKey | bstr | Hotkey for the element | Available | Readonly | Available | Available
hWnd | ole_handle | Handle for picture | Unused | Readonly | Available | Available
ID | long | ID of the element (unique) | Readonly | Readonly | Available | Available
Interlocking | iinterlocking | Returns the linked Interlocking. | Readonly | Readonly | Available | Available
InterlockingStatus | tplockresult | Returns whether the Element is currently interlocked. | Unused | Readonly | Available | Available
Left | long | Left-coordinate of the element | Available | Readonly | Available | Available
LineColorVariable | ivariable | Name (as string) of the variable, whose limit colors should influence the line/text color of the element. | Available | Unused | Available | Available
MenuName | bstr | Name of the linked Menu | Available | Readonly | Available | Available
Name | bstr | Name of the element (optional) | Available | Readonly | Available | Available
Parent | ielements | Parent-Object of the element | Readonly | Readonly | Available | Available
PasswordLevel | short | Password-Level for user-action | Available | Readonly | Available | Available
Right | long | Returns the position of the right window border of the dynamic element in pixel. | Available | Readonly | Available | Available
SelectionFeedbackVariable | ivariable | Returns the variable for the Selection Feedback. | Available | Unused | Available | Available
StationName | bstr | Element is entered into the object list of the world view with the text defined with this property as string. | Available | Readonly | Available | Available
SymbolInLibrary | variant_bool | Insert the given symbol into the symbol-library | Readonly | Unused | Available | Available
SymbolNo | long | Number of symbol within the picture. | Readonly | Readonly | Available | Available
ToolTip | bstr | Info-Text for the element (is shown by mouseover in the runtime) | Available | Unused | Available | Available
Top | long | Top-coordinate of the element | Available | Readonly | Available | Available
TwistVariable | ivariable | Name of the variable for rotating the element as string. | Available | Unused | Available | Available
TwistVarMax | double | Highest variable value for rotating the element. | Available | Unused | Available | Available
TwistVarMin | double | Lowest variable value for rotating the element. | Available | Unused | Available | Available
TwistViewMax | long | Rotation angle of the element for variable maximum. | Available | Unused | Available | Available
TwistViewMin | long | Rotation angle of the element for variable minimum. | Available | Unused | Available | Available
Type | long | Type of the element () | Readonly | Readonly | Available | Available
VerticalOrigin | byte |  | Available | Readonly | Available | Available
VisibilityFrom | double | Minimum value of the variable for visibility of the element | Available | Readonly | Available | Available
VisibilityFromLimit | variant_bool | Returns true if visibility is adopted from the limit value of the variable | Available | Readonly | Available | Available
VisibilityInterlocking | iinterlocking | Returns the interlocking object for visibility | Unused | Readonly | Available | Available
VisibilityTo | double | Maximum value of the variable for visibility of the element | Available | Readonly | Available | Available
VisibilityType | tpvisibilitytype | Returns the visibility type | Available | Readonly | Available | Available
VisibilityVariable | ivariable | Returns the variable for visibility | Available | Readonly | Available | Available
VisibilityWhenInterlocked | variant_bool | Returns true if visible when interlocked | Available | Readonly | Available | Available
Width | long | Width of the element | Available | Unused | Available | Available
XVariable | ivariable | Name of the variable for horizontal moving of the element as string. | Available | Unused | Available | Available
XVarMax | double | Highest variable value for horizontal moving of the element. | Available | Unused | Available | Available
XVarMin | double | Lowest variable value for horizontal moving of the element. | Available | Unused | Available | Available
XViewMax | long | Horizontal position of the element for variable maximum (in pixels). | Available | Unused | Available | Available
XViewMin | long | Horizontal position of the element for variable minimum (in pixels). | Available | Unused | Available | Available
XZoomVariable | ivariable | Name of the variable for zooming the width of the element as string. | Available | Unused | Available | Available
XZoomVarMax | double | Highest variable value for zooming the width of the element. | Available | Unused | Available | Available
XZoomVarMin | double | Lowest variable value for zooming the width of the element. | Available | Unused | Available | Available
XZoomViewMax | long | Zoom factor of the width of the element for variable maximum (in %). | Available | Unused | Available | Available
XZoomViewMin | long | Zoom factor of the width of the element for variable minimum (in %). | Available | Unused | Available | Available
YVariable | ivariable | Name of the variable for vertical moving of the element as string. | Available | Unused | Available | Available
YVarMax | double | Highest variable value for vertical moving of the element. | Available | Unused | Available | Available
YVarMin | double | Lowest variable value for vertical moving of the element. | Available | Unused | Available | Available
YViewMax | long | Vertical position of the element for variable maximum (in pixels). | Available | Unused | Available | Available
YViewMin | long | Vertical position of the element for variable minimum (in pixels). | Available | Unused | Available | Available
YZoomVariable | ivariable | Name of the variable for zooming the height of the element as string. | Available | Unused | Available | Available
YZoomVarMax | double | Highest variable value for zooming the height of the element. | Available | Unused | Available | Available
YZoomVarMin | double | Lowest variable value for zooming the height of the element. | Available | Unused | Available | Available
YZoomViewMax | long | Zoom factor of the height of the element for variable maximum (in %). | Available | Unused | Available | Available
YZoomViewMin | long | Zoom factor of the height of the element for variable minimum (in %). | Available | Unused | Available | Available
ZoomMax | short | Highest zoom step in which the element should be visible in the worldview. Default: -1. | Available | Readonly | Available | Available
ZoomMin | short | Lowest zoom step in which the element should be visible in the worldview. Default: -1. | Available | Readonly | Available | Available


BackColor
ObjectModel COM [image] Element [image] Properties [image] BackColor
Remarks

Background-Color.

Datatype
OLE_COLOR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


BackColorVariable
ObjectModel COM [image] Element [image] Properties [image] BackColorVariable
Remarks

Name (as string) of the variable, whose limit colors should influence the background/filling color of the element.

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Bottom
ObjectModel COM [image] Element [image] Properties [image] Bottom
Remarks

Returns the position of the bottom window border of the dynamic element in pixel. The value defines the distance from the top border of the screen.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


CountVariable
ObjectModel COM [image] Element [image] Properties [image] CountVariable
Remarks

Returns the number of variables linked to the dynamic element.Hint: With the method "ItemVariable" the single variables of the dynamic element can be found out.The following VBA example reads all variables of a Trend element and displays them in the Debug window of VBA. Then the user is asked if VBA should be opened, to let him read the messages.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Elements
ObjectModel COM [image] Element [image] Properties [image] Elements
Remarks

Returns the collection ("SymbolElements" object) of the embedded "Element" objects.

Datatype
ISymbolElements

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Enable
ObjectModel COM [image] Element [image] Properties [image] Enable
Remarks

De/activates the dynamic element. If deactivated, actions like setting a value are not executed.Usually this property returns True indicating, that the element is active. Setting it to False deactivates the element.Hint: VBA macros are also executed, if the element is deactivated. Standard actions, e.g. executing functions for a button are not executed when deactivated.The following example de/activates the dynamic element BITMAP_BTN_1, which is on the current picture, depending on the current status of the element.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Available
VBA | Available
VSTA | Available


Focus
ObjectModel COM [image] Element [image] Properties [image] Focus
Remarks

This property checks, if the current element has the focus. Only one element per picture can have the focus at the same time. An element gets the focus, when clicking on it with the mouse or switching to it with the Tab key. In the later case the Tab functionality for the Runtime has to be activated.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ForeColor
ObjectModel COM [image] Element [image] Properties [image] ForeColor
Remarks

Text-Color

Datatype
OLE_COLOR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Function
ObjectModel COM [image] Element [image] Properties [image] Function
Remarks

The result is a dispatch-interface object. In case there is no linkage the result can be NULLid=97(Ele_dispidFunction)

Datatype
IRtFunction

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Height
ObjectModel COM [image] Element [image] Properties [image] Height
Remarks

Height of the element (in pixels).

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


HelpCapture
ObjectModel COM [image] Element [image] Properties [image] HelpCapture
Remarks

Help-Index in the helpfile for context-sensitive help

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


HelpFile
ObjectModel COM [image] Element [image] Properties [image] HelpFile
Remarks

Name of the linked helpfile

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Hide
ObjectModel COM [image] Element [image] Properties [image] Hide
Remarks

This property can influence the visibility of the dynamic element. Usually this property returns False, i.e. the element is displayed.If the property is set to True, the element is hidden. And the element stays invisible, until this property is set back to False.Reopening the picture resets the element.The following example influences the visibility of the dynamic element BITMAP_BTN_1, which exists in the current picture.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


HorizontalOrigin
ObjectModel COM [image] Element [image] Properties [image] HorizontalOrigin
Remarks

Datatype
BYTE

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


HotKey
ObjectModel COM [image] Element [image] Properties [image] HotKey
Remarks

Hotkey for the element

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


hWnd
ObjectModel COM [image] Element [image] Properties [image] hWnd
Remarks

Returns the handle for the dynamic element. Each window in Windows is identified by a handle. This handle is used for most of the standard routines, e.g. for drawing.

Datatype
OLE_HANDLE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ID
ObjectModel COM [image] Element [image] Properties [image] ID
Remarks

ID of the element (unique)

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Interlocking
ObjectModel COM [image] Element [image] Properties [image] Interlocking
Remarks

The result is a dispatch-interface object. In case there is no linkage the result can be NULLid=98(Ele_dispidInterlocking)

Datatype
IInterlocking

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


InterlockingStatus
ObjectModel COM [image] Element [image] Properties [image] InterlockingStatus
Remarks

Returns whether the Element is currently interlocked.

Datatype
tpLockResult

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Left
ObjectModel COM [image] Element [image] Properties [image] Left
Remarks

Returns the position of the left window border of the dynamic element in pixel. The value defines the distance from the left border of the screen.The following example moves a Bitmap-Button to the right by the width of the element. If the right border of the picture is reached, the element is moved to the left border.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


LineColorVariable
ObjectModel COM [image] Element [image] Properties [image] LineColorVariable
Remarks

Name (as string) of the variable, whose limit colors should influence the line/text color of the element.

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


MenuName
ObjectModel COM [image] Element [image] Properties [image] MenuName
Remarks

Name of the linked zenOn-Menu as string.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] Element [image] Properties [image] Name
Remarks

Returns the name of the dynamic element. This property is optional, i.e. if the user did not define a name, an empty string is returned. Hint: With this unique name a dynamic element can be found in the list of the dynamic elements of the picture.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Element [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IElements

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


PasswordLevel
ObjectModel COM [image] Element [image] Properties [image] PasswordLevel
Remarks

This property returns the password level of the dynamic element. Usually this method returns 0 indicating, that no password level is set. If the value is > 0, only users with the defined password level are allowed to execute the action.

Datatype
short

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Right
ObjectModel COM [image] Element [image] Properties [image] Right
Remarks

Returns the position of the right window border of the dynamic element in pixel. The value defines the distance from the left border of the screen.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


SelectionFeedbackVariable
ObjectModel COM [image] Element [image] Properties [image] SelectionFeedbackVariable
Remarks

Returns the variable for the Selection Feedback.

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


StationName
ObjectModel COM [image] Element [image] Properties [image] StationName
Remarks

Element is entered into the object list of the world view with the text defined with this property as string.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


SymbolInLibrary
ObjectModel COM [image] Element [image] Properties [image] SymbolInLibrary
Remarks

Insert the given symbol into the symbol-library

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


SymbolNo
ObjectModel COM [image] Element [image] Properties [image] SymbolNo
Remarks

Number of symbol within the picture.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ToolTip
ObjectModel COM [image] Element [image] Properties [image] ToolTip
Remarks

Info-Text for the element (is shown by mouseover in the runtime)

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Top
ObjectModel COM [image] Element [image] Properties [image] Top
Remarks

Returns the position of the top window border of the dynamic element in pixel. The value defines the distance from the top border of the screen.The following example moves a Bitmap-Button down by the height of the element. If the bottom border of the picture is reached, the element is moved to the top border.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


TwistVariable
ObjectModel COM [image] Element [image] Properties [image] TwistVariable
Remarks

Name of the variable for rotating the element as string.

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


TwistVarMax
ObjectModel COM [image] Element [image] Properties [image] TwistVarMax
Remarks

Highest variable value for rotating the element.Hint: A variable has to be assigned to the property "TwistVariable", in order to use this property.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


TwistVarMin
ObjectModel COM [image] Element [image] Properties [image] TwistVarMin
Remarks

Lowest variable value for rotating the element.Hint: A variable has to be assigned to the property "TwistVariable", in order to use this property.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


TwistViewMax
ObjectModel COM [image] Element [image] Properties [image] TwistViewMax
Remarks

Rotation angle of the element for variable maximum.Hint: A variable has to be assigned to the property "TwistVariable", in order to use this property.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


TwistViewMin
ObjectModel COM [image] Element [image] Properties [image] TwistViewMin
Remarks

Rotation angle of the element for variable minimum.Hint: A variable has to be assigned to the property "TwistVariable", in order to use this property.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] Element [image] Properties [image] Type
Remarks

Returns the type of the "Element" object.The following table gives an overview of the common element types:

Value | Hex | Name | Description
0 | &H0 | tpDynBargraph | Bar Graph
1 | read only | tpDynZahlenElem | Numerical value
2 | read only | tpDynText | Link Text
4 | yes | tpDynTrend | Trend Graph
5 | yes | tpDynZeiger | Indicating instrument
6 | &H6 | tpDynBewegt | Move element
7 | &H7 | tpDynBinaer | Binary element
8 | &H8 | tpDynBitmap | Bitmap button
9 | &H9 | tpDynVerkn | Invisible button
10 | &HA | tpDynButton | Text button
11 | &HB | tpDynSchalter | Switch
12 | &HC | tpDynMulitbin | Multi-binary element
13 | &HD | tpDynMeldung | Message
14 | &HE | tpDynUhr | Clock
15 | &HF | tpDynBefMdi | Command element
16 | &H10 | tpDynStatus | State element
17 | &H11 | tpDynBaButton | Picture alarm
18 | &H12 | tpDynControl | Control element
19 | &H13 | tpDynAegel |
20 | &H14 | tpDynActiveX | ActiveX element
21 | &H15 | tpDynTopLgt | Topological line
22 | &H16 | tpDynTopStrg | Topological branch
23 | &H17 | tpDynInstrument | Universal Slider
24 | &H18 | tpDynCombiList | ComboListBox
29 | &H1D | tpDynWPF | WPF Element
100 | &H64 | tpDot |
101 | &H65 | tpLine | Line
102 | &H66 | tpRectangle | Rectangle
103 | &H67 | tpCircle | Ellipse / Circle
104 | &H68 | tpPolyLine | Polyline
107 | &H6B | tpText | Text
108 | &H6C | tpArc | Arc of circle
109 | &H6D | tpSolid |
111 | &H6F | tpTraceDr |
114 | &H72 | tpKegel |
115 | &H73 | tpFillPara |
116 | &H74 | tpFillTria |
117 | &H75 | tpFillBlock |
121 | &H79 | tpPie | Pie
127 | &H7F | tpRoundRect | Rounded rectangle
128 | &H80 | tpPolygon | Polygon
129 | &H81 | tpSymbol | Embedded symbol
130 | &H82 | tpSymbolLnk | Linked symbol
131 | &H83 | tpSegme_Dxf | Graphical element of DXF
133 | &H85 | tpWMF | Graphical element of WMF
134 | &H86 | tpEMF | Graphical element of EMF
135 | &H87 | tpWinkel | 3D-angle
136 | &H88 |  | Tube

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


VerticalOrigin
ObjectModel COM [image] Element [image] Properties [image] VerticalOrigin
Remarks

Datatype
BYTE

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


VisibilityFrom
ObjectModel COM [image] Element [image] Properties [image] VisibilityFrom
Remarks

Lowest value of the variable, for which the element is visible. Hint: Only available, after a variable has been assigned to the property "VisibilityVariable" and the property "VisibilityFromLimit" is set to FALSE.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


VisibilityFromLimit
ObjectModel COM [image] Element [image] Properties [image] VisibilityFromLimit
Remarks

If set TRUE, the visibility of the element will be influenced by the limit definition of the variable. ATTENTION: At least for one limit of the variable the property "invisible" must be activated. Otherwise, the visibility is influenced by the properties "VisibilityFrom" and "VisibilityTo" of the element. Hint: Only available, after a variable has been assigned to the property "VisibilityVariable".

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


VisibilityInterlocking
ObjectModel COM [image] Element [image] Properties [image] VisibilityInterlocking
Remarks

Example how to get Properties in the Runtime:publicvoid Macro_ShowElementsRT() { zenOn.IElements myElementsBild0 = this.DynPictures().Item(1).Elements(); zenOn.IElement button1 = myElementsBild0.Item(0); zenOn.ICel theCel = this.Cel(); theCel.WriteCelString("Vis.Type " + button1.VisibilityType); theCel.WriteCelString("Variable Name: " + button1.VisibilityVariable.Name); theCel.WriteCelString("Von, bis: " + button1.VisibilityFrom + " - " + button1.VisibilityTo); theCel.WriteCelString("VonGrenzwert: " + button1.VisibilityFromLimit); theCel.WriteCelString("Interlocking: " + button1.VisibilityInterlocking.ToString()); theCel.WriteCelString("VisWhenInterl.: " + button1.VisibilityWhenInterlocked); }

Datatype
IInterlocking

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


VisibilityTo
ObjectModel COM [image] Element [image] Properties [image] VisibilityTo
Remarks

Highest value of the variable, for which the element is visible. Hint: Only available, after a variable has been assigned to the property "VisibilityVariable" and the property "VisibilityFromLimit" is set to FALSE.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


VisibilityType
ObjectModel COM [image] Element [image] Properties [image] VisibilityType
Remarks

Example how to get Properties in the Editor:publicvoid Macro_ShowElementSettings() { zenOn.IProject myActiveProject = this.Application.MyWorkspace.ActiveDocument; zenOn.IDynPictures myDynPics = myActiveProject.DynPictures(); zenOn.IElements myElementsBild0 = myDynPics.Item(0).Elements(); zenOn.IElement button1 = myElementsBild0.Item(0); System.Windows.Forms.MessageBox.Show("VisibilityType: " + button1.VisibilityType); System.Windows.Forms.MessageBox.Show(" Von Grenzw: " + button1.VisibilityFromLimit); zenOn.IVariable anVariable = button1.VisibilityVariable; System.Windows.Forms.MessageBox.Show("Var: " + anVariable.Name); }Example how to get Properties in the Runtime:publicvoid Macro_ShowElementsRT() { zenOn.IElements myElementsBild0 = this.DynPictures().Item(1).Elements(); zenOn.IElement button1 = myElementsBild0.Item(0); zenOn.ICel theCel = this.Cel(); theCel.WriteCelString("Vis.Type " + button1.VisibilityType); theCel.WriteCelString("Variable Name: " + button1.VisibilityVariable.Name); theCel.WriteCelString("Von, bis: " + button1.VisibilityFrom + " - " + button1.VisibilityTo); theCel.WriteCelString("VonGrenzwert: " + button1.VisibilityFromLimit); theCel.WriteCelString("Interlocking: " + button1.VisibilityInterlocking.ToString()); theCel.WriteCelString("VisWhenInterl.: " + button1.VisibilityWhenInterlocked); }

Datatype
tpVisibilityType

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


VisibilityVariable
ObjectModel COM [image] Element [image] Properties [image] VisibilityVariable
Remarks

Name (as string) of the variable, whose value should influence the visibility of the element. Hint: If no variable is linked, the element is always visible.

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


VisibilityWhenInterlocked
ObjectModel COM [image] Element [image] Properties [image] VisibilityWhenInterlocked
Remarks

Example how to get Properties in the Editor:publicvoid Macro_ShowElementSettings() { zenOn.IProject myActiveProject = this.Application.MyWorkspace.ActiveDocument; zenOn.IDynPictures myDynPics = myActiveProject.DynPictures(); zenOn.IElements myElementsBild0 = myDynPics.Item(0).Elements(); zenOn.IElement button1 = myElementsBild0.Item(0); System.Windows.Forms.MessageBox.Show("VisibilityType: " + button1.VisibilityType); System.Windows.Forms.MessageBox.Show(" Von Grenzw: " + button1.VisibilityFromLimit); zenOn.IVariable anVariable = button1.VisibilityVariable; System.Windows.Forms.MessageBox.Show("Var: " + anVariable.Name); }Example how to get Properties in the Runtime:publicvoid Macro_ShowElementsRT() { zenOn.IElements myElementsBild0 = this.DynPictures().Item(1).Elements(); zenOn.IElement button1 = myElementsBild0.Item(0); zenOn.ICel theCel = this.Cel(); theCel.WriteCelString("Vis.Type " + button1.VisibilityType); theCel.WriteCelString("Variable Name: " + button1.VisibilityVariable.Name); theCel.WriteCelString("Von, bis: " + button1.VisibilityFrom + " - " + button1.VisibilityTo); theCel.WriteCelString("VonGrenzwert: " + button1.VisibilityFromLimit); theCel.WriteCelString("Interlocking: " + button1.VisibilityInterlocking.ToString()); theCel.WriteCelString("VisWhenInterl.: " + button1.VisibilityWhenInterlocked); }

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Width
ObjectModel COM [image] Element [image] Properties [image] Width
Remarks

Width of the element (in pixel).

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


XVariable
ObjectModel COM [image] Element [image] Properties [image] XVariable
Remarks

Name of the variable for horizontal moving of the element as string.

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


XVarMax
ObjectModel COM [image] Element [image] Properties [image] XVarMax
Remarks

Highest variable value for horizontal moving of the element.Hint: A variable has to be assigned to the property "XVariable", in order to use this property.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


XVarMin
ObjectModel COM [image] Element [image] Properties [image] XVarMin
Remarks

Lowest variable value for horizontal moving of the element.Hint: A variable has to be assigned to the property "XVariable", in order to use this property.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


XViewMax
ObjectModel COM [image] Element [image] Properties [image] XViewMax
Remarks

Horizontal position of the element for variable maximum (in pixels).Hint: A variable has to be assigned to the property "XVariable", in order to use this property.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


XViewMin
ObjectModel COM [image] Element [image] Properties [image] XViewMin
Remarks

Horizontal position of the element for variable minimum (in pixels).Hint: A variable has to be assigned to the property "XVariable", in order to use this property.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


XZoomVariable
ObjectModel COM [image] Element [image] Properties [image] XZoomVariable
Remarks

Name of the variable for zooming the width of the element as string.

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


XZoomVarMax
ObjectModel COM [image] Element [image] Properties [image] XZoomVarMax
Remarks

Highest variable value for zooming the width of the element.Hint: A variable has to be assigned to the property "XZoomVariable", in order to use this property.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


XZoomVarMin
ObjectModel COM [image] Element [image] Properties [image] XZoomVarMin
Remarks

Lowest variable value for zooming the width of the element.Hint: A variable has to be assigned to the property "XZoomVariable", in order to use this property.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


XZoomViewMax
ObjectModel COM [image] Element [image] Properties [image] XZoomViewMax
Remarks

Zoom factor of the width of the element for variable maximum (in %).Hint: A variable has to be assigned to the property "XZoomVariable", in order to use this property.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


XZoomViewMin
ObjectModel COM [image] Element [image] Properties [image] XZoomViewMin
Remarks

Zoom factor of the width of the element for variable minimum (in %).Hint: A variable has to be assigned to the property "XZoomVariable", in order to use this property.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


YVariable
ObjectModel COM [image] Element [image] Properties [image] YVariable
Remarks

Name of the variable for vertical moving of the element as string.

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


YVarMax
ObjectModel COM [image] Element [image] Properties [image] YVarMax
Remarks

Highest variable value for vertical moving of the element.Hint: A variable has to be assigned to the property "YVariable", in order to use this property.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


YVarMin
ObjectModel COM [image] Element [image] Properties [image] YVarMin
Remarks

Lowest variable value for vertical moving of the element.Hint: A variable has to be assigned to the property "YVariable", in order to use this property.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


YViewMax
ObjectModel COM [image] Element [image] Properties [image] YViewMax
Remarks

Vertical position of the element for variable maximum (in pixels).Hint: A variable has to be assigned to the property "YVariable", in order to use this property.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


YViewMin
ObjectModel COM [image] Element [image] Properties [image] YViewMin
Remarks

Vertical position of the element for variable minimum (in pixels).Hint: A variable has to be assigned to the property "YVariable", in order to use this property.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


YZoomVariable
ObjectModel COM [image] Element [image] Properties [image] YZoomVariable
Remarks

Name of the variable for zooming the height of the element as string.

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


YZoomVarMax
ObjectModel COM [image] Element [image] Properties [image] YZoomVarMax
Remarks

Highest variable value for zooming the height of the element.Hint: A variable has to be assigned to the property "YZoomVariable", in order to use this property.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


YZoomVarMin
ObjectModel COM [image] Element [image] Properties [image] YZoomVarMin
Remarks

Lowest variable value for zooming the height of the element.Hint: A variable has to be assigned to the property "YZoomVariable", in order to use this property.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


YZoomViewMax
ObjectModel COM [image] Element [image] Properties [image] YZoomViewMax
Remarks

Zoom factor of the height of the element for variable maximum (in %).Hint: A variable has to be assigned to the property "YZoomVariable", in order to use this property.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


YZoomViewMin
ObjectModel COM [image] Element [image] Properties [image] YZoomViewMin
Remarks

Zoom factor of the height of the element for variable minimum (in %).Hint: A variable has to be assigned to the property "YZoomVariable", in order to use this property.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


ZoomMax
ObjectModel COM [image] Element [image] Properties [image] ZoomMax
Remarks

Highest zoom step in which the element should be visible in the worldview. Default: -1.Hint: Where visible from zoom step -1 to -1 means, that the element is visible in all zoom steps.

Datatype
short

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ZoomMin
ObjectModel COM [image] Element [image] Properties [image] ZoomMin
Remarks

Lowest zoom step in which the element should be visible in the worldview. Default: -1.Hint: Where visible from zoom step -1 to -1 means, that the element is visible in all zoom steps.

Datatype
short

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Element [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AddVariable | variant_bool | Add a link to a Variable | Available | Unused | Available | Available
AktiveX | idispatch | Returns the linked Active-X control (Standard = Nothing) | Unused | Available | Available | Available
CreateDynProperty | variant_bool | Creates SubItems of the actual object. The parameter has to be the name of the SubItem to be created. | Available | Unused | Available | Available
DynProperties [GET] | variant |  | Available | Available | Available | Available
DynProperties [PUT] | void |  | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant |  | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available
ItemVariable | ivariable | Returns the linked variable on the given position (depent of the type) | Available | Available | Available | Available
LeftClickDown | void | Executes the action of the dynamic element for pressing the left mouse button. | Unused | Available | Available | Available
LeftClickUp | void | Executes the action of the dynamic element for releasing the left mouse button. | Unused | Available | Available | Available
LeftDClick | void | Executes the action of the dynamic element for doubleclicking the left mouse button. | Unused | Available | Available | Available
Move | void | Moves the element to the given position | Unused | Available | Available | Available
RemoveVariable | variant_bool | Remove the link to the zenOn-variable on the position. | Available | Unused | Available | Available
RightClickDown | void |  | Unused | Available | Available | Available
RightClickUp | void |  | Unused | Available | Available | Available
RightDClick | void |  | Unused | Available | Available | Available
SaveAktiveX | void | Saves the current ActiveX-settings into to picture (requires additional Save for the picture). | Available | Unused | Available | Available
Update | void | Updates the element | Available | Available | Available | Available
WPFProperty [GET] | variant | Get/Set a property of a certain WPF-Element. | Unused | Available | Available | Available
WPFProperty [PUT] | void | Get/Set a property of a certain WPF-Element. | Unused | Available | Available | Available


AddVariable
ObjectModel COM [image] Element [image] Methods [image] AddVariable
Remarks

Assigns a variable to the object.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lpVar as LPDISPATCH

Example
C#
Copy
//Reads all elements of a (defined) screen
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.ActiveDocument.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}

//Adds a variable to an element if there is non linked to it
public void MacroGetVariableElementAdd()
{
    IElements zenonElements = GetElementsOnScreen("Start");
    IElement zenonTank = zenonElements.Item("graph_tank");
    System.Diagnostics.Debug.Print(zenonTank.CountVariable.ToString());

    IVariable zenonVar = this.ActiveDocument.Variables().Item("WIZ_VAR_10");
    //If there is no linked variable then add one to the tank graph
    if (zenonTank.ItemVariable(0) == null)
        zenonTank.AddVariable(zenonVar);
    zenonTank.Update();
}
VB.NET
Copy
'Reads all elements of a (defined) screen
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.ActiveDocument.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function

'Adds a variable to an element if there is non linked to it
Public Sub MacroGetVariableElementAdd()
    Dim zenonElements As IElements = GetElementsOnScreen("Start")
    Dim zenonTank As IElement = zenonElements.Item("graph_tank")
    System.Diagnostics.Debug.Print(zenonTank.CountVariable.ToString())

    Dim zenonVar As IVariable = Me.ActiveDocument.Variables().Item("WIZ_VAR_10")
    'If there is no linked variable then add one to the tank graph
    If zenonTank.ItemVariable(0) Is Nothing Then
        zenonTank.AddVariable(zenonVar)
    End If
    zenonTank.Update()
End Sub


AktiveX
ObjectModel COM [image] Element [image] Methods [image] AktiveX
Remarks

This method returns the object for the linked Active-X Control, if the dynamic element is an ActiveX element of the control system. If this is not the case, this method returns "Nothing". Hint: The returned object should be checked on "Nothing", as only the ActiveX element of the control system needs this method.

Datatype
IDispatch

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


CreateDynProperty
ObjectModel COM [image] Element [image] Methods [image] CreateDynProperty
Remarks

This method is able to create SubItems of the actual object. The parameter has to be the name of the SubItem to be created.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"


DynProperties [GET]
ObjectModel COM [image] Element [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] Element [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.


DynPropertiesEnum [GET]
ObjectModel COM [image] Element [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties: DynPropertiesEnum("")


DynPropertyParam [GET]
ObjectModel COM [image] Element [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


ItemVariable
ObjectModel COM [image] Element [image] Methods [image] ItemVariable
Remarks

Returns the object Variable, which is identified by the parameter vID. Most of the dynamic elements can be linked to variables. The visualization of most elements depends on the linked variables.The parameter vID can have two values:

  • Index: Access with an index mostly is used in combination with the property Count to find out the position of the variable object in the list.
  • Variable name: The variable can also be accessed with its unique name.

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPv as VARIANT

Example
C#
Copy
//Reads all elements of a (defined) screen
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.ActiveDocument.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}

//Get the variable of a graph element that represents a tank, the variable indicates how full the tank is
public void MacroGetVariableElement()
{
    IElements zenonElements = GetElementsOnScreen("Start");
    IElement zenonTank = zenonElements.Item("graph_tank");
    System.Diagnostics.Debug.Print(zenonTank.CountVariable.ToString());
    for (int i = 0; i < zenonTank.CountVariable; ++i)
    {
        IVariable zenonVariable = zenonTank.ItemVariable(i);
        if (zenonVariable != null)
        {
            //Print the max range of the variable
            System.Diagnostics.Debug.Print(zenonVariable.Name);
        }
    }
}
VB.NET
Copy
'Reads all elements of a (defined) screen
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.ActiveDocument.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function

'Get the variable of a graph element that represents a tank, the variable indicates how full the tank is
Public Sub MacroGetVariableElement()
    Dim zenonElements As IElements = GetElementsOnScreen("Start")
    Dim zenonTank As IElement = zenonElements.Item("graph_tank")
    System.Diagnostics.Debug.Print(zenonTank.CountVariable.ToString())
    For i As Integer = 0 To zenonTank.CountVariable - 1
        Dim zenonVariable As IVariable = zenonTank.ItemVariable(i)
        If zenonVariable IsNot Nothing Then
            'Print the max range of the variable
            System.Diagnostics.Debug.Print(zenonVariable.Name)
        End If
    Next
End Sub


LeftClickDown
ObjectModel COM [image] Element [image] Methods [image] LeftClickDown
Remarks

This method executes the action of the dynamic element for pressing the left mouse button. This action can be a set value action or the execution of a function depending of the type of dynamic element.Hint: This method should be used in combination with the VBA macro LeftClickDown.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}

//Simulates a list of events on the element
public void MacroSimulateEvents()
{
    IElements zenonElements = GetElementsOnScreen("Start");
    IElement zenonMyElement = zenonElements.Item("my_test_element");

    //Simulate left mouse button
    zenonMyElement.LeftClickDown();
    zenonMyElement.LeftClickUp();
    zenonMyElement.LeftDClick();

    //Simulate right mouse button
    zenonMyElement.RightClickDown();
    zenonMyElement.RightClickUp();
    zenonMyElement.RightDClick();
}
VB.NET
Copy
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function

'Simulates a list of events on the element
Public Sub MacroSimulateEvents()
    Dim zenonElements As IElements = GetElementsOnScreen("Start")
    Dim zenonMyElement As IElement = zenonElements.Item("my_test_element")

    'Simulate left mouse button
    zenonMyElement.LeftClickDown()
    zenonMyElement.LeftClickUp()
    zenonMyElement.LeftDClick()

    'Simulate right mouse button
    zenonMyElement.RightClickDown()
    zenonMyElement.RightClickUp()
    zenonMyElement.RightDClick()
End Sub


LeftClickUp
ObjectModel COM [image] Element [image] Methods [image] LeftClickUp
Remarks

This method executes the action of the dynamic element for releasing the left mouse button. This action can be a set value action or the execution of a function depending of the type of dynamic element.Hint: This method should be used in combination with the VBA macro LeftClickUp.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}

//Simulates a list of events on the element
public void MacroSimulateEvents()
{
    IElements zenonElements = GetElementsOnScreen("Start");
    IElement zenonMyElement = zenonElements.Item("my_test_element");

    //Simulate left mouse button
    zenonMyElement.LeftClickDown();
    zenonMyElement.LeftClickUp();
    zenonMyElement.LeftDClick();

    //Simulate right mouse button
    zenonMyElement.RightClickDown();
    zenonMyElement.RightClickUp();
    zenonMyElement.RightDClick();
}
VB.NET
Copy
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function

'Simulates a list of events on the element
Public Sub MacroSimulateEvents()
    Dim zenonElements As IElements = GetElementsOnScreen("Start")
    Dim zenonMyElement As IElement = zenonElements.Item("my_test_element")

    'Simulate left mouse button
    zenonMyElement.LeftClickDown()
    zenonMyElement.LeftClickUp()
    zenonMyElement.LeftDClick()

    'Simulate right mouse button
    zenonMyElement.RightClickDown()
    zenonMyElement.RightClickUp()
    zenonMyElement.RightDClick()
End Sub


LeftDClick
ObjectModel COM [image] Element [image] Methods [image] LeftDClick
Remarks

This method executes the action of the dynamic element for doubleclicking the left mouse button. This action can be a set value action or the execution of a function depending of the type of dynamic element.Hint: This method should be used in combination with the VBA macro LeftDClick.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}

//Simulates a list of events on the element
public void MacroSimulateEvents()
{
    IElements zenonElements = GetElementsOnScreen("Start");
    IElement zenonMyElement = zenonElements.Item("my_test_element");

    //Simulate left mouse button
    zenonMyElement.LeftClickDown();
    zenonMyElement.LeftClickUp();
    zenonMyElement.LeftDClick();

    //Simulate right mouse button
    zenonMyElement.RightClickDown();
    zenonMyElement.RightClickUp();
    zenonMyElement.RightDClick();
}
VB.NET
Copy
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function

'Simulates a list of events on the element
Public Sub MacroSimulateEvents()
    Dim zenonElements As IElements = GetElementsOnScreen("Start")
    Dim zenonMyElement As IElement = zenonElements.Item("my_test_element")

    'Simulate left mouse button
    zenonMyElement.LeftClickDown()
    zenonMyElement.LeftClickUp()
    zenonMyElement.LeftDClick()

    'Simulate right mouse button
    zenonMyElement.RightClickDown()
    zenonMyElement.RightClickUp()
    zenonMyElement.RightDClick()
End Sub


Move
ObjectModel COM [image] Element [image] Methods [image] Move
Remarks

Sets the dimensions of the element in the form of left, top, bottom, right.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Left as long

Top as long

Right as long

Bottom as long

Example
C#
Copy
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}
public void MacroMoveElement()
{
    IElements zenonElements = GetElementsOnScreen("Start");
    IElement zenonMyElement = zenonElements.Item("my_test_element");

    //Sets the element to position (100/100) with size (100/100)
    zenonMyElement.Move(100, 100, 200, 200);
    zenonMyElement.Update();
}
VB.NET
Copy
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function
Public Sub MacroMoveElement()
    Dim zenonElements As IElements = GetElementsOnScreen("Start")
    Dim zenonMyElement As IElement = zenonElements.Item("my_test_element")

    'Sets the element to position (100/100) with size (100/100)
    zenonMyElement.Move(100, 100, 200, 200)
    zenonMyElement.Update()
End Sub


RemoveVariable
ObjectModel COM [image] Element [image] Methods [image] RemoveVariable
Remarks

Remove the link to the zenOn-variable on the position.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
nPosition as long

Example
C#
Copy
//Reads all elements of a (defined) screen
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.ActiveDocument.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}

//Remove all linked variables from an element
public void MacroGetVariableElementRemove()
{
    IElements zenonElements = GetElementsOnScreen("Start");
    IElement zenonTank = zenonElements.Item("graph_tank");
    System.Diagnostics.Debug.Print(zenonTank.CountVariable.ToString());

    //Loop through available var spaces and remove them all
    for (int i = 0; i < zenonTank.CountVariable; ++i)
    {
        if (zenonTank.ItemVariable(i) != null)
            zenonTank.RemoveVariable(i);
    }
}
VB.NET
Copy
'Reads all elements of a (defined) screen
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.ActiveDocument.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function

'Remove all linked variables from an element
Public Sub MacroGetVariableElementRemove()
    Dim zenonElements As IElements = GetElementsOnScreen("Start")
    Dim zenonTank As IElement = zenonElements.Item("graph_tank")
    System.Diagnostics.Debug.Print(zenonTank.CountVariable.ToString())

    'Loop through available var spaces and remove them all
    For i As Integer = 0 To zenonTank.CountVariable - 1
        If zenonTank.ItemVariable(i) IsNot Nothing Then
            zenonTank.RemoveVariable(i)
        End If
    Next
End Sub


RightClickDown
ObjectModel COM [image] Element [image] Methods [image] RightClickDown
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
{
    IDynPicture zenonChosenScreen = this.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}

//Simulates a list of events on the element
public void MacroSimulateEvents()
{
    IElements zenonElements = GetElementsOnScreen("Start");
    IElement zenonMyElement = zenonElements.Item("my_test_element");

    //Simulate left mouse button
    zenonMyElement.LeftClickDown();
    zenonMyElement.LeftClickUp();
    zenonMyElement.LeftDClick();

    //Simulate right mouse button
    zenonMyElement.RightClickDown();
    zenonMyElement.RightClickUp();
    zenonMyElement.RightDClick();
}
VB.NET
Copy
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function

'Simulates a list of events on the element
Public Sub MacroSimulateEvents()
    Dim zenonElements As IElements = GetElementsOnScreen("Start")
    Dim zenonMyElement As IElement = zenonElements.Item("my_test_element")

    'Simulate left mouse button
    zenonMyElement.LeftClickDown()
    zenonMyElement.LeftClickUp()
    zenonMyElement.LeftDClick()

    'Simulate right mouse button
    zenonMyElement.RightClickDown()
    zenonMyElement.RightClickUp()
    zenonMyElement.RightDClick()
End Sub


RightClickUp
ObjectModel COM [image] Element [image] Methods [image] RightClickUp
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}

//Simulates a list of events on the element
public void MacroSimulateEvents()
{
    IElements zenonElements = GetElementsOnScreen("Start");
    IElement zenonMyElement = zenonElements.Item("my_test_element");

    //Simulate left mouse button
    zenonMyElement.LeftClickDown();
    zenonMyElement.LeftClickUp();
    zenonMyElement.LeftDClick();

    //Simulate right mouse button
    zenonMyElement.RightClickDown();
    zenonMyElement.RightClickUp();
    zenonMyElement.RightDClick();
}
VB.NET
Copy
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function

'Simulates a list of events on the element
Public Sub MacroSimulateEvents()
    Dim zenonElements As IElements = GetElementsOnScreen("Start")
    Dim zenonMyElement As IElement = zenonElements.Item("my_test_element")

    'Simulate left mouse button
    zenonMyElement.LeftClickDown()
    zenonMyElement.LeftClickUp()
    zenonMyElement.LeftDClick()

    'Simulate right mouse button
    zenonMyElement.RightClickDown()
    zenonMyElement.RightClickUp()
    zenonMyElement.RightDClick()
End Sub


RightDClick
ObjectModel COM [image] Element [image] Methods [image] RightDClick
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}

//Simulates a list of events on the element
public void MacroSimulateEvents()
{
    IElements zenonElements = GetElementsOnScreen("Start");
    IElement zenonMyElement = zenonElements.Item("my_test_element");

    //Simulate left mouse button
    zenonMyElement.LeftClickDown();
    zenonMyElement.LeftClickUp();
    zenonMyElement.LeftDClick();

    //Simulate right mouse button
    zenonMyElement.RightClickDown();
    zenonMyElement.RightClickUp();
    zenonMyElement.RightDClick();
}
VB.NET
Copy
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function

'Simulates a list of events on the element
Public Sub MacroSimulateEvents()
    Dim zenonElements As IElements = GetElementsOnScreen("Start")
    Dim zenonMyElement As IElement = zenonElements.Item("my_test_element")

    'Simulate left mouse button
    zenonMyElement.LeftClickDown()
    zenonMyElement.LeftClickUp()
    zenonMyElement.LeftDClick()

    'Simulate right mouse button
    zenonMyElement.RightClickDown()
    zenonMyElement.RightClickUp()
    zenonMyElement.RightDClick()
End Sub


SaveAktiveX
ObjectModel COM [image] Element [image] Methods [image] SaveAktiveX
Remarks

Saves the current ActiveX-settings into to picture (requires additional Save for the picture).

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Update
ObjectModel COM [image] Element [image] Methods [image] Update
Remarks

This method updates a dynamic element. After changes with VBA always use this method to refresh the display.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}
public void MacroMoveElement()
{
    IElements zenonElements = GetElementsOnScreen("Start");
    IElement zenonMyElement = zenonElements.Item("my_test_element");

    //Sets the element to position (100/100) with size (100/100)
    zenonMyElement.Move(100, 100, 200, 200);
    zenonMyElement.Update();
}
VB.NET
Copy
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function
Public Sub MacroMoveElement()
    Dim zenonElements As IElements = GetElementsOnScreen("Start")
    Dim zenonMyElement As IElement = zenonElements.Item("my_test_element")

    'Sets the element to position (100/100) with size (100/100)
    zenonMyElement.Move(100, 100, 200, 200)
    zenonMyElement.Update()
End Sub


WPFProperty [GET]
ObjectModel COM [image] Element [image] Methods [image] WPFProperty [GET]
Remarks

Grants access to the WPF properties of an object and reads them.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsElement as BSTR

bsProperty as BSTR


WPFProperty [PUT]
ObjectModel COM [image] Element [image] Methods [image] WPFProperty [PUT]
Remarks

Get/Set a property of a certain WPF-Element.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsElement as BSTR

bsProperty as BSTR

vValue as VARIANT


DynProperties
ObjectModel COM [image] Element [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

ActiveX
Angle
Arc of circle
Bargraph
Base class picture elements
Base class vector elements
Basisklasse dynamische Bildelemente
Batch recipe editor control
Binary
Bitmap
Calander control
Circle
Clock
Combi
Combo Listbox
Combobox
Command
Dynamic window batch parameter list
Dynamic window list control
Dynamic window no header list control
Dynamic window picture control
EMF WMF
Frame polygon
Frame vector
Indicating instrument
Invisible button
Line
Link text
Linked symbol
Listbox
Listcontrol
MDI element
Message
Move
Multibin
Numerical value
Picture alarm
Picture elements
Polygon
Polyline
Rectangle
Report viewer control
Segment of circle
Static text
Switch
Symbol
Template
Text button
Topological line
Topological wire
Trend curve
Tube
Universal slider
Window
WPF element


ActiveX
ObjectModel COM [image] Element [image] DynProperties [image] ActiveX
Overview
External Name | Type | Display Name | Description
ActiveX | UInt32 | ActiveX settings | Selection of the ActiveX element and the linked variable. .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
DynEleVar | Node | DynEleVar | "With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] ActiveX [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] ActiveX [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] ActiveX [image] CZenonGestureManipulation [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Angle
ObjectModel COM [image] Element [image] DynProperties [image] Angle
Overview
External Name | Type | Display Name | Description
ALCAlias | Bool | Use alias | Only available if is active.Active : Alias is used. In the Runtime the element receives its ALC colors from another ALC element of the topological model without being part of the model itself. The displayed ALC color of the element is thus not determined by the linked lines. The ALC color is identical to the color of the ALC element, the name of which is linked in the .Inactive : Element is an ALC element according to the configured ALC . The ALC display color is determined by the linked lines.Default: Inactive .
ALCAliasName | String | Alias | Only available if is active.Defined source element for property . Clicking on the ... button opens the dialog to select a pre-configured ALC element in a pre-configured zenon screen. Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project. .
ALCAlternativeColor | UInt32 | Alternative color | Only available if property has value alternative color .Alternative color for the ALC coloring at multiple supply. .
ALCDashLen | Int16 | Dashing length supplied multiple times | Only available if property has value two highest prior sources .Defines the dash length in pixel for the dashed ALC coloring at multiply supply.Minimal: 0 (automatic dash length)Maximum: 32767 Default: 0 .
ALCEnclosementSize | SByte | Curb width [px] | Width of the curb in pixels.Default: 1 pixel Input range: 1 to 20 pixels.Note: Only available if property is active. .
ALCLength | double | Length of the line [km] | ALC line: Length of the line. .
ALCLineName | String | Line name | Unique name of the line. Is used for the identification of the line in the load distribution calculation. In addition, this name is used as interlocking text for the "Overload of a line " topological interlocking.Note : Only available for the Line or Pipe screen element. .
ALCMaxIType | Int16 | Limit value current carrying capacity | Origin of data on the limit value of the current carrying capacity for the calculation of load distribution . The current carrying capacity of the weakest link (cable) in a line. Selection of the type from the drop-down list: Default: Static limit value current carrying capacity Note: The entries in the drop-down list correspond to the properties that follow the Editor directly. .
ALCMaxIVal | double | Static limit value current carrying capacity [A] | Entry of the maximum current-carrying capacity of the weakest link (cable) in the line. Entry in amperes.Default: 20 Not available if the property is configured with limit value of current-carrying capacity dynamic . .
ALCMSecuredSupply | Int16 | display secured supply | Only available if was activated.Definition of the display of the secured supply:double widthdouble brightnessnormalDefault: normal .
ALCMultiSource | Int16 | display multiple supplies | Only available if the property is active. Defines the display type if the element is connected to several sources: most prior source: Only the color of the source with the highest priority is used. two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line. alternative color : Alternative color for the coloring at multiple supply.Default: highest priority source .
ALCPrecedence | Int16 | Priority for display | Only available if the property is active.Defines the priority of the display when the element is connected to several active sources. Multiple supply : The element is displayed according to the rules of the multiple supply. secured supply : The element is displayed according to the rules of the secured supply. No priority : The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.Default: Multiple supply .
ALCReact | double | Reactance value of the cable [Ohm] | Maximum permitted value of the reactance (reactance X) of the line in Ohms. Is used for the detection of the fault locating of protection . .
ALCResist | double | Resistance value of the electric line [Ohm] | Maximum permitted value of the resistance (effective resistance R) of the line in Ohms. Is used for the calculation of load distribution. .
ALCUseColor | Bool | Color from ALC | Only available if you have licensed Automatic Line Coloring (ALC) : Active: The automatic color of the linked source(s) is used. Inactive: The standard color is used. Default: inactive. .
ALCUseEnclosement | Bool | Use curb | Checkbox for the activation of the curb of lines, polylines and pipelines.active: ALC line elements are visualized in Runtime for a ground fault or short circuit with an additional border in the corresponding color. The colors are defined in the ALC project settings.Inactive: No display of curbing in Runtime.Default: Inactive Note: only active if is activated. .
ALCVarCalcI | CDynEleVar | Measuring value of the calculated current flow | Linked variable with the measured value of the calculated current flow of the branch. Calculation result in amperes [A]. .
ALCVarCalcIEx | Node | ALCVarCalcIEx | ALC Leitung: Messwert des berechneten Stromflusses für Export.Mehr in der Online-Hilfe .
ALCVarMaxI | CDynEleVar | Dynamic limit value current carrying capacity | Linked variable for the maximum current-carrying capacity of the weakest link (cable) in the line. Only available if the limit value of current-carrying capacity property is configured with limit value of current-carrying capacity dynamic . .
ALCVarMaxIEx | Node | ALCVarMaxIEx | Node
Align | Int16 | Alignment | Direction of color shift. horizontal vertical
AlphaBackColor | SByte | Transparency of the fill color [%] | .
AlphaBackColor2 | SByte | Transparency gradient color [%] | Only available if Linear was selected in the property. .
AlphaLineColor | SByte | Transparency line color [%] | .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColor2 | UInt32 | Gradient color | Color gradient must be selected for the property.Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of . .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVariable2 | CDynEleVar | Gradient color | Name of the variable whose limit value color should influence the gradient color of the element. Click on the input filed in order to open the dialog for selecting a variable. .
BackColorVariable2Preview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
ColorGradientAngle | Int16 | Angle [°] | Defines the direction of the color gradient starting in the center of the element.Values: 0° to 360° . Default: 0° .
ColorGradientOffset | Int16 | Offset [%] | Only available if, for a vector element or a dynamic button element, the property has been set. Linear or Selective or Selective with edges .Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.Values: 0 equals the center of the element. 100 the edge. Note: The value can also be outside of the element and is therefore not limited to 100 . .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillColorInvert | Bool | Invert color gradient | Only available if Color gradient was selected as . Active: The brightness gradient is inverted. Inactive: The brightness gradient is not inverted. Default: Inactive .
FillPattern | UInt32 | Fill pattern | Selection of the filling pattern for the element from the list.This property is only available if property is inactive. .
FillStyle | Guid | Fill style |
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
InnerBrightness | SByte | Brightness inside | Only available if "via brightness value" is active : Brightness in the middle of the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Lightning | Int16 | Color gradient | Only available if was set to Color gradient . Defines the color gradient for elements. Linear : steady gradientDefined point : Gradient from a defined point to the edges of the element Selective with edges : Gradient from a defined point to the edges of the element with beamsRadiant : From the bottom to the middle, then gradient from the middle to the top (with rectangular form only).
LineColor | UInt32 | Line color | Line color of the element.
LineColorEx | UInt32 | Line color | Defines the line color of the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LineStyle | Guid | Line style | Display and selection of the line style that is assigned to the element. .
LineType | UInt32 | Line type | Selection of the line type for the element from the list. Attention: If the node in in the project properties, the property has been set to Windows basic , you can only use line width >1 with a "continuous line" type line. .
LineWidth | UInt16 | Line width [Pixel] | Width of the line (in pixels).Minimum: 0 In this case the width of the line is 1 pixel.Maximum: 40 Default: 1 Attention: If in the project settings in node you set property to Windows basis , you can use line width >1 only with a line of type "continuous line". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
MeasuredInputActivePower | Node | Active power input [MW] | Linked variable with the measured value of the active power at the line input. .
MeasuredInputActivePowerImEx | Node | MeasuredInputActivePowerImEx | Description
MeasuredInputCosPhi | Node | cos Phi input | Linked variable with the measured value of the cos phi power factor at the line input. .
MeasuredInputCosPhiImEx | Node | MeasuredInputCosPhiImEx | Description
MeasuredInputCurrent | Node | Power Input [A] | Linked variable with the measured value of the amperage at the line input. .
MeasuredInputCurrentImEx | Node | MeasuredInputCurrentImEx | Description
MeasuredInputReactivePower | Node | Reactive power input [MVar] | Linked variable with the measured value of the reactive power at the line input. .
MeasuredInputReactivePowerImEx | Node | MeasuredInputReactivePowerImEx | Description
MeasuredInputVoltage | Node | Voltage input [kV] | Linked variable with the measured value of the voltage at the line input. .
MeasuredInputVoltageImEx | Node | MeasuredInputVoltageImEx | Description
MeasuredOutputActivePower | Node | Active power output [MW] | Linked variable with the measured value of the active power at the line output. .
MeasuredOutputActivePowerImEx | Node | MeasuredOutputActivePowerImEx | Description
MeasuredOutputCosPhi | Node | cos Phi output | Linked variable with the measured value of the cos phi power factor at the line output. .
MeasuredOutputCosPhiImEx | Node | MeasuredOutputCosPhiImEx | Description
MeasuredOutputCurrent | Node | Power Output [A] | Linked variable with the measured value of the amperage at the line output. .
MeasuredOutputCurrentImEx | Node | MeasuredOutputCurrentImEx | Description
MeasuredOutputReactivePower | Node | Reactive power output [MVar] | Linked variable with the measured value of the reactive power at the line output. .
MeasuredOutputReactivePowerImEx | Node | MeasuredOutputReactivePowerImEx | Description
MeasuredOutputVoltage | Node | Voltage output [kV] | Linked variable with the measured value of the voltage at the line output. .
MeasuredOutputVoltageImEx | Node | MeasuredOutputVoltageImEx | Description
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
OuterBrightness | SByte | Brightness outside | Only available if "via brightness value" is active : Brightness at the outer side of the element. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
Shifted | Int16 | Shifted color gradient | Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein. Mehr im Online-Handbuch
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VarLineCurrent | Node | Current [A] | Linked variable with the result of the load flow calculation for the calculated amperage at the line input. .
VarLineCurrentImEx | Node | VarLineCurrentImEx | Description
VarLinePowerFactorVar | Node | cos Phi output | Linked variable with the result of the load flow calculation for the calculated power factor (cos phi). This corresponds to the average value of the calculated cos phi at the output. .
VarLinePowerFactorVarImEx | Node | VarLinePowerFactorVarImEx | Description
VarLinePowerInVar | Node | Active power input [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line input. .
VarLinePowerInVarImEx | Node | VarLinePowerInVarImEx | Description
VarLinePowerOutVar | Node | Active power output [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line output. .
VarLinePowerOutVarImEx | Node | VarLinePowerOutVarImEx | Description
VarLineReactivePowerInVar | Node | Reactive power input [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line input. .
VarLineReactivePowerInVarImEx | Node | VarLineReactivePowerInVarImEx | Description
VarLineReactivePowerOutVar | Node | Reactive power output [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line output. .
VarLineReactivePowerOutVarImEx | Node | VarLineReactivePowerOutVarImEx | Description
VarLineVoltageInVar | Node | Voltage input [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line input. .
VarLineVoltageInVarImEx | Node | VarLineVoltageInVarImEx | Description
VarLineVoltageOutVar | Node | Voltage output [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line output. .
VarLineVoltageOutVarImEx | Node | VarLineVoltageOutVarImEx | Description
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Angle [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Arc of circle
ObjectModel COM [image] Element [image] DynProperties [image] Arc of circle
Overview
External Name | Type | Display Name | Description
ALCAlias | Bool | Use alias | Only available if is active.Active : Alias is used. In the Runtime the element receives its ALC colors from another ALC element of the topological model without being part of the model itself. The displayed ALC color of the element is thus not determined by the linked lines. The ALC color is identical to the color of the ALC element, the name of which is linked in the .Inactive : Element is an ALC element according to the configured ALC . The ALC display color is determined by the linked lines.Default: Inactive .
ALCAliasName | String | Alias | Only available if is active.Defined source element for property . Clicking on the ... button opens the dialog to select a pre-configured ALC element in a pre-configured zenon screen. Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project. .
ALCAlternativeColor | UInt32 | Alternative color | Only available if property has value alternative color .Alternative color for the ALC coloring at multiple supply. .
ALCDashLen | Int16 | Dashing length supplied multiple times | Only available if property has value two highest prior sources .Defines the dash length in pixel for the dashed ALC coloring at multiply supply.Minimal: 0 (automatic dash length)Maximum: 32767 Default: 0 .
ALCEnclosementSize | SByte | Curb width [px] | Width of the curb in pixels.Default: 1 pixel Input range: 1 to 20 pixels.Note: Only available if property is active. .
ALCLength | double | Length of the line [km] | ALC line: Length of the line. .
ALCLineName | String | Line name | Unique name of the line. Is used for the identification of the line in the load distribution calculation. In addition, this name is used as interlocking text for the "Overload of a line " topological interlocking.Note : Only available for the Line or Pipe screen element. .
ALCMaxIType | Int16 | Limit value current carrying capacity | Origin of data on the limit value of the current carrying capacity for the calculation of load distribution . The current carrying capacity of the weakest link (cable) in a line. Selection of the type from the drop-down list: Default: Static limit value current carrying capacity Note: The entries in the drop-down list correspond to the properties that follow the Editor directly. .
ALCMaxIVal | double | Static limit value current carrying capacity [A] | Entry of the maximum current-carrying capacity of the weakest link (cable) in the line. Entry in amperes.Default: 20 Not available if the property is configured with limit value of current-carrying capacity dynamic . .
ALCMSecuredSupply | Int16 | display secured supply | Only available if was activated.Definition of the display of the secured supply:double widthdouble brightnessnormalDefault: normal .
ALCMultiSource | Int16 | display multiple supplies | Only available if the property is active. Defines the display type if the element is connected to several sources: most prior source: Only the color of the source with the highest priority is used. two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line. alternative color : Alternative color for the coloring at multiple supply.Default: highest priority source .
ALCPrecedence | Int16 | Priority for display | Only available if the property is active.Defines the priority of the display when the element is connected to several active sources. Multiple supply : The element is displayed according to the rules of the multiple supply. secured supply : The element is displayed according to the rules of the secured supply. No priority : The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.Default: Multiple supply .
ALCReact | double | Reactance value of the cable [Ohm] | Maximum permitted value of the reactance (reactance X) of the line in Ohms. Is used for the detection of the fault locating of protection . .
ALCResist | double | Resistance value of the electric line [Ohm] | Maximum permitted value of the resistance (effective resistance R) of the line in Ohms. Is used for the calculation of load distribution. .
ALCUseColor | Bool | Color from ALC | Only available if you have licensed Automatic Line Coloring (ALC) : Active: The automatic color of the linked source(s) is used. Inactive: The standard color is used. Default: inactive. .
ALCUseEnclosement | Bool | Use curb | Checkbox for the activation of the curb of lines, polylines and pipelines.active: ALC line elements are visualized in Runtime for a ground fault or short circuit with an additional border in the corresponding color. The colors are defined in the ALC project settings.Inactive: No display of curbing in Runtime.Default: Inactive Note: only active if is activated. .
ALCVarCalcI | CDynEleVar | Measuring value of the calculated current flow | Linked variable with the measured value of the calculated current flow of the branch. Calculation result in amperes [A]. .
ALCVarCalcIEx | Node | ALCVarCalcIEx | ALC Leitung: Messwert des berechneten Stromflusses für Export.Mehr in der Online-Hilfe .
ALCVarMaxI | CDynEleVar | Dynamic limit value current carrying capacity | Linked variable for the maximum current-carrying capacity of the weakest link (cable) in the line. Only available if the limit value of current-carrying capacity property is configured with limit value of current-carrying capacity dynamic . .
ALCVarMaxIEx | Node | ALCVarMaxIEx | Node
Align | Int16 | Alignment | Direction of color shift. horizontal vertical
AlphaLineColor | SByte | Transparency line color [%] | .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
Brightness | Bool | With brightness values | Only available if was selected as color gradient was selected.Active: The brightness of the color gradient can be freely defined. Inactive: The brightness of the color gradient is defined automatically.Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
InnerBrightness | SByte | Brightness inside | Only available if "via brightness value" is active : Brightness in the middle of the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LineCapEnd | UInt32 | End type | Defines the symbol for the end point of the line. Clicking on the field opens the dialog to select an element. Only available for the arc of a circle and segment of a circle if has been set to without . .
LineCapScale | float | Size | Defines the magnifying factor for the line width of the arrow. The factor relates to the line width of the vector element as defined in the property. For arc of circle and segment of circle only available if property was set to without .Value: greater or equal 1 Default: 4 .
LineCapStart | UInt32 | Start type | Defines the symbol for the starting point of the line. Click on the field and a dialog opens to select an element. For arc of circle and segment of circle only available if property was set to without . .
LineColor | UInt32 | Line color | Line color of the element.
LineColorEx | UInt32 | Line color | Defines the line color of the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LineStyle | Guid | Line style | Display and selection of the line style that is assigned to the element. .
LineType | UInt32 | Line type | Selection of the line type for the element from the list. Attention: If the node in in the project properties, the property has been set to Windows basic , you can only use line width >1 with a "continuous line" type line. .
LineWidth | UInt16 | Line width [Pixel] | Width of the line (in pixels).Minimum: 0 In this case the width of the line is 1 pixel.Maximum: 40 Default: 1 Attention: If in the project settings in node you set property to Windows basis , you can use line width >1 only with a line of type "continuous line". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
MeasuredInputActivePower | Node | Active power input [MW] | Linked variable with the measured value of the active power at the line input. .
MeasuredInputActivePowerImEx | Node | MeasuredInputActivePowerImEx | Description
MeasuredInputCosPhi | Node | cos Phi input | Linked variable with the measured value of the cos phi power factor at the line input. .
MeasuredInputCosPhiImEx | Node | MeasuredInputCosPhiImEx | Description
MeasuredInputCurrent | Node | Power Input [A] | Linked variable with the measured value of the amperage at the line input. .
MeasuredInputCurrentImEx | Node | MeasuredInputCurrentImEx | Description
MeasuredInputReactivePower | Node | Reactive power input [MVar] | Linked variable with the measured value of the reactive power at the line input. .
MeasuredInputReactivePowerImEx | Node | MeasuredInputReactivePowerImEx | Description
MeasuredInputVoltage | Node | Voltage input [kV] | Linked variable with the measured value of the voltage at the line input. .
MeasuredInputVoltageImEx | Node | MeasuredInputVoltageImEx | Description
MeasuredOutputActivePower | Node | Active power output [MW] | Linked variable with the measured value of the active power at the line output. .
MeasuredOutputActivePowerImEx | Node | MeasuredOutputActivePowerImEx | Description
MeasuredOutputCosPhi | Node | cos Phi output | Linked variable with the measured value of the cos phi power factor at the line output. .
MeasuredOutputCosPhiImEx | Node | MeasuredOutputCosPhiImEx | Description
MeasuredOutputCurrent | Node | Power Output [A] | Linked variable with the measured value of the amperage at the line output. .
MeasuredOutputCurrentImEx | Node | MeasuredOutputCurrentImEx | Description
MeasuredOutputReactivePower | Node | Reactive power output [MVar] | Linked variable with the measured value of the reactive power at the line output. .
MeasuredOutputReactivePowerImEx | Node | MeasuredOutputReactivePowerImEx | Description
MeasuredOutputVoltage | Node | Voltage output [kV] | Linked variable with the measured value of the voltage at the line output. .
MeasuredOutputVoltageImEx | Node | MeasuredOutputVoltageImEx | Description
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
OuterBrightness | SByte | Brightness outside | Only available if "via brightness value" is active : Brightness at the outer side of the element. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
Shifted | Int16 | Shifted color gradient | Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein. Mehr im Online-Handbuch
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
VarLineCurrent | Node | Current [A] | Linked variable with the result of the load flow calculation for the calculated amperage at the line input. .
VarLineCurrentImEx | Node | VarLineCurrentImEx | Description
VarLinePowerFactorVar | Node | cos Phi output | Linked variable with the result of the load flow calculation for the calculated power factor (cos phi). This corresponds to the average value of the calculated cos phi at the output. .
VarLinePowerFactorVarImEx | Node | VarLinePowerFactorVarImEx | Description
VarLinePowerInVar | Node | Active power input [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line input. .
VarLinePowerInVarImEx | Node | VarLinePowerInVarImEx | Description
VarLinePowerOutVar | Node | Active power output [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line output. .
VarLinePowerOutVarImEx | Node | VarLinePowerOutVarImEx | Description
VarLineReactivePowerInVar | Node | Reactive power input [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line input. .
VarLineReactivePowerInVarImEx | Node | VarLineReactivePowerInVarImEx | Description
VarLineReactivePowerOutVar | Node | Reactive power output [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line output. .
VarLineReactivePowerOutVarImEx | Node | VarLineReactivePowerOutVarImEx | Description
VarLineVoltageInVar | Node | Voltage input [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line input. .
VarLineVoltageInVarImEx | Node | VarLineVoltageInVarImEx | Description
VarLineVoltageOutVar | Node | Voltage output [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line output. .
VarLineVoltageOutVarImEx | Node | VarLineVoltageOutVarImEx | Description
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Arc of circle [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Bargraph
ObjectModel COM [image] Element [image] DynProperties [image] Bargraph
Overview
External Name | Type | Display Name | Description
Absolute | Bool | Absolute amount | For element Numeric value only available if property is inactive .Active: Unsigned display of the variable value (-200 = 200).Inactive: Normal display of the value.Default: Inactive Note: In this case, the set value is entered in percent. .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BarFillStyle | Guid | Fill style |
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
Direction | UInt16 | Direction | Direction of the bar. Up : Lowest value at the bottom, highest value at the top. Move down : Lowest value at the top, highest value at the bottom. Move left : Lowest value on the right, highest value on the left. Move right : Highest value on the left, highest value on the right. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
DynEleVar | Node | DynEleVar | "With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"
DynMaxVar | CDynEleVar | Maximum | Variable that defines the maximum of the display range in Runtime. .
DynMinVar | CDynEleVar | Minimum | Variable that defines the minimum of the display range in Runtime. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
Explicit | Bool | Explicit | Note: Only available at element Pointer instrument if the display is activated as or . .
FillStyle | Guid | Fill style |
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
Frame | UInt16 | Element border | Drop-down list for the selection of the frame type. The following are available:For the button element Thin border 3D Default: Thin border For other dynamic elements Edge heightened Edge deepened No border Classical heightened Classical deepened Margin heightened Margin deepened Default: No border .
FrameStyle | Guid | Element border line style | Display and selection of the element style that is assigned to the element. .
FromZero | Bool | From zero | Only affects the display of values with a sign: Active: The bar ranges from zero to the current value of the linked variable. Inactive: The bar ranges from the lowest displayed value to the current value of the linked variable. Default: inactive. .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
HWDirect | Bool | without dialog | Active: The value is sent to the hardware without a possibility to be changed in the Runtime. Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware. .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
IsSetValue | Bool | Write set value | Active: Setting of set values for this dynamic element is allowed.Inactive: The element is ReadOnly.Not available for the dynamic text element if it has been set to read only in the screen. .
KbdName | String | Screen Keyboard | Only available if property is active.Name of the linked keyboard screen. If no keyboard screen is entered, the respective corresponding keyboard is called up in Runtime:String variable: SETSTRINGKBD Numeric variable: SETVALUEKBD Binary variable: SETBOOLKBD Note: For the input field input option, no keyboard is called up if the option is activated. A keyboard screen must be linked. .
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LimitColor | Bool | Use limit value color | Defines whether the limit value color for the variable linked to the element is displayed in Runtime. The color has an effect on the text displayed, or in the indicator of a universal slider .Active : The defined limit value color is displayed in the Runtime.Default: active .
LimitFromVar | Bool | Take set value limits from variable | Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly. Inactive: The range can be limited directly in the "Minimum" and "Maximum". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
Max | double | Maximum | Upper limit of the permitted range for the set value. Only available if "Take set value limits from variable" is not active. Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum. .
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
Min | double | Minimum | Bottom limit of the permitted range for the set value. Only available if Take set value limits from variable is not active: Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
Preset | Bool | propose current value | Active: The current value of the variable is proposed as set value. In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value). Inactive: The value defined in "Set value / amend" is proposed. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
ScaleStyle | Guid | Scales style | Display and selection of the scale style that is assigned to the element. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetProgram | String | External program | Only available if an external program was selected for Write set value : The set value is written by an external program that must be selected in the dialog box that appears here. This program is then started and gets the following parameters: 1) Name of the linked variable 2) Proposed value, as defined in the corresponding properties 3) Left coordinate of the element in pixels 4) Upper coordinate of the element in pixels 5) Right coordinate of the element in pixels 6) Lower coordinate of the element in pixels 7) Permitted minimum for the set value, as defined in the corresponding properties 8) Permitted maximum for the set value, as defined in the corresponding properties .
SetValue | double | Set value/change by | Value that should be sent as the set value or as a default. If "Propose current value" is active: : Value that is added to the current value. In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
SetValueWith | SByte | Write set value via | Configuration of how the target value is set. Select from drop-down list:Command Processing: The new value is set using command processing . For input, the screen that is defined in the command group of the linked variable is opened.Standard dialog box : The new value is entered using the standard dialog box. If a screen of type "Keyboard " with name "SETVALUEKBD " (for numeric values) or "SETSTRINGKBD " (for string variables) exists, it is used instead of the standard dialog box. Note: If the element is linked to a function that allows inputs, is automated automatically. If a screen is linked in the property, this is used. Otherwise a SETSTRINGKBD keyboard is used.Element : The new value is directly entered in the element (only for the elements Numeric value and Text ).Program : The new value is entered in an external program. .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShowScale | Bool | Show scale | Active: A scale is shown in the element inactive: No scale is displayed. .
ShowState | Bool | Display status of variable | Graphical display of the status of the variable. Selection from a checkbox.Active: The status of the variables is indicated by a colored square at the element. Color : Red square: No communication with the PLC. Example: INVALID, OFF, ALT_VAL, REVISION, TIMEOUT, ...Blue square(N_UPDATE) : On the network client: The client has lost its connection to the Primary Server. With a standalone integration project: The Primary Server has not yet supplied the data.Yellow square (PR_NR) : Visualizes in Runtime that the variable has not been logged during replay in the Process Recorder . No value is therefore known in the playback.Position: The position of the square at the element depends on the element form:Angular and all other elements: Top right cornerRound element: Top, in the middle Rounded element : Top right corner, slightly offset to the left Inactive: The status is not shown. Also deactivates the display of additional variable information with a right click.Default: activated .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Bar color | Color for the bar of the bar chart. The set color is used if there has been no imit value violation. .
TextStyle | Guid | Text style |
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
Transparent | Bool | Transparent | Settings for transparency.Active : Displays the element transparently.Default: Inactive The effect of this option on a button is an Invisible button . It can be positioned above other elements as an invisible button. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
ValueStyle | Guid | Value display style | Display and selection of the value display style that is assigned to the element. .
Variable | CDynEleVar | Variable | Name of the linked variable. Click on button ... in order to open the dialog for selecting variables. The value of this variable is displayed in this element and can also be set here.Note: Only available for buttons if they are used as a switch .Hint: If the variable value is to be toggled, we recommend activating the property. Only SICAM 230 and Screen Alarm element: The description above only applies to the elements Text Button, Bitmap Button and Invisible Button . Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).Lower bit: Alarm active/inactive Higher bit: Alarm acknowledged/not acknowledged .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
ViewLimitFromVar | Bool | Apply display range from variables | Takes over the display area of the linked variable. You can update this display area during replacement with a variable with a different values range. .
ViewMax | double | Maximum | Highest variable value that is to be displayed in the element. .
ViewMin | double | Minimum | Lowest variable value that is to be displayed in the element. .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Bargraph [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Bargraph [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Base class picture elements
ObjectModel COM [image] Element [image] DynProperties [image] Base class picture elements
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Base class picture elements [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Base class vector elements
ObjectModel COM [image] Element [image] DynProperties [image] Base class vector elements
Overview
External Name | Type | Display Name | Description
ALCAlias | Bool | Use alias | Only available if is active.Active : Alias is used. In the Runtime the element receives its ALC colors from another ALC element of the topological model without being part of the model itself. The displayed ALC color of the element is thus not determined by the linked lines. The ALC color is identical to the color of the ALC element, the name of which is linked in the .Inactive : Element is an ALC element according to the configured ALC . The ALC display color is determined by the linked lines.Default: Inactive .
ALCAliasName | String | Alias | Only available if is active.Defined source element for property . Clicking on the ... button opens the dialog to select a pre-configured ALC element in a pre-configured zenon screen. Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project. .
ALCAlternativeColor | UInt32 | Alternative color | Only available if property has value alternative color .Alternative color for the ALC coloring at multiple supply. .
ALCDashLen | Int16 | Dashing length supplied multiple times | Only available if property has value two highest prior sources .Defines the dash length in pixel for the dashed ALC coloring at multiply supply.Minimal: 0 (automatic dash length)Maximum: 32767 Default: 0 .
ALCEnclosementSize | SByte | Curb width [px] | Width of the curb in pixels.Default: 1 pixel Input range: 1 to 20 pixels.Note: Only available if property is active. .
ALCLength | double | Length of the line [km] | ALC line: Length of the line. .
ALCLineName | String | Line name | Unique name of the line. Is used for the identification of the line in the load distribution calculation. In addition, this name is used as interlocking text for the "Overload of a line " topological interlocking.Note : Only available for the Line or Pipe screen element. .
ALCMaxIType | Int16 | Limit value current carrying capacity | Origin of data on the limit value of the current carrying capacity for the calculation of load distribution . The current carrying capacity of the weakest link (cable) in a line. Selection of the type from the drop-down list: Default: Static limit value current carrying capacity Note: The entries in the drop-down list correspond to the properties that follow the Editor directly. .
ALCMaxIVal | double | Static limit value current carrying capacity [A] | Entry of the maximum current-carrying capacity of the weakest link (cable) in the line. Entry in amperes.Default: 20 Not available if the property is configured with limit value of current-carrying capacity dynamic . .
ALCMSecuredSupply | Int16 | display secured supply | Only available if was activated.Definition of the display of the secured supply:double widthdouble brightnessnormalDefault: normal .
ALCMultiSource | Int16 | display multiple supplies | Only available if the property is active. Defines the display type if the element is connected to several sources: most prior source: Only the color of the source with the highest priority is used. two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line. alternative color : Alternative color for the coloring at multiple supply.Default: highest priority source .
ALCPrecedence | Int16 | Priority for display | Only available if the property is active.Defines the priority of the display when the element is connected to several active sources. Multiple supply : The element is displayed according to the rules of the multiple supply. secured supply : The element is displayed according to the rules of the secured supply. No priority : The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.Default: Multiple supply .
ALCReact | double | Reactance value of the cable [Ohm] | Maximum permitted value of the reactance (reactance X) of the line in Ohms. Is used for the detection of the fault locating of protection . .
ALCResist | double | Resistance value of the electric line [Ohm] | Maximum permitted value of the resistance (effective resistance R) of the line in Ohms. Is used for the calculation of load distribution. .
ALCUseColor | Bool | Color from ALC | Only available if you have licensed Automatic Line Coloring (ALC) : Active: The automatic color of the linked source(s) is used. Inactive: The standard color is used. Default: inactive. .
ALCUseEnclosement | Bool | Use curb | Checkbox for the activation of the curb of lines, polylines and pipelines.active: ALC line elements are visualized in Runtime for a ground fault or short circuit with an additional border in the corresponding color. The colors are defined in the ALC project settings.Inactive: No display of curbing in Runtime.Default: Inactive Note: only active if is activated. .
ALCVarCalcI | CDynEleVar | Measuring value of the calculated current flow | Linked variable with the measured value of the calculated current flow of the branch. Calculation result in amperes [A]. .
ALCVarCalcIEx | Node | ALCVarCalcIEx | ALC Leitung: Messwert des berechneten Stromflusses für Export.Mehr in der Online-Hilfe .
ALCVarMaxI | CDynEleVar | Dynamic limit value current carrying capacity | Linked variable for the maximum current-carrying capacity of the weakest link (cable) in the line. Only available if the limit value of current-carrying capacity property is configured with limit value of current-carrying capacity dynamic . .
ALCVarMaxIEx | Node | ALCVarMaxIEx | Node
Align | Int16 | Alignment | Direction of color shift. horizontal vertical
AlphaBackColor | SByte | Transparency of the fill color [%] | .
AlphaBackColor2 | SByte | Transparency gradient color [%] | Only available if Linear was selected in the property. .
AlphaLineColor | SByte | Transparency line color [%] | .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColor2 | UInt32 | Gradient color | Color gradient must be selected for the property.Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of . .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVariable2 | CDynEleVar | Gradient color | Name of the variable whose limit value color should influence the gradient color of the element. Click on the input filed in order to open the dialog for selecting a variable. .
BackColorVariable2Preview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
Brightness | Bool | With brightness values | Only available if was selected as color gradient was selected.Active: The brightness of the color gradient can be freely defined. Inactive: The brightness of the color gradient is defined automatically.Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners. .
ColorGradientAngle | Int16 | Angle [°] | Defines the direction of the color gradient starting in the center of the element.Values: 0° to 360° . Default: 0° .
ColorGradientOffset | Int16 | Offset [%] | Only available if, for a vector element or a dynamic button element, the property has been set. Linear or Selective or Selective with edges .Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.Values: 0 equals the center of the element. 100 the edge. Note: The value can also be outside of the element and is therefore not limited to 100 . .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillColorInvert | Bool | Invert color gradient | Only available if Color gradient was selected as . Active: The brightness gradient is inverted. Inactive: The brightness gradient is not inverted. Default: Inactive .
FillPattern | UInt32 | Fill pattern | Selection of the filling pattern for the element from the list.This property is only available if property is inactive. .
FillStyle | Guid | Fill style |
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
InnerBrightness | SByte | Brightness inside | Only available if "via brightness value" is active : Brightness in the middle of the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Lightning | Int16 | Color gradient | Only available if was set to Color gradient . Defines the color gradient for elements. Linear : steady gradientDefined point : Gradient from a defined point to the edges of the element Selective with edges : Gradient from a defined point to the edges of the element with beamsRadiant : From the bottom to the middle, then gradient from the middle to the top (with rectangular form only).
LineCapEnd | UInt32 | End type | Defines the symbol for the end point of the line. Clicking on the field opens the dialog to select an element. Only available for the arc of a circle and segment of a circle if has been set to without . .
LineCapScale | float | Size | Defines the magnifying factor for the line width of the arrow. The factor relates to the line width of the vector element as defined in the property. For arc of circle and segment of circle only available if property was set to without .Value: greater or equal 1 Default: 4 .
LineCapStart | UInt32 | Start type | Defines the symbol for the starting point of the line. Click on the field and a dialog opens to select an element. For arc of circle and segment of circle only available if property was set to without . .
LineColor | UInt32 | Line color | Line color of the element.
LineColorEx | UInt32 | Line color | Defines the line color of the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LineStyle | Guid | Line style | Display and selection of the line style that is assigned to the element. .
LineType | UInt32 | Line type | Selection of the line type for the element from the list. Attention: If the node in in the project properties, the property has been set to Windows basic , you can only use line width >1 with a "continuous line" type line. .
LineWidth | UInt16 | Line width [Pixel] | Width of the line (in pixels).Minimum: 0 In this case the width of the line is 1 pixel.Maximum: 40 Default: 1 Attention: If in the project settings in node you set property to Windows basis , you can use line width >1 only with a line of type "continuous line". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
MeasuredInputActivePower | Node | Active power input [MW] | Linked variable with the measured value of the active power at the line input. .
MeasuredInputActivePowerImEx | Node | MeasuredInputActivePowerImEx | Description
MeasuredInputCosPhi | Node | cos Phi input | Linked variable with the measured value of the cos phi power factor at the line input. .
MeasuredInputCosPhiImEx | Node | MeasuredInputCosPhiImEx | Description
MeasuredInputCurrent | Node | Power Input [A] | Linked variable with the measured value of the amperage at the line input. .
MeasuredInputCurrentImEx | Node | MeasuredInputCurrentImEx | Description
MeasuredInputReactivePower | Node | Reactive power input [MVar] | Linked variable with the measured value of the reactive power at the line input. .
MeasuredInputReactivePowerImEx | Node | MeasuredInputReactivePowerImEx | Description
MeasuredInputVoltage | Node | Voltage input [kV] | Linked variable with the measured value of the voltage at the line input. .
MeasuredInputVoltageImEx | Node | MeasuredInputVoltageImEx | Description
MeasuredOutputActivePower | Node | Active power output [MW] | Linked variable with the measured value of the active power at the line output. .
MeasuredOutputActivePowerImEx | Node | MeasuredOutputActivePowerImEx | Description
MeasuredOutputCosPhi | Node | cos Phi output | Linked variable with the measured value of the cos phi power factor at the line output. .
MeasuredOutputCosPhiImEx | Node | MeasuredOutputCosPhiImEx | Description
MeasuredOutputCurrent | Node | Power Output [A] | Linked variable with the measured value of the amperage at the line output. .
MeasuredOutputCurrentImEx | Node | MeasuredOutputCurrentImEx | Description
MeasuredOutputReactivePower | Node | Reactive power output [MVar] | Linked variable with the measured value of the reactive power at the line output. .
MeasuredOutputReactivePowerImEx | Node | MeasuredOutputReactivePowerImEx | Description
MeasuredOutputVoltage | Node | Voltage output [kV] | Linked variable with the measured value of the voltage at the line output. .
MeasuredOutputVoltageImEx | Node | MeasuredOutputVoltageImEx | Description
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
Offset_H | UInt16 | Horiz. distance [pixels] | Horizontal distance of the end of the rounding of the actual corner in pixels. .
Offset_V | UInt16 | Vertical distance [pixels] | Vertical distance of the end of the rounding of the actual corner in pixels. .
OuterBrightness | SByte | Brightness outside | Only available if "via brightness value" is active : Brightness at the outer side of the element. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
Shifted | Int16 | Shifted color gradient | Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein. Mehr im Online-Handbuch
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VarLineCurrent | Node | Current [A] | Linked variable with the result of the load flow calculation for the calculated amperage at the line input. .
VarLineCurrentImEx | Node | VarLineCurrentImEx | Description
VarLinePowerFactorVar | Node | cos Phi output | Linked variable with the result of the load flow calculation for the calculated power factor (cos phi). This corresponds to the average value of the calculated cos phi at the output. .
VarLinePowerFactorVarImEx | Node | VarLinePowerFactorVarImEx | Description
VarLinePowerInVar | Node | Active power input [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line input. .
VarLinePowerInVarImEx | Node | VarLinePowerInVarImEx | Description
VarLinePowerOutVar | Node | Active power output [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line output. .
VarLinePowerOutVarImEx | Node | VarLinePowerOutVarImEx | Description
VarLineReactivePowerInVar | Node | Reactive power input [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line input. .
VarLineReactivePowerInVarImEx | Node | VarLineReactivePowerInVarImEx | Description
VarLineReactivePowerOutVar | Node | Reactive power output [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line output. .
VarLineReactivePowerOutVarImEx | Node | VarLineReactivePowerOutVarImEx | Description
VarLineVoltageInVar | Node | Voltage input [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line input. .
VarLineVoltageInVarImEx | Node | VarLineVoltageInVarImEx | Description
VarLineVoltageOutVar | Node | Voltage output [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line output. .
VarLineVoltageOutVarImEx | Node | VarLineVoltageOutVarImEx | Description
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Base class vector elements [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Basisklasse dynamische Bildelemente
ObjectModel COM [image] Element [image] DynProperties [image] Basisklasse dynamische Bildelemente
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Basisklasse dynamische Bildelemente [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Basisklasse dynamische Bildelemente [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Batch recipe editor control
ObjectModel COM [image] Element [image] DynProperties [image] Batch recipe editor control
Overview
External Name | Type | Display Name | Description
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Legend | String | Text | Label of the element in the Editor. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
ShowBorder | Bool | Show border lines | Visualizes a border for certain elements when displayed in Runtime. The configuration of the and properties is no longer taken into account for the display in Runtime as a result.Active : The element is shown in Runtime with a border.Inactive: No border when displayed in Runtime.Default: inactive. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleH | UInt16 | Style H | Windows style of the element, for internal use only. .
StyleL | UInt16 | Style L | Windows style of the element, for internal use only. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Text color | Text color of the element. .
TouchIP | Bool | Touch execution positions | Optimization of touch operation in Runtime:Active : The active elements are displayed in Runtime with semi-transparent circles.Default: Inactive .
TranslateText | Bool | Translate display text | Active : The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.Default: Inactive .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
WithPanes | Bool | Dockable windows | Active : The list of dockable windows is shown in the recipe editor.Inactive : The list of dockable windows is not shown in the recipe editor.Default: active .
WithTBs | Bool | Toolbars | Active : Toolbars are displayed in the recipe editor.Inactive : Toolbars are not displayed in the recipe editor. Recommended if the actions of the individual symbols are assigned to their own buttons.Default: active .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Batch recipe editor control [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Binary
ObjectModel COM [image] Element [image] DynProperties [image] Binary
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
ContitionText | Bool | Show limit value text | Active: The status/limit value of the assigned variable is shown in the element. Inactive: No text is displayed. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
DynEleVar | Node | DynEleVar | "With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillArea | Bool | Color fill area only | Active: with circles, polygons and rectangles assigned to this linked symbol, only the fill color is changed according to the color definition of the variables. The color of the border is retained. Inactive: The border is also colored accordingly. Default: inactive. .
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
HWDirect | Bool | without dialog | Active: The value is sent to the hardware without a possibility to be changed in the Runtime. Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware. .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
IsSetValue | Bool | Write set value | Active: Setting of set values for this dynamic element is allowed.Inactive: The element is ReadOnly.Not available for the dynamic text element if it has been set to read only in the screen. .
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LimitFromVar | Bool | Take set value limits from variable | Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly. Inactive: The range can be limited directly in the "Minimum" and "Maximum". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
Max | double | Maximum | Upper limit of the permitted range for the set value. Only available if "Take set value limits from variable" is not active. Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum. .
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
Min | double | Minimum | Bottom limit of the permitted range for the set value. Only available if Take set value limits from variable is not active: Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
Preset | Bool | propose current value | Active: The current value of the variable is proposed as set value. In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value). Inactive: The value defined in "Set value / amend" is proposed. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetProgram | String | External program | Only available if an external program was selected for Write set value : The set value is written by an external program that must be selected in the dialog box that appears here. This program is then started and gets the following parameters: 1) Name of the linked variable 2) Proposed value, as defined in the corresponding properties 3) Left coordinate of the element in pixels 4) Upper coordinate of the element in pixels 5) Right coordinate of the element in pixels 6) Lower coordinate of the element in pixels 7) Permitted minimum for the set value, as defined in the corresponding properties 8) Permitted maximum for the set value, as defined in the corresponding properties .
SetValue | double | Set value/change by | Value that should be sent as the set value or as a default. If "Propose current value" is active: : Value that is added to the current value. In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
SetValueWith | SByte | Write set value via | Configuration of how the target value is set. Select from drop-down list:Command Processing: The new value is set using command processing . For input, the screen that is defined in the command group of the linked variable is opened.Standard dialog box : The new value is entered using the standard dialog box. If a screen of type "Keyboard " with name "SETVALUEKBD " (for numeric values) or "SETSTRINGKBD " (for string variables) exists, it is used instead of the standard dialog box. Note: If the element is linked to a function that allows inputs, is automated automatically. If a screen is linked in the property, this is used. Otherwise a SETSTRINGKBD keyboard is used.Element : The new value is directly entered in the element (only for the elements Numeric value and Text ).Program : The new value is entered in an external program. .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShowState | Bool | Display status of variable | Graphical display of the status of the variable. Selection from a checkbox.Active: The status of the variables is indicated by a colored square at the element. Color : Red square: No communication with the PLC. Example: INVALID, OFF, ALT_VAL, REVISION, TIMEOUT, ...Blue square(N_UPDATE) : On the network client: The client has lost its connection to the Primary Server. With a standalone integration project: The Primary Server has not yet supplied the data.Yellow square (PR_NR) : Visualizes in Runtime that the variable has not been logged during replay in the Process Recorder . No value is therefore known in the playback.Position: The position of the square at the element depends on the element form:Angular and all other elements: Top right cornerRound element: Top, in the middle Rounded element : Top right corner, slightly offset to the left Inactive: The status is not shown. Also deactivates the display of additional variable information with a right click.Default: activated .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Symbol | UInt16 | Symbol | A symbol can be selected from the list of symbols present in the screen. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
Variable | CDynEleVar | Variable | Name of the linked variable. Click on button ... in order to open the dialog for selecting variables. The value of this variable is displayed in this element and can also be set here.Note: Only available for buttons if they are used as a switch .Hint: If the variable value is to be toggled, we recommend activating the property. Only SICAM 230 and Screen Alarm element: The description above only applies to the elements Text Button, Bitmap Button and Invisible Button . Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).Lower bit: Alarm active/inactive Higher bit: Alarm acknowledged/not acknowledged .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Binary [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Binary [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Bitmap
ObjectModel COM [image] Element [image] DynProperties [image] Bitmap
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
Animate | Bool | GIF animation always | Active: The animation always runs. Inactive: Then the animation is not executed. You can switch the animation on and off with an optional link to . .
AnimateVar | CDynEleVar | Variable | Bit variable that switches the animation on and off. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FileName | String | Graphics File | Graphics that are to be displayed on the button when the button is not pressed (*.bmp, *.wmf, *.jpg, *.gif, *.png, *.tif). Click on button ... Opens the file selection dialog. .
Function | CDynEleFkt | Function | Name of the linked function. Opens the function selection dialog. This function will be executed when the button is clicked in the Runtime or when the assigned key shortcut is pressed. If you wish to execute more than one function, you need to create a script with the required functions and specify the function for executing that script here.SICAM 230 and screen alarming element only: In addition to the standard screen switch property, the screen whose alarm states are supposed to be displayed will be determined by the linked function. Obligatory (unless the Global setting is active )! .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
GraphicSize | Int16 | Graphic size | Definition of the graphics size.Adjusted : The size of the graphics is adjusted to the size of the element.Original size : The linked graphics are displayed in their original size. When selecting this option, the and properties can no longer be configured individually for the multibin, combi-element, button and switch elements. All graphics files should be the same size.Default: adjust .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
MDIFunction | UInt32 | Screen type specific action | Only available in screens with a special screen type (screen type is not standard ): Linking to a screen-specific function. Clicking on the ... button opens the dialog for selecting a screen-specific function. This function is executed if the button is clicked with the mouse in Runtime or the linked key combination is pressed.Attention: In addition to a screen-type specific function, it is also possible to link a general function with the button. In this case, note the sequence of execution when clicking on the button: The screen-type-specific function is executed first. Only once this has been ended is the general function executed. If VBA events are linked to the button in Runtime, these are executed before the functions. .
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
ThreeDimensional | Bool | 3D | Active: The element is displayed in 3D. Inactive: The element is displayed flat. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Bitmap [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Bitmap [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Calander control
ObjectModel COM [image] Element [image] DynProperties [image] Calander control
Overview
External Name | Type | Display Name | Description
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
ColorNonWorkingHours | UInt32 | Fill color non-working time | Fill color of the work-free time. .
ColorWorkingHours | UInt32 | Fill color Working Time | Fill color of the work time. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Legend | String | Text | Label of the element in the Editor. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
ShowBorder | Bool | Show border lines | Visualizes a border for certain elements when displayed in Runtime. The configuration of the and properties is no longer taken into account for the display in Runtime as a result.Active : The element is shown in Runtime with a border.Inactive: No border when displayed in Runtime.Default: inactive. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleH | UInt16 | Style H | Windows style of the element, for internal use only. .
StyleL | UInt16 | Style L | Windows style of the element, for internal use only. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TranslateText | Bool | Translate display text | Active : The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.Default: Inactive .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Calander control [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Circle
ObjectModel COM [image] Element [image] DynProperties [image] Circle
Overview
External Name | Type | Display Name | Description
ALCAlias | Bool | Use alias | Only available if is active.Active : Alias is used. In the Runtime the element receives its ALC colors from another ALC element of the topological model without being part of the model itself. The displayed ALC color of the element is thus not determined by the linked lines. The ALC color is identical to the color of the ALC element, the name of which is linked in the .Inactive : Element is an ALC element according to the configured ALC . The ALC display color is determined by the linked lines.Default: Inactive .
ALCAliasName | String | Alias | Only available if is active.Defined source element for property . Clicking on the ... button opens the dialog to select a pre-configured ALC element in a pre-configured zenon screen. Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project. .
ALCAlternativeColor | UInt32 | Alternative color | Only available if property has value alternative color .Alternative color for the ALC coloring at multiple supply. .
ALCDashLen | Int16 | Dashing length supplied multiple times | Only available if property has value two highest prior sources .Defines the dash length in pixel for the dashed ALC coloring at multiply supply.Minimal: 0 (automatic dash length)Maximum: 32767 Default: 0 .
ALCEnclosementSize | SByte | Curb width [px] | Width of the curb in pixels.Default: 1 pixel Input range: 1 to 20 pixels.Note: Only available if property is active. .
ALCLength | double | Length of the line [km] | ALC line: Length of the line. .
ALCLineName | String | Line name | Unique name of the line. Is used for the identification of the line in the load distribution calculation. In addition, this name is used as interlocking text for the "Overload of a line " topological interlocking.Note : Only available for the Line or Pipe screen element. .
ALCMaxIType | Int16 | Limit value current carrying capacity | Origin of data on the limit value of the current carrying capacity for the calculation of load distribution . The current carrying capacity of the weakest link (cable) in a line. Selection of the type from the drop-down list: Default: Static limit value current carrying capacity Note: The entries in the drop-down list correspond to the properties that follow the Editor directly. .
ALCMaxIVal | double | Static limit value current carrying capacity [A] | Entry of the maximum current-carrying capacity of the weakest link (cable) in the line. Entry in amperes.Default: 20 Not available if the property is configured with limit value of current-carrying capacity dynamic . .
ALCMSecuredSupply | Int16 | display secured supply | Only available if was activated.Definition of the display of the secured supply:double widthdouble brightnessnormalDefault: normal .
ALCMultiSource | Int16 | display multiple supplies | Only available if the property is active. Defines the display type if the element is connected to several sources: most prior source: Only the color of the source with the highest priority is used. two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line. alternative color : Alternative color for the coloring at multiple supply.Default: highest priority source .
ALCPrecedence | Int16 | Priority for display | Only available if the property is active.Defines the priority of the display when the element is connected to several active sources. Multiple supply : The element is displayed according to the rules of the multiple supply. secured supply : The element is displayed according to the rules of the secured supply. No priority : The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.Default: Multiple supply .
ALCReact | double | Reactance value of the cable [Ohm] | Maximum permitted value of the reactance (reactance X) of the line in Ohms. Is used for the detection of the fault locating of protection . .
ALCResist | double | Resistance value of the electric line [Ohm] | Maximum permitted value of the resistance (effective resistance R) of the line in Ohms. Is used for the calculation of load distribution. .
ALCUseColor | Bool | Color from ALC | Only available if you have licensed Automatic Line Coloring (ALC) : Active: The automatic color of the linked source(s) is used. Inactive: The standard color is used. Default: inactive. .
ALCUseEnclosement | Bool | Use curb | Checkbox for the activation of the curb of lines, polylines and pipelines.active: ALC line elements are visualized in Runtime for a ground fault or short circuit with an additional border in the corresponding color. The colors are defined in the ALC project settings.Inactive: No display of curbing in Runtime.Default: Inactive Note: only active if is activated. .
ALCVarCalcI | CDynEleVar | Measuring value of the calculated current flow | Linked variable with the measured value of the calculated current flow of the branch. Calculation result in amperes [A]. .
ALCVarCalcIEx | Node | ALCVarCalcIEx | ALC Leitung: Messwert des berechneten Stromflusses für Export.Mehr in der Online-Hilfe .
ALCVarMaxI | CDynEleVar | Dynamic limit value current carrying capacity | Linked variable for the maximum current-carrying capacity of the weakest link (cable) in the line. Only available if the limit value of current-carrying capacity property is configured with limit value of current-carrying capacity dynamic . .
ALCVarMaxIEx | Node | ALCVarMaxIEx | Node
Align | Int16 | Alignment | Direction of color shift. horizontal vertical
AlphaBackColor | SByte | Transparency of the fill color [%] | .
AlphaBackColor2 | SByte | Transparency gradient color [%] | Only available if Linear was selected in the property. .
AlphaLineColor | SByte | Transparency line color [%] | .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColor2 | UInt32 | Gradient color | Color gradient must be selected for the property.Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of . .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVariable2 | CDynEleVar | Gradient color | Name of the variable whose limit value color should influence the gradient color of the element. Click on the input filed in order to open the dialog for selecting a variable. .
BackColorVariable2Preview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
Brightness | Bool | With brightness values | Only available if was selected as color gradient was selected.Active: The brightness of the color gradient can be freely defined. Inactive: The brightness of the color gradient is defined automatically.Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners. .
ColorGradientAngle | Int16 | Angle [°] | Defines the direction of the color gradient starting in the center of the element.Values: 0° to 360° . Default: 0° .
ColorGradientOffset | Int16 | Offset [%] | Only available if, for a vector element or a dynamic button element, the property has been set. Linear or Selective or Selective with edges .Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.Values: 0 equals the center of the element. 100 the edge. Note: The value can also be outside of the element and is therefore not limited to 100 . .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillColorInvert | Bool | Invert color gradient | Only available if Color gradient was selected as . Active: The brightness gradient is inverted. Inactive: The brightness gradient is not inverted. Default: Inactive .
FillPattern | UInt32 | Fill pattern | Selection of the filling pattern for the element from the list.This property is only available if property is inactive. .
FillStyle | Guid | Fill style |
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
InnerBrightness | SByte | Brightness inside | Only available if "via brightness value" is active : Brightness in the middle of the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Lightning | Int16 | Color gradient | Only available if was set to Color gradient . Defines the color gradient for elements. Linear : steady gradientDefined point : Gradient from a defined point to the edges of the element Selective with edges : Gradient from a defined point to the edges of the element with beamsRadiant : From the bottom to the middle, then gradient from the middle to the top (with rectangular form only).
LineColor | UInt32 | Line color | Line color of the element.
LineColorEx | UInt32 | Line color | Defines the line color of the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LineStyle | Guid | Line style | Display and selection of the line style that is assigned to the element. .
LineType | UInt32 | Line type | Selection of the line type for the element from the list. Attention: If the node in in the project properties, the property has been set to Windows basic , you can only use line width >1 with a "continuous line" type line. .
LineWidth | UInt16 | Line width [Pixel] | Width of the line (in pixels).Minimum: 0 In this case the width of the line is 1 pixel.Maximum: 40 Default: 1 Attention: If in the project settings in node you set property to Windows basis , you can use line width >1 only with a line of type "continuous line". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
MeasuredInputActivePower | Node | Active power input [MW] | Linked variable with the measured value of the active power at the line input. .
MeasuredInputActivePowerImEx | Node | MeasuredInputActivePowerImEx | Description
MeasuredInputCosPhi | Node | cos Phi input | Linked variable with the measured value of the cos phi power factor at the line input. .
MeasuredInputCosPhiImEx | Node | MeasuredInputCosPhiImEx | Description
MeasuredInputCurrent | Node | Power Input [A] | Linked variable with the measured value of the amperage at the line input. .
MeasuredInputCurrentImEx | Node | MeasuredInputCurrentImEx | Description
MeasuredInputReactivePower | Node | Reactive power input [MVar] | Linked variable with the measured value of the reactive power at the line input. .
MeasuredInputReactivePowerImEx | Node | MeasuredInputReactivePowerImEx | Description
MeasuredInputVoltage | Node | Voltage input [kV] | Linked variable with the measured value of the voltage at the line input. .
MeasuredInputVoltageImEx | Node | MeasuredInputVoltageImEx | Description
MeasuredOutputActivePower | Node | Active power output [MW] | Linked variable with the measured value of the active power at the line output. .
MeasuredOutputActivePowerImEx | Node | MeasuredOutputActivePowerImEx | Description
MeasuredOutputCosPhi | Node | cos Phi output | Linked variable with the measured value of the cos phi power factor at the line output. .
MeasuredOutputCosPhiImEx | Node | MeasuredOutputCosPhiImEx | Description
MeasuredOutputCurrent | Node | Power Output [A] | Linked variable with the measured value of the amperage at the line output. .
MeasuredOutputCurrentImEx | Node | MeasuredOutputCurrentImEx | Description
MeasuredOutputReactivePower | Node | Reactive power output [MVar] | Linked variable with the measured value of the reactive power at the line output. .
MeasuredOutputReactivePowerImEx | Node | MeasuredOutputReactivePowerImEx | Description
MeasuredOutputVoltage | Node | Voltage output [kV] | Linked variable with the measured value of the voltage at the line output. .
MeasuredOutputVoltageImEx | Node | MeasuredOutputVoltageImEx | Description
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
OuterBrightness | SByte | Brightness outside | Only available if "via brightness value" is active : Brightness at the outer side of the element. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
Shifted | Int16 | Shifted color gradient | Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein. Mehr im Online-Handbuch
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VarLineCurrent | Node | Current [A] | Linked variable with the result of the load flow calculation for the calculated amperage at the line input. .
VarLineCurrentImEx | Node | VarLineCurrentImEx | Description
VarLinePowerFactorVar | Node | cos Phi output | Linked variable with the result of the load flow calculation for the calculated power factor (cos phi). This corresponds to the average value of the calculated cos phi at the output. .
VarLinePowerFactorVarImEx | Node | VarLinePowerFactorVarImEx | Description
VarLinePowerInVar | Node | Active power input [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line input. .
VarLinePowerInVarImEx | Node | VarLinePowerInVarImEx | Description
VarLinePowerOutVar | Node | Active power output [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line output. .
VarLinePowerOutVarImEx | Node | VarLinePowerOutVarImEx | Description
VarLineReactivePowerInVar | Node | Reactive power input [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line input. .
VarLineReactivePowerInVarImEx | Node | VarLineReactivePowerInVarImEx | Description
VarLineReactivePowerOutVar | Node | Reactive power output [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line output. .
VarLineReactivePowerOutVarImEx | Node | VarLineReactivePowerOutVarImEx | Description
VarLineVoltageInVar | Node | Voltage input [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line input. .
VarLineVoltageInVarImEx | Node | VarLineVoltageInVarImEx | Description
VarLineVoltageOutVar | Node | Voltage output [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line output. .
VarLineVoltageOutVarImEx | Node | VarLineVoltageOutVarImEx | Description
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Circle [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Clock
ObjectModel COM [image] Element [image] DynProperties [image] Clock
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
DynEleVar | Node | DynEleVar | "With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillStyle | Guid | Fill style |
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
Format | UInt16 | Formating | Format of the time/date display. A formatting string is selected from the list. .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalAlign | Int16 | Alignment horizontal | Horizontal orientation of the value for the display. Selection from a drop-down list:Left Right Centered Default: Centered. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
HWDirect | Bool | without dialog | Active: The value is sent to the hardware without a possibility to be changed in the Runtime. Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware. .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
IsSetValue | Bool | Write set value | Active: Setting of set values for this dynamic element is allowed.Inactive: The element is ReadOnly.Not available for the dynamic text element if it has been set to read only in the screen. .
KbdName | String | Screen Keyboard | Only available if property is active.Name of the linked keyboard screen. If no keyboard screen is entered, the respective corresponding keyboard is called up in Runtime:String variable: SETSTRINGKBD Numeric variable: SETVALUEKBD Binary variable: SETBOOLKBD Note: For the input field input option, no keyboard is called up if the option is activated. A keyboard screen must be linked. .
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LimitColor | Bool | Use limit value color | Defines whether the limit value color for the variable linked to the element is displayed in Runtime. The color has an effect on the text displayed, or in the indicator of a universal slider .Active : The defined limit value color is displayed in the Runtime.Default: active .
LimitFromVar | Bool | Take set value limits from variable | Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly. Inactive: The range can be limited directly in the "Minimum" and "Maximum". .
LineColorVariable | CDynEleVar | Text color | Name of the variable whose limit value color is to influence the text color of the element. Click on the ... button to open the dialog for selecting a variable..
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
Max | double | Maximum | Upper limit of the permitted range for the set value. Only available if "Take set value limits from variable" is not active. Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum. .
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
Min | double | Minimum | Bottom limit of the permitted range for the set value. Only available if Take set value limits from variable is not active: Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
Preset | Bool | propose current value | Active: The current value of the variable is proposed as set value. In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value). Inactive: The value defined in "Set value / amend" is proposed. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
Separator | String | Separator | Only available with time difference: : Separator for display of time/date. (e.g. : in 10: 15) .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetProgram | String | External program | Only available if an external program was selected for Write set value : The set value is written by an external program that must be selected in the dialog box that appears here. This program is then started and gets the following parameters: 1) Name of the linked variable 2) Proposed value, as defined in the corresponding properties 3) Left coordinate of the element in pixels 4) Upper coordinate of the element in pixels 5) Right coordinate of the element in pixels 6) Lower coordinate of the element in pixels 7) Permitted minimum for the set value, as defined in the corresponding properties 8) Permitted maximum for the set value, as defined in the corresponding properties .
SetValue | double | Set value/change by | Value that should be sent as the set value or as a default. If "Propose current value" is active: : Value that is added to the current value. In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
SetValueWith | SByte | Write set value via | Configuration of how the target value is set. Select from drop-down list:Command Processing: The new value is set using command processing . For input, the screen that is defined in the command group of the linked variable is opened.Standard dialog box : The new value is entered using the standard dialog box. If a screen of type "Keyboard " with name "SETVALUEKBD " (for numeric values) or "SETSTRINGKBD " (for string variables) exists, it is used instead of the standard dialog box. Note: If the element is linked to a function that allows inputs, is automated automatically. If a screen is linked in the property, this is used. Otherwise a SETSTRINGKBD keyboard is used.Element : The new value is directly entered in the element (only for the elements Numeric value and Text ).Program : The new value is entered in an external program. .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShowState | Bool | Display status of variable | Graphical display of the status of the variable. Selection from a checkbox.Active: The status of the variables is indicated by a colored square at the element. Color : Red square: No communication with the PLC. Example: INVALID, OFF, ALT_VAL, REVISION, TIMEOUT, ...Blue square(N_UPDATE) : On the network client: The client has lost its connection to the Primary Server. With a standalone integration project: The Primary Server has not yet supplied the data.Yellow square (PR_NR) : Visualizes in Runtime that the variable has not been logged during replay in the Process Recorder . No value is therefore known in the playback.Position: The position of the square at the element depends on the element form:Angular and all other elements: Top right cornerRound element: Top, in the middle Rounded element : Top right corner, slightly offset to the left Inactive: The status is not shown. Also deactivates the display of additional variable information with a right click.Default: activated .
ShowUnit | Bool | Show measuring unit | Only available: General: If property has been activated. For the Clock element: if Time difference was selected in the property . For the pointer instrument : if property was activated.Active: The unit of the linked variable is displayed to the right of the value. If the value is displayed in percent, the percent character % is displayed instaed of the unit of the linked variable. Inactive: The technical unit is not displayed. Default: active . Note: .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Text color | Text color of the element. .
TextStyle | Guid | Text style |
TimeStyle | Guid | Time representation style | Display and selection of the time display style that is assigned to the element. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
Transparent | Bool | Transparent | Settings for transparency.Active : Displays the element transparently.Default: Inactive The effect of this option on a button is an Invisible button . It can be positioned above other elements as an invisible button. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
TwoLines | Bool | Two-lined display | Only available with absolute time : Aktive: In the simultaneous display of time and date the time is shown in the first line and the date is shown in the second line. Inactive: Date and time are displayed in a line. Default: active. .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
ValueStyle | Guid | Value display style | Display and selection of the value display style that is assigned to the element. .
Variable | CDynEleVar | Variable | Name of the linked variable. Click on button ... in order to open the dialog for selecting variables. The value of this variable is displayed in this element and can also be set here.Note: Only available for buttons if they are used as a switch .Hint: If the variable value is to be toggled, we recommend activating the property. Only SICAM 230 and Screen Alarm element: The description above only applies to the elements Text Button, Bitmap Button and Invisible Button . Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).Lower bit: Alarm active/inactive Higher bit: Alarm acknowledged/not acknowledged .
VerticalAlign | Int16 | Alignment vertical | Vertical orientation of the value for the display. Selection from a drop-down list:Top Bottom Centered Default: Centered. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
ViewType | Int16 | Display type | Absolute time : the time of the system clock is displayed in the chosen format. Time difference : the value of a linked variable is displayed in the chosen time format. Default: Absolute time period: .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Clock [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Clock [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Combi
ObjectModel COM [image] Element [image] DynProperties [image] Combi
Overview

External Name

Type

Display Name

Description

ActivePowerValue

double

Active power [MW]

Available active power of the element. Entry of a static value (in megawatts) in the input field.Default: 100,000000 [MW] Note: Only available for elements with the Generator , Source or Drain . .

ActivePowerVariable

CDynEleVar

Active power dynamic [MW]

Variable with the available active power of the element. Linking of a numeric variable for the dynamic value (in megawatts). Note: Only available for elements with the Generator , Source or Drain . .

ActivePowerVariableImEx

Node

ActivePowerVariableImEx

Description

ALCAlias

Bool

Use alias

Only available if is active.Active : Alias is used. In the Runtime the element receives its ALC colors from another ALC element of the topological model without being part of the model itself. The displayed ALC color of the element is thus not determined by the linked lines. The ALC color is identical to the color of the ALC element, the name of which is linked in the .Inactive : Element is an ALC element according to the configured ALC . The ALC display color is determined by the linked lines.Default: Inactive .

ALCAliasName

String

Alias

Only available if is active.Defined source element for property . Clicking on the ... button opens the dialog to select a pre-configured ALC element in a pre-configured zenon screen. Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project. .

ALCExchangeInOut

Bool

Switch input/output

Only available if you selected Transformer , Switch, Valve, Check valve or Separator at option .Active: Moves the input of the ALC element to the right or to the bottom and the output to the left or to the top.Default: Inactive .

ALCGroundFaultType

Int16

Type

Selection of the type for the detection of the ground fault. Defines the direction (leading /lagging ) and the processing type of the message (none , Permanent message or Wiper ). Select from drop-down list.none : Normal switchPermanent message : Message is considered as an earth fault triggering.Wiper: Messages that are received during a current Search are suppressedlagging : There is a wait for 2 seconds for the first rising flank of one directionleading : current status of the direction is usedDefault: None More in the online help .

ALCGroundFaultVarDisp

CDynEleVar

Display

Only available if a has been selected. Defines the output variable of the error detection in order to display the status of the earth fault detection device. The variable which is linked there, should be a local variable in order to prevent problems in the network operation. Click on button ... in order to open the dialog for selecting a variable. .

ALCGroundFaultVarDispEx

Node

ALCGroundFaultVarDispEx

Node

ALCGroundFaultVarFwd

CDynEleVar

Forwards

Only available if a has been selected. Defines the variable for the forward earth fault detection. Click on button ... in order to open the dialog for selecting a variable. .

ALCGroundFaultVarFwdEx

Node

ALCGroundFaultVarFwdEx

Node

ALCGroundFaultVarRev

CDynEleVar

Backwards

Only available if a has been selected. Defines the variable for the backward earth fault detection. Click on button ... in order to open the dialog for selecting a variable. .

ALCGroundFaultVarRevEx

Node

ALCGroundFaultVarRevEx

Node

ALCGroundFaultVarTrg

CDynEleVar

Triggering

Only available if a has been selected. Defines the variable which displays the detection of an earth fault. For directed earth fault detection devices the direction ( or ) must be defined additionally. Click on button ... in order to open the dialog for selecting a variable. .

ALCGroundFaultVarTrgEx

Node

ALCGroundFaultVarTrgEx

Node

ALCLinkID

Int16

ALCLinkID

Only available if Link function type has been selected . Identification number of the link. A different link on a different screen with the same information number will take over the data of the source link. .

ALCLinkName

String

Link name

Identification name of the link. Serves to connect the topological network of a zenon screen to another screen. In doing so, several links are connected to the same text. Two texts are identical, regardless of upper case and lower case.Only available if Link has been selected for the property. .

ALCLoadType

Int16

Load

Load type for the type of load distribution calculation.Select from drop-down list:Current load : The measured value is calculated with the current load. Note: The values are read from a linked variable ( property).Historic average load : The measured value is calculated with the average load. Note: The values are read from the configuration of the property.Historic maximum load : The highest load (in the past) is used as the measured value. Note: The values are read from the configuration of the property.Only available for the drain . .

ALCLoadVal

double

Load fixed [A]

Value to be configured for the load distribution calculation. Input in amperes [A].The following is applicable for entry:Positive value : Flow of current to the consuming deviceNegative value : Feed-in, from renewable energies, for example.Only available if the property is configured with historic maximum load or historic average load . .

ALCMaxIType

Int16

Limit value current carrying capacity

Origin of data on the limit value of the current carrying capacity for the calculation of load distribution . The current carrying capacity of the weakest link (cable) in a line. Selection of the type from the drop-down list: Default: Static limit value current carrying capacity Note: The entries in the drop-down list correspond to the properties that follow the Editor directly. .

ALCMaxIVal

double

Static limit value current carrying capacity [A]

Entry of the maximum current-carrying capacity of the weakest link (cable) in the line. Entry in amperes.Default: 20 Not available if the property is configured with limit value of current-carrying capacity dynamic . .

ALCReverseSourceID

Int16

Source for reverse feed

Only available if you have selected Transformer for the property.Selection of the linked transformers.If you select another source as UNDEFINED [0] , the transformer is capable of reverse feed. This means that the transformer behaves the same for both directions - from the input to the output (forward) and also from the output to the input (backward). The only difference is that the property and not the property is used for further distribution of the source number.Note: Defective network statuses or missing configurations, such as a feed from the input and output at the same time or a short circuit from input and output are not specially colored. This means that the transformer capable of taking a reverse feed behaves like two transformers switched to run antiparallel that are not capable of taking a reverse feed. .

ALCShortFaultMarkerColor

UInt32

Marker color

Color of the marker that visualizes the location of a problem in a zenon screen during impedance-based fault locating.Click on the ... button to open the color selection dialog.The following project configuration must be configured to use this property: : Switch : this property must be linked to a REAL data type variable.Note: Only active if the project property is active. .

ALCShortFaultType

Int16

Type

Defines the processing of the message (none or Permanent message and its direction (leading /lagging ).Only available if you selected Switch at property .Select from drop-down list:none : Normal switchPermanent message : Message is considered as an earth fault triggering.lagging : There is a wait for the first rising edge of a directionleading : current status of the direction is usedDefault: None .

ALCShortFaultVarDisp

CDynEleVar

Display

Only available if a has been selected.Defines the output variable of the error detection in order to display the status of the shirt circuit detection device. The variable which is linked there, should be a local variable in order to prevent problems in the network operation. Click on button ... in order to open the dialog for selecting a variable. .

ALCShortFaultVarDispEx

Node

ALCShortFaultVarDispEx

Node

ALCShortFaultVarFwd

CDynEleVar

Forwards

Only available if a has been selected. Defines the variable for the forward short circuit detection. Click on button ... in order to open the dialog for selecting a variable. .

ALCShortFaultVarFwdEx

Node

ALCShortFaultVarFwdEx

Node

ALCShortFaultVarRev

CDynEleVar

Backwards

Only available if a has been selected. Defines the variable for the backward short circuit detection. Click on button ... in order to open the dialog for selecting a variable. .

ALCShortFaultVarRevEx

Node

ALCShortFaultVarRevEx

Node

ALCShortFaultVarTrg

CDynEleVar

Triggering

Only available if a has been selected.Defines the variable for the message of the short circuit detection device. For directed short circuit detection devices the direction ( or ) must be defined additionally. Click on button ... in order to open the dialog for selecting a variable. .

ALCShortFaultVarTrgEx

Node

ALCShortFaultVarTrgEx

Node

ALCSourceID

Int16

Source

Only active, if the function type source or transformer has been selected : Selection of the linked source/transformers. .

ALCStatusHighSourceIn

CDynEleVar

Highest priority source input

Variable for the display of the number of the highest priority ALC source that is currently at the input of the process-technical ALC element.Click on the ... button to open the dialog for selecting a numeric variable. .

ALCStatusHighSourceInImEx

Node

ALCStatusHighSourceInImEx

Description

ALCStatusHighSourceOut

CDynEleVar

Highest priority source output

Variable for the display of a number of the highest priority ALC source that is currently at the output of the process-technical ALC element.Click on the ... button to open the dialog for selecting a numeric variable. .

ALCStatusHighSourceOutImEx

Node

ALCStatusHighSourceOutImEx

Description

ALCStatusSourceListIn

CDynEleVar

Input active sources

Variable for the display of the number of the ALC sources that are currently at the input of the process-technical ALC element. Several sources are separated by a semi colon (;).Clicking on the ... button opens the dialog to select a STRING variable. .

ALCStatusSourceListInImEx

Node

ALCStatusSourceListInImEx

Description

ALCStatusSourceListOut

CDynEleVar

Output active sources

Variable for the display of the number of the ALC sources that are currently at the output of the process-technical ALC element. Several sources are separated by a semi colon (;).Clicking on the ... button opens the dialog to select a STRING variable. .

ALCStatusSourceListOutImEx

Node

ALCStatusSourceListOutImEx

Description

ALCTransformatorName

String

Transformer name

Unique name of the transformer. Is used for the identification of the transformer for the load distribution calculation. In addition, this name is used as interlocking text for the "Overload of a line " topological interlocking. .

ALCType

Int16

Function type

Only available if you have licensed the Automatic Line Coloring (ALC) module.Selection of the function type of the element. Click on opens a drop-down list for selection:Conclusion : For bus bar end; blocks the error message "Line only connected on one side " when being compiled in the Editor.Generator : Element works as a generator, in case of activity the color is forwarded to the next line. Note: This function is the same as for ALC Source No function : The element has no function in the ALC.Capacitor : The capacitor can only be connected as a load on one side. For the load flow calculation, the capacitor serves as compensation for the reactive power.Link : The ALC information is transferred from a source link to a target link.Source : If source is active, the color is forwarded to the next line.Switch : The color is forwarded to the next line if the switch is closed and if it is supplied by a source.Valve : The color is forwarded to the next line if the valve is open or partly open and if it is supplied by a source. Note: This function is the same as for ALC Switch . Values of the main variable: see manual .Drain : This function type has no effect on the coloring. With the help of VBA you can however poll if this device is supplied.Check valve : If the check valve is open, the ALC information is only forwarded in one direction for this function type. The direction is always from the input to the output and not in the other direction. There is only forwarding if the check valve is supplied by a source.Transformer : If the element is supplied, it changes a source (color) into another.Disconnector works in the same way as switch ; contains however a topologic interlocking Disconnector under load . The color is forwarded to the next line if the disconnector is closed and if it is supplied by a source.Default: No function .

ALCVarCalcI

CDynEleVar

Measuring value of the calculated current flow

Linked variable with the measured value of the calculated current flow of the branch. Calculation result in amperes [A]. .

ALCVarCalcIEx

Node

ALCVarCalcIEx

ALC Leitung: Messwert des berechneten Stromflusses für Export.Mehr in der Online-Hilfe .

ALCVarCurI

CDynEleVar

Measured value of the actual current flow

Linked variable with the measured value of the current power flow of the branch. Measured value in amperes [A]. .

ALCVarCurIEx

Node

ALCVarCurIEx

Node

ALCVarCurP

CDynEleVar

Measured value of the current apparent power

Linked value for the measured value of the current apparent power. The linked variable represents the current apparent value in kilovolt amperes [kVA]. This value serves as the direction display of the energy flow. It can be positive or negative. .

ALCVarCurPEx

Node

ALCVarCurPEx

Node

ALCVarLoad

CDynEleVar

Load dynamic

Variable with the value for the calculation of load distribution. The linked variable must be a numerical data type. The following is applicable for entry:Positive value : Flow of power to the consuming deviceNegative value : Feed-in, from renewable energies, for example.Only available if the property is configured with current load . .

ALCVarLoadEx

Node

ALCVarLoadEx

Node

ALCVarMaxI

CDynEleVar

Dynamic limit value current carrying capacity

Linked variable for the maximum current-carrying capacity of the weakest link (cable) in the line. Only available if the limit value of current-carrying capacity property is configured with limit value of current-carrying capacity dynamic . .

ALCVarMaxIEx

Node

ALCVarMaxIEx

Node

ALCVarProtReact

CDynEleVar

Reactance value from protection

Linked value for the measured value from the protective device. The linked variable must be the data type REAL and represents the reactance value in Ohms. .

ALCVarProtReactEx

Node

ALCVarProtReactEx

Node

Angle

Int32

Rotation angle [°]

Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .

BackColorVariable

CDynEleVar

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .

BackColorVarPreview

UInt32

Show color preview

Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .

BkCl2Variable

Node

BkCl2Variable

Node

BkClVariable

Node

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

BlinkingBackColor

UInt32

Flashing color

Background color with option "flashing background transparent" not set. .

BlinkingBackGroundTransparent

Bool

Flashing background transparent

Active: The symbol background is transparent when flashing (bitmap background cannot be displayed as transparent). Inactive: The symbol background is not transparent. .

BlinkingFromAllVariables

Bool

Recognize flashing of all variables

Only available if "Take flashing from main variable" is active : Active: The flashing attributes of all variables are taken. Inactive: Only the flashing attribute of the main variable is taken or there is no flashing (depending on the "Take flashing from main variable" option"). .

BlinkingFromVariable

Bool

Take flashing from main variable

Active: The flashing attribute of the main variables is taken and can be acknowledged on the element. Inactive: No flashing occurs. .

BlinkVar

Node

BlinkVar

Node

ButtonFillColor

UInt32

Fill color

Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .

CalculatedVoltageVar

CDynEleVar

Voltage calculated [kV]

Linked variable with the result of the load flow calculation for the calculated voltage of the load. .

CalculatedVoltageVarImEx

Node

CalculatedVoltageVarImEx

Description

CapacitorCurrentPosition

CDynEleVar

current position

Current position of the capacitor. The current position determines the current stage as the index (starting with 1). The value of a higher position is corrected to the value of the last step. If no position variable is linked for this property, the first increment is used. If no has been configured, the nominal output is used: the standard increment is then 1. .

CapacitorCurrentPositionImEx

Node

CapacitorCurrentPositionImEx

Description

CapacitorStepSize

double

Inkrement [kVAr]

Capacitor increment in kVar. .

CapacitorWiring

String

Interconnection

The interconnection is the steps of a ganged capacitor. It consists of whole figures in the range of 0 to 999. Several steps are separated by a semicolon (';'). The following is applicable for evaluation:Negative figures or an entry > 999 are considered as 0.After a valid number, a text (directly connected or separated by a space) is ignored.At the start of or after a separator, (further) separators or spaces are ignored; .

Chained

Bool

Text chained

Only available for representation type "Status text" : Active: When several states apply, the individual status texts will displayed as a combined string. Inactive: The text of the active status with the highest priority will be used. Default: inactive. .

ColorFromVariable

Bool

Take color of main variable

Active: The fill color at embedded symbols and symbols from the library is taken over from the main variable at status Default if there is a limit value violation at this variable. That means: As long as a limit value violation of the main variable is active, the fill color is taken from the limit color. The color definition of the states is overwritten. Additional status attributes such as Flashing , Transparency or Original symbol color are however taken from the status definition. This property does not effect the bitmap notation.Exception: If at status Default property Original symbol color is activated, the original symbol color is always used. Inactive : The color of the main variable does not effect the displayed color of the combined element. Default: Inactive . .

DisabledStyleAsButtons

Bool

Apply project properties for "locked"

Setting for whether the key actions are taken from the project property. For this, the settings of the following project properties are taken into account: -> -> Possible settings:Active : The settings from the project properties are accepted. Note: The gray setting has no effect on text in symbols.Inactive : The settings are ignored.Default: Inactive .

DragBegin

UInt32

DragBegin

VBA macro that is to be executed when dragging starts. .

DragDrop

UInt32

DragDrop

VBA macro that is to be executed when the mouse button is released. .

DragOver

UInt32

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .

DynEleFkt

Node Node Node

DynEleVar

Node

DynEleVar

"With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"

EnablePunchFrame

Bool

Show border

A frame around the element can be displayed. Default: inactive.

EndX

Int32

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels). .

EndY

Int32

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels). .

FastReaction

Bool

Fast reaction

Only available if is active . Active: The switch immediately changes its position in Runtime, regardless of whether the linked bit has actually been set in the PLC. In the next driver update cycle, the bit will be read from the PLC. Then the switch again ressembles the correct position of the bit in the PLC. Attention: The switch will only be visibly operable after the value has been read from the PLC.Inactive: The switch will change its position only after the bit has been sent to the PLC and then again read from the PLC.Default: inactive. .

FillAreaOnly

Bool

Color fill area only

Active: The color switching only affects the fill area. The color switching also affects the lines. Default: inactive. .

FillColor

Bool

Transparent

Active: The symbol background is transparent. Inactive: The symbol background can be defined individually for each state. Default: inactive. .

FillStyle

Guid

Fill style

FktOnDown

Bool

Function execution on pressing

Active: The linked function is executed when the element is pressed. Inactive: The linked function is executed when the element is released. Default: inactive. .

Font

UInt16

Font

Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .

Function

CDynEleFkt

Function

Name of the linked function. Opens the function selection dialog. This function will be executed when the button is clicked in the Runtime or when the assigned key shortcut is pressed. If you wish to execute more than one function, you need to create a script with the required functions and specify the function for executing that script here.SICAM 230 and screen alarming element only: In addition to the standard screen switch property, the screen whose alarm states are supposed to be displayed will be determined by the linked function. Obligatory (unless the Global setting is active )! .

FunctionParameter

String

Parameter for substitution

Entry of the character sequence for substitution via parameters. Replaces the key word {PARAM} in the substitution dialog of the screen switching.Note: Avoid character sequences that are also used for parameter of the indexing variables, such as {X01} . .

GeneratorReactivePowerVar

CDynEleVar

Reactive power calculated [MVar]

Linked variable with the result of the load flow calculation for the calculated reactive power of the generator. .

GeneratorReactivePowerVarImEx

Node

GeneratorReactivePowerVarImEx

Description

GestureManipulationGroup

Node

Manipulation

Properties for the manipulation of screens and screen elements with touch operation. .

GestureRecognitionActive

Bool

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .

Gestures_CrossSlide

Bool

Cross slide

Active : Detection for Cross Slide set. .

Gestures_CrossSlideExact

Bool

Cross slide exact

Active : Detection for Cross Slide Exact set. .

Gestures_CrossSlideHorizontal

Bool

Cross slide horizontal

Active : Detection for Cross Slide Horizontal set. .

Gestures_CrossSlideRearrange

Bool

Cross slide rearrange

Active : Detection for Cross Slide Rearrange set. .

Gestures_CrossSlideSelect

Bool

Cross slide select

Active : Detection for Cross Slide Select set. .

Gestures_CrossSlideSpeedBump

Bool

Cross slide speed bump

Active : Detection for Cross Slide Speed Bump set. .

Gestures_Drag

Bool

Drag

Active : Detection for Drag set. .

Gestures_Exact

Bool

Exact

Active : Detection for Exact set. .

Gestures_Hold

Bool

Hold

Active : Detection for Hold set. .

Gestures_Manipulation

Bool

Manipulation

Active : Detection for Manipulation set. .

Gestures_RailsX

Bool

Rails X

Active : Detection for Rails X set. .

Gestures_RailsY

Bool

Rails Y

Active : Detection for Rails Y set. .

Gestures_Rotation

Bool

Rotation

Active : Detection for Rotation set. .

Gestures_RotationInertia

Bool

Rotation Inertia

Active : Detection for Rotation Inertia set. .

Gestures_Scaling

Bool

Scaling

Active : Detection for Scaling set. .

Gestures_ScalingInertia

Bool

Scaling inertia

Active : Detection for Scaling Inertia set. .

Gestures_SecondaryTap

Bool

Secondary tap

Active : Detection for Secondary Tap set. .

Gestures_Tap

Bool

Tap

Active : Detection for Tap set. .

Gestures_TapDouble

Bool

Tap double

Active : Detection for Tap Double set. .

Gestures_TranslationInertia

Bool

Translation inertia

Active : Detection for Translation Inertia set. .

Gestures_TranslationX

Bool

Translation X

Active : Detection for Translation X set. .

Gestures_TranslationY

Bool

Translation Y

Active : Detection for Translation Y set. .

GlowEffect2ndBlinkStateVisible

Bool

Make 2. flash state invisible

In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .

GlowEffectActive

Bool

Activate

The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .

GlowEffectAlpha

SByte

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .

GlowEffectBlinkVar

Node

GlowEffectBlinkVar

Node

GlowEffectBlinkVariable

CDynEleVar

Variable for flashing

Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .

GlowEffectBlinkVariablePreview

UInt32

Show flash preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .

GlowEffectColor

UInt32

Color

The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .

GlowEffectEvent

Bool

Active if clicked only

Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .

GlowEffectGlowColorVar

Node

GlowEffectGlowColorVar

Node

GlowEffectGlowColorVariable

CDynEleVar

Variable for color

The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .

GlowEffectGlowColorVariablePreview

UInt32

Show color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .

GlowEffectSpread

SByte

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .

GlowEffectStyle

Guid

Glow effect style

Display and selection of the style for glow effects that are assigned to the element. .

GlowEffectUseBlinkColor

Bool

Adopt flashing color from limit value

In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .

GlowEffectUseColor

Bool

Coloring

Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .

GlowEffectVisibilityFrom

double

Visible from

In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .

GlowEffectVisibilityFromLimit

Bool

Adopt visibility from limit value

In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .

GlowEffectVisibilityTo

double

Visible to

In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .

GlowEffectVisibilityVar

Node

GlowEffectVisibilityVar

Node

GlowEffectVisibilityVariable

CDynEleVar

Variable for visibility

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .

GlowEffectVisibilityVariablePreview

UInt32

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .

Height

Int32

Height [pixels]

Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .

HelpCapture

String

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .

Helpfile

String

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .

HorizontalAlign

Int16

Alignment horizontal

Horizontal orientation of the value for the display. Selection from a drop-down list:Left Right Centered Default: Centered. .

HorizontalOrigin

SByte

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .

HWDirect

Bool

without dialog

Active: The value is sent to the hardware without a possibility to be changed in the Runtime. Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware. .

Init

UInt32

Init

VBA macro that is to be executed when initializing the element. .

Interlocking

UInt32

Interlocking

Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..

InterlockingName

String

InterlockingName

Description

IsPictureSymbol

Bool

Screen symbol active

Only available if, for the property, Graphics file and screen symbol or Status text and screen symbol has been selected.Active: In addition to the animated graphics file or the status text, a screen symbol can be displayed.Inactive: No screen symbol is used. .

IsSetValue

Bool

Write set value

Active: Setting of set values for this dynamic element is allowed.Inactive: The element is ReadOnly.Not available for the dynamic text element if it has been set to read only in the screen. .

KbdName

String

Screen Keyboard

Only available if property is active.Name of the linked keyboard screen. If no keyboard screen is entered, the respective corresponding keyboard is called up in Runtime:String variable: SETSTRINGKBD Numeric variable: SETVALUEKBD Binary variable: SETBOOLKBD Note: For the input field input option, no keyboard is called up if the option is activated. A keyboard screen must be linked. .

KbdUsage

Bool

Use screen Keyboard

At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .

KillFocus

UInt32

KillFocus

VBA macro that is to be executed when the element is no longer in focus. .

LassoSelect

Bool

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .

Layer

SByte

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .

LeftClickDown

UInt32

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element. .

LeftClickUp

UInt32

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element. .

LeftDClick

UInt32

LeftDClick

VBA macro that is to be executed when double clicking the left mouse button on the element. .

LimitFromVar

Bool

Take set value limits from variable

Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly. Inactive: The range can be limited directly in the "Minimum" and "Maximum". .

LnClVariable

Node

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

Locking

UInt32

Interlocking

Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

LostActivePower

double

Loss active power [MW]

Fixed value of the loss active power of the transformer in megawatts.Default: 0.000000 .

LostReactivePower

double

Loss reactive power [MVar]

Fixed value of the loss reactive power of the transformer in megawatts. This is calculated from nominal power * nominal short circuit voltage [%]/100 .Default: 0.000000 .

Max

double

Maximum

Upper limit of the permitted range for the set value. Only available if "Take set value limits from variable" is not active. Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum. .

Menu

String

Context Menu

Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .

Min

double

Minimum

Bottom limit of the permitted range for the set value. Only available if Take set value limits from variable is not active: Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum. .

MouseManipulationETM

Manipulation using mouse

Properties for changing the content of trends in Runtime with the mouse. .

MouseOver

UInt32

MouseOver

VBA macro that is to be executed if the cursor is moved over the element. .

Name

String

Element name

Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .

NominalPower

double

Nominal output [MW]

Fixed value of the nominal power of the transformer in megawatts.Default: 0.000000 .

OriginalSize

Bool

In original size

Active: The graphics are displayed in their original size. Inactive: The graphics are stretched to the size of the element. Default: active Note: If the property is active, it is recommended that the same size is used for all graphics used in the element, because the size of the element adapts itself to the size of the currently-displayed graphics. .

Overlapping

Bool

Overlapping

Only available for the "Symbol from library" display type : Active: If several value assignments are active, the display is overlapping, i.e. all active states are displayed. Inactive: Only the status with the highest priority is displayed. Default: inactive. .

ParamFromScreen

Bool

Take over from calling screen

The function allows the application of the parameters for the substitution of the calling screen.active: Parameter text field is deactivatedDefault: Inactive

Passwordlevel

UInt16

Authorization level

Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .

PhaseShift

double

Phase shift [Degree]

Value of the phase shift in degrees.Note: For the prefix of the phase shift, the value denotes the phase on the input side relative to the output (with phase 0°).Default: 0.000000 This property is only active if has been activated.

PhaseShiftVariable

CDynEleVar

Phase shift dynamic

Linked variable with the value of the phase shifting in degrees. Note: For the prefix of the phase shift, the value denotes of the phase on the input side relative to the output (with phase 0°). This property is only active if has been activated. .

PhaseShiftVariableImEx

Node

PhaseShiftVariableImEx

Description

PhaseVar

CDynEleVar

Phase calculated [Degree]

Linked variables with the result of the load flow calculation for the calculated phase angle of the generator or the load. .

PhaseVarImEx

Node

PhaseVarImEx

Description

PictureSymbol

UInt16

Screen symbol

Only available if, for the property, Only Screen symbol has been selected or if the property has been activated. Selection of the screen symbol, whose color should be switched according to status. This can be a symbol or an element group. .

Preset

Bool

propose current value

Active: The current value of the variable is proposed as set value. In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value). Inactive: The value defined in "Set value / amend" is proposed. .

PrimaryThreeWinding

Bool

Primary coil for three-coil transformer

This property defines (if activated) a transformer in the topological network of the ALC as a three-coil transformer. The load flow calculation is amended accordingly.Active: Primary side is a three-coil transformer. This results in: The three-coil transformer uses the tap change from the primary transformer only, the tap change of the secondary transformer is ignored. A phase shift is only evaluated by the secondary transformers.Inactive: Transformer is calculated in the ALC network of the two-coil transformer.Default: Inactive Attention: If this property is activated, a further two transformers must be connected on the secondary side, which represent the secondary and tertiary coil. .Note also the configuration notes for a three-coil transformer .

PunchFrameAlpha

SByte

Transparency [%]

Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .

PunchFrameAngle

Int16

Angle [°]

Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .

PunchFrameColor

UInt32

Border/shadow color

Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .

PunchFrameOffset

UInt16

Distance [pixels]

Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .

PunchFrameSize

Int32

Shadow size [%]

Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .

PunchFrameSoftFocus

SByte

Blur

Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .

PunchFrameType

SByte

Border type

Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .

PunchFrameWidth

UInt16

Line width [Pixel]

Definition of the line width of the frame in pixel.Default: 1 .

ReactionTime

UInt16

Holding time [ms]

Only available if is active . If is active: Time (in ms) which a state is held starting from the left click on the respective element.If property is inactive: Delayed reaction to a left click. .

ReactivePowerValue

double

Reactive power [MVar]

Reactive power for the element. Entry of a static value (in megavar) in the input field.Default: 0,000000 [MVar] Note: Only available for elements with the Drain . .

ReactivePowerVariable

CDynEleVar

Reactive power dynamic [MVar]

Variable with the reactive power for the element. This variable is primarily to display the reactive power value in Runtime. Linking of a numeric variable for the dynamic value (in megavar). Note: Only available for elements with the Drain . .

ReactivePowerVariableImEx

Node

ReactivePowerVariableImEx

Description

RedPoint

Bool

Display status with square

If an exception status (e.g. "disturbed") is present, a red marking is placed at the top right in the element area. .

RepresentationStyle

UInt16

Type of display

Selection of the display type from drop-down list:Graphics file and screen symbol : You can define a graphics file or a screen symbol (symbol or elemt group) for each status. In addition, the color of a screen symbol can also be changed.Only screen symbol : For every status, you can assign a color to a symbol that already exists in the screen.Symbol from library : For each status a symbol from the library as well as a line and filling color can be selectedSign : For every status, you can define a character (only SICAM 230).Status text and screen symbol: You can define a text for every status. Additionally, you can also change the color of a screen symbol. .

ResetOnLeave

Bool

Reset on exit

Only available if property is active . If you press and hold the mouse button and move the mouse pointer away from the pushbutton, this will automatically reset the value of the variable. .

RightClickDown

UInt32

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element. .

RightClickUp

UInt32

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element. .

RightDClick

UInt32

RightDClick

VBA macro that is to be executed when double clicking the right mouse button on the element. .

Scanner

Bool

Pushbutton

Only available if property is active. (Exception: always available in the switch dynamic element.) Active: The target state - defined in property - is only held as long as the left mouse button is pressed but at least as long as . Inactive: The target state remains even after the mouse button is released. Default: inactive. .

ScannerOn

Bool

Pushbutton On

Only available if is active . Active: Pushbutton switches to ON. Inactive: Pushbutton switches to OFF. Default: Inactive. .

SeparateBlinking

Bool

Separate flashing

Only available if "overlapping" is active. Active: The flashing of each state is shown separately. Inactive: The flashing of the active status with the highest priority will be used. Default: inactive. .

SeparateColors

Bool

Separate colors

Only available if "overlapping" is active. Active: Each state is displayed in its defined color. Inactive: The color of the active status with the highest priority will be used. Default: inactive. .

SetFocus

UInt32

SetFocus

VBA macro that is to be executed when the element is in focus. .

SetProgram

String

External program

Only available if an external program was selected for Write set value : The set value is written by an external program that must be selected in the dialog box that appears here. This program is then started and gets the following parameters: 1) Name of the linked variable 2) Proposed value, as defined in the corresponding properties 3) Left coordinate of the element in pixels 4) Upper coordinate of the element in pixels 5) Right coordinate of the element in pixels 6) Lower coordinate of the element in pixels 7) Permitted minimum for the set value, as defined in the corresponding properties 8) Permitted maximum for the set value, as defined in the corresponding properties .

SetValue

double

Set value/change by

Value that should be sent as the set value or as a default. If "Propose current value" is active: : Value that is added to the current value. In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented. .

SetValueDynMax

CDynEleVar

Maximum

Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .

SetValueDynMin

CDynEleVar

Minimum

Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .

SetValueWith

SByte

Write set value via

Configuration of how the target value is set. Select from drop-down list:Command Processing: The new value is set using command processing . For input, the screen that is defined in the command group of the linked variable is opened.Standard dialog box : The new value is entered using the standard dialog box. If a screen of type "Keyboard " with name "SETVALUEKBD " (for numeric values) or "SETSTRINGKBD " (for string variables) exists, it is used instead of the standard dialog box. Note: If the element is linked to a function that allows inputs, is automated automatically. If a screen is linked in the property, this is used. Otherwise a SETSTRINGKBD keyboard is used.Element : The new value is directly entered in the element (only for the elements Numeric value and Text ).Program : The new value is entered in an external program. .

ShadowEffectStyle

Guid

Borders/shadows effect style

Display and selection of the style for framing and shading that is assigned to the element. .

ShortCut

String

Key combination

Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .

ShowState

Bool

Display status of main variable

If the "Display status" option is highlighted, the current status bit assignment for the stored variable is displayed in online operation in addition to the variable display when the right mouse button is pressed. .

ShuntActivePower

double

Magnetization active power [MW]

Fixed value of the magnetization active power (current measured resistance) of the transformer in megawatts.Default: 0.000000 .

ShuntReactivePower

double

Magnetization reactive power [MVar]

Fixed value of the magnetization reactive power (current measured resistance) of the transformer in megawatts. The magnetization corresponds to the no-load loss.Default: 0.000000 .

Signature

Bool

Signature necessary

Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .

SignatureEditModus

Int16

Signature text editable

Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .

SignatureText

String

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .

StartX

Int32

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels). .

StartY

Int32

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels). .

StateAndTest

UInt32

Configuration and test

Opens the dialog to define the states. .

States

Node

States

Node

Stationname

String

Name for object list

The element is entered in the station list of the worldview screen with the text entered here. .

StayPressed

Bool

Keep pushed state

Only available if properties , and are active. Active: As long as you hold the mouse button pressed on this element, its graphical display does not change - independent of possible values changes in the PLC. At the element Switch property must be active in order for this to happen. Inactive: The element always displays the value of the variable from the PLC. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SupplyNumber

SByte

Supply number

Supply number

Switch

Bool

Switch

Only available if property is inactive.Active: The element switches the value of a bit variable. Inactive: The element carries out a function. Default: Inactive .

SymbolFormClickArea

Bool

Symbol form defines the click area

Makes it possible to create a clickable button in any form. Is only available for option Symbol from library of the combined element.Active: The symbol form is used as a click area. Each element in the symbol is considered individually for the click area.Inactive : The form of the combined element (whole rectangle) is used as click area.Default: Inactive Attention: Not available for Windows CE.Property is available from version 6.51. For projects for earlier versions, the property is treated as inactive . .

Tab

Bool

Focus is set to the element

Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .

TABOrderH

Int32

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..

TABOrderV

Int32

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .

TapOnSecondary

Bool

Tap-change secondarily side

Secondary-side tap change on/off.Active: A tap change is also executed on the secondary side.Inactive: No secondary-side tap changeDefault: inactive This property is only active if has been activated. .Note also the configuration notes for a three-coil transformer .

TapPositionMaximal

Int16

Tap-change maximum

Maximum value of a tap change.Default: 0 .

TapPositionMinimal

Int16

Tap-change minimum

Minimum value of a tap change.Default: 0 .

TapPositionNominal

Int16

Tap-change nominal

Nominal value of a tap change.Default: 0 .

TapPositionVariable

CDynEleVar

Tap-change current position

Linked variable with the value of the current position of the tap change. Note: If the increment increases on the primary side, the secondary voltage falls. .

TapPositionVariableImEx

Node

TapPositionVariableImEx

Description

TapStepSize

double

Tap-change step width [%]

Increment of a tap change in %.Default: 0.000000 .

TextStyle

Guid

Text style

ThreeDimensional

Bool

3D

Active: The element is displayed in 3D. Inactive: The element is displayed flat. .

Tooltip

String

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .

TopologyBorderFOS

Bool

Limit for failure location from protection

TopologyBorderSHL

Bool

Limit for selfhealing

If property is set: The element is considered a limit for a self-healing region.

TopologyBorderSV

Bool

Limit for power distribution calculation

TopologyBorderWBR

Bool

Limit for wide range regulation

If property is set: The element is considered a limit for a wide-range-regulation region.

TopologyLRChanged

Bool

Switch impact direction/mounting direction

Switches the left/right connection for topological elements which have a direction connection.

TopologyResourceNr

UInt32

Resource type

TopologyType

Int16

Topology type

Topology type

TopologyUseFrame

Bool

Use effects/borders for curb

If property is set: The framework configured under effects/frame (width/distance) is used to support the border, including for combined elements

TransformatorActivePowerVarIn

CDynEleVar

Active power input [MW]

Linked variable with the result of the load flow calculation for the calculated active power at the transformer input. .Note also the configuration notes for a three-coil transformer .

TransformatorActivePowerVarInImEx

Node

TransformatorActivePowerVarInImEx

Description

TransformatorActivePowerVarOut

CDynEleVar

Active power output [MW]

Linked variable with the result of the load flow calculation for the calculated active power at the transformer output. .Note also the configuration notes for a three-coil transformer .

TransformatorActivePowerVarOutImEx

Node

TransformatorActivePowerVarOutImEx

Description

TransformatorCurrentVarIn

CDynEleVar

Power Input [A]

Linked variable with the result of the load flow calculation for the calculated amperage at the transformer input. .Note also the configuration notes for a three-coil transformer .

TransformatorCurrentVarInImEx

Node

TransformatorCurrentVarInImEx

Description

TransformatorCurrentVarOut

CDynEleVar

Power Output [A]

Linked variable with the result of the load flow calculation for the calculated amperage at the transformer output. .Note also the configuration notes for a three-coil transformer .

TransformatorCurrentVarOutImEx

Node

TransformatorCurrentVarOutImEx

Description

TransformatorReactivePowerVarIn

CDynEleVar

Reactive power input [MVar]

Linked variable with the result of the load flow calculation for the calculated reactive power at the transformer input. .Note also the configuration notes for a three-coil transformer .

TransformatorReactivePowerVarInImEx

Node

TransformatorReactivePowerVarInImEx

Description

TransformatorReactivePowerVarOut

CDynEleVar

Reactive power output [MVar]

Linked variable with the result of the load flow calculation for the calculated reactive power at the transformer output. .Note also the configuration notes for a three-coil transformer .

TransformatorReactivePowerVarOutImEx

Node

TransformatorReactivePowerVarOutImEx

Description

TransformatorVoltageVarIn

CDynEleVar

Voltage input [kV]

Linked variable with the result of the load flow calculation for the calculated voltage at the transformer input. .Note also the configuration notes for a three-coil transformer .

TransformatorVoltageVarInImEx

Node

TransformatorVoltageVarInImEx

Description

TransformatorVoltageVarOut

CDynEleVar

Voltage output [kV]

Linked variable with the result of the load flow calculation for the calculated voltage at the transformer output. .Note also the configuration notes for a three-coil transformer .

TransformatorVoltageVarOutImEx

Node

TransformatorVoltageVarOutImEx

Description

TransformerSide

SByte

Transformer side

Transformer side

TwistVar

Node

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

TwistVariable

CDynEleVar

Variable

Name of the variable for rotating the element. .

TwistVarMax

double

Max. variable value

Maximum variable value for rotating the element. .

TwistVarMin

double

Min. variable value

Minimum variable value for rotating the element. .

TwistViewMax

Int32

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °). .

TwistViewMin

Int32

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °). .

UnderCE

Bool

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .

Variable

CDynEleVar

Variable

Name of the linked variable. Click on button ... in order to open the dialog for selecting variables. The value of this variable is displayed in this element and can also be set here.Note: Only available for buttons if they are used as a switch .Hint: If the variable value is to be toggled, we recommend activating the property. Only SICAM 230 and Screen Alarm element: The description above only applies to the elements Text Button, Bitmap Button and Invisible Button . Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).Lower bit: Alarm active/inactive Higher bit: Alarm acknowledged/not acknowledged .

VerticalAlign

Int16

Alignment vertical

Vertical orientation of the value for the display. Selection from a drop-down list:Top Bottom Centered Default: Centered. .

VerticalOrigin

SByte

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .

VisibilityFrom

double

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .

VisibilityFromLimit

Bool

adopt from limit value

Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .

VisibilityTo

double

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .

VisibilityType

UInt32

Visibility

Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .

VisibilityVariable

CDynEleVar

Variable

Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..

VisibleWhenInterlocked

Bool

Visible if interlocked

Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .

VisVariable

Node

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

VisVarPreview

UInt32

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .

Voltage

double

Voltage [kV]

Strength of the voltage of the element. Entry of a static value (in kilovolt) in the input field.Default: 0,000000 [kV] Note: Only available for elements with Source or Generator . .

VoltageVariable

CDynEleVar

Voltage dynamic [kV]

Voltage value of the element. This variable is primarily to display the voltage value of the element in Runtime. Linking of a numeric variable for the dynamic value (in kilovolt). Note: Only available for elements with Source or Generator . .

VoltageVariableImEx

Node

VoltageVariableImEx

Description

Width

Int32

Width [pixels]

Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .

Wordbreak

Bool

Automatic word wrap

Active: Automatic word wrap is used for the text in the element. The length of the lines depends on the width of the element.Inactive: The text is displayed in one line.Default: Inactive .

XVar

Node

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

XVariable

CDynEleVar

Variable

Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .

XVarMax

double

Max. variable value

Maximum variable value for the horizontal movement of the element. .

XVarMin

double

Min. variable value

Minimum variable value for the horizontal movement of the element. .

XVarZoom

Node

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

XViewMax

Int32

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels). .

XViewMin

Int32

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels). .

XZoomVariable

CDynEleVar

Variable

Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .

XZoomVarMax

double

Max. variable value

Maximum variable value for the zooming of the width of the element. .

XZoomVarMin

double

Min. variable value

Minimum variable value for the zooming of the width of the element. .

XZoomViewMax

Int32

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %). .

XZoomViewMin

Int32

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %). .

YVar

Node

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

YVariable

CDynEleVar

Variable

Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .

YVarMax

double

Max. variable value

Maximum variable value for the vertical movement of the element. .

YVarMin

double

Min. variable value

Minimum variable value for the vertical movement of the element. .

YVarZoom

Node

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

YViewMax

Int32

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels). .

YViewMin

Int32

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels). .

YZoomVariable

CDynEleVar

Variable

Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .

YZoomVarMax

double

Max. variable value

Maximum variable value for the zooming of the height of the element. .

YZoomVarMin

double

Min. variable value

Minimum variable value for the zooming of the height of the element. .

YZoomViewMax

Int32

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %). .

YZoomViewMin

Int32

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %). .

ZoomMax

Int16

Visible to

Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .

ZoomMin

Int16

Visible from

Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleFkt
ObjectModel COM [image] Element [image] DynProperties [image] Combi [image] CDynEleFkt
Overview
External Name | Type | Display Name | Description
Name | String | Name |
ProjectFunction | CProjektFunktion | ProjectFunction |


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Combi [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CStatusElemZustand
ObjectModel COM [image] Element [image] DynProperties [image] Combi [image] CStatusElemZustand
Overview
External Name | Type | Display Name | Description
Additive | UInt32 | Additive |
AdditiveMask | UInt32 | AdditiveMask |
BkColor | UInt32 | BkColor |
BkTransparent | Bool | BkTransparent |
Blinking | Bool | Blinking |
Color | UInt32 | Color |
DownText | String | DownText |
Formula | String | Formula |
IsSymbolColor | Bool | IsSymbolColor |
IsTopologyBkColor | Bool | IsTopologyBkColor |
IsTopologyColor | Bool | IsTopologyColor |
LayerTransparent | Bool | LayerTransparent |
Status | UInt64 | Status |
StatusMask | UInt64 | StatusMask |
SymbolName | String | SymbolName |
SymbolPath | String | SymbolPath |
TextOrBitmap | String | TextOrBitmap |
Value | UInt32 | Value |
ValueMask | UInt32 | ValueMask |


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Combi [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Combo Listbox
ObjectModel COM [image] Element [image] DynProperties [image] Combo Listbox
Overview
External Name | Type | Display Name | Description
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorSelected | UInt32 | Background color when selected | Defines the background color when an element is selected. The color is static and does not use the linked variable. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
ControlType | UInt16 | Type | Combobox : This element is used as a combobox.Listbox : This element is used as a list box.Default: Listbox .
DynContentVariable | CDynEleVar | Variable | Only available if property is active.Selection of the string variable which contain the entries for the combo-/listbox. A click on the ... button opens the dialog for variable selection. .
DynEleVar | Node | DynEleVar | "With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillStyle | Guid | Fill style |
FillStyleForSelected | Guid | Fill style on selection | Display and selection of the fill style during selection that is assigned to the element. .
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
InstantReaction | Bool | Fast reaction | Allows you to display a reaction as already happened, even if the response of a slowly reacting driver has not been received yet.active: Displays the driver reaction as already happened in the visualization, even if it is still outstanding.Default: activeNote: In case the driver does not react, the absence of the reaction will not be noticed. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LineColorVariable | CDynEleVar | Text color | Name of the variable whose limit value color is to influence the text color of the element. Click on the ... button to open the dialog for selecting a variable..
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShowState | Bool | Display status of variable | Graphical display of the status of the variable. Selection from a checkbox.Active: The status of the variables is indicated by a colored square at the element. Color : Red square: No communication with the PLC. Example: INVALID, OFF, ALT_VAL, REVISION, TIMEOUT, ...Blue square(N_UPDATE) : On the network client: The client has lost its connection to the Primary Server. With a standalone integration project: The Primary Server has not yet supplied the data.Yellow square (PR_NR) : Visualizes in Runtime that the variable has not been logged during replay in the Process Recorder . No value is therefore known in the playback.Position: The position of the square at the element depends on the element form:Angular and all other elements: Top right cornerRound element: Top, in the middle Rounded element : Top right corner, slightly offset to the left Inactive: The status is not shown. Also deactivates the display of additional variable information with a right click.Default: activated .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
States | Node | States | With this property you have the opportunity to get/set some properties of the different statis. The settings can be handled via some subitems.
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
Status | String | Entries | Only available if the property is inactive.Clicking on the ... button opens the dialog for defining the entries for a static list box / combo box. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TextColor | UInt32 | Text color | Text color of the element. .
TextColorSelected | UInt32 | Text color when selected | Defines the color of the text when an element is selected. The color is static and does not use the linked variable. .
TextStyle | Guid | Text style |
TextStyleForSelected | Guid | Text style on selection | Display and selection of the text style that is assigned to the element during selection. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
UseDynContent | Bool | Entries from string variable | Active : Entries in combo-/listbox are defined via the selected string variable in property .Inactive: Entries are defined via the dialog of property in the Editor.Default: Inactive .
Variable | CDynEleVar | Variable | Name of the linked variable. Click on button ... in order to open the dialog for selecting variables. The value of this variable is displayed in this element and can also be set here.Note: Only available for buttons if they are used as a switch .Hint: If the variable value is to be toggled, we recommend activating the property. Only SICAM 230 and Screen Alarm element: The description above only applies to the elements Text Button, Bitmap Button and Invisible Button . Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).Lower bit: Alarm active/inactive Higher bit: Alarm acknowledged/not acknowledged .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Combo Listbox [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CDynEleVarMulti
ObjectModel COM [image] Element [image] DynProperties [image] Combo Listbox [image] CDynEleVarMulti
Overview
External Name | Type | Display Name | Description
BitmapHigh | String | BitmapHigh | "With this item you have the opportunity to get/set the picture for the ""high"" state of a multibin element via a string."
BitmapLow | String | BitmapLow | "With this item you have the opportunity to get/set the picture for the ""low"" state of a multibin element via a string."
Bits | String | Bits |
BkColorHigh | UInt32 | BkColorHigh |
BkColorLow | UInt32 | BkColorLow |
ColorHigh | UInt32 | ColorHigh |
ColorLow | UInt32 | ColorLow |
KeyFlags1 | UInt32 | KeyFlags1 | "A long value which sets the keys for the ""key combination"" property of the multibin element. This property is available when a bool variable is linked to the element. "
KeyFlags2 | UInt32 | KeyFlags2 | "A long value which sets the keys for the ""key combination"" property of the multibin element. This property is available when a bool variable is linked to the element. "
KeyFlags3 | Int16 | KeyFlags3 | "A long value which sets the keys for the ""key combination"" property of the multibin element. This property is available when a bool variable is linked to the element. "
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
StateTextHigh | String | StateTextHigh | With this property you have the opportunity to get/set the text for the high state of the mulibin element.
StateTextLow | String | StateTextLow | With this property you have the opportunity to get/set the text for the low state of the mulibin element.
Symbol | UInt16 | Symbol | A symbol can be selected from the list of symbols present in the screen. .
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.
Value | UInt32 | Value |


Combobox
ObjectModel COM [image] Element [image] DynProperties [image] Combobox
Overview
External Name | Type | Display Name | Description
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Legend | String | Text | Label of the element in the Editor. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
ShowBorder | Bool | Show border lines | Visualizes a border for certain elements when displayed in Runtime. The configuration of the and properties is no longer taken into account for the display in Runtime as a result.Active : The element is shown in Runtime with a border.Inactive: No border when displayed in Runtime.Default: inactive. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleH | UInt16 | Style H | Windows style of the element, for internal use only. .
StyleL | UInt16 | Style L | Windows style of the element, for internal use only. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Text color | Text color of the element. .
TranslateText | Bool | Translate display text | Active : The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.Default: Inactive .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Combobox [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Command
ObjectModel COM [image] Element [image] DynProperties [image] Command
Overview
External Name | Type | Display Name | Description
Action | Node | Action | Properties for command actions .
AlwaysSelectable | Bool | always available | Active: Command selection directly via left mouse click.Inactive: Command selection only possible after previous selection function (Functions ->Application->Command activation ) After commands have been activated in Runtime, a border will be displayed around all elements that have been configured this way.Create a new command action via right mouse click -> Action new. Attention: only available in the left window in the dialog view.
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDrawBefCommand
ObjectModel COM [image] Element [image] DynProperties [image] Command [image] CDrawBefCommand
Overview
External Name | Type | Display Name | Description
ActivationGroup | Int16 | Activation group | Specifies the activation group.Only required in combination with the pre-selection function.
Function | CProjektFunktion | Function | Specifies the function to be executed for mode: Function . No longer used. Kept only for reasons of compatibility with older versions.
Mode | UInt16 | Mode | Used for selecting the intended purposeInput: Command element will be used for command inputFunction call: Command element will be used for executing functions. This option only exists for reasons of compatibility with older versions and should not be used any longer.
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
PictFilter |  | PictFilter |
PictSwitch | Node | PictSwitch | Node


CD_CBildumschaltung
ObjectModel COM [image] Element [image] DynProperties [image] Command [image] CDrawBefCommand [image] CD_CBildumschaltung
Overview
External Name | Type | Display Name | Description
ALCSubstitution | Node | ALCSubstitution | Node
CaseSensitive | Bool | CaseSensitive | "Indices substitution is case sensitive, if set TRUE."
IndexSubstitution | Node | IndexSubstitution | "Replaces the indices Debug.Print zFct.DynProperties(""PictSwitch.IndexSubstitution[-1]"") 'Output the amount of substituted indices Debug.Print zFct.DynProperties(""PictSwitch.IndexSubstitution[0].Source"") 'Access the name of the first variable Debug.Print zFct.DynProperties(""PictSwitch.IndexSubstitution[0].Destination"") 'Name of the corresponding substitution variable"
IndexVar | Node | IndexVar | "Accesses the assigned variables for the index substitution. Debug.Print zFct.DynProperties(""PictSwitch.IndexVar[-1]"") 'Amount of assigned variables Debug.Print zFct.DynProperties(""PictSwitch.IndexVar[0].Title"").Name 'Name of first variable"
IsCallingPic | Bool | IsCallingPic | Specifies the variable unit.
IsFilterRT | Bool | IsFilterRT | "Displays the picture selection dialog within the runtime, if set TRUE."
IsMonScroll | Bool | IsMonScroll | "Scrolls to the corresponding monitor on picture switch, if set TRUE."
Monitor | Int16 | Monitor | Defines on which monitor the picture is displayed. -2 = Relative to caller 0 = Display 0 (default display) 1 = Display 1 (only for multi-monitor projects) ... = etc.
Picture | String | Picture | Gets or sets the name of the switching picture.
ProjectName | String | ProjectName | "Gets or sets the project name where the picture is defined. Hint: The current project will be used, if this property is not specified."
SubstiFkt | Node | SubstiFkt | "Function substitution Debug.Print zFct.DynProperties(""PictSwitch.SubstiFkt[-1]"") 'Outputs the amount of substituted functions Debug.Print zFct.DynProperties(""PictSwitch.SubstiFkt[0].Source"") 'Access the name of the first source function Debug.Print zFct.DynProperties(""PictSwitch.SubstiFkt[0].Destination"") 'Name of the corresponding substitution function"
SubstiVar | Node | SubstiVar | "Variable substitution Debug.Print zFct.DynProperties(""PictSwitch.SubstiVar[-1]"") 'Outputs the amount of substituted variables Debug.Print zFct.DynProperties(""PictSwitch.SubstiVar[0].Source"") 'Access the name of the first source variable Debug.Print zFct.DynProperties(""PictSwitch.SubstiVar[0].Destination"") 'Name of the corresponding substitution variable"
WndType | UInt32 | WndType | Only users with the appropriate user authorization can edit entries in the database of the Industrial Performance Analyzer (IPA).


CIndexSubsti
ObjectModel COM [image] Element [image] DynProperties [image] Command [image] CDrawBefCommand [image] CD_CBildumschaltung [image] CIndexSubsti
Overview
External Name | Type | Display Name | Description
Destination | String | Destination | "The name of the variable, which should replace the source."
Source | String | Source | "The name of the variable linked in the picture, which should be replaced."


CProjektVariableProp
ObjectModel COM [image] Element [image] DynProperties [image] Command [image] CDrawBefCommand [image] CD_CBildumschaltung [image] CProjektVariableProp
Overview
External Name | Type | Display Name | Description
Title | CProjektVariable | Title | Gets or sets a variable object.


CSubsti
ObjectModel COM [image] Element [image] DynProperties [image] Command [image] CDrawBefCommand [image] CD_CBildumschaltung [image] CSubsti
Overview
External Name | Type | Display Name | Description
Destination | String | Destination | Name of target variable/function for the substitution.
Source | String | Source | Name of the source variable/function for the substitution. ATTENTION: Wildcards (*) are allowed at the beginning and at the end of the variable or function name.


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Command [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Command [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Dynamic window batch parameter list
ObjectModel COM [image] Element [image] DynProperties [image] Dynamic window batch parameter list
Overview
External Name | Type | Display Name | Description
AdvancedStyleH | Bool | Extended graphical settings | Controls the use of the customizable horizontal and vertical scroll bars, the header and the grid. If you activate this property, you can customize the display of the list field as you wish.Default: Inactive . .
AscSortImage | String | Sort ascending | Select a graphics file that is to be displayed in the header of the list field for ascending sort in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> for AML . for CEL . for ETM .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColor2H | UInt32 | Gradient color | Define the second filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property .As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColor2V | UInt32 | Gradient color | Define the second filling color which is used for the color gradient for the vertical scroll bar. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property .As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColorH | UInt32 | Fill color | Define the first filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColorV | UInt32 | Fill color | Define the first filling color which is used for the color gradient for the vertical scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BarStyleH | Int16 | Display style | Define how the header of the list field should look like. Select one of the following options:Color gradient : Uses a special color gradient for the header. You can customize the color gradient with the help of properties , , , and .Graphics file : Uses the selected graphics files for the individual areas. If no graphics files have been selected, the Color gradient display is used.Standard : Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.Default: Standard . .
BarStyleV | Int16 | Display style | Define how the header of the list field should look like. Select one of the following options:Color gradient : Uses a special color gradient for the header. You can customize the color gradient with the help of properties , , , and .Graphics file : Uses the selected graphics files for the individual areas. If no graphics files have been selected, the Color gradient display is used.Standard : Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.Default: Standard . .
BitmapLeftH | String | Scroll arrow left | Select a graphics file that is to be displayed in the list field for the left scroll arrow for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapLeftV | String | Scroll arrow up | Select a graphics file that is to be displayed in the list field for the up scroll arrow for the vertical scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapRightH | String | Scroll arrow right | Select a graphics file that is to be displayed in the list field for the right scroll arrow for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapRightV | String | Scroll arrow down | Select a graphics file that is to be displayed in the list field for the down scroll arrow for the vertical scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapSpanH | String | Background graphics file | Select a graphics file that is to be displayed in the list field as a background for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapSpanV | String | Background graphics file | Select a graphics file that is to be displayed in the list field as a background for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapThumbH | String | Scroll box | Select a graphics file that is to be displayed in the list field for the scroll box for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapThumbV | String | Scroll box | Select a graphics file that is to be displayed in the list field for the scroll box for the vertical scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
ButtonHeightH | Int16 | Height scroll arrow [Pixel] | Define the height of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.Default: 12 . .
ButtonHeightV | Int16 | Height scroll arrow [Pixel] | Define the height of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.Default: 12 . .
ButtonWidthH | Int16 | Width scroll arrow [Pixel] | Define the width of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.Default: 12 . .
ButtonWidthV | Int16 | Width scroll arrow [Pixel] | Define the width of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.Default: 12 . .
CheckOffImage | String | Off | Selection of a graphic which displays status "value is 0 and property cannot be edited ". .
CheckOffImageInActive | String | Off (inactive) | Selection of a graphic which displays status "value is 0 and property cannot be edited ". .
CheckOnImage | String | On | Selection of a graphic which displays status "value is 1 and property cannot be edited ". .
CheckOnImageInActive | String | On (inactive) | Selection of a graphic which displays status "value is 1 and property cannot be edited ". .
ColorGradientAngleH | Int16 | Angle [°] | Define the angle in whose direction the color gradient spreads. As starting point the point defined in property is used.Minimum: 0 Maximum: 360 Default: 0 .
ColorGradientAngleV | Int16 | Angle [°] | Define the angle in whose direction the color gradient spreads. As starting point the point defined in property is used.Minimum: 0 Maximum: 360 Default: 0 .
ColorGradientOffsetH | Int16 | Offset [%] | Define the distance of the color gradient point from the center of the horizontal scroll bar to the left or the right in percent. 0 means the center of the horizontal scroll bar, 100 means the right edge of the horizontal scroll bar and -100 means the left edge of the horizontal scroll bar.Minimum: -100 Maximum: 100 Default: 0 .
ColorGradientOffsetV | Int16 | Offset [%] | Define the distance of the color gradient point from the center of the vertical scroll bar to the left or the right in percent. 0 means the center of the vertical scroll bar, 100 means the right edge of the vertical scroll bar and -100 means the left edge of the vertical scroll bar.Minimum: -100 Maximum: 100 Default: 0 .
ColumnOrderStatic | Bool | Freeze column location | For configurable lists, controls the possibility to move table columns in Runtime with mouse actions.Active : The columns cannot be arranged by dragging & dropping. The column width can still be amended by dragging with the mouse.Inactive : The columns can be arranged by means of drag&drop. The column width can be amended by dragging with the mouse.If there is an element in the screen that has column selection via the , this element is deactivated if the property is active.Default: Inactive . With the property activated, neither sorting by means of drag&drop nor amendment of the column width with the mouse is possible.
ColumnOrderStatic | Bool | Freeze column location | For configurable lists, controls the possibility to move table columns in Runtime with mouse actions.Active : The columns cannot be arranged by dragging & dropping. The column width can still be amended by dragging with the mouse.Inactive : The columns can be arranged by means of drag&drop. The column width can be amended by dragging with the mouse.If there is an element in the screen that has column selection via the , this element is deactivated if the property is active.Default: Inactive . With the property activated, neither sorting by means of drag&drop nor amendment of the column width with the mouse is possible.
DescDownImage | String | Sort descending | Select a graphics file that is to be displayed in the header of the list field for descending sort in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> for AML . for CEL . for ETM .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnableHeader | Bool | Make header editable | Makes it possible to operate the header for the respective list field. You can change the width of the columns and sort the display according to any desired column in Runtime.active : The header can be operated.Default: active Availability: Available for AML and CEL under the following conditions: If you selected operable header in the group for the property or in the group for the property. for AML . for CEL . for ETM .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
GridColorH | UInt32 | Horizontal line color | Defines the line color of the horizontal grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
GridColorV | UInt32 | Vertical line color | Defines the line color of the vertical grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
GridSizeH | UInt16 | Horizontal line width [Pixel] | Width of the horizontal grid line in pixel. Change this value in order to change the horizontal lines of the grid of the list view in the Runtime. If you enter 0 , the horizontal lines are hidden.Default: 1 . .
GridSizeV | UInt16 | Vertical line width [Pixel] | Width of the vertical grid line in pixel. Change this value in order to change the vertical lines of the grid of the list view in the Runtime. If you enter 0 , the vertical lines are hidden.Default: 1 . .
GridTypeH | UInt32 | Horizontal line type | Defines the type of the horizontal grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).Default: solid line.Attention: This property is available if the value for property is 1 . For values >1 a solid line is used. .
GridTypeV | UInt32 | Vertical line type | Defines the type of the vertical grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).Default: solid line.Attention: This property is available if the value for property is 1 . For values >1 a solid line is used. .
HeaderBackColor | UInt32 | Fill color | Define the first filling color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. for AML . for CEL . for ETM .
HeaderBackColor2 | UInt32 | Gradient color | Define the second fill color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property .As color for a newly created element the color which was used for the previous element of the same type is used. AML . CEL . for ETM .
HeaderBarImage | String | Background | Select a graphics file that is to be displayed in the header of the list field as a background in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> for AML . for CEL . for ETM .
HeaderColorGradientAngle | Int16 | Angle | Define the angle in whose direction the color gradient spreads. As starting point the point defined in property is used.Minimum: 0 Maximum: 360 Default: 0 AML . CEL . for ETM .
HeaderColorGradientOffset | Int16 | Offset | Define the distance of the color gradient from the center of the header to the left or the right in percent. 0 means the center of the header, 100 means the right edge of the header and -100 means the left edge of the header.Minimum: -100 Maximum: 100 Default: 0 AML . CEL . for ETM .
HeaderFont | UInt16 | Font | Define the font which should be used for the text in the header. Clicking on the button opens a dialog for selecting the pre-defined fonts.As font for a newly created element the font which was used for the previous element of the same type is used. for AML . for CEL . for ETM .
HeaderFontColor | UInt32 | Text color | Define the color which should be used for the text in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. for AML . for CEL . for ETM .
HeaderHeight | UInt32 | Height of the header [in pixels] | Configuration of the height of the header in pixels.Minimum: 0 - height is automatically determined using the font size.Maximum: 255 Default: 0 .
HeaderLightning | Int16 | Light effect | Select the type of the color gradient for the header from the following options:Linear : steady gradientDefined point : Gradient from the defined point to the edges of the elementStarting from a defined point with beams : Gradient with beams from the defined point to the edges of the elementDefault: Linear AML . CEL . for ETM .
HeaderStatic | Bool | HeaderStatic | Active : Columns can no longer be moved by dragging & dropping in Runtime and also cannot be sorted. The column width can be adjusted again. .
HeaderStyle | Int16 | Display style | Define how the header of the list field should look like. Select one of the following options:Color gradient : Uses a special color gradient for the header. You can customize the color gradient with the help of properties , , , and .Graphics file : Uses the selected graphics files for the individual areas. If no graphics files have been selected, the Color gradient display is used.Standard : Uses the standard setting for the header. You can only change the and the with the help of the respective setting.Default: Standard . for AML . for CEL . for ETM .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HideColumnSettingsMenu | Bool | Deactivate context menu | Allows the display and hiding of the context menus of the headers.Active : Context menu is deactivated.Inactive : Context menu is activated. The list can be configured in Runtime.Default: Inactive .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
IsSetValue | Bool | Write set value | Active: Setting of set values for this dynamic element is allowed.Inactive: The element is ReadOnly.Not available for the dynamic text element if it has been set to read only in the screen. .
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Legend | String | Text | Label of the element in the Editor. .
LightningH | Int16 | Color gradient | Select the type of the color gradient for the horizontal scroll bar from the following options:Linear : steady gradientDefined point : Gradient from the defined point to the edges of the elementStarting from a defined point with beams : Gradient with beams from the defined point to the edges of the elementDefault: Linear .
LightningV | Int16 | Color gradient | Select the type of the color gradient for the vertical scroll bar from the following options:Linear : steady gradientDefined point : Gradient from the defined point to the edges of the elementStarting from a defined point with beams : Gradient with beams from the defined point to the edges of the elementDefault: Linear .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
NoSortHeader | Bool | Disable sorting | Controls the possibility of sorting table columns in Runtime with a click on the header.Active : The table cannot be sorted by means of clicking.Inactive : The table can be sorted by clicking in the header of the column.Default: Inactive
NoSortHeader | Bool | Disable sorting | Controls the possibility of sorting table columns in Runtime with a click on the header.Active : The table cannot be sorted by means of clicking.Inactive : The table can be sorted by clicking in the header of the column.Default: Inactive
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RowHeight | UInt32 | Line height [pixel] | Makes it possible to define the row height in pixels independent of the font size.Maximum value: 255 px Minimum value : 0 px - row height is adapted to font size.Default : 0 Attention: If the row heightis selected is too large, nothing is displayed in Runtime in certain circumstances.is selected as smaller than the font size, then graphical illustrations are cut off. .
SelectionActive | CDynEleVar | Selection active | Linking of a response variable for configurable lists . The variable must be of the type BOOL . It shows in Runtime whether something has been selected in the list (1 ) or not (0 ). Clicking on the ... button opens the dialog to select a variable. .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
ShowBoolAsNumber | Bool | Numeric display | Active : Binary values are displayed numerically in Runtime. If the list element allows it, binary values can also be entered numerically. .
ShowFilter | Bool | Show filter row | Active : The filter line is displayed in Runtime.Inactive : The filter line is not shown in Runtime. Note: Configured filters are also implemented if the filter line is not shown. .
ShowHeader | Bool | Show header | Only available if you have selected operable header or fixed header in the project settings in the group for the property or in the group for the property. Displays the header for the respective list field. In group you can customize the look of the header.active: The header is displayed.Default: active for AML . for CEL . for ETM .
ShowHeader | Bool | Show header | Active : The header is displayed in Runtime.Inactive : The header is not shown in Runtime. The filter line is thus also not shown, but configured filters continue to be used. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Text color | Text color of the element. .
ThumbSizeH | Int16 | Width scroll box [Pixel] | Define the width of the scroll box in pixel for the horizontal scroll bar. Adjust the value to your ideas.Default: 20 . .
ThumbSizeV | Int16 | Width scroll box [Pixel] | Define the width of the scroll box in pixel for the vertical scroll bar. Adjust the value to your ideas.Default: 20 . .
TranslateText | Bool | Translate display text | Active : The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.Default: Inactive .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
WordWrap | Bool | Automatic word wrap | Allows multi-line display of texts in the list if the column width for the text to be shown is not sufficient. In doing so, the line height is enlarged accordingly.Active : If the column width is not sufficient, a line break is carried out and the line height is increased.Inactive : No word wrap is performed, the display is in one line.Info: A word wrap is only carried out if there are empty spaces in the text to be displayed (spaces, tabs or similar) or if a line break is inserted manually by means of a \n in the text. No line break is carried out for uninterrupted texts.Default: Inactive for AML . for CEL .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Dynamic window batch parameter list [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Dynamic window list control
ObjectModel COM [image] Element [image] DynProperties [image] Dynamic window list control
Overview
External Name | Type | Display Name | Description
AdvancedStyleH | Bool | Extended graphical settings | Controls the use of the customizable horizontal and vertical scroll bars, the header and the grid. If you activate this property, you can customize the display of the list field as you wish.Default: Inactive . .
AscSortImage | String | Sort ascending | Select a graphics file that is to be displayed in the header of the list field for ascending sort in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> for AML . for CEL . for ETM .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColor2H | UInt32 | Gradient color | Define the second filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property .As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColor2V | UInt32 | Gradient color | Define the second filling color which is used for the color gradient for the vertical scroll bar. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property .As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColorH | UInt32 | Fill color | Define the first filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColorV | UInt32 | Fill color | Define the first filling color which is used for the color gradient for the vertical scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BarStyleH | Int16 | Display style | Define how the header of the list field should look like. Select one of the following options:Color gradient : Uses a special color gradient for the header. You can customize the color gradient with the help of properties , , , and .Graphics file : Uses the selected graphics files for the individual areas. If no graphics files have been selected, the Color gradient display is used.Standard : Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.Default: Standard . .
BarStyleV | Int16 | Display style | Define how the header of the list field should look like. Select one of the following options:Color gradient : Uses a special color gradient for the header. You can customize the color gradient with the help of properties , , , and .Graphics file : Uses the selected graphics files for the individual areas. If no graphics files have been selected, the Color gradient display is used.Standard : Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.Default: Standard . .
BitmapLeftH | String | Scroll arrow left | Select a graphics file that is to be displayed in the list field for the left scroll arrow for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapLeftV | String | Scroll arrow up | Select a graphics file that is to be displayed in the list field for the up scroll arrow for the vertical scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapRightH | String | Scroll arrow right | Select a graphics file that is to be displayed in the list field for the right scroll arrow for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapRightV | String | Scroll arrow down | Select a graphics file that is to be displayed in the list field for the down scroll arrow for the vertical scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapSpanH | String | Background graphics file | Select a graphics file that is to be displayed in the list field as a background for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapSpanV | String | Background graphics file | Select a graphics file that is to be displayed in the list field as a background for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapThumbH | String | Scroll box | Select a graphics file that is to be displayed in the list field for the scroll box for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapThumbV | String | Scroll box | Select a graphics file that is to be displayed in the list field for the scroll box for the vertical scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
ButtonHeightH | Int16 | Height scroll arrow [Pixel] | Define the height of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.Default: 12 . .
ButtonHeightV | Int16 | Height scroll arrow [Pixel] | Define the height of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.Default: 12 . .
ButtonWidthH | Int16 | Width scroll arrow [Pixel] | Define the width of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.Default: 12 . .
ButtonWidthV | Int16 | Width scroll arrow [Pixel] | Define the width of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.Default: 12 . .
CheckOffImage | String | Off | Selection of a graphic which displays status "value is 0 and property cannot be edited ". .
CheckOffImageInActive | String | Off (inactive) | Selection of a graphic which displays status "value is 0 and property cannot be edited ". .
CheckOnImage | String | On | Selection of a graphic which displays status "value is 1 and property cannot be edited ". .
CheckOnImageInActive | String | On (inactive) | Selection of a graphic which displays status "value is 1 and property cannot be edited ". .
ColorGradientAngleH | Int16 | Angle [°] | Define the angle in whose direction the color gradient spreads. As starting point the point defined in property is used.Minimum: 0 Maximum: 360 Default: 0 .
ColorGradientAngleV | Int16 | Angle [°] | Define the angle in whose direction the color gradient spreads. As starting point the point defined in property is used.Minimum: 0 Maximum: 360 Default: 0 .
ColorGradientOffsetH | Int16 | Offset [%] | Define the distance of the color gradient point from the center of the horizontal scroll bar to the left or the right in percent. 0 means the center of the horizontal scroll bar, 100 means the right edge of the horizontal scroll bar and -100 means the left edge of the horizontal scroll bar.Minimum: -100 Maximum: 100 Default: 0 .
ColorGradientOffsetV | Int16 | Offset [%] | Define the distance of the color gradient point from the center of the vertical scroll bar to the left or the right in percent. 0 means the center of the vertical scroll bar, 100 means the right edge of the vertical scroll bar and -100 means the left edge of the vertical scroll bar.Minimum: -100 Maximum: 100 Default: 0 .
ColumnOrderStatic | Bool | Freeze column location | For configurable lists, controls the possibility to move table columns in Runtime with mouse actions.Active : The columns cannot be arranged by dragging & dropping. The column width can still be amended by dragging with the mouse.Inactive : The columns can be arranged by means of drag&drop. The column width can be amended by dragging with the mouse.If there is an element in the screen that has column selection via the , this element is deactivated if the property is active.Default: Inactive . With the property activated, neither sorting by means of drag&drop nor amendment of the column width with the mouse is possible.
ColumnOrderStatic | Bool | Freeze column location | For configurable lists, controls the possibility to move table columns in Runtime with mouse actions.Active : The columns cannot be arranged by dragging & dropping. The column width can still be amended by dragging with the mouse.Inactive : The columns can be arranged by means of drag&drop. The column width can be amended by dragging with the mouse.If there is an element in the screen that has column selection via the , this element is deactivated if the property is active.Default: Inactive . With the property activated, neither sorting by means of drag&drop nor amendment of the column width with the mouse is possible.
DescDownImage | String | Sort descending | Select a graphics file that is to be displayed in the header of the list field for descending sort in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> for AML . for CEL . for ETM .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnableHeader | Bool | Make header editable | Makes it possible to operate the header for the respective list field. You can change the width of the columns and sort the display according to any desired column in Runtime.active : The header can be operated.Default: active Availability: Available for AML and CEL under the following conditions: If you selected operable header in the group for the property or in the group for the property. for AML . for CEL . for ETM .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
GridColorH | UInt32 | Horizontal line color | Defines the line color of the horizontal grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
GridColorV | UInt32 | Vertical line color | Defines the line color of the vertical grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
GridSizeH | UInt16 | Horizontal line width [Pixel] | Width of the horizontal grid line in pixel. Change this value in order to change the horizontal lines of the grid of the list view in the Runtime. If you enter 0 , the horizontal lines are hidden.Default: 1 . .
GridSizeV | UInt16 | Vertical line width [Pixel] | Width of the vertical grid line in pixel. Change this value in order to change the vertical lines of the grid of the list view in the Runtime. If you enter 0 , the vertical lines are hidden.Default: 1 . .
GridTypeH | UInt32 | Horizontal line type | Defines the type of the horizontal grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).Default: solid line.Attention: This property is available if the value for property is 1 . For values >1 a solid line is used. .
GridTypeV | UInt32 | Vertical line type | Defines the type of the vertical grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).Default: solid line.Attention: This property is available if the value for property is 1 . For values >1 a solid line is used. .
HeaderBackColor | UInt32 | Fill color | Define the first filling color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. for AML . for CEL . for ETM .
HeaderBackColor2 | UInt32 | Gradient color | Define the second fill color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property .As color for a newly created element the color which was used for the previous element of the same type is used. AML . CEL . for ETM .
HeaderBarImage | String | Background | Select a graphics file that is to be displayed in the header of the list field as a background in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> for AML . for CEL . for ETM .
HeaderColorGradientAngle | Int16 | Angle | Define the angle in whose direction the color gradient spreads. As starting point the point defined in property is used.Minimum: 0 Maximum: 360 Default: 0 AML . CEL . for ETM .
HeaderColorGradientOffset | Int16 | Offset | Define the distance of the color gradient from the center of the header to the left or the right in percent. 0 means the center of the header, 100 means the right edge of the header and -100 means the left edge of the header.Minimum: -100 Maximum: 100 Default: 0 AML . CEL . for ETM .
HeaderFont | UInt16 | Font | Define the font which should be used for the text in the header. Clicking on the button opens a dialog for selecting the pre-defined fonts.As font for a newly created element the font which was used for the previous element of the same type is used. for AML . for CEL . for ETM .
HeaderFontColor | UInt32 | Text color | Define the color which should be used for the text in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. for AML . for CEL . for ETM .
HeaderHeight | UInt32 | Height of the header [in pixels] | Configuration of the height of the header in pixels.Minimum: 0 - height is automatically determined using the font size.Maximum: 255 Default: 0 .
HeaderLightning | Int16 | Light effect | Select the type of the color gradient for the header from the following options:Linear : steady gradientDefined point : Gradient from the defined point to the edges of the elementStarting from a defined point with beams : Gradient with beams from the defined point to the edges of the elementDefault: Linear AML . CEL . for ETM .
HeaderStatic | Bool | HeaderStatic | Active : Columns can no longer be moved by dragging & dropping in Runtime and also cannot be sorted. The column width can be adjusted again. .
HeaderStyle | Int16 | Display style | Define how the header of the list field should look like. Select one of the following options:Color gradient : Uses a special color gradient for the header. You can customize the color gradient with the help of properties , , , and .Graphics file : Uses the selected graphics files for the individual areas. If no graphics files have been selected, the Color gradient display is used.Standard : Uses the standard setting for the header. You can only change the and the with the help of the respective setting.Default: Standard . for AML . for CEL . for ETM .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HideColumnSettingsMenu | Bool | Deactivate context menu | Allows the display and hiding of the context menus of the headers.Active : Context menu is deactivated.Inactive : Context menu is activated. The list can be configured in Runtime.Default: Inactive .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Legend | String | Text | Label of the element in the Editor. .
LightningH | Int16 | Color gradient | Select the type of the color gradient for the horizontal scroll bar from the following options:Linear : steady gradientDefined point : Gradient from the defined point to the edges of the elementStarting from a defined point with beams : Gradient with beams from the defined point to the edges of the elementDefault: Linear .
LightningV | Int16 | Color gradient | Select the type of the color gradient for the vertical scroll bar from the following options:Linear : steady gradientDefined point : Gradient from the defined point to the edges of the elementStarting from a defined point with beams : Gradient with beams from the defined point to the edges of the elementDefault: Linear .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
NoSortHeader | Bool | Disable sorting | Controls the possibility of sorting table columns in Runtime with a click on the header.Active : The table cannot be sorted by means of clicking.Inactive : The table can be sorted by clicking in the header of the column.Default: Inactive
NoSortHeader | Bool | Disable sorting | Controls the possibility of sorting table columns in Runtime with a click on the header.Active : The table cannot be sorted by means of clicking.Inactive : The table can be sorted by clicking in the header of the column.Default: Inactive
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RowHeight | UInt32 | Line height [pixel] | Makes it possible to define the row height in pixels independent of the font size.Maximum value: 255 px Minimum value : 0 px - row height is adapted to font size.Default : 0 Attention: If the row heightis selected is too large, nothing is displayed in Runtime in certain circumstances.is selected as smaller than the font size, then graphical illustrations are cut off. .
SelectionActive | CDynEleVar | Selection active | Linking of a response variable for configurable lists . The variable must be of the type BOOL . It shows in Runtime whether something has been selected in the list (1 ) or not (0 ). Clicking on the ... button opens the dialog to select a variable. .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
ShowBoolAsNumber | Bool | Numeric display | Active : Binary values are displayed numerically in Runtime. If the list element allows it, binary values can also be entered numerically. .
ShowFilter | Bool | Show filter row | Active : The filter line is displayed in Runtime.Inactive : The filter line is not shown in Runtime. Note: Configured filters are also implemented if the filter line is not shown. .
ShowHeader | Bool | Show header | Only available if you have selected operable header or fixed header in the project settings in the group for the property or in the group for the property. Displays the header for the respective list field. In group you can customize the look of the header.active: The header is displayed.Default: active for AML . for CEL . for ETM .
ShowHeader | Bool | Show header | Active : The header is displayed in Runtime.Inactive : The header is not shown in Runtime. The filter line is thus also not shown, but configured filters continue to be used. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Text color | Text color of the element. .
ThumbSizeH | Int16 | Width scroll box [Pixel] | Define the width of the scroll box in pixel for the horizontal scroll bar. Adjust the value to your ideas.Default: 20 . .
ThumbSizeV | Int16 | Width scroll box [Pixel] | Define the width of the scroll box in pixel for the vertical scroll bar. Adjust the value to your ideas.Default: 20 . .
TranslateText | Bool | Translate display text | Active : The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.Default: Inactive .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
WordWrap | Bool | Automatic word wrap | Allows multi-line display of texts in the list if the column width for the text to be shown is not sufficient. In doing so, the line height is enlarged accordingly.Active : If the column width is not sufficient, a line break is carried out and the line height is increased.Inactive : No word wrap is performed, the display is in one line.Info: A word wrap is only carried out if there are empty spaces in the text to be displayed (spaces, tabs or similar) or if a line break is inserted manually by means of a \n in the text. No line break is carried out for uninterrupted texts.Default: Inactive for AML . for CEL .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Dynamic window list control [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Dynamic window no header list control
ObjectModel COM [image] Element [image] DynProperties [image] Dynamic window no header list control
Overview
External Name | Type | Display Name | Description
AdvancedStyleH | Bool | Extended graphical settings | Controls the use of the customizable horizontal and vertical scroll bars, the header and the grid. If you activate this property, you can customize the display of the list field as you wish.Default: Inactive . .
AscSortImage | String | Sort ascending | Select a graphics file that is to be displayed in the header of the list field for ascending sort in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> for AML . for CEL . for ETM .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColor2H | UInt32 | Gradient color | Define the second filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property .As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColor2V | UInt32 | Gradient color | Define the second filling color which is used for the color gradient for the vertical scroll bar. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property .As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColorH | UInt32 | Fill color | Define the first filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColorSelectFocus | UInt32 | Background color on focus | Background color of a list entry if the focus is on the element. Default: Value of the operating system .
BackColorSelectNoFocus | UInt32 | Background color without focus | Background color of a list entry if the focus is not on the element. Default: Value of the operating system .
BackColorV | UInt32 | Fill color | Define the first filling color which is used for the color gradient for the vertical scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BarStyleH | Int16 | Display style | Define how the header of the list field should look like. Select one of the following options:Color gradient : Uses a special color gradient for the header. You can customize the color gradient with the help of properties , , , and .Graphics file : Uses the selected graphics files for the individual areas. If no graphics files have been selected, the Color gradient display is used.Standard : Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.Default: Standard . .
BarStyleV | Int16 | Display style | Define how the header of the list field should look like. Select one of the following options:Color gradient : Uses a special color gradient for the header. You can customize the color gradient with the help of properties , , , and .Graphics file : Uses the selected graphics files for the individual areas. If no graphics files have been selected, the Color gradient display is used.Standard : Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.Default: Standard . .
BitmapLeftH | String | Scroll arrow left | Select a graphics file that is to be displayed in the list field for the left scroll arrow for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapLeftV | String | Scroll arrow up | Select a graphics file that is to be displayed in the list field for the up scroll arrow for the vertical scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapRightH | String | Scroll arrow right | Select a graphics file that is to be displayed in the list field for the right scroll arrow for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapRightV | String | Scroll arrow down | Select a graphics file that is to be displayed in the list field for the down scroll arrow for the vertical scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapSpanH | String | Background graphics file | Select a graphics file that is to be displayed in the list field as a background for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapSpanV | String | Background graphics file | Select a graphics file that is to be displayed in the list field as a background for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapThumbH | String | Scroll box | Select a graphics file that is to be displayed in the list field for the scroll box for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapThumbV | String | Scroll box | Select a graphics file that is to be displayed in the list field for the scroll box for the vertical scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
ButtonHeightH | Int16 | Height scroll arrow [Pixel] | Define the height of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.Default: 12 . .
ButtonHeightV | Int16 | Height scroll arrow [Pixel] | Define the height of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.Default: 12 . .
ButtonWidthH | Int16 | Width scroll arrow [Pixel] | Define the width of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.Default: 12 . .
ButtonWidthV | Int16 | Width scroll arrow [Pixel] | Define the width of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.Default: 12 . .
ColorGradientAngleH | Int16 | Angle [°] | Define the angle in whose direction the color gradient spreads. As starting point the point defined in property is used.Minimum: 0 Maximum: 360 Default: 0 .
ColorGradientAngleV | Int16 | Angle [°] | Define the angle in whose direction the color gradient spreads. As starting point the point defined in property is used.Minimum: 0 Maximum: 360 Default: 0 .
ColorGradientOffsetH | Int16 | Offset [%] | Define the distance of the color gradient point from the center of the horizontal scroll bar to the left or the right in percent. 0 means the center of the horizontal scroll bar, 100 means the right edge of the horizontal scroll bar and -100 means the left edge of the horizontal scroll bar.Minimum: -100 Maximum: 100 Default: 0 .
ColorGradientOffsetV | Int16 | Offset [%] | Define the distance of the color gradient point from the center of the vertical scroll bar to the left or the right in percent. 0 means the center of the vertical scroll bar, 100 means the right edge of the vertical scroll bar and -100 means the left edge of the vertical scroll bar.Minimum: -100 Maximum: 100 Default: 0 .
ColumnOrderStatic | Bool | Freeze column location | For configurable lists, controls the possibility to move table columns in Runtime with mouse actions.Active : The columns cannot be arranged by dragging & dropping. The column width can still be amended by dragging with the mouse.Inactive : The columns can be arranged by means of drag&drop. The column width can be amended by dragging with the mouse.If there is an element in the screen that has column selection via the , this element is deactivated if the property is active.Default: Inactive . With the property activated, neither sorting by means of drag&drop nor amendment of the column width with the mouse is possible.
DescDownImage | String | Sort descending | Select a graphics file that is to be displayed in the header of the list field for descending sort in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> for AML . for CEL . for ETM .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnableHeader | Bool | Make header editable | Makes it possible to operate the header for the respective list field. You can change the width of the columns and sort the display according to any desired column in Runtime.active : The header can be operated.Default: active Availability: Available for AML and CEL under the following conditions: If you selected operable header in the group for the property or in the group for the property. for AML . for CEL . for ETM .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
GridColorH | UInt32 | Horizontal line color | Defines the line color of the horizontal grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
GridColorV | UInt32 | Vertical line color | Defines the line color of the vertical grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
GridSizeH | UInt16 | Horizontal line width [Pixel] | Width of the horizontal grid line in pixel. Change this value in order to change the horizontal lines of the grid of the list view in the Runtime. If you enter 0 , the horizontal lines are hidden.Default: 1 . .
GridSizeV | UInt16 | Vertical line width [Pixel] | Width of the vertical grid line in pixel. Change this value in order to change the vertical lines of the grid of the list view in the Runtime. If you enter 0 , the vertical lines are hidden.Default: 1 . .
GridTypeH | UInt32 | Horizontal line type | Defines the type of the horizontal grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).Default: solid line.Attention: This property is available if the value for property is 1 . For values >1 a solid line is used. .
GridTypeV | UInt32 | Vertical line type | Defines the type of the vertical grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).Default: solid line.Attention: This property is available if the value for property is 1 . For values >1 a solid line is used. .
HeaderBackColor | UInt32 | Fill color | Define the first filling color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. for AML . for CEL . for ETM .
HeaderBackColor2 | UInt32 | Gradient color | Define the second fill color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property .As color for a newly created element the color which was used for the previous element of the same type is used. AML . CEL . for ETM .
HeaderBarImage | String | Background | Select a graphics file that is to be displayed in the header of the list field as a background in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> for AML . for CEL . for ETM .
HeaderColorGradientAngle | Int16 | Angle | Define the angle in whose direction the color gradient spreads. As starting point the point defined in property is used.Minimum: 0 Maximum: 360 Default: 0 AML . CEL . for ETM .
HeaderColorGradientOffset | Int16 | Offset | Define the distance of the color gradient from the center of the header to the left or the right in percent. 0 means the center of the header, 100 means the right edge of the header and -100 means the left edge of the header.Minimum: -100 Maximum: 100 Default: 0 AML . CEL . for ETM .
HeaderFont | UInt16 | Font | Define the font which should be used for the text in the header. Clicking on the button opens a dialog for selecting the pre-defined fonts.As font for a newly created element the font which was used for the previous element of the same type is used. for AML . for CEL . for ETM .
HeaderFontColor | UInt32 | Text color | Define the color which should be used for the text in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. for AML . for CEL . for ETM .
HeaderLightning | Int16 | Light effect | Select the type of the color gradient for the header from the following options:Linear : steady gradientDefined point : Gradient from the defined point to the edges of the elementStarting from a defined point with beams : Gradient with beams from the defined point to the edges of the elementDefault: Linear AML . CEL . for ETM .
HeaderStyle | Int16 | Display style | Define how the header of the list field should look like. Select one of the following options:Color gradient : Uses a special color gradient for the header. You can customize the color gradient with the help of properties , , , and .Graphics file : Uses the selected graphics files for the individual areas. If no graphics files have been selected, the Color gradient display is used.Standard : Uses the standard setting for the header. You can only change the and the with the help of the respective setting.Default: Standard . for AML . for CEL . for ETM .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HideSelection | Bool | Do not mark selected row | You use this to define whether the selected line is highlighted in the list field. If you activate this property, you do not see which entry you have selected. All lines of the list look the same.Default: Inactive . for AML . for CEL .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Legend | String | Text | Label of the element in the Editor. .
LightningH | Int16 | Color gradient | Select the type of the color gradient for the horizontal scroll bar from the following options:Linear : steady gradientDefined point : Gradient from the defined point to the edges of the elementStarting from a defined point with beams : Gradient with beams from the defined point to the edges of the elementDefault: Linear .
LightningV | Int16 | Color gradient | Select the type of the color gradient for the vertical scroll bar from the following options:Linear : steady gradientDefined point : Gradient from the defined point to the edges of the elementStarting from a defined point with beams : Gradient with beams from the defined point to the edges of the elementDefault: Linear .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
NoSortHeader | Bool | Disable sorting | Controls the possibility of sorting table columns in Runtime with a click on the header.Active : The table cannot be sorted by means of clicking.Inactive : The table can be sorted by clicking in the header of the column.Default: Inactive
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RowHeight | UInt32 | Line height [pixel] | Makes it possible to define the row height in pixels independent of the font size.Maximum value: 255 px Minimum value : 0 px - row height is adapted to font size.Default : 0 Attention: If the row heightis selected is too large, nothing is displayed in Runtime in certain circumstances.is selected as smaller than the font size, then graphical illustrations are cut off. .
SelectionActive | CDynEleVar | Selection active | Linking of a response variable for configurable lists . The variable must be of the type BOOL . It shows in Runtime whether something has been selected in the list (1 ) or not (0 ). Clicking on the ... button opens the dialog to select a variable. .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
ShowBorder | Bool | Show border lines | Visualizes a border for certain elements when displayed in Runtime. The configuration of the and properties is no longer taken into account for the display in Runtime as a result.Active : The element is shown in Runtime with a border.Inactive: No border when displayed in Runtime.Default: inactive. .
ShowHeader | Bool | Show header | Only available if you have selected operable header or fixed header in the project settings in the group for the property or in the group for the property. Displays the header for the respective list field. In group you can customize the look of the header.active: The header is displayed.Default: active for AML . for CEL . for ETM .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleH | UInt16 | Style H | Windows style of the element, for internal use only. .
StyleL | UInt16 | Style L | Windows style of the element, for internal use only. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Text color | Text color of the element. .
TextColorSelectFocus | UInt32 | Text color on focus | Color for the text of a list entry if the focus is on the element. Default: Value of the operating system .
TextColorSelectNoFocus | UInt32 | Text color without focus | Color for the text of a list entry if the focus is not on the element. Default: Value of the operating system .
ThumbSizeH | Int16 | Width scroll box [Pixel] | Define the width of the scroll box in pixel for the horizontal scroll bar. Adjust the value to your ideas.Default: 20 . .
ThumbSizeV | Int16 | Width scroll box [Pixel] | Define the width of the scroll box in pixel for the vertical scroll bar. Adjust the value to your ideas.Default: 20 . .
TranslateText | Bool | Translate display text | Active : The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.Default: Inactive .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
WordWrap | Bool | Automatic word wrap | Allows multi-line display of texts in the list if the column width for the text to be shown is not sufficient. In doing so, the line height is enlarged accordingly.Active : If the column width is not sufficient, a line break is carried out and the line height is increased.Inactive : No word wrap is performed, the display is in one line.Info: A word wrap is only carried out if there are empty spaces in the text to be displayed (spaces, tabs or similar) or if a line break is inserted manually by means of a \n in the text. No line break is carried out for uninterrupted texts.Default: Inactive for AML . for CEL .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Dynamic window no header list control [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Dynamic window picture control
ObjectModel COM [image] Element [image] DynProperties [image] Dynamic window picture control
Overview
External Name | Type | Display Name | Description
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Legend | String | Text | Label of the element in the Editor. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PictureContainerPictureName | String | Screen | Linked screen that is displayed in the faceplate. Click the ... button and a dialog opens to select a screen.Permitted screen types: AML, AML filter, equipment model, CEL, CEL filter, ETM, HTML, Report Generator, Report Viewer, standard, time filter .
Preview | String | Preview | Opens the dialog to replace links. Changes in the preview are taken over and reversed in properties and . Stands for symbols and faceplates available. Only active for symbols if there is already linking to the symbol; for faceplate containers, only if a screen is linked to a container.More information is in the online manual in he Symbols and Faceplates sections.
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
ShowPreviewInEditor | Bool | Show preview in the Editor | Active : Preview of the linked screen is displayed in the Editor. Deactivation is recommended in the event of performance problems.Standard: active
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleH | UInt16 | Style H | Windows style of the element, for internal use only. .
StyleL | UInt16 | Style L | Windows style of the element, for internal use only. .
SubstituteDestination | String | Target | Replacement of variables or functions in a symbol or faceplate container: Enter the new variables/functions to be assigned. At this no wildcards are allowed. Several entries are separated by a semicolon (; ).You can define the sources with the help of property . Example: Variables in the symbol: Tank1.fill level and Tank1.position of the valve . These should be replaced by Tank2.fill level and Tank2.position of the valve . For this enter the following at : *1* and at 2 . In the Runtime the variables which contain 1 are replaced by the variables which contain 2 .More information is in the online manual in he Symbols and Faceplates sections.
SubstituteMatchCase | Bool | Case sensitive | The capitalization in the inputs for the source and the target to replace variables or functions in a symbol or faceplate container.Active: Capitalization is taken into account.Inactive: Capitalization is not taken into account.More information is in the online manual in he Symbols and Faceplates sections.
SubstituteOnName | Bool | Via variable name | Replacement of variables in a symbol or faceplate container using variables:Active: The replacement of links is implemented via the name of the variables.Inactive The replacement of the links is implemented via the identification of the variables.Default: activated More information is in the online manual in he Symbols and Faceplates sections. Note: This property also has effects on the behavior of the property. You can find more information on this in the Screens manual.
SubstituteSource | String | Source | Replacing variables or functions in a symbol or faceplate container.Enter the source variable/source function. You can use wildcards (?,*). Several entries are separated by a semicolon (; ).You can define the target with the help of property . Example: Variables in the symbol: Tank1.fill level and Tank1.position of the valve . These should be replaced by Tank2.fill level and Tank2.position of the valve . For this enter the following at : *1* and at 2 . In the Runtime the variables which contain 1 are replaced by the variables which contain 2 .More information is in the online manual in he Symbols and Faceplates sections.
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Text color | Text color of the element. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Dynamic window picture control [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


EMF WMF
ObjectModel COM [image] Element [image] DynProperties [image] EMF WMF
Overview
External Name | Type | Display Name | Description
ALCAlias | Bool | Use alias | Only available if is active.Active : Alias is used. In the Runtime the element receives its ALC colors from another ALC element of the topological model without being part of the model itself. The displayed ALC color of the element is thus not determined by the linked lines. The ALC color is identical to the color of the ALC element, the name of which is linked in the .Inactive : Element is an ALC element according to the configured ALC . The ALC display color is determined by the linked lines.Default: Inactive .
ALCAliasName | String | Alias | Only available if is active.Defined source element for property . Clicking on the ... button opens the dialog to select a pre-configured ALC element in a pre-configured zenon screen. Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project. .
ALCAlternativeColor | UInt32 | Alternative color | Only available if property has value alternative color .Alternative color for the ALC coloring at multiple supply. .
ALCDashLen | Int16 | Dashing length supplied multiple times | Only available if property has value two highest prior sources .Defines the dash length in pixel for the dashed ALC coloring at multiply supply.Minimal: 0 (automatic dash length)Maximum: 32767 Default: 0 .
ALCEnclosementSize | SByte | Curb width [px] | Width of the curb in pixels.Default: 1 pixel Input range: 1 to 20 pixels.Note: Only available if property is active. .
ALCLength | double | Length of the line [km] | ALC line: Length of the line. .
ALCLineName | String | Line name | Unique name of the line. Is used for the identification of the line in the load distribution calculation. In addition, this name is used as interlocking text for the "Overload of a line " topological interlocking.Note : Only available for the Line or Pipe screen element. .
ALCMaxIType | Int16 | Limit value current carrying capacity | Origin of data on the limit value of the current carrying capacity for the calculation of load distribution . The current carrying capacity of the weakest link (cable) in a line. Selection of the type from the drop-down list: Default: Static limit value current carrying capacity Note: The entries in the drop-down list correspond to the properties that follow the Editor directly. .
ALCMaxIVal | double | Static limit value current carrying capacity [A] | Entry of the maximum current-carrying capacity of the weakest link (cable) in the line. Entry in amperes.Default: 20 Not available if the property is configured with limit value of current-carrying capacity dynamic . .
ALCMSecuredSupply | Int16 | display secured supply | Only available if was activated.Definition of the display of the secured supply:double widthdouble brightnessnormalDefault: normal .
ALCMultiSource | Int16 | display multiple supplies | Only available if the property is active. Defines the display type if the element is connected to several sources: most prior source: Only the color of the source with the highest priority is used. two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line. alternative color : Alternative color for the coloring at multiple supply.Default: highest priority source .
ALCPrecedence | Int16 | Priority for display | Only available if the property is active.Defines the priority of the display when the element is connected to several active sources. Multiple supply : The element is displayed according to the rules of the multiple supply. secured supply : The element is displayed according to the rules of the secured supply. No priority : The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.Default: Multiple supply .
ALCReact | double | Reactance value of the cable [Ohm] | Maximum permitted value of the reactance (reactance X) of the line in Ohms. Is used for the detection of the fault locating of protection . .
ALCResist | double | Resistance value of the electric line [Ohm] | Maximum permitted value of the resistance (effective resistance R) of the line in Ohms. Is used for the calculation of load distribution. .
ALCUseColor | Bool | Color from ALC | Only available if you have licensed Automatic Line Coloring (ALC) : Active: The automatic color of the linked source(s) is used. Inactive: The standard color is used. Default: inactive. .
ALCUseEnclosement | Bool | Use curb | Checkbox for the activation of the curb of lines, polylines and pipelines.active: ALC line elements are visualized in Runtime for a ground fault or short circuit with an additional border in the corresponding color. The colors are defined in the ALC project settings.Inactive: No display of curbing in Runtime.Default: Inactive Note: only active if is activated. .
ALCVarCalcI | CDynEleVar | Measuring value of the calculated current flow | Linked variable with the measured value of the calculated current flow of the branch. Calculation result in amperes [A]. .
ALCVarCalcIEx | Node | ALCVarCalcIEx | ALC Leitung: Messwert des berechneten Stromflusses für Export.Mehr in der Online-Hilfe .
ALCVarMaxI | CDynEleVar | Dynamic limit value current carrying capacity | Linked variable for the maximum current-carrying capacity of the weakest link (cable) in the line. Only available if the limit value of current-carrying capacity property is configured with limit value of current-carrying capacity dynamic . .
ALCVarMaxIEx | Node | ALCVarMaxIEx | Node
Align | Int16 | Alignment | Direction of color shift. horizontal vertical
AlphaBackColor | SByte | Transparency of the fill color [%] | .
AlphaBackColor2 | SByte | Transparency gradient color [%] | Only available if Linear was selected in the property. .
AlphaLineColor | SByte | Transparency line color [%] | .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColor2 | UInt32 | Gradient color | Color gradient must be selected for the property.Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of . .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVariable2 | CDynEleVar | Gradient color | Name of the variable whose limit value color should influence the gradient color of the element. Click on the input filed in order to open the dialog for selecting a variable. .
BackColorVariable2Preview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
Brightness | Bool | With brightness values | Only available if was selected as color gradient was selected.Active: The brightness of the color gradient can be freely defined. Inactive: The brightness of the color gradient is defined automatically.Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners. .
ColorGradientAngle | Int16 | Angle [°] | Defines the direction of the color gradient starting in the center of the element.Values: 0° to 360° . Default: 0° .
ColorGradientOffset | Int16 | Offset [%] | Only available if, for a vector element or a dynamic button element, the property has been set. Linear or Selective or Selective with edges .Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.Values: 0 equals the center of the element. 100 the edge. Note: The value can also be outside of the element and is therefore not limited to 100 . .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillColorInvert | Bool | Invert color gradient | Only available if Color gradient was selected as . Active: The brightness gradient is inverted. Inactive: The brightness gradient is not inverted. Default: Inactive .
FillPattern | UInt32 | Fill pattern | Selection of the filling pattern for the element from the list.This property is only available if property is inactive. .
FillStyle | Guid | Fill style |
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
InnerBrightness | SByte | Brightness inside | Only available if "via brightness value" is active : Brightness in the middle of the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Lightning | Int16 | Color gradient | Only available if was set to Color gradient . Defines the color gradient for elements. Linear : steady gradientDefined point : Gradient from a defined point to the edges of the element Selective with edges : Gradient from a defined point to the edges of the element with beamsRadiant : From the bottom to the middle, then gradient from the middle to the top (with rectangular form only).
LineCapEnd | UInt32 | End type | Defines the symbol for the end point of the line. Clicking on the field opens the dialog to select an element. Only available for the arc of a circle and segment of a circle if has been set to without . .
LineCapScale | float | Size | Defines the magnifying factor for the line width of the arrow. The factor relates to the line width of the vector element as defined in the property. For arc of circle and segment of circle only available if property was set to without .Value: greater or equal 1 Default: 4 .
LineCapStart | UInt32 | Start type | Defines the symbol for the starting point of the line. Click on the field and a dialog opens to select an element. For arc of circle and segment of circle only available if property was set to without . .
LineColor | UInt32 | Line color | Line color of the element.
LineColorEx | UInt32 | Line color | Defines the line color of the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LineStyle | Guid | Line style | Display and selection of the line style that is assigned to the element. .
LineType | UInt32 | Line type | Selection of the line type for the element from the list. Attention: If the node in in the project properties, the property has been set to Windows basic , you can only use line width >1 with a "continuous line" type line. .
LineWidth | UInt16 | Line width [Pixel] | Width of the line (in pixels).Minimum: 0 In this case the width of the line is 1 pixel.Maximum: 40 Default: 1 Attention: If in the project settings in node you set property to Windows basis , you can use line width >1 only with a line of type "continuous line". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
MeasuredInputActivePower | Node | Active power input [MW] | Linked variable with the measured value of the active power at the line input. .
MeasuredInputActivePowerImEx | Node | MeasuredInputActivePowerImEx | Description
MeasuredInputCosPhi | Node | cos Phi input | Linked variable with the measured value of the cos phi power factor at the line input. .
MeasuredInputCosPhiImEx | Node | MeasuredInputCosPhiImEx | Description
MeasuredInputCurrent | Node | Power Input [A] | Linked variable with the measured value of the amperage at the line input. .
MeasuredInputCurrentImEx | Node | MeasuredInputCurrentImEx | Description
MeasuredInputReactivePower | Node | Reactive power input [MVar] | Linked variable with the measured value of the reactive power at the line input. .
MeasuredInputReactivePowerImEx | Node | MeasuredInputReactivePowerImEx | Description
MeasuredInputVoltage | Node | Voltage input [kV] | Linked variable with the measured value of the voltage at the line input. .
MeasuredInputVoltageImEx | Node | MeasuredInputVoltageImEx | Description
MeasuredOutputActivePower | Node | Active power output [MW] | Linked variable with the measured value of the active power at the line output. .
MeasuredOutputActivePowerImEx | Node | MeasuredOutputActivePowerImEx | Description
MeasuredOutputCosPhi | Node | cos Phi output | Linked variable with the measured value of the cos phi power factor at the line output. .
MeasuredOutputCosPhiImEx | Node | MeasuredOutputCosPhiImEx | Description
MeasuredOutputCurrent | Node | Power Output [A] | Linked variable with the measured value of the amperage at the line output. .
MeasuredOutputCurrentImEx | Node | MeasuredOutputCurrentImEx | Description
MeasuredOutputReactivePower | Node | Reactive power output [MVar] | Linked variable with the measured value of the reactive power at the line output. .
MeasuredOutputReactivePowerImEx | Node | MeasuredOutputReactivePowerImEx | Description
MeasuredOutputVoltage | Node | Voltage output [kV] | Linked variable with the measured value of the voltage at the line output. .
MeasuredOutputVoltageImEx | Node | MeasuredOutputVoltageImEx | Description
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
OuterBrightness | SByte | Brightness outside | Only available if "via brightness value" is active : Brightness at the outer side of the element. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
Shifted | Int16 | Shifted color gradient | Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein. Mehr im Online-Handbuch
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VarLineCurrent | Node | Current [A] | Linked variable with the result of the load flow calculation for the calculated amperage at the line input. .
VarLineCurrentImEx | Node | VarLineCurrentImEx | Description
VarLinePowerFactorVar | Node | cos Phi output | Linked variable with the result of the load flow calculation for the calculated power factor (cos phi). This corresponds to the average value of the calculated cos phi at the output. .
VarLinePowerFactorVarImEx | Node | VarLinePowerFactorVarImEx | Description
VarLinePowerInVar | Node | Active power input [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line input. .
VarLinePowerInVarImEx | Node | VarLinePowerInVarImEx | Description
VarLinePowerOutVar | Node | Active power output [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line output. .
VarLinePowerOutVarImEx | Node | VarLinePowerOutVarImEx | Description
VarLineReactivePowerInVar | Node | Reactive power input [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line input. .
VarLineReactivePowerInVarImEx | Node | VarLineReactivePowerInVarImEx | Description
VarLineReactivePowerOutVar | Node | Reactive power output [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line output. .
VarLineReactivePowerOutVarImEx | Node | VarLineReactivePowerOutVarImEx | Description
VarLineVoltageInVar | Node | Voltage input [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line input. .
VarLineVoltageInVarImEx | Node | VarLineVoltageInVarImEx | Description
VarLineVoltageOutVar | Node | Voltage output [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line output. .
VarLineVoltageOutVarImEx | Node | VarLineVoltageOutVarImEx | Description
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] EMF WMF [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Frame polygon
ObjectModel COM [image] Element [image] DynProperties [image] Frame polygon
Overview
External Name | Type | Display Name | Description
ALCAlias | Bool | Use alias | Only available if is active.Active : Alias is used. In the Runtime the element receives its ALC colors from another ALC element of the topological model without being part of the model itself. The displayed ALC color of the element is thus not determined by the linked lines. The ALC color is identical to the color of the ALC element, the name of which is linked in the .Inactive : Element is an ALC element according to the configured ALC . The ALC display color is determined by the linked lines.Default: Inactive .
ALCAliasName | String | Alias | Only available if is active.Defined source element for property . Clicking on the ... button opens the dialog to select a pre-configured ALC element in a pre-configured zenon screen. Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project. .
ALCAlternativeColor | UInt32 | Alternative color | Only available if property has value alternative color .Alternative color for the ALC coloring at multiple supply. .
ALCDashLen | Int16 | Dashing length supplied multiple times | Only available if property has value two highest prior sources .Defines the dash length in pixel for the dashed ALC coloring at multiply supply.Minimal: 0 (automatic dash length)Maximum: 32767 Default: 0 .
ALCEnclosementSize | SByte | Curb width [px] | Width of the curb in pixels.Default: 1 pixel Input range: 1 to 20 pixels.Note: Only available if property is active. .
ALCLength | double | Length of the line [km] | ALC line: Length of the line. .
ALCLineName | String | Line name | Unique name of the line. Is used for the identification of the line in the load distribution calculation. In addition, this name is used as interlocking text for the "Overload of a line " topological interlocking.Note : Only available for the Line or Pipe screen element. .
ALCMaxIType | Int16 | Limit value current carrying capacity | Origin of data on the limit value of the current carrying capacity for the calculation of load distribution . The current carrying capacity of the weakest link (cable) in a line. Selection of the type from the drop-down list: Default: Static limit value current carrying capacity Note: The entries in the drop-down list correspond to the properties that follow the Editor directly. .
ALCMaxIVal | double | Static limit value current carrying capacity [A] | Entry of the maximum current-carrying capacity of the weakest link (cable) in the line. Entry in amperes.Default: 20 Not available if the property is configured with limit value of current-carrying capacity dynamic . .
ALCMSecuredSupply | Int16 | display secured supply | Only available if was activated.Definition of the display of the secured supply:double widthdouble brightnessnormalDefault: normal .
ALCMultiSource | Int16 | display multiple supplies | Only available if the property is active. Defines the display type if the element is connected to several sources: most prior source: Only the color of the source with the highest priority is used. two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line. alternative color : Alternative color for the coloring at multiple supply.Default: highest priority source .
ALCPrecedence | Int16 | Priority for display | Only available if the property is active.Defines the priority of the display when the element is connected to several active sources. Multiple supply : The element is displayed according to the rules of the multiple supply. secured supply : The element is displayed according to the rules of the secured supply. No priority : The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.Default: Multiple supply .
ALCReact | double | Reactance value of the cable [Ohm] | Maximum permitted value of the reactance (reactance X) of the line in Ohms. Is used for the detection of the fault locating of protection . .
ALCResist | double | Resistance value of the electric line [Ohm] | Maximum permitted value of the resistance (effective resistance R) of the line in Ohms. Is used for the calculation of load distribution. .
ALCUseColor | Bool | Color from ALC | Only available if you have licensed Automatic Line Coloring (ALC) : Active: The automatic color of the linked source(s) is used. Inactive: The standard color is used. Default: inactive. .
ALCUseEnclosement | Bool | Use curb | Checkbox for the activation of the curb of lines, polylines and pipelines.active: ALC line elements are visualized in Runtime for a ground fault or short circuit with an additional border in the corresponding color. The colors are defined in the ALC project settings.Inactive: No display of curbing in Runtime.Default: Inactive Note: only active if is activated. .
ALCVarCalcI | CDynEleVar | Measuring value of the calculated current flow | Linked variable with the measured value of the calculated current flow of the branch. Calculation result in amperes [A]. .
ALCVarCalcIEx | Node | ALCVarCalcIEx | ALC Leitung: Messwert des berechneten Stromflusses für Export.Mehr in der Online-Hilfe .
ALCVarMaxI | CDynEleVar | Dynamic limit value current carrying capacity | Linked variable for the maximum current-carrying capacity of the weakest link (cable) in the line. Only available if the limit value of current-carrying capacity property is configured with limit value of current-carrying capacity dynamic . .
ALCVarMaxIEx | Node | ALCVarMaxIEx | Node
Align | Int16 | Alignment | Direction of color shift. horizontal vertical
AlphaBackColor | SByte | Transparency of the fill color [%] | .
AlphaBackColor2 | SByte | Transparency gradient color [%] | Only available if Linear was selected in the property. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColor2 | UInt32 | Gradient color | Color gradient must be selected for the property.Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of . .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVariable2 | CDynEleVar | Gradient color | Name of the variable whose limit value color should influence the gradient color of the element. Click on the input filed in order to open the dialog for selecting a variable. .
BackColorVariable2Preview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
ColorGradientAngle | Int16 | Angle [°] | Defines the direction of the color gradient starting in the center of the element.Values: 0° to 360° . Default: 0° .
ColorGradientOffset | Int16 | Offset [%] | Only available if, for a vector element or a dynamic button element, the property has been set. Linear or Selective or Selective with edges .Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.Values: 0 equals the center of the element. 100 the edge. Note: The value can also be outside of the element and is therefore not limited to 100 . .
Combine | Int16 | Area utilization | Define what effects the created element should have on the frame.The following settings are available:Cover : The surface of the element is used as the screen area.Cut : The surface of the element is removed from the surfaces underneathORed : This is either cut out or covered according to whether a covering element is under the element or not.Note: The way the surface is used always relates to the surface under the element. For newly-created elements, the setting that was selected last is always used. .
Coordinates | String |  | "With this property you can get/set the coordinates of the element via a string. zElement.DynProperties(""Coordinates"") = ""197/118;260/200"""
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillColorInvert | Bool | Invert color gradient | Only available if Color gradient was selected as . Active: The brightness gradient is inverted. Inactive: The brightness gradient is not inverted. Default: Inactive .
FillPattern | UInt32 | Fill pattern | Selection of the filling pattern for the element from the list.This property is only available if property is inactive. .
FillStyle | Guid | Fill style |
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Lightning | Int16 | Color gradient | Only available if was set to Color gradient . Defines the color gradient for elements. Linear : steady gradientDefined point : Gradient from a defined point to the edges of the element Selective with edges : Gradient from a defined point to the edges of the element with beamsRadiant : From the bottom to the middle, then gradient from the middle to the top (with rectangular form only).
LineColor | UInt32 | Line color | Line color of the element.
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
MeasuredInputActivePower | Node | Active power input [MW] | Linked variable with the measured value of the active power at the line input. .
MeasuredInputActivePowerImEx | Node | MeasuredInputActivePowerImEx | Description
MeasuredInputCosPhi | Node | cos Phi input | Linked variable with the measured value of the cos phi power factor at the line input. .
MeasuredInputCosPhiImEx | Node | MeasuredInputCosPhiImEx | Description
MeasuredInputCurrent | Node | Power Input [A] | Linked variable with the measured value of the amperage at the line input. .
MeasuredInputCurrentImEx | Node | MeasuredInputCurrentImEx | Description
MeasuredInputReactivePower | Node | Reactive power input [MVar] | Linked variable with the measured value of the reactive power at the line input. .
MeasuredInputReactivePowerImEx | Node | MeasuredInputReactivePowerImEx | Description
MeasuredInputVoltage | Node | Voltage input [kV] | Linked variable with the measured value of the voltage at the line input. .
MeasuredInputVoltageImEx | Node | MeasuredInputVoltageImEx | Description
MeasuredOutputActivePower | Node | Active power output [MW] | Linked variable with the measured value of the active power at the line output. .
MeasuredOutputActivePowerImEx | Node | MeasuredOutputActivePowerImEx | Description
MeasuredOutputCosPhi | Node | cos Phi output | Linked variable with the measured value of the cos phi power factor at the line output. .
MeasuredOutputCosPhiImEx | Node | MeasuredOutputCosPhiImEx | Description
MeasuredOutputCurrent | Node | Power Output [A] | Linked variable with the measured value of the amperage at the line output. .
MeasuredOutputCurrentImEx | Node | MeasuredOutputCurrentImEx | Description
MeasuredOutputReactivePower | Node | Reactive power output [MVar] | Linked variable with the measured value of the reactive power at the line output. .
MeasuredOutputReactivePowerImEx | Node | MeasuredOutputReactivePowerImEx | Description
MeasuredOutputVoltage | Node | Voltage output [kV] | Linked variable with the measured value of the voltage at the line output. .
MeasuredOutputVoltageImEx | Node | MeasuredOutputVoltageImEx | Description
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
Shifted | Int16 | Shifted color gradient | Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein. Mehr im Online-Handbuch
SplineTension | float | Rounding | Defines the rounding for the polylines, polygons and the pipes.Values: 0,0 (no rounding) to 1,0 . (maximum rounding)Default: 0 .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VarLineCurrent | Node | Current [A] | Linked variable with the result of the load flow calculation for the calculated amperage at the line input. .
VarLineCurrentImEx | Node | VarLineCurrentImEx | Description
VarLinePowerFactorVar | Node | cos Phi output | Linked variable with the result of the load flow calculation for the calculated power factor (cos phi). This corresponds to the average value of the calculated cos phi at the output. .
VarLinePowerFactorVarImEx | Node | VarLinePowerFactorVarImEx | Description
VarLinePowerInVar | Node | Active power input [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line input. .
VarLinePowerInVarImEx | Node | VarLinePowerInVarImEx | Description
VarLinePowerOutVar | Node | Active power output [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line output. .
VarLinePowerOutVarImEx | Node | VarLinePowerOutVarImEx | Description
VarLineReactivePowerInVar | Node | Reactive power input [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line input. .
VarLineReactivePowerInVarImEx | Node | VarLineReactivePowerInVarImEx | Description
VarLineReactivePowerOutVar | Node | Reactive power output [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line output. .
VarLineReactivePowerOutVarImEx | Node | VarLineReactivePowerOutVarImEx | Description
VarLineVoltageInVar | Node | Voltage input [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line input. .
VarLineVoltageInVarImEx | Node | VarLineVoltageInVarImEx | Description
VarLineVoltageOutVar | Node | Voltage output [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line output. .
VarLineVoltageOutVarImEx | Node | VarLineVoltageOutVarImEx | Description
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Frame polygon [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Frame vector
ObjectModel COM [image] Element [image] DynProperties [image] Frame vector
Overview
External Name | Type | Display Name | Description
ALCAlias | Bool | Use alias | Only available if is active.Active : Alias is used. In the Runtime the element receives its ALC colors from another ALC element of the topological model without being part of the model itself. The displayed ALC color of the element is thus not determined by the linked lines. The ALC color is identical to the color of the ALC element, the name of which is linked in the .Inactive : Element is an ALC element according to the configured ALC . The ALC display color is determined by the linked lines.Default: Inactive .
ALCAliasName | String | Alias | Only available if is active.Defined source element for property . Clicking on the ... button opens the dialog to select a pre-configured ALC element in a pre-configured zenon screen. Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project. .
ALCAlternativeColor | UInt32 | Alternative color | Only available if property has value alternative color .Alternative color for the ALC coloring at multiple supply. .
ALCDashLen | Int16 | Dashing length supplied multiple times | Only available if property has value two highest prior sources .Defines the dash length in pixel for the dashed ALC coloring at multiply supply.Minimal: 0 (automatic dash length)Maximum: 32767 Default: 0 .
ALCEnclosementSize | SByte | Curb width [px] | Width of the curb in pixels.Default: 1 pixel Input range: 1 to 20 pixels.Note: Only available if property is active. .
ALCLength | double | Length of the line [km] | ALC line: Length of the line. .
ALCLineName | String | Line name | Unique name of the line. Is used for the identification of the line in the load distribution calculation. In addition, this name is used as interlocking text for the "Overload of a line " topological interlocking.Note : Only available for the Line or Pipe screen element. .
ALCMaxIType | Int16 | Limit value current carrying capacity | Origin of data on the limit value of the current carrying capacity for the calculation of load distribution . The current carrying capacity of the weakest link (cable) in a line. Selection of the type from the drop-down list: Default: Static limit value current carrying capacity Note: The entries in the drop-down list correspond to the properties that follow the Editor directly. .
ALCMaxIVal | double | Static limit value current carrying capacity [A] | Entry of the maximum current-carrying capacity of the weakest link (cable) in the line. Entry in amperes.Default: 20 Not available if the property is configured with limit value of current-carrying capacity dynamic . .
ALCMSecuredSupply | Int16 | display secured supply | Only available if was activated.Definition of the display of the secured supply:double widthdouble brightnessnormalDefault: normal .
ALCMultiSource | Int16 | display multiple supplies | Only available if the property is active. Defines the display type if the element is connected to several sources: most prior source: Only the color of the source with the highest priority is used. two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line. alternative color : Alternative color for the coloring at multiple supply.Default: highest priority source .
ALCPrecedence | Int16 | Priority for display | Only available if the property is active.Defines the priority of the display when the element is connected to several active sources. Multiple supply : The element is displayed according to the rules of the multiple supply. secured supply : The element is displayed according to the rules of the secured supply. No priority : The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.Default: Multiple supply .
ALCReact | double | Reactance value of the cable [Ohm] | Maximum permitted value of the reactance (reactance X) of the line in Ohms. Is used for the detection of the fault locating of protection . .
ALCResist | double | Resistance value of the electric line [Ohm] | Maximum permitted value of the resistance (effective resistance R) of the line in Ohms. Is used for the calculation of load distribution. .
ALCUseColor | Bool | Color from ALC | Only available if you have licensed Automatic Line Coloring (ALC) : Active: The automatic color of the linked source(s) is used. Inactive: The standard color is used. Default: inactive. .
ALCUseEnclosement | Bool | Use curb | Checkbox for the activation of the curb of lines, polylines and pipelines.active: ALC line elements are visualized in Runtime for a ground fault or short circuit with an additional border in the corresponding color. The colors are defined in the ALC project settings.Inactive: No display of curbing in Runtime.Default: Inactive Note: only active if is activated. .
ALCVarCalcI | CDynEleVar | Measuring value of the calculated current flow | Linked variable with the measured value of the calculated current flow of the branch. Calculation result in amperes [A]. .
ALCVarCalcIEx | Node | ALCVarCalcIEx | ALC Leitung: Messwert des berechneten Stromflusses für Export.Mehr in der Online-Hilfe .
ALCVarMaxI | CDynEleVar | Dynamic limit value current carrying capacity | Linked variable for the maximum current-carrying capacity of the weakest link (cable) in the line. Only available if the limit value of current-carrying capacity property is configured with limit value of current-carrying capacity dynamic . .
ALCVarMaxIEx | Node | ALCVarMaxIEx | Node
Align | Int16 | Alignment | Direction of color shift. horizontal vertical
AlphaBackColor | SByte | Transparency of the fill color [%] | .
AlphaBackColor2 | SByte | Transparency gradient color [%] | Only available if Linear was selected in the property. .
AlphaLineColor | SByte | Transparency line color [%] | .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColor2 | UInt32 | Gradient color | Color gradient must be selected for the property.Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of . .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVariable2 | CDynEleVar | Gradient color | Name of the variable whose limit value color should influence the gradient color of the element. Click on the input filed in order to open the dialog for selecting a variable. .
BackColorVariable2Preview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
Brightness | Bool | With brightness values | Only available if was selected as color gradient was selected.Active: The brightness of the color gradient can be freely defined. Inactive: The brightness of the color gradient is defined automatically.Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners. .
ColorGradientAngle | Int16 | Angle [°] | Defines the direction of the color gradient starting in the center of the element.Values: 0° to 360° . Default: 0° .
ColorGradientOffset | Int16 | Offset [%] | Only available if, for a vector element or a dynamic button element, the property has been set. Linear or Selective or Selective with edges .Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.Values: 0 equals the center of the element. 100 the edge. Note: The value can also be outside of the element and is therefore not limited to 100 . .
Combine | Int16 | Area utilization | Define what effects the created element should have on the frame.The following settings are available:Cover : The surface of the element is used as the screen area.Cut : The surface of the element is removed from the surfaces underneathORed : This is either cut out or covered according to whether a covering element is under the element or not.Note: The way the surface is used always relates to the surface under the element. For newly-created elements, the setting that was selected last is always used. .
CornerAll_X | Int32 | All x [%] | Only available if property is inactive.Defines the value of the rounding of the X-axis in percent for all corners. This value is used for all corners whose values equals -1. Individual corners can therefore be defined independently.If the value of the rounding is changed, all corners are automatically set to the value -1. With this all corners are set back to the pre-defined value.Value range: 0 % to 100 %. Default button: 20 Default rectangle: 0 .
CornerAll_Y | Int32 | All y [%] | Only available if the property is active and the property is inactive.Defines the value of the rounding of the Y-axis in percent for all corners. This value is used for all corners whose values equals -1. Individual corners can therefore be defined independently.If the value of the rounding is changed, all corners are automatically set to the value -1. With this all corners are set back to the pre-defined value.Value range: 0 % to 100 % Default button: 20 Default rectangle: 0 .
CornerLeftBottom_X | Int32 | Left/bottom x [%] | The property must be activated.Defines the radius value of the X-axis for the bottom left corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerLeftBottom_Y | Int32 | Left/bottom y [%] | In addition, the property must be activated and the property must be deactivated.Defines the radius value of the Y-axis for the bottom left corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerLeftTop_X | Int32 | Left/top x [%] | The property must be activated.Defines the radius value of the X-axis for the top left corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerLeftTop_Y | Int32 | Left/top y [%] | In addition, the property must be activated and the property must be deactivated.Defines the radius value of the Y-axis for the top left corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerProportional | Bool | Proportional | Only available if property is inactive.Active: For creating a radiused corner only the x value can be entered. The y value is always the same.The percentage entered at property refers to the shorter side (width or height) of the element.Inactive: The x and y values can be entered freely. The x value refers to the width of the element. The y value refers to the height of the element.Default: active .
CornerRightBottom_X | Int32 | Right/bottom x [%] | Only available if property is inactive.Defines the value of the rounding of the X-axis for the bottom right corner. Click on button ... opens a slider with which you can set the radius.Possible values:-1: The setting from is used.0 to 100: Rounding in percent.Default: -1 .
CornerRightBottom_Y | Int32 | Right/bottom y [%] | In addition, the property must be activated and the property must be deactivated.Defines the radius value of the Y-axis for the bottom right corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerRightTop_X | Int32 | Right/top x [%] | The property must be activated.Defines the radius value of the X-axis for the top right corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerRightTop_Y | Int32 | Right/top y [%] | In addition, the property must be activated and the property must be deactivated.Defines the radius value of the Y-axis for the top right corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillColorInvert | Bool | Invert color gradient | Only available if Color gradient was selected as . Active: The brightness gradient is inverted. Inactive: The brightness gradient is not inverted. Default: Inactive .
FillPattern | UInt32 | Fill pattern | Selection of the filling pattern for the element from the list.This property is only available if property is inactive. .
FillStyle | Guid | Fill style |
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
InnerBrightness | SByte | Brightness inside | Only available if "via brightness value" is active : Brightness in the middle of the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Lightning | Int16 | Color gradient | Only available if was set to Color gradient . Defines the color gradient for elements. Linear : steady gradientDefined point : Gradient from a defined point to the edges of the element Selective with edges : Gradient from a defined point to the edges of the element with beamsRadiant : From the bottom to the middle, then gradient from the middle to the top (with rectangular form only).
LineCapEnd | UInt32 | End type | Defines the symbol for the end point of the line. Clicking on the field opens the dialog to select an element. Only available for the arc of a circle and segment of a circle if has been set to without . .
LineCapScale | float | Size | Defines the magnifying factor for the line width of the arrow. The factor relates to the line width of the vector element as defined in the property. For arc of circle and segment of circle only available if property was set to without .Value: greater or equal 1 Default: 4 .
LineCapStart | UInt32 | Start type | Defines the symbol for the starting point of the line. Click on the field and a dialog opens to select an element. For arc of circle and segment of circle only available if property was set to without . .
LineColor | UInt32 | Line color | Line color of the element.
LineColorEx | UInt32 | Line color | Defines the line color of the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LineStyle | Guid | Line style | Display and selection of the line style that is assigned to the element. .
LineType | UInt32 | Line type | Selection of the line type for the element from the list. Attention: If the node in in the project properties, the property has been set to Windows basic , you can only use line width >1 with a "continuous line" type line. .
LineWidth | UInt16 | Line width [Pixel] | Width of the line (in pixels).Minimum: 0 In this case the width of the line is 1 pixel.Maximum: 40 Default: 1 Attention: If in the project settings in node you set property to Windows basis , you can use line width >1 only with a line of type "continuous line". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
MeasuredInputActivePower | Node | Active power input [MW] | Linked variable with the measured value of the active power at the line input. .
MeasuredInputActivePowerImEx | Node | MeasuredInputActivePowerImEx | Description
MeasuredInputCosPhi | Node | cos Phi input | Linked variable with the measured value of the cos phi power factor at the line input. .
MeasuredInputCosPhiImEx | Node | MeasuredInputCosPhiImEx | Description
MeasuredInputCurrent | Node | Power Input [A] | Linked variable with the measured value of the amperage at the line input. .
MeasuredInputCurrentImEx | Node | MeasuredInputCurrentImEx | Description
MeasuredInputReactivePower | Node | Reactive power input [MVar] | Linked variable with the measured value of the reactive power at the line input. .
MeasuredInputReactivePowerImEx | Node | MeasuredInputReactivePowerImEx | Description
MeasuredInputVoltage | Node | Voltage input [kV] | Linked variable with the measured value of the voltage at the line input. .
MeasuredInputVoltageImEx | Node | MeasuredInputVoltageImEx | Description
MeasuredOutputActivePower | Node | Active power output [MW] | Linked variable with the measured value of the active power at the line output. .
MeasuredOutputActivePowerImEx | Node | MeasuredOutputActivePowerImEx | Description
MeasuredOutputCosPhi | Node | cos Phi output | Linked variable with the measured value of the cos phi power factor at the line output. .
MeasuredOutputCosPhiImEx | Node | MeasuredOutputCosPhiImEx | Description
MeasuredOutputCurrent | Node | Power Output [A] | Linked variable with the measured value of the amperage at the line output. .
MeasuredOutputCurrentImEx | Node | MeasuredOutputCurrentImEx | Description
MeasuredOutputReactivePower | Node | Reactive power output [MVar] | Linked variable with the measured value of the reactive power at the line output. .
MeasuredOutputReactivePowerImEx | Node | MeasuredOutputReactivePowerImEx | Description
MeasuredOutputVoltage | Node | Voltage output [kV] | Linked variable with the measured value of the voltage at the line output. .
MeasuredOutputVoltageImEx | Node | MeasuredOutputVoltageImEx | Description
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
OuterBrightness | SByte | Brightness outside | Only available if "via brightness value" is active : Brightness at the outer side of the element. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
Shifted | Int16 | Shifted color gradient | Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein. Mehr im Online-Handbuch
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VarLineCurrent | Node | Current [A] | Linked variable with the result of the load flow calculation for the calculated amperage at the line input. .
VarLineCurrentImEx | Node | VarLineCurrentImEx | Description
VarLinePowerFactorVar | Node | cos Phi output | Linked variable with the result of the load flow calculation for the calculated power factor (cos phi). This corresponds to the average value of the calculated cos phi at the output. .
VarLinePowerFactorVarImEx | Node | VarLinePowerFactorVarImEx | Description
VarLinePowerInVar | Node | Active power input [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line input. .
VarLinePowerInVarImEx | Node | VarLinePowerInVarImEx | Description
VarLinePowerOutVar | Node | Active power output [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line output. .
VarLinePowerOutVarImEx | Node | VarLinePowerOutVarImEx | Description
VarLineReactivePowerInVar | Node | Reactive power input [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line input. .
VarLineReactivePowerInVarImEx | Node | VarLineReactivePowerInVarImEx | Description
VarLineReactivePowerOutVar | Node | Reactive power output [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line output. .
VarLineReactivePowerOutVarImEx | Node | VarLineReactivePowerOutVarImEx | Description
VarLineVoltageInVar | Node | Voltage input [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line input. .
VarLineVoltageInVarImEx | Node | VarLineVoltageInVarImEx | Description
VarLineVoltageOutVar | Node | Voltage output [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line output. .
VarLineVoltageOutVarImEx | Node | VarLineVoltageOutVarImEx | Description
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Frame vector [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Indicating instrument
ObjectModel COM [image] Element [image] DynProperties [image] Indicating instrument
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
DisplayType | UInt16 | Display type | Properties for the display type in the element.The following display types are available:Ribbon : The value is displayed via a bar from minimal value up to the current value.Arc of a circle : The value is displayed by means of a graduated circle from the minimum value up to the current value.Pointer : The value is shown with a pointer. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
DynEleVar | Node | DynEleVar | "With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndAngle | UInt16 | End angle | Definition of the end angle (0°=bottom center, continues further clockwise)Must not be less than the .Only available for round form with universal slider. .
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
Explicit | Bool | Explicit | Note: Only available at element Pointer instrument if the display is activated as or . .
FillStyle | Guid | Fill style |
FillStyle4Pointer | Guid | Fill style for pointer | Display and selection of the fill style for the pointer that is assigned to the element. .
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
HWDirect | Bool | without dialog | Active: The value is sent to the hardware without a possibility to be changed in the Runtime. Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware. .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
IsSetValue | Bool | Write set value | Active: Setting of set values for this dynamic element is allowed.Inactive: The element is ReadOnly.Not available for the dynamic text element if it has been set to read only in the screen. .
KbdName | String | Screen Keyboard | Only available if property is active.Name of the linked keyboard screen. If no keyboard screen is entered, the respective corresponding keyboard is called up in Runtime:String variable: SETSTRINGKBD Numeric variable: SETVALUEKBD Binary variable: SETBOOLKBD Note: For the input field input option, no keyboard is called up if the option is activated. A keyboard screen must be linked. .
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LimitColor | Bool | Use limit value color | Defines whether the limit value color for the variable linked to the element is displayed in Runtime. The color has an effect on the text displayed, or in the indicator of a universal slider .Active : The defined limit value color is displayed in the Runtime.Default: active .
LimitFromVar | Bool | Take set value limits from variable | Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly. Inactive: The range can be limited directly in the "Minimum" and "Maximum". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
MainTicks | double | Main ticks | Defines main ticks of the scale. Value defines the distance between the main ticks. Value must be larger or equal to the value of property . If it is the same value, no are displayed. .
Max | double | Maximum | Upper limit of the permitted range for the set value. Only available if "Take set value limits from variable" is not active. Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum. .
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
Min | double | Minimum | Bottom limit of the permitted range for the set value. Only available if Take set value limits from variable is not active: Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
OpeningAngle | UInt16 | End angle | Opening angle of the travel of pointer (max. 360° - start angle). .
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
Percentage | Bool | Percent display | Active: The value of the variable is displayed as 0-100%. 0% = minimum measurement range 100% = maximum measurement range The conversion is linear. Setpoint inputs are also entered in percent. Inactive: The value is displayed as usual. Default: inactive. .
Pie | Bool | Arc of a circle | Only available if property is inactive.Active: The value is displayed by means of a graduated circle from the minimum value up to the current value.Inactive: No graduated circle is displayed. .
Preset | Bool | propose current value | Active: The current value of the variable is proposed as set value. In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value). Inactive: The value defined in "Set value / amend" is proposed. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
Ribbon | Bool | Ribbon | Only available if property is inactive.Active: The value is displayed via a bar from minimal value up to the current value.Inactive: No bar is displayed. .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetProgram | String | External program | Only available if an external program was selected for Write set value : The set value is written by an external program that must be selected in the dialog box that appears here. This program is then started and gets the following parameters: 1) Name of the linked variable 2) Proposed value, as defined in the corresponding properties 3) Left coordinate of the element in pixels 4) Upper coordinate of the element in pixels 5) Right coordinate of the element in pixels 6) Lower coordinate of the element in pixels 7) Permitted minimum for the set value, as defined in the corresponding properties 8) Permitted maximum for the set value, as defined in the corresponding properties .
SetValue | double | Set value/change by | Value that should be sent as the set value or as a default. If "Propose current value" is active: : Value that is added to the current value. In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
SetValueWith | SByte | Write set value via | Configuration of how the target value is set. Select from drop-down list:Command Processing: The new value is set using command processing . For input, the screen that is defined in the command group of the linked variable is opened.Standard dialog box : The new value is entered using the standard dialog box. If a screen of type "Keyboard " with name "SETVALUEKBD " (for numeric values) or "SETSTRINGKBD " (for string variables) exists, it is used instead of the standard dialog box. Note: If the element is linked to a function that allows inputs, is automated automatically. If a screen is linked in the property, this is used. Otherwise a SETSTRINGKBD keyboard is used.Element : The new value is directly entered in the element (only for the elements Numeric value and Text ).Program : The new value is entered in an external program. .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShowLeadingZeros | Bool | Show leading zeros | Only available if, for the property, either binary , decimal , hexadecimal or octal has been selected.Defines whether leading zeros are also to be displayed when displaying the numeric values.Inactive: Leading zeros are suppressed. Active : The numeric values are displayed with a different number of digits in accordance with their base. The digits which are not used by the numeric value are filled up with leading zeros. Default: Inactive The following parameters are available for the different bases:Binary: 32 digitsDecimal: 10 digitsHexadecimal: 8 digitsOctal: 11 digits .
ShowState | Bool | Display status of variable | Graphical display of the status of the variable. Selection from a checkbox.Active: The status of the variables is indicated by a colored square at the element. Color : Red square: No communication with the PLC. Example: INVALID, OFF, ALT_VAL, REVISION, TIMEOUT, ...Blue square(N_UPDATE) : On the network client: The client has lost its connection to the Primary Server. With a standalone integration project: The Primary Server has not yet supplied the data.Yellow square (PR_NR) : Visualizes in Runtime that the variable has not been logged during replay in the Process Recorder . No value is therefore known in the playback.Position: The position of the square at the element depends on the element form:Angular and all other elements: Top right cornerRound element: Top, in the middle Rounded element : Top right corner, slightly offset to the left Inactive: The status is not shown. Also deactivates the display of additional variable information with a right click.Default: activated .
ShowUnit | Bool | Show measuring unit | Only available: General: If property has been activated. For the Clock element: if Time difference was selected in the property . For the pointer instrument : if property was activated.Active: The unit of the linked variable is displayed to the right of the value. If the value is displayed in percent, the percent character % is displayed instaed of the unit of the linked variable. Inactive: The technical unit is not displayed. Default: active . Note: .
ShowValueBasis | Bool | Show base | Only available if either binary , hexadecimal or octal has been selected for the property.Active : A short identification for the numbering basis is shown behind the value.The following short identifications are used for:Binary: b Decimal: (no short identification)Exponential: (no short identification)Hexadecimal: h Octal: o Default: active .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
SmallTicks | double | Sub ticks | Defines the division of the scale between .Value defines the distance between the subsidiary ticks. Value must be smaller or equal to the value of property . If it is the same value, no subsidiary ticks are displayed. .
StartAngle | UInt16 | Start angle | Definition of the initial angle (0°=bottom left, continues further clockwise) .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Text color | Text color of the element. .
TextStyle | Guid | Text style |
ThreeDimensional | Bool | 3D | Active: The element is displayed in 3D. Inactive: The element is displayed flat. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
ValueBase | UInt16 | Base for display | Selection of the numbering system for the display of the values. The following numbering systems are available:Binary : Binary display.Decimal : Decimal display.Exponential: Decimal display in exponential notation. Example: 1E+03 equals 1000 in decimal notation.Hexadecimal : Hexadecimal display.Octal : Octal display.Default: Decimal l .
ValueStyle | Guid | Value display style | Display and selection of the value display style that is assigned to the element. .
Variable | CDynEleVar | Variable | Name of the linked variable. Click on button ... in order to open the dialog for selecting variables. The value of this variable is displayed in this element and can also be set here.Note: Only available for buttons if they are used as a switch .Hint: If the variable value is to be toggled, we recommend activating the property. Only SICAM 230 and Screen Alarm element: The description above only applies to the elements Text Button, Bitmap Button and Invisible Button . Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).Lower bit: Alarm active/inactive Higher bit: Alarm acknowledged/not acknowledged .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
ViewMax | double | Maximum | Highest variable value that is to be displayed in the element. .
ViewMin | double | Minimum | Lowest variable value that is to be displayed in the element. .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Indicating instrument [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Indicating instrument [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Invisible button
ObjectModel COM [image] Element [image] DynProperties [image] Invisible button
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
DynEleFkt | Node | Node | Node
DynEleVar | Node | DynEleVar | "With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FastReaction | Bool | Fast reaction | Only available if is active . Active: The switch immediately changes its position in Runtime, regardless of whether the linked bit has actually been set in the PLC. In the next driver update cycle, the bit will be read from the PLC. Then the switch again ressembles the correct position of the bit in the PLC. Attention: The switch will only be visibly operable after the value has been read from the PLC.Inactive: The switch will change its position only after the bit has been sent to the PLC and then again read from the PLC.Default: inactive. .
FktOnDown | Bool | Function execution on pressing | Active: The linked function is executed when the element is pressed. Inactive: The linked function is executed when the element is released. Default: inactive. .
Function | CDynEleFkt | Function | Name of the linked function. Opens the function selection dialog. This function will be executed when the button is clicked in the Runtime or when the assigned key shortcut is pressed. If you wish to execute more than one function, you need to create a script with the required functions and specify the function for executing that script here.SICAM 230 and screen alarming element only: In addition to the standard screen switch property, the screen whose alarm states are supposed to be displayed will be determined by the linked function. Obligatory (unless the Global setting is active )! .
FunctionParameter | String | Parameter for substitution | Entry of the character sequence for substitution via parameters. Replaces the key word {PARAM} in the substitution dialog of the screen switching.Note: Avoid character sequences that are also used for parameter of the indexing variables, such as {X01} . .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
MDIFunction | UInt32 | Screen type specific action | Only available in screens with a special screen type (screen type is not standard ): Linking to a screen-specific function. Clicking on the ... button opens the dialog for selecting a screen-specific function. This function is executed if the button is clicked with the mouse in Runtime or the linked key combination is pressed.Attention: In addition to a screen-type specific function, it is also possible to link a general function with the button. In this case, note the sequence of execution when clicking on the button: The screen-type-specific function is executed first. Only once this has been ended is the general function executed. If VBA events are linked to the button in Runtime, these are executed before the functions. .
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
ParamFromScreen | Bool | Take over from calling screen | The function allows the application of the parameters for the substitution of the calling screen.active: Parameter text field is deactivatedDefault: Inactive
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ReactionTime | UInt16 | Holding time [ms] | Only available if is active . If is active: Time (in ms) which a state is held starting from the left click on the respective element.If property is inactive: Delayed reaction to a left click. .
ResetOnLeave | Bool | Reset on exit | Only available if property is active . If you press and hold the mouse button and move the mouse pointer away from the pushbutton, this will automatically reset the value of the variable. .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
Scanner | Bool | Pushbutton | Only available if property is active. (Exception: always available in the switch dynamic element.) Active: The target state - defined in property - is only held as long as the left mouse button is pressed but at least as long as . Inactive: The target state remains even after the mouse button is released. Default: inactive. .
ScannerOn | Bool | Pushbutton On | Only available if is active . Active: Pushbutton switches to ON. Inactive: Pushbutton switches to OFF. Default: Inactive. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StayPressed | Bool | Keep pushed state | Only available if properties , and are active. Active: As long as you hold the mouse button pressed on this element, its graphical display does not change - independent of possible values changes in the PLC. At the element Switch property must be active in order for this to happen. Inactive: The element always displays the value of the variable from the PLC. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Switch | Bool | Switch | Only available if property is inactive.Active: The element switches the value of a bit variable. Inactive: The element carries out a function. Default: Inactive .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
Variable | CDynEleVar | Variable | Name of the linked variable. Click on button ... in order to open the dialog for selecting variables. The value of this variable is displayed in this element and can also be set here.Note: Only available for buttons if they are used as a switch .Hint: If the variable value is to be toggled, we recommend activating the property. Only SICAM 230 and Screen Alarm element: The description above only applies to the elements Text Button, Bitmap Button and Invisible Button . Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).Lower bit: Alarm active/inactive Higher bit: Alarm acknowledged/not acknowledged .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleFkt
ObjectModel COM [image] Element [image] DynProperties [image] Invisible button [image] CDynEleFkt
Overview
External Name | Type | Display Name | Description
Name | String | Name |
ProjectFunction | CProjektFunktion | ProjectFunction |


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Invisible button [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Invisible button [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Line
ObjectModel COM [image] Element [image] DynProperties [image] Line
Overview
External Name | Type | Display Name | Description
ALCAlias | Bool | Use alias | Only available if is active.Active : Alias is used. In the Runtime the element receives its ALC colors from another ALC element of the topological model without being part of the model itself. The displayed ALC color of the element is thus not determined by the linked lines. The ALC color is identical to the color of the ALC element, the name of which is linked in the .Inactive : Element is an ALC element according to the configured ALC . The ALC display color is determined by the linked lines.Default: Inactive .
ALCAliasName | String | Alias | Only available if is active.Defined source element for property . Clicking on the ... button opens the dialog to select a pre-configured ALC element in a pre-configured zenon screen. Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project. .
ALCAlternativeColor | UInt32 | Alternative color | Only available if property has value alternative color .Alternative color for the ALC coloring at multiple supply. .
ALCDashLen | Int16 | Dashing length supplied multiple times | Only available if property has value two highest prior sources .Defines the dash length in pixel for the dashed ALC coloring at multiply supply.Minimal: 0 (automatic dash length)Maximum: 32767 Default: 0 .
ALCEnclosementSize | SByte | Curb width [px] | Width of the curb in pixels.Default: 1 pixel Input range: 1 to 20 pixels.Note: Only available if property is active. .
ALCLength | double | Length of the line [km] | ALC line: Length of the line. .
ALCLineName | String | Line name | Unique name of the line. Is used for the identification of the line in the load distribution calculation. In addition, this name is used as interlocking text for the "Overload of a line " topological interlocking.Note : Only available for the Line or Pipe screen element. .
ALCMaxIType | Int16 | Limit value current carrying capacity | Origin of data on the limit value of the current carrying capacity for the calculation of load distribution . The current carrying capacity of the weakest link (cable) in a line. Selection of the type from the drop-down list: Default: Static limit value current carrying capacity Note: The entries in the drop-down list correspond to the properties that follow the Editor directly. .
ALCMaxIVal | double | Static limit value current carrying capacity [A] | Entry of the maximum current-carrying capacity of the weakest link (cable) in the line. Entry in amperes.Default: 20 Not available if the property is configured with limit value of current-carrying capacity dynamic . .
ALCMSecuredSupply | Int16 | display secured supply | Only available if was activated.Definition of the display of the secured supply:double widthdouble brightnessnormalDefault: normal .
ALCMultiSource | Int16 | display multiple supplies | Only available if the property is active. Defines the display type if the element is connected to several sources: most prior source: Only the color of the source with the highest priority is used. two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line. alternative color : Alternative color for the coloring at multiple supply.Default: highest priority source .
ALCPrecedence | Int16 | Priority for display | Only available if the property is active.Defines the priority of the display when the element is connected to several active sources. Multiple supply : The element is displayed according to the rules of the multiple supply. secured supply : The element is displayed according to the rules of the secured supply. No priority : The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.Default: Multiple supply .
ALCReact | double | Reactance value of the cable [Ohm] | Maximum permitted value of the reactance (reactance X) of the line in Ohms. Is used for the detection of the fault locating of protection . .
ALCResist | double | Resistance value of the electric line [Ohm] | Maximum permitted value of the resistance (effective resistance R) of the line in Ohms. Is used for the calculation of load distribution. .
ALCUseColor | Bool | Color from ALC | Only available if you have licensed Automatic Line Coloring (ALC) : Active: The automatic color of the linked source(s) is used. Inactive: The standard color is used. Default: inactive. .
ALCUseEnclosement | Bool | Use curb | Checkbox for the activation of the curb of lines, polylines and pipelines.active: ALC line elements are visualized in Runtime for a ground fault or short circuit with an additional border in the corresponding color. The colors are defined in the ALC project settings.Inactive: No display of curbing in Runtime.Default: Inactive Note: only active if is activated. .
ALCVarCalcI | CDynEleVar | Measuring value of the calculated current flow | Linked variable with the measured value of the calculated current flow of the branch. Calculation result in amperes [A]. .
ALCVarCalcIEx | Node | ALCVarCalcIEx | ALC Leitung: Messwert des berechneten Stromflusses für Export.Mehr in der Online-Hilfe .
ALCVarMaxI | CDynEleVar | Dynamic limit value current carrying capacity | Linked variable for the maximum current-carrying capacity of the weakest link (cable) in the line. Only available if the limit value of current-carrying capacity property is configured with limit value of current-carrying capacity dynamic . .
ALCVarMaxIEx | Node | ALCVarMaxIEx | Node
AlphaLineColor | SByte | Transparency line color [%] | .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVariable2 | CDynEleVar | Gradient color | Name of the variable whose limit value color should influence the gradient color of the element. Click on the input filed in order to open the dialog for selecting a variable. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LineCapEnd | UInt32 | End type | Defines the symbol for the end point of the line. Clicking on the field opens the dialog to select an element. Only available for the arc of a circle and segment of a circle if has been set to without . .
LineCapScale | float | Size | Defines the magnifying factor for the line width of the arrow. The factor relates to the line width of the vector element as defined in the property. For arc of circle and segment of circle only available if property was set to without .Value: greater or equal 1 Default: 4 .
LineCapStart | UInt32 | Start type | Defines the symbol for the starting point of the line. Click on the field and a dialog opens to select an element. For arc of circle and segment of circle only available if property was set to without . .
LineColor | UInt32 | Line color | Line color of the element.
LineColorEx | UInt32 | Line color | Defines the line color of the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LineStyle | Guid | Line style | Display and selection of the line style that is assigned to the element. .
LineType | UInt32 | Line type | Selection of the line type for the element from the list. Attention: If the node in in the project properties, the property has been set to Windows basic , you can only use line width >1 with a "continuous line" type line. .
LineWidth | UInt16 | Line width [Pixel] | Width of the line (in pixels).Minimum: 0 In this case the width of the line is 1 pixel.Maximum: 40 Default: 1 Attention: If in the project settings in node you set property to Windows basis , you can use line width >1 only with a line of type "continuous line". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
MeasuredInputActivePower | Node | Active power input [MW] | Linked variable with the measured value of the active power at the line input. .
MeasuredInputActivePowerImEx | Node | MeasuredInputActivePowerImEx | Description
MeasuredInputCosPhi | Node | cos Phi input | Linked variable with the measured value of the cos phi power factor at the line input. .
MeasuredInputCosPhiImEx | Node | MeasuredInputCosPhiImEx | Description
MeasuredInputCurrent | Node | Power Input [A] | Linked variable with the measured value of the amperage at the line input. .
MeasuredInputCurrentImEx | Node | MeasuredInputCurrentImEx | Description
MeasuredInputReactivePower | Node | Reactive power input [MVar] | Linked variable with the measured value of the reactive power at the line input. .
MeasuredInputReactivePowerImEx | Node | MeasuredInputReactivePowerImEx | Description
MeasuredInputVoltage | Node | Voltage input [kV] | Linked variable with the measured value of the voltage at the line input. .
MeasuredInputVoltageImEx | Node | MeasuredInputVoltageImEx | Description
MeasuredOutputActivePower | Node | Active power output [MW] | Linked variable with the measured value of the active power at the line output. .
MeasuredOutputActivePowerImEx | Node | MeasuredOutputActivePowerImEx | Description
MeasuredOutputCosPhi | Node | cos Phi output | Linked variable with the measured value of the cos phi power factor at the line output. .
MeasuredOutputCosPhiImEx | Node | MeasuredOutputCosPhiImEx | Description
MeasuredOutputCurrent | Node | Power Output [A] | Linked variable with the measured value of the amperage at the line output. .
MeasuredOutputCurrentImEx | Node | MeasuredOutputCurrentImEx | Description
MeasuredOutputReactivePower | Node | Reactive power output [MVar] | Linked variable with the measured value of the reactive power at the line output. .
MeasuredOutputReactivePowerImEx | Node | MeasuredOutputReactivePowerImEx | Description
MeasuredOutputVoltage | Node | Voltage output [kV] | Linked variable with the measured value of the voltage at the line output. .
MeasuredOutputVoltageImEx | Node | MeasuredOutputVoltageImEx | Description
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VarLineCurrent | Node | Current [A] | Linked variable with the result of the load flow calculation for the calculated amperage at the line input. .
VarLineCurrentImEx | Node | VarLineCurrentImEx | Description
VarLinePowerFactorVar | Node | cos Phi output | Linked variable with the result of the load flow calculation for the calculated power factor (cos phi). This corresponds to the average value of the calculated cos phi at the output. .
VarLinePowerFactorVarImEx | Node | VarLinePowerFactorVarImEx | Description
VarLinePowerInVar | Node | Active power input [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line input. .
VarLinePowerInVarImEx | Node | VarLinePowerInVarImEx | Description
VarLinePowerOutVar | Node | Active power output [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line output. .
VarLinePowerOutVarImEx | Node | VarLinePowerOutVarImEx | Description
VarLineReactivePowerInVar | Node | Reactive power input [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line input. .
VarLineReactivePowerInVarImEx | Node | VarLineReactivePowerInVarImEx | Description
VarLineReactivePowerOutVar | Node | Reactive power output [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line output. .
VarLineReactivePowerOutVarImEx | Node | VarLineReactivePowerOutVarImEx | Description
VarLineVoltageInVar | Node | Voltage input [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line input. .
VarLineVoltageInVarImEx | Node | VarLineVoltageInVarImEx | Description
VarLineVoltageOutVar | Node | Voltage output [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line output. .
VarLineVoltageOutVarImEx | Node | VarLineVoltageOutVarImEx | Description
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Line [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Link text
ObjectModel COM [image] Element [image] DynProperties [image] Link text
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
CommitOnKillFocus | Bool | Write on lost focus | Behavior of an element when writing a set value in Runtime:Active : The value is written as soon as the control element loses the focus. Input is canceled by pressing the Esc key and the value is not written.Inactive : The value is written after confirmation by pressing the Enter key . Input is canceled by pressing the Esc key and the value is not set.Default valueAs an element in the screen: Inactive Editable dynamic text from the control elements menu: active .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
DynEleVar | Node | DynEleVar | "With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"
DynText | String | Text | Only available if a numeric value has been linked and limit value text has been selected for the property.Input of the text that is displayed in Runtime if there is no limit value violation. If a limit value is violated, the limit value text configured for the variable is displayed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillStyle | Guid | Fill style |
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
Frame | UInt16 | Element border | Drop-down list for the selection of the frame type. The following are available:For the button element Thin border 3D Default: Thin border For other dynamic elements Edge heightened Edge deepened No border Classical heightened Classical deepened Margin heightened Margin deepened Default: No border .
FrameStyle | Guid | Element border line style | Display and selection of the element style that is assigned to the element. .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HiddenInput | Bool | Hidden input | Activation of hidden input of text.Active : Text of the element is shown as masked in Runtime. To do this, the field is filled eight times with the character selected in the property. Standard character: * Default: inactive .
HorizontalAlign | Int16 | Alignment horizontal | Horizontal orientation of the value for the display. Selection from a drop-down list:Left Right Centered Default: Centered. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
HWDirect | Bool | without dialog | Active: The value is sent to the hardware without a possibility to be changed in the Runtime. Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware. .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
IsSetValue | Bool | Write set value | Active: Setting of set values for this dynamic element is allowed.Inactive: The element is ReadOnly.Not available for the dynamic text element if it has been set to read only in the screen. .
KbdName | String | Screen Keyboard | Only available if property is active.Name of the linked keyboard screen. If no keyboard screen is entered, the respective corresponding keyboard is called up in Runtime:String variable: SETSTRINGKBD Numeric variable: SETVALUEKBD Binary variable: SETBOOLKBD Note: For the input field input option, no keyboard is called up if the option is activated. A keyboard screen must be linked. .
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LimitColor | Bool | Use limit value color | Defines whether the limit value color for the variable linked to the element is displayed in Runtime. The color has an effect on the text displayed, or in the indicator of a universal slider .Active : The defined limit value color is displayed in the Runtime.Default: active .
LimitFromVar | Bool | Take set value limits from variable | Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly. Inactive: The range can be limited directly in the "Minimum" and "Maximum". .
LineColorVariable | CDynEleVar | Text color | Name of the variable whose limit value color is to influence the text color of the element. Click on the ... button to open the dialog for selecting a variable..
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
MaskingLetter | String | Masking character | Selection of the character with which the text is to be hidden in Runtime. Only available if property is active. .
Max | double | Maximum | Upper limit of the permitted range for the set value. Only available if "Take set value limits from variable" is not active. Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum. .
MDIFunction | UInt32 | Screen type specific action | Only available in screens with a special screen type (screen type is not standard ): Linking to a screen-specific function. Clicking on the ... button opens the dialog for selecting a screen-specific function. This function is executed if the button is clicked with the mouse in Runtime or the linked key combination is pressed.Attention: In addition to a screen-type specific function, it is also possible to link a general function with the button. In this case, note the sequence of execution when clicking on the button: The screen-type-specific function is executed first. Only once this has been ended is the general function executed. If VBA events are linked to the button in Runtime, these are executed before the functions. .
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
Min | double | Minimum | Bottom limit of the permitted range for the set value. Only available if Take set value limits from variable is not active: Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
Preset | Bool | propose current value | Active: The current value of the variable is proposed as set value. In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value). Inactive: The value defined in "Set value / amend" is proposed. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetProgram | String | External program | Only available if an external program was selected for Write set value : The set value is written by an external program that must be selected in the dialog box that appears here. This program is then started and gets the following parameters: 1) Name of the linked variable 2) Proposed value, as defined in the corresponding properties 3) Left coordinate of the element in pixels 4) Upper coordinate of the element in pixels 5) Right coordinate of the element in pixels 6) Lower coordinate of the element in pixels 7) Permitted minimum for the set value, as defined in the corresponding properties 8) Permitted maximum for the set value, as defined in the corresponding properties .
SetValue | double | Set value/change by | Value that should be sent as the set value or as a default. If "Propose current value" is active: : Value that is added to the current value. In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
SetValueText | String | Set value text | Text that is used in Runtime as a proposal for writing the set value.Only available if the following conditions are applicable: property is active :Property is inactive :Linked variable is a of type STRING Maximum text length: depends on the value of the property for the linked variableNote: If this property is used with the property deactivated, the value is written directly to the element in Runtime. .
SetValueWith | SByte | Write set value via | Configuration of how the target value is set. Select from drop-down list:Command Processing: The new value is set using command processing . For input, the screen that is defined in the command group of the linked variable is opened.Standard dialog box : The new value is entered using the standard dialog box. If a screen of type "Keyboard " with name "SETVALUEKBD " (for numeric values) or "SETSTRINGKBD " (for string variables) exists, it is used instead of the standard dialog box. Note: If the element is linked to a function that allows inputs, is automated automatically. If a screen is linked in the property, this is used. Otherwise a SETSTRINGKBD keyboard is used.Element : The new value is directly entered in the element (only for the elements Numeric value and Text ).Program : The new value is entered in an external program. .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShowState | Bool | Display status of variable | Graphical display of the status of the variable. Selection from a checkbox.Active: The status of the variables is indicated by a colored square at the element. Color : Red square: No communication with the PLC. Example: INVALID, OFF, ALT_VAL, REVISION, TIMEOUT, ...Blue square(N_UPDATE) : On the network client: The client has lost its connection to the Primary Server. With a standalone integration project: The Primary Server has not yet supplied the data.Yellow square (PR_NR) : Visualizes in Runtime that the variable has not been logged during replay in the Process Recorder . No value is therefore known in the playback.Position: The position of the square at the element depends on the element form:Angular and all other elements: Top right cornerRound element: Top, in the middle Rounded element : Top right corner, slightly offset to the left Inactive: The status is not shown. Also deactivates the display of additional variable information with a right click.Default: activated .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Text color | Text color of the element. .
TextSource | UInt16 | Display text | Selection of the content to be displayed in Runtime from a drop-down list:Resources label : The content of the variable property is displayed.Limit value text : As long as no limit value has been violated, the content of the screen property is displayed. If a limit value is violated, the content of the variable property is displayed.Measuring unit : The content of the variable property is displayed.Variable identification : The content of the variable property is displayed.Variable name : The content of the variable property is displayed.Variable value : The value of the variable is displayed.Default: Limit value text The selected content is displayed in the preview of the element in the main window below the linked variables. .
TextStyle | Guid | Text style |
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TranslateText | Bool | Translate display text | Active : The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.Default: Inactive .
Transparent | Bool | Transparent | Settings for transparency.Active : Displays the element transparently.Default: Inactive The effect of this option on a button is an Invisible button . It can be positioned above other elements as an invisible button. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
Variable | CDynEleVar | Variable | Name of the linked variable. Click on button ... in order to open the dialog for selecting variables. The value of this variable is displayed in this element and can also be set here.Note: Only available for buttons if they are used as a switch .Hint: If the variable value is to be toggled, we recommend activating the property. Only SICAM 230 and Screen Alarm element: The description above only applies to the elements Text Button, Bitmap Button and Invisible Button . Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).Lower bit: Alarm active/inactive Higher bit: Alarm acknowledged/not acknowledged .
VerticalAlign | Int16 | Alignment vertical | Vertical orientation of the value for the display. Selection from a drop-down list:Top Bottom Centered Default: Centered. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
Wordbreak | Bool | Automatic word wrap | Active: Automatic word wrap is used for the text in the element. The length of the lines depends on the width of the element.Inactive: The text is displayed in one line.Default: Inactive .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Link text [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Link text [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Linked symbol
ObjectModel COM [image] Element [image] DynProperties [image] Linked symbol
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
ExpProps | Node | ExpProps | Node
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
GraphicSize | UInt16 | Graphic size | Definition of the graphics size.Adjusted : The size of the graphics is adjusted to the size of the element.Original size : The linked graphics are displayed in their original size. When selecting this option, the and properties can no longer be configured individually for the multibin, combi-element, button and switch elements. All graphics files should be the same size.Default: adjust .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LinkName | String | Symbol name | Name of the symbol. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
Preview | String | Preview | Opens the dialog to replace links. Changes in the preview are taken over and reversed in properties and . Stands for symbols and faceplates available. Only active for symbols if there is already linking to the symbol; for faceplate containers, only if a screen is linked to a container.More information is in the online manual in he Symbols and Faceplates sections.
PropSymbolNumber | UInt16 | Screen symbol number | Unique number of the symbol or the element group. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
SubstituteCombinedName | Bool | Hierarchical names | Replacing variables in a symbol.The behavior of this property is directly related to the settings of the property: If the property is activated, the variable name ( property) is used. If the property is not active, the variable identification ( property) is used. propertyActive: The names of the linked variables/identification are put together from the object name of the symbol and the variables defined in the symbol. The two names are separated by a dot: "Symbol name.Variable " or "Symbol name.Identification "Inactive: Variable name or variable identification are used.Default: Inactive Attention: .
SubstituteDestination | String | Target | Replacement of variables or functions in a symbol or faceplate container: Enter the new variables/functions to be assigned. At this no wildcards are allowed. Several entries are separated by a semicolon (; ).You can define the sources with the help of property . Example: Variables in the symbol: Tank1.fill level and Tank1.position of the valve . These should be replaced by Tank2.fill level and Tank2.position of the valve . For this enter the following at : *1* and at 2 . In the Runtime the variables which contain 1 are replaced by the variables which contain 2 .More information is in the online manual in he Symbols and Faceplates sections.
SubstituteInterlockingVariables | Bool | Consider interlocking variables | Description as text.
SubstituteMatchCase | Bool | Case sensitive | The capitalization in the inputs for the source and the target to replace variables or functions in a symbol or faceplate container.Active: Capitalization is taken into account.Inactive: Capitalization is not taken into account.More information is in the online manual in he Symbols and Faceplates sections.
SubstituteOnName | Bool | Via variable name | Replacement of variables in a symbol or faceplate container using variables:Active: The replacement of links is implemented via the name of the variables.Inactive The replacement of the links is implemented via the identification of the variables.Default: activated More information is in the online manual in he Symbols and Faceplates sections. Note: This property also has effects on the behavior of the property. You can find more information on this in the Screens manual.
SubstituteSource | String | Source | Replacing variables or functions in a symbol or faceplate container.Enter the source variable/source function. You can use wildcards (?,*). Several entries are separated by a semicolon (; ).You can define the target with the help of property . Example: Variables in the symbol: Tank1.fill level and Tank1.position of the valve . These should be replaced by Tank2.fill level and Tank2.position of the valve . For this enter the following at : *1* and at 2 . In the Runtime the variables which contain 1 are replaced by the variables which contain 2 .More information is in the online manual in he Symbols and Faceplates sections.
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Linked symbol [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CSymbLibProp
ObjectModel COM [image] Element [image] DynProperties [image] Linked symbol [image] CSymbLibProp
Overview

External Name

Type

Display Name

Description


Listbox
ObjectModel COM [image] Element [image] DynProperties [image] Listbox
Overview
External Name | Type | Display Name | Description
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Legend | String | Text | Label of the element in the Editor. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
ShowBorder | Bool | Show border lines | Visualizes a border for certain elements when displayed in Runtime. The configuration of the and properties is no longer taken into account for the display in Runtime as a result.Active : The element is shown in Runtime with a border.Inactive: No border when displayed in Runtime.Default: inactive. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleH | UInt16 | Style H | Windows style of the element, for internal use only. .
StyleL | UInt16 | Style L | Windows style of the element, for internal use only. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Text color | Text color of the element. .
TranslateText | Bool | Translate display text | Active : The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.Default: Inactive .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Listbox [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Listcontrol
ObjectModel COM [image] Element [image] DynProperties [image] Listcontrol
Overview
External Name | Type | Display Name | Description
AdvancedStyleH | Bool | Extended graphical settings | Controls the use of the customizable horizontal and vertical scroll bars, the header and the grid. If you activate this property, you can customize the display of the list field as you wish.Default: Inactive . .
AscSortImage | String | Sort ascending | Select a graphics file that is to be displayed in the header of the list field for ascending sort in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> for AML . for CEL . for ETM .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColor2H | UInt32 | Gradient color | Define the second filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property .As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColor2V | UInt32 | Gradient color | Define the second filling color which is used for the color gradient for the vertical scroll bar. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property .As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColorH | UInt32 | Fill color | Define the first filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColorV | UInt32 | Fill color | Define the first filling color which is used for the color gradient for the vertical scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BarStyleH | Int16 | Display style | Define how the header of the list field should look like. Select one of the following options:Color gradient : Uses a special color gradient for the header. You can customize the color gradient with the help of properties , , , and .Graphics file : Uses the selected graphics files for the individual areas. If no graphics files have been selected, the Color gradient display is used.Standard : Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.Default: Standard . .
BarStyleV | Int16 | Display style | Define how the header of the list field should look like. Select one of the following options:Color gradient : Uses a special color gradient for the header. You can customize the color gradient with the help of properties , , , and .Graphics file : Uses the selected graphics files for the individual areas. If no graphics files have been selected, the Color gradient display is used.Standard : Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.Default: Standard . .
BitmapLeftH | String | Scroll arrow left | Select a graphics file that is to be displayed in the list field for the left scroll arrow for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapLeftV | String | Scroll arrow up | Select a graphics file that is to be displayed in the list field for the up scroll arrow for the vertical scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapRightH | String | Scroll arrow right | Select a graphics file that is to be displayed in the list field for the right scroll arrow for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapRightV | String | Scroll arrow down | Select a graphics file that is to be displayed in the list field for the down scroll arrow for the vertical scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapSpanH | String | Background graphics file | Select a graphics file that is to be displayed in the list field as a background for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapSpanV | String | Background graphics file | Select a graphics file that is to be displayed in the list field as a background for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapThumbH | String | Scroll box | Select a graphics file that is to be displayed in the list field for the scroll box for the horizontal scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BitmapThumbV | String | Scroll box | Select a graphics file that is to be displayed in the list field for the scroll box for the vertical scroll bar in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
ButtonHeightH | Int16 | Height scroll arrow [Pixel] | Define the height of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.Default: 12 . .
ButtonHeightV | Int16 | Height scroll arrow [Pixel] | Define the height of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.Default: 12 . .
ButtonWidthH | Int16 | Width scroll arrow [Pixel] | Define the width of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.Default: 12 . .
ButtonWidthV | Int16 | Width scroll arrow [Pixel] | Define the width of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.Default: 12 . .
ColorGradientAngleH | Int16 | Angle [°] | Define the angle in whose direction the color gradient spreads. As starting point the point defined in property is used.Minimum: 0 Maximum: 360 Default: 0 .
ColorGradientAngleV | Int16 | Angle [°] | Define the angle in whose direction the color gradient spreads. As starting point the point defined in property is used.Minimum: 0 Maximum: 360 Default: 0 .
ColorGradientOffsetH | Int16 | Offset [%] | Define the distance of the color gradient point from the center of the horizontal scroll bar to the left or the right in percent. 0 means the center of the horizontal scroll bar, 100 means the right edge of the horizontal scroll bar and -100 means the left edge of the horizontal scroll bar.Minimum: -100 Maximum: 100 Default: 0 .
ColorGradientOffsetV | Int16 | Offset [%] | Define the distance of the color gradient point from the center of the vertical scroll bar to the left or the right in percent. 0 means the center of the vertical scroll bar, 100 means the right edge of the vertical scroll bar and -100 means the left edge of the vertical scroll bar.Minimum: -100 Maximum: 100 Default: 0 .
ColumnOrderStatic | Bool | Freeze column location | For configurable lists, controls the possibility to move table columns in Runtime with mouse actions.Active : The columns cannot be arranged by dragging & dropping. The column width can still be amended by dragging with the mouse.Inactive : The columns can be arranged by means of drag&drop. The column width can be amended by dragging with the mouse.If there is an element in the screen that has column selection via the , this element is deactivated if the property is active.Default: Inactive . With the property activated, neither sorting by means of drag&drop nor amendment of the column width with the mouse is possible.
DescDownImage | String | Sort descending | Select a graphics file that is to be displayed in the header of the list field for descending sort in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> for AML . for CEL . for ETM .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnableHeader | Bool | Make header editable | Makes it possible to operate the header for the respective list field. You can change the width of the columns and sort the display according to any desired column in Runtime.active : The header can be operated.Default: active Availability: Available for AML and CEL under the following conditions: If you selected operable header in the group for the property or in the group for the property. for AML . for CEL . for ETM .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
GridColorH | UInt32 | Horizontal line color | Defines the line color of the horizontal grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
GridColorV | UInt32 | Vertical line color | Defines the line color of the vertical grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. .
GridSizeH | UInt16 | Horizontal line width [Pixel] | Width of the horizontal grid line in pixel. Change this value in order to change the horizontal lines of the grid of the list view in the Runtime. If you enter 0 , the horizontal lines are hidden.Default: 1 . .
GridSizeV | UInt16 | Vertical line width [Pixel] | Width of the vertical grid line in pixel. Change this value in order to change the vertical lines of the grid of the list view in the Runtime. If you enter 0 , the vertical lines are hidden.Default: 1 . .
GridTypeH | UInt32 | Horizontal line type | Defines the type of the horizontal grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).Default: solid line.Attention: This property is available if the value for property is 1 . For values >1 a solid line is used. .
GridTypeV | UInt32 | Vertical line type | Defines the type of the vertical grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).Default: solid line.Attention: This property is available if the value for property is 1 . For values >1 a solid line is used. .
HeaderBackColor | UInt32 | Fill color | Define the first filling color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. for AML . for CEL . for ETM .
HeaderBackColor2 | UInt32 | Gradient color | Define the second fill color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property .As color for a newly created element the color which was used for the previous element of the same type is used. AML . CEL . for ETM .
HeaderBarImage | String | Background | Select a graphics file that is to be displayed in the header of the list field as a background in Runtime. This graphics file is used if you selected Graphics file for the property.Default: <No file> for AML . for CEL . for ETM .
HeaderColorGradientAngle | Int16 | Angle | Define the angle in whose direction the color gradient spreads. As starting point the point defined in property is used.Minimum: 0 Maximum: 360 Default: 0 AML . CEL . for ETM .
HeaderColorGradientOffset | Int16 | Offset | Define the distance of the color gradient from the center of the header to the left or the right in percent. 0 means the center of the header, 100 means the right edge of the header and -100 means the left edge of the header.Minimum: -100 Maximum: 100 Default: 0 AML . CEL . for ETM .
HeaderFont | UInt16 | Font | Define the font which should be used for the text in the header. Clicking on the button opens a dialog for selecting the pre-defined fonts.As font for a newly created element the font which was used for the previous element of the same type is used. for AML . for CEL . for ETM .
HeaderFontColor | UInt32 | Text color | Define the color which should be used for the text in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.As color for a newly created element the color which was used for the previous element of the same type is used. for AML . for CEL . for ETM .
HeaderLightning | Int16 | Light effect | Select the type of the color gradient for the header from the following options:Linear : steady gradientDefined point : Gradient from the defined point to the edges of the elementStarting from a defined point with beams : Gradient with beams from the defined point to the edges of the elementDefault: Linear AML . CEL . for ETM .
HeaderStyle | Int16 | Display style | Define how the header of the list field should look like. Select one of the following options:Color gradient : Uses a special color gradient for the header. You can customize the color gradient with the help of properties , , , and .Graphics file : Uses the selected graphics files for the individual areas. If no graphics files have been selected, the Color gradient display is used.Standard : Uses the standard setting for the header. You can only change the and the with the help of the respective setting.Default: Standard . for AML . for CEL . for ETM .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HideSelection | Bool | Do not mark selected row | You use this to define whether the selected line is highlighted in the list field. If you activate this property, you do not see which entry you have selected. All lines of the list look the same.Default: Inactive . for AML . for CEL .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Legend | String | Text | Label of the element in the Editor. .
LightningH | Int16 | Color gradient | Select the type of the color gradient for the horizontal scroll bar from the following options:Linear : steady gradientDefined point : Gradient from the defined point to the edges of the elementStarting from a defined point with beams : Gradient with beams from the defined point to the edges of the elementDefault: Linear .
LightningV | Int16 | Color gradient | Select the type of the color gradient for the vertical scroll bar from the following options:Linear : steady gradientDefined point : Gradient from the defined point to the edges of the elementStarting from a defined point with beams : Gradient with beams from the defined point to the edges of the elementDefault: Linear .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
NoSortHeader | Bool | Disable sorting | Controls the possibility of sorting table columns in Runtime with a click on the header.Active : The table cannot be sorted by means of clicking.Inactive : The table can be sorted by clicking in the header of the column.Default: Inactive
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RowHeight | UInt32 | Line height [pixel] | Makes it possible to define the row height in pixels independent of the font size.Maximum value: 255 px Minimum value : 0 px - row height is adapted to font size.Default : 0 Attention: If the row heightis selected is too large, nothing is displayed in Runtime in certain circumstances.is selected as smaller than the font size, then graphical illustrations are cut off. .
SelectionActive | CDynEleVar | Selection active | Linking of a response variable for configurable lists . The variable must be of the type BOOL . It shows in Runtime whether something has been selected in the list (1 ) or not (0 ). Clicking on the ... button opens the dialog to select a variable. .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
ShowBorder | Bool | Show border lines | Visualizes a border for certain elements when displayed in Runtime. The configuration of the and properties is no longer taken into account for the display in Runtime as a result.Active : The element is shown in Runtime with a border.Inactive: No border when displayed in Runtime.Default: inactive. .
ShowHeader | Bool | Show header | Only available if you have selected operable header or fixed header in the project settings in the group for the property or in the group for the property. Displays the header for the respective list field. In group you can customize the look of the header.active: The header is displayed.Default: active for AML . for CEL . for ETM .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleH | UInt16 | Style H | Windows style of the element, for internal use only. .
StyleL | UInt16 | Style L | Windows style of the element, for internal use only. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Text color | Text color of the element. .
ThumbSizeH | Int16 | Width scroll box [Pixel] | Define the width of the scroll box in pixel for the horizontal scroll bar. Adjust the value to your ideas.Default: 20 . .
ThumbSizeV | Int16 | Width scroll box [Pixel] | Define the width of the scroll box in pixel for the vertical scroll bar. Adjust the value to your ideas.Default: 20 . .
TranslateText | Bool | Translate display text | Active : The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.Default: Inactive .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
WordWrap | Bool | Automatic word wrap | Allows multi-line display of texts in the list if the column width for the text to be shown is not sufficient. In doing so, the line height is enlarged accordingly.Active : If the column width is not sufficient, a line break is carried out and the line height is increased.Inactive : No word wrap is performed, the display is in one line.Info: A word wrap is only carried out if there are empty spaces in the text to be displayed (spaces, tabs or similar) or if a line break is inserted manually by means of a \n in the text. No line break is carried out for uninterrupted texts.Default: Inactive for AML . for CEL .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Listcontrol [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


MDI element
ObjectModel COM [image] Element [image] DynProperties [image] MDI element
Overview
External Name | Type | Display Name | Description
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Legend | String | Text | Label of the element in the Editor. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleH | UInt16 | Style H | Windows style of the element, for internal use only. .
StyleL | UInt16 | Style L | Windows style of the element, for internal use only. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Text color | Text color of the element. .
TranslateText | Bool | Translate display text | Active : The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.Default: Inactive .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] MDI element [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Message
ObjectModel COM [image] Element [image] DynProperties [image] Message
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
ColVars | String | Line activation | The line variables define the line position from which the text is taken. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
MessageText | UInt32 | Text file | Selection of the text file. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextChangeTime | UInt32 | Time for text change [s] | With several set bits of the line variables the changeover of the text occurs automatically within the configured time .
TextColor | UInt32 | Text color | Text color of the element. .
ThreeDimensional | Bool | 3D | Active: The element is displayed in 3D. Inactive: The element is displayed flat. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
Transparent | Bool | Transparent | Settings for transparency.Active : Displays the element transparently.Default: Inactive The effect of this option on a button is an Invisible button . It can be positioned above other elements as an invisible button. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
Variable | String | Column selection | The column variable must be a word variable and defines the column position from which the text is taken. ATTENTION : The column variable must be selected before the line variable. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Message [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Message [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Move
ObjectModel COM [image] Element [image] DynProperties [image] Move
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
DynEleVarX | Node | DynEleVarX | "With this property you have the opportunity to get informations about the variable which is linked at the ""dynamic x position"" property. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVarX.SymVarName"") 'Return the name of the ""x position dynamic"" variable zElement.DynProperties (""DynEleVarX.SymVarTagNr"") 'Return the identification of the ""x position dynamic"" variable"
DynEleVarXZoom | Node | DynEleVarXZoom | "With this property you have the opportunity to get informations about the variable which is linked at the ""change width"" property. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVarXZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""DynEleVarXZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
DynEleVarY | Node | DynEleVarY | "With this property you have the opportunity to get informations about the variable which is linked at the ""dynamic y position"" property. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVarY.SymVarName"") 'Return the name of the ""y position dynamic"" variable zElement.DynProperties (""DynEleVarY.SymVarTagNr"") 'Return the identification of the ""y position dynamic"" variable"
DynEleVarYZoom | Node | DynEleVarYZoom | "With this property you have the opportunity to get informations about the variable which is linked at the ""change height"" property. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVarYZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""DynEleVarYZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
IsXActive | Bool | Change X direction active | Active: Horizontal movement of the linked element is available. Inactive: Horizontal movement is not available. .
IsXZoomActive | Bool | Change width active | Active: Zooming of the width of the linked element is available. Inactive: Zooming of the width is not available. .
IsYActive | Bool | Change Y direction active | Active: Vertical movement of the linked element is available. Inactive: Vertical movement is not available. .
IsYZoomActive | Bool | Change height active | Activate zooming of the height of the element. .
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Symbol | UInt16 | Symbol | A symbol can be selected from the list of symbols present in the screen. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Move [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Move [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Multibin
ObjectModel COM [image] Element [image] DynProperties [image] Multibin
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkBackColor | UInt32 | BlinkBackColor |
BlinkVar | Node | BlinkVar | Node
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillOnly | Bool | FillOnly |
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
IsBackColor | Bool | IsBackColor |
IsText | Bool | IsText |
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LinkType | SByte | LinkType |
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
OriginalSize | Bool | OriginalSize |
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ReactionTime | UInt16 | Holding time [ms] | Only available if is active . If is active: Time (in ms) which a state is held starting from the left click on the respective element.If property is inactive: Delayed reaction to a left click. .
RegardAllVarBlinking | Bool | RegardAllVarBlinking |
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShowState | Bool | Display status of variable | Graphical display of the status of the variable. Selection from a checkbox.Active: The status of the variables is indicated by a colored square at the element. Color : Red square: No communication with the PLC. Example: INVALID, OFF, ALT_VAL, REVISION, TIMEOUT, ...Blue square(N_UPDATE) : On the network client: The client has lost its connection to the Primary Server. With a standalone integration project: The Primary Server has not yet supplied the data.Yellow square (PR_NR) : Visualizes in Runtime that the variable has not been logged during replay in the Process Recorder . No value is therefore known in the playback.Position: The position of the square at the element depends on the element form:Angular and all other elements: Top right cornerRound element: Top, in the middle Rounded element : Top right corner, slightly offset to the left Inactive: The status is not shown. Also deactivates the display of additional variable information with a right click.Default: activated .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
States | Node | States | With this property you have the opportunity to get/set some properties of the different statis. The settings can be handled via some subitems.
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
Status | UInt32 | Configuration | Opens the dialog to define the states. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
SwitchFunction | UInt16 | SwitchFunction | "With this property you get/set the different switch modes when a bool variable is linked at the element. zElement.DynProperties(""SwitchFunction"") = 0 'Set to ""Read only"" zElement.DynProperties(""SwitchFunction"") = 1 'Set to ""TOOGLE"" zElement.DynProperties(""SwitchFunction"") = 2 'Set to ""Momentary switch On"" zElement.DynProperties(""SwitchFunction"") = 3 'Set to ""Momentary switch Off"""
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Multibin [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CDynEleVarMulti
ObjectModel COM [image] Element [image] DynProperties [image] Multibin [image] CDynEleVarMulti
Overview
External Name | Type | Display Name | Description
BitmapHigh | String | BitmapHigh | "With this item you have the opportunity to get/set the picture for the ""high"" state of a multibin element via a string."
BitmapLow | String | BitmapLow | "With this item you have the opportunity to get/set the picture for the ""low"" state of a multibin element via a string."
Bits | String | Bits |
BkColorHigh | UInt32 | BkColorHigh |
BkColorLow | UInt32 | BkColorLow |
ColorHigh | UInt32 | ColorHigh |
ColorLow | UInt32 | ColorLow |
KeyFlags1 | UInt32 | KeyFlags1 | "A long value which sets the keys for the ""key combination"" property of the multibin element. This property is available when a bool variable is linked to the element. "
KeyFlags2 | UInt32 | KeyFlags2 | "A long value which sets the keys for the ""key combination"" property of the multibin element. This property is available when a bool variable is linked to the element. "
KeyFlags3 | Int16 | KeyFlags3 | "A long value which sets the keys for the ""key combination"" property of the multibin element. This property is available when a bool variable is linked to the element. "
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
StateTextHigh | String | StateTextHigh | With this property you have the opportunity to get/set the text for the high state of the mulibin element.
StateTextLow | String | StateTextLow | With this property you have the opportunity to get/set the text for the low state of the mulibin element.
Symbol | UInt16 | Symbol | A symbol can be selected from the list of symbols present in the screen. .
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.
Value | UInt32 | Value |


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Multibin [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Numerical value
ObjectModel COM [image] Element [image] DynProperties [image] Numerical value
Overview
External Name | Type | Display Name | Description
Absolute | Bool | Absolute amount | For element Numeric value only available if property is inactive .Active: Unsigned display of the variable value (-200 = 200).Inactive: Normal display of the value.Default: Inactive Note: In this case, the set value is entered in percent. .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
DynEleVar | Node | DynEleVar | "With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillStyle | Guid | Fill style |
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
Frame | UInt16 | Element border | Drop-down list for the selection of the frame type. The following are available:For the button element Thin border 3D Default: Thin border For other dynamic elements Edge heightened Edge deepened No border Classical heightened Classical deepened Margin heightened Margin deepened Default: No border .
FrameStyle | Guid | Element border line style | Display and selection of the element style that is assigned to the element. .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalAlign | Int16 | Alignment horizontal | Horizontal orientation of the value for the display. Selection from a drop-down list:Left Right Centered Default: Centered. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
HWDirect | Bool | without dialog | Active: The value is sent to the hardware without a possibility to be changed in the Runtime. Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware. .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
IsSetValue | Bool | Write set value | Active: Setting of set values for this dynamic element is allowed.Inactive: The element is ReadOnly.Not available for the dynamic text element if it has been set to read only in the screen. .
KbdName | String | Screen Keyboard | Only available if property is active.Name of the linked keyboard screen. If no keyboard screen is entered, the respective corresponding keyboard is called up in Runtime:String variable: SETSTRINGKBD Numeric variable: SETVALUEKBD Binary variable: SETBOOLKBD Note: For the input field input option, no keyboard is called up if the option is activated. A keyboard screen must be linked. .
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LimitColor | Bool | Use limit value color | Defines whether the limit value color for the variable linked to the element is displayed in Runtime. The color has an effect on the text displayed, or in the indicator of a universal slider .Active : The defined limit value color is displayed in the Runtime.Default: active .
LimitFromVar | Bool | Take set value limits from variable | Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly. Inactive: The range can be limited directly in the "Minimum" and "Maximum". .
LineColorVariable | CDynEleVar | Text color | Name of the variable whose limit value color is to influence the text color of the element. Click on the ... button to open the dialog for selecting a variable..
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
Max | double | Maximum | Upper limit of the permitted range for the set value. Only available if "Take set value limits from variable" is not active. Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum. .
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
Min | double | Minimum | Bottom limit of the permitted range for the set value. Only available if Take set value limits from variable is not active: Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
Percentage | Bool | Show value in percent | Active: The value of the variable is displayed as 0 - 100% .Inactive: The value is displayed as usual.Range of values:Minimum measurement range: 0% Maximum measurement range 100% The conversion is linear. Setpoint inputs are also entered in percent. Default: Inactive .
Preset | Bool | propose current value | Active: The current value of the variable is proposed as set value. In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value). Inactive: The value defined in "Set value / amend" is proposed. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetProgram | String | External program | Only available if an external program was selected for Write set value : The set value is written by an external program that must be selected in the dialog box that appears here. This program is then started and gets the following parameters: 1) Name of the linked variable 2) Proposed value, as defined in the corresponding properties 3) Left coordinate of the element in pixels 4) Upper coordinate of the element in pixels 5) Right coordinate of the element in pixels 6) Lower coordinate of the element in pixels 7) Permitted minimum for the set value, as defined in the corresponding properties 8) Permitted maximum for the set value, as defined in the corresponding properties .
SetValue | double | Set value/change by | Value that should be sent as the set value or as a default. If "Propose current value" is active: : Value that is added to the current value. In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
SetValueWith | SByte | Write set value via | Configuration of how the target value is set. Select from drop-down list:Command Processing: The new value is set using command processing . For input, the screen that is defined in the command group of the linked variable is opened.Standard dialog box : The new value is entered using the standard dialog box. If a screen of type "Keyboard " with name "SETVALUEKBD " (for numeric values) or "SETSTRINGKBD " (for string variables) exists, it is used instead of the standard dialog box. Note: If the element is linked to a function that allows inputs, is automated automatically. If a screen is linked in the property, this is used. Otherwise a SETSTRINGKBD keyboard is used.Element : The new value is directly entered in the element (only for the elements Numeric value and Text ).Program : The new value is entered in an external program. .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShowLeadingZeros | Bool | Show leading zeros | Only available if, for the property, either binary , decimal , hexadecimal or octal has been selected.Defines whether leading zeros are also to be displayed when displaying the numeric values.Inactive: Leading zeros are suppressed. Active : The numeric values are displayed with a different number of digits in accordance with their base. The digits which are not used by the numeric value are filled up with leading zeros. Default: Inactive The following parameters are available for the different bases:Binary: 32 digitsDecimal: 10 digitsHexadecimal: 8 digitsOctal: 11 digits .
ShowState | Bool | Display status of variable | Graphical display of the status of the variable. Selection from a checkbox.Active: The status of the variables is indicated by a colored square at the element. Color : Red square: No communication with the PLC. Example: INVALID, OFF, ALT_VAL, REVISION, TIMEOUT, ...Blue square(N_UPDATE) : On the network client: The client has lost its connection to the Primary Server. With a standalone integration project: The Primary Server has not yet supplied the data.Yellow square (PR_NR) : Visualizes in Runtime that the variable has not been logged during replay in the Process Recorder . No value is therefore known in the playback.Position: The position of the square at the element depends on the element form:Angular and all other elements: Top right cornerRound element: Top, in the middle Rounded element : Top right corner, slightly offset to the left Inactive: The status is not shown. Also deactivates the display of additional variable information with a right click.Default: activated .
ShowUnit | Bool | Show measuring unit | Only available: General: If property has been activated. For the Clock element: if Time difference was selected in the property . For the pointer instrument : if property was activated.Active: The unit of the linked variable is displayed to the right of the value. If the value is displayed in percent, the percent character % is displayed instaed of the unit of the linked variable. Inactive: The technical unit is not displayed. Default: active . Note: .
ShowValueBasis | Bool | Show base | Only available if either binary , hexadecimal or octal has been selected for the property.Active : A short identification for the numbering basis is shown behind the value.The following short identifications are used for:Binary: b Decimal: (no short identification)Exponential: (no short identification)Hexadecimal: h Octal: o Default: active .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Text color | Text color of the element. .
TextStyle | Guid | Text style |
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
Transparent | Bool | Transparent | Settings for transparency.Active : Displays the element transparently.Default: Inactive The effect of this option on a button is an Invisible button . It can be positioned above other elements as an invisible button. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
UnitPos | UInt16 | Unit position [%] | Only available if property is active. Positions the display of the unit and makes it possible to adjust units with different widths to values which are listed one under the other. For positioning enter a percentage between 0 and 100 . The unit is always displayed to the right of the defined position. The corresponding value to the left depends on the set alignment. Default: 0 - means no percentage alignment. Value and unit are always displayed together. .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
ValueBase | UInt16 | Base for display | Selection of the numbering system for the display of the values. The following numbering systems are available:Binary : Binary display.Decimal : Decimal display.Exponential: Decimal display in exponential notation. Example: 1E+03 equals 1000 in decimal notation.Hexadecimal : Hexadecimal display.Octal : Octal display.Default: Decimal l .
ValueStyle | Guid | Value display style | Display and selection of the value display style that is assigned to the element. .
Variable | CDynEleVar | Variable | Name of the linked variable. Click on button ... in order to open the dialog for selecting variables. The value of this variable is displayed in this element and can also be set here.Note: Only available for buttons if they are used as a switch .Hint: If the variable value is to be toggled, we recommend activating the property. Only SICAM 230 and Screen Alarm element: The description above only applies to the elements Text Button, Bitmap Button and Invisible Button . Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).Lower bit: Alarm active/inactive Higher bit: Alarm acknowledged/not acknowledged .
VerticalAlign | Int16 | Alignment vertical | Vertical orientation of the value for the display. Selection from a drop-down list:Top Bottom Centered Default: Centered. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Numerical value [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Numerical value [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Picture alarm
ObjectModel COM [image] Element [image] DynProperties [image] Picture alarm
Overview
External Name | Type | Display Name | Description
AbbModus | Bool | Display of the selected alarm/event classes | Defines how the class states will be written to the image variable.Active: The states of the selected alarm/event classes will be written to the image variable without gaps. e.g. selected classes 1,3 -> class 1: bits 0,1; class 3: bits 2,3Inactive: The states of the selected alarm/event classes will be written to the image variable with fixed position. e.g. selected classes 1,3 -> class 1: bits 0,1;0 (class 2: bits 2.3); class 3: bits 4,5
AlphaBackColor | SByte | Transparency of the fill color [%] | .
AlphaBackColor2 | SByte | Transparency gradient color [%] | Only available if Linear was selected in the property. .
AlphaBorderColor | SByte | Transparency border color [%] | The property must be activated.Defines the transparency of the color using a value between 0 and 100 .0 : opaque100 : completely transparentAll values between this appear transparent according to how they are set.Default: 0 .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
Animate | Bool | GIF animation always | Active: The animation always runs. Inactive: Then the animation is not executed. You can switch the animation on and off with an optional link to . .
AnimateVar | CDynEleVar | Variable | Bit variable that switches the animation on and off. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColor2 | UInt32 | Gradient color | Color gradient must be selected for the property.Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of . .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVariable2 | CDynEleVar | Gradient color | Name of the variable whose limit value color should influence the gradient color of the element. Click on the input filed in order to open the dialog for selecting a variable. .
BackColorVariable2Preview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BAGlobal | Bool | Global | Alarms will be considered system-wide. Main use: Sum alarm of the global alarm list. Active: Alarms will be considered independently of the linked screen. The linked function will only be used for screen switching.Inactive: Only alarms of the linked screen will be considered.
BAKlassen | String | Alarm/event classes | Selection of alarm/event groups which should be displayed.Opens the class selection catalog.
BAPriorit�t | Bool | Priority | Prioritization of the alarm/event classes. Active: Even if more than one alarm/event classes were selected, only one of them will be displayed. Priority rules: The lower the class number, the higher the priority.Not acknowledged has a higher priority than acknowledged.Inactive: all selected classes will be displayed (side by side).
BAProjekt | UInt16 | Project | Selection of a single project or of all projects.Only available if Global is active. Used for multi-hierarchic projects.
BAUnsichtbar | Bool | Invisible | The element will not be displayed during RuntimeActive: The element will not be hidden during Runtime Will be applied if the element only actuates an image variable but is not supposed to be displayed itself. Inactive: The element will be displayed as a button.
BkCl2Variable | Node | BkCl2Variable | Node
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
BorderColor | UInt32 | Border color | Define the frame color of the element. At selecting Automatical the color value changes depending on the value of ..
BtnStyleBorder | UInt16 | Button shape | Shape of the button:Angular : The button has pointed corners. With the help of the properties of group you can change the pointed corners to rounded corners.Round : The button is displayed round.Default: Angular The settings for the depend on this setting. .
BtnStyleFill | UInt16 | Fill | Filling of the button: monochrome : No gradient linear : steady gradient radiant : From the bottom to the middle fill color 1, then gradient from the middle to the top defined point : Gradient from a defined point to the edges of the elementSelective with edges : Gradient from a defined point to the edges of the element with beams .
BtnStyleInvert | Bool | Invert color gradient | Only available if Color gradient was selected as . Active: The brightness gradient is inverted. Inactive: The brightness gradient is not inverted. Default: Inactive .
ChangeText | Bool | Change text depending on control keys | Only available if you have activated in the properties of the screen.active : Use to for labelling the button. Inputs at and is no longer necessary.Default: Inactive .
ColorGradientAngle | Int16 | Angle [°] | Defines the direction of the color gradient starting in the center of the element.Values: 0° to 360° . Default: 0° .
ColorGradientOffset | Int16 | Offset [%] | Only available if, for a vector element or a dynamic button element, the property has been set. Linear or Selective or Selective with edges .Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.Values: 0 equals the center of the element. 100 the edge. Note: The value can also be outside of the element and is therefore not limited to 100 . .
CornerAll_X | Int32 | All x [%] | Only available if property is inactive.Defines the value of the rounding of the X-axis in percent for all corners. This value is used for all corners whose values equals -1. Individual corners can therefore be defined independently.If the value of the rounding is changed, all corners are automatically set to the value -1. With this all corners are set back to the pre-defined value.Value range: 0 % to 100 %. Default button: 20 Default rectangle: 0 .
CornerAll_Y | Int32 | All y [%] | Only available if the property is active and the property is inactive.Defines the value of the rounding of the Y-axis in percent for all corners. This value is used for all corners whose values equals -1. Individual corners can therefore be defined independently.If the value of the rounding is changed, all corners are automatically set to the value -1. With this all corners are set back to the pre-defined value.Value range: 0 % to 100 % Default button: 20 Default rectangle: 0 .
CornerLeftBottom_X | Int32 | Left/bottom x [%] | The property must be activated.Defines the radius value of the X-axis for the bottom left corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerLeftBottom_Y | Int32 | Left/bottom y [%] | In addition, the property must be activated and the property must be deactivated.Defines the radius value of the Y-axis for the bottom left corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerLeftTop_X | Int32 | Left/top x [%] | The property must be activated.Defines the radius value of the X-axis for the top left corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerLeftTop_Y | Int32 | Left/top y [%] | In addition, the property must be activated and the property must be deactivated.Defines the radius value of the Y-axis for the top left corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerProportional | Bool | Proportional | Only available if property is inactive.Active: For creating a radiused corner only the x value can be entered. The y value is always the same.The percentage entered at property refers to the shorter side (width or height) of the element.Inactive: The x and y values can be entered freely. The x value refers to the width of the element. The y value refers to the height of the element.Default: active .
CornerRightBottom_X | Int32 | Right/bottom x [%] | Only available if property is inactive.Defines the value of the rounding of the X-axis for the bottom right corner. Click on button ... opens a slider with which you can set the radius.Possible values:-1: The setting from is used.0 to 100: Rounding in percent.Default: -1 .
CornerRightBottom_Y | Int32 | Right/bottom y [%] | In addition, the property must be activated and the property must be deactivated.Defines the radius value of the Y-axis for the bottom right corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerRightTop_X | Int32 | Right/top x [%] | The property must be activated.Defines the radius value of the X-axis for the top right corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerRightTop_Y | Int32 | Right/top y [%] | In addition, the property must be activated and the property must be deactivated.Defines the radius value of the Y-axis for the top right corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
DownText | String | Text when pressed | Button text in Runtime when pressed. The character sequence \n causes a new line in the text.Attention: If this property is configured, the property is deactivated and cannot be used in Runtime. Content that has already been configured is grayed out and deactivated. This is also applicable if the property is subsequently filled with content. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
DynEleFkt | Node | Node | Node
DynEleFkt | Node | Node | Node
DynEleVar | Node | DynEleVar | "With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"
DynEleVar | Node | DynEleVar | "With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FileName | String | Graphics File | Graphics that are to be displayed on the button when the button is not pressed (*.bmp, *.wmf, *.jpg, *.gif, *.png, *.tif). Click on button ... Opens the file selection dialog. .
FileNameDown | String | Graphics file for pressed | Graphics file that is to be displayed on the button when the button is pressed (*.bmp, *.wmf, *.jpg, *.gif, *.png, *.tif). Click on button ... Opens the file selection dialog. .
FillPattern | UInt32 | Fill pattern | Selection of the filling pattern for the element from the list.This property is only available if property is inactive. .
FillStyle | Guid | Fill style |
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
Frame | UInt16 | Element border | Drop-down list for the selection of the frame type. The following are available:For the button element Thin border 3D Default: Thin border For other dynamic elements Edge heightened Edge deepened No border Classical heightened Classical deepened Margin heightened Margin deepened Default: No border .
FrameStyle | Guid | Element border line style | Display and selection of the element style that is assigned to the element. .
Function | CDynEleFkt | Function | Name of the linked function. Opens the function selection dialog. This function will be executed when the button is clicked in the Runtime or when the assigned key shortcut is pressed. If you wish to execute more than one function, you need to create a script with the required functions and specify the function for executing that script here.SICAM 230 and screen alarming element only: In addition to the standard screen switch property, the screen whose alarm states are supposed to be displayed will be determined by the linked function. Obligatory (unless the Global setting is active )! .
Function | CDynEleFkt | Function | Name of the linked function. Opens the function selection dialog. This function will be executed when the button is clicked in the Runtime or when the assigned key shortcut is pressed. If you wish to execute more than one function, you need to create a script with the required functions and specify the function for executing that script here.SICAM 230 and screen alarming element only: In addition to the standard screen switch property, the screen whose alarm states are supposed to be displayed will be determined by the linked function. Obligatory (unless the Global setting is active )! .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
GraphicsFillStyle | Guid | Fill style for graphic if pressed/on | Description as text.
GraphicSize | UInt16 | Graphic size | Definition of the graphics size.Adjusted : The size of the graphics is adjusted to the size of the element.Original size : The linked graphics are displayed in their original size. When selecting this option, the and properties can no longer be configured individually for the multibin, combi-element, button and switch elements. All graphics files should be the same size.Default: adjust .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalAlign | Int16 | Alignment horizontal | Horizontal orientation of the value for the display. Selection from a drop-down list:Left Right Centered Default: Centered. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
InterlockingName | String | InterlockingName | Description
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
Lightning | Int16 | Color gradient | Only available if was set to Color gradient . Defines the color gradient for elements. Linear : steady gradientDefined point : Gradient from a defined point to the edges of the element Selective with edges : Gradient from a defined point to the edges of the element with beamsRadiant : From the bottom to the middle, then gradient from the middle to the top (with rectangular form only).
LineColorVariable | CDynEleVar | Text color | Name of the variable whose limit value color is to influence the text color of the element. Click on the ... button to open the dialog for selecting a variable..
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
Offset | UInt16 | First alarm/event class to be displayed | Starting with this class, the class states will be written to the image variable.
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
PredefinedBitmaps | UInt32 | Predefined graphics | Pre-defined bitmaps for the LOW/HIGH state can be selected from the list. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
RoundingStyle | Guid | Rounding style | Display and selection of the style for rounding that is assigned to the element. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
ShowState | Bool | Display status of variable | Graphical display of the status of the variable. Selection from a checkbox.Active: The status of the variables is indicated by a colored square at the element. Color : Red square: No communication with the PLC. Example: INVALID, OFF, ALT_VAL, REVISION, TIMEOUT, ...Blue square(N_UPDATE) : On the network client: The client has lost its connection to the Primary Server. With a standalone integration project: The Primary Server has not yet supplied the data.Yellow square (PR_NR) : Visualizes in Runtime that the variable has not been logged during replay in the Process Recorder . No value is therefore known in the playback.Position: The position of the square at the element depends on the element form:Angular and all other elements: Top right cornerRound element: Top, in the middle Rounded element : Top right corner, slightly offset to the left Inactive: The status is not shown. Also deactivates the display of additional variable information with a right click.Default: activated .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
Spot | Bool | Spot | Display of the spot:Active : The button is displayed with a glare effect.Inactive : No glare effect is displayed; the setting from is used.Only active if the property is round .Default: Inactive .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
Text1 | String | Text line 1 | First text line in button. By using the & character, you can underline the following character in the Runtime. To display the character & itself, enter &&.With character string \n a line break can be forced.Attention: To use \n , property must be empty. .
Text1Ctrl | String | Text line 1 with Ctrl | Only available if property is active. Labeling of the first text line in the button if the Control key is pressed. Note : By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
Text1CtrlAlt | String | Text line 1 with Ctrl+Alt (Alt Gr) | Only available if property is active. Labels the first text line in the button when the CTRL key and the ALT GR key are pressed. Note: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
Text1Normal | String | Text line 1 normal | Only available if property is active. Labels the first text line in the button without pressing a control key. Notice: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
Text1Shift | String | Text line 1 with Shift | Only available if property is active. Labels the first text line in the button if the Shift key is pressed. Note: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
Text2 | String | Text line 2 | Second text line in button. By using the & character, you can underline the following character in the Runtime. To display the character & itself, enter &&.Note: This property serves the compatibility with older version. In current versions: Use property and start new lines with \n .Attention: This line must remain empty if the automatic line break should be used.If this property is configured, the property is deactivated and cannot be used in Runtime. Content of the property that has already been configured is grayed out and deactivated. Even a space is considered a valid project configuration and blocks the text display if the button is held down! Subsequent configuration of the property also deactivates the existing project configuration in the property. .
Text2Ctrl | String | Text line 2 with Ctrl | Only available if property is active. Labels the second text line in the button if the CTRL key is pressed. Note: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
Text2CtrlAlt | String | Text line 2 with Ctrl+Alt (Alt Gr) | Only available if property is active. Labels the second text line in the button when the CTRL key and the ALT GR key are pressed. Note : By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
Text2Normal | String | Text line 2 normal | Only available if property is active. Labels the second text line in the button without pressing a control key. Note : By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
Text2Shift | String | Text line 2 with Shift | Only available if property is active. Labels the second text line in the button if the Shift key is pressed. Note: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
TextColor | UInt32 | Text color | Text color of the element. .
TextStyle | Guid | Text style |
ThreeDimensional | Bool | 3D | Active: The element is displayed in 3D. Inactive: The element is displayed flat. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
Transparent | Bool | Transparent | Settings for transparency.Active : Displays the element transparently.Default: Inactive The effect of this option on a button is an Invisible button . It can be positioned above other elements as an invisible button. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
Variable | CDynEleVar | Variable | Name of the linked variable. Click on button ... in order to open the dialog for selecting variables. The value of this variable is displayed in this element and can also be set here.Note: Only available for buttons if they are used as a switch .Hint: If the variable value is to be toggled, we recommend activating the property. Only SICAM 230 and Screen Alarm element: The description above only applies to the elements Text Button, Bitmap Button and Invisible Button . Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).Lower bit: Alarm active/inactive Higher bit: Alarm acknowledged/not acknowledged .
VerticalAlign | Int16 | Alignment vertical | Vertical orientation of the value for the display. Selection from a drop-down list:Top Bottom Centered Default: Centered. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
Wordbreak | Bool | Automatic word wrap | Active: Automatic word wrap is used for the text in the element. The length of the lines depends on the width of the element.Inactive: The text is displayed in one line.Default: Inactive .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleFkt
ObjectModel COM [image] Element [image] DynProperties [image] Picture alarm [image] CDynEleFkt
Overview
External Name | Type | Display Name | Description
Name | String | Name |
ProjectFunction | CProjektFunktion | ProjectFunction |


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Picture alarm [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Picture alarm [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Picture elements
ObjectModel COM [image] Element [image] DynProperties [image] Picture elements
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Picture elements [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Polygon
ObjectModel COM [image] Element [image] DynProperties [image] Polygon
Overview
External Name | Type | Display Name | Description
ALCAlias | Bool | Use alias | Only available if is active.Active : Alias is used. In the Runtime the element receives its ALC colors from another ALC element of the topological model without being part of the model itself. The displayed ALC color of the element is thus not determined by the linked lines. The ALC color is identical to the color of the ALC element, the name of which is linked in the .Inactive : Element is an ALC element according to the configured ALC . The ALC display color is determined by the linked lines.Default: Inactive .
ALCAliasName | String | Alias | Only available if is active.Defined source element for property . Clicking on the ... button opens the dialog to select a pre-configured ALC element in a pre-configured zenon screen. Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project. .
ALCAlternativeColor | UInt32 | Alternative color | Only available if property has value alternative color .Alternative color for the ALC coloring at multiple supply. .
ALCDashLen | Int16 | Dashing length supplied multiple times | Only available if property has value two highest prior sources .Defines the dash length in pixel for the dashed ALC coloring at multiply supply.Minimal: 0 (automatic dash length)Maximum: 32767 Default: 0 .
ALCEnclosementSize | SByte | Curb width [px] | Width of the curb in pixels.Default: 1 pixel Input range: 1 to 20 pixels.Note: Only available if property is active. .
ALCLength | double | Length of the line [km] | ALC line: Length of the line. .
ALCLineName | String | Line name | Unique name of the line. Is used for the identification of the line in the load distribution calculation. In addition, this name is used as interlocking text for the "Overload of a line " topological interlocking.Note : Only available for the Line or Pipe screen element. .
ALCMaxIType | Int16 | Limit value current carrying capacity | Origin of data on the limit value of the current carrying capacity for the calculation of load distribution . The current carrying capacity of the weakest link (cable) in a line. Selection of the type from the drop-down list: Default: Static limit value current carrying capacity Note: The entries in the drop-down list correspond to the properties that follow the Editor directly. .
ALCMaxIVal | double | Static limit value current carrying capacity [A] | Entry of the maximum current-carrying capacity of the weakest link (cable) in the line. Entry in amperes.Default: 20 Not available if the property is configured with limit value of current-carrying capacity dynamic . .
ALCMSecuredSupply | Int16 | display secured supply | Only available if was activated.Definition of the display of the secured supply:double widthdouble brightnessnormalDefault: normal .
ALCMultiSource | Int16 | display multiple supplies | Only available if the property is active. Defines the display type if the element is connected to several sources: most prior source: Only the color of the source with the highest priority is used. two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line. alternative color : Alternative color for the coloring at multiple supply.Default: highest priority source .
ALCPrecedence | Int16 | Priority for display | Only available if the property is active.Defines the priority of the display when the element is connected to several active sources. Multiple supply : The element is displayed according to the rules of the multiple supply. secured supply : The element is displayed according to the rules of the secured supply. No priority : The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.Default: Multiple supply .
ALCReact | double | Reactance value of the cable [Ohm] | Maximum permitted value of the reactance (reactance X) of the line in Ohms. Is used for the detection of the fault locating of protection . .
ALCResist | double | Resistance value of the electric line [Ohm] | Maximum permitted value of the resistance (effective resistance R) of the line in Ohms. Is used for the calculation of load distribution. .
ALCUseColor | Bool | Color from ALC | Only available if you have licensed Automatic Line Coloring (ALC) : Active: The automatic color of the linked source(s) is used. Inactive: The standard color is used. Default: inactive. .
ALCUseEnclosement | Bool | Use curb | Checkbox for the activation of the curb of lines, polylines and pipelines.active: ALC line elements are visualized in Runtime for a ground fault or short circuit with an additional border in the corresponding color. The colors are defined in the ALC project settings.Inactive: No display of curbing in Runtime.Default: Inactive Note: only active if is activated. .
ALCVarCalcI | CDynEleVar | Measuring value of the calculated current flow | Linked variable with the measured value of the calculated current flow of the branch. Calculation result in amperes [A]. .
ALCVarCalcIEx | Node | ALCVarCalcIEx | ALC Leitung: Messwert des berechneten Stromflusses für Export.Mehr in der Online-Hilfe .
ALCVarMaxI | CDynEleVar | Dynamic limit value current carrying capacity | Linked variable for the maximum current-carrying capacity of the weakest link (cable) in the line. Only available if the limit value of current-carrying capacity property is configured with limit value of current-carrying capacity dynamic . .
ALCVarMaxIEx | Node | ALCVarMaxIEx | Node
Align | Int16 | Alignment | Direction of color shift. horizontal vertical
AlphaBackColor | SByte | Transparency of the fill color [%] | .
AlphaBackColor2 | SByte | Transparency gradient color [%] | Only available if Linear was selected in the property. .
AlphaLineColor | SByte | Transparency line color [%] | .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColor2 | UInt32 | Gradient color | Color gradient must be selected for the property.Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of . .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVariable2 | CDynEleVar | Gradient color | Name of the variable whose limit value color should influence the gradient color of the element. Click on the input filed in order to open the dialog for selecting a variable. .
BackColorVariable2Preview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
ColorGradientAngle | Int16 | Angle [°] | Defines the direction of the color gradient starting in the center of the element.Values: 0° to 360° . Default: 0° .
ColorGradientOffset | Int16 | Offset [%] | Only available if, for a vector element or a dynamic button element, the property has been set. Linear or Selective or Selective with edges .Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.Values: 0 equals the center of the element. 100 the edge. Note: The value can also be outside of the element and is therefore not limited to 100 . .
Coordinates | String |  | "With this property you can get/set the coordinates of the element via a string. zElement.DynProperties(""Coordinates"") = ""197/118;260/200"""
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillColorInvert | Bool | Invert color gradient | Only available if Color gradient was selected as . Active: The brightness gradient is inverted. Inactive: The brightness gradient is not inverted. Default: Inactive .
FillPattern | UInt32 | Fill pattern | Selection of the filling pattern for the element from the list.This property is only available if property is inactive. .
FillStyle | Guid | Fill style |
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Lightning | Int16 | Color gradient | Only available if was set to Color gradient . Defines the color gradient for elements. Linear : steady gradientDefined point : Gradient from a defined point to the edges of the element Selective with edges : Gradient from a defined point to the edges of the element with beamsRadiant : From the bottom to the middle, then gradient from the middle to the top (with rectangular form only).
LineColor | UInt32 | Line color | Line color of the element.
LineColorEx | UInt32 | Line color | Defines the line color of the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LineStyle | Guid | Line style | Display and selection of the line style that is assigned to the element. .
LineType | UInt32 | Line type | Selection of the line type for the element from the list. Attention: If the node in in the project properties, the property has been set to Windows basic , you can only use line width >1 with a "continuous line" type line. .
LineWidth | UInt16 | Line width [Pixel] | Width of the line (in pixels).Minimum: 0 In this case the width of the line is 1 pixel.Maximum: 40 Default: 1 Attention: If in the project settings in node you set property to Windows basis , you can use line width >1 only with a line of type "continuous line". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
MeasuredInputActivePower | Node | Active power input [MW] | Linked variable with the measured value of the active power at the line input. .
MeasuredInputActivePowerImEx | Node | MeasuredInputActivePowerImEx | Description
MeasuredInputCosPhi | Node | cos Phi input | Linked variable with the measured value of the cos phi power factor at the line input. .
MeasuredInputCosPhiImEx | Node | MeasuredInputCosPhiImEx | Description
MeasuredInputCurrent | Node | Power Input [A] | Linked variable with the measured value of the amperage at the line input. .
MeasuredInputCurrentImEx | Node | MeasuredInputCurrentImEx | Description
MeasuredInputReactivePower | Node | Reactive power input [MVar] | Linked variable with the measured value of the reactive power at the line input. .
MeasuredInputReactivePowerImEx | Node | MeasuredInputReactivePowerImEx | Description
MeasuredInputVoltage | Node | Voltage input [kV] | Linked variable with the measured value of the voltage at the line input. .
MeasuredInputVoltageImEx | Node | MeasuredInputVoltageImEx | Description
MeasuredOutputActivePower | Node | Active power output [MW] | Linked variable with the measured value of the active power at the line output. .
MeasuredOutputActivePowerImEx | Node | MeasuredOutputActivePowerImEx | Description
MeasuredOutputCosPhi | Node | cos Phi output | Linked variable with the measured value of the cos phi power factor at the line output. .
MeasuredOutputCosPhiImEx | Node | MeasuredOutputCosPhiImEx | Description
MeasuredOutputCurrent | Node | Power Output [A] | Linked variable with the measured value of the amperage at the line output. .
MeasuredOutputCurrentImEx | Node | MeasuredOutputCurrentImEx | Description
MeasuredOutputReactivePower | Node | Reactive power output [MVar] | Linked variable with the measured value of the reactive power at the line output. .
MeasuredOutputReactivePowerImEx | Node | MeasuredOutputReactivePowerImEx | Description
MeasuredOutputVoltage | Node | Voltage output [kV] | Linked variable with the measured value of the voltage at the line output. .
MeasuredOutputVoltageImEx | Node | MeasuredOutputVoltageImEx | Description
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
Shifted | Int16 | Shifted color gradient | Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein. Mehr im Online-Handbuch
SplineTension | float | Rounding | Defines the rounding for the polylines, polygons and the pipes.Values: 0,0 (no rounding) to 1,0 . (maximum rounding)Default: 0 .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VarLineCurrent | Node | Current [A] | Linked variable with the result of the load flow calculation for the calculated amperage at the line input. .
VarLineCurrentImEx | Node | VarLineCurrentImEx | Description
VarLinePowerFactorVar | Node | cos Phi output | Linked variable with the result of the load flow calculation for the calculated power factor (cos phi). This corresponds to the average value of the calculated cos phi at the output. .
VarLinePowerFactorVarImEx | Node | VarLinePowerFactorVarImEx | Description
VarLinePowerInVar | Node | Active power input [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line input. .
VarLinePowerInVarImEx | Node | VarLinePowerInVarImEx | Description
VarLinePowerOutVar | Node | Active power output [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line output. .
VarLinePowerOutVarImEx | Node | VarLinePowerOutVarImEx | Description
VarLineReactivePowerInVar | Node | Reactive power input [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line input. .
VarLineReactivePowerInVarImEx | Node | VarLineReactivePowerInVarImEx | Description
VarLineReactivePowerOutVar | Node | Reactive power output [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line output. .
VarLineReactivePowerOutVarImEx | Node | VarLineReactivePowerOutVarImEx | Description
VarLineVoltageInVar | Node | Voltage input [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line input. .
VarLineVoltageInVarImEx | Node | VarLineVoltageInVarImEx | Description
VarLineVoltageOutVar | Node | Voltage output [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line output. .
VarLineVoltageOutVarImEx | Node | VarLineVoltageOutVarImEx | Description
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Polygon [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Polyline
ObjectModel COM [image] Element [image] DynProperties [image] Polyline
Overview
External Name | Type | Display Name | Description
ALCAlias | Bool | Use alias | Only available if is active.Active : Alias is used. In the Runtime the element receives its ALC colors from another ALC element of the topological model without being part of the model itself. The displayed ALC color of the element is thus not determined by the linked lines. The ALC color is identical to the color of the ALC element, the name of which is linked in the .Inactive : Element is an ALC element according to the configured ALC . The ALC display color is determined by the linked lines.Default: Inactive .
ALCAliasName | String | Alias | Only available if is active.Defined source element for property . Clicking on the ... button opens the dialog to select a pre-configured ALC element in a pre-configured zenon screen. Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project. .
ALCAlternativeColor | UInt32 | Alternative color | Only available if property has value alternative color .Alternative color for the ALC coloring at multiple supply. .
ALCDashLen | Int16 | Dashing length supplied multiple times | Only available if property has value two highest prior sources .Defines the dash length in pixel for the dashed ALC coloring at multiply supply.Minimal: 0 (automatic dash length)Maximum: 32767 Default: 0 .
ALCEnclosementSize | SByte | Curb width [px] | Width of the curb in pixels.Default: 1 pixel Input range: 1 to 20 pixels.Note: Only available if property is active. .
ALCLength | double | Length of the line [km] | ALC line: Length of the line. .
ALCLineName | String | Line name | Unique name of the line. Is used for the identification of the line in the load distribution calculation. In addition, this name is used as interlocking text for the "Overload of a line " topological interlocking.Note : Only available for the Line or Pipe screen element. .
ALCMaxIType | Int16 | Limit value current carrying capacity | Origin of data on the limit value of the current carrying capacity for the calculation of load distribution . The current carrying capacity of the weakest link (cable) in a line. Selection of the type from the drop-down list: Default: Static limit value current carrying capacity Note: The entries in the drop-down list correspond to the properties that follow the Editor directly. .
ALCMaxIVal | double | Static limit value current carrying capacity [A] | Entry of the maximum current-carrying capacity of the weakest link (cable) in the line. Entry in amperes.Default: 20 Not available if the property is configured with limit value of current-carrying capacity dynamic . .
ALCMSecuredSupply | Int16 | display secured supply | Only available if was activated.Definition of the display of the secured supply:double widthdouble brightnessnormalDefault: normal .
ALCMultiSource | Int16 | display multiple supplies | Only available if the property is active. Defines the display type if the element is connected to several sources: most prior source: Only the color of the source with the highest priority is used. two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line. alternative color : Alternative color for the coloring at multiple supply.Default: highest priority source .
ALCPrecedence | Int16 | Priority for display | Only available if the property is active.Defines the priority of the display when the element is connected to several active sources. Multiple supply : The element is displayed according to the rules of the multiple supply. secured supply : The element is displayed according to the rules of the secured supply. No priority : The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.Default: Multiple supply .
ALCReact | double | Reactance value of the cable [Ohm] | Maximum permitted value of the reactance (reactance X) of the line in Ohms. Is used for the detection of the fault locating of protection . .
ALCResist | double | Resistance value of the electric line [Ohm] | Maximum permitted value of the resistance (effective resistance R) of the line in Ohms. Is used for the calculation of load distribution. .
ALCUseColor | Bool | Color from ALC | Only available if you have licensed Automatic Line Coloring (ALC) : Active: The automatic color of the linked source(s) is used. Inactive: The standard color is used. Default: inactive. .
ALCUseEnclosement | Bool | Use curb | Checkbox for the activation of the curb of lines, polylines and pipelines.active: ALC line elements are visualized in Runtime for a ground fault or short circuit with an additional border in the corresponding color. The colors are defined in the ALC project settings.Inactive: No display of curbing in Runtime.Default: Inactive Note: only active if is activated. .
ALCVarCalcI | CDynEleVar | Measuring value of the calculated current flow | Linked variable with the measured value of the calculated current flow of the branch. Calculation result in amperes [A]. .
ALCVarCalcIEx | Node | ALCVarCalcIEx | ALC Leitung: Messwert des berechneten Stromflusses für Export.Mehr in der Online-Hilfe .
ALCVarMaxI | CDynEleVar | Dynamic limit value current carrying capacity | Linked variable for the maximum current-carrying capacity of the weakest link (cable) in the line. Only available if the limit value of current-carrying capacity property is configured with limit value of current-carrying capacity dynamic . .
ALCVarMaxIEx | Node | ALCVarMaxIEx | Node
AlphaLineColor | SByte | Transparency line color [%] | .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
Coordinates | String |  | "With this property you can get/set the coordinates of the element via a string. zElement.DynProperties(""Coordinates"") = ""197/118;260/200"""
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LineColor | UInt32 | Line color | Line color of the element.
LineColorEx | UInt32 | Line color | Defines the line color of the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LineStyle | Guid | Line style | Display and selection of the line style that is assigned to the element. .
LineType | UInt32 | Line type | Selection of the line type for the element from the list. Attention: If the node in in the project properties, the property has been set to Windows basic , you can only use line width >1 with a "continuous line" type line. .
LineWidth | UInt16 | Line width [Pixel] | Width of the line (in pixels).Minimum: 0 In this case the width of the line is 1 pixel.Maximum: 40 Default: 1 Attention: If in the project settings in node you set property to Windows basis , you can use line width >1 only with a line of type "continuous line". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
MeasuredInputActivePower | Node | Active power input [MW] | Linked variable with the measured value of the active power at the line input. .
MeasuredInputActivePowerImEx | Node | MeasuredInputActivePowerImEx | Description
MeasuredInputCosPhi | Node | cos Phi input | Linked variable with the measured value of the cos phi power factor at the line input. .
MeasuredInputCosPhiImEx | Node | MeasuredInputCosPhiImEx | Description
MeasuredInputCurrent | Node | Power Input [A] | Linked variable with the measured value of the amperage at the line input. .
MeasuredInputCurrentImEx | Node | MeasuredInputCurrentImEx | Description
MeasuredInputReactivePower | Node | Reactive power input [MVar] | Linked variable with the measured value of the reactive power at the line input. .
MeasuredInputReactivePowerImEx | Node | MeasuredInputReactivePowerImEx | Description
MeasuredInputVoltage | Node | Voltage input [kV] | Linked variable with the measured value of the voltage at the line input. .
MeasuredInputVoltageImEx | Node | MeasuredInputVoltageImEx | Description
MeasuredOutputActivePower | Node | Active power output [MW] | Linked variable with the measured value of the active power at the line output. .
MeasuredOutputActivePowerImEx | Node | MeasuredOutputActivePowerImEx | Description
MeasuredOutputCosPhi | Node | cos Phi output | Linked variable with the measured value of the cos phi power factor at the line output. .
MeasuredOutputCosPhiImEx | Node | MeasuredOutputCosPhiImEx | Description
MeasuredOutputCurrent | Node | Power Output [A] | Linked variable with the measured value of the amperage at the line output. .
MeasuredOutputCurrentImEx | Node | MeasuredOutputCurrentImEx | Description
MeasuredOutputReactivePower | Node | Reactive power output [MVar] | Linked variable with the measured value of the reactive power at the line output. .
MeasuredOutputReactivePowerImEx | Node | MeasuredOutputReactivePowerImEx | Description
MeasuredOutputVoltage | Node | Voltage output [kV] | Linked variable with the measured value of the voltage at the line output. .
MeasuredOutputVoltageImEx | Node | MeasuredOutputVoltageImEx | Description
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
SplineTension | float | Rounding | Defines the rounding for the polylines, polygons and the pipes.Values: 0,0 (no rounding) to 1,0 . (maximum rounding)Default: 0 .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
VarLineCurrent | Node | Current [A] | Linked variable with the result of the load flow calculation for the calculated amperage at the line input. .
VarLineCurrentImEx | Node | VarLineCurrentImEx | Description
VarLinePowerFactorVar | Node | cos Phi output | Linked variable with the result of the load flow calculation for the calculated power factor (cos phi). This corresponds to the average value of the calculated cos phi at the output. .
VarLinePowerFactorVarImEx | Node | VarLinePowerFactorVarImEx | Description
VarLinePowerInVar | Node | Active power input [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line input. .
VarLinePowerInVarImEx | Node | VarLinePowerInVarImEx | Description
VarLinePowerOutVar | Node | Active power output [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line output. .
VarLinePowerOutVarImEx | Node | VarLinePowerOutVarImEx | Description
VarLineReactivePowerInVar | Node | Reactive power input [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line input. .
VarLineReactivePowerInVarImEx | Node | VarLineReactivePowerInVarImEx | Description
VarLineReactivePowerOutVar | Node | Reactive power output [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line output. .
VarLineReactivePowerOutVarImEx | Node | VarLineReactivePowerOutVarImEx | Description
VarLineVoltageInVar | Node | Voltage input [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line input. .
VarLineVoltageInVarImEx | Node | VarLineVoltageInVarImEx | Description
VarLineVoltageOutVar | Node | Voltage output [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line output. .
VarLineVoltageOutVarImEx | Node | VarLineVoltageOutVarImEx | Description
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Polyline [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Rectangle
ObjectModel COM [image] Element [image] DynProperties [image] Rectangle
Overview
External Name | Type | Display Name | Description
ALCAlias | Bool | Use alias | Only available if is active.Active : Alias is used. In the Runtime the element receives its ALC colors from another ALC element of the topological model without being part of the model itself. The displayed ALC color of the element is thus not determined by the linked lines. The ALC color is identical to the color of the ALC element, the name of which is linked in the .Inactive : Element is an ALC element according to the configured ALC . The ALC display color is determined by the linked lines.Default: Inactive .
ALCAliasName | String | Alias | Only available if is active.Defined source element for property . Clicking on the ... button opens the dialog to select a pre-configured ALC element in a pre-configured zenon screen. Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project. .
ALCAlternativeColor | UInt32 | Alternative color | Only available if property has value alternative color .Alternative color for the ALC coloring at multiple supply. .
ALCDashLen | Int16 | Dashing length supplied multiple times | Only available if property has value two highest prior sources .Defines the dash length in pixel for the dashed ALC coloring at multiply supply.Minimal: 0 (automatic dash length)Maximum: 32767 Default: 0 .
ALCEnclosementSize | SByte | Curb width [px] | Width of the curb in pixels.Default: 1 pixel Input range: 1 to 20 pixels.Note: Only available if property is active. .
ALCLength | double | Length of the line [km] | ALC line: Length of the line. .
ALCLineName | String | Line name | Unique name of the line. Is used for the identification of the line in the load distribution calculation. In addition, this name is used as interlocking text for the "Overload of a line " topological interlocking.Note : Only available for the Line or Pipe screen element. .
ALCMaxIType | Int16 | Limit value current carrying capacity | Origin of data on the limit value of the current carrying capacity for the calculation of load distribution . The current carrying capacity of the weakest link (cable) in a line. Selection of the type from the drop-down list: Default: Static limit value current carrying capacity Note: The entries in the drop-down list correspond to the properties that follow the Editor directly. .
ALCMaxIVal | double | Static limit value current carrying capacity [A] | Entry of the maximum current-carrying capacity of the weakest link (cable) in the line. Entry in amperes.Default: 20 Not available if the property is configured with limit value of current-carrying capacity dynamic . .
ALCMSecuredSupply | Int16 | display secured supply | Only available if was activated.Definition of the display of the secured supply:double widthdouble brightnessnormalDefault: normal .
ALCMultiSource | Int16 | display multiple supplies | Only available if the property is active. Defines the display type if the element is connected to several sources: most prior source: Only the color of the source with the highest priority is used. two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line. alternative color : Alternative color for the coloring at multiple supply.Default: highest priority source .
ALCPrecedence | Int16 | Priority for display | Only available if the property is active.Defines the priority of the display when the element is connected to several active sources. Multiple supply : The element is displayed according to the rules of the multiple supply. secured supply : The element is displayed according to the rules of the secured supply. No priority : The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.Default: Multiple supply .
ALCReact | double | Reactance value of the cable [Ohm] | Maximum permitted value of the reactance (reactance X) of the line in Ohms. Is used for the detection of the fault locating of protection . .
ALCResist | double | Resistance value of the electric line [Ohm] | Maximum permitted value of the resistance (effective resistance R) of the line in Ohms. Is used for the calculation of load distribution. .
ALCUseColor | Bool | Color from ALC | Only available if you have licensed Automatic Line Coloring (ALC) : Active: The automatic color of the linked source(s) is used. Inactive: The standard color is used. Default: inactive. .
ALCUseEnclosement | Bool | Use curb | Checkbox for the activation of the curb of lines, polylines and pipelines.active: ALC line elements are visualized in Runtime for a ground fault or short circuit with an additional border in the corresponding color. The colors are defined in the ALC project settings.Inactive: No display of curbing in Runtime.Default: Inactive Note: only active if is activated. .
ALCVarCalcI | CDynEleVar | Measuring value of the calculated current flow | Linked variable with the measured value of the calculated current flow of the branch. Calculation result in amperes [A]. .
ALCVarCalcIEx | Node | ALCVarCalcIEx | ALC Leitung: Messwert des berechneten Stromflusses für Export.Mehr in der Online-Hilfe .
ALCVarMaxI | CDynEleVar | Dynamic limit value current carrying capacity | Linked variable for the maximum current-carrying capacity of the weakest link (cable) in the line. Only available if the limit value of current-carrying capacity property is configured with limit value of current-carrying capacity dynamic . .
ALCVarMaxIEx | Node | ALCVarMaxIEx | Node
Align | Int16 | Alignment | Direction of color shift. horizontal vertical
AlphaBackColor | SByte | Transparency of the fill color [%] | .
AlphaBackColor2 | SByte | Transparency gradient color [%] | Only available if Linear was selected in the property. .
AlphaLineColor | SByte | Transparency line color [%] | .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColor2 | UInt32 | Gradient color | Color gradient must be selected for the property.Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of . .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVariable2 | CDynEleVar | Gradient color | Name of the variable whose limit value color should influence the gradient color of the element. Click on the input filed in order to open the dialog for selecting a variable. .
BackColorVariable2Preview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
Brightness | Bool | With brightness values | Only available if was selected as color gradient was selected.Active: The brightness of the color gradient can be freely defined. Inactive: The brightness of the color gradient is defined automatically.Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners. .
ColorGradientAngle | Int16 | Angle [°] | Defines the direction of the color gradient starting in the center of the element.Values: 0° to 360° . Default: 0° .
ColorGradientOffset | Int16 | Offset [%] | Only available if, for a vector element or a dynamic button element, the property has been set. Linear or Selective or Selective with edges .Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.Values: 0 equals the center of the element. 100 the edge. Note: The value can also be outside of the element and is therefore not limited to 100 . .
CornerAll_X | Int32 | All x [%] | Only available if property is inactive.Defines the value of the rounding of the X-axis in percent for all corners. This value is used for all corners whose values equals -1. Individual corners can therefore be defined independently.If the value of the rounding is changed, all corners are automatically set to the value -1. With this all corners are set back to the pre-defined value.Value range: 0 % to 100 %. Default button: 20 Default rectangle: 0 .
CornerAll_Y | Int32 | All y [%] | Only available if the property is active and the property is inactive.Defines the value of the rounding of the Y-axis in percent for all corners. This value is used for all corners whose values equals -1. Individual corners can therefore be defined independently.If the value of the rounding is changed, all corners are automatically set to the value -1. With this all corners are set back to the pre-defined value.Value range: 0 % to 100 % Default button: 20 Default rectangle: 0 .
CornerLeftBottom_X | Int32 | Left/bottom x [%] | The property must be activated.Defines the radius value of the X-axis for the bottom left corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerLeftBottom_Y | Int32 | Left/bottom y [%] | In addition, the property must be activated and the property must be deactivated.Defines the radius value of the Y-axis for the bottom left corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerLeftTop_X | Int32 | Left/top x [%] | The property must be activated.Defines the radius value of the X-axis for the top left corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerLeftTop_Y | Int32 | Left/top y [%] | In addition, the property must be activated and the property must be deactivated.Defines the radius value of the Y-axis for the top left corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerProportional | Bool | Proportional | Only available if property is inactive.Active: For creating a radiused corner only the x value can be entered. The y value is always the same.The percentage entered at property refers to the shorter side (width or height) of the element.Inactive: The x and y values can be entered freely. The x value refers to the width of the element. The y value refers to the height of the element.Default: active .
CornerRightBottom_X | Int32 | Right/bottom x [%] | Only available if property is inactive.Defines the value of the rounding of the X-axis for the bottom right corner. Click on button ... opens a slider with which you can set the radius.Possible values:-1: The setting from is used.0 to 100: Rounding in percent.Default: -1 .
CornerRightBottom_Y | Int32 | Right/bottom y [%] | In addition, the property must be activated and the property must be deactivated.Defines the radius value of the Y-axis for the bottom right corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerRightTop_X | Int32 | Right/top x [%] | The property must be activated.Defines the radius value of the X-axis for the top right corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
CornerRightTop_Y | Int32 | Right/top y [%] | In addition, the property must be activated and the property must be deactivated.Defines the radius value of the Y-axis for the top right corner. Click on button ... opens a slider with which you can set the radius. Possible values:-1 : The setting from is used.0 to 100 : Radius in percent.Default: -1 .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillColorInvert | Bool | Invert color gradient | Only available if Color gradient was selected as . Active: The brightness gradient is inverted. Inactive: The brightness gradient is not inverted. Default: Inactive .
FillPattern | UInt32 | Fill pattern | Selection of the filling pattern for the element from the list.This property is only available if property is inactive. .
FillStyle | Guid | Fill style |
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
InnerBrightness | SByte | Brightness inside | Only available if "via brightness value" is active : Brightness in the middle of the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Lightning | Int16 | Color gradient | Only available if was set to Color gradient . Defines the color gradient for elements. Linear : steady gradientDefined point : Gradient from a defined point to the edges of the element Selective with edges : Gradient from a defined point to the edges of the element with beamsRadiant : From the bottom to the middle, then gradient from the middle to the top (with rectangular form only).
LineColor | UInt32 | Line color | Line color of the element.
LineColorEx | UInt32 | Line color | Defines the line color of the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LineStyle | Guid | Line style | Display and selection of the line style that is assigned to the element. .
LineType | UInt32 | Line type | Selection of the line type for the element from the list. Attention: If the node in in the project properties, the property has been set to Windows basic , you can only use line width >1 with a "continuous line" type line. .
LineWidth | UInt16 | Line width [Pixel] | Width of the line (in pixels).Minimum: 0 In this case the width of the line is 1 pixel.Maximum: 40 Default: 1 Attention: If in the project settings in node you set property to Windows basis , you can use line width >1 only with a line of type "continuous line". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
MeasuredInputActivePower | Node | Active power input [MW] | Linked variable with the measured value of the active power at the line input. .
MeasuredInputActivePowerImEx | Node | MeasuredInputActivePowerImEx | Description
MeasuredInputCosPhi | Node | cos Phi input | Linked variable with the measured value of the cos phi power factor at the line input. .
MeasuredInputCosPhiImEx | Node | MeasuredInputCosPhiImEx | Description
MeasuredInputCurrent | Node | Power Input [A] | Linked variable with the measured value of the amperage at the line input. .
MeasuredInputCurrentImEx | Node | MeasuredInputCurrentImEx | Description
MeasuredInputReactivePower | Node | Reactive power input [MVar] | Linked variable with the measured value of the reactive power at the line input. .
MeasuredInputReactivePowerImEx | Node | MeasuredInputReactivePowerImEx | Description
MeasuredInputVoltage | Node | Voltage input [kV] | Linked variable with the measured value of the voltage at the line input. .
MeasuredInputVoltageImEx | Node | MeasuredInputVoltageImEx | Description
MeasuredOutputActivePower | Node | Active power output [MW] | Linked variable with the measured value of the active power at the line output. .
MeasuredOutputActivePowerImEx | Node | MeasuredOutputActivePowerImEx | Description
MeasuredOutputCosPhi | Node | cos Phi output | Linked variable with the measured value of the cos phi power factor at the line output. .
MeasuredOutputCosPhiImEx | Node | MeasuredOutputCosPhiImEx | Description
MeasuredOutputCurrent | Node | Power Output [A] | Linked variable with the measured value of the amperage at the line output. .
MeasuredOutputCurrentImEx | Node | MeasuredOutputCurrentImEx | Description
MeasuredOutputReactivePower | Node | Reactive power output [MVar] | Linked variable with the measured value of the reactive power at the line output. .
MeasuredOutputReactivePowerImEx | Node | MeasuredOutputReactivePowerImEx | Description
MeasuredOutputVoltage | Node | Voltage output [kV] | Linked variable with the measured value of the voltage at the line output. .
MeasuredOutputVoltageImEx | Node | MeasuredOutputVoltageImEx | Description
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
OuterBrightness | SByte | Brightness outside | Only available if "via brightness value" is active : Brightness at the outer side of the element. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RoundingStyle | Guid | Rounding style | Display and selection of the style for rounding that is assigned to the element. .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
Shifted | Int16 | Shifted color gradient | Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein. Mehr im Online-Handbuch
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VarLineCurrent | Node | Current [A] | Linked variable with the result of the load flow calculation for the calculated amperage at the line input. .
VarLineCurrentImEx | Node | VarLineCurrentImEx | Description
VarLinePowerFactorVar | Node | cos Phi output | Linked variable with the result of the load flow calculation for the calculated power factor (cos phi). This corresponds to the average value of the calculated cos phi at the output. .
VarLinePowerFactorVarImEx | Node | VarLinePowerFactorVarImEx | Description
VarLinePowerInVar | Node | Active power input [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line input. .
VarLinePowerInVarImEx | Node | VarLinePowerInVarImEx | Description
VarLinePowerOutVar | Node | Active power output [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line output. .
VarLinePowerOutVarImEx | Node | VarLinePowerOutVarImEx | Description
VarLineReactivePowerInVar | Node | Reactive power input [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line input. .
VarLineReactivePowerInVarImEx | Node | VarLineReactivePowerInVarImEx | Description
VarLineReactivePowerOutVar | Node | Reactive power output [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line output. .
VarLineReactivePowerOutVarImEx | Node | VarLineReactivePowerOutVarImEx | Description
VarLineVoltageInVar | Node | Voltage input [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line input. .
VarLineVoltageInVarImEx | Node | VarLineVoltageInVarImEx | Description
VarLineVoltageOutVar | Node | Voltage output [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line output. .
VarLineVoltageOutVarImEx | Node | VarLineVoltageOutVarImEx | Description
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Rectangle [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Report viewer control
ObjectModel COM [image] Element [image] DynProperties [image] Report viewer control
Overview
External Name | Type | Display Name | Description
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Legend | String | Text | Label of the element in the Editor. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
ShowBorder | Bool | Show border lines | Visualizes a border for certain elements when displayed in Runtime. The configuration of the and properties is no longer taken into account for the display in Runtime as a result.Active : The element is shown in Runtime with a border.Inactive: No border when displayed in Runtime.Default: inactive. .
ShowReportViewerHeader | Bool | Show integrated Report Viewer tool bar | Checkbox for the display of the incorporated symbols of the Report Viewer in Runtime.Active: The internal tool bar of the Report Viewer is visualized in Runtime.Inactive: No display of the Report Viewer tool bar in Runtime.Default: Inactive .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleH | UInt16 | Style H | Windows style of the element, for internal use only. .
StyleL | UInt16 | Style L | Windows style of the element, for internal use only. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Text color | Text color of the element. .
TranslateText | Bool | Translate display text | Active : The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.Default: Inactive .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Report viewer control [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Segment of circle
ObjectModel COM [image] Element [image] DynProperties [image] Segment of circle
Overview
External Name | Type | Display Name | Description
ALCAlias | Bool | Use alias | Only available if is active.Active : Alias is used. In the Runtime the element receives its ALC colors from another ALC element of the topological model without being part of the model itself. The displayed ALC color of the element is thus not determined by the linked lines. The ALC color is identical to the color of the ALC element, the name of which is linked in the .Inactive : Element is an ALC element according to the configured ALC . The ALC display color is determined by the linked lines.Default: Inactive .
ALCAliasName | String | Alias | Only available if is active.Defined source element for property . Clicking on the ... button opens the dialog to select a pre-configured ALC element in a pre-configured zenon screen. Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project. .
ALCAlternativeColor | UInt32 | Alternative color | Only available if property has value alternative color .Alternative color for the ALC coloring at multiple supply. .
ALCDashLen | Int16 | Dashing length supplied multiple times | Only available if property has value two highest prior sources .Defines the dash length in pixel for the dashed ALC coloring at multiply supply.Minimal: 0 (automatic dash length)Maximum: 32767 Default: 0 .
ALCEnclosementSize | SByte | Curb width [px] | Width of the curb in pixels.Default: 1 pixel Input range: 1 to 20 pixels.Note: Only available if property is active. .
ALCLength | double | Length of the line [km] | ALC line: Length of the line. .
ALCLineName | String | Line name | Unique name of the line. Is used for the identification of the line in the load distribution calculation. In addition, this name is used as interlocking text for the "Overload of a line " topological interlocking.Note : Only available for the Line or Pipe screen element. .
ALCMaxIType | Int16 | Limit value current carrying capacity | Origin of data on the limit value of the current carrying capacity for the calculation of load distribution . The current carrying capacity of the weakest link (cable) in a line. Selection of the type from the drop-down list: Default: Static limit value current carrying capacity Note: The entries in the drop-down list correspond to the properties that follow the Editor directly. .
ALCMaxIVal | double | Static limit value current carrying capacity [A] | Entry of the maximum current-carrying capacity of the weakest link (cable) in the line. Entry in amperes.Default: 20 Not available if the property is configured with limit value of current-carrying capacity dynamic . .
ALCMSecuredSupply | Int16 | display secured supply | Only available if was activated.Definition of the display of the secured supply:double widthdouble brightnessnormalDefault: normal .
ALCMultiSource | Int16 | display multiple supplies | Only available if the property is active. Defines the display type if the element is connected to several sources: most prior source: Only the color of the source with the highest priority is used. two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line. alternative color : Alternative color for the coloring at multiple supply.Default: highest priority source .
ALCPrecedence | Int16 | Priority for display | Only available if the property is active.Defines the priority of the display when the element is connected to several active sources. Multiple supply : The element is displayed according to the rules of the multiple supply. secured supply : The element is displayed according to the rules of the secured supply. No priority : The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.Default: Multiple supply .
ALCReact | double | Reactance value of the cable [Ohm] | Maximum permitted value of the reactance (reactance X) of the line in Ohms. Is used for the detection of the fault locating of protection . .
ALCResist | double | Resistance value of the electric line [Ohm] | Maximum permitted value of the resistance (effective resistance R) of the line in Ohms. Is used for the calculation of load distribution. .
ALCUseColor | Bool | Color from ALC | Only available if you have licensed Automatic Line Coloring (ALC) : Active: The automatic color of the linked source(s) is used. Inactive: The standard color is used. Default: inactive. .
ALCUseEnclosement | Bool | Use curb | Checkbox for the activation of the curb of lines, polylines and pipelines.active: ALC line elements are visualized in Runtime for a ground fault or short circuit with an additional border in the corresponding color. The colors are defined in the ALC project settings.Inactive: No display of curbing in Runtime.Default: Inactive Note: only active if is activated. .
ALCVarCalcI | CDynEleVar | Measuring value of the calculated current flow | Linked variable with the measured value of the calculated current flow of the branch. Calculation result in amperes [A]. .
ALCVarCalcIEx | Node | ALCVarCalcIEx | ALC Leitung: Messwert des berechneten Stromflusses für Export.Mehr in der Online-Hilfe .
ALCVarMaxI | CDynEleVar | Dynamic limit value current carrying capacity | Linked variable for the maximum current-carrying capacity of the weakest link (cable) in the line. Only available if the limit value of current-carrying capacity property is configured with limit value of current-carrying capacity dynamic . .
ALCVarMaxIEx | Node | ALCVarMaxIEx | Node
Align | Int16 | Alignment | Direction of color shift. horizontal vertical
AlphaLineColor | SByte | Transparency line color [%] | .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
Brightness | Bool | With brightness values | Only available if was selected as color gradient was selected.Active: The brightness of the color gradient can be freely defined. Inactive: The brightness of the color gradient is defined automatically.Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndOffset | float | Thickness end angles [pixel] | Segment thickness at the end angle from the outer edge of the ellipse to the centrepoint in pixels. Only available if the property has been activated and the property has been deactivated.Minimum: 0 pixelsMaximum: A value less than half the height or half the width of the element.Default: 12:00 AM .
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
InnerBrightness | SByte | Brightness inside | Only available if "via brightness value" is active : Brightness in the middle of the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LineCapEnd | UInt32 | End type | Defines the symbol for the end point of the line. Clicking on the field opens the dialog to select an element. Only available for the arc of a circle and segment of a circle if has been set to without . .
LineCapScale | float | Size | Defines the magnifying factor for the line width of the arrow. The factor relates to the line width of the vector element as defined in the property. For arc of circle and segment of circle only available if property was set to without .Value: greater or equal 1 Default: 4 .
LineCapStart | UInt32 | Start type | Defines the symbol for the starting point of the line. Click on the field and a dialog opens to select an element. For arc of circle and segment of circle only available if property was set to without . .
LineColor | UInt32 | Line color | Line color of the element.
LineColorEx | UInt32 | Line color | Defines the line color of the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LineStyle | Guid | Line style | Display and selection of the line style that is assigned to the element. .
LineType | UInt32 | Line type | Selection of the line type for the element from the list. Attention: If the node in in the project properties, the property has been set to Windows basic , you can only use line width >1 with a "continuous line" type line. .
LineWidth | UInt16 | Line width [Pixel] | Width of the line (in pixels).Minimum: 0 In this case the width of the line is 1 pixel.Maximum: 40 Default: 1 Attention: If in the project settings in node you set property to Windows basis , you can use line width >1 only with a line of type "continuous line". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
MeasuredInputActivePower | Node | Active power input [MW] | Linked variable with the measured value of the active power at the line input. .
MeasuredInputActivePowerImEx | Node | MeasuredInputActivePowerImEx | Description
MeasuredInputCosPhi | Node | cos Phi input | Linked variable with the measured value of the cos phi power factor at the line input. .
MeasuredInputCosPhiImEx | Node | MeasuredInputCosPhiImEx | Description
MeasuredInputCurrent | Node | Power Input [A] | Linked variable with the measured value of the amperage at the line input. .
MeasuredInputCurrentImEx | Node | MeasuredInputCurrentImEx | Description
MeasuredInputReactivePower | Node | Reactive power input [MVar] | Linked variable with the measured value of the reactive power at the line input. .
MeasuredInputReactivePowerImEx | Node | MeasuredInputReactivePowerImEx | Description
MeasuredInputVoltage | Node | Voltage input [kV] | Linked variable with the measured value of the voltage at the line input. .
MeasuredInputVoltageImEx | Node | MeasuredInputVoltageImEx | Description
MeasuredOutputActivePower | Node | Active power output [MW] | Linked variable with the measured value of the active power at the line output. .
MeasuredOutputActivePowerImEx | Node | MeasuredOutputActivePowerImEx | Description
MeasuredOutputCosPhi | Node | cos Phi output | Linked variable with the measured value of the cos phi power factor at the line output. .
MeasuredOutputCosPhiImEx | Node | MeasuredOutputCosPhiImEx | Description
MeasuredOutputCurrent | Node | Power Output [A] | Linked variable with the measured value of the amperage at the line output. .
MeasuredOutputCurrentImEx | Node | MeasuredOutputCurrentImEx | Description
MeasuredOutputReactivePower | Node | Reactive power output [MVar] | Linked variable with the measured value of the reactive power at the line output. .
MeasuredOutputReactivePowerImEx | Node | MeasuredOutputReactivePowerImEx | Description
MeasuredOutputVoltage | Node | Voltage output [kV] | Linked variable with the measured value of the voltage at the line output. .
MeasuredOutputVoltageImEx | Node | MeasuredOutputVoltageImEx | Description
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
OffsetAdjustable | Bool | Adjustable segment thickness | Segment thickness for the segment of a circle. Active : The thickness of the segment of a circle can be configured individually. .
OffsetEndEqualsStart | Bool | End thickness equals start thickness | Active : Set the segment thickness for the end angle to the same value as the start angle. The property is deactivated. This means that the whole element is displayed with an even segment thickness. Only available if the property has been activated.
OuterBrightness | SByte | Brightness outside | Only available if "via brightness value" is active : Brightness at the outer side of the element. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
SegEndAngle | double | End angle [°] | End of the opening angle. The opening angle of the segment of the circle is displayed between the start angle and the end angle. .
SegEndX | Int16 | End point X [pixels] |
SegEndY | Int16 | End point Y [pixels] |
SegStartAngle | double | Start angle [°] | Start of the opening angle. The opening angle of the segment of the circle is displayed between the start angle and the end angle. .
SegStartX | Int16 | Start point X [pixels] |
SegStartY | Int16 | Start point Y [pixels] |
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
Shifted | Int16 | Shifted color gradient | Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein. Mehr im Online-Handbuch
StartOffset | float | Thick start angles [pixel] | Segment thickness at the start angle from the outer edge of the ellipse to the centrepoint in pixels. Only available if property is active.Minimum: 0 pixelsMaximum: A value less than half the height or half the width of the element.Default: 12:00 AM .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
VarLineCurrent | Node | Current [A] | Linked variable with the result of the load flow calculation for the calculated amperage at the line input. .
VarLineCurrentImEx | Node | VarLineCurrentImEx | Description
VarLinePowerFactorVar | Node | cos Phi output | Linked variable with the result of the load flow calculation for the calculated power factor (cos phi). This corresponds to the average value of the calculated cos phi at the output. .
VarLinePowerFactorVarImEx | Node | VarLinePowerFactorVarImEx | Description
VarLinePowerInVar | Node | Active power input [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line input. .
VarLinePowerInVarImEx | Node | VarLinePowerInVarImEx | Description
VarLinePowerOutVar | Node | Active power output [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line output. .
VarLinePowerOutVarImEx | Node | VarLinePowerOutVarImEx | Description
VarLineReactivePowerInVar | Node | Reactive power input [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line input. .
VarLineReactivePowerInVarImEx | Node | VarLineReactivePowerInVarImEx | Description
VarLineReactivePowerOutVar | Node | Reactive power output [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line output. .
VarLineReactivePowerOutVarImEx | Node | VarLineReactivePowerOutVarImEx | Description
VarLineVoltageInVar | Node | Voltage input [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line input. .
VarLineVoltageInVarImEx | Node | VarLineVoltageInVarImEx | Description
VarLineVoltageOutVar | Node | Voltage output [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line output. .
VarLineVoltageOutVarImEx | Node | VarLineVoltageOutVarImEx | Description
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Segment of circle [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Static text
ObjectModel COM [image] Element [image] DynProperties [image] Static text
Overview
External Name | Type | Display Name | Description
AlphaBackColor | SByte | Transparency of the fill color [%] | .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillStyle | Guid | Fill style |
Font | LogFont | Font | Selection of the font with which the display happens.Attention: This option only works for embedded fonts. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalAlign | Int16 | Alignment horizontal | Horizontal orientation of the value for the display. Selection from a drop-down list:Left Right Centered Default: Centered. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LineColorVariable | CDynEleVar | Text color | Name of the variable whose limit value color is to influence the text color of the element. Click on the ... button to open the dialog for selecting a variable..
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LinkedFont | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Text | String | Text | Text which should be displayed in the screen.By using the & character, you can underline the following character in the Runtime. To display the character & itself, enter &&.With character string \n a line break can be forced. .
TextColor | UInt32 | Text color | Text color of the element. .
TextStyle | Guid | Text style |
Transparent | Bool | Transparent | Settings for transparency.Active : Displays the element transparently.Default: Inactive The effect of this option on a button is an Invisible button . It can be positioned above other elements as an invisible button. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalAlign | Int16 | Alignment vertical | Vertical orientation of the value for the display. Selection from a drop-down list:Top Bottom Centered Default: Centered. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
Wordbreak | Bool | Automatic word wrap | Active: Automatic word wrap is used for the text in the element. The length of the lines depends on the width of the element.Inactive: The text is displayed in one line.Default: Inactive .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Static text [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Switch
ObjectModel COM [image] Element [image] DynProperties [image] Switch
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
Animate | Bool | GIF animation always | Active: The animation always runs. Inactive: Then the animation is not executed. You can switch the animation on and off with an optional link to . .
AnimateVar | CDynEleVar | Variable | Bit variable that switches the animation on and off. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BitmapHigh | String | Graphics file for On (1) | Pre-defined or user-defined graphics file for the on status of the switch. .
BitmapLow | String | Graphics file for Off (0) | Pre-defined or user-defined graphics file for the off status of the switch. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
DynEleVar | Node | DynEleVar | "With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FastReaction | Bool | Fast reaction | Only available if is active . Active: The switch immediately changes its position in Runtime, regardless of whether the linked bit has actually been set in the PLC. In the next driver update cycle, the bit will be read from the PLC. Then the switch again ressembles the correct position of the bit in the PLC. Attention: The switch will only be visibly operable after the value has been read from the PLC.Inactive: The switch will change its position only after the bit has been sent to the PLC and then again read from the PLC.Default: inactive. .
FillStyle | Guid | Fill style |
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
GraphicsFillStyle | Guid | Fill style for graphic if pressed/on | Description as text.
GraphicSize | UInt16 | Graphic size | Definition of the graphics size.Adjusted : The size of the graphics is adjusted to the size of the element.Original size : The linked graphics are displayed in their original size. When selecting this option, the and properties can no longer be configured individually for the multibin, combi-element, button and switch elements. All graphics files should be the same size.Default: adjust .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
MDIFunction | UInt32 | Screen type specific action | Only available in screens with a special screen type (screen type is not standard ): Linking to a screen-specific function. Clicking on the ... button opens the dialog for selecting a screen-specific function. This function is executed if the button is clicked with the mouse in Runtime or the linked key combination is pressed.Attention: In addition to a screen-type specific function, it is also possible to link a general function with the button. In this case, note the sequence of execution when clicking on the button: The screen-type-specific function is executed first. Only once this has been ended is the general function executed. If VBA events are linked to the button in Runtime, these are executed before the functions. .
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
PredefinedBitmaps | UInt32 | Predefined graphics | Pre-defined bitmaps for the LOW/HIGH state can be selected from the list. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ReactionTime | UInt16 | Holding time [ms] | Only available if is active . If is active: Time (in ms) which a state is held starting from the left click on the respective element.If property is inactive: Delayed reaction to a left click. .
ResetOnLeave | Bool | Reset on exit | Only available if property is active . If you press and hold the mouse button and move the mouse pointer away from the pushbutton, this will automatically reset the value of the variable. .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
Scanner | Bool | Pushbutton | Only available if property is active. (Exception: always available in the switch dynamic element.) Active: The target state - defined in property - is only held as long as the left mouse button is pressed but at least as long as . Inactive: The target state remains even after the mouse button is released. Default: inactive. .
ScannerOn | Bool | Pushbutton On | Only available if is active . Active: Pushbutton switches to ON. Inactive: Pushbutton switches to OFF. Default: Inactive. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
ShowState | Bool | Display status of variable | Graphical display of the status of the variable. Selection from a checkbox.Active: The status of the variables is indicated by a colored square at the element. Color : Red square: No communication with the PLC. Example: INVALID, OFF, ALT_VAL, REVISION, TIMEOUT, ...Blue square(N_UPDATE) : On the network client: The client has lost its connection to the Primary Server. With a standalone integration project: The Primary Server has not yet supplied the data.Yellow square (PR_NR) : Visualizes in Runtime that the variable has not been logged during replay in the Process Recorder . No value is therefore known in the playback.Position: The position of the square at the element depends on the element form:Angular and all other elements: Top right cornerRound element: Top, in the middle Rounded element : Top right corner, slightly offset to the left Inactive: The status is not shown. Also deactivates the display of additional variable information with a right click.Default: activated .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StayPressed | Bool | Keep pushed state | Only available if properties , and are active. Active: As long as you hold the mouse button pressed on this element, its graphical display does not change - independent of possible values changes in the PLC. At the element Switch property must be active in order for this to happen. Inactive: The element always displays the value of the variable from the PLC. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
ThreeDimensional | Bool | 3D | Active: The element is displayed in 3D. Inactive: The element is displayed flat. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
Variable | CDynEleVar | Variable | Name of the linked variable. Click on button ... in order to open the dialog for selecting variables. The value of this variable is displayed in this element and can also be set here.Note: Only available for buttons if they are used as a switch .Hint: If the variable value is to be toggled, we recommend activating the property. Only SICAM 230 and Screen Alarm element: The description above only applies to the elements Text Button, Bitmap Button and Invisible Button . Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).Lower bit: Alarm active/inactive Higher bit: Alarm acknowledged/not acknowledged .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Switch [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Switch [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Symbol
ObjectModel COM [image] Element [image] DynProperties [image] Symbol
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
Category | String | Category | Concept for categorization. You can also filter or group by this property. .
Description | String | Description | More-detailed description of the symbol or the element group. You can also filter by this property. .
Elements | Node | Elements | Node
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
ExpProps | Node | ExpProps | Node
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PropSymbolNumber | UInt16 | Screen symbol number | Unique number of the symbol or the element group. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDrawObj
ObjectModel COM [image] Element [image] DynProperties [image] Symbol [image] CDrawObj
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Symbol [image] CDrawObj [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Symbol [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CSymbLibProp
ObjectModel COM [image] Element [image] DynProperties [image] Symbol [image] CSymbLibProp
Overview

External Name

Type

Display Name

Description


Template
ObjectModel COM [image] Element [image] DynProperties [image] Template
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Template [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Text button
ObjectModel COM [image] Element [image] DynProperties [image] Text button
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
ChangeText | Bool | Change text depending on control keys | Only available if you have activated in the properties of the screen.active : Use to for labelling the button. Inputs at and is no longer necessary.Default: Inactive .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
DynEleFkt | Node | Node | Node
DynEleVar | Node | DynEleVar | "With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FastReaction | Bool | Fast reaction | Only available if is active . Active: The switch immediately changes its position in Runtime, regardless of whether the linked bit has actually been set in the PLC. In the next driver update cycle, the bit will be read from the PLC. Then the switch again ressembles the correct position of the bit in the PLC. Attention: The switch will only be visibly operable after the value has been read from the PLC.Inactive: The switch will change its position only after the bit has been sent to the PLC and then again read from the PLC.Default: inactive. .
FktOnDown | Bool | Function execution on pressing | Active: The linked function is executed when the element is pressed. Inactive: The linked function is executed when the element is released. Default: inactive. .
Function | CDynEleFkt | Function | Name of the linked function. Opens the function selection dialog. This function will be executed when the button is clicked in the Runtime or when the assigned key shortcut is pressed. If you wish to execute more than one function, you need to create a script with the required functions and specify the function for executing that script here.SICAM 230 and screen alarming element only: In addition to the standard screen switch property, the screen whose alarm states are supposed to be displayed will be determined by the linked function. Obligatory (unless the Global setting is active )! .
FunctionParameter | String | Parameter for substitution | Entry of the character sequence for substitution via parameters. Replaces the key word {PARAM} in the substitution dialog of the screen switching.Note: Avoid character sequences that are also used for parameter of the indexing variables, such as {X01} . .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
MDIFunction | UInt32 | Screen type specific action | Only available in screens with a special screen type (screen type is not standard ): Linking to a screen-specific function. Clicking on the ... button opens the dialog for selecting a screen-specific function. This function is executed if the button is clicked with the mouse in Runtime or the linked key combination is pressed.Attention: In addition to a screen-type specific function, it is also possible to link a general function with the button. In this case, note the sequence of execution when clicking on the button: The screen-type-specific function is executed first. Only once this has been ended is the general function executed. If VBA events are linked to the button in Runtime, these are executed before the functions. .
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
ParamFromScreen | Bool | Take over from calling screen | The function allows the application of the parameters for the substitution of the calling screen.active: Parameter text field is deactivatedDefault: Inactive
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ReactionTime | UInt16 | Holding time [ms] | Only available if is active . If is active: Time (in ms) which a state is held starting from the left click on the respective element.If property is inactive: Delayed reaction to a left click. .
ResetOnLeave | Bool | Reset on exit | Only available if property is active . If you press and hold the mouse button and move the mouse pointer away from the pushbutton, this will automatically reset the value of the variable. .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
Scanner | Bool | Pushbutton | Only available if property is active. (Exception: always available in the switch dynamic element.) Active: The target state - defined in property - is only held as long as the left mouse button is pressed but at least as long as . Inactive: The target state remains even after the mouse button is released. Default: inactive. .
ScannerOn | Bool | Pushbutton On | Only available if is active . Active: Pushbutton switches to ON. Inactive: Pushbutton switches to OFF. Default: Inactive. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StayPressed | Bool | Keep pushed state | Only available if properties , and are active. Active: As long as you hold the mouse button pressed on this element, its graphical display does not change - independent of possible values changes in the PLC. At the element Switch property must be active in order for this to happen. Inactive: The element always displays the value of the variable from the PLC. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Switch | Bool | Switch | Only available if property is inactive.Active: The element switches the value of a bit variable. Inactive: The element carries out a function. Default: Inactive .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
Text1Ctrl | String | Text line 1 with Ctrl | Only available if property is active. Labeling of the first text line in the button if the Control key is pressed. Note : By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
Text1CtrlAlt | String | Text line 1 with Ctrl+Alt (Alt Gr) | Only available if property is active. Labels the first text line in the button when the CTRL key and the ALT GR key are pressed. Note: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
Text1Normal | String | Text line 1 normal | Only available if property is active. Labels the first text line in the button without pressing a control key. Notice: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
Text1Shift | String | Text line 1 with Shift | Only available if property is active. Labels the first text line in the button if the Shift key is pressed. Note: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
Text2Ctrl | String | Text line 2 with Ctrl | Only available if property is active. Labels the second text line in the button if the CTRL key is pressed. Note: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
Text2CtrlAlt | String | Text line 2 with Ctrl+Alt (Alt Gr) | Only available if property is active. Labels the second text line in the button when the CTRL key and the ALT GR key are pressed. Note : By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
Text2Normal | String | Text line 2 normal | Only available if property is active. Labels the second text line in the button without pressing a control key. Note : By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
Text2Shift | String | Text line 2 with Shift | Only available if property is active. Labels the second text line in the button if the Shift key is pressed. Note: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
Variable | CDynEleVar | Variable | Name of the linked variable. Click on button ... in order to open the dialog for selecting variables. The value of this variable is displayed in this element and can also be set here.Note: Only available for buttons if they are used as a switch .Hint: If the variable value is to be toggled, we recommend activating the property. Only SICAM 230 and Screen Alarm element: The description above only applies to the elements Text Button, Bitmap Button and Invisible Button . Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).Lower bit: Alarm active/inactive Higher bit: Alarm acknowledged/not acknowledged .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleFkt
ObjectModel COM [image] Element [image] DynProperties [image] Text button [image] CDynEleFkt
Overview
External Name | Type | Display Name | Description
Name | String | Name |
ProjectFunction | CProjektFunktion | ProjectFunction |


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Text button [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Text button [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Topological line
ObjectModel COM [image] Element [image] DynProperties [image] Topological line
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
BrokenLine1 | UInt32 | Broken line color 1 | Broken line color 1
BrokenLine2 | UInt32 | Broken line color 2 | Broken line color 2
Coordinates | String |  | "With this property you can get/set the coordinates of the element via a string. zElement.DynProperties(""Coordinates"") = ""197/118;260/200"""
DisplayMode | UInt32 | Display mode | Mode display
DistributionLineCharacter | String | Sign split elsewhere | Sign split elsewhere
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
ExtraPoints | String | Sign split (several times) | Sign (several times) interrupted
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LineWidth | UInt32 | Line width | Line width
LineWidthFGES | UInt32 | Line width protected | Line width Protected
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
SaumWidth | UInt32 | Edge width | Edge width
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
Variable | CDynEleVar | Variable | Name of the linked variable. Click on button ... in order to open the dialog for selecting variables. The value of this variable is displayed in this element and can also be set here.Note: Only available for buttons if they are used as a switch .Hint: If the variable value is to be toggled, we recommend activating the property. Only SICAM 230 and Screen Alarm element: The description above only applies to the elements Text Button, Bitmap Button and Invisible Button . Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).Lower bit: Alarm active/inactive Higher bit: Alarm acknowledged/not acknowledged .
Variable_SS_1_1 | CDynEleVar | Variable SS_1_1 | Variable SS_1_1
Variable_SS_1_2 | CDynEleVar | Variable SS_1_2 | Variable SS_1_2
Variable_SS_1_3 | CDynEleVar | Variable SS_1_4 | Variable SS_1_4
Variable_SS_1_4 | CDynEleVar | Variable SS_1_4 | Variable SS_1_4
Variable_SS_2_1 | CDynEleVar | Variable SS_2_1 | Variable SS_2_1
Variable_SS_2_2 | CDynEleVar | Variable SS_2_2 | Variable SS_2_2
Variable_SS_2_3 | CDynEleVar | Variable SS_2_3 | Variable SS_2_3
Variable_SS_2_4 | CDynEleVar | Variable SS_2_4 | Variable SS_2_4
Variable_Start1 | CDynEleVar | Variable Start1 | Variable Start1
Variable_Start2 | CDynEleVar | Variable Start2 | Variable Start2
VariableStandardIsolatingPoint | CDynEleVar | Variable standard dividing point | Variable standard dividing point
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Topological line [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Topological line [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Topological wire
ObjectModel COM [image] Element [image] DynProperties [image] Topological wire
Overview
External Name | Type | Display Name | Description
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
BrokenLine1 | UInt32 | Broken line color 1 | Broken line color 1
BrokenLine2 | UInt32 | Broken line color 2 | Broken line color 2
Coordinates | String |  | "With this property you can get/set the coordinates of the element via a string. zElement.DynProperties(""Coordinates"") = ""197/118;260/200"""
DisplayMode | UInt32 | Display mode | Mode display
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LineWidth | UInt32 | Line width | Line width
LineWidthFGES | UInt32 | Line width protected | Line width Protected
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
NCCableType | Int16 | Cable type |
NCCCurrentMax | float | Current carrying capacity [A] |
NCCLength | float | Length [m] |
NCCReactance | float | Reactance [Ohm] |
NCCResistance | float | Resistance [Ohm] |
NCCurrentMax | float | Max. allocatable load | Maximal load which can be assigned.
NCCurrentVal | float | Load [A] |
NCCurrentVar | CDynEleVar | Measured value current/load |
NCCurrentVarEx | Node | NCCurrentVarEx | Node
NCMappingVarOut | CDynEleVar | Prefix for mapping variables | Variable which serves as base for variables in the topology.In the topology you can define a variable for each line. This variable serves as base for additional variables which you define in the topology engineering. You can assign performance-oriented - calculated by the topology - variables to these values.Click on the button in order to open the dialog for database selection.
NCMappingVarOutEx | Node | NCMappingVarOutEx | Node
NCType | Int16 | Type |
NCVoltageVal | float | Voltage level [V] |
NCVoltageVar | CDynEleVar | Measured value voltage |
NCVoltageVarEx | Node | NCVoltageVarEx | Node
NotSuppliedColor | SByte | 2nd color number for \"Not energized\" | Symbol edge
OBJNameLink | Bool | Object name as link | Object name as link
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
RTInvisible | Bool | invisible in Runtime |
SaumWidth | UInt32 | Edge width | Edge width
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
SymbolF1 | UInt16 | Symbol F1 | Symbol F1
SymbolF1_Mode | UInt32 | Symbol F1 colors | Symbol F1 colors
SymbolF2 | UInt16 | Symbol F2 | Symbol F2
SymbolF2_Mode | UInt32 | Symbol F2 colors | Symbol F2 colors
SymbolFGES | UInt16 | Symbol FGES | Symbol FGES
SymbolFGES_Mode | UInt32 | Symbol FGES colors | Symbol FGES colors
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Topological wire [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Topological wire [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Trend curve
ObjectModel COM [image] Element [image] DynProperties [image] Trend curve
Overview
External Name | Type | Display Name | Description
Addresses | Bool | Show curve info | Active: The name or the amended source text and the measurement range of the linked variables are displayed in a key. Inactive : No key is shown. Default: active. .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
Area | Bool | Show curves as areas | Active: Curves are displayed as function calls. Inactive: Curves are displayed as lines. Default: inactive. .
Axes | Bool | Display axis | Active: The time and percent axis are displayed. Inactive: No axes are displayed. Default: inactive. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
Curves | Node | Curves | Properties for the curves of the trend elements. .
Direction | UInt16 | Direction | This property defines the arrangement of the time axis to be displayed. Right : oldest on the left, newest on the right. Left : oldest on the right, newest on the left. Up : oldest at the bottom, newest at the top. Down : Oldest at the top, newest at the bottom. If the axes are displayed, an arrow in the bottom corner of the element shows the direction. Default: Right. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillStyle | Guid | Fill style |
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
NoInterpolation | Bool | Do not interpolate | Active: Values are linked without interpolation in stages. Inactive: Values are linked with interpolation. Default: inactive. .
NumericalValues | Bool | Show numeric values | Active: The values of the last refresh are displayed for all linked variables as figures. Inactive: The Values are not displayed. Default: active. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
RefreshHour | UInt32 | Hours | Hours of the updating time. Minimum: 0. Maximum: 119304. Default: 0. .
RefreshMilliSecond | UInt16 | Milliseconds | Milliseconds of the updating time. Minimum: 0. Maximum: 999. Default: 0. .
RefreshMinute | UInt16 | Min | Minutes of the updating time. Minimum: 0. Maximum: 59. Default: 0. .
RefreshSecond | UInt16 | Seconds | Seconds of the updating time. Minimum: 0. Maximum: 59. Default: 1. .
RepresentationHour | UInt32 | Hours | Hours of the period of representation. Default: 0. .
RepresentationMinute | UInt16 | Min | Minutes of the period of representation. Minimum: 0. Maximum: 59. Default: 0. .
RepresentationSecond | UInt16 | Seconds | Seconds of the periof of representation. Minimum: 0. Maximum: 59. Default: 0. .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
ScrollWidth | Int16 | Scroll width [%] | This property defines the percentage by which the curve will be moved on reaching the display limit; values between 0 and 100% are possible. 0% : Remove the oldest entry for each new entry. 50% : In the event of an overrun, delete half of the screen range and continue to write. 100% : In the event of an overrun, delete all of the screen range and start again. Default: 0. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
ThreeDimensional | Bool | 3D | Active: The element is displayed in 3D. Inactive: The element is displayed flat. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
ValueStyle | Guid | Value display style | Display and selection of the value display style that is assigned to the element. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Trend curve [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CDynEleVarTrend
ObjectModel COM [image] Element [image] DynProperties [image] Trend curve [image] CDynEleVarTrend
Overview
External Name | Type | Display Name | Description
LineColor | UInt32 | Line color | Normal color; the limit value color is used in the event of a limit violation .
LineStyle | UInt16 | Line type | Unbroken line, dashes, dot-dash. .
LineStyleLink | Guid | Line style | Display and selection of the line style that is assigned to the element. .
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.
TrendText | String | Curve name | Entry of the name that is used if the property is used. If this property remains empty, either the name, identifier or address of the variables are shown when the property is configured. Tip: Leave the field empty if Replace links or Indexing is used. You thus prevent the display of incorrect static text. The correct information is automatically shown in Runtime if the field is empty. .
ViewLimitFromVar | Bool | Apply display range from variables | Takes over the display area of the linked variable. You can update this display area during replacement with a variable with a different values range. .
ViewMax | double | Max. display range | Maximum of the technical display range for the curve (enlarged excerpt). Minimum: Minimum value of the variable. Maximum: Maximum value of the variable. Default: Maximum value of the variable. .
ViewMin | double | Min. display range | Minimum of the technical display range for the curve (enlarged excerpt). Minimum: Minimum value of the variable. Maximum: Maximum value of the variable. Default: Minimum value of the variable. .


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Trend curve [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Tube
ObjectModel COM [image] Element [image] DynProperties [image] Tube
Overview
External Name | Type | Display Name | Description
ALCAlias | Bool | Use alias | Only available if is active.Active : Alias is used. In the Runtime the element receives its ALC colors from another ALC element of the topological model without being part of the model itself. The displayed ALC color of the element is thus not determined by the linked lines. The ALC color is identical to the color of the ALC element, the name of which is linked in the .Inactive : Element is an ALC element according to the configured ALC . The ALC display color is determined by the linked lines.Default: Inactive .
ALCAliasName | String | Alias | Only available if is active.Defined source element for property . Clicking on the ... button opens the dialog to select a pre-configured ALC element in a pre-configured zenon screen. Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project. .
ALCAlternativeColor | UInt32 | Alternative color | Only available if property has value alternative color .Alternative color for the ALC coloring at multiple supply. .
ALCDashLen | Int16 | Dashing length supplied multiple times | Only available if property has value two highest prior sources .Defines the dash length in pixel for the dashed ALC coloring at multiply supply.Minimal: 0 (automatic dash length)Maximum: 32767 Default: 0 .
ALCEnclosementSize | SByte | Curb width [px] | Width of the curb in pixels.Default: 1 pixel Input range: 1 to 20 pixels.Note: Only available if property is active. .
ALCLength | double | Length of the line [km] | ALC line: Length of the line. .
ALCLineName | String | Line name | Unique name of the line. Is used for the identification of the line in the load distribution calculation. In addition, this name is used as interlocking text for the "Overload of a line " topological interlocking.Note : Only available for the Line or Pipe screen element. .
ALCMaxIType | Int16 | Limit value current carrying capacity | Origin of data on the limit value of the current carrying capacity for the calculation of load distribution . The current carrying capacity of the weakest link (cable) in a line. Selection of the type from the drop-down list: Default: Static limit value current carrying capacity Note: The entries in the drop-down list correspond to the properties that follow the Editor directly. .
ALCMaxIVal | double | Static limit value current carrying capacity [A] | Entry of the maximum current-carrying capacity of the weakest link (cable) in the line. Entry in amperes.Default: 20 Not available if the property is configured with limit value of current-carrying capacity dynamic . .
ALCMSecuredSupply | Int16 | display secured supply | Only available if was activated.Definition of the display of the secured supply:double widthdouble brightnessnormalDefault: normal .
ALCMultiSource | Int16 | display multiple supplies | Only available if the property is active. Defines the display type if the element is connected to several sources: most prior source: Only the color of the source with the highest priority is used. two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line. alternative color : Alternative color for the coloring at multiple supply.Default: highest priority source .
ALCPrecedence | Int16 | Priority for display | Only available if the property is active.Defines the priority of the display when the element is connected to several active sources. Multiple supply : The element is displayed according to the rules of the multiple supply. secured supply : The element is displayed according to the rules of the secured supply. No priority : The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.Default: Multiple supply .
ALCReact | double | Reactance value of the cable [Ohm] | Maximum permitted value of the reactance (reactance X) of the line in Ohms. Is used for the detection of the fault locating of protection . .
ALCResist | double | Resistance value of the electric line [Ohm] | Maximum permitted value of the resistance (effective resistance R) of the line in Ohms. Is used for the calculation of load distribution. .
ALCUseColor | Bool | Color from ALC | Only available if you have licensed Automatic Line Coloring (ALC) : Active: The automatic color of the linked source(s) is used. Inactive: The standard color is used. Default: inactive. .
ALCUseEnclosement | Bool | Use curb | Checkbox for the activation of the curb of lines, polylines and pipelines.active: ALC line elements are visualized in Runtime for a ground fault or short circuit with an additional border in the corresponding color. The colors are defined in the ALC project settings.Inactive: No display of curbing in Runtime.Default: Inactive Note: only active if is activated. .
ALCVarCalcI | CDynEleVar | Measuring value of the calculated current flow | Linked variable with the measured value of the calculated current flow of the branch. Calculation result in amperes [A]. .
ALCVarCalcIEx | Node | ALCVarCalcIEx | ALC Leitung: Messwert des berechneten Stromflusses für Export.Mehr in der Online-Hilfe .
ALCVarMaxI | CDynEleVar | Dynamic limit value current carrying capacity | Linked variable for the maximum current-carrying capacity of the weakest link (cable) in the line. Only available if the limit value of current-carrying capacity property is configured with limit value of current-carrying capacity dynamic . .
ALCVarMaxIEx | Node | ALCVarMaxIEx | Node
Align | Int16 | Alignment | Direction of color shift. horizontal vertical
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColor2 | UInt32 | Gradient color | Color gradient must be selected for the property.Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of . .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
Coordinates | String |  | "With this property you can get/set the coordinates of the element via a string. zElement.DynProperties(""Coordinates"") = ""197/118;260/200"""
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FillPattern | UInt32 | Fill pattern | Selection of the filling pattern for the element from the list.This property is only available if property is inactive. .
FillStyle | Guid | Fill style |
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Lightning | Int16 | Color gradient | Only available if was set to Color gradient . Defines the color gradient for elements. Linear : steady gradientDefined point : Gradient from a defined point to the edges of the element Selective with edges : Gradient from a defined point to the edges of the element with beamsRadiant : From the bottom to the middle, then gradient from the middle to the top (with rectangular form only).
LineColor | UInt32 | Line color | Line color of the element.
LineColorEx | UInt32 | Line color | Defines the line color of the element. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LineStyle | Guid | Line style | Display and selection of the line style that is assigned to the element. .
LineType | UInt32 | Line type | Selection of the line type for the element from the list. Attention: If the node in in the project properties, the property has been set to Windows basic , you can only use line width >1 with a "continuous line" type line. .
LineWidth | UInt16 | Line width [Pixel] | Width of the line (in pixels).Minimum: 0 In this case the width of the line is 1 pixel.Maximum: 40 Default: 1 Attention: If in the project settings in node you set property to Windows basis , you can use line width >1 only with a line of type "continuous line". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
MeasuredInputActivePower | Node | Active power input [MW] | Linked variable with the measured value of the active power at the line input. .
MeasuredInputActivePowerImEx | Node | MeasuredInputActivePowerImEx | Description
MeasuredInputCosPhi | Node | cos Phi input | Linked variable with the measured value of the cos phi power factor at the line input. .
MeasuredInputCosPhiImEx | Node | MeasuredInputCosPhiImEx | Description
MeasuredInputCurrent | Node | Power Input [A] | Linked variable with the measured value of the amperage at the line input. .
MeasuredInputCurrentImEx | Node | MeasuredInputCurrentImEx | Description
MeasuredInputReactivePower | Node | Reactive power input [MVar] | Linked variable with the measured value of the reactive power at the line input. .
MeasuredInputReactivePowerImEx | Node | MeasuredInputReactivePowerImEx | Description
MeasuredInputVoltage | Node | Voltage input [kV] | Linked variable with the measured value of the voltage at the line input. .
MeasuredInputVoltageImEx | Node | MeasuredInputVoltageImEx | Description
MeasuredOutputActivePower | Node | Active power output [MW] | Linked variable with the measured value of the active power at the line output. .
MeasuredOutputActivePowerImEx | Node | MeasuredOutputActivePowerImEx | Description
MeasuredOutputCosPhi | Node | cos Phi output | Linked variable with the measured value of the cos phi power factor at the line output. .
MeasuredOutputCosPhiImEx | Node | MeasuredOutputCosPhiImEx | Description
MeasuredOutputCurrent | Node | Power Output [A] | Linked variable with the measured value of the amperage at the line output. .
MeasuredOutputCurrentImEx | Node | MeasuredOutputCurrentImEx | Description
MeasuredOutputReactivePower | Node | Reactive power output [MVar] | Linked variable with the measured value of the reactive power at the line output. .
MeasuredOutputReactivePowerImEx | Node | MeasuredOutputReactivePowerImEx | Description
MeasuredOutputVoltage | Node | Voltage output [kV] | Linked variable with the measured value of the voltage at the line output. .
MeasuredOutputVoltageImEx | Node | MeasuredOutputVoltageImEx | Description
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
Shifted | Int16 | Shifted color gradient | Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein. Mehr im Online-Handbuch
SplineTension | float | Rounding | Defines the rounding for the polylines, polygons and the pipes.Values: 0,0 (no rounding) to 1,0 . (maximum rounding)Default: 0 .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VarLineCurrent | Node | Current [A] | Linked variable with the result of the load flow calculation for the calculated amperage at the line input. .
VarLineCurrentImEx | Node | VarLineCurrentImEx | Description
VarLinePowerFactorVar | Node | cos Phi output | Linked variable with the result of the load flow calculation for the calculated power factor (cos phi). This corresponds to the average value of the calculated cos phi at the output. .
VarLinePowerFactorVarImEx | Node | VarLinePowerFactorVarImEx | Description
VarLinePowerInVar | Node | Active power input [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line input. .
VarLinePowerInVarImEx | Node | VarLinePowerInVarImEx | Description
VarLinePowerOutVar | Node | Active power output [MW] | Linked variable with the result of the load flow calculation for the calculated active power at the line output. .
VarLinePowerOutVarImEx | Node | VarLinePowerOutVarImEx | Description
VarLineReactivePowerInVar | Node | Reactive power input [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line input. .
VarLineReactivePowerInVarImEx | Node | VarLineReactivePowerInVarImEx | Description
VarLineReactivePowerOutVar | Node | Reactive power output [MVar] | Linked variable with the result of the load flow calculation for the calculated reactive power at the line output. .
VarLineReactivePowerOutVarImEx | Node | VarLineReactivePowerOutVarImEx | Description
VarLineVoltageInVar | Node | Voltage input [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line input. .
VarLineVoltageInVarImEx | Node | VarLineVoltageInVarImEx | Description
VarLineVoltageOutVar | Node | Voltage output [kV] | Linked variable with the result of the load flow calculation for the calculated voltage at the line output. .
VarLineVoltageOutVarImEx | Node | VarLineVoltageOutVarImEx | Description
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Tube [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


Universal slider
ObjectModel COM [image] Element [image] DynProperties [image] Universal slider
Overview
External Name | Type | Display Name | Description
Absolute | Bool | Absolute amount | For element Numeric value only available if property is inactive .Active: Unsigned display of the variable value (-200 = 200).Inactive: Normal display of the value.Default: Inactive Note: In this case, the set value is entered in percent. .
Align | Int16 | Alignment | Note: Only available for linear form.Horizontal : Horizontal display of the bar or slider.Vertical : Vertical display of the bar or slider.Default: horizontal . .
Angle | Int32 | Rotation angle [°] | Freely definable angle about which the element is rotate. Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers. At rotated elements the following actions are no longer possible: mirrorrotate by +/- 90°scaling by means of arrow keysDefault: 0 Note: This setting is activated and reset when configuring for Windows CE. .
AutoReset | Bool | Reset automatically | Automatically reset drag indicator for minimum/maximum display after set time. .
AutoResetTime | Int16 | Reset after [min] | Time for automatic resetting of the min./max. Advertisement. .
Axistype | Int16 | Type of axis | Select from drop-down list:Linear Linear division of the axis.Logarithmic Logarithmic division of the X-axis.Default: Linear .
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BarFillStyle | Guid | Fill style |
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
BottomFrame | Int16 | Bottom [pixels] | Distance between the lower edge of the element and the and the graphic display (in pixels). .
Discrete | Bool | Discrete | Setting of values only in defined steps. .
DiscreteSteps | Int16 | Discrete steps | Number of steps for property .Minimum: 2 Maximum: 20 Default: 5 .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
DynEleVar | Node | DynEleVar | "With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"
DynMaxVar | CDynEleVar | Maximum | Variable that defines the maximum of the display range in Runtime. .
DynMinVar | CDynEleVar | Minimum | Variable that defines the minimum of the display range in Runtime. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
End | double | End angle | Definition of the end angle (0°=bottom center, continues further clockwise)Must not be less than the .Only available for round form with universal slider. .
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
Explicit | Bool | Bar explicit | Only available if for property Bar , Moving scale or LED bar has been selected. .
FillStyle | Guid | Fill style |
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
Frame | UInt16 | Element border | Drop-down list for the selection of the frame type. The following are available:For the button element Thin border 3D Default: Thin border For other dynamic elements Edge heightened Edge deepened No border Classical heightened Classical deepened Margin heightened Margin deepened Default: No border .
FrameStyle | Guid | Element border line style | Display and selection of the element style that is assigned to the element. .
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureRecognitionActive | Bool | Gesture recognition active | Activates gesture evaluation. Gestures are defined using other properties.Only available if, in the group in the project properties, the Windows 8 property was entered. .
Gestures_CrossSlide | Bool | Cross slide | Active : Detection for Cross Slide set. .
Gestures_CrossSlideExact | Bool | Cross slide exact | Active : Detection for Cross Slide Exact set. .
Gestures_CrossSlideHorizontal | Bool | Cross slide horizontal | Active : Detection for Cross Slide Horizontal set. .
Gestures_CrossSlideRearrange | Bool | Cross slide rearrange | Active : Detection for Cross Slide Rearrange set. .
Gestures_CrossSlideSelect | Bool | Cross slide select | Active : Detection for Cross Slide Select set. .
Gestures_CrossSlideSpeedBump | Bool | Cross slide speed bump | Active : Detection for Cross Slide Speed Bump set. .
Gestures_Drag | Bool | Drag | Active : Detection for Drag set. .
Gestures_Exact | Bool | Exact | Active : Detection for Exact set. .
Gestures_Hold | Bool | Hold | Active : Detection for Hold set. .
Gestures_Manipulation | Bool | Manipulation | Active : Detection for Manipulation set. .
Gestures_RailsX | Bool | Rails X | Active : Detection for Rails X set. .
Gestures_RailsY | Bool | Rails Y | Active : Detection for Rails Y set. .
Gestures_Rotation | Bool | Rotation | Active : Detection for Rotation set. .
Gestures_RotationInertia | Bool | Rotation Inertia | Active : Detection for Rotation Inertia set. .
Gestures_Scaling | Bool | Scaling | Active : Detection for Scaling set. .
Gestures_ScalingInertia | Bool | Scaling inertia | Active : Detection for Scaling Inertia set. .
Gestures_SecondaryTap | Bool | Secondary tap | Active : Detection for Secondary Tap set. .
Gestures_Tap | Bool | Tap | Active : Detection for Tap set. .
Gestures_TapDouble | Bool | Tap double | Active : Detection for Tap Double set. .
Gestures_TranslationInertia | Bool | Translation inertia | Active : Detection for Translation Inertia set. .
Gestures_TranslationX | Bool | Translation X | Active : Detection for Translation X set. .
Gestures_TranslationY | Bool | Translation Y | Active : Detection for Translation Y set. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HelpCapture | String | Help chapter | Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page. Attention: This entry is case sensitive. .
Helpfile | String | Help file | Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog. Attention: . Only help files that have already been added to the files/help node are available. .
HorizontalAlign | Int16 | Alignment horizontal | Horizontal orientation of the value for the display. Selection from a drop-down list:Left Right Centered Default: Centered. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
HWDirect | Bool | without dialog | Active: The value is sent to the hardware without a possibility to be changed in the Runtime. Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware. .
Init | UInt32 | Init | VBA macro that is to be executed when initializing the element. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
IsSetValue | Bool | Write set value | Active: Setting of set values for this dynamic element is allowed.Inactive: The element is ReadOnly.Not available for the dynamic text element if it has been set to read only in the screen. .
KbdName | String | Screen Keyboard | Only available if property is active.Name of the linked keyboard screen. If no keyboard screen is entered, the respective corresponding keyboard is called up in Runtime:String variable: SETSTRINGKBD Numeric variable: SETVALUEKBD Binary variable: SETBOOLKBD Note: For the input field input option, no keyboard is called up if the option is activated. A keyboard screen must be linked. .
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
KillFocus | UInt32 | KillFocus | VBA macro that is to be executed when the element is no longer in focus. .
KnobColor | UInt32 | Knob color | Color of the knop. .
KnobStyle | Int16 | Knob type | Form of the button.Select from drop-down list:High Flat Sunken Default: Sunken . .
LassoSelect | Bool | selectable with lasso | Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.Active : The element can be selected with the lasso in the Runtime.Inactive : The element cannot be selected in the Runtime.Default: active Attention: For the element to be selectable in Runtime, you must activate the property in the project settings!Note for Command Processing: If the property issued, the lasso for the Execute 2nd stage must not be activated. .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
LeftClickDown | UInt32 | LeftClickDown | VBA macro that is to be executed when pressing the left mouse button on the element. .
LeftClickUp | UInt32 | LeftClickUp | VBA macro that is to be executed when releasing the left mouse button from the element. .
LeftDClick | UInt32 | LeftDClick | VBA macro that is to be executed when double clicking the left mouse button on the element. .
LeftFrame | Int16 | Left [pixels] | Distance between the left edge of the element and the graphic display (in pixels). .
LegendColor | UInt32 | Label color | Color of the key. .
LegendDistance | Int16 | Distance [pixels] | Distance between key and the scale (in pixels). .
LimitColor | Bool | Use limit value color | Defines whether the limit value color for the variable linked to the element is displayed in Runtime. The color has an effect on the text displayed, or in the indicator of a universal slider .Active : The defined limit value color is displayed in the Runtime.Default: active .
LimitFromVar | Bool | Take set value limits from variable | Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly. Inactive: The range can be limited directly in the "Minimum" and "Maximum". .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
Logarithmic | Bool | Logarithmic | Active: Logarithmic scaling Inactive: Linear scaling. .
MainTickColor | UInt32 | Main tick color | Color of the main ticks (number display) of the scaling. .
MainTicks | Int16 | Main ticks | Range for the main ticks (number display) of the scaling.Example: If you enter 50, a main tick is displayed every 50 units: 0 - 50 - 100 - 150 ... .
Max | double | Maximum | Upper limit of the permitted range for the set value. Only available if "Take set value limits from variable" is not active. Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum. .
MaxColor | UInt32 | Color maximum value | Color for displayed maximum. .
Menu | String | Context Menu | Context menu for the element. A click on the element with the right mouse button opens the context menu in Runtime. .
Min | double | Minimum | Bottom limit of the permitted range for the set value. Only available if Take set value limits from variable is not active: Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum. .
MinColor | UInt32 | Color minimum value | Color for displayed minimum. .
MinMaxShape | Int16 | Type of display | Graphic marking (drag indicator) for the minimum or maximum value by means of:Line Pointer Triangle .
MinMaxView | Bool | Show drag indicator | Activate minimum/maximum display drag indicator. .
MouseManipulationETM |  | Manipulation using mouse | Properties for changing the content of trends in Runtime with the mouse. .
MouseMovement | Bool | Set value during mouse-move | Active: Continuous sending of new values whilst the mouse is moved. Inactive: One-off sending of the new value if the mouse button is released. (only if the “direct to hardware” option is activated on the in the “Set value” section) .
MouseOver | UInt32 | MouseOver | VBA macro that is to be executed if the cursor is moved over the element. .
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PaddingStyle | Guid | Padding style | Display and selection of the padding style that is assigned to the element. .
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
Percentage | Bool | Show value in percent | Active: The value of the variable is displayed as 0 - 100% .Inactive: The value is displayed as usual.Range of values:Minimum measurement range: 0% Maximum measurement range 100% The conversion is linear. Setpoint inputs are also entered in percent. Default: Inactive .
Pointer | Int16 | Pointer type | Graphical marking of the current value with:Line Pointer Triangle .
PointerColor | UInt32 | Pointer/bar color | Color for the pointer or bar. .
Preset | Bool | propose current value | Active: The current value of the variable is proposed as set value. In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value). Inactive: The value defined in "Set value / amend" is proposed. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ReverseDirection | Bool | Reverse direction | Reverse display of minimum and maximum value .
RightClickDown | UInt32 | RightClickDown | VBA macro that is to be executed when pressing the right mouse button on the element. .
RightClickUp | UInt32 | RightClickUp | VBA macro that is to be executed when releasing the right mouse button from the element. .
RightDClick | UInt32 | RightDClick | VBA macro that is to be executed when double clicking the right mouse button on the element. .
RightFrame | Int16 | Right [pixels] | Distance between the right edge of the element and the graphic display (in pixels). .
ScaleDistance | Int16 | Distance [pixels] | Distance between scale and element (in pixels). .
ScaleHeight | Int16 | Height [pixels] | Height of the scale (in pixels). .
ScaleStyle | Guid | Scales style | Display and selection of the scale style that is assigned to the element. .
SetFocus | UInt32 | SetFocus | VBA macro that is to be executed when the element is in focus. .
SetProgram | String | External program | Only available if an external program was selected for Write set value : The set value is written by an external program that must be selected in the dialog box that appears here. This program is then started and gets the following parameters: 1) Name of the linked variable 2) Proposed value, as defined in the corresponding properties 3) Left coordinate of the element in pixels 4) Upper coordinate of the element in pixels 5) Right coordinate of the element in pixels 6) Lower coordinate of the element in pixels 7) Permitted minimum for the set value, as defined in the corresponding properties 8) Permitted maximum for the set value, as defined in the corresponding properties .
SetValue | double | Set value/change by | Value that should be sent as the set value or as a default. If "Propose current value" is active: : Value that is added to the current value. In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented. .
SetValueDynMax | CDynEleVar | Maximum | Variable whose current value is applicable as the upper set value limit for the element.Only available if is not active. .
SetValueDynMin | CDynEleVar | Minimum | Variable whose current value is applicable as the lower set value limit for the element. Only available if is not active: .
SetValueWith | SByte | Write set value via | Configuration of how the target value is set. Select from drop-down list:Command Processing: The new value is set using command processing . For input, the screen that is defined in the command group of the linked variable is opened.Standard dialog box : The new value is entered using the standard dialog box. If a screen of type "Keyboard " with name "SETVALUEKBD " (for numeric values) or "SETSTRINGKBD " (for string variables) exists, it is used instead of the standard dialog box. Note: If the element is linked to a function that allows inputs, is automated automatically. If a screen is linked in the property, this is used. Otherwise a SETSTRINGKBD keyboard is used.Element : The new value is directly entered in the element (only for the elements Numeric value and Text ).Program : The new value is entered in an external program. .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
Shape | Int16 | Shape | Linear : Display as bar or slider. Round : Display as pointer instrument .
ShowKnob | Bool | Show knob | An operating element is displayed with a button instead of the current value. .
ShowLeadingZeros | Bool | Show leading zeros | Only available if, for the property, either binary , decimal , hexadecimal or octal has been selected.Defines whether leading zeros are also to be displayed when displaying the numeric values.Inactive: Leading zeros are suppressed. Active : The numeric values are displayed with a different number of digits in accordance with their base. The digits which are not used by the numeric value are filled up with leading zeros. Default: Inactive The following parameters are available for the different bases:Binary: 32 digitsDecimal: 10 digitsHexadecimal: 8 digitsOctal: 11 digits .
ShowLegend | Bool | Show label | If activated, text (values) are displayed on the scale. .
ShowScale | Bool | Show scale | Active: A scale is shown in the element inactive: No scale is displayed. .
ShowState | Bool | Display status of variable | Graphical display of the status of the variable. Selection from a checkbox.Active: The status of the variables is indicated by a colored square at the element. Color : Red square: No communication with the PLC. Example: INVALID, OFF, ALT_VAL, REVISION, TIMEOUT, ...Blue square(N_UPDATE) : On the network client: The client has lost its connection to the Primary Server. With a standalone integration project: The Primary Server has not yet supplied the data.Yellow square (PR_NR) : Visualizes in Runtime that the variable has not been logged during replay in the Process Recorder . No value is therefore known in the playback.Position: The position of the square at the element depends on the element form:Angular and all other elements: Top right cornerRound element: Top, in the middle Rounded element : Top right corner, slightly offset to the left Inactive: The status is not shown. Also deactivates the display of additional variable information with a right click.Default: activated .
ShowTitle | Bool | Show title | Display title. .
ShowUnit | Bool | Show measuring unit | Only available: General: If property has been activated. For the Clock element: if Time difference was selected in the property . For the pointer instrument : if property was activated.Active: The unit of the linked variable is displayed to the right of the value. If the value is displayed in percent, the percent character % is displayed instaed of the unit of the linked variable. Inactive: The technical unit is not displayed. Default: active . Note: .
ShowValue | Bool | Show value | Additional display of the current value as number; Position in the element and font color can be defined .
ShowValueBasis | Bool | Show base | Only available if either binary , hexadecimal or octal has been selected for the property.Active : A short identification for the numbering basis is shown behind the value.The following short identifications are used for:Binary: b Decimal: (no short identification)Exponential: (no short identification)Hexadecimal: h Octal: o Default: active .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
SmallTickColor | UInt32 | Sub tick color | Color of the main ticks (no numerical display) in the scale. .
SmallTicks | Int16 | Sub ticks | Range for the subsidiary ticks (no number display) of the scaling. Example : The input 100 leads to the display of a subsidiary tick for each thousandth, starting with the smallest displayed value. .
Start | double | Start angle | Definition of the initial angle (0°=bottom center, continues further clockwise)Must be less than the .Only available for round form with universal slider: .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
Style | Int16 | Style | Type of display in Runtime. Select from drop-down list:Bar Moving scale Note: Values can only be amended in Runtime by means of a dialog. Changing a value using the slider directly is not possible.LED bar Slider/Turn-around .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextStyle | Guid | Text style |
TextStyle2 | Guid | Text style |
TitleColor | UInt32 | Title color | Text color for the title. .
TitleHorizontalAlign | Int16 | Alignment horizontal | Horizontal orientation of the title for the display. Selection from drop-down list:Left Right Centered Default: Centered. .
TitlePos | Int16 | Title position | Position for the title. .
TitleText | String | Title text | Text that is to be displayed as the title. .
TitleVerticalAlign | Int16 | Alignment vertical | Vertical orientation of the title for the display. Selection from a drop-down list:Top Bottom Centered Default: Centered. .
Tooltip | String | Tool tip | Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.Maximum: 79 character Attention: The character combination \n is also counted in the limit of 79 characters. .
TopFrame | Int16 | Top [pixels] | Distance between the upper edge of the element and the and the graphic display (in pixels). .
Transparent | Bool | Transparent | Settings for transparency.Active : Displays the element transparently.Default: Inactive The effect of this option on a button is an Invisible button . It can be positioned above other elements as an invisible button. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UnderCE | Bool | Visible under WinCE | Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).Active: The screen/element is also visible under Windows CE.Default: active .
UniversalSliderStyle | Guid | Universal slider style | Display and selection of the universal slider style that is assigned to the element. .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
ValueBase | UInt16 | Base for display | Selection of the numbering system for the display of the values. The following numbering systems are available:Binary : Binary display.Decimal : Decimal display.Exponential: Decimal display in exponential notation. Example: 1E+03 equals 1000 in decimal notation.Hexadecimal : Hexadecimal display.Octal : Octal display.Default: Decimal l .
ValueColor | UInt32 | Value color | Color for the value to be displayed. .
ValueDistance | Int16 | Distance [pixels] | Distance between title and value display (in pixels). .
ValuePos | Int16 | Value position | Position for the value to be displayed. .
ValueStyle | Guid | Value display style | Display and selection of the value display style that is assigned to the element. .
Variable | CDynEleVar | Variable | Name of the linked variable. Click on button ... in order to open the dialog for selecting variables. The value of this variable is displayed in this element and can also be set here.Note: Only available for buttons if they are used as a switch .Hint: If the variable value is to be toggled, we recommend activating the property. Only SICAM 230 and Screen Alarm element: The description above only applies to the elements Text Button, Bitmap Button and Invisible Button . Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).Lower bit: Alarm active/inactive Higher bit: Alarm acknowledged/not acknowledged .
VerticalAlign | Int16 | Alignment vertical | Vertical orientation of the value for the display. Selection from a drop-down list:Top Bottom Centered Default: Centered. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
ViewLimitFromVar | Bool | Apply display range from variables | Takes over the display area of the linked variable. You can update this display area during replacement with a variable with a different values range. .
ViewMax | double | Maximum | Highest variable value that is to be displayed in the element. .
ViewMin | double | Minimum | Lowest variable value that is to be displayed in the element. .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Universal slider [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CZenonGestureManipulation
ObjectModel COM [image] Element [image] DynProperties [image] Universal slider [image] CZenonGestureManipulation
Overview
External Name | Type | Display Name | Description
GestureManipulationGroup | Node | Manipulation | Properties for the manipulation of screens and screen elements with touch operation. .
GestureManipulationX | UInt32 | Move horizontally | Definition of the reaction to a gesture for horizontal movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationXY | UInt32 | Move | Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationY | UInt32 | Move vertically | Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured. .
GestureManipulationZoom | UInt32 | Zoom | Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured. .


Window
ObjectModel COM [image] Element [image] DynProperties [image] Window
Overview
External Name | Type | Display Name | Description
BackColor | UInt32 | Fill color | Only available if property is inactive.Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property from group . Note: As color for a newly created element the color which was used for the previous element of the same type is used. Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime. .
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
DragBegin | UInt32 | DragBegin | VBA macro that is to be executed when dragging starts. .
DragDrop | UInt32 | DragDrop | VBA macro that is to be executed when the mouse button is released. .
DragOver | UInt32 | DragOver | VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
Font | UInt16 | Font | Selection of the font that is used for display.A click on the ... button opens the selection dialog. The selected font is linked. .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
HorizontalOrigin | SByte | Horizontal | Horizontal reference point of the element. Possible values are: left, centered, right . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Left .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
KbdUsage | Bool | Use screen Keyboard | At selecting the element in the Runtime, the keyboard is called up. At selecting a free input field in the Runtime, the keyboard screen DIALOGKBD is called up if available. Default: active .
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Legend | String | Text | Label of the element in the Editor. .
LineColorVariable | CDynEleVar | Line color | Name of the variables whose limit value colors should influence the line/text color of the element. Click on the ... button to open the dialog for selecting a variable. .
LineColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
ShortCut | String | Key combination | Shortcuts support executing operable elements. For example:- Executing control elements and functions which have an element assigned - Write set value (e.g. for switches) - Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly. .
ShowBorder | Bool | Show border lines | Visualizes a border for certain elements when displayed in Runtime. The configuration of the and properties is no longer taken into account for the display in Runtime as a result.Active : The element is shown in Runtime with a border.Inactive: No border when displayed in Runtime.Default: inactive. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleH | UInt16 | Style H | Windows style of the element, for internal use only. .
StyleL | UInt16 | Style L | Windows style of the element, for internal use only. .
Tab | Bool | Focus is set to the element | Active: The dynamic element can be operated using the keyboard. inactive: The dynamic element cannot be accessed using the keyboard. Default: avtive. .
TABOrderH | Int32 | Focus position left/right | Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here..
TABOrderV | Int32 | Focus position top/bottom | Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here. .
TextColor | UInt32 | Text color | Text color of the element. .
TranslateText | Bool | Translate display text | Active : The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.Default: Inactive .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
TwistVariable | CDynEleVar | Variable | Name of the variable for rotating the element. .
TwistVarMax | double | Max. variable value | Maximum variable value for rotating the element. .
TwistVarMin | double | Min. variable value | Minimum variable value for rotating the element. .
TwistViewMax | Int32 | Max. rotation [°] | Rotation angle of the element for the maximum variable value (in °). .
TwistViewMin | Int32 | Min. rotation [°] | Rotation angle of the element for the minimum variable value (in °). .
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VerticalOrigin | SByte | Vertical | Vertical reference point of the element. Possible values are: top, centered, bottom . This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.Default: Top .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVariable | CDynEleVar | Variable | Name of the variable for the horizontal movement of the element. Opens the dialog for selecting variables. .
XVarMax | double | Max. variable value | Maximum variable value for the horizontal movement of the element. .
XVarMin | double | Min. variable value | Minimum variable value for the horizontal movement of the element. .
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
XViewMax | Int32 | Max. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XViewMin | Int32 | Min. movement [pixels] | Horizontal position of the element for minimum variable value (in pixels). .
XZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the width of the element. Opens the dialog for selecting variables. .
XZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the width of the element. .
XZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the width of the element. .
XZoomViewMax | Int32 | Max. width [%] | Zoom factor of the width of the element for the maximum variable value (in %). .
XZoomViewMin | Int32 | Min. width [%] | Zoom factor of the width of the element for the minimum variable value (in %). .
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVariable | CDynEleVar | Variable | Name of the variable for the vertical movement of the element. Open the dialog for selecting variables. .
YVarMax | double | Max. variable value | Maximum variable value for the vertical movement of the element. .
YVarMin | double | Min. variable value | Minimum variable value for the vertical movement of the element. .
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
YViewMax | Int32 | Max. movement [pixels] | Vertical position of the element for maximum variable value (in pixels). .
YViewMin | Int32 | Min. movement [pixels] | Vertical position of the element for minimum variable value (in pixels). .
YZoomVariable | CDynEleVar | Variable | Name of the variable for the zooming of the height of the element. Opens the dialog for selecting variables. .
YZoomVarMax | double | Max. variable value | Maximum variable value for the zooming of the height of the element. .
YZoomVarMin | double | Min. variable value | Minimum variable value for the zooming of the height of the element. .
YZoomViewMax | Int32 | Max. height [%] | Zoom factor of the height of the element for the maximum variable value (in %). .
YZoomViewMin | Int32 | Min. height [%] | Zoom factor of the height of the element for the minimum variable value (in %). .
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] Window [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


WPF element
ObjectModel COM [image] Element [image] DynProperties [image] WPF element
Overview
External Name | Type | Display Name | Description
BackColorVariable | CDynEleVar | Fill color | Name of the variable whose limit value colors should influence the background/fill color of the element. Opens the dialog for selecting variables. .
BackColorVarPreview | UInt32 | Show color preview | Display of the limit value for defined for the variable. Only available if, for the property, a variable has been configured. .
BkCl2Variable | Node | BkCl2Variable | Node
BkClVariable | Node | BkClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"
BlinkVar | Node | BlinkVar | Node
BlinkVariable | CDynEleVar | Adopt flashing from limit value | Variable that contains the configuration of the flashing behavior for the display of the element in zenon Runtime. The parameters for the flashing behavior are set in the configuration of the limit value for the linked variable.Click on button ... in order to open the dialog for selecting variables.In contrast to the normal flashing, the whole element flashes and not only the displayed value. .
BlinkVarPreview | UInt32 | Show flash preview | Display of the limit value for flashing defined for the variable. Only available if a variable has been linked in the property. .
EnablePunchFrame | Bool | Show border | A frame around the element can be displayed. Default: inactive.
EndX | Int32 | End point X [pixels] | X coordinates of the lower right corner points of the element (in pixels). .
EndY | Int32 | End point Y [pixels] | Y coordinates of the lower right corner points of the element (in pixels). .
FileName | String | XAML file | Selection of the XAML file for the WPF element. Click on ... Opens the dialog for selection. The file must already have been created in the project manager under File/Graphics or selected in the dialog with the help of the symbol Add file . .
GlowEffect2ndBlinkStateVisible | Bool | Make 2. flash state invisible | In addition you must define a variable in property and property must be inactive.Active : At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit value is possible.Default: Inactive .
GlowEffectActive | Bool | Activate | The project property must not be active. Availability also depends on the graphical element.Active : Glow effect is used for the element.Inactive: No glow effect for the element.Default: Inactive .
GlowEffectAlpha | SByte | Transparency [%] | Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.Minimum: 0% , opaqueMaximum: 100% , fully opaqueDefault: 20% .
GlowEffectBlinkVar | Node | GlowEffectBlinkVar | Node
GlowEffectBlinkVariable | CDynEleVar | Variable for flashing | Variable from whose limit value(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.Default: no variable linked .
GlowEffectBlinkVariablePreview | UInt32 | Show flash preview | Display of the limit value defined for the flash variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectColor | UInt32 | Color | The property must be activated.Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.Default: 0xFFFF90 (yellow) .
GlowEffectEvent | Bool | Active if clicked only | Only available of property is active and if the element is a button.Active : The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.Default: Inactive .
GlowEffectGlowColorVar | Node | GlowEffectGlowColorVar | Node
GlowEffectGlowColorVariable | CDynEleVar | Variable for color | The property must be activated.Name of the variable whose limit value color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property is used.Default: no variable linked .
GlowEffectGlowColorVariablePreview | UInt32 | Show color preview | Display of the limit value defined for the color variable when glowing. Only available if, for the property, a variable has been configured. .
GlowEffectSpread | SByte | Spread [pixel] | Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.Minimum: 0 , no expansionMaximum: 50 Default: 15 .
GlowEffectStyle | Guid | Glow effect style | Display and selection of the style for glow effects that are assigned to the element. .
GlowEffectUseBlinkColor | Bool | Adopt flashing color from limit value | In addition you must define a variable in property .Active : Takes over the color for the glow effect from the flashing from the active limit value of the variable defined in property . This property acts independent of property . At flashing the glow effect does not toggle to invisible but to the active glow effect.Default: Inactive .
GlowEffectUseColor | Bool | Coloring | Active : The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property or via a variable defined in proeprty . If both properties are active, the color from property is used.Inactive : The color of the element is used for the glow effect.Default: Inactive .
GlowEffectVisibilityFrom | double | Visible from | In addition you must define a variable in property and property must be inactive.Defines the value from which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : lowest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityFromLimit | Bool | Adopt visibility from limit value | In addition you must define a variable in property .Active : The visibility of the glow effect is influenced by the limit value property of the variable.Attention: At least for one limit value of the variable property must be active.Inactive : The visibility is influenced by the properties of the element. .
GlowEffectVisibilityTo | double | Visible to | In addition you must define a variable in property and property must be inactive.Defines the value until which the glow effect is visible. Minimum : lowest possible value for the variable linked in . Maximum : highest possible value for the variable linked in . Default : highest possible value for the variable linked in . .
GlowEffectVisibilityVar | Node | GlowEffectVisibilityVar | Node
GlowEffectVisibilityVariable | CDynEleVar | Variable for visibility | Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit value properties of this variable (property active) or defined by the value range which is defined in properties and . Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.Note: If no variable is linked, the glow effect is always visible.Default: no variable linked .
GlowEffectVisibilityVariablePreview | UInt32 | Display visibility preview | Display of the limit value defined for the visibility variable when glowing. Only available if, for the property, a variable has been configured. .
Height | Int32 | Height [pixels] | Height of the elements (in pixels).Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
Interlocking | UInt32 | Interlocking | Only available if, for the property, from interlocking has been selected.Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked..
InterlockingName | String | InterlockingName | Description
Layer | SByte | Visibility level | Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the toolbarVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime. Default: 0 . .
Links | Node | Links | Node
LinksConfig | String | Configuration | Opens the dialog for configuring the XAML file. Properties, events, transformations and authorizations can be allocated. .
LnClVariable | Node | LnClVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"
Locking | UInt32 | Interlocking | Link to an existing interlocking to this element.If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project. .
LockingName | String | LockingName | "With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""
Name | String | Element name | Assign an element name. This must not be empty.Attention: This property is not available for language switch.Note on faceplates: For screen containers , issue clearly distinguishable names for clear selection when configuring screen switching. .
Passwordlevel | UInt16 | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0 Maximum: 127 Default: 0 .
PunchFrameAlpha | SByte | Transparency [%] | Shadow must be selected as a .States the transparency of the shadow between 0 and 100% .0 : opaque100 : transparentDefault: 60 .
PunchFrameAngle | Int16 | Angle [°] | Shadow must be selected as a .Angle in degrees in which the shadow is offset.Values: 0° to 359° . 0° corresponds to the extreme right position (3 o' clock) and is continued anticlockwise.Default: 315° A click on button ... opens a slider. .
PunchFrameColor | UInt32 | Border/shadow color | Only available if you selected Frame of Shadow at option .Definition of the color of frame or shadow. .
PunchFrameOffset | UInt16 | Distance [pixels] | Only available if you selected frames or shadow at property .Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property . The size of the range depends on the monitor resolution. Default: 10 .
PunchFrameSize | Int32 | Shadow size [%] | Shadow must be selected as .Value in pixel which defines the size of the shadow independently.The size of the range depends on the monitor resolution.Positive value: Shadow is larger than the elementNegative value: Shadow is smaller than the elementDefault: 100 .
PunchFrameSoftFocus | SByte | Blur | Shadow must be selected as a .Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.Values: 0 to 50 0 : No blurring50 : Maximum blurringDefault: 0 Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected. .
PunchFrameType | SByte | Border type | Drop-down list for the selection of the frame type. The following are available:No frame/shadow: No frame and no shadow is displayed.Frame:Frame: The element can be provided with a frame.Shadow: The element can be provided with a shadowframe. ( ) Exception: Some elements cannot obtain shadows.Default: No border/shadow .
PunchFrameWidth | UInt16 | Line width [Pixel] | Definition of the line width of the frame in pixel.Default: 1 .
ShadowEffectStyle | Guid | Borders/shadows effect style | Display and selection of the style for framing and shading that is assigned to the element. .
StartX | Int32 | Start point X [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
StartY | Int32 | Start point Y [pixels] | Y coordinates of the upper left corner points of the element (in pixels). .
Stationname | String | Name for object list | The element is entered in the station list of the worldview screen with the text entered here. .
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
Transparent | Bool | Transparent | Settings for transparency.Active : Displays the element transparently.Default: Inactive The effect of this option on a button is an Invisible button . It can be positioned above other elements as an invisible button. .
TwistVar | Node | TwistVar | "With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"
UseBlinkColor | Bool | Flashing color from limit value | Color of the screen element when visualizing the flashing in zenon Runtime.Active: Takes over the background color of the flashing from the active limit value of the variable for . Element changes during flashing not to invisible but to the active background color.Inactive : Screen element flashes without taking on the color of the limit value configuration.Default: Inactive Note: The color is not taken into consideration if the background color is configured. .
VisibilityFrom | double | from | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Lowest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: smallest possible value of the linked variable. .
VisibilityFromLimit | Bool | adopt from limit value | Only available after you have selected a variable:Active: The visibility of the element is influenced by the limit value property of the variable.Attention: The property must be active for at least one limit value of the variable.Inactive: The visibility is influenced by the properties of the element.Default: active .
VisibilityTo | double | to | Only available after a variable has been selected and if the visibility has not been taken on by the limit value:Highest value of the variable where the element is visible.Minimum: smallest possible value of the linked variable.Maximum: highest possible value of the linked variable.Default: highest possible value of the linked variable. .
VisibilityType | UInt32 | Visibility | Selection from which the visibility of an element is determined:From variable From interlocking Default: From variable .
VisibilityVariable | CDynEleVar | Variable | Only available if, for the property, from variable has been configured.Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit value properties of these variables or defined by the value range that is defined in the and properties. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. The element is always visible if no variable is linked..
VisibleWhenInterlocked | Bool | Visible if interlocked | Controls visibility of the element if interlocking is selected:Active : Element is visible if it is interlocked.Inactive : Element is visible if it is not interlocked.Default: Inactive .
VisVariable | Node | VisVariable | "With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"
VisVarPreview | UInt32 | Display visibility preview | Display of the limit value for visibility defined for the variable. Only available if, for the property in the group, a variable has been configured. .
Width | Int32 | Width [pixels] | Width of the elements in pixels.Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the property. .
XVar | Node | XVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"
XVarZoom | Node | XVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"
YVar | Node | YVar | "With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"
YVarZoom | Node | YVarZoom | "With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element. The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr. zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"
ZoomMax | Int16 | Visible to | Highest zoom steps in which the element is visible in the world view.Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .
ZoomMin | Int16 | Visible from | Lowest zoom steps in which the element is visible in the worldview. Default: -1 Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.The zoom levels that are displayed in the worldview are configured using the -> -> project property.Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0 , the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0 . .


CDynEleVar
ObjectModel COM [image] Element [image] DynProperties [image] WPF element [image] CDynEleVar
Overview
External Name | Type | Display Name | Description
ProjectVar | CProjektVariable | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
SymVarName | String | SymVarName | This property returns the name of a variable.
SymVarTagNr | String | SymVarTagNr | This property returns the identification of a variable.


CWPFConnectionBase
ObjectModel COM [image] Element [image] DynProperties [image] WPF element [image] CWPFConnectionBase
Overview
External Name | Type | Display Name | Description
Element | String | Element name |
Link | String | Linkage |


Elements
ObjectModel COM [image] Elements
Remarks

This collection contains the defined dynamic elements of a Screen.The single dynamic elements contain the most important properties, e.g. type, position, color, ...The single dynamic elements can be found in the collection by their unique name or by the index.Hint for older Versions:Giving a name to a dynamic element is optional.If a dynamic element has no name, it is not found under certain circumstances.So the result of the method Item should always be checked on Nothing / null.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
//Reads all elements of a (defined) screen
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.ActiveDocument.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}

//Print all the element names on the start screen to the debugger output
public void MacroElements()
{

    IElements zenonElements = GetElementsOnScreen("Start");
    for (int i = 0; i < zenonElements.Count; ++i)
    {
        System.Diagnostics.Debug.Print(zenonElements.Item(i).Name);
    }
}
VB.NET
Copy
'Reads all elements of a (defined) screen
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.ActiveDocument.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function

'Print all the element names on the start screen to the debugger output
Public Sub MacroElements()

    Dim zenonElements As IElements = GetElementsOnScreen("Start")
    For i As Integer = 0 To zenonElements.Count - 1
        System.Diagnostics.Debug.Print(zenonElements.Item(i).Name)
    Next
End Sub


Properties
ObjectModel COM [image] Elements [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns count of the elements | Readonly | Readonly | Available | Available
Parent | idynpicture | The parent object of the current object | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] Elements [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Elements [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IDynPicture

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Elements [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | ielement | Creates and returns a new Object | Available | Unused | Available | Available
Delete | variant_bool | Deletes the objects from collection | Available | Unused | Available | Available
Item | ielement | Returns a object at a position or by a specified key | Available | Available | Available | Available
ItemById | ielement | Returns a object with the given Id | Available | Available | Available | Available


Create
ObjectModel COM [image] Elements [image] Methods [image] Create
Remarks

Creates a new "Element" object by its name as string and its "Element" type.

Datatype
IElement

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

tpType as tpElementTypes

Example
C#
Copy
//Reads all elements of a (defined) screen
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.ActiveDocument.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}

//Adds a new Button element to the start screen
public void MacroAddElement()
{
    IElements zenonElements = GetElementsOnScreen("Start");

    //Create a new element on the elements list for dynPicture "Start"
    zenonElements.Create("my_test_element", tpElementTypes.tpDynButton);

    //Set some properties of the new element
    zenonElements.Item("my_test_element").Width = 200;
    zenonElements.Item("my_test_element").Height = 200;
}
VB.NET
Copy
'Reads all elements of a (defined) screen
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.ActiveDocument.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function

'Adds a new Button element to the start screen
Public Sub MacroAddElement()
    Dim zenonElements As IElements = GetElementsOnScreen("Start")

    'Create a new element on the elements list for dynPicture "Start"
    zenonElements.Create("my_test_element", tpElementTypes.tpDynButton)

    'Set some properties of the new element
    zenonElements.Item("my_test_element").Width = 200
    zenonElements.Item("my_test_element").Height = 200
End Sub


Delete
ObjectModel COM [image] Elements [image] Methods [image] Delete
Remarks

Deletes an existing "Element" object by its name as string.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
nElemId as BSTR

Example
C#
Copy
//Reads all elements of a (defined) screen
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.ActiveDocument.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}

public void MacroDeleteElement()
{
    IElements zenonElements = GetElementsOnScreen("Start");

    //Delete an element of the list we got
    zenonElements.Delete("my_test_element");
}
VB.NET
Copy
'Reads all elements of a (defined) screen
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.ActiveDocument.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function

Public Sub MacroDeleteElement()
    Dim zenonElements As IElements = GetElementsOnScreen("Start")

    'Delete an element of the list we got
    zenonElements.Delete("my_test_element")
End Sub


Item
ObjectModel COM [image] Elements [image] Methods [image] Item
Remarks

Returns the object Element from the collection, which is identified by the parameter vID. The parameter vID can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • Element name: The element can also be accessed with its unique name.
Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IElement

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT

Example
C#
Copy
//Reads all elements of a (defined) screen
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.ActiveDocument.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}

//Print all the element names on the start screen to the debugger output
public void MacroElements()
{

    IElements zenonElements = GetElementsOnScreen("Start");
    for (int i = 0; i < zenonElements.Count; ++i)
    {
        System.Diagnostics.Debug.Print(zenonElements.Item(i).Name);
    }
}
VB.NET
Copy
'Reads all elements of a (defined) screen
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.ActiveDocument.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function

'Print all the element names on the start screen to the debugger output
Public Sub MacroElements()

    Dim zenonElements As IElements = GetElementsOnScreen("Start")
    For i As Integer = 0 To zenonElements.Count - 1
        System.Diagnostics.Debug.Print(zenonElements.Item(i).Name)
    Next
End Sub


ItemById
ObjectModel COM [image] Elements [image] Methods [image] ItemById
Remarks

Returns an element object which is identified by its unique (one based) ID.

Datatype
IElement

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vElementID as VARIANT

Example
C#
Copy
//Reads all elements of a (defined) screen
public IElements GetElementsOnScreen(string screenName)
{
    IDynPicture zenonChosenScreen = this.ActiveDocument.DynPictures().Item(screenName);
    if (zenonChosenScreen == null)
        return null;
    return zenonChosenScreen.Elements();
}

//Print all the element names on the start screen to the debugger output
public void MacroElementsById()
{
    IElements zenonElements = GetElementsOnScreen("Start");

    //Gets the element with unique identifier "5" of the picture "start"
    IElement zenonUniqueElement = zenonElements.ItemById(5);
    //Prints the name of the element to check if we got the right one
    System.Diagnostics.Debug.Print(zenonUniqueElement.Name);
}
VB.NET
Copy
'Reads all elements of a (defined) screen
Public Function GetElementsOnScreen(screenName As String) As IElements
    Dim zenonChosenScreen As IDynPicture = Me.ActiveDocument.DynPictures().Item(screenName)
    If zenonChosenScreen Is Nothing Then
        Return Nothing
    End If
    Return zenonChosenScreen.Elements()
End Function

'Print all the element names on the start screen to the debugger output
Public Sub MacroElementsById()
    Dim zenonElements As IElements = GetElementsOnScreen("Start")

    'Gets the element with unique identifier "5" of the picture "start"
    Dim zenonUniqueElement As IElement = zenonElements.ItemById(5)
    'Prints the name of the element to check if we got the right one
    System.Diagnostics.Debug.Print(zenonUniqueElement.Name)
End Sub


FileManager
ObjectModel COM [image] FileManager
Remarks

This collection represents the directories and files of the files node.The following Enumerators are supported for the FileManager:

Name | Value | Correspondent directory/zenon module
tpPathBMP | 2 | Files - Graphics
tpPathList | 4 | Files - Texts and Formats
tpPathMedia | 5 | Files - Multimedia
tpPathReport | 6 | Report Generator files (*.xrs)
tpPathLanguage | 9 | Language Table files
tpPathHelp | 10 | Files - Help
tpPathDrivers | 15 | Files - Driver
tpPathAdditional | 17 | Files - Additional
tpPathRDLC | 18 | Files - Report Viewer (*.rdl)

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage);
    //Add a language file
    zenonFolder.AddItem(@"C:\Language_Tables\English.txt");
}
VB.NET
Copy
'Gets the current file manager and uses it to add a new language file
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage)
    'Add a language file
    zenonFolder.AddItem("C:\Language_Tables\English.txt")
End Sub
VBA
Copy
Sub FileManager()
Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Object from type

FileManagerFolder
'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager
'Set the folder for the language tables
Set zFileManagerFolder =
      zFileManager.FolderItem(zenOn.tpModulePaths.tpPathLanguage)
'Add a new item
zFileManagerFolder.AddItem ("C:\Language_Tables\English.txt")

End Sub


Properties
ObjectModel COM [image] FileManager [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Parent | iproject | Returns the parent of the FileManager Object. | Readonly | Readonly | Available | Available


Parent
ObjectModel COM [image] FileManager [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] FileManager [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
FolderItem | ifilemanagerfolder | Returns the folder object for the given folder. | Available | Unused | Available | Available


FolderItem
ObjectModel COM [image] FileManager [image] Methods [image] FolderItem
Remarks

Returns a FileManagerFolder object corresponding the path given in this method. The path is a constant specified in the FileManager Table:

Name | Value | Correspondent directory/zenon module
tpPathBMP | 2 | Files - Graphics
tpPathList | 4 | Files - Texts and Formats
tpPathMedia | 5 | Files - Multimedia
tpPathReport | 6 | Report Generator files (*.xrs)
tpPathLanguage | 9 | Language Table files
tpPathHelp | 10 | Files - Help
tpPathDrivers | 15 | Files - Driver
tpPathAdditional | 17 | Files - Additional
tpPathRDLC | 18 | Files - Report Viewer (*.rdl)

Datatype
IFileManagerFolder

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lModule as tpModulePaths

A constant which defines the specific folder.

Example
C#
Copy
//Gets the current file manager and uses it to add a new language file
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage);
    //Add a language file
    zenonFolder.AddItem(@"C:\Language_Tables\English.txt");
}
VB.NET
Copy
'Gets the current file manager and uses it to add a new language file
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage)
    'Add a language file
    zenonFolder.AddItem("C:\Language_Tables\English.txt")
End Sub
VBA
Copy
Sub FolderItem()
Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Object from type

FileManagerFolder
'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager
'Read the "language list"
Set zFileManagerFolder = zFileManager.FolderItem(9)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Language_Tables\English.txt")
'Read the "graphics list"
Set zFileManagerFolder = zFileManager.FolderItem(2)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Graphics\zenOn_Logo.jpg")
'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Help\help.chm")
'Read the "multimedia list"
Set zFileManagerFolder = zFileManager.FolderItem(5)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Media\intro.wav")
'Read the "lists list"
Set zFileManagerFolder = zFileManager.FolderItem(4)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Lists\List.doc")
'Read the "drivers list"
Set zFileManagerFolder = zFileManager.FolderItem(15)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Drivers\driver.exe")
'Read the "others list"
Set zFileManagerFolder = zFileManager.FolderItem(17)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Others\infos.pdf")

End Sub


FileManagerFileItem
ObjectModel COM [image] FileManagerFileItem
Remarks

This collection makes it possible to manage the files in a list.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
//Gets the current file manager and loops through all the files in the language directory
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage);

    //Loop through all the files and print the names on the debug window
    for (int i = 0; i < zenonFolder.FileCount; ++i)
    {
        System.Diagnostics.Debug.Print(zenonFolder.FileItem(i).FileName);
    }
}
VB.NET
Copy
'Gets the current file manager and loops through all the files in the language directory
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage)

    'Loop through all the files and print the names on the debug window
    For i As Integer = 0 To zenonFolder.FileCount - 1
        System.Diagnostics.Debug.Print(zenonFolder.FileItem(i).FileName)
    Next
End Sub
VBA
Copy
Sub FileItem()
Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type

FileManager
Dim zFileManagerItem As FileManagerFileItem 'Child object from type

FileManagerFolder
'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager
'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Read the first file in the list
Set zFileManagerItem = zFileManagerFolder.FileItem(0)
'Returns the filename of the file in the list
Debug.Print "Filename = " & zFileManagerItem.FileName

End Sub


Properties
ObjectModel COM [image] FileManagerFileItem [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
FileName | bstr | Returns the name of the File. | Available | Readonly | Available | Available


FileName
ObjectModel COM [image] FileManagerFileItem [image] Properties [image] FileName
Remarks

Returns the filename of the selected file.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] FileManagerFileItem [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


CheckIn
ObjectModel COM [image] FileManagerFileItem [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
//Gets the current file manager and uses multiuser methods to edit files
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage);

    //Get the first item in the directory to work with
    IFileManagerFileItem zenonFileItem = zenonFolder.FileItem(0);

    if (!zenonFileItem.IsCheckedOut())
    {
        if (zenonFileItem.CheckOut())
        {
            //The File was checked out by the user who executed this macro
            if (zenonFileItem.Get())
            {
                //Got the latest version of the File
                //Edit some properties of the File
                zenonFileItem.FileName = "NewFileName";

                //Check in the file again so others can check it out
                zenonFileItem.CheckIn();

            }
            else
            {
                zenonFileItem.UndoCheckOut();
                //The latest version could not be received, undo the checkout
            }
        }
        else
        {
            //The File can't currently be checked out
        }
    }
    else
    {
        //Someone else has the File checked out!
    }
}
VB.NET
Copy
'Gets the current file manager and uses multiuser methods to edit files
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage)

    'Get the first item in the directory to work with
    Dim zenonFileItem As IFileManagerFileItem = zenonFolder.FileItem(0)

    If Not zenonFileItem.IsCheckedOut() Then
        If zenonFileItem.CheckOut() Then
            'The File was checked out by the user who executed this macro
            If zenonFileItem.[Get]() Then
                'Got the latest version of the File
                'Edit some properties of the File
                zenonFileItem.FileName = "NewFileName"

                'Check in the file again so others can check it out

                zenonFileItem.CheckIn()
            Else
                    'The latest version could not be received, undo the checkout
                zenonFileItem.UndoCheckOut()
            End If
                'The File can't currently be checked out
        Else
        End If
            'Someone else has the File checked out!
    Else
    End If
End Sub


CheckOut
ObjectModel COM [image] FileManagerFileItem [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
//Gets the current file manager and uses multiuser methods to edit files
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage);

    //Get the first item in the directory to work with
    IFileManagerFileItem zenonFileItem = zenonFolder.FileItem(0);

    if (!zenonFileItem.IsCheckedOut())
    {
        if (zenonFileItem.CheckOut())
        {
            //The File was checked out by the user who executed this macro
            if (zenonFileItem.Get())
            {
                //Got the latest version of the File
                //Edit some properties of the File
                zenonFileItem.FileName = "NewFileName";

                //Check in the file again so others can check it out
                zenonFileItem.CheckIn();

            }
            else
            {
                zenonFileItem.UndoCheckOut();
                //The latest version could not be received, undo the checkout
            }
        }
        else
        {
            //The File can't currently be checked out
        }
    }
    else
    {
        //Someone else has the File checked out!
    }
}
VB.NET
Copy
'Gets the current file manager and uses multiuser methods to edit files
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage)

    'Get the first item in the directory to work with
    Dim zenonFileItem As IFileManagerFileItem = zenonFolder.FileItem(0)

    If Not zenonFileItem.IsCheckedOut() Then
        If zenonFileItem.CheckOut() Then
            'The File was checked out by the user who executed this macro
            If zenonFileItem.[Get]() Then
                'Got the latest version of the File
                'Edit some properties of the File
                zenonFileItem.FileName = "NewFileName"

                'Check in the file again so others can check it out

                zenonFileItem.CheckIn()
            Else
                    'The latest version could not be received, undo the checkout
                zenonFileItem.UndoCheckOut()
            End If
                'The File can't currently be checked out
        Else
        End If
            'Someone else has the File checked out!
    Else
    End If
End Sub


Get
ObjectModel COM [image] FileManagerFileItem [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
//Gets the current file manager and uses multiuser methods to edit files
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage);

    //Get the first item in the directory to work with
    IFileManagerFileItem zenonFileItem = zenonFolder.FileItem(0);

    if (!zenonFileItem.IsCheckedOut())
    {
        if (zenonFileItem.CheckOut())
        {
            //The File was checked out by the user who executed this macro
            if (zenonFileItem.Get())
            {
                //Got the latest version of the File
                //Edit some properties of the File
                zenonFileItem.FileName = "NewFileName";

                //Check in the file again so others can check it out
                zenonFileItem.CheckIn();

            }
            else
            {
                zenonFileItem.UndoCheckOut();
                //The latest version could not be received, undo the checkout
            }
        }
        else
        {
            //The File can't currently be checked out
        }
    }
    else
    {
        //Someone else has the File checked out!
    }
}
VB.NET
Copy
'Gets the current file manager and uses multiuser methods to edit files
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage)

    'Get the first item in the directory to work with
    Dim zenonFileItem As IFileManagerFileItem = zenonFolder.FileItem(0)

    If Not zenonFileItem.IsCheckedOut() Then
        If zenonFileItem.CheckOut() Then
            'The File was checked out by the user who executed this macro
            If zenonFileItem.[Get]() Then
                'Got the latest version of the File
                'Edit some properties of the File
                zenonFileItem.FileName = "NewFileName"

                'Check in the file again so others can check it out

                zenonFileItem.CheckIn()
            Else
                    'The latest version could not be received, undo the checkout
                zenonFileItem.UndoCheckOut()
            End If
                'The File can't currently be checked out
        Else
        End If
            'Someone else has the File checked out!
    Else
    End If
End Sub


IsCheckedOut
ObjectModel COM [image] FileManagerFileItem [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
//Gets the current file manager and uses multiuser methods to edit files
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage);

    //Get the first item in the directory to work with
    IFileManagerFileItem zenonFileItem = zenonFolder.FileItem(0);

    if (!zenonFileItem.IsCheckedOut())
    {
        if (zenonFileItem.CheckOut())
        {
            //The File was checked out by the user who executed this macro
            if (zenonFileItem.Get())
            {
                //Got the latest version of the File
                //Edit some properties of the File
                zenonFileItem.FileName = "NewFileName";

                //Check in the file again so others can check it out
                zenonFileItem.CheckIn();

            }
            else
            {
                zenonFileItem.UndoCheckOut();
                //The latest version could not be received, undo the checkout
            }
        }
        else
        {
            //The File can't currently be checked out
        }
    }
    else
    {
        //Someone else has the File checked out!
    }
}
VB.NET
Copy
'Gets the current file manager and uses multiuser methods to edit files
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage)

    'Get the first item in the directory to work with
    Dim zenonFileItem As IFileManagerFileItem = zenonFolder.FileItem(0)

    If Not zenonFileItem.IsCheckedOut() Then
        If zenonFileItem.CheckOut() Then
            'The File was checked out by the user who executed this macro
            If zenonFileItem.[Get]() Then
                'Got the latest version of the File
                'Edit some properties of the File
                zenonFileItem.FileName = "NewFileName"

                'Check in the file again so others can check it out

                zenonFileItem.CheckIn()
            Else
                    'The latest version could not be received, undo the checkout
                zenonFileItem.UndoCheckOut()
            End If
                'The File can't currently be checked out
        Else
        End If
            'Someone else has the File checked out!
    Else
    End If
End Sub


IsDifferent
ObjectModel COM [image] FileManagerFileItem [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
//Gets the current file manager and uses multiuser methods to edit files
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage);

    //Get the first item in the directory to work with
    IFileManagerFileItem zenonFileItem = zenonFolder.FileItem(0);

    if (!zenonFileItem.IsCheckedOut())
    {
        if (zenonFileItem.CheckOut())
        {
            //The File was checked out by the user who executed this macro
            if (zenonFileItem.Get())
            {
                //Got the latest version of the File
                //Edit some properties of the File
                zenonFileItem.FileName = "NewFileName";

                //Check in the file again so others can check it out
                zenonFileItem.CheckIn();

            }
            else
            {
                zenonFileItem.UndoCheckOut();
                //The latest version could not be received, undo the checkout
            }
        }
        else
        {
            //The File can't currently be checked out
        }
    }
    else
    {
        //Someone else has the File checked out!
    }
}
VB.NET
Copy
'Gets the current file manager and uses multiuser methods to edit files
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage)

    'Get the first item in the directory to work with
    Dim zenonFileItem As IFileManagerFileItem = zenonFolder.FileItem(0)

    If Not zenonFileItem.IsCheckedOut() Then
        If zenonFileItem.CheckOut() Then
            'The File was checked out by the user who executed this macro
            If zenonFileItem.[Get]() Then
                'Got the latest version of the File
                'Edit some properties of the File
                zenonFileItem.FileName = "NewFileName"

                'Check in the file again so others can check it out

                zenonFileItem.CheckIn()
            Else
                    'The latest version could not be received, undo the checkout
                zenonFileItem.UndoCheckOut()
            End If
                'The File can't currently be checked out
        Else
        End If
            'Someone else has the File checked out!
    Else
    End If
End Sub


IsLocked
ObjectModel COM [image] FileManagerFileItem [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
//Gets the current file manager and uses multiuser methods to edit files
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage);

    //Get the first item in the directory to work with
    IFileManagerFileItem zenonFileItem = zenonFolder.FileItem(0);

    if (!zenonFileItem.IsCheckedOut())
    {
        if (zenonFileItem.CheckOut())
        {
            //The File was checked out by the user who executed this macro
            if (zenonFileItem.Get())
            {
                //Got the latest version of the File
                //Edit some properties of the File
                zenonFileItem.FileName = "NewFileName";

                //Check in the file again so others can check it out
                zenonFileItem.CheckIn();

            }
            else
            {
                zenonFileItem.UndoCheckOut();
                //The latest version could not be received, undo the checkout
            }
        }
        else
        {
            //The File can't currently be checked out
        }
    }
    else
    {
        //Someone else has the File checked out!
    }
}
VB.NET
Copy
'Gets the current file manager and uses multiuser methods to edit files
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage)

    'Get the first item in the directory to work with
    Dim zenonFileItem As IFileManagerFileItem = zenonFolder.FileItem(0)

    If Not zenonFileItem.IsCheckedOut() Then
        If zenonFileItem.CheckOut() Then
            'The File was checked out by the user who executed this macro
            If zenonFileItem.[Get]() Then
                'Got the latest version of the File
                'Edit some properties of the File
                zenonFileItem.FileName = "NewFileName"

                'Check in the file again so others can check it out

                zenonFileItem.CheckIn()
            Else
                    'The latest version could not be received, undo the checkout
                zenonFileItem.UndoCheckOut()
            End If
                'The File can't currently be checked out
        Else
        End If
            'Someone else has the File checked out!
    Else
    End If
End Sub


UndoCheckOut
ObjectModel COM [image] FileManagerFileItem [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
//Gets the current file manager and uses multiuser methods to edit files
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage);

    //Get the first item in the directory to work with
    IFileManagerFileItem zenonFileItem = zenonFolder.FileItem(0);

    if (!zenonFileItem.IsCheckedOut())
    {
        if (zenonFileItem.CheckOut())
        {
            //The File was checked out by the user who executed this macro
            if (zenonFileItem.Get())
            {
                //Got the latest version of the File
                //Edit some properties of the File
                zenonFileItem.FileName = "NewFileName";

                //Check in the file again so others can check it out
                zenonFileItem.CheckIn();

            }
            else
            {
                zenonFileItem.UndoCheckOut();
                //The latest version could not be received, undo the checkout
            }
        }
        else
        {
            //The File can't currently be checked out
        }
    }
    else
    {
        //Someone else has the File checked out!
    }
}
VB.NET
Copy
'Gets the current file manager and uses multiuser methods to edit files
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage)

    'Get the first item in the directory to work with
    Dim zenonFileItem As IFileManagerFileItem = zenonFolder.FileItem(0)

    If Not zenonFileItem.IsCheckedOut() Then
        If zenonFileItem.CheckOut() Then
            'The File was checked out by the user who executed this macro
            If zenonFileItem.[Get]() Then
                'Got the latest version of the File
                'Edit some properties of the File
                zenonFileItem.FileName = "NewFileName"

                'Check in the file again so others can check it out

                zenonFileItem.CheckIn()
            Else
                    'The latest version could not be received, undo the checkout
                zenonFileItem.UndoCheckOut()
            End If
                'The File can't currently be checked out
        Else
        End If
            'Someone else has the File checked out!
    Else
    End If
End Sub


DynProperties
ObjectModel COM [image] FileManagerFileItem [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

File object


File object
ObjectModel COM [image] FileManagerFileItem [image] DynProperties [image] File object
Overview
External Name | Type | Display Name | Description
Name | String | File name | Name of the integrated file. External files that are integrated in this way are saved both in the Runtime folder and in the database folder of the project. Attention: Every time new Runtime files are created, the files in the Runtime folder are overwritten with the files from the database folder. External files should therefore only be amended using the context menu of the corresponding file and not externally. This ensures that the files are also amended in the database folder. .


FileManagerFolder
ObjectModel COM [image] FileManagerFolder
Remarks

This collection contains the folder object for the specified folder. The folder item object allows different methods for different tpModulepaths. Not all methods are supported for all tpModulepaths

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
//Loops through the help folder and prints every subdirectory
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathHelp);

    //Loop through all subfolders and print them
    for (int i = 0; i < zenonFolder.FolderCount; ++i)
    {
        System.Diagnostics.Debug.Print(zenonFolder.FolderItem(i).Name);
    }
}
VB.NET
Copy
'Loops through the help folder and prints every subdirectory
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathHelp)

    'Loop through all subfolders and print them
    For i As Integer = 0 To zenonFolder.FolderCount - 1
        System.Diagnostics.Debug.Print(zenonFolder.FolderItem(i).Name)
    Next
End Sub
VBA
Copy
Sub AddItem()
Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type

FileManager
'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager
'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Language_Tables\English.txt")
Call CreateFolder

End Sub
Sub CreateFolder()
Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type

FileManager
'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager
'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Create a new folder in the list
zFileManagerFolder.CreateFolder ("My_Folder")
Call FolderItem

End Sub
Sub FolderItem()
Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type

FileManager
Dim zFileManagerItem As FileManagerFileItem 'Child object from type

FileManagerFolder
Dim zFolderItem As FileManagerFolder 'Child object from type FileManager
'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager
'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Read a sub folder item
Set zFolderItem = zFileManagerFolder.FolderItem(0)
'Add a file at the created sub-folder
zFolderItem.AddItem ("C:\Programme\COPA-DATA\Help\editor.chm")

End Sub


Properties
ObjectModel COM [image] FileManagerFolder [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
FileCount | long | Returns the amount of files located in the folder. | Available | Available | Available | Available
FolderCount | long | Returns the amount of folders located in the folder. | Available | Available | Available | Available
Name | bstr | Name of the folder. | Available | Readonly | Available | Available


FileCount
ObjectModel COM [image] FileManagerFolder [image] Properties [image] FileCount
Remarks

Returns the number of files in a directory.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


FolderCount
ObjectModel COM [image] FileManagerFolder [image] Properties [image] FolderCount
Remarks

Returns the number of sub-directories in this directory.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] FileManagerFolder [image] Properties [image] Name
Remarks

Returns the name of the directory.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] FileManagerFolder [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AddItem | variant_bool | Inserts the given file into the folder. | Available | Unused | Available | Available
CreateFolder | variant_bool | Creates a subfolder. | Available | Unused | Available | Available
DeleteFile | variant_bool | Deletes the file from the folder. | Available | Unused | Available | Available
DeleteFolder | variant_bool | Deletes the folder. | Available | Unused | Available | Available
FileItem | ifilemanagerfileitem | Returns the file, at given index, from the folder. | Available | Available | Available | Available
FolderItem | ifilemanagerfolder | Returns the sub-folder, at given index, from the folder. | Available | Available | Available | Available


AddItem
ObjectModel COM [image] FileManagerFolder [image] Methods [image] AddItem
Remarks

This method allows adding files to the directory.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Filename (path) as string.

Example
C#
Copy
//Gets the current file manager and uses it to add a new language file
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage);
    //Add a language file
    zenonFolder.AddItem(@"C:\Language_Tables\English.txt");
}
VB.NET
Copy
'Gets the current file manager and uses it to add a new language file
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage)
    'Add a language file
    zenonFolder.AddItem("C:\Language_Tables\English.txt")
End Sub
VBA
Copy
Sub AddItem()
Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type FileManager
'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager
'Read the "language list"
Set zFileManagerFolder = zFileManager.FolderItem(9)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Language_Tables\English.txt")

End Sub


CreateFolder
ObjectModel COM [image] FileManagerFolder [image] Methods [image] CreateFolder
Remarks

This method creates a new directory. It is not supported for all tpModulepaths directories. Returns True if successfull

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFolderName as BSTR

The folder name is defined by a string.

Example
C#
Copy
//Creates a new folder
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathHelp);

    //Create a new directory in the help path
    zenonFolder.CreateFolder("new_folder");
}
VB.NET
Copy
'Creates a new folder
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathHelp)

    'Create a new directory in the help path
    zenonFolder.CreateFolder("new_folder")
End Sub
VBA
Copy
Sub CreateFolder()
Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type

FileManager
'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager
'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Create a new folder in the list
zFileManagerFolder.CreateFolder ("My_Folder")

End Sub


DeleteFile
ObjectModel COM [image] FileManagerFolder [image] Methods [image] DeleteFile
Remarks

This method allows the deletion of files. Returns true if successfull.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lIndex as long

Defines the position of the file.

Example
C#
Copy
//Delete files in a folder
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathHelp);

    //loop through all files and delete them
    for (int i = 0; i < zenonFolder.FileCount; ++i)
    {
        zenonFolder.DeleteFile(i);
    }
}
VB.NET
Copy
'Delete files in a folder
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathHelp)

    'loop through all files and delete them
    For i As Integer = 0 To zenonFolder.FileCount - 1
        zenonFolder.DeleteFile(i)
    Next
End Sub
VBA
Copy
Sub DeleteFile()
Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type

FileManager
'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager
'Read the "language list"
Set zFileManagerFolder = zFileManager.FolderItem(9)
'Delete the first file in the list
zFileManagerFolder.DeleteFile (0)

End Sub


DeleteFolder
ObjectModel COM [image] FileManagerFolder [image] Methods [image] DeleteFolder
Remarks

With this method a list folder can be deleted.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lIndex as long

Defines the position of the folder.

Example
C#
Copy
//Delete all folders in a folder
public void MacroDeleteFolder()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathHelp);

    //loop through all files and delete them
    for (int i = 0; i < zenonFolder.FolderCount; ++i)
    {
        zenonFolder.DeleteFolder(i);
    }
}
VB.NET
Copy
'Delete all folders in a folder
Public Sub MacroDeleteFolder()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathHelp)

    'loop through all files and delete them
    For i As Integer = 0 To zenonFolder.FolderCount - 1
        zenonFolder.DeleteFolder(i)
    Next
End Sub
VBA
Copy
Sub DeleteFolder()
Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type

FileManager
'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager
'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Delete the first folder
zFileManagerFolder.DeleteFolder (0)

End Sub


FileItem
ObjectModel COM [image] FileManagerFolder [image] Methods [image] FileItem
Remarks

This method returns an object from type FileManagerFileItem.

Datatype
IFileManagerFileItem

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lIndex as long

Defines the position of the file.

Example
C#
Copy
//Gets the current file manager and loops through all the files in the language directory
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage);

    //Loop through all the files and print the names on the debug window
    for (int i = 0; i < zenonFolder.FileCount; ++i)
    {
        System.Diagnostics.Debug.Print(zenonFolder.FileItem(i).FileName);
    }
}
VB.NET
Copy
'Gets the current file manager and loops through all the files in the language directory
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathLanguage)

    'Loop through all the files and print the names on the debug window
    For i As Integer = 0 To zenonFolder.FileCount - 1
        System.Diagnostics.Debug.Print(zenonFolder.FileItem(i).FileName)
    Next
End Sub
VBA
Copy
Sub FileItem()
Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type FileManager
Dim zFileManagerItem As FileManagerFileItem 'Child object from type FileManagerFolder
'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager
'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Read the first file in the list
Set zFileManagerItem = zFileManagerFolder.FileItem(0)
'Returns the filename of the file in the list
Debug.Print "Filename = " & zFileManagerItem.FileName

End Sub


FolderItem
ObjectModel COM [image] FileManagerFolder [image] Methods [image] FolderItem
Remarks

This method returns a sub-folder from type "FileManagerFolder".

Datatype
IFileManagerFolder

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lIndex as long

Defines the position of the sub folder.

Example
C#
Copy
//Loops through the help folder and prints every subdirectory
public void MacroFileManager()
{
    //Get the current filemanager
    IFileManager zenonFileManager = this.ActiveDocument.FileManager();

    //Get the language directory
    IFileManagerFolder zenonFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathHelp);

    //Loop through all subfolders and print them
    for (int i = 0; i < zenonFolder.FolderCount; ++i)
    {
        System.Diagnostics.Debug.Print(zenonFolder.FolderItem(i).Name);
    }
}
VB.NET
Copy
'Loops through the help folder and prints every subdirectory
Public Sub MacroFileManager()
    'Get the current filemanager
    Dim zenonFileManager As IFileManager = Me.ActiveDocument.FileManager()

    'Get the language directory
    Dim zenonFolder As IFileManagerFolder = zenonFileManager.FolderItem(tpModulePaths.tpPathHelp)

    'Loop through all subfolders and print them
    For i As Integer = 0 To zenonFolder.FolderCount - 1
        System.Diagnostics.Debug.Print(zenonFolder.FolderItem(i).Name)
    Next
End Sub
VBA
Copy
Sub FolderItem()
Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type FileManager
Dim zFileManagerItem As FileManagerFileItem 'Child object from type

FileManagerFolder
Dim zFolderItem As FileManagerFolder 'Child object from type FileManager
'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager
'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Read a sub folder item
Set zFolderItem = zFileManagerFolder.FolderItem(0)
'Add a file at the created sub-folder
zFolderItem.AddItem ("C:\Programme\COPA-DATA\Help\editor.chm")

End Sub


FontItem
ObjectModel COM [image] FontItem
Remarks

Defines a font item, for encoding the fontItem strings into proper LogFont objects take a look at the LOGFONT structure and the LogFont class in the code examples. In order to use that class make sure to include the namespaceSystem.Runtime.InteropServiceseither via using or Import when working on VSTA.

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
public class LogFont
{
    [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 32)]
    private string _faceName;

    public int Height { get; set; }
    public int Width { get; set; }
    public int Escapement { get; set; }
    public int Orientation  { get; set; }
    public int Weight { get; set; }
    public byte Italic  { get; set; }
    public byte Underline { get; set; }
    public byte StrikeOut { get; set; }
    public byte FontCharSet { get; set; }
    public byte OutPrecision { get; set; }
    public byte ClipPrecision { get; set; }
    public byte Quality { get; set; }
    public byte PitchAndFamily { get; set; }
    public string FaceName
    {
        get
        {
            return _faceName;
        }
        set
        {
            if (value.Length > 32)
                _faceName = value.Substring(0, 32);
            else
                _faceName = value;
        }
    }

    public LogFont(int height, int width, int escape, int orient, int weight,
        byte italic, byte underline, byte strikeout, byte charSet, byte outPrecision,
        byte clipPrecision, byte quality, byte pitchAndFamily, string faceName)
    {
        this.Height = height;
        this.Width = width;
        this.Escapement = escape;
        this.Orientation = orient;
        this.Weight = weight;
        this.Italic = italic;
        this.Underline = underline;
        this.StrikeOut = strikeout;
        this.FontCharSet = charSet;
        this.OutPrecision = outPrecision;
        this.ClipPrecision = clipPrecision;
        this.Quality = quality;
        this.PitchAndFamily = pitchAndFamily;
        this.FaceName = faceName;
    }

    public LogFont(string s)
    {
        string[] parseSplit = s.Split(' ');
        this.Height = int.Parse(parseSplit[0]);
        this.Width = int.Parse(parseSplit[1]);
        this.Escapement = int.Parse(parseSplit[2]);
        this.Orientation = int.Parse(parseSplit[3]);
        this.Weight = int.Parse(parseSplit[4]);
        this.Italic = byte.Parse(parseSplit[5]);
        this.Underline = byte.Parse(parseSplit[6]);
        this.StrikeOut = byte.Parse(parseSplit[7]);
        this.FontCharSet = byte.Parse(parseSplit[8]);
        this.OutPrecision = byte.Parse(parseSplit[9]);
        this.ClipPrecision = byte.Parse(parseSplit[10]);
        this.Quality = byte.Parse(parseSplit[11]);
        this.PitchAndFamily = byte.Parse(parseSplit[12]);
        this.FaceName = parseSplit[13];
    }

    public override string ToString()
    {
        return string.Format("{0} {1} {2} {3} {4} {5} {6} {7} {8} {9} {10} {11} {12} {13}",
            this.Height, this.Width, this.Escapement, this.Orientation, this.Weight,
            this.Italic, this.Underline, this.StrikeOut, this.FontCharSet, this.OutPrecision,
            this.ClipPrecision, this.Quality, this.PitchAndFamily, this.FaceName);
    }
}

public void MacroFont()
{
    IFontLists zenonFontLists = this.ActiveDocument.FontLists;
    for (int i = 0; i < zenonFontLists.Count; ++i )
    {

        IFontList zenonFontList = zenonFontLists.Item(i);
        //Loop through all fonts and set the height to 10
        for (int j = 0; j < zenonFontList.Count; ++j)
        {
            IFontItem zenonFont = zenonFontList.Item(j);
            //Parse the LogFont string of the font
            LogFont lf = new LogFont((string)zenonFont.get_DynProperties("Font"));
            lf.Height = -27;
            //Change the height value and set the Font property again
            zenonFont.set_DynProperties("Font", lf.ToString());

        }

    }
}
VB.NET
Copy
<StructLayout(LayoutKind.Sequential, CharSet := CharSet.Auto)> _
Public Class LogFont
    <MarshalAs(UnmanagedType.ByValTStr, SizeConst := 32)> _
    Private _faceName As String

    Public Property Height() As Integer
        Get
            Return m_Height
        End Get
        Set
            m_Height = Value
        End Set
    End Property
    Private m_Height As Integer
    Public Property Width() As Integer
        Get
            Return m_Width
        End Get
        Set
            m_Width = Value
        End Set
    End Property
    Private m_Width As Integer
    Public Property Escapement() As Integer
        Get
            Return m_Escapement
        End Get
        Set
            m_Escapement = Value
        End Set
    End Property
    Private m_Escapement As Integer
    Public Property Orientation() As Integer
        Get
            Return m_Orientation
        End Get
        Set
            m_Orientation = Value
        End Set
    End Property
    Private m_Orientation As Integer
    Public Property Weight() As Integer
        Get
            Return m_Weight
        End Get
        Set
            m_Weight = Value
        End Set
    End Property
    Private m_Weight As Integer
    Public Property Italic() As Byte
        Get
            Return m_Italic
        End Get
        Set
            m_Italic = Value
        End Set
    End Property
    Private m_Italic As Byte
    Public Property Underline() As Byte
        Get
            Return m_Underline
        End Get
        Set
            m_Underline = Value
        End Set
    End Property
    Private m_Underline As Byte
    Public Property StrikeOut() As Byte
        Get
            Return m_StrikeOut
        End Get
        Set
            m_StrikeOut = Value
        End Set
    End Property
    Private m_StrikeOut As Byte
    Public Property FontCharSet() As Byte
        Get
            Return m_FontCharSet
        End Get
        Set
            m_FontCharSet = Value
        End Set
    End Property
    Private m_FontCharSet As Byte
    Public Property OutPrecision() As Byte
        Get
            Return m_OutPrecision
        End Get
        Set
            m_OutPrecision = Value
        End Set
    End Property
    Private m_OutPrecision As Byte
    Public Property ClipPrecision() As Byte
        Get
            Return m_ClipPrecision
        End Get
        Set
            m_ClipPrecision = Value
        End Set
    End Property
    Private m_ClipPrecision As Byte
    Public Property Quality() As Byte
        Get
            Return m_Quality
        End Get
        Set
            m_Quality = Value
        End Set
    End Property
    Private m_Quality As Byte
    Public Property PitchAndFamily() As Byte
        Get
            Return m_PitchAndFamily
        End Get
        Set
            m_PitchAndFamily = Value
        End Set
    End Property
    Private m_PitchAndFamily As Byte
    Public Property FaceName() As String
        Get
            Return _faceName
        End Get
        Set
            If value.Length > 32 Then
                _faceName = value.Substring(0, 32)
            Else
                _faceName = value
            End If
        End Set
    End Property

    Public Sub New(height As Integer, width As Integer, escape As Integer, orient As Integer, weight As Integer, italic As Byte, _
        underline As Byte, strikeout As Byte, charSet As Byte, outPrecision As Byte, clipPrecision As Byte, quality As Byte, _
        pitchAndFamily As Byte, faceName As String)
        Me.Height = height
        Me.Width = width
        Me.Escapement = escape
        Me.Orientation = orient
        Me.Weight = weight
        Me.Italic = italic
        Me.Underline = underline
        Me.StrikeOut = strikeout
        Me.FontCharSet = charSet
        Me.OutPrecision = outPrecision
        Me.ClipPrecision = clipPrecision
        Me.Quality = quality
        Me.PitchAndFamily = pitchAndFamily
        Me.FaceName = faceName
    End Sub

    Public Sub New(s As String)
        Dim parseSplit As String() = s.Split(" "C)
        Me.Height = Integer.Parse(parseSplit(0))
        Me.Width = Integer.Parse(parseSplit(1))
        Me.Escapement = Integer.Parse(parseSplit(2))
        Me.Orientation = Integer.Parse(parseSplit(3))
        Me.Weight = Integer.Parse(parseSplit(4))
        Me.Italic = Byte.Parse(parseSplit(5))
        Me.Underline = Byte.Parse(parseSplit(6))
        Me.StrikeOut = Byte.Parse(parseSplit(7))
        Me.FontCharSet = Byte.Parse(parseSplit(8))
        Me.OutPrecision = Byte.Parse(parseSplit(9))
        Me.ClipPrecision = Byte.Parse(parseSplit(10))
        Me.Quality = Byte.Parse(parseSplit(11))
        Me.PitchAndFamily = Byte.Parse(parseSplit(12))
        Me.FaceName = parseSplit(13)
    End Sub

    Public Overrides Function ToString() As String
        Return String.Format("{0} {1} {2} {3} {4} {5} {6} {7} {8} {9} {10} {11} {12} {13}", Me.Height, Me.Width, Me.Escapement, Me.Orientation, Me.Weight, _
            Me.Italic, Me.Underline, Me.StrikeOut, Me.FontCharSet, Me.OutPrecision, Me.ClipPrecision, _
            Me.Quality, Me.PitchAndFamily, Me.FaceName)
    End Function
End Class

Public Sub MacroFont()
    Dim zenonFontLists As IFontLists = Me.ActiveDocument.FontLists
    For i As Integer = 0 To zenonFontLists.Count - 1

        Dim zenonFontList As IFontList = zenonFontLists.Item(i)
        'Loop through all fonts and set the height to 10
        For j As Integer = 0 To zenonFontList.Count - 1
            Dim zenonFont As IFontItem = zenonFontList.Item(j)
            'Parse the LogFont string of the font
            Dim lf As New LogFont(DirectCast(zenonFont.get_DynProperties("Font"), String))
            lf.Height = -27
            'Change the height value and set the Font property again

            zenonFont.set_DynProperties("Font", lf.ToString())

        Next
    Next
End Sub
VBA
Copy
'Type definition of LOGFONT type (see MSDN)
Type LOGFONT
Height As Long
Width As Long
Escapement As Long
Orientation As Long
Weight As Long
Italic As Byte
Underline As Byte
StrikeOut As Byte
CharSet As Byte
OutPrecision As Byte
ClipPrecision As Byte
Quality As Byte
PitchAndFamily As Byte
FaceName As String * 32
End Type
Sub GetFontList()
Dim zPRJ As Project
Dim zFLs As FontLists
Dim zFL As FontList
Dim zFI As FontItem
Dim i As Integer
Dim n As Integer
Dim lf As LOGFONT
Set zPRJ = MyWorkspace.ActiveDocument
Set zFLs = zPRJ.FontLists
'enumerate all fontlists of the active project
For i = 0 To zFLs.Count - 1

Set zFL = zFLs.Item(i)

Debug.Print "Fontlist: " & zFL.DynProperties("Name")

'enumrate fonts of a fontlist

For n = 0 To zFL.Count - 1

Set zFI = zFL.Item(n)

Debug.Print zFI.DynProperties("Number")

Debug.Print zFI.DynProperties("Name")

Debug.Print zFI.DynProperties("Font")

'convert string to LOGFONT type in a function

lf = GetLogFontFromString(zFI.DynProperties("Font"))

Next n
Next i
End Sub
Sub CreateFontList()
Dim zPRJ As Project
Dim zFLs As FontLists
Dim zFL As FontList
Dim zFI As FontItem
Dim i As Integer
Dim lf As LOGFONT
Set zPRJ = MyWorkspace.ActiveDocument
Set zFLs = zPRJ.FontLists
'define font (LOGFONT)
lf.Height = 10
lf.Width = 0
lf.Escapement = 0
lf.Orientation = 0
lf.Weight = 400
lf.Italic = 0
lf.Underline = 0
lf.StrikeOut = 0
lf.CharSet = 0
lf.OutPrecision = 3
lf.ClipPrecision = 2
lf.Quality = 5
lf.PitchAndFamily = 34
lf.FaceName = String(25, " ") & "Courier" '32 - 7
'create new fontlist
Set zFL = zFLs.Create
With zFL

'set name of new fontlist

.DynProperties("Name") = "VBA_FontList3"

For i = 1 To 10

'create fonts in fontlist

Set zFI = zFL.Create(i)

zFI.DynProperties("Name") = "VBA_Font_" & Format(i, "00")

zFI.DynProperties("Font") = strFont

'modify LOGFONT definition

lf.Height = 10 + (i * 2)

'set font

zFI.DynProperties("Font") = GetStringFromLogFont(lf)

Next i
End With

End Sub
'CONVERT A STRING TO LOGFONT TYPE
Function GetLogFontFromString(strFont As String) As LOGFONT
Dim vSplit As Variant
Dim sFaceName As String
Dim i As Integer
vSplit = Split(strFont, " ")
GetLogFontFromString.Height = vSplit(0)
GetLogFontFromString.Width = vSplit(1)
GetLogFontFromString.Escapement = vSplit(2)
GetLogFontFromString.Orientation = vSplit(3)
GetLogFontFromString.Weight = vSplit(4)
GetLogFontFromString.Italic = vSplit(5)
GetLogFontFromString.Underline = vSplit(6)
GetLogFontFromString.StrikeOut = vSplit(7)
GetLogFontFromString.CharSet = vSplit(8)
GetLogFontFromString.OutPrecision = vSplit(9)
GetLogFontFromString.ClipPrecision = vSplit(10)
GetLogFontFromString.Quality = vSplit(11)
GetLogFontFromString.PitchAndFamily = vSplit(12)
For i = 13 To UBound(vSplit)

sFaceName = sFaceName & vSplit(i) & " "
Next i
sFaceName = RTrim(sFaceName)
sFaceName = String(32 - Len(sFaceName), " ") & sFaceName
GetLogFontFromString.FaceName = sFaceName
End Function
'CONVERT A LOGFONT TO STRING
Function GetStringFromLogFont(lfFont As LOGFONT) As String
GetStringFromLogFont = lfFont.Height & " " & _
lfFont.Width & " " & _
lfFont.Escapement & " " & _
lfFont.Orientation & " " & _
lfFont.Weight & " " & _
lfFont.Italic & " " & _
lfFont.Underline & " " & _
lfFont.StrikeOut & " " & _
lfFont.CharSet & " " & _
lfFont.OutPrecision & " " & _
lfFont.ClipPrecision & " " & _
lfFont.Quality & " " & _
lfFont.PitchAndFamily & " " & _
lfFont.FaceName
End Function


Methods
ObjectModel COM [image] FontItem [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant |  | Available | Unused | Available | Available
DynProperties [PUT] | void |  | Available | Unused | Available | Available
DynPropertiesEnum [GET] | variant |  | Available | Unused | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available


DynProperties [GET]
ObjectModel COM [image] FontItem [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] FontItem [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.


DynPropertiesEnum [GET]
ObjectModel COM [image] FontItem [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"


DynPropertyParam [GET]
ObjectModel COM [image] FontItem [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties
ObjectModel COM [image] FontItem [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Font


Font
ObjectModel COM [image] FontItem [image] DynProperties [image] Font
Overview
External Name | Type | Display Name | Description
Font | LogFont | Font | Selection of the font type from the font types available on the computer. Note: The dialog for selection of the font type is a Windows standard dialog. .
Name | String | Name | Freely-definable identification. For information only. Default: New font x (whereby x is a consecutive number). .
Number | UInt16 | Number | Unique number of the font. The number is set by the system when the font is created. Numbers 1 and 2 are assigned fixedly and cannot be changed. All other font numbers can be changed afterwards as long as the newly assigned numbers are not already used for others fonts.Note: If there are same numbers in the global project and in the project, the project font is used. .


FontList
ObjectModel COM [image] FontList
Remarks

Defines a FontList object which contains single FontItem objects.

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
public class LogFont
{
    [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 32)]
    private string _faceName;

    public int Height { get; set; }
    public int Width { get; set; }
    public int Escapement { get; set; }
    public int Orientation  { get; set; }
    public int Weight { get; set; }
    public byte Italic  { get; set; }
    public byte Underline { get; set; }
    public byte StrikeOut { get; set; }
    public byte FontCharSet { get; set; }
    public byte OutPrecision { get; set; }
    public byte ClipPrecision { get; set; }
    public byte Quality { get; set; }
    public byte PitchAndFamily { get; set; }
    public string FaceName
    {
        get
        {
            return _faceName;
        }
        set
        {
            if (value.Length > 32)
                _faceName = value.Substring(0, 32);
            else
                _faceName = value;
        }
    }

    public LogFont(int height, int width, int escape, int orient, int weight,
        byte italic, byte underline, byte strikeout, byte charSet, byte outPrecision,
        byte clipPrecision, byte quality, byte pitchAndFamily, string faceName)
    {
        this.Height = height;
        this.Width = width;
        this.Escapement = escape;
        this.Orientation = orient;
        this.Weight = weight;
        this.Italic = italic;
        this.Underline = underline;
        this.StrikeOut = strikeout;
        this.FontCharSet = charSet;
        this.OutPrecision = outPrecision;
        this.ClipPrecision = clipPrecision;
        this.Quality = quality;
        this.PitchAndFamily = pitchAndFamily;
        this.FaceName = faceName;
    }

    public LogFont(string s)
    {
        string[] parseSplit = s.Split(' ');
        this.Height = int.Parse(parseSplit[0]);
        this.Width = int.Parse(parseSplit[1]);
        this.Escapement = int.Parse(parseSplit[2]);
        this.Orientation = int.Parse(parseSplit[3]);
        this.Weight = int.Parse(parseSplit[4]);
        this.Italic = byte.Parse(parseSplit[5]);
        this.Underline = byte.Parse(parseSplit[6]);
        this.StrikeOut = byte.Parse(parseSplit[7]);
        this.FontCharSet = byte.Parse(parseSplit[8]);
        this.OutPrecision = byte.Parse(parseSplit[9]);
        this.ClipPrecision = byte.Parse(parseSplit[10]);
        this.Quality = byte.Parse(parseSplit[11]);
        this.PitchAndFamily = byte.Parse(parseSplit[12]);
        this.FaceName = parseSplit[13];
    }

    public override string ToString()
    {
        return string.Format("{0} {1} {2} {3} {4} {5} {6} {7} {8} {9} {10} {11} {12} {13}",
            this.Height, this.Width, this.Escapement, this.Orientation, this.Weight,
            this.Italic, this.Underline, this.StrikeOut, this.FontCharSet, this.OutPrecision,
            this.ClipPrecision, this.Quality, this.PitchAndFamily, this.FaceName);
    }
}

public void MacroFont()
{
    IFontLists zenonFontLists = this.ActiveDocument.FontLists;
    for (int i = 0; i < zenonFontLists.Count; ++i )
    {

        IFontList zenonFontList = zenonFontLists.Item(i);
        //Loop through all fonts and set the height to 10
        for (int j = 0; j < zenonFontList.Count; ++j)
        {
            IFontItem zenonFont = zenonFontList.Item(j);
            //Parse the LogFont string of the font
            LogFont lf = new LogFont((string)zenonFont.get_DynProperties("Font"));
            lf.Height = -27;
            //Change the height value and set the Font property again
            zenonFont.set_DynProperties("Font", lf.ToString());

        }

    }
}
VB.NET
Copy
<StructLayout(LayoutKind.Sequential, CharSet := CharSet.Auto)> _
Public Class LogFont
    <MarshalAs(UnmanagedType.ByValTStr, SizeConst := 32)> _
    Private _faceName As String

    Public Property Height() As Integer
        Get
            Return m_Height
        End Get
        Set
            m_Height = Value
        End Set
    End Property
    Private m_Height As Integer
    Public Property Width() As Integer
        Get
            Return m_Width
        End Get
        Set
            m_Width = Value
        End Set
    End Property
    Private m_Width As Integer
    Public Property Escapement() As Integer
        Get
            Return m_Escapement
        End Get
        Set
            m_Escapement = Value
        End Set
    End Property
    Private m_Escapement As Integer
    Public Property Orientation() As Integer
        Get
            Return m_Orientation
        End Get
        Set
            m_Orientation = Value
        End Set
    End Property
    Private m_Orientation As Integer
    Public Property Weight() As Integer
        Get
            Return m_Weight
        End Get
        Set
            m_Weight = Value
        End Set
    End Property
    Private m_Weight As Integer
    Public Property Italic() As Byte
        Get
            Return m_Italic
        End Get
        Set
            m_Italic = Value
        End Set
    End Property
    Private m_Italic As Byte
    Public Property Underline() As Byte
        Get
            Return m_Underline
        End Get
        Set
            m_Underline = Value
        End Set
    End Property
    Private m_Underline As Byte
    Public Property StrikeOut() As Byte
        Get
            Return m_StrikeOut
        End Get
        Set
            m_StrikeOut = Value
        End Set
    End Property
    Private m_StrikeOut As Byte
    Public Property FontCharSet() As Byte
        Get
            Return m_FontCharSet
        End Get
        Set
            m_FontCharSet = Value
        End Set
    End Property
    Private m_FontCharSet As Byte
    Public Property OutPrecision() As Byte
        Get
            Return m_OutPrecision
        End Get
        Set
            m_OutPrecision = Value
        End Set
    End Property
    Private m_OutPrecision As Byte
    Public Property ClipPrecision() As Byte
        Get
            Return m_ClipPrecision
        End Get
        Set
            m_ClipPrecision = Value
        End Set
    End Property
    Private m_ClipPrecision As Byte
    Public Property Quality() As Byte
        Get
            Return m_Quality
        End Get
        Set
            m_Quality = Value
        End Set
    End Property
    Private m_Quality As Byte
    Public Property PitchAndFamily() As Byte
        Get
            Return m_PitchAndFamily
        End Get
        Set
            m_PitchAndFamily = Value
        End Set
    End Property
    Private m_PitchAndFamily As Byte
    Public Property FaceName() As String
        Get
            Return _faceName
        End Get
        Set
            If value.Length > 32 Then
                _faceName = value.Substring(0, 32)
            Else
                _faceName = value
            End If
        End Set
    End Property

    Public Sub New(height As Integer, width As Integer, escape As Integer, orient As Integer, weight As Integer, italic As Byte, _
        underline As Byte, strikeout As Byte, charSet As Byte, outPrecision As Byte, clipPrecision As Byte, quality As Byte, _
        pitchAndFamily As Byte, faceName As String)
        Me.Height = height
        Me.Width = width
        Me.Escapement = escape
        Me.Orientation = orient
        Me.Weight = weight
        Me.Italic = italic
        Me.Underline = underline
        Me.StrikeOut = strikeout
        Me.FontCharSet = charSet
        Me.OutPrecision = outPrecision
        Me.ClipPrecision = clipPrecision
        Me.Quality = quality
        Me.PitchAndFamily = pitchAndFamily
        Me.FaceName = faceName
    End Sub

    Public Sub New(s As String)
        Dim parseSplit As String() = s.Split(" "C)
        Me.Height = Integer.Parse(parseSplit(0))
        Me.Width = Integer.Parse(parseSplit(1))
        Me.Escapement = Integer.Parse(parseSplit(2))
        Me.Orientation = Integer.Parse(parseSplit(3))
        Me.Weight = Integer.Parse(parseSplit(4))
        Me.Italic = Byte.Parse(parseSplit(5))
        Me.Underline = Byte.Parse(parseSplit(6))
        Me.StrikeOut = Byte.Parse(parseSplit(7))
        Me.FontCharSet = Byte.Parse(parseSplit(8))
        Me.OutPrecision = Byte.Parse(parseSplit(9))
        Me.ClipPrecision = Byte.Parse(parseSplit(10))
        Me.Quality = Byte.Parse(parseSplit(11))
        Me.PitchAndFamily = Byte.Parse(parseSplit(12))
        Me.FaceName = parseSplit(13)
    End Sub

    Public Overrides Function ToString() As String
        Return String.Format("{0} {1} {2} {3} {4} {5} {6} {7} {8} {9} {10} {11} {12} {13}", Me.Height, Me.Width, Me.Escapement, Me.Orientation, Me.Weight, _
            Me.Italic, Me.Underline, Me.StrikeOut, Me.FontCharSet, Me.OutPrecision, Me.ClipPrecision, _
            Me.Quality, Me.PitchAndFamily, Me.FaceName)
    End Function
End Class

Public Sub MacroFont()
    Dim zenonFontLists As IFontLists = Me.ActiveDocument.FontLists
    For i As Integer = 0 To zenonFontLists.Count - 1

        Dim zenonFontList As IFontList = zenonFontLists.Item(i)
        'Loop through all fonts and set the height to 10
        For j As Integer = 0 To zenonFontList.Count - 1
            Dim zenonFont As IFontItem = zenonFontList.Item(j)
            'Parse the LogFont string of the font
            Dim lf As New LogFont(DirectCast(zenonFont.get_DynProperties("Font"), String))
            lf.Height = -27
            'Change the height value and set the Font property again

            zenonFont.set_DynProperties("Font", lf.ToString())

        Next
    Next
End Sub
VBA
Copy
'Type definition of LOGFONT type (see MSDN)
Type LOGFONT
Height As Long
Width As Long
Escapement As Long
Orientation As Long
Weight As Long
Italic As Byte
Underline As Byte
StrikeOut As Byte
CharSet As Byte
OutPrecision As Byte
ClipPrecision As Byte
Quality As Byte
PitchAndFamily As Byte
FaceName As String * 32
End Type
Sub GetFontList()
Dim zPRJ As Project
Dim zFLs As FontLists
Dim zFL As FontList
Dim zFI As FontItem
Dim i As Integer
Dim n As Integer
Dim lf As LOGFONT
Set zPRJ = MyWorkspace.ActiveDocument
Set zFLs = zPRJ.FontLists
'enumerate all fontlists of the active project
For i = 0 To zFLs.Count - 1

Set zFL = zFLs.Item(i)

Debug.Print "Fontlist: " & zFL.DynProperties("Name")

'enumrate fonts of a fontlist

For n = 0 To zFL.Count - 1

Set zFI = zFL.Item(n)

Debug.Print zFI.DynProperties("Number")

Debug.Print zFI.DynProperties("Name")

Debug.Print zFI.DynProperties("Font")

'convert string to LOGFONT type in a function

lf = GetLogFontFromString(zFI.DynProperties("Font"))

Next n
Next i
End Sub
Sub CreateFontList()
Dim zPRJ As Project
Dim zFLs As FontLists
Dim zFL As FontList
Dim zFI As FontItem
Dim i As Integer
Dim lf As LOGFONT
Set zPRJ = MyWorkspace.ActiveDocument
Set zFLs = zPRJ.FontLists
'define font (LOGFONT)
lf.Height = 10
lf.Width = 0
lf.Escapement = 0
lf.Orientation = 0
lf.Weight = 400
lf.Italic = 0
lf.Underline = 0
lf.StrikeOut = 0
lf.CharSet = 0
lf.OutPrecision = 3
lf.ClipPrecision = 2
lf.Quality = 5
lf.PitchAndFamily = 34
lf.FaceName = String(25, " ") & "Courier" '32 - 7
'create new fontlist
Set zFL = zFLs.Create
With zFL

'set name of new fontlist

.DynProperties("Name") = "VBA_FontList3"

For i = 1 To 10

'create fonts in fontlist

Set zFI = zFL.Create(i)

zFI.DynProperties("Name") = "VBA_Font_" & Format(i, "00")

zFI.DynProperties("Font") = strFont

'modify LOGFONT definition

lf.Height = 10 + (i * 2)

'set font

zFI.DynProperties("Font") = GetStringFromLogFont(lf)

Next i
End With

End Sub
'CONVERT A STRING TO LOGFONT TYPE
Function GetLogFontFromString(strFont As String) As LOGFONT
Dim vSplit As Variant
Dim sFaceName As String
Dim i As Integer
vSplit = Split(strFont, " ")
GetLogFontFromString.Height = vSplit(0)
GetLogFontFromString.Width = vSplit(1)
GetLogFontFromString.Escapement = vSplit(2)
GetLogFontFromString.Orientation = vSplit(3)
GetLogFontFromString.Weight = vSplit(4)
GetLogFontFromString.Italic = vSplit(5)
GetLogFontFromString.Underline = vSplit(6)
GetLogFontFromString.StrikeOut = vSplit(7)
GetLogFontFromString.CharSet = vSplit(8)
GetLogFontFromString.OutPrecision = vSplit(9)
GetLogFontFromString.ClipPrecision = vSplit(10)
GetLogFontFromString.Quality = vSplit(11)
GetLogFontFromString.PitchAndFamily = vSplit(12)
For i = 13 To UBound(vSplit)

sFaceName = sFaceName & vSplit(i) & " "
Next i
sFaceName = RTrim(sFaceName)
sFaceName = String(32 - Len(sFaceName), " ") & sFaceName
GetLogFontFromString.FaceName = sFaceName
End Function
'CONVERT A LOGFONT TO STRING
Function GetStringFromLogFont(lfFont As LOGFONT) As String
GetStringFromLogFont = lfFont.Height & " " & _
lfFont.Width & " " & _
lfFont.Escapement & " " & _
lfFont.Orientation & " " & _
lfFont.Weight & " " & _
lfFont.Italic & " " & _
lfFont.Underline & " " & _
lfFont.StrikeOut & " " & _
lfFont.CharSet & " " & _
lfFont.OutPrecision & " " & _
lfFont.ClipPrecision & " " & _
lfFont.Quality & " " & _
lfFont.PitchAndFamily & " " & _
lfFont.FaceName
End Function


Properties
ObjectModel COM [image] FontList [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the number of Font objects. | Available | Unused | Available | Available


Count
ObjectModel COM [image] FontList [image] Properties [image] Count
Remarks

Returns the number of Font objects.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] FontList [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | ifontitem | Create a new Font. | Available | Unused | Available | Available
DynProperties [GET] | variant |  | Available | Unused | Available | Available
DynProperties [PUT] | void |  | Available | Unused | Available | Available
DynPropertiesEnum [GET] | variant |  | Available | Unused | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available
Item | ifontitem | Returns the Font at the given index. | Available | Unused | Available | Available
ItemById | ifontitem | Returns the Font with the given Id. | Available | Unused | Available | Available


Create
ObjectModel COM [image] FontList [image] Methods [image] Create
Remarks

Creates a new FontItem object in the font list and returns it.

Datatype
IFontItem

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lFontId as long

Example
C#
Copy
[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
public class LogFont
{
    [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 32)]
    private string _faceName;

    public int Height { get; set; }
    public int Width { get; set; }
    public int Escapement { get; set; }
    public int Orientation  { get; set; }
    public int Weight { get; set; }
    public byte Italic  { get; set; }
    public byte Underline { get; set; }
    public byte StrikeOut { get; set; }
    public byte FontCharSet { get; set; }
    public byte OutPrecision { get; set; }
    public byte ClipPrecision { get; set; }
    public byte Quality { get; set; }
    public byte PitchAndFamily { get; set; }
    public string FaceName
    {
        get
        {
            return _faceName;
        }
        set
        {
            if (value.Length > 32)
                _faceName = value.Substring(0, 32);
            else
                _faceName = value;
        }
    }

    public LogFont(int height, int width, int escape, int orient, int weight,
        byte italic, byte underline, byte strikeout, byte charSet, byte outPrecision,
        byte clipPrecision, byte quality, byte pitchAndFamily, string faceName)
    {
        this.Height = height;
        this.Width = width;
        this.Escapement = escape;
        this.Orientation = orient;
        this.Weight = weight;
        this.Italic = italic;
        this.Underline = underline;
        this.StrikeOut = strikeout;
        this.FontCharSet = charSet;
        this.OutPrecision = outPrecision;
        this.ClipPrecision = clipPrecision;
        this.Quality = quality;
        this.PitchAndFamily = pitchAndFamily;
        this.FaceName = faceName;
    }

    public LogFont(string s)
    {
        string[] parseSplit = s.Split(' ');
        this.Height = int.Parse(parseSplit[0]);
        this.Width = int.Parse(parseSplit[1]);
        this.Escapement = int.Parse(parseSplit[2]);
        this.Orientation = int.Parse(parseSplit[3]);
        this.Weight = int.Parse(parseSplit[4]);
        this.Italic = byte.Parse(parseSplit[5]);
        this.Underline = byte.Parse(parseSplit[6]);
        this.StrikeOut = byte.Parse(parseSplit[7]);
        this.FontCharSet = byte.Parse(parseSplit[8]);
        this.OutPrecision = byte.Parse(parseSplit[9]);
        this.ClipPrecision = byte.Parse(parseSplit[10]);
        this.Quality = byte.Parse(parseSplit[11]);
        this.PitchAndFamily = byte.Parse(parseSplit[12]);
        this.FaceName = parseSplit[13];
    }

    public override string ToString()
    {
        return string.Format("{0} {1} {2} {3} {4} {5} {6} {7} {8} {9} {10} {11} {12} {13}",
            this.Height, this.Width, this.Escapement, this.Orientation, this.Weight,
            this.Italic, this.Underline, this.StrikeOut, this.FontCharSet, this.OutPrecision,
            this.ClipPrecision, this.Quality, this.PitchAndFamily, this.FaceName);
    }
}

public void MacroFont()
{
    IFontLists zenonFontLists = this.ActiveDocument.FontLists;
    IFontList zenonFontList = zenonFontLists.Item(0);
    //Create new font with id 6
    zenonFontList.Create(6);
    IFontItem zenonFont = zenonFontList.ItemById(6);
    //Creates a new Webdings LogFont
    LogFont newFont = new LogFont(-22, 0, 0, 0, 0, 0, 0, 0, 0, 3, 2, 5, 34, "Webdings");
    zenonFont.set_DynProperties("Font", newFont.ToString());
    zenonFont.set_DynProperties("Name", "Webdings Font");
}
VB.NET
Copy
<StructLayout(LayoutKind.Sequential, CharSet := CharSet.Auto)> _
Public Class LogFont
    <MarshalAs(UnmanagedType.ByValTStr, SizeConst := 32)> _
    Private _faceName As String

    Public Property Height() As Integer
        Get
            Return m_Height
        End Get
        Set
            m_Height = Value
        End Set
    End Property
    Private m_Height As Integer
    Public Property Width() As Integer
        Get
            Return m_Width
        End Get
        Set
            m_Width = Value
        End Set
    End Property
    Private m_Width As Integer
    Public Property Escapement() As Integer
        Get
            Return m_Escapement
        End Get
        Set
            m_Escapement = Value
        End Set
    End Property
    Private m_Escapement As Integer
    Public Property Orientation() As Integer
        Get
            Return m_Orientation
        End Get
        Set
            m_Orientation = Value
        End Set
    End Property
    Private m_Orientation As Integer
    Public Property Weight() As Integer
        Get
            Return m_Weight
        End Get
        Set
            m_Weight = Value
        End Set
    End Property
    Private m_Weight As Integer
    Public Property Italic() As Byte
        Get
            Return m_Italic
        End Get
        Set
            m_Italic = Value
        End Set
    End Property
    Private m_Italic As Byte
    Public Property Underline() As Byte
        Get
            Return m_Underline
        End Get
        Set
            m_Underline = Value
        End Set
    End Property
    Private m_Underline As Byte
    Public Property StrikeOut() As Byte
        Get
            Return m_StrikeOut
        End Get
        Set
            m_StrikeOut = Value
        End Set
    End Property
    Private m_StrikeOut As Byte
    Public Property FontCharSet() As Byte
        Get
            Return m_FontCharSet
        End Get
        Set
            m_FontCharSet = Value
        End Set
    End Property
    Private m_FontCharSet As Byte
    Public Property OutPrecision() As Byte
        Get
            Return m_OutPrecision
        End Get
        Set
            m_OutPrecision = Value
        End Set
    End Property
    Private m_OutPrecision As Byte
    Public Property ClipPrecision() As Byte
        Get
            Return m_ClipPrecision
        End Get
        Set
            m_ClipPrecision = Value
        End Set
    End Property
    Private m_ClipPrecision As Byte
    Public Property Quality() As Byte
        Get
            Return m_Quality
        End Get
        Set
            m_Quality = Value
        End Set
    End Property
    Private m_Quality As Byte
    Public Property PitchAndFamily() As Byte
        Get
            Return m_PitchAndFamily
        End Get
        Set
            m_PitchAndFamily = Value
        End Set
    End Property
    Private m_PitchAndFamily As Byte
    Public Property FaceName() As String
        Get
            Return _faceName
        End Get
        Set
            If value.Length > 32 Then
                _faceName = value.Substring(0, 32)
            Else
                _faceName = value
            End If
        End Set
    End Property

    Public Sub New(height As Integer, width As Integer, escape As Integer, orient As Integer, weight As Integer, italic As Byte, _
        underline As Byte, strikeout As Byte, charSet As Byte, outPrecision As Byte, clipPrecision As Byte, quality As Byte, _
        pitchAndFamily As Byte, faceName As String)
        Me.Height = height
        Me.Width = width
        Me.Escapement = escape
        Me.Orientation = orient
        Me.Weight = weight
        Me.Italic = italic
        Me.Underline = underline
        Me.StrikeOut = strikeout
        Me.FontCharSet = charSet
        Me.OutPrecision = outPrecision
        Me.ClipPrecision = clipPrecision
        Me.Quality = quality
        Me.PitchAndFamily = pitchAndFamily
        Me.FaceName = faceName
    End Sub

    Public Sub New(s As String)
        Dim parseSplit As String() = s.Split(" "C)
        Me.Height = Integer.Parse(parseSplit(0))
        Me.Width = Integer.Parse(parseSplit(1))
        Me.Escapement = Integer.Parse(parseSplit(2))
        Me.Orientation = Integer.Parse(parseSplit(3))
        Me.Weight = Integer.Parse(parseSplit(4))
        Me.Italic = Byte.Parse(parseSplit(5))
        Me.Underline = Byte.Parse(parseSplit(6))
        Me.StrikeOut = Byte.Parse(parseSplit(7))
        Me.FontCharSet = Byte.Parse(parseSplit(8))
        Me.OutPrecision = Byte.Parse(parseSplit(9))
        Me.ClipPrecision = Byte.Parse(parseSplit(10))
        Me.Quality = Byte.Parse(parseSplit(11))
        Me.PitchAndFamily = Byte.Parse(parseSplit(12))
        Me.FaceName = parseSplit(13)
    End Sub

    Public Overrides Function ToString() As String
        Return String.Format("{0} {1} {2} {3} {4} {5} {6} {7} {8} {9} {10} {11} {12} {13}", Me.Height, Me.Width, Me.Escapement, Me.Orientation, Me.Weight, _
            Me.Italic, Me.Underline, Me.StrikeOut, Me.FontCharSet, Me.OutPrecision, Me.ClipPrecision, _
            Me.Quality, Me.PitchAndFamily, Me.FaceName)
    End Function
End Class

Public Sub MacroFont()
    Dim zenonFontLists As IFontLists = Me.ActiveDocument.FontLists
    Dim zenonFontList As IFontList = zenonFontLists.Item(0)
    'Create new font with id 6
    zenonFontList.Create(6)
    Dim zenonFont As IFontItem = zenonFontList.ItemById(6)
    'Creates a new Webdings LogFont
    Dim newFont As New LogFont(-22, 0, 0, 0, 0, 0, _
        0, 0, 0, 3, 2, 5, _
        34, "Webdings")
    zenonFont.set_DynProperties("Font", newFont.ToString())
    zenonFont.set_DynProperties("Name", "Webdings Font")
End Sub


DynProperties [GET]
ObjectModel COM [image] FontList [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] FontList [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.


DynPropertiesEnum [GET]
ObjectModel COM [image] FontList [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"


DynPropertyParam [GET]
ObjectModel COM [image] FontList [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Item
ObjectModel COM [image] FontList [image] Methods [image] Item
Remarks

Returns a specific FontItem object from the list identified by its zero based index.

Datatype
IFontItem

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lIndex as long

Index of the font to be returned.

Example
C#
Copy
[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
public class LogFont
{
    [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 32)]
    private string _faceName;

    public int Height { get; set; }
    public int Width { get; set; }
    public int Escapement { get; set; }
    public int Orientation  { get; set; }
    public int Weight { get; set; }
    public byte Italic  { get; set; }
    public byte Underline { get; set; }
    public byte StrikeOut { get; set; }
    public byte FontCharSet { get; set; }
    public byte OutPrecision { get; set; }
    public byte ClipPrecision { get; set; }
    public byte Quality { get; set; }
    public byte PitchAndFamily { get; set; }
    public string FaceName
    {
        get
        {
            return _faceName;
        }
        set
        {
            if (value.Length > 32)
                _faceName = value.Substring(0, 32);
            else
                _faceName = value;
        }
    }

    public LogFont(int height, int width, int escape, int orient, int weight,
        byte italic, byte underline, byte strikeout, byte charSet, byte outPrecision,
        byte clipPrecision, byte quality, byte pitchAndFamily, string faceName)
    {
        this.Height = height;
        this.Width = width;
        this.Escapement = escape;
        this.Orientation = orient;
        this.Weight = weight;
        this.Italic = italic;
        this.Underline = underline;
        this.StrikeOut = strikeout;
        this.FontCharSet = charSet;
        this.OutPrecision = outPrecision;
        this.ClipPrecision = clipPrecision;
        this.Quality = quality;
        this.PitchAndFamily = pitchAndFamily;
        this.FaceName = faceName;
    }

    public LogFont(string s)
    {
        string[] parseSplit = s.Split(' ');
        this.Height = int.Parse(parseSplit[0]);
        this.Width = int.Parse(parseSplit[1]);
        this.Escapement = int.Parse(parseSplit[2]);
        this.Orientation = int.Parse(parseSplit[3]);
        this.Weight = int.Parse(parseSplit[4]);
        this.Italic = byte.Parse(parseSplit[5]);
        this.Underline = byte.Parse(parseSplit[6]);
        this.StrikeOut = byte.Parse(parseSplit[7]);
        this.FontCharSet = byte.Parse(parseSplit[8]);
        this.OutPrecision = byte.Parse(parseSplit[9]);
        this.ClipPrecision = byte.Parse(parseSplit[10]);
        this.Quality = byte.Parse(parseSplit[11]);
        this.PitchAndFamily = byte.Parse(parseSplit[12]);
        this.FaceName = parseSplit[13];
    }

    public override string ToString()
    {
        return string.Format("{0} {1} {2} {3} {4} {5} {6} {7} {8} {9} {10} {11} {12} {13}",
            this.Height, this.Width, this.Escapement, this.Orientation, this.Weight,
            this.Italic, this.Underline, this.StrikeOut, this.FontCharSet, this.OutPrecision,
            this.ClipPrecision, this.Quality, this.PitchAndFamily, this.FaceName);
    }
}

public void MacroFont()
{
    IFontLists zenonFontLists = this.ActiveDocument.FontLists;
    for (int i = 0; i < zenonFontLists.Count; ++i )
    {

        IFontList zenonFontList = zenonFontLists.Item(i);
        //Loop through all fonts and set the height to 10
        for (int j = 0; j < zenonFontList.Count; ++j)
        {
            IFontItem zenonFont = zenonFontList.Item(j);
            //Parse the LogFont string of the font
            LogFont lf = new LogFont((string)zenonFont.get_DynProperties("Font"));
            lf.Height = -27;
            //Change the height value and set the Font property again
            zenonFont.set_DynProperties("Font", lf.ToString());

        }

    }
}
VB.NET
Copy
'Define LogFont Structure
<StructLayout(LayoutKind.Sequential, CharSet := CharSet.Auto)> _
Public Class LogFont
    <MarshalAs(UnmanagedType.ByValTStr, SizeConst := 32)> _
    Private _faceName As String

    Public Property Height() As Integer
        Get
            Return m_Height
        End Get
        Set
            m_Height = Value
        End Set
    End Property
    Private m_Height As Integer
    Public Property Width() As Integer
        Get
            Return m_Width
        End Get
        Set
            m_Width = Value
        End Set
    End Property
    Private m_Width As Integer
    Public Property Escapement() As Integer
        Get
            Return m_Escapement
        End Get
        Set
            m_Escapement = Value
        End Set
    End Property
    Private m_Escapement As Integer
    Public Property Orientation() As Integer
        Get
            Return m_Orientation
        End Get
        Set
            m_Orientation = Value
        End Set
    End Property
    Private m_Orientation As Integer
    Public Property Weight() As Integer
        Get
            Return m_Weight
        End Get
        Set
            m_Weight = Value
        End Set
    End Property
    Private m_Weight As Integer
    Public Property Italic() As Byte
        Get
            Return m_Italic
        End Get
        Set
            m_Italic = Value
        End Set
    End Property
    Private m_Italic As Byte
    Public Property Underline() As Byte
        Get
            Return m_Underline
        End Get
        Set
            m_Underline = Value
        End Set
    End Property
    Private m_Underline As Byte
    Public Property StrikeOut() As Byte
        Get
            Return m_StrikeOut
        End Get
        Set
            m_StrikeOut = Value
        End Set
    End Property
    Private m_StrikeOut As Byte
    Public Property FontCharSet() As Byte
        Get
            Return m_FontCharSet
        End Get
        Set
            m_FontCharSet = Value
        End Set
    End Property
    Private m_FontCharSet As Byte
    Public Property OutPrecision() As Byte
        Get
            Return m_OutPrecision
        End Get
        Set
            m_OutPrecision = Value
        End Set
    End Property
    Private m_OutPrecision As Byte
    Public Property ClipPrecision() As Byte
        Get
            Return m_ClipPrecision
        End Get
        Set
            m_ClipPrecision = Value
        End Set
    End Property
    Private m_ClipPrecision As Byte
    Public Property Quality() As Byte
        Get
            Return m_Quality
        End Get
        Set
            m_Quality = Value
        End Set
    End Property
    Private m_Quality As Byte
    Public Property PitchAndFamily() As Byte
        Get
            Return m_PitchAndFamily
        End Get
        Set
            m_PitchAndFamily = Value
        End Set
    End Property
    Private m_PitchAndFamily As Byte
    Public Property FaceName() As String
        Get
            Return _faceName
        End Get
        Set
            If value.Length > 32 Then
                _faceName = value.Substring(0, 32)
            Else
                _faceName = value
            End If
        End Set
    End Property

    Public Sub New(height As Integer, width As Integer, escape As Integer, orient As Integer, weight As Integer, italic As Byte, _
        underline As Byte, strikeout As Byte, charSet As Byte, outPrecision As Byte, clipPrecision As Byte, quality As Byte, _
        pitchAndFamily As Byte, faceName As String)
        Me.Height = height
        Me.Width = width
        Me.Escapement = escape
        Me.Orientation = orient
        Me.Weight = weight
        Me.Italic = italic
        Me.Underline = underline
        Me.StrikeOut = strikeout
        Me.FontCharSet = charSet
        Me.OutPrecision = outPrecision
        Me.ClipPrecision = clipPrecision
        Me.Quality = quality
        Me.PitchAndFamily = pitchAndFamily
        Me.FaceName = faceName
    End Sub

    Public Sub New(s As String)
        Dim parseSplit As String() = s.Split(" "C)
        Me.Height = Integer.Parse(parseSplit(0))
        Me.Width = Integer.Parse(parseSplit(1))
        Me.Escapement = Integer.Parse(parseSplit(2))
        Me.Orientation = Integer.Parse(parseSplit(3))
        Me.Weight = Integer.Parse(parseSplit(4))
        Me.Italic = Byte.Parse(parseSplit(5))
        Me.Underline = Byte.Parse(parseSplit(6))
        Me.StrikeOut = Byte.Parse(parseSplit(7))
        Me.FontCharSet = Byte.Parse(parseSplit(8))
        Me.OutPrecision = Byte.Parse(parseSplit(9))
        Me.ClipPrecision = Byte.Parse(parseSplit(10))
        Me.Quality = Byte.Parse(parseSplit(11))
        Me.PitchAndFamily = Byte.Parse(parseSplit(12))
        Me.FaceName = parseSplit(13)
    End Sub

    Public Overrides Function ToString() As String
        Return String.Format("{0} {1} {2} {3} {4} {5} {6} {7} {8} {9} {10} {11} {12} {13}", Me.Height, Me.Width, Me.Escapement, Me.Orientation, Me.Weight, _
            Me.Italic, Me.Underline, Me.StrikeOut, Me.FontCharSet, Me.OutPrecision, Me.ClipPrecision, _
            Me.Quality, Me.PitchAndFamily, Me.FaceName)
    End Function
End Class

Public Sub MacroFont()
    Dim zenonFontLists As IFontLists = Me.ActiveDocument.FontLists
    For i As Integer = 0 To zenonFontLists.Count - 1

        Dim zenonFontList As IFontList = zenonFontLists.Item(i)
        'Loop through all fonts and set the height to 10
        For j As Integer = 0 To zenonFontList.Count - 1
            Dim zenonFont As IFontItem = zenonFontList.Item(j)
            'Parse the LogFont string of the font
            Dim lf As New LogFont(DirectCast(zenonFont.get_DynProperties("Font"), String))
            lf.Height = -27
            'Change the height value and set the Font property again

            zenonFont.set_DynProperties("Font", lf.ToString())

        Next
    Next
End Sub


ItemById
ObjectModel COM [image] FontList [image] Methods [image] ItemById
Remarks

Gets a specific FontItem object from the list by its unique identifier (Which can be found in the editor) - Use this if you want to access a specific object instead of enumerating through the list as a whole.

Datatype
IFontItem

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lId as long

ID of the font to be returned.

Example
C#
Copy
[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
public class LogFont
{
    [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 32)]
    private string _faceName;

    public int Height { get; set; }
    public int Width { get; set; }
    public int Escapement { get; set; }
    public int Orientation  { get; set; }
    public int Weight { get; set; }
    public byte Italic  { get; set; }
    public byte Underline { get; set; }
    public byte StrikeOut { get; set; }
    public byte FontCharSet { get; set; }
    public byte OutPrecision { get; set; }
    public byte ClipPrecision { get; set; }
    public byte Quality { get; set; }
    public byte PitchAndFamily { get; set; }
    public string FaceName
    {
        get
        {
            return _faceName;
        }
        set
        {
            if (value.Length > 32)
                _faceName = value.Substring(0, 32);
            else
                _faceName = value;
        }
    }

    public LogFont(int height, int width, int escape, int orient, int weight,
        byte italic, byte underline, byte strikeout, byte charSet, byte outPrecision,
        byte clipPrecision, byte quality, byte pitchAndFamily, string faceName)
    {
        this.Height = height;
        this.Width = width;
        this.Escapement = escape;
        this.Orientation = orient;
        this.Weight = weight;
        this.Italic = italic;
        this.Underline = underline;
        this.StrikeOut = strikeout;
        this.FontCharSet = charSet;
        this.OutPrecision = outPrecision;
        this.ClipPrecision = clipPrecision;
        this.Quality = quality;
        this.PitchAndFamily = pitchAndFamily;
        this.FaceName = faceName;
    }

    public LogFont(string s)
    {
        string[] parseSplit = s.Split(' ');
        this.Height = int.Parse(parseSplit[0]);
        this.Width = int.Parse(parseSplit[1]);
        this.Escapement = int.Parse(parseSplit[2]);
        this.Orientation = int.Parse(parseSplit[3]);
        this.Weight = int.Parse(parseSplit[4]);
        this.Italic = byte.Parse(parseSplit[5]);
        this.Underline = byte.Parse(parseSplit[6]);
        this.StrikeOut = byte.Parse(parseSplit[7]);
        this.FontCharSet = byte.Parse(parseSplit[8]);
        this.OutPrecision = byte.Parse(parseSplit[9]);
        this.ClipPrecision = byte.Parse(parseSplit[10]);
        this.Quality = byte.Parse(parseSplit[11]);
        this.PitchAndFamily = byte.Parse(parseSplit[12]);
        this.FaceName = parseSplit[13];
    }

    public override string ToString()
    {
        return string.Format("{0} {1} {2} {3} {4} {5} {6} {7} {8} {9} {10} {11} {12} {13}",
            this.Height, this.Width, this.Escapement, this.Orientation, this.Weight,
            this.Italic, this.Underline, this.StrikeOut, this.FontCharSet, this.OutPrecision,
            this.ClipPrecision, this.Quality, this.PitchAndFamily, this.FaceName);
    }
}

public void MacroFont()
{
    IFontLists zenonFontLists = this.ActiveDocument.FontLists;
    for (int i = 0; i < zenonFontLists.Count; ++i)
    {

        IFontList zenonFontList = zenonFontLists.Item(i);

        //Gets a specific font specified by its unique identifier
        IFontItem zenonFont = zenonFontList.ItemById(4);
        //Parse the LogFont string of the font
        LogFont lf = new LogFont((string)zenonFont.get_DynProperties("Font"));
        lf.Height = -27;
        //Change the height value and set the Font property again
        zenonFont.set_DynProperties("Font", lf.ToString());

    }
}
VB.NET
Copy
'Define LogFont Structure
<StructLayout(LayoutKind.Sequential, CharSet := CharSet.Auto)> _
Public Class LogFont
    <MarshalAs(UnmanagedType.ByValTStr, SizeConst := 32)> _
    Private _faceName As String

    Public Property Height() As Integer
        Get
            Return m_Height
        End Get
        Set
            m_Height = Value
        End Set
    End Property
    Private m_Height As Integer
    Public Property Width() As Integer
        Get
            Return m_Width
        End Get
        Set
            m_Width = Value
        End Set
    End Property
    Private m_Width As Integer
    Public Property Escapement() As Integer
        Get
            Return m_Escapement
        End Get
        Set
            m_Escapement = Value
        End Set
    End Property
    Private m_Escapement As Integer
    Public Property Orientation() As Integer
        Get
            Return m_Orientation
        End Get
        Set
            m_Orientation = Value
        End Set
    End Property
    Private m_Orientation As Integer
    Public Property Weight() As Integer
        Get
            Return m_Weight
        End Get
        Set
            m_Weight = Value
        End Set
    End Property
    Private m_Weight As Integer
    Public Property Italic() As Byte
        Get
            Return m_Italic
        End Get
        Set
            m_Italic = Value
        End Set
    End Property
    Private m_Italic As Byte
    Public Property Underline() As Byte
        Get
            Return m_Underline
        End Get
        Set
            m_Underline = Value
        End Set
    End Property
    Private m_Underline As Byte
    Public Property StrikeOut() As Byte
        Get
            Return m_StrikeOut
        End Get
        Set
            m_StrikeOut = Value
        End Set
    End Property
    Private m_StrikeOut As Byte
    Public Property FontCharSet() As Byte
        Get
            Return m_FontCharSet
        End Get
        Set
            m_FontCharSet = Value
        End Set
    End Property
    Private m_FontCharSet As Byte
    Public Property OutPrecision() As Byte
        Get
            Return m_OutPrecision
        End Get
        Set
            m_OutPrecision = Value
        End Set
    End Property
    Private m_OutPrecision As Byte
    Public Property ClipPrecision() As Byte
        Get
            Return m_ClipPrecision
        End Get
        Set
            m_ClipPrecision = Value
        End Set
    End Property
    Private m_ClipPrecision As Byte
    Public Property Quality() As Byte
        Get
            Return m_Quality
        End Get
        Set
            m_Quality = Value
        End Set
    End Property
    Private m_Quality As Byte
    Public Property PitchAndFamily() As Byte
        Get
            Return m_PitchAndFamily
        End Get
        Set
            m_PitchAndFamily = Value
        End Set
    End Property
    Private m_PitchAndFamily As Byte
    Public Property FaceName() As String
        Get
            Return _faceName
        End Get
        Set
            If value.Length > 32 Then
                _faceName = value.Substring(0, 32)
            Else
                _faceName = value
            End If
        End Set
    End Property

    Public Sub New(height As Integer, width As Integer, escape As Integer, orient As Integer, weight As Integer, italic As Byte, _
        underline As Byte, strikeout As Byte, charSet As Byte, outPrecision As Byte, clipPrecision As Byte, quality As Byte, _
        pitchAndFamily As Byte, faceName As String)
        Me.Height = height
        Me.Width = width
        Me.Escapement = escape
        Me.Orientation = orient
        Me.Weight = weight
        Me.Italic = italic
        Me.Underline = underline
        Me.StrikeOut = strikeout
        Me.FontCharSet = charSet
        Me.OutPrecision = outPrecision
        Me.ClipPrecision = clipPrecision
        Me.Quality = quality
        Me.PitchAndFamily = pitchAndFamily
        Me.FaceName = faceName
    End Sub

    Public Sub New(s As String)
        Dim parseSplit As String() = s.Split(" "C)
        Me.Height = Integer.Parse(parseSplit(0))
        Me.Width = Integer.Parse(parseSplit(1))
        Me.Escapement = Integer.Parse(parseSplit(2))
        Me.Orientation = Integer.Parse(parseSplit(3))
        Me.Weight = Integer.Parse(parseSplit(4))
        Me.Italic = Byte.Parse(parseSplit(5))
        Me.Underline = Byte.Parse(parseSplit(6))
        Me.StrikeOut = Byte.Parse(parseSplit(7))
        Me.FontCharSet = Byte.Parse(parseSplit(8))
        Me.OutPrecision = Byte.Parse(parseSplit(9))
        Me.ClipPrecision = Byte.Parse(parseSplit(10))
        Me.Quality = Byte.Parse(parseSplit(11))
        Me.PitchAndFamily = Byte.Parse(parseSplit(12))
        Me.FaceName = parseSplit(13)
    End Sub

    Public Overrides Function ToString() As String
        Return String.Format("{0} {1} {2} {3} {4} {5} {6} {7} {8} {9} {10} {11} {12} {13}", Me.Height, Me.Width, Me.Escapement, Me.Orientation, Me.Weight, _
            Me.Italic, Me.Underline, Me.StrikeOut, Me.FontCharSet, Me.OutPrecision, Me.ClipPrecision, _
            Me.Quality, Me.PitchAndFamily, Me.FaceName)
    End Function
End Class

Public Sub MacroFont()
    Dim zenonFontLists As IFontLists = Me.ActiveDocument.FontLists
    For i As Integer = 0 To zenonFontLists.Count - 1

        Dim zenonFontList As IFontList = zenonFontLists.Item(i)

        'Gets a specific font specified by its unique identifier
        Dim zenonFont As IFontItem = zenonFontList.ItemById(4)
        'Parse the LogFont string of the font
        Dim lf As New LogFont(DirectCast(zenonFont.get_DynProperties("Font"), String))
        lf.Height = -27
        'Change the height value and set the Font property again

        zenonFont.set_DynProperties("Font", lf.ToString())
    Next
End Sub


DynProperties
ObjectModel COM [image] FontList [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Fontlist


Fontlist
ObjectModel COM [image] FontList [image] DynProperties [image] Fontlist
Overview
External Name | Type | Display Name | Description
Name | String | Name | Name of the font list. .


FontLists
ObjectModel COM [image] FontLists
Remarks

Contains the FontList objects of a project. Since a project can have multiple font lists this is an enumerator class to access them.

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
public class LogFont
{
    [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 32)]
    private string _faceName;

    public int Height { get; set; }
    public int Width { get; set; }
    public int Escapement { get; set; }
    public int Orientation  { get; set; }
    public int Weight { get; set; }
    public byte Italic  { get; set; }
    public byte Underline { get; set; }
    public byte StrikeOut { get; set; }
    public byte FontCharSet { get; set; }
    public byte OutPrecision { get; set; }
    public byte ClipPrecision { get; set; }
    public byte Quality { get; set; }
    public byte PitchAndFamily { get; set; }
    public string FaceName
    {
        get
        {
            return _faceName;
        }
        set
        {
            if (value.Length > 32)
                _faceName = value.Substring(0, 32);
            else
                _faceName = value;
        }
    }

    public LogFont(int height, int width, int escape, int orient, int weight,
        byte italic, byte underline, byte strikeout, byte charSet, byte outPrecision,
        byte clipPrecision, byte quality, byte pitchAndFamily, string faceName)
    {
        this.Height = height;
        this.Width = width;
        this.Escapement = escape;
        this.Orientation = orient;
        this.Weight = weight;
        this.Italic = italic;
        this.Underline = underline;
        this.StrikeOut = strikeout;
        this.FontCharSet = charSet;
        this.OutPrecision = outPrecision;
        this.ClipPrecision = clipPrecision;
        this.Quality = quality;
        this.PitchAndFamily = pitchAndFamily;
        this.FaceName = faceName;
    }

    public LogFont(string s)
    {
        string[] parseSplit = s.Split(' ');
        this.Height = int.Parse(parseSplit[0]);
        this.Width = int.Parse(parseSplit[1]);
        this.Escapement = int.Parse(parseSplit[2]);
        this.Orientation = int.Parse(parseSplit[3]);
        this.Weight = int.Parse(parseSplit[4]);
        this.Italic = byte.Parse(parseSplit[5]);
        this.Underline = byte.Parse(parseSplit[6]);
        this.StrikeOut = byte.Parse(parseSplit[7]);
        this.FontCharSet = byte.Parse(parseSplit[8]);
        this.OutPrecision = byte.Parse(parseSplit[9]);
        this.ClipPrecision = byte.Parse(parseSplit[10]);
        this.Quality = byte.Parse(parseSplit[11]);
        this.PitchAndFamily = byte.Parse(parseSplit[12]);
        this.FaceName = parseSplit[13];
    }

    public override string ToString()
    {
        return string.Format("{0} {1} {2} {3} {4} {5} {6} {7} {8} {9} {10} {11} {12} {13}",
            this.Height, this.Width, this.Escapement, this.Orientation, this.Weight,
            this.Italic, this.Underline, this.StrikeOut, this.FontCharSet, this.OutPrecision,
            this.ClipPrecision, this.Quality, this.PitchAndFamily, this.FaceName);
    }
}

public void MacroFont()
{
    IFontLists zenonFontLists = this.ActiveDocument.FontLists;
    for (int i = 0; i < zenonFontLists.Count; ++i )
    {

        IFontList zenonFontList = zenonFontLists.Item(i);
        //Loop through all fonts and set the height to 10
        for (int j = 0; j < zenonFontList.Count; ++j)
        {
            IFontItem zenonFont = zenonFontList.Item(j);
            //Parse the LogFont string of the font
            LogFont lf = new LogFont((string)zenonFont.get_DynProperties("Font"));
            lf.Height = -27;
            //Change the height value and set the Font property again
            zenonFont.set_DynProperties("Font", lf.ToString());

        }

    }
}
VB.NET
Copy
<StructLayout(LayoutKind.Sequential, CharSet := CharSet.Auto)> _
Public Class LogFont
    <MarshalAs(UnmanagedType.ByValTStr, SizeConst := 32)> _
    Private _faceName As String

    Public Property Height() As Integer
        Get
            Return m_Height
        End Get
        Set
            m_Height = Value
        End Set
    End Property
    Private m_Height As Integer
    Public Property Width() As Integer
        Get
            Return m_Width
        End Get
        Set
            m_Width = Value
        End Set
    End Property
    Private m_Width As Integer
    Public Property Escapement() As Integer
        Get
            Return m_Escapement
        End Get
        Set
            m_Escapement = Value
        End Set
    End Property
    Private m_Escapement As Integer
    Public Property Orientation() As Integer
        Get
            Return m_Orientation
        End Get
        Set
            m_Orientation = Value
        End Set
    End Property
    Private m_Orientation As Integer
    Public Property Weight() As Integer
        Get
            Return m_Weight
        End Get
        Set
            m_Weight = Value
        End Set
    End Property
    Private m_Weight As Integer
    Public Property Italic() As Byte
        Get
            Return m_Italic
        End Get
        Set
            m_Italic = Value
        End Set
    End Property
    Private m_Italic As Byte
    Public Property Underline() As Byte
        Get
            Return m_Underline
        End Get
        Set
            m_Underline = Value
        End Set
    End Property
    Private m_Underline As Byte
    Public Property StrikeOut() As Byte
        Get
            Return m_StrikeOut
        End Get
        Set
            m_StrikeOut = Value
        End Set
    End Property
    Private m_StrikeOut As Byte
    Public Property FontCharSet() As Byte
        Get
            Return m_FontCharSet
        End Get
        Set
            m_FontCharSet = Value
        End Set
    End Property
    Private m_FontCharSet As Byte
    Public Property OutPrecision() As Byte
        Get
            Return m_OutPrecision
        End Get
        Set
            m_OutPrecision = Value
        End Set
    End Property
    Private m_OutPrecision As Byte
    Public Property ClipPrecision() As Byte
        Get
            Return m_ClipPrecision
        End Get
        Set
            m_ClipPrecision = Value
        End Set
    End Property
    Private m_ClipPrecision As Byte
    Public Property Quality() As Byte
        Get
            Return m_Quality
        End Get
        Set
            m_Quality = Value
        End Set
    End Property
    Private m_Quality As Byte
    Public Property PitchAndFamily() As Byte
        Get
            Return m_PitchAndFamily
        End Get
        Set
            m_PitchAndFamily = Value
        End Set
    End Property
    Private m_PitchAndFamily As Byte
    Public Property FaceName() As String
        Get
            Return _faceName
        End Get
        Set
            If value.Length > 32 Then
                _faceName = value.Substring(0, 32)
            Else
                _faceName = value
            End If
        End Set
    End Property

    Public Sub New(height As Integer, width As Integer, escape As Integer, orient As Integer, weight As Integer, italic As Byte, _
        underline As Byte, strikeout As Byte, charSet As Byte, outPrecision As Byte, clipPrecision As Byte, quality As Byte, _
        pitchAndFamily As Byte, faceName As String)
        Me.Height = height
        Me.Width = width
        Me.Escapement = escape
        Me.Orientation = orient
        Me.Weight = weight
        Me.Italic = italic
        Me.Underline = underline
        Me.StrikeOut = strikeout
        Me.FontCharSet = charSet
        Me.OutPrecision = outPrecision
        Me.ClipPrecision = clipPrecision
        Me.Quality = quality
        Me.PitchAndFamily = pitchAndFamily
        Me.FaceName = faceName
    End Sub

    Public Sub New(s As String)
        Dim parseSplit As String() = s.Split(" "C)
        Me.Height = Integer.Parse(parseSplit(0))
        Me.Width = Integer.Parse(parseSplit(1))
        Me.Escapement = Integer.Parse(parseSplit(2))
        Me.Orientation = Integer.Parse(parseSplit(3))
        Me.Weight = Integer.Parse(parseSplit(4))
        Me.Italic = Byte.Parse(parseSplit(5))
        Me.Underline = Byte.Parse(parseSplit(6))
        Me.StrikeOut = Byte.Parse(parseSplit(7))
        Me.FontCharSet = Byte.Parse(parseSplit(8))
        Me.OutPrecision = Byte.Parse(parseSplit(9))
        Me.ClipPrecision = Byte.Parse(parseSplit(10))
        Me.Quality = Byte.Parse(parseSplit(11))
        Me.PitchAndFamily = Byte.Parse(parseSplit(12))
        Me.FaceName = parseSplit(13)
    End Sub

    Public Overrides Function ToString() As String
        Return String.Format("{0} {1} {2} {3} {4} {5} {6} {7} {8} {9} {10} {11} {12} {13}", Me.Height, Me.Width, Me.Escapement, Me.Orientation, Me.Weight, _
            Me.Italic, Me.Underline, Me.StrikeOut, Me.FontCharSet, Me.OutPrecision, Me.ClipPrecision, _
            Me.Quality, Me.PitchAndFamily, Me.FaceName)
    End Function
End Class

Public Sub MacroFont()
    Dim zenonFontLists As IFontLists = Me.ActiveDocument.FontLists
    For i As Integer = 0 To zenonFontLists.Count - 1

        Dim zenonFontList As IFontList = zenonFontLists.Item(i)
        'Loop through all fonts and set the height to 10
        For j As Integer = 0 To zenonFontList.Count - 1
            Dim zenonFont As IFontItem = zenonFontList.Item(j)
            'Parse the LogFont string of the font
            Dim lf As New LogFont(DirectCast(zenonFont.get_DynProperties("Font"), String))
            lf.Height = -27
            'Change the height value and set the Font property again

            zenonFont.set_DynProperties("Font", lf.ToString())

        Next
    Next
End Sub
VBA
Copy
'Type definition of LOGFONT type (see MSDN)
Type LOGFONT
Height As Long
Width As Long
Escapement As Long
Orientation As Long
Weight As Long
Italic As Byte
Underline As Byte
StrikeOut As Byte
CharSet As Byte
OutPrecision As Byte
ClipPrecision As Byte
Quality As Byte
PitchAndFamily As Byte
FaceName As String * 32
End Type
Sub GetFontList()
Dim zPRJ As Project
Dim zFLs As FontLists
Dim zFL As FontList
Dim zFI As FontItem
Dim i As Integer
Dim n As Integer
Dim lf As LOGFONT
Set zPRJ = MyWorkspace.ActiveDocument
Set zFLs = zPRJ.FontLists
'enumerate all fontlists of the active project
For i = 0 To zFLs.Count - 1

Set zFL = zFLs.Item(i)

Debug.Print "Fontlist: " & zFL.DynProperties("Name")

'enumrate fonts of a fontlist

For n = 0 To zFL.Count - 1

Set zFI = zFL.Item(n)

Debug.Print zFI.DynProperties("Number")

Debug.Print zFI.DynProperties("Name")

Debug.Print zFI.DynProperties("Font")

'convert string to LOGFONT type in a function

lf = GetLogFontFromString(zFI.DynProperties("Font"))

Next n
Next i
End Sub
Sub CreateFontList()
Dim zPRJ As Project
Dim zFLs As FontLists
Dim zFL As FontList
Dim zFI As FontItem
Dim i As Integer
Dim lf As LOGFONT
Set zPRJ = MyWorkspace.ActiveDocument
Set zFLs = zPRJ.FontLists
'define font (LOGFONT)
lf.Height = 10
lf.Width = 0
lf.Escapement = 0
lf.Orientation = 0
lf.Weight = 400
lf.Italic = 0
lf.Underline = 0
lf.StrikeOut = 0
lf.CharSet = 0
lf.OutPrecision = 3
lf.ClipPrecision = 2
lf.Quality = 5
lf.PitchAndFamily = 34
lf.FaceName = String(25, " ") & "Courier" '32 - 7
'create new fontlist
Set zFL = zFLs.Create
With zFL

'set name of new fontlist

.DynProperties("Name") = "VBA_FontList3"

For i = 1 To 10

'create fonts in fontlist

Set zFI = zFL.Create(i)

zFI.DynProperties("Name") = "VBA_Font_" & Format(i, "00")

zFI.DynProperties("Font") = strFont

'modify LOGFONT definition

lf.Height = 10 + (i * 2)

'set font

zFI.DynProperties("Font") = GetStringFromLogFont(lf)

Next i

End With

End Sub
'CONVERT A STRING TO LOGFONT TYPE
Function GetLogFontFromString(strFont As String) As LOGFONT
Dim vSplit As Variant
Dim sFaceName As String
Dim i As Integer
vSplit = Split(strFont, " ")
GetLogFontFromString.Height = vSplit(0)
GetLogFontFromString.Width = vSplit(1)
GetLogFontFromString.Escapement = vSplit(2)
GetLogFontFromString.Orientation = vSplit(3)
GetLogFontFromString.Weight = vSplit(4)
GetLogFontFromString.Italic = vSplit(5)
GetLogFontFromString.Underline = vSplit(6)
GetLogFontFromString.StrikeOut = vSplit(7)
GetLogFontFromString.CharSet = vSplit(8)
GetLogFontFromString.OutPrecision = vSplit(9)
GetLogFontFromString.ClipPrecision = vSplit(10)
GetLogFontFromString.Quality = vSplit(11)
GetLogFontFromString.PitchAndFamily = vSplit(12)
For i = 13 To UBound(vSplit)

sFaceName = sFaceName & vSplit(i) & " "
Next i
sFaceName = RTrim(sFaceName)
sFaceName = String(32 - Len(sFaceName), " ") & sFaceName
GetLogFontFromString.FaceName = sFaceName
End Function
'CONVERT A LOGFONT TO STRING
Function GetStringFromLogFont(lfFont As LOGFONT) As String
GetStringFromLogFont = lfFont.Height & " " & _
lfFont.Width & " " & _
lfFont.Escapement & " " & _
lfFont.Orientation & " " & _
lfFont.Weight & " " & _
lfFont.Italic & " " & _
lfFont.Underline & " " & _
lfFont.StrikeOut & " " & _
lfFont.CharSet & " " & _
lfFont.OutPrecision & " " & _
lfFont.ClipPrecision & " " & _
lfFont.Quality & " " & _
lfFont.PitchAndFamily & " " & _
lfFont.FaceName
End Function


Properties
ObjectModel COM [image] FontLists [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the number of Fontlist objects. | Available | Unused | Available | Available


Count
ObjectModel COM [image] FontLists [image] Properties [image] Count
Remarks

Returns the number of Fontlist objects.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] FontLists [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | ifontlist | Create a new FontList. | Available | Unused | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
Item | ifontlist | Returns the FontList at the given index. | Available | Unused | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index | Available | Unused | Available | Available


Create
ObjectModel COM [image] FontLists [image] Methods [image] Create
Remarks

Creates a new FontList object in the collection.

Datatype
IFontList

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroFontListCreate()
{
    //Simply creates a new empty font list
    IFontLists zenonFontLists = this.ActiveDocument.FontLists;
    zenonFontLists.Create();
}
VB.NET
Copy
Public Sub MacroFontListCreate()
    'Simply creates a new empty font list
    Dim zenonFontLists As IFontLists = Me.ActiveDocument.FontLists
    zenonFontLists.Create()
End Sub


Export
ObjectModel COM [image] FontLists [image] Methods [image] Export
Remarks

Exports all font lists to a single xml file.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
C#
Copy
public void MacroFontListExport()
{
    //Export all font lists to a single xml file
    IFontLists zenonFontLists = this.ActiveDocument.FontLists;
    zenonFontLists.Export(@"C:\FontLists\exported.xml");
}
VB.NET
Copy
Public Sub MacroFontListExport()
    'Export all font lists to a single xml file
    Dim zenonFontLists As IFontLists = Me.ActiveDocument.FontLists
    zenonFontLists.Export("C:\FontLists\exported.xml")
End Sub


Import
ObjectModel COM [image] FontLists [image] Methods [image] Import
Remarks

Imports settings using a xml file. New settings are added, existing settings will be replaced.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Filename (path) as string of the xml file to import.

Example
C#
Copy
public void MacroFontListImport()
{
    //Import all font lists from a single xml file
    IFontLists zenonFontLists = this.ActiveDocument.FontLists;
    zenonFontLists.Import(@"C:\FontLists\exported.xml");
}
VB.NET
Copy
Public Sub MacroFontListExport()
    'Import all font lists from a single xml file
    Dim zenonFontLists As IFontLists = Me.ActiveDocument.FontLists
    zenonFontLists.Import("C:\FontLists\exported.xml")
End Sub
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
'Export settings to an xml file
zenOnObject.Export ("C:\zenOn_eXaMpLe.xml, False")
'Import settings from an xml file
zenOnObject.Import ("C:\zenOn_eXaMpLe.xml, False")

End Sub


Item
ObjectModel COM [image] FontLists [image] Methods [image] Item
Remarks

Returns a single FontList object in the collection identified by its index. (Enumerable)

Datatype
IFontList

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lIndex as long

Index of the fontlist to be returned.

Example
C#
Copy
[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
public class LogFont
{
    [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 32)]
    private string _faceName;

    public int Height { get; set; }
    public int Width { get; set; }
    public int Escapement { get; set; }
    public int Orientation  { get; set; }
    public int Weight { get; set; }
    public byte Italic  { get; set; }
    public byte Underline { get; set; }
    public byte StrikeOut { get; set; }
    public byte FontCharSet { get; set; }
    public byte OutPrecision { get; set; }
    public byte ClipPrecision { get; set; }
    public byte Quality { get; set; }
    public byte PitchAndFamily { get; set; }
    public string FaceName
    {
        get
        {
            return _faceName;
        }
        set
        {
            if (value.Length > 32)
                _faceName = value.Substring(0, 32);
            else
                _faceName = value;
        }
    }

    public LogFont(int height, int width, int escape, int orient, int weight,
        byte italic, byte underline, byte strikeout, byte charSet, byte outPrecision,
        byte clipPrecision, byte quality, byte pitchAndFamily, string faceName)
    {
        this.Height = height;
        this.Width = width;
        this.Escapement = escape;
        this.Orientation = orient;
        this.Weight = weight;
        this.Italic = italic;
        this.Underline = underline;
        this.StrikeOut = strikeout;
        this.FontCharSet = charSet;
        this.OutPrecision = outPrecision;
        this.ClipPrecision = clipPrecision;
        this.Quality = quality;
        this.PitchAndFamily = pitchAndFamily;
        this.FaceName = faceName;
    }

    public LogFont(string s)
    {
        string[] parseSplit = s.Split(' ');
        this.Height = int.Parse(parseSplit[0]);
        this.Width = int.Parse(parseSplit[1]);
        this.Escapement = int.Parse(parseSplit[2]);
        this.Orientation = int.Parse(parseSplit[3]);
        this.Weight = int.Parse(parseSplit[4]);
        this.Italic = byte.Parse(parseSplit[5]);
        this.Underline = byte.Parse(parseSplit[6]);
        this.StrikeOut = byte.Parse(parseSplit[7]);
        this.FontCharSet = byte.Parse(parseSplit[8]);
        this.OutPrecision = byte.Parse(parseSplit[9]);
        this.ClipPrecision = byte.Parse(parseSplit[10]);
        this.Quality = byte.Parse(parseSplit[11]);
        this.PitchAndFamily = byte.Parse(parseSplit[12]);
        this.FaceName = parseSplit[13];
    }

    public override string ToString()
    {
        return string.Format("{0} {1} {2} {3} {4} {5} {6} {7} {8} {9} {10} {11} {12} {13}",
            this.Height, this.Width, this.Escapement, this.Orientation, this.Weight,
            this.Italic, this.Underline, this.StrikeOut, this.FontCharSet, this.OutPrecision,
            this.ClipPrecision, this.Quality, this.PitchAndFamily, this.FaceName);
    }
}

public void MacroFont()
{
    IFontLists zenonFontLists = this.ActiveDocument.FontLists;
    for (int i = 0; i < zenonFontLists.Count; ++i )
    {

        IFontList zenonFontList = zenonFontLists.Item(i);
        //Loop through all fonts and set the height to 10
        for (int j = 0; j < zenonFontList.Count; ++j)
        {
            IFontItem zenonFont = zenonFontList.Item(j);
            //Parse the LogFont string of the font
            LogFont lf = new LogFont((string)zenonFont.get_DynProperties("Font"));
            lf.Height = -27;
            //Change the height value and set the Font property again
            zenonFont.set_DynProperties("Font", lf.ToString());

        }

    }
}
VB.NET
Copy
<StructLayout(LayoutKind.Sequential, CharSet := CharSet.Auto)> _
Public Class LogFont
    <MarshalAs(UnmanagedType.ByValTStr, SizeConst := 32)> _
    Private _faceName As String

    Public Property Height() As Integer
        Get
            Return m_Height
        End Get
        Set
            m_Height = Value
        End Set
    End Property
    Private m_Height As Integer
    Public Property Width() As Integer
        Get
            Return m_Width
        End Get
        Set
            m_Width = Value
        End Set
    End Property
    Private m_Width As Integer
    Public Property Escapement() As Integer
        Get
            Return m_Escapement
        End Get
        Set
            m_Escapement = Value
        End Set
    End Property
    Private m_Escapement As Integer
    Public Property Orientation() As Integer
        Get
            Return m_Orientation
        End Get
        Set
            m_Orientation = Value
        End Set
    End Property
    Private m_Orientation As Integer
    Public Property Weight() As Integer
        Get
            Return m_Weight
        End Get
        Set
            m_Weight = Value
        End Set
    End Property
    Private m_Weight As Integer
    Public Property Italic() As Byte
        Get
            Return m_Italic
        End Get
        Set
            m_Italic = Value
        End Set
    End Property
    Private m_Italic As Byte
    Public Property Underline() As Byte
        Get
            Return m_Underline
        End Get
        Set
            m_Underline = Value
        End Set
    End Property
    Private m_Underline As Byte
    Public Property StrikeOut() As Byte
        Get
            Return m_StrikeOut
        End Get
        Set
            m_StrikeOut = Value
        End Set
    End Property
    Private m_StrikeOut As Byte
    Public Property FontCharSet() As Byte
        Get
            Return m_FontCharSet
        End Get
        Set
            m_FontCharSet = Value
        End Set
    End Property
    Private m_FontCharSet As Byte
    Public Property OutPrecision() As Byte
        Get
            Return m_OutPrecision
        End Get
        Set
            m_OutPrecision = Value
        End Set
    End Property
    Private m_OutPrecision As Byte
    Public Property ClipPrecision() As Byte
        Get
            Return m_ClipPrecision
        End Get
        Set
            m_ClipPrecision = Value
        End Set
    End Property
    Private m_ClipPrecision As Byte
    Public Property Quality() As Byte
        Get
            Return m_Quality
        End Get
        Set
            m_Quality = Value
        End Set
    End Property
    Private m_Quality As Byte
    Public Property PitchAndFamily() As Byte
        Get
            Return m_PitchAndFamily
        End Get
        Set
            m_PitchAndFamily = Value
        End Set
    End Property
    Private m_PitchAndFamily As Byte
    Public Property FaceName() As String
        Get
            Return _faceName
        End Get
        Set
            If value.Length > 32 Then
                _faceName = value.Substring(0, 32)
            Else
                _faceName = value
            End If
        End Set
    End Property

    Public Sub New(height As Integer, width As Integer, escape As Integer, orient As Integer, weight As Integer, italic As Byte, _
        underline As Byte, strikeout As Byte, charSet As Byte, outPrecision As Byte, clipPrecision As Byte, quality As Byte, _
        pitchAndFamily As Byte, faceName As String)
        Me.Height = height
        Me.Width = width
        Me.Escapement = escape
        Me.Orientation = orient
        Me.Weight = weight
        Me.Italic = italic
        Me.Underline = underline
        Me.StrikeOut = strikeout
        Me.FontCharSet = charSet
        Me.OutPrecision = outPrecision
        Me.ClipPrecision = clipPrecision
        Me.Quality = quality
        Me.PitchAndFamily = pitchAndFamily
        Me.FaceName = faceName
    End Sub

    Public Sub New(s As String)
        Dim parseSplit As String() = s.Split(" "C)
        Me.Height = Integer.Parse(parseSplit(0))
        Me.Width = Integer.Parse(parseSplit(1))
        Me.Escapement = Integer.Parse(parseSplit(2))
        Me.Orientation = Integer.Parse(parseSplit(3))
        Me.Weight = Integer.Parse(parseSplit(4))
        Me.Italic = Byte.Parse(parseSplit(5))
        Me.Underline = Byte.Parse(parseSplit(6))
        Me.StrikeOut = Byte.Parse(parseSplit(7))
        Me.FontCharSet = Byte.Parse(parseSplit(8))
        Me.OutPrecision = Byte.Parse(parseSplit(9))
        Me.ClipPrecision = Byte.Parse(parseSplit(10))
        Me.Quality = Byte.Parse(parseSplit(11))
        Me.PitchAndFamily = Byte.Parse(parseSplit(12))
        Me.FaceName = parseSplit(13)
    End Sub

    Public Overrides Function ToString() As String
        Return String.Format("{0} {1} {2} {3} {4} {5} {6} {7} {8} {9} {10} {11} {12} {13}", Me.Height, Me.Width, Me.Escapement, Me.Orientation, Me.Weight, _
            Me.Italic, Me.Underline, Me.StrikeOut, Me.FontCharSet, Me.OutPrecision, Me.ClipPrecision, _
            Me.Quality, Me.PitchAndFamily, Me.FaceName)
    End Function
End Class

Public Sub MacroFont()
    Dim zenonFontLists As IFontLists = Me.ActiveDocument.FontLists
    For i As Integer = 0 To zenonFontLists.Count - 1

        Dim zenonFontList As IFontList = zenonFontLists.Item(i)
        'Loop through all fonts and set the height to 10
        For j As Integer = 0 To zenonFontList.Count - 1
            Dim zenonFont As IFontItem = zenonFontList.Item(j)
            'Parse the LogFont string of the font
            Dim lf As New LogFont(DirectCast(zenonFont.get_DynProperties("Font"), String))
            lf.Height = -27
            'Change the height value and set the Font property again

            zenonFont.set_DynProperties("Font", lf.ToString())

        Next
    Next
End Sub


SingleExport
ObjectModel COM [image] FontLists [image] Methods [image] SingleExport
Remarks

Exports a single FontList object to an xml formatted file.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR

Example
C#
Copy
public void MacroFontListSingleExport()
{
    IFontLists zenonFontLists = this.ActiveDocument.FontLists;
    for (int i = 0; i < zenonFontLists.Count; ++i)
    {
        //Export each list to a single file
        zenonFontLists.SingleExport(i, @"C:\FontLists\" + i.ToString() + ".xml");
    }
}
VB.NET
Copy
Public Sub MacroFontListSingleExport()
    Dim zenonFontLists As IFontLists = Me.ActiveDocument.FontLists
    For i As Integer = 0 To zenonFontLists.Count - 1
        'Export each list to a single file
        zenonFontLists.SingleExport(i, "C:\FontLists\" + i.ToString() + ".xml")
    Next
End Sub


Interlocking
ObjectModel COM [image] Interlocking
Remarks

With the interlocking object you have the opportunity to edit standard interlockings and command interlockings (zenOn Energy edition)

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void Macro_Interlocking()
{
    IInterlockings zenonInterlockings = this.ActiveDocument.Interlockings();
    IInterlocking zenonInterlocking = zenonInterlockings.Item("switches");

    //Get an interlocking object called "switches" and print values of its first action
    //Note: In order to get human readable values you might have to cast the returned objects to their appropriate type or parse them
    System.Diagnostics.Debug.Print("Action type = " + zenonInterlocking.get_DynProperties("Actions[0].Type"));
    System.Diagnostics.Debug.Print("Variable = " + zenonInterlocking.get_DynProperties("Actions[0].TTA"));
    System.Diagnostics.Debug.Print("Switching direction = " + zenonInterlocking.get_DynProperties("Actions[0].Direction"));
    System.Diagnostics.Debug.Print("Command setting status = " + zenonInterlocking.get_DynProperties("Actions[0].CommandState"));
    System.Diagnostics.Debug.Print("Entries are suppressed = " + zenonInterlocking.get_DynProperties("Actions[0].CELBlock"));
    System.Diagnostics.Debug.Print("Timeout (s) = " + zenonInterlocking.get_DynProperties("Actions[0].Timeout"));
    System.Diagnostics.Debug.Print("Edge delay (ms) = " + zenonInterlocking.get_DynProperties("Actions[0].EdgeDelay"));
    System.Diagnostics.Debug.Print("Modifyable stati = " + zenonInterlocking.get_DynProperties("Actions[0].State"));
    System.Diagnostics.Debug.Print("Nominal/actual value comparison is activated = " + zenonInterlocking.get_DynProperties("Actions[0].Picture"));
    System.Diagnostics.Debug.Print("Menu specific picture = " + zenonInterlocking.get_DynProperties("Actions[0].TTA"));
    System.Diagnostics.Debug.Print("Close automatically is activated = " + zenonInterlocking.get_DynProperties("Actions[0].CloseMDIWnd"));
    System.Diagnostics.Debug.Print("Two-stage is activated = " + zenonInterlocking.get_DynProperties("Actions[0].TwoLevel"));
    System.Diagnostics.Debug.Print("Two-hand operation is activated = " + zenonInterlocking.get_DynProperties("Actions[0].TwoHand"));
}
VB.NET
Copy
Public Sub Macro_Interlocking()
    Dim zenonInterlockings As IInterlockings = Me.ActiveDocument.Interlockings()
    Dim zenonInterlocking As IInterlocking = zenonInterlockings.Item("switches")

    'Get an interlocking object called "switches" and print values of its first action
    'Note: In order to get human readable values you might have to cast the returned objects to their appropriate type or parse them
    System.Diagnostics.Debug.Print("Action type = " + zenonInterlocking.get_DynProperties("Actions[0].Type"))
    System.Diagnostics.Debug.Print("Variable = " + zenonInterlocking.get_DynProperties("Actions[0].TTA"))
    System.Diagnostics.Debug.Print("Switching direction = " + zenonInterlocking.get_DynProperties("Actions[0].Direction"))
    System.Diagnostics.Debug.Print("Command setting status = " + zenonInterlocking.get_DynProperties("Actions[0].CommandState"))
    System.Diagnostics.Debug.Print("Entries are suppressed = " + zenonInterlocking.get_DynProperties("Actions[0].CELBlock"))
    System.Diagnostics.Debug.Print("Timeout (s) = " + zenonInterlocking.get_DynProperties("Actions[0].Timeout"))
    System.Diagnostics.Debug.Print("Edge delay (ms) = " + zenonInterlocking.get_DynProperties("Actions[0].EdgeDelay"))
    System.Diagnostics.Debug.Print("Modifyable stati = " + zenonInterlocking.get_DynProperties("Actions[0].State"))
    System.Diagnostics.Debug.Print("Nominal/actual value comparison is activated = " + zenonInterlocking.get_DynProperties("Actions[0].Picture"))
    System.Diagnostics.Debug.Print("Menu specific picture = " + zenonInterlocking.get_DynProperties("Actions[0].TTA"))
    System.Diagnostics.Debug.Print("Close automatically is activated = " + zenonInterlocking.get_DynProperties("Actions[0].CloseMDIWnd"))
    System.Diagnostics.Debug.Print("Two-stage is activated = " + zenonInterlocking.get_DynProperties("Actions[0].TwoLevel"))
    System.Diagnostics.Debug.Print("Two-hand operation is activated = " + zenonInterlocking.get_DynProperties("Actions[0].TwoHand"))
End Sub
VBA
Copy
Sub Get_Interlocking_Information()
Dim zInterlockings As Interlockings 'Object from type Interlockings
Dim zInterlocking As Interlocking 'Child object from type Interlocking
'Load the available Interlockings
Set zInterlockings = thisProject.Interlockings
'Select a command interlocking called "switches"
Set zInterlocking = zInterlockings.Item("switches")
'Get all projected informations of the first action
'Get action type
Debug.Print "Action type = " & zInterlocking.DynProperties("Actions[0].Type")
'Get the linked variable
Debug.Print "Variable = " & zInterlocking.DynProperties("Actions[0].TTA")
'Get the "switching direction"
Debug.Print "Switching direction = " &

zInterlocking.DynProperties("Actions[0].Direction")
'Get the "command setting status"
Debug.Print "Command setting status = " &

zInterlocking.DynProperties("Actions[0].CommandState")
'Get state "CEL entries suppressed"
Debug.Print "CEL entries are suppressed = " &

zInterlocking.DynProperties("Actions[0].CELBlock")
'Get the "timeout" in seconds
Debug.Print "Timeout (s) = " & zInterlocking.DynProperties("Actions[0].Timeout")
'Get the "edge delay" in milliseconds
Debug.Print "Edge delay (ms) = " &

zInterlocking.DynProperties("Actions[0].EdgeDelay")
'Get the "modifyable stati"
Debug.Print "Modifyable stati = " & zInterlocking.DynProperties("Actions[0].State")
'Get state "nominal/actual value comparison"
Debug.Print "Nominal/actual value comparison is activated = " &

zInterlocking.DynProperties("Actions[0].Actual")
'Get the "menu specific Screen"
Debug.Print "Menu specific picture = " &

zInterlocking.DynProperties("Actions[0].Picture")
'Get state "close automatically"
Debug.Print "Close automatically is activated = " &

zInterlocking.DynProperties("Actions[0].CloseMDIWnd")
'Get state "two-stage"
Debug.Print "Two-stage is activated = " &

zInterlocking.DynProperties("Actions[0].TwoLevel")
'Get state "two-hand operation"
Debug.Print "Two-hand operation is activated = " &

zInterlocking.DynProperties("Actions[0].TwoHand")

End Sub


Methods
ObjectModel COM [image] Interlocking [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateDynProperty | variant_bool | With the DynProperties "Variables" and "Actions" you have the opportunity to create a variable at an interlocking and to create an action at a command interlocking. | Available | Unused | Available | Available
DynProperties [GET] | variant |  | Available | Available | Available | Available
DynProperties [PUT] | void | <span"></span> | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant |  | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available


CreateDynProperty
ObjectModel COM [image] Interlocking [image] Methods [image] CreateDynProperty
Remarks

With the DynProperties "Variables" and "Actions" you have the opportunity to create a variable at an interlocking and to create an action at a command interlocking (special interlockings for zenOn Energy).

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Name of DynProperty to be created as string.

Example
VBA
Copy
Sub Command_Interlockings()
Dim zInterlockings As Interlockings 'Object from type Interlockings
Dim zInterlocking As Interlocking 'Child object from type Interlocking
'Load the available Interlockings
Set zInterlockings = thisProject.Interlockings
'Select a command interlocking
Set zInterlocking = zInterlockings.Item("Verriegelung 1")
'Create a "variable" at the command interlocking
zInterlocking.CreateDynProperty ("Variables")
'Allocate the first variable of the project variables list
zInterlocking.DynProperties("Variables[0].Name") = thisProject.Variables.Item(0)

'Create an "action" at the command interlocking
zInterlocking.CreateDynProperty ("Actions")
'The action should be from type "Double command"
zInterlocking.DynProperties("Actions[0].Type") = 1
'Set the "variable" via a string
zInterlocking.DynProperties("Actions[0].TTA") = "switch_1"
'Set the "switching direction" to ON
zInterlocking.DynProperties("Actions[0].Direction") = 1
'Set the "command setting status" to 1
zInterlocking.DynProperties("Actions[0].CommandState") = 1
'Set that CEL entries should be suppressed
zInterlocking.DynProperties("Actions[0].CELBlock") = True
'Set the "timeout" to 60 sec
zInterlocking.DynProperties("Actions[0].Timeout") = 60
'Set the edge "delay" to 2000 msec
zInterlocking.DynProperties("Actions[0].EdgeDelay") = 2000
'Read the "modifyable stati"
Debug.Print zInterlocking.DynProperties("Actions[0].State")
'Set the "nominal/actual value comparison" active
zInterlocking.DynProperties("Actions[0].Actual") = True
'Set the "menu specific picture" (menu type = commands) via a string
zInterlocking.DynProperties("Actions[0].Picture") = "Picture 1"
'Set the "close automatically" property active
zInterlocking.DynProperties("Actions[0].CloseMDIWnd") = True
'Set the "two-stage" property active
zInterlocking.DynProperties("Actions[0].TwoLevel") = True
'Set the "two-hand operation" property active
zInterlocking.DynProperties("Actions[0].TwoHand") = True

End Sub


DynProperties [GET]
ObjectModel COM [image] Interlocking [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] Interlocking [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.


DynPropertiesEnum [GET]
ObjectModel COM [image] Interlocking [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties: DynPropertiesEnum("")


DynPropertyParam [GET]
ObjectModel COM [image] Interlocking [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties
ObjectModel COM [image] Interlocking [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Interlocking


Interlocking
ObjectModel COM [image] Interlocking [image] DynProperties [image] Interlocking
Overview

External Name

Type

Display Name

Description

CBTR_Act

Bool

Breaker tripping detection

Only available if property is activated.Active : Response variable is monitored for an unexpected change from <> 0 to 0 .Default: Inactive .

CBTR_Formula

String

Suppress detection

Entering the formula with which the detection of a breaker tripping can be suppressed. A click on button ... opens the formula editor.For the formula, all variables from the list of command groups can be used; name replacements with '*' are possible, as with the definition of the Interlocking conditions of an action .Note: Variables that are used in the formula cannot be deleted from the list of the command group. .

DesiredDirection

Bool

Set status PROGRESS

Active: For command (all), setpoint input and manual corrections actions, the in progress[PROGRESS] status bit is set for the response variable if the actions are triggered in Runtime. The bit is used to implement a graphical display in order to show the user that an action is carried out at the moment. With the help of the combined element or a reaction matrix you can check the status bit and implement a graphical display.Inactive : The status bit is not set.Default: Inactive . .

ListConfigEXP

List configuration export

Description

Modal

Bool

Screen modal

Active: The command is switched to modal regardless of the 'Modal dialog' property of the screen. This means that other screens can only be operated once the screen has been closed. Inactive: The command screen is switched normally. Default: inactive. .

Picture

String

Exp. menu spec. screen

ReturnInformation

CDynEleVar

Variable name of response

Variable name or the mask for replacing the response variable. The placeholder for the substitution text is the character '*’ within a name. Only one placeholder can be used in a name. When entering the mask, it is important to take care that this name results in an existing variable name after replacement. If the variable that is used here (substituted or absolute) does not exist during the creation of the Runtime files, the command group will not be available in the Runtime. An according message announces this error during the creation of the Runtime files. Direct entry or opening the dialog for selecting variables. .

RM-Titel

Bool

Screen title from response variable

Active: The identification of the response variable is used as screen title. Inactive: The name of the screen is used as screen title. Default: inactive . Attention : For activating the screen title you must in addition activate property in the respective frame. .

SubstiGroup

Bool

Replace in screen

Substitution for command groups:

ValueVariable

CDynEleVar

Result variable

Shows the result of the interlocking condition on the selected variable.A click on the button opens the dialog for selecting the variable. You can also enter the name of the variable directly in the input field. .

WatchDogTimer

SByte

Watchdog timer

Determines the process of the watchdog timer.Note: This runtime monitoring only supports switching command , pulse command and limited setpoint input action types.Possible settings:none : No watchdog timer.Only via response variable (RV) : The value of the response variable is used to check whether the process was successful. The monitoring is activated only if the value to be written does not equal the current value of the action variable. Nor for setpoint input.Only via cause of transmission (COT) : COT (Cause of Transmission) is used to check whether the process was successful. For the 'Command ' action, the status bits of the cause of transmission (COTx) are evaluated. The monitoring is concluded if COT_actterm (10) has been reached.Via COT and RV: Waits and reacts to COT and to value changes of the response variable. Combines the properties of Only on response variable (RV) and Only on cause of transmission (COT) . For setpoint input: As for only via cause of transmission (COT) In general, the following applies: If runtime monitoring is not ended successfully within the property configured for the action, the TIMEOUT status bit is set for the response variable. If the property is activated, the status bit is also set for the command variable.Default: none . .

WriteStatusBitActive

Bool

Write status bits to command variables

Possible status transfer in command variable, in addition to automatic status transfer in the response variableactivated:In the event of a block , the status bit M1 is set in the response variable and command variable.If the timeout is exceeded during runtime monitoring, the [TIMEOUT] status bit is set in the response variable and the command bit.Deactivated: Status is only set in the response variable.Default: Inactive .


Interlockings
ObjectModel COM [image] Interlockings
Remarks

With the interlockings object you have the opportunity to create and edit interlockings in the list.

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void Macro_Interlocking()
{
    IInterlockings zenonInterlockings = this.ActiveDocument.Interlockings();
    IInterlocking zenonInterlocking = zenonInterlockings.Item("switches");

    //Get an interlocking object called "switches" and print values of its first action
    //Note: In order to get human readable values you might have to cast the returned objects to their appropriate type or parse them
    System.Diagnostics.Debug.Print("Action type = " + zenonInterlocking.get_DynProperties("Actions[0].Type"));
    System.Diagnostics.Debug.Print("Variable = " + zenonInterlocking.get_DynProperties("Actions[0].TTA"));
    System.Diagnostics.Debug.Print("Switching direction = " + zenonInterlocking.get_DynProperties("Actions[0].Direction"));
    System.Diagnostics.Debug.Print("Command setting status = " + zenonInterlocking.get_DynProperties("Actions[0].CommandState"));
    System.Diagnostics.Debug.Print("Entries are suppressed = " + zenonInterlocking.get_DynProperties("Actions[0].CELBlock"));
    System.Diagnostics.Debug.Print("Timeout (s) = " + zenonInterlocking.get_DynProperties("Actions[0].Timeout"));
    System.Diagnostics.Debug.Print("Edge delay (ms) = " + zenonInterlocking.get_DynProperties("Actions[0].EdgeDelay"));
    System.Diagnostics.Debug.Print("Modifyable stati = " + zenonInterlocking.get_DynProperties("Actions[0].State"));
    System.Diagnostics.Debug.Print("Nominal/actual value comparison is activated = " + zenonInterlocking.get_DynProperties("Actions[0].Picture"));
    System.Diagnostics.Debug.Print("Menu specific picture = " + zenonInterlocking.get_DynProperties("Actions[0].TTA"));
    System.Diagnostics.Debug.Print("Close automatically is activated = " + zenonInterlocking.get_DynProperties("Actions[0].CloseMDIWnd"));
    System.Diagnostics.Debug.Print("Two-stage is activated = " + zenonInterlocking.get_DynProperties("Actions[0].TwoLevel"));
    System.Diagnostics.Debug.Print("Two-hand operation is activated = " + zenonInterlocking.get_DynProperties("Actions[0].TwoHand"));
}
VB.NET
Copy
Public Sub Macro_Interlocking()
    Dim zenonInterlockings As IInterlockings = Me.ActiveDocument.Interlockings()
    Dim zenonInterlocking As IInterlocking = zenonInterlockings.Item("switches")

    'Get an interlocking object called "switches" and print values of its first action
    'Note: In order to get human readable values you might have to cast the returned objects to their appropriate type or parse them
    System.Diagnostics.Debug.Print("Action type = " + zenonInterlocking.get_DynProperties("Actions[0].Type"))
    System.Diagnostics.Debug.Print("Variable = " + zenonInterlocking.get_DynProperties("Actions[0].TTA"))
    System.Diagnostics.Debug.Print("Switching direction = " + zenonInterlocking.get_DynProperties("Actions[0].Direction"))
    System.Diagnostics.Debug.Print("Command setting status = " + zenonInterlocking.get_DynProperties("Actions[0].CommandState"))
    System.Diagnostics.Debug.Print("Entries are suppressed = " + zenonInterlocking.get_DynProperties("Actions[0].CELBlock"))
    System.Diagnostics.Debug.Print("Timeout (s) = " + zenonInterlocking.get_DynProperties("Actions[0].Timeout"))
    System.Diagnostics.Debug.Print("Edge delay (ms) = " + zenonInterlocking.get_DynProperties("Actions[0].EdgeDelay"))
    System.Diagnostics.Debug.Print("Modifyable stati = " + zenonInterlocking.get_DynProperties("Actions[0].State"))
    System.Diagnostics.Debug.Print("Nominal/actual value comparison is activated = " + zenonInterlocking.get_DynProperties("Actions[0].Picture"))
    System.Diagnostics.Debug.Print("Menu specific picture = " + zenonInterlocking.get_DynProperties("Actions[0].TTA"))
    System.Diagnostics.Debug.Print("Close automatically is activated = " + zenonInterlocking.get_DynProperties("Actions[0].CloseMDIWnd"))
    System.Diagnostics.Debug.Print("Two-stage is activated = " + zenonInterlocking.get_DynProperties("Actions[0].TwoLevel"))
    System.Diagnostics.Debug.Print("Two-hand operation is activated = " + zenonInterlocking.get_DynProperties("Actions[0].TwoHand"))
End Sub
VBA
Copy
Sub Interlockings()
Dim zInterlockings As Interlockings 'Object from type Interlockings
Dim zInterlocking As Interlocking 'Child object from type Interlockings
'Fill the objects
Set zInterlockings = MyWorkspace.ActiveDocument.Interlockings
'Creates an interlocking called "Interlocking" with an assignment
Set zInterlocking = zInterlockings.Create("Interlocking", False)
Call InterlockingsItem

End Sub
Sub InterlockingsItem()
Dim zInterlockings As Interlockings 'Object from type Interlockings
Dim zInterlocking As Interlocking 'Child object from type Interlockings
'Fill the objects
Set zInterlockings = MyWorkspace.ActiveDocument.Interlockings
'Returns an interlocking out of the list
Set zInterlocking = zInterlockings.Item("Interlocking")
'Rename the interlocking
zInterlocking.DynProperties("Name") = "My_Interlocking"

End Sub


Properties
ObjectModel COM [image] Interlockings [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the amount of interlockings. | Readonly | Readonly | Available | Available
Parent | iproject | Returns the parent of the interlockings object. | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] Interlockings [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Interlockings [image] Properties [image] Parent
Remarks

Returns the parent object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Interlockings [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | iinterlocking | Creates a new interlocking. | Available | Unused | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
Item | iinterlocking | Returns the interlocking at the given index. | Available | Unused | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index | Available | Unused | Available | Available


Create
ObjectModel COM [image] Interlockings [image] Methods [image] Create
Remarks

Creates a new Interlocking an returns this new object.

Datatype
IInterlocking

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

Name as string.

bCommand as VARIANT_BOOL

If this value is set to 'True' then a "Command" is created instead of an "Assignment".
"Commands" are only available within an "Energy Edition - License"!

Example
C#
Copy
public void MacroCreateInterlocking()
{
    IInterlockings zenonInterlockings = this.ActiveDocument.Interlockings();

    //Creates a new interlocking that is not a command
    IInterlocking zenonNewInterlocking = zenonInterlockings.Create("new_interlocking", false);
}
VB.NET
Copy
Public Sub MacroCreateInterlocking()
    Dim zenonInterlockings As IInterlockings = Me.ActiveDocument.Interlockings()

    'Creates a new interlocking that is not a command
    Dim zenonNewInterlocking As IInterlocking = zenonInterlockings.Create("new_interlocking", False)
End Sub
VBA
Copy
Sub Interlockings()
Dim zInterlockings As Interlockings 'Object from type Interlockings
Dim zInterlocking As Interlocking 'Object from type Interlocking
'Fill the objects
Set zInterlockings = MyWorkspace.ActiveDocument.Interlockings
'Creates an interlocking called "Interl_1" with an assignment
Set zInterlocking = zInterlockings.Create("Interl_1", False)
Debug.Print "Count = " & zInterlockings.Count

End Sub


Export
ObjectModel COM [image] Interlockings [image] Methods [image] Export
Remarks

Export settings to an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Filename (path) as string of the xml file to export.

bCommand as VARIANT_BOOL

If this value is set to 'True' then a "Command" is created instead of an "Assignment".
"Commands" are only available within an "Energy Edition - License"!

Example
C#
Copy
public void MacroInterlockingExport()
{
    IInterlockings zenonInterlockings = this.ActiveDocument.Interlockings();
    zenonInterlockings.Export(@"C:\Interlockings\interlockings.xml", true);
}
VB.NET
Copy
Public Sub MacroInterlockingExport()
    Dim zenonInterlockings As IInterlockings = Me.ActiveDocument.Interlockings()
    zenonInterlockings.Export("C:\Interlockings\interlockings.xml", True)
End Sub
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
'Export settings to an xml file
zenOnObject.Export ("C:\zenOn_eXaMpLe.xml, False") 'Interlocking
'Import settings from an xml file
zenOnObject.Import ("C:\zenOn_eXaMpLe.xml, False") 'Interlocking

End Sub


Import
ObjectModel COM [image] Interlockings [image] Methods [image] Import
Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

bCommand as VARIANT_BOOL

If this value is set to 'True' then a "Command" is created instead of an "Assignment".
"Commands" are only available within an "Energy Edition - License"!

Example
C#
Copy
public void MacroInterlockingImport()
{
    IInterlockings zenonInterlockings = this.ActiveDocument.Interlockings();
    zenonInterlockings.Import(@"C:\Interlockings\interlockings.xml", true);
}
VB.NET
Copy
Public Sub MacroInterlockingImport()
    Dim zenonInterlockings As IInterlockings = Me.ActiveDocument.Interlockings()
    zenonInterlockings.Import("C:\Interlockings\interlockings.xml", True)
End Sub
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
'Export settings to an xml file
zenOnObject.Export ("C:\zenOn_eXaMpLe.xml, False") 'Interlocking
'Import settings from an xml file
zenOnObject.Import ("C:\zenOn_eXaMpLe.xml, False") 'Interlocking

End Sub


Item
ObjectModel COM [image] Interlockings [image] Methods [image] Item
Remarks

Returns the object "Interlocking" from the collection, which is identified by the parameter vItem.The parameter vItem can have two values:<ul><li>Index: Access with an index mostly is used in combination with the property Count to find out the position of the object in the list.</li><li>Name: The interlocking can also be accessed with its unique name.</li></ul>Hint:The returned object should always be checked on Nothing, for the case that no object was found for the search criteria.

Datatype
IInterlocking

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vItem as VARIANT

Index or name of the "Interlocking" object within the collection.

If the parameter is a numerical value, the object is searched by its index (>= 0 and <= Count-1).
If it is an alphanumerical value, the object is searched by its unique name.

Example
C#
Copy
public void Macro_Interlocking()
{
    IInterlockings zenonInterlockings = this.ActiveDocument.Interlockings();
    IInterlocking zenonInterlocking = zenonInterlockings.Item("switches");

    //Get an interlocking object called "switches" and print values of its first action
    //Note: In order to get human readable values you might have to cast the returned objects to their appropriate type or parse them
    System.Diagnostics.Debug.Print("Action type = " + zenonInterlocking.get_DynProperties("Actions[0].Type"));
    System.Diagnostics.Debug.Print("Variable = " + zenonInterlocking.get_DynProperties("Actions[0].TTA"));
    System.Diagnostics.Debug.Print("Switching direction = " + zenonInterlocking.get_DynProperties("Actions[0].Direction"));
    System.Diagnostics.Debug.Print("Command setting status = " + zenonInterlocking.get_DynProperties("Actions[0].CommandState"));
    System.Diagnostics.Debug.Print("Entries are suppressed = " + zenonInterlocking.get_DynProperties("Actions[0].CELBlock"));
    System.Diagnostics.Debug.Print("Timeout (s) = " + zenonInterlocking.get_DynProperties("Actions[0].Timeout"));
    System.Diagnostics.Debug.Print("Edge delay (ms) = " + zenonInterlocking.get_DynProperties("Actions[0].EdgeDelay"));
    System.Diagnostics.Debug.Print("Modifyable stati = " + zenonInterlocking.get_DynProperties("Actions[0].State"));
    System.Diagnostics.Debug.Print("Nominal/actual value comparison is activated = " + zenonInterlocking.get_DynProperties("Actions[0].Picture"));
    System.Diagnostics.Debug.Print("Menu specific picture = " + zenonInterlocking.get_DynProperties("Actions[0].TTA"));
    System.Diagnostics.Debug.Print("Close automatically is activated = " + zenonInterlocking.get_DynProperties("Actions[0].CloseMDIWnd"));
    System.Diagnostics.Debug.Print("Two-stage is activated = " + zenonInterlocking.get_DynProperties("Actions[0].TwoLevel"));
    System.Diagnostics.Debug.Print("Two-hand operation is activated = " + zenonInterlocking.get_DynProperties("Actions[0].TwoHand"));
}
VB.NET
Copy
Public Sub Macro_Interlocking()
    Dim zenonInterlockings As IInterlockings = Me.ActiveDocument.Interlockings()
    Dim zenonInterlocking As IInterlocking = zenonInterlockings.Item("switches")

    'Get an interlocking object called "switches" and print values of its first action
    'Note: In order to get human readable values you might have to cast the returned objects to their appropriate type or parse them
    System.Diagnostics.Debug.Print("Action type = " + zenonInterlocking.get_DynProperties("Actions[0].Type"))
    System.Diagnostics.Debug.Print("Variable = " + zenonInterlocking.get_DynProperties("Actions[0].TTA"))
    System.Diagnostics.Debug.Print("Switching direction = " + zenonInterlocking.get_DynProperties("Actions[0].Direction"))
    System.Diagnostics.Debug.Print("Command setting status = " + zenonInterlocking.get_DynProperties("Actions[0].CommandState"))
    System.Diagnostics.Debug.Print("Entries are suppressed = " + zenonInterlocking.get_DynProperties("Actions[0].CELBlock"))
    System.Diagnostics.Debug.Print("Timeout (s) = " + zenonInterlocking.get_DynProperties("Actions[0].Timeout"))
    System.Diagnostics.Debug.Print("Edge delay (ms) = " + zenonInterlocking.get_DynProperties("Actions[0].EdgeDelay"))
    System.Diagnostics.Debug.Print("Modifyable stati = " + zenonInterlocking.get_DynProperties("Actions[0].State"))
    System.Diagnostics.Debug.Print("Nominal/actual value comparison is activated = " + zenonInterlocking.get_DynProperties("Actions[0].Picture"))
    System.Diagnostics.Debug.Print("Menu specific picture = " + zenonInterlocking.get_DynProperties("Actions[0].TTA"))
    System.Diagnostics.Debug.Print("Close automatically is activated = " + zenonInterlocking.get_DynProperties("Actions[0].CloseMDIWnd"))
    System.Diagnostics.Debug.Print("Two-stage is activated = " + zenonInterlocking.get_DynProperties("Actions[0].TwoLevel"))
    System.Diagnostics.Debug.Print("Two-hand operation is activated = " + zenonInterlocking.get_DynProperties("Actions[0].TwoHand"))
End Sub
VBA
Copy
Sub InterlockingsItem()
Dim zInterlockings As Interlockings 'Object from type Interlockings
Dim zInterlocking As Interlocking 'Child object from type Interlockings
'Fill the objects
Set zInterlockings = MyWorkspace.ActiveDocument.Interlockings
'Returns an interlocking out of the list
Set zInterlocking = zInterlockings.Item("Interlocking 1")
'Rename the interlocking
zInterlocking.DynProperties("Name") = "My_Interlocking"

End Sub


SingleExport
ObjectModel COM [image] Interlockings [image] Methods [image] SingleExport
Remarks

Exports a single interlocking to an xml formatted file.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR

bCommand as VARIANT_BOOL

Example
C#
Copy
public void MacroInterlockingSingleExport()
{
    IInterlockings zenonInterlockings = this.ActiveDocument.Interlockings();
    zenonInterlockings.SingleExport("switches", @"C:\Interlockings\switches.xml", true);
}
VB.NET
Copy
Public Sub MacroInterlockingSingleExport()
    Dim zenonInterlockings As IInterlockings = Me.ActiveDocument.Interlockings()
    zenonInterlockings.SingleExport("switches", "C:\Interlockings\switches.xml", True)
End Sub


LanguageTable
ObjectModel COM [image] LanguageTable
Remarks

Represents the language table of the project.

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroLanguageTable()
{
    //Prints the number of language table entries in the current active project
    ILanguageTable zenonLanguageTable = this.ActiveDocument.LanguageTable;
    System.Diagnostics.Debug.Print(zenonLanguageTable.Count.ToString());
}
VB.NET
Copy
Public Sub MacroLanguageTable()
    'Prints the number of language table entries in the current active project
    Dim zenonLanguageTable As ILanguageTable = Me.ActiveDocument.LanguageTable
    System.Diagnostics.Debug.Print(zenonLanguageTable.Count.ToString())
End Sub
VBA
Copy
Dim ILang As LanguageTable
    Set ILang = MyWorkspace.ActiveDocument.LanguageTable


Properties
ObjectModel COM [image] LanguageTable [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Count of Files in the Language Table | Available | Unused | Available | Available
Parent | iproject | Parent-object | Available | Unused | Available | Available


Count
ObjectModel COM [image] LanguageTable [image] Properties [image] Count
Remarks

The property „Count" contains the number of all files from the language table.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] LanguageTable [image] Properties [image] Parent
Remarks

The property „Parent" is a reference to the parent object, the project to which the language table corresponds.

Datatype
IProject

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] LanguageTable [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateFile | variant_bool | Creates a new File in the Language Table | Available | Unused | Available | Available
DeleteFile | variant_bool | Deletes a File from the Language Table | Available | Unused | Available | Available
DeleteKey | variant_bool | Deletes a Key from all Files of the Language Table | Available | Unused | Available | Available
ExportCSV | variant_bool | Exports the Language Table to a CSV file | Available | Unused | Available | Available
ExportFile | variant_bool | Exports an existing File from the Language Table | Available | Unused | Available | Available
GetString | bstr | Returns a String from the Language Table | Available | Unused | Available | Available
ImportCSV | variant_bool | Imports the Language Table from a CSV file | Available | Unused | Available | Available
ImportFile | variant_bool | Imports (and merges) an existing File into the Language Table | Available | Unused | Available | Available
Item | ifilemanagerfileitem | Returns the File by Name or Position | Available | Unused | Available | Available
Save | variant_bool | Saves the Language Table | Available | Unused | Available | Available
SetString | variant_bool | Sets a String in the Language Table | Available | Unused | Available | Available


CreateFile
ObjectModel COM [image] LanguageTable [image] Methods [image] CreateFile
Remarks

The method „CreateFile" creates a new, empty file in the language table.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
Name as BSTR

Example
C#
Copy
public void MacroLanguageTableCreate()
{
    ILanguageTable zenonLanguageTable = this.ActiveDocument.LanguageTable;
    //Create a new LanguageTable file called "FRENCH.TXT"
    zenonLanguageTable.CreateFile("FRENCH.TXT");
}
VB.NET
Copy
Public Sub MacroLanguageTableCreate()
    Dim zenonLanguageTable As ILanguageTable = Me.ActiveDocument.LanguageTable
    'Create a new LanguageTable file called "FRENCH.TXT"
    zenonLanguageTable.CreateFile("FRENCH.TXT")
End Sub
VBA
Copy
Private Sub LangCreate()
Dim ILang As LanguageTable
Dim IFile As FileManagerFileItem
Set ILang = MyWorkspace.ActiveDocument.LanguageTable
'Create a new empty file
ILang.CreateFile("ENGLISH.TXT")
End Sub


DeleteFile
ObjectModel COM [image] LanguageTable [image] Methods [image] DeleteFile
Remarks

The method „DeleteFile" removes a file from the language table.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
Name as BSTR

Example
C#
Copy
public void MacroLanguageTableDelete()
{
    ILanguageTable zenonLanguageTable = this.ActiveDocument.LanguageTable;
    //Delete the french language file
    zenonLanguageTable.DeleteFile("FRENCH.TXT");
}
VB.NET
Copy
Public Sub MacroLanguageTableDelete()
    Dim zenonLanguageTable As ILanguageTable = Me.ActiveDocument.LanguageTable
    'Delete the french language file
    zenonLanguageTable.DeleteFile("FRENCH.TXT")
End Sub
VBA
Copy
Private Sub LangDelete()
Dim ILang As LanguageTable
Set ILang = MyWorkspace.ActiveDocument.LanguageTable
ILang.DeleteFile("ENGLISH.TXT")
End Sub


DeleteKey
ObjectModel COM [image] LanguageTable [image] Methods [image] DeleteKey
Remarks

The method "DeleteKey" deletes a key text and all its translations from the language table.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
Key as BSTR

Example
C#
Copy
public void MacroLanguageTableDeleteKey()
{
    ILanguageTable zenonLanguageTable = this.ActiveDocument.LanguageTable;
    //Deletes the translation for Motor (Engine) in all language files
    zenonLanguageTable.DeleteKey("Motor");
}
VB.NET
Copy
Public Sub MacroLanguageTableDeleteKey()
    Dim zenonLanguageTable As ILanguageTable = Me.ActiveDocument.LanguageTable
    'Deletes the translation for Motor (Engine) in all language files
    zenonLanguageTable.DeleteKey("Motor")
End Sub
VBA
Copy
Private Sub KeyDelete()
Dim ILang As LanguageTable
Set ILang = MyWorkspace.ActiveDocument.LanguageTable
If CheckOutAll Then

ILang.DeleteKey("Motor")
End If
End Sub


ExportCSV
ObjectModel COM [image] LanguageTable [image] Methods [image] ExportCSV
Remarks

Exports the whole language table into the given file as CSV. Output is exactly like the GUI-Command "CSV exportieren" alle".
sFileName = file location

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
Name as BSTR

Example
VBA
Copy
Private Sub LangExportCSV()
    Dim Ok As Boolean
    Dim LangTab As LanguageTable
    Set LangTab = MyWorkspace.ActiveDocument.LanguageTable
    Ok = LangTab.ExportCSV("C:\Test\Language.csv")
End Sub


ExportFile
ObjectModel COM [image] LanguageTable [image] Methods [image] ExportFile
Remarks

Exports (copies) the given LanguageTable file to the specified locationvID = index or filename of LanguageTable
sFileName = file location

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vID as VARIANT

Name as BSTR

Example
VBA
Copy
Private Sub LangExport()
    Dim Ok As Boolean
    Dim LangTab As LanguageTable
    Set LangTab = MyWorkspace.ActiveDocument.LanguageTable
    Ok = LangTab.ExportFile("ENGLISH.TXT", "C:\Test\ENGLISH.TXT")
End Sub


GetString
ObjectModel COM [image] LanguageTable [image] Methods [image] GetString
Remarks

The method "GetString" returns the translation of a key text.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
File as BSTR

Key as BSTR

Example
C#
Copy
public void MacroLanguageTableGetString()
{
    ILanguageTable zenonLanguageTable = this.ActiveDocument.LanguageTable;
    //Get the english translation for the german word Motor (Engine)
    System.Diagnostics.Debug.Print(zenonLanguageTable.GetString("ENGLISH.TXT", "Motor"));
}
VB.NET
Copy
Public Sub MacroLanguageTableGetString()
    Dim zenonLanguageTable As ILanguageTable = Me.ActiveDocument.LanguageTable
    'Get the english translation for the german word Motor (Engine)
    System.Diagnostics.Debug.Print(zenonLanguageTable.GetString("ENGLISH.TXT", "Motor"))
End Sub
VBA
Copy
Private Sub GetKey()
Dim ILang As LanguageTable
Set ILang = MyWorkspace.ActiveDocument.LanguageTable
Debug.Print ILang.GetString("ENGLISH.TXT", "Motor")
End Sub


ImportCSV
ObjectModel COM [image] LanguageTable [image] Methods [image] ImportCSV
Remarks

Imports (and merges) the given file into the language table. (like the gui-command "CSV importieren...)
sFileName = file location

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
Name as BSTR

Example
VBA
Copy
Private Sub LangImportCSV()
    Dim Ok As Boolean
    Dim LangTab As LanguageTable
    Set LangTab = MyWorkspace.ActiveDocument.LanguageTable
    Ok = LangTab.ImportCSV("C:\Test\Language.csv")
End Sub


ImportFile
ObjectModel COM [image] LanguageTable [image] Methods [image] ImportFile
Remarks

The method „ImportFile" imports a file into the language table. The translations of the imported file are inserted to an already existing file with the same name (see above "import from text file") or if any other file with the same name exists, it will be inserted as a new file.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
Name as BSTR

Example
C#
Copy
public void MacroLanguageTableDeleteKey()
{
    ILanguageTable zenonLanguageTable = this.ActiveDocument.LanguageTable;
    //Adds an existing file for german translations to the table
    zenonLanguageTable.ImportFile(@"C:\DEUTSCH.TXT");
}
VB.NET
Copy
Public Sub MacroLanguageTableDeleteKey()
    Dim zenonLanguageTable As ILanguageTable = Me.ActiveDocument.LanguageTable
    'Adds an existing file for german translations to the table
    zenonLanguageTable.ImportFile("C:\DEUTSCH.TXT")
End Sub
VBA
Copy
Private Sub LangImport()
    Dim Ok As Boolean
    Dim ILang As LanguageTable
    Dim IFile As FileManagerFileItem
    Set ILang = MyWorkspace.ActiveDocument.LanguageTable
    Set IFile = ILang.Item("DEUTSCH.TXT")
    If Not IFile Is Nothing Then
        If Not IFile.IsLocked And Not IFile.IsCheckedOut Then IFile.CheckOut
    End If
    Ok = ILang.ImportFile("C:\DEUTSCH.TXT")
End Sub


Item
ObjectModel COM [image] LanguageTable [image] Methods [image] Item
Remarks

The method „Item" returns a language table file as „FileManagerFileItem" object. The file can be chosen either by the name or by the index.The file can as well be renamed over the returned object FileManagerItem.In case of multi user projects, the files have to be "checked out" (allow changes) in order to be editable.

Datatype
IFileManagerFileItem

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vID as VARIANT

Example
C#
Copy
public void MacroLanguageTableItem()
{
    ILanguageTable zenonLanguageTable = this.ActiveDocument.LanguageTable;
    IFileManagerFileItem zenonEnglishFile = zenonLanguageTable.Item(0);
    System.Diagnostics.Debug.Print(zenonEnglishFile.FileName);

    //rename the file to "ENGLISH.TXT"
    zenonEnglishFile.FileName = "ENGLISH.TXT";
}
VB.NET
Copy
Public Sub MacroLanguageTableItem()
    Dim zenonLanguageTable As ILanguageTable = Me.ActiveDocument.LanguageTable
    Dim zenonEnglishFile As IFileManagerFileItem = zenonLanguageTable.Item(0)
    System.Diagnostics.Debug.Print(zenonEnglishFile.FileName)

    'rename the file to "ENGLISH.TXT"
    zenonEnglishFile.FileName = "ENGLISH.TXT"
End Sub
VBA
Copy
Private Sub LangItem()
Dim ILang As LanguageTable
Dim IFile As FileManagerFileItem
Set ILang = MyWorkspace.ActiveDocument.LanguageTable
Set IFile = ILang.Item("ENGLISH.TXT")
Debug.Print IFile.FileName
Set IFile = ILang.Item(3)
Debug.Print IFile.FileName
End Sub
Private Sub LangRename()
    Dim ILang As LanguageTable
    Dim IFile As FileManagerFileItem
    Set ILang = MyWorkspace.ActiveDocument.LanguageTable
    Set IFile = ILang.Item("ENGLISH.TXT")
    If Not IFile Is Nothing Then
        IFile.FileName = "FRENCH.TXT"
    End If
End Sub
Private Function CheckOutAll() As Boolean
    Dim Ok As Boolean
    Dim Cnt, i As Integer
    Dim ILang As LanguageTable
    Dim IFile As FileManagerFileItem
    Set ILang = MyWorkspace.ActiveDocument.LanguageTable
    CheckOutAll = True
    Cnt = ILang.Count
    For i = 0 To Cnt - 1
        Set IFile = ILang.Item(i)
        If Not IFile Is Nothing Then
            If Not IFile.IsLocked And Not IFile.IsCheckedOut Then
                CheckOutAll = CheckOutAll And IFile.CheckOut
            End If
        End If
    Next
End Function


Save
ObjectModel COM [image] LanguageTable [image] Methods [image] Save
Remarks

Saves the language table

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroLanguageTableSave()
{
    ILanguageTable zenonLanguageTable = this.ActiveDocument.LanguageTable;

    //Do some changes to the table before saving it...

    //Writes the language table to disk
    zenonLanguageTable.Save();
}
VB.NET
Copy
Public Sub MacroLanguageTableSave()
    Dim zenonLanguageTable As ILanguageTable = Me.ActiveDocument.LanguageTable

    'Do some changes to the table before saving it...

    'Writes the language table to disk
    zenonLanguageTable.Save()
End Sub


SetString
ObjectModel COM [image] LanguageTable [image] Methods [image] SetString
Remarks

The method "SetString" inserts a new key word/translation pair into the language table.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
File as BSTR

Key as BSTR

Text as BSTR

Example
C#
Copy
public void MacroLanguageTableSetString()
{
    ILanguageTable zenonLanguageTable = this.ActiveDocument.LanguageTable;
    IFileManagerFileItem zenonEnglishFile = zenonLanguageTable.Item("ENGLISH.TXT");
    if (zenonEnglishFile != null)
    {
        if (!zenonEnglishFile.IsLocked() && !zenonEnglishFile.IsCheckedOut())
            zenonEnglishFile.CheckOut();
        if (zenonEnglishFile.IsCheckedOut())
        {
            //Provide basic english translation of the german words Motor for engine and Schalter for switch
            zenonLanguageTable.SetString("ENGLISH.TXT", "Motor", "Engine");
            zenonLanguageTable.SetString("ENGLISH.TXT", "Schalter", "Switch");
            zenonEnglishFile.CheckIn();
        }
    }
}
VB.NET
Copy
Public Sub MacroLanguageTableSetString()
    Dim zenonLanguageTable As ILanguageTable = Me.ActiveDocument.LanguageTable
    Dim zenonEnglishFile As IFileManagerFileItem = zenonLanguageTable.Item("ENGLISH.TXT")
    If zenonEnglishFile IsNot Nothing Then
        If Not zenonEnglishFile.IsLocked() AndAlso Not zenonEnglishFile.IsCheckedOut() Then
            zenonEnglishFile.CheckOut()
        End If
        If zenonEnglishFile.IsCheckedOut() Then
            'Provide basic english translation of the german words Motor for engine and Schalter for switch
            zenonLanguageTable.SetString("ENGLISH.TXT", "Motor", "Engine")
            zenonLanguageTable.SetString("ENGLISH.TXT", "Schalter", "Switch")
            zenonEnglishFile.CheckIn()
        End If
    End If
End Sub
VBA
Copy
Private Sub LangFill()
Dim i As Integer
Dim Ok As Boolean
Dim ILang As LanguageTable
Dim IFile As FileManagerFileItem
Set ILang = MyWorkspace.ActiveDocument.LanguageTable
Set IFile = ILang.Item("ENGLISH.TXT")
If Not IFile Is Nothing Then

If Not IFile.IsLocked And Not IFile.IsCheckedOut Then IFile.CheckOut

If IFile.IsCheckedOut Then

Ok = ILang.SetString("ENGLISH.TXT", "Motor", "Engine")

Ok = ILang.SetString("ENGLISH.TXT", "Schalter", "Switch")

End If

End If
End Sub
'create keywords
Public Sub CreateLangTableKey()

Dim bRet As Boolean
Dim obLangTable As LanguageTable
Dim obLangFile As FileManagerFileItem

'create object of the language table
 Set obLangTable = MyWorkspace.ActiveDocument.LanguageTable
'create object of the language file
 Set obLangFile = obLangTable.Item("ZENONSTR.TXT")
'check if the given language file exists
 If Not obLangFile Is Nothing Then
'create the keyword
 bRet = obLangTable.SetString("ZENONSTR.TXT", "Hallo", "Du")
 Else
 MsgBox ("error getting defined language file")
 End If
 'check if the keyword was written
 If bRet <> True Then
 MsgBox ("something happend... and it was not good.... ")
 End If
End Sub


License
ObjectModel COM [image] License
Remarks

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] License [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
BorrowExpirationTime [GET] | date |  | Readonly | Readonly | Available | Available
ExpirationTime [GET] | date |  | Readonly | Readonly | Available | Available
GetDriverLicenseEntry | ilicenseentry |  | Readonly | Readonly | Available | Available
GetLicenseEntry | ilicenseentry |  | Readonly | Readonly | Available | Available
GetLogicDriverLicenseEntry | ilicenseentry |  | Readonly | Readonly | Available | Available
IsBorrowExpirationTimeSet [GET] | variant_bool |  | Readonly | Readonly | Available | Available
IsDriverLicensed | variant_bool |  | Readonly | Readonly | Available | Available
IsExpirationTimeSet [GET] | variant_bool |  | Readonly | Readonly | Available | Available
IsLicensed | variant_bool |  | Readonly | Readonly | Available | Available
IsLogicDriverLicensed | variant_bool |  | Readonly | Readonly | Available | Available
IsTimeQuotaSet [GET] | variant_bool |  | Readonly | Readonly | Available | Available
SerialNumber [GET] | bstr |  | Readonly | Readonly | Available | Available
TimeQuotaInMinutes [GET] | long |  | Readonly | Readonly | Available | Available


BorrowExpirationTime [GET]
ObjectModel COM [image] License [image] Methods [image] BorrowExpirationTime [GET]
Remarks

Datatype
DATE

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ExpirationTime [GET]
ObjectModel COM [image] License [image] Methods [image] ExpirationTime [GET]
Remarks

Datatype
DATE

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


GetDriverLicenseEntry
ObjectModel COM [image] License [image] Methods [image] GetDriverLicenseEntry
Remarks

Datatype
ILicenseEntry

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
p_driver as LicenseDriver


GetLicenseEntry
ObjectModel COM [image] License [image] Methods [image] GetLicenseEntry
Remarks

Datatype
ILicenseEntry

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
p_module as LicenseModule


GetLogicDriverLicenseEntry
ObjectModel COM [image] License [image] Methods [image] GetLogicDriverLicenseEntry
Remarks

Datatype
ILicenseEntry

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
p_logicDriver as LicenseLogicDriver


IsBorrowExpirationTimeSet [GET]
ObjectModel COM [image] License [image] Methods [image] IsBorrowExpirationTimeSet [GET]
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


IsDriverLicensed
ObjectModel COM [image] License [image] Methods [image] IsDriverLicensed
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
p_driver as LicenseDriver


IsExpirationTimeSet [GET]
ObjectModel COM [image] License [image] Methods [image] IsExpirationTimeSet [GET]
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


IsLicensed
ObjectModel COM [image] License [image] Methods [image] IsLicensed
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
p_module as LicenseModule


IsLogicDriverLicensed
ObjectModel COM [image] License [image] Methods [image] IsLogicDriverLicensed
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
p_logicDriver as LicenseLogicDriver


IsTimeQuotaSet [GET]
ObjectModel COM [image] License [image] Methods [image] IsTimeQuotaSet [GET]
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


SerialNumber [GET]
ObjectModel COM [image] License [image] Methods [image] SerialNumber [GET]
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


TimeQuotaInMinutes [GET]
ObjectModel COM [image] License [image] Methods [image] TimeQuotaInMinutes [GET]
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


LicenseEntry
ObjectModel COM [image] LicenseEntry
Remarks

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] LicenseEntry [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Values [GET] | variant |  | Readonly | Readonly | Available | Available


Values [GET]
ObjectModel COM [image] LicenseEntry [image] Methods [image] Values [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Limit
ObjectModel COM [image] Limit
Remarks

The collection Variables contains all defined limits of a variable.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroLimit()
{
    IVariable zenonVariable = this.Variables().Item("WIZ_VAR_10");

    //Get the first limit of a specified variable
    ILimit zenonLimit = zenonVariable.Limits().Item(0);

    System.Diagnostics.Debug.Print("Text: " + zenonLimit.Text);
    System.Diagnostics.Debug.Print("Value: " + zenonLimit.Value);
    System.Diagnostics.Debug.Print("AlarmClass: " + zenonLimit.AlarmClass);
    System.Diagnostics.Debug.Print("AlarmGroup: " + zenonLimit.AlarmGroup);

    string[] enumDynProp = (string[])zenonLimit.get_DynPropertiesEnum("");
    foreach (string item in enumDynProp)
    {
        string propertyName = item.Split(',')[0];
        //Note: This just prints the ToString() method of each dynamic property
        //If you want to use the objects you want to look up the object type and
        //cast the dynamic property
        System.Diagnostics.Debug.Print(propertyName +" = " +
            zenonLimit.get_DynProperties(propertyName));
    }
}
VB.NET
Copy
Public Sub MacroLimit()
    Dim zenonVariable As IVariable = Me.Variables().Item("WIZ_VAR_10")

    'Get the first limit of a specified variable
    Dim zenonLimit As ILimit = zenonVariable.Limits().Item(0)

    System.Diagnostics.Debug.Print("Text: " + zenonLimit.Text)
    System.Diagnostics.Debug.Print("Value: " + zenonLimit.Value)
    System.Diagnostics.Debug.Print("AlarmClass: " + zenonLimit.AlarmClass)
    System.Diagnostics.Debug.Print("AlarmGroup: " + zenonLimit.AlarmGroup)

    Dim enumDynProp As String() = DirectCast(zenonLimit.get_DynPropertiesEnum(""), String())
    For Each item As String In enumDynProp
        Dim propertyName As String = item.Split(","C)(0)
        'Note: This just prints the ToString() method of each dynamic property
        'If you want to use the objects you want to look up the object type and
        'cast the dynamic property
        System.Diagnostics.Debug.Print((propertyName & Convert.ToString(" = ")) + zenonLimit.get_DynProperties(propertyName))
    Next
End Sub
VBA
Copy
Public Sub zenOn_Limit()
Dim zVAR As Variable
Dim zLimit As Limit
Dim vDynProps As Variant
Dim strDynProp As String
'set variable object to get the limits collection
Set zVAR = thisProject.Variables.Item("WIZ_VAR_10")
'set limit object
Set zLimit = zVAR.Limits.Item(0)
'read all Default Properties from a limit
With zLimit

'generate some output information

Debug.Print "Text: " & .Text

Debug.Print "Value: " & .Value

Debug.Print "AlarmClass: " & .AlarmClass

Debug.Print "AlarmGroup: " & .AlarmGroup
End With
'read all DynProperties from a limit
vDynProps = zLimit.DynPropertiesEnum("")
For Each strItem In vDynProps
strDynProp = Mid(strItem, 1, InStr(1, strItem, ",") - 1)
Debug.Print "--------------------"
Debug.Print strItem
Debug.Print zLimit.DynProperties(strDynProp)
Next
End Sub


Properties
ObjectModel COM [image] Limit [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AlarmClass | short | Alarmclass | Unused | Readonly | Available | Available
AlarmGroup | short | Alarmgroup | Unused | Readonly | Available | Available
Parent | limits | Parent-object | Readonly | Readonly | Available | Available
Text | bstr | Alarmtext | Unused | Readonly | Available | Available
Value | double | Value | Unused | Readonly | Available | Available


AlarmClass
ObjectModel COM [image] Limit [image] Properties [image] AlarmClass
Remarks

Returns the ID of the defined alarm class for the actual limit. At the moment the alarm class is not available as an object.

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


AlarmGroup
ObjectModel COM [image] Limit [image] Properties [image] AlarmGroup
Remarks

Returns the ID of the defined alarm group for the actual limit. At the moment the alarm group is not available as an object.

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Limit [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
Limits

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Text
ObjectModel COM [image] Limit [image] Properties [image] Text
Remarks

Returns/sets the limit text. For reading operations the translated string – in the current language of the Runtime – is returned. Allocating a limit directly changes the key of the entry – i.e. different to reading access, where the string is translated to the current language of the project.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Value
ObjectModel COM [image] Limit [image] Properties [image] Value
Remarks

Returns/sets the limit, at which the current status occurs. The current status occurs – depending on the setting Min or Max – on violating this limit. The setting Min or Max cannot be changed via VBA. The methods IsMin and IsMax can check the type of the limit.

Datatype
double

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Limit [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant |  | Available | Available | Available | Available
DynProperties [PUT] | void |  | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant |  | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available
IsMax | variant_bool | Returns 'True' if the type of the current limit is 'Max', violated as soon as the current value is higher. | Available | Unused | Available | Available
IsMin | variant_bool | Returns 'True' if the type of the current limit is 'Min', violated as soon as the current value is lower. | Available | Unused | Available | Available


DynProperties [GET]
ObjectModel COM [image] Limit [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"

Example
VBA
Copy
Sub
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] Limit [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.


DynPropertiesEnum [GET]
ObjectModel COM [image] Limit [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties: DynPropertiesEnum("")


DynPropertyParam [GET]
ObjectModel COM [image] Limit [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


IsMax
ObjectModel COM [image] Limit [image] Methods [image] IsMax
Remarks

Returns 'True' if the type of the current limit is 'Max', violated as soon as the current value is higher. Otherwise it is a minimum limit.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroLimitMinMax()
{
    IVariable zenonVariable = this.ActiveDocument.Variables().Item("WIZ_VAR_10");

    //Get the first limit of a specified variable
    ILimit zenonLimit = zenonVariable.Limits().Item(0);
    if (zenonLimit.IsMax())
    {
        this.Application.DebugPrint("Limit 0 of WIZ_WAR_10 currently at its max value",
            tpDebugPrintStyle.tpMsg);
    }
    else if (zenonLimit.IsMin())
    {
        this.Application.DebugPrint("Limit 0 of WIZ_WAR_10 currently at its min value",
            tpDebugPrintStyle.tpMsg);
    }
}
VB.NET
Copy
Public Sub MacroLimitMinMax()
    Dim zenonVariable As IVariable = Me.ActiveDocument.Variables().Item("WIZ_VAR_10")

    'Get the first limit of a specified variable
    Dim zenonLimit As ILimit = zenonVariable.Limits().Item(0)
    If zenonLimit.IsMax() Then
        Me.Application.DebugPrint("Limit 0 of WIZ_WAR_10 currently at its max value", tpDebugPrintStyle.tpMsg)
    ElseIf zenonLimit.IsMin() Then
        Me.Application.DebugPrint("Limit 0 of WIZ_WAR_10 currently at its min value", tpDebugPrintStyle.tpMsg)
    End If
End Sub


IsMin
ObjectModel COM [image] Limit [image] Methods [image] IsMin
Remarks

Returns 'True' if the type of the current limit is 'Min', violated as soon as the current value is lower. Otherwise it is a maximal limit.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroLimitMinMax()
{
    IVariable zenonVariable = this.ActiveDocument.Variables().Item("WIZ_VAR_10");

    //Get the first limit of a specified variable
    ILimit zenonLimit = zenonVariable.Limits().Item(0);
    if (zenonLimit.IsMax())
    {
        this.Application.DebugPrint("Limit 0 of WIZ_WAR_10 currently at its max value",
            tpDebugPrintStyle.tpMsg);
    }
    else if (zenonLimit.IsMin())
    {
        this.Application.DebugPrint("Limit 0 of WIZ_WAR_10 currently at its min value",
            tpDebugPrintStyle.tpMsg);
    }
}
VB.NET
Copy
Public Sub MacroLimitMinMax()
    Dim zenonVariable As IVariable = Me.ActiveDocument.Variables().Item("WIZ_VAR_10")

    'Get the first limit of a specified variable
    Dim zenonLimit As ILimit = zenonVariable.Limits().Item(0)
    If zenonLimit.IsMax() Then
        Me.Application.DebugPrint("Limit 0 of WIZ_WAR_10 currently at its max value", tpDebugPrintStyle.tpMsg)
    ElseIf zenonLimit.IsMin() Then
        Me.Application.DebugPrint("Limit 0 of WIZ_WAR_10 currently at its min value", tpDebugPrintStyle.tpMsg)
    End If
End Sub


Limits
ObjectModel COM [image] Limits
Remarks

The collection Limits contains the defined limits of a variable. With this collection you can access the defined limits.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroLimit()
{
    IVariable zenonVariable = this.Variables().Item("WIZ_VAR_10");

    //Get the first limit of a specified variable
    ILimit zenonLimit = zenonVariable.Limits().Item(0);

    System.Diagnostics.Debug.Print("Text: " + zenonLimit.Text);
    System.Diagnostics.Debug.Print("Value: " + zenonLimit.Value);
    System.Diagnostics.Debug.Print("AlarmClass: " + zenonLimit.AlarmClass);
    System.Diagnostics.Debug.Print("AlarmGroup: " + zenonLimit.AlarmGroup);

    string[] enumDynProp = (string[])zenonLimit.get_DynPropertiesEnum("");
    foreach (string item in enumDynProp)
    {
        string propertyName = item.Split(',')[0];
        //Note: This just prints the ToString() method of each dynamic property
        //If you want to use the objects you want to look up the object type and
        //cast the dynamic property
        System.Diagnostics.Debug.Print(propertyName +" = " +
            zenonLimit.get_DynProperties(propertyName));
    }
}
VB.NET
Copy
Public Sub MacroLimit()
    Dim zenonVariable As IVariable = Me.Variables().Item("WIZ_VAR_10")

    'Get the first limit of a specified variable
    Dim zenonLimit As ILimit = zenonVariable.Limits().Item(0)

    System.Diagnostics.Debug.Print("Text: " + zenonLimit.Text)
    System.Diagnostics.Debug.Print("Value: " + zenonLimit.Value)
    System.Diagnostics.Debug.Print("AlarmClass: " + zenonLimit.AlarmClass)
    System.Diagnostics.Debug.Print("AlarmGroup: " + zenonLimit.AlarmGroup)

    Dim enumDynProp As String() = DirectCast(zenonLimit.get_DynPropertiesEnum(""), String())
    For Each item As String In enumDynProp
        Dim propertyName As String = item.Split(","C)(0)
        'Note: This just prints the ToString() method of each dynamic property
        'If you want to use the objects you want to look up the object type and
        'cast the dynamic property
        System.Diagnostics.Debug.Print((propertyName & Convert.ToString(" = ")) + zenonLimit.get_DynProperties(propertyName))
    Next
End Sub
VBA
Copy
Public Sub zenOn_Limits()
Dim zVAR As Variable
Dim zLimit As Limit
Dim i As Integer
'set variable object to get the limits collection
Set zVAR = thisProject.Variables.Item("WIZ_VAR_10")
'enumerate all limits of the variable
For i = 0 To zVAR.Limits.Count - 1

Set zLimit = zVAR.Limits.Item(i)

Debug.Print "LIMIT " & (i + 1) & ":"

With zLimit

'generate some output information

Debug.Print "Text: " & .Text

Debug.Print "Value: " & .Value

Debug.Print "AlarmClass: " & .AlarmClass

Debug.Print "AlarmGroup: " & .AlarmGroup

Debug.Print "Status: " & .DynProperties("Status")

End With
Next i
End Sub


Properties
ObjectModel COM [image] Limits [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Count of defined limits | Readonly | Readonly | Available | Available
Parent | ivariable | Parent-object | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] Limits [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Limits [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IVariable

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Limits [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Item | ilimit | Returns limit on the given position | Available | Available | Available | Available


Item
ObjectModel COM [image] Limits [image] Methods [image] Item
Remarks

Returns a "Limit" object by its position.

Datatype
ILimit

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
iIndex as long

Index of the limit to be returned.

Example
C#
Copy
public void MacroLimit()
{
    IVariable zenonVariable = this.Variables().Item("WIZ_VAR_10");

    //Get the first limit of a specified variable
    ILimit zenonLimit = zenonVariable.Limits().Item(0);

    System.Diagnostics.Debug.Print("Text: " + zenonLimit.Text);
    System.Diagnostics.Debug.Print("Value: " + zenonLimit.Value);
    System.Diagnostics.Debug.Print("AlarmClass: " + zenonLimit.AlarmClass);
    System.Diagnostics.Debug.Print("AlarmGroup: " + zenonLimit.AlarmGroup);

    string[] enumDynProp = (string[])zenonLimit.get_DynPropertiesEnum("");
    foreach (string item in enumDynProp)
    {
        string propertyName = item.Split(',')[0];
        //Note: This just prints the ToString() method of each dynamic property
        //If you want to use the objects you want to look up the object type and
        //cast the dynamic property
        System.Diagnostics.Debug.Print(propertyName +" = " +
            zenonLimit.get_DynProperties(propertyName));
    }
}
VB.NET
Copy
Public Sub MacroLimit()
    Dim zenonVariable As IVariable = Me.Variables().Item("WIZ_VAR_10")

    'Get the first limit of a specified variable
    Dim zenonLimit As ILimit = zenonVariable.Limits().Item(0)

    System.Diagnostics.Debug.Print("Text: " + zenonLimit.Text)
    System.Diagnostics.Debug.Print("Value: " + zenonLimit.Value)
    System.Diagnostics.Debug.Print("AlarmClass: " + zenonLimit.AlarmClass)
    System.Diagnostics.Debug.Print("AlarmGroup: " + zenonLimit.AlarmGroup)

    Dim enumDynProp As String() = DirectCast(zenonLimit.get_DynPropertiesEnum(""), String())
    For Each item As String In enumDynProp
        Dim propertyName As String = item.Split(","C)(0)
        'Note: This just prints the ToString() method of each dynamic property
        'If you want to use the objects you want to look up the object type and
        'cast the dynamic property
        System.Diagnostics.Debug.Print((propertyName & Convert.ToString(" = ")) + zenonLimit.get_DynProperties(propertyName))
    Next
End Sub


MdiElement
ObjectModel COM [image] MdiElement
Remarks

The availibility and functionality of MDI elements, also called control elements within zenOn, depend on the corresponding Screen type. This collection returns the default settings of the MDI elements.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroMdiElements()
{
    IDynPicture zenonDynPicture = this.ActiveDocument.DynPictures().Item("AML");
    IMdiElements zenonMdiElements = zenonDynPicture.MdiElements();

    for (int i = 0; i < zenonMdiElements.Count; ++i)
    {
        System.Diagnostics.Debug.Print("Caption: " +
            zenonMdiElements.Item(i).Caption);
        System.Diagnostics.Debug.Print("Position Left: " +
            zenonMdiElements.Item(i).Left);
        System.Diagnostics.Debug.Print("Position Top: " +
            zenonMdiElements.Item(i).Top);
        System.Diagnostics.Debug.Print("Width: " +
            zenonMdiElements.Item(i).Width);
        System.Diagnostics.Debug.Print("Height: " +
            zenonMdiElements.Item(i).Height);
    }
}
VB.NET
Copy
Public Sub MacroMdiElements()
    Dim zenonDynPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item("AML")
    Dim zenonMdiElements As IMdiElements = zenonDynPicture.MdiElements()

    For i As Integer = 0 To zenonMdiElements.Count - 1
        System.Diagnostics.Debug.Print("Caption: " + zenonMdiElements.Item(i).Caption)
        System.Diagnostics.Debug.Print("Position Left: " + zenonMdiElements.Item(i).Left)
        System.Diagnostics.Debug.Print("Position Top: " + zenonMdiElements.Item(i).Top)
        System.Diagnostics.Debug.Print("Width: " + zenonMdiElements.Item(i).Width)
        System.Diagnostics.Debug.Print("Height: " + zenonMdiElements.Item(i).Height)
    Next
End Sub
VBA
Copy
Sub zenOn_MdiElements()
'Declarations
Dim zPIC As DynPicture
Dim zMDIs As MdiElements
Dim i As Integer
'Initialize zPIC with the ALARM Screen
Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Item("ALARM")
'Initialize zMDIs with the available MDI elements for the ALARM Screen
Set zMDIs = zPIC.MdiElements
'For every MDI element in the ALARM Screen...
For i = 0 To zMDIs.Count - 1

'... output the details

With zMDIs.Item(i)

Debug.Print "Caption: " & .Caption

Debug.Print "Position left: " & .Left

Debug.Print "Position top: " & .Top

Debug.Print "Width: " & .Width

Debug.Print "Height: " & .Height

End With
Next i
End Sub


Properties
ObjectModel COM [image] MdiElement [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
BackColor | ole_color |  | Available | Readonly | Available | Available
Caption | bstr | Name of the linked picture type specific function. | Available | Unused | Available | Available
ForeColor | ole_color |  | Available | Readonly | Available | Available
Height | long | Height of the element (in pixels). | Available | Readonly | Available | Available
ID | long | Returns the unique ID of the "MdiElement" object. | Available | Unused | Available | Available
IsDefault | variant_bool | Returns TRUE, if the "MdiElement" object belongs to the default elements. | Available | Unused | Available | Available
Left | long | Returns the position of the left window border of the element in pixel. | Available | Readonly | Available | Available
Parent | imdielements | Returns the parent object. | Readonly | Readonly | Available | Available
Top | long | Returns the position of the top window border of the element in pixel. | Available | Readonly | Available | Available
Type | long | Type of the "Element" object. | Readonly | Available | Available | Available
Width | long | Width of the element (in pixel). | Available | Readonly | Available | Available


BackColor
ObjectModel COM [image] MdiElement [image] Properties [image] BackColor
Remarks

Datatype
OLE_COLOR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Caption
ObjectModel COM [image] MdiElement [image] Properties [image] Caption
Remarks

Name of the linked picture type specific function.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


ForeColor
ObjectModel COM [image] MdiElement [image] Properties [image] ForeColor
Remarks

Datatype
OLE_COLOR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Height
ObjectModel COM [image] MdiElement [image] Properties [image] Height
Remarks

Height of the element (in pixels).

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ID
ObjectModel COM [image] MdiElement [image] Properties [image] ID
Remarks

Returns the unique ID of the "MdiElement" object.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IsDefault
ObjectModel COM [image] MdiElement [image] Properties [image] IsDefault
Remarks

Returns TRUE, if the "MdiElement" object belongs to the default elements.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Left
ObjectModel COM [image] MdiElement [image] Properties [image] Left
Remarks

Returns the position of the left window border of the element in pixel. The value defines the distance from the top border of the screen.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] MdiElement [image] Properties [image] Parent
Remarks

Returns the parent object.

Datatype
IMdiElements

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Top
ObjectModel COM [image] MdiElement [image] Properties [image] Top
Remarks

Returns the position of the top window border of the element in pixel. The value defines the distance from the top border of the screen.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] MdiElement [image] Properties [image] Type
Remarks

Type of the "Element" object.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Available
VBA | Available
VSTA | Available


Width
ObjectModel COM [image] MdiElement [image] Properties [image] Width
Remarks

Width of the element (in pixel).

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] MdiElement [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant |  | Available | Available | Available | Available
DynProperties [PUT] | void |  | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant |  | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available


DynProperties [GET]
ObjectModel COM [image] MdiElement [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties [PUT]
ObjectModel COM [image] MdiElement [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.


DynPropertiesEnum [GET]
ObjectModel COM [image] MdiElement [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties: DynPropertiesEnum("")


DynPropertyParam [GET]
ObjectModel COM [image] MdiElement [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties
ObjectModel COM [image] MdiElement [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

MDI elements default list


MDI elements default list
ObjectModel COM [image] MdiElement [image] DynProperties [image] MDI elements default list
Overview
External Name | Type | Display Name | Description
BackColor | UInt32 | BackColor |
Default | Bool | Default |
Height | Int32 | Height |
ID | Int32 | ID |
Info | UInt32 | Info |
Left | Int32 | Left |
MenuID | UInt32 | MenuID |
Style | UInt32 | Style |
StyleMask | UInt32 | StyleMask |
Text | String | Text | The dialog for the definition of the formula for the Mathematics variable is opened.
TextColor | UInt32 | TextColor |
Top | Int32 | Top |
Type | UInt16 | Type |
Width | Int32 | Width | Name of the inserted file.


MdiElements
ObjectModel COM [image] MdiElements
Remarks

This object manages "MdiElement" objects.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroMdiElements()
{
    IDynPicture zenonDynPicture = this.ActiveDocument.DynPictures().Item("AML");
    IMdiElements zenonMdiElements = zenonDynPicture.MdiElements();

    for (int i = 0; i < zenonMdiElements.Count; ++i)
    {
        System.Diagnostics.Debug.Print("Caption: " +
            zenonMdiElements.Item(i).Caption);
        System.Diagnostics.Debug.Print("Position Left: " +
            zenonMdiElements.Item(i).Left);
        System.Diagnostics.Debug.Print("Position Top: " +
            zenonMdiElements.Item(i).Top);
        System.Diagnostics.Debug.Print("Width: " +
            zenonMdiElements.Item(i).Width);
        System.Diagnostics.Debug.Print("Height: " +
            zenonMdiElements.Item(i).Height);
    }
}
VB.NET
Copy
Public Sub MacroMdiElements()
    Dim zenonDynPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item("AML")
    Dim zenonMdiElements As IMdiElements = zenonDynPicture.MdiElements()

    For i As Integer = 0 To zenonMdiElements.Count - 1
        System.Diagnostics.Debug.Print("Caption: " + zenonMdiElements.Item(i).Caption)
        System.Diagnostics.Debug.Print("Position Left: " + zenonMdiElements.Item(i).Left)
        System.Diagnostics.Debug.Print("Position Top: " + zenonMdiElements.Item(i).Top)
        System.Diagnostics.Debug.Print("Width: " + zenonMdiElements.Item(i).Width)
        System.Diagnostics.Debug.Print("Height: " + zenonMdiElements.Item(i).Height)
    Next
End Sub
VBA
Copy
Sub zenOn_MdiElements()
'Declarations
Dim zPIC As DynPicture
Dim zMDIs As MdiElements
Dim i As Integer
'Initialize zPIC with the ALARM Screen
Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Item("ALARM")
'Initialize zMDIs with the available MDI elements for the ALARM Screen
Set zMDIs = zPIC.MdiElements
'For every MDI element in the ALARM Screen...
For i = 0 To zMDIs.Count - 1

'... which is not a default element...

If Not zMDIs.Item(i).IsDefault Then

'... output the caption of the element.

Debug.Print zMDIs.Item(i).Caption

End If
Next i
End Sub


Properties
ObjectModel COM [image] MdiElements [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns count of the elements | Readonly | Readonly | Available | Available
Parent | idynpicture | The parent object of the current object | Readonly | Readonly | Available | Available
UseProfile | variant_bool | Returns TRUE, if profile elements are available for this type of object. | Readonly | Unused | Available | Available


Count
ObjectModel COM [image] MdiElements [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] MdiElements [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IDynPicture

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


UseProfile
ObjectModel COM [image] MdiElements [image] Properties [image] UseProfile
Remarks

Returns TRUE, if profile elements are available for this type of object.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] MdiElements [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Item | imdielement | Returns a object at a position or by a specified key | Available | Available | Available | Available


Item
ObjectModel COM [image] MdiElements [image] Methods [image] Item
Remarks

Returns the object Element from the collection, which is identified by the parameter vID. The parameter vID can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • Element name: The element can also be accessed with its unique name.
Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IMdiElement

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vElementID as VARIANT

Example
C#
Copy
Public Sub MacroMdiElements()
    Dim zenonDynPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item("AML")
    Dim zenonMdiElements As IMdiElements = zenonDynPicture.MdiElements()

    For i As Integer = 0 To zenonMdiElements.Count - 1
        System.Diagnostics.Debug.Print("Caption: " + zenonMdiElements.Item(i).Caption)
        System.Diagnostics.Debug.Print("Position Left: " + zenonMdiElements.Item(i).Left)
        System.Diagnostics.Debug.Print("Position Top: " + zenonMdiElements.Item(i).Top)
        System.Diagnostics.Debug.Print("Width: " + zenonMdiElements.Item(i).Width)
        System.Diagnostics.Debug.Print("Height: " + zenonMdiElements.Item(i).Height)
    Next
End Sub
VB.NET
Copy
Public Sub MacroMdiElements()
    Dim zenonDynPicture As IDynPicture = Me.ActiveDocument.DynPictures().Item("AML")
    Dim zenonMdiElements As IMdiElements = zenonDynPicture.MdiElements()

    For i As Integer = 0 To zenonMdiElements.Count - 1
        System.Diagnostics.Debug.Print("Caption: " + zenonMdiElements.Item(i).Caption)
        System.Diagnostics.Debug.Print("Position Left: " + zenonMdiElements.Item(i).Left)
        System.Diagnostics.Debug.Print("Position Top: " + zenonMdiElements.Item(i).Top)
        System.Diagnostics.Debug.Print("Width: " + zenonMdiElements.Item(i).Width)
        System.Diagnostics.Debug.Print("Height: " + zenonMdiElements.Item(i).Height)
    Next
End Sub


MDITemplate
ObjectModel COM [image] MDITemplate
Remarks

<span"></span>

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroMdiTemplate()
{
    //Print the properties of all "Keyboard" MDITemplates
    IMDITemplates zenonMDITemplates = this.GetMDiTemplates("Keyboard");
    if (zenonMDITemplates != null)
    {
        for (int i = 0; i < zenonMDITemplates.Count; ++i)
        {
            IMDITemplate zenonMdiTemplate = zenonMDITemplates.Item(i);
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("Name").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("GUID").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("ImportPath").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("Folder").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("MDIType").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("Language").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("Description").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("CopaDataTemplate").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("DefaultTemplate").ToString());
        }
    }
}
VB.NET
Copy
Public Sub MacroMdiTemplate()
    'Print the properties of all "Keyboard" MDITemplates
    Dim zenonMDITemplates As IMDITemplates = Me.GetMDiTemplates("Keyboard")
    If zenonMDITemplates IsNot Nothing Then
        For i As Integer = 0 To zenonMDITemplates.Count - 1
            Dim zenonMdiTemplate As IMDITemplate = zenonMDITemplates.Item(i)
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("Name").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("GUID").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("ImportPath").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("Folder").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("MDIType").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("Language").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("Description").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("CopaDataTemplate").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("DefaultTemplate").ToString())
        Next
    End If
End Sub
VBA
Copy
Private Sub GetTemplates()
Dim IMDITemplates As MDITemplates
Dim IMDITemplate As MDITemplate
Dim Count As Integer
Dim Ok As Boolean
Dim i As Integer
' --- Selection by Name
Set IMDITemplates = MyWorkspace.GetMDiTemplates("Keyboard")
If Not IMDITemplates Is Nothing Then

Set IMDITemplate = IMDITemplates.Item("Test 3")

Ok = PrintTemplate(IMDITemplate)
End If
' --- Selection by index (zenon Constant)
Set IMDITemplates = MyWorkspace.GetMDiTemplates(tpKeyboard)
If Not IMDITemplates Is Nothing Then
Count = IMDITemplates.Count

For i = 0 To Count - 1

Set IMDITemplate = IMDITemplates.Item(i)

Ok = PrintTemplate(IMDITemplate)

Next
End If
End Sub
Private Function PrintTemplate(IMDITemplate As MDITemplate) As Boolean

If Not IMDITemplate Is Nothing Then

Debug.Print ("Name: " & IMDITemplate.DynProperties("Name"))

Debug.Print ("GUID: " & IMDITemplate.DynProperties("GUID"))

Debug.Print ("ImportPath: " & IMDITemplate.DynProperties("ImportPath"))

Debug.Print ("Folder: " & IMDITemplate.DynProperties("Folder"))

Debug.Print ("MDIType: " & IMDITemplate.DynProperties("MDIType"))

Debug.Print ("Language: " & IMDITemplate.DynProperties("Language"))

Debug.Print ("Description: " & IMDITemplate.DynProperties("Description"))

Debug.Print ("CopaDataTemplate: " & IMDITemplate.DynProperties("CopaDataTemplate"))

Debug.Print ("DefaultTemplate: " & IMDITemplate.DynProperties("DefaultTemplate"))

PrintTemplate = True
Else

PrintTemplate = False
End If
End Function


Methods
ObjectModel COM [image] MDITemplate [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant |  | Readonly | Unused | Available | Available
DynPropertiesEnum [GET] | variant |  | Readonly | Unused | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available


DynProperties [GET]
ObjectModel COM [image] MDITemplate [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Private Sub GetTemplates()
Dim IMDITemplates As MDITemplates
Dim IMDITemplate As MDITemplate
Dim Count As Integer
Dim Ok As Boolean
Dim i As Integer
' --- Selection by Name
Set IMDITemplates = MyWorkspace.GetMDiTemplates("Keyboard")
If Not IMDITemplates Is Nothing Then

Set IMDITemplate = IMDITemplates.Item("Test 3")

Ok = PrintTemplate(IMDITemplate)
End If
' --- Selection by index (zenon Constant)
Set IMDITemplates = MyWorkspace.GetMDiTemplates(tpKeyboard)
If Not IMDITemplates Is Nothing Then

Count = IMDITemplates.Count

For i = 0 To Count - 1

Set IMDITemplate = IMDITemplates.Item(i)

Ok = PrintTemplate(IMDITemplate)

Next
End If
End Sub
Private Function PrintTemplate(IMDITemplate As MDITemplate) As Boolean
If Not IMDITemplate Is Nothing Then

Debug.Print ("Name: " & IMDITemplate.DynProperties("Name"))

Debug.Print ("GUID: " & IMDITemplate.DynProperties("GUID"))

Debug.Print ("ImportPath: " & IMDITemplate.DynProperties("ImportPath"))

Debug.Print ("Folder: " & IMDITemplate.DynProperties("Folder"))

Debug.Print ("MDIType: " & IMDITemplate.DynProperties("MDIType"))

Debug.Print ("Language: " & IMDITemplate.DynProperties("Language"))

Debug.Print ("Description: " & IMDITemplate.DynProperties("Description"))

Debug.Print ("CopaDataTemplate: " & IMDITemplate.DynProperties("CopaDataTemplate"))

Debug.Print ("DefaultTemplate: " & IMDITemplate.DynProperties("DefaultTemplate"))

PrintTemplate = True
Else

PrintTemplate = False
End If
End Function


DynPropertiesEnum [GET]
ObjectModel COM [image] MDITemplate [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynPropertyParam [GET]
ObjectModel COM [image] MDITemplate [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties
ObjectModel COM [image] MDITemplate [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

MDI data template


MDI data template
ObjectModel COM [image] MDITemplate [image] DynProperties [image] MDI data template
Overview
External Name | Type | Display Name | Description
CopaDataTemplate | Bool | CopaDataTemplate | True=Copa Date template False= Customer created templated
DefaultTemplate | Bool | DefaultTemplate | TRUE= Default template FALSE= none default template
Description | String | Description | Description of the template.
Folder | String | Folder | Path where the templates is stored. eg. C:\ProgramData\COPA-DATA\zenon700\Templates\ScreenTypes\ENGLISH\Alarm Message list\5d1c2408-29b4-4cb9-95578-562jj458990.zip
GUID | String | GUID | Guid of the Template. E.g. 5d1c2408-29b4-4cb9-95578-562jj458990
Height | UInt32 | Height | Heigth of the template.
ImportPath | String | ImportPath | Import path of the template.
Language | String | Language | Language of the template.
MDIType | UInt32 | MDIType | Type of the templates ( Constants tpDynPicturesTypes)
Name | String | Name | Given name of the template.
ScreenX | UInt32 | ScreenX | Screen width.
ScreenY | UInt32 | ScreenY | Screen height.
Width | UInt32 | Width | Widthof the template.


MDITemplates
ObjectModel COM [image] MDITemplates
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroMdiTemplate()
{
    //Print the properties of all "Keyboard" MDITemplates
    IMDITemplates zenonMDITemplates = this.GetMDiTemplates("Keyboard");
    if (zenonMDITemplates != null)
    {
        for (int i = 0; i < zenonMDITemplates.Count; ++i)
        {
            IMDITemplate zenonMdiTemplate = zenonMDITemplates.Item(i);
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("Name").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("GUID").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("ImportPath").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("Folder").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("MDIType").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("Language").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("Description").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("CopaDataTemplate").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("DefaultTemplate").ToString());
        }
    }
}
VB.NET
Copy
Public Sub MacroMdiTemplate()
    'Print the properties of all "Keyboard" MDITemplates
    Dim zenonMDITemplates As IMDITemplates = Me.GetMDiTemplates("Keyboard")
    If zenonMDITemplates IsNot Nothing Then
        For i As Integer = 0 To zenonMDITemplates.Count - 1
            Dim zenonMdiTemplate As IMDITemplate = zenonMDITemplates.Item(i)
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("Name").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("GUID").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("ImportPath").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("Folder").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("MDIType").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("Language").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("Description").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("CopaDataTemplate").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("DefaultTemplate").ToString())
        Next
    End If
End Sub
VBA
Copy
Private Sub GetTemplates()
Dim IMDITemplates As MDITemplates
Dim IMDITemplate As MDITemplate
Dim Count As Integer
Dim Ok As Boolean
Dim i As Integer
' --- Selection by Name
Set IMDITemplates = MyWorkspace.GetMDiTemplates("Keyboard")
If Not IMDITemplates Is Nothing Then

Set IMDITemplate = IMDITemplates.Item("Test 3")

Ok = PrintTemplate(IMDITemplate)
End If
' --- Selection by index (zenon Constant)
Set IMDITemplates = MyWorkspace.GetMDiTemplates(tpKeyboard)
If Not IMDITemplates Is Nothing Then

Count = IMDITemplates.Count

For i = 0 To Count - 1

Set IMDITemplate = IMDITemplates.Item(i)

Ok = PrintTemplate(IMDITemplate)

Next
End If
End Sub
Private Function PrintTemplate(IMDITemplate As MDITemplate) As Boolean
If Not IMDITemplate Is Nothing Then

Debug.Print ("Name: " & IMDITemplate.DynProperties("Name"))

Debug.Print ("GUID: " & IMDITemplate.DynProperties("GUID"))

Debug.Print ("ImportPath: " & IMDITemplate.DynProperties("ImportPath"))

Debug.Print ("Folder: " & IMDITemplate.DynProperties("Folder"))

Debug.Print ("MDIType: " & IMDITemplate.DynProperties("MDIType"))

Debug.Print ("Language: " & IMDITemplate.DynProperties("Language"))

Debug.Print ("Description: " & IMDITemplate.DynProperties("Description"))

Debug.Print ("CopaDataTemplate: " & IMDITemplate.DynProperties("CopaDataTemplate"))

Debug.Print ("DefaultTemplate: " & IMDITemplate.DynProperties("DefaultTemplate"))

PrintTemplate = True
Else

PrintTemplate = False
End If
End Function


Properties
ObjectModel COM [image] MDITemplates [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Number of MDI Templates in the Collection. | Available | Unused | Available | Available


Count
ObjectModel COM [image] MDITemplates [image] Properties [image] Count
Remarks

Number of MDI Templates in the Collection.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] MDITemplates [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Item | imditemplate | Returns the MDI Template by Name or Position. | Available | Unused | Available | Available


Item
ObjectModel COM [image] MDITemplates [image] Methods [image] Item
Remarks

Returns the MDI Template by Name or Position.

Datatype
IMDITemplate

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vPosOrName as VARIANT

Example
C#
Copy
public void MacroMdiTemplate()
{
    //Print the properties of all "Keyboard" MDITemplates
    IMDITemplates zenonMDITemplates = this.GetMDiTemplates("Keyboard");
    if (zenonMDITemplates != null)
    {
        for (int i = 0; i < zenonMDITemplates.Count; ++i)
        {
            IMDITemplate zenonMdiTemplate = zenonMDITemplates.Item(i);
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("Name").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("GUID").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("ImportPath").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("Folder").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("MDIType").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("Language").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("Description").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("CopaDataTemplate").ToString());
            System.Diagnostics.Debug.Print(
                zenonMdiTemplate.get_DynProperties("DefaultTemplate").ToString());
        }
    }
}
VB.NET
Copy
Public Sub MacroMdiTemplate()
    'Print the properties of all "Keyboard" MDITemplates
    Dim zenonMDITemplates As IMDITemplates = Me.GetMDiTemplates("Keyboard")
    If zenonMDITemplates IsNot Nothing Then
        For i As Integer = 0 To zenonMDITemplates.Count - 1
            Dim zenonMdiTemplate As IMDITemplate = zenonMDITemplates.Item(i)
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("Name").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("GUID").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("ImportPath").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("Folder").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("MDIType").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("Language").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("Description").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("CopaDataTemplate").ToString())
            System.Diagnostics.Debug.Print(zenonMdiTemplate.get_DynProperties("DefaultTemplate").ToString())
        Next
    End If
End Sub


MessageControl
ObjectModel COM [image] MessageControl
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroMessageControl()
{
    //Print properties of the message control
    IMessageControl zenonMessageControl =
        this.ActiveDocument.MessageControl;
    System.Diagnostics.Debug.Print("Message Control active during Runtime start: "
        + zenonMessageControl.ActiveAtStartup);
    System.Diagnostics.Debug.Print("Max number of attempts: "
        + zenonMessageControl.Attempts);
    System.Diagnostics.Debug.Print("Detail level for log in CEL: "
        + zenonMessageControl.CelDetail);
    System.Diagnostics.Debug.Print("Waiting period between two attempts[min]: "
        + zenonMessageControl.TimeToWait);
    System.Diagnostics.Debug.Print("Log manual deletion of messages in CEL: "
        + zenonMessageControl.LogMessageDeleteActions);
}
VB.NET
Copy
Public Sub MacroMessageControl()
    'Print properties of the message control
    Dim zenonMessageControl As IMessageControl = Me.ActiveDocument.MessageControl
    System.Diagnostics.Debug.Print("Message Control active during Runtime start: " + zenonMessageControl.ActiveAtStartup)
    System.Diagnostics.Debug.Print("Max number of attempts: " + zenonMessageControl.Attempts)
    System.Diagnostics.Debug.Print("Detail level for log in CEL: " + zenonMessageControl.CelDetail)
    System.Diagnostics.Debug.Print("Waiting period between two attempts[min]: " + zenonMessageControl.TimeToWait)
    System.Diagnostics.Debug.Print("Log manual deletion of messages in CEL: " + zenonMessageControl.LogMessageDeleteActions)
End Sub
VBA
Copy
'====================================================================================================
' MessageControl Workspace
'====================================================================================================
Private Sub MessageControl_Sample()
Dim zMessage As MessageControlMessage
Dim zMessageControl As MessageControl
Dim i As Integer
Dim count As Integer
On Error GoTo ErrorHandler
Stop
'Get Message Control Properties
Set zMessageControl = MyWorkspace.ActiveDocument.MessageControl
With zMessageControl

Debug.Print ("Message Control active during Runtime start: " &
CStr(.ActiveAtStartup))

Debug.Print ("Max. number of attemtps: " & CStr(.Attempts))

Debug.Print ("Detail level for Log in CEL: " & CStr(.CelDetail))

Debug.Print ("Waiting period between two attempts[min] : " & CStr(.TimeToWait))

Debug.Print ("Log manuel deletion of messages in the CEL : " &
CStr(.LogMessageDeleteActions));

'Set Message Control Properties

.ActiveAtStartup = False

.Attempts = 5

.CelDetail = tpCelDetailNone

.TimeToWait = 15

.LogMessageDeleteActions = True
End With
Exit Sub
ErrorHandler:
Debug.Print ("Error :" & Err.Description & " " & Err.Number)
End Sub


Properties
ObjectModel COM [image] MessageControl [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ActiveAtStartup | variant_bool |  | Available | Readonly | Available | Available
Attempts | short |  | Available | Readonly | Available | Available
CelDetail | tpmsgctrlceldetail |  | Available | Readonly | Available | Available
CurrentQueue | variant |  | Unused | Readonly | Available | Available
LogMessageDeleteActions | variant_bool |  | Available | Readonly | Available | Available
TimeToWait | short |  | Available | Readonly | Available | Available


ActiveAtStartup
ObjectModel COM [image] MessageControl [image] Properties [image] ActiveAtStartup
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Attempts
ObjectModel COM [image] MessageControl [image] Properties [image] Attempts
Remarks

Datatype
short

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


CelDetail
ObjectModel COM [image] MessageControl [image] Properties [image] CelDetail
Remarks

Datatype
tpMsgCtrlCelDetail

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


CurrentQueue
ObjectModel COM [image] MessageControl [image] Properties [image] CurrentQueue
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


LogMessageDeleteActions
ObjectModel COM [image] MessageControl [image] Properties [image] LogMessageDeleteActions
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


TimeToWait
ObjectModel COM [image] MessageControl [image] Properties [image] TimeToWait
Remarks

Datatype
short

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] MessageControl [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant |  | Available | Readonly | Available | Available
DynProperties [PUT] | void |  | Available | Readonly | Available | Available
DynPropertiesEnum [GET] | variant |  | Available | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available


DynProperties [GET]
ObjectModel COM [image] MessageControl [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties [PUT]
ObjectModel COM [image] MessageControl [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT


DynPropertiesEnum [GET]
ObjectModel COM [image] MessageControl [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynPropertyParam [GET]
ObjectModel COM [image] MessageControl [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Events
ObjectModel COM [image] MessageControl [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
MessageAcknowledged | void |  | Unused | Readonly | Available | Available
MessageAcknowledgeTimeOut | void |  | Unused | Readonly | Available | Available
MessageCreated | void | Event is fired once a new message is created. | Unused | Available | Available | Available
MessageDeleted | void | Event is fired once a message gets deleted. | Unused | Readonly | Available | Available
MessageIn | void | Event is fired once a message comes in. | Unused | Readonly | Available | Available
MessageNegAcknowledged | void |  | Unused | Readonly | Available | Available
MessageSendError | void | Event is fired once an error occurs during the message sending process. | Unused | Readonly | Available | Available
MessageSent | void | Event is fired once a message has been sent. | Unused | Readonly | Available | Available
SelectionChanged | void |  | Unused | Readonly | Available | Available


MessageAcknowledged
ObjectModel COM [image] MessageControl [image] Events [image] MessageAcknowledged
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
obMessage as IMessageControlMessage

Example
C#
Copy
//Initialize event handlers
private IMessageControl _zenonMessageControl;
void ThisProject_Active()
{
    _zenonMessageControl = this.MessageControl;
    _zenonMessageControl.MessageAcknowledged += new MessageAcknowledgedEventHandler(_zenonMessageControl_MessageAcknowledged);
    _zenonMessageControl.MessageNegAcknowledged += new MessageNegAcknowledgedEventHandler(_zenonMessageControl_MessageNegAcknowledged);
    _zenonMessageControl.MessageAcknowledgeTimeOut += new MessageAcknowledgeTimeOutEventHandler(_zenonMessageControl_MessageAcknowledgeTimeOut);
}

void _zenonMessageControl_MessageAcknowledgeTimeOut(IMessageControlMessage obMessage)
{
    System.Diagnostics.Debug.Print("Message's \"" +
        obMessage.MessageText + "\" acknowledge timed out.");
}

void _zenonMessageControl_MessageNegAcknowledged(IMessageControlMessage obMessage)
{
    System.Diagnostics.Debug.Print("Message \"" +
        obMessage.MessageText + "\" has had its acknowledge status reset.");
}

void _zenonMessageControl_MessageAcknowledged(IMessageControlMessage obMessage)
{
    System.Diagnostics.Debug.Print("Message \"" +
        obMessage.MessageText + "\" has been acknowledged.");
}

//Destroy event handlers
void ThisProject_Inactive()
{
    _zenonMessageControl.MessageAcknowledgeTimeOut -= _zenonMessageControl_MessageAcknowledgeTimeOut;
    _zenonMessageControl.MessageAcknowledged -= _zenonMessageControl_MessageAcknowledged;
    _zenonMessageControl.MessageNegAcknowledged -= _zenonMessageControl_MessageNegAcknowledged;
    FreeObjects();
}
VB.NET
Copy
'Initialize event handlers
Private _zenonMessageControl As IMessageControl
Private Sub ThisProject_Active()
    _zenonMessageControl = Me.MessageControl
    _zenonMessageControl.MessageAcknowledged += New MessageAcknowledgedEventHandler(AddressOf _zenonMessageControl_MessageAcknowledged)
    _zenonMessageControl.MessageNegAcknowledged += New MessageNegAcknowledgedEventHandler(AddressOf _zenonMessageControl_MessageNegAcknowledged)
    _zenonMessageControl.MessageAcknowledgeTimeOut += New MessageAcknowledgeTimeOutEventHandler(AddressOf _zenonMessageControl_MessageAcknowledgeTimeOut)
End Sub

Private Sub _zenonMessageControl_MessageAcknowledgeTimeOut(obMessage As IMessageControlMessage)
    System.Diagnostics.Debug.Print("Message's """ + obMessage.MessageText + """ acknowledge timed out.")
End Sub

Private Sub _zenonMessageControl_MessageNegAcknowledged(obMessage As IMessageControlMessage)
    System.Diagnostics.Debug.Print("Message """ + obMessage.MessageText + """ has had its acknowledge status reset.")
End Sub

Private Sub _zenonMessageControl_MessageAcknowledged(obMessage As IMessageControlMessage)
    System.Diagnostics.Debug.Print("Message """ + obMessage.MessageText + """ has been acknowledged.")
End Sub

'Destroy event handlers
Private Sub ThisProject_Inactive()
    RemoveHandler _zenonMessageControl.MessageAcknowledgeTimeOut, AddressOf _zenonMessageControl_MessageAcknowledgeTimeOut
    RemoveHandler _zenonMessageControl.MessageAcknowledged, AddressOf _zenonMessageControl_MessageAcknowledged
    RemoveHandler _zenonMessageControl.MessageNegAcknowledged, AddressOf _zenonMessageControl_MessageNegAcknowledged
    FreeObjects()
End Sub


MessageAcknowledgeTimeOut
ObjectModel COM [image] MessageControl [image] Events [image] MessageAcknowledgeTimeOut
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
obMessage as IMessageControlMessage

Example
C#
Copy
//Initialize event handlers
private IMessageControl _zenonMessageControl;
void ThisProject_Active()
{
    _zenonMessageControl = this.MessageControl;
    _zenonMessageControl.MessageAcknowledged += new MessageAcknowledgedEventHandler(_zenonMessageControl_MessageAcknowledged);
    _zenonMessageControl.MessageNegAcknowledged += new MessageNegAcknowledgedEventHandler(_zenonMessageControl_MessageNegAcknowledged);
    _zenonMessageControl.MessageAcknowledgeTimeOut += new MessageAcknowledgeTimeOutEventHandler(_zenonMessageControl_MessageAcknowledgeTimeOut);
}

void _zenonMessageControl_MessageAcknowledgeTimeOut(IMessageControlMessage obMessage)
{
    System.Diagnostics.Debug.Print("Message's \"" +
        obMessage.MessageText + "\" acknowledge timed out.");
}

void _zenonMessageControl_MessageNegAcknowledged(IMessageControlMessage obMessage)
{
    System.Diagnostics.Debug.Print("Message \"" +
        obMessage.MessageText + "\" has had its acknowledge status reset.");
}

void _zenonMessageControl_MessageAcknowledged(IMessageControlMessage obMessage)
{
    System.Diagnostics.Debug.Print("Message \"" +
        obMessage.MessageText + "\" has been acknowledged.");
}

//Destroy event handlers
void ThisProject_Inactive()
{
    _zenonMessageControl.MessageAcknowledgeTimeOut -= _zenonMessageControl_MessageAcknowledgeTimeOut;
    _zenonMessageControl.MessageAcknowledged -= _zenonMessageControl_MessageAcknowledged;
    _zenonMessageControl.MessageNegAcknowledged -= _zenonMessageControl_MessageNegAcknowledged;
    FreeObjects();
}
VB.NET
Copy
'Initialize event handlers
Private _zenonMessageControl As IMessageControl
Private Sub ThisProject_Active()
    _zenonMessageControl = Me.MessageControl
    _zenonMessageControl.MessageAcknowledged += New MessageAcknowledgedEventHandler(AddressOf _zenonMessageControl_MessageAcknowledged)
    _zenonMessageControl.MessageNegAcknowledged += New MessageNegAcknowledgedEventHandler(AddressOf _zenonMessageControl_MessageNegAcknowledged)
    _zenonMessageControl.MessageAcknowledgeTimeOut += New MessageAcknowledgeTimeOutEventHandler(AddressOf _zenonMessageControl_MessageAcknowledgeTimeOut)
End Sub

Private Sub _zenonMessageControl_MessageAcknowledgeTimeOut(obMessage As IMessageControlMessage)
    System.Diagnostics.Debug.Print("Message's """ + obMessage.MessageText + """ acknowledge timed out.")
End Sub

Private Sub _zenonMessageControl_MessageNegAcknowledged(obMessage As IMessageControlMessage)
    System.Diagnostics.Debug.Print("Message """ + obMessage.MessageText + """ has had its acknowledge status reset.")
End Sub

Private Sub _zenonMessageControl_MessageAcknowledged(obMessage As IMessageControlMessage)
    System.Diagnostics.Debug.Print("Message """ + obMessage.MessageText + """ has been acknowledged.")
End Sub

'Destroy event handlers
Private Sub ThisProject_Inactive()
    RemoveHandler _zenonMessageControl.MessageAcknowledgeTimeOut, AddressOf _zenonMessageControl_MessageAcknowledgeTimeOut
    RemoveHandler _zenonMessageControl.MessageAcknowledged, AddressOf _zenonMessageControl_MessageAcknowledged
    RemoveHandler _zenonMessageControl.MessageNegAcknowledged, AddressOf _zenonMessageControl_MessageNegAcknowledged
    FreeObjects()
End Sub


MessageCreated
ObjectModel COM [image] MessageControl [image] Events [image] MessageCreated
Remarks

Event is fired once a new message is created.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obAlarmItem as IAlarmItem

obMessage as IMessageControlMessage

Example
C#
Copy
//Initialize event handlers
private IMessageControl _zenonMessageControl;
void ThisProject_Active()
{
    _zenonMessageControl = this.MessageControl;
    _zenonMessageControl.MessageCreated += new MessageCreatedEventHandler(_zenonMessageControl_MessageCreated);
}

void _zenonMessageControl_MessageCreated(IAlarmItem obAlarmItem, IMessageControlMessage obMessage)
{
    if (obAlarmItem != null)
        System.Diagnostics.Debug.Print(obAlarmItem.Name);
    if (obMessage != null)
    {
        System.Diagnostics.Debug.Print("Current message text: " +
            obMessage.MessageText);
        obMessage.MessageText = "New Message Text";
        //In this event the message has not been sent yet and it is
        //possible to change the message text.
    }
}

//Destroy event handlers
void ThisProject_Inactive()
{
    _zenonMessageControl.MessageCreated -= _zenonMessageControl_MessageCreated;
    FreeObjects();
}
VB.NET
Copy
'Initialize event handlers
Private _zenonMessageControl As IMessageControl
Private Sub ThisProject_Active()
    _zenonMessageControl = Me.MessageControl
    _zenonMessageControl.MessageCreated += New MessageCreatedEventHandler(AddressOf _zenonMessageControl_MessageCreated)
End Sub

Private Sub _zenonMessageControl_MessageCreated(obAlarmItem As IAlarmItem, obMessage As IMessageControlMessage)
    If obAlarmItem IsNot Nothing Then
        System.Diagnostics.Debug.Print(obAlarmItem.Name)
    End If
    If obMessage IsNot Nothing Then
        System.Diagnostics.Debug.Print("Current message text: " + obMessage.MessageText)
            'In this event the message has not been sent yet and it is
            'possible to change the message text.
        obMessage.MessageText = "New Message Text"
    End If
End Sub

'Destroy event handlers
Private Sub ThisProject_Inactive()
    RemoveHandler _zenonMessageControl.MessageCreated, AddressOf _zenonMessageControl_MessageCreated
    FreeObjects()
End Sub
VBA
Copy
Dim WithEvents zMessageControl As MessageControl
Private Sub Project_Active()
Set zMessageControl = thisProject.MessageControl
End Sub

'====================================================================================================
' MessageControl Runtime
' It has been generates a new message in the system. The Message Control Message object
' corresponding to the actual message object which will be shipped later.
' Access to this object is only allowed within the event handler.
'====================================================================================================
Private Sub zMessageControl_MessageCreated(ByVal obAlarmItem As IAlarmItem, ByVal obMessage As IMessageControlMessage)
Stop
If Not obAlarmItem Is Nothing Then

Debug.Print (obAlarmItem.Name)
End If
If Not obMessage Is Nothing Then

Debug.Print ("Current message text: " & obMessage.MessageText)

' Only in this event it is possible to overrite the MessageControlMessage Object

obMessage.MessageText = "New message text"
End If
End Sub


MessageDeleted
ObjectModel COM [image] MessageControl [image] Events [image] MessageDeleted
Remarks

Event is fired once a message gets deleted.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
obMessage as IMessageControlMessage

Example
C#
Copy
//Initialize event handlers
private IMessageControl _zenonMessageControl;
void ThisProject_Active()
{
    _zenonMessageControl = this.MessageControl;
    _zenonMessageControl.MessageAcknowledged += new MessageAcknowledgedEventHandler(_zenonMessageControl_MessageAcknowledged);
    _zenonMessageControl.MessageNegAcknowledged += new MessageNegAcknowledgedEventHandler(_zenonMessageControl_MessageNegAcknowledged);
    _zenonMessageControl.MessageAcknowledgeTimeOut += new MessageAcknowledgeTimeOutEventHandler(_zenonMessageControl_MessageAcknowledgeTimeOut);
}

void _zenonMessageControl_MessageAcknowledgeTimeOut(IMessageControlMessage obMessage)
{
    System.Diagnostics.Debug.Print("Message's \"" +
        obMessage.MessageText + "\" acknowledge timed out.");
}

void _zenonMessageControl_MessageNegAcknowledged(IMessageControlMessage obMessage)
{
    System.Diagnostics.Debug.Print("Message \"" +
        obMessage.MessageText + "\" has had its acknowledge status reset.");
}

void _zenonMessageControl_MessageAcknowledged(IMessageControlMessage obMessage)
{
    System.Diagnostics.Debug.Print("Message \"" +
        obMessage.MessageText + "\" has been acknowledged.");
}

//Destroy event handlers
void ThisProject_Inactive()
{
    _zenonMessageControl.MessageAcknowledgeTimeOut -= _zenonMessageControl_MessageAcknowledgeTimeOut;
    _zenonMessageControl.MessageAcknowledged -= _zenonMessageControl_MessageAcknowledged;
    _zenonMessageControl.MessageNegAcknowledged -= _zenonMessageControl_MessageNegAcknowledged;
    FreeObjects();
}
VB.NET
Copy
'Initialize event handlers
Private _zenonMessageControl As IMessageControl
Private Sub ThisProject_Active()
    _zenonMessageControl = Me.MessageControl
    _zenonMessageControl.MessageAcknowledged += New MessageAcknowledgedEventHandler(AddressOf _zenonMessageControl_MessageAcknowledged)
    _zenonMessageControl.MessageNegAcknowledged += New MessageNegAcknowledgedEventHandler(AddressOf _zenonMessageControl_MessageNegAcknowledged)
    _zenonMessageControl.MessageAcknowledgeTimeOut += New MessageAcknowledgeTimeOutEventHandler(AddressOf _zenonMessageControl_MessageAcknowledgeTimeOut)
End Sub

Private Sub _zenonMessageControl_MessageAcknowledgeTimeOut(obMessage As IMessageControlMessage)
    System.Diagnostics.Debug.Print("Message's """ + obMessage.MessageText + """ acknowledge timed out.")
End Sub

Private Sub _zenonMessageControl_MessageNegAcknowledged(obMessage As IMessageControlMessage)
    System.Diagnostics.Debug.Print("Message """ + obMessage.MessageText + """ has had its acknowledge status reset.")
End Sub

Private Sub _zenonMessageControl_MessageAcknowledged(obMessage As IMessageControlMessage)
    System.Diagnostics.Debug.Print("Message """ + obMessage.MessageText + """ has been acknowledged.")
End Sub

'Destroy event handlers
Private Sub ThisProject_Inactive()
    RemoveHandler _zenonMessageControl.MessageAcknowledgeTimeOut, AddressOf _zenonMessageControl_MessageAcknowledgeTimeOut
    RemoveHandler _zenonMessageControl.MessageAcknowledged, AddressOf _zenonMessageControl_MessageAcknowledged
    RemoveHandler _zenonMessageControl.MessageNegAcknowledged, AddressOf _zenonMessageControl_MessageNegAcknowledged
    FreeObjects()
End Sub


MessageIn
ObjectModel COM [image] MessageControl [image] Events [image] MessageIn
Remarks

Event is fired once a message comes in.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsIdentifier as BSTR

bsMessage as BSTR

Example
C#
Copy
//Initialize event handlers
private IMessageControl _zenonMessageControl;
void ThisProject_Active()
{
    _zenonMessageControl = this.MessageControl;
    _zenonMessageControl.MessageIn += new MessageInEventHandler(_zenonMessageControl_MessageIn);
}

void _zenonMessageControl_MessageIn(ref string bsIdentifier, ref string bsMessage)
{
    System.Diagnostics.Debug.Print("Message came: " + bsMessage);
}

//Destroy event handlers
void ThisProject_Inactive()
{
    FreeObjects();
    _zenonMessageControl.MessageIn -= _zenonMessageControl_MessageIn;
}
VB.NET
Copy
'Initialize event handlers
Private _zenonMessageControl As IMessageControl
Private Sub ThisProject_Active()
    _zenonMessageControl = Me.MessageControl
    _zenonMessageControl.MessageIn += New MessageInEventHandler(AddressOf _zenonMessageControl_MessageIn)
End Sub

Private Sub _zenonMessageControl_MessageIn(ByRef bsIdentifier As String, ByRef bsMessage As String)
    System.Diagnostics.Debug.Print(Convert.ToString("Message came: ") & bsMessage)
End Sub

'Destroy event handlers
Private Sub ThisProject_Inactive()
    FreeObjects()
    RemoveHandler _zenonMessageControl.MessageIn, AddressOf _zenonMessageControl_MessageIn
End Sub


MessageNegAcknowledged
ObjectModel COM [image] MessageControl [image] Events [image] MessageNegAcknowledged
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
obMessage as IMessageControlMessage

Example
C#
Copy
//Initialize event handlers
private IMessageControl _zenonMessageControl;
void ThisProject_Active()
{
    _zenonMessageControl = this.MessageControl;
    _zenonMessageControl.MessageAcknowledged += new MessageAcknowledgedEventHandler(_zenonMessageControl_MessageAcknowledged);
    _zenonMessageControl.MessageNegAcknowledged += new MessageNegAcknowledgedEventHandler(_zenonMessageControl_MessageNegAcknowledged);
    _zenonMessageControl.MessageAcknowledgeTimeOut += new MessageAcknowledgeTimeOutEventHandler(_zenonMessageControl_MessageAcknowledgeTimeOut);
}

void _zenonMessageControl_MessageAcknowledgeTimeOut(IMessageControlMessage obMessage)
{
    System.Diagnostics.Debug.Print("Message's \"" +
        obMessage.MessageText + "\" acknowledge timed out.");
}

void _zenonMessageControl_MessageNegAcknowledged(IMessageControlMessage obMessage)
{
    System.Diagnostics.Debug.Print("Message \"" +
        obMessage.MessageText + "\" has had its acknowledge status reset.");
}

void _zenonMessageControl_MessageAcknowledged(IMessageControlMessage obMessage)
{
    System.Diagnostics.Debug.Print("Message \"" +
        obMessage.MessageText + "\" has been acknowledged.");
}

//Destroy event handlers
void ThisProject_Inactive()
{
    _zenonMessageControl.MessageAcknowledgeTimeOut -= _zenonMessageControl_MessageAcknowledgeTimeOut;
    _zenonMessageControl.MessageAcknowledged -= _zenonMessageControl_MessageAcknowledged;
    _zenonMessageControl.MessageNegAcknowledged -= _zenonMessageControl_MessageNegAcknowledged;
    FreeObjects();
}
VB.NET
Copy
'Initialize event handlers
Private _zenonMessageControl As IMessageControl
Private Sub ThisProject_Active()
    _zenonMessageControl = Me.MessageControl
    _zenonMessageControl.MessageAcknowledged += New MessageAcknowledgedEventHandler(AddressOf _zenonMessageControl_MessageAcknowledged)
    _zenonMessageControl.MessageNegAcknowledged += New MessageNegAcknowledgedEventHandler(AddressOf _zenonMessageControl_MessageNegAcknowledged)
    _zenonMessageControl.MessageAcknowledgeTimeOut += New MessageAcknowledgeTimeOutEventHandler(AddressOf _zenonMessageControl_MessageAcknowledgeTimeOut)
End Sub

Private Sub _zenonMessageControl_MessageAcknowledgeTimeOut(obMessage As IMessageControlMessage)
    System.Diagnostics.Debug.Print("Message's """ + obMessage.MessageText + """ acknowledge timed out.")
End Sub

Private Sub _zenonMessageControl_MessageNegAcknowledged(obMessage As IMessageControlMessage)
    System.Diagnostics.Debug.Print("Message """ + obMessage.MessageText + """ has had its acknowledge status reset.")
End Sub

Private Sub _zenonMessageControl_MessageAcknowledged(obMessage As IMessageControlMessage)
    System.Diagnostics.Debug.Print("Message """ + obMessage.MessageText + """ has been acknowledged.")
End Sub

'Destroy event handlers
Private Sub ThisProject_Inactive()
    RemoveHandler _zenonMessageControl.MessageAcknowledgeTimeOut, AddressOf _zenonMessageControl_MessageAcknowledgeTimeOut
    RemoveHandler _zenonMessageControl.MessageAcknowledged, AddressOf _zenonMessageControl_MessageAcknowledged
    RemoveHandler _zenonMessageControl.MessageNegAcknowledged, AddressOf _zenonMessageControl_MessageNegAcknowledged
    FreeObjects()
End Sub


MessageSendError
ObjectModel COM [image] MessageControl [image] Events [image] MessageSendError
Remarks

Event is fired once an error occurs during the message sending process.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
obMessage as IMessageControlMessage

Example
C#
Copy
//Initialize event handlers
private IMessageControl _zenonMessageControl;
void ThisProject_Active()
{
    _zenonMessageControl = this.MessageControl;
    _zenonMessageControl.MessageSendError += new MessageSendErrorEventHandler(_zenonMessageControl_MessageSendError);
}

void _zenonMessageControl_MessageSendError(IMessageControlMessage obMessage)
{
    System.Diagnostics.Debug.Print("An error occured while sending \""
        + obMessage.MessageText + "\"");
}

//Destroy event handlers
void ThisProject_Inactive()
{
    _zenonMessageControl.MessageSendError -= _zenonMessageControl_MessageSendError;
    FreeObjects();
}
VB.NET
Copy
'Initialize event handlers
Private _zenonMessageControl As IMessageControl
Private Sub ThisProject_Active()
    _zenonMessageControl = Me.MessageControl
    _zenonMessageControl.MessageSendError += New MessageSendErrorEventHandler(AddressOf _zenonMessageControl_MessageSendError)
End Sub

Private Sub _zenonMessageControl_MessageSendError(obMessage As IMessageControlMessage)
    System.Diagnostics.Debug.Print("An error occured while sending """ + obMessage.MessageText + """")
End Sub

'Destroy event handlers
Private Sub ThisProject_Inactive()
    RemoveHandler _zenonMessageControl.MessageSendError, AddressOf _zenonMessageControl_MessageSendError
    FreeObjects()
End Sub


MessageSent
ObjectModel COM [image] MessageControl [image] Events [image] MessageSent
Remarks

Event is fired once a message has been sent.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
obMessage as IMessageControlMessage

Example
C#
Copy
//Initialize event handlers
private IMessageControl _zenonMessageControl;
void ThisProject_Active()
{
    _zenonMessageControl = this.MessageControl;
    _zenonMessageControl.MessageSent += new MessageSentEventHandler(_zenonMessageControl_MessageSent);
}

void _zenonMessageControl_MessageSent(IMessageControlMessage obMessage)
{
    System.Diagnostics.Debug.Print("A new message was sent.");
    System.Diagnostics.Debug.Print("Message text: " + obMessage.MessageText);
}

//Destroy event handlers
void ThisProject_Inactive()
{
    _zenonMessageControl.MessageSent -= _zenonMessageControl_MessageSent;
    FreeObjects();
}
VB.NET
Copy
'Initialize event handlers
Private _zenonMessageControl As IMessageControl
Private Sub ThisProject_Active()
    _zenonMessageControl = Me.MessageControl
    _zenonMessageControl.MessageSent += New MessageSentEventHandler(AddressOf _zenonMessageControl_MessageSent)
End Sub

Private Sub _zenonMessageControl_MessageSent(obMessage As IMessageControlMessage)
    System.Diagnostics.Debug.Print("A new message was sent.")
    System.Diagnostics.Debug.Print("Message text: " + obMessage.MessageText)
End Sub

'Destroy event handlers
Private Sub ThisProject_Inactive()
    RemoveHandler _zenonMessageControl.MessageSent, AddressOf _zenonMessageControl_MessageSent
    FreeObjects()
End Sub


SelectionChanged
ObjectModel COM [image] MessageControl [image] Events [image] SelectionChanged
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
obSelection as LPVARIANT


DynProperties
ObjectModel COM [image] MessageControl [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Message control


Message control
ObjectModel COM [image] MessageControl [image] DynProperties [image] Message control
Overview
External Name | Type | Display Name | Description
ActiveAtStartup | Bool | Active during Runtime start | Active : Message Control is started together with the Runtime.Default: active .
Attempts | Int16 | Maximum number of attempts | Maximum number of dispatch attempts in the event of a dispatch error that is recognized as a hardware error. If the request from the called is canceled without confirmation or rejection, there is no repetition.Maximum: 100 Minimum: 1 Default: 3 Note: This setting depends on the settings in the Methods option in the function. .
CelDetail | Int16 | Log in CEL | Defines which events are logged in the CEL. Select from drop-down list: .
ErrorColor | UInt32 | Error during sending | Defines the color with which the column status in screen of type Message Control is color-coded if the sending of a message fails. Click on button ... in order to open the dialog for selecting a color. .
ErrorImage | String | Error during sending | Defines a graphics file which is displayed in screen of type Message Control in column status if the sending try for a message failed. Click on button ... in order to open the dialog for selecting a graphics file. .
LogDeleteActions | Bool | Log manually deletion of messages in CEL. | Active : Manual deleting of entries from the CEL is logged in the CEL. .
SendingColor | UInt32 | Sending message | Defines the color with which the column status in screen of type Message Control is color-coded as long as the message is sent.. Click on button ... in order to open the dialog for selecting a color. .
SendingImage | String | Sending message | Defines a graphics file which is displayed in screen of type Message Control in column status as long as it is tried to send the message. Click on button ... in order to open the dialog for selecting a graphics file. .
SentColor | UInt32 | Message sent | Defines the color with which the column status in screen of type Message Control is color-coded when the message was sent successfully. Click on button ... in order to open the dialog for selecting a color. .
SentImage | String | Message sent | Defines a graphics file which is displayed in screen of type Message Control in column status as soon as the message was sent successfully. Click on button ... in order to open the dialog for selecting a graphics file. .
SubjectDyn | String | Dynamic part of the subject | Defines the project-specific part of the subject of incoming and outgoing messages. Is used together with properties / or / in the global sending settings. Incoming messages are filtered for this content for forwarding to Message Control.The text can contain wildcards.Key from the language tableName of a variablecompound entry in the language tableSyntax:Text parts are separated by a semi colon (; ),$ marks text that contains the parameter@ marks language switching% marks variablesText must end with a semicolon (; ).Example: $@Attention;%Var1; .
TimeToWait | Int16 | Waiting period between trials and timeout | Waiting period in minutes for the repetition between two sending tries or forwarding of a message.Default: 6 .


MessageControlMessage
ObjectModel COM [image] MessageControlMessage
Remarks

This object represents the user administration of the current project.With this object new users can be created and existing users can be edited/deleted during online operation. These changes can be imported into the Editor with decompiling. See the documentation of the control system for further information on decompiling.Users also can be logged in and out with this collection. Additionally this objects offers information on the currently logged in user.A user login executes the event UserChange with which you can execute user defined actions.Hint: For the event the object has to be defined with the attribute WithEvents in Visual Basic or VBA.

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Example
C#
Copy
//Initialize event handlers
private IMessageControl _zenonMessageControl;
void ThisProject_Active()
{
    _zenonMessageControl = this.MessageControl;
    _zenonMessageControl.MessageCreated += new MessageCreatedEventHandler(_zenonMessageControl_MessageCreated);
}

void _zenonMessageControl_MessageCreated(IAlarmItem obAlarmItem, IMessageControlMessage obMessage)
{
    if (obAlarmItem != null)
        System.Diagnostics.Debug.Print(obAlarmItem.Name);
    if (obMessage != null)
    {
        PrintMessage(obMessage);
    }
}

void PrintMessage(IMessageControlMessage zenonMessage)
{
    //Print some detail about the given message
    System.Diagnostics.Debug.Print("GUID: " + zenonMessage.Guid);
    System.Diagnostics.Debug.Print("Numbers of attempt: " + zenonMessage.Attempts);
    System.Diagnostics.Debug.Print("Max number of attempts: " + zenonMessage.MaxAttempts);
    System.Diagnostics.Debug.Print("Customer identifier: " + zenonMessage.CustomIdentifier);
    System.Diagnostics.Debug.Print("Title: " + zenonMessage.Title);
    System.Diagnostics.Debug.Print("Message text: " + zenonMessage.MessageText);
}

//Destroy event handlers
void ThisProject_Inactive()
{
    _zenonMessageControl.MessageCreated -= _zenonMessageControl_MessageCreated;
    FreeObjects();
}
VB.NET
Copy
'Initialize event handlers
Private _zenonMessageControl As IMessageControl
Private Sub ThisProject_Active()
    _zenonMessageControl = Me.MessageControl
    _zenonMessageControl.MessageCreated += New MessageCreatedEventHandler(AddressOf _zenonMessageControl_MessageCreated)
End Sub

Private Sub _zenonMessageControl_MessageCreated(obAlarmItem As IAlarmItem, obMessage As IMessageControlMessage)
    If obAlarmItem IsNot Nothing Then
        System.Diagnostics.Debug.Print(obAlarmItem.Name)
    End If
    If obMessage IsNot Nothing Then
        PrintMessage(obMessage)
    End If
End Sub

Private Sub PrintMessage(zenonMessage As IMessageControlMessage)
    'Print some detail about the given message
    System.Diagnostics.Debug.Print("GUID: " + zenonMessage.Guid)
    System.Diagnostics.Debug.Print("Numbers of attempt: " + zenonMessage.Attempts)
    System.Diagnostics.Debug.Print("Max number of attempts: " + zenonMessage.MaxAttempts)
    System.Diagnostics.Debug.Print("Customer identifier: " + zenonMessage.CustomIdentifier)
    System.Diagnostics.Debug.Print("Title: " + zenonMessage.Title)
    System.Diagnostics.Debug.Print("Message text: " + zenonMessage.MessageText)
End Sub

'Destroy event handlers
Private Sub ThisProject_Inactive()
    RemoveHandler _zenonMessageControl.MessageCreated, AddressOf _zenonMessageControl_MessageCreated
    FreeObjects()
End Sub
VBA
Copy
Dim WithEvents zMessageControl As MessageControl
Private Sub Project_Active()
Set zMessageControl = thisProject.MessageControl
End Sub

'====================================================================================================
' MessageControl Runtime
' It has been generates a new message in the system. The Message Control Message object
' corresponding to the actual message object which will be shipped later.
' Access to this object is only allowed within the event handler.
'====================================================================================================
Private Sub zMessageControl_MessageCreated(ByVal obAlarmItem As IAlarmItem, ByVal obMessage As IMessageControlMessage)
Stop
If Not obAlarmItem Is Nothing Then

Debug.Print (obAlarmItem.Name)
End If
If Not obMessage Is Nothing Then

Debug.Print ("Current message text: " & obMessage.MessageText)

' Only in this event it is possible to overrite the MessageControlMessage Object

obMessage.MessageText = "New message text"

Call ShowMessageInformation(obMessage)
End If
End Sub
Public Function ShowMessageInformation(ByVal obMessage As MessageControlMessage)
Debug.Print ("========================================================")
Debug.Print ("Message Guid: " & obMessage.Guid)
Debug.Print ("Numbers of attempt: " & CStr(obMessage.Attempts))
Debug.Print ("Max. number of attempts:" & CStr(obMessage.MaxAttempts))
Debug.Print ("Waiting period between two attempts [min]: " &

CStr(obMessage.TimeToWait))
Debug.Print ("Used dispatcher type: " & CStr(obMessage.DispatcherType))
Debug.Print ("Destination: " & obMessage.Destination)
Debug.Print ("Customer identifier: " & obMessage.CustomIdentifier)
Debug.Print ("Title of the message: " & obMessage.Title)
Debug.Print ("Current message text: " & obMessage.MessageText)
Debug.Print ("Time stamp when message is sending: " & CStr(obMessage.Send))
Debug.Print ("Time stamp when message was sent: " & CStr(obMessage.Sent))
Debug.Print ("Acknowledge required: " & CStr(obMessage.AcknowledgeRequired))
Debug.Print ("Time limit when message must be acknowledged: " &

CStr(obMessage.AcknowledgeTimeOut))
Debug.Print ("Dispatch type style: " & CStr(obMessage.TypeStyle)) 'User, Usergroup....
Debug.Print ("Destination type: " & CStr(obMessage.DestinationType))
Debug.Print ("Codes from function: " & CStr(obMessage.CodesFromFunction))
Debug.Print ("Cycle Counter: " & CStr(obMessage.CycleCounter))
Debug.Print ("========================================================")
End Function


Properties
ObjectModel COM [image] MessageControlMessage [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AcknowledgeRequired | variant_bool |  | Unused | Available | Available | Available
AcknowledgeTimeOut | date |  | Unused | Available | Available | Available
Attachment | bstr |  | Unused | Available | Available | Available
Attempts | short |  | Unused | Available | Available | Available
CodesFromFunction | variant_bool |  | Unused | Available | Available | Available
CustomIdentifier | bstr |  | Unused | Available | Available | Available
CycleCounter | long |  | Unused | Available | Available | Available
Destination | bstr |  | Unused | Available | Available | Available
DestinationType | short |  | Unused | Available | Available | Available
DispatcherType | short |  | Unused | Available | Available | Available
GroupSendingMethod | messagecontrolgroupsendingmethod |  | Unused | Available | Available | Available
Guid | bstr |  | Unused | Available | Available | Available
MaxAttempts | short |  | Unused | Readonly | Available | Available
MessageText | bstr |  | Unused | Available | Available | Available
RecipientType | messagecontrolrecipienttype |  | Unused | Available | Available | Available
Send | date |  | Unused | Available | Available | Available
SendingMode | messagecontrolsendingmode |  | Unused | Available | Available | Available
Sent | date |  | Unused | Available | Available | Available
TimeToWait | short |  | Unused | Available | Available | Available
Title | bstr |  | Unused | Available | Available | Available
TypeStyle | short |  | Unused | Available | Available | Available
UserName | bstr | Returns the name of the target User. | Unused | Available | Available | Available


AcknowledgeRequired
ObjectModel COM [image] MessageControlMessage [image] Properties [image] AcknowledgeRequired
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


AcknowledgeTimeOut
ObjectModel COM [image] MessageControlMessage [image] Properties [image] AcknowledgeTimeOut
Remarks

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Attachment
ObjectModel COM [image] MessageControlMessage [image] Properties [image] Attachment
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Attempts
ObjectModel COM [image] MessageControlMessage [image] Properties [image] Attempts
Remarks

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


CodesFromFunction
ObjectModel COM [image] MessageControlMessage [image] Properties [image] CodesFromFunction
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


CustomIdentifier
ObjectModel COM [image] MessageControlMessage [image] Properties [image] CustomIdentifier
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


CycleCounter
ObjectModel COM [image] MessageControlMessage [image] Properties [image] CycleCounter
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Destination
ObjectModel COM [image] MessageControlMessage [image] Properties [image] Destination
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


DestinationType
ObjectModel COM [image] MessageControlMessage [image] Properties [image] DestinationType
Remarks

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


DispatcherType
ObjectModel COM [image] MessageControlMessage [image] Properties [image] DispatcherType
Remarks

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


GroupSendingMethod
ObjectModel COM [image] MessageControlMessage [image] Properties [image] GroupSendingMethod
Remarks

Datatype
MessageControlGroupSendingMethod

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Guid
ObjectModel COM [image] MessageControlMessage [image] Properties [image] Guid
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


MaxAttempts
ObjectModel COM [image] MessageControlMessage [image] Properties [image] MaxAttempts
Remarks

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


MessageText
ObjectModel COM [image] MessageControlMessage [image] Properties [image] MessageText
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


RecipientType
ObjectModel COM [image] MessageControlMessage [image] Properties [image] RecipientType
Remarks

Datatype
MessageControlRecipientType

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Send
ObjectModel COM [image] MessageControlMessage [image] Properties [image] Send
Remarks

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


SendingMode
ObjectModel COM [image] MessageControlMessage [image] Properties [image] SendingMode
Remarks

Datatype
MessageControlSendingMode

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Sent
ObjectModel COM [image] MessageControlMessage [image] Properties [image] Sent
Remarks

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


TimeToWait
ObjectModel COM [image] MessageControlMessage [image] Properties [image] TimeToWait
Remarks

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Title
ObjectModel COM [image] MessageControlMessage [image] Properties [image] Title
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


TypeStyle
ObjectModel COM [image] MessageControlMessage [image] Properties [image] TypeStyle
Remarks

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


UserName
ObjectModel COM [image] MessageControlMessage [image] Properties [image] UserName
Remarks

Returns the name of the target User.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] MessageControlMessage [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant |  | Unused | Available | Available | Available
DynProperties [PUT] | void |  | Unused | Available | Available | Available
DynPropertiesEnum [GET] | variant | <span"></span> | Unused | Available | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available


DynProperties [GET]
ObjectModel COM [image] MessageControlMessage [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties [PUT]
ObjectModel COM [image] MessageControlMessage [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT


DynPropertiesEnum [GET]
ObjectModel COM [image] MessageControlMessage [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynPropertyParam [GET]
ObjectModel COM [image] MessageControlMessage [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties
ObjectModel COM [image] MessageControlMessage [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Send parameter


Send parameter
ObjectModel COM [image] MessageControlMessage [image] DynProperties [image] Send parameter
Overview
External Name | Type | Display Name | Description
AckReq | Bool | Acknowledgement mandatory | Message must be acknowledged at reception. .
AckTimeOut | UInt32 | Acknowledgement timeout | Time slot for the acknowledgment of the message. .
Attachment | String | Attachment | Name of the attachment of the message. Only for e-mail via SMTP. .
Attempts | Int16 | Tries | Number of tries. .
CodesFromFunction | Bool | Function-specific codes | Display whether an individual code is used for the acknowledgement. .
CustomIdentifier | String | Custom Identifier | Customized identifier. Can only be set via VBA/VSTA in Event MessageCreated . .
CycleCounter | UInt32 | Count of sent cycles | Number of forwards of this message. .
Destination | String | Target | Destination address of the message (e-mail address, telephone number). .
DestiType | Int16 | Target type (ID) |
DispatchType | Int16 | Sending mode (ID) |
GroupSendingMethod | UInt16 | GroupSendingMethod | Description
GUID | String | GUID | Unique identifier (GUID) of the message. .
MaxAttempts | Int16 | Maximum attempts | Maximum number of sending tries. .
MessageText | String | Message | Message text. .
RecipientType | Int16 | RecipientType | Description
Send | UInt32 | Next try | Time for the next sending try of the message. .
SendingMode | Int16 | SendingMode | Description
Sent | UInt32 | Created/last sending | Time at which the message was created or at which the last sending try took place. .
TimeToWait | Int16 | Waiting period | Waiting time in minutes for the monitoring of time out and forwarding of messages. .
Title | String | Subject |
TypeStyle | UInt16 | Sending mode style (ID) |
UserName | String | Recipient name |


OnlineAlarm
ObjectModel COM [image] OnlineAlarm
Remarks

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] OnlineAlarm [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AlarmEventMode | alarmeventmode | Returns and sets event mode of the online-alarm. | Unused | Available | Available | Available


AlarmEventMode
ObjectModel COM [image] OnlineAlarm [image] Properties [image] AlarmEventMode
Remarks

Returns and sets event mode of the online-alarm.

Datatype
AlarmEventMode

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] OnlineAlarm [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Activate | variant_bool | Activates the online-alarm. | Unused | Available | Available | Available
Deactivate | void | Deactivates the online-alarm. | Unused | Available | Available | Available
IsActive [GET] | variant_bool | Returns if the online-alarm is active. | Unused | Readonly | Available | Available
Name [GET] | bstr | Name of the online-alarm. | Unused | Readonly | Available | Available
Parent [GET] | ionlinealarmcollection | Parent-object. | Unused | Readonly | Available | Available
SetFilter | variant_bool | Sets the filter criteria as XML string. | Unused | Available | Available | Available


Activate
ObjectModel COM [image] OnlineAlarm [image] Methods [image] Activate
Remarks

Activates the online-alarm.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Deactivate
ObjectModel COM [image] OnlineAlarm [image] Methods [image] Deactivate
Remarks

Deactivates the online-alarm.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


IsActive [GET]
ObjectModel COM [image] OnlineAlarm [image] Methods [image] IsActive [GET]
Remarks

Returns if the online-alarm is active.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Name [GET]
ObjectModel COM [image] OnlineAlarm [image] Methods [image] Name [GET]
Remarks

Name of the online-alarm.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Parent [GET]
ObjectModel COM [image] OnlineAlarm [image] Methods [image] Parent [GET]
Remarks

Parent-object.

Datatype
IOnlineAlarmCollection

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


SetFilter
ObjectModel COM [image] OnlineAlarm [image] Methods [image] SetFilter
Remarks

Sets the filter criteria as XML string.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_filterXml as BSTR


Events
ObjectModel COM [image] OnlineAlarm [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
BulkChanged | void | Event: Is fired with a list of alarm object changes. | Unused | Available | Available | Available
Changed | void | Event: Is fired for alarm object change. | Unused | Available | Available | Available


BulkChanged
ObjectModel COM [image] OnlineAlarm [image] Events [image] BulkChanged
Remarks

Event: Is fired with a list of alarm object changes.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_xml as BSTR


Changed
ObjectModel COM [image] OnlineAlarm [image] Events [image] Changed
Remarks

Event: Is fired for alarm object change.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_reason as AlarmEventReason

p_alarmKey as BSTR

p_alarm as IAlarmItem


OnlineAlarmCollection
ObjectModel COM [image] OnlineAlarmCollection
Remarks

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] OnlineAlarmCollection [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count [GET] | long | Count of contained online-alarm objects. | Unused | Readonly | Available | Available
CreateOnlineAlarm | ionlinealarm | Creates a new online-alarm object. | Unused | Available | Available | Available
DeleteOnlineAlarm | variant_bool | Deletes the given online-alarm object. | Unused | Available | Available | Available
GetItem | ionlinealarm | Returns the online-alarm by name or position. | Unused | Available | Available | Available
Parent [GET] | ialarm | Parent-object | Unused | Readonly | Available | Available


Count [GET]
ObjectModel COM [image] OnlineAlarmCollection [image] Methods [image] Count [GET]
Remarks

Count of contained online-alarm objects.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


CreateOnlineAlarm
ObjectModel COM [image] OnlineAlarmCollection [image] Methods [image] CreateOnlineAlarm
Remarks

Creates a new online-alarm object.

Datatype
IOnlineAlarm

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_name as BSTR


DeleteOnlineAlarm
ObjectModel COM [image] OnlineAlarmCollection [image] Methods [image] DeleteOnlineAlarm
Remarks

Deletes the given online-alarm object.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_name as BSTR


GetItem
ObjectModel COM [image] OnlineAlarmCollection [image] Methods [image] GetItem
Remarks

Returns the online-alarm by name or position.

Datatype
IOnlineAlarm

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_nameOrIndex as VARIANT


Parent [GET]
ObjectModel COM [image] OnlineAlarmCollection [image] Methods [image] Parent [GET]
Remarks

Parent-object

Datatype
IAlarm

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


OnlineCel
ObjectModel COM [image] OnlineCel
Remarks

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] OnlineCel [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CelEventMode | celeventmode | Returns and sets event mode of the online-CEL. | Unused | Available | Available | Available


CelEventMode
ObjectModel COM [image] OnlineCel [image] Properties [image] CelEventMode
Remarks

Returns and sets event mode of the online-CEL.

Datatype
CelEventMode

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] OnlineCel [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Activate | variant_bool | Activates the online-CEL. | Unused | Available | Available | Available
Deactivate | void | Deactivates the online-CEL. | Unused | Available | Available | Available
IsActive [GET] | variant_bool | Returns if the online-CEL is active. | Unused | Readonly | Available | Available
Name [GET] | bstr | Name of the online-CEL. | Unused | Readonly | Available | Available
Parent [GET] | ionlinecelcollection | Parent-object. | Unused | Readonly | Available | Available
SetFilter | variant_bool | Sets the filter criteria as XML string. | Unused | Available | Available | Available


Activate
ObjectModel COM [image] OnlineCel [image] Methods [image] Activate
Remarks

Activates the online-CEL.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Deactivate
ObjectModel COM [image] OnlineCel [image] Methods [image] Deactivate
Remarks

Deactivates the online-CEL.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


IsActive [GET]
ObjectModel COM [image] OnlineCel [image] Methods [image] IsActive [GET]
Remarks

Returns if the online-CEL is active.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Name [GET]
ObjectModel COM [image] OnlineCel [image] Methods [image] Name [GET]
Remarks

Name of the online-CEL.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Parent [GET]
ObjectModel COM [image] OnlineCel [image] Methods [image] Parent [GET]
Remarks

Parent-object.

Datatype
IOnlineCelCollection

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


SetFilter
ObjectModel COM [image] OnlineCel [image] Methods [image] SetFilter
Remarks

Sets the filter criteria as XML string.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_filterXml as BSTR


Events
ObjectModel COM [image] OnlineCel [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
BulkChanged | void | Event: Is fired with a list of CEL object changes. | Unused | Available | Available | Available
Changed | void | Event: Is fired for CEL object change. | Unused | Available | Available | Available


BulkChanged
ObjectModel COM [image] OnlineCel [image] Events [image] BulkChanged
Remarks

Event: Is fired with a list of CEL object changes.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_xml as BSTR


Changed
ObjectModel COM [image] OnlineCel [image] Events [image] Changed
Remarks

Event: Is fired for CEL object change.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_reason as CelEventReason

p_celKey as BSTR

p_cel as ICelItem


OnlineCelCollection
ObjectModel COM [image] OnlineCelCollection
Remarks

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] OnlineCelCollection [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count [GET] | long | Count of contained online-CEL objects. | Unused | Readonly | Available | Available
CreateOnlineCel | ionlinecel | Creates a new online-CEL object. | Unused | Available | Available | Available
DeleteOnlineCel | variant_bool | Deletes the given online-CEL object. | Unused | Available | Available | Available
GetItem | ionlinecel | Returns the online-CEL by name or position. | Unused | Available | Available | Available
Parent [GET] | icel | Parent-object. | Unused | Readonly | Available | Available


Count [GET]
ObjectModel COM [image] OnlineCelCollection [image] Methods [image] Count [GET]
Remarks

Count of contained online-CEL objects.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


CreateOnlineCel
ObjectModel COM [image] OnlineCelCollection [image] Methods [image] CreateOnlineCel
Remarks

Creates a new online-CEL object.

Datatype
IOnlineCel

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_name as BSTR


DeleteOnlineCel
ObjectModel COM [image] OnlineCelCollection [image] Methods [image] DeleteOnlineCel
Remarks

Deletes the given online-CEL object.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_name as BSTR


GetItem
ObjectModel COM [image] OnlineCelCollection [image] Methods [image] GetItem
Remarks

Returns the online-CEL by name or position.

Datatype
IOnlineCel

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_nameOrIndex as VARIANT


Parent [GET]
ObjectModel COM [image] OnlineCelCollection [image] Methods [image] Parent [GET]
Remarks

Parent-object.

Datatype
ICel

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


OnlineVariable
ObjectModel COM [image] OnlineVariable
Remarks

The object OnlineVariable is a container for variables.The method Define of this object requests all variables, that are linked to that object. The same thing happens whenever a Screen is opened in the Runtime. On initializing the variable or changing the value an event is executed, in which the changed variable can be edited as a parameter.This object should always be used, if one or more variable(s) are needed, that perhaps are not yet requested. As the request for the value of a variable takes most time, the performance here is increased, as you can be sure, that the values of the linked variables always are requested because of the method Define.Hint: For the event the object Visual Basic has to be defined with the attribute WithEvents.Using online variables always needs the following procedure:· Linking the online variable to variables of the control system. For each variable the method Add has to be executed with the unique name of the variable. Alternatively you can also use the method AddBulk. In this case a dynamic string array is created, that contains the variables‘ names. This array then is passed to the method AddBulk.· Executing the method Define to activate monitoring the variables. A VBA event is executed, when a variable changes. The event contains the canges variable object as a parameter. In the routine the different actions are executed.· Executing the method Undefine of the object to stop monitoring the variables. From now on changes of the variables are no longer reported via the VBA event.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroOnlineVariables()
{
    //Get a online variable container from the project
    IOnlineVariable zenonOlv = this.OnlineVariables().Item(0);
    //Print the active status of the OLV - if its not active the OLV does not
    //monitor the variables added to it

    //NOTE: The object zenonOlv might be null if there is no Online Variable in the collection
    //In this scenario we assume that there is at least one object in the collection
    System.Diagnostics.Debug.Print(zenonOlv.Aktiv.ToString());

    for (int i = 0; i < zenonOlv.Count; ++i)
    {
        //Print the name of every Variable in the container
        System.Diagnostics.Debug.Print(zenonOlv.Item(i).Name);
    }
}
VB.NET
Copy
Public Sub MacroOnlineVariables()
    'Get a online variable container from the project
    Dim zenonOlv As IOnlineVariable = Me.OnlineVariables().Item(0)
    'Print the active status of the OLV - if its not active the OLV does not
    'monitor the variables added to it

    'NOTE: The object zenonOlv might be null if there is no Online Variable in the collection
    'In this scenario we assume that there is at least one object in the collection
    System.Diagnostics.Debug.Print(zenonOlv.Aktiv.ToString())

    For i As Integer = 0 To zenonOlv.Count - 1
        'Print the name of every Variable in the container
        System.Diagnostics.Debug.Print(zenonOlv.Item(i).Name)
    Next
End Sub
VBA
Copy
Sub VariablesOfOLV()
Dim i As Integer
Dim obOLV As OnlineVariable
Dim obVAR As Variable
'get OnlineVariable
Set obOLV = thisProject.OnlineVariables.Item(0)
Debug.Print "Active: " & obOLV.Aktiv
'enum linked variables
For i = 0 To obOLV.Count - 1

Set obVAR = obOLV.Item(i)

Debug.Print obVAR.Name & " - " & obVAR.Tagname
Next i
End Sub


Properties
ObjectModel COM [image] OnlineVariable [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Aktiv | variant_bool | Returns the communication status of the online variable. | Unused | Available | Available | Available
Count | long | Returns the number of available objects. | Readonly | Readonly | Available | Available
EventMode | long | Activated event mode. | Unused | Readonly | Available | Available
Name | bstr | Name of the online-variable (unique) | Unused | Available | Available | Available
Parent | ionlinevariables | Parent-object | Readonly | Readonly | Available | Available


Aktiv
ObjectModel COM [image] OnlineVariable [image] Properties [image] Aktiv
Remarks

Returns the communication status of the online variable.The communication is set to True on executing the method Define. On deleting the object or executing the method Undefine the communication status is set to False.From this moment on the event VariableChange is no longer executed.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Count
ObjectModel COM [image] OnlineVariable [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


EventMode
ObjectModel COM [image] OnlineVariable [image] Properties [image] EventMode
Remarks

Activated event mode.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] OnlineVariable [image] Properties [image] Name
Remarks

Returns the unique name of the current online variable. With this name the online variable can be accessed in the collection OnlineVariables of the current project.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] OnlineVariable [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IOnlineVariables

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] OnlineVariable [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ActivateBulkMode | variant_bool | Activate bulk event mode. | Unused | Available | Available | Available
Add | variant_bool | Adds a new IVariable item to the online variable container. | Unused | Available | Available | Available
AddBulk | variant_bool |  | Unused | Available | Available | Available
Define | variant_bool | Activates monitoring of all variables linked to this object. | Unused | Available | Available | Available
DynProperties [GET] | variant |  | Available | Available | Available | Available
DynProperties [PUT] | void |  | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | <span"></span> | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty. | Readonly | Unused | Available | Available
Item | ivariable |  | Available | Unused | Available | Available
Remove | variant_bool | Removes a variable from the online variable container. | Unused | Available | Available | Available
SetMemCfg | variant_bool |  | Unused | Available | Available | Available
Undefine | void | Deactivates monitoring of the linked control system variables. | Unused | Available | Available | Available
WriteBack | variant_bool |  | Unused | Available | Available | Available


ActivateBulkMode
ObjectModel COM [image] OnlineVariable [image] Methods [image] ActivateBulkMode
Remarks

Activate bulk event mode.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Add
ObjectModel COM [image] OnlineVariable [image] Methods [image] Add
Remarks

The add method adds a new IVariable item to the online variable container. It returns true if the operation was successful, false otherwise. The method takes a string as a parameter which identifies the variable you want to add by its unique name.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
szPvName as BSTR

Example
C#
Copy
public void MacroOnlineVariablesAdd()
{
    IOnlineVariable zenonNewOlv = this.OnlineVariables()
        .CreateOnlineVariables("New Container");

    //Add a new variable to the collection we created above.
    zenonNewOlv.Add("WIZ_VAR_10");
}
VB.NET
Copy
Public Sub MacroOnlineVariablesAdd()
    Dim zenonNewOlv As IOnlineVariable = Me.OnlineVariables().CreateOnlineVariables("New Container")

    'Add a new variable to the collection we created above.
    zenonNewOlv.Add("WIZ_VAR_10")
End Sub


AddBulk
ObjectModel COM [image] OnlineVariable [image] Methods [image] AddBulk
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
szPvNames as SAFEARRAY(BSTR)

Example
C#
Copy
public void MacroOnlineVariablesAdd()
{
    IOnlineVariable zenonNewOlv = this.OnlineVariables()
        .CreateOnlineVariables("New Container");

    string[] bulkAdd = new string[] { "WIZ_VAR_10", "WIZ_VAR_11" };
    //Add a list of variables to the collection.
    zenonNewOlv.AddBulk(ref bulkAdd);
}
VB.NET
Copy
Public Sub MacroOnlineVariablesAdd()
    Dim zenonNewOlv As IOnlineVariable = Me.OnlineVariables().CreateOnlineVariables("New Container")

    Dim bulkAdd As String() = New String() {"WIZ_VAR_10", "WIZ_VAR_11"}
    'Add a list of variables to the collection.
    zenonNewOlv.AddBulk(bulkAdd)
End Sub


Define
ObjectModel COM [image] OnlineVariable [image] Methods [image] Define
Remarks

This method activates monitoring of all variables linked to this object.Before executing this method control system variables have to be linked to the object with the methods Add or AddBulk.Now on the initialization of a variable or on changing ist value a VBA event is executed, in which the linked variable is available as a parameter. In this event you can e.g. request the value, ...On executing this method the property Aktiv returns True. It is set to False, when the object is deleted or the methof Undefine is executed to stop monitoring.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroOnlineVariablesDefine()
{
    IOnlineVariable zenonNewOlv = this.OnlineVariables()
        .CreateOnlineVariables("New Container");

    string[] bulkAdd = new string[] { "WIZ_VAR_10", "WIZ_VAR_11" };
    //Add a list of variables to the collection.
    zenonNewOlv.AddBulk(ref bulkAdd);

    //Activate monitoring of the OLV
    zenonNewOlv.Define();
}
VB.NET
Copy
Public Sub MacroOnlineVariablesDefine()
    Dim zenonNewOlv As IOnlineVariable = Me.OnlineVariables().CreateOnlineVariables("New Container")

    Dim bulkAdd As String() = New String() {"WIZ_VAR_10", "WIZ_VAR_11"}
    'Add a list of variables to the collection.
    zenonNewOlv.AddBulk(bulkAdd)

    'Activate monitoring of the OLV
    zenonNewOlv.Define()
End Sub


DynProperties [GET]
ObjectModel COM [image] OnlineVariable [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] OnlineVariable [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the Property.

Example: "NetAktive"

vValue as VARIANT

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.


DynPropertiesEnum [GET]
ObjectModel COM [image] OnlineVariable [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties: DynPropertiesEnum("")


DynPropertyParam [GET]
ObjectModel COM [image] OnlineVariable [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the PropParam objekt of the given DynProperty.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Item
ObjectModel COM [image] OnlineVariable [image] Methods [image] Item
Remarks

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vID as VARIANT

Example
C#
Copy
public void MacroOnlineVariables()
{
    //Get a online variable container from the project
    IOnlineVariable zenonOlv = this.OnlineVariables().Item(0);
    //Print the active status of the OLV - if its not active the OLV does not
    //monitor the variables added to it

    //NOTE: The object zenonOlv might be null if there is no Online Variable in the collection
    //In this scenario we assume that there is at least one object in the collection
    System.Diagnostics.Debug.Print(zenonOlv.Aktiv.ToString());

    for (int i = 0; i < zenonOlv.Count; ++i)
    {
        //Print the name of every Variable in the container
        System.Diagnostics.Debug.Print(zenonOlv.Item(i).Name);
    }
}
VB.NET
Copy
Public Sub MacroOnlineVariables()
    'Get a online variable container from the project
    Dim zenonOlv As IOnlineVariable = Me.OnlineVariables().Item(0)
    'Print the active status of the OLV - if its not active the OLV does not
    'monitor the variables added to it

    'NOTE: The object zenonOlv might be null if there is no Online Variable in the collection
    'In this scenario we assume that there is at least one object in the collection
    System.Diagnostics.Debug.Print(zenonOlv.Aktiv.ToString())

    For i As Integer = 0 To zenonOlv.Count - 1
        'Print the name of every Variable in the container
        System.Diagnostics.Debug.Print(zenonOlv.Item(i).Name)
    Next
End Sub


Remove
ObjectModel COM [image] OnlineVariable [image] Methods [image] Remove
Remarks

Removes a variable from the online variable container, the parameter is a string which identifies the variable you want to remove by its unique name.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
szPvName as BSTR

Example
C#
Copy
public void MacroOnlineVariablesRemove()
{
    IOnlineVariable zenonNewOlv = this.OnlineVariables().Item(0);
    //Remove a variable from the container
    zenonNewOlv.Remove("WIZ_VAR_10");
}
VB.NET
Copy
Public Sub MacroOnlineVariablesRemove()
    Dim zenonNewOlv As IOnlineVariable = Me.OnlineVariables().Item(0)
    'Remove a variable from the container
    zenonNewOlv.Remove("WIZ_VAR_10")
End Sub


SetMemCfg
ObjectModel COM [image] OnlineVariable [image] Methods [image] SetMemCfg
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
szMemName as BSTR

szPvNames as SAFEARRAY(BSTR)

lOffsets as SAFEARRAY(long)

bAsRawValue as VARIANT_BOOL


Undefine
ObjectModel COM [image] OnlineVariable [image] Methods [image] Undefine
Remarks

This method deactivates monitoring of the linked control system variables.The event VariableChange, usually executed on changing the value of a linked variable, is no longer executed.Hint: This is not necessary, if the online variables are used in combination with zenOn VBA and the events FireActive or FireInactive of the project, as the method Undefine is executed internally at the time of the FireInactive.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void MacroOnlineVariablesUndefine()
{
    IOnlineVariable zenonOlv = this.OnlineVariables().Item(0);
    zenonOlv.Undefine();
}
VB.NET
Copy
Public Sub MacroOnlineVariablesUndefine()
    Dim zenonOlv As IOnlineVariable = Me.OnlineVariables().Item(0)
    zenonOlv.Undefine()
End Sub


WriteBack
ObjectModel COM [image] OnlineVariable [image] Methods [image] WriteBack
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Events
ObjectModel COM [image] OnlineVariable [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
VariableBulkChange | void | Event: Is fired to handle a bulk of changed variable values. | Unused | Available | Available | Available
VariableChange | void | Event: Is fired by changing the value of a variable | Unused | Available | Available | Available


VariableBulkChange
ObjectModel COM [image] OnlineVariable [image] Events [image] VariableBulkChange
Remarks

Event: Is fired to handle a bulk of changed variable values.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
pvVars as LPVARIANT

pvPvIDs as LPVARIANT

pvValues as LPVARIANT

pvStatesLo as LPVARIANT

pvStatesHi as LPVARIANT

pvTimes as LPVARIANT


VariableChange
ObjectModel COM [image] OnlineVariable [image] Events [image] VariableChange
Remarks

The VariableChange event is fired once a variable in the collection changes. It gets the variable in question as a parameter.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obVar as IVariable

Example
C#
Copy
public void MacroOnlineVariablesEvents()
{
    IOnlineVariable zenonNewOlv = this.OnlineVariables()
        .CreateOnlineVariables("New Container");

    //Add a new variable to the collection we created above.
    zenonNewOlv.Add("WIZ_VAR_10");
    //Activate monitoring, without Define the events won't be fired
    zenonNewOlv.Define();
    //Register a new event handler, normally you would do this at runtime start and not inside a macro,
    //This is only for demonstration
    zenonNewOlv.VariableChange += new VariableChangeEventHandler(zenonNewOlv_VariableChange);
}

void zenonNewOlv_VariableChange(IVariable obVar)
{
    System.Diagnostics.Debug.Print("Variable " + obVar.Name + " was changed");
}
VB.NET
Copy
Public Sub MacroOnlineVariablesEvents()
    Dim zenonNewOlv As IOnlineVariable = Me.OnlineVariables().CreateOnlineVariables("New Container")

    'Add a new variable to the collection we created above.
    zenonNewOlv.Add("WIZ_VAR_10")
    'Activate monitoring, without Define the events won't be fired
    zenonNewOlv.Define()
    'Register a new event handler, normally you would do this at runtime start and not inside a macro,
    'This is only for demonstration
    zenonNewOlv.VariableChange += New VariableChangeEventHandler(AddressOf zenonNewOlv_VariableChange)
End Sub

Private Sub zenonNewOlv_VariableChange(obVar As IVariable)
    System.Diagnostics.Debug.Print("Variable " + obVar.Name + " was changed")
End Sub


OnlineVariables
ObjectModel COM [image] OnlineVariables
Remarks

This collection contains the single objects OnlineVariable. An online variable is an object, in which control system variables are linked, which on being initialized or changed execute a VBA event. In this VBA event user defined actions can be defined.The usage of online variables is recommended for the reading of variable values, as all variables linked to the online variable can be ordered with one action. This enhances the performance.An online variable can be compared to a container or – even better – a Screen of the control system without display. In such a Screen of the control system also all values are ordered from the driver when the Screen is opened.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
void ThisProject_Active()
{
    IOnlineVariable zenonOLV = this.OnlineVariables().Item("test_container");
    if (zenonOLV == null)
    {
        //if the container does not exist create it and add variables to it
        zenonOLV = this.OnlineVariables().CreateOnlineVariables("test_container");
        zenonOLV.Add("WIZ_VAR_10");
        zenonOLV.Add("WIZ_VAR_11");
        zenonOLV.Add("WIZ_VAR_12");
    }
    zenonOLV.Define();
    zenonOLV.VariableChange += new VariableChangeEventHandler(zenonOLV_VariableChange);
}

void zenonOLV_VariableChange(IVariable obVar)
{
    System.Diagnostics.Debug.Print("Variable " + obVar.Name + " was changed.");
}

void ThisProject_Inactive()
{
    IOnlineVariable zenonOLV = this.OnlineVariables().Item("test_container");
    if (zenonOLV != null)
    {
        zenonOLV.VariableChange -= zenonOLV_VariableChange;
        zenonOLV.Undefine();
        this.OnlineVariables().DeleteOnlineVariables("test_container");
    }
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    Dim zenonOLV As IOnlineVariable = Me.OnlineVariables().Item("test_container")
    If zenonOLV Is Nothing Then
        'if the container does not exist create it and add variables to it
        zenonOLV = Me.OnlineVariables().CreateOnlineVariables("test_container")
        zenonOLV.Add("WIZ_VAR_10")
        zenonOLV.Add("WIZ_VAR_11")
        zenonOLV.Add("WIZ_VAR_12")
    End If
    zenonOLV.Define()
    zenonOLV.VariableChange += New VariableChangeEventHandler(AddressOf zenonOLV_VariableChange)
End Sub

Private Sub zenonOLV_VariableChange(obVar As IVariable)
    System.Diagnostics.Debug.Print("Variable " + obVar.Name + " was changed.")
End Sub

Private Sub ThisProject_Inactive()
    Dim zenonOLV As IOnlineVariable = Me.OnlineVariables().Item("test_container")
    If zenonOLV IsNot Nothing Then
        RemoveHandler zenonOLV.VariableChange, AddressOf zenonOLV_VariableChange
        zenonOLV.Undefine()
        Me.OnlineVariables().DeleteOnlineVariables("test_container")
    End If
    FreeObjects()
End Sub
VBA
Copy
Dim WithEvents zOLV As OnlineVariable
Const strOLV As String = "MyOnlineVariableContainer"
'initialize event on runtime startup
Private Sub Project_Active()
'get object if already exists
Set zOLV = thisProject.OnlineVariables.Item(strOLV)
If zOLV Is Nothing Then

'if not exitst, create a new OnlineVariable container

Set zOLV = thisProject.OnlineVariables.CreateOnlineVariables(strOLV)

'add variables to the container

zOLV.Add "Variable1"

zOLV.Add "Variable2"

zOLV.Add "Variable3"
End If
'activate 'VariableChange' event
zOLV.Define
End Sub
'event is fired when a variable value changes
Private Sub zOLV_VariableChange(ByVal obVar As IVariable)
Dim vValue As Variant
vValue = obVar.Value
'ignore error values (i.e. on startup)
If IsError(vValue) Then Exit Sub
D

ebug.Print obVar.Name & " = " & vValue
End Sub
'release objects on closing the runtime
Private Sub Project_Inactive()
'deactivate 'VariableChange' event
If Not zOLV Is Nothing Then zOLV.Undefine
Set zOLV = Nothing
End Sub


Properties
ObjectModel COM [image] OnlineVariables [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Count of defined online-variables | Readonly | Readonly | Available | Available
Parent | iproject | Parent-object | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] OnlineVariables [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] OnlineVariables [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] OnlineVariables [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateOnlineVariables | ionlinevariable | Creates a new online-variable (unique name) | Unused | Available | Available | Available
DeleteOnlineVariables | variant_bool | Deletes the given variable. | Unused | Available | Available | Available
Item | ionlinevariable | Returns the variable by name or position | Available | Available | Available | Available


CreateOnlineVariables
ObjectModel COM [image] OnlineVariables [image] Methods [image] CreateOnlineVariables
Remarks

Creates a new online-variable (unique name)

Datatype
IOnlineVariable

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR

Example
C#
Copy
void ThisProject_Active()
{
    IOnlineVariable zenonOLV = this.OnlineVariables().Item("test_container");
    if (zenonOLV == null)
    {
        //if the container does not exist create it and add variables to it
        zenonOLV = this.OnlineVariables().CreateOnlineVariables("test_container");
        zenonOLV.Add("WIZ_VAR_10");
        zenonOLV.Add("WIZ_VAR_11");
        zenonOLV.Add("WIZ_VAR_12");
    }
    zenonOLV.Define();
    zenonOLV.VariableChange += new VariableChangeEventHandler(zenonOLV_VariableChange);
}

void zenonOLV_VariableChange(IVariable obVar)
{
    System.Diagnostics.Debug.Print("Variable " + obVar.Name + " was changed.");
}

void ThisProject_Inactive()
{
    IOnlineVariable zenonOLV = this.OnlineVariables().Item("test_container");
    if (zenonOLV != null)
    {
        zenonOLV.VariableChange -= zenonOLV_VariableChange;
        zenonOLV.Undefine();
        this.OnlineVariables().DeleteOnlineVariables("test_container");
    }
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    Dim zenonOLV As IOnlineVariable = Me.OnlineVariables().Item("test_container")
    If zenonOLV Is Nothing Then
        'if the container does not exist create it and add variables to it
        zenonOLV = Me.OnlineVariables().CreateOnlineVariables("test_container")
        zenonOLV.Add("WIZ_VAR_10")
        zenonOLV.Add("WIZ_VAR_11")
        zenonOLV.Add("WIZ_VAR_12")
    End If
    zenonOLV.Define()
    zenonOLV.VariableChange += New VariableChangeEventHandler(AddressOf zenonOLV_VariableChange)
End Sub

Private Sub zenonOLV_VariableChange(obVar As IVariable)
    System.Diagnostics.Debug.Print("Variable " + obVar.Name + " was changed.")
End Sub

Private Sub ThisProject_Inactive()
    Dim zenonOLV As IOnlineVariable = Me.OnlineVariables().Item("test_container")
    If zenonOLV IsNot Nothing Then
        RemoveHandler zenonOLV.VariableChange, AddressOf zenonOLV_VariableChange
        zenonOLV.Undefine()
        Me.OnlineVariables().DeleteOnlineVariables("test_container")
    End If
    FreeObjects()
End Sub


DeleteOnlineVariables
ObjectModel COM [image] OnlineVariables [image] Methods [image] DeleteOnlineVariables
Remarks

Deletes the given variable.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR

Example
C#
Copy
void ThisProject_Active()
{
    IOnlineVariable zenonOLV = this.OnlineVariables().Item("test_container");
    if (zenonOLV == null)
    {
        //if the container does not exist create it and add variables to it
        zenonOLV = this.OnlineVariables().CreateOnlineVariables("test_container");
        zenonOLV.Add("WIZ_VAR_10");
        zenonOLV.Add("WIZ_VAR_11");
        zenonOLV.Add("WIZ_VAR_12");
    }
    zenonOLV.Define();
    zenonOLV.VariableChange += new VariableChangeEventHandler(zenonOLV_VariableChange);
}

void zenonOLV_VariableChange(IVariable obVar)
{
    System.Diagnostics.Debug.Print("Variable " + obVar.Name + " was changed.");
}

void ThisProject_Inactive()
{
    IOnlineVariable zenonOLV = this.OnlineVariables().Item("test_container");
    if (zenonOLV != null)
    {
        zenonOLV.VariableChange -= zenonOLV_VariableChange;
        zenonOLV.Undefine();
        this.OnlineVariables().DeleteOnlineVariables("test_container");
    }
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    Dim zenonOLV As IOnlineVariable = Me.OnlineVariables().Item("test_container")
    If zenonOLV Is Nothing Then
        'if the container does not exist create it and add variables to it
        zenonOLV = Me.OnlineVariables().CreateOnlineVariables("test_container")
        zenonOLV.Add("WIZ_VAR_10")
        zenonOLV.Add("WIZ_VAR_11")
        zenonOLV.Add("WIZ_VAR_12")
    End If
    zenonOLV.Define()
    zenonOLV.VariableChange += New VariableChangeEventHandler(AddressOf zenonOLV_VariableChange)
End Sub

Private Sub zenonOLV_VariableChange(obVar As IVariable)
    System.Diagnostics.Debug.Print("Variable " + obVar.Name + " was changed.")
End Sub

Private Sub ThisProject_Inactive()
    Dim zenonOLV As IOnlineVariable = Me.OnlineVariables().Item("test_container")
    If zenonOLV IsNot Nothing Then
        RemoveHandler zenonOLV.VariableChange, AddressOf zenonOLV_VariableChange
        zenonOLV.Undefine()
        Me.OnlineVariables().DeleteOnlineVariables("test_container")
    End If
    FreeObjects()
End Sub


Item
ObjectModel COM [image] OnlineVariables [image] Methods [image] Item
Remarks

Returns the object OnlineVariable from the collection, which is identified by the parameter vID.The parameter vID can have two values:· Index: Access with an index mostly is used in combination with the property Count to find out the position of the online variable object in the list.· Variable name: The online variable can also be accessed with its unique name.

Datatype
IOnlineVariable

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vID as VARIANT

Index or name as Variant
If the parameter is a numerical value, the variable is searched by its index (>= 0 and <= Count-1). If it is an alphanumerical value, the variable is searched by its unique name.

Example
C#
Copy
void ThisProject_Active()
{
    IOnlineVariable zenonOLV = this.OnlineVariables().Item("test_container");
    if (zenonOLV == null)
    {
        //if the container does not exist create it and add variables to it
        zenonOLV = this.OnlineVariables().CreateOnlineVariables("test_container");
        zenonOLV.Add("WIZ_VAR_10");
        zenonOLV.Add("WIZ_VAR_11");
        zenonOLV.Add("WIZ_VAR_12");
    }
    zenonOLV.Define();
    zenonOLV.VariableChange += new VariableChangeEventHandler(zenonOLV_VariableChange);
}

void zenonOLV_VariableChange(IVariable obVar)
{
    System.Diagnostics.Debug.Print("Variable " + obVar.Name + " was changed.");
}

void ThisProject_Inactive()
{
    IOnlineVariable zenonOLV = this.OnlineVariables().Item("test_container");
    if (zenonOLV != null)
    {
        zenonOLV.VariableChange -= zenonOLV_VariableChange;
        zenonOLV.Undefine();
        this.OnlineVariables().DeleteOnlineVariables("test_container");
    }
    FreeObjects();
}
VB.NET
Copy
Private Sub ThisProject_Active()
    Dim zenonOLV As IOnlineVariable = Me.OnlineVariables().Item("test_container")
    If zenonOLV Is Nothing Then
        'if the container does not exist create it and add variables to it
        zenonOLV = Me.OnlineVariables().CreateOnlineVariables("test_container")
        zenonOLV.Add("WIZ_VAR_10")
        zenonOLV.Add("WIZ_VAR_11")
        zenonOLV.Add("WIZ_VAR_12")
    End If
    zenonOLV.Define()
    zenonOLV.VariableChange += New VariableChangeEventHandler(AddressOf zenonOLV_VariableChange)
End Sub

Private Sub zenonOLV_VariableChange(obVar As IVariable)
    System.Diagnostics.Debug.Print("Variable " + obVar.Name + " was changed.")
End Sub

Private Sub ThisProject_Inactive()
    Dim zenonOLV As IOnlineVariable = Me.OnlineVariables().Item("test_container")
    If zenonOLV IsNot Nothing Then
        RemoveHandler zenonOLV.VariableChange, AddressOf zenonOLV_VariableChange
        zenonOLV.Undefine()
        Me.OnlineVariables().DeleteOnlineVariables("test_container")
    End If
    FreeObjects()
End Sub
VBA
Copy
'enumerate all OnlineVariables
Sub EnumOLVs()
Dim i As Integer
Dim obOLV As OnlineVariable
For i = 0 To thisProject.OnlineVariables.Count - 1

Set obOLV = thisProject.OnlineVariables.Item(i)

Debug.Print obOLV.Name & " (Vars: " & obOLV.Count & ")"
Next i
End Sub


Passwords
ObjectModel COM [image] Passwords
Remarks

This object represents the user administration of the current project.With this object new users can be created and existing users can be edited/deleted during online operation. These changes can be imported into the Editor with decompiling. See the documentation of the control system for further information on decompiling.Users also can be logged in and out with this collection. Additionally this objects offers information on the currently logged in user.A user login executes the event UserChange with which you can execute user defined actions.Hint: For the event the object has to be defined with the attribute WithEvents in Visual Basic or VBA.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Dim WithEvents zUserAdministration As Passwords
'initialize event on runtime startup
Private Sub Project_Active()
Set zUserAdministration = thisProject.Passwords
End Sub
Private Sub zUserAdministration_UserChange()
Debug.Print zUserAdministration.LoggedUser; " is logged in!"
End Sub
'create a new user
Sub CreateUser()
Dim zUser As User
'12345 = Levels: 0,3,4,5,12,13
Set zUser = thisProject.Passwords.CreateUser("Full Name", "Username", "P@ssword", 12345)
With zUser

.Active = True

.Admin = True

.Locked = False
End With
End Sub
'change some user properties
Sub ChangeUser()
Dim zUser As User
Dim vResult As Variant
Set zUser = thisProject.Passwords.ItemUser(0)
Debug.Print zUser.Name & " will be changed"
'change the identification of the user
vResult = zUser.IdentificationChange("NewLogonName")
'change the password for the user
vResult = zUser.PasswordChange("P@ssword", "NewPassword")

End Sub
'login a user with its password...
Sub LoginUser()
Dim bResult As Boolean
bResult = zUserAdministration.LoginPassword("LogonName", "P@ssword")
End Sub
'release objects on closing the runtime
Private Sub Project_Inactive()
Set zUserAdministration = Nothing
End Sub


Properties
ObjectModel COM [image] Passwords [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CountUser | long | Count of defined users | Available | Available | Available | Available
CountUserGroup | long | Count of defined usergroups | Readonly | Readonly | Available | Available
LoggedUser | bstr | Current logged on user | Available | Available | Available | Available
LoggedUsername | bstr | TagName of the logged on user | Available | Available | Available | Available
Parent | iproject | Parent-object | Readonly | Readonly | Available | Available


CountUser
ObjectModel COM [image] Passwords [image] Properties [image] CountUser
Remarks

Returns the number of defined users, created in the user adminsitration of the control system. This method mostly is used for the iteration, i.e. to run through all the users in combination with the method ItemUser.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


CountUserGroup
ObjectModel COM [image] Passwords [image] Properties [image] CountUserGroup
Remarks

Returns the number of defined usergroups, created in the user adminsitration of the control system. This method mostly is used for the iteration, i.e. to run through all the usergroups in combination with the method ItemUserGroup.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


LoggedUser
ObjectModel COM [image] Passwords [image] Properties [image] LoggedUser
Remarks

Returns the identification of the user currently logged in. The identification can have up to 14 characters. The identification is the unique Id for the user, i.e. with this parameter the user can be identified. E.g. the identification for the user System is 0000.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


LoggedUsername
ObjectModel COM [image] Passwords [image] Properties [image] LoggedUsername
Remarks

Returns the name of the currently logged in user. The name of the user is defined in the control system.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Passwords [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Passwords [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckLogin | tploginresult | Checks the Login of a user with given ID and password | Unused | Available | Available | Available
CheckLoginEx | tploginresult | Checks the Login of a user with given ID and password hash. | Unused | Available | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
CreateUser | iuser | Creates a new user | Available | Available | Available | Available
CreateUserEx | iuser | Creates a new user | Available | Available | Available | Available
CreateUserGroup | iusergroup | Creates a new usergroup. | Available | Unused | Available | Available
DeleteUser | variant_bool | Deletes the given user | Available | Available | Available | Available
DeleteUserGroup | variant_bool | Deletes the given usergroup. | Available | Unused | Available | Available
Export | variant_bool | Exports the user list | Available | Unused | Available | Available
ExportGroup | variant_bool | Exports the usergroup list. | Available | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
Import | variant_bool | Imports the user list. | Available | Unused | Available | Available
ImportGroup | variant_bool | Imports the usergroup list. | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
ItemUser | iuser | Returns user by position or by name | Available | Available | Available | Available
ItemUserGroup | iusergroup | Returns usergroup by position or by name. | Available | Available | Available | Available
Login | variant_bool | Logs in the user with the given ID | Available | Available | Available | Available
LoginPassword | variant_bool | Logs in the user with the given ID and the given password | Available | Available | Available | Available
Logoff | void | Log out the current user | Available | Available | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index. | Available | Available | Available | Available
SingleExportGroup | variant_bool | Exports the Item with given Name oder Index. | Available | Available | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


CheckIn
ObjectModel COM [image] Passwords [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckLogin
ObjectModel COM [image] Passwords [image] Methods [image] CheckLogin
Remarks

Function CheckLogin(szUser As String, szPassword As String, vLevels) As tpLoginBesides a new enumeration tpLogin with the following values:tpDefaultError, tpLoginOk, tpPasswordExpired, tpSystemLocked, tpUserDeactivated, tpUserLocked, tpWrongPassword, tpWrongPasswordUserLocked, tpWrongUser, tpWrongUserSystemLockedThe committed user name and password are checked, the result is returned and a corresponding CEL entry is generated. Error entries on user name and password have the same consequences as on normal log in. (for ex. blocking the user or systems after a certain number). Is the user authenticated successfully, his authority levels are returned as an array of 4 longs (in the variant vLevels).

Datatype
tpLoginResult

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
szUser as BSTR

szPassword as BSTR

vLevels as LPVARIANT

Example
VBA
Copy
Public Sub Macro_CheckLogin()
Dim zPassword As Passwords
Dim tpResult As tpLoginResult
Dim vLevels As Variant
Dim vUserLevel As Variant
Dim i As Integer
Dim j As Integer
Dim mask As Double
Dim userLevels As String
Set zPassword = thisProject.Passwords
'Get Login result
tpResult = zPassword.CheckLogin("John", "123456", vLevels)
' Show result
getTpResultInformaion (tpResult)
For i = 0 To UBound(vLevels) 'User levels split in 4 groups with 32 bits

j = 0

mask = 0

If vLevels(i) > 0 Then

For j = 0 To 31 - 1 ' iterate the 32 bits

mask = 2 ^ j ' 0,2,4,8,16,32,64....

If vLevels(i) And mask Then ' If bit is set the user has this level

userLevels = userLevels + CStr(j + (32 * i)) & " "

End If

Next j

End If
Next i
Debug.Print ("User Levels: " & userLevels)
End Sub
Private Function getTpResultInformaion(tpResult As tpLoginResult)
Select Case tpResult

Case tpLoginResult.tpLoginOk

Debug.Print ("Login Ok: " & tpLoginResult.tpLoginOk)

Case tpLoginResult.tpPasswordExpired

Debug.Print ("Password expired: " & tpLoginResult.tpPasswordExpired)

Case tpLoginResult.tpSystemLocked

Debug.Print ("System locked: " & tpLoginResult.tpSystemLocked)

Case tpLoginResult.tpUserDeactivated

Debug.Print ("User deactivated: " & tpLoginResult.tpUserDeactivated)

Case tpLoginResult.tpUserLocked

Debug.Print ("User locked: " & tpLoginResult.tpUserLocked)

Case tpLoginResult.tpWrongPassword

Debug.Print ("Wrong password: " & tpLoginResult.tpWrongPassword)

Case tpLoginResult.tpWrongPasswordUserLocked

Debug.Print ("Wrong password - User locked: " &
tpLoginResult.tpWrongPasswordUserLocked)

Case tpLoginResult.tpWrongUser

Debug.Print ("Wrong user: " & tpLoginResult.tpWrongUser)

Case tpLoginResult.tpWrongUserSystemLocked

Debug.Print ("Wrong user- System locked: " &
tpLoginResult.tpWrongUserSystemLocked)

Case tpLoginResult.tpDefaultError

Debug.Print ("Default Error: " & tpLoginResult.tpDefaultError)
End Select

End Function


CheckLoginEx
ObjectModel COM [image] Passwords [image] Methods [image] CheckLoginEx
Remarks

Checks the Login of a user with given ID and password hash.

Datatype
tpLoginResult

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
szUser as BSTR

szPwdHash as BSTR

szServerSalt as BSTR

szClientSalt as BSTR

eLoginType as tpLoginType

vLevels as LPVARIANT


CheckOut
ObjectModel COM [image] Passwords [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CreateUser
ObjectModel COM [image] Passwords [image] Methods [image] CreateUser
Remarks

This method creates new users during online operation. If the identification is an empty string or an user with the same identification already exists, this method returns Nothing.Hint: Therefore the returned object always should be checked on Nothing.If the identification is valid, a new object User is created and the defined parameters are transferred to the object. Then the object is handed over to the central user administration and the changes are saved.

Datatype
IUser

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
szIdentification as BSTR

Identification of a user as string.

szUsername as BSTR

Unique name of the user as string.

szPassword as BSTR

Password of the user as string.

dwLevel as long

Password level of the user as long.

Example
VBA
Copy
'create a new user
Sub CreateUser()
Dim zUser As User
'12345 = Levels: 0,3,4,5,12,13
Set zUser = thisProject.Passwords.CreateUser("Full Name", "Username", "P@ssword", 12345)
With zUser

.Active = True

.Admin = True

.Locked = False
End With
End Sub


CreateUserEx
ObjectModel COM [image] Passwords [image] Methods [image] CreateUserEx
Remarks

This method creates new users during online operation. If the identification is an empty string or an user with the same identification already exists, this method returns Nothing.Hint: Therefore the returned object always should be checked on Nothing.If the identification is valid, a new object User is created and the defined parameters are transferred to the object. Then the object is handed over to the central user administration and the changes are saved.

Datatype
IUser

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
szIdentification as BSTR

Identification of a user as string.

szUsername as BSTR

Unique name of the user as string.

szPassword as BSTR

Password of the user as string.

dwLevel1 as long

Password levels 0 to 31 of the user as long.

dwLevel2 as long

Password levels 32 to 63 of the user as long.

dwLevel3 as long

Password levels 64 to 95 of the user as long.

dwLevel4 as long

Password levels 96 to 127 of the user as long.

Example
VBA
Copy
'create a new user
Sub CreateUser()
Dim zUser As User
'12345 = Levels: 0,3,4,5,12,13
' 4711 = Levels: 32,33,34,37,38,41,44
' 555 = Levels: 64,65,67,69,73
' 1234 = Levels: 97,100,102,103,106
Set zUser = thisProject.Passwords.CreateUserEx("LogonName", "Full Username", "P@ssword", 12345, 4711, 555, 1234)
With zUser

.Active = True

.Admin = True

.Locked = False
End With
End Sub


CreateUserGroup
ObjectModel COM [image] Passwords [image] Methods [image] CreateUserGroup
Remarks

Creates a new usergroup.

Datatype
IUserGroup

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
szName as BSTR

dwLevel as long


DeleteUser
ObjectModel COM [image] Passwords [image] Methods [image] DeleteUser
Remarks

This method deletes the user with the identification szIdentification from the central user administration.This change is immediately saved, i.e. after deleting a user he is no longer available for the system.If no user with this identification can be found, the method returns False.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
szIdentification as BSTR

Identification of a user as string.

Example
VBA
Copy
'delete a user
Sub DeleteUSer()
Dim bResult As Boolean
bResult = thisProject.Passwords.DeleteUSer("LogonName")
End Sub


DeleteUserGroup
ObjectModel COM [image] Passwords [image] Methods [image] DeleteUserGroup
Remarks

Deletes the given usergroup.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
szName as BSTR


Export
ObjectModel COM [image] Passwords [image] Methods [image] Export
Remarks

Export settings to an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Filename (path) as string of the xml file to import.

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


ExportGroup
ObjectModel COM [image] Passwords [image] Methods [image] ExportGroup
Remarks

Exports the usergroup list.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Filename (path) as string of the xml file to export.


Get
ObjectModel COM [image] Passwords [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Import
ObjectModel COM [image] Passwords [image] Methods [image] Import
Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Filename (path) as string of the xml file to import.


ImportGroup
ObjectModel COM [image] Passwords [image] Methods [image] ImportGroup
Remarks

Imports the usergroup list.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Filename (path) as string of the xml file to import.


IsCheckedOut
ObjectModel COM [image] Passwords [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDifferent
ObjectModel COM [image] Passwords [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] Passwords [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


ItemUser
ObjectModel COM [image] Passwords [image] Methods [image] ItemUser
Remarks

Returns the user from the collection, who is identified by the parameter vIndex.The parameter vIndex can have two values:· Index: Access with an index mostly is used in combination with the property Count to find out the position of the variable object in the list.· Identification: The user can also be accessed with his unique identification.Hint: The returned object should be checked on Nothing to find out, if no object for the search creteria was found.

Datatype
IUser

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT

Index or name as variant.
If the parameter is a numerical value, the user is searched by its index (>= 0 and <= Count-1).
If it is an alphanumerical value, the user is searched by its unique name.

Example
VBA
Copy
'enumerate all users
Sub EnumUsers()
Dim zUser As User
Dim i As Integer
For i = 0 To thisProject.Passwords.CountUser - 1

'get user object

Set zUser = thisProject.Passwords.ItemUser(i)

Debug.Print zUser.Identification & " > " & zUser.Name
Next i
End Sub


ItemUserGroup
ObjectModel COM [image] Passwords [image] Methods [image] ItemUserGroup
Remarks

Returns usergroup by position or by name.

Datatype
IUserGroup

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT


Login
ObjectModel COM [image] Passwords [image] Methods [image] Login
Remarks

Searches for the user with the identification szIdentification and tries to log him in, if he is not the currently logged in user.If a user with the given identification cannot be found, an entry in the CEL is generated.Otherwise the user is logged in and the following further actions are executed:·System variable for current user level is actualized·System variable for the name of the current user is updated.·Alarming is informed about the user change·All opened MDI windows are informed about the user change.·A CEL entry for the user is generated. The·UserChange event for the object Passwords is fired.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
szIdentification as BSTR

Index or name as variant.
If the parameter is a numerical value, the user is searched by its index (>= 0 and <= Count-1).
If it is an alphanumerical value, the user is searched by its unique name.

Example
VBA
Copy
'login a user...
Sub LoginUser()
Dim bResult As Boolean
bResult = zUserAdministration.Login("LogonName")
End Sub


LoginPassword
ObjectModel COM [image] Passwords [image] Methods [image] LoginPassword
Remarks

Searches for the user with the identification szIdentification and tries to log him in, if he is not the currently logged in user.In this case also the new password is compared to the current one.If a user with thie identification cannot be found, an entry in the CEL is generated.Otherwise the user is logged in and the following further actions are executed:·System variable for current user level is actualized·System variable for the name of the current user is actualized·Alarming is informed about user change·All opened MDI windows are informed about user change·CEL entry for user is generated·UserChange event for the object Passwords is executed

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
szIdentification as BSTR

Identification of a user as string.

szPassword as BSTR

Password of the user as string.

Example
VBA
Copy
'login a user with its password...
Sub LoginUser()
Dim bResult As Boolean
bResult = zUserAdministration.LoginPassword("LogonName", "P@ssword")
End Sub


Logoff
ObjectModel COM [image] Passwords [image] Methods [image] Logoff
Remarks

This method logs out the current user and logs in the user SYSTEM. If the user SYSTEM is already active, no further steps are taken.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


SingleExport
ObjectModel COM [image] Passwords [image] Methods [image] SingleExport
Remarks

Exports the Item with given Name oder Index.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR


SingleExportGroup
ObjectModel COM [image] Passwords [image] Methods [image] SingleExportGroup
Remarks

Exports the Item with given Name oder Index.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR


UndoCheckOut
ObjectModel COM [image] Passwords [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Events
ObjectModel COM [image] Passwords [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
UserChange | void | This event is executed, when a user is logged into the system. | Available | Available | Available | Available
ValidatePassword | void |  | Unused | Available | Available | Available


UserChange
ObjectModel COM [image] Passwords [image] Events [image] UserChange
Remarks

This event is executed, when a user is logged into the system. In this event you can execute your user defined actions.With the property LoggedUser and the method ItemUser you can find out the newly logged in user.Hint: For the event the object has to be defined with the attribute WithEvents in Visual Basic or VBA.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


ValidatePassword
ObjectModel COM [image] Passwords [image] Events [image] ValidatePassword
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsIdentification as BSTR

Contains the Identification of the User who tries to change his password.

bsPassword as BSTR

Contains the new password wich was entered by the actual user.

bOK as VARIANT_BOOL

Defines if the new password is valid or not.
Set the "bOK" to "False" if the password is not valid.
Default value = True

Example
VBA
Copy
'The following Code is used in the "thisProject" classmodule...
Dim WithEvents zPWD As Passwords
Private Sub Project_Active()
Set zPWD = thisProject.Passwords
End Sub
Private Sub zPWD_ValidatePassword(ByVal bsIdentification As String, ByVal bsPassword As String, bOK As Boolean)
'check password length
If Len(bsPassword) < 8 Then

bOK = False
Else

'check if password contains username

If InStr(1, UCase(bsPassword), UCase(bsIdentification)) <> 0 Then

bOK = False

End If
End If

End Sub


PfsCalendar
ObjectModel COM [image] PfsCalendar
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsCalendar [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateSwitchingPointFilter | ipfsswitchingpointfilter | Creates a switching point filter that can be configured and then used to call the SwitchingPointPreview method | Available | Available | Available | Available
SchedulesForDay | variant | Returns the linked schedules for the day | Available | Available | Available | Available
TimeModelForDay | ipfstimemodell | Returns the linked time model for the day | Available | Available | Available | Available


CreateSwitchingPointFilter
ObjectModel COM [image] PfsCalendar [image] Methods [image] CreateSwitchingPointFilter
Remarks

Creates a switching point filter that can then be used to get a switching point preview.

Datatype
IPfsSwitchingPointFilter

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_SwitchingPointPreview()
        {
// create a switching point filter
var filter = Pfs().Calendar().CreateSwitchingPointFilter();

// configure the filter
            filter.StartTime = System.DateTime.Now;
            filter.EndTime = System.DateTime.Now + new System.TimeSpan(7, 0, 0, 0);
            filter.TimeModelGroup = "z*";
            filter.Schedule = "N*";
            filter.Variable = "*";
            filter.Function = "*";
            filter.SearchData = zenOn.tpPfsData.tpPfsStoredData;

// get the preview for the configuration
string output = "";
object[] switchtingPoints = (object[])filter.SwitchingPointPreview();
foreach (object switchingPoint in switchtingPoints)
            {
                zenOn.IPfsSwitchingPoint p = (zenOn.IPfsSwitchingPoint)switchingPoint;
                output = output + "Active: " + p.Active.ToString();
                output = output + " TimeModelGroup: " + p.ScheduleValue.Parent.Parent.Parent.Parent.Parent.Parent.Name;
                output = output + " Schedule: " + p.ScheduleValue.Parent.Parent.Parent.Parent.KeyNote;
                output = output + " ExecTime: " + p.ExecutionTime.ToString();
                output = output + " LinkedType: " + p.ScheduleValue.Type.ToString();
                output = output + " LinkedObject: " + p.ScheduleValue.GetScheduleLink().Name;
if (p.ScheduleValue.Value != null)
                {
                    output = output + " SetValue: " + p.ScheduleValue.Value.ToString();
                }
                output = output + " PasswordLevel: " + p.ScheduleValue.PasswordLevel.ToString();
                output = output + " TriggerType: " + p.ScheduleValue.Parent.Parent.Type.ToString();
                output = output + " EventId: " + p.ScheduleValue.Parent.Parent.EventId.ToString();
                output = output + "\n\n";
            }

// show output
            System.Windows.Forms.MessageBox.Show(output);
        }
VBA
Copy
Public Sub Preview()
    'create a switching point filter
    Dim filter As PfsSwitchingPointFilter
    Set filter = thisProject.Pfs.Calendar.CreateSwitchingPointFilter
    'configure the filter
    filter.StartTime = Now
    filter.EndTime = Now + 7
    filter.TimeModelGroup = "z*"
    filter.Schedule = "N*"
    filter.Variable = "*"
    filter.Function = "*"
    filter.SearchData = tpPfsStoredData
    'get the preview for the filter configuration
    Dim points() As PfsSwitchingPoint
    points = filter.SwitchingPointPreview
    'build an output message
    Dim output As String
    Dim idx As Integer
    For idx = 0 To UBound(points)
        output = output & "Active: " & CStr(points(idx).Active)
        output = output & " TimeModelGroup: " & points(idx).ScheduleValue.Parent.Parent.Parent.Parent.Parent.Parent.Name
        output = output & " Schedule: " & points(idx).ScheduleValue.Parent.Parent.Parent.Parent.KeyNote
        output = output & " ExecTime: " & CStr(points(idx).ExecutionTime)
        output = output & " LinkedType: " & CStr(points(idx).ScheduleValue.Type)
        output = output & " LinkedObject: " & CStr(points(idx).ScheduleValue.GetScheduleLink.Name)
        output = output & " SetValue: " & CStr(points(idx).ScheduleValue.value)
        output = output & " PasswordLevel: " & CStr(points(idx).ScheduleValue.PasswordLevel)
        output = output & " TriggerType: " & CStr(points(idx).ScheduleValue.Parent.Parent.Type)
        output = output & " EventId: " & CStr(points(idx).ScheduleValue.Parent.Parent.EventId)
        output = output & vbNewLine & vbNewLine
    Next idx
    'show the output
    MsgBox output
End Sub


SchedulesForDay
ObjectModel COM [image] PfsCalendar [image] Methods [image] SchedulesForDay
Remarks

Get scheduals for a specific day.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
date as DATE

bstrGroup as BSTR

Example
VBA
Copy
Public Sub ShowTodaysScheduleType()
    Set PfsSchedule = thisProject.pfs.Groups.Item(0).Schedules.Item(0)
    Dim link As tpPfsDayLink
    link = PfsSchedule.IsOnDay(Date)
    If link = tpPfsExecute Then
        MsgBox "Einzeltag"
    End If
    If link = tpPfsSkip Then
        MsgBox "Übersprungen"
    End If
    If link = tpPfsDefaultDay Then
        MsgBox "Defaultbelegung"
    End If
    If link = tpPfsUnused Then
        MsgBox "Nicht verwendet"
    End If
End Sub
Public Sub SetTodaysSchedule()
    Dim PfsSchedule As PfsSchedule
    Set PfsSchedule = thisProject.pfs.Groups.Item(0).Schedules.Item(0)
    Call PfsSchedule.AddToDay(Date, tpPfsExecute)
    thisProject.pfs.Save
End Sub
Public Sub DeleteTodaysSchedule()
    Dim PfsSchedule As PfsSchedule
    Set PfsSchedule = thisProject.pfs.Groups.Item(0).Schedules.Item(0)
    Call PfsSchedule.RemoveFromDay(Date, True)
    thisProject.pfs.Save
End Sub
Public Sub GetCalendar()
    Dim Engine As PfsEngine
    Dim Calendar As PfsCalendar
    Set Engine = thisProject.Pfs
    Set Calendar = Engine.Calendar
End Sub
Public Sub GetSchedules()
    Dim calendar As pfsCalendar
    Dim schedules() As pfsSchedule
    Set calendar = thisProject.Pfs.calendar
    schedules = calendar.SchedulesForDay(Now, "ZMG1")
    Dim text As String
    For I = 0 To UBound(schedules)
      text = text + schedules(I).Name + "/"
    Next I
    MsgBox text
End Sub


TimeModelForDay
ObjectModel COM [image] PfsCalendar [image] Methods [image] TimeModelForDay
Remarks

Connect a timemodel to a single day.

Datatype
IPfsTimeModell

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
date as DATE

bstrGroup as BSTR

Example
VBA
Copy
Public Sub ConnectTimeModelToDay()
    Dim pfsTM As PfsTimeModell
    Set pfsTM = thisProject.Pfs.Groups.Item(0).TimeModells.Item(0)
    Call pfsTM.AddToDay(Date, tpPfsExecute)
    thisProject.Pfs.Save
End Sub
Public Sub Macro0()
    Dim pfsTM As PfsTimeModell
    Set pfsTM = thisProject.pfs.Groups.Item(0).TimeModells.Item(0)
    Dim link As tpPfsDayLink
    link = pfsTM.IsOnDay(Date)
    If link = tpPfsExecute Then
        MsgBox "Einzeltag"
    End If
    If link = tpPfsDefaultDay Then
        MsgBox "Defaultbelegung"
    End If
    If link = tpPfsUnused Then
        MsgBox "Nicht verwendet"
    End If
End Sub
Public Sub GetTimeModel()
    Dim calendar As pfsCalendar
    Dim timemodel As PfsTimeModell
    Set calendar = thisProject.Pfs.calendar
    Set timemodel = calendar.TimeModelForDay(Now, "ZMG1")
    If Not timemodel Is Nothing Then
      MsgBox timemodel.Name
    Else
      MsgBox "Kein Zeitmodell verknüpft"
    End If
End Sub


PfsEngine
ObjectModel COM [image] PfsEngine
Remarks

The PfsEngine object is the entry point into the Pfs object model. With the property CountryName you can define the country for the holiday definition. The method events returns a list of the user-defined events.The Groups method returns the definition of the existing PFS equipments.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
'''''''''''''''''''''''''''''''''''''''''''''
''''''Define PFS Engine with Events!'''''''''
'''''''''''''''''''''''''''''''''''''''''''''
Dim WithEvents myPFS As PfsEngine
'''''''''''''''''''''''''''''''''''''''''''''
''''''''Define Events for PFS Engine'''''''''
'''''''''''''''''''''''''''''''''''''''''''''
Private Sub myPFS_OnCreateGroup(ByVal obNewGroup As IPfsGroup)
Debug.Print "myPFS_OnCreateGroup " & " " & obNewGroup.Name & " was created!"
End Sub
Private Sub myPFS_OnCreateEvent(ByVal obNewEvent As IPfsEvent)
Debug.Print "myPFS_OnCreateEvent " & " " & obNewEvent.Name & " was created!"
End Sub
'''''''''''''''''''''''''''''''''''''''''''''
''''''''''Excecute the defined Events,'''''''
'''''''''''by creating new objects'''''''''''
'''''''''''''''''''''''''''''''''''''''''''''
Sub TestEvents()
Set myPFS = MyWorkspace.ActiveDocument.Pfs
myPFS.Groups.CreateGroup ("TestGroup1")
myPFS.Events.CreateEvent ("TestEvent1")
End Sub

'''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''Creation of a PFS Engine object'''''''''''''
'''''''''''''''Giving out Group Names''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub EnumGroups()
Dim i As Double
Dim myPFS As PfsEngine
Set myPFS = MyWorkspace.ActiveDocument.Pfs
For i = 0 To myPFS.Groups.Count - 1

Debug.Print myPFS.Groups.Item(i).Name
Next i
End Sub


Properties
ObjectModel COM [image] PfsEngine [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CountryName | bstr | Contains the value for the selected country. | Available | Available | Available | Available
Parent | iproject | Returns the parent object. | Readonly | Readonly | Available | Available


CountryName
ObjectModel COM [image] PfsEngine [image] Properties [image] CountryName
Remarks

This property contains the value for the selected country. This is important because of the statutory holidays, which change automatically in the calendar, when a different country is selected.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsEngine [image] Properties [image] Parent
Remarks

Returns the parent object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsEngine [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Calendar | ipfscalendar | Retrieves the object for the pfs calendar. | Available | Available | Available | Available
Events | ipfsevents | The "Event" Object is a collection of all "Event" objects, which are created from the user. | Available | Available | Available | Available
Groups | ipfsgroups | The "Groups" object manages the "Group" objects. | Available | Available | Available | Available
Holidays | ipfsholidays | In the "Holidays" object all "Holiday" objects are managed. | Available | Available | Available | Available
Save | variant_bool | With the "Save" methode all changes made in the PFS module can be saved. | Available | Available | Available | Available


Calendar
ObjectModel COM [image] PfsEngine [image] Methods [image] Calendar
Remarks

Retrieves the object for the pfs calendar.

Datatype
IPfsCalendar

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Events
ObjectModel COM [image] PfsEngine [image] Methods [image] Events
Remarks

The "Event" Object is a collection of all "Event" objects, which are created from the user.

Datatype
IPfsEvents

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Groups
ObjectModel COM [image] PfsEngine [image] Methods [image] Groups
Remarks

The "Groups" object manages the "Group" objects.

Datatype
IPfsGroups

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Holidays
ObjectModel COM [image] PfsEngine [image] Methods [image] Holidays
Remarks

In the "Holidays" object all "Holiday" objects are managed.

Datatype
IPfsHolidays

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Save
ObjectModel COM [image] PfsEngine [image] Methods [image] Save
Remarks

With the "Save" methode all changes made in the PFS module can be saved.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Events
ObjectModel COM [image] PfsEngine [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AfterUpdate | void | This event is fired, after the Save methode has been excecuted. | Available | Available | Available | Available
BeforeUpdate | void | This event is fired, before the Save methode has been excecuted. | Available | Available | Available | Available
OnCreateBreak | void | This event is fired, when a new break has been created. | Available | Available | Available | Available
OnCreateEvent | void | This event is fired, when a new event has been created. | Available | Available | Available | Available
OnCreateGroup | void | This event is fired, when a new group has been created. | Available | Available | Available | Available
OnCreateSchedule | void | This event is fired, when a new schedule has been created. | Available | Available | Available | Available
OnCreateScheduleTime | void | This event is fired, when a new schedule time has been created. | Available | Available | Available | Available
OnCreateScheduleValue | void | This event is fired, when a new schedule value has been created. | Available | Available | Available | Available
OnCreateShift | void | This event is fired, when a new shift has been created. | Available | Available | Available | Available
OnCreateTimeModell | void | This event is fired, when a new time model has been created. | Available | Available | Available | Available
OnDeleteBreak | void | This event is fired, when a break has been deleted. | Available | Available | Available | Available
OnDeleteEvent | void | This event is fired, when an event has been deleted. | Available | Available | Available | Available
OnDeleteGroup | void | This event is fired, when a group has been deleted. | Available | Available | Available | Available
OnDeleteSchedule | void | This event is fired, when a schedule has been deleted. | Available | Available | Available | Available
OnDeleteScheduleTime | void | This event is fired, when a schedule time has been deleted. | Available | Available | Available | Available
OnDeleteScheduleValue | void | This event is fired, when a schedule value has been deleted. | Available | Available | Available | Available
OnDeleteShift | void | This event is fired, when a shift has been deleted. | Available | Available | Available | Available
OnDeleteTimeModell | void | This event is fired, when a time model has been deleted. | Available | Available | Available | Available
OnRenameBreak | void | This event is fired, when the rename methode of a break is excecuted. | Available | Available | Available | Available
OnRenameEvent | void | This event is fired, when the Rename methode of an event has been excecuted. | Available | Available | Available | Available
OnRenameGroup | void | This event is fired, when the rename methode of a group is excecuted. | Available | Available | Available | Available
OnRenameSchedule | void | This event is fired, when the rename methode of a schedule is excecuted. | Available | Available | Available | Available
OnRenameShift | void | This event is fired, when the rename methode of a shift is excecuted. | Available | Available | Available | Available
OnRenameTimeModell | void | This event is fired, when the rename methode of a time model is excecuted. | Available | Available | Available | Available
OnSave | void | This event is fired, when the Save methode is excecuted. | Available | Available | Available | Available


AfterUpdate
ObjectModel COM [image] PfsEngine [image] Events [image] AfterUpdate
Remarks

This event is fired, after the Save methode has been excecuted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


BeforeUpdate
ObjectModel COM [image] PfsEngine [image] Events [image] BeforeUpdate
Remarks

This event is fired, before the Save methode has been excecuted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


OnCreateBreak
ObjectModel COM [image] PfsEngine [image] Events [image] OnCreateBreak
Remarks

This event is fired, when a new break has been created.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obNewBreak as IPfsModellBreak


OnCreateEvent
ObjectModel COM [image] PfsEngine [image] Events [image] OnCreateEvent
Remarks

This event is fired, when a new event has been created.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obNewEvent as IPfsEvent


OnCreateGroup
ObjectModel COM [image] PfsEngine [image] Events [image] OnCreateGroup
Remarks

This event is fired, when a new group has been created.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obNewGroup as IPfsGroup


OnCreateSchedule
ObjectModel COM [image] PfsEngine [image] Events [image] OnCreateSchedule
Remarks

This event is fired, when a new schedule has been created.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obNewSchedule as IPfsSchedule


OnCreateScheduleTime
ObjectModel COM [image] PfsEngine [image] Events [image] OnCreateScheduleTime
Remarks

This event is fired, when a new schedule time has been created.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obNewTime as IPfsScheduleTime


OnCreateScheduleValue
ObjectModel COM [image] PfsEngine [image] Events [image] OnCreateScheduleValue
Remarks

This event is fired, when a new schedule value has been created.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obNewValue as IPfsScheduleValue


OnCreateShift
ObjectModel COM [image] PfsEngine [image] Events [image] OnCreateShift
Remarks

This event is fired, when a new shift has been created.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obNewShift as IPfsModellShift


OnCreateTimeModell
ObjectModel COM [image] PfsEngine [image] Events [image] OnCreateTimeModell
Remarks

This event is fired, when a new time model has been created.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obNewModell as IPfsTimeModell


OnDeleteBreak
ObjectModel COM [image] PfsEngine [image] Events [image] OnDeleteBreak
Remarks

This event is fired, when a break has been deleted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strString as BSTR


OnDeleteEvent
ObjectModel COM [image] PfsEngine [image] Events [image] OnDeleteEvent
Remarks

This event is fired, when an event has been deleted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strString as BSTR


OnDeleteGroup
ObjectModel COM [image] PfsEngine [image] Events [image] OnDeleteGroup
Remarks

This event is fired, when a group has been deleted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strString as BSTR


OnDeleteSchedule
ObjectModel COM [image] PfsEngine [image] Events [image] OnDeleteSchedule
Remarks

This event is fired, when a schedule has been deleted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strString as BSTR


OnDeleteScheduleTime
ObjectModel COM [image] PfsEngine [image] Events [image] OnDeleteScheduleTime
Remarks

This event is fired, when a schedule time has been deleted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strGuid as BSTR


OnDeleteScheduleValue
ObjectModel COM [image] PfsEngine [image] Events [image] OnDeleteScheduleValue
Remarks

This event is fired, when a schedule value has been deleted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strGuid as BSTR


OnDeleteShift
ObjectModel COM [image] PfsEngine [image] Events [image] OnDeleteShift
Remarks

This event is fired, when a shift has been deleted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strString as BSTR


OnDeleteTimeModell
ObjectModel COM [image] PfsEngine [image] Events [image] OnDeleteTimeModell
Remarks

This event is fired, when a time model has been deleted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strString as BSTR


OnRenameBreak
ObjectModel COM [image] PfsEngine [image] Events [image] OnRenameBreak
Remarks

This event is fired, when the rename methode of a break is excecuted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strOld as BSTR

strNew as BSTR


OnRenameEvent
ObjectModel COM [image] PfsEngine [image] Events [image] OnRenameEvent
Remarks

This event is fired, when the Rename methode of an event has been excecuted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strOld as BSTR

strNew as BSTR


OnRenameGroup
ObjectModel COM [image] PfsEngine [image] Events [image] OnRenameGroup
Remarks

This event is fired, when the rename methode of a group is excecuted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strOld as BSTR

strNew as BSTR


OnRenameSchedule
ObjectModel COM [image] PfsEngine [image] Events [image] OnRenameSchedule
Remarks

This event is fired, when the rename methode of a schedule is excecuted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strOld as BSTR

strNew as BSTR


OnRenameShift
ObjectModel COM [image] PfsEngine [image] Events [image] OnRenameShift
Remarks

This event is fired, when the rename methode of a shift is excecuted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strOld as BSTR

strNew as BSTR


OnRenameTimeModell
ObjectModel COM [image] PfsEngine [image] Events [image] OnRenameTimeModell
Remarks

This event is fired, when the rename methode of a time model is excecuted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strOld as BSTR

strNew as BSTR


OnSave
ObjectModel COM [image] PfsEngine [image] Events [image] OnSave
Remarks

This event is fired, when the Save methode is excecuted.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


PfsEvent
ObjectModel COM [image] PfsEvent
Remarks

The PFSEvent object is an user defined event, which can be linked to the schedules as relative switching operations.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
'''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''Renaming of an event''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub test()
Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.Pfs

mypfs.Events.Item(0).Rename ("my event")
Debug.Print mypfs.Events.Item(0).Name

End Sub


Properties
ObjectModel COM [image] PfsEvent [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Guid | bstr | Is the Guid of the event which is unique and can be used to identify the object. | Readonly | Readonly | Available | Available
ID | long | is the ID of the event. | Readonly | Readonly | Available | Available
Name | bstr | Is the name of the event. | Readonly | Readonly | Available | Available
Parent | ipfsevents | Returns the parent object. | Readonly | Readonly | Available | Available
Session | iproject | Contains the "Project" object. | Readonly | Readonly | Available | Available


Guid
ObjectModel COM [image] PfsEvent [image] Properties [image] Guid
Remarks

Is the Guid of the event which is unique and can be used to identify the object.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ID
ObjectModel COM [image] PfsEvent [image] Properties [image] ID
Remarks

is the ID of the event.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] PfsEvent [image] Properties [image] Name
Remarks

Is the name of the event.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsEvent [image] Properties [image] Parent
Remarks

Returns the parent object.

Datatype
IPfsEvents

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsEvent [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsEvent [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Execute | variant_bool | With this methode you can manualy excecute an event. | Available | Available | Available | Available
Rename | variant_bool | With this methode you can rename the event. | Available | Available | Available | Available
SetModify | void | Sets the modify flag, so that the save option in the context menu of the PFS object is available. | Available | Available | Available | Available


Execute
ObjectModel COM [image] PfsEvent [image] Methods [image] Execute
Remarks

With this methode you can manualy excecute an event.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Rename
ObjectModel COM [image] PfsEvent [image] Methods [image] Rename
Remarks

With this methode you can rename the event.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrNewName as BSTR


SetModify
ObjectModel COM [image] PfsEvent [image] Methods [image] SetModify
Remarks

With this methode you can set the modify flag, so that the save option in the context menu of the PFS object is available.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


PfsEvents
ObjectModel COM [image] PfsEvents
Remarks

The Events collection contains the user-defined events of the PFS.User-defined events can be linked to the schedules as relative switching operations.When execution the function Execute PFS event for an event, the linked switching operations in the schedule are executed.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
'''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''Reading out Event Names ''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub test()
Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.Pfs

Dim i As Double
For i = 0 To mypfs.Events.Count - 1

Debug.Print mypfs.Events.Item(i).Name
Next i

End Sub


Properties
ObjectModel COM [image] PfsEvents [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the number of available objects. | Readonly | Readonly | Available | Available
Parent | ipfsengine | Returns the parent object. | Readonly | Readonly | Available | Available
Session | iproject | Contains the "Project" object. | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] PfsEvents [image] Properties [image] Count
Remarks

Returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsEvents [image] Properties [image] Parent
Remarks

Returns the parent object.

Datatype
IPfsEngine

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsEvents [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsEvents [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateEvent | ipfsevent | Is the methode to create a new event. | Available | Available | Available | Available
DeleteEvent | variant_bool | With this methode you can delete an event. | Available | Available | Available | Available
Item | ipfsevent | Returns the object Event from the collection, which is identified by the parameter vNameOrPos. | Available | Available | Available | Available
ItemById | ipfsevent |  | Available | Available | Available | Available


CreateEvent
ObjectModel COM [image] PfsEvents [image] Methods [image] CreateEvent
Remarks

Is the methode to create a new event.

Datatype
IPfsEvent

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrName as BSTR


DeleteEvent
ObjectModel COM [image] PfsEvents [image] Methods [image] DeleteEvent
Remarks

With this methode you can delete an event.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrID as VARIANT


Item
ObjectModel COM [image] PfsEvents [image] Methods [image] Item
Remarks

Returns the object Event from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • Event name: The element can also be accessed with its unique name.
Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IPfsEvent

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT


ItemById
ObjectModel COM [image] PfsEvents [image] Methods [image] ItemById
Remarks

Datatype
IPfsEvent

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosition as VARIANT


PfsGroup
ObjectModel COM [image] PfsGroup
Remarks

The IPfsGroup object is an object which describes an equipment object in the PFS module.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
'''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''Giving out all group names''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub test()
Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.Pfs

Dim i As Double
For i = 0 To mypfs.Groups.Count - 1

Debug.Print mypfs.Groups.Item(i).Name
Next i

End Sub


Properties
ObjectModel COM [image] PfsGroup [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CycleEnd | long | Is the end time of the group in seconds. | Available | Available | Available | Available
CycleStart | long | Is the start time of the group in seconds. | Available | Available | Available | Available
Guid | bstr | Is the Guid of the group which is unique and can be used to identify the object. | Readonly | Readonly | Available | Available
Name | bstr | Is the name of the group. | Readonly | Readonly | Available | Available
Parent | ipfsgroups | Returns the parent object | Readonly | Readonly | Available | Available
Session | iproject | Contains the "Project" object. | Readonly | Readonly | Available | Available


CycleEnd
ObjectModel COM [image] PfsGroup [image] Properties [image] CycleEnd
Remarks

Is the end time of the group in seconds.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


CycleStart
ObjectModel COM [image] PfsGroup [image] Properties [image] CycleStart
Remarks

Is the start time of the group in seconds.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Guid
ObjectModel COM [image] PfsGroup [image] Properties [image] Guid
Remarks

Is the Guid of the group which is unique and can be used to identify the object.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] PfsGroup [image] Properties [image] Name
Remarks

Is the name of the group.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsGroup [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPfsGroups

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsGroup [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsGroup [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Rename | variant_bool | With this methode you can rename the group. | Available | Available | Available | Available
Schedules | ipfsschedules | The "Schedules" object manages the "Schedule" objects. | Available | Available | Available | Available
SetModify | void | With this methode you can set the modify flag, so that the save option in the context menu of the PFS object is available. | Available | Available | Available | Available
SystemModelGroupAtIndex | isystemmodelgroup |  | Available | Available | Available | Available
SystemModelGroupCount | long |  | Available | Available | Available | Available
TimeModells | ipfstimemodells | The "TimeModels" object manages the "TimeModel" objects. | Available | Available | Available | Available


Rename
ObjectModel COM [image] PfsGroup [image] Methods [image] Rename
Remarks

With this methode you can rename the group.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrNewName as BSTR


Schedules
ObjectModel COM [image] PfsGroup [image] Methods [image] Schedules
Remarks

The "Schedules" object manages the "Schedule" objects.

Datatype
IPfsSchedules

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


SetModify
ObjectModel COM [image] PfsGroup [image] Methods [image] SetModify
Remarks

With this methode you can set the modify flag, so that the save option in the context menu of the PFS object is available.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


SystemModelGroupAtIndex
ObjectModel COM [image] PfsGroup [image] Methods [image] SystemModelGroupAtIndex
Remarks

Datatype
ISystemModelGroup

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
nIndex as long


SystemModelGroupCount
ObjectModel COM [image] PfsGroup [image] Methods [image] SystemModelGroupCount
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


TimeModells
ObjectModel COM [image] PfsGroup [image] Methods [image] TimeModells
Remarks

The "TimeModels" object manages the "TimeModel" objects.

Datatype
IPfsTimeModells

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


PfsGroups
ObjectModel COM [image] PfsGroups
Remarks

The Groups collection contains the groups of the PFS module (in the editor also called "equipments).

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
'''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''Test Groups''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''
Private Sub TEST()
Dim myPFS As PfsEngine
Set myPFS = MyWorkspace.ActiveDocument.PFS
Call CreateGroups(myPFS)
Call ReadGroups(myPFS)
Call DeleteGroups(myPFS)
DoEvents
Call ReadGroups(myPFS)

End Sub
''''''''''''''''''''''''''''''''''''''''''''''
''''''''''Creates 5 Test Groups'''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Function CreateGroups(myPFS As PfsEngine)
Dim i As Integer
Dim myString As String
For i = 0 To 4

myString = "testgruppe " & i

myPFS.Groups.CreateGroup (myString)
Next i
Debug.Print "Groups were created!"

End Function
''''''''''''''''''''''''''''''''''''''''''''''
''''''''''Read out all Group names''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Function ReadGroups(myPFS As PfsEngine)
Dim i As Integer
For i = 0 To myPFS.Groups.Count - 1

Debug.Print myPFS.Groups.Item(i).Name
Next i

End Function
''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''Delete all Groups''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Function DeleteGroups(myPFS As PfsEngine)
Dim strTMP As String
Dim i As Double
Debug.Print myPFS.Groups.Count & " Groups to delete!"
For i = myPFS.Groups.Count - 1 To 0 Step -1

strTMP = myPFS.Groups.Item(i).Name

Debug.Print "Group deleted! - " & strTMP & " - " & myPFS.Groups.DeleteGroup(strTMP)
Next i
myPFS.Save
End Function


Properties
ObjectModel COM [image] PfsGroups [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | The method returns the number of available objects. | Readonly | Readonly | Available | Available
Parent | ipfsengine | Returns the parent object | Readonly | Readonly | Available | Available
Session | iproject | Contains the "Project" object. | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] PfsGroups [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsGroups [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPfsEngine

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsGroups [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsGroups [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateGroup | ipfsgroup | With this method you can create a new group. | Available | Available | Available | Available
DeleteGroup | variant_bool | With this methode you can delete a group. | Available | Available | Available | Available
Item | ipfsgroup | Returns the group object from the collection, which is identified by the parameter vNameOrPos. | Available | Available | Available | Available


CreateGroup
ObjectModel COM [image] PfsGroups [image] Methods [image] CreateGroup
Remarks

With this method you can create a new group.

Datatype
IPfsGroup

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrName as BSTR


DeleteGroup
ObjectModel COM [image] PfsGroups [image] Methods [image] DeleteGroup
Remarks

With this methode you can delete a group.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vName as VARIANT


Item
ObjectModel COM [image] PfsGroups [image] Methods [image] Item
Remarks

Returns the group object from the collection, which is identified by the parameter vNameOrPos.Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IPfsGroup

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT

The parameter vNameOrPos can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • Group name: The group can also be accessed with its unique name.


PfsHoliday
ObjectModel COM [image] PfsHoliday
Remarks

The Holiday object contains information on a holiday from the feiertage.txt. This object contains a name and a date for the holiday.On loading the project only the holidays of the current year are acquired.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] PfsHoliday [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
date | date |  | Readonly | Readonly | Available | Available
Name | bstr | Returns the unique name of the holiday. | Readonly | Readonly | Available | Available
Parent | ipfsholidays | Returns the parent object | Readonly | Readonly | Available | Available
Session | iproject | Contains the "Project" object. | Readonly | Readonly | Available | Available


date
ObjectModel COM [image] PfsHoliday [image] Properties [image] date
Remarks

Datatype
DATE

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] PfsHoliday [image] Properties [image] Name
Remarks

Returns the unique name of the holiday.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsHoliday [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPfsHolidays

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsHoliday [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


PfsHolidays
ObjectModel COM [image] PfsHolidays
Remarks

The Holidays collection contains all holiday definitions of the defined country for the current year. The holiday definition is saved in the Feiertage.txt.On activating a project these are acquired for the defined country.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
''''''''''''''''''''''''''''''''''''''''''''''
'''''''Giving out the Count of Holidays'''''''
''''''''''''''''''''''''''''''''''''''''''''''
Sub holidaytest()
Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.PFS
Dim i As Double

Debug.Print mypfs.Holidays.Count

End Sub


Properties
ObjectModel COM [image] PfsHolidays [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | The method returns the number of available objects | Readonly | Readonly | Available | Available
Parent | ipfsengine | Returns the parent object | Readonly | Readonly | Available | Available
Session | iproject | Contains the "Project" object. | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] PfsHolidays [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsHolidays [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPfsEngine

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsHolidays [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsHolidays [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Item | ipfsholiday | Returns the holiday object from the collection, which is identified by the parameter vPosition | Available | Available | Available | Available


Item
ObjectModel COM [image] PfsHolidays [image] Methods [image] Item
Remarks

Returns the holiday object from the collection, which is identified by the parameter vPosition.Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IPfsHoliday

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosition as VARIANT

The parameter vPosition is the index of the element you want to get.


PfsModellBreak
ObjectModel COM [image] PfsModellBreak
Remarks

The ModellBreak object is a break within a shift in a time model. During the defined period of time the production should be interrupted.The breaks consist of an unique name and an unique period of time.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] PfsModellBreak [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
EndTime | date | Is the end time of the break. | Available | Available | Available | Available
Guid | bstr | Is the Guid of the group which is unique and can be used to identify the object. | Readonly | Readonly | Available | Available
KeyNote | bstr | The Keynote returns the name of one or more main objects and of the current object sepperated with a dot. | Readonly | Readonly | Available | Available
Name | bstr | Is the name of the break. | Readonly | Readonly | Available | Available
Notes | bstr | Notes can be added and read out, this property contains the notes to a selected break. | Readonly | Readonly | Available | Available
Parent | ipfsmodellbreaks | Returns the parent object | Readonly | Readonly | Available | Available
Session | iproject | Contains the "Project" object. | Readonly | Readonly | Available | Available
StartTime | date | Is the start time of the break. | Available | Available | Available | Available


EndTime
ObjectModel COM [image] PfsModellBreak [image] Properties [image] EndTime
Remarks

Is the end time of the break.

Datatype
DATE

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Guid
ObjectModel COM [image] PfsModellBreak [image] Properties [image] Guid
Remarks

Is the Guid of the group which is unique and can be used to identify the object.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


KeyNote
ObjectModel COM [image] PfsModellBreak [image] Properties [image] KeyNote
Remarks

The Keynote returns the name of one or more main objects and of the current object sepperated with a dot. For instance "shift1.break1" is the keynote of the break1 which is an element of the shift1.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] PfsModellBreak [image] Properties [image] Name
Remarks

Is the name of the break.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Notes
ObjectModel COM [image] PfsModellBreak [image] Properties [image] Notes
Remarks

Notes can be added and read out, this property contains the notes to a selected break.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsModellBreak [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPfsModellBreaks

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsModellBreak [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


StartTime
ObjectModel COM [image] PfsModellBreak [image] Properties [image] StartTime
Remarks

Is the start time of the break.

Datatype
DATE

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsModellBreak [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Rename | variant_bool | With this method you can rename a break. | Available | Available | Available | Available


Rename
ObjectModel COM [image] PfsModellBreak [image] Methods [image] Rename
Remarks

With this method you can rename a break.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrNewName as BSTR


PfsModellBreaks
ObjectModel COM [image] PfsModellBreaks
Remarks

The ModellBreaks collection allows the access to the breaks of a shift. The breaks are the production-free times in a shift.The breaks consist of a unique name and a unique period of time.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''Creating some breaks'''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Sub holidaytest()
Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.PFS
Dim mystring As String
Dim i As Double
For i = 0 To 5

mystring = "testbreak" & i

mypfs.Groups.Item(0).TimeModells.Item(0).Shifts.Item(0).Breaks.CreateBreak (mystring)

Debug.Print mystring & " was created!"

Next i

End Sub


Properties
ObjectModel COM [image] PfsModellBreaks [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | The method returns the number of available objects. | Readonly | Readonly | Available | Available
Parent | ipfsmodellshift | Returns the parent object | Readonly | Readonly | Available | Available
Session | iproject | Contains the "Project" object. | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] PfsModellBreaks [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsModellBreaks [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPfsModellShift

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsModellBreaks [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsModellBreaks [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateBreak | ipfsmodellbreak | Creates a new break in the current shift and returns it. | Available | Available | Available | Available
DeleteBreak | variant_bool | Deletes the defined break from the current shift. | Available | Available | Available | Available
Item | ipfsmodellbreak | Returns the ModelBreak object from the collection, which is identified by the parameter vNameOrPos. | Available | Available | Available | Available


CreateBreak
ObjectModel COM [image] PfsModellBreaks [image] Methods [image] CreateBreak
Remarks

Creates a new break in the current shift and returns it.

Datatype
IPfsModellBreak

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lpszName as BSTR


DeleteBreak
ObjectModel COM [image] PfsModellBreaks [image] Methods [image] DeleteBreak
Remarks

Deletes the defined break from the current shift.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrID as VARIANT


Item
ObjectModel COM [image] PfsModellBreaks [image] Methods [image] Item
Remarks

Returns the ModelBreak object from the collection, which is identified by the parameter vNameOrPos. Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IPfsModellBreak

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT

The parameter vNameOrPos can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • ModelBreak name: The ModelBreak can also be accessed with its unique name.


PfsModellShift
ObjectModel COM [image] PfsModellShift
Remarks

The ModellShift object is a shift in a time model.Each shift consists of an unique name and a period of time (from/to). This period of time is the active production cycle.The defined period of time must be unique, i.e. you cannot define more than one shift for the same time.Each shift can contain any number of breaks, that interrupt the production cycle.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''Creating, Reading out''''''''''''
''''''''''and Deletion of some shifts'''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub shifttest()
Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.PFS

'''''''Creation''''''''
Dim i As Double
Dim mystring As String
Debug.Print "--Creation:"
For i = 0 To 5

mystring = "testshift " & i

mypfs.Groups.Item(0).TimeModells.Item(0).Shifts.CreateShift (mystring)

Debug.Print mystring & " was created!"
Next i
mypfs.Save
''''Reading Out''''''
Dim o As Double
Debug.Print "--Reading Out:"
For o = 0 To mypfs.Groups.Item(0).TimeModells.Item(0).Shifts.Count - 1

Debug.Print mypfs.Groups.Item(0).TimeModells.Item(0).Shifts.Item(o).Name
Next o

''''''Deletion''''''''
Dim f As Double
Debug.Print "--Deletion:"
For f = mypfs.Groups.Item(0).TimeModells.Item(0).Shifts.Count - 1 To f = 1 Step -1

mypfs.Groups.Item(0).TimeModells.Item(0).Shifts.DeleteShift (f)

Debug.Print "shift " & f; " was deleted!"
Next f

End Sub


Properties
ObjectModel COM [image] PfsModellShift [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
EndTime | date | Is the end time of the shift. | Available | Available | Available | Available
Guid | bstr | Is the Guid of the ModelShift which is unique and can be used to identify the object. | Readonly | Readonly | Available | Available
KeyNote | bstr | The Keynote returns the name of one or more main objects and of the current object sepperated with a dot | Readonly | Readonly | Available | Available
Name | bstr | Is the name of the shift. | Readonly | Readonly | Available | Available
Notes | bstr | Notes can be added and read out, this property contains the notes to a selected shift. | Readonly | Readonly | Available | Available
Parent | ipfsmodellshifts | Returns the parent object | Readonly | Readonly | Available | Available
Session | iproject | Contains the "Project" object. | Readonly | Readonly | Available | Available
StartTime | date | Is the start time of the shift. | Available | Available | Available | Available


EndTime
ObjectModel COM [image] PfsModellShift [image] Properties [image] EndTime
Remarks

Is the end time of the shift.

Datatype
DATE

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Guid
ObjectModel COM [image] PfsModellShift [image] Properties [image] Guid
Remarks

Is the Guid of the ModelShift which is unique and can be used to identify the object.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


KeyNote
ObjectModel COM [image] PfsModellShift [image] Properties [image] KeyNote
Remarks

The Keynote returns the name of one or more main objects and of the current object sepperated with a dot. For instance "group1.timemodel1.shift1" is the keynote of the break1 which is an element of the shift1.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] PfsModellShift [image] Properties [image] Name
Remarks

Is the name of the shift.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Notes
ObjectModel COM [image] PfsModellShift [image] Properties [image] Notes
Remarks

Notes can be added and read out, this property contains the notes to a selected shift.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsModellShift [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPfsModellShifts

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsModellShift [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


StartTime
ObjectModel COM [image] PfsModellShift [image] Properties [image] StartTime
Remarks

Is the start time of the shift.

Datatype
DATE

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsModellShift [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Breaks | ipfsmodellbreaks | The "Breaks" object manages the "Break" objects. | Available | Available | Available | Available
Rename | variant_bool | With this methode a shift can be renamed. | Available | Available | Available | Available


Breaks
ObjectModel COM [image] PfsModellShift [image] Methods [image] Breaks
Remarks

The "Breaks" object manages the "Break" objects.

Datatype
IPfsModellBreaks

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Rename
ObjectModel COM [image] PfsModellShift [image] Methods [image] Rename
Remarks

With this methode a shift can be renamed.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrName as BSTR


PfsModellShifts
ObjectModel COM [image] PfsModellShifts
Remarks

The ModellShifts collection allows the access to the shifts of a time model. The single shifts consist of a number and a period of time (from/to), when the shift is active.Any number of breaks can be defined for each shift. The breaks interrupt the production and are inactive states.The period of time of a shift has to be unique, i.e. it is not possible to define a shift within a shift.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
''''''''''''''''''''''''''''''''''''''''''''''
'''''''''Reading out Count of shifts''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub shifttest()
Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.Pfs
Debug.Print mypfs.Groups.Item(0).TimeModells.Item(0).Shifts.Count

End Sub


Properties
ObjectModel COM [image] PfsModellShifts [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | The method returns the number of available objects. | Readonly | Readonly | Available | Available
Parent | ipfstimemodell | Returns the parent object | Readonly | Readonly | Available | Available
Session | iproject | Returns the current project reference. | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] PfsModellShifts [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsModellShifts [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPfsTimeModell

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsModellShifts [image] Properties [image] Session
Remarks

Returns the current project reference.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsModellShifts [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateShift | ipfsmodellshift | Creates a new shift. | Available | Available | Available | Available
DeleteShift | variant_bool | Deletes the defined shift. | Available | Available | Available | Available
Item | ipfsmodellshift | Returns the linked shift on the defined position or with the unique name. | Available | Available | Available | Available


CreateShift
ObjectModel COM [image] PfsModellShifts [image] Methods [image] CreateShift
Remarks

Creates a new shift.

Datatype
IPfsModellShift

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrName as BSTR


DeleteShift
ObjectModel COM [image] PfsModellShifts [image] Methods [image] DeleteShift
Remarks

Deletes the defined shift.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrID as VARIANT


Item
ObjectModel COM [image] PfsModellShifts [image] Methods [image] Item
Remarks

Returns the linked shift on the defined position or with the unique name.

Datatype
IPfsModellShift

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT


PfsSchedule
ObjectModel COM [image] PfsSchedule
Remarks

In a schedule object you can create absolute and relativ times and link them with switching points, so that a funktion is excecuted or a the value of a variable can be changed.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''Creation, Reading out''''''''''''
'''''''''''and Deletion of schedules''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub shifttest()
Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.PFS
Dim mystring As String
''''''Creation''''''''
Dim i As Double
Debug.Print "---Creation:"
For i = 0 To 5

mystring = "schedule" & i

mypfs.Groups.Item(0).Schedules.CreateSchedule (mystring)

Debug.Print mystring & " was created!"
Next i
''''''Reading out'''''
Dim f As Double
Debug.Print "---Reading Out:"
For f = 0 To mypfs.Groups.Item(0).Schedules.Count - 1

Debug.Print mypfs.Groups.Item(0).Schedules.Item(f).Name

Debug.Print mypfs.Groups.Item(0).Schedules.Item(f).GUID

Debug.Print mystring & " was created!"
Next f
''''''Deletion'''''
Dim t As Double
Debug.Print "---Deletion:"
For t = mypfs.Groups.Item(0).Schedules.Count - 1 To 1 Step -1

mystring = mypfs.Groups.Item(0).Schedules.Item(t).Name

mypfs.Groups.Item(0).Schedules.DeleteSchedule (t)

Debug.Print mystring & " was deleted!"
Next t

End Sub


Properties
ObjectModel COM [image] PfsSchedule [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Active | variant_bool | With this property the schedule can be activated or deactivated. | Available | Available | Available | Available
Guid | bstr | Is the Guid of the Schedule which is unique and can be used to identify the object. | Readonly | Readonly | Available | Available
KeyNote | bstr | The Keynote returns the name of one or more main objects and of the current object sepperated with a dot | Readonly | Readonly | Available | Available
Name | bstr | Is the name of the schedule. | Readonly | Readonly | Available | Available
Parent | ipfsschedules | Returns the parent object | Readonly | Readonly | Available | Available
Session | iproject | Contains the "Project" object. | Readonly | Readonly | Available | Available
Structure | variant_bool | The Structure property is true if the schedule is marked as "structured schedule". | Available | Available | Available | Available


Active
ObjectModel COM [image] PfsSchedule [image] Properties [image] Active
Remarks

With this property the schedule can be activated or deactivated.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Guid
ObjectModel COM [image] PfsSchedule [image] Properties [image] Guid
Remarks

Is the Guid of the Schedule which is unique and can be used to identify the object.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


KeyNote
ObjectModel COM [image] PfsSchedule [image] Properties [image] KeyNote
Remarks

The Keynote returns the name of one or more main objects and of the current object sepperated with a dot. For instance "group1.schedule1" is the keynote of the schedule1.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] PfsSchedule [image] Properties [image] Name
Remarks

Is the name of the schedule.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsSchedule [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPfsSchedules

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsSchedule [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Structure
ObjectModel COM [image] PfsSchedule [image] Properties [image] Structure
Remarks

The Structure property is true if the schedule is marked as "structured schedule".

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsSchedule [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AddToDay | variant_bool | With this methode a schedule can be linked to a day. | Available | Available | Available | Available
ExecutionDays | ipfsscheduledays | This Collection contains all days where a schedule is linked but not as default. | Available | Available | Available | Available
IsDefaultDay | variant_bool | With this methode you can check if a schedule is linked as default schedule to a daytype. | Available | Available | Available | Available
IsOnDay | tppfsdaylink | The methode returns a tpPFSDayLink. | Available | Available | Available | Available
RemoveFromDay | variant_bool | With this methode a schedule can be removed from a specific date. | Available | Available | Available | Available
Rename | variant_bool | With this methode you can rename a schedule. | Available | Available | Available | Available
ScheduleLinks | ipfsschedulelinks | This collecton manages the functions and variables which are linked to the schedule. | Available | Available | Available | Available
Schedules | ipfsschedules | A Schedule can also be a container for other schedules, with the "Schedules" collection you can access the sub schedules of a schedule. | Available | Available | Available | Available
ScheduleTimes | ipfsscheduletimes | This object manages the schedule times of the schedule. | Available | Available | Available | Available
SetDefaultDay | void | With this methode you can link a schedule as default to a day type. | Available | Available | Available | Available
SkippedDays | ipfsscheduledays | Manages the days which are manualy linked to a schedule for some specific dates as skipped days. | Available | Available | Available | Available


AddToDay
ObjectModel COM [image] PfsSchedule [image] Methods [image] AddToDay
Remarks

With this methode a schedule can be linked to a day. As parameters you have to give the methode the date and the type of the link.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vDay as DATE

sType as tpPfsDayLink


ExecutionDays
ObjectModel COM [image] PfsSchedule [image] Methods [image] ExecutionDays
Remarks

This Collection contains all days where a schedule is linked but not as default.

Datatype
IPfsScheduleDays

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


IsDefaultDay
ObjectModel COM [image] PfsSchedule [image] Methods [image] IsDefaultDay
Remarks

With this methode you can check if a schedule is linked as default schedule to a daytype. For instance IsDefaultDay(tppfsMonday) would be true if the schedule is linked to all mondays, instead it would be false.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
sDayOfWeek as tpPfsDefaultDays


IsOnDay
ObjectModel COM [image] PfsSchedule [image] Methods [image] IsOnDay
Remarks

With this methode you can check with which link type the schedule is linked on a specific date. The methode returns a tpPFSDayLink.

Datatype
tpPfsDayLink

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vDay as DATE


RemoveFromDay
ObjectModel COM [image] PfsSchedule [image] Methods [image] RemoveFromDay
Remarks

With this methode a schedule can be removed from a specific date.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vDate as DATE

bDayOnly as VARIANT


Rename
ObjectModel COM [image] PfsSchedule [image] Methods [image] Rename
Remarks

With this methode you can rename a schedule.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrNewName as BSTR


ScheduleLinks
ObjectModel COM [image] PfsSchedule [image] Methods [image] ScheduleLinks
Remarks

This collecton manages the functions and variables which are linked to the schedule.

Datatype
IPfsScheduleLinks

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Schedules
ObjectModel COM [image] PfsSchedule [image] Methods [image] Schedules
Remarks

A Schedule can also be a container for other schedules, with the "Schedules" collection you can access the sub schedules of a schedule.

Datatype
IPfsSchedules

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


ScheduleTimes
ObjectModel COM [image] PfsSchedule [image] Methods [image] ScheduleTimes
Remarks

This object manages the schedule times of the schedule.

Datatype
IPfsScheduleTimes

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


SetDefaultDay
ObjectModel COM [image] PfsSchedule [image] Methods [image] SetDefaultDay
Remarks

With this methode you can link a schedule as default to a day type.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
sDayOfWeek as tpPfsDefaultDays


SkippedDays
ObjectModel COM [image] PfsSchedule [image] Methods [image] SkippedDays
Remarks

Manages the days which are manualy linked to a schedule for some specific dates as skipped days.

Datatype
IPfsScheduleDays

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


PfsScheduleDay
ObjectModel COM [image] PfsScheduleDay
Remarks

A Schedule day object is a specific date on which a schedule is excecuted or not.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''Reading out all Dates''''''''''''
'''''''of the ExecutionDays of a Schedule'''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub test23()
Dim pfs As PfsEngine
Dim i As Integer
Set pfs = MyWorkspace.ActiveDocument.pfs
''''''Giving out the Count of all Execution Days
Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ExecutionDays.Count
For i = 0 To pfs.Groups.Item(0).Schedules.Item(0).ExecutionDays.Count - 1

Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ExecutionDays.Item(i).Date
Next i

End Sub


Properties
ObjectModel COM [image] PfsScheduleDay [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
date | date |  | Readonly | Readonly | Available | Available
Parent | ipfsschedule | Returns the parent object. | Readonly | Readonly | Available | Available
Session | iproject | Contains the "Project" object. | Readonly | Readonly | Available | Available
Type | short | Contains the type of the schedule day. | Readonly | Readonly | Available | Available


date
ObjectModel COM [image] PfsScheduleDay [image] Properties [image] date
Remarks

Datatype
DATE

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsScheduleDay [image] Properties [image] Parent
Remarks

Returns the parent object.

Datatype
IPfsSchedule

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsScheduleDay [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] PfsScheduleDay [image] Properties [image] Type
Remarks

Contains the type of the schedule day. Can contain the following values:

  • tpPfsExecute = 0x30,
  • tpPfsSkip = 0x31,
  • tpPfsDefaultDay = 0x32,
  • tpPfsDefaultHDay = 0x33,
  • tpPfsUnused = 0x34,

Datatype
short

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsScheduleDay [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DayLinkType [GET] | tppfsdaylink |  | Readonly | Readonly | Available | Available


DayLinkType [GET]
ObjectModel COM [image] PfsScheduleDay [image] Methods [image] DayLinkType [GET]
Remarks

Datatype
tpPfsDayLink

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


PfsScheduleDays
ObjectModel COM [image] PfsScheduleDays
Remarks

The ScheduleDay collection contains a date, on which the schedule should be executed or not.With the Type property you can find out, if the schadule should be executed or not on the given day.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''Reading out all Dates''''''''''''
'''''''of the ExecutionDays of a Schedule'''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub test23()
Dim pfs As PfsEngine
Dim i As Integer
Set pfs = MyWorkspace.ActiveDocument.pfs
''''''Giving out the Count of all Execution Days
Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ExecutionDays.Count
For i = 0 To pfs.Groups.Item(0).Schedules.Item(0).ExecutionDays.Count - 1

Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ExecutionDays.Item(i).Date
Next i

End Sub


Properties
ObjectModel COM [image] PfsScheduleDays [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | The method returns the number of available objects. | Readonly | Readonly | Available | Available
Parent | ipfsschedule | Returns the parent object. | Readonly | Readonly | Available | Available
Session | iproject | Contains the "Project" object. | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] PfsScheduleDays [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsScheduleDays [image] Properties [image] Parent
Remarks

Returns the parent object.

Datatype
IPfsSchedule

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsScheduleDays [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsScheduleDays [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Item | ipfsscheduleday | Returns the ScheduleDay object from the collection, which is identified by the parameter vNameOrPos. | Available | Available | Available | Available


Item
ObjectModel COM [image] PfsScheduleDays [image] Methods [image] Item
Remarks

Returns the ScheduleDay object from the collection, which is identified by the parameter vNameOrPos.Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IPfsScheduleDay

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT

The parameter vNameOrPos can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • ScheduleDay name: The ScheduleDay can also be accessed with its unique name.


PfsScheduleLink
ObjectModel COM [image] PfsScheduleLink
Remarks

The ScheduleLink object is a link to the variable/function. Depending on the Type property you can access the linked variable/function with the methods ItemVariable resp. ItemRtFunction.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
'''''''''''''''''''''''''''''''''''''''''''''
''''''''Giving out all Names, function-''''''
'''''''or variable names of a schedule'''''''
'''''''''''''''''''''''''''''''''''''''''''''
Private Sub test()
Dim pfs As PfsEngine
Dim i As Integer
Set pfs = MyWorkspace.ActiveDocument.pfs
Dim mytype As Integer
Debug.Print pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Count - 1
For i = 0 To pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Count - 1

mytype = pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Item(i).Type

Debug.Print pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Item(i).Type

Debug.Print pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Item(i).Name

Debug.Print pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Item(i).GUID

If mytype = 32 Or mytype = 34 Then

Debug.Print

pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Item(i).Variable.Driver.Name

Else

Debug.Print

pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Item(i).RtFunction.Name

End If

Next i
End Sub


Properties
ObjectModel COM [image] PfsScheduleLink [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Guid | bstr | Is the Guid of the ScheduleLink which is unique and can be used to identify the object. | Readonly | Readonly | Available | Available
Name | bstr | Is the name of the ScheduleLink. | Readonly | Readonly | Available | Available
Parent | ipfsschedulelinks | Returns the parent object. | Readonly | Readonly | Available | Available
Session | iproject | Contains the "Project" object. | Readonly | Readonly | Available | Available
Type | tppfslinktypes |  | Readonly | Readonly | Available | Available


Guid
ObjectModel COM [image] PfsScheduleLink [image] Properties [image] Guid
Remarks

Is the Guid of the ScheduleLink which is unique and can be used to identify the object.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] PfsScheduleLink [image] Properties [image] Name
Remarks

Is the name of the ScheduleLink.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsScheduleLink [image] Properties [image] Parent
Remarks

Returns the parent object.

Datatype
IPfsScheduleLinks

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsScheduleLink [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] PfsScheduleLink [image] Properties [image] Type
Remarks

Datatype
tpPfsLinkTypes

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsScheduleLink [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
RtFunction | irtfunction | Returns the function which is linked to the switching point. | Readonly | Readonly | Available | Available
Variable | ivariable | Returns the variable which is linked to the switching point. | Readonly | Readonly | Available | Available


RtFunction
ObjectModel COM [image] PfsScheduleLink [image] Methods [image] RtFunction
Remarks

Returns the function which is linked to the switching point. Is just available if the Type of the Link is correctly set.

Datatype
IRtFunction

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Variable
ObjectModel COM [image] PfsScheduleLink [image] Methods [image] Variable
Remarks

Returns the variable which is linked to the switching point. Is just available if the Type of the Link is correctly set.

Datatype
IVariable

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


PfsScheduleLinks
ObjectModel COM [image] PfsScheduleLinks
Remarks

The "IPfsScheduleLinks" object manages the collection of the "IPfsScheduleLink" objects.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub PFS_Sample()
Dim i As Integer
Dim zPFS As PfsEngine
Dim zPFS_GRP As PfsGroup
Dim zPFS_SCD As PfsSchedule
Dim zPFS_SCL As PfsScheduleLink
Dim zFCT As RtFunction
Dim zVAR As Variable
'get PFS Engine
Set zPFS = MyWorkspace.ActiveDocument.Pfs
'get 1st found group
Set zPFS_GRP = zPFS.Groups.Item(0)
'get 1st found schedule
Set zPFS_SCD = zPFS_GRP.Schedules.Item(0)
'get count of ScheduleLinks
Debug.Print "ScheduleLinks: " & zPFS_SCD.ScheduleLinks.Count
'create new FunctionLink
Set zFCT = MyWorkspace.ActiveDocument.RtFunctions.Item("myFunction")
Set zPFS_SCL = zPFS_SCD.ScheduleLinks.CreateFktLink(zFCT)
Debug.Print zPFS_SCL.Name
'create new VariableLink
Set zVAR = MyWorkspace.ActiveDocument.Variables.Item("myVAR")
Set zPFS_SCL = zPFS_SCD.ScheduleLinks.CreateVarLink(zVAR)
Debug.Print zPFS_SCL.Name
'enumerate ScheduleLinks
For i = 0 To zPFS_SCD.ScheduleLinks.Count - 1

Set zPFS_SCL = zPFS_SCD.ScheduleLinks.Item(i)

Debug.Print "Nr." & i & ": " & zPFS_SCL.Name & " [" & zPFS_SCL.Type & "]"
Next i
Set zPFS_SCL = Nothing
'delete ScheduleLinks
zPFS_SCD.ScheduleLinks.DeleteVarLink ("MyVAR")
'save changes
zPFS.Save
End Sub


Properties
ObjectModel COM [image] PfsScheduleLinks [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Readonly | Available | Available
Parent | ipfsschedule |  | Readonly | Readonly | Available | Available
Session | iproject |  | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] PfsScheduleLinks [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsScheduleLinks [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPfsSchedule

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsScheduleLinks [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsScheduleLinks [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateFktLink | ipfsschedulelink | With this methode you can create a new function link. | Available | Available | Available | Available
CreateVarLink | ipfsschedulelink | With this methode you can create a new variable link. | Available | Available | Available | Available
DeleteFktLink | variant_bool | With this methode a function link can be deleted. | Available | Available | Available | Available
DeleteVarLink | variant_bool | With this methode a variable link can be deleted. | Available | Available | Available | Available
Item | ipfsschedulelink | Returns the ScheduleLink object at the specified position. | Available | Available | Available | Available


CreateFktLink
ObjectModel COM [image] PfsScheduleLinks [image] Methods [image] CreateFktLink
Remarks

With this methode you can create a new function link.

Datatype
IPfsScheduleLink

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
pFunction as IRtFunction


CreateVarLink
ObjectModel COM [image] PfsScheduleLinks [image] Methods [image] CreateVarLink
Remarks

With this methode you can create a new variable link.

Datatype
IPfsScheduleLink

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
pVariable as IVariable


DeleteFktLink
ObjectModel COM [image] PfsScheduleLinks [image] Methods [image] DeleteFktLink
Remarks

With this methode a function link can be deleted.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT


DeleteVarLink
ObjectModel COM [image] PfsScheduleLinks [image] Methods [image] DeleteVarLink
Remarks

With this methode a variable link can be deleted.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT


Item
ObjectModel COM [image] PfsScheduleLinks [image] Methods [image] Item
Remarks

Returns the ScheduleLink object at the specified position.

Datatype
IPfsScheduleLink

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosition as VARIANT


PfsSchedules
ObjectModel COM [image] PfsSchedules
Remarks

The Schedules collection contains the existing schedules of an equipment or a parent schedule. The single schedules contain the execution times and a pool of links, e.g. variables/functions. The times are linked to any number of switching points, that execute switching operations.With the Item method combined with the Count property you can iterate through the existing schedules.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
''''''''''''''''''''''''''''''''''''''''''''''
''''''''Reading out Count of schedules''''''''
''''''Creating and Deleting of Schedules''''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub shifttest()
Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.pfs
Debug.Print mypfs.Groups.Item(0).Schedules.Count
mypfs.Groups.Item(0).Schedules.CreateSchedule ("myschedule1")
mypfs.Groups.Item(0).Schedules.CreateSchedule ("myschedule2")
mypfs.Groups.Item(0).Schedules.CreateSchedule ("myschedule3")
Debug.Print mypfs.Groups.Item(0).Schedules.Count
mypfs.Groups.Item(0).Schedules.DeleteSchedule ("myschedule1")
mypfs.Groups.Item(0).Schedules.DeleteSchedule ("myschedule2")
mypfs.Groups.Item(0).Schedules.DeleteSchedule ("myschedule3")
Debug.Print mypfs.Groups.Item(0).Schedules.Count

End Sub


Properties
ObjectModel COM [image] PfsSchedules [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | The method returns the number of available objects. | Readonly | Readonly | Available | Available
Parent | ipfsgroup | Returns the parent object. | Readonly | Readonly | Available | Available
Session | iproject | Contains the "Project" object. | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] PfsSchedules [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsSchedules [image] Properties [image] Parent
Remarks

Returns the parent object.

Datatype
IPfsGroup

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsSchedules [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsSchedules [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateSchedule | ipfsschedule | With this methode you can create a new Schedule. | Available | Available | Available | Available
DeleteSchedule | variant_bool | With this methode you can delete a Schedule. | Available | Available | Available | Available
DuplicateSchedule | ipfsschedule | This method will copy the schedule identified by bstrFullSourceName into the PfsSchedules collection. It will return a pointer to the newly created PfsSchedule. | Available | Available | Available | Available
DuplicateSchedule2 | ipfsschedule |  | Available | Available | Available | Available
Item | ipfsschedule | Returns the Schedule object from the collection, which is identified by the parameter vNameOrPos. | Available | Available | Available | Available
ParentSchedule [GET] | ipfsschedule |  | Readonly | Readonly | Available | Available


CreateSchedule
ObjectModel COM [image] PfsSchedules [image] Methods [image] CreateSchedule
Remarks

With this methode you can create a new Schedule.

Datatype
IPfsSchedule

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrName as BSTR


DeleteSchedule
ObjectModel COM [image] PfsSchedules [image] Methods [image] DeleteSchedule
Remarks

With this methode you can delete a Schedule.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT


DuplicateSchedule
ObjectModel COM [image] PfsSchedules [image] Methods [image] DuplicateSchedule
Remarks

This method will copy the schedule identified by bstrFullSourceName into the PfsSchedules collection. It will return a pointer to the newly created PfsSchedule.Note: The name of the copy will be made unique the same way as over the GUI.bstrFullSourceName: Name with all parent names of a PfsSchedule. May be found in the PfsSchedule.KeyNote PropertybCopyChildSchedules: If true, all Child Schedules of the Source Schedule will be copied as well. If false, the source Schedule will be copied without any children.

Datatype
IPfsSchedule

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrFullSourceName as BSTR

bCopyChildSchedules as BOOL

Example
C#
Copy
public void Macro_DuplicateSchedule()
        {
            // Get the Schedule we want to copy
            var sourceSchedule = this.Pfs().Groups().Item("someGroupName").Schedules().Item("theScheduleIWantToCopy");

            // Get the Collection into which we want to paste the new copy
            var targetSchedules = this.Pfs().Groups().Item("theGroupIWantToCopyTheScheduleInto").Schedules();

            // Create a Copy
            var newSchedule = targetSchedules.DuplicateSchedule(sourceSchedule.KeyNote, 1);

            this.Pfs().Save();

            // Inspect the result
            System.Windows.Forms.MessageBox.Show("newObject: " + newSchedule.KeyNote);
        }
VBA
Copy
Public Sub SimpleDuplicate()
    'Get the Schedule we want to copy
    Dim sourceSchedule As PfsSchedule
    Set sourceSchedule = thisProject.pfs.Groups.Item("someGroupName").schedules.Item("theScheduleIWantToCopy")
    'Get the Collection into which we want to paste the new copy
    Dim targetSchedules As PfsSchedules
    Set targetSchedules = thisProject.pfs.Groups.Item("theGroupIWantToCopyTheScheduleInto").schedules
    'Create a Copy
    Set newSchedule = targetSchedules.DuplicateSchedule(sourceSchedule.KeyNote, True)
    thisProject.pfs.save
    'Inspect the result
    Debug.Print "newObject: " + newSchedule.KeyNote
End Sub


DuplicateSchedule2
ObjectModel COM [image] PfsSchedules [image] Methods [image] DuplicateSchedule2
Remarks

Datatype
IPfsSchedule

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_fullSourceName as BSTR

p_copyChildScheduleCollection as VARIANT_BOOL


Item
ObjectModel COM [image] PfsSchedules [image] Methods [image] Item
Remarks

Returns the Schedule object from the collection, which is identified by the parameter vNameOrPos. Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IPfsSchedule

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT

The parameter vNameOrPos can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • Schedule name: The Schedule can also be accessed with its unique name.


ParentSchedule [GET]
ObjectModel COM [image] PfsSchedules [image] Methods [image] ParentSchedule [GET]
Remarks

Datatype
IPfsSchedule

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


PfsScheduleTime
ObjectModel COM [image] PfsScheduleTime
Remarks

Schedule Times are the entries in a schedule which can contain switching points for functions or variables.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
''''''''''''''''''''''''''''''''''''''''''''''
''''''''Reading out Types and times of '''''''
''''''''''''''''all Schedule Times''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub mytest1()
Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.pfs
Dim i As Integer
For i = 0 To mypfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Count - 1

Debug.Print mypfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).Type

Debug.Print mypfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).Time
Next i

End Sub
Public Sub TestMacro_UserEvent()
    Dim pfsTime As PfsScheduleTime
    Dim pfsEvent As pfsEvent
    Set pfsTime = thisProject.Pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0)
    Set pfsEvent = thisProject.Pfs.Events.Item(0)
    pfsTime.UserEventId = pfsEvent.ID
    thisProject.Pfs.Save
End Sub
Public Sub TestMacro_PredefniedEvent()
    Dim pfsTime As PfsScheduleTime
    Dim pfsEvent As pfsEvent
    Set pfsTime = thisProject.Pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0)
    pfsTime.EventId = tpPfsShiftStart
    thisProject.Pfs.Save
End Sub


Properties
ObjectModel COM [image] PfsScheduleTime [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
EventId | tppfseventtypes | Adds a pre-defined event to a relative switch point. | Unused | Unused | Available | Available
Guid | bstr | Is the Guid of the ScheduleLink which is unique and can be used to identify the object. | Readonly | Readonly | Available | Available
Offset | double | Is the deviation of the set time. | Available | Available | Available | Available
Parent | ipfsscheduletimes | Returns the parent object. | Readonly | Readonly | Available | Available
Session | iproject | Contains the "Project" object. | Readonly | Readonly | Available | Available
Time | date | Is the Time which is set to the Schedule Time. | Available | Available | Available | Available
Type | tppfstimetypes |  | Available | Available | Available | Available
UserEventId | long | Adds a user defined event to a relative switch point. | Unused | Unused | Available | Available


EventId
ObjectModel COM [image] PfsScheduleTime [image] Properties [image] EventId
Remarks

Adds a pre-defined event to a relative switch point.

Datatype
tpPfsEventTypes

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


Guid
ObjectModel COM [image] PfsScheduleTime [image] Properties [image] Guid
Remarks

Is the Guid of the ScheduleLink which is unique and can be used to identify the object.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Offset
ObjectModel COM [image] PfsScheduleTime [image] Properties [image] Offset
Remarks

Is the deviation of the set time.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsScheduleTime [image] Properties [image] Parent
Remarks

Returns the parent object.

Datatype
IPfsScheduleTimes

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsScheduleTime [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] PfsScheduleTime [image] Properties [image] Time
Remarks

Is the Time which is set to the Schedule Time.

Datatype
DATE

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] PfsScheduleTime [image] Properties [image] Type
Remarks

Datatype
tpPfsTimeTypes

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


UserEventId
ObjectModel COM [image] PfsScheduleTime [image] Properties [image] UserEventId
Remarks

Adds a user defined event to a relative switch point.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsScheduleTime [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Event | ipfsevent |  | Unused | Unused | Available | Available
ScheduleValues | ipfsschedulevalues | Contains all linked values of the schedule time. | Available | Available | Available | Available


Event
ObjectModel COM [image] PfsScheduleTime [image] Methods [image] Event
Remarks

Datatype
IPfsEvent

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


ScheduleValues
ObjectModel COM [image] PfsScheduleTime [image] Methods [image] ScheduleValues
Remarks

Contains all linked values of the schedule time.

Datatype
IPfsScheduleValues

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


PfsScheduleTimes
ObjectModel COM [image] PfsScheduleTimes
Remarks

The ScheduleTimes collection contains the times of the schedule. As the times of a schedule are inherited to its children, this list contains all times of the schedule itself and all the times of parent schedules.Several switching operations can be executed at any time! With the Item method combined with the Count property you can iterate through the existing times.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
''''''''''''''''''''''''''''''''''''''''''''''
''''''''''Creating and Deletion of 5''''''''''
'''''''''''''''Schedule Times'''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub test()
Dim pfs As PfsEngine
Dim i As Integer
Dim g As Integer
Set pfs = MyWorkspace.ActiveDocument.pfs
Dim mytime As tpPfsTimeTypes
mytime = tpPfsRelativeTime
g = pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Count
Debug.Print g
Debug.Print "-------Creation-------"
For i = 0 To 4

Debug.Print g

pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.CreateTime (mytime)

pfs.Save

g = pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Count
Next i
Debug.Print "-------Deletion-------"
For i = g - 1 To 0 Step -1

pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.DeleteTime (i)

pfs.Save

g = pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Count

Debug.Print g
Next i

End Sub


Properties
ObjectModel COM [image] PfsScheduleTimes [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Readonly | Available | Available
Parent | ipfsschedule |  | Readonly | Readonly | Available | Available
Session | iproject |  | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] PfsScheduleTimes [image] Properties [image] Count
Remarks

This property returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsScheduleTimes [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPfsSchedule

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsScheduleTimes [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsScheduleTimes [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateTime | ipfsscheduletime | - | Available | Available | Available | Available
DeleteTime | variant_bool | - | Available | Available | Available | Available
Item | ipfsscheduletime | - | Available | Available | Available | Available


CreateTime
ObjectModel COM [image] PfsScheduleTimes [image] Methods [image] CreateTime
Remarks

With this methode you can create a new ScheduleTime.

Datatype
IPfsScheduleTime

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
tpTimeType as tpPfsTimeTypes


DeleteTime
ObjectModel COM [image] PfsScheduleTimes [image] Methods [image] DeleteTime
Remarks

With this methode you can delete a ScheduleTime.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lIndex as long


Item
ObjectModel COM [image] PfsScheduleTimes [image] Methods [image] Item
Remarks

Returns the ScheduleTime object from the collection, which is identified by the parameter vPosition. The parameter vPosition is the index of the element you want to get. Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IPfsScheduleTime

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosition as VARIANT


PfsScheduleValue
ObjectModel COM [image] PfsScheduleValue
Remarks

A ScheduleValue is a subelement of a ScheduleTime. One ScheduleTime can have many ScheduleValues. For Instance: An absolute ScheduleTime is configured at 12:00am. If you want to change the value of three variables and excecute two functions at 12:00am you need to add five ScheduleValues.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''Reading out Count, Value'''''''''''
''''''''''Active Status and type of'''''''''''
'''''''''''''''Schedule Values''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub test()
Dim pfs As PfsEngine
Dim i As Integer
Dim g As Integer
Set pfs = MyWorkspace.ActiveDocument.pfs
Debug.Print "------>Count:"
Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Count
For i = 0 To pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Count - 1

Debug.Print "--->Item " & i & ": "

Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Item(i).value

Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Item(i).Active

Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Item(i).Type
Next i
End Sub


Properties
ObjectModel COM [image] PfsScheduleValue [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Active | variant_bool |  | Available | Available | Available | Available
Guid | bstr |  | Available | Available | Available | Available
Parent | ipfsschedulevalues |  | Readonly | Readonly | Available | Available
PasswordLevel | short |  | Readonly | Readonly | Available | Available
Session | iproject |  | Readonly | Readonly | Available | Available
Type | tppfslinktypes |  | Readonly | Readonly | Available | Available
Value | variant |  | Available | Available | Available | Available


Active
ObjectModel COM [image] PfsScheduleValue [image] Properties [image] Active
Remarks

This property gives you the possibility to activate or deactivate single ScheduleValues.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Guid
ObjectModel COM [image] PfsScheduleValue [image] Properties [image] Guid
Remarks

Is the Guid of the ScheduleValue which is unique and can be used to identify the object.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsScheduleValue [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPfsScheduleValues

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


PasswordLevel
ObjectModel COM [image] PfsScheduleValue [image] Properties [image] PasswordLevel
Remarks

Datatype
short

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsScheduleValue [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] PfsScheduleValue [image] Properties [image] Type
Remarks

Datatype
tpPfsLinkTypes

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Value
ObjectModel COM [image] PfsScheduleValue [image] Properties [image] Value
Remarks

Is the Value which is written to a variable when the ScheduleValue is executed.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsScheduleValue [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
GetScheduleLink | ipfsschedulelink | - | Available | Available | Available | Available
ScheduleLink | ipfsschedulelink | For internal use only | Available | Available | Available | Available
SetScheduleLink | variant_bool | - | Available | Available | Available | Available


GetScheduleLink
ObjectModel COM [image] PfsScheduleValue [image] Methods [image] GetScheduleLink
Remarks

This methode returns the ScheduleLink object of the ScheduleValue.

Datatype
IPfsScheduleLink

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


ScheduleLink
ObjectModel COM [image] PfsScheduleValue [image] Methods [image] ScheduleLink
Remarks

-

Datatype
IPfsScheduleLink

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


SetScheduleLink
ObjectModel COM [image] PfsScheduleValue [image] Methods [image] SetScheduleLink
Remarks

With this methode you can manually set the ScheduleLink.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
pLink as IPfsScheduleLink


PfsScheduleValues
ObjectModel COM [image] PfsScheduleValues
Remarks

The ScheduleValues collection contains the switching points of a schedule. A switching point is linked to a point of time, a variable/function and a value or VBA macro.The execution of the switching point is defined with a status (in-/active). The linked point of time can also be taken from a parent schedule.With this Item method combined with the Count property you can iterate through the switching points of a schedule.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''Creation and Deletion''''''''''''''
'''''''''''of 5 Schedule Values''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub test()
Dim pfs As PfsEngine
Dim i As Integer
Dim g As Integer
Set pfs = MyWorkspace.ActiveDocument.pfs

Dim mytype As tpPfsLinkTypes
mytype = tpPfsFunction
Debug.Print "---->Creation:"
For i = 0 To 4

Debug.Print
pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Count

pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.CreateValue (mytype)
Next i
Debug.Print "---->Deletion:"
For i = pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Count - 1 To 0 Step -1
pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.DeleteValue (i)
Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Count
Next i
End Sub


Properties
ObjectModel COM [image] PfsScheduleValues [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Readonly | Available | Available
Parent | ipfsscheduletime |  | Readonly | Readonly | Available | Available
Session | iproject |  | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] PfsScheduleValues [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsScheduleValues [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPfsScheduleTime

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsScheduleValues [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsScheduleValues [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateValue | ipfsschedulevalue | - | Available | Available | Available | Available
DeleteValue | variant_bool | - | Available | Available | Available | Available
Item | ipfsschedulevalue | - | Available | Available | Available | Available


CreateValue
ObjectModel COM [image] PfsScheduleValues [image] Methods [image] CreateValue
Remarks

With this methode you can create new Schedule Values at a specific ScheduleTime.

Datatype
IPfsScheduleValue

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
tpLinkType as tpPfsLinkTypes


DeleteValue
ObjectModel COM [image] PfsScheduleValues [image] Methods [image] DeleteValue
Remarks

With this methode you can delete a ScheduleValue.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lIndex as long


Item
ObjectModel COM [image] PfsScheduleValues [image] Methods [image] Item
Remarks

Returns the ScheduleValue object from the collection, which is identified by the parameter vPosition. The parameter vPosition is the index of the element you want to get. Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IPfsScheduleValue

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosition as VARIANT


PfsSwitchingPoint
ObjectModel COM [image] PfsSwitchingPoint
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_SwitchingPointPreview()
        {
// create a switching point filter
var filter = Pfs().Calendar().CreateSwitchingPointFilter();

// configure the filter
            filter.StartTime = System.DateTime.Now;
            filter.EndTime = System.DateTime.Now + new System.TimeSpan(7, 0, 0, 0);
            filter.TimeModelGroup = "z*";
            filter.Schedule = "N*";
            filter.Variable = "*";
            filter.Function = "*";
            filter.SearchData = zenOn.tpPfsData.tpPfsStoredData;

// get the preview for the configuration
string output = "";
object[] switchtingPoints = (object[])filter.SwitchingPointPreview();
foreach (object switchingPoint in switchtingPoints)
            {
                zenOn.IPfsSwitchingPoint p = (zenOn.IPfsSwitchingPoint)switchingPoint;
                output = output + "Active: " + p.Active.ToString();
                output = output + " TimeModelGroup: " + p.ScheduleValue.Parent.Parent.Parent.Parent.Parent.Parent.Name;
                output = output + " Schedule: " + p.ScheduleValue.Parent.Parent.Parent.Parent.KeyNote;
                output = output + " ExecTime: " + p.ExecutionTime.ToString();
                output = output + " LinkedType: " + p.ScheduleValue.Type.ToString();
                output = output + " LinkedObject: " + p.ScheduleValue.GetScheduleLink().Name;
if (p.ScheduleValue.Value != null)
                {
                    output = output + " SetValue: " + p.ScheduleValue.Value.ToString();
                }
                output = output + " PasswordLevel: " + p.ScheduleValue.PasswordLevel.ToString();
                output = output + " TriggerType: " + p.ScheduleValue.Parent.Parent.Type.ToString();
                output = output + " EventId: " + p.ScheduleValue.Parent.Parent.EventId.ToString();
                output = output + "\n\n";
            }

// show output
            System.Windows.Forms.MessageBox.Show(output);
        }
VBA
Copy
Public Sub Preview()
    'create a switching point filter
    Dim filter As PfsSwitchingPointFilter
    Set filter = thisProject.Pfs.Calendar.CreateSwitchingPointFilter
    'configure the filter
    filter.StartTime = Now
    filter.EndTime = Now + 7
    filter.TimeModelGroup = "z*"
    filter.Schedule = "N*"
    filter.Variable = "*"
    filter.Function = "*"
    filter.SearchData = tpPfsStoredData
    'get the preview for the filter configuration
    Dim points() As PfsSwitchingPoint
    points = filter.SwitchingPointPreview
    'build an output message
    Dim output As String
    Dim idx As Integer
    For idx = 0 To UBound(points)
        output = output & "Active: " & CStr(points(idx).Active)
        output = output & " TimeModelGroup: " & points(idx).ScheduleValue.Parent.Parent.Parent.Parent.Parent.Parent.Name
        output = output & " Schedule: " & points(idx).ScheduleValue.Parent.Parent.Parent.Parent.KeyNote
        output = output & " ExecTime: " & CStr(points(idx).ExecutionTime)
        output = output & " LinkedType: " & CStr(points(idx).ScheduleValue.Type)
        output = output & " LinkedObject: " & CStr(points(idx).ScheduleValue.GetScheduleLink.Name)
        output = output & " SetValue: " & CStr(points(idx).ScheduleValue.value)
        output = output & " PasswordLevel: " & CStr(points(idx).ScheduleValue.PasswordLevel)
        output = output & " TriggerType: " & CStr(points(idx).ScheduleValue.Parent.Parent.Type)
        output = output & " EventId: " & CStr(points(idx).ScheduleValue.Parent.Parent.EventId)
        output = output & vbNewLine & vbNewLine
    Next idx
    'show the output
    MsgBox output
End Sub


Properties
ObjectModel COM [image] PfsSwitchingPoint [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Active | variant_bool | If the switching point is to be executed | Available | Available | Available | Available
ExecutionTime | date | Time on which the schedule value is executed | Available | Available | Available | Available
ScheduleValue | ipfsschedulevalue | Schedule value to be executed at the execution time | Available | Available | Available | Available


Active
ObjectModel COM [image] PfsSwitchingPoint [image] Properties [image] Active
Remarks

true, when the switching point is Active and will be executed.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


ExecutionTime
ObjectModel COM [image] PfsSwitchingPoint [image] Properties [image] ExecutionTime
Remarks

Time when this particular switching point is executed.

Datatype
Date

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


ScheduleValue
ObjectModel COM [image] PfsSwitchingPoint [image] Properties [image] ScheduleValue
Remarks

short PasswordLevel.

Datatype
IPfsScheduleValue

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


PfsSwitchingPointFilter
ObjectModel COM [image] PfsSwitchingPointFilter
Remarks

The object that is used to get a filtered subset of the switching points that are to be executed in a defined timeframe. To use this class first define the filteroptions in the properties of the object, and then call the SwitchingPointPreview() method to get the results for your current filter as an array. Note that the objects in this array are only allowed to be used while the IPfsSwitchingPointFilter object is still alive or until the next call of SwitchingPointPreview().

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] PfsSwitchingPointFilter [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
EndTime | date | End of the timeframe in which we search | Available | Available | Available | Available
Function | bstr | Filter string for the names of the functions that are triggered by the schedule values | Available | Available | Available | Available
Schedule | bstr | Filter string for the names of the schedules that are to be searched | Available | Available | Available | Available
SearchData | tppfsdata | Data that is to be searched. The locally edited version or the stored one | Available | Available | Available | Available
StartTime | date | Start of the time frame in which we search | Available | Available | Available | Available
TimeModelGroup | bstr | Filter string for the names of the time model groups that are to be searched | Available | Available | Available | Available
Variable | bstr | Filter string for the names of variables that are set by the schedule values | Available | Available | Available | Available


EndTime
ObjectModel COM [image] PfsSwitchingPointFilter [image] Properties [image] EndTime
Remarks

End time of your filter timeframe.

Datatype
DATE

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Function
ObjectModel COM [image] PfsSwitchingPointFilter [image] Properties [image] Function
Remarks

Filter string for the names of the functions that are to be executed by the switching point.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Schedule
ObjectModel COM [image] PfsSwitchingPointFilter [image] Properties [image] Schedule
Remarks

Filter string for the names of the schedules that are to be considered.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


SearchData
ObjectModel COM [image] PfsSwitchingPointFilter [image] Properties [image] SearchData
Remarks

use tpPfsStoredData to only check the saved configuration or tpPfsEditData to consider the unsaved changes as well.

Datatype
tpPfsData

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


StartTime
ObjectModel COM [image] PfsSwitchingPointFilter [image] Properties [image] StartTime
Remarks

Start time of your filter timeframe.

Datatype
DATE

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


TimeModelGroup
ObjectModel COM [image] PfsSwitchingPointFilter [image] Properties [image] TimeModelGroup
Remarks

Filter string for the names of the time model groups that are to be considered.text.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Variable
ObjectModel COM [image] PfsSwitchingPointFilter [image] Properties [image] Variable
Remarks

Filter string for the names of the variables that will be set by the switching point.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsSwitchingPointFilter [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
SwitchingPointPreview | variant | Returns an array of switching points that match the filter | Available | Available | Available | Available


SwitchingPointPreview
ObjectModel COM [image] PfsSwitchingPointFilter [image] Methods [image] SwitchingPointPreview
Remarks

This method returns an array of switching points that match the filtering set in its properties. Note that the objects in this array are only valid until you next call SwitchingPointPreview() or the IPfsSwitchingPointFilter is destroyed.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_SwitchingPointPreview()
        {
// create a switching point filter
var filter = Pfs().Calendar().CreateSwitchingPointFilter();

// configure the filter
            filter.StartTime = System.DateTime.Now;
            filter.EndTime = System.DateTime.Now + new System.TimeSpan(7, 0, 0, 0);
            filter.TimeModelGroup = "z*";
            filter.Schedule = "N*";
            filter.Variable = "*";
            filter.Function = "*";
            filter.SearchData = zenOn.tpPfsData.tpPfsStoredData;

// get the preview for the configuration
string output = "";
object[] switchtingPoints = (object[])filter.SwitchingPointPreview();
foreach (object switchingPoint in switchtingPoints)
            {
                zenOn.IPfsSwitchingPoint p = (zenOn.IPfsSwitchingPoint)switchingPoint;
                output = output + "Active: " + p.Active.ToString();
                output = output + " TimeModelGroup: " + p.ScheduleValue.Parent.Parent.Parent.Parent.Parent.Parent.Name;
                output = output + " Schedule: " + p.ScheduleValue.Parent.Parent.Parent.Parent.KeyNote;
                output = output + " ExecTime: " + p.ExecutionTime.ToString();
                output = output + " LinkedType: " + p.ScheduleValue.Type.ToString();
                output = output + " LinkedObject: " + p.ScheduleValue.GetScheduleLink().Name;
if (p.ScheduleValue.Value != null)
                {
                    output = output + " SetValue: " + p.ScheduleValue.Value.ToString();
                }
                output = output + " PasswordLevel: " + p.ScheduleValue.PasswordLevel.ToString();
                output = output + " TriggerType: " + p.ScheduleValue.Parent.Parent.Type.ToString();
                output = output + " EventId: " + p.ScheduleValue.Parent.Parent.EventId.ToString();
                output = output + "\n\n";
            }

// show output
            System.Windows.Forms.MessageBox.Show(output);
        }
VBA
Copy
Public Sub Preview()
    'create a switching point filter
    Dim filter As PfsSwitchingPointFilter
    Set filter = thisProject.Pfs.Calendar.CreateSwitchingPointFilter
    'configure the filter
    filter.StartTime = Now
    filter.EndTime = Now + 7
    filter.TimeModelGroup = "z*"
    filter.Schedule = "N*"
    filter.Variable = "*"
    filter.Function = "*"
    filter.SearchData = tpPfsStoredData
    'get the preview for the filter configuration
    Dim points() As PfsSwitchingPoint
    points = filter.SwitchingPointPreview
    'build an output message
    Dim output As String
    Dim idx As Integer
    For idx = 0 To UBound(points)
        output = output & "Active: " & CStr(points(idx).Active)
        output = output & " TimeModelGroup: " & points(idx).ScheduleValue.Parent.Parent.Parent.Parent.Parent.Parent.Name
        output = output & " Schedule: " & points(idx).ScheduleValue.Parent.Parent.Parent.Parent.KeyNote
        output = output & " ExecTime: " & CStr(points(idx).ExecutionTime)
        output = output & " LinkedType: " & CStr(points(idx).ScheduleValue.Type)
        output = output & " LinkedObject: " & CStr(points(idx).ScheduleValue.GetScheduleLink.Name)
        output = output & " SetValue: " & CStr(points(idx).ScheduleValue.value)
        output = output & " PasswordLevel: " & CStr(points(idx).ScheduleValue.PasswordLevel)
        output = output & " TriggerType: " & CStr(points(idx).ScheduleValue.Parent.Parent.Type)
        output = output & " EventId: " & CStr(points(idx).ScheduleValue.Parent.Parent.EventId)
        output = output & vbNewLine & vbNewLine
    Next idx
    'show the output
    MsgBox output
End Sub


PfsTimeModell
ObjectModel COM [image] PfsTimeModell
Remarks

A TimeModell contains shifts and breaks and defines the operating time of an equipment.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub PFS_Sample()
Dim i As Integer
Dim zPFS As PfsEngine
Dim zPFS_GRP As PfsGroup
Dim zPFS_TML As PfsTimeModell
'get PFS Engine
Set zPFS = MyWorkspace.ActiveDocument.Pfs
'get 1st found group
Set zPFS_GRP = zPFS.Groups.Item(0)
'get count of TimeModels
Debug.Print "TimeModels: " & zPFS_GRP.TimeModells.Count
'enumerate TimeModels
For i = 0 To zPFS_GRP.TimeModells.Count - 1

Set zPFS_TML = zPFS_GRP.TimeModells.Item(i)

Debug.Print "Nr." & i & ": " & zPFS_TML.Name

'check actual day...

Select Case zPFS_TML.IsOnDay(Now)

Case tpPfsDefaultDay

Debug.Print " tpPfsDefaultDay"

Case tpPfsDefaultHDay

Debug.Print " tpPfsDefaultHDay"

Case tpPfsExecute

Debug.Print " tpPfsExecute"

Case tpPfsSkip

Debug.Print " tpPfsSkip"

Case tpPfsUnused

Debug.Print " tpPfsUnused"

End Select
Next i
End Sub


Properties
ObjectModel COM [image] PfsTimeModell [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Guid | bstr |  | Readonly | Readonly | Available | Available
KeyNote | bstr |  | Readonly | Readonly | Available | Available
Name | bstr |  | Readonly | Readonly | Available | Available
Parent | ipfstimemodells |  | Readonly | Readonly | Available | Available
Session | iproject |  | Readonly | Readonly | Available | Available


Guid
ObjectModel COM [image] PfsTimeModell [image] Properties [image] Guid
Remarks

Is the Guid of the TimeMoedel which is unique and can be used to identify the object.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


KeyNote
ObjectModel COM [image] PfsTimeModell [image] Properties [image] KeyNote
Remarks

The Keynote returns the path from the equipment to the TimeModell seperated with dots.. For instance "group1.timemodel1" is the keynote of the timemodel1.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] PfsTimeModell [image] Properties [image] Name
Remarks

Is the name of the Time Model.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsTimeModell [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPfsTimeModells

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsTimeModell [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsTimeModell [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AddToDay | variant_bool | - | Available | Available | Available | Available
IsDefaultDay | tppfsdaylink | - | Available | Available | Available | Available
IsOnDay | tppfsdaylink |  | Available | Available | Available | Available
RemoveFromDay | variant_bool | - | Unused | Unused | Available | Available
Rename | variant_bool | - | Available | Available | Available | Available
SetDefaultDay | void | - | Unused | Unused | Available | Available
Shifts | ipfsmodellshifts | - | Available | Available | Available | Available


AddToDay
ObjectModel COM [image] PfsTimeModell [image] Methods [image] AddToDay
Remarks

With this methode a TimeModel can be linked to a Day. As parameters you have to hand over the Date of the day and a Boolean, which defines if the Schedule should be linked to all types of this day or just to this Date.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vDay as DATE

sType as tpPfsDayLink


IsDefaultDay
ObjectModel COM [image] PfsTimeModell [image] Methods [image] IsDefaultDay
Remarks

With this methode you can check the tpPfsDefaultDays.

Datatype
tpPfsDayLink

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
sDayOfWeek as tpPfsDefaultDays


IsOnDay
ObjectModel COM [image] PfsTimeModell [image] Methods [image] IsOnDay
Remarks

Datatype
tpPfsDayLink

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vDate as DATE


RemoveFromDay
ObjectModel COM [image] PfsTimeModell [image] Methods [image] RemoveFromDay
Remarks

[MISSING DESCRIPTION]

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vDay as DATE


Rename
ObjectModel COM [image] PfsTimeModell [image] Methods [image] Rename
Remarks

With this methode a Time Model can be renamed.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrNewName as BSTR


SetDefaultDay
ObjectModel COM [image] PfsTimeModell [image] Methods [image] SetDefaultDay
Remarks

[MISSING DESCRIPTION]

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
nDayOfWeek as tpPfsDefaultDays


Shifts
ObjectModel COM [image] PfsTimeModell [image] Methods [image] Shifts
Remarks

This collection contains the shifts of the time model.

Datatype
IPfsModellShifts

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


PfsTimeModells
ObjectModel COM [image] PfsTimeModells
Remarks

The TimeModells collection contains the existing time models of a PFS equipment. The time models contain the shift/break times of an equipment. Any number of time models can exist in an equipment.Time models have to be unique within an equipment.With the Item method you can access a time model. With the Item method combined with the Count property you can iterate through the existing models.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub PFS_Sample()
Dim i As Integer
Dim zPFS As PfsEngine
Dim zPFS_GRP As PfsGroup
Dim zPFS_TML As PfsTimeModell
'get PFS Engine
Set zPFS = MyWorkspace.ActiveDocument.Pfs
'get 1st found group
Set zPFS_GRP = zPFS.Groups.Item(0)
'get count of TimeModels
Debug.Print "TimeModels: " & zPFS_GRP.TimeModells.Count
'create new TimeModel
Set zPFS_TML = zPFS_GRP.TimeModells.CreateModell("Temporary")
'enumerate TimeModels
For i = 0 To zPFS_GRP.TimeModells.Count - 1

Set zPFS_TML = zPFS_GRP.TimeModells.Item(i)

Debug.Print "Nr." & i & ": " & zPFS_TML.Name
Next i
Set zPFS_TML = Nothing
'delete TimeModel
zPFS_GRP.TimeModells.DeleteModell ("Temporary")
'save changes
zPFS.Save
End Sub


Properties
ObjectModel COM [image] PfsTimeModells [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Readonly | Available | Available
Parent | ipfsgroup |  | Readonly | Readonly | Available | Available
Session | iproject |  | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] PfsTimeModells [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] PfsTimeModells [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPfsGroup

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Session
ObjectModel COM [image] PfsTimeModells [image] Properties [image] Session
Remarks

Contains the "Project" object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PfsTimeModells [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateModell | ipfstimemodell | - | Available | Available | Available | Available
DeleteModell | variant_bool | - | Available | Available | Available | Available
Item | ipfstimemodell | - | Available | Available | Available | Available


CreateModell
ObjectModel COM [image] PfsTimeModells [image] Methods [image] CreateModell
Remarks

With this methode you can create a Time Model.

Datatype
IPfsTimeModell

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrName as BSTR


DeleteModell
ObjectModel COM [image] PfsTimeModells [image] Methods [image] DeleteModell
Remarks

With this methode you can delete a Time Model.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vName as VARIANT


Item
ObjectModel COM [image] PfsTimeModells [image] Methods [image] Item
Remarks

Returns the TimeModel object from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • ModelBreak name: The TimeModel can also be accessed with its unique name.
Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
IPfsTimeModell

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT


PictureFilter
ObjectModel COM [image] PictureFilter
Remarks

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub ShowAlarms()
Dim zPicCEL As DynPicture
Dim zPicFilter As PictureFilter
Dim zFctAML As RtFunction
'Name of the CEL Screen
Const strCELPicture As String = "EVENTS"
'Name of the PictureSwitch Funktion to open the AML Screen
Const strAMLFunction As String = "picALARM"
'get CEL Screen objects
Set zPicCEL = thisProject.DynPictures.Item(strCELPicture)
'get AML function object
Set zFctAML = thisProject.RtFunctions.Item(strAMLFunction)
'check if Screen and Function exists
If Not zPicCEL Is Nothing And Not zFctAML Is Nothing Then
'if picture is not opened, then exit...
If zPicCEL.Online = False Then Exit Sub

'get actual PictureFilter

Set zPicFilter = zPicCEL.PictureFilter

'change Filter Settings in 'Picture Switch' function...

zFctAML.DynProperties("PictFilter.TimeFilter.ARVTime1") =
zPicFilter.DynProperties("TimeFilter.ARVTime1")

zFctAML.DynProperties("PictFilter.TimeFilter.ARVTime2") =
zPicFilter.DynProperties("TimeFilter.ARVTime2")

'execute function

zFctAML.Start
End If
End Sub


Methods
ObjectModel COM [image] PictureFilter [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateDynProperty | variant_bool | - | Readonly | Readonly | Available | Available
DynProperties [GET] | variant | - | Unused | Available | Available | Available
DynProperties [PUT] | void | - | Unused | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Unused | Available | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available


CreateDynProperty
ObjectModel COM [image] PictureFilter [image] Methods [image] CreateDynProperty
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties [GET]
ObjectModel COM [image] PictureFilter [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] PictureFilter [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] PictureFilter [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] PictureFilter [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Project
ObjectModel COM [image] Project
Remarks

The object Project is the most central VBA object, as it contains the single modules, as e.g. variables, drivers, ....The single objects of Project can be found in the collection Projects of the object Application. This way is needed for external applications, that are written e.g. in VB or VC++ and access the COM interface of the control system.In Visual Basic for Applications (VBA) the current project always is available via thisProject. The validity in ths case is restricted to the current project. If you need to access a project from within another project, then you have to get the appropriate project from the central collection Projects.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub ProjectExample()
'Return the name of the actual project
MsgBox "Name of the actual project = " & thisProject.Name
'Return the SQL path of the project
MsgBox "Project path = " & thisProject.Path
'Return the unique GUID of the project
MsgBox "GUID of the project = " & thisProject.DynProperties("GUID")
'Return the number of pictures in the project
MsgBox "Number of pictures = " & thisProject.DynPictures.Count
'Return the number of variables in the project
MsgBox "Number of variables = " & thisProject.Variables.Count
'Return the number of templates in the project
MsgBox "Number of templates = " & thisProject.Templates.Count
'Return the number of functions in the project
MsgBox "Number of functions = " & thisProject.RtFunctions.Count

End Sub


Properties
ObjectModel COM [image] Project [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
FontLists | ifontlists | Returns the FontList object. | Available | Unused | Available | Available
Guid | bstr | Returns the unique Project guid(Read Only). | Readonly | Readonly | Available | Available
IsGlobal | variant_bool |  | Readonly | Readonly | Available | Available
IsNet | variant_bool |  | Available | Readonly | Available | Available
LanguageTable | ilanguagetable | Returns the Language Table | Available | Unused | Available | Available
MessageControl | imessagecontrol | Returns the MessageControl object. | Available | Unused | Available | Available
Name | bstr |  | Readonly | Readonly | Available | Available
NetType | tpprojectnettypes |  | Unused | Readonly | Available | Available
Parent | iprojects |  | Readonly | Readonly | Available | Available
Path | bstr |  | Readonly | Readonly | Available | Available
RemoteTransport | iremotetransport | Returns the remote transport object. | Available | Unused | Available | Available
Scheduler | ischeduler | The scheduler object | Available | Available | Available | Available
ScreenHeight | long | Sets the height of the screen (Editor Only). | Available | Unused | Available | Available
ScreenWidth | long | Sets the width of the screen (Editor Only). | Available | Unused | Available | Available
ShiftManagement | ishiftmanagement | The shift management object | Unused | Available | Available | Available
StyleManager | istylemanager | Returns the StyleManager object | Unused | Unused | Available | Available
Symbols | isymbols | Returns the Symbols object. | Readonly | Unused | Available | Available
TextListManager | itextlistmanager | Returns the TextListManager object | Unused | Available | Available | Available
Units | iunits | Returns the Units object. | Available | Unused | Available | Available


FontLists
ObjectModel COM [image] Project [image] Properties [image] FontLists
Remarks

Datatype
IFontLists

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Guid
ObjectModel COM [image] Project [image] Properties [image] Guid
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


IsGlobal
ObjectModel COM [image] Project [image] Properties [image] IsGlobal
Remarks

Returns true if it is a global project and false if its not.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


IsNet
ObjectModel COM [image] Project [image] Properties [image] IsNet
Remarks

Returns true if the project is a network project and false if its not.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


LanguageTable
ObjectModel COM [image] Project [image] Properties [image] LanguageTable
Remarks

Datatype
ILanguageTable

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


MessageControl
ObjectModel COM [image] Project [image] Properties [image] MessageControl
Remarks

Datatype
IMessageControl

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] Project [image] Properties [image] Name
Remarks

Returns the name of the project. The project name has to be unique within a workspace. Otherwise it cannot be loaded in the Editor.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


NetType
ObjectModel COM [image] Project [image] Properties [image] NetType
Remarks

Datatype
tpProjectNetTypes

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Project [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProjects

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Path
ObjectModel COM [image] Project [image] Properties [image] Path
Remarks

Returns the path of the project.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


RemoteTransport
ObjectModel COM [image] Project [image] Properties [image] RemoteTransport
Remarks

Datatype
IRemoteTransport

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Scheduler
ObjectModel COM [image] Project [image] Properties [image] Scheduler
Remarks

Datatype
IScheduler

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


ScreenHeight
ObjectModel COM [image] Project [image] Properties [image] ScreenHeight
Remarks

Returns the resolution (height) of the project.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


ScreenWidth
ObjectModel COM [image] Project [image] Properties [image] ScreenWidth
Remarks

Returns the resolution (width) of the project.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


ShiftManagement
ObjectModel COM [image] Project [image] Properties [image] ShiftManagement
Remarks

Datatype
IShiftManagement

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


StyleManager
ObjectModel COM [image] Project [image] Properties [image] StyleManager
Remarks

Datatype
IStyleManager

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


Symbols
ObjectModel COM [image] Project [image] Properties [image] Symbols
Remarks

Datatype
ISymbols

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


TextListManager
ObjectModel COM [image] Project [image] Properties [image] TextListManager
Remarks

Datatype
ITextListManager

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Units
ObjectModel COM [image] Project [image] Properties [image] Units
Remarks

Datatype
IUnits

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Project [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Alarm | ialarm | - | Unused | Available | Available | Available
ALCEngine | ialcengine | - | Available | Available | Available | Available
Archives | iarchives | - | Unused | Available | Available | Available
ArchivesED | iarchivesed | - | Available | Unused | Available | Available
BatchManager | ibatchmanager | Returns the BatchManager object | Unused | Readonly | Available | Available
Build | variant_bool | - | Available | Unused | Available | Available
Cel | icel | - | Unused | Available | Available | Available
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
ColorPalettes | icolorpalettes | Return the ColorPalettes object. | Available | Unused | Available | Available
CreateDynProperty | variant_bool | - | Available | Unused | Available | Available
Decompile | void | - | Available | Unused | Available | Available
Drivers | idrivers | - | Available | Available | Available | Available
DynPictures | idynpictures | - | Available | Available | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
FileManager | ifilemanager | - | Available | Available | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
Interlockings | iinterlockings | Returns the Interlockings object. | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
ModulePath [GET] | bstr | - | Available | Unused | Available | Available
ModulePath [PUT] | void | - | Available | Unused | Available | Available
NetSend | variant_bool | By use of this methode, VBA-Data can be send to another System | Unused | Available | Available | Available
OnlineVariables | ionlinevariables | - | Unused | Available | Available | Available
ParentProject | variant_bool | Sets the parent project of the current project. | Available | Unused | Available | Available
Passwords | ipasswords | - | Available | Available | Available | Available
Pfs | ipfsengine | - | Available | Available | Available | Available
Recipes | irecipes | - | Available | Available | Available | Available
Reload | void |  | Unused | Available | Available | Available
Remas | iremas |  | Available | Available | Available | Available
ReplaceLinks | variant_bool | Replaces project links to 'bsSource' with 'bsTarget'. | Unused | Available | Available | Available
RGMGroups | irgmrecipegroups |  | Available | Available | Available | Available
RtFunctions | irtfunctions |  | Available | Available | Available | Available
SapFunctions | isapfunctions |  | Unused | Available | Available | Available
Scripts | iscripts |  | Available | Readonly | Available | Available
SetUserPropertyStrings | variant_bool | With this methode the Strings for the UserProperties (Rema and Limits) can be set | Available | Unused | Available | Available
String | bstr |  | Unused | Available | Available | Available
SystemModelManager | isystemmodelmanager | Return the SystemModelManager object. | Available | Unused | Available | Available
Tasks | itasks |  | Available | Available | Available | Available
Templates | itemplates |  | Available | Available | Available | Available
TimeFunctions | itimefunctions | - | Available | Available | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available
VarAssignments | ivarassignments | - | Available | Available | Available | Available
Variables | ivariables | - | Available | Available | Available | Available
VarTypes | ivartypes | - | Available | Available | Available | Available
ZenMenus | izenmenus | - | Available | Available | Available | Available


Alarm
ObjectModel COM [image] Project [image] Methods [image] Alarm
Remarks

Returns the object for alarming. With this object the single alarms can be accessed and the properties of the alarms can be read. With Events you have the possibility, to execute actions on the occurance of events.

Datatype
IAlarm

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ALCEngine
ObjectModel COM [image] Project [image] Methods [image] ALCEngine
Remarks

Returns the 'ALCEngine' object of the automatic line coloring mechanism.

Datatype
IALCEngine

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Archives
ObjectModel COM [image] Project [image] Methods [image] Archives
Remarks

Returns the 'Archives' object to read and write archive values.

Datatype
IArchives

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ArchivesED
ObjectModel COM [image] Project [image] Methods [image] ArchivesED
Remarks

Returns the 'ArchivesED' object to create archives in the editor.

Datatype
IArchivesED

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


BatchManager
ObjectModel COM [image] Project [image] Methods [image] BatchManager
Remarks

Datatype
IBatchManager

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Build
ObjectModel COM [image] Project [image] Methods [image] Build
Remarks

This method starts an rebuild of the runtime files, depending to given parameter all or only the changed files are created.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lMethod as tpBuildMethod

Example
VBA
Copy
Sub BuildRtFiles()
'build only changed
MyWorkspace.ActiveDocument.Build tpIncremental
'build all
MyWorkspace.ActiveDocument.Build tpAll
End Sub


Cel
ObjectModel COM [image] Project [image] Methods [image] Cel
Remarks

Returns the 'Cel' object for the Chronologic Event List. With this object CEL entries can be created or inherited.

Datatype
ICel

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


CheckIn
ObjectModel COM [image] Project [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckOut
ObjectModel COM [image] Project [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


ColorPalettes
ObjectModel COM [image] Project [image] Methods [image] ColorPalettes
Remarks

Datatype
IColorPalettes

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CreateDynProperty
ObjectModel COM [image] Project [image] Methods [image] CreateDynProperty
Remarks

New Items like AlarmClasses can be created.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
'Create/Change 3 AlarmClasses...
Sub CreateAlarmClasses()
Dim zPRJ As Project
Dim i As Integer
Dim bResult As Boolean
Set zPRJ = MyWorkspace.ActiveDocument
For i = 1 To 3

'check if AlarmClass exists

If CInt(zPRJ.DynProperties("AlarmClasses[-1]")) < i Then

'Create new AlarmClass

bResult = zPRJ.CreateDynProperty("AlarmClasses")

If bResult Then

zPRJ.DynProperties("AlarmClasses[" & i - 1 & "].Name") = "Class_" & i

zPRJ.DynProperties("AlarmClasses[" & i - 1 & "].Color") = RGB(120 + ((i - 1) * 63), 0, 0)

zPRJ.DynProperties("AlarmClasses[" & i - 1 & "].Description") = "created by VBA"

End If

Else

'change existing classes

zPRJ.DynProperties("AlarmClasses[" & i - 1 & "].Name") = "Class_" & i

zPRJ.DynProperties("AlarmClasses[" & i - 1 & "].Color") = RGB(120 + ((i - 1) * 63), 0, 0)

zPRJ.DynProperties("AlarmClasses[" & i - 1 & "].Description") = "created by VBA"

End If
Next i
End Sub


Decompile
ObjectModel COM [image] Project [image] Methods [image] Decompile
Remarks

This method starts an import of the runtime files, depending to given parameter there will be a warning message or not.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bPromptForOverwrite as VARIANT_BOOL

Example
VBA
Copy
Sub DeCompileRTFiles()
'Runtime files will be imported with warning message
MyWorkspace.ActiveDocument.Decompile True
End Sub


Drivers
ObjectModel COM [image] Project [image] Methods [image] Drivers
Remarks

Returns the VBA object for the driver administration. In the driver administration all defined drivers are available. The single driver objects offer important information, e.g. status, driver name, ...

Datatype
IDrivers

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


DynPictures
ObjectModel COM [image] Project [image] Methods [image] DynPictures
Remarks

Returns the VBA object for the defined pictures (*.zp). With the name or the index a picture can be accessed. The different elements DynPicture contain information on the display (position, colour, status, ... ), the linked Frame and a list of the dynamic elements of the picture.

Datatype
IDynPictures

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


DynProperties [GET]
ObjectModel COM [image] Project [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] Project [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] Project [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynPropertyParam [GET]
ObjectModel COM [image] Project [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


FileManager
ObjectModel COM [image] Project [image] Methods [image] FileManager
Remarks

Returns the VBA object for the file manager. With this object graphics, language, help, multimedia, lists, driver and other files can be managed.

Datatype
IFileManager

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Get
ObjectModel COM [image] Project [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Interlockings
ObjectModel COM [image] Project [image] Methods [image] Interlockings
Remarks

Returns the VBA object for the interlockings. With this object you have the opportunity to edit interlockings.

Datatype
IInterlockings

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IsCheckedOut
ObjectModel COM [image] Project [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDifferent
ObjectModel COM [image] Project [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] Project [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


ModulePath [GET]
ObjectModel COM [image] Project [image] Methods [image] ModulePath [GET]
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lModule as tpModulePaths


ModulePath [PUT]
ObjectModel COM [image] Project [image] Methods [image] ModulePath [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lModule as tpModulePaths

szNewValue as BSTR


NetSend
ObjectModel COM [image] Project [image] Methods [image] NetSend
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
NetSendType as tpNetSendType

strDestination as BSTR

lId as long

pvData as VARIANT

Example
VBA
Copy
Sub ServerNetSend()
'Server should send to all clients whith an ID = 99 and data = "This is a test"
Debug.Print thisProject.NetSend(2, "", 99, "This is a test")

End Sub


OnlineVariables
ObjectModel COM [image] Project [image] Methods [image] OnlineVariables
Remarks

Returns the VBA object for the online variables administration. The online variables enable a very performant access on changed variables values. With this object you can create an online variable dynamically and link it with a control system variable. The variable is identified with an unique name. With the method Define of the online variable checking the variable is activated. On initializing/changing a variable, that was linked to the online variable, in VBA a Event is executed. In the event handler you now can react on the changed value.

Datatype
IOnlineVariables

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ParentProject
ObjectModel COM [image] Project [image] Methods [image] ParentProject
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsProjectName as BSTR


Passwords
ObjectModel COM [image] Project [image] Methods [image] Passwords
Remarks

Returns the object of the user administration. This object contains the defined users of the project. You also have the possibility to create new users or edit/delete existing users. Additionally you can use this object to find out the currently logged in user.

Datatype
IPasswords

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Pfs
ObjectModel COM [image] Project [image] Methods [image] Pfs
Remarks

This method returns the PfsEngine object. With this object you have the opportunity to handle the hole production and facility scheduler.

Datatype
IPfsEngine

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Recipes
ObjectModel COM [image] Project [image] Methods [image] Recipes
Remarks

This method returns the recipes object. With this object you have the opportunity to handle standard recipes.

Datatype
IRecipes

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Reload
ObjectModel COM [image] Project [image] Methods [image] Reload
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bMody as VARIANT_BOOL


Remas
ObjectModel COM [image] Project [image] Methods [image] Remas
Remarks

Datatype
IRemas

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


ReplaceLinks
ObjectModel COM [image] Project [image] Methods [image] ReplaceLinks
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsSourcePrjName as BSTR

bsTargetPrjName as BSTR


RGMGroups
ObjectModel COM [image] Project [image] Methods [image] RGMGroups
Remarks

Datatype
IRGMRecipeGroups

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


RtFunctions
ObjectModel COM [image] Project [image] Methods [image] RtFunctions
Remarks

Datatype
IRtFunctions

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


SapFunctions
ObjectModel COM [image] Project [image] Methods [image] SapFunctions
Remarks

Datatype
ISapFunctions

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Scripts
ObjectModel COM [image] Project [image] Methods [image] Scripts
Remarks

Datatype
IScripts

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


SetUserPropertyStrings
ObjectModel COM [image] Project [image] Methods [image] SetUserPropertyStrings
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
strProperty as BSTR

vStrings as VARIANT


String
ObjectModel COM [image] Project [image] Methods [image] String
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strKeyId as BSTR


SystemModelManager
ObjectModel COM [image] Project [image] Methods [image] SystemModelManager
Remarks

Datatype
ISystemModelManager

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Tasks
ObjectModel COM [image] Project [image] Methods [image] Tasks
Remarks

Datatype
ITasks

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Templates
ObjectModel COM [image] Project [image] Methods [image] Templates
Remarks

Datatype
ITemplates

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


TimeFunctions
ObjectModel COM [image] Project [image] Methods [image] TimeFunctions
Remarks

This method returns the list of defined time functions. With this object time functions can be created, edited and deleted.

Datatype
ITimeFunctions

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


UndoCheckOut
ObjectModel COM [image] Project [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


VarAssignments
ObjectModel COM [image] Project [image] Methods [image] VarAssignments
Remarks

This method returns an object for the VarAssignments. The VarAssignments collection contains all existing allocations of the current project. With this collection you can access all or certain allocations.

Datatype
IVarAssignments

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Variables
ObjectModel COM [image] Project [image] Methods [image] Variables
Remarks

This method returns the variables list. The single variables contain on the one hand most of their defined properties, e.g. signal resolution, limits, name, .... and on the other hand Runtime data, e.g. current value, status, ...

Datatype
IVariables

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


VarTypes
ObjectModel COM [image] Project [image] Methods [image] VarTypes
Remarks

This method returns an object for the datatypes. With this object datatypes can be created, edited and deleted.

Datatype
IVarTypes

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


ZenMenus
ObjectModel COM [image] Project [image] Methods [image] ZenMenus
Remarks

This method returns an object for the menus. With this object menus can be created, edited and deleted.

Datatype
IZenMenus

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Events
ObjectModel COM [image] Project [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Active | void |  | Available | Available | Available | Available
FirePostReload | void |  | Unused | Available | Available | Available
FirePreReload | void |  | Unused | Available | Available | Available
Inactive | void |  | Unused | Available | Available | Available
OnMessageSetDestination | void | Fired before a message is send. | Unused | Available | Available | Available
OnNetReceive | void | This event is fired when NetData is received, it contains the Data-Source, an Id and the actual Data | Unused | Available | Available | Available
OnPostVSTAUpdate | void | For internal use only | Unused | Available | Available | Available
OnPreVSTADebugStart | void | For internal use only | Unused | Available | Available | Available
OnPreVSTADebugStop | void | For internal use only | Unused | Available | Available | Available
OnPreVSTAUpdate | void | For internal use only | Unused | Available | Available | Available
OnVSTADebugStart | void | For internal use only | Unused | Available | Available | Available
OnVSTADebugStopped | void | For internal use only | Unused | Available | Available | Available
SbToServer | void |  | Unused | Available | Available | Available
ServerToSb | void |  | Unused | Available | Available | Available


Active
ObjectModel COM [image] Project [image] Events [image] Active
Remarks

This event is executed on activating the project in the Runtime. A project is activated at the following actions: · Starting the Runtime · Reloading · Redundancy update

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


FirePostReload
ObjectModel COM [image] Project [image] Events [image] FirePostReload
Remarks

This action is fired after the FirePreReload on client or standby-server when a reload of the project is started.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


FirePreReload
ObjectModel COM [image] Project [image] Events [image] FirePreReload
Remarks

This action is fired on client or standby-server when a reload of the project is started.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Inactive
ObjectModel COM [image] Project [image] Events [image] Inactive
Remarks

This event is executed on deactivating the project in the Runtime. A project is deactivated at the following actions: · Closing the Runtime · Reloading · Redundancy update

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


OnMessageSetDestination
ObjectModel COM [image] Project [image] Events [image] OnMessageSetDestination
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsDestinationGuid as BSTR

bsDestination as BSTR

Example
VBA
Copy
Private Sub Project_OnMessageSetDestination(ByVal bsDestinationGuid As String, bsDestination As String)
Dim strGuid As String
Dim strNewDestination
strGuid = "cdd44b4a-5951-43bb-a9d9-e0810dfb9bc3"
If bsDestinationGuid = strGuid Then

'Now we change the destination before a message is send!

strNewDestination = ""

bsDestination = strNewDestination
End If
End Sub


OnNetReceive
ObjectModel COM [image] Project [image] Events [image] OnNetReceive
Remarks

This event reacts on receiving a NetSend message.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strSource as BSTR

lId as long

pvData as LPVARIANT

Example
VBA
Copy
'This event will be executed when the client receives the NetSend message
Private Sub Project_OnNetReceive(ByVal strSource As String, ByVal lID As Long,

pvData As Variant)
MsgBox "Source string = " & strSource
MsgBox "lID = " & lID
MsgBox "Data = " & pvData

End Sub


OnPostVSTAUpdate
ObjectModel COM [image] Project [image] Events [image] OnPostVSTAUpdate
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


OnPreVSTADebugStart
ObjectModel COM [image] Project [image] Events [image] OnPreVSTADebugStart
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


OnPreVSTADebugStop
ObjectModel COM [image] Project [image] Events [image] OnPreVSTADebugStop
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


OnPreVSTAUpdate
ObjectModel COM [image] Project [image] Events [image] OnPreVSTAUpdate
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


OnVSTADebugStart
ObjectModel COM [image] Project [image] Events [image] OnVSTADebugStart
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


OnVSTADebugStopped
ObjectModel COM [image] Project [image] Events [image] OnVSTADebugStopped
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


SbToServer
ObjectModel COM [image] Project [image] Events [image] SbToServer
Remarks

This event is executed when the server crashes and so the standby gets server. It is also executed when the server restarts and the standby is downlevelled.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ServerToSb
ObjectModel COM [image] Project [image] Events [image] ServerToSb
Remarks

This event is executed when a standby which has been uplevelled to server is downlevelled to standby again. The event occurs on the standby server.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Projects
ObjectModel COM [image] Projects
Remarks

The collection Projects contains all projects loaded in the Runtime. The single projects of the Runtime are available as objects Project in VBA. It is not possible to create an object of this type with the attribute New.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub GetProjects()
Dim i As Integer
'enumerate all projects
'"Application" instead of "ApplicationED" at runtime!
For i = 0 To ApplicationED.Projects.Count - 1

Debug.Print ApplicationED.Projects.Item(i).Name & _

ApplicationED.Projects.Item(i).DynProperties("GUID")
Next i
End Sub
Sub CreateProject()
'create a new project
ApplicationED.Projects.Create
End Sub


Properties
ObjectModel COM [image] Projects [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Readonly | Available | Available
CountHidden | long | For internal use only | Unused | Unused | Available | Available
Parent | iapplication |  | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] Projects [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


CountHidden
ObjectModel COM [image] Projects [image] Properties [image] CountHidden
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Projects [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IApplication

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Projects [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | variant_bool | Shows the dialog to create a new project and/or workspace. | Available | Unused | Available | Available
CreateEx | variant_bool | Creates a new project without dialog. | Available | Unused | Available | Available
Item | iproject | - | Available | Unused | Available | Available
ItemHidden | iproject | For internal use only | Unused | Unused | Available | Available


Create
ObjectModel COM [image] Projects [image] Methods [image] Create
Remarks

Opens the dialog to create a new project.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CreateEx
ObjectModel COM [image] Projects [image] Methods [image] CreateEx
Remarks

The Projects-Collection has received a new method CreateEx(), in order to generate projects without dialogs:Project name and project basis path can be specified as parameter, in order to define whether it is a global project or a multi user project and in the last case its server name. The new project is basically attached to the open workspace and no error messages or queries will be displayed as dialogs or message boxes.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

bsPath as BSTR

bGlobal as VARIANT_BOOL

bMultiUser as VARIANT_BOOL

bsServer as BSTR

Example
VBA
Copy
Call MyWorkspace.Application.Projects.CreateEx("Hugo", "D:\TEMP\HUGO", False, False, "")


Item
ObjectModel COM [image] Projects [image] Methods [image] Item
Remarks

Returns the object Project from the collection, identified by the parameter vID. The parameter vID can have two values: - Index: The access with the index is often used in combination with the property Count to find an object Project by its position in the list. For „simple“ (not hierarchical) projects the index 0 always is the current project. - Project name: The project can be found by its name.

Datatype
IProject

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vID as VARIANT


ItemHidden
ObjectModel COM [image] Projects [image] Methods [image] ItemHidden
Remarks

Datatype
IProject

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vID as VARIANT


PropParam
ObjectModel COM [image] PropParam
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
public void Macronew()
        {
            zenOn.IPropParam Param = this.ActiveDocument.get_DynPropertyParam("MultitouchMode");
 if (Param.OptionCount > 0)
            {
 for (int i = 0; i < Param.OptionCount; i++)
                {
 this.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);
 this.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);
                }
            }
        }
VB.NET
Copy
Public Sub Macronew()
    Dim Param As zenOn.IPropParam = Me.ActiveDocument.get_DynPropertyParam("MultitouchMode")
    If Param.OptionCount > 0 Then
        For i As Integer = 0 To Param.OptionCount - 1
            Me.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)
            Me.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)
        Next
    End If
End Sub
VBA
Copy
Public Sub VBAMacro()
Dim obparm As PropParam
Dim n As Integer
Set obparm = thisProject.DynPropertyParam("MultitouchMode")
If (Not obparm Is Nothing) Then
 If obparm.OptionCount > 0 Then
 For n = 0 To obparm.OptionCount - 1

 Debug.Print "Option:" & obparm.OptionText(n)

 Debug.Print "Option:" & obparm.OptionValue(n)
 Next
 End If
End If
End Sub


Properties
ObjectModel COM [image] PropParam [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Enabled | variant_bool | Returns whether or not the property is enabled. | Readonly | Readonly | Available | Available
OptionCount | long | Returns the amount of options. | Readonly | Readonly | Available | Available


Enabled
ObjectModel COM [image] PropParam [image] Properties [image] Enabled
Remarks

Returns a value that determines if the property is usable or not.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


OptionCount
ObjectModel COM [image] PropParam [image] Properties [image] OptionCount
Remarks

Returns the amount of available Options, in case there are no Options this value will be: 0.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] PropParam [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
OptionText | bstr | Returns the text of the option at the given index | Readonly | Readonly | Available | Available
OptionValue | variant | Returns the value of the option at the given index | Readonly | Readonly | Available | Available


OptionText
ObjectModel COM [image] PropParam [image] Methods [image] OptionText
Remarks

Returns the text of Option lIndex

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lIndex as long

Example
C#
Copy
public void Macronew()
        {
            zenOn.IPropParam Param = this.ActiveDocument.get_DynPropertyParam("MultitouchMode");
 if (Param.OptionCount > 0)
            {
 for (int i = 0; i < Param.OptionCount; i++)
                {
 this.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);
 this.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);
                }
            }
        }
VB.NET
Copy
Public Sub Macronew()
    Dim Param As zenOn.IPropParam = Me.ActiveDocument.get_DynPropertyParam("MultitouchMode")
    If Param.OptionCount > 0 Then
        For i As Integer = 0 To Param.OptionCount - 1
            Me.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)
            Me.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)
        Next
    End If
End Sub
VBA
Copy
Public Sub VBAMacro()
Dim obparm As PropParam
Dim n As Integer
Set obparm = thisProject.DynPropertyParam("MultitouchMode")
If (Not obparm Is Nothing) Then
 If obparm.OptionCount > 0 Then
 For n = 0 To obparm.OptionCount - 1

 Debug.Print "Option:" & obparm.OptionText(n)

 Debug.Print "Option:" & obparm.OptionValue(n)
 Next
 End If
End If
End Sub


OptionValue
ObjectModel COM [image] PropParam [image] Methods [image] OptionValue
Remarks

Returns the value of Option lIndex.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lIndex as long

Example
C#
Copy
public void Macronew()
        {
            zenOn.IPropParam Param = this.ActiveDocument.get_DynPropertyParam("MultitouchMode");
 if (Param.OptionCount > 0)
            {
 for (int i = 0; i < Param.OptionCount; i++)
                {
 this.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);
 this.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);
                }
            }
        }
VB.NET
Copy
Public Sub Macronew()
    Dim Param As zenOn.IPropParam = Me.ActiveDocument.get_DynPropertyParam("MultitouchMode")
    If Param.OptionCount > 0 Then
        For i As Integer = 0 To Param.OptionCount - 1
            Me.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)
            Me.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)
        Next
    End If
End Sub
VBA
Copy
Public Sub VBAMacro()
Dim obparm As PropParam
Dim n As Integer
Set obparm = thisProject.DynPropertyParam("MultitouchMode")
If (Not obparm Is Nothing) Then
 If obparm.OptionCount > 0 Then
 For n = 0 To obparm.OptionCount - 1

 Debug.Print "Option:" & obparm.OptionText(n)

 Debug.Print "Option:" & obparm.OptionValue(n)
 Next
 End If
End If
End Sub


Recipe
ObjectModel COM [image] Recipe
Remarks

Recipes serve for the assembling of input lists for setpoint values and commands which in online operation are executed with a function call.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub zenOn_Recipe(ByRef zRecipes As Recipes)
'Declarations
Dim zRecipe As recipe
Dim zVariable As Variable
Dim i As Integer
'Initialization of zRecipe with the first element in the "zRecipes" object
Set zRecipe = zRecipes.Item(0)
'Initialization of zVariable with the first element in the "Variables" object
Set zVariable = thisProject.Variables.Item(0)
'Create new "RecipeValue" object
'Assign zVariable with a default value of 50
zRecipe.Create zVariable.PvID, 50
'For every "RecipeValue" object in zRecipe,...
For i = 0 To zRecipe.Count - 1

'... output the name

Debug.Print "Name: " & zRecipe.Item(i).ItemVariable.Name

'and value

Debug.Print "Value: " & zRecipe.Item(i).Value
Next i
'Delete the former created "RecipeValue" object
zRecipe.Delete (zVariable.PvID)

End Sub


Properties
ObjectModel COM [image] Recipe [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Readonly | Available | Available
Name | bstr |  | Available | Available | Available | Available
Parent | irecipes |  | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] Recipe [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] Recipe [image] Properties [image] Name
Remarks

Gets or sets the name of the recipe.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Recipe [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IRecipes

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Recipe [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | irecipevalue | Creates and returns a new Object | Available | Available | Available | Available
Delete | variant_bool | Deletes the objects from collection | Available | Available | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
ExecuteValues | variant_bool | - | Unused | Available | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Available | Available | Available
ExportXML | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
ImportXML | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
Item | irecipevalue | Returns a object at a position or by a specified key | Available | Unused | Available | Available
ReadValues | variant_bool | - | Unused | Available | Available | Available
Save | variant_bool | - | Available | Available | Available | Available


Create
ObjectModel COM [image] Recipe [image] Methods [image] Create
Remarks

Creates a new "RecipeValue" object.

Datatype
IRecipeValue

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
PvID as long

dfValue as double

vProjekt as VARIANT

Example
VBA
Copy
Private Sub CreateRecipeValue(ByRef zRecipe As recipe)
'Declarations
Dim zVariable As Variable
Dim i As Integer
'Initialization of zVariable with the first "Variable" object within the "Variables" object
Set zVariable = thisProject.Variables.Item(0)
'Create new "RecipeValue" object within zRecipe
'zVariable.PvID assigns zVariable to the recipe
'22 will be the default value of zVariable
zRecipe.Create zVariable.PvID, 22
'For every "RecipeValue" object within zRecipe...
For i = 0 To zRecipe.Count - 1

'...output the value

Debug.Print i + 1 & ". value: " & zRecipe.Item(i).Value
Next i

End Sub


Delete
ObjectModel COM [image] Recipe [image] Methods [image] Delete
Remarks

Deletes a "RecipeValue" object from the collection by the PvID of the "Variable" object that was assigned to the "RecipeValue" object.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
PvID as long

vProjekt as VARIANT

Example
VBA
Copy
Private Sub DeleteRecipeValue(ByRef zRecipe As recipe)
'Declarations
Dim zVariable As Variable
Dim i As Integer
'Initialization of zVariable with the variable that is named "zenOn_Test"
Set zVariable = thisProject.Variables.Item("zenOn_Test")
'Deletes the variable "zenOn_Test" from the recipe
zRecipe.Delete zVariable.PvID
'For every "RecipeValue" object within zRecipe...
For i = 0 To zRecipe.Count - 1

'...output the value
Debug.Print i + 1 & ". value: " & zRecipe.Item(i).Value
Next i

End Sub


DynProperties [GET]
ObjectModel COM [image] Recipe [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] Recipe [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] Recipe [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] Recipe [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


ExecuteValues
ObjectModel COM [image] Recipe [image] Methods [image] ExecuteValues
Remarks

Overwrites the current values of the variables in the recipe with the recipe values.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Export
ObjectModel COM [image] Recipe [image] Methods [image] Export
Remarks

Exports the recipe into a textfile.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strFileName as BSTR


ExportXML
ObjectModel COM [image] Recipe [image] Methods [image] ExportXML
Remarks

Export settings to an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


ImportXML
ObjectModel COM [image] Recipe [image] Methods [image] ImportXML
Remarks

Import settings from an xml file. New settings are added, existing settings will be merged.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Item
ObjectModel COM [image] Recipe [image] Methods [image] Item
Remarks

Returns a "RecipeValue"object at a position or by a specified key.

Datatype
IRecipeValue

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vID as VARIANT


ReadValues
ObjectModel COM [image] Recipe [image] Methods [image] ReadValues
Remarks

Reads the current values.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Save
ObjectModel COM [image] Recipe [image] Methods [image] Save
Remarks

Saves the current values as the new recipe values.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


DynProperties
ObjectModel COM [image] Recipe [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Formulation


Formulation
ObjectModel COM [image] Recipe [image] DynProperties [image] Formulation
Overview
External Name | Type | Display Name | Description
PasswordLevel | UInt16 | Authorization level | Authorization groups required to change the recipe in Runtime. A user can only change recipe values (read, manual changing, deleting), if they fulfill the password level. Minimum: 0. Maximum: 127. Default: 0. .
RecipeName | String | Name | Distinct name of the recipe. Default: Recipe_x ( x means a successive number). .
SyncWrite | Bool | Write synchronously | Active: Execution of a function with this recipe is only ended if a positive response comes from the write action or the defined waiting period has expired. In scripts this can make sure, that the following function is not started, before this one is finished. The confirmation can also be evaluated with the status bit WR-SUC .Inactive: Do not wait for the writing confirmation. Default: inaktiv .
SyncWriteTimeout | UInt32 | Timeout [ms] | If synchronous writing has been activated, a timeout can be entered here. If 0 is entered here, the control system calculates the waiting time as follows: 3000+(100*number of data points) Minimum: 0. Maximum: 4294967295. Default: 0. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .


Recipes
ObjectModel COM [image] Recipes
Remarks

This object manages "Recipe" objects.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub zenOn_Recipes()
'Declarations
Dim zWork As Project
Dim zRecipes As Recipes
Dim zRecipe As recipe
Dim zRecipeValue As RecipeValue
Dim zVariable As Variable
'Initialization of zWork with current project
Set zWork = thisProject
'Initialization of zRecipes with the recipe list of the project
Set zRecipes = zWork.Recipes
'Initialization of zRecipe with the new "Recipe" object
Set zRecipe = zRecipes.Create("zenOn_Recipe")
'Initialization of zVariable with the first element in the "Variables" object
Set zVariable = zWork.Variables.Item(0)
'Initialization of zRecipeValue with the new assigned variable.

Default-Value = 5
Set zRecipeValue = zRecipe.Create(zVariable.PvID, 5)
'Deletes the recipe "zenOn_Recipe"
zRecipes.Delete (zRecipe.Name)

End Sub


Properties
ObjectModel COM [image] Recipes [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Readonly | Available | Available
Parent | iproject |  | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] Recipes [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Recipes [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Recipes [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
Create | irecipe | Creates and returns a new Object | Available | Available | Available | Available
Delete | variant_bool | Deletes the objects from collection | Available | Available | Available | Available
ExportXML | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Unused | Available | Available | Available
ImportXML | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
Item | irecipe | Returns a object at a position or by a specified key | Available | Available | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index | Available | Available | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


CheckIn
ObjectModel COM [image] Recipes [image] Methods [image] CheckIn
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckOut
ObjectModel COM [image] Recipes [image] Methods [image] CheckOut
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Create
ObjectModel COM [image] Recipes [image] Methods [image] Create
Remarks

Creates a new "Recipe" object by name as string parameter.

Datatype
IRecipe

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strName as BSTR

Example
VBA
Copy
Sub CreateNewRecipe()
'Declarations
Dim zRecipes As Recipes
Dim zRecipe As recipe
'Initialization of zRecipes with the recipes list of the current project
Set zRecipes = thisProject.Recipes
'Initialization of zRecipe with the new "Recipe" object
Set zRecipe = zRecipes.Create("zenOn_Recipe")

End Sub


Delete
ObjectModel COM [image] Recipes [image] Methods [image] Delete
Remarks

Deletes a "Recipe" object from the collection.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strName as BSTR

Example
VBA
Copy
Sub DeleteRecipe()
'Declarations
Dim zRecipes As Recipes
'Initialization of zRecipes with the recipes list of the current project
Set zRecipes = thisProject.Recipes
'Deletes the recipe with the name "zenOn_Recipe"
zRecipes.Delete ("zenOn_Recipe")
End Sub


ExportXML
ObjectModel COM [image] Recipes [image] Methods [image] ExportXML
Remarks

Export settings to an xml file.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Get
ObjectModel COM [image] Recipes [image] Methods [image] Get
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Import
ObjectModel COM [image] Recipes [image] Methods [image] Import
Remarks

Imports a recipe from a textfile.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strFileName as BSTR


ImportXML
ObjectModel COM [image] Recipes [image] Methods [image] ImportXML
Remarks

Import settings from an xml file. New settings are added, existing settings will be merged.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


IsCheckedOut
ObjectModel COM [image] Recipes [image] Methods [image] IsCheckedOut
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDifferent
ObjectModel COM [image] Recipes [image] Methods [image] IsDifferent
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] Recipes [image] Methods [image] IsLocked
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Item
ObjectModel COM [image] Recipes [image] Methods [image] Item
Remarks

Returns a "Recipe" object at a position or by a specified key.

Datatype
IRecipe

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vID as VARIANT


SingleExport
ObjectModel COM [image] Recipes [image] Methods [image] SingleExport
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR


UndoCheckOut
ObjectModel COM [image] Recipes [image] Methods [image] UndoCheckOut
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


DynProperties
ObjectModel COM [image] Recipes [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Recipes


Recipes
ObjectModel COM [image] Recipes [image] DynProperties [image] Recipes
Overview

External Name

Type

Display Name

Description


RecipeValue
ObjectModel COM [image] RecipeValue
Remarks

The "RecipeValue" object is utilized by the "Recipe" object, in order to define the characteristics.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub zenOn_RecipeValue(ByRef zRecipe As recipe)
'Declarations
Dim zRecipeValue As RecipeValue
Dim zVariable As Variable
'Initialization of zVariable with the first element in the "Variables" object
Set zVariable = thisProject.Variables.Item(0)
'Initialization of zRecipeValue by creating a new "RecipeValue" object
'Assigns zVariable with a default value of 50
Set zRecipeValue = zRecipe.Create(zVariable.PvID, 50)
'Delete the former created "RecipeValue" object
zRecipe.Delete (zVariable.PvID)
End Sub


Properties
ObjectModel COM [image] RecipeValue [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Parent | irecipe |  | Readonly | Readonly | Available | Available
Type | long |  | Readonly | Readonly | Available | Available
Value | double |  | Available | Available | Available | Available


Parent
ObjectModel COM [image] RecipeValue [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IRecipe

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] RecipeValue [image] Properties [image] Type
Remarks

Returns the type of the "RecipeValue" object.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Value
ObjectModel COM [image] RecipeValue [image] Properties [image] Value
Remarks

Gets or sets the value of the "RecipeValue" object.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] RecipeValue [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
ItemVariable | ivariable | - | Available | Available | Available | Available


DynProperties [GET]
ObjectModel COM [image] RecipeValue [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] RecipeValue [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] RecipeValue [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] RecipeValue [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


ItemVariable
ObjectModel COM [image] RecipeValue [image] Methods [image] ItemVariable
Remarks

Gets, sets or modifies the assigend "Variable" object. For further information, please have a look at the "Variable" object part.

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


DynProperties
ObjectModel COM [image] RecipeValue [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Recipe set value


Recipe set value
ObjectModel COM [image] RecipeValue [image] DynProperties [image] Recipe set value
Overview
External Name | Type | Display Name | Description
Maximum | double | Maximum | Maximum
Minimum | double | Minimum | Minimum
SetValue | double | Set value | Set value
VarName | String | Variable | Variable
VarTagName | String | Identification | Identification
VarUnit | String | Measuring unit | Unit


Rema
ObjectModel COM [image] Rema
Remarks

The Reaction Matrices are the most sophisticated way to deal with stati.Here single stati can be evaluated and cause alarms. Basically a status can be treated like a value. As with a value it is also possible with a status to cause certain actions.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub zenOn_CreateAnalogRema()
'*************** Use this code in the editor ***************
'Declaration zRema
Dim zRema As Rema
'Initialize zRema by creating a new analog rema with the name

"zenOn_AnalogRemaExample"
Set zRema = MyWorkspace.ActiveDocument.Remas.Create(tpAnalog,

"zenOn_AnalogRemaExample")
'Create a new state...
zRema.CreateState
'... and intialize the state by handing the rema over to the initialization example for state objects
Call zenOn_SetStateForAnalogRema(zRema)

End Sub
Private Sub zenOn_SetStateForAnalogRema(ByRef zRema As Rema)
'Declaration zState
Dim zState As State
'Intialize zState with the first state inside the passed analog rema
Set zState = zRema.StateItem(1)
'Sets the comparision mode to "greater"
zState.CheckArt = 1
'This definition constitutes the threshold value, where the alarm will be triggered
zState.ReaAlarm = 11
'This definition means that the system will be set back to its normal configuration, when "ReaAlarm" goes below 10 (hysteresis)
zState.Hysterese = 1
'User message that will be displayed when the event occurs
zState.Text = "Limit is reached!"
'Moreover, the first defined function will be called when the event occurs
zState.Function = MyWorkspace.ActiveDocument.RtFunctions.Item(0).ID
'The function will only be executed when the tpBitFkt is set. Additionaly the tpBitAlarm flag is set too.
zState.Status = tpBitFkt Or tpBitAlarm

End Sub


Properties
ObjectModel COM [image] Rema [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
IsAlarm | variant_bool |  | Readonly | Readonly | Available | Available
IsBTB | variant_bool |  | Readonly | Readonly | Available | Available
IsFunction | variant_bool |  | Readonly | Readonly | Available | Available
IsFunctionClient | variant_bool |  | Readonly | Readonly | Available | Available
IsFunctionServer | variant_bool |  | Readonly | Readonly | Available | Available
IsStateBlinking | variant_bool |  | Readonly | Readonly | Available | Available
Name | bstr |  | Available | Readonly | Available | Available
Parent | iremas |  | Readonly | Readonly | Available | Available
StateCount | long |  | Readonly | Readonly | Available | Available
Status | tpstatebit |  | Readonly | Readonly | Available | Available
Type | tprema |  | Readonly | Readonly | Available | Available


IsAlarm
ObjectModel COM [image] Rema [image] Properties [image] IsAlarm
Remarks

At least one status of the reaction matrix is defined as an alarm.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


IsBTB
ObjectModel COM [image] Rema [image] Properties [image] IsBTB
Remarks

At least one status of the reaction matrix is also logged in the Chronologic Event List (CEL).

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


IsFunction
ObjectModel COM [image] Rema [image] Properties [image] IsFunction
Remarks

At least one status of the reaction matrix is linked to a function.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


IsFunctionClient
ObjectModel COM [image] Rema [image] Properties [image] IsFunctionClient
Remarks

At least one status of the reaction matrix is linked to a function that runs on the client.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


IsFunctionServer
ObjectModel COM [image] Rema [image] Properties [image] IsFunctionServer
Remarks

At least one status of the reaction matrix is linked to a function that runs on the server.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


IsStateBlinking
ObjectModel COM [image] Rema [image] Properties [image] IsStateBlinking
Remarks

At least for one status of the reaction matrix the property "flashing" is activated.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] Rema [image] Properties [image] Name
Remarks

Gets or sets the name of the Reaction Matrix.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Rema [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IRemas

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


StateCount
ObjectModel COM [image] Rema [image] Properties [image] StateCount
Remarks

Returns the amount of states within the Reaction Matrix.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Status
ObjectModel COM [image] Rema [image] Properties [image] Status
Remarks

Datatype
tpStateBit

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] Rema [image] Properties [image] Type
Remarks

Datatype
tpRema

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Rema [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateDynProperty | variant_bool | - | Available | Unused | Available | Available
CreateState | istate | - | Available | Unused | Available | Available
DeleteState | void | - | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
GetColor | long | - | Available | Readonly | Available | Available
GetDelayZeit | long | For internal use only | Available | Available | Available | Available
GetStatus | tpstatebit | - | Available | Available | Available | Available
GetText | bstr | - | Available | Available | Available | Available
StateIsAlarm | variant_bool | - | Readonly | Readonly | Available | Available
StateIsBTB | variant_bool | - | Readonly | Readonly | Available | Available
StateIsFunction | variant_bool | - | Readonly | Readonly | Available | Available
StateIsFunctionClient | variant_bool | - | Readonly | Readonly | Available | Available
StateIsFunctionServer | variant_bool | - | Readonly | Readonly | Available | Available
StateIsStateBlinking | variant_bool | - | Readonly | Readonly | Available | Available
StateItem | istate | - | Available | Readonly | Available | Available


CreateDynProperty
ObjectModel COM [image] Rema [image] Methods [image] CreateDynProperty
Remarks

This Method is able to create SubItems of the actual object, the Parameter has to be the Name of the SubItem to be created.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub Base()
Dim zProject As Project
Dim zRema As Rema
Dim bResult As Boolean
'get Project and Rema object
Set zProject = MyWorkspace.ActiveDocument
Set zRema = zProject.Remas.Item("MyRema")
'create SubItem States....
bResult = CreateSubItem(zRema, "State")
If bResult Then

MsgBox "SubItem 'State' was created successfully!"
Else

MsgBox "SubItem 'State' already exists or could not be created!"
End If

End Sub

Function CreateSubItem(zenOnObject As Object, strDynProperty As String) As Boolean
Dim nCount As Integer
'get count of given DynProperty
nCount = zenOnObject.DynProperties(strDynProperty & "[-1]")
If nCount = 0 Then '0 = DynProperty-SubItem not found

'create SubItem with given parameters...

CreateSubItem = zenOnObject.CreateDynProperty(strDynProperty)

Exit Function
End If
CreateSubItem = False
End Function


CreateState
ObjectModel COM [image] Rema [image] Methods [image] CreateState
Remarks

Creates a new state within the Reaction matrix.

Datatype
IState

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


DeleteState
ObjectModel COM [image] Rema [image] Methods [image] DeleteState
Remarks

Deletes an existing state within the Reaction Matrix.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vPos as VARIANT


DynProperties [GET]
ObjectModel COM [image] Rema [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] Rema [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] Rema [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] Rema [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


GetColor
ObjectModel COM [image] Rema [image] Methods [image] GetColor
Remarks

Returns the Color of the corresponding state object.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
iIndex as long


GetDelayZeit
ObjectModel COM [image] Rema [image] Methods [image] GetDelayZeit
Remarks

HIDDEN

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
iIndex as long


GetStatus
ObjectModel COM [image] Rema [image] Methods [image] GetStatus
Remarks

Returns the "Status" flags from the corresponding state object. For further information have a look at the "Status" description in the "State" object part.

Datatype
tpStateBit

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
iIndex as long


GetText
ObjectModel COM [image] Rema [image] Methods [image] GetText
Remarks

Returns the set text that will be displayed, if the defined limit is reached.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
iIndex as long


StateIsAlarm
ObjectModel COM [image] Rema [image] Methods [image] StateIsAlarm
Remarks

Returns TRUE, if inside the "Status" DWORD of the corresponding "State" object the "tpBitAlarm" is set TRUE.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
iIndex as long


StateIsBTB
ObjectModel COM [image] Rema [image] Methods [image] StateIsBTB
Remarks

Returns TRUE, if inside the "Status" DWORD of the corresponding "State" object the "tpBitBtb" is set TRUE.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
iIndex as long


StateIsFunction
ObjectModel COM [image] Rema [image] Methods [image] StateIsFunction
Remarks

Returns TRUE, if inside the "Status" DWORD of the corresponding "State" object the "tpBitFkt" is set TRUE.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
iIndex as long


StateIsFunctionClient
ObjectModel COM [image] Rema [image] Methods [image] StateIsFunctionClient
Remarks

Returns TRUE, if inside the "Status" DWORD of the corresponding "State" object the "tpBitFktClient" is set TRUE.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
iIndex as long


StateIsFunctionServer
ObjectModel COM [image] Rema [image] Methods [image] StateIsFunctionServer
Remarks

Returns TRUE, if inside the "Status" DWORD of the corresponding "State" object the "tpBitFktServer" is set TRUE.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
iIndex as long


StateIsStateBlinking
ObjectModel COM [image] Rema [image] Methods [image] StateIsStateBlinking
Remarks

Returns TRUE, if inside the "Status" DWORD of the corresponding "State" object the "tpBitBlink" is set TRUE.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
iIndex as long


StateItem
ObjectModel COM [image] Rema [image] Methods [image] StateItem
Remarks

Returns a "State" object with the selected state from the Reaction Matrix.

Datatype
IState

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
vPos as VARIANT


Remas
ObjectModel COM [image] Remas
Remarks

This object manages "Rema" objects.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub zenOn_RemasExample()
'Declarations
Dim zRemas As Remas
Dim zBinRema As Rema
Dim zAnaRema As Rema
Dim i As Integer
'Initialization of zRemas
Set zRemas = MyWorkspace.ActiveDocument.Remas
'Intialization of zBinRema by creating a new binary rema
Set zBinRema = zRemas.Create(tpBinaer, "zenOn_BinaryRema")
'Intialization of zAnaRema by creating a new analog rema
Set zAnaRema = zRemas.Create(tpAnalog, "zenOn_AnalogRema")
'Output some details on the remas
For i = 0 To zRemas.Count - 1

'Display name

Debug.Print "Name: " & zRemas.Item(i).Name

'Show type of Reaction Matrix

Select Case zRemas.Item(i).Type

Case Is = 1

Debug.Print "Type: Binary"

Case Is = 2

Debug.Print "Type: Analog"

Case Is = 3

Debug.Print "Type: MultiBinary"

Case Is = 4

Debug.Print "Type: MultiAnalog"

Case Is = 5

Debug.Print "Type: String"

End Select
Next i
'Delete the binary rema by its position
Debug.Print zRemas.Delete(1)
'Delete the analog rema by its name
Debug.Print zRemas.Delete("zenOn_AnalogRema")

End Sub


Properties
ObjectModel COM [image] Remas [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Count of remas | Readonly | Readonly | Available | Available
Parent | iproject | Parent-object | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] Remas [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Remas [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Remas [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
Create | irema | Creates a new rema (unique name) | Available | Unused | Available | Available
Delete | variant_bool | Delete the given rema | Available | Unused | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
Item | irema | Returns the rema on the given position or name | Available | Available | Available | Available
ItemById | irema | Returns the rema with the given id | Available | Available | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index | Available | Unused | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


CheckIn
ObjectModel COM [image] Remas [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckOut
ObjectModel COM [image] Remas [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Create
ObjectModel COM [image] Remas [image] Methods [image] Create
Remarks

Datatype
IRema

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
rID as tpRema

strName as BSTR


Delete
ObjectModel COM [image] Remas [image] Methods [image] Delete
Remarks

Deletes an existing Reaction Matrix by its position or by name.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vID as VARIANT


Export
ObjectModel COM [image] Remas [image] Methods [image] Export
Remarks

Export settings to an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Get
ObjectModel COM [image] Remas [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Import
ObjectModel COM [image] Remas [image] Methods [image] Import
Remarks

Import settings from an xml file. New settings are added, existing settings will not be replaced.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


IsCheckedOut
ObjectModel COM [image] Remas [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDifferent
ObjectModel COM [image] Remas [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] Remas [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Item
ObjectModel COM [image] Remas [image] Methods [image] Item
Remarks

Returns a "Rema" object with the Reaction Matrix at the given position.

Datatype
IRema

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNamePos as VARIANT


ItemById
ObjectModel COM [image] Remas [image] Methods [image] ItemById
Remarks

Returns a "Rema" object with the Reaction Matrix with the given ID.

Datatype
IRema

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vID as VARIANT


SingleExport
ObjectModel COM [image] Remas [image] Methods [image] SingleExport
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR


UndoCheckOut
ObjectModel COM [image] Remas [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


RemoteTransport
ObjectModel COM [image] RemoteTransport
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Private Sub CreateCustomOption()
Dim obRemoteTP As RemoteTransport
Set obRemoteTP = MyWorkspace.ActiveDocument.RemoteTransport
'define basic remote transport settings
obRemoteTP.HidePasswordDialog = True
obRemoteTP.TransportType = tpTCP
obRemoteTP.TcpByIp = False
obRemoteTP.TcpIpName = "COMPUTERNAME"
'create custom options for the remote transport
obRemoteTP.CreateCustom
obRemoteTP.CustomItem(0).Comment = "TEST: Copy - Execute"
obRemoteTP.CustomItem(0).ActionType = tpCopyExecute
obRemoteTP.CustomItem(0).Active = True
obRemoteTP.CustomItem(0).SourcePath = "source"
obRemoteTP.CustomItem(0).TargetPath = "target"
obRemoteTP.CreateCustom
obRemoteTP.CustomItem(1).Comment = "TEST: Copy"
obRemoteTP.CustomItem(1).ActionType = tpCopy
obRemoteTP.CustomItem(1).Active = False
obRemoteTP.CustomItem(1).SourcePath = "source1"
obRemoteTP.CustomItem(1).TargetPath = "target1"
obRemoteTP.CreateCustom
obRemoteTP.CustomItem(2).Comment = "TEST: Copy - Register"
obRemoteTP.CustomItem(2).ActionType = tpCopyRegister
obRemoteTP.CustomItem(2).Active = True
obRemoteTP.CustomItem(2).SourcePath = "source2"
obRemoteTP.CustomItem(2).TargetPath = "target2"
'save the changes...
obRemoteTP.Save
End Sub


Properties
ObjectModel COM [image] RemoteTransport [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CEFolder | bstr | Get/Set the CE folder. | Available | Unused | Available | Available
CustomCount | long | Returns the amount of custom entries. | Available | Unused | Available | Available
HidePasswordDialog | variant_bool | Get/Set whether the password dialog is shown. | Available | Unused | Available | Available
IncludeAdditional | variant_bool | Get/Set whether the Additional folder is to be transported. | Available | Unused | Available | Available
IncludeDrivers | variant_bool | Get/Set whether the Drivers folder is to be transported. | Available | Unused | Available | Available
IncludeGraphics | variant_bool | Get/Set whether the Graphic folder is to be transported. | Available | Unused | Available | Available
IncludeHelp | variant_bool | Get/Set whether the Help folder is to be transported. | Available | Unused | Available | Available
IncludeLists | variant_bool | Get/Set whether the Lists folder is to be transported. | Available | Unused | Available | Available
IncludeMedia | variant_bool | Get/Set whether the Media folder is to be transported. | Available | Unused | Available | Available
IncludeReports | variant_bool | Get/Set whether the Reports folder is to be transported. | Available | Unused | Available | Available
IncludeStraton | variant_bool | Get/Set whether the Straton folder is to be transported. | Available | Unused | Available | Available
Password | bstr | Get/Set the connection password. | Available | Unused | Available | Available
ProjectBase | bstr | Get/Set the project base. | Available | Unused | Available | Available
SerialName | bstr | Get/Set the Serial connection address. | Available | Unused | Available | Available
TcpIpName | bstr | Get/Set the TCP Name. | Available | Unused | Available | Available
TransportType | tpremotetransporttype | Get/Set the connection type. | Available | Unused | Available | Available
UseCEFolderSetting | variant_bool | Get/Set whether the CE folder setting is to be used. | Available | Unused | Available | Available


CEFolder
ObjectModel COM [image] RemoteTransport [image] Properties [image] CEFolder
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CustomCount
ObjectModel COM [image] RemoteTransport [image] Properties [image] CustomCount
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


HidePasswordDialog
ObjectModel COM [image] RemoteTransport [image] Properties [image] HidePasswordDialog
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IncludeAdditional
ObjectModel COM [image] RemoteTransport [image] Properties [image] IncludeAdditional
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IncludeDrivers
ObjectModel COM [image] RemoteTransport [image] Properties [image] IncludeDrivers
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IncludeGraphics
ObjectModel COM [image] RemoteTransport [image] Properties [image] IncludeGraphics
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IncludeHelp
ObjectModel COM [image] RemoteTransport [image] Properties [image] IncludeHelp
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IncludeLists
ObjectModel COM [image] RemoteTransport [image] Properties [image] IncludeLists
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IncludeMedia
ObjectModel COM [image] RemoteTransport [image] Properties [image] IncludeMedia
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IncludeReports
ObjectModel COM [image] RemoteTransport [image] Properties [image] IncludeReports
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IncludeStraton
ObjectModel COM [image] RemoteTransport [image] Properties [image] IncludeStraton
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Password
ObjectModel COM [image] RemoteTransport [image] Properties [image] Password
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


ProjectBase
ObjectModel COM [image] RemoteTransport [image] Properties [image] ProjectBase
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


SerialName
ObjectModel COM [image] RemoteTransport [image] Properties [image] SerialName
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


TcpIpName
ObjectModel COM [image] RemoteTransport [image] Properties [image] TcpIpName
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


TransportType
ObjectModel COM [image] RemoteTransport [image] Properties [image] TransportType
Remarks

Datatype
tpRemoteTransportType

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


UseCEFolderSetting
ObjectModel COM [image] RemoteTransport [image] Properties [image] UseCEFolderSetting
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] RemoteTransport [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Connect | void | Start a remote transport connection. | Available | Unused | Available | Available
CreateCustom | iremotetransportcustom | Adds a new custom entry. | Available | Unused | Available | Available
CustomItem | iremotetransportcustom | Returns the custom entry at the given index. | Available | Unused | Available | Available
DeleteCustom | bool | Deletes the custom entry at the given index. | Available | Unused | Available | Available
DeleteCustomTransportItem | variant_bool |  | Available | Unused | Available | Available
Disconnect | void | Stop the current remote transport connection. | Available | Unused | Available | Available
RebootOS | void | Reboots the remote OS. | Available | Unused | Available | Available
ReloadRT | void | Reload the remote runtime. | Available | Unused | Available | Available
Retrieve | void | Retrieve all. | Available | Unused | Available | Available
Save | bool | Saves current remote transport setting. | Available | Unused | Available | Available
Save2 | variant_bool |  | Available | Unused | Available | Available
SetStartProject | void | Set start project. | Available | Unused | Available | Available
StartRT | void | Start the remote runtime. | Available | Unused | Available | Available
StopRT | void | Stop the remote runtime. | Available | Unused | Available | Available
TransferAll | void | Transfer all. | Available | Unused | Available | Available
TransferChanged | void | Transfer changes. | Available | Unused | Available | Available


Connect
ObjectModel COM [image] RemoteTransport [image] Methods [image] Connect
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CreateCustom
ObjectModel COM [image] RemoteTransport [image] Methods [image] CreateCustom
Remarks

Datatype
IRemoteTransportCustom

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CustomItem
ObjectModel COM [image] RemoteTransport [image] Methods [image] CustomItem
Remarks

Datatype
IRemoteTransportCustom

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lIndex as long


DeleteCustom
ObjectModel COM [image] RemoteTransport [image] Methods [image] DeleteCustom
Remarks

Datatype
BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lIndex as long


DeleteCustomTransportItem
ObjectModel COM [image] RemoteTransport [image] Methods [image] DeleteCustomTransportItem
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
p_index as long


Disconnect
ObjectModel COM [image] RemoteTransport [image] Methods [image] Disconnect
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


RebootOS
ObjectModel COM [image] RemoteTransport [image] Methods [image] RebootOS
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


ReloadRT
ObjectModel COM [image] RemoteTransport [image] Methods [image] ReloadRT
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Retrieve
ObjectModel COM [image] RemoteTransport [image] Methods [image] Retrieve
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Save
ObjectModel COM [image] RemoteTransport [image] Methods [image] Save
Remarks

Datatype
BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Save2
ObjectModel COM [image] RemoteTransport [image] Methods [image] Save2
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


SetStartProject
ObjectModel COM [image] RemoteTransport [image] Methods [image] SetStartProject
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


StartRT
ObjectModel COM [image] RemoteTransport [image] Methods [image] StartRT
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


StopRT
ObjectModel COM [image] RemoteTransport [image] Methods [image] StopRT
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


TransferAll
ObjectModel COM [image] RemoteTransport [image] Methods [image] TransferAll
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


TransferChanged
ObjectModel COM [image] RemoteTransport [image] Methods [image] TransferChanged
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


RemoteTransportCustom
ObjectModel COM [image] RemoteTransportCustom
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Private Sub CreateCustomOption()
Dim obRemoteTP As RemoteTransport
Set obRemoteTP = MyWorkspace.ActiveDocument.RemoteTransport
'define basic remote transport settings
obRemoteTP.HidePasswordDialog = True
obRemoteTP.TransportType = tpTCP
obRemoteTP.TcpByIp = False
obRemoteTP.TcpIpName = "COMPUTERNAME"
'create custom options for the remote transport
obRemoteTP.CreateCustom
obRemoteTP.CustomItem(0).Comment = "TEST: Copy - Execute"
obRemoteTP.CustomItem(0).ActionType = tpCopyExecute
obRemoteTP.CustomItem(0).Active = True
obRemoteTP.CustomItem(0).SourcePath = "source"
obRemoteTP.CustomItem(0).TargetPath = "target"
obRemoteTP.CreateCustom
obRemoteTP.CustomItem(1).Comment = "TEST: Copy"
obRemoteTP.CustomItem(1).ActionType = tpCopy
obRemoteTP.CustomItem(1).Active = False
obRemoteTP.CustomItem(1).SourcePath = "source1"
obRemoteTP.CustomItem(1).TargetPath = "target1"
obRemoteTP.CreateCustom
obRemoteTP.CustomItem(2).Comment = "TEST: Copy - Register"
obRemoteTP.CustomItem(2).ActionType = tpCopyRegister
obRemoteTP.CustomItem(2).Active = True
obRemoteTP.CustomItem(2).SourcePath = "source2"
obRemoteTP.CustomItem(2).TargetPath = "target2"
'save the changes...
obRemoteTP.Save
End Sub


Properties
ObjectModel COM [image] RemoteTransportCustom [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ActionType | tprtcustomaction | Get/Set the action type. | Available | Unused | Available | Available
Active | variant_bool | Activate/deactivate the custom entry. | Available | Unused | Available | Available
Comment | bstr | Get/Set the comment of the custom entry. | Available | Unused | Available | Available
SourcePath | bstr | Get/Set the source path. | Available | Unused | Available | Available
TargetPath | bstr | Get/Set the target path. | Available | Unused | Available | Available


ActionType
ObjectModel COM [image] RemoteTransportCustom [image] Properties [image] ActionType
Remarks

Datatype
tpRTCustomAction

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Active
ObjectModel COM [image] RemoteTransportCustom [image] Properties [image] Active
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Comment
ObjectModel COM [image] RemoteTransportCustom [image] Properties [image] Comment
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


SourcePath
ObjectModel COM [image] RemoteTransportCustom [image] Properties [image] SourcePath
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


TargetPath
ObjectModel COM [image] RemoteTransportCustom [image] Properties [image] TargetPath
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


RGMRecipe
ObjectModel COM [image] RGMRecipe
Remarks

Recipes serve for the assembling of input lists for setpoint values and commands which in online operation are executed with a function call.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub zenOn_RGMRecipe()
'Declarations
Dim zRGM_Recipe As RGMRecipe
'Initialization of zRGM_Recipe with the first recipe within the first recipe group
Set zRGM_Recipe = MyWorkspace.ActiveDocument.RGMGroups.Item(0).RecipeItem(0)
'Modify a Recipe:
Call Modify_RGMRecipe(zRGM_Recipe)
'Write Values from Recipe to variables
Call Write_RGMRecipe(zRGM_Recipe)
'Read from Variables and save as raceipe
Call Read_RGMRecipe(zRGM_Recipe)
End Sub
Sub Modify_RGMRecipe(zRGM_Recipe As RGMRecipe)
'Declarations
Dim i As Integer
For i = 0 To zRGM_Recipe.ValueCount - 1

'Set action type to "Modify spontaneous value"

zRGM_Recipe.ValueItem(i).DynProperties("Type") = 2

'Set value...

zRGM_Recipe.ValueItem(i).DynProperties("Value") = (i + 1) * 25
Next i
'Save the current value to the recipe
zRGM_Recipe.Save
End Sub
Sub Read_RGMRecipe(zRGM_Recipe As RGMRecipe)
'Read the current variable value and output the result
zRGM_Recipe.Read
'Save the current value to the recipe
zRGM_Recipe.Save
End Sub
Sub Write_RGMRecipe(zRGM_Recipe As RGMRecipe)
'Read the current variable value and output the result
zRGM_Recipe.Execute
'Save the current value to the recipe
zRGM_Recipe.Save
End Sub


Properties
ObjectModel COM [image] RGMRecipe [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Name | bstr | The name of the recipe | Available | Available | Available | Available
Number | long | The identification number of the recipe | Available | Available | Available | Available
Parent | irgmrecipegroup | Parent of object | Readonly | Readonly | Available | Available
Status | long | The numeric status value of the recipe | Available | Available | Available | Available
ValueCount | long |  | Readonly | Readonly | Available | Available
Version | long | The version of the recipe | Available | Available | Available | Available


Name
ObjectModel COM [image] RGMRecipe [image] Properties [image] Name
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Number
ObjectModel COM [image] RGMRecipe [image] Properties [image] Number
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] RGMRecipe [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IRGMRecipeGroup

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Status
ObjectModel COM [image] RGMRecipe [image] Properties [image] Status
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


ValueCount
ObjectModel COM [image] RGMRecipe [image] Properties [image] ValueCount
Remarks

Returns the amount of "RGMRecipeValue" objects within the "RGMRecipe" object, i.e. the amount of variables assigned to the recipe.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Version
ObjectModel COM [image] RGMRecipe [image] Properties [image] Version
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] RGMRecipe [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Check | long | Get differences between recipe and actual values | Unused | Available | Available | Available
Duplicate | variant_bool | Duplicate this recipe | Available | Available | Available | Available
DuplicateAsVersion | variant_bool | Duplicate this recipe into a new version | Available | Available | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
Execute | variant_bool | - | Available | Available | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Available | Available | Available
ExportXML | variant_bool | Export the data of this recipe to a xml file for documentation purpose | Unused | Available | Available | Available
Read | variant_bool | - | Available | Available | Available | Available
Save | variant_bool | - | Available | Available | Available | Available
ValueItem | irgmrecipevalue | - | Available | Available | Available | Available


Check
ObjectModel COM [image] RGMRecipe [image] Methods [image] Check
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
pDifferences as LPVARIANT


Duplicate
ObjectModel COM [image] RGMRecipe [image] Methods [image] Duplicate
Remarks

Method to create a duplicate of the actual RGMRecipe. The given string parameter represents the duplicates name. A boolean result will be returned.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsDuplicate as BSTR


DuplicateAsVersion
ObjectModel COM [image] RGMRecipe [image] Methods [image] DuplicateAsVersion
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


DynProperties [GET]
ObjectModel COM [image] RGMRecipe [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] RGMRecipe [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] RGMRecipe [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] RGMRecipe [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Execute
ObjectModel COM [image] RGMRecipe [image] Methods [image] Execute
Remarks

Overwrites the current values of the variables in the recipe with the recipe values.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Export
ObjectModel COM [image] RGMRecipe [image] Methods [image] Export
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR


ExportXML
ObjectModel COM [image] RGMRecipe [image] Methods [image] ExportXML
Remarks

Export the RGMRecipe to an XML File.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
strExportPath as BSTR


Read
ObjectModel COM [image] RGMRecipe [image] Methods [image] Read
Remarks

Reads the current values.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Save
ObjectModel COM [image] RGMRecipe [image] Methods [image] Save
Remarks

Saves the current values as the new recipe values.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


ValueItem
ObjectModel COM [image] RGMRecipe [image] Methods [image] ValueItem
Remarks

Datatype
IRGMRecipeValue

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosOrName as VARIANT


DynProperties
ObjectModel COM [image] RGMRecipe [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Object recipe


Object recipe
ObjectModel COM [image] RGMRecipe [image] DynProperties [image] Object recipe
Overview
External Name | Type | Display Name | Description
Comment1 | String | Comment 1 | Comment line 1 for the current recipe. .
Comment2 | String | Comment 2 | Comment line 2 for the current recipe. .
Comment3 | String | Comment 3 | Comment line 3 for the current recipe. .
Comment4 | String | Comment 4 | Comment line 4 for the current recipe. .
Comment5 | String | Comment 5 | Comment line 5 for the current recipe. .
Comment6 | String | Comment 6 | Comment line 6 for the current recipe. .
Comment7 | String | Comment 7 | Comment line 7 for the current recipe. .
Comment8 | String | Comment 8 | Comment line 8 for the current recipe. .
PWLevel | UInt16 | Authorization level | Selection of authorization level from drop-down list. .
RecipeName | String | Recipe name | Name for recipe. The recipe name must be unique. If you selected binary files for property , the name must only contain alphanumeric characters. .
RecipeNumber | UInt32 | Recipe number | Number of the recipe .
RecipeVersion | UInt32 | Recipe version | Displays the version number of the selected recipe. Display only, cannot be changed. The version number is automatically set by the system. A maximum of 89999 recipe versions can be created. .
Status | UInt16 | Status | Selection of the recipe status from the drop-down list. (Configuration of the status in property / .) The recipe status can be set differently for each . This property can also be changed in the Runtime. .
TimeChange | double | TimeChange | "this property returns the time the recipe was saved last. When editing the recipe via the automation interface, this property must be set manually by the user"
TimeSent | double | TimeSent | for compatibility reasons only
UserChange | String | User for last change | "This property returns the name of the user who has created / modified the recipe. When editing the recipe via the automation interface, this property must be set manually by the user "
UserSent | String | User for last writing | for compatibility reasons only
WriteSync | Bool | Write synchronously | Is set at recipe group for all recipes of this recipe group and can be overwritten at each recipe.Active : When writing a recipe, all control elements are locked in the Recipegroup Manager screen until the driver confirms that all values have been written successfully or the defined has expired.Inactive : The values of the recipe are written without waiting for a confirmation. The control elements can be used again immediately. The confirmation of the driver is done with the status bit WR-SUC , which is set to 1, when values have been written successfully. .
WriteSync_IsLocal | Bool | WriteSync_IsLocal |
WriteTimeout | UInt32 | Timeout [ms] | Is set at recipe group for all recipes of this recipe group and can be overwritten at each recipe.If you activated , you can enter a timeout here. The control elements of the Recipegroup Manager screen can be operated once again after this time at the latest. If, in Timeout , the value 0 is entered, zenon calculates the timeout in the following way: 30000+(100*number of datapoints) .
WriteTimeout_IsLocal | Bool | WriteTimeout_IsLocal |


RGMRecipeGroup
ObjectModel COM [image] RGMRecipeGroup
Remarks

The "RGMRecipeGroup" object manages the "RGMRecipe" collection and the utilized "RGMRecipeVar" variables.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub zenOn_RGMGroup()
'Declarations
Dim zRGM_Group As RGMRecipeGroup
Dim zVariable As Variable
Dim zRGMGroup_Name As String
'Initialization of zRGMGroup_Name with the name of the created group
'zRGMGroup_Name = "zenOn_RGMGroup"
zRGMGroup_Name =

MyWorkspace.ActiveDocument.RGMGroups.CreateGroup("zenOn_RGMGroup").DynProperties("Name")
'Initialization of zRGM_Group with the former created group
Set zRGM_Group = MyWorkspace.ActiveDocument.RGMGroups.Item(zRGMGroup_Name)
'Initialization of zVariable with the first element in the "Variables" object of the current project
Set zVariable = MyWorkspace.ActiveDocument.Variables.Item(0)
'Add variable to the recipe group
zRGM_Group.AddVariable zVariable
'Create a new recipe in the recipe group
zRGM_Group.CreateRecipe ("zenOn_RGMRecipe")
'Output the number of variables and recipes in the group
Debug.Print "Number of variables: " & zRGM_Group.VariableCount
Debug.Print "Number of recipes: " & zRGM_Group.RecipeCount & vbNewLine
'Rename the recipe
zRGM_Group.RenameRecipe "zenOn_RGMRecipe", "zenOn_RGMRecipeRenamed"
'Delete the whole recipe group
zRGM_Group.Parent.DeleteGroup (zRGM_Group.DynProperties("Name"))

End Sub


Properties
ObjectModel COM [image] RGMRecipeGroup [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Name | bstr |  | Available | Available | Available | Available
Parent | irgmrecipegroups | Parent of object | Readonly | Readonly | Available | Available
RecipeCount | long |  | Available | Available | Available | Available
VariableCount | long |  | Available | Available | Available | Available


Name
ObjectModel COM [image] RGMRecipeGroup [image] Properties [image] Name
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] RGMRecipeGroup [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IRGMRecipeGroups

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


RecipeCount
ObjectModel COM [image] RGMRecipeGroup [image] Properties [image] RecipeCount
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


VariableCount
ObjectModel COM [image] RGMRecipeGroup [image] Properties [image] VariableCount
Remarks

Returns the amount of "RGMVar" objects within the collection, i.e. the amount of variables that are assigned.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] RGMRecipeGroup [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AddBulk | variant_bool | Adds a bulk of variables to the RGM | Available | Available | Available | Available
AddVariable | variant_bool | - | Available | Available | Available | Available
CreateRecipe | lpdispatch | - | Available | Available | Available | Available
CreateRecipeVersion | lpdispatch | Creates a new recipe version for the given recipe name | Available | Available | Available | Available
DeleteRecipe | variant_bool | Delete a recipe object by name OR by nummeric index (for name all recipe versions are deleted) | Available | Available | Available | Available
DeleteRecipeVersion | variant_bool | Delete a recipe object by name and version OR by nummeric index (for indexes the version is ignored) | Available | Available | Available | Available
DeleteVariable | variant_bool | - | Available | Available | Available | Available
Duplicate | variant_bool | Duplicate this recipe group | Available | Available | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Available | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Available | Available | Available
ListRecipeInfo | variant | Returns a list containing the name, number, version and status of all recipes in the group. | Available | Available | Available | Available
ListRecipesName | variant | Passes an array with all recipes name of this group | Available | Available | Available | Available
ListRecipeVersions | variant | Passes an array with all versions of a specified recipe | Available | Available | Available | Available
ListVariablesName | variant | List all variable names from this group | Available | Available | Available | Available
RecipeItem | irgmrecipe | Get a recipe object by name OR by nummeric index (for name the lowest version is returned) | Available | Available | Available | Available
RecipeItemVersion | irgmrecipe | Get a recipe object by name and version OR by nummeric index (for indexes the version is ignored) | Available | Available | Available | Available
RenameRecipe | variant_bool | - | Available | Available | Available | Available
ReorderVariables | variant_bool | Reorders the variables in the group | Available | Available | Available | Available
Save | variant_bool | Save the Recipegroup and all Recipegroup Variables | Available | Available | Available | Available
VariableItem | irgmrecipevar | - | Available | Available | Available | Available


AddBulk
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] AddBulk
Remarks

The AddBulk function takes a Stringarray of Variablenames as a parameter and adds all variables from the array to the Recipegroup.If a variable is multiple times in the list or added in different bulks, it will be ignored and no error will occure.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
szVarNames as SAFEARRAY(BSTR)

Example
C#
Copy
thisProject.RGMGroups.Item("zenon").AddBulk(VariablesNames)


AddVariable
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] AddVariable
Remarks

Adds a "Variable" object to the collection.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lpVariable as LPDISPATCH

Example
VBA
Copy
Sub AddRemoveVariable(ByRef zRGMGroup As RGMRecipeGroup)
'Declarations
Dim zVariable As Variable
'Initialization of zVariable with the first element of collection within the "Variables" object
Set zVariable = MyWorkspace.ActiveDocument.Variables.Item(0)
'Add the variable to the recipe group
zRGMGroup.AddVariable zVariable
'Remove the variable from the recipe group by its name
zRGMGroup.DeleteVariable (zVariable.Name)

End Sub


CreateRecipe
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] CreateRecipe
Remarks

Creates a new recipe by its name as a string.

Datatype
LPDISPATCH

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrName as BSTR


CreateRecipeVersion
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] CreateRecipeVersion
Remarks

Creates a new version of a recipe. bstrName The recipe name of a recipe fo which has to be created a new version.Return value The new created recipe version as RGMRecipe.

Datatype
LPDISPATCH

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrName as BSTR

Example
VBA
Copy
Public Sub Macro_Recipes()
Dim zRecipeGroups As RGMRecipeGroups
Dim zRecipeGroup As RGMRecipeGroup
Dim zRecipe As RGMRecipe
Set zRecipeGroups = thisProject.RGMGroups
If zRecipeGroups.count > 0 Then

Set zRecipeGroup = zRecipeGroups.Item(0)

Set zRecipe = zRecipeGroup.CreateRecipeVersion("Recipe_A")

If Not zRecipe Is Nothing Then

Debug.Print ("Created new recipe version")

Debug.Print ("Version: " & zRecipe.Version)

End If
End If
End Sub


DeleteRecipe
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] DeleteRecipe
Remarks

The function for deleting recipes was extended by the parameter nversion. For nVersion, either the recipe version to be deleted is specified or 0 if the whole recipe with all its versions should be deleted.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosOrName as VARIANT


DeleteRecipeVersion
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] DeleteRecipeVersion
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosOrName as VARIANT

nVersion as long


DeleteVariable
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] DeleteVariable
Remarks

Deletes an existing "RGMRecipeVar" object from the collection by its name as string or position.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosOrName as VARIANT


Duplicate
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] Duplicate
Remarks

Method to create a duplicate of the actual RGMRecipeGroup. The given string parameter represents the duplicates name. A boolean result will be returned.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsDuplicate as BSTR


DynProperties [GET]
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Export
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] Export
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Public Sub Macro_ExportRecipeGroup()
Dim zRGMGroups As RGMRecipeGroups
Dim zRGMGroup As RGMRecipeGroup
Dim zFile As String
Dim i As Integer
Set zRGMGroups = thisProject.RGMGroups ' Get all recipe groups
zFile = zRGMGroups.Parent.ModulePath(tpModulePaths.tpPathExport)
For i = 0 To zRGMGroups.count - 1

Set zRGMGroup = zRGMGroups.Item(i) ' Get a recipe group

With zRGMGroup

Debug.Print ("Export: " & .Name & " To '" & zFile & .Name & ".XML'")

If Dir(zFile & .Name & ".XML") <> "" Then 'Check if file exist

Debug.Print ("File exist!")

Else

If zRGMGroups.Item(i).Export(.Name & ".XML") Then ' Export with relative path

Debug.Print ("Exported!")

Else

Debug.Print ("ERROR!")

End If

End If

End With
Set zRGMGroup = Nothing
Next i

End Sub


Import
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] Import
Remarks

Import settings from an xml file. Existing settings will be replaced.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Public Sub Macro_ImportRecipeGroup()
Dim zRGMGroups As RGMRecipeGroups
Dim zRGMGroup As RGMRecipeGroup
Dim zFile As String
Dim i As Integer
Set zRGMGroups = thisProject.RGMGroups 'Get all recipe groups
zFile = zRGMGroups.Parent.ModulePath(tpModulePaths.tpPathExport) & "Group_B.XML"

'RuntimeFolder\Export\Group_B.XML
Debug.Print ("Import: " & zFile)
If Dir(zFile) <> "" Then 'Check if file exist

Debug.Print ("File exist!")

If zRGMGroups.Item("Group_B") Is Nothing Then

Set zRGMGroup = zRGMGroups.CreateGroup("Group_B") 'Create new RGMGroup

If zRGMGroup.Import(zFile) Then 'Import recipes with relative path

Debug.Print ("Imported!")

Else

Debug.Print ("Error!")

End If

Set zRGMGroup = Nothing

End If
End If

End Sub


ListRecipeInfo
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] ListRecipeInfo
Remarks

This methode generates one array with all the following information from all recipes in this group.RecipeName|RecipeNumber|RecipeVersion|RecipeStatusThe seperator is a Pipe |

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub Macro_RecipesList()
Dim zRecipeGroups As RGMRecipeGroups
Dim zRecipeGroup As RGMRecipeGroup
Dim vRecipeList As Variant
Dim i As Integer
Set zRecipeGroups = MyWorkspace.ActiveDocument.RGMGroups
If zRecipeGroups.Count > 0 Then

Set zRecipeGroup = zRecipeGroups.Item(0)

vRecipeList = zRecipeGroup.ListRecipeVersions()

For i = 0 To UBound(vRecipeList)

Debug.Print (vRecipeList(i))

Next i
End If
End Sub


ListRecipesName
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] ListRecipesName
Remarks

Generates an array with all recipe names of this group. Return value An array with all recipe names as variant.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub Macro_RecipesList()
Dim zRecipeGroups As RGMRecipeGroups
Dim zRecipeGroup As RGMRecipeGroup
Dim vRecipeList As Variant
Dim i As Integer
Set zRecipeGroups = MyWorkspace.ActiveDocument.RGMGroups
If zRecipeGroups.Count > 0 Then

Set zRecipeGroup = zRecipeGroups.Item(0)

vRecipeList = zRecipeGroup.ListRecipesName()

For i = 0 To UBound(vRecipeList)

Debug.Print (vRecipeList(i))

Next i
End If
End Sub


ListRecipeVersions
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] ListRecipeVersions
Remarks

Generates an array with all recipe versions of a recipe of this group. bsRecipeName The recipe name of the recipe for which the array has to be created.Return value An array with all recipe version numbers as variant.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsRecipeName as BSTR

Example
VBA
Copy
Public Sub Macro_RecipesVersionList()
Dim zRecipeGroups As RGMRecipeGroups
Dim zRecipeGroup As RGMRecipeGroup
Dim vRecipeList As Variant
Dim i As Integer
Set zRecipeGroups = MyWorkspace.ActiveDocument.RGMGroups
If zRecipeGroups.Count > 0 Then

Set zRecipeGroup = zRecipeGroups.Item(0)

If Not zRecipeGroup.RecipeItem("Recipe_A") Is Nothing Then

Debug.Print ("Show Version of Recipe: " & zRecipeGroup.RecipeItem("Recipe_A").name)

' Get an array of the RecipeVersion

vRecipeList = zRecipeGroup.ListRecipeVersions("Recipe_A")

For i = 0 To UBound(vRecipeList)

Debug.Print ("Version: " & vRecipeList(i))

Next i

End If

Set zRecipeGroup = Nothing
End If
Set zRecipeGroups = Nothing
End Sub


ListVariablesName
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] ListVariablesName
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub Macro_RecipesVariableList()
Dim zRecipeGroups As RGMRecipeGroups
Dim zRecipeGroup As RGMRecipeGroup
Dim vVariableList As Variant
Dim i As Integer
Set zRecipeGroups = MyWorkspace.ActiveDocument.RGMGroups
If zRecipeGroups.Count > 0 Then

Set zRecipeGroup = zRecipeGroups.Item(0)

If Not zRecipeGroup.RecipeItem("Recipe_A") Is Nothing Then

Debug.Print ("Show Version of Recipe: " & zRecipeGroup.RecipeItem("Recipe_A").name)

' Get an array with the variable names

vVariableList = zRecipeGroup.ListVariablesName()

For i = 0 To UBound(vVariableList)

Debug.Print ("Variable name: " & vVariableList(i))

Next i

End If

Set zRecipeGroup = Nothing
End If
Set zRecipeGroups = Nothing
End Sub


RecipeItem
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] RecipeItem
Remarks

The function was extended by the parameter nversion.For nVersion, the desired version number of the recipe is specified. Hint: You can get a list with all possible recipe versions through the method RGMRecipeGroup.ListRecipeVersions.

Datatype
IRGMRecipe

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosOrName as VARIANT


RecipeItemVersion
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] RecipeItemVersion
Remarks

Datatype
IRGMRecipe

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosOrName as VARIANT

nVersion as long


RenameRecipe
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] RenameRecipe
Remarks

Renames a recipe by passing the old and new name as string.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrOldName as BSTR

bstrNewName as BSTR


ReorderVariables
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] ReorderVariables
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNamesInNewOrder as VARIANT

Example
VBA
Copy
Sub Macro_SortVars()
Dim zRecipeGroup As RGMRecipeGroup
Dim sVars1() As String
Dim sVars2() As String
Dim i As Integer
Set zRecipeGroup = MyWorkspace.ActiveDocument.RGMGroups.Item(0)
'Get list of variable names
sVars1 = zRecipeGroup.ListVariablesName
Debug.Print ("Before reorder")
For i = 0 To UBound(sVars1)

Debug.Print (i & ": " & sVars1(i))
Next i
' Move first variable down
ReDim sVars2(UBound(sVars1, 1))
Dim length As Integer
length = UBound(sVars1)
For i = 0 To length

If (i < length) Then

sVars2(i) = sVars1((i + 1)) ' set variable to next index

Else

sVars2(i) = sVars1(0) ' set last variable to first position

End If
Next i
' set new order
Dim b As Boolean
b = zRecipeGroup.ReorderVariables(sVars2)
Debug.Print ("After reorder")
'Get list of variable names
sVars1 = zRecipeGroup.ListVariablesName
For i = 0 To UBound(sVars1)

Debug.Print (i & ": " & sVars1(i))
Next i
End Sub


Save
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] Save
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


VariableItem
ObjectModel COM [image] RGMRecipeGroup [image] Methods [image] VariableItem
Remarks

Returns a "RGMRecipeVar" object from the collection, selected by its name as string or position within the collection.

Datatype
IRGMRecipeVar

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosOrName as VARIANT


DynProperties
ObjectModel COM [image] RGMRecipeGroup [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Object recipes


Object recipes
ObjectModel COM [image] RGMRecipeGroup [image] DynProperties [image] Object recipes
Overview
External Name | Type | Display Name | Description
Feedback_Check_Comment1 | String | Comment 1 | Comment 1 of the recipe checked last.
Feedback_Check_Comment2 | String | Comment 2 | Comment 2 of the recipe checked last.
Feedback_Check_Comment3 | String | Comment 3 | Comment 3 of the recipe checked last.
Feedback_Check_Comment4 | String | Comment 4 | Comment 4 of the recipe checked last.
Feedback_Check_Comment5 | String | Comment 5 | Comment 5 of the recipe checked last.
Feedback_Check_Comment6 | String | Comment 6 | Comment 6 of the recipe checked last.
Feedback_Check_Comment7 | String | Comment 7 | Comment 7 of the recipe checked last.
Feedback_Check_Comment8 | String | Comment 8 | Comment 8 of the recipe checked last.
Feedback_Check_Different | String | Check recipe value - deviation | Deviances at the result of the check of the recipe as text.
Feedback_Check_Name | String | Recipe name | Name of the recipe checked last.
Feedback_Check_Number | String | Recipe number | Number of the recipe checked last.
Feedback_Check_Result | String | Check recipe value - result | Result of the checking of the recipe as numeric value.
Feedback_Check_Rights | String | Authorization level | Authorization level of the last recipe checked.
Feedback_Check_Status_Nr | String | Recipe status number | Status of the last recipe checked as a number.
Feedback_Check_Status_Txt | String | Recipe status text | Status of the recipe checked last. The text has the following format: 1 - @Text This text is written as raw text to the variable. To display the text translated, you must activate property for the display element (dynamic text).
Feedback_Check_Timechange | String | Change time | Time of the last recipe change of the last recipe checked.
Feedback_Check_Userchange | String | Change user | Name of the user who was logged in when the last change was made to the last recipe checked.
Feedback_Check_Version | String | Recipe version | Version of the last recipe checked.
Feedback_Read_Comment1 | String | Comment 1 | Comment 1 of the recipe read last.
Feedback_Read_Comment2 | String | Comment 2 | Comment 2 of the recipe read last.
Feedback_Read_Comment3 | String | Comment 3 | Comment 3 of the recipe read last.
Feedback_Read_Comment4 | String | Comment 4 | Comment 4 of the recipe read last.
Feedback_Read_Comment5 | String | Comment 5 | Comment 5 of the recipe read last.
Feedback_Read_Comment6 | String | Comment 6 | Comment 6 of the recipe read last.
Feedback_Read_Comment7 | String | Comment 7 | Comment 7 of the recipe read last.
Feedback_Read_Comment8 | String | Comment 8 | Comment 8 of the recipe read last.
Feedback_Read_Name | String | Recipe name | Name of the recipe read last.
Feedback_Read_Number | String | Recipe number | Number of the recipe read last.
Feedback_Read_Result | String | Recipe reading complete | Result of the recipe read as numeric value.
Feedback_Read_Rights | String | Authorization level | Level of authorization of the last recipe read.
Feedback_Read_Status_Nr | String | Recipe status number | Status of the last recipe read as a number.
Feedback_Read_Status_Txt | String | Recipe status text | Status of the last recipe read. The text has the following format: 1 - @Text This text is written as raw text to the variable. To display the text translated, you must activate property for the display element (dynamic text).
Feedback_Read_Timechange | String | Change time | Time of the last recipe change of the last recipe read.
Feedback_Read_Userchange | String | Change user | Name of the user who was logged in when the last change was made to the last recipe read.
Feedback_Read_Version | String | Recipe version | Version of the last recipe read.
Feedback_Write_Comment1 | String | Comment 1 | Comment 1 of the recipe written last.
Feedback_Write_Comment2 | String | Comment 2 | Comment 2 of the recipe written last.
Feedback_Write_Comment3 | String | Comment 3 | Comment 3 of the recipe written last.
Feedback_Write_Comment4 | String | Comment 4 | Comment 4 of the recipe written last.
Feedback_Write_Comment5 | String | Comment 5 | Comment 5 of the recipe written last.
Feedback_Write_Comment6 | String | Comment 6 | Comment 6 of the recipe written last.
Feedback_Write_Comment7 | String | Comment 7 | Comment 7 of the recipe written last.
Feedback_Write_Comment8 | String | Comment 8 | Comment 8 of the recipe written last.
Feedback_Write_Name | String | Recipe name | Name of the recipe written last.
Feedback_Write_Number | String | Recipe number | Number of the recipe written last.
Feedback_Write_Result | String | Recipe writing complete | Result of the writing of the recipe as numeric value.
Feedback_Write_Rights | String | Authorization level | Authorization level of the last recipe written.
Feedback_Write_Status_Nr | String | Recipe status number | Status of the last recipe written as a number.
Feedback_Write_Status_Txt | String | Recipe status text | Status of the last recipe written. The text has the following format: 1 - @Text This text is written as raw text to the variable. To display the text translated, you must activate property for the display element (dynamic text).
Feedback_Write_Timechange | String | Change time | Time of the last recipe change of the last recipe written.
Feedback_Write_Userchange | String | Change user | Name of the user who was logged in when the last change was made to the last recipe written.
Feedback_Write_Version | String | Recipe version | Version of the last recipe written.
Feedback_XMLImport_Result | String | Import result | Success of the XML import.
Name | String | Group name | Name of the recipe group.When you set binary files for property , only alphanumeric characters are allowed. .
SystemModelGroup | CD_CMemFile | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
WriteSync | Bool | Write synchronously | Is set at recipe group for all recipes of this recipe group and can be overwritten at each recipe.Active : When writing a recipe, all control elements are locked in the Recipegroup Manager screen until the driver confirms that all values have been written successfully or the defined has expired.Inactive : The values of the recipe are written without waiting for a confirmation. The control elements can be used again immediately. The confirmation of the driver is done with the status bit WR-SUC , which is set to 1, when values have been written successfully. .
WriteTimeout | UInt32 | Timeout [ms] | Is set at recipe group for all recipes of this recipe group and can be overwritten at each recipe.If you activated , you can enter a timeout here. The control elements of the Recipegroup Manager screen can be operated once again after this time at the latest. If, in Timeout , the value 0 is entered, zenon calculates the timeout in the following way: 30000+(100*number of datapoints) .


RGMRecipeGroups
ObjectModel COM [image] RGMRecipeGroups
Remarks

This object manages "RGMRecipeGroup" objects.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub zenOn_RGMGroups()
'Declarations
Dim zRGM_Groups As RGMRecipeGroups
Dim zRGM_Group As RGMRecipeGroup
Dim i As Integer
'Initialize zRGM_Groups with the "RGMGroups" object of the current project
Set zRGM_Groups = MyWorkspace.ActiveDocument.RGMGroups
'Create a new group called "zenOn_RGMGroup"
zRGM_Groups.CreateGroup ("zenOn_RGMGroup")
'Enumerate all recipe groups
For i = 0 To zRGM_Groups.Count - 1

'Assign the current item to zRGM_Group

Set zRGM_Group = zRGM_Groups.Item(i)

'Enumerate the groups

Debug.Print i + 1 & ". Group: "

'Output name of the group

Debug.Print " Name: " & zRGM_Group.DynProperties("Name")

'Output amount of recipes within the collection

Debug.Print " Recipes: " & zRGM_Group.RecipeCount

'Output amount of variables within the collection

Debug.Print " Variables: " & zRGM_Group.VariableCount

'Output a blank line

Debug.Print ""

'If there are recipes available, then output them

If zRGM_Group.RecipeCount > 0 Then

Call GetRecipesOfGroup(zRGM_Group)

End If

'If there are variables available, then output them

If zRGM_Group.VariableCount > 0 Then

Call GetVariablesOfGroup(zRGM_Group)

End If

Next i
'Delete the former created group
zRGM_Groups.DeleteGroup ("zenOn_RGMGroup")
Debug.Print ""
End Sub
Sub GetRecipesOfGroup(myRGMGroup As RGMRecipeGroup)
'Declarations
Dim zRGM_Recipe As RGMRecipe
Dim i As Integer
Debug.Print "Recipes"
'Enumerate all recipes in the group
For i = 0 To myRGMGroup.RecipeCount - 1

'Assign the current recipe item to zRGM_Recipe

Set zRGM_Recipe = myRGMGroup.RecipeItem(i)

'Output the recipe

Debug.Print " Recipe" & i + 1 & ": " & zRGM_Recipe.DynProperties("RecipeName")
Next i
'Output a blank line
Debug.Print ""
End Sub
Sub GetVariablesOfGroup(myRGMGroup As RGMRecipeGroup)
'Declarations
Dim zRGM_Variable As RGMRecipeVar
Dim i As Integer
'Enumerate all variables of the group
Debug.Print "Variables"
For i = 0 To myRGMGroup.VariableCount - 1

'Assign the current variable item to zRGM_Variable

Set zRGM_Variable = myRGMGroup.VariableItem(i)

'Output the variable

Debug.Print " Var" & i + 1 & ": " & zRGM_Variable.Name
Next i
'Output a blank line
Debug.Print ""
End Sub


Properties
ObjectModel COM [image] RGMRecipeGroups [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Readonly | Available | Available
Parent | iproject | Parent of object | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] RGMRecipeGroups [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] RGMRecipeGroups [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] RGMRecipeGroups [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
CreateGroup | irgmrecipegroup | - | Available | Available | Available | Available
DeleteGroup | variant_bool | - | Available | Available | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Available | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
Item | irgmrecipegroup | - | Available | Available | Available | Available
RenameGroup | variant_bool | - | Available | Available | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index | Available | Available | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


CheckIn
ObjectModel COM [image] RGMRecipeGroups [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckOut
ObjectModel COM [image] RGMRecipeGroups [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CreateGroup
ObjectModel COM [image] RGMRecipeGroups [image] Methods [image] CreateGroup
Remarks

Creates a new group by its name as string.

Datatype
IRGMRecipeGroup

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrName as BSTR


DeleteGroup
ObjectModel COM [image] RGMRecipeGroups [image] Methods [image] DeleteGroup
Remarks

Deletes a group by its name as string.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrName as BSTR


Export
ObjectModel COM [image] RGMRecipeGroups [image] Methods [image] Export
Remarks

Export settings to an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Get
ObjectModel COM [image] RGMRecipeGroups [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Import
ObjectModel COM [image] RGMRecipeGroups [image] Methods [image] Import
Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


IsCheckedOut
ObjectModel COM [image] RGMRecipeGroups [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDifferent
ObjectModel COM [image] RGMRecipeGroups [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] RGMRecipeGroups [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Item
ObjectModel COM [image] RGMRecipeGroups [image] Methods [image] Item
Remarks

Returns a "RGMRecipeGroup" object by its name as a string or by its position.

Datatype
IRGMRecipeGroup

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosOrName as VARIANT


RenameGroup
ObjectModel COM [image] RGMRecipeGroups [image] Methods [image] RenameGroup
Remarks

Renames a group by passing the old and new name as string.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bstrOldName as BSTR

bstrNewName as BSTR


SingleExport
ObjectModel COM [image] RGMRecipeGroups [image] Methods [image] SingleExport
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR


UndoCheckOut
ObjectModel COM [image] RGMRecipeGroups [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Events
ObjectModel COM [image] RGMRecipeGroups [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
RecipeCreate | void | A new recipe is going to be created | Available | Available | Available | Available
RecipeCreated | void | A new recipe was created (from the RGM MDI screen). | Unused | Available | Available | Available
RecipeDelete | void | A recipe is going to be deleted | Available | Available | Available | Available
RecipeDuplicate | void | A recipe is going to be created as a duplicate | Available | Available | Available | Available
RecipeDuplicated | void | A recipe was created (from the RGM MDI screen) as a duplicate. | Unused | Available | Available | Available
RecipeImportingByXml | void |  | Available | Available | Available | Available
RecipeRename | void | A recipe is going to be renamed | Available | Available | Available | Available
RecipeXMLImport | void | A recipe is going to be imported from a XML file. | Available | Available | Available | Available
StatusChange | void | A recipe status is going to be changed | Available | Available | Available | Available
VersionCreate | void | A new recipe version is going to be created | Available | Available | Available | Available
VersionCreated | void | A new recipe version was created (from the RGM MDI screen). | Unused | Available | Available | Available
VersionDelete | void | A recipe version is going to be deleted | Available | Available | Available | Available
VersionDuplicate | void | A recipe version is going to be created as a duplicate | Available | Available | Available | Available
VersionDuplicated | void | A recipe version was created (from the RGM MDI screen) as a duplicate | Unused | Available | Available | Available
VersionDuplicatedRead | void | A recipe version was created (from the RGM MDI screen) as a duplicate and read from the PLC | Unused | Available | Available | Available
VersionDuplicateRead | void | A recipe version is going to be created as a duplicate and read | Available | Available | Available | Available


RecipeCreate
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] RecipeCreate
Remarks

Is requested for validation before creating a recipe. obRecipeGroup The concerned recipe group which the recipe is added to. strNewName [ByRef]The recipe name to be assigned.nNewNumber [ByRef]The recipe number to be assigned.bCancel [ByRef]Flag to cancel this action. If true, the action will be canceled.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obRecipeGroup as IRGMRecipeGroup

strNewName as BSTR

nNewNumber as long

bCancel as VARIANT_BOOL


RecipeCreated
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] RecipeCreated
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obRecipe as IRGMRecipe


RecipeDelete
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] RecipeDelete
Remarks

Is requested for validation before deleting a recipe (with all its versions). obRecipe The lowest version of the concerned recipe.bCancel [ByRef]Flag to cancel this action. If true, the action will be canceled.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obRecipe as IRGMRecipe

bCancel as VARIANT_BOOL


RecipeDuplicate
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] RecipeDuplicate
Remarks

Is requested for validation before duplicating (save recipe under) a recipe.obRecipeGroup The concerned recipe group which the recipe is added to. strNewName [ByRef]The recipe name to be assigned. nNewNumber [ByRef]The recipe number to be assigned.bCancel [ByRef]Flag to cancel this action. If true, the action will be canceled.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obRecipeGroup as IRGMRecipeGroup

strNewName as BSTR

nNewNumber as long

bCancel as VARIANT_BOOL


RecipeDuplicated
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] RecipeDuplicated
Remarks

Is requested after duplicating a recipe.obRecipe [ByRef] The new created recipe.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obRecipe as IRGMRecipe


RecipeImportingByXml
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] RecipeImportingByXml
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_eventTopic as tpRGMRecipeImport

p_recipeGroup as IRGMRecipeGroup

p_recipeName as BSTR

p_recipeVersion as long

p_cancelStyle as RGMRecipeImportCancelStyle


RecipeRename
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] RecipeRename
Remarks

Is requested for validation before renaming a recipe. obRecipe The lowest version of the concerned recipe.strNewName [ByRef]The new recipe name.bCancel [ByRef]Flag to cancel this action. If true, the action will be canceled.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obRecipe as IRGMRecipe

strNewName as BSTR

bCancel as VARIANT_BOOL


RecipeXMLImport
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] RecipeXMLImport
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
nEventTopic as tpRGMRecipeImport

obRecipeGroup as IRGMRecipeGroup

strRecipeName as BSTR

nRecipeVersion as long

lCancel as long

Example
VBA
Copy
Dim WithEvents zRGMRecipeGroups As RGMRecipeGroups
Private Sub Project_Active()
Set zRGMRecipeGroups = thisProject.RGMGroups
End Sub
Public Sub zRGMRecipeGroups_RecipeXMLImport(ByVal nEventTopic As tpRGMRecipeImport, _
ByVal obRecipeGroup As IRGMRecipeGroup, _
ByVal strRecipeName As String, _
ByVal nRecipeVersion As Long, _
lCancel As Long)
Select Case nEventTopic

Case tpRGMRecipeImport.tpOverwriteRecipe

Debug.Print ("Overwrite recipe: " & tpRGMRecipeImport.tpOverwriteRecipe)

Case tpRGMRecipeImport.tpCreateNewRecipe

Debug.Print ("Create new recipe: " & tpRGMRecipeImport.tpCreateNewRecipe)

Case tpRGMRecipeImport.tpValuesDiffer

Debug.Print ("Values differ: " & tpRGMRecipeImport.tpValuesDiffer)
End Select
Debug.Print ("=======================================")
Debug.Print ("Recipe Group: " & obRecipeGroup.Name)
Debug.Print ("Recipe Name: " & strRecipeName)
Debug.Print ("Recipe Count: " & obRecipeGroup.RecipeCount)
Debug.Print ("Recipe Version: " & nRecipeVersion)
If (obRecipeGroup.RecipeCount = 1) Then

'Continue import

lCancel = 0
ElseIf (obRecipeGroup.RecipeCount = 2) Then

'Cancel the import for the current recipe and proceed with the next recipe.

lCancel = 1
ElseIf obRecipeGroup.RecipeCount > 2 Then

'Cancel the import for the current recipe and proceed with the next recipegroup

lCancel = 2
End If
End Sub


StatusChange
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] StatusChange
Remarks

Is requested before changing the status. obRecipe The concerned recipe.nStatusNew [ByRef]The wanted status in the way how the operater would like to change it. bCancel [ByRef]Flag to cancel this action. If true, the action will be canceled.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obRecipe as IRGMRecipe

nStatusNew as long

bCancel as VARIANT_BOOL


VersionCreate
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] VersionCreate
Remarks

Is requested for validation before creating a recipe version.obRecipeGroup The concerned recipe group which the recipe is added to. strNewName The recipe name.nNewNumber [ByRef]The recipe number to be assigned. bCancel [ByRef]Flag to cancel this action. If true, the action will be canceled.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obRecipeGroup as IRGMRecipeGroup

strName as BSTR

nNewNumber as long

bCancel as VARIANT_BOOL


VersionCreated
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] VersionCreated
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obRecipe as IRGMRecipe


VersionDelete
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] VersionDelete
Remarks

Is requested for validation before deleting a recipe version. obRecipe The recipe version to be deleted. bCancel [ByRef]Flag to cancel this action. If true, the action is canceled.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obRecipe as IRGMRecipe

bCancel as VARIANT_BOOL


VersionDuplicate
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] VersionDuplicate
Remarks

Wird zur Validierung vor dem Anlegen der Rezeptversion beim Duplizieren aufgerufen.obRecipeGroup Die betroffene Rezeptgruppe zu welcher das Rezept hinzugefügt wird.strNewName Der Rezeptname.nNewNumber [ByRef]Die zu vergebende Rezeptnummer.bCancel [ByRef]Das Flag um diese Aktion abzubrechen. Bei True wird die Aktion abgebrochen.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obRecipeGroup as IRGMRecipeGroup

strName as BSTR

nNewNumber as long

bCancel as VARIANT_BOOL


VersionDuplicated
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] VersionDuplicated
Remarks

Is requested after duplicating a recipe version. obRecipe [ByRef]The new recipe version which has been created.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obRecipe as IRGMRecipe


VersionDuplicatedRead
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] VersionDuplicatedRead
Remarks

Is requested after „duplicate and read" of a recipe version.obRecipe [ByRef]The recipe version which has been created new.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obRecipe as IRGMRecipe


VersionDuplicateRead
ObjectModel COM [image] RGMRecipeGroups [image] Events [image] VersionDuplicateRead
Remarks

It is requested for validation before creating a recipe version on "duplicate and read". obRecipeGroup The concerned recipe group which the recipe is added to. strNewName The recipe name.nNewNumber [ByRef]The recipe number to be assigned.bCancel [ByRef]The Flag to cancel the action. If true, the action will be canceled.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obRecipeGroup as IRGMRecipeGroup

strName as BSTR

nNewNumber as long

bCancel as VARIANT_BOOL


DynProperties
ObjectModel COM [image] RGMRecipeGroups [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Base recipes


Base recipes
ObjectModel COM [image] RGMRecipeGroups [image] DynProperties [image] Base recipes
Overview
External Name | Type | Display Name | Description
BackColorInterlockedParameter | UInt32 | Background color for locked recipe parameters | Selection of the background color for interlocked recipe parameters. Default: Grey (#D3D3D3 ) .
BackColorInvalidPLC | UInt32 | Background color for invalid PLC values | Selection of the background color for invalid PLC values. Default: blue (#3D6894 ) .
BackColorInvalidValue | UInt32 | Background color for invalid recipe values | Selection of the background color for cells with invalid values. This highlights parameters that are outside the defined minimum/maximum value or whose action relates to a variable that is not present or cannot be accessed. Default: red (#DD4814 ) .
BackColorMatchPLC | UInt32 | Background color if recipe value is equal to PLC value | Selection of the background color for corresponding values. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.Default: green (#96BD33 ) .
BackColorNoMatchPLC | UInt32 | Background color if recipe value is different to PLC value | Selection of the background color for different PLC values. Default: red (#DD4814 ) .
BoolKbd | String | Binary tags | Selection of a keyboard for binary inputs. Clicking on the ... button opens the dialog to select a keyboard screen. .
NumKbd | String | Numeric tags | Selection of a keyboard for numerical inputs. Clicking on the ... button opens the dialog to select a keyboard screen. .
StatusList | CD_CMemFile | Identifier recipe status | Configuration of the status identifier. Click on property in order to open the configuration dialog. A list of the states is used at the status selection in the recipe. .
StringKbd | String | String tags | Selection of a keyboard for string inputs. Clicking on the ... button opens the dialog to select a keyboard screen. .
TextColorInterlockedParameter | UInt32 | Text color for interlocked recipe parameters | Selection of the text color for interlocked recipe parameters. Default: Black (#000000 ) .
TextColorInvalidPLC | UInt32 | Text color for invalid PLC values | Selection of the text color for invalid PLC values. Default: White (#FFFFFF ) .
TextColorInvalidValue | UInt32 | Text color for invalid recipe values | Selection of the text color for cells with invalid values. This highlights parameters that are outside the defined minimum/maximum value or whose action relates to a variable that is not present or cannot be accessed. Default: White (#FFFFFF ) .
TextColorMatchPLC | UInt32 | Text color if recipe value is equal to PLC value | Selection of the text color for corresponding values. Default: White (#FFFFFF ) .
TextColorNoMatchPLC | UInt32 | Text color if recipe value is different to PLC value | Selection of the text color for different PLC values. Default: White (#FFFFFF ) .
WriteInvalidRecipes | Bool | Invalid recipes writeable via function | Defines whether recipes where recipe values are outside the valid range of values can be written to using the Recipegroup Manager function.Active : Invalid recipes can be written.Inactive : Invalid recipes cannot be written.Default: Inactive .


RGMRecipeValue
ObjectModel COM [image] RGMRecipeValue
Remarks

The "RGMRecipeValue" object is utilized by the "RGMRecipe" object, in order to define the characteristics.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub GetValuesOfRecipe(myRGMRecipe As RGMRecipe)
'Declarations
Dim zRGM_Value As RGMRecipeValue
Dim i As Integer
'enum all values of the recipe
For i = 0 To myRGMRecipe.ValueCount - 1

Set zRGM_Value = myRGMRecipe.ValueItem(i)

Debug.Print "Value: " & zRGM_Value.VarName & " = " &
zRGM_Value.DynProperties("Value")
Next i

End Sub


Properties
ObjectModel COM [image] RGMRecipeValue [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Parent | irgmrecipe | Parent of object | Readonly | Readonly | Available | Available
VarName | bstr | Name of the Variable | Readonly | Readonly | Available | Available


Parent
ObjectModel COM [image] RGMRecipeValue [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IRGMRecipe

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


VarName
ObjectModel COM [image] RGMRecipeValue [image] Properties [image] VarName
Remarks

Returns the name of the assigned variable.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] RGMRecipeValue [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available


DynProperties [GET]
ObjectModel COM [image] RGMRecipeValue [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] RGMRecipeValue [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] RGMRecipeValue [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] RGMRecipeValue [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties
ObjectModel COM [image] RGMRecipeValue [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Object value


Object value
ObjectModel COM [image] RGMRecipeValue [image] DynProperties [image] Object value
Overview
External Name | Type | Display Name | Description
Offset | Int32 | Offset | "This property returns the offset for variables with an old-style array. It returns ""-1"" when a normal variable is used. ""0"" is the first element in the old style array."
SourceOffset | Int32 | SourceOffset | "this property returns the index of the old array when ""link with PV"" is used and the source variable has an old-style array. It returns ""-1"" in normal cases, where the source variable is a normal variable."
SourceVar | CProjektVariable | SourceVar | "This property returns the variable which is linked to the recipe variable when action type ""Link to PV"" is used."
StringValue | String | StringValue | "This property returns the project string when action type ""user status"" is used."
Type | UInt32 | Action | This property defines the action type on a recipe variable.
Value | double | Value or variable | "This property returns the projected value when action type: ""Modify spontaneous value"", ""Switch to and modify spontaneous value"", ""modify substitute value"" or Switch to and modify alternate value is projected."
Variable | CProjektVariable | Variable | This property returns the recipe variable.
ZValue | double | Variable name | This property returns the recipe variable.


RGMRecipeVar
ObjectModel COM [image] RGMRecipeVar
Remarks

This object is utilized by the "RGMRecipeGroup" object, in order to define which Variable is assigned to it.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub GetVariablesOfGroup(myRGMGroup As RGMRecipeGroup)
'Declarations
Dim zRGM_Variable As RGMRecipeVar
Dim i As Integer
'enum all variables of the group
For i = 0 To myRGMGroup.VariableCount - 1

Set zRGM_Variable = myRGMGroup.VariableItem(i)

Debug.Print "Variable: " & zRGM_Variable.Name
Next i

End Sub


Properties
ObjectModel COM [image] RGMRecipeVar [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Name | bstr | Name of the Variable | Readonly | Readonly | Available | Available
Parent | irgmrecipegroup | Parent of object | Readonly | Readonly | Available | Available


Name
ObjectModel COM [image] RGMRecipeVar [image] Properties [image] Name
Remarks

Returns the name of the assigned variable.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] RGMRecipeVar [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IRGMRecipeGroup

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] RGMRecipeVar [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available


DynProperties [GET]
ObjectModel COM [image] RGMRecipeVar [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] RGMRecipeVar [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] RGMRecipeVar [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] RGMRecipeVar [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties
ObjectModel COM [image] RGMRecipeVar [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Object channell


Object channell
ObjectModel COM [image] RGMRecipeVar [image] DynProperties [image] Object channell
Overview
External Name | Type | Display Name | Description
Filter | String | Filter | Input of filter texts for variables.Maximum: 65535 characters .
Interlocking | String | Interlocking | Allocation of an interlocking to a variable. Select from drop-down list. .
Keyboard | String | Screen Keyboard | Link of a screen of type keyboard which should be called up via a left click on the variable in order to enter a value in the Runtime. A click on the button opens the selection dialog. .
Max | double | max. value | Maximum value of the variable. Only available if property was not activated. .
Min | double | min. value | Minimum value of the variable. Only available if property was not activated. .
Offset | Int32 | Offset | "This property returns the offset for variables with an old-style array. It returns ""-1"" when a normal variable is used. ""0"" is the first element in the old style array."
RangeFromVar | Bool | Take set value limits from variable | Active : The set value limits are fetched dynamically from the variable and are not fixedly defined in the recipe group. .
RequireSignatureRGM | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
ShadowVariable | CProjektVariable | Graphic recipe variable | Graphic recipe variables make it possible to change an RGM recipe value via a screen in Runtime. A graphic recipe variable can be defined for each variable in a recipe group. In Runtime, the RGM variable is replaced by a graphic recipe variable using the function with the help of the Write recipe value to shadow variable action and written back after a change to the RGM with the help of the Write shadow variable to recipe value action.Click the button and a dialog opens to select the shadow variable. Each graphic recipe variable can be only used once per recipe group. .
SignatureEditableRGM | UInt32 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureTextRGM | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
Variable | CProjektVariable | Variable name | This property returns the recipe variable.
VisibilityVar | CProjektVariable | Visibility variable | Select a variable in order to control the visibility. A click on the ... button opens the selection dialog. .


RtFunction
ObjectModel COM [image] RtFunction
Remarks

This object is a zenOn function and contains the most important information about the function.A function can be accessed by a unique name, that has to be defined for it, or you can run through all functions by its index.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
'########################################################################'
'# Procedure to change the properties of a function with replacing... #'
'# -------------------------------------------------------------------- #'
'# In the picture to show there are several linked variables, #'
'# beginning with 'Dummy/Dummy' this string will be replaced with the #'
'# given parameter 'strDest' and the function will be executed. #'
'########################################################################'
Sub ChangeFunction(strName As String, strDest As String)
Dim zFCT As RtFunction
Dim strTemp As String
Dim i As Integer
Set zFCT = thisProject.RtFunctions.Item(strName)
If zFCT Is Nothing Then

MsgBox "A function called: " & strName & " is missing!"

Exit Sub
End If
With zFCT

For i = 0 To CLng(.DynProperties("PictSwitch.SubstiVar")) - 1

strTemp = .DynProperties("PictSwitch.SubstiVar[" & i & "].Source")

strTemp = Replace(strTemp, "Dummy/Dummy", strDest)

.DynProperties("PictSwitch.SubstiVar[" & i & "].Destination") = strTemp

Next i

For i = 0 To CLng(.DynProperties("PictSwitch.SubstiFkt")) - 1

strTemp = .DynProperties("PictSwitch.SubstiFkt[" & i & "].Source")

strTemp = Replace(strTemp, "Dummy/Dummy", strDest)

.DynProperties("PictSwitch.SubstiFkt[" & i & "].Destination") = strTemp

Next i
End With
End Sub


Properties
ObjectModel COM [image] RtFunction [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Actual | variant_bool |  | Available | Readonly | Available | Available
Client | variant_bool |  | Available | Readonly | Available | Available
ID | long |  | Readonly | Readonly | Available | Available
Name | bstr |  | Available | Readonly | Available | Available
ParamString | bstr |  | Readonly | Readonly | Available | Available
Parent | irtfunctions |  | Readonly | Readonly | Available | Available
Server | variant_bool |  | Available | Readonly | Available | Available
StandBy | variant_bool |  | Available | Readonly | Available | Available
Type | long |  | Readonly | Readonly | Available | Available


Actual
ObjectModel COM [image] RtFunction [image] Properties [image] Actual
Remarks

The function will be executed on the PC on which it was started. Only available in network projects!

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Client
ObjectModel COM [image] RtFunction [image] Properties [image] Client
Remarks

The function will be executed on all clients of the project. Only available in network projects!

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ID
ObjectModel COM [image] RtFunction [image] Properties [image] ID
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] RtFunction [image] Properties [image] Name
Remarks

This property returns the name to identify the function. This name can be (but may not in earlier version) defined in the Editor on creating the function. The user has to define the name explicitely. This name has to be unique.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ParamString
ObjectModel COM [image] RtFunction [image] Properties [image] ParamString
Remarks

Returns the string wich is shown in the editor.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] RtFunction [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IRtFunctions

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Server
ObjectModel COM [image] RtFunction [image] Properties [image] Server
Remarks

The function will be executed on the server of the project. Only available in network projects!

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


StandBy
ObjectModel COM [image] RtFunction [image] Properties [image] StandBy
Remarks

The function will be executed on the standby server of the project. Only available in network projects!

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] RtFunction [image] Properties [image] Type
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] RtFunction [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
Copy | variant_bool | - | Available | Unused | Available | Available
CreateDynProperty | variant_bool | - | Available | Available | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
Parameter | variant_bool | - | Available | Unused | Available | Available
Start | variant_bool | - | Unused | Available | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


CheckIn
ObjectModel COM [image] RtFunction [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckOut
ObjectModel COM [image] RtFunction [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Copy
ObjectModel COM [image] RtFunction [image] Methods [image] Copy
Remarks

Copies the settings of an existing function to the function object.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
pSource as IRtFunction

Example
VBA
Copy
Sub CopyFunction()
Dim zFct As RtFunction
Dim zFctCopy As RtFunction
'get existing function
Set zFct = MyWorkspace.ActiveDocument.RtFunctions.Item("picSTART")
'create new function
Set zFctCopy = MyWorkspace.ActiveDocument.RtFunctions.Create("TESTING", tpPicture)
'copy existing function settings to new one...
Debug.Print zFctCopy.Copy(zFct)
End Sub


CreateDynProperty
ObjectModel COM [image] RtFunction [image] Methods [image] CreateDynProperty
Remarks

A new Subitem of the Function (i.e. Filter settings) can be created.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
'Create Function for TREND - PICTURE
Sub TrendFunction()
Dim zFCT As RtFunction
Dim i As Integer
'Get function
Set zFCT = MyWorkspace.ActiveDocument.RtFunctions.Item("picTREND")
'function settings...
With zFCT

'check amount of 'PictFilter' subitems (normaly 1)

i = .DynProperties("PictFilter[-1]")

'if 0 (not exists) then create it...

If i = 0 Then .CreateDynProperty "PictFilter"

'change some settings

.DynProperties("PictFilter[0].RefreshRate") = 1

'enum CURVES

For i = 0 To CInt(.DynProperties("PictFilter[0].Curve[-1]")) - 1

'print curve settings

Debug.Print .DynProperties("PictFilter[0].Curve[" & i & "].GraphName")

Debug.Print .DynProperties("PictFilter[0].Curve[" & i & "].VarInfo.VarName")

Debug.Print .DynProperties("PictFilter[0].Curve[" & i & "].YAxe.Scale.ScaleTop")

Debug.Print .DynProperties("PictFilter[0].Curve[" & i & "].YAxe.Scale.ScaleBotton")

Next i
End With
End Sub


DynProperties [GET]
ObjectModel COM [image] RtFunction [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] RtFunction [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] RtFunction [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] RtFunction [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Get
ObjectModel COM [image] RtFunction [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IsCheckedOut
ObjectModel COM [image] RtFunction [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDifferent
ObjectModel COM [image] RtFunction [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] RtFunction [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Parameter
ObjectModel COM [image] RtFunction [image] Methods [image] Parameter
Remarks

Opens the dialog in the editor to configure the actual function.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Start
ObjectModel COM [image] RtFunction [image] Methods [image] Start
Remarks

This method executes the function with its defined parameters (also the parameter 'with filter dialog'). The parameters cannot be changed with VBA.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


UndoCheckOut
ObjectModel COM [image] RtFunction [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


DynProperties
ObjectModel COM [image] RtFunction [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Alarmgroup connection
Alarming
Alarms flashing'
Alarms Groups Classes
Analyzer report function
Assign screen monitor
Authorization in network
Base function
Batch command function state
Batch create function
Batch recipe export
Batch recipe import
Batchmanager release function
Call SAP function
Center screen
Check maintanances
Client simulatio'
Command sequence export function
Command sequence function
Command sequence import function
Create IPA document
Driver commands
Earth fault topology
EMS
Execute addin wizard function
Export alarms
Export archive
Export data function
Fault location
File operations
Focus set
Graph7 Heuristics
Index archive
Language change
License information function
List of active archives
Login without password
Manage addin service function
MtConcurrentExecutionFunction
Open help
Overview window function
PFS event
Play sound file
Playback mode function
Print a hard copy function
Print actual values function
Print alarm or CEL list
Print report function
Print trend
Read dBase file
Read Write time variable
Recipegroup
Recipegroup manager
Reload
Report execute
Runtime profiles
SAT command activation
Save remanent data
Screen return
Screen switch function
Screen with index
Script execute select online
Send message
Send value to hardware
Sequence teaching function
Setpoint
Shedding load topology
Show menu
Simulation image
SQL export function
Standard recipe
Start SEA
Suppress message function
Switch net redundancy
Switch online printer
Switch palette
Toggle online printing
Unit switch
VBA execute macro
VSTA execute macro


Alarmgroup connection
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarmgroup connection
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
GroupName | String | GroupName | With this property you have the opportunity to get/set the alarm group.
GroupNr | Int16 | GroupNr | With this property you have the opportunity to get/set the alarm group via an index.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsAdvise | Bool | IsAdvise | With this property you have the opportunity to activate/deactivate the alarm group connection.
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Alarming
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarming
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
Filter | Node | Filter | Node
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CD_CAmlCelFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarming [image] CD_CAmlCelFilter
Overview
External Name | Type | Display Name | Description
Areas | String | Areas |
Classes | String | Classes | "Filters for alarm classes, where system messages are marked out, as they are not linked to a variable. Multiple class numbers have to be seperated with a semicolon. zFct.DynProperties(""PictFilter.Classes"") = ""1;2;"""
EditableInRT | Bool | EditableInRT | Description as text.
EntriesCount | UInt16 | EntriesCount | "Specifies the maximum amount of entries that should be filtered from a file. Hint: Only available, if the DynProperty ""IsFromFiles"" is set TRUE."
FileName | String | FileName | With this property you get/set the file name for the different export mechanism.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
FilterTitel | String | FilterTitel | "Filters for the identifictaion of variables, where system messages are masked out, as they are not linked to a variable. Wildcards can be used here. Default = ""*"""
Font | UInt16 | Font | "Specifies the font that should be used. The parameter that is passed, is the index of the font within the specified font list. 0 = Standard font 1 = Default font 1 ... 5 = Default font 5 6 = User specified font 1 ... = etc. "
Groups | String | Groups | "Filters for alarm groups, where system messages are marked out, as they are not linked to a variable. Multiple group numbers have to be seperated with a semicolon. zFct.DynProperties(""PictFilter.Groups"") = ""1;2;"""
IncTime | UInt32 | IncTime | "Gets or sets the minimal time for current alarms in seconds. Hint: Milliseconds can be specified with the ""mSeconds"" DynProperty."
IsAcknowledged | Bool | IsAcknowledged | "Filters unacknowledged alarms, if set TRUE."
IsAML | Bool | IsAML | "Prints the alarm list, if set TRUE. Otherwise the CEL list will be printed."
IsAscentOnly | Bool | IsAscentOnly | "Prints only current alarms, if set TRUE."
IsAutoName | Bool | IsAutoName |
IsDBASE | Bool | IsDBASE |
IsFilterExp | Bool | IsFilterExp | "Opens the list stopped, if set TRUE. "
IsFilterRT | Bool | IsFilterRT | "Displays the configuration dialog within the runtime, if set TRUE."
IsFromFiles | Bool | IsFromFiles | "Filter is applied to file entries, if set TRUE. Otherwise, the filter is applied to the entries from the memory. Hint: The maximum amount of entries which should be filtered from the file is specified by the ""EntriesCount"" DynProperty."
IsGoneOnly | Bool | IsGoneOnly |
IsIncremental | Bool | IsIncremental |
IsMatchCase | Bool | IsMatchCase | "Filter is case sensitive, if set TRUE. Otherwise the case sensitivity is ignored."
IsReadAll | Bool | IsReadAll |
IsRelationTime | Bool | IsRelationTime | "Display of relative times (relative to selected entries), if set TRUE."
IsSQL | Bool | IsSQL |
IsUnicode | Bool | IsUnicode |
IsXML | Bool | IsXML |
ListInfo | Node | ListInfo | Node
mSeconds | UInt16 | mSeconds | "Gets or sets the milliseconds in addition to the ""IncTime"" DynProperty."
NeedAlarmCause | Bool | NeedAlarmCause | Description
NeedComment | Bool | NeedComment |
ProjectNames | String | ProjectNames | "Specifies the names of the projects. Multiple project names are seperated with a semicolon. zFct.DynProperties(""PictFilter.ProjectNames"") = ""PROJECT1;PROJECT2;"""
ResString | String | ResString |
RTMDIFilterScreen | Node | RTMDIFilterScreen | Node
SQLBase | String | SQLBase |
SQLTable | String | SQLTable |
StatusFilter | Node | StatusFilter | Node
SystemModelGroup | Node | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
TextFilter | Node | TextFilter | Node
TimeFilter | Node | TimeFilter | Node
VarFilter | String | VarFilter | "Filters for variable names, where system messages are masked out, as they are not linked to a variable. Wildcards can be used here. Default = ""*"" (All variables)"


CD_CAmlCelListInfo
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarming [image] CD_CAmlCelFilter [image] CD_CAmlCelListInfo
Overview
External Name | Type | Display Name | Description
Acknowledged | String | Acknowledged | "Specifies the header text (column title) for the option ""Time acknowledged"" (DynProperty ""Entry"" option ""5"")."
AktText | String | AktText | "Specifies the header text (column title) for the option ""User text"" (DynProperty ""Entry"" option ""D"")."
AlarmCount | Int16 | AlarmCount | "Specifies the number of characters for text entries, for the option ""Text"" (DynProperty ""Entry"" option ""2"")."
Area | String | Area |
AreaAnz | Int16 | AreaAnz |
AreaNr | String | AreaNr |
AreaNrAnz | Int16 | AreaNrAnz |
Cause | String | Cause | Description
CauseAnz | Int16 | CauseAnz | Description
Class | String | Class | "Specifies the header text (column title) for the option ""Class"" (DynProperty ""Entry"" option ""F"")."
ClassCount | Int16 | ClassCount | "Specifies the number of characters for text entries, for the option ""Class"" (DynProperty ""Entry"" option ""F"")."
ClassNr | String | ClassNr | "Specifies the header text (column title) for the option ""ClassNr"" (DynProperty ""Entry"" option ""J"")."
ClassNrCount | Int16 | ClassNrCount | "Specifies the number of characters for text entries, for the option ""ClassNo"" (DynProperty ""Entry"" option ""J"")."
ClassSymbol | String | ClassSymbol |
ClassSymbolAnz | Int16 | ClassSymbolAnz |
ClassSymbolStyle | Int16 | ClassSymbolStyle |
Color1 | UInt32 | Color1 |
Color2 | UInt32 | Color2 |
Comes | String | Comes | "Specifies the header text (column title) for the option ""Time received"" (DynProperty ""Entry"" option ""3"")."
ComesAnz | Int16 | ComesAnz |
ComingTimeExtern | String | ComingTimeExtern | Description
ComingTimeExternWidth | Int16 | ComingTimeExternWidth | Description
ComingTimeIntern | String | ComingTimeIntern | Description
ComingTimeInternWidth | Int16 | ComingTimeInternWidth | Description
CompCount | Int16 | CompCount | "Specifies the number of characters for text entries, for the option ""Computer"" (DynProperty ""Entry"" option ""9"")."
Computer | String | Computer | "Specifies the header text (column title) for the option ""Computer"" (DynProperty ""Entry"" option ""9"")."
EditableInRT | Bool | EditableInRT | Description as text.
Entry | String | Entry | "Defines which formatting options are activated. Activation is done by passing a string with the corresponding option values (see table). ATTENTION: The formatting is produced in the sequence of the option activation, i.e. as specified within the string from left to right. Activate formatting options in following order: Variable name, Time received, Value, Text, User text zFct.DynProperties(""PictFilter.ListInfo.Entry"") = ""0372D"""
EntryAll | String | EntryAll |
EquipmentModelGroup | String | EquipmentModelGroup | Description
EquipmentModelGroupWidth | Int16 | EquipmentModelGroupWidth | Description
FilterPartGUID | Guid | FilterPartGUID | Description as text.
Goes | String | Goes | "Specifies the header text (column title) for the option ""Time cleared"" (DynProperty ""Entry"" option ""4"")."
GoesAnz | Int16 | GoesAnz |
Group | String | Group | "Specifies the header text (column title) for the option ""Group"" (DynProperty ""Entry"" option ""G"")."
GroupCount | Int16 | GroupCount | "Specifies the number of characters for text entries, for the option ""Group"" (DynProperty ""Entry"" option ""G"")."
GroupNr | String | GroupNr | "Specifies the header text (column title) for the option ""GroupNr"" (DynProperty ""Entry"" option ""I"")."
GroupNrCount | Int16 | GroupNrCount | "Specifies the number of characters for text entries, for the option ""GroupNo"" (DynProperty ""Entry"" option ""I"")."
GroupsSymbol | String | GroupsSymbol |
GroupSymbolAnz | Int16 | GroupSymbolAnz |
GroupSymbolStyle | Int16 | GroupSymbolStyle |
IsDate | Bool | IsDate | "Specifies, if the time options should be displayed with the date, when the values were recorded. Hint:Only available, if one of the following options has been enabled within DynProperty ""Entry"": ""Time received"", ""Time cleared"", ""Time acknowledged"" and/or ""Time reactivated"""
IsDynLimitFile | Bool | IsDynLimitFile |
IsMicroSeconds | Bool | IsMicroSeconds | Description
IsMilliseconds | Bool | IsMilliseconds | "Specifies, if the time options should be displayed with the milliseconds, when the values were recorded. Hint:Only available, if one of the following options has been enabled within DynProperty ""Entry"": ""Time received"", ""Time cleared"", ""Time acknowledged"" and/or ""Time reactivated"""
IsTime | Bool | IsTime | "Specifies, if the time options should be displayed with the time, when the values were recorded. Hint:Only available, if one of the following options has been enabled within DynProperty ""Entry"": ""Time received"", ""Time cleared"", ""Time acknowledged"" and/or ""Time reactivated"""
LeavingTimeExtern | String | LeavingTimeExtern | Description
LeavingTimeExternWidth | Int16 | LeavingTimeExternWidth | Description
LeavingTimeIntern | String | LeavingTimeIntern | Description
LeavingTimeInternWidth | Int16 | LeavingTimeInternWidth | Description
Name | String | Name | "Specifies the header text (column title) for the option ""Variable name"" (DynProperty ""Entry"" option ""0"")."
Project | String | Project | "Specifies the header text (column title) for the option ""Project name"" (DynProperty ""Entry"" option ""E"")."
ProjectCount | Int16 | ProjectCount | "Specifies the number of characters for text entries, for the option ""Project name"" (DynProperty ""Entry"" option ""E"")."
QuitAnz | Int16 | QuitAnz |
ReactionCountAnz | Int16 | ReactionCountAnz |
ReactionStatAnz | Int16 | ReactionStatAnz |
ReactionTimeAnz | Int16 | ReactionTimeAnz |
ReactivationTimeExtern | String | ReactivationTimeExtern | Description
ReactivationTimeExternWidth | Int16 | ReactivationTimeExternWidth | Description
ReactivationTimeIntern | String | ReactivationTimeIntern | Description
ReactivationTimeInternWidth | Int16 | ReactivationTimeInternWidth | Description
ReaktCount | String | ReaktCount | "Specifies the header text (column title) for the option ""Number reactivated"" (DynProperty ""Entry"" option ""B"")."
ReaktStat | String | ReaktStat | "Specifies the header text (column title) for the option ""State reactivated"" (DynProperty ""Entry"" option ""C"")."
ReaktTime | String | ReaktTime | "Specifies the header text (column title) for the option ""Time reactivated"" (DynProperty ""Entry"" option ""A"")."
ResourceLabel | String | ResourceLabel |
ResourceLabelAnz | Int16 | ResourceLabelAnz |
RTextCount | Int16 | RTextCount | "Specifies the number of characters for text entries, for the option ""User text"" (DynProperty ""Entry"" option ""D"")."
ShowGrid | Bool | ShowGrid |
SortDescending | Bool | SortDescending |
StatCount | Int16 | StatCount | "Specifies the number of characters for text entries, for the option ""Status"" (DynProperty ""Entry"" option ""6"")."
Status | String | Status | "Specifies the header text (column title) for the option ""Status"" (DynProperty ""Entry"" option ""6"")."
StatusCaption | String | StatusCaption |
StatusCaptionNr | Int16 | StatusCaptionNr |
StatusStyle | Int16 | StatusStyle |
Stop | String | Stop | "Specifies the header text (column title) for the option ""Time active"" (DynProperty ""Entry"" option ""H"")."
SystemModel | String | SystemModel | Description
TagCount | Int16 | TagCount | "Specifies the number of characters for text entries, for the option ""Identification"" (DynProperty ""Entry"" option ""1"")."
TagNr | String | TagNr | "Specifies the header text (column title) for the option ""Identification"" (DynProperty ""Entry"" option ""1"")."
Text | String | Text | "Specifies the header text (column title) for the option ""Text"" (DynProperty ""Entry"" option ""2"")."
TimeLastingAnz | Int16 | TimeLastingAnz |
Unit | String | Unit |
UnitAnz | Int16 | UnitAnz |
UseOptionalColors | Bool | UseOptionalColors |
User | String | User | "Specifies the header text (column title) for the option ""User identifier"" (DynProperty ""Entry"" option ""8"")."
UserCount | Int16 | UserCount | "Specifies the number of characters for text entries, for the option ""User identifier"" (DynProperty ""Entry"" option ""8"")."
UserName | String | UserName | "Specifies the header text (column title) for the option ""Complete name"" (DynProperty ""Entry"" option ""K"")."
UserNameCount | Int16 | UserNameCount | "Specifies the number of characters for text entries, for the option ""Complete name"" (DynProperty ""Entry"" option ""K"")."
ValCount | Int16 | ValCount | "Specifies the number of characters for text entries, for the option ""Value"" (DynProperty ""Entry"" option ""7"")."
Value | String | Value | "Specifies the header text (column title) for the option ""Value"" (DynProperty ""Entry"" option ""7"")."
VarCount | Int16 | VarCount | "Specifies the number of characters for text entries, for the option ""Variable name"" (DynProperty ""Entry"" option ""0"")."


CD_CZeitFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarming [image] CD_CAmlCelFilter [image] CD_CZeitFilter
Overview
External Name | Type | Display Name | Description
AddLen | UInt16 | AddLen | "Specifies if the length value (""Length"" DynProperty) should be added or subtracted. 0 = Subtract length 1 = Add length "
ARVTime1 | UInt32 | ARVTime1 | "Specifies the start time of the filter. zFct.DynProperties(""Filter.TimeFilter.ARVTime1"") = CDate(""30.07.2007 12:00:00"")"
ARVTime2 | UInt32 | ARVTime2 | Specifies the end time of the filter.
BoxenType | UInt16 | BoxenType |
ChargeFilter | Node | ChargeFilter | Batch filter settings
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
Length | UInt32 | Length | "Specifies the value of the length (in seconds) that should be added or subtracted (see ""AddLen"" DynProperty)."
ModifyTimePeriod | Bool | ModifyTimePeriod |
Offset | UInt32 | Offset | "Specifies the offset (in seconds) for the ""BoxType"" DynProperty option 1 to 8."
Options | UInt16 | Options |
ResString | String | ResString |
ShiftFilter | Node | ShiftFilter | Description
TimeFormat | UInt16 | TimeFormat | "Specifies the time format for the filter. ATTENTION: Can only be used, if ""BoxType"" DynProperty is set to 0. 10 = Time relative 12 = Absolute time 14 = From the specified day 20 = From month 22 = From year 25 = All "


CD_CChargenFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarming [image] CD_CAmlCelFilter [image] CD_CZeitFilter [image] CD_CChargenFilter
Overview
External Name | Type | Display Name | Description
ArchiveName | String | ArchiveName |
ArchiveNameFilterType | UInt16 | ArchiveNameFilterType |
ArchiveNameFilterVar | CProjektVariable | ArchiveNameFilterVar | Description as text.
ArvLotList | String | ArvLotList | In the runtime you can access the lot filter via the zenon API using the DynProperty "ArvLotList". It is available on the AML, CEL, Reportviewer and Reportgenerator screen. It returns an array which includes the filtered lots and the equipment model formatted as follows:{{lot-name1;archive-name1;start1;end1;{equipment11;equipment12;…}};{{lot-name2;archive-name2;start2;end2;{equipment21;equipment22;…}};…}.
ChargenNameFilterType | UInt16 | ChargenNameFilterType | Description as text.
ChargenNameFilterVar | CProjektVariable | ChargenNameFilterVar | Description as text.
ChargeRelative | Bool | ChargeRelative |
Count | UInt32 | Count | "Specifies how many last closed batches are displayed. Hint: Only available, if DynProperty ""LastCharge"" is set to 1."
DoneLots | Bool | DoneLots |
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
LotName | String | LotName |
OpenLots | Bool | OpenLots |
RTMDIFilterScreen | Node | RTMDIFilterScreen | Description
State | SByte | State |
TimeFilterType | SByte | TimeFilterType |
TimeLimits | UInt16 | TimeLimits | "Specifies the time limits for the batches: 0 = Outside: Batches that only lie partially within the time limit are fully enclosed. 1 = Inside: Batches that only lie partially within the time limit are not enclosed. 2 = From outside: Batches that started before the time limit are fully enclosed. Batches that end after the time limit are not enclosed. 3 = To outside: Batches that end after the time limit are fully enclosed. Batches that started before the time limit are not enclosed. 4 = Cut: Variables of batches that only partially lie within the time. Hint: Only available, if DynProperty ""LastCharge"" is set to 0."


CRelPicItem
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarming [image] CD_CAmlCelFilter [image] CD_CZeitFilter [image] CD_CChargenFilter [image] CRelPicItem
Overview
External Name | Type | Display Name | Description
RelatedPicture | String | Screen for time filter |


CShiftFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarming [image] CD_CAmlCelFilter [image] CD_CZeitFilter [image] CShiftFilter
Overview
External Name | Type | Display Name | Description
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.


CSystemModelFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarming [image] CD_CAmlCelFilter [image] CD_CZeitFilter [image] CShiftFilter [image] CSystemModelFilter
Overview
External Name | Type | Display Name | Description
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
SystemModelGroup | CD_CMemFile | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .


CRelPicItem
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarming [image] CD_CAmlCelFilter [image] CRelPicItem
Overview
External Name | Type | Display Name | Description
RelatedPicture | String | Screen for time filter |


CStatusFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarming [image] CD_CAmlCelFilter [image] CStatusFilter
Overview
External Name | Type | Display Name | Description
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
Status | UInt64 | Status |
StatusMask | UInt64 | StatusMask |


CSystemModelFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarming [image] CD_CAmlCelFilter [image] CSystemModelFilter
Overview
External Name | Type | Display Name | Description
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
SystemModelGroup | CD_CMemFile | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .


CTextFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarming [image] CD_CAmlCelFilter [image] CTextFilter
Overview
External Name | Type | Display Name | Description
Condition | UInt16 | Condition |
EditableInRT | Bool | EditableInRT | Description as text.
Expression | String | Expression |
FilterPartGUID | Guid | FilterPartGUID | Description as text.
IsFilterActive | Bool | IsFilterActive |
IsMatchCase | Bool | IsMatchCase |
IsSubFind | Bool | IsSubFind |


Alarms flashing'
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarms flashing'
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
PictSwitch | Node | PictSwitch | Node
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CD_CBildumschaltung
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarms flashing' [image] CD_CBildumschaltung
Overview
External Name | Type | Display Name | Description
ALCSubstitution | Node | ALCSubstitution | Node
CaseSensitive | Bool | CaseSensitive | "Indices substitution is case sensitive, if set TRUE."
IndexSubstitution | Node | IndexSubstitution | "Replaces the indices Debug.Print zFct.DynProperties(""PictSwitch.IndexSubstitution[-1]"") 'Output the amount of substituted indices Debug.Print zFct.DynProperties(""PictSwitch.IndexSubstitution[0].Source"") 'Access the name of the first variable Debug.Print zFct.DynProperties(""PictSwitch.IndexSubstitution[0].Destination"") 'Name of the corresponding substitution variable"
IndexVar | Node | IndexVar | "Accesses the assigned variables for the index substitution. Debug.Print zFct.DynProperties(""PictSwitch.IndexVar[-1]"") 'Amount of assigned variables Debug.Print zFct.DynProperties(""PictSwitch.IndexVar[0].Title"").Name 'Name of first variable"
IsCallingPic | Bool | IsCallingPic | Specifies the variable unit.
IsFilterRT | Bool | IsFilterRT | "Displays the picture selection dialog within the runtime, if set TRUE."
IsMonScroll | Bool | IsMonScroll | "Scrolls to the corresponding monitor on picture switch, if set TRUE."
Monitor | Int16 | Monitor | Defines on which monitor the picture is displayed. -2 = Relative to caller 0 = Display 0 (default display) 1 = Display 1 (only for multi-monitor projects) ... = etc.
Picture | String | Picture | Gets or sets the name of the switching picture.
ProjectName | String | ProjectName | "Gets or sets the project name where the picture is defined. Hint: The current project will be used, if this property is not specified."
SubstiFkt | Node | SubstiFkt | "Function substitution Debug.Print zFct.DynProperties(""PictSwitch.SubstiFkt[-1]"") 'Outputs the amount of substituted functions Debug.Print zFct.DynProperties(""PictSwitch.SubstiFkt[0].Source"") 'Access the name of the first source function Debug.Print zFct.DynProperties(""PictSwitch.SubstiFkt[0].Destination"") 'Name of the corresponding substitution function"
SubstiVar | Node | SubstiVar | "Variable substitution Debug.Print zFct.DynProperties(""PictSwitch.SubstiVar[-1]"") 'Outputs the amount of substituted variables Debug.Print zFct.DynProperties(""PictSwitch.SubstiVar[0].Source"") 'Access the name of the first source variable Debug.Print zFct.DynProperties(""PictSwitch.SubstiVar[0].Destination"") 'Name of the corresponding substitution variable"
WndType | UInt32 | WndType | Only users with the appropriate user authorization can edit entries in the database of the Industrial Performance Analyzer (IPA).


CIndexSubsti
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarms flashing' [image] CD_CBildumschaltung [image] CIndexSubsti
Overview
External Name | Type | Display Name | Description
Destination | String | Destination | "The name of the variable, which should replace the source."
Source | String | Source | "The name of the variable linked in the picture, which should be replaced."


CProjektVariableProp
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarms flashing' [image] CD_CBildumschaltung [image] CProjektVariableProp
Overview
External Name | Type | Display Name | Description
Title | CProjektVariable | Title | Gets or sets a variable object.


CSubsti
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarms flashing' [image] CD_CBildumschaltung [image] CSubsti
Overview
External Name | Type | Display Name | Description
Destination | String | Destination | Name of target variable/function for the substitution.
Source | String | Source | Name of the source variable/function for the substitution. ATTENTION: Wildcards (*) are allowed at the beginning and at the end of the variable or function name.


Alarms Groups Classes
ObjectModel COM [image] RtFunction [image] DynProperties [image] Alarms Groups Classes
Overview
External Name | Type | Display Name | Description
Action | UInt16 | Action | Gets or sets the action that should be executed. 0 = Activate alarms/groups/classes 1 = Deactivate 2 = Toggle
ActionType | UInt16 | ActionType | Gets or sets the type of alarm selection. 0 = Total alarm administration 1 = Alarms of group 2 = Alarms of class
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
Index | UInt16 | Index | With this property you have the opportunity to get/set the alarm group or class.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Analyzer report function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Analyzer report function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
ReportFilter | Node | ReportFilter | Provides access to the filter function.Typ = ZT_KNOTENArray-Members = CAnalyzerReportFilter
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CAnalyzerReportFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Analyzer report function [image] CAnalyzerReportFilter
Overview
External Name | Type | Display Name | Description
ConnectionTimeout | Int32 | ConnectionTimeout | Description
CryptedPassword | String | CryptedPassword | Provides access to the crypted password used for the authentification.Type = VT_BSTR
IncludeTimestamp | Bool | IncludeTimestamp | Provides access to the timestamp flag.Type = VT_BOOL
ParameterList | Node | ParameterList | Provides access to the parameterlist of the actual report.Typ = ZT_KNOTENArray-Members = CAnalyzerParamList
ParameterListCfg |  | ParameterListCfg | Provides access to the column settings of the GFX list.Typ = ZT_KNOTENArray-Members = CAnalyzerParamListCfg
RenderingEngine | String | RenderingEngine | Provides access to the selected rendering extension.Type = VT_BSTR
SecureConnection | Bool | SecureConnection | Description
SelectedReport | String | SelectedReport | Provides access to the selected report.Type = VT_BSTR
ServerName | String | ServerName | Provides access to the server name.Type = VT_BSTR
ServerVersion | UInt16 | ServerVersion | Provides access to the server version.Typ = VT_UI2
UserName | String | UserName | Provides access to the username used for the authentification.Type = VT_BSTR
UseRuntimeUser | Bool | UseRuntimeUser | Provides access to the windows authentification flag.Type = VT_BOOL
VariableForOutputFilePath | CProjektVariable | VariableForOutputFilePath | Provides access to the variable which includes the path of the file.Type = ZT_VARIABLE


CAnalyzerParamList
ObjectModel COM [image] RtFunction [image] DynProperties [image] Analyzer report function [image] CAnalyzerReportFilter [image] CAnalyzerParamList
Overview
External Name | Type | Display Name | Description
ParameterItem | Node | ParameterItem | Provides access to the parameters of the reports.Type = ZT_KNOTENArray-Members = CAnalyzerParam


CAnalyzerParam
ObjectModel COM [image] RtFunction [image] DynProperties [image] Analyzer report function [image] CAnalyzerReportFilter [image] CAnalyzerParamList [image] CAnalyzerParam
Overview
External Name | Type | Display Name | Description
GuiName | String | GuiName | Provides access to the parameter displayname.Type = VT_BSTR
InputMode | Int32 | InputMode | Provides access to the input mode of the parameter.Type = VT_I4
LogValue | String | LogValue | Provides access to the parameter log value.Type = VT_BSTR
State | Int32 | State | Provides access to the parameter state.Type = VT_I4
Type | Int32 | Type | Provides access to the parameter datatype.Type = VT_I4
VariableForLotOrShiftName | CProjektVariable | VariableForLotOrShiftName | Provides access to the batchname variable.Type = ZT_VARIABLE


Assign screen monitor
ObjectModel COM [image] RtFunction [image] DynProperties [image] Assign screen monitor
Overview
External Name | Type | Display Name | Description
DstNum | Int16 | DstNum |
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SrcNum | Int16 | SrcNum |
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Authorization in network
ObjectModel COM [image] RtFunction [image] DynProperties [image] Authorization in network
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Token | Node | Token | Node
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CD_CFktToken
ObjectModel COM [image] RtFunction [image] DynProperties [image] Authorization in network [image] CD_CFktToken
Overview
External Name | Type | Display Name | Description
Hierarchic | Bool | Hierarchic | Description
ShowAtRuntime | Bool | ShowAtRuntime | Description
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Token | Int16 | Token |


Base function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Base function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Batch command function state
ObjectModel COM [image] RtFunction [image] DynProperties [image] Batch command function state
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
StateCmdFilter | Node | StateCmdFilter | Description as text.
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CBatchCmdFuncFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Batch command function state [image] CBatchCmdFuncFilter
Overview
External Name | Type | Display Name | Description
CaseSensitive | Bool | CaseSensitive | Description
CrCurrentness | Int32 | CrCurrentness | Description as text.
CrState | Int32 | CrState | Description as text.
CRTextFilter | String | CRTextFilter | Description as text.
FilterForRecipeType | Int32 | FilterForRecipeType | Description as text.
MrCurrentness | Int32 | MrCurrentness | Description as text.
MrState | Int32 | MrState | Description as text.
MRTextFilter | String | MRTextFilter | Description as text.
PV_CR | CProjektVariable | PV_CR | Description as text.
PV_MR | CProjektVariable | PV_MR | Description as text.
SettingCR | Int32 | SettingCR | Description as text.
SettingMR | Int32 | SettingMR | Description as text.
StateCmd | Int32 | StateCmd | Description as text.
StateCmdMode | Int32 | StateCmdMode | Description as text.
VersionNum | UInt32 | VersionNum | Description as text.
VersionSearchType | Int32 | VersionSearchType | Description as text.
VersionVar | CProjektVariable | VersionVar | Description as text.


Batch create function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Batch create function
Overview
External Name | Type | Display Name | Description
CrCreateFilter | Node | CrCreateFilter | Description as text.
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CBatchCrCreateFunctionFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Batch create function [image] CBatchCrCreateFunctionFilter
Overview
External Name | Type | Display Name | Description
CaseSensitive | Bool | CaseSensitive | Description
CrNameCreation | Int32 | CrNameCreation | Description as text.
CrNameCreationVar | CProjektVariable | CrNameCreationVar | Description as text.
IndividualJobIdLinkType | Int32 | IndividualJobIdLinkType | Description as text.
IndividualJobVariable | CProjektVariable | IndividualJobVariable | Description as text.
LinkJobId | Bool | LinkJobId | Description as text.
MrCurrentness | Int32 | MrCurrentness | Description as text.
MrState | Int32 | MrState | Description as text.
MRTextFilter | String | MRTextFilter | Description as text.
PV_MR | CProjektVariable | PV_MR | Description as text.
SettingMR | Int32 | SettingMR | Description as text.
VersionNum | UInt32 | VersionNum | Description as text.
VersionSearchType | Int32 | VersionSearchType | Description as text.
VersionVar | CProjektVariable | VersionVar | Description as text.


Batch recipe export
ObjectModel COM [image] RtFunction [image] DynProperties [image] Batch recipe export
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
RecipeExportFilter | Node | RecipeExportFilter | Description
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CRecipeExportFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Batch recipe export [image] CRecipeExportFilter
Overview
External Name | Type | Display Name | Description
FileName | String | FileName | Description
FileNamePv | CProjektVariable | FileNamePv | Description
FileNaming | Int16 | FileNaming | Description
FilterType | Int16 | FilterType | Description
OperationFilter |  | OperationFilter | Description
OverwriteExistingFile | Bool | OverwriteExistingFile | Description
RecipeFilter |  | RecipeFilter | Description
ShowRT | Bool | ShowRT | Description


Batch recipe import
ObjectModel COM [image] RtFunction [image] DynProperties [image] Batch recipe import
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
RecipeImportFilter | Node | RecipeImportFilter | Description
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CRecipeImportFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Batch recipe import [image] CRecipeImportFilter
Overview
External Name | Type | Display Name | Description
FileName | String | FileName | Description
FileNameFromVariable | Bool | FileNameFromVariable | Description
FileNameVariable | CProjektVariable | FileNameVariable | Description
IndividualJobIdLinkType | Int16 | IndividualJobIdLinkType | Description as text.
IndividualJobVariable | CProjektVariable | IndividualJobVariable | Description as text.
LinkJobId | Bool | LinkJobId | Description as text.
MrNameConflictAction | Int16 | MrNameConflictAction | Description
MrOpNameConflictAction | Int16 | MrOpNameConflictAction | Description
ShowRT | Bool | ShowRT | Description


Batchmanager release function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Batchmanager release function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
MrReleaseFilter |  | MrReleaseFilter | Description
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Call SAP function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Call SAP function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
FunctionId | UInt32 | Function number |
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsDialogRT | Bool | IsDialogRT | "Displays the printer selection dialog in the runtime, if set TRUE."
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Center screen
ObjectModel COM [image] RtFunction [image] DynProperties [image] Center screen
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
MidParameter | Node | MidParameter | Parameters for centering and zooming
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
PictSwitch | Node | PictSwitch | Node
Picture | String | Picture | Specifies the GUID of the picture that should be centered and/or zoomed.
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CD_CBildumschaltung
ObjectModel COM [image] RtFunction [image] DynProperties [image] Center screen [image] CD_CBildumschaltung
Overview
External Name | Type | Display Name | Description
ALCSubstitution | Node | ALCSubstitution | Node
CaseSensitive | Bool | CaseSensitive | "Indices substitution is case sensitive, if set TRUE."
IndexSubstitution | Node | IndexSubstitution | "Replaces the indices Debug.Print zFct.DynProperties(""PictSwitch.IndexSubstitution[-1]"") 'Output the amount of substituted indices Debug.Print zFct.DynProperties(""PictSwitch.IndexSubstitution[0].Source"") 'Access the name of the first variable Debug.Print zFct.DynProperties(""PictSwitch.IndexSubstitution[0].Destination"") 'Name of the corresponding substitution variable"
IndexVar | Node | IndexVar | "Accesses the assigned variables for the index substitution. Debug.Print zFct.DynProperties(""PictSwitch.IndexVar[-1]"") 'Amount of assigned variables Debug.Print zFct.DynProperties(""PictSwitch.IndexVar[0].Title"").Name 'Name of first variable"
IsCallingPic | Bool | IsCallingPic | Specifies the variable unit.
IsFilterRT | Bool | IsFilterRT | "Displays the picture selection dialog within the runtime, if set TRUE."
IsMonScroll | Bool | IsMonScroll | "Scrolls to the corresponding monitor on picture switch, if set TRUE."
Monitor | Int16 | Monitor | Defines on which monitor the picture is displayed. -2 = Relative to caller 0 = Display 0 (default display) 1 = Display 1 (only for multi-monitor projects) ... = etc.
Picture | String | Picture | Gets or sets the name of the switching picture.
ProjectName | String | ProjectName | "Gets or sets the project name where the picture is defined. Hint: The current project will be used, if this property is not specified."
SubstiFkt | Node | SubstiFkt | "Function substitution Debug.Print zFct.DynProperties(""PictSwitch.SubstiFkt[-1]"") 'Outputs the amount of substituted functions Debug.Print zFct.DynProperties(""PictSwitch.SubstiFkt[0].Source"") 'Access the name of the first source function Debug.Print zFct.DynProperties(""PictSwitch.SubstiFkt[0].Destination"") 'Name of the corresponding substitution function"
SubstiVar | Node | SubstiVar | "Variable substitution Debug.Print zFct.DynProperties(""PictSwitch.SubstiVar[-1]"") 'Outputs the amount of substituted variables Debug.Print zFct.DynProperties(""PictSwitch.SubstiVar[0].Source"") 'Access the name of the first source variable Debug.Print zFct.DynProperties(""PictSwitch.SubstiVar[0].Destination"") 'Name of the corresponding substitution variable"
WndType | UInt32 | WndType | Only users with the appropriate user authorization can edit entries in the database of the Industrial Performance Analyzer (IPA).


CDBildMittelPunktPara
ObjectModel COM [image] RtFunction [image] DynProperties [image] Center screen [image] CDBildMittelPunktPara
Overview
External Name | Type | Display Name | Description
Station | String | Station | "Name of the object, which should be the reference for the new center. Hint: Only available, if DynProperty ""Type"" is set to 1."
Type | Int16 | Type | "Specifies the centering method: 0 = Centering deactivated 1 = Set desired center via an object (DynProperty ""Station"") 3 = Set desired center via coordinates (DynProperties ""X"" and ""Y"") "
X | Int16 | X | "X coordinate of the new center. Hint: Only available, if DynProperty ""Type"" is set to 3."
Y | Int16 | Y | "Y coordinate of the new center. Hint: Only available, if DynProperty ""Type"" is set to 3."
ZoomLevel | Int16 | ZoomLevel | "Specifies the zoom steps. Hint: Only available, if DynProperty ""ZoomType"" is set to 3."
ZoomPercent | Int16 | ZoomPercent | "Specifies the zoom factor in percent. Hint: Only available, if DynProperty ""ZoomType"" is set to 1."
ZoomType | Int16 | ZoomType | "Specifies the zoom method: 0 = Zoom deactivated 1 = Set desired zoom factor in percent (DynProperty ""ZoomPercent"") 3 = Set desired zoom factor via the defined zoom steps (DynProperty ""ZoomLevel"") "


Check maintanances
ObjectModel COM [image] RtFunction [image] DynProperties [image] Check maintanances
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
TimeSpan | UInt32 | TimeSpan |
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
VarList | Node | VarList | Node


CPlantStatusVar
ObjectModel COM [image] RtFunction [image] DynProperties [image] Check maintanances [image] CPlantStatusVar
Overview
External Name | Type | Display Name | Description
Plants | String | Plants |
ProjectVar | CProjektVariable | ProjectVar |


Client simulatio'
ObjectModel COM [image] RtFunction [image] DynProperties [image] Client simulatio'
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SimulCmd | Int32 | Type of simulation |
SimulErrMsg | Bool | Show error message in the Runtime |
SimulMaxWait | Int32 | Maximum waiting time |
SimulName | String | Simulation image name |
SimulReplayConfig |  | SimulReplayConfig | Description
SimulRtDlg | Bool | Show this dialog in the Runtime |
SimulStartPlayBack | Bool | SimulStartPlayBack | Description
SimulWait4All | Bool | Wait for all variables | Description as text.
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Command sequence export function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Command sequence export function
Overview
External Name | Type | Display Name | Description
CmdSequenceExportFilter | Node | CmdSequenceExportFilter | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CRecipeExportFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Command sequence export function [image] CRecipeExportFilter
Overview
External Name | Type | Display Name | Description
FileName | String | FileName | Description
FileNamePv | CProjektVariable | FileNamePv | Description
FileNaming | Int16 | FileNaming | Description
FilterType | Int16 | FilterType | Description
OperationFilter |  | OperationFilter | Description
OverwriteExistingFile | Bool | OverwriteExistingFile | Description
RecipeFilter |  | RecipeFilter | Description
ShowRT | Bool | ShowRT | Description


Command sequence function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Command sequence function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SequenceStateCmdFilter |  | SequenceStateCmdFilter | Description
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Command sequence import function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Command sequence import function
Overview
External Name | Type | Display Name | Description
CmdSequenceImportFilter | Node | CmdSequenceImportFilter | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CRecipeImportFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Command sequence import function [image] CRecipeImportFilter
Overview
External Name | Type | Display Name | Description
FileName | String | FileName | Description
FileNameFromVariable | Bool | FileNameFromVariable | Description
FileNameVariable | CProjektVariable | FileNameVariable | Description
IndividualJobIdLinkType | Int16 | IndividualJobIdLinkType | Description as text.
IndividualJobVariable | CProjektVariable | IndividualJobVariable | Description as text.
LinkJobId | Bool | LinkJobId | Description as text.
MrNameConflictAction | Int16 | MrNameConflictAction | Description
MrOpNameConflictAction | Int16 | MrOpNameConflictAction | Description
ShowRT | Bool | ShowRT | Description


Create IPA document
ObjectModel COM [image] RtFunction [image] DynProperties [image] Create IPA document
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
Filename | String | Filename |
Filter | Node | Filter | Node
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
ToFile | Bool | ToFile |
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CD_CAsmFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Create IPA document [image] CD_CAsmFilter
Overview
External Name | Type | Display Name | Description
DBConnection | Node | DBConnection | Node
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
ListConfig | Node | ListConfig | Node
ShowFilter | Bool | ShowFilter |
ShowRaster | Bool | ShowRaster |
SubFilter | Node | SubFilter | Node


CAsmDBConnection
ObjectModel COM [image] RtFunction [image] DynProperties [image] Create IPA document [image] CD_CAsmFilter [image] CAsmDBConnection
Overview
External Name | Type | Display Name | Description
DNS | String | DNS |
Table | String | Table |


CAsmFilterCriteria
ObjectModel COM [image] RtFunction [image] DynProperties [image] Create IPA document [image] CD_CAsmFilter [image] CAsmFilterCriteria
Overview
External Name | Type | Display Name | Description
AKZSelName | String | AKZSelName |
AKZSelNameList | String | AKZSelNameList |
CauseList | String | CauseList |
CLSSelList | String | CLSSelList |
DateSelection | Int16 | DateSelection |
DurationMax | double | DurationMax |
DurationMin | double | DurationMin |
EndDate | DateTime | EndDate |
EndTime | DateTime | EndTime |
FilterText | String | FilterText |
FilterTextTag | String | FilterTextTag |
FrequencyMax | Int32 | FrequencyMax |
FrequencyMin | Int32 | FrequencyMin |
GRPSelList | String | GRPSelList |
IsAKZActive | Bool | IsAKZActive |
IsCauseFilterActive | Bool | IsCauseFilterActive |
IsCLSActive | Bool | IsCLSActive |
IsDateActive | Bool | IsDateActive |
IsDateWithTime | Bool | IsDateWithTime |
IsDurationActive | Bool | IsDurationActive |
IsEmptyCauseActive | Bool | IsEmptyCauseActive |
IsFrequencyActive | Bool | IsFrequencyActive |
IsGRPActive | Bool | IsGRPActive |
IsProjectActive | Bool | IsProjectActive |
IsSHFComeActive | Bool | IsSHFComeActive |
IsSHFGoneActive | Bool | IsSHFGoneActive |
IsStateActive | Bool | IsStateActive |
IsTextActive | Bool | IsTextActive |
IsTextCase | Bool | IsTextCase |
IsTextTagActive | Bool | IsTextTagActive |
IsTextTagCase | Bool | IsTextTagCase |
IsTextTagUseRE | Bool | IsTextTagUseRE |
IsTextUseRE | Bool | IsTextUseRE |
IsTimeActive | Bool | IsTimeActive |
PreTimes | String | PreTimes |
ProjectList | String | ProjectList |
SHFComeSelList | String | SHFComeSelList |
SHFGoneSelList | String | SHFGoneSelList |
StartDate | DateTime | StartDate |
StartTime | DateTime | StartTime |
StatCount | Int32 | StatCount |
State | Int32 | State |
TimeSelection | Int16 | TimeSelection |
ViewMode | Int32 | ViewMode |


CD_CAsmListConfig
ObjectModel COM [image] RtFunction [image] DynProperties [image] Create IPA document [image] CD_CAsmFilter [image] CD_CAsmListConfig
Overview
External Name | Type | Display Name | Description
ColumnSetting | Node | ColumnSetting | Node


CD_CAsmColumnSetting
ObjectModel COM [image] RtFunction [image] DynProperties [image] Create IPA document [image] CD_CAsmFilter [image] CD_CAsmListConfig [image] CD_CAsmColumnSetting
Overview
External Name | Type | Display Name | Description
Caption | String | Caption |
UseCustom | Bool | UseCustom |
Width | Int16 | Width |


Driver commands
ObjectModel COM [image] RtFunction [image] DynProperties [image] Driver commands
Overview
External Name | Type | Display Name | Description
Command | Node | Command | Node
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CTreiberCommand
ObjectModel COM [image] RtFunction [image] DynProperties [image] Driver commands [image] CTreiberCommand
Overview
External Name | Type | Display Name | Description
Command | UInt16 | Command |
DrvIndex | UInt32 | DrvIndex |
IsFilterRT | Bool | IsFilterRT |
ResString | String | ResString |
UsrCommand | String | UsrCommand |


Earth fault topology
ObjectModel COM [image] RtFunction [image] DynProperties [image] Earth fault topology
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


EMS
ObjectModel COM [image] RtFunction [image] DynProperties [image] EMS
Overview
External Name | Type | Display Name | Description
EMSAlgo | String | EMSAlgo |
EMSArea | String | EMSArea |
EMSNet | String | EMSNet |
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Execute addin wizard function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Execute addin wizard function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
FrameWorkId | String | FrameWorkId | Description
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
ShowRT | Bool | ShowRT | Description
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
WizardEntryPointId | String | WizardEntryPointId | Description


Export alarms
ObjectModel COM [image] RtFunction [image] DynProperties [image] Export alarms
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
Filter | Node | Filter | Node
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CD_CAmlCelFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Export alarms [image] CD_CAmlCelFilter
Overview
External Name | Type | Display Name | Description
Areas | String | Areas |
Classes | String | Classes | "Filters for alarm classes, where system messages are marked out, as they are not linked to a variable. Multiple class numbers have to be seperated with a semicolon. zFct.DynProperties(""PictFilter.Classes"") = ""1;2;"""
EditableInRT | Bool | EditableInRT | Description as text.
EntriesCount | UInt16 | EntriesCount | "Specifies the maximum amount of entries that should be filtered from a file. Hint: Only available, if the DynProperty ""IsFromFiles"" is set TRUE."
FileName | String | FileName | With this property you get/set the file name for the different export mechanism.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
FilterTitel | String | FilterTitel | "Filters for the identifictaion of variables, where system messages are masked out, as they are not linked to a variable. Wildcards can be used here. Default = ""*"""
Font | UInt16 | Font | "Specifies the font that should be used. The parameter that is passed, is the index of the font within the specified font list. 0 = Standard font 1 = Default font 1 ... 5 = Default font 5 6 = User specified font 1 ... = etc. "
Groups | String | Groups | "Filters for alarm groups, where system messages are marked out, as they are not linked to a variable. Multiple group numbers have to be seperated with a semicolon. zFct.DynProperties(""PictFilter.Groups"") = ""1;2;"""
IncTime | UInt32 | IncTime | "Gets or sets the minimal time for current alarms in seconds. Hint: Milliseconds can be specified with the ""mSeconds"" DynProperty."
IsAcknowledged | Bool | IsAcknowledged | "Filters unacknowledged alarms, if set TRUE."
IsAML | Bool | IsAML | "Prints the alarm list, if set TRUE. Otherwise the CEL list will be printed."
IsAscentOnly | Bool | IsAscentOnly | "Prints only current alarms, if set TRUE."
IsAutoName | Bool | IsAutoName |
IsDBASE | Bool | IsDBASE |
IsFilterExp | Bool | IsFilterExp | "Opens the list stopped, if set TRUE. "
IsFilterRT | Bool | IsFilterRT | "Displays the configuration dialog within the runtime, if set TRUE."
IsFromFiles | Bool | IsFromFiles | "Filter is applied to file entries, if set TRUE. Otherwise, the filter is applied to the entries from the memory. Hint: The maximum amount of entries which should be filtered from the file is specified by the ""EntriesCount"" DynProperty."
IsGoneOnly | Bool | IsGoneOnly |
IsIncremental | Bool | IsIncremental |
IsMatchCase | Bool | IsMatchCase | "Filter is case sensitive, if set TRUE. Otherwise the case sensitivity is ignored."
IsReadAll | Bool | IsReadAll |
IsRelationTime | Bool | IsRelationTime | "Display of relative times (relative to selected entries), if set TRUE."
IsSQL | Bool | IsSQL |
IsUnicode | Bool | IsUnicode |
IsXML | Bool | IsXML |
ListInfo | Node | ListInfo | Node
mSeconds | UInt16 | mSeconds | "Gets or sets the milliseconds in addition to the ""IncTime"" DynProperty."
NeedAlarmCause | Bool | NeedAlarmCause | Description
NeedComment | Bool | NeedComment |
ProjectNames | String | ProjectNames | "Specifies the names of the projects. Multiple project names are seperated with a semicolon. zFct.DynProperties(""PictFilter.ProjectNames"") = ""PROJECT1;PROJECT2;"""
ResString | String | ResString |
RTMDIFilterScreen | Node | RTMDIFilterScreen | Node
SQLBase | String | SQLBase |
SQLTable | String | SQLTable |
StatusFilter | Node | StatusFilter | Node
SystemModelGroup | Node | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
TextFilter | Node | TextFilter | Node
TimeFilter | Node | TimeFilter | Node
VarFilter | String | VarFilter | "Filters for variable names, where system messages are masked out, as they are not linked to a variable. Wildcards can be used here. Default = ""*"" (All variables)"


Export archive
ObjectModel COM [image] RtFunction [image] DynProperties [image] Export archive
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
Filter | Node | Filter | Node
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CD_CArchivExportFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Export archive [image] CD_CArchivExportFilter
Overview
External Name | Type | Display Name | Description
ArvName | String | ArvName |
AutomaticNameGeneration | Bool | AutomaticNameGeneration |
Backup | SByte | Backup |
Database | String | Database |
DBTable | String | DBTable |
ExportType | Int32 | ExportType | Description
Format | String | Format |
IsFilterRT | Bool | IsFilterRT |
IsUnicode | Bool | IsUnicode |
Name | String | Name |
ResString | String | ResString |
TimeFilter | Node | TimeFilter | Node
UseLotForNameGeneration | Bool | UseLotForNameGeneration | Description


CD_CZeitFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Export archive [image] CD_CArchivExportFilter [image] CD_CZeitFilter
Overview
External Name | Type | Display Name | Description
AddLen | UInt16 | AddLen | "Specifies if the length value (""Length"" DynProperty) should be added or subtracted. 0 = Subtract length 1 = Add length "
ARVTime1 | UInt32 | ARVTime1 | "Specifies the start time of the filter. zFct.DynProperties(""Filter.TimeFilter.ARVTime1"") = CDate(""30.07.2007 12:00:00"")"
ARVTime2 | UInt32 | ARVTime2 | Specifies the end time of the filter.
BoxenType | UInt16 | BoxenType |
ChargeFilter | Node | ChargeFilter | Batch filter settings
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
Length | UInt32 | Length | "Specifies the value of the length (in seconds) that should be added or subtracted (see ""AddLen"" DynProperty)."
ModifyTimePeriod | Bool | ModifyTimePeriod |
Offset | UInt32 | Offset | "Specifies the offset (in seconds) for the ""BoxType"" DynProperty option 1 to 8."
Options | UInt16 | Options |
ResString | String | ResString |
ShiftFilter | Node | ShiftFilter | Description
TimeFormat | UInt16 | TimeFormat | "Specifies the time format for the filter. ATTENTION: Can only be used, if ""BoxType"" DynProperty is set to 0. 10 = Time relative 12 = Absolute time 14 = From the specified day 20 = From month 22 = From year 25 = All "


Export data function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Export data function
Overview
External Name | Type | Display Name | Description
ExportStruct | Node | ExportStruct | Defines the export settings
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CExportInitStrukt
ObjectModel COM [image] RtFunction [image] DynProperties [image] Export data function [image] CExportInitStrukt
Overview
External Name | Type | Display Name | Description
AppName | String | AppName | Specifies the name of the project.
FileName | String | FileName | Specifies the name of the file that should be exported. ATTENTION: Only filnames with up to 8 characters are allowed.
Format | Int16 | Format | Specifies the output format. 0 = dBase IV (*.DBF) 1 = XML (*.xml) 2 = ASCII (*.TXT)
InitVal | Int16 | InitVal | "For the HD values, a ring buffer is filled and stored. Active (TRUE): The ring buffer is initialised for the export Inactive (FALSE): The ring buffer is kept for the export"
IsUniText | Bool | IsUniText | "Exports the file in unicode characters if set TRUE. Hint: Only available for the ASCII export option specified by the ""Format"" DynProperty."
Type | Int16 | Type |
Vars | Node | Vars | "Creates, accesses and modifies the variables which should be exported. Returns a ""Variable"" object. Hint: ""ExportStruct.Vars[-1]"" returns the amount of variables."


CProjektVariableProp
ObjectModel COM [image] RtFunction [image] DynProperties [image] Export data function [image] CExportInitStrukt [image] CProjektVariableProp
Overview
External Name | Type | Display Name | Description
Title | CProjektVariable | Title | Gets or sets a variable object.


Fault location
ObjectModel COM [image] RtFunction [image] DynProperties [image] Fault location
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SourceBackground | UInt32 | SourceBackground |
SourceColor | UInt32 | SourceColor |
SourceID | Int16 | SourceID |
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
Vars | Node | Vars | Node


CProjektVariableProp
ObjectModel COM [image] RtFunction [image] DynProperties [image] Fault location [image] CProjektVariableProp
Overview
External Name | Type | Display Name | Description
Title | CProjektVariable | Title | Gets or sets a variable object.


File operations
ObjectModel COM [image] RtFunction [image] DynProperties [image] File operations
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameter | Node | Parameter | Specifies parameters for the file operations
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CDateiOperationParameter
ObjectModel COM [image] RtFunction [image] DynProperties [image] File operations [image] CDateiOperationParameter
Overview
External Name | Type | Display Name | Description
Days | Int16 | Days | "Sets the number of ""not older than""-days x for the time-filter of the file operation function."
Destination | String | Destination | "sets the destination path and / or filename for the file-operation function. Depending on the ""Parameter.Modus"", either: an absolute path (Modus=0, e.g. ""c:\hugo.txt"") or a relative path / filename (Modus=1 / Modus = 2, e.g. ""\hugo.txt"") should be used"
DstPathModus | UInt16 | DstPathModus | sets the destination-path mode for the file-operation function. 0 = absolute path 1 = relative path starting from the project runtime directory 2 = relative path starting from the project runtime data directory (directoryname equal to the PC name)
Hours | Int16 | Hours | "Sets the number of ""not older than""-hours x for the time-filter of the file operation function."
IsErrorMsg | Bool | IsErrorMsg | should an error message be displayed in the runtime if the file-operation function could not be executed successfully (TRUE) or not (FALSE)
IsFilterRT | Bool | IsFilterRT | should the dialog for the file operation function be displayed in the runtime prior to execution (TRUE) or not (FALSE)
IsOlder | Bool | IsOlder | "sets the ""not younger than"" option for the time filter at the file operation function active (TRUE) or not (False)"
IsOverwrite | Bool | IsOverwrite | should files be overwritten at the file-operation function (move and copy mode) (TRUE) or not (FALSE). Read-only files are not overwritten regardless of this checkbox.
IsTimeCond | Bool | IsTimeCond | should the file-operation function be executed regardless of the filedate (FALSE) or consider the filedate set at the time-filter (TRUE)
IsYounger | Bool | IsYounger | "sets the ""not older than"" option for the time filter at the file operation function active (TRUE) or not (False)"
Modus | UInt16 | Modus | sets the mode for the file-operation function 0 = Copy 1 = Move 2 = Delete
OlderDays | Int16 | OlderDays | "Sets the number of ""not younger than""-days x for the time-filter of the file operation function."
OlderHours | Int16 | OlderHours | "Sets the number of ""not younger than""-hours x for the time-filter of the file operation function."
Recursive | Bool | Recursive | should also subdirectories be taken in account at the file-operation function (TRUE) or not (FALSE)
Source | String | Source | "sets the source path and / or filename for the file-operation function. Depending on the ""Parameter.Modus"", either: an absolute path (Modus=0, e.g. ""c:\hugo.txt"") or a relative path / filename (Modus=1 / Modus = 2, e.g. ""\hugo.txt"") should be used"
SrcPathModus | UInt16 | SrcPathModus | sets the source-path mode for the file-operation function. 0 = absolute path 1 = relative path starting from the project runtime directory 2 = relative path starting from the project runtime data directory (directoryname equal to the PC name)


Focus set
ObjectModel COM [image] RtFunction [image] DynProperties [image] Focus set
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
Focus | Node | Focus | Node
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CD_CSetFocus
ObjectModel COM [image] RtFunction [image] DynProperties [image] Focus set [image] CD_CSetFocus
Overview
External Name | Type | Display Name | Description
Direction | Int16 | Direction |
IsElementName | String | IsElementName |
IsOnElement | Bool | IsOnElement |


Graph7 Heuristics
ObjectModel COM [image] RtFunction [image] DynProperties [image] Graph7 Heuristics
Overview
External Name | Type | Display Name | Description
ComBlock | CProjektVariable | ComBlock |
DestVar | CProjektVariable | DestVar |
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
G7File | String | G7File |
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZuliFile | String | ZuliFile |


Index archive
ObjectModel COM [image] RtFunction [image] DynProperties [image] Index archive
Overview
External Name | Type | Display Name | Description
ArvBackup | Bool | @Use backup folder@ |
ArvName | String | ArvName |
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Language change
ObjectModel COM [image] RtFunction [image] DynProperties [image] Language change
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
FileDirectory | String | FileDirectory |
FileName | String | FileName |
FontList | String | FontList |
GraphicsDirectory | String | GraphicsDirectory |
HelpDirectory | String | HelpDirectory |
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
MediaDirectory | String | MediaDirectory |
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
RDLDirectory | String | RDLDirectory |
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


License information function
ObjectModel COM [image] RtFunction [image] DynProperties [image] License information function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


List of active archives
ObjectModel COM [image] RtFunction [image] DynProperties [image] List of active archives
Overview
External Name | Type | Display Name | Description
ArvName | String | ArvName |
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Login without password
ObjectModel COM [image] RtFunction [image] DynProperties [image] Login without password
Overview
External Name | Type | Display Name | Description
Alias | String | Alias | Sets or returns the name of the user for the login.
CodeFlag | Bool | CodeFlag | Description
CodeVariable | CProjektVariable | CodeVariable | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
Userflag | Bool | Userflag |
Variable | CProjektVariable | Variable |


Manage addin service function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Manage addin service function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


MtConcurrentExecutionFunction
ObjectModel COM [image] RtFunction [image] DynProperties [image] MtConcurrentExecutionFunction
Overview
External Name | Type | Display Name | Description
AdviseAsync | Bool | AdviseAsync | Description
AdviseEndId | UInt32 | AdviseEndId | Description
AdviseLocal | Bool | AdviseLocal | Description
AdviseStartId | UInt32 | AdviseStartId | Description
AdviseValueAdjustment | Bool | AdviseValueAdjustment | Description
AdviseVars | Node | AdviseVars | Description
Command | Byte | Command | Description
CreateInitiatorEndId | UInt32 | CreateInitiatorEndId | Description
CreateInitiatorStartId | UInt32 | CreateInitiatorStartId | Description
CreateInitiatorVars | Node | CreateInitiatorVars | Description
DelayStartCommandEndId | UInt32 | DelayStartCommandEndId | Description
DelayStartCommandStartId | UInt32 | DelayStartCommandStartId | Description
DelayStartCommandVars |  | DelayStartCommandVars | Description
DelayStopCommandEndId | UInt32 | DelayStopCommandEndId | Description
DelayStopCommandStartId | UInt32 | DelayStopCommandStartId | Description
DelayStopCommandVars |  | DelayStopCommandVars | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
ReleaseInitiatorEndId | UInt32 | ReleaseInitiatorEndId | Description
ReleaseInitiatorStartId | UInt32 | ReleaseInitiatorStartId | Description
ReleaseInitiatorVars | Node | ReleaseInitiatorVars | Description
SbAdviseAsync | Bool | SbAdviseAsync | Description
SbAdviseEndId | UInt32 | SbAdviseEndId | Description
SbAdviseStartId | UInt32 | SbAdviseStartId | Description
SbAdviseVars |  | SbAdviseVars | Description
SbUnadviseAsync | Bool | SbUnadviseAsync | Description
SbUnadviseEndId | UInt32 | SbUnadviseEndId | Description
SbUnadviseStartId | UInt32 | SbUnadviseStartId | Description
SbUnadviseVars |  | SbUnadviseVars | Description
ShowRT | Bool | ShowRT | Description
SyncVoidCommandEndId | UInt32 | SyncVoidCommandEndId | Description
SyncVoidCommandStartId | UInt32 | SyncVoidCommandStartId | Description
SyncVoidCommandVars |  | SyncVoidCommandVars | Description
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
UnadviseAsync | Bool | UnadviseAsync | Description
UnadviseEndId | UInt32 | UnadviseEndId | Description
UnadviseLocal | Bool | UnadviseLocal | Description
UnadviseStartId | UInt32 | UnadviseStartId | Description
UnadviseValueAdjustment | Bool | UnadviseValueAdjustment | Description
UnadviseVars | Node | UnadviseVars | Description
VoidCommandEndId | UInt32 | VoidCommandEndId | Description
VoidCommandStartId | UInt32 | VoidCommandStartId | Description
VoidCommandVars |  | VoidCommandVars | Description
XorAdviseAsync | Bool | XorAdviseAsync | Description
XorAdviseEndId | UInt32 | XorAdviseEndId | Description
XorAdviseLocal | Bool | XorAdviseLocal | Description
XorAdviseStartId | UInt32 | XorAdviseStartId | Description
XorAdviseValueAdjustment | Bool | XorAdviseValueAdjustment | Description
XorAdviseVars | Node | XorAdviseVars | Description


CProjektVariableProp
ObjectModel COM [image] RtFunction [image] DynProperties [image] MtConcurrentExecutionFunction [image] CProjektVariableProp
Overview
External Name | Type | Display Name | Description
Title | CProjektVariable | Title | Gets or sets a variable object.


Open help
ObjectModel COM [image] RtFunction [image] DynProperties [image] Open help
Overview
External Name | Type | Display Name | Description
CHMFile | String | CHMFile |
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
HTMFile | String | HTMFile |
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Overview window function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Overview window function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
OverviewInfo | Node | OverviewInfo | Properties for the overview window
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


COverviewInfo
ObjectModel COM [image] RtFunction [image] DynProperties [image] Overview window function [image] COverviewInfo
Overview
External Name | Type | Display Name | Description
Action | Int16 | Action | "The function can display, toggle or close the overview window: 0 = Display 1 = Toggle 2 = Close "
Color1 | UInt32 | Color1 | Specifies the background color of the overview picture.
Color2 | UInt32 | Color2 | Specifies the color of the current view.
Color3 | UInt32 | Color3 | Specifies the frame color.
Color4 | UInt32 | Color4 | Specifies the selection color.
PosBottom | Int32 | PosBottom | Specifies the bottom position of the overview window on the screen (in pixel).
PosLeft | Int32 | PosLeft | Specifies the left position of the overview window on the screen (in pixel).
PosRight | Int32 | PosRight | Specifies the right position of the overview window on the screen (in pixel).
PosTop | Int32 | PosTop | Specifies the top position of the overview window on the screen (in pixel).
Style | UInt32 | Style | Specifies the style settings for the overview window: Hint: Multiple style settings have to be combined by ORing (Logical OR).
Type | Int16 | Type | "Selects, if monitors or templates are shown as frames in the overview window: 0 = Templates 1 = Montiors "


PFS event
ObjectModel COM [image] RtFunction [image] DynProperties [image] PFS event
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
Filter | Node | Filter | Node
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CFPUserEventFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] PFS event [image] CFPUserEventFilter
Overview
External Name | Type | Display Name | Description
EventID | String | EventID |


Play sound file
ObjectModel COM [image] RtFunction [image] DynProperties [image] Play sound file
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
FileName | String | FileName | "Gets or sets the path of the program that should be executed. Hint: Addtitional parameters can be passed with the ""FilePar"" DynProperty."
FilePar | String | FilePar | "Gets or sets the parameters for the program that is executed (specified by the ""FileName"" DynProperty)."
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsDialogRT | Bool | IsDialogRT | "Displays the program and parameter selection dialog within the runtime, if set TRUE."
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Playback mode function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Playback mode function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
PlaybackMode | Byte | PlaybackMode | Description
ShowRT | Bool | ShowRT | Description
StartingTime | UInt64 | StartingTime | Description
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Print a hard copy function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print a hard copy function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
Info | Node | Info | Specifies parameters for the hardcopy
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CHardCopyPrintInfo
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print a hard copy function [image] CHardCopyPrintInfo
Overview
External Name | Type | Display Name | Description
IsFax | Bool | IsFax | "If set TRUE, the hardcopy will routed to a facsimile."
IsInvert | Bool | IsInvert | "If set TRUE, the hardcopy will be inverted."
IsOffset | Bool | IsOffset | "If set TRUE, the hardcopy will be printed with a margin."
IsScreen | Bool | IsScreen | "If set TRUE the whole screen will be incorporated for the hardcopy. Otherwise (FALSE) the template specified in the ""Picture"" DynProperty will be consulted for the hardcopy."
Monitor | Int16 | Monitor | "Monitor Id, only relevant if multi monitor solutions are used."
Picture | String | Picture | "Specifies the template that is utilized for the hardcopy. Hint: This property is only considered, if the ""IsScreen"" DynProperty is set to FALSE."


Print actual values function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print actual values function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
FormatInfo | Node | FormatInfo | Defines the parameters for the print
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CFormatInfo
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print actual values function [image] CFormatInfo
Overview
External Name | Type | Display Name | Description
Font | UInt32 | Font | "Defines the font that is utilized for the print. The parameter that is passed, is the index of the font within the specified font list. 0 = Standard font 1 = Default font 1 5 = Default font 5 6 = User defined font 1 "
FormatFile | String | FormatFile | Defines the path and name of the format file for the print.
IsCancel | Bool | IsCancel | "Displays the cancel dialog, if set true. Otherwise the dialog is hidden and the print can't be stopped by means of the program."


Print alarm or CEL list
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print alarm or CEL list
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
Filter | Node | Filter | Node
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsCEL | Bool | IsCEL | Description
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CD_CAmlCelFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print alarm or CEL list [image] CD_CAmlCelFilter
Overview
External Name | Type | Display Name | Description
Areas | String | Areas |
Classes | String | Classes | "Filters for alarm classes, where system messages are marked out, as they are not linked to a variable. Multiple class numbers have to be seperated with a semicolon. zFct.DynProperties(""PictFilter.Classes"") = ""1;2;"""
EditableInRT | Bool | EditableInRT | Description as text.
EntriesCount | UInt16 | EntriesCount | "Specifies the maximum amount of entries that should be filtered from a file. Hint: Only available, if the DynProperty ""IsFromFiles"" is set TRUE."
FileName | String | FileName | With this property you get/set the file name for the different export mechanism.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
FilterTitel | String | FilterTitel | "Filters for the identifictaion of variables, where system messages are masked out, as they are not linked to a variable. Wildcards can be used here. Default = ""*"""
Font | UInt16 | Font | "Specifies the font that should be used. The parameter that is passed, is the index of the font within the specified font list. 0 = Standard font 1 = Default font 1 ... 5 = Default font 5 6 = User specified font 1 ... = etc. "
Groups | String | Groups | "Filters for alarm groups, where system messages are marked out, as they are not linked to a variable. Multiple group numbers have to be seperated with a semicolon. zFct.DynProperties(""PictFilter.Groups"") = ""1;2;"""
IncTime | UInt32 | IncTime | "Gets or sets the minimal time for current alarms in seconds. Hint: Milliseconds can be specified with the ""mSeconds"" DynProperty."
IsAcknowledged | Bool | IsAcknowledged | "Filters unacknowledged alarms, if set TRUE."
IsAML | Bool | IsAML | "Prints the alarm list, if set TRUE. Otherwise the CEL list will be printed."
IsAscentOnly | Bool | IsAscentOnly | "Prints only current alarms, if set TRUE."
IsAutoName | Bool | IsAutoName |
IsDBASE | Bool | IsDBASE |
IsFilterExp | Bool | IsFilterExp | "Opens the list stopped, if set TRUE. "
IsFilterRT | Bool | IsFilterRT | "Displays the configuration dialog within the runtime, if set TRUE."
IsFromFiles | Bool | IsFromFiles | "Filter is applied to file entries, if set TRUE. Otherwise, the filter is applied to the entries from the memory. Hint: The maximum amount of entries which should be filtered from the file is specified by the ""EntriesCount"" DynProperty."
IsGoneOnly | Bool | IsGoneOnly |
IsIncremental | Bool | IsIncremental |
IsMatchCase | Bool | IsMatchCase | "Filter is case sensitive, if set TRUE. Otherwise the case sensitivity is ignored."
IsReadAll | Bool | IsReadAll |
IsRelationTime | Bool | IsRelationTime | "Display of relative times (relative to selected entries), if set TRUE."
IsSQL | Bool | IsSQL |
IsUnicode | Bool | IsUnicode |
IsXML | Bool | IsXML |
ListInfo | Node | ListInfo | Node
mSeconds | UInt16 | mSeconds | "Gets or sets the milliseconds in addition to the ""IncTime"" DynProperty."
NeedAlarmCause | Bool | NeedAlarmCause | Description
NeedComment | Bool | NeedComment |
ProjectNames | String | ProjectNames | "Specifies the names of the projects. Multiple project names are seperated with a semicolon. zFct.DynProperties(""PictFilter.ProjectNames"") = ""PROJECT1;PROJECT2;"""
ResString | String | ResString |
RTMDIFilterScreen | Node | RTMDIFilterScreen | Node
SQLBase | String | SQLBase |
SQLTable | String | SQLTable |
StatusFilter | Node | StatusFilter | Node
SystemModelGroup | Node | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
TextFilter | Node | TextFilter | Node
TimeFilter | Node | TimeFilter | Node
VarFilter | String | VarFilter | "Filters for variable names, where system messages are masked out, as they are not linked to a variable. Wildcards can be used here. Default = ""*"" (All variables)"


Print report function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print report function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
Filter | Node | Filter | Description as text.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CReportViewerFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print report function [image] CReportViewerFilter
Overview
External Name | Type | Display Name | Description
BatchFilter | Node | BatchFilter | Description as text.
DataSet | Node | DataSet | Node
EditableInRT | Bool | EditableInRT | Description as text.
Fct_Filename | String | Fct_Filename | Description as text.
Fct_NameFromVar | Bool | Fct_NameFromVar | Description as text.
Fct_OverwriteFile | Bool | Fct_OverwriteFile | Description as text.
Fct_RenderDo | Int32 | Fct_RenderDo | Description as text.
Fct_Variable | CProjektVariable | Fct_Variable | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
RDLFile | String | RDLFile |
RTMDIFilterScreen | Node | RTMDIFilterScreen | Description as text.
TimeFilter | Node | TimeFilter | Node


CBatchRecipeFilterReportViewer
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print report function [image] CReportViewerFilter [image] CBatchRecipeFilterReportViewer
Overview
External Name | Type | Display Name | Description
CaseSensitive | Bool | CaseSensitive | Description
CrCurrentness | Int32 | CrCurrentness | Description as text.
CrState | Int32 | CrState | Description as text.
CRTextFilter | String | CRTextFilter | Description as text.
FilterForRecipeType | Int32 | FilterForRecipeType | Description as text.
MrCurrentness | Int32 | MrCurrentness | Description as text.
MrState | Int32 | MrState | Description as text.
MRTextFilter | String | MRTextFilter | Description as text.
PV_CR | CProjektVariable | PV_CR | Description as text.
PV_MR | CProjektVariable | PV_MR | Description as text.
SelectionFromPicture | Bool | SelectionFromPicture | Description as text.
SettingCR | Int32 | SettingCR | Description as text.
SettingMR | Int32 | SettingMR | Description as text.
VersionNum | UInt32 | VersionNum | Description as text.
VersionSearchType | Int32 | VersionSearchType | Description as text.
VersionVar | CProjektVariable | VersionVar | Description as text.


CD_CZeitFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print report function [image] CReportViewerFilter [image] CD_CZeitFilter
Overview
External Name | Type | Display Name | Description
AddLen | UInt16 | AddLen | "Specifies if the length value (""Length"" DynProperty) should be added or subtracted. 0 = Subtract length 1 = Add length "
ARVTime1 | UInt32 | ARVTime1 | "Specifies the start time of the filter. zFct.DynProperties(""Filter.TimeFilter.ARVTime1"") = CDate(""30.07.2007 12:00:00"")"
ARVTime2 | UInt32 | ARVTime2 | Specifies the end time of the filter.
BoxenType | UInt16 | BoxenType |
ChargeFilter | Node | ChargeFilter | Batch filter settings
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
Length | UInt32 | Length | "Specifies the value of the length (in seconds) that should be added or subtracted (see ""AddLen"" DynProperty)."
ModifyTimePeriod | Bool | ModifyTimePeriod |
Offset | UInt32 | Offset | "Specifies the offset (in seconds) for the ""BoxType"" DynProperty option 1 to 8."
Options | UInt16 | Options |
ResString | String | ResString |
ShiftFilter | Node | ShiftFilter | Description
TimeFormat | UInt16 | TimeFormat | "Specifies the time format for the filter. ATTENTION: Can only be used, if ""BoxType"" DynProperty is set to 0. 10 = Time relative 12 = Absolute time 14 = From the specified day 20 = From month 22 = From year 25 = All "


CRelPicItem
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print report function [image] CReportViewerFilter [image] CRelPicItem
Overview
External Name | Type | Display Name | Description
RelatedPicture | String | Screen for time filter |


CRptDatSet
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print report function [image] CReportViewerFilter [image] CRptDatSet
Overview
External Name | Type | Display Name | Description
Calc | Int32 | Calc | Description as text.
DatSetType | Int32 | DatSetType |
Filter |  | Filter |
MaxRowCount | Int32 | MaxRowCount | Description as text.
Name | String | Name |
TimeFilterIdx | Int16 | TimeFilterIdx |
UseBackupFolder | Bool | UseBackupFolder | Description


Print trend
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend
Overview
External Name | Type | Display Name | Description
Diagram | Node | Diagram | Node
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CDiagram
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram
Overview
External Name | Type | Display Name | Description
BordBottom | Int32 | BordBottom | Distance between the lower edge of the control element and the X-axis (Origin 0%-Y-axis) ATTENTION: Room for two-line labelling of the X-axis for the configured user defined font.
BordLeft | Int32 | BordLeft | Distance between the lower edge of the control element and the X-axis (Origin 0%-Y-axis) ATTENTION: Room for the left-hand side labelling of the Y-axis for the configured user defined font.
BordRight | Int32 | BordRight | Distance between the lower edge of the control element and the X-axis (Origin 100%-Y-axis) ATTENTION: Room for the right-hand side labelling of the Y-axis for the configured user defined font.
BordTop | Int32 | BordTop | Distance between the upper edge of the control element and the trend curves represented inside it. ATTENTION: Room for later optional showing of stored details with active pointer.
Curve | Node | Curve | Node
DataSource | Int16 | DataSource |
DateWidth | Int16 | DateWidth | Column width for the time stamp in the legend.
DelayRefresh | UInt32 | DelayRefresh |
EditableInRT | Bool | EditableInRT | Description as text.
FillingStyle | Guid | Fill style |
FilterPartGUID | Guid | FilterPartGUID | Description as text.
FirstCursorVar | CProjektVariable | FirstCursorVar | Description
Font | UInt16 | Font | Selection or setting of the user defined font for the axis labels and the value indicators.
GanttGap | UInt32 | GanttGap | Description
GanttOrder | UInt32 | GanttOrder | Description
GanttRefPos | UInt32 | GanttRefPos | Description
GridColor | UInt32 | GridColor | Color of the overlaying grid.
HGColor | UInt32 | HGColor | Background colour of the displayed graphics.
IndexSubstiCaseSensitive | Bool | IndexSubstiCaseSensitive | Description
IndexSubstitutionRule | Node | IndexSubstitutionRule | Description
IndexVar | Node | IndexVar | Description
IsArchive | Bool | IsArchive |
IsBackup | Bool | IsBackup | "Use of historic archives from the backup path, if set TRUE. Hint: Only available, if DynProperty ""IsArchive"" is set TRUE."
IsBorder | Bool | IsBorder |
IsDateAct | Bool | IsDateAct |
IsDeltaData | Bool | IsDeltaData | Description as text.
IsExponent | Bool | IsExponent |
IsGanttAutoPos | Bool | IsGanttAutoPos | Description
IsHeaderAct | Bool | IsHeaderAct |
IsMaxAct | Bool | IsMaxAct | "Activation (TRUE) / deactivation (FALSE) of DynProperty ""MaxWidth""."
IsMinAct | Bool | IsMinAct | "Activation (TRUE) / deactivation (FALSE) of DynProperty ""MinWidth""."
IsMWAct | Bool | IsMWAct | "Activation (TRUE) / deactivation (FALSE) of DynProperty ""MWWidth""."
IsQuantityAct | Bool | IsQuantityAct |
IsShowXYCross | Bool | IsShowXYCross | Description
IsSmartArchive | Bool | IsSmartArchive |
IsSortData | Bool | IsSortData | Description as text.
IsStateAct | Bool | IsStateAct | "Activation (TRUE) / deactivation (FALSE) of DynProperty ""StateWidth""."
IsStatusAct | Bool | IsStatusAct | "Activation (TRUE) / deactivation (FALSE) of DynProperty ""StatusWidth""."
IsStdDevAct | Bool | IsStdDevAct |
IsSumAct | Bool | IsSumAct |
IsTimeDiffAct | Bool | IsTimeDiffAct |
IsUnitsAct | Bool | IsUnitsAct |
IsValueAct | Bool | IsValueAct |
IsValueDiffAct | Bool | IsValueDiffAct |
IsVarAct | Bool | IsVarAct |
IsXAxis | Bool | IsXAxis | "If set TRUE, the XY (X-Axis) diagram style is used. Otherwise (FALSE) the standard XT (Time axis) representation is utilized."
LineStyle | Guid | Line style | Display and selection of the line style that is assigned to the element. .
ListConfig |  | ListConfig |
MaxWidth | Int16 | MaxWidth | "Column width for the maximum of the variable value in the displayed time period in the legend. Hint: Activation/deactivation of the maximum with DynProperty ""IsMaxAct""."
MinWidth | Int16 | MinWidth | "Column width for the minimum of the variable value in the displayed time period in the legend. Hint: Activation/deactivation of the minimum with DynProperty ""IsMinAct""."
MWWidth | Int16 | MWWidth | "Column width for the mean value of the variable value in the displayed time period in the legend. Hint: Activation/deactivation of the mean value with DynProperty ""IsMWAct"". "
Name | String | Name | "Freely configurable diagram name. Can be shown in the control element. If the string in the diagram name contains the character combination %c, this combination is replaced by the name of the batch(es) reaching into the defined filter during online operation. e.g. Diagram name = ""Diagram1_%C%_End"" = ""Diagram1_Batch1_End"" in the runtime"
PaddingStyle | Guid | Padding style | Display and selection of the padding style that is assigned to the element. .
PrintData | Node | PrintData | Node
QuantityWidth | Int16 | QuantityWidth |
RefreshRate | float | RefreshRate | Definition of the screen updating in seconds. Minimum: 0.1
ScrollWidth | Int16 | ScrollWidth | "Specifies the screen scrolling, if the right edge of the diagram has been reached. ATTENTION: Only for diagrams with online values."
SecondCursorVar | CProjektVariable | SecondCursorVar | Description
StateWidth | Int16 | StateWidth | "Column width for the condition in the legend. Hint: Activation/deactivation of the condition with ""IsStateAct""."
StatusWidth | Int16 | StatusWidth | "Column width for the status in the legend. Hint: Activation/deactivation of the status with DynProperty ""IsStatusAct""."
StdDevWidth | Int16 | StdDevWidth |
StyleGroup | Guid | Style group | Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .
SubstiFilterCurve |  | SubstiFilterCurve | Description
SubstiFilterVar |  | SubstiFilterVar | Description
SumWidth | Int16 | SumWidth |
TextStyle | Guid | Text style |
TimeAxe | Node | TimeAxe | Node
TimeDiffWidth | Int16 | TimeDiffWidth |
UnitsWidth | Int16 | UnitsWidth | Column width for the unit in the legend.
ValueDiffWidth | Int16 | ValueDiffWidth |
ValueWidth | Int16 | ValueWidth | Column width for the variable value in the legend.
VarWidth | Int16 | VarWidth | Column width for the variable name in the legend.
XAxe | Node | XAxe | Node
XYStart | UInt32 | XYStart |


CIndexSubsti
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram [image] CIndexSubsti
Overview
External Name | Type | Display Name | Description
Destination | String | Destination | "The name of the variable, which should replace the source."
Source | String | Source | "The name of the variable linked in the picture, which should be replaced."


CKurve
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram [image] CKurve
Overview
External Name | Type | Display Name | Description
Charge | String | Charge |
Color | UInt32 | Color | Definition of the trend curve colour for the online representation.
CurveInfo | String | Source | Description
CurveLabeling | UInt32 | CurveLabeling | Description
CurveOrder | UInt32 | Sorting order |
CurveStyle | Guid | Curve style | Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .
DayOffset | Int32 | DayOffset | Specifies the day offset of the curve within the diagram.
FillAlpha | SByte | FillAlpha |
FillColor | UInt32 | FillColor | Description
GraphName | String | Curve name | Freely definable curve name.
GraphWidth | Int16 | Line width | Line width of the curve display in Runtime. Configuration of the line width in pixels.Default: 1 px .
HasYAxis | Bool | Y axis | "Displays the Y axis for the corresponding curve, if set TRUE. Otherwise (FALSE), the Y axis will be hidden."
HourOffset | Int32 | HourOffset | Specifies the hour offset of the curve within the diagram.
Index | Int16 | Index |
IsBars | Bool | Area display | The values are shown as two-dimensional instead of lines if active . .
IsExtendCurve | Bool | Lengthen curve | The curve is lengthened from the last-available datapoint to the right border if active . .
IsGantt | Bool | Graph | Type of graph display in zenon Runtime. Selection from a drop-down list:Curve : Values are displayed as a curve.Gantt : Gantt display of the values.Default: Curve .
IsGanttFromString | Bool | IsGanttFromString | Description as text.
IsGanttShowLimit | Bool | Show limit value | Shows the numerical limit value.Default: Inactive .
IsGanttShowLimitText | Bool | Show limit value text | Displays the description of the limit value.Default: Inactive .
IsInterpolation | Bool | Interpolation | Type of display of value changes in RuntimeActive: Values are connected using polylines (supporting positions).Inactive: Value changes are displayed as line jumps (stepped display).Default: Inactive .
IsMonthChange | Bool | IsMonthChange |
IsShow | Bool | Active | "Shows the selected curve, if set TRUE. Otherwise, the curve and the corresponding Y axis will be hidden. Hint: To hide only the Y axis, please use the DynProperty ""HasYAxis""."
IsTrigger | Bool | IsTrigger |
IsYearChange | Bool | IsYearChange |
LineType | Int16 | Line type | Type of curve line for display in Runtime. Select from drop-down list.Default: Solid line .
MinuteOffset | Int32 | MinuteOffset | Specifies the minute offset of the curve within the diagram.
TimeFactor | Int16 | TimeFactor |
Titel | String | Title | Text for the axis labelling in the online representation.
TrendLabelingVar | CProjektVariable | TrendLabelingVar | Description
TrendVisibilityVar | CProjektVariable | TrendVisibilityVar | Description
VariableName | String | Variable name | Description as text.
VariableTagNr | String | Variable identification |
VarInfo | Node | VarInfo | Node
XScan | Int16 | XScan |
YAxe | Node | YAxe | Node
YOffset | Int16 | Distance from the top edge | Distance of the display in Runtime from the top border in pixels.Default: 0 .
YScan | Int16 | YScan |


CKanal
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram [image] CKurve [image] CKanal
Overview
External Name | Type | Display Name | Description
Archive | String | Archive | "Specifies the short name of the archive, where the variable is linked to."
ArvVar | String | ArvVar |
AutoArchive | Bool | AutoArchive | Description
Calculation | UInt16 | Calculation |
SrcCalculation | UInt16 | SrcCalculation |
SrcVar | String | SrcVar |
Variable | CProjektVariable | Variable | "Gets or sets a ""Variable"" object, specifying the variable from which the curve is generated."
VarMaxValue | double | VarMaxValue | Specifies the maximum variable value.
VarMinValue | double | VarMinValue | Specifies the minimum variable value.
VarName | String | VarName | Specifies the variable name.


CYAchse
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram [image] CKurve [image] CYAchse
Overview
External Name | Type | Display Name | Description
AxisLabeling | UInt32 | AxisLabeling | Description
BeginTime | UInt32 | BeginTime |
Color | UInt32 | Color | Specifies the axis colour. ATTENTION: Can be configured independently of the trend curve color.
DivCount | Int16 | DivCount | "Number of subdivisions between two main subdivisions (DynProperty ""MainDiv"")."
DivLen | Int16 | DivLen | "Length of the main subdivision lines (DynProperty ""MainDiv"") in pixel."
EndTime | UInt32 | EndTime |
FirstOrd | Int32 | FirstOrd | "Position of the X-axis in the diagram (0=bottom, 100=top) "
IsAutoScale | Bool | IsAutoScale | "Automatic setting of scaling and axis subdivision in online operation, if set TRUE."
IsExpScale | Bool | IsExpScale | "Displays the value steps of the Y axis in exponential notation, if set TRUE. Otherwise (FALSE), the values are displayed in the conventional way."
IsGrid | Bool | IsGrid | "Representation of help lines on the main subdivisions, if set TRUE."
IsLog | Bool | IsLog | "Utilizes logarithmic division of the Y-axis, if set TRUE. Otherwise (FALSE), linear division of the Y-axis is used."
IsOwnArv | Bool | IsOwnArv |
IsShow | Bool | IsShow |
IsTitelLeftBotton | Bool | IsTitelLeftBotton | Position of the axis labelling: TRUE = Bottom FALSE = Top
IsUnitDisabled | Bool | IsUnitDisabled |
IsYAutoScale | Bool | IsYAutoScale | Description as text.
LeftOffset | Int32 | LeftOffset |
LogBotton | double | LogBotton |
LogMainDiv | Int16 | LogMainDiv |
LogTop | double | LogTop |
MainDiv | Int16 | MainDiv | Number of main subdivisions of the axis with value indication.
MaxArv | Int32 | MaxArv |
OldDiff | double | OldDiff |
OldMainDiv | Int16 | OldMainDiv |
RightOffset | Int32 | RightOffset |
Scale | Node | Scale | Node
ScaleStyle | Guid | Scales style | Display and selection of the scale style that is assigned to the element. .
TickCalculation | UInt32 | TickCalculation | Description
TimeOffset | float | TimeOffset |
Titel | String | Titel | Text of the axis labelling in online representation.
TrendLabelingVar | CProjektVariable | TrendLabelingVar | Description


CAchsenScala
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram [image] CKurve [image] CYAchse [image] CAchsenScala
Overview
External Name | Type | Display Name | Description
ScaleBotton | double | ScaleBotton | Defines the bottom of the representation range for the process variables (Zoom function).
ScaleTop | double | ScaleTop | Defines the top of the representation range for the process variables (Zoom function).
TriggerOffset | Int32 | TriggerOffset |


CProjektVariableProp
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram [image] CProjektVariableProp
Overview
External Name | Type | Display Name | Description
Title | CProjektVariable | Title | Gets or sets a variable object.


CTrendPrintData
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram [image] CTrendPrintData
Overview
External Name | Type | Display Name | Description
Comment | String | Comment | Specifies a comment for the print-out of the extended trend.
DiaHeight | Int32 | DiaHeight |
DiaWidth | Int32 | DiaWidth |
FileName | String | FileName |
FootLeft | String | FootLeft | "Specifies the footer text, which is positioned on the bottom left-hand corner of the page. Hint: Following placeholders are allowed: %ZEIT% = Prints current time %DATUM% = Current date %SEITE% = Page number %DIAGRAMMNAME% = Diagram name"
FootMid | String | FootMid | "Specifies the footer text, which is centered on the bottom of the page. Hint: For further information, please have a look at the DynProperty ""FootLeft"" part."
FootRight | String | FootRight | "Specifies the footer text, which is positioned on the bottom right-hand corner of the page. Hint: For further information, please have a look at the DynProperty ""FootLeft"" part."
HeadLeft | String | HeadLeft | "Specifies the header text, which is positioned on the top left-hand corner of the page. Hint: For further information, please have a look at the DynProperty ""FootLeft"" part."
HeadMid | String | HeadMid | "Specifies the header text, which is centered on the top of the page. Hint: For further information, please have a look at the DynProperty ""FootLeft"" part."
HeadRight | String | HeadRight | "Specifies the header text, which is positioned on the top right-hand corner of the page. Hint: For further information, please have a look at the DynProperty ""FootLeft"" part."
IsFile | Bool | IsFile |
IsLegend | Bool | IsLegend | A legend indicating the color of each curve can be activated for the print-out of the extended trend.
IsOneSite | Bool | IsOneSite | "Specifies, whether the legend and the trend curves should be on the same page."
Titel | String | Titel | Specifies the titel for the print-out of the extended trend.


CXAchse
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram [image] CXAchse
Overview
External Name | Type | Display Name | Description
AxisLabeling | UInt32 | AxisLabeling | Description
BeginTime | UInt32 | BeginTime |
Color | UInt32 | Color | Specifies the axis colour. ATTENTION: Can be configured independently of the trend curve color.
DivCount | Int16 | DivCount | "Number of subdivisions between two main subdivisions (DynProperty ""MainDiv"")."
DivLen | Int16 | DivLen | "Length of the main subdivision lines (DynProperty ""MainDiv"") in pixel."
EndTime | UInt32 | EndTime |
FirstOrd | Int32 | FirstOrd | "Position of the X-axis in the diagram (0=bottom, 100=top) "
IsAutoScale | Bool | IsAutoScale | "Automatic setting of scaling and axis subdivision in online operation, if set TRUE."
IsExpScale | Bool | IsExpScale | "Displays the value steps of the Y axis in exponential notation, if set TRUE. Otherwise (FALSE), the values are displayed in the conventional way."
IsFilterDlg | Bool | IsFilterDlg |
IsGrid | Bool | IsGrid | "Representation of help lines on the main subdivisions, if set TRUE."
IsLog | Bool | IsLog | "Utilizes logarithmic division of the Y-axis, if set TRUE. Otherwise (FALSE), linear division of the Y-axis is used."
IsOwnArv | Bool | IsOwnArv |
IsShow | Bool | IsShow |
IsTitelLeftBotton | Bool | IsTitelLeftBotton | Position of the axis labelling: TRUE = Bottom FALSE = Top
IsUnitDisabled | Bool | IsUnitDisabled |
IsYAutoScale | Bool | IsYAutoScale | Description as text.
LeftOffset | Int32 | LeftOffset |
LogBotton | double | LogBotton |
LogMainDiv | Int16 | LogMainDiv |
LogTop | double | LogTop |
MainDiv | Int16 | MainDiv | Number of main subdivisions of the axis with value indication.
MaxArv | Int32 | MaxArv |
OldDiff | double | OldDiff |
OldMainDiv | Int16 | OldMainDiv |
RightOffset | Int32 | RightOffset |
RTMDIFilterScreen | Node | RTMDIFilterScreen | Description as text.
Scale | Node | Scale | Node
ScaleStyle | Guid | Scales style | Display and selection of the scale style that is assigned to the element. .
TickCalculation | UInt32 | TickCalculation | Description
TimeFilter | Node | TimeFilter | Node
TimeOffset | float | TimeOffset |
Titel | String | Titel | Text of the axis labelling in online representation.
TrendLabelingVar | CProjektVariable | TrendLabelingVar | Description


CAchsenScala
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram [image] CXAchse [image] CAchsenScala
Overview
External Name | Type | Display Name | Description
ScaleBotton | double | ScaleBotton | Defines the bottom of the representation range for the process variables (Zoom function).
ScaleTop | double | ScaleTop | Defines the top of the representation range for the process variables (Zoom function).
TriggerOffset | Int32 | TriggerOffset |


CD_CZeitFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram [image] CXAchse [image] CD_CZeitFilter
Overview
External Name | Type | Display Name | Description
AddLen | UInt16 | AddLen | "Specifies if the length value (""Length"" DynProperty) should be added or subtracted. 0 = Subtract length 1 = Add length "
ARVTime1 | UInt32 | ARVTime1 | "Specifies the start time of the filter. zFct.DynProperties(""Filter.TimeFilter.ARVTime1"") = CDate(""30.07.2007 12:00:00"")"
ARVTime2 | UInt32 | ARVTime2 | Specifies the end time of the filter.
BoxenType | UInt16 | BoxenType |
ChargeFilter | Node | ChargeFilter | Batch filter settings
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
Length | UInt32 | Length | "Specifies the value of the length (in seconds) that should be added or subtracted (see ""AddLen"" DynProperty)."
ModifyTimePeriod | Bool | ModifyTimePeriod |
Offset | UInt32 | Offset | "Specifies the offset (in seconds) for the ""BoxType"" DynProperty option 1 to 8."
Options | UInt16 | Options |
ResString | String | ResString |
ShiftFilter | Node | ShiftFilter | Description
TimeFormat | UInt16 | TimeFormat | "Specifies the time format for the filter. ATTENTION: Can only be used, if ""BoxType"" DynProperty is set to 0. 10 = Time relative 12 = Absolute time 14 = From the specified day 20 = From month 22 = From year 25 = All "


CRelPicItem
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram [image] CXAchse [image] CRelPicItem
Overview
External Name | Type | Display Name | Description
RelatedPicture | String | Screen for time filter |


CZeitAchse
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram [image] CZeitAchse
Overview
External Name | Type | Display Name | Description
AddLen | UInt16 | AddLen |
AxisLabeling | UInt32 | AxisLabeling | Description
BoxType | UInt16 | BoxType |
Color | UInt32 | Color | Specifies the axis colour. ATTENTION: Can be configured independently of the trend curve color.
DivCount | Int16 | DivCount | "Number of subdivisions between two main subdivisions (DynProperty ""MainDiv"")."
DivLen | Int16 | DivLen | "Length of the main subdivision lines (DynProperty ""MainDiv"") in pixel."
FirstOrd | Int32 | FirstOrd | "Position of the X-axis in the diagram (0=bottom, 100=top) "
GrabPointSize | Int32 | GrabPointSize |
IsAutoScale | Bool | IsAutoScale | "Automatic setting of scaling and axis subdivision in online operation, if set TRUE."
IsDay | Bool | IsDay | "Specifies, if the day of the time stamps should be displayed next to the time axis."
IsExpScale | Bool | IsExpScale | "Displays the value steps of the Y axis in exponential notation, if set TRUE. Otherwise (FALSE), the values are displayed in the conventional way."
IsFilterRT | Bool | IsFilterRT | "Displays the filter configuration dialog within the runtime, if set TRUE."
IsGrid | Bool | IsGrid | "Representation of help lines on the main subdivisions, if set TRUE."
IsHour | Bool | IsHour | "Specifies, if the hour of the time stamps should be displayed next to the time axis."
IsLog | Bool | IsLog | "Utilizes logarithmic division of the Y-axis, if set TRUE. Otherwise (FALSE), linear division of the Y-axis is used."
IsMilliSecond | Bool | IsMilliSecond | "Specifies, if the milliseconds of the time stamps should be displayed next to the time axis."
IsMinute | Bool | IsMinute | "Specifies, if the minutes of the time stamps should be displayed next to the time axis."
IsMonth | Bool | IsMonth | "Specifies, if the month of the time stamps should be displayed next to the time axis."
IsRealTime | Bool | IsRealTime | "Representation of the time in online operation: If the option is set TRUE, then the axis is provided with the existing time marks. If the option is set FALSE, then the current time is 00:00 and the axis is labelled relatively in the past: -01:00 "
IsSecond | Bool | IsSecond | "Specifies, if the seconds of the time stamps should be displayed next to the time axis."
IsTime | Bool | IsTime | Only available for momentary switches: If the mouse cursor is moved away from the switch with the mouse key pressed down, the value of the variable is automatically reset.
IsTitelLeftBotton | Bool | IsTitelLeftBotton | Position of the axis labelling: TRUE = Bottom FALSE = Top
IsUnitDisabled | Bool | IsUnitDisabled |
IsVarTime | Bool | IsVarTime | Description
IsYear | Bool | IsYear | "Specifies, if the year of the time stamps should be displayed next to the time axis."
Length | UInt32 | Length |
LogBotton | double | LogBotton |
LogMainDiv | Int16 | LogMainDiv |
LogTop | double | LogTop |
MainDiv | Int16 | MainDiv | Number of main subdivisions of the axis with value indication.
Offset | UInt32 | Offset |
OldDiff | double | OldDiff |
OldMainDiv | Int16 | OldMainDiv |
Options | UInt16 | Options |
Overlap | Int32 | Overlap |
RTMDIFilterScreen | Node | RTMDIFilterScreen | Description as text.
Scale | Node | Scale | Node
ScaleStyle | Guid | Scales style | Display and selection of the scale style that is assigned to the element. .
TickCalculation | UInt32 | TickCalculation | Description
Time1 | UInt32 | Time1 |
Time2 | UInt32 | Time2 |
TimeDay | UInt32 | TimeDay |
TimeFilter | Node | TimeFilter | Node
TimeFormat | UInt16 | TimeFormat |
TimeHours | UInt32 | TimeHours |
TimeMinutes | UInt32 | TimeMinutes |
TimeRangeFrom | String | TimeRangeFrom |
TimeRangeTo | String | TimeRangeTo |
TrendLabelingVar | CProjektVariable | TrendLabelingVar | Description


CAchsenScala
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram [image] CZeitAchse [image] CAchsenScala
Overview
External Name | Type | Display Name | Description
ScaleBotton | double | ScaleBotton | Defines the bottom of the representation range for the process variables (Zoom function).
ScaleTop | double | ScaleTop | Defines the top of the representation range for the process variables (Zoom function).
TriggerOffset | Int32 | TriggerOffset |


CD_CZeitFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram [image] CZeitAchse [image] CD_CZeitFilter
Overview
External Name | Type | Display Name | Description
AddLen | UInt16 | AddLen | "Specifies if the length value (""Length"" DynProperty) should be added or subtracted. 0 = Subtract length 1 = Add length "
ARVTime1 | UInt32 | ARVTime1 | "Specifies the start time of the filter. zFct.DynProperties(""Filter.TimeFilter.ARVTime1"") = CDate(""30.07.2007 12:00:00"")"
ARVTime2 | UInt32 | ARVTime2 | Specifies the end time of the filter.
BoxenType | UInt16 | BoxenType |
ChargeFilter | Node | ChargeFilter | Batch filter settings
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
Length | UInt32 | Length | "Specifies the value of the length (in seconds) that should be added or subtracted (see ""AddLen"" DynProperty)."
ModifyTimePeriod | Bool | ModifyTimePeriod |
Offset | UInt32 | Offset | "Specifies the offset (in seconds) for the ""BoxType"" DynProperty option 1 to 8."
Options | UInt16 | Options |
ResString | String | ResString |
ShiftFilter | Node | ShiftFilter | Description
TimeFormat | UInt16 | TimeFormat | "Specifies the time format for the filter. ATTENTION: Can only be used, if ""BoxType"" DynProperty is set to 0. 10 = Time relative 12 = Absolute time 14 = From the specified day 20 = From month 22 = From year 25 = All "


CRelPicItem
ObjectModel COM [image] RtFunction [image] DynProperties [image] Print trend [image] CDiagram [image] CZeitAchse [image] CRelPicItem
Overview
External Name | Type | Display Name | Description
RelatedPicture | String | Screen for time filter |


Read dBase file
ObjectModel COM [image] RtFunction [image] DynProperties [image] Read dBase file
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
FileName | String | FileName | Gets or sets the path of the database file that should be read.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Read Write time variable
ObjectModel COM [image] RtFunction [image] DynProperties [image] Read Write time variable
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web |
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Time | Node | Time | Node
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CUhrzeit
ObjectModel COM [image] RtFunction [image] DynProperties [image] Read Write time variable [image] CUhrzeit
Overview
External Name | Type | Display Name | Description
Variable | CProjektVariable | Variable |


Recipegroup
ObjectModel COM [image] RtFunction [image] DynProperties [image] Recipegroup
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
RecipeName | String | RecipeName | Gets or sets the name of the recipe that should be executed.
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Recipegroup manager
ObjectModel COM [image] RtFunction [image] DynProperties [image] Recipegroup manager
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
Filter | Node | Filter | Node
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CRezeptFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Recipegroup manager [image] CRezeptFilter
Overview
External Name | Type | Display Name | Description
ColOrder | String | ColOrder |
ColOrderAll | String | ColOrderAll |
ColText_ActVal | String | ColText_ActVal |
ColText_Filter | String | ColText_Filter |
ColText_Identifier | String | ColText_Identifier |
ColText_Max | String | ColText_Max |
ColText_Min | String | ColText_Min |
ColText_Mode | String | ColText_Mode |
ColText_ResLabel | String | ColText_ResLabel |
ColText_Symbolism | String | ColText_Symbolism |
ColText_Unit | String | ColText_Unit |
ColText_Value | String | ColText_Value |
ColText_VarName | String | ColText_VarName |
ColWidth_ActVal | Int32 | ColWidth_ActVal |
ColWidth_Filter | Int32 | ColWidth_Filter |
ColWidth_Identifier | Int32 | ColWidth_Identifier |
ColWidth_Max | Int32 | ColWidth_Max |
ColWidth_Min | Int32 | ColWidth_Min |
ColWidth_Mode | Int32 | ColWidth_Mode |
ColWidth_ResLabel | Int32 | ColWidth_ResLabel |
ColWidth_Symbolism | Int32 | ColWidth_Symbolism |
ColWidth_Unit | Int32 | ColWidth_Unit |
ColWidth_Value | Int32 | ColWidth_Value |
ColWidth_VarName | Int32 | ColWidth_VarName |
DWPar1 | UInt32 | DWPar1 |
DWPar2 | UInt32 | DWPar2 |
DWPar3 | UInt32 | DWPar3 |
DWPar4 | UInt32 | DWPar4 |
DWPar5 | UInt32 | DWPar5 |
ExportExt | UInt32 | ExportExt | Defines the import/export format for the recipe file. 0 = Text file (TXT)
ExportFile | String | ExportFile | Defines the path and the name of the import/export file.
FileNameVar | CProjektVariable | FileNameVar | "Defines the name of the variable which contains the name for the import/export (DynProperty ""Modus"" options 3 and 4)."
FilterText | String | FilterText | this property defines the filter to open the RGM picture with in the runtime. Only variables with this Filtertext set will be shown.
FilterVar | CProjektVariable | FilterVar | This property defines which string variable will be used to open the RGM picture. The string in this variable will be used to show only the variables with this Filtertext.
FilterVarOn | Bool | FilterVarOn | Description as text.
FormatFile | String | FormatFile |
GrpVar | CProjektVariable | GrpVar |
ImportGroupName | Bool | ImportGroupName | Description as text.
IsAutoName | Int16 | IsAutoName | "If set TRUE, a name for the export file (DynProperty ""Modus"" option 3) will be automatically generated."
IsFilterRT | Bool | IsFilterRT | "Displays the recipe configuration dialog within the runtime, if set TRUE."
IsReadOnly | Bool | IsReadOnly | "If set TRUE, this property only allows the selection of a recipe within the runtime, but unlike ""IsRecOnly"" no recipe configuration is allowed. Hint: Only available, if DynProperty ""IsFilterRT"" is set TRUE."
IsRecNumName | Bool | IsRecNumName | "Specifies if the assigned variable contains the number (FALSE) or the name (TRUE) of the recipe. Hint: This property is only available, if DynProperty ""WithNumber"" specifies that the recipe selection is done via a variable."
IsRecOnly | Bool | IsRecOnly | "If set TRUE, this property only allows the selection of a recipe within the runtime. Hint: Only available, if DynProperty ""IsFilterRT"" is set TRUE."
IsWithFormat | Bool | IsWithFormat |
Modus | UInt32 | Modus | Defines the recipe mode. 0 = Execute recipe 1 = Duplicate and teach 2 = Read recipe 3 = Export recipe 4 = Import recipe 5 = Duplicate
PictName | String | PictName |
ProjectName | String | ProjectName | Description as text.
RecGroup | String | RecGroup | Specifies the name of the recipe group which contains the utilized RGM recipe.
Recipe | String | Recipe | Specifies the name of the recipe that should be operated. ATTENTION: The name of the recipe has to be the exact name of an existing RGM recipe.
RecipesListConfig |  | RecipesListConfig |
RecipeValueListConfig |  | RecipeValueListConfig | Description
RecNumber | UInt32 | RecNumber |
RecVar | CProjektVariable | RecVar | "Gets or sets a variable (""Variable"" object) that should be used, in order to select the recipe by name or number. "
ShowRowNr | Bool | ShowRowNr |
Status | UInt32 | Status |
StatusVar | CProjektVariable | StatusVar |
StatusVarOn | Bool | StatusVarOn | Description as text.
StrPar1 | String | StrPar1 |
StrPar2 | String | StrPar2 |
StrPar3 | String | StrPar3 |
StrPar4 | String | StrPar4 |
StrPar5 | String | StrPar5 |
SystemModelGroup | Node | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
TargetRecipe | String | TargetRecipe | "Defines the name of the target recipe to which should be copied. Hint: Only available for DynProperty ""Modus"" option 5 (""Duplicate"")."
TargetRecipeVar | CProjektVariable | TargetRecipeVar |
TargetRecipeVarOn | Bool | TargetRecipeVarOn | Description as text.
TargetStatus | UInt32 | TargetStatus |
TargetStatusVar | CProjektVariable | TargetStatusVar |
TargetStatusVarOn | Bool | TargetStatusVarOn | Description as text.
TargetVersion | UInt32 | TargetVersion |
TargetVersionVar | CProjektVariable | TargetVersionVar |
TargetVersionVarOn | Bool | TargetVersionVarOn | Description as text.
TextFilter | Node | TextFilter | Node
Version | UInt32 | Version |
VersionVar | CProjektVariable | VersionVar |
VersionVarOn | Bool | VersionVarOn | Description as text.
WithGrpVar | Bool | WithGrpVar |
WithNumber | UInt32 | WithNumber | Specifies it the recipe should be selected with a variable. 0 = No recipe selection 1 = Recipe selection with variable
XMLExpOverwriteFile | Bool | XMLExpOverwriteFile |
XMLImpOverwriteRecipe | Bool | XMLImpOverwriteRecipe |


CSystemModelFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Recipegroup manager [image] CRezeptFilter [image] CSystemModelFilter
Overview
External Name | Type | Display Name | Description
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
SystemModelGroup | CD_CMemFile | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .


CTextFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Recipegroup manager [image] CRezeptFilter [image] CTextFilter
Overview
External Name | Type | Display Name | Description
Condition | UInt16 | Condition |
EditableInRT | Bool | EditableInRT | Description as text.
Expression | String | Expression |
FilterPartGUID | Guid | FilterPartGUID | Description as text.
IsFilterActive | Bool | IsFilterActive |
IsMatchCase | Bool | IsMatchCase |
IsSubFind | Bool | IsSubFind |


Reload
ObjectModel COM [image] RtFunction [image] DynProperties [image] Reload
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsAll | Bool | IsAll |
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Report execute
ObjectModel COM [image] RtFunction [image] DynProperties [image] Report execute
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
Filter | Node | Filter | Node
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CD_CTabellenFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Report execute [image] CD_CTabellenFilter
Overview
External Name | Type | Display Name | Description
DWPar1 | UInt32 | DWPar1 | First doubleword transfer parameter for value markers.
DWPar2 | UInt32 | DWPar2 | Second doubleword transfer parameter for value markers.
DWPar3 | UInt32 | DWPar3 | Third doubleword transfer parameter for value markers.
DWPar4 | UInt32 | DWPar4 | Fourth doubleword transfer parameter for value markers.
DWPar5 | UInt32 | DWPar5 | Fifth doubleword transfer parameter for value markers.
EditableInRT | Bool | EditableInRT | Description as text.
ExportFile | String | ExportFile |
Extension | UInt16 | Extension |
FilterPartGUID | Guid | FilterPartGUID | Description as text.
IsAutoName | Bool | IsAutoName |
IsBackup | Bool | IsBackup | "Reads archive from backup path, if set TRUE."
IsCancel | Bool | IsCancel |
IsFilterRT | Bool | IsFilterRT | "Displays the report filter configuration dialog within the runtime, if set TRUE."
IsReadOnly | Bool | IsReadOnly | "Allows no modifications to the file, if set TRUE."
ResString | String | ResString |
StrPar1 | String | StrPar1 | First string transfer parameter for text markers.
StrPar2 | String | StrPar2 | Second string transfer parameter for text markers.
StrPar3 | String | StrPar3 | Third string transfer parameter for text markers.
StrPar4 | String | StrPar4 | Fourth string transfer parameter for text markers.
StrPar5 | String | StrPar5 | Fifth string transfer parameter for text markers.
TableFile | String | TableFile | Specifies the name of the report file.
TimeFilter | Node | TimeFilter | Time filter settings


CD_CZeitFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Report execute [image] CD_CTabellenFilter [image] CD_CZeitFilter
Overview
External Name | Type | Display Name | Description
AddLen | UInt16 | AddLen | "Specifies if the length value (""Length"" DynProperty) should be added or subtracted. 0 = Subtract length 1 = Add length "
ARVTime1 | UInt32 | ARVTime1 | "Specifies the start time of the filter. zFct.DynProperties(""Filter.TimeFilter.ARVTime1"") = CDate(""30.07.2007 12:00:00"")"
ARVTime2 | UInt32 | ARVTime2 | Specifies the end time of the filter.
BoxenType | UInt16 | BoxenType |
ChargeFilter | Node | ChargeFilter | Batch filter settings
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
Length | UInt32 | Length | "Specifies the value of the length (in seconds) that should be added or subtracted (see ""AddLen"" DynProperty)."
ModifyTimePeriod | Bool | ModifyTimePeriod |
Offset | UInt32 | Offset | "Specifies the offset (in seconds) for the ""BoxType"" DynProperty option 1 to 8."
Options | UInt16 | Options |
ResString | String | ResString |
ShiftFilter | Node | ShiftFilter | Description
TimeFormat | UInt16 | TimeFormat | "Specifies the time format for the filter. ATTENTION: Can only be used, if ""BoxType"" DynProperty is set to 0. 10 = Time relative 12 = Absolute time 14 = From the specified day 20 = From month 22 = From year 25 = All "


Runtime profiles
ObjectModel COM [image] RtFunction [image] DynProperties [image] Runtime profiles
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
LoadModus | Int32 | LoadModus |
LoadName | String | LoadName |
LoadVar | CProjektVariable | LoadVar |
Modus | Int32 | Modus |
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SaveModus | Int32 | SaveModus |
SaveName | String | SaveName |
SaveVar | CProjektVariable | SaveVar |
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


SAT command activation
ObjectModel COM [image] RtFunction [image] DynProperties [image] SAT command activation
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Mode | Int16 | Mode |
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Save remanent data
ObjectModel COM [image] RtFunction [image] DynProperties [image] Save remanent data
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SaveAML | Bool | SaveAML |
SaveCEL | Bool | SaveCEL |
SaveEnergy | Bool | SaveEnergy |
SaveIDrv | Bool | SaveIDrv |
SaveSYMA | Bool | SaveSYMA |
SaveZDrv | Bool | SaveZDrv |
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Screen return
ObjectModel COM [image] RtFunction [image] DynProperties [image] Screen return
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Templates | String | Templates |
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Screen switch function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Screen switch function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
PictFilter |  | PictFilter |
PictSwitch | Node | PictSwitch | Node
Picture | String | Picture | Gets or sets the name of the switching picture.
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
WndType | UInt32 | WndType | Only users with the appropriate user authorization can edit entries in the database of the Industrial Performance Analyzer (IPA).


CD_CBildumschaltung
ObjectModel COM [image] RtFunction [image] DynProperties [image] Screen switch function [image] CD_CBildumschaltung
Overview
External Name | Type | Display Name | Description
ALCSubstitution | Node | ALCSubstitution | Node
CaseSensitive | Bool | CaseSensitive | "Indices substitution is case sensitive, if set TRUE."
IndexSubstitution | Node | IndexSubstitution | "Replaces the indices Debug.Print zFct.DynProperties(""PictSwitch.IndexSubstitution[-1]"") 'Output the amount of substituted indices Debug.Print zFct.DynProperties(""PictSwitch.IndexSubstitution[0].Source"") 'Access the name of the first variable Debug.Print zFct.DynProperties(""PictSwitch.IndexSubstitution[0].Destination"") 'Name of the corresponding substitution variable"
IndexVar | Node | IndexVar | "Accesses the assigned variables for the index substitution. Debug.Print zFct.DynProperties(""PictSwitch.IndexVar[-1]"") 'Amount of assigned variables Debug.Print zFct.DynProperties(""PictSwitch.IndexVar[0].Title"").Name 'Name of first variable"
IsCallingPic | Bool | IsCallingPic | Specifies the variable unit.
IsFilterRT | Bool | IsFilterRT | "Displays the picture selection dialog within the runtime, if set TRUE."
IsMonScroll | Bool | IsMonScroll | "Scrolls to the corresponding monitor on picture switch, if set TRUE."
Monitor | Int16 | Monitor | Defines on which monitor the picture is displayed. -2 = Relative to caller 0 = Display 0 (default display) 1 = Display 1 (only for multi-monitor projects) ... = etc.
Picture | String | Picture | Gets or sets the name of the switching picture.
ProjectName | String | ProjectName | "Gets or sets the project name where the picture is defined. Hint: The current project will be used, if this property is not specified."
SubstiFkt | Node | SubstiFkt | "Function substitution Debug.Print zFct.DynProperties(""PictSwitch.SubstiFkt[-1]"") 'Outputs the amount of substituted functions Debug.Print zFct.DynProperties(""PictSwitch.SubstiFkt[0].Source"") 'Access the name of the first source function Debug.Print zFct.DynProperties(""PictSwitch.SubstiFkt[0].Destination"") 'Name of the corresponding substitution function"
SubstiVar | Node | SubstiVar | "Variable substitution Debug.Print zFct.DynProperties(""PictSwitch.SubstiVar[-1]"") 'Outputs the amount of substituted variables Debug.Print zFct.DynProperties(""PictSwitch.SubstiVar[0].Source"") 'Access the name of the first source variable Debug.Print zFct.DynProperties(""PictSwitch.SubstiVar[0].Destination"") 'Name of the corresponding substitution variable"
WndType | UInt32 | WndType | Only users with the appropriate user authorization can edit entries in the database of the Industrial Performance Analyzer (IPA).


Screen with index
ObjectModel COM [image] RtFunction [image] DynProperties [image] Screen with index
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
Variable | String | Variable |


Script execute select online
ObjectModel COM [image] RtFunction [image] DynProperties [image] Script execute select online
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
Script | String | Script | Gets or sets the name of the script that should be executed.
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Send message
ObjectModel COM [image] RtFunction [image] DynProperties [image] Send message
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
Filter | Node | Filter | Message control settings
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CD_CMessageFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Send message [image] CD_CMessageFilter
Overview
External Name | Type | Display Name | Description
AckCode | String | AckCode |
AcknowledgeFunctions | String | AcknowledgeFunctions |
AcknowledgeTimeOutFunctions | String | AcknowledgeTimeOutFunctions |
AttachmentFromVar | Bool | AttachmentFromVar |
AttachmentName | String | AttachmentName |
AttachmentVar | CProjektVariable | AttachmentVar |
ConstText | String | ConstText | "Specifies the constant text that will be sent or played (if option ""Telephone speech"" is selected within DynProperty ""MsgType""). ATTENTION: This property always requires an entry, except option ""Telephone"" (not ""Telephone speech"") within DynProperty ""MsgType""."
Destination | String | Destination |
DestinationFromVariable | Bool | DestinationFromVariable |
DestinationVar | CProjektVariable | DestinationVar |
ErrorFile | String | ErrorFile | "Specifies the text (""Telephone speech"") or the name of the soundfile (""Telephone"") that will be played, if the wrong pin was entered. Hint: This property is only available for the options ""Telephone"" and ""Telephone speech"" within DynProperty ""MsgType""."
GUID | String | GUID | "Gets or sets the GUID of the group or recipient (depending on DynProperty ""UserType"") that should be informed."
HeaderFile | String | HeaderFile | "Specifies the text (""Telephone speech"") or the name of the soundfile (""Telephone"") that will be played, after getting connection to the phone of the recipient. This file should ask the recipient to enter his PIN code. If the pin is correct, the specified text within DynProperty ""ConstText"" (option ""Telephone speech"") or the soundfile specified within DynProperty ""WaveFile"" (option ""Telephone"") is played. Otherwise, the text or file specified within ""ErrorFile"" (both options ""Telephone speech"" and ""Telephone"") is played. Hint: This property is only available for the options ""Telephone"" and ""Telephone speech"" within DynProperty ""MsgType""."
IsDynLimits | Bool | IsDynLimits | "Adds information about the violated variable to the constant text, if set TRUE. Hint: Only available, if DynProperty ""IsVar"" is set FALSE and DynProperty ""IsUseVariable"" is set TRUE."
IsResign | Bool | IsResign | "For security purposes, it is often necessary to acknowledge sent messages. If this property is set true, acknowledging will be activated. ATTENTION: For options ""Telephone"" and ""Telephone speech"" (see DynProperty ""MsgType""), this property has always to be activated."
IsTextDlg | Bool | IsTextDlg | "Displays the message control dialog within the runtime, if set TRUE."
IsUseVariable | Bool | IsUseVariable | "With this option the limit text of a defined variable or a violated variable can be added to the message, if set TRUE. Hint: Available for all message types, except option ""Telephone"" within DynProperty ""MsgType""."
MessageContent | String | MessageContent |
MsgType | UInt16 | MsgType | Defines the transfer medium for sending messages. Following message types are supported: 1 = E-Mail 3 = Telephone 4 = Paging / SMS 5 = GSM-SMS 6 = Telephone (speech)
MsgTypeStyle | UInt16 | MsgTypeStyle |
NackCode | String | NackCode |
NegativeAcknowledgeFunctions | String | NegativeAcknowledgeFunctions |
OldUserId | Int32 | OldUserId |
ResignTime | Int16 | ResignTime | "The property defines, how long the Message Control waits for the acknowledging of the recipient, before his replacement is informed. If no replacement is entered, an corresponding entry in the CEL is generated. "
UseFuncCodes | Bool | UseFuncCodes |
UserType | UInt16 | UserType | Specifies to whom the message should be sent: 2 = Group 3 = Recipient 6 = Current shift
Var | CProjektVariable | Var | "Gets or sets a ""Variable"" object that contains the limit text, which will be added to the constant text. Hint: Only available, if DynProperty ""IsVar"" is set TRUE."
WaveFile | String | WaveFile | "Specifies the name of the soundfile that will be played, if the correct pin was entered. Hint: This property is only available for the option ""Telephone"" within DynProperty ""MsgType""."


Send value to hardware
ObjectModel COM [image] RtFunction [image] DynProperties [image] Send value to hardware
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SetValue | Node | SetValue | Node
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CFktSwNeu
ObjectModel COM [image] RtFunction [image] DynProperties [image] Send value to hardware [image] CFktSwNeu
Overview
External Name | Type | Display Name | Description
Command | UInt16 | Command |
IsCurValue | Bool | IsCurValue | "Active (TRUE): The value is read from the hardware and then is proposed as a default or directly sent to the hardware. Additionally for numerical variables, the DynProperty ""NumValue"" becomes a new function, as the value entered there is added to the default (subtracted if negative value). Inactive (FALSE): The value defined under DynProperty ""NumValue"" is proposed as a default or directly sent to the hardware."
IsDirect | Bool | IsDirect | "Active (TRUE): After activating the function, the value is directly sent to the hardware, not asking for a further confirmation. Inactive (FALSE): Before sending the value to the hardware, the set value dialog is opened and the user can change the settings within the Runtime."
IsVarLimit | Bool | IsVarLimit | "If this property is TRUE, the set value limits are taken from the variable definition. Otherwise (FALSE), the value limits can be defined directly by means of the DynProperties ""Minimum"" and ""Maximum""."
IsWriteSync | Bool | IsWriteSync | "Active (TRUE): Executing the function is not finished, before a positive confirmation of the writing action is received or the fixly defined timeout of 30 seconds is over. In scripts this can make sure, that the following function is not started, before this one is finished. The confirmation can also be evaluated with the status bit WR-SUC . Inactive (FALSE): Do not wait for the writing confirmation. "
Maximum | double | Maximum | "Specifies the maximum limit of the value. Hint: Only available, if DynProperty ""IsVarLimit"" is set to FALSE."
Minimum | double | Minimum | "Specifies the minimum limit of the value. Hint: Only available, if DynProperty ""IsVarLimit"" is set to FALSE."
NumValue | double | NumValue | Value of numerical variables which will be issued. ATTENTION: For boolean variables only following values can be set ... 0 = LOW (0) 1 = HIGH (0) 2 = TOGGLE (Value of variable is switched to complementary status)
PrgName | String | PrgName | "Specifies the path and the name of the program (plus its file extension) which should be executed, if option 1 within DynProperty ""Setting"" is set."
Setting | SByte | Setting | "Send value with (in online operation): 0 = Standard dialog box of the control system 1 = External program provided by the user Hint: This property is only available, if DynProperty ""IsDirect"" is set to FALSE."
StrValue | String | StrValue | Value of alphanumerical variables which will be issued.
Variable | CProjektVariable | Variable | "Gets or sets the ""Variable"" object which should be (or is already) linked to the function."


Sequence teaching function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Sequence teaching function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
ShowRT | Bool | ShowRT | Description
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
TeachingOption | Byte | TeachingOption | Description
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Setpoint
ObjectModel COM [image] RtFunction [image] DynProperties [image] Setpoint
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SetpointSetting | String | SetpointSetting |
SubmitAndCloseWnd | UInt16 | SubmitAndCloseWnd |
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Shedding load topology
ObjectModel COM [image] RtFunction [image] DynProperties [image] Shedding load topology
Overview
External Name | Type | Display Name | Description
Consumer | Node | Consumer | Description as text.
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SourceVar | Node | SourceVar | Description as text.
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CLoadSheddingVerbraucher
ObjectModel COM [image] RtFunction [image] DynProperties [image] Shedding load topology [image] CLoadSheddingVerbraucher
Overview
External Name | Type | Display Name | Description
ConsumerVar | CProjektVariable | ConsumerVar | Description as text.
IBitVar | CProjektVariable | IBitVar | Description as text.
ValueVar | CProjektVariable | ValueVar | Description as text.


CProjektVariableProp
ObjectModel COM [image] RtFunction [image] DynProperties [image] Shedding load topology [image] CProjektVariableProp
Overview
External Name | Type | Display Name | Description
Title | CProjektVariable | Title | Gets or sets a variable object.


Show menu
ObjectModel COM [image] RtFunction [image] DynProperties [image] Show menu
Overview
External Name | Type | Display Name | Description
ActionType | Int16 | ActionType | "Gets or sets the action that should be executed. 0 = Show menu (specified by ""MenuName"") 1 = Hide menu 2 = Change menu (specified by ""MenuName"") 3 = If no menu exists, then show menu specified by ""MenuName"""
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
FilterInRT | Bool | FilterInRT | "Shows the dialog in the runtime, if set TRUE."
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
MenuName | String | MenuName | Gets or sets the name of the menu as string.
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Simulation image
ObjectModel COM [image] RtFunction [image] DynProperties [image] Simulation image
Overview
External Name | Type | Display Name | Description
Drivers | Node | Drivers | Node
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CDrvProperty
ObjectModel COM [image] RtFunction [image] DynProperties [image] Simulation image [image] CDrvProperty
Overview
External Name | Type | Display Name | Description
Description | String | Description |
FileName | String | FileName |


SQL export function
ObjectModel COM [image] RtFunction [image] DynProperties [image] SQL export function
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
Filter |  | Filter | Description
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Standard recipe
ObjectModel COM [image] RtFunction [image] DynProperties [image] Standard recipe
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
Filter | Node | Filter | Node
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CRezeptFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Standard recipe [image] CRezeptFilter
Overview
External Name | Type | Display Name | Description
ColOrder | String | ColOrder |
ColOrderAll | String | ColOrderAll |
ColText_ActVal | String | ColText_ActVal |
ColText_Filter | String | ColText_Filter |
ColText_Identifier | String | ColText_Identifier |
ColText_Max | String | ColText_Max |
ColText_Min | String | ColText_Min |
ColText_Mode | String | ColText_Mode |
ColText_ResLabel | String | ColText_ResLabel |
ColText_Symbolism | String | ColText_Symbolism |
ColText_Unit | String | ColText_Unit |
ColText_Value | String | ColText_Value |
ColText_VarName | String | ColText_VarName |
ColWidth_ActVal | Int32 | ColWidth_ActVal |
ColWidth_Filter | Int32 | ColWidth_Filter |
ColWidth_Identifier | Int32 | ColWidth_Identifier |
ColWidth_Max | Int32 | ColWidth_Max |
ColWidth_Min | Int32 | ColWidth_Min |
ColWidth_Mode | Int32 | ColWidth_Mode |
ColWidth_ResLabel | Int32 | ColWidth_ResLabel |
ColWidth_Symbolism | Int32 | ColWidth_Symbolism |
ColWidth_Unit | Int32 | ColWidth_Unit |
ColWidth_Value | Int32 | ColWidth_Value |
ColWidth_VarName | Int32 | ColWidth_VarName |
DWPar1 | UInt32 | DWPar1 |
DWPar2 | UInt32 | DWPar2 |
DWPar3 | UInt32 | DWPar3 |
DWPar4 | UInt32 | DWPar4 |
DWPar5 | UInt32 | DWPar5 |
ExportExt | UInt32 | ExportExt | Defines the import/export format for the recipe file. 0 = Text file (TXT)
ExportFile | String | ExportFile | Defines the path and the name of the import/export file.
FileNameVar | CProjektVariable | FileNameVar | "Defines the name of the variable which contains the name for the import/export (DynProperty ""Modus"" options 3 and 4)."
FilterText | String | FilterText | this property defines the filter to open the RGM picture with in the runtime. Only variables with this Filtertext set will be shown.
FilterVar | CProjektVariable | FilterVar | This property defines which string variable will be used to open the RGM picture. The string in this variable will be used to show only the variables with this Filtertext.
FilterVarOn | Bool | FilterVarOn | Description as text.
FormatFile | String | FormatFile |
GrpVar | CProjektVariable | GrpVar |
ImportGroupName | Bool | ImportGroupName | Description as text.
IsAutoName | Int16 | IsAutoName | "If set TRUE, a name for the export file (DynProperty ""Modus"" option 3) will be automatically generated."
IsFilterRT | Bool | IsFilterRT | "Displays the recipe configuration dialog within the runtime, if set TRUE."
IsReadOnly | Bool | IsReadOnly | "If set TRUE, this property only allows the selection of a recipe within the runtime, but unlike ""IsRecOnly"" no recipe configuration is allowed. Hint: Only available, if DynProperty ""IsFilterRT"" is set TRUE."
IsRecNumName | Bool | IsRecNumName | "Specifies if the assigned variable contains the number (FALSE) or the name (TRUE) of the recipe. Hint: This property is only available, if DynProperty ""WithNumber"" specifies that the recipe selection is done via a variable."
IsRecOnly | Bool | IsRecOnly | "If set TRUE, this property only allows the selection of a recipe within the runtime. Hint: Only available, if DynProperty ""IsFilterRT"" is set TRUE."
IsWithFormat | Bool | IsWithFormat |
Modus | UInt32 | Modus | Defines the recipe mode. 0 = Execute recipe 1 = Duplicate and teach 2 = Read recipe 3 = Export recipe 4 = Import recipe 5 = Duplicate
PictName | String | PictName |
ProjectName | String | ProjectName | Description as text.
RecGroup | String | RecGroup | Specifies the name of the recipe group which contains the utilized RGM recipe.
Recipe | String | Recipe | Specifies the name of the recipe that should be operated. ATTENTION: The name of the recipe has to be the exact name of an existing RGM recipe.
RecipesListConfig |  | RecipesListConfig |
RecipeValueListConfig |  | RecipeValueListConfig | Description
RecNumber | UInt32 | RecNumber |
RecVar | CProjektVariable | RecVar | "Gets or sets a variable (""Variable"" object) that should be used, in order to select the recipe by name or number. "
ShowRowNr | Bool | ShowRowNr |
Status | UInt32 | Status |
StatusVar | CProjektVariable | StatusVar |
StatusVarOn | Bool | StatusVarOn | Description as text.
StrPar1 | String | StrPar1 |
StrPar2 | String | StrPar2 |
StrPar3 | String | StrPar3 |
StrPar4 | String | StrPar4 |
StrPar5 | String | StrPar5 |
SystemModelGroup | Node | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
TargetRecipe | String | TargetRecipe | "Defines the name of the target recipe to which should be copied. Hint: Only available for DynProperty ""Modus"" option 5 (""Duplicate"")."
TargetRecipeVar | CProjektVariable | TargetRecipeVar |
TargetRecipeVarOn | Bool | TargetRecipeVarOn | Description as text.
TargetStatus | UInt32 | TargetStatus |
TargetStatusVar | CProjektVariable | TargetStatusVar |
TargetStatusVarOn | Bool | TargetStatusVarOn | Description as text.
TargetVersion | UInt32 | TargetVersion |
TargetVersionVar | CProjektVariable | TargetVersionVar |
TargetVersionVarOn | Bool | TargetVersionVarOn | Description as text.
TextFilter | Node | TextFilter | Node
Version | UInt32 | Version |
VersionVar | CProjektVariable | VersionVar |
VersionVarOn | Bool | VersionVarOn | Description as text.
WithGrpVar | Bool | WithGrpVar |
WithNumber | UInt32 | WithNumber | Specifies it the recipe should be selected with a variable. 0 = No recipe selection 1 = Recipe selection with variable
XMLExpOverwriteFile | Bool | XMLExpOverwriteFile |
XMLImpOverwriteRecipe | Bool | XMLImpOverwriteRecipe |


Start SEA
ObjectModel COM [image] RtFunction [image] DynProperties [image] Start SEA
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SEAParams | String | SEAParams |
SwitchingSequence | String | SwitchingSequence |
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Suppress message function
ObjectModel COM [image] RtFunction [image] DynProperties [image] Suppress message function
Overview
External Name | Type | Display Name | Description
Activate | Bool | Activate |
Areas | String | Areas |
Classes | String | Classes |
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
Groups | String | Groups |
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsFilterRT | Bool | IsFilterRT |
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
SystemModelGroupFilter | Node | SystemModelGroupFilter | Node
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CSystemModelFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] Suppress message function [image] CSystemModelFilter
Overview
External Name | Type | Display Name | Description
EditableInRT | Bool | EditableInRT | Description as text.
FilterPartGUID | Guid | FilterPartGUID | Description as text.
SystemModelGroup | CD_CMemFile | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .


Switch net redundancy
ObjectModel COM [image] RtFunction [image] DynProperties [image] Switch net redundancy
Overview
External Name | Type | Display Name | Description
DetectionOffTime | UInt16 | DetectionOffTime |
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SwitchDirection | Int16 | SwitchDirection |
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Switch online printer
ObjectModel COM [image] RtFunction [image] DynProperties [image] Switch online printer
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsDialogRT | Bool | IsDialogRT | "Displays the printer selection dialog in the runtime, if set TRUE."
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
Printer | String | Printer | Gets or sets the name of the printer.
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Switch palette
ObjectModel COM [image] RtFunction [image] DynProperties [image] Switch palette
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsDialogRT | Bool | IsDialogRT | "Displays the printer selection dialog in the runtime, if set TRUE."
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
PaletteName | String | Palette name | Name of palette.Default: Color palette plus Index number , for example Color palette 1 .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Toggle online printing
ObjectModel COM [image] RtFunction [image] DynProperties [image] Toggle online printing
Overview
External Name | Type | Display Name | Description
Action | SByte | Action | "Sets online printing (e.g. for unmanned stations) to a processing status (switch on, switch off, active/inactive). 0 = Active/Inactive 1 = On 2 = Off "
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Unit switch
ObjectModel COM [image] RtFunction [image] DynProperties [image] Unit switch
Overview
External Name | Type | Display Name | Description
ActiveSecondaryUnits | String | ActiveSecondaryUnits |
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
PrimaryUnits | String | PrimaryUnits |
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


VBA execute macro
ObjectModel COM [image] RtFunction [image] DynProperties [image] VBA execute macro
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
Filter | Node | Filter | Node
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CD_CVbaMacroFilter
ObjectModel COM [image] RtFunction [image] DynProperties [image] VBA execute macro [image] CD_CVbaMacroFilter
Overview
External Name | Type | Display Name | Description
Info | UInt16 | Info |
IsBreakOnError | Bool | IsBreakOnError |
MacroName | String | MacroName | Specifies the name of the macro that should be executed.
Parameters | Node | Parameters | Node
ProjectName | String | ProjectName |


CFunctionParam
ObjectModel COM [image] RtFunction [image] DynProperties [image] VBA execute macro [image] CD_CVbaMacroFilter [image] CFunctionParam
Overview
External Name | Type | Display Name | Description
ParamValue | String | ParamValue |


VSTA execute macro
ObjectModel COM [image] RtFunction [image] DynProperties [image] VSTA execute macro
Overview
External Name | Type | Display Name | Description
ExternalReference | String | External reference | Note: XML import and export is supported. If a function is created using copy&paste , this property is empty.
ID | UInt32 | ID | Internal unique ID of the function.
IsActual | Bool | Current computer | Only available in network projects : The function is executed on the computer on which it was instigated. .
IsClient | Bool | Client | Only available in network projects : The function is carried out on all Clients of the project. .
IsServer | Bool | Primary Server | Only available in network projects : The function is carried out on the primary server of the project. .
IsStandBy | Bool | Standby Server | Only available for network projects : The function is carried out on the Standby Server of the project. .
IsUrlStartWeb | Bool | URL start function for web | URL start function for web:Active: The function can be executed by means of a URL extension on the HTML web client when the session is started.Inactive: The function cannot be executed by means of a URL expansion on the HTML web client when the session is started.Default: Inactive .
MacroName | String | MacroName |
Name | String | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function.Maximum: 128 characters Default: Funktion_x (whereby x is a consecutive number) .
Parameters | UInt32 | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens dialog to configure the function. Depending on the type of function, the corresponding parameter dialog is opened. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Type | UInt32 | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


RtFunctions
ObjectModel COM [image] RtFunctions
Remarks

This collection contains the defined functions. The single functions can be executed at Runtime via VBA.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
'Create Function for TREND - PICTURE
Sub CreateTrendFunction()
Dim zPIC As DynPicture
Dim zFCT As RtFunction
Dim i As Integer
Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Item("TREND")
'Create new function
Set zFCT = MyWorkspace.ActiveDocument.RtFunctions.Create("picTREND", tpPicture)
'function settings...
With zFCT

.DynProperties("Picture") = zPIC.Name

i = .DynProperties("PictFilter[-1]")

If i = 0 Then .CreateDynProperty "PictFilter"

.DynProperties("PictFilter[0].RefreshRate") = 1

.DynProperties("PictFilter[0].Name") = "WIZARD TREND"

.DynProperties("PictFilter[0].IsArchive") = False

.DynProperties("PictFilter[0].IsXAxis") = False

'Add 3 CURVES

For i = 0 To 2

n = .DynProperties("PictFilter[0].Curve[-1]")

If n <= i Then

'create CURVE SubItem if needed

.CreateDynProperty ("PictFilter[0].Curve")

.CreateDynProperty ("PictFilter[0].Curve[" & i & "].VarInfo")

.CreateDynProperty ("PictFilter[0].Curve[" & i & "].YAxe")

.CreateDynProperty ("PictFilter[0].Curve[" & i & "].YAxe[0].Scale")

End If

'change curve settings

.DynProperties("PictFilter[0].Curve[" & i & "].GraphName") = "MyVariable_" & i

.DynProperties("PictFilter[0].Curve[" & i & "].HasYAxis") = True

.DynProperties("PictFilter[0].Curve[" & i & "].IsShow") = True

.DynProperties("PictFilter[0].Curve[" & i & "].IsInterpolation") = True

.DynProperties("PictFilter[0].Curve[" & i & "].VarInfo.VarName") = "MyVariable_" & i

.DynProperties("PictFilter[0].Curve[" & i & "].VarInfo.Channel") = "MyVariable_" & i

.DynProperties("PictFilter[0].Curve[" & i & "].VarInfo.Variable") = "MyVariable_" & i

.DynProperties("PictFilter[0].Curve[" & i & "].VarInfo.VarMaxValue") = 1000

.DynProperties("PictFilter[0].Curve[" & i & "].VarInfo.VarMinValue") = 0

.DynProperties("PictFilter[0].Curve[" & i & "].YAxe.IsAutoScale") = False

.DynProperties("PictFilter[0].Curve[" & i & "].YAxe.Color") = vbBlack

.DynProperties("PictFilter[0].Curve[" & i & "].YAxe.Scale.ScaleTop") = 1000

.DynProperties("PictFilter[0].Curve[" & i & "].YAxe.Scale.ScaleBotton") = 0

Next i

'filter settings (relative time 5 minutes)

.CreateDynProperty ("PictFilter[0].TimeAxe")

.DynProperties("PictFilter[0].TimeAxe.OldDiff") = 3600

.DynProperties("PictFilter[0].TimeAxe.TimeFilter.Options") = 65535

.DynProperties("PictFilter[0].TimeAxe.TimeFilter.ARVTime1") =
CDate(25569.0451388889) '("01.01.1970 01:05:00")

.DynProperties("PictFilter[0].TimeAxe.TimeFilter.ARVTime2") =
CDate(25569.0416666667) '("01.01.1970 01:00:00")
End With
End Sub
'Create Function for ALARM - PICTURE
Sub CreateAlarmFunction()
Dim zPIC As DynPicture
Dim zFCT As RtFunction
Dim i As Integer
Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Item("ALARM")
'Create new function
Set zFCT = MyWorkspace.ActiveDocument.RtFunctions.Create("picALARM", tpPicture)
'function and filter settings...
With zFCT

.DynProperties("Picture") = zPIC.Name

i = .DynProperties("PictFilter[-1]")

If i = 0 Then .CreateDynProperty "PictFilter"

.DynProperties("PictFilter[0].VarFilter") = "*"

.DynProperties("PictFilter[0].FilterTitel") = "*"

i = .DynProperties("PictFilter[0].TimeFilter[-1]")

If i = 0 Then .CreateDynProperty "PictFilter[0].TimeFilter"

.DynProperties("PictFilter[0].TimeFilter[0].TimeFormat") = 10

.DynProperties("PictFilter[0].TimeFilter[0].Options") = 65535

.DynProperties("PictFilter[0].TimeFilter[0].ARVTime1") = CDate(25570.0416666667) '("02.01.1970 01:00:00")

.DynProperties("PictFilter[0].TimeFilter[0].ARVTime2") = CDate(25569.0416666667) '("01.01.1970 01:00:00")

i = .DynProperties("PictFilter[0].TimeFilter[0].ChargeFilter[-1]")

If i = 0 Then .CreateDynProperty "PictFilter[0].TimeFilter[0].ChargeFilter"

i = .DynProperties("PictFilter[0].TextFilter[-1]")

If i = 0 Then .CreateDynProperty "PictFilter[0].TextFilter"

i = .DynProperties("PictFilter[0].ListInfo[-1]")

If i = 0 Then .CreateDynProperty "PictFilter[0].ListInfo"
End With
End Sub


Properties
ObjectModel COM [image] RtFunctions [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns count of the elements | Readonly | Readonly | Available | Available
Parent | iproject | The parent object of the current object | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] RtFunctions [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] RtFunctions [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] RtFunctions [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | irtfunction | Creates and returns a new Object | Available | Unused | Available | Available
Delete | variant_bool | Deletes the objects from collection | Available | Unused | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
Item | irtfunction | Returns a object at a position or by a specified key | Available | Unused | Available | Available
ShowCreateDialog | ishowcreatefunctiondialogresult | Opens the zenon standard dialog "Select a function". | Available | Unused | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index | Available | Unused | Available | Available


Create
ObjectModel COM [image] RtFunctions [image] Methods [image] Create
Remarks

Creates a new function and returns the new RtFunction object.

Datatype
IRtFunction

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

tpFuncType as tpFunctionTypes


Delete
ObjectModel COM [image] RtFunctions [image] Methods [image] Delete
Remarks

Deletes the RtFunjction objects from the collection.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT


Export
ObjectModel COM [image] RtFunctions [image] Methods [image] Export
Remarks

Export settings to an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Import
ObjectModel COM [image] RtFunctions [image] Methods [image] Import
Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Item
ObjectModel COM [image] RtFunctions [image] Methods [image] Item
Remarks

Returns the object Function from the collection, which is identified by the parameter vNameOrPos.

Datatype
IRtFunction

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT


ShowCreateDialog
ObjectModel COM [image] RtFunctions [image] Methods [image] ShowCreateDialog
Remarks

Opens the zenon standard dialog "Select a function". After the dialog is closed the object ShowCreateFunctionDialogResult is returned which contains an enumerator (ShowCreateFunctionDialogReturnResult) – returns if successful or notfunction object (Function) – created driver object (if successful)

Datatype
IShowCreateFunctionDialogResult

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub showFunctionDialog()
Dim obFunctions As Functions
Dim obFunction As Function
Dim enumFncRet As ShowCreateFunctionDialogReturnResult
Dim obFncResult As ShowCreateFunctionDialogResult
    Set obFunctions = MyWorkspace.ActiveDocument.Functions
    Set obFncResult = obFunctions.ShowCreateDialog
    enumFncRet = obFncResult.ShowCreateFunctionDialogReturnResult
    If enumFncRet = ShowCreateFunctionDialogReturnResult_Successful Then
        Set obFunction = obFncResult.Function
        Debug.Print "Function " & obFunction.Name & " successfully created"
    ElseIf enumFncRet = ShowCreateFunctionDialogReturnResult_UndefinedFailure Then
    'just to test the enum (elseif instead of else)
        Debug.Print "Aborted or unkown error occured"
    End If
End Sub


SingleExport
ObjectModel COM [image] RtFunctions [image] Methods [image] SingleExport
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR


Events
ObjectModel COM [image] RtFunctions [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
PreFunctionExecute | void | This event is fired when a function is executed and containes a copy of the function. | Unused | Available | Available | Available


PreFunctionExecute
ObjectModel COM [image] RtFunctions [image] Events [image] PreFunctionExecute
Remarks

This event will be fired if a zenon function is called via the function list (function call via dynamic element, script, limit violation, reaction matrix, API).This event contains a temporary copy of the called function object as a parameter (containing all information of the function), not the object from the function list itself. To get the "original" function object the .Parent method of the temporary object could be used.Like for all other events, the parameter object is only valid in the scope of the event itself and therefore it must not be stored.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
obFunction as IRtFunction

Example
C#
Copy
//RtFunctions object
public zenOn.IRtFunctions myRtFcts;
//...
//Init object, create eventhandler
void ThisProject_Active()
{
   myRtFcts = this.RtFunctions();
   myRtFcts.PreFunctionExecute += new
                 zenOn.PreFunctionExecuteEventHandler(myRtFcts_PreFunctionExecute);

//...
}

//Event method
void myRtFcts_PreFunctionExecute(zenOn.IRtFunction obFunction)
{
//Output debug information
   System.Diagnostics.Debug.Print("Function: \"" + obFunction.Name + "\"
                 executes - Function type: " + obFunction.Type.ToString());

//Do something with the object –
   //Note: Object obFunction is valid only in this scope!
   //...
}

//Delete eventhandler, release object
void ThisProject_Inactive()
{
   myRtFcts.PreFunctionExecute -= new
                 zenOn.PreFunctionExecuteEventHandler(myRtFcts_PreFunctionExecute);
   myRtFcts = null;

//...
}


SapFunction
ObjectModel COM [image] SapFunction
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public WithEvents obFunReadTable As SapFunction
Public Sub ReadTable()
Dim obFunctions As SapFunctions
'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only

Fielddefinitions (FIELDS)
'Tables
Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata
Dim obRow As SapRow
Dim Error As tpSapError
' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions
' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
If obFunReadTable Is Nothing Then

Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If
' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of Parameters
If Not obParameters Is Nothing Then
'Tablename
Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then

Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value
'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then

Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value
'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then

Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value
'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")
If obParRowSkip Is Nothing Then

Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value
'Fields only
Set obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then

Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If
' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then
'Selections , "WHERE-Clause" (in)
Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then

Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else

obTabOptions.Clear
End If
'Names (in) and Structure (out) of read fields
Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then

Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else

obTabFields.Clear
End If
'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then

Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else

obTabData.Clear
End If
End If
' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)
'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub
' |
' |
' V
Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction, ByVal

Error As tpSapError)
'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...
' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)
' === check result
If Error = tpSapError_Ok Then 'no error
Dim obParameters As SapParameters
Dim obParameter As SapParameter
Dim obTables As SapTables
Dim obTable As SapTable
Dim obTabFields As SapTable 'Input
Dim obTabData As SapTable 'Output
Dim Count As Integer
Dim RowData As String
' === check Parameter and Tables
Set obTables = obFunReadTable.Tables
' === check Table "FIELDS"
Set obTabFields = obTables.Item("FIELDS")
Count = obTabFields.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1

RowData = obTabFields.Rows.Item(i).RawData

'FIELDNAME = Name of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value =

GetNextField(RowData)

'OFFSET = Start of the Field in the Row

thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value =

CInt(GetNextField(RowData))

'LENGTH = Length of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value =

CInt(GetNextField(RowData))

'TYPE = Datatype of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value =

GetNextField(RowData)

'FIELDTEXT = description of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value =

GetNextField(RowData)

Next

' === check Table "DATA"

Set obTabData = obTables.Item("DATA")

Count = obTabData.Rows.Count

If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1

'One row of the table "DATA" contains only one filed with 512 characters

RowData = obTabData.Rows.Item(i).RawData

thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData

Next

End If
End Sub
Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String
Select Case Error

Case tpSapError_No_Connection ' No connection to SAP system

ShortError = "No connection to SAP system"

Case tpSapError_Ok ' OK.

ShortError = "No Error"

Case tpSapError_Failure ' Error occurred

ShortError = "Error occurred"

Case tpSapError_Exception ' Exception raised

ShortError = "Exception raised"

Case tpSapError_Sys_Exception ' System exception raised, connection closed

ShortError = "System exception raised, connection closed"

Case tpSapError_Call ' Call received

ShortError = "Call received"

Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only

ShortError = "Internal communication, repeat (internal use only)"

Case tpSapError_Closed ' Connection closed by the other side

ShortError = "Connection closed by the other side"

Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)

ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"

Case tpSapError_No_Tid ' No Transaction ID available

DError = "No Transaction ID available"

Case tpSapError_Executed ' Function already executed

ShortError = "Function already executed"

Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)

ShortError = "Synchronous Call in Progress (only for Windows)"

Case tpSapError_Memory_Insufficient ' Memory insufficient

ShortError = "Memory insufficient"

Case tpSapError_Version_Mismatch ' Version mismatch

ShortError = "Version mismatch"

Case tpSapError_Not_found ' Function not found (internal use only)

ShortError = "Function not found (internal use only)"

Case tpSapError_Call_Not_Supported ' This call is not supported

ShortError = "This call is not supported"

Case tpSapError_Not_Owner ' Caller does not own the specified handle

ShortError = "Caller does not own the specified handle"

Case tpSapError_Not_Initialized ' RFC not yet initialized

ShortError = "RFC not yet initialized"

Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed

ShortError = "A system call such as RFC_PING for connection test is executed"

Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API call

ShortError = "An invalid handle was passed to an API call"

Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.

ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."

Case tpSapError_Canceled ' An rfc call has been canceled by user

ShortError = "An rfc call has been canceled by user"

Case tpSapError_Conversion ' An error during conversion has been d

etected

ShortError = "An error during conversion has been detected"

Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format

ShortError = "The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format"

Case tpSapError_Timeout ' Timeout
ShortError = "Timeout"
End Select
'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub
Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...
pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?

GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters

GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function
Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub


Properties
ObjectModel COM [image] SapFunction [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Activity | tpsapactivity | Activity state of the function call (0 = inactive, 1 = in queue, 2 = call in progress) | Available | Available | Available | Available
ErrorCode | tpsaperror | Code for result of last call | Unused | Readonly | Available | Available
ErrorText | bstr | Short text for result of last call | Unused | Readonly | Available | Available
LastError | bstr | Last Error | Readonly | Readonly | Available | Available
Name | bstr | Name of the SAP function | Available | Available | Available | Available
Parent | isapfunctions | Parent-object | Available | Available | Available | Available


Activity
ObjectModel COM [image] SapFunction [image] Properties [image] Activity
Remarks

Returns the actuial activity state of the SAP function.

Datatype
tpSapActivity

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


ErrorCode
ObjectModel COM [image] SapFunction [image] Properties [image] ErrorCode
Remarks

Datatype
tpSapError

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


ErrorText
ObjectModel COM [image] SapFunction [image] Properties [image] ErrorText
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


LastError
ObjectModel COM [image] SapFunction [image] Properties [image] LastError
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] SapFunction [image] Properties [image] Name
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] SapFunction [image] Properties [image] Parent
Remarks

Datatype
ISapFunctions

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] SapFunction [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Call | tpsaperror | Calls the SAP function synchronously | Available | Available | Available | Available
CallAsync | tpsaperror | Calls the SAP function asynchronously | Available | Available | Available | Available
Parameters | isapparameters | Returns the SAP parameters collection | Available | Available | Available | Available
StartServer | variant_bool | Starts the SAP function as server program to be called from SAP | Available | Available | Available | Available
StopServer | void | Stops the server program | Available | Available | Available | Available
Tables | isaptables | Returns the SAP tables collection | Available | Available | Available | Available


Call
ObjectModel COM [image] SapFunction [image] Methods [image] Call
Remarks

Datatype
tpSapError

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bReuseConnection as VARIANT


CallAsync
ObjectModel COM [image] SapFunction [image] Methods [image] CallAsync
Remarks

Datatype
tpSapError

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bReuseConnection as VARIANT


Parameters
ObjectModel COM [image] SapFunction [image] Methods [image] Parameters
Remarks

Datatype
ISapParameters

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


StartServer
ObjectModel COM [image] SapFunction [image] Methods [image] StartServer
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


StopServer
ObjectModel COM [image] SapFunction [image] Methods [image] StopServer
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Tables
ObjectModel COM [image] SapFunction [image] Methods [image] Tables
Remarks

Datatype
ISapTables

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Events
ObjectModel COM [image] SapFunction [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ActivityChanged | void | Activity state of the function call has changed | Unused | Readonly | Available | Available
CallFinished | void | SAP function returns from asynchronous call | Readonly | Readonly | Available | Available
ServerCall | void | Server program called by SAP | Unused | Readonly | Available | Available


ActivityChanged
ObjectModel COM [image] SapFunction [image] Events [image] ActivityChanged
Remarks

This events reacts on a change of the activity state of an SAP function.The Function object and the State-Value will be delivered from the event.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
obFunction as ISapFunction

Activity as tpSapActivity

Example
VBA
Copy
Private Sub obFunReadTable_ActivityChanged(ByVal obFunction As ISapFunction,_
ByVal Activity As tpSapActivity)
thisProject.Variables.Item("ReadTableActive").Value = obFunction.Activity
End Sub


CallFinished
ObjectModel COM [image] SapFunction [image] Events [image] CallFinished
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
obFunction as ISapFunction

Error as tpSapError


ServerCall
ObjectModel COM [image] SapFunction [image] Events [image] ServerCall
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
obFunction as ISapFunction

Error as tpSapError


DynProperties
ObjectModel COM [image] SapFunction [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

SAP function


SAP function
ObjectModel COM [image] SapFunction [image] DynProperties [image] SAP function
Overview
External Name | Type | Display Name | Description
ActivityVar | CProjektVariable | Activity | Numeric variable for activity monitoring of the SAP function. Can e.g. be used for interlockings in order to prevent overlapping calls.Possible values: 0, 1, 2 0 : inactive1 : queued in the call queue2 : call active .
ErrorTextVar | CProjektVariable | Error text | String variable for short description of the error which occurred lastly. .
ErrorVar | CProjektVariable | Error code | Numeric variable for the error code of the function call. .
Info | String | Information | Freely definable short text. Only used for information. If available, it is set when a SAP function is created via the Wizard in accordance with the interface description in the SAP system. .
Label | String | Function name | Freely definable label for the SAP function. .
LastErrorVar | CProjektVariable | Error description | String variable for extensive description of the error which occurred last. .
Name | String | RFC function block | Name of the function block that was called up in the SAP system .
ServerFunction | CProjektFunktion | Function | Selection of a zenon function that is to be called up by the server program. Clicking on the ... button opens the dialog for Function selection.Note: If the function is called up by another project, ensure that this project is running in Runtime. .
ServerPgm | Bool | Run as server program | Definition of an SAP function as a server program.Active : The function is executed as a Server program.Inactive : The function is executed as a Client program.Default: Inactive If a variable is linked with the property, this is set to active (2 ) whilst the server program is called up. .
Wait | UInt32 | Waiting period | Stipulation of a time period in milliseconds that is waited for before and after calling the linked function, so that variables can be written or read with certainty. Recommended most of all for variables on controllers with slow communication or slow read cycles.Minimum: 0 Maximum: 4294967295 Default: 0 Recommendation: Variables of the internal driver or system driver: Low values by 0 ms .Mathematics driver: Values between 100 – 200 ms . (this driver is, depending on the system load, updated approximately every 100 ms .)Other drivers and controllers: Values that are above the update time of the driver. Correspondingly higher if the number of variables is higher. .


SapFunctions
ObjectModel COM [image] SapFunctions
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public WithEvents obFunReadTable As SapFunction
Public Sub ReadTable()
Dim obFunctions As SapFunctions
'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only

Fielddefinitions (FIELDS)
'Tables
Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata
Dim obRow As SapRow
Dim Error As tpSapError
' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions
' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
If obFunReadTable Is Nothing Then

Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If
' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of Parameters
If Not obParameters Is Nothing Then
'Tablename
Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then

Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value
'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then

Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value
'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then

Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value
'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")
If obParRowSkip Is Nothing Then

Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value
'Fields only
Set obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then

Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If
' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then
'Selections , "WHERE-Clause" (in)
Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then

Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else

obTabOptions.Clear
End If
'Names (in) and Structure (out) of read fields
Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then

Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else

obTabFields.Clear
End If
'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then

Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else

obTabData.Clear
End If
End If
' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)
'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub
' |
' |
' V
Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction,

ByVal Error As tpSapError)
'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...
' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)
' === check result
If Error = tpSapError_Ok Then 'no error
Dim obParameters As SapParameters
Dim obParameter As SapParameter
Dim obTables As SapTables
Dim obTable As SapTable
Dim obTabFields As SapTable 'Input
Dim obTabData As SapTable 'Output
Dim Count As Integer
Dim RowData As String
' === check Parameter and Tables
Set obTables = obFunReadTable.Tables
' === check Table "FIELDS"
Set obTabFields = obTables.Item("FIELDS")
Count = obTabFields.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows
For i = 0 To Count - 1

RowData = obTabFields.Rows.Item(i).RawData

'FIELDNAME = Name of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value = GetNextField(RowData)

'OFFSET = Start of the Field in the Row

thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value = CInt(GetNextField(RowData))

'LENGTH = Length of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value = CInt(GetNextField(RowData))

'TYPE = Datatype of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value = GetNextField(RowData)

'FIELDTEXT = description of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value = GetNextField(RowData)
Next
' === check Table "DATA"
Set obTabData = obTables.Item("DATA")
Count = obTabData.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1

'One row of the table "DATA" contains only one filed with 512 characters

RowData = obTabData.Rows.Item(i).RawData

thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData

Next
End If
End Sub
Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String
Select Case Error

Case tpSapError_No_Connection ' No connection to SAP system

ShortError = "No connection to SAP system"

Case tpSapError_Ok ' OK.

ShortError = "No Error"

Case tpSapError_Failure ' Error occurred

ShortError = "Error occurred"

Case tpSapError_Exception ' Exception raised

ShortError = "Exception raised"

Case tpSapError_Sys_Exception ' System exception raised, connection closed

ShortError = "System exception raised, connection closed"

Case tpSapError_Call ' Call received

ShortError = "Call received"

Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only

ShortError = "Internal communication, repeat (internal use only)"

Case tpSapError_Closed ' Connection closed by the other side

ShortError = "Connection closed by the other side"

Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)

ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"

Case tpSapError_No_Tid ' No Transaction ID available

DError = "No Transaction ID available"

Case tpSapError_Executed ' Function already executed

ShortError = "Function already executed"

Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)

ShortError = "Synchronous Call in Progress (only for Windows)"

Case tpSapError_Memory_Insufficient ' Memory insufficient

ShortError = "Memory insufficient"

Case tpSapError_Version_Mismatch ' Version mismatch

ShortError = "Version mismatch"

Case tpSapError_Not_found ' Function not found (internal use only)

ShortError = "Function not found (internal use only)"

Case tpSapError_Call_Not_Supported ' This call is not supported

ShortError = "This call is not supported"

Case tpSapError_Not_Owner ' Caller does not own the specified handle

ShortError = "Caller does not own the specified handle"

Case tpSapError_Not_Initialized ' RFC not yet initialized

ShortError = "RFC not yet initialized"

Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed

ShortError = "A system call such as RFC_PING for connection test is executed"

Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API call

ShortError = "An invalid handle was passed to an API call"

Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.

ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."

Case tpSapError_Canceled ' An rfc call has been canceled by user

ShortError = "An rfc call has been canceled by user"

Case tpSapError_Conversion ' An error during conversion has been detected

ShortError = "An error during conversion has been detected"

Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format

ShortError = "The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format"

Case tpSapError_Timeout ' Timeout

ShortError = "Timeout"
End Select
'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub
Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...
pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?

GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters

GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function
Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub


Properties
ObjectModel COM [image] SapFunctions [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Count of defined SAP functions | Available | Available | Available | Available
Parent | iproject | Parent-object | Available | Available | Available | Available


Count
ObjectModel COM [image] SapFunctions [image] Properties [image] Count
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] SapFunctions [image] Properties [image] Parent
Remarks

Datatype
IProject

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] SapFunctions [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateSapFunction | isapfunction | Creates a new SAP function (unique name) | Available | Available | Available | Available
DeleteSapFunction | variant_bool | Deletes the given SAP function | Available | Available | Available | Available
Item | isapfunction | Returns the SAP function by name or position | Available | Available | Available | Available


CreateSapFunction
ObjectModel COM [image] SapFunctions [image] Methods [image] CreateSapFunction
Remarks

Datatype
ISapFunction

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR


DeleteSapFunction
ObjectModel COM [image] SapFunctions [image] Methods [image] DeleteSapFunction
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR


Item
ObjectModel COM [image] SapFunctions [image] Methods [image] Item
Remarks

Datatype
ISapFunction

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vID as VARIANT


SapParameter
ObjectModel COM [image] SapParameter
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public WithEvents obFunReadTable As SapFunction
Public Sub ReadTable()
Dim obFunctions As SapFunctions
'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only

Fielddefinitions (FIELDS)
'Tables
Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata
Dim obRow As SapRow
Dim Error As tpSapError
' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions
' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
If obFunReadTable Is Nothing Then

Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If
' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of

Parameters
If Not obParameters Is Nothing Then
'Tablename
Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then

Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value
'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then

Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value
'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then

Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value
'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")
If obParRowSkip Is Nothing Then

Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value
'Fields only
S

et obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then

Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If
' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then
'Selections , "WHERE-Clause" (in)
Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then

Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else

obTabOptions.Clear
End If
'Names (in) and Structure (out) of read fields
Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then

Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else

obTabFields.Clear
End If
'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then

Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else

obTabData.Clear
End If
End If
' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)
'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub
' |
' |
' V
Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction,

ByVal Error As tpSapError)
'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...
' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)
' === check result
If Error = tpSapError_Ok Then 'no error
Dim obParameters As SapParameters
Dim obParameter As SapParameter
Dim obTables As SapTables
Dim obTable As SapTable
Dim obTabFields As SapTable 'Input
Dim obTabData As SapTable 'Output
Dim Count As Integer
Dim RowData As String
' === check Parameter and Tables
Set obTables = obFunReadTable.Tables
' === check Table "FIELDS"
Set obTabFields = obTables.Item("FIELDS")
Count = obTabFields.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1

RowData = obTabFields.Rows.Item(i).RawData

'FIELDNAME = Name of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value = GetNextField(RowData)

'OFFSET = Start of the Field in the Row

thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value = CInt(GetNextField(RowData))

'LENGTH = Length of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value = CInt(GetNextField(RowData))

'TYPE = Datatype of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value =

GetNextField(RowData)
'FIELDTEXT = description of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value = GetNextField(RowData)

Next

' === check Table "DATA"

Set obTabData = obTables.Item("DATA")

Count = obTabData.Rows.Count

If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1

'One row of the table "DATA" contains only one filed with 512 characters

RowData = obTabData.Rows.Item(i).RawData

thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData

Next
End If
End Sub
Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String
Select Case Error

Case tpSapError_No_Connection ' No connection to SAP system

ShortError = "No connection to SAP system"

Case tpSapError_Ok ' OK.

ShortError = "No Error"

Case tpSapError_Failure ' Error occurred

ShortError = "Error occurred"

Case tpSapError_Exception ' Exception raised

ShortError = "Exception raised"

Case tpSapError_Sys_Exception ' System exception raised, connection closed

ShortError = "System exception raised, connection closed"

Case tpSapError_Call ' Call received

ShortError = "Call received"

Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only

ShortError = "Internal communication, repeat (internal use only)"

Case tpSapError_Closed ' Connection closed by the other side

ShortError = "Connection closed by the other side"

Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)

ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"

Case tpSapError_No_Tid ' No Transaction ID available

DError = "No Transaction ID available"

Case tpSapError_Executed ' Function already executed

ShortError = "Function already executed"

Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)

ShortError = "Synchronous Call in Progress (only for Windows)"

Case tpSapError_Memory_Insufficient ' Memory insufficient

ShortError = "Memory insufficient"

Case tpSapError_Version_Mismatch ' Version mismatch

ShortError = "Version mismatch"

Case tpSapError_Not_found ' Function not found (internal use only)

ShortError = "Function not found (internal use only)"

Case tpSapError_Call_Not_Supported ' This call is not supported

ShortError = "This call is not supported"

Case tpSapError_Not_Owner ' Caller does not own the specified handle

ShortError = "Caller does not own the specified handle"

Case tpSapError_Not_Initialized ' RFC not yet initialized

ShortError = "RFC not yet initialized"

Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed

ShortError = "A system call such as RFC_PING for connection test is executed"

Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API call

ShortError = "An invalid handle was passed to an API call"

Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.

ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."

Case tpSapError_Canceled ' An rfc call has been canceled by user

ShortError = "An rfc call has been canceled by user"

Case tpSapError_Conversion ' An error during conversion has been detected

ShortError = "An error during conversion has been detected"

Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format

ShortError = "The received data has an unsupported format. e.g.: non unicode
application receives data sent in unicode format"

Case tpSapError_Timeout ' Timeout

ShortError = "Timeout"
End Select
'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub
Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...
pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?

GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters

GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function
Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub


Properties
ObjectModel COM [image] SapParameter [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Default | variant_bool | SAP parameter has a default value (TRUE/FALSE) | Available | Available | Available | Available
Name | bstr | Name of the SAP parameter | Available | Available | Available | Available
Optional | variant_bool | SAP parameter is optional (TRUE/FALSE) | Available | Available | Available | Available
Parent | isapparameters | Parent-object | Available | Available | Available | Available
RawData | bstr | Returns the raw Data of the SAP parameter in a delimited string | Unused | Readonly | Available | Available


Default
ObjectModel COM [image] SapParameter [image] Properties [image] Default
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] SapParameter [image] Properties [image] Name
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Optional
ObjectModel COM [image] SapParameter [image] Properties [image] Optional
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] SapParameter [image] Properties [image] Parent
Remarks

Datatype
ISapParameters

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


RawData
ObjectModel COM [image] SapParameter [image] Properties [image] RawData
Remarks

returns the data of the Parameter as one line, the values are separated by a Line-Feed character...

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] SapParameter [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Value [GET] | variant | Value of the SAP parameter | Available | Available | Available | Available
Value [PUT] | void | Value of the SAP parameter | Available | Available | Available | Available


Value [GET]
ObjectModel COM [image] SapParameter [image] Methods [image] Value [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT


Value [PUT]
ObjectModel COM [image] SapParameter [image] Methods [image] Value [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT

newValue as VARIANT


DynProperties
ObjectModel COM [image] SapParameter [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

SAP Parameter


SAP Parameter
ObjectModel COM [image] SapParameter [image] DynProperties [image] SAP Parameter
Overview
External Name | Type | Display Name | Description
Info | String | Information | Freely definable short text. Serves only informational purposes and if available, it is set when a SAP function is created via the wizard in accordance with the interface description in the SAP system. .
Optional | Bool | Optional | States whether der parameter or table is optional. Optional parameters and tables can be left out when a function block is called.Serves only informational purposes and it is set when a SAP function is created via the wizard in accordance with the interface description in the SAP system. .


SapParameters
ObjectModel COM [image] SapParameters
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public WithEvents obFunReadTable As SapFunction
Public Sub ReadTable()
Dim obFunctions As SapFunctions
'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only

Fielddefinitions (FIELDS)
'Tables
Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata
Dim obRow As SapRow
Dim Error As tpSapError
' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions
' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
If obFunReadTable Is Nothing Then

Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If
' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of Parameters
If Not obParameters Is Nothing Then

'Tablename

Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then

Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value
'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then

Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value
'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then

Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value
'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")
If obParRowSkip Is Nothing Then

Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value
'Fields only
Set obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then

Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If
' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then
'Selections , "WHERE-Clause" (in)
Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then

Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else

obTabOptions.Clear
End If
'Names (in) and Structure (out) of read fields
Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then

Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else

obTabFields.Clear
End If
'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then

Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else

obTabData.Clear
End If
End If
' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)
'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub
' |
' |
' V
Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction, ByVal Error As tpSapError)
'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...
' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)
' === check result
If Error = tpSapError_Ok Then 'no error
Dim obParameters As SapParameters
Dim obParameter As SapParameter
Dim obTables As SapTables
Dim obTable As SapTable
Dim obTabFields As SapTable 'Input
Dim obTabData As SapTable 'Output
Dim Count As Integer
Dim RowData As String
' === check Parameter and Tables
Set obTables = obFunReadTable.Tables
' === check Table "FIELDS"
Set obTabFields = obTables.Item("FIELDS")
Count = obTabFields.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows
For i = 0 To Count - 1

RowData = obTabFields.Rows.Item(i).RawData

'FIELDNAME = Name of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value = GetNextField(RowData)

'OFFSET = Start of the Field in the Row

thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value = CInt(GetNextField(RowData))

'LENGTH = Length of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value = CInt(GetNextField(RowData))

'TYPE = Datatype of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value = GetNextField(RowData)

'FIELDTEXT = description of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value = GetNextField(RowData)
Next
' === check Table "DATA"
Set obTabData = obTables.Item("DATA")
Count = obTabData.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1

'One row of the table "DATA" contains only one filed with 512 characters

RowData = obTabData.Rows.Item(i).RawData

thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData

Next
End If
End Sub
Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String
Select Case Error

Case tpSapError_No_Connection ' No connection to SAP system

ShortError = "No connection to SAP system"

Case tpSapError_Ok ' OK.

ShortError = "No Error"

Case tpSapError_Failure ' Error occurred

ShortError = "Error occurred"

Case tpSapError_Exception ' Exception raised

ShortError = "Exception raised"

Case tpSapError_Sys_Exception ' System exception raised, connection closed

ShortError = "System exception raised, connection closed"

Case tpSapError_Call ' Call received

ShortError = "Call received"

Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only

ShortError = "Internal communication, repeat (internal use only)"

Case tpSapError_Closed ' Connection closed by the other side

ShortError = "Connection closed by the other side"

Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)

ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"

Case tpSapError_No_Tid ' No Transaction ID available

DError = "No Transaction ID available"

Case tpSapError_Executed ' Function already executed

ShortError = "Function already executed"

Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)

ShortError = "Synchronous Call in Progress (only for Windows)"

Case tpSapError_Memory_Insufficient ' Memory insufficient

ShortError = "Memory insufficient"

Case tpSapError_Version_Mismatch ' Version mismatch

ShortError = "Version mismatch"

Case tpSapError_Not_found ' Function not found (internal use only)

ShortError = "Function not found (internal use only)"

Case tpSapError_Call_Not_Supported ' This call is not supported

ShortError = "This call is not supported"

Case tpSapError_Not_Owner ' Caller does not own the specified handle

ShortError = "Caller does not own the specified handle"

Case tpSapError_Not_Initialized ' RFC not yet initialized

ShortError = "RFC not yet initialized"

Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed

ShortError = "A system call such as RFC_PING for connection test is executed"

Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API call

ShortError = "An invalid handle was passed to an API call"

Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.

ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."

Case tpSapError_Canceled ' An rfc call has been canceled by user

ShortError = "An rfc call has been canceled by user"

Case tpSapError_Conversion ' An error during conversion has been detected

ShortError = "An error during conversion has been detected"

Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format

ShortError = "The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format"

Case tpSapError_Timeout ' Timeout

ShortError = "Timeout"
End Select
'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub
Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...
pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?

GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters

GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function
Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub


Properties
ObjectModel COM [image] SapParameters [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Count of defined SAP parameters | Available | Available | Available | Available
Parent | isapfunction | Parent-object | Available | Available | Available | Available


Count
ObjectModel COM [image] SapParameters [image] Properties [image] Count
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] SapParameters [image] Properties [image] Parent
Remarks

Datatype
ISapFunction

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] SapParameters [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateSapParameter | isapparameter | Creates a new SAP parameter (unique name) | Available | Available | Available | Available
DeleteSapParameter | variant_bool | Deletes the given SAP parameter | Available | Available | Available | Available
Item | isapparameter | Returns the SAP parameter by name or position | Available | Available | Available | Available


CreateSapParameter
ObjectModel COM [image] SapParameters [image] Methods [image] CreateSapParameter
Remarks

Datatype
ISapParameter

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR

bOptional as VARIANT

bDefault as VARIANT


DeleteSapParameter
ObjectModel COM [image] SapParameters [image] Methods [image] DeleteSapParameter
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR


Item
ObjectModel COM [image] SapParameters [image] Methods [image] Item
Remarks

Datatype
ISapParameter

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vID as VARIANT


SapRow
ObjectModel COM [image] SapRow
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Public WithEvents obFunReadTable As SapFunction
Public Sub ReadTable()
Dim obFunctions As SapFunctions
'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only

Fielddefinitions (FIELDS)
'Tables
Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata
Dim obRow As SapRow
Dim Error As tpSapError
' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions
' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
I

f obFunReadTable Is Nothing Then

Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If
' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of Parameters
If Not obParameters Is Nothing Then

'Tablename

Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then

Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value
'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then

Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value
'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then

Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value
'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")
If obParRowSkip Is Nothing Then

Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value
'Fields only
Set obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then

Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If
' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then

'Selections , "WHERE-Clause" (in)

Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then

Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else

obTabOptions.Clear
End If
'Names (in) and Structure (out) of read fields
Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then

Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else

obTabFields.Clear
End If
'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then

Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else

obTabData.Clear
End If
End If
' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)
'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub
' |
' |
' V
Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction, ByVal Error As tpSapError)
'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...
' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)
' === check result
If Error = tpSapError_Ok Then 'no error
Dim obParameters As SapParameters
Dim obParameter As SapParameter
Dim obTables As SapTables
Dim obTable As SapTable
Dim obTabFields As SapTable 'Input
Dim obTabData As SapTable 'Output
Dim Count As Integer
Dim RowData As String
' === check Parameter and Tables
Set obTables = obFunReadTable.Tables
' === check Table "FIELDS"
Set obTabFields = obTables.Item("FIELDS")
Count = obTabFields.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1

RowData = obTabFields.Rows.Item(i).RawData

'FIELDNAME = Name of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value = GetNextField(RowData)

'OFFSET = Start of the Field in the Row

thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value = CInt(GetNextField(RowData))

'LENGTH = Length of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value = CInt(GetNextField(RowData))

'TYPE = Datatype of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value = GetNextField(RowData)

'FIELDTEXT = description of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value

Next
' === check Table "DATA"

Set obTabData = obTables.Item("DATA")

Count = obTabData.Rows.Count

If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1

'One row of the table "DATA" contains only one filed with 512 characters

RowData = obTabData.Rows.Item(i).RawData

thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData

Next
End If
End Sub
Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String
Select Case Error

Case tpSapError_No_Connection ' No connection to SAP system

ShortError = "No connection to SAP system"

Case tpSapError_Ok ' OK.

ShortError = "No Error"

Case tpSapError_Failure ' Error occurred

ShortError = "Error occurred"

Case tpSapError_Exception ' Exception raised

ShortError = "Exception raised"

Case tpSapError_Sys_Exception ' System exception raised, connection closed

ShortError = "System exception raised, connection closed"

Case tpSapError_Call ' Call received

ShortError = "Call received"

Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only

ShortError = "Internal communication, repeat (internal use only)"

Case tpSapError_Closed ' Connection closed by the other side

ShortError = "Connection closed by the other side"

Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)

ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"

Case tpSapError_No_Tid ' No Transaction ID available

DError = "No Transaction ID available"

Case tpSapError_Executed ' Function already executed

ShortError = "Function already executed"

Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)

ShortError = "Synchronous Call in Progress (only for Windows)"

Case tpSapError_Memory_Insufficient ' Memory insufficient

ShortError = "Memory insufficient"

Case tpSapError_Version_Mismatch ' Version mismatch

ShortError = "Version mismatch"

Case tpSapError_Not_found ' Function not found (internal use only)

ShortError = "Function not found (internal use only)"

Case tpSapError_Call_Not_Supported ' This call is not supported

ShortError = "This call is not supported"

Case tpSapError_Not_Owner ' Caller does not own the specified handle

ShortError = "Caller does not own the specified handle"

Case tpSapError_Not_Initialized ' RFC not yet initialized

ShortError = "RFC not yet initialized"

Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed

ShortError = "A system call such as RFC_PING for connection test is executed"

Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API call

ShortError = "An invalid handle was passed to an API call"

Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.

ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."

Case tpSapError_Canceled ' An rfc call has been canceled by user

ShortError = "An rfc call has been canceled by user"

Case tpSapError_Conversion ' An error during conversion has been detected

ShortError = "An error during conversion has been detected"

Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format

ShortError = "The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format"

Case tpSapError_Timeout ' Timeout

ShortError = "Timeout"
End Select
'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub
Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...
pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?

GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters

GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function
Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub


Properties
ObjectModel COM [image] SapRow [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Parent | isaprows | Parent-object | Available | Available | Available | Available
RawData | bstr | Returns the raw Data of the SAP row in a delimited string | Available | Unused | Available | Available


Parent
ObjectModel COM [image] SapRow [image] Properties [image] Parent
Remarks

Datatype
ISapRows

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


RawData
ObjectModel COM [image] SapRow [image] Properties [image] RawData
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] SapRow [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Value [GET] | variant | Value of the SAP row / column | Available | Available | Available | Available
Value [PUT] | void | Value of the SAP row / column | Available | Available | Available | Available


Value [GET]
ObjectModel COM [image] SapRow [image] Methods [image] Value [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT


Value [PUT]
ObjectModel COM [image] SapRow [image] Methods [image] Value [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT

newValue as VARIANT


SapRows
ObjectModel COM [image] SapRows
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Public WithEvents obFunReadTable As SapFunction
Public Sub ReadTable()
Dim obFunctions As SapFunctions
'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only

Fielddefinitions (FIELDS)
'Tables

Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata
Dim obRow As SapRow
Dim Error As tpSapError
' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions
' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
If obFunReadTable Is Nothing Then

Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If
' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of Parameters
If Not obParameters Is Nothing Then

'Tablename

Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then

Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value
'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then

Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value
'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then

Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value
'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")

If obParRowSkip Is Nothing Then
Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value
'Fields only
Set obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then

Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If
' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then

'Selections , "WHERE-Clause" (in)

Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then

Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else

obTabOptions.Clear
End If
'Names (in) and Structure (out) of read fields
Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then

Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else

obTabFields.Clear
End If
'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then

Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else

obTabData.Clear
End If
End If
' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)
'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub
' |
' |
' V
Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction, ByVal Error As tpSapError)
'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...
' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)
' === check result
If Error = tpSapError_Ok Then 'no error
Dim obParameters As SapParameters
Dim obParameter As SapParameter
Dim obTables As SapTables
Dim obTable As SapTable
Dim obTabFields As SapTable 'Input
Dim obTabData As SapTable 'Output
Dim Count As Integer
Dim RowData As String
' === check Parameter and Tables
Set obTables = obFunReadTable.Tables
' === check Table "FIELDS"
Set obTabFields = obTables.Item("FIELDS")
Count = obTabFields.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows
For i = 0 To Count - 1

RowData = obTabFields.Rows.Item(i).RawData

'FIELDNAME = Name of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value = GetNextField(RowData)

'OFFSET = Start of the Field in the Row

thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value = CInt(GetNextField(RowData))

'LENGTH = Length of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value = CInt(GetNextField(RowData))

'TYPE = Datatype of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value = GetNextField(RowData)

'FIELDTEXT = description of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value = GetNextField(RowData)
Next
' === check Table "DATA"
Set obTabData = obTables.Item("DATA")
Count = obTabData.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1

'One row of the table "DATA" contains only one filed with 512 characters

RowData = obTabData.Rows.Item(i).RawData

thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData

Next
End If
End Sub
Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String
Select Case Error

Case tpSapError_No_Connection ' No connection to SAP system

ShortError = "No connection to SAP system"

Case tpSapError_Ok ' OK.

ShortError = "No Error"

Case tpSapError_Failure ' Error occurred

ShortError = "Error occurred"

Case tpSapError_Exception ' Exception raised

ShortError = "Exception raised"

Case tpSapError_Sys_Exception ' System exception raised, connection closed

ShortError = "System exception raised, connection closed"

Case tpSapError_Call ' Call received

ShortError = "Call received"

Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only

ShortError = "Internal communication, repeat (internal use only)"

Case tpSapError_Closed ' Connection closed by the other side

ShortError = "Connection closed by the other side"

Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)

ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"

Case tpSapError_No_Tid ' No Transaction ID available

DError = "No Transaction ID available"

Case tpSapError_Executed ' Function already executed

ShortError = "Function already executed"

Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)

ShortError = "Synchronous Call in Progress (only for Windows)"

Case tpSapError_Memory_Insufficient ' Memory insufficient

ShortError = "Memory insufficient"

Case tpSapError_Version_Mismatch ' Version mismatch

ShortError = "Version mismatch"

Case tpSapError_Not_found ' Function not found (internal use only)

ShortError = "Function not found (internal use only)"

Case tpSapError_Call_Not_Supported ' This call is not supported

ShortError = "This call is not supported"

Case tpSapError_Not_Owner ' Caller does not own the specified handle

ShortError = "Caller does not own the specified handle"

Case tpSapError_Not_Initialized ' RFC not yet initialized

ShortError = "RFC not yet initialized"

Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed

ShortError = "A system call such as RFC_PING for connection test is executed"

Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API call

ShortError = "An invalid handle was passed to an API call"

Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.

ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."

Case tpSapError_Canceled ' An rfc call has been canceled by user

ShortError = "An rfc call has been canceled by user"

Case tpSapError_Conversion ' An error during conversion has been detected

ShortError = "An error during conversion has been detected"

Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format

ShortError = "The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format"

Case tpSapError_Timeout ' Timeout

ShortError = "Timeout"
End Select
'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub
Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...
pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?

GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters

GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function
Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub


Properties
ObjectModel COM [image] SapRows [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Count of defined SAP rows in the table | Available | Available | Available | Available
Parent | isaptable | Parent-object | Available | Available | Available | Available


Count
ObjectModel COM [image] SapRows [image] Properties [image] Count
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] SapRows [image] Properties [image] Parent
Remarks

Datatype
ISapTable

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] SapRows [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AppendSapRow | isaprow | Appends a new SAP row at the end of the table | Available | Unused | Available | Available
DeleteSapRow | variant_bool | Deletes the SAP row at the given index | Available | Unused | Available | Available
InsertSapRow | isaprow | Inserts a new SAP row at the given index | Available | Unused | Available | Available
Item | isaprow | Returns the SAP row at the given index | Available | Unused | Available | Available


AppendSapRow
ObjectModel COM [image] SapRows [image] Methods [image] AppendSapRow
Remarks

Datatype
ISapRow

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


DeleteSapRow
ObjectModel COM [image] SapRows [image] Methods [image] DeleteSapRow
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
p_index as long


InsertSapRow
ObjectModel COM [image] SapRows [image] Methods [image] InsertSapRow
Remarks

Datatype
ISapRow

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
Index as long


Item
ObjectModel COM [image] SapRows [image] Methods [image] Item
Remarks

Datatype
ISapRow

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vID as VARIANT


SapTable
ObjectModel COM [image] SapTable
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public WithEvents obFunReadTable As SapFunction
Public Sub ReadTable()
Dim obFunctions As SapFunctions
'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only

Fielddefinitions (FIELDS)
'Tables
Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata
Dim obRow As SapRow
Dim Error As tpSapError
' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions
' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
If obFunReadTable Is Nothing Then

Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If
' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of Parameters
If Not obParameters Is Nothing Then

'Tablename

Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then

Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value
'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then

Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value
'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then

Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value
'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")
If obParRowSkip Is Nothing Then

Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value
'Fields only
Set obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then

Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If
' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then

'Selections , "WHERE-Clause" (in)

Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then

Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else

obTabOptions.Clear
End If
'Names (in) and Structure (out) of read fields
Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then

Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else

obTabFields.Clear
End If
'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then

Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else

obTabData.Clear
End If
End If
' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)
'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub
' |
' |
' V
Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction, ByVal Error As tpSapError)
'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...
' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)
' === check result
If Error = tpSapError_Ok Then 'no error

Dim obParameters As SapParameters

Dim obParameter As SapParameter

Dim obTables As SapTables

Dim obTable As SapTable

Dim obTabFields As SapTable 'Input

Dim obTabData As SapTable 'Output

Dim Count As Integer

Dim RowData As String

' === check Parameter and Tables

Set obTables = obFunReadTable.Tables

' === check Table "FIELDS"

Set obTabFields = obTables.Item("FIELDS")

Count = obTabFields.Rows.Count

If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1

RowData = obTabFields.Rows.Item(i).RawData

'FIELDNAME = Name of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value = GetNextField(RowData)

'OFFSET = Start of the Field in the Row

thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value = CInt(GetNextField(RowData))

'LENGTH = Length of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value = CInt(GetNextField(RowData))

'TYPE = Datatype of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value = GetNextField(RowData)

'FIELDTEXT = description of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value = GetNextField(RowData)

Next

' === check Table "DATA"

Set obTabData = obTables.Item("DATA")

Count = obTabData.Rows.Count

If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1

'One row of the table "DATA" contains only one filed with 512 characters

RowData = obTabData.Rows.Item(i).RawData

thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData

Next

End If
End Sub
Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String
Select Case Error

Case tpSapError_No_Connection ' No connection to SAP system

ShortError = "No connection to SAP system"

Case tpSapError_Ok ' OK.

ShortError = "No Error"

Case tpSapError_Failure ' Error occurred

ShortError = "Error occurred"

Case tpSapError_Exception ' Exception raised

ShortError = "Exception raised"

Case tpSapError_Sys_Exception ' System exception raised, connection closed

ShortError = "System exception raised, connection closed"

Case tpSapError_Call ' Call received

ShortError = "Call received"
Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only

ShortError = "Internal communication, repeat (internal use only)"

Case tpSapError_Closed ' Connection closed by the other side

ShortError = "Connection closed by the other side"

Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)

ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"

Case tpSapError_No_Tid ' No Transaction ID available

DError = "No Transaction ID available"

Case tpSapError_Executed ' Function already executed

ShortError = "Function already executed"

Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)

ShortError = "Synchronous Call in Progress (only for Windows)"

Case tpSapError_Memory_Insufficient ' Memory insufficient

ShortError = "Memory insufficient"

Case tpSapError_Version_Mismatch ' Version mismatch

ShortError = "Version mismatch"

Case tpSapError_Not_found ' Function not found (internal use only)

ShortError = "Function not found (internal use only)"

Case tpSapError_Call_Not_Supported ' This call is not supported

ShortError = "This call is not supported"

Case tpSapError_Not_Owner ' Caller does not own the specified handle

ShortError = "Caller does not own the specified handle"

Case tpSapError_Not_Initialized ' RFC not yet initialized

ShortError = "RFC not yet initialized"

Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed

ShortError = "A system call such as RFC_PING for connection test is executed"

Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API
call

ShortError = "An invalid handle was passed to an API call"

Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.

ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."

Case tpSapError_Canceled ' An rfc call has been canceled by user

ShortError = "An rfc call has been canceled by user"

Case tpSapError_Conversion ' An error during conversion has been detected

ShortError = "An error during conversion has been detected"

Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format

ShortError = "The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format"

Case tpSapError_Timeout ' Timeout

ShortError = "Timeout"
End Select
'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub
Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...
pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?

GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters

GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function
Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub


Properties
ObjectModel COM [image] SapTable [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Name | bstr | Name of the SAP table | Available | Available | Available | Available
Optional | variant_bool | SAP table is optional (TRUE/FALSE) | Available | Available | Available | Available
Parent | isaptables | Parent-object | Available | Available | Available | Available


Name
ObjectModel COM [image] SapTable [image] Properties [image] Name
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Optional
ObjectModel COM [image] SapTable [image] Properties [image] Optional
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] SapTable [image] Properties [image] Parent
Remarks

Datatype
ISapTables

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] SapTable [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Clear | void | Deletes all rows in the table | Available | Available | Available | Available
Rows | isaprows | Returns the collection of the rows in the table | Available | Unused | Available | Available


Clear
ObjectModel COM [image] SapTable [image] Methods [image] Clear
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Rows
ObjectModel COM [image] SapTable [image] Methods [image] Rows
Remarks

Datatype
ISapRows

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


DynProperties
ObjectModel COM [image] SapTable [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

SAP table


SAP table
ObjectModel COM [image] SapTable [image] DynProperties [image] SAP table
Overview
External Name | Type | Display Name | Description
Info | String | Information | Freely definable short text. Serves only informational purposes and if available, it is set when a SAP function is created via the wizard in accordance with the interface description in the SAP system. .
Name | String | Name in SAP system | Name of the parameter, the table or the structure field in the SAP system. .
Optional | Bool | Optional | States whether der parameter or table is optional. Optional parameters and tables can be left out when a function block is called.Serves only informational purposes and it is set when a SAP function is created via the wizard in accordance with the interface description in the SAP system. .
RowCountVar | CProjektVariable | Number of lines | Numeric variables for the number of lines which should be taken from the variable linked with the table respectively the number of lines read when a SAP function is called. .
Type | SByte | Type | Type of the parameter. Dependent of the function type. Serves only informational purposes and it is set when a SAP function is created via the wizard in accordance with the interface description in the SAP system.Import : the value of the parameter is transferred to the function block when called up.Export: The value of the parameter is returned by the function call.Changing : both input and return parameter.Table : Function type table. Cannot be changed. .
Variable | CProjektVariable | Variable | zenon variable linked with the parameter, the table or the structure field. For tables it is normally an array variable. .


SapTables
ObjectModel COM [image] SapTables
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public WithEvents obFunReadTable As SapFunction
Public Sub ReadTable()
Dim obFunctions As SapFunctions
'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only

Fielddefinitions (FIELDS)
'Tables
Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata
Dim obRow As SapRow
Dim Error As tpSapError
' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions
' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
If obFunReadTable Is Nothing Then

Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If
' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of Parameters
If Not obParameters Is Nothing Then

'Tablename
Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then

Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value
'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then

Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value
'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then

Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value
'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")
If obParRowSkip Is Nothing Then

Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value
'Fields only
Set obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then

Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If
' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then

'Selections , "WHERE-Clause" (in)

Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then

Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else
obTabOptions.Clear
End If

'Names (in) and Structure (out) of read fields

Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then

Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else

obTabFields.Clear
End If
'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then

Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else

obTabData.Clear
End If
End If
' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)
'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub
' |
' |
' V
Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction, ByVal Error As tpSapError)
'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...
' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)
' === check result
If Error = tpSapError_Ok Then 'no error

Dim obParameters As SapParameters

Dim obParameter As SapParameter

Dim obTables As SapTables

Dim obTable As SapTable

Dim obTabFields As SapTable 'Input

Dim obTabData As SapTable 'Output

Dim Count As Integer

Dim RowData As String

' === check Parameter and Tables

Set obTables = obFunReadTable.Tables

' === check Table "FIELDS"

Set obTabFields = obTables.Item("FIELDS")

Count = obTabFields.Rows.Count

If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1

RowData = obTabFields.Rows.Item(i).RawData

'FIELDNAME = Name of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value = GetNextField(RowData)

'OFFSET = Start of the Field in the Row

thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value = CInt(GetNextField(RowData))

'LENGTH = Length of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value = CInt(GetNextField(RowData))

'TYPE = Datatype of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value = GetNextField(RowData)

'FIELDTEXT = description of the Field

thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value = GetNextField(RowData)

Next

' === check Table "DATA"

Set obTabData = obTables.Item("DATA")

Count = obTabData.Rows.Count

If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1

'One row of the table "DATA" contains only one filed with 512 characters

RowData = obTabData.Rows.Item(i).RawData

thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData

Next

End If
End Sub
Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String
Select Case Error

Case tpSapError_No_Connection ' No connection to SAP system

ShortError = "No connection to SAP system"

Case tpSapError_Ok ' OK.

StError = "No Error"

Case tpSapError_Failure ' Error occurred

ShortError = "Error occurred"

Case tpSapError_Exception ' Exception raised

ShortError = "Exception raised"

Case tpSapError_Sys_Exception ' System exception raised, connection closed

ShortError = "System exception raised, connection closed"

Case tpSapError_Call ' Call received

ShortError = "Call received"

Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only

ShortError = "Internal communication, repeat (internal use only)"

Case tpSapError_Closed ' Connection closed by the other side

ShortError = "Connection closed by the other side"

Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)

ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"

Case tpSapError_No_Tid ' No Transaction ID available

DError = "No Transaction ID available"

Case tpSapError_Executed ' Function already executed

ShortError = "Function already executed"

Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)

ShortError = "Synchronous Call in Progress (only for Windows)"

Case tpSapError_Memory_Insufficient ' Memory insufficient

ShortError = "Memory insufficient"

Case tpSapError_Version_Mismatch ' Version mismatch

ShortError = "Version mismatch"

Case tpSapError_Not_found ' Function not found (internal use only)

ShortError = "Function not found (internal use only)"

Case tpSapError_Call_Not_Supported ' This call is not supported

ShortError = "This call is not supported"

Case tpSapError_Not_Owner ' Caller does not own the specified handle

ShortError = "Caller does not own the specified handle"

Case tpSapError_Not_Initialized ' RFC not yet initialized

ShortError = "RFC not yet initialized"

Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed

ShortError = "A system call such as RFC_PING for connection test is executed"

Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API call

ShortError = "An invalid handle was passed to an API call"

Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.

ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."

Case tpSapError_Canceled ' An rfc call has been canceled by user

ShortError = "An rfc call has been canceled by user"

Case tpSapError_Conversion ' An error during conversion has been detected

ShortError = "An error during conversion has been detected"

Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format

ShortError = "The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format"

Case tpSapError_Timeout ' Timeout

ShortError = "Timeout"
End Select
'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub
Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...
pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?

GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters

GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function
Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub


Properties
ObjectModel COM [image] SapTables [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Count of defined SAP tables | Available | Available | Available | Available
Parent | isapfunction | Parent-object | Available | Available | Available | Available


Count
ObjectModel COM [image] SapTables [image] Properties [image] Count
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] SapTables [image] Properties [image] Parent
Remarks

Datatype
ISapFunction

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] SapTables [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateSapTable | isaptable | Creates a new SAP table (unique name) | Available | Available | Available | Available
DeleteSapTable | variant_bool | Deletes the given SAP table | Available | Available | Available | Available
Item | isaptable | Returns the SAP table by name or position | Available | Available | Available | Available


CreateSapTable
ObjectModel COM [image] SapTables [image] Methods [image] CreateSapTable
Remarks

Datatype
ISapTable

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR

bOptional as VARIANT


DeleteSapTable
ObjectModel COM [image] SapTables [image] Methods [image] DeleteSapTable
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR


Item
ObjectModel COM [image] SapTables [image] Methods [image] Item
Remarks

Datatype
ISapTable

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vID as VARIANT


ScheduleCustomPeriod
ObjectModel COM [image] ScheduleCustomPeriod
Remarks

A custom Time Period Schedule in which its Switching Actions are used instead of the standard ones.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] ScheduleCustomPeriod [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
EndDate | date | End Date of a Custom Period | Readonly | Readonly | Available | Available
StartDate | date | Start Date of a Custom Period | Readonly | Readonly | Available | Available
SwitchingPeriods | ischeduleswitchingperiods | Collection of Switching Periods in a Custom Period | Readonly | Readonly | Available | Available
SwitchingPoints | ischeduleswitchingpoints | Collection of Switching Points in a Custom Period | Readonly | Readonly | Available | Available


EndDate
ObjectModel COM [image] ScheduleCustomPeriod [image] Properties [image] EndDate
Remarks

End date of the period. Cannot be changed after creation.

Datatype
DATE

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


StartDate
ObjectModel COM [image] ScheduleCustomPeriod [image] Properties [image] StartDate
Remarks

Start date of the period. Cannot be changed after creation.

Datatype
DATE

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


SwitchingPeriods
ObjectModel COM [image] ScheduleCustomPeriod [image] Properties [image] SwitchingPeriods
Remarks

Collection of Switching Periods

Datatype
IScheduleSwitchingPeriods

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


SwitchingPoints
ObjectModel COM [image] ScheduleCustomPeriod [image] Properties [image] SwitchingPoints
Remarks

Collection of Switching Points

Datatype
IScheduleSwitchingPoints

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ScheduleFunction
ObjectModel COM [image] ScheduleFunction
Remarks

Link to a single Function

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_SchedulerLinkFunctionToPeriod()

 {

//Specify a ScheduleGroup via Index!

 String fullString = "";

 zenOn.IScheduleGroup group =

 ActiveDocument.Scheduler.ScheduleGroups.ItemByItem(0);

if (group != null)

 {

 zenOn.IScheduleStandardDay monday =

 group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday);

if (monday != null)

 {

//Creates a Reload Function!

 zenOn.IRtFunctions functions = ActiveDocument.RtFunctions();

 zenOn.IRtFunction function = functions.Create("Reload_Period", zenOn.tpFunctionTypes.tpReloadProject);

//Specify a SchedulePeriod to which the Function should be linked!

 zenOn.IScheduleSwitchingPeriod period = monday.SwitchingPeriods.Item(0);

if (period != null)

 {

 fullString += "Monday:\n";

 fullString += "Before Editing : \n";

 fullString += "Amount of Functions: " + (period.Start.Functions.Count + period.End.Functions.Count) + "\n\n";

 fullString += "SwitchingPeriod: \n\n";

 fullString += "Function(s) linked at start: \n";

 Macro_CreateReportForAFunctionsContainer(period.Start.Functions, ref fullString);

 fullString += "Function(s) linked at end: \n";

 Macro_CreateReportForAFunctionsContainer(period.End.Functions, ref fullString);

 fullString += "------------------------------------";

 period.Start.Functions.Create(function);

 period.End.Functions.Create(function);

 fullString += "\n\nAfter Editing : \n";

 fullString += "Amount of Functions: " + (period.Start.Functions.Count + period.End.Functions.Count) + "\n\n";

 fullString += "SwitchingPeriod: \n\n";

 fullString += "Function(s) linked at start: \n";

 Macro_CreateReportForAFunctionsContainer(period.Start.Functions, ref fullString);

 fullString += "Function(s) linked at end: \n";

 Macro_CreateReportForAFunctionsContainer(period.End.Functions, ref fullString);

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while accessing schedule '" + group.Name + "'");

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");

 }

 System.Windows.Forms.MessageBox.Show(fullString);

 }

privatevoid Macro_CreateReportForAFunctionsContainer(zenOn.IScheduleFunctions functionsContainer,

ref String report)

 {

int functionCount = functionsContainer.Count;

for (int i = 0; i < functionCount; i++)

 {

 zenOn.IScheduleFunction function = functionsContainer.Item(i);

if (function != null)

 {

 Macro_ReportOfOneFunction(function, ref report);

 report += "\n\n";

 }

 }

 }

privatevoid Macro_ReportOfOneFunction(zenOn.IScheduleFunction function, ref String report)

 {

 report +=

"Name: " + function.Function.Name + "\n" +

"Active: " + function.Active + "\n" +

"Type: " + function.Function.Type;

 }
VBA
Copy
Public Sub LinkFunctionToPeriod()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
'Specify ScheduleGroup via Index!
Set group = groups.ItemByItem(0)
If Not group Is Nothing Then

 Dim monday As ScheduleStandardDay

 Set monday = group.Schedules.GetStandardDay(tpScheduleMonday)

 If Not monday Is Nothing Then

 Dim functions As RtFunctions
 Set funcs = MyWorkspace.ActiveDocument.RtFunctions
 'Creates a Reload Function!
 Set func = funcs.Create("Reload_Test", tpReloadProject)
 Dim period As ScheduleSwitchingPeriod
 'Specify a SwitchingPeriod to which the Function should be linked!
 Set period = monday.SwitchingPeriods.Item(0)

 If Not period Is Nothing Then
 Dim fullString As String
 fullString = fullString & "------------------------------------" & vbNewLine
 fullString = fullString & "Monday:" & vbNewLine
 fullString = fullString & "------------------------------------" & vbNewLine & vbNewLine
 fullString = fullString & "Before Editing: " & vbNewLine & vbNewLine
 fullString = fullString & "SwitchingPeriod:" & vbNewLine
 fullString = fullString & "Amount of Functions: " & (period.Start.functions.count + period.End.functions.count) & vbNewLine
 fullString = fullString & "Function(s) linked at start:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.Start.functions, fullString)
 fullString = fullString & "Function(s) linked at end:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.End.functions, fullString)

 Dim funcTest As ScheduleFunction
 Set funcTest = period.Start.functions.Create(func)
 Set funcTest = period.End.functions.Create(func)

 fullString = fullString & vbNewLine & vbNewLine & "After Editing: " & vbNewLine
 fullString = fullString & "SwitchingPeriod:" & vbNewLine
 fullString = fullString & "Amount of Functions: " & (period.Start.functions.count + period.End.functions.count) & vbNewLine & vbNewLine
 fullString = fullString & "Function(s) linked at start:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.Start.functions, fullString)
 fullString = fullString & "Function(s) linked at end:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.End.functions, fullString)

 MsgBox fullString
 End If

 Else

 MsgBox "Error while accessing schedule'" + group.Name + "'"

 End If
Else
 MsgBox "No accessable scheduleGroup existing"
End If
End Sub
Private Sub CreateReportForAFunctionsContainer(functionsContainer As ScheduleFunctions, ByRef report As String)
For functionCount = 0 To (functionsContainer.count - 1)
 Dim func As ScheduleFunction
 Set func = functionsContainer.Item(0)
 If Not func Is Nothing Then
 Call ReportOfOneFunction(func, report)
 report = report & vbCrLf & vbCrLf
 End If
Next
End Sub

Private Sub ReportOfOneFunction(func As ScheduleFunction, ByRef report As String)
report = report & "Name: " & func.Function.Name & vbCrLf & _

 "Active: " & func.Active & vbCrLf & _

 "Type: " & func.Function.Type
End Sub


Properties
ObjectModel COM [image] ScheduleFunction [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Active | variant_bool | Returns TRUE if the Action of a Function is Active | Available | Available | Available | Available
Function | irtfunction | Defines a Function in a Switching Point | Readonly | Readonly | Available | Available


Active
ObjectModel COM [image] ScheduleFunction [image] Properties [image] Active
Remarks

Defines, if this function gets executed. Can be changed.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Function
ObjectModel COM [image] ScheduleFunction [image] Properties [image] Function
Remarks

Function that gets executed. Cannot be changed.

Datatype
IRtFunction

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ScheduleFunctions
ObjectModel COM [image] ScheduleFunctions
Remarks

Collection of Functions in a Switching Point

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_SchedulerLinkFunctionToPeriod()

 {

//Specify a ScheduleGroup via Index!

 String fullString = "";

 zenOn.IScheduleGroup group =

 ActiveDocument.Scheduler.ScheduleGroups.ItemByItem(0);

if (group != null)

 {

 zenOn.IScheduleStandardDay monday =

 group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday);

if (monday != null)

 {

//Creates a Reload Function!

 zenOn.IRtFunctions functions = ActiveDocument.RtFunctions();

 zenOn.IRtFunction function = functions.Create("Reload_Period", zenOn.tpFunctionTypes.tpReloadProject);

//Specify a SchedulePeriod to which the Function should be linked!

 zenOn.IScheduleSwitchingPeriod period = monday.SwitchingPeriods.Item(0);

if (period != null)

 {

 fullString += "Monday:\n";

 fullString += "Before Editing : \n";

 fullString += "Amount of Functions: " + (period.Start.Functions.Count + period.End.Functions.Count) + "\n\n";

 fullString += "SwitchingPeriod: \n\n";

 fullString += "Function(s) linked at start: \n";

 Macro_CreateReportForAFunctionsContainer(period.Start.Functions, ref fullString);

 fullString += "Function(s) linked at end: \n";

 Macro_CreateReportForAFunctionsContainer(period.End.Functions, ref fullString);

 fullString += "------------------------------------";

 period.Start.Functions.Create(function);

 period.End.Functions.Create(function);

 fullString += "\n\nAfter Editing : \n";

 fullString += "Amount of Functions: " + (period.Start.Functions.Count + period.End.Functions.Count) + "\n\n";

 fullString += "SwitchingPeriod: \n\n";

 fullString += "Function(s) linked at start: \n";

 Macro_CreateReportForAFunctionsContainer(period.Start.Functions, ref fullString);

 fullString += "Function(s) linked at end: \n";

 Macro_CreateReportForAFunctionsContainer(period.End.Functions, ref fullString);

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while accessing schedule '" + group.Name + "'");

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");

 }

 System.Windows.Forms.MessageBox.Show(fullString);

 }

privatevoid Macro_CreateReportForAFunctionsContainer(zenOn.IScheduleFunctions functionsContainer,

ref String report)

 {

int functionCount = functionsContainer.Count;

for (int i = 0; i < functionCount; i++)

 {

 zenOn.IScheduleFunction function = functionsContainer.Item(i);

if (function != null)

 {

 Macro_ReportOfOneFunction(function, ref report);

 report += "\n\n";

 }

 }

 }

privatevoid Macro_ReportOfOneFunction(zenOn.IScheduleFunction function, ref String report)

 {

 report +=

"Name: " + function.Function.Name + "\n" +

"Active: " + function.Active + "\n" +

"Type: " + function.Function.Type;

 }
VBA
Copy
Public Sub LinkFunctionToPeriod()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
'Specify ScheduleGroup via Index!
Set group = groups.ItemByItem(0)
If Not group Is Nothing Then

 Dim monday As ScheduleStandardDay

 Set monday = group.Schedules.GetStandardDay(tpScheduleMonday)

 If Not monday Is Nothing Then

 Dim functions As RtFunctions
 Set funcs = MyWorkspace.ActiveDocument.RtFunctions
 'Creates a Reload Function!
 Set func = funcs.Create("Reload_Test", tpReloadProject)
 Dim period As ScheduleSwitchingPeriod
 'Specify a SwitchingPeriod to which the Function should be linked!
 Set period = monday.SwitchingPeriods.Item(0)

 If Not period Is Nothing Then
 Dim fullString As String
 fullString = fullString & "------------------------------------" & vbNewLine
 fullString = fullString & "Monday:" & vbNewLine
 fullString = fullString & "------------------------------------" & vbNewLine & vbNewLine
 fullString = fullString & "Before Editing: " & vbNewLine & vbNewLine
 fullString = fullString & "SwitchingPeriod:" & vbNewLine
 fullString = fullString & "Amount of Functions: " & (period.Start.functions.count + period.End.functions.count) & vbNewLine
 fullString = fullString & "Function(s) linked at start:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.Start.functions, fullString)
 fullString = fullString & "Function(s) linked at end:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.End.functions, fullString)

 Dim funcTest As ScheduleFunction
 Set funcTest = period.Start.functions.Create(func)
 Set funcTest = period.End.functions.Create(func)

 fullString = fullString & vbNewLine & vbNewLine & "After Editing: " & vbNewLine
 fullString = fullString & "SwitchingPeriod:" & vbNewLine
 fullString = fullString & "Amount of Functions: " & (period.Start.functions.count + period.End.functions.count) & vbNewLine & vbNewLine
 fullString = fullString & "Function(s) linked at start:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.Start.functions, fullString)
 fullString = fullString & "Function(s) linked at end:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.End.functions, fullString)

 MsgBox fullString
 End If

 Else

 MsgBox "Error while accessing schedule'" + group.Name + "'"

 End If
Else
 MsgBox "No accessable scheduleGroup existing"
End If
End Sub
Private Sub CreateReportForAFunctionsContainer(functionsContainer As ScheduleFunctions, ByRef report As String)
For functionCount = 0 To (functionsContainer.count - 1)
 Dim func As ScheduleFunction
 Set func = functionsContainer.Item(0)
 If Not func Is Nothing Then
 Call ReportOfOneFunction(func, report)
 report = report & vbCrLf & vbCrLf
 End If
Next
End Sub

Private Sub ReportOfOneFunction(func As ScheduleFunction, ByRef report As String)
report = report & "Name: " & func.Function.Name & vbCrLf & _

 "Active: " & func.Active & vbCrLf & _

 "Type: " & func.Function.Type
End Sub


Properties
ObjectModel COM [image] ScheduleFunctions [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] ScheduleFunctions [image] Properties [image] Count
Remarks

Count of Functions. Cannot be changed directly.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ScheduleFunctions [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | ischedulefunction |  | Available | Available | Available | Available
Delete | variant_bool |  | Available | Available | Available | Available
Item | ischedulefunction |  | Available | Available | Available | Available


Create
ObjectModel COM [image] ScheduleFunctions [image] Methods [image] Create
Remarks

Creates a „Reload" function, and links it to the defined SwitchingPeriod

Datatype
IScheduleFunction

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Function as IRtFunction

Example
C#
Copy
publicvoid Macro_SchedulerLinkFunctionToPeriod()

 {

//Specify a ScheduleGroup via Index!

 String fullString = "";

 zenOn.IScheduleGroup group =

 ActiveDocument.Scheduler.ScheduleGroups.ItemByItem(0);

if (group != null)

 {

 zenOn.IScheduleStandardDay monday =

 group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday);

if (monday != null)

 {

//Creates a Reload Function!

 zenOn.IRtFunctions functions = ActiveDocument.RtFunctions();

 zenOn.IRtFunction function = functions.Create("Reload_Period", zenOn.tpFunctionTypes.tpReloadProject);

//Specify a SchedulePeriod to which the Function should be linked!

 zenOn.IScheduleSwitchingPeriod period = monday.SwitchingPeriods.Item(0);

if (period != null)

 {

 fullString += "Monday:\n";

 fullString += "Before Editing : \n";

 fullString += "Amount of Functions: " + (period.Start.Functions.Count + period.End.Functions.Count) + "\n\n";

 fullString += "SwitchingPeriod: \n\n";

 fullString += "Function(s) linked at start: \n";

 Macro_CreateReportForAFunctionsContainer(period.Start.Functions, ref fullString);

 fullString += "Function(s) linked at end: \n";

 Macro_CreateReportForAFunctionsContainer(period.End.Functions, ref fullString);

 fullString += "------------------------------------";

 period.Start.Functions.Create(function);

 period.End.Functions.Create(function);

 fullString += "\n\nAfter Editing : \n";

 fullString += "Amount of Functions: " + (period.Start.Functions.Count + period.End.Functions.Count) + "\n\n";

 fullString += "SwitchingPeriod: \n\n";

 fullString += "Function(s) linked at start: \n";

 Macro_CreateReportForAFunctionsContainer(period.Start.Functions, ref fullString);

 fullString += "Function(s) linked at end: \n";

 Macro_CreateReportForAFunctionsContainer(period.End.Functions, ref fullString);

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while accessing schedule '" + group.Name + "'");

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");

 }

 System.Windows.Forms.MessageBox.Show(fullString);

 }

privatevoid Macro_CreateReportForAFunctionsContainer(zenOn.IScheduleFunctions functionsContainer,

ref String report)

 {

int functionCount = functionsContainer.Count;

for (int i = 0; i < functionCount; i++)

 {

 zenOn.IScheduleFunction function = functionsContainer.Item(i);

if (function != null)

 {

 Macro_ReportOfOneFunction(function, ref report);

 report += "\n\n";

 }

 }

 }

privatevoid Macro_ReportOfOneFunction(zenOn.IScheduleFunction function, ref String report)

 {

 report +=

"Name: " + function.Function.Name + "\n" +

"Active: " + function.Active + "\n" +

"Type: " + function.Function.Type;

 }
VBA
Copy
Public Sub LinkFunctionToPeriod()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
'Specify ScheduleGroup via Index!
Set group = groups.ItemByItem(0)
If Not group Is Nothing Then

 Dim monday As ScheduleStandardDay

 Set monday = group.Schedules.GetStandardDay(tpScheduleMonday)

 If Not monday Is Nothing Then

 Dim functions As RtFunctions
 Set funcs = MyWorkspace.ActiveDocument.RtFunctions
 'Creates a Reload Function!
 Set func = funcs.Create("Reload_Test", tpReloadProject)
 Dim period As ScheduleSwitchingPeriod
 'Specify a SwitchingPeriod to which the Function should be linked!
 Set period = monday.SwitchingPeriods.Item(0)

 If Not period Is Nothing Then
 Dim fullString As String
 fullString = fullString & "------------------------------------" & vbNewLine
 fullString = fullString & "Monday:" & vbNewLine
 fullString = fullString & "------------------------------------" & vbNewLine & vbNewLine
 fullString = fullString & "Before Editing: " & vbNewLine & vbNewLine
 fullString = fullString & "SwitchingPeriod:" & vbNewLine
 fullString = fullString & "Amount of Functions: " & (period.Start.functions.count + period.End.functions.count) & vbNewLine
 fullString = fullString & "Function(s) linked at start:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.Start.functions, fullString)
 fullString = fullString & "Function(s) linked at end:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.End.functions, fullString)

 Dim funcTest As ScheduleFunction
 Set funcTest = period.Start.functions.Create(func)
 Set funcTest = period.End.functions.Create(func)

 fullString = fullString & vbNewLine & vbNewLine & "After Editing: " & vbNewLine
 fullString = fullString & "SwitchingPeriod:" & vbNewLine
 fullString = fullString & "Amount of Functions: " & (period.Start.functions.count + period.End.functions.count) & vbNewLine & vbNewLine
 fullString = fullString & "Function(s) linked at start:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.Start.functions, fullString)
 fullString = fullString & "Function(s) linked at end:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.End.functions, fullString)

 MsgBox fullString
 End If

 Else

 MsgBox "Error while accessing schedule'" + group.Name + "'"

 End If
Else
 MsgBox "No accessable scheduleGroup existing"
End If
End Sub
Private Sub CreateReportForAFunctionsContainer(functionsContainer As ScheduleFunctions, ByRef report As String)
For functionCount = 0 To (functionsContainer.count - 1)
 Dim func As ScheduleFunction
 Set func = functionsContainer.Item(0)
 If Not func Is Nothing Then
 Call ReportOfOneFunction(func, report)
 report = report & vbCrLf & vbCrLf
 End If
Next
End Sub

Private Sub ReportOfOneFunction(func As ScheduleFunction, ByRef report As String)
report = report & "Name: " & func.Function.Name & vbCrLf & _

 "Active: " & func.Active & vbCrLf & _

 "Type: " & func.Function.Type
End Sub


Delete
ObjectModel COM [image] ScheduleFunctions [image] Methods [image] Delete
Remarks

Deletes the specified function from the defined SwitchingPeriod

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Index as long

Example
C#
Copy
publicvoid Macro_SchedulerDeleteFunctionFromPeriod()

 {

//Specify a ScheduleGroup via Index!

 String fullString = "";

 zenOn.IScheduleGroup group =

 ActiveDocument.Scheduler.ScheduleGroups.ItemByItem(0);

if (group != null)

 {

 zenOn.IScheduleStandardDay monday =

 group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday);

if (monday != null)

 {

//Specify a SwitchingPeriod via Index!

 zenOn.IScheduleSwitchingPeriod period = monday.SwitchingPeriods.Item(0);

if (period != null)

 {

 fullString += "------------------------------------" + "\n";

 fullString += "Monday:\n";

 fullString += "------------------------------------" + "\n\n";

 fullString += "Before Editing : \n";

 fullString += "SwitchingPeriod: \n\n";

 fullString += "Amount of Functions: " + (period.Start.Functions.Count + period.End.Functions.Count) + "\n";

 fullString += "Function(s) linked at start: \n";

 Macro_CreateReportForAFunctionsContainer(period.Start.Functions, ref fullString);

 fullString += "Function(s) linked at end: \n";

 Macro_CreateReportForAFunctionsContainer(period.End.Functions, ref fullString);

 Macro_SchedulerDeleteFunction(period);

 fullString += "\n\nAfter Editing : \n";

 fullString += "SwitchingPeriod: \n\n";

 fullString += "Amount of Functions: " + (period.Start.Functions.Count + period.End.Functions.Count) + "\n";

 fullString += "Function(s) linked at start: \n";

 Macro_CreateReportForAFunctionsContainer(period.Start.Functions, ref fullString);

 fullString += "Function(s) linked at end: \n";

 Macro_CreateReportForAFunctionsContainer(period.End.Functions, ref fullString);

 System.Windows.Forms.MessageBox.Show(fullString);

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while accessing 'Monday' of your schedule '" + group.Name + "'");

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");

 }

 }

privatevoid Macro_SchedulerDeleteFunction(zenOn.IScheduleSwitchingPeriod period)

 {

if (period != null)

 {

//Specify Function at Start Time to be Deleted!

bool success = period.Start.Functions.Delete(0);

//Specify Function at End Time to be Deleted!

 success = success && period.End.Functions.Delete(0);

if (success)

 {

 System.Windows.Forms.MessageBox.Show("Function deleted successfully");

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while deleting function");

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("The object for switchingPeriod is not valid");

 }

 }
VBA
Copy
Public Sub DeleteFunctionFromPeriod()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
'Specify ScheduleGroup via Index!
Set group = groups.ItemByItem(0)
If Not group Is Nothing Then

 Dim monday As ScheduleStandardDay

 Set monday = group.Schedules.GetStandardDay(tpScheduleMonday)

 If Not monday Is Nothing Then
 Dim period As ScheduleSwitchingPeriod
 'Specify SwitchingPeriod via Index!
 Set period = monday.SwitchingPeriods.Item(0)
 If Not period Is Nothing Then
 Dim fullString As String
 fullString = fullString & "------------------------------------" & vbNewLine
 fullString = fullString & "Monday:" & vbNewLine
 fullString = fullString & "------------------------------------" & vbNewLine & vbNewLine
 fullString = fullString & "Before Editing: " & vbNewLine
 fullString = fullString & "SwitchingPeriod:" & vbNewLine & vbNewLine
 fullString = fullString & "Amount of Functions: " & (period.Start.functions.count + period.End.functions.count) & vbNewLine
 fullString = fullString & "Function(s) linked at start:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.Start.functions, fullString)
 fullString = fullString & "Function(s) linked at end:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.End.functions, fullString)

 Call SchedulerDeleteFunction(period)

 fullString = fullString & vbNewLine & vbNewLine & "After Editing: " & vbNewLine
 fullString = fullString & "SwitchingPeriod:" & vbNewLine & vbNewLine
 fullString = fullString & "Amount of Functions: " & (period.Start.functions.count + period.End.functions.count) & vbNewLine
 fullString = fullString & "Function(s) linked at start:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.Start.functions, fullString)
 fullString = fullString & "Function(s) linked at end:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.End.functions, fullString)

 MsgBox fullString
 End If

 Else

 MsgBox "Error while accessing schedule '" + group.Name + "'"

 End If
Else
 MsgBox "No accessable scheduleGroup existing"
End If
End Sub

Private Sub SchedulerDeleteFunction(period As ScheduleSwitchingPeriod)
Dim success As Boolean
If Not period Is Nothing Then
 'Specify Function at Start Time to be Deleted!
 success = period.Start.functions.Delete(0)
 'Specify Function at End Time to be Deleted!
 success = (success And period.End.functions.Delete(0))
 If success = True Then
 MsgBox "Function deleted successfully"
 Else
 MsgBox "Error while deleting function"
 End If

Else
 MsgBox "The object for switchingPeriod is not valid"
End If
End Sub


Item
ObjectModel COM [image] ScheduleFunctions [image] Methods [image] Item
Remarks

Returns the function link at the passed 'Index'(0-based). Returns null if 'Index' is invalid.

Datatype
IScheduleFunction

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Index as long

Example
C#
Copy
publicvoid Macro_SchedulerDeleteFunctionFromPeriod()

 {

//Specify a ScheduleGroup via Index!

 String fullString = "";

 zenOn.IScheduleGroup group =

 ActiveDocument.Scheduler.ScheduleGroups.ItemByItem(0);

if (group != null)

 {

 zenOn.IScheduleStandardDay monday =

 group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday);

if (monday != null)

 {

//Specify a SwitchingPeriod via Index!

 zenOn.IScheduleSwitchingPeriod period = monday.SwitchingPeriods.Item(0);

if (period != null)

 {

 fullString += "------------------------------------" + "\n";

 fullString += "Monday:\n";

 fullString += "------------------------------------" + "\n\n";

 fullString += "Before Editing : \n";

 fullString += "SwitchingPeriod: \n\n";

 fullString += "Amount of Functions: " + (period.Start.Functions.Count + period.End.Functions.Count) + "\n";

 fullString += "Function(s) linked at start: \n";

 Macro_CreateReportForAFunctionsContainer(period.Start.Functions, ref fullString);

 fullString += "Function(s) linked at end: \n";

 Macro_CreateReportForAFunctionsContainer(period.End.Functions, ref fullString);

 Macro_SchedulerDeleteFunction(period);

 fullString += "\n\nAfter Editing : \n";

 fullString += "SwitchingPeriod: \n\n";

 fullString += "Amount of Functions: " + (period.Start.Functions.Count + period.End.Functions.Count) + "\n";

 fullString += "Function(s) linked at start: \n";

 Macro_CreateReportForAFunctionsContainer(period.Start.Functions, ref fullString);

 fullString += "Function(s) linked at end: \n";

 Macro_CreateReportForAFunctionsContainer(period.End.Functions, ref fullString);

 System.Windows.Forms.MessageBox.Show(fullString);

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while accessing 'Monday' of your schedule '" + group.Name + "'");

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");

 }

 }

privatevoid Macro_SchedulerDeleteFunction(zenOn.IScheduleSwitchingPeriod period)

 {

if (period != null)

 {

//Specify Function at Start Time to be Deleted!

bool success = period.Start.Functions.Delete(0);

//Specify Function at End Time to be Deleted!

 success = success && period.End.Functions.Delete(0);

if (success)

 {

 System.Windows.Forms.MessageBox.Show("Function deleted successfully");

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while deleting function");

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("The object for switchingPeriod is not valid");

 }

 }
VBA
Copy
Public Sub DeleteFunctionFromPeriod()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
'Specify ScheduleGroup via Index!
Set group = groups.ItemByItem(0)
If Not group Is Nothing Then

 Dim monday As ScheduleStandardDay

 Set monday = group.Schedules.GetStandardDay(tpScheduleMonday)

 If Not monday Is Nothing Then
 Dim period As ScheduleSwitchingPeriod
 'Specify SwitchingPeriod via Index!
 Set period = monday.SwitchingPeriods.Item(0)
 If Not period Is Nothing Then
 Dim fullString As String
 fullString = fullString & "------------------------------------" & vbNewLine
 fullString = fullString & "Monday:" & vbNewLine
 fullString = fullString & "------------------------------------" & vbNewLine & vbNewLine
 fullString = fullString & "Before Editing: " & vbNewLine
 fullString = fullString & "SwitchingPeriod:" & vbNewLine & vbNewLine
 fullString = fullString & "Amount of Functions: " & (period.Start.functions.count + period.End.functions.count) & vbNewLine
 fullString = fullString & "Function(s) linked at start:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.Start.functions, fullString)
 fullString = fullString & "Function(s) linked at end:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.End.functions, fullString)

 Call SchedulerDeleteFunction(period)

 fullString = fullString & vbNewLine & vbNewLine & "After Editing: " & vbNewLine
 fullString = fullString & "SwitchingPeriod:" & vbNewLine & vbNewLine
 fullString = fullString & "Amount of Functions: " & (period.Start.functions.count + period.End.functions.count) & vbNewLine
 fullString = fullString & "Function(s) linked at start:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.Start.functions, fullString)
 fullString = fullString & "Function(s) linked at end:" & vbNewLine
 Call CreateReportForAFunctionsContainer(period.End.functions, fullString)

 MsgBox fullString
 End If

 Else

 MsgBox "Error while accessing schedule '" + group.Name + "'"

 End If
Else
 MsgBox "No accessable scheduleGroup existing"
End If
End Sub

Private Sub SchedulerDeleteFunction(period As ScheduleSwitchingPeriod)
Dim success As Boolean
If Not period Is Nothing Then
 'Specify Function at Start Time to be Deleted!
 success = period.Start.functions.Delete(0)
 'Specify Function at End Time to be Deleted!
 success = (success And period.End.functions.Delete(0))
 If success = True Then
 MsgBox "Function deleted successfully"
 Else
 MsgBox "Error while deleting function"
 End If

Else
 MsgBox "The object for switchingPeriod is not valid"
End If
End Sub


ScheduleGroup
ObjectModel COM [image] ScheduleGroup
Remarks

A single Schedule Group

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_SchedulerCreate()

 {

 zenOn.IScheduleGroup group =

 ActiveDocument.Scheduler.ScheduleGroups.Create();

if (group != null)

 {

 System.Windows.Forms.MessageBox.Show("Name of new scheduleGroup: " + group.Name);

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while creating a scheduleGroup");

 }

 }
VBA
Copy
Public Function Create() As ScheduleGroup
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Set Create = groups.Create()
End Function


Properties
ObjectModel COM [image] ScheduleGroup [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Name | bstr | Schedule Group Name | Readonly | Readonly | Available | Available
Schedules | ischedules | Collection of Schedules in a Schedule Group | Readonly | Readonly | Available | Available


Name
ObjectModel COM [image] ScheduleGroup [image] Properties [image] Name
Remarks

Name of the ScheduleGroup. Can only be changed via the Rename Methods in the collection

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Schedules
ObjectModel COM [image] ScheduleGroup [image] Properties [image] Schedules
Remarks

Collection of the Schedules in this Group

Datatype
ISchedules

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ScheduleGroups
ObjectModel COM [image] ScheduleGroups
Remarks

Collection of Schedule Groups

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_GetListOfScheduleGroups()
{

 String fullString = "";

 fullString += "Amount of ScheduleGroups: " + ActiveDocument.Scheduler.ScheduleGroups.Count + "\n";

for (int i = 0; i < ActiveDocument.Scheduler.ScheduleGroups.Count; i++)

 {

 zenOn.IScheduleGroup group =

 ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(i);

if (group != null)

 {

if (fullString.Length > 0)

 {

 fullString += "\n";

 }

 fullString += "Name of ScheduleGroup: " + group.Name + " ";

 }

 }

 System.Windows.Forms.MessageBox.Show(fullString);
}

publicvoid Macro_SchedulerCount()

 {

 System.Windows.Forms.MessageBox.Show("Amount of scheduleGroups: " + ActiveDocument.Scheduler.ScheduleGroups.Count);

 }
VBA
Copy
Public Sub GetListOfScheduleGroups()
Dim fullString As String
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim index As Long
fullString = fullString & "Amount of scheduleGroups: " & groups.count & vbNewLine
For index = 0 To (groups.count - 1)
 Dim group As ScheduleGroup
 Set group = groups.ItemByIndex(index)
 If Len(fullString) > 0 Then
 fullString = fullString & vbNewLine
 End If
 fullString = fullString & "Name of ScheduleGroup: " & group.Name
Next
MsgBox fullString
End Sub
Public Sub Count()
MsgBox MyWorkspace.ActiveDocument.scheduler.ScheduleGroups.Count
End Sub


Properties
ObjectModel COM [image] ScheduleGroups [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the Count of Schedule Groups | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] ScheduleGroups [image] Properties [image] Count
Remarks

Count of Groups. Cannot be modified directly.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ScheduleGroups [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | ischedulegroup | Creates a Schedule Group | Available | Available | Available | Available
DeleteByIndex | variant_bool | Deletes a Schedule Group via Index | Available | Available | Available | Available
DeleteByName | variant_bool | Deletes a Schedule Group via Name | Available | Available | Available | Available
DuplicateByIndex | ischedulegroup | Duplicates a Schedule Group via Index | Available | Available | Available | Available
DuplicateByName | ischedulegroup | Duplicates a Schedule Group via Name | Available | Available | Available | Available
GetItem | ischedulegroup | Returns a Schedule Group via Index | Available | Available | Available | Available
GetItemByName | ischedulegroup | Returns a Schedule Group via Name | Available | Available | Available | Available
RenameByIndex | variant_bool | Renames a Schedule Group via Index | Available | Available | Available | Available
RenameByName | variant_bool | Renames a Schedule Group via Name | Available | Available | Available | Available


Create
ObjectModel COM [image] ScheduleGroups [image] Methods [image] Create
Remarks

Creates a new ScheduleGroup

Datatype
IScheduleGroup

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_SchedulerCreate()

 {

 zenOn.IScheduleGroup group =

 ActiveDocument.Scheduler.ScheduleGroups.Create();

if (group != null)

 {

 System.Windows.Forms.MessageBox.Show("Name of new scheduleGroup: " + group.Name);

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while creating a scheduleGroup");

 }

 }
VBA
Copy
Public Function Create() As ScheduleGroup
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Set Create = groups.Create()
End Function


DeleteByIndex
ObjectModel COM [image] ScheduleGroups [image] Methods [image] DeleteByIndex
Remarks

Deletes a ScheduleGroup with the specified index

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Index as long

Example
C#
Copy
publicvoid Macro_SchedulerDeleteByIndex()

 {

if (ActiveDocument.Scheduler.ScheduleGroups.Count > 0)

 {

bool success =

 ActiveDocument.Scheduler.ScheduleGroups.DeleteByIndex(0);

if (success)

 {

 System.Windows.Forms.MessageBox.Show("SchedulerGroup with index 0 deleted succesfully");

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while deleting SchedulerGroup with index '0'");

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("There's no existing group to delete");

 }

 }
VBA
Copy
Public Sub DeleteByIndex()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim Count As Long
Count = groups.Count
If Count > 0 Then
    Dim success As Boolean
    success = groups.DeleteByIndex(0)
    If success Then
        MsgBox "SchedulerGroup with index 0 deleted succesfully"
    Else
        MsgBox "Error while deleting SchedulerGroup with index '0'"
    End If
Else
    MsgBox "There's no existing group to delete"
End If
End Sub


DeleteByName
ObjectModel COM [image] ScheduleGroups [image] Methods [image] DeleteByName
Remarks

Deletes the ScheduleGroup with the specified name

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR

Example
C#
Copy
publicvoid Macro_SchedulerDeleteByName()

 {

bool success =

 ActiveDocument.Scheduler.ScheduleGroups.DeleteByName("New schedule1");

if (success)

 {

 System.Windows.Forms.MessageBox.Show("SchedulerGroup deleted succesfully");

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while deleting SchedulerGroup");

 }

 }
VBA
Copy
Public Sub DeleteByName()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim success As Boolean
success = groups.DeleteByName("New schedule1")
If success Then
 MsgBox "SchedulerGroup deleted succesfully"
Else
 MsgBox "Error while deleting SchedulerGroup'"
End If
End Sub


DuplicateByIndex
ObjectModel COM [image] ScheduleGroups [image] Methods [image] DuplicateByIndex
Remarks

Duplicates the ScheduleGroup with the specified index

Datatype
IScheduleGroup

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Index as long

Example
C#
Copy
publicvoid Macro_SchedulerDuplicateByIndex()

 {

if (ActiveDocument.Scheduler.ScheduleGroups.Count > 0)

 {

 zenOn.IScheduleGroup newGroup =

 ActiveDocument.Scheduler.ScheduleGroups.DuplicateByIndex(0);

if (newGroup != null)

 {

 System.Windows.Forms.MessageBox.Show("Name of new Group: " + newGroup.Name);

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while duplicating the scheduleGroup");

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("There's no existing group to duplicate");

 }

 }
VBA
Copy
Public Sub DuplicateByIndex()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim count As Long
count = groups.count
If count > 0 Then
    Dim newGroup As ScheduleGroup
    Set newGroup = groups.DuplicateByIndex(0)
    If Not newGroup Is Nothing Then
        MsgBox "Name of new Group: " + newGroup.name
    Else
        MsgBox "Error while duplicating the scheduleGroup with index '0'"
    End If
Else
    MsgBox "There's no existing group to duplicate"
End If
End Sub


DuplicateByName
ObjectModel COM [image] ScheduleGroups [image] Methods [image] DuplicateByName
Remarks

Duplicates the ScheduleGroup with the specified name

Datatype
IScheduleGroup

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR

Example
C#
Copy
publicvoid Macro_SchedulerDuplicateByName()

 {

 zenOn.IScheduleGroup newGroup =

 ActiveDocument.Scheduler.ScheduleGroups.DuplicateByName("New schedule1");

if (newGroup != null)

 {

 System.Windows.Forms.MessageBox.Show("Name of new Group: " + newGroup.Name);

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while duplicating the scheduleGroup");

 }

 }
VBA
Copy
Public Sub DuplicateByName()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim newGroup As ScheduleGroup
Set newGroup = groups.DuplicateByName("New schedule1")
If Not newGroup Is Nothing Then
 MsgBox "Name of new Group: " + newGroup.Name
Else
 MsgBox "Error while duplicating the scheduleGroup"
End If
End Sub


GetItem
ObjectModel COM [image] ScheduleGroups [image] Methods [image] GetItem
Remarks

Datatype
IScheduleGroup

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Index as long


GetItemByName
ObjectModel COM [image] ScheduleGroups [image] Methods [image] GetItemByName
Remarks

Datatype
IScheduleGroup

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR


RenameByIndex
ObjectModel COM [image] ScheduleGroups [image] Methods [image] RenameByIndex
Remarks

Renames the ScheduleGroup with the specified index

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Index as long

newName as BSTR

Example
C#
Copy
publicvoid Macro_SchedulerRenameByIndex()

 {

bool success =

 ActiveDocument.Scheduler.ScheduleGroups.RenameByIndex(0, "NewName");

if (success)

 {

 System.Windows.Forms.MessageBox.Show("The scheduleGroup with index '0' was renamed to 'newName'");

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while renaming scheduleGroup with index '0'");

 }

 }
VBA
Copy
Public Sub RenameByIndex()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim Count As Long
Count = groups.Count
If Count > 0 Then
    Dim success As Boolean
    success = groups.RenameByIndex(0, "newName")
    If success Then
        MsgBox "The scheduleGroup with index '0' was renamed to 'newName'"
    Else
        MsgBox "ScheduleGroup with index '0' is not existing"
    End If
Else
    MsgBox "There's no existing group to rename"
End If
End Sub


RenameByName
ObjectModel COM [image] ScheduleGroups [image] Methods [image] RenameByName
Remarks

Renames the ScheduleGroup with the specified name

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
OldName as BSTR

newName as BSTR

Example
C#
Copy
publicvoid Macro_SchedulerRenameByName()

 {

bool success =

 ActiveDocument.Scheduler.ScheduleGroups.RenameByName("New schedule1", "newName");

if (success)

 {

 System.Windows.Forms.MessageBox.Show("The scheduleGroup was renamed to 'newName'");

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while renaming scheduleGroup");

 }

 }
VBA
Copy
Public Sub RenameByName()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim success As Boolean
success = groups.RenameByName("New schedule1", "newName")
If success Then
 MsgBox "The scheduleGroup was renamed to 'newName'"
Else
 MsgBox "ScheduleGroup does not exist"
End If
End Sub


Scheduler
ObjectModel COM [image] Scheduler
Remarks

The Scheduler API allows access and modification to the Scheduler data through VBA and VSTA in the Editor and Runtime.General rules when using the Scheduler API:Do not use the Scheduler API from a second thread or keep API Objects for later calls. The Scheduler data may get edited elsewhere, so the lifetime and validity of the objects is only guaranteed in the immediate function context.After modifications to collections (add, remove, rename) the iteration order of all objects may change, so performing these operations mid iteration may invalidate your index.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
classProject
{
properties:
Scheduler* Scheduler; // Access to the Scheduler API in the Project
}

The following classes are new in the zenon API to access the Scheduler:

// Root class for the Scheduler Api
classScheduler
{
properties:
ScheduleGroups* ScheduleGroups; // Access to the configured Schedule Groups
methods:
bool Save(); // Saves all unsaved changes. Returns true if store was successful
void Undo(); // Undoes all unsaved changes

// Multiuser block
bool Get();
bool CheckOut();
bool CheckIn();
bool UndoCheckOut();
bool IsLocked();
bool IsCheckedOut();
bool IsDifferent();
};

// Collection of Schedule Groups
classScheduleGroups
{
properties:
long Count; // Count of Groups. Cannot be modified directly.
methods:
ScheduleGroup* Create(); // Creates and returns a new ScheduleGroup. The new ScheduleGroup is created with the default name for new Groups. If no Groups could be created, null is returned.
ScheduleGroup* DuplicateByName(String Name); // Duplicates and returns the ScheduleGroup with the passed 'Name'. The new ScheduleGroup is created with the default name for copied Groups. If no Groups could be created, null is returned.
ScheduleGroup* DuplicateByIndex(long Index); // Duplicates and returns the ScheduleGroup at the passed 'Index'(0-based). The new ScheduleGroup is created with the default name for copied Groups. If no Groups could be created or 'Index' is invalid, null is returned.
bool DeleteByName(String Name); // Deletes the ScheduleGroup with the passed 'Name'. Returns true, if the Group was deleted successfully and false if the 'Name' does not exist or the Group could not be deleted.
bool DeleteByIndex(long Index); // Deletes the ScheduleGroup at the passed 'Index'(0-based). Returns true, if the Group was deleted successfully and false if the 'Index' is invalid or the Group could not be deleted.
ScheduleGroup* ItemByName(String Name); // Returns the ScheduleGroup with the passed 'Name'. Returns null if no Group with that name exists.
ScheduleGroup* ItemByIndex(long Index); // Returns the ScheduleGroup at the passed Index(0-based). Returns null the index in invalid.
bool RenameByName(String OldName, String NewName); // Changes the name of a ScheduleGroup from 'OldName' to 'NewName'. Returns true if the object was renamed successfully.
bool RenameByIndex(long Index, String NewName); // Changes the name of a ScheduleGroup at the passed 'Index'(0-based) to 'NewName'. Returns true if the object was renamed successfully.
};

// A single Schedule Group
classScheduleGroup
{
properties:
String Name; // Name of the ScheduleGroup. Can only be changed via the Rename Methods in the collection
Schedules* Schedules; // Collection of the Schedules in this Group
};

// Collection of Schedules in the Group
classSchedules
{
properties:
long CustomPeriodCount; // Count of Custom Periods. Cannot be modified directly.
methods:
ScheduleCustomPeriod* CreateCustomPeriod(DateTime Start, DateTime End); // Creates and returns a new Custom Period or null if it could not be created. Only the date of 'Start' and 'End' is considered for Custom Periods and both are included in the Period. The date of 'End' must not be before the date of 'Start'. The time range for a Period cannot overlap with any existing Custom Periods.
bool DeleteCustomPeriod(long Index); // Deletes a Custom Period at the passed 'Index'(0-based). Returns false, if the 'Index' is invalid or the Period could not be deleted.
ScheduleStandardDay* GetStandardDay(tpScheduleDayType Day); // Returns the ScheduleStandardDay with the passed type or null if 'Day' is invalid.
ScheduleCustomPeriod* GetCustomPeriod(long Index); // Returns the ScheduleCustomPeriod at the passed 'Index' or null if the 'Index' is invalid.
};

// A Standard Day Schedule that defines the Switching Actions that are normally to be used on a Day of its Type
classScheduleStandardDay
{
properties:
tpScheduleDayType Type; // defines the days on which it gets used. Cannot be changed.
ScheduleSwitchingPeriods* SwitchingPeriods; // Collection of Switching Periods
ScheduleSwitchingPoints* SwitchingPoints; // Collection of Switching Points
};

// A custom Time Period Schedule in which its Switching Actions are used instead of the standard ones.
classScheduleCustomPeriod
{
properties:
  DateTime StartDateTime; // Start date of the period. Cannot be changed after creation.
  DateTime EndDateTime; // End date of the period. Cannot be changed after creation.
ScheduleSwitchingPeriods* SwitchingPeriods; // Collection of Switching Periods
ScheduleSwitchingPoints* SwitchingPoints; // Collection of Switching Points
};

// Collection of Switching Periods.
classScheduleSwitchingPeriods
{
properties:
long Count; // Count of Switching Periods. Cannot be changed directly.
methods:
ScheduleSwitchingPeriod* Create(DateTime StartTime, DateTime EndTime); // Creates and returns a new Switching Period. Only the time component of 'StartTime' and 'EndTime' are relevant. Both times must be unique within the Schedule and 'EndTime' must be after 'StartTime'.
bool Delete(long Index); // Deletes the Switching Period at the passed 'Index'(0-based). Returns false, if the 'Index' is invalid or the Period could not be deleted.
ScheduleSwitchingPeriod* Item(long Index); // Returns the Switching Period at the passed 'Index'(0-based) or null if the 'Index' is invalid.
};

// A single Switching Period
classScheduleSwitchingPeriod
{
properties:
ScheduleSwitchingPoint* Start; // Switching Point at the Start of the Period
ScheduleSwitchingPoint* End; // Switching Point at the End of the Period
};

// Collection of Switching Points
classScheduleSwitchingPoints
{
properties:
long Count; // Count if Swichting Points. Cannot be changed directly.
methods:
ScheduleSwitchingPoint* Create(DateTime Time); // Creates and returns a new Switching Point. Only the time component of 'Time' is relevant. The time must be unique within the Schedule.
bool Delete(long Index); // Deletes the Switching Point at the passed 'Index'(0-based). Returns false, if the 'Index' is invalid or the Point could not be deleted.
ScheduleSwitchingPoint* Item(long Index); // Returns the Switching Point at the passed 'Index'(0-based) or null if the 'Index' is invalid.
};

// A single switching Point
classScheduleSwitchingPoint
{
properties:
  DateTime Time; // Time of the switching Point. Only the time component is relevant
ScheduleVariables* Variables; // Collection of Actions to be performed on Variables
ScheduleFunctions* Functions; // Collection of Functions to be Executed
};

// Collection of Functions in a Switching Point
classScheduleFunctions
{
properties:
long Count; // Count of Functions. Cannot be changed directly.
methods:
ScheduleFunction* Create(IRtFunction* Function); // Inserts the new 'Function' to be executed and returns the new link. Returns null if the 'Function' is not unique within the collection or cannot be added.
bool Delete(long Index); // Deletes the link to a function at the passed 'Index'(0-based). Returns false, if the 'Index' is invalid or the function could not be removed
ScheduleFunction* Item(long Index); // Returns the function link at the passed 'Index'(0-based). Returns null if 'Index' is invalid.
};

// Link to a single Function
classScheduleFunction
{
properties:
bool Active; // Defines, if this function gets executed. Can be changed.
IRtFunction* Function; // Function that gets executed. Cannot be changed.
};

// Collection of Variable Actions in a Switching Point
classScheduleVariables
{
properties:
long Count; // Count of Variable Actions. Cannot be changed directly.
methods:
ScheduleVariable* Create(IVariable* Variable, VARIANT SetValue); // Creates and returns a new variable Action to set 'SetValue' into 'Variable'. Returns null, if 'Variable' is not unique within the Switching Point or the new action could not be added
bool Delete(long Index); // Deletes the Variable at the passed 'Index'(0-based). Returns false, if 'Index' is invalid or the Variable could not be deleted.
ScheduleVariable* Item(long Index); // Returns the Variable at the passed 'Index'(0-based). Returns null if 'Index' is invalid.
};

// A single Variable Action
classScheduleVariable
{
properties:
bool Active; // Defines, if this Action gets Executed. Can be changed.
IVariable* Variable; // Variable, that gets a Value set into. Cannot be changed.
VBA
Copy
Public Sub Save()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim returnValue As Boolean
returnValue = scheduler.Save()
If returnValue = True Then
MsgBox "Data saved"
Else
MsgBox "Error while saving"
End If
End Sub


Properties
ObjectModel COM [image] Scheduler [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ScheduleGroups | ischedulegroups | Collection of Schedule Groups | Readonly | Readonly | Available | Available


ScheduleGroups
ObjectModel COM [image] Scheduler [image] Properties [image] ScheduleGroups
Remarks

Access to the configured Schedule Groups

Datatype
IScheduleGroups

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Scheduler [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
Save | variant_bool | Saves the changes made to the Scheduler | Available | Available | Available | Available
Undo | void | Undo changes made to the Scheduler since the last Save | Available | Available | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


CheckIn
ObjectModel COM [image] Scheduler [image] Methods [image] CheckIn
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckOut
ObjectModel COM [image] Scheduler [image] Methods [image] CheckOut
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Get
ObjectModel COM [image] Scheduler [image] Methods [image] Get
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IsCheckedOut
ObjectModel COM [image] Scheduler [image] Methods [image] IsCheckedOut
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDifferent
ObjectModel COM [image] Scheduler [image] Methods [image] IsDifferent
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] Scheduler [image] Methods [image] IsLocked
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Save
ObjectModel COM [image] Scheduler [image] Methods [image] Save
Remarks

Saves the changes made to the Scheduler

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_SchedulerSave()

 {

if (ActiveDocument.Scheduler.Save())

 {

 System.Windows.Forms.MessageBox.Show("Data saved");

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while saving");

 }

 }
VBA
Copy
Public Sub Save()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim returnValue As Boolean
returnValue = scheduler.Save()
If returnValue = True Then
MsgBox "Data saved"
Else
MsgBox "Error while saving"
End If
End Sub


Undo
ObjectModel COM [image] Scheduler [image] Methods [image] Undo
Remarks

Undo all changes made to the Scheduler. Reverts to the last save

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_SchedulerUndo()

 {

 ActiveDocument.Scheduler.Undo();

 }
VBA
Copy
Public Sub Undo()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
scheduler.Undo
End Sub


UndoCheckOut
ObjectModel COM [image] Scheduler [image] Methods [image] UndoCheckOut
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Schedules
ObjectModel COM [image] Schedules
Remarks

Collection of Schedules in the Group

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
///<summary>
/// Creates a CustomPeriod in the first scheduleGroup and displays it's data in a messageBox
///</summary>
publicvoid Macro_SchedulerCreateCustomPeriod()
{
    zenOn.IScheduleGroup group =
    ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)
    {
        DateTime startOfCustomPeriod = DateTime.Now;
        TimeSpan oneDay = new TimeSpan(1,0,0,0);
        DateTime endOfCustomPeriod = startOfCustomPeriod + oneDay;
        zenOn.IScheduleCustomPeriod newCustomPeriod = group.Schedules.CreateCustomPeriod(startOfCustomPeriod, endOfCustomPeriod);
if (newCustomPeriod != null)
        {
            String report = "scheduleGroup: " + group.Name + "\n";
            report += "new custom Period: " + newCustomPeriod.StartDate.Day + "." + newCustomPeriod.StartDate.Month + "." + newCustomPeriod.StartDate.Year;
            report += " - " + newCustomPeriod.EndDate.Day + "." + newCustomPeriod.EndDate.Month + "." + newCustomPeriod.EndDate.Year;
            System.Windows.Forms.MessageBox.Show(report);
        }
else
        {
            System.Windows.Forms.MessageBox.Show("Period does already exist");
        }
    }
else
    {
        System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");
    }
}
VBA
Copy
Public Sub CreateCustomPeriod()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
Set group = groups.ItemByIndex(0)
If Not group Is Nothing Then
    Dim startOfCustomPeriod As Date
    startOfCustomPeriod = Now()
    Dim endOfCustomPeriod As Date
    endOfCustomPeriod = DateAdd("y", 1, startOfCustomPeriod)
    Dim newPeriod As ScheduleCustomPeriod
    Set newPeriod = group.Schedules.CreateCustomPeriod(startOfCustomPeriod, endOfCustomPeriod)
    If Not newPeriod Is Nothing Then
        Dim report As String
        report = report & "scheduleGroup: " & group.name & vbNewLine
        report = report & "new customPeriod: " & Format(startOfCustomPeriod, "dd.mm.yyyy") & " - " & Format(endOfCustomPeriod, "dd.mm.yyyy")
        MsgBox report
    Else
        MsgBox "Period does already exist"
    End If
Else
    MsgBox "No accessable scheduleGroup existing"
End If
End Sub


Properties
ObjectModel COM [image] Schedules [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CustomPeriodCount | long | Returns the Count of Custom Periods | Readonly | Readonly | Available | Available


CustomPeriodCount
ObjectModel COM [image] Schedules [image] Properties [image] CustomPeriodCount
Remarks

Count of Custom Periods. Cannot be modified directly.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Schedules [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateCustomPeriod | ischedulecustomperiod | Creates a Custom Period | Available | Available | Available | Available
DeleteCustomPeriod | variant_bool | Deletes a Custom Period | Available | Available | Available | Available
GetCustomPeriod | ischedulecustomperiod | Returns a Custom Period via Index | Available | Available | Available | Available
GetStandardDay | ischedulestandardday | Returns a Standard Day via enum | Available | Available | Available | Available


CreateCustomPeriod
ObjectModel COM [image] Schedules [image] Methods [image] CreateCustomPeriod
Remarks

Creates a custom period

Datatype
IScheduleCustomPeriod

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Start as DATE

End as DATE

Example
C#
Copy
///<summary>
/// Creates a CustomPeriod in the first scheduleGroup and displays it's data in a messageBox
///</summary>
publicvoid Macro_SchedulerCreateCustomPeriod()
{
    zenOn.IScheduleGroup group =
    ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)
    {
        DateTime startOfCustomPeriod = DateTime.Now;
        TimeSpan oneDay = new TimeSpan(1,0,0,0);
        DateTime endOfCustomPeriod = startOfCustomPeriod + oneDay;
        zenOn.IScheduleCustomPeriod newCustomPeriod = group.Schedules.CreateCustomPeriod(startOfCustomPeriod, endOfCustomPeriod);
if (newCustomPeriod != null)
        {
            String report = "scheduleGroup: " + group.Name + "\n";
            report += "new custom Period: " + newCustomPeriod.StartDate.Day + "." + newCustomPeriod.StartDate.Month + "." + newCustomPeriod.StartDate.Year;
            report += " - " + newCustomPeriod.EndDate.Day + "." + newCustomPeriod.EndDate.Month + "." + newCustomPeriod.EndDate.Year;
            System.Windows.Forms.MessageBox.Show(report);
        }
else
        {
            System.Windows.Forms.MessageBox.Show("Period does already exist");
        }
    }
else
    {
        System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");
    }
}
VBA
Copy
Public Sub CreateCustomPeriod()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
Set group = groups.ItemByIndex(0)
If Not group Is Nothing Then
    Dim startOfCustomPeriod As Date
    startOfCustomPeriod = Now()
    Dim endOfCustomPeriod As Date
    endOfCustomPeriod = DateAdd("y", 1, startOfCustomPeriod)
    Dim newPeriod As ScheduleCustomPeriod
    Set newPeriod = group.Schedules.CreateCustomPeriod(startOfCustomPeriod, endOfCustomPeriod)
    If Not newPeriod Is Nothing Then
        Dim report As String
        report = report & "scheduleGroup: " & group.name & vbNewLine
        report = report & "new customPeriod: " & Format(startOfCustomPeriod, "dd.mm.yyyy") & " - " & Format(endOfCustomPeriod, "dd.mm.yyyy")
        MsgBox report
    Else
        MsgBox "Period does already exist"
    End If
Else
    MsgBox "No accessable scheduleGroup existing"
End If
End Sub


DeleteCustomPeriod
ObjectModel COM [image] Schedules [image] Methods [image] DeleteCustomPeriod
Remarks

Deletes the custom period.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Index as long

Example
C#
Copy
///<summary>
/// Deletes the first existing CustomPeriod in the first scheduleGroup and shows details in a messageBox
///</summary>
publicvoid Macro_SchedulerDeleteCustomPeriod()
{
    zenOn.IScheduleGroup group =
    ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)
    {
if (group.Schedules.CustomPeriodCount > 0)
        {
            String report = "";
            zenOn.IScheduleCustomPeriod period = group.Schedules.GetCustomPeriod(0);
            report += "scheduleGroup: " + group.Name + "\n";
            report += "first customPeriod: " + period.StartDate.Day + "." + period.StartDate.Month + "." + period.StartDate.Year;
            report += " - " + period.EndDate.Day + "." + period.EndDate.Month + "." + period.EndDate.Year;
bool success = group.Schedules.DeleteCustomPeriod(0);
if (success)
            {
                report += "\nCustomPeriod deleted successfully";
            }
else
            {
                report += "\nDeleting customPeriod was not successful";
            }
            System.Windows.Forms.MessageBox.Show(report);
        }
else
        {
            System.Windows.Forms.MessageBox.Show("There's no customPeriod existing to delete");
        }
    }
else
    {
        System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");
    }
}
VBA
Copy
Public Sub DeleteCustomPeriod()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
Set group = groups.ItemByIndex(0)
If Not group Is Nothing Then
    If group.Schedules.customPeriodCount > 0 Then
        Dim report As String
        Dim period As ScheduleCustomPeriod
        Set period = group.Schedules.GetCustomPeriod(0)
        report = report & "scheduleGroup: " & group.name & vbNewLine
        report = report & "first customPeriod: " & Format(period.StartDate, "dd.mm.yyyy") & " - " & Format(period.EndDate, "dd.mm.yyyy")
        Dim success As Boolean
        success = group.Schedules.DeleteCustomPeriod(0)
        If success Then
            report = report & vbNewLine & "CustomPeriod deleted successfully"
        Else
        report = report & vbNewLine & "Deleting customPeriod was not successful"
        End If
        MsgBox report
    Else
    MsgBox "There's no customPeriod existing to delete"
    End If
Else
    MsgBox "No accessable scheduleGroup existing"
End If
End Sub


GetCustomPeriod
ObjectModel COM [image] Schedules [image] Methods [image] GetCustomPeriod
Remarks

Access a specific CustomPeriod within a ScheduleGroup. Generates a List containing the amount of Switching Periods & Points within a Schedule. Both the ScheduleGroup and the Schedule (CustomPeriod) must be defined by the user!

Datatype
IScheduleCustomPeriod

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Index as long

Example
C#
Copy
publicvoid Macro_SchedulerAccessCustomPeriod()

 {

 String fullString = "";

 {

//Specify ScheduleGroup index!

 zenOn.IScheduleGroup group =

 ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)

 {

if (fullString.Length > 0)

 {

 fullString += "\n\n\n\n";

 }

 fullString += "ScheduleName: " + group.Name + " ";

 fullString += "\n";

//Specify CustomPeriod via Index!

 Macro_ReportOfOneCustomPeriod(group.Schedules.GetCustomPeriod(1), ref fullString);

 }

 }

 System.Windows.Forms.MessageBox.Show(fullString);

 }
VBA
Copy
Public Sub AccessCustomPeriod()
Dim fullString As String
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
'Specify ScheduleGroup via Index!
Set group = groups.ItemByIndex(0)
Dim customPeriodCount As Long
customPeriodCount = group.Schedules.customPeriodCount
If Not group Is Nothing Then
 If Len(fullString) > 0 Then
 fullString = fullString & vbNewLine & vbNewLine & vbNewLine & vbNewLine
 End If
 fullString = fullString & "ScheduleName: " & group.Name
 fullString = fullString & vbNewLine
 Dim customPeriod As ScheduleCustomPeriod
 'Specify CustomPeriod via Index!
 Set customPeriod = group.Schedules.GetCustomPeriod(2)
 Call ReportOfOneCustomPeriod(customPeriod, fullString)
End If
MsgBox fullString
End Sub


GetStandardDay
ObjectModel COM [image] Schedules [image] Methods [image] GetStandardDay
Remarks

Access a specific Schedule within a ScheduleGroup. Generates a List containing the amount of Switching Periods & Points within a Schedule. Both the ScheduleGroup and the Schedule (StandardDay) must be defined by the user!

Datatype
IScheduleStandardDay

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Day as tpScheduleDayType

Example
C#
Copy
publicvoid Macro_SchedulerAccessStandardDay()

 {

 String fullString = "";

 {

//Specify ScheduleGroup via Index!

 zenOn.IScheduleGroup group =

 ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)

 {

if (fullString.Length > 0)

 {

 fullString += "\n\n\n\n";

 }

 fullString += "ScheduleName: " + group.Name + " ";

 fullString += "\n";

//Specify StandardDay via Index!

 zenOn.tpScheduleDayType dayType = Macro_GetDayTypeForIndex(2);

 Macro_ReportOfOneStandardDay(group.Schedules.GetStandardDay(dayType), ref fullString);

 }

 }

 System.Windows.Forms.MessageBox.Show(fullString);

 }
VBA
Copy
Public Sub AccessStandardDay()
Dim fullString As String
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
'Specify ScheduleGroup via Index!
Set group = groups.ItemByIndex(0)
Dim standardDayCount As Long
standardDayCount = 8
If Not group Is Nothing Then
 If Len(fullString) > 0 Then
 fullString = fullString & vbNewLine & vbNewLine & vbNewLine & vbNewLine
 End If
 fullString = fullString & "ScheduleName: " & group.Name
 fullString = fullString & vbNewLine
 Dim dayType As tpScheduleDayType
 'Specify StandardDay via Index!
 dayType = GetDayTypeForIndex(0)
 Call ReportOfOneStandardDay(group.Schedules.GetStandardDay(dayType), fullString)
End If
MsgBox fullString
End Sub


ScheduleStandardDay
ObjectModel COM [image] ScheduleStandardDay
Remarks

A Standard Day Schedule that defines the Switching Actions that are normally to be used on a Day of its Type

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] ScheduleStandardDay [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
SwitchingPeriods | ischeduleswitchingperiods | Collection of Switching Periods in a Standard Day | Readonly | Readonly | Available | Available
SwitchingPoints | ischeduleswitchingpoints | Collection of Switching Points in a Standard Day | Readonly | Readonly | Available | Available
Type | tpscheduledaytype | Standard Day type | Readonly | Readonly | Available | Available


SwitchingPeriods
ObjectModel COM [image] ScheduleStandardDay [image] Properties [image] SwitchingPeriods
Remarks

Collection of Switching Periods

Datatype
IScheduleSwitchingPeriods

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


SwitchingPoints
ObjectModel COM [image] ScheduleStandardDay [image] Properties [image] SwitchingPoints
Remarks

Collection of Switching Points

Datatype
IScheduleSwitchingPoints

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] ScheduleStandardDay [image] Properties [image] Type
Remarks

Defines the days on which it gets used. Cannot be changed.

Datatype
tpScheduleDayType

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ScheduleSwitchingPeriod
ObjectModel COM [image] ScheduleSwitchingPeriod
Remarks

A single Switching Period

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
///<summary>
/// Creates a Switching Period with current time and a dureation of 1 hour on monday of the first scheduleGroup and shows details in a messageBox
///</summary>
publicvoid Macro_SchedulerCreateSwitchingPeriod()
{
    zenOn.IScheduleGroup group =
    ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)
    {
        zenOn.IScheduleStandardDay day = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday);
if (day != null)
        {
            String report = "scheduleGroup: " + group.Name + "\n";
            report += "\nschedule: Monday\n";
            TimeSpan oneDay = new TimeSpan(1, 0, 0);
            zenOn.IScheduleSwitchingPeriod newSwitchingPeriod = day.SwitchingPeriods.Create(DateTime.Now, DateTime.Now+oneDay);
if (newSwitchingPeriod != null)
            {
                report += "new switchingPeriod: " + newSwitchingPeriod.Start.Time.TimeOfDay + " - " + newSwitchingPeriod.End.Time.TimeOfDay;
                report += "\nSwitchingPeriod created successfully";
            }
else
            {
                report += "\nNo switchingPeriod created";
            }
            System.Windows.Forms.MessageBox.Show(report);
        }
else
        {
            System.Windows.Forms.MessageBox.Show("Monday does not exist");
        }
    }
else
    {
        System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");
    }
}
VBA
Copy
Public Sub CreateSwitchingPeriod()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
Set group = groups.ItemByIndex(0)
If Not group Is Nothing Then
    Dim monday As ScheduleStandardDay
    Set monday = group.Schedules.GetStandardDay(tpScheduleMonday)
    If Not monday Is Nothing Then
       Dim report As String
       report = report & "scheduleGroup: " & group.name & vbNewLine
       report = report & "schedule: Monday" & vbNewLine
       Dim newSwitchingPeriod As ScheduleSwitchingPeriod
       Dim endTime As Date
       endTime = DateAdd("h", 1, Now())
       Set newSwitchingPeriod = monday.SwitchingPeriods.Create(Now(), endTime)
       If Not newSwitchingPeriod Is Nothing Then
       report = report & "new switchingPoint: " & Format(newSwitchingPeriod.Start.Time, "hh:mm")
       report = report & " - " & Format(newSwitchingPeriod.End.Time, "hh:mm")
       report = report & vbNewLine & "SwitchingPeriod created successfully"
       Else
       report = report & vbNewLine & "No SwitchingPeriod created"
       End If
       MsgBox report
    Else
        MsgBox "Monday does not exist"
    End If
Else
    MsgBox "No accessable scheduleGroup existing"
End If
End Sub


Properties
ObjectModel COM [image] ScheduleSwitchingPeriod [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
End | ischeduleswitchingpoint | Switching Point at the End of the Period | Readonly | Readonly | Available | Available
Start | ischeduleswitchingpoint | Switching Point at the Start of the Period | Readonly | Readonly | Available | Available


End
ObjectModel COM [image] ScheduleSwitchingPeriod [image] Properties [image] End
Remarks

Switching Point at the end of the Period

Datatype
IScheduleSwitchingPoint

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Start
ObjectModel COM [image] ScheduleSwitchingPeriod [image] Properties [image] Start
Remarks

Switching Point at the Start of the Period

Datatype
IScheduleSwitchingPoint

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ScheduleSwitchingPeriods
ObjectModel COM [image] ScheduleSwitchingPeriods
Remarks

Collection of Switching Periods.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
///<summary>
/// Creates a Switching Period with current time and a dureation of 1 hour on monday of the first scheduleGroup and shows details in a messageBox
///</summary>
publicvoid Macro_SchedulerCreateSwitchingPeriod()
{
    zenOn.IScheduleGroup group =
    ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)
    {
        zenOn.IScheduleStandardDay day = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday);
if (day != null)
        {
            String report = "scheduleGroup: " + group.Name + "\n";
            report += "\nschedule: Monday\n";
            TimeSpan oneDay = new TimeSpan(1, 0, 0);
            zenOn.IScheduleSwitchingPeriod newSwitchingPeriod = day.SwitchingPeriods.Create(DateTime.Now, DateTime.Now+oneDay);
if (newSwitchingPeriod != null)
            {
                report += "new switchingPeriod: " + newSwitchingPeriod.Start.Time.TimeOfDay + " - " + newSwitchingPeriod.End.Time.TimeOfDay;
                report += "\nSwitchingPeriod created successfully";
            }
else
            {
                report += "\nNo switchingPeriod created";
            }
            System.Windows.Forms.MessageBox.Show(report);
        }
else
        {
            System.Windows.Forms.MessageBox.Show("Monday does not exist");
        }
    }
else
    {
        System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");
    }
}
VBA
Copy
Public Sub CreateSwitchingPeriod()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
Set group = groups.ItemByIndex(0)
If Not group Is Nothing Then
    Dim monday As ScheduleStandardDay
    Set monday = group.Schedules.GetStandardDay(tpScheduleMonday)
    If Not monday Is Nothing Then
       Dim report As String
       report = report & "scheduleGroup: " & group.name & vbNewLine
       report = report & "schedule: Monday" & vbNewLine
       Dim newSwitchingPeriod As ScheduleSwitchingPeriod
       Dim endTime As Date
       endTime = DateAdd("h", 1, Now())
       Set newSwitchingPeriod = monday.SwitchingPeriods.Create(Now(), endTime)
       If Not newSwitchingPeriod Is Nothing Then
       report = report & "new switchingPoint: " & Format(newSwitchingPeriod.Start.Time, "hh:mm")
       report = report & " - " & Format(newSwitchingPeriod.End.Time, "hh:mm")
       report = report & vbNewLine & "SwitchingPeriod created successfully"
       Else
       report = report & vbNewLine & "No SwitchingPeriod created"
       End If
       MsgBox report
    Else
        MsgBox "Monday does not exist"
    End If
Else
    MsgBox "No accessable scheduleGroup existing"
End If
End Sub


Properties
ObjectModel COM [image] ScheduleSwitchingPeriods [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the Count of Switching Periods | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] ScheduleSwitchingPeriods [image] Properties [image] Count
Remarks

Count of Switching Periods. Cannot be changed directly.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ScheduleSwitchingPeriods [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | ischeduleswitchingperiod | Creates a new Switching Period | Available | Available | Available | Available
Delete | variant_bool | Deletes a Switching Period | Available | Available | Available | Available
Item | ischeduleswitchingperiod | Returns a Switching Period | Available | Available | Available | Available


Create
ObjectModel COM [image] ScheduleSwitchingPeriods [image] Methods [image] Create
Remarks

Creates a switching period

Datatype
IScheduleSwitchingPeriod

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
StartTime as DATE

EndTime as DATE

Example
C#
Copy
///<summary>
/// Creates a Switching Period with current time and a dureation of 1 hour on monday of the first scheduleGroup and shows details in a messageBox
///</summary>
publicvoid Macro_SchedulerCreateSwitchingPeriod()
{
    zenOn.IScheduleGroup group =
    ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)
    {
        zenOn.IScheduleStandardDay day = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday);
if (day != null)
        {
            String report = "scheduleGroup: " + group.Name + "\n";
            report += "\nschedule: Monday\n";
            TimeSpan oneDay = new TimeSpan(1, 0, 0);
            zenOn.IScheduleSwitchingPeriod newSwitchingPeriod = day.SwitchingPeriods.Create(DateTime.Now, DateTime.Now+oneDay);
if (newSwitchingPeriod != null)
            {
                report += "new switchingPeriod: " + newSwitchingPeriod.Start.Time.TimeOfDay + " - " + newSwitchingPeriod.End.Time.TimeOfDay;
                report += "\nSwitchingPeriod created successfully";
            }
else
            {
                report += "\nNo switchingPeriod created";
            }
            System.Windows.Forms.MessageBox.Show(report);
        }
else
        {
            System.Windows.Forms.MessageBox.Show("Monday does not exist");
        }
    }
else
    {
        System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");
    }
}
VBA
Copy
Public Sub CreateSwitchingPeriod()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
Set group = groups.ItemByIndex(0)
If Not group Is Nothing Then
    Dim monday As ScheduleStandardDay
    Set monday = group.Schedules.GetStandardDay(tpScheduleMonday)
    If Not monday Is Nothing Then
       Dim report As String
       report = report & "scheduleGroup: " & group.name & vbNewLine
       report = report & "schedule: Monday" & vbNewLine
       Dim newSwitchingPeriod As ScheduleSwitchingPeriod
       Dim endTime As Date
       endTime = DateAdd("h", 1, Now())
       Set newSwitchingPeriod = monday.SwitchingPeriods.Create(Now(), endTime)
       If Not newSwitchingPeriod Is Nothing Then
       report = report & "new switchingPoint: " & Format(newSwitchingPeriod.Start.Time, "hh:mm")
       report = report & " - " & Format(newSwitchingPeriod.End.Time, "hh:mm")
       report = report & vbNewLine & "SwitchingPeriod created successfully"
       Else
       report = report & vbNewLine & "No SwitchingPeriod created"
       End If
       MsgBox report
    Else
        MsgBox "Monday does not exist"
    End If
Else
    MsgBox "No accessable scheduleGroup existing"
End If
End Sub


Delete
ObjectModel COM [image] ScheduleSwitchingPeriods [image] Methods [image] Delete
Remarks

Deletes existing SwitchingPeriods

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Index as long

Example
C#
Copy
///<summary>
/// Deletes the first existing SwitchingPeriod from Monday in the first existing scheduleGroup and shows details in a messageBox
///</summary>
publicvoid Macro_SchedulerDeleteSwitchingPeriod()
{
    zenOn.IScheduleGroup group =
    ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)
    {
        zenOn.IScheduleStandardDay day = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday);
if (day != null)
        {
if (day.SwitchingPeriods.Count > 0)
            {
                zenOn.IScheduleSwitchingPeriod period = day.SwitchingPeriods.Item(0);
if (period != null)
                {
                    String report = "scheduleGroup: " + group.Name + "\n";
                    report += "first switchingPeriod: " + period.Start.Time.TimeOfDay + " - " + period.End.Time.TimeOfDay;

bool success = day.SwitchingPeriods.Delete(0);
if (success)
                    {
                        report += "\n SwitchingPeriod deleted successfully";
                    }
else
                    {
                        report += "\nDeleting switchingPeriod was not successful";
                    }
                    System.Windows.Forms.MessageBox.Show(report);
                }
            }
else
            {
                System.Windows.Forms.MessageBox.Show("There are no switching periods existing to delete");
            }
        }
else
        {
            System.Windows.Forms.MessageBox.Show("Monday does not exist");
        }
    }
else
    {
        System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");
    }
}
VBA
Copy
Public Sub DeleteSwitchingPeriod()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
Set group = groups.ItemByIndex(0)
If Not group Is Nothing Then
    Dim monday As ScheduleStandardDay
    Set monday = group.Schedules.GetStandardDay(tpScheduleMonday)
    If Not monday Is Nothing Then
        If monday.SwitchingPeriods.Count > 0 Then
            Dim period As ScheduleSwitchingPeriod
            Set period = monday.SwitchingPeriods.Item(0)
            If Not period Is Nothing Then
                Dim report As String
                report = report & "scheduleGroup: " & group.name & vbNewLine
                report = report & "first switchingPeriod: " & Format(period.Start.Time, "hh:mm") & " - " & Format(period.End.Time, "hh:mm")
                Dim success As Boolean
                success = monday.SwitchingPeriods.Delete(0)
                If success Then
                    report = report & vbNewLine & "switchingPeriod deleted successfully"
                Else
                report = report & vbNewLine & "Deleting switchingPeriod was not successful"
                End If
                MsgBox report
            End If
        Else
            MsgBox "There are no switchingPeriods existing"
        End If
    Else
        MsgBox "Monday does not exist"
    End If
Else
    MsgBox "No accessable scheduleGroup existing"
End If
End Sub


Item
ObjectModel COM [image] ScheduleSwitchingPeriods [image] Methods [image] Item
Remarks

Returns a Count and a list of all SwitchingPeriods contained within the specified Schedule

Datatype
IScheduleSwitchingPeriod

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Index as long

Example
C#
Copy
publicvoid Macro_SchedulerAccessSwitchingPeriods()

 {

 String fullString = "";

//Specify a ScheduleGroup via index!

 zenOn.IScheduleGroup group =

 ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)

 {

 zenOn.IScheduleStandardDay monday =

 group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday);

if (monday != null)

 {

 fullString += "Monday:\n";

 fullString += "\n";

 fullString += "Amount of SwitchingPeriods: " + monday.SwitchingPeriods.Count + "\n";

for (int i = 0; i < monday.SwitchingPeriods.Count; i++)

 {

 zenOn.IScheduleSwitchingPeriod period = monday.SwitchingPeriods.Item(i);

if (period != null)

 {

 fullString += period.Start.Time.TimeOfDay + " - " + period.End.Time.TimeOfDay + "\n";

 }

 }

 System.Windows.Forms.MessageBox.Show(fullString);

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while accessing 'Monday' of your schedule '" + group.Name + "'");

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");

 }

 }
VBA
Copy
Public Sub AccessAllSwitchingPeriods()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
'Specify ScheduleGroup via Index!
Set group = groups.ItemByIndex(0)
If Not group Is Nothing Then
'Specify StandardDay!

 Dim monday As ScheduleStandardDay

 Set monday = group.Schedules.GetStandardDay(tpScheduleMonday)

 If Not monday Is Nothing Then
 Dim fullString As String
 fullString = fullString & vbNewLine
 fullString = fullString & "Monday: " & vbNewLine
 fullString = fullString & vbNewLine
 fullString = fullString & "Amount of SwitchingPeriods: " & monday.SwitchingPeriods.count & vbNewLine
 Dim index As Long
 For index = 0 To (monday.SwitchingPeriods.count - 1)
 Dim period As ScheduleSwitchingPeriod
 Set period = monday.SwitchingPeriods.Item(index)
 If Not period Is Nothing Then

 fullString = fullString & Format(period.Start.Time, "hh:mm:ss") & " - " & Format(period.End.Time, "hh:mm:ss") & vbNewLine
 End If
 Next
 fullString = fullString & vbNewLine
 MsgBox fullString

 Else

 MsgBox "Error while accessing schedule '" + group.Name + "'"

 End If
Else
 MsgBox "No accessable scheduleGroup existing"
End If
End Sub


ScheduleSwitchingPoint
ObjectModel COM [image] ScheduleSwitchingPoint
Remarks

A single switching Point

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
///<summary>
/// Deletes the first existing SwitchingPoint from Monday in the first scheduleGroup and shows details in a messageBox
///</summary>
publicvoid Macro_SchedulerDeleteSwitchingPoint()
{
    zenOn.IScheduleGroup group =
    ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)
    {
        zenOn.IScheduleStandardDay day = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday);
if (day != null)
        {
if (day.SwitchingPoints.Count > 0)
            {
                zenOn.IScheduleSwitchingPoint point = day.SwitchingPoints.Item(0);
if (point != null)
                {
                    String report = "scheduleGroup: " + group.Name + "\n";
                    report += "first switchingPoint: " + point.Time.TimeOfDay;

bool success = day.SwitchingPoints.Delete(0);
if (success)
                    {
                        report += "\nSwitchingPoint deleted successfully";
                    }
else
                    {
                        report += "\nDeleting switchingPoint was not successful";
                    }
                    System.Windows.Forms.MessageBox.Show(report);
                }
            }
else
            {
                System.Windows.Forms.MessageBox.Show("There are no switching points existing to delete");
            }
        }
else
        {
            System.Windows.Forms.MessageBox.Show("Monday does not exist");
        }
    }
else
    {
        System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");
    }
}
VBA
Copy
Public Sub DeleteSwitchingPoint()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
Set group = groups.ItemByIndex(0)
If Not group Is Nothing Then
    Dim monday As ScheduleStandardDay
    Set monday = group.Schedules.GetStandardDay(tpScheduleMonday)
    If Not monday Is Nothing Then
        If monday.SwitchingPoints.Count > 0 Then
            Dim point As ScheduleSwitchingPoint
            Set point = monday.SwitchingPoints.Item(0)
            If Not point Is Nothing Then
                Dim report As String
                report = report & "scheduleGroup: " & group.name & vbNewLine
                report = report & "first switchingPoint: " & Format(point.Time, "hh:mm") & " - " & Format(point.Time, "hh:mm")
                Dim success As Boolean
                success = monday.SwitchingPoints.Delete(0)
                If success Then
                    report = report & vbNewLine & "switchingPoint deleted successfully"
                Else
                report = report & vbNewLine & "Deleting switchingPoint was not successful"
                End If
                MsgBox report
            End If
        Else
            MsgBox "There are no switchingPoints existing"
        End If
    Else
        MsgBox "Monday does not exist"
    End If
Else
    MsgBox "No accessable scheduleGroup existing"
End If
End Sub


Properties
ObjectModel COM [image] ScheduleSwitchingPoint [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Functions | ischedulefunctions | Collection of Functions in a Switching Point | Readonly | Readonly | Available | Available
Time | date | Switching Point execution Time | Readonly | Readonly | Available | Available
Variables | ischedulevariables | Collection of Variables in a Switching Point | Readonly | Readonly | Available | Available


Functions
ObjectModel COM [image] ScheduleSwitchingPoint [image] Properties [image] Functions
Remarks

Collection of Functions to be Executed

Datatype
IScheduleFunctions

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] ScheduleSwitchingPoint [image] Properties [image] Time
Remarks

Time of the switching Point. Only the time component is relevant

Datatype
DATE

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Variables
ObjectModel COM [image] ScheduleSwitchingPoint [image] Properties [image] Variables
Remarks

Collection of Actions to be performed on Variables

Datatype
IScheduleVariables

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ScheduleSwitchingPoints
ObjectModel COM [image] ScheduleSwitchingPoints
Remarks

Collection of Switching Points

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
///<summary>
/// Deletes the first existing SwitchingPoint from Monday in the first scheduleGroup and shows details in a messageBox
///</summary>
publicvoid Macro_SchedulerDeleteSwitchingPoint()
{
    zenOn.IScheduleGroup group =
    ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)
    {
        zenOn.IScheduleStandardDay day = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday);
if (day != null)
        {
if (day.SwitchingPoints.Count > 0)
            {
                zenOn.IScheduleSwitchingPoint point = day.SwitchingPoints.Item(0);
if (point != null)
                {
                    String report = "scheduleGroup: " + group.Name + "\n";
                    report += "first switchingPoint: " + point.Time.TimeOfDay;

bool success = day.SwitchingPoints.Delete(0);
if (success)
                    {
                        report += "\nSwitchingPoint deleted successfully";
                    }
else
                    {
                        report += "\nDeleting switchingPoint was not successful";
                    }
                    System.Windows.Forms.MessageBox.Show(report);
                }
            }
else
            {
                System.Windows.Forms.MessageBox.Show("There are no switching points existing to delete");
            }
        }
else
        {
            System.Windows.Forms.MessageBox.Show("Monday does not exist");
        }
    }
else
    {
        System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");
    }
}
VBA
Copy
Public Sub DeleteSwitchingPoint()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
Set group = groups.ItemByIndex(0)
If Not group Is Nothing Then
    Dim monday As ScheduleStandardDay
    Set monday = group.Schedules.GetStandardDay(tpScheduleMonday)
    If Not monday Is Nothing Then
        If monday.SwitchingPoints.Count > 0 Then
            Dim point As ScheduleSwitchingPoint
            Set point = monday.SwitchingPoints.Item(0)
            If Not point Is Nothing Then
                Dim report As String
                report = report & "scheduleGroup: " & group.name & vbNewLine
                report = report & "first switchingPoint: " & Format(point.Time, "hh:mm") & " - " & Format(point.Time, "hh:mm")
                Dim success As Boolean
                success = monday.SwitchingPoints.Delete(0)
                If success Then
                    report = report & vbNewLine & "switchingPoint deleted successfully"
                Else
                report = report & vbNewLine & "Deleting switchingPoint was not successful"
                End If
                MsgBox report
            End If
        Else
            MsgBox "There are no switchingPoints existing"
        End If
    Else
        MsgBox "Monday does not exist"
    End If
Else
    MsgBox "No accessable scheduleGroup existing"
End If
End Sub


Properties
ObjectModel COM [image] ScheduleSwitchingPoints [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] ScheduleSwitchingPoints [image] Properties [image] Count
Remarks

Count if Swichting Points. Cannot be changed directly.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ScheduleSwitchingPoints [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | ischeduleswitchingpoint |  | Available | Available | Available | Available
Delete | variant_bool |  | Available | Available | Available | Available
Item | ischeduleswitchingpoint |  | Available | Available | Available | Available


Create
ObjectModel COM [image] ScheduleSwitchingPoints [image] Methods [image] Create
Remarks

Creates a Switching Point

Datatype
IScheduleSwitchingPoint

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Time as DATE

Example
C#
Copy
publicvoid Macro_SchedulerCreateSwitchingPoint()
{
    zenOn.IScheduleGroup group =
    ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)
    {
        zenOn.IScheduleStandardDay day = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday);
if (day != null)
        {
            String report = "scheduleGroup: " + group.Name + "\n";
            report += "\nschedule: Monday\n";
            zenOn.IScheduleSwitchingPoint newSwitchingPoint = day.SwitchingPoints.Create(DateTime.Now);
if (newSwitchingPoint != null)
            {
                report += "new switchingPoint: " + newSwitchingPoint.Time.TimeOfDay;
                report += "\nSwitchingPoint created successfully";
            }
else
            {
                report += "\nNo switchingPoint created";
            }
            System.Windows.Forms.MessageBox.Show(report);
        }
else
        {
            System.Windows.Forms.MessageBox.Show("Monday does not exist");
        }
    }
else
    {
        System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");
    }
}
VBA
Copy
Public Sub CreateSwitchingPoint()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
Set group = groups.ItemByIndex(0)
If Not group Is Nothing Then
    Dim monday As ScheduleStandardDay
    Set monday = group.Schedules.GetStandardDay(tpScheduleMonday)
    If Not monday Is Nothing Then
       Dim report As String
       report = report & "scheduleGroup: " & group.name & vbNewLine
       report = report & "schedule: Monday" & vbNewLine
       Dim newSwitchingPoint As ScheduleSwitchingPoint
       Set newSwitchingPoint = monday.SwitchingPoints.Create(Now())
       If Not newSwitchingPoint Is Nothing Then
       report = report & "new switchingPoint: " & Format(newSwitchingPoint.Time, "hh:mm")
       report = report & vbNewLine & "SwitchingPoint created successfully"
       Else
       report = report & vbNewLine & "No SwitchingPoint created"
       End If
       MsgBox report
    Else
        MsgBox "Monday does not exist"
    End If
Else
    MsgBox "No accessable scheduleGroup existing"
End If
End Sub


Delete
ObjectModel COM [image] ScheduleSwitchingPoints [image] Methods [image] Delete
Remarks

Deletes existing SwitchingPoints

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Index as long

Example
C#
Copy
///<summary>
/// Deletes the first existing SwitchingPoint from Monday in the first scheduleGroup and shows details in a messageBox
///</summary>
publicvoid Macro_SchedulerDeleteSwitchingPoint()
{
    zenOn.IScheduleGroup group =
    ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)
    {
        zenOn.IScheduleStandardDay day = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday);
if (day != null)
        {
if (day.SwitchingPoints.Count > 0)
            {
                zenOn.IScheduleSwitchingPoint point = day.SwitchingPoints.Item(0);
if (point != null)
                {
                    String report = "scheduleGroup: " + group.Name + "\n";
                    report += "first switchingPoint: " + point.Time.TimeOfDay;

bool success = day.SwitchingPoints.Delete(0);
if (success)
                    {
                        report += "\nSwitchingPoint deleted successfully";
                    }
else
                    {
                        report += "\nDeleting switchingPoint was not successful";
                    }
                    System.Windows.Forms.MessageBox.Show(report);
                }
            }
else
            {
                System.Windows.Forms.MessageBox.Show("There are no switching points existing to delete");
            }
        }
else
        {
            System.Windows.Forms.MessageBox.Show("Monday does not exist");
        }
    }
else
    {
        System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");
    }
}
VBA
Copy
Public Sub DeleteSwitchingPoint()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
Set group = groups.ItemByIndex(0)
If Not group Is Nothing Then
    Dim monday As ScheduleStandardDay
    Set monday = group.Schedules.GetStandardDay(tpScheduleMonday)
    If Not monday Is Nothing Then
        If monday.SwitchingPoints.Count > 0 Then
            Dim point As ScheduleSwitchingPoint
            Set point = monday.SwitchingPoints.Item(0)
            If Not point Is Nothing Then
                Dim report As String
                report = report & "scheduleGroup: " & group.name & vbNewLine
                report = report & "first switchingPoint: " & Format(point.Time, "hh:mm") & " - " & Format(point.Time, "hh:mm")
                Dim success As Boolean
                success = monday.SwitchingPoints.Delete(0)
                If success Then
                    report = report & vbNewLine & "switchingPoint deleted successfully"
                Else
                report = report & vbNewLine & "Deleting switchingPoint was not successful"
                End If
                MsgBox report
            End If
        Else
            MsgBox "There are no switchingPoints existing"
        End If
    Else
        MsgBox "Monday does not exist"
    End If
Else
    MsgBox "No accessable scheduleGroup existing"
End If
End Sub


Item
ObjectModel COM [image] ScheduleSwitchingPoints [image] Methods [image] Item
Remarks

Returns a Count and a list of all SwitchingPoints contained within the specified Schedule

Datatype
IScheduleSwitchingPoint

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Index as long

Example
C#
Copy
publicvoid Macro_SchedulerAccessSwitchingPoints()

 {

 String fullString = "";

//Specify a ScheduleGroup via index!

 zenOn.IScheduleGroup group =

 ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)

 {

 zenOn.IScheduleStandardDay monday =

 group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday);

if (monday != null)

 {

 fullString += "Monday:\n";

 fullString += "\n\nAmount of SwitchingPoints: " + monday.SwitchingPoints.Count + "\n";

for (int i = 0; i < monday.SwitchingPoints.Count; i++)

 {

 zenOn.IScheduleSwitchingPoint point = monday.SwitchingPoints.Item(i);

if (point != null)

 {

 fullString += point.Time.TimeOfDay + "\n";

 }

 }

 System.Windows.Forms.MessageBox.Show(fullString);

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Error while accessing schedule '" + group.Name + "'");

 }

 }

else

 {

 System.Windows.Forms.MessageBox.Show("No accessable scheduleGroup existing");

 }

 }
VBA
Copy
Public Sub AccessAllSwitchingPoints()
Dim scheduler As scheduler
Set scheduler = MyWorkspace.ActiveDocument.scheduler
Dim groups As ScheduleGroups
Set groups = scheduler.ScheduleGroups
Dim group As ScheduleGroup
'Specify ScheduleGroup via Index!
Set group = groups.ItemByIndex(0)
If Not group Is Nothing Then
'Specify StandardDay!

 Dim monday As ScheduleStandardDay

 Set monday = group.Schedules.GetStandardDay(tpScheduleMonday)

 If Not monday Is Nothing Then
 Dim fullString As String
 fullString = fullString & vbNewLine
 fullString = fullString & "Monday: " & vbNewLine
 fullString = fullString & vbNewLine
 fullString = fullString & "Amount of SwitchingPoints: " & monday.SwitchingPoints.count & vbNewLine
 Dim index As Long
 For index = 0 To (monday.SwitchingPoints.count - 1)
 Dim point As ScheduleSwitchingPoint
 Set point = monday.SwitchingPoints.Item(index)
 If Not point Is Nothing Then

 fullString = fullString & Format(point.Time, "hh:mm:ss") & vbNewLine
 End If
 Next
 fullString = fullString & vbNewLine
 MsgBox fullString

 Else

 MsgBox "Error while accessing schedule '" + group.Name + "'"

 End If
Else
 MsgBox "No accessable scheduleGroup existing"
End If
End Sub


ScheduleVariable
ObjectModel COM [image] ScheduleVariable
Remarks

A single Variable Action

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_LinkVariableToSwitchingPeriodStartTime()

 {

//Specify a ScheduleGroup via Index!

 zenOn.IScheduleGroup group = ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)

 {

//Specify a SwitchingPeriod to which the Variable should be linked!

 zenOn.IScheduleSwitchingPeriod switchingPeriod = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday).SwitchingPeriods.Item(0);

if (switchingPeriod != null)

 {

//Specify a Variable to be linked!

 zenOn.IVariable var = ActiveDocument.Variables().Item("variableNameBool");

if (var != null)

 {

//Insert the variable with set value to the Start-time of the SwitchingPeriod

 zenOn.IScheduleVariable newScheduleVariable = switchingPeriod.Start.Variables.Create(var, 1);

if (newScheduleVariable != null)

 {

 System.Windows.Forms.MessageBox.Show("New variable link created");

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Link could not be created");

 }

 }

 }

 }

 }

publicvoid Macro_LinkVariableToSwitchingPoint()

 {

//Specify a ScheduleGroup via Index!

 zenOn.IScheduleGroup group = ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)

 {

//Specify a SwitchingPoint to which the Variable should be linked!

 zenOn.IScheduleSwitchingPoint switchingPoint = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday).SwitchingPoints.Item(0);

if (switchingPoint != null)

 {

//Specify a Variable to be linked!

 zenOn.IVariable var = ActiveDocument.Variables().Item("variableName");

if (var != null)

 {

//Insert the variable with set value to the SwitchingPoint

 zenOn.IScheduleVariable newScheduleVariable = switchingPoint.Variables.Create(var, 100);

if (newScheduleVariable != null)

 {

 System.Windows.Forms.MessageBox.Show("New variable link created");

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Link could not be created");

 }

 }

 }

 }

 }
VBA
Copy
Public Sub LinkVariableToSwitchingPeriodStartTime()
 Dim group As ScheduleGroup
 'Specify a ScheduleGroup via index!
 Set group = MyWorkspace.ActiveDocument.scheduler.ScheduleGroups.ItemByIndex(0)
 If Not group Is Nothing Then
 Dim var As Variable
 'Specify a Variable to be linked!
 Set var = MyWorkspace.ActiveDocument.Variables().Item("variableNameBool")
 If Not var Is Nothing Then

 Dim switchingPeriod As ScheduleSwitchingPeriod

 'Specify a SwitchingPeriod to which the Variable should be linked!

 Set switchingPeriod = group.Schedules.GetStandardDay(tpScheduleMonday).SwitchingPeriods.Item(0)

 If Not switchingPeriod Is Nothing Then

 Dim newScheduleVariable As ScheduleVariable

 'Insert the variable with set value to the Start of the SwitchingPeriod

 Set newScheduleVariable = switchingPeriod.Start.Variables.Create(var, 1)

 If Not newScheduleVariable Is Nothing Then

 MsgBox "New variable link created"

 Else

 MsgBox "Link could not be created"

 End If

 End If
 End If
 End If
End Sub

Public Sub LinkVariableToSwitchingPoint()
 Dim group As ScheduleGroup
 'Specify a ScheduleGroup via index!
 Set group = MyWorkspace.ActiveDocument.scheduler.ScheduleGroups.ItemByIndex(0)
 If Not group Is Nothing Then
 Dim var As Variable
 'Specify a Variable to be linked!
 Set var = MyWorkspace.ActiveDocument.Variables().Item("variableName")
 If Not var Is Nothing Then

 Dim switchingPoint As ScheduleSwitchingPoint

 'Specify a SwitchingPoint to which the Variable should be linked!

 Set switchingPoint = group.Schedules.GetStandardDay(tpScheduleMonday).SwitchingPoints.Item(0)

 If Not switchingPoint Is Nothing Then

 Dim newScheduleVariable As ScheduleVariable

 'Insert the variable with set value to the Start of the SwitchingPeriod

 Set newScheduleVariable = switchingPoint.Variables.Create(var, 100)

 If Not newScheduleVariable Is Nothing Then

 MsgBox "New variable link created"

 Else

 MsgBox "Link could not be created"

 End If

 End If
 End If
 End If
End Sub


Properties
ObjectModel COM [image] ScheduleVariable [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Active | variant_bool | Returns TRUE if the Action of a Variable is Active | Available | Available | Available | Available
SetValue | variant | Defines the Value of a Variable | Available | Available | Available | Available
Variable | ivariable |  | Readonly | Readonly | Available | Available


Active
ObjectModel COM [image] ScheduleVariable [image] Properties [image] Active
Remarks

Defines, if this Action gets Executed. Can be changed.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


SetValue
ObjectModel COM [image] ScheduleVariable [image] Properties [image] SetValue
Remarks

Value that is to be set into the Variable. Can be changed.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Variable
ObjectModel COM [image] ScheduleVariable [image] Properties [image] Variable
Remarks

Variable, that gets a Value set into. Cannot be changed.

Datatype
IVariable

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ScheduleVariables
ObjectModel COM [image] ScheduleVariables
Remarks

Collection of Variable Actions in a Switching Point

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_LinkVariableToSwitchingPeriodStartTime()

 {

//Specify a ScheduleGroup via Index!

 zenOn.IScheduleGroup group = ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)

 {

//Specify a SwitchingPeriod to which the Variable should be linked!

 zenOn.IScheduleSwitchingPeriod switchingPeriod = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday).SwitchingPeriods.Item(0);

if (switchingPeriod != null)

 {

//Specify a Variable to be linked!

 zenOn.IVariable var = ActiveDocument.Variables().Item("variableNameBool");

if (var != null)

 {

//Insert the variable with set value to the Start-time of the SwitchingPeriod

 zenOn.IScheduleVariable newScheduleVariable = switchingPeriod.Start.Variables.Create(var, 1);

if (newScheduleVariable != null)

 {

 System.Windows.Forms.MessageBox.Show("New variable link created");

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Link could not be created");

 }

 }

 }

 }

 }

publicvoid Macro_LinkVariableToSwitchingPoint()

 {

//Specify a ScheduleGroup via Index!

 zenOn.IScheduleGroup group = ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)

 {

//Specify a SwitchingPoint to which the Variable should be linked!

 zenOn.IScheduleSwitchingPoint switchingPoint = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday).SwitchingPoints.Item(0);

if (switchingPoint != null)

 {

//Specify a Variable to be linked!

 zenOn.IVariable var = ActiveDocument.Variables().Item("variableName");

if (var != null)

 {

//Insert the variable with set value to the SwitchingPoint

 zenOn.IScheduleVariable newScheduleVariable = switchingPoint.Variables.Create(var, 100);

if (newScheduleVariable != null)

 {

 System.Windows.Forms.MessageBox.Show("New variable link created");

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Link could not be created");

 }

 }

 }

 }

 }
VBA
Copy
Public Sub LinkVariableToSwitchingPeriodStartTime()
 Dim group As ScheduleGroup
 'Specify a ScheduleGroup via index!
 Set group = MyWorkspace.ActiveDocument.scheduler.ScheduleGroups.ItemByIndex(0)
 If Not group Is Nothing Then
 Dim var As Variable
 'Specify a Variable to be linked!
 Set var = MyWorkspace.ActiveDocument.Variables().Item("variableNameBool")
 If Not var Is Nothing Then

 Dim switchingPeriod As ScheduleSwitchingPeriod

 'Specify a SwitchingPeriod to which the Variable should be linked!

 Set switchingPeriod = group.Schedules.GetStandardDay(tpScheduleMonday).SwitchingPeriods.Item(0)

 If Not switchingPeriod Is Nothing Then

 Dim newScheduleVariable As ScheduleVariable

 'Insert the variable with set value to the Start of the SwitchingPeriod

 Set newScheduleVariable = switchingPeriod.Start.Variables.Create(var, 1)

 If Not newScheduleVariable Is Nothing Then

 MsgBox "New variable link created"

 Else

 MsgBox "Link could not be created"

 End If

 End If
 End If
 End If
End Sub

Public Sub LinkVariableToSwitchingPoint()
 Dim group As ScheduleGroup
 'Specify a ScheduleGroup via index!
 Set group = MyWorkspace.ActiveDocument.scheduler.ScheduleGroups.ItemByIndex(0)
 If Not group Is Nothing Then
 Dim var As Variable
 'Specify a Variable to be linked!
 Set var = MyWorkspace.ActiveDocument.Variables().Item("variableName")
 If Not var Is Nothing Then

 Dim switchingPoint As ScheduleSwitchingPoint

 'Specify a SwitchingPoint to which the Variable should be linked!

 Set switchingPoint = group.Schedules.GetStandardDay(tpScheduleMonday).SwitchingPoints.Item(0)

 If Not switchingPoint Is Nothing Then

 Dim newScheduleVariable As ScheduleVariable

 'Insert the variable with set value to the Start of the SwitchingPeriod

 Set newScheduleVariable = switchingPoint.Variables.Create(var, 100)

 If Not newScheduleVariable Is Nothing Then

 MsgBox "New variable link created"

 Else

 MsgBox "Link could not be created"

 End If

 End If
 End If
 End If
End Sub


Properties
ObjectModel COM [image] ScheduleVariables [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the Count of Variables in a Switching Point | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] ScheduleVariables [image] Properties [image] Count
Remarks

Count of Variable Actions. Cannot be changed directly.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ScheduleVariables [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | ischedulevariable | Creates a Variable in a Switching Point | Available | Available | Available | Available
Delete | variant_bool | Deletes a Variable in a Switching Point | Available | Available | Available | Available
Item | ischedulevariable | Returns a Variable in a Switching Point | Available | Available | Available | Available


Create
ObjectModel COM [image] ScheduleVariables [image] Methods [image] Create
Remarks

Links the specified Variable to a SwitchingPeriod or SwitchingPoint.

Datatype
IScheduleVariable

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Variable as IVariable

SetValue as VARIANT

Example
C#
Copy
publicvoid Macro_LinkVariableToSwitchingPeriodStartTime()

 {

//Specify a ScheduleGroup via Index!

 zenOn.IScheduleGroup group = ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)

 {

//Specify a SwitchingPeriod to which the Variable should be linked!

 zenOn.IScheduleSwitchingPeriod switchingPeriod = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday).SwitchingPeriods.Item(0);

if (switchingPeriod != null)

 {

//Specify a Variable to be linked!

 zenOn.IVariable var = ActiveDocument.Variables().Item("variableNameBool");

if (var != null)

 {

//Insert the variable with set value to the Start-time of the SwitchingPeriod

 zenOn.IScheduleVariable newScheduleVariable = switchingPeriod.Start.Variables.Create(var, 1);

if (newScheduleVariable != null)

 {

 System.Windows.Forms.MessageBox.Show("New variable link created");

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Link could not be created");

 }

 }

 }

 }

 }

publicvoid Macro_LinkVariableToSwitchingPoint()

 {

//Specify a ScheduleGroup via Index!

 zenOn.IScheduleGroup group = ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)

 {

//Specify a SwitchingPoint to which the Variable should be linked!

 zenOn.IScheduleSwitchingPoint switchingPoint = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday).SwitchingPoints.Item(0);

if (switchingPoint != null)

 {

//Specify a Variable to be linked!

 zenOn.IVariable var = ActiveDocument.Variables().Item("variableName");

if (var != null)

 {

//Insert the variable with set value to the SwitchingPoint

 zenOn.IScheduleVariable newScheduleVariable = switchingPoint.Variables.Create(var, 100);

if (newScheduleVariable != null)

 {

 System.Windows.Forms.MessageBox.Show("New variable link created");

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Link could not be created");

 }

 }

 }

 }

 }
VBA
Copy
Public Sub LinkVariableToSwitchingPeriodStartTime()
 Dim group As ScheduleGroup
 'Specify a ScheduleGroup via index!
 Set group = MyWorkspace.ActiveDocument.scheduler.ScheduleGroups.ItemByIndex(0)
 If Not group Is Nothing Then
 Dim var As Variable
 'Specify a Variable to be linked!
 Set var = MyWorkspace.ActiveDocument.Variables().Item("variableNameBool")
 If Not var Is Nothing Then

 Dim switchingPeriod As ScheduleSwitchingPeriod

 'Specify a SwitchingPeriod to which the Variable should be linked!

 Set switchingPeriod = group.Schedules.GetStandardDay(tpScheduleMonday).SwitchingPeriods.Item(0)

 If Not switchingPeriod Is Nothing Then

 Dim newScheduleVariable As ScheduleVariable

 'Insert the variable with set value to the Start of the SwitchingPeriod

 Set newScheduleVariable = switchingPeriod.Start.Variables.Create(var, 1)

 If Not newScheduleVariable Is Nothing Then

 MsgBox "New variable link created"

 Else

 MsgBox "Link could not be created"

 End If

 End If
 End If
 End If
End Sub

Public Sub LinkVariableToSwitchingPoint()
 Dim group As ScheduleGroup
 'Specify a ScheduleGroup via index!
 Set group = MyWorkspace.ActiveDocument.scheduler.ScheduleGroups.ItemByIndex(0)
 If Not group Is Nothing Then
 Dim var As Variable
 'Specify a Variable to be linked!
 Set var = MyWorkspace.ActiveDocument.Variables().Item("variableName")
 If Not var Is Nothing Then

 Dim switchingPoint As ScheduleSwitchingPoint

 'Specify a SwitchingPoint to which the Variable should be linked!

 Set switchingPoint = group.Schedules.GetStandardDay(tpScheduleMonday).SwitchingPoints.Item(0)

 If Not switchingPoint Is Nothing Then

 Dim newScheduleVariable As ScheduleVariable

 'Insert the variable with set value to the Start of the SwitchingPeriod

 Set newScheduleVariable = switchingPoint.Variables.Create(var, 100)

 If Not newScheduleVariable Is Nothing Then

 MsgBox "New variable link created"

 Else

 MsgBox "Link could not be created"

 End If

 End If
 End If
 End If
End Sub


Delete
ObjectModel COM [image] ScheduleVariables [image] Methods [image] Delete
Remarks

Deletes the specified Variable from the a SwitchingPeriod or SwitchingPoint.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Index as long

Example
C#
Copy
publicvoid Macro_DeleteVariableFromSwitchingPeriodEndTime()

 {

//Specify a ScheduleGroup via index!

 zenOn.IScheduleGroup group = ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)

 {

//Specify a SwitchingPeriod in which a Variable should get deleted

 zenOn.IScheduleSwitchingPeriod switchingPeriod = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday).SwitchingPeriods.Item(0);

if (switchingPeriod != null)

 {

//Remove the first Variable linked at the End-time of the SwitchingPeriod

bool deleteResult = switchingPeriod.End.Variables.Delete(0);

if (deleteResult)

 {

 System.Windows.Forms.MessageBox.Show("Variable link was deleted");

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Link could not be deleted");

 }

 }

 }

 }

publicvoid Macro_DeleteVariableFromSwitchingPoint()

 {

//Specify a ScheduleGroup via Index!

 zenOn.IScheduleGroup group = ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)

 {

//Specify a SwitchingPoint in which a Variable should get deleted

 zenOn.IScheduleSwitchingPoint switchingPoint = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday).SwitchingPoints.Item(0);

if (switchingPoint != null)

 {

//Remove the first Variable linked in the SwitchingPoint

bool deleteResult = switchingPoint.Variables.Delete(0);

if (deleteResult)

 {

 System.Windows.Forms.MessageBox.Show("Variable link was deleted");

 }

else

 {

 System.Windows.Forms.MessageBox.Show("Link could not be deleted");

 }

 }

 }

 }
VBA
Copy
Public Sub DeleteVariableFromSwitchingPeriodEndTime()
 Dim group As ScheduleGroup
 'Specify a ScheduleGroup via index!
 Set group = MyWorkspace.ActiveDocument.scheduler.ScheduleGroups.ItemByIndex(0)
 If Not group Is Nothing Then
 Dim switchingPeriod As ScheduleSwitchingPeriod
 'Specify a SwitchingPeriod in which a Variable should get deleted
 Set switchingPeriod = group.Schedules.GetStandardDay(tpScheduleMonday).SwitchingPeriods.Item(0)
 If Not switchingPeriod Is Nothing Then

 Dim deleteResult As Boolean

 'Remove the first Variable linked at the End-time of the SwitchingPeriod

 deleteResult = switchingPeriod.End.Variables.Delete(0)

 If deleteResult = True Then

 MsgBox "Variable link was deleted"

 Else

 MsgBox "Link could not be deleted"

 End If
 End If
 End If
End Sub
Public Sub DeleteVariableFromSwitchingPoint()
 Dim group As ScheduleGroup
 'Specify a ScheduleGroup via index!
 Set group = MyWorkspace.ActiveDocument.scheduler.ScheduleGroups.ItemByIndex(0)
 If Not group Is Nothing Then
 Dim switchingPoint As ScheduleSwitchingPoint
 'Specify a SwitchingPoint in which a Variable should get deleted
 Set switchingPoint = group.Schedules.GetStandardDay(tpScheduleMonday).SwitchingPoints.Item(0)
 If Not switchingPoint Is Nothing Then

 Dim deleteResult As Boolean

 'Remove the first Variable linked in the SwitchingPoint

 deleteResult = switchingPoint.Variables.Delete(0)

 If deleteResult = True Then

 MsgBox "Variable link was deleted"

 Else

 MsgBox "Link could not be deleted"

 End If
 End If
 End If
End Sub


Item
ObjectModel COM [image] ScheduleVariables [image] Methods [image] Item
Remarks

Returns the Variables linked a SwitchingPeriod or SwitchingPoint.

Datatype
IScheduleVariable

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Index as long

Example
C#
Copy
publicvoid Macro_IterateVariableLinksInSwitchingPeriodStartTime()

 {

//Specify a ScheduleGroup via index!

 zenOn.IScheduleGroup group = ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)

 {

//Specify a SwitchingPeriod to be Iterated!

 zenOn.IScheduleSwitchingPeriod switchingPeriod = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday).SwitchingPeriods.Item(0);

if (switchingPeriod != null)

 {

string message = "SwitchingPeriod Start-time variables:\n";

for (int index = 0; index < switchingPeriod.Start.Variables.Count; index++)

 {

//Get Variable at the current index

 zenOn.IScheduleVariable currentVariable = switchingPeriod.Start.Variables.Item(index);

 message += "Variable: " + currentVariable.Variable.Name + "\nValue: " + currentVariable.SetValue + "\nActive: " + currentVariable.Active + "\n";

 }

//show collected information

 System.Windows.Forms.MessageBox.Show(message);

 }

 }

 }

publicvoid Macro_IterateVariableLinksInSwitchingPoint()

 {

//Specify a ScheduleGroup via Index!

 zenOn.IScheduleGroup group = ActiveDocument.Scheduler.ScheduleGroups.ItemByIndex(0);

if (group != null)

 {

//Specify a SwitchingPoint to be Iterated!

 zenOn.IScheduleSwitchingPoint switchingPoint = group.Schedules.GetStandardDay(zenOn.tpScheduleDayType.tpScheduleMonday).SwitchingPoints.Item(0);

if (switchingPoint != null)

 {

string message = "SwitchingPoint variables: \n";

for (int index = 0; index < switchingPoint.Variables.Count; index++)

 {

//Get Variable at the current index

 zenOn.IScheduleVariable currentVariable = switchingPoint.Variables.Item(index);

 message += "Variable: " + currentVariable.Variable.Name + "\nValue: " + currentVariable.SetValue + "\nActive: " + currentVariable.Active + "\n";

 }

//show collected information

 System.Windows.Forms.MessageBox.Show(message);

 }

 }

 }
VBA
Copy
Public Sub IterateVariableLinksInSwitchingPeriodEndTime()
 Dim group As ScheduleGroup
 'Specify a ScheduleGroup via index!
 Set group = MyWorkspace.ActiveDocument.scheduler.ScheduleGroups.ItemByIndex(0)
 If Not group Is Nothing Then
 Dim switchingPeriod As ScheduleSwitchingPeriod
 'Specify a SwitchingPeriod to be Iterated!
 Set switchingPeriod = group.Schedules.GetStandardDay(tpScheduleMonday).SwitchingPeriods.Item(0)
 If Not switchingPeriod Is Nothing Then

 Dim message As String

 message = "SwitchingPeriod End-time variables:" & vbCrLf

 Dim index As Integer

 For index = 0 To switchingPeriod.End.Variables.count - 1

 Dim currentVariable As ScheduleVariable

 'Get Variable at the current index

 Set currentVariable = switchingPeriod.End.Variables.Item(index)

 If Not currentVariable Is Nothing Then

 message = message & "Variable: " & currentVariable.Variable.Name & vbNewLine & "Value: " & currentVariable.SetValue & vbNewLine & "Active: " & currentVariable.Active & vbCrLf

 End If

 Next index

 'Show collected information

 MsgBox message
 End If
 End If
End Sub
Public Sub IterateVariableLinksInSwitchingPoint()
 Dim group As ScheduleGroup
 'Specify a ScheduleGroup via index!
 Set group = MyWorkspace.ActiveDocument.scheduler.ScheduleGroups.ItemByIndex(0)
 If Not group Is Nothing Then
 Dim switchingPoint As ScheduleSwitchingPoint
 'Specify a SwitchingPeriod to be Iterated!
 Set switchingPoint = group.Schedules.GetStandardDay(tpScheduleMonday).SwitchingPoints.Item(0)
 If Not switchingPoint Is Nothing Then

 Dim message As String

 message = "SwitchingPoint variables:" & vbCrLf

 Dim index As Integer

 For index = 0 To switchingPoint.Variables.count - 1

 Dim currentVariable As ScheduleVariable

 'Get Variable at the current index

 Set currentVariable = switchingPoint.Variables.Item(index)

 If Not currentVariable Is Nothing Then

 message = message & "Variable: " & currentVariable.Variable.Name & vbNewLine & "Value: " & currentVariable.SetValue & vbNewLine & "Active: " & currentVariable.Active & vbCrLf

 End If

 Next index

 'Show collected information

 MsgBox message
 End If
 End If
End Sub


Script
ObjectModel COM [image] Script
Remarks

If several functions should be combined and be executed in the defined order (similar to a batch file), they can be entered into a script.

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub zenOn_ScriptExample()
'**************** Use this code in the editor ****************
Dim zScript As Script
Dim i As Integer
'Initialize the script object with the first script in the scripts object (list)
Set zScript = MyWorkspace.ActiveDocument.Scripts.Item(0)
'If there is no script available (no script in the scripts object),...
If zScript Is Nothing Then

'...then inform the user

MsgBox ("No Script available")

'otherwise:
Else

'Output the name of the script

Debug.Print "Scriptname: " & zScript.Name

'For every function in the script...

For i = 0 To zScript.Count - 1

'...output the name of the function

Debug.Print i + 1 & ". Function: " & zScript.Item(i).Name

Next i

'Add the picSTART function to the script

zScript.Add (MyWorkspace.ActiveDocument.RtFunctions.Item("picSTART").ID)

'Remove the picSTART function from the script

zScript.Remove (MyWorkspace.ActiveDocument.RtFunctions.Item("picSTART").ID)
End If
End Sub


Properties
ObjectModel COM [image] Script [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Readonly | Available | Available
Name | bstr |  | Available | Readonly | Available | Available
Parent | iscripts |  | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] Script [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] Script [image] Properties [image] Name
Remarks

Gets or sets the name of the script.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Script [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IScripts

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Script [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Add | variant_bool | - | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Readonly | Available | Available
DynProperties [PUT] | void | - | Available | Readonly | Available | Available
DynPropertiesEnum [GET] | variant | - | Available | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
Item | irtfunction | - | Available | Available | Available | Available
Remove | variant_bool | - | Available | Readonly | Available | Available


Add
ObjectModel COM [image] Script [image] Methods [image] Add
Remarks

The Method adds a function to the script package by the corresponding function ID.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
nFuncID as long

Example
VBA
Copy
Sub zenOn_ManageScriptFunctions()
Dim zScript As Script
'Initialize the script object with the first script in the scripts object (list)
Set zScript = MyWorkspace.ActiveDocument.Scripts.Item(0)
'Add the picSTART function to the script
zScript.Add (MyWorkspace.ActiveDocument.RtFunctions.Item("picSTART").ID)
'Remove the picSTART function from the script
zScript.Remove (MyWorkspace.ActiveDocument.RtFunctions.Item("picSTART").ID)
End Sub


DynProperties [GET]
ObjectModel COM [image] Script [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties [PUT]
ObjectModel COM [image] Script [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT


DynPropertiesEnum [GET]
ObjectModel COM [image] Script [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynPropertyParam [GET]
ObjectModel COM [image] Script [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Item
ObjectModel COM [image] Script [image] Methods [image] Item
Remarks

Returns the script function at the position vPosition. This method Item only allows accessing with the index. Hint: Check the returned object on Nothing, if no object for the search creteria was found.

Datatype
IRtFunction

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosition as VARIANT


Remove
ObjectModel COM [image] Script [image] Methods [image] Remove
Remarks

The Method removes a function from the script package by the corresponding function ID.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
nFuncID as long

Example
VBA
Copy
Sub zenOn_ManageScriptFunctions()
Dim zScript As Script
'Initialize the script object with the first script in the scripts object (list)
Set zScript = MyWorkspace.ActiveDocument.Scripts.Item(0)
'Add the picSTART function to the script
zScript.Add (MyWorkspace.ActiveDocument.RtFunctions.Item("picSTART").ID)
'Remove the picSTART function from the script
zScript.Remove (MyWorkspace.ActiveDocument.RtFunctions.Item("picSTART").ID)
End Sub


DynProperties
ObjectModel COM [image] Script [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Script


Script
ObjectModel COM [image] Script [image] DynProperties [image] Script
Overview

External Name

Type

Display Name

Description

Name

String

Name

Distinct name of the script. The name must not be empty.Default: Script_x ( x means a successive number).Your own scripts can be defined and pre-completed scripts can be selected. Entry of a name in the combobox for your own scripts or selection from a drop-down list:AUTOSTART : The script will be executed automatically at start of the Runtime (individual workplace or server) and after activation of start display (at individual workplace or server) if the project is the Runtime start project.AUTOEND : The script will be executed automatically at end of the Runtime (individual workplace or server) if the project is the Runtime start project. Attention: VBA macros that should be carried out in "AUTOEND " must be called up via Project.Inactive . Cyclical archives must not be given in the AUTOEND script.AUTOSTART_CLIENT : The script will be executed automatically at start of the Runtime on a client and before activation of start display on a client if the project is the Runtime start project.AUTOEND_CLIENT : The script will be executed automatically at end of the Runtime on a client if the project is the Runtime start project.AUTOSTART_SRVPRJ : The script will be executed automatically at start of the Runtime on the PC which is the server of the project, before activation of the start display if the project is not the Runtime start project.AUTOEND_SRVPRJ : The script will be executed automatically at end of the Runtime on the PC which is the server of the project if the project is not the Runtime start project. Hint multi-user projects: When you change the name of scripts, the parameters of the linked functions are adjusted automatically after a control question for Enable changes . After the name has been changed successfully, the script is changed. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .


Scripts
ObjectModel COM [image] Scripts
Remarks

This object manages scripts.

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub zenOn_ScriptsExample()
'************ Use this script in the editor ************
Dim zScripts As Scripts
Dim i As Integer
'Initialize the scripts object with the current scripts
Set zScripts = MyWorkspace.ActiveDocument.Scripts
'For every script available in the scripts object...
For i = 0 To zScripts.Count - 1

'...output the name

Debug.Print i + 1 & ". Script: " & zScripts.Item(i).Name
Next i

End Sub


Properties
ObjectModel COM [image] Scripts [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | - | Readonly | Readonly | Available | Available
Parent | iproject | - | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] Scripts [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Scripts [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Scripts [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
Create | iscript | - | Available | Unused | Available | Available
Delete | variant_bool | - | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
Item | iscript | - | Available | Available | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index | Available | Unused | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


CheckIn
ObjectModel COM [image] Scripts [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckOut
ObjectModel COM [image] Scripts [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Create
ObjectModel COM [image] Scripts [image] Methods [image] Create
Remarks

Create a new script by name as string parameter

Datatype
IScript

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

Example
VBA
Copy
Sub zenOn_CreateDeleteScript()
Dim zScripts As Scripts
Dim i As Integer
'Initialize the scripts object with the current scripts
Set zScripts = MyWorkspace.ActiveDocument.Scripts
'Create a new script inside the scripts object
zScripts.Create ("zenOn_ScriptTest")
'Delete a script inside the scripts object
zScripts.Delete ("zenOn_ScriptTest")

End Sub


Delete
ObjectModel COM [image] Scripts [image] Methods [image] Delete
Remarks

Delete an existing script by name

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

Example
VBA
Copy
Sub zenOn_CreateDeleteScript()
Dim zScripts As Scripts
Dim i As Integer
'Initialize the scripts object with the current scripts
Set zScripts = MyWorkspace.ActiveDocument.Scripts
'Create a new script inside the scripts object
zScripts.Create ("zenOn_ScriptTest")
'Delete a script inside the scripts object
zScripts.Delete ("zenOn_ScriptTest")

End Sub


DynProperties [GET]
ObjectModel COM [image] Scripts [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] Scripts [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] Scripts [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] Scripts [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Export
ObjectModel COM [image] Scripts [image] Methods [image] Export
Remarks

Export settings to an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR


Get
ObjectModel COM [image] Scripts [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Import
ObjectModel COM [image] Scripts [image] Methods [image] Import
Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR


IsCheckedOut
ObjectModel COM [image] Scripts [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDifferent
ObjectModel COM [image] Scripts [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] Scripts [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Item
ObjectModel COM [image] Scripts [image] Methods [image] Item
Remarks

Returns the corresponding script at the position vPosition. This method Item only allows accessing with the index. Hint: Check the returned object on "Nothing", if no object for the search criteria was found.

Datatype
IScript

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosition as VARIANT


SingleExport
ObjectModel COM [image] Scripts [image] Methods [image] SingleExport
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR


UndoCheckOut
ObjectModel COM [image] Scripts [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


DynProperties
ObjectModel COM [image] Scripts [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Scripts


Scripts
ObjectModel COM [image] Scripts [image] DynProperties [image] Scripts
Overview

External Name

Type

Display Name

Description


SelectionChangedEventParameter
ObjectModel COM [image] SelectionChangedEventParameter
Remarks

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] SelectionChangedEventParameter [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
SelectionKind | tpshiftcalendarselection | Kind of the selection for the changed selection event in a calendar view | Unused | Available | Available | Available
SelectionPicture | idynpicture | Picture for the changed selection event in a calendar view | Unused | Available | Available | Available


SelectionKind
ObjectModel COM [image] SelectionChangedEventParameter [image] Properties [image] SelectionKind
Remarks

Datatype
tpShiftCalendarSelection

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


SelectionPicture
ObjectModel COM [image] SelectionChangedEventParameter [image] Properties [image] SelectionPicture
Remarks

Datatype
IDynPicture

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


SelectionRange
ObjectModel COM [image] SelectionRange
Remarks

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] SelectionRange [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
EndTime | date | The selection end time | Unused | Available | Available | Available
StartTime | date | The selection start time | Unused | Available | Available | Available


EndTime
ObjectModel COM [image] SelectionRange [image] Properties [image] EndTime
Remarks

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


StartTime
ObjectModel COM [image] SelectionRange [image] Properties [image] StartTime
Remarks

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Shift
ObjectModel COM [image] Shift
Remarks

Every shift which is created using the shift management module is stored in the ShiftCalendar as a Shift object. Every shift contains a set of mandatory (name, start time, end time) and optional properties (description, equipment model groups, users, breaks)

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid MacroTraceUpcomingShiftsToCEL()
{
//create a shift filter
    zenOn.IShiftFilter shiftFilter = this.ShiftManagement.Calendar.CreateShiftFilter();

//set the filter to the next 24 hours
    shiftFilter.StartTime = DateTime.Now;
    shiftFilter.EndTime = DateTime.Now.AddDays(1);

//get shift list for filter
    zenOn.IShifts shifts = shiftFilter.GetShifts();

if (shifts != null)
    {
// interate shift list
for (int index = 0; index < shifts.Count; index++)
        {
            zenOn.IShift shift = shifts.GetItem(index);

//create string containing shift information
            String shiftString = "Name:" + shift.Name + " Description:" + shift.Description + " start:" + shift.StartTime.ToString() + " end:" + shift.EndTime.ToString();

//wirte shift into cel
            Cel().WriteCelString(shiftString);
        }
    }
}
VBA
Copy
Public Sub TraceUpcomingShiftsToCEL()
    'create a shift filter
    Dim filter As ShiftFilter
    Set filter = thisProject.ShiftManagement.Calendar.CreateShiftFilter
    'set the filter to the next 24 hours
    filter.StartTime = Now()
    filter.EndTime = Now() + 1
    'get shift list for filter
    Dim shiftList As Shifts
    Set shiftList = filter.GetShifts
    If Not shiftList Is Nothing Then
        'interate shift list
        For i = 0 To shiftList.Count - 1
            Dim currentShift As Shift
            Set currentShift = shiftList.GetItem(i)
            'create string containing shift information
            Dim shiftString As String
            shiftString = "name:" & currentShift.Name & " desc:" & currentShift.Description & " begin:" & CStr(currentShift.StartTime) & " end:" & CStr(currentShift.EndTime)
            'write shift info to CEL
            thisProject.Cel.WriteCelString "shift:" & shiftString
        Next
    End If
End Sub


Properties
ObjectModel COM [image] Shift [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Breaks | ishiftbreaks | Returns the shift breaks object | Unused | Available | Available | Available
Description | bstr | The shift description | Unused | Available | Available | Available
EndTime | date | The shift end time | Unused | Available | Available | Available
Name | bstr | The shift name | Unused | Available | Available | Available
StartTime | date | The shift start time | Unused | Available | Available | Available
SystemModelGroups | bstr | String containing a list of all linked system model groups | Unused | Available | Available | Available
UseHierarchicEquipmentGroups | variant_bool |  | Unused | Available | Available | Available


Breaks
ObjectModel COM [image] Shift [image] Properties [image] Breaks
Remarks

Datatype
IShiftBreaks

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Description
ObjectModel COM [image] Shift [image] Properties [image] Description
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


EndTime
ObjectModel COM [image] Shift [image] Properties [image] EndTime
Remarks

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] Shift [image] Properties [image] Name
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


StartTime
ObjectModel COM [image] Shift [image] Properties [image] StartTime
Remarks

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


SystemModelGroups
ObjectModel COM [image] Shift [image] Properties [image] SystemModelGroups
Remarks

These equipment model groups are used to match the shifts when the GetShifts() Method of IShiftFilter is called. The filter is applied the same way it is for the control in the GUI: A shift is then part of a filter if:The filter has no equipment model group set, orThe shift has no equipment model group set, orThe shift and the filter have at least one equipment model group in common // String containing a list of equipment model group guids. The guids are separated by a ‘;’ characterString SystemModelGroups;

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


UseHierarchicEquipmentGroups
ObjectModel COM [image] Shift [image] Properties [image] UseHierarchicEquipmentGroups
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Shift [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Delete | tpshiftdeleteresult | Delete shift | Unused | Available | Available | Available
Save | tpshiftsaveresult | Save shift | Unused | Available | Available | Available
ShiftUserCollection [GET] | ishiftusercollection | Returns the shift users collection object | Unused | Available | Available | Available


Delete
ObjectModel COM [image] Shift [image] Methods [image] Delete
Remarks

Delete shift

Datatype
tpShiftDeleteResult

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Save
ObjectModel COM [image] Shift [image] Methods [image] Save
Remarks

Save shift

Datatype
tpShiftSaveResult

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid ReportSaveResult(zenOn.tpShiftSaveResult saveResult)
{
switch (saveResult)
    {
case zenOn.tpShiftSaveResult.tpShiftSaveError:
           System.Windows.Forms.MessageBox.Show("ShiftSaveResult: general error!");
break;
case zenOn.tpShiftSaveResult.tpShiftSaveNameError:
           System.Windows.Forms.MessageBox.Show("ShiftSaveResult: invalid name!");
break;
case zenOn.tpShiftSaveResult.tpShiftSaveRangeError:
           System.Windows.Forms.MessageBox.Show("ShiftSaveResult: invalid range!");
break;
case zenOn.tpShiftSaveResult.tpShiftSaveNotFoundError:
           System.Windows.Forms.MessageBox.Show("ShiftSaveResult: shift not found!");
break;
case zenOn.tpShiftSaveResult.tpShiftSaveSuccess:
           System.Windows.Forms.MessageBox.Show("ShiftSaveResult: success!");
break;
    }
}
VBA
Copy
PublicSub testSaveResult(result As tpShiftSaveResult)
SelectCase result
Case tpShiftSaveResult.tpShiftSaveError:
        MsgBox ("ShiftSaveResult: general error!")
Case tpShiftSaveResult.tpShiftSaveNameError:
        MsgBox ("ShiftSaveResult: invalid name!")
Case tpShiftSaveResult.tpShiftSaveRangeError:
        MsgBox ("ShiftSaveResult: invalid range!")
Case tpShiftSaveResult.tpShiftSaveNotFoundError:
        MsgBox ("ShiftSaveResult: shift not found!")
Case tpShiftSaveResult.tpShiftSaveSuccess:
        MsgBox ("ShiftSaveResult: success!")
EndSelect
EndSub


ShiftUserCollection [GET]
ObjectModel COM [image] Shift [image] Methods [image] ShiftUserCollection [GET]
Remarks

Datatype
IShiftUserCollection

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ShiftBreak
ObjectModel COM [image] ShiftBreak
Remarks

Every shift may contain multiple breaks. Every break is defined by its name, start time and end time. Note that multiple breaks may have the same name, but they must not overlap.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub createShift()
    Dim shift As IShift
    Dim saveResult As tpShiftSaveResult
    Set shift = thisProject.ShiftManagement.calendar.createShift()
    shift.Name = "Test"
    shift.StartTime = Now()
    shift.EndTime = Now() + (8 / 24)
    Set Break = shift.Breaks.CreateBreak
    Break.StartTime = shift.StartTime + 3 / 24
    Break.EndTime = Break.StartTime + 5 / 1440
    Break.Name = "@Break@ "
    saveResult = shift.Save
    Set Break = shift.Breaks.GetItem(0)
    Break.Delete
    saveResult = shift.Save
End Sub


Properties
ObjectModel COM [image] ShiftBreak [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
EndTime | date | The shift break end time | Unused | Available | Available | Available
Name | bstr | The shift break name | Unused | Available | Available | Available
StartTime | date | The shift break start time | Unused | Available | Available | Available


EndTime
ObjectModel COM [image] ShiftBreak [image] Properties [image] EndTime
Remarks

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] ShiftBreak [image] Properties [image] Name
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


StartTime
ObjectModel COM [image] ShiftBreak [image] Properties [image] StartTime
Remarks

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ShiftBreak [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Delete | tpshiftbreakdeleteresult | Delete shift break | Unused | Available | Available | Available


Delete
ObjectModel COM [image] ShiftBreak [image] Methods [image] Delete
Remarks

Datatype
tpShiftBreakDeleteResult

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ShiftBreaks
ObjectModel COM [image] ShiftBreaks
Remarks

ShiftBreaks allows to define a set of breaks for a shift. These are stored in ShiftBreaks.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub createShift()
    Dim shift As IShift
    Dim saveResult As tpShiftSaveResult
    Set shift = thisProject.ShiftManagement.calendar.createShift()
    shift.Name = "Test"
    shift.StartTime = Now()
    shift.EndTime = Now() + (8 / 24)
    Set Break = shift.Breaks.CreateBreak
    Break.StartTime = shift.StartTime + 3 / 24
    Break.EndTime = Break.StartTime + 5 / 1440
    Break.Name = "@Break@ "
    saveResult = shift.Save
    Set Break = shift.Breaks.GetItem(0)
    Break.Delete
    saveResult = shift.Save
End Sub


Properties
ObjectModel COM [image] ShiftBreaks [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | The amount of shift breaks | Unused | Available | Available | Available


Count
ObjectModel COM [image] ShiftBreaks [image] Properties [image] Count
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ShiftBreaks [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateBreak | ishiftbreak | Returns a new unsaved shift break object | Unused | Available | Available | Available
GetItem | ishiftbreak | Returns a shift break from the list | Unused | Available | Available | Available


CreateBreak
ObjectModel COM [image] ShiftBreaks [image] Methods [image] CreateBreak
Remarks

Datatype
IShiftBreak

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


GetItem
ObjectModel COM [image] ShiftBreaks [image] Methods [image] GetItem
Remarks

Datatype
IShiftBreak

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lIdx as long


ShiftCalendar
ObjectModel COM [image] ShiftCalendar
Remarks

ShiftCalendar is the container for all shifts of a project. It provides methods to create new shifts and to access existing shifts.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid MacroTraceUpcomingShiftsToCEL()
{
//create a shift filter
    zenOn.IShiftFilter shiftFilter = this.ShiftManagement.Calendar.CreateShiftFilter();

//set the filter to the next 24 hours
    shiftFilter.StartTime = DateTime.Now;
    shiftFilter.EndTime = DateTime.Now.AddDays(1);

//get shift list for filter
    zenOn.IShifts shifts = shiftFilter.GetShifts();

if (shifts != null)
    {
// interate shift list
for (int index = 0; index < shifts.Count; index++)
        {
            zenOn.IShift shift = shifts.GetItem(index);

//create string containing shift information
            String shiftString = "Name:" + shift.Name + " Description:" + shift.Description + " start:" + shift.StartTime.ToString() + " end:" + shift.EndTime.ToString();

//wirte shift into cel
            Cel().WriteCelString(shiftString);
        }
    }
}
VBA
Copy
Public Sub TraceUpcomingShiftsToCEL()
    'create a shift filter
    Dim filter As ShiftFilter
    Set filter = thisProject.ShiftManagement.Calendar.CreateShiftFilter
    'set the filter to the next 24 hours
    filter.StartTime = Now()
    filter.EndTime = Now() + 1
    'get shift list for filter
    Dim shiftList As Shifts
    Set shiftList = filter.GetShifts
    If Not shiftList Is Nothing Then
        'interate shift list
        For i = 0 To shiftList.Count - 1
            Dim currentShift As Shift
            Set currentShift = shiftList.GetItem(i)
            'create string containing shift information
            Dim shiftString As String
            s = "name:" & currentShift.Name & " desc:" & currentShift.Description & " begin:" & CStr(currentShift.StartTime) & " end:" & CStr(currentShift.EndTime)
            'write shift info to CEL
            thisProject.Cel.WriteCelString "shift:" & s
        Next
    End If
End Sub


Methods
ObjectModel COM [image] ShiftCalendar [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateShift | ishift | Returns a new unsaved shift object | Unused | Available | Available | Available
CreateShiftFilter | ishiftfilter | Returns the shift filter object | Unused | Available | Available | Available
CreateShiftModelInsertSettings | ishiftmodelinsertsettings | Returns a new insert settings object | Unused | Available | Available | Available
GetSelectionRange | iselectionrange | Returns the selection time range of a calendar view | Unused | Available | Available | Available
GetSelectionShifts | ishifts | Returns the selected shifts of a calendar view | Unused | Available | Available | Available
InsertShiftModel | ishiftmodelinsertresult | Inserts a shift model accordings to the given settings | Unused | Available | Available | Available


CreateShift
ObjectModel COM [image] ShiftCalendar [image] Methods [image] CreateShift
Remarks

CreateShift creates a new shift object. This object´s properties may then be set as required. Once configured, the object may be stored in the shift calendar.

Datatype
IShift

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_TestShiftCommands()
{
    System.Windows.Forms.MessageBox.Show("Attempt to create a new shift...");
    zenOn.IShift shift = this.ShiftManagement.Calendar.CreateShift();

if (null != shift)
    {
// Save shift: invalid name
                System.Windows.Forms.MessageBox.Show("New shift context: Attempt to save shift with invalid name...");
                zenOn.tpShiftSaveResult saveResult = shift.Save();
                ReportSaveResult(saveResult);

// Save shift: valid name, invalid range
                System.Windows.Forms.MessageBox.Show("New shift context: Attempt to save shift with invalid range...");
                shift.Name = "Shift_01";
                saveResult = shift.Save();
                ReportSaveResult(saveResult);

// Save shift: valid properties
                System.Windows.Forms.MessageBox.Show("New shift context: Attempt to save valid shift...");
                shift.StartTime = DateTime.Now;
                shift.EndTime = DateTime.Now.AddHours(1);
                saveResult = shift.Save();
                ReportSaveResult(saveResult);

// Edit shift: valid name
                System.Windows.Forms.MessageBox.Show("Edit shift context: Attempt to save modified shift name...");
                shift.Name = "Shift_02";
                saveResult = shift.Save();
                ReportSaveResult(saveResult);
// Edit shift: valid range
                System.Windows.Forms.MessageBox.Show("Edit shift context: Attempt to save modified shift range...");
                shift.StartTime = DateTime.Now;
                shift.EndTime = DateTime.Now.AddHours(15);
                saveResult = shift.Save();
                ReportSaveResult(saveResult);

// Edit shift: invalid range
                System.Windows.Forms.MessageBox.Show("Edit shift context: Attempt to save invalid modified shift range...");
                shift.StartTime = DateTime.Now;
                shift.EndTime = DateTime.Now;
                saveResult = shift.Save();
                ReportSaveResult(saveResult);

// Edit shift: invalid name
                System.Windows.Forms.MessageBox.Show("Edit shift context: Attempt to save invalid shift name...");
                shift.Name = "Schift/shift";
                saveResult = shift.Save();
                ReportSaveResult(saveResult);

// Delete shift: exisiting shift
                System.Windows.Forms.MessageBox.Show("Delete shift context: Attempt to delete existing shift...");
                zenOn.tpShiftDeleteResult deleteResult = shift.Delete();
                ReportDeleteResult(deleteResult);

// Delete shift: non-existant shift
                System.Windows.Forms.MessageBox.Show("Delete shift context: Attempt to delete non-existant shift...");
                deleteResult = shift.Delete();
                ReportDeleteResult(deleteResult);

// Edit shift: non-existant shift
                System.Windows.Forms.MessageBox.Show("Edit shift context: Attempt to save non-existant shift...");
                shift.Name = "Shift_01";
                shift.StartTime = DateTime.Now;
                shift.EndTime = DateTime.Now.AddHours(15);
                saveResult = shift.Save();
                ReportSaveResult(saveResult);
    }
else
    {
        System.Windows.Forms.MessageBox.Show("Error: The shift could not be created!");
    }
}
VBA
Copy
PublicSub testShiftComands()
Dim shift As IShift
Dim saveResult As tpShiftSaveResult
Set shift = thisProject.ShiftManagement.Calendar.CreateShift()
MsgBox ("New shift context: Attempt to save shift with invalid name...")
saveResult = shift.Save
testSaveResult (saveResult)
shift.Name = "Shift_01"
MsgBox ("New shift context: Attempt to save shift with invalid range...")
saveResult = shift.Save
testSaveResult (saveResult)
shift.Description = "test"
shift.StartTime = Now()
shift.EndTime = Now() + (1 / 24)
MsgBox ("New shift context: Attempt to save valid shift...")
saveResult = shift.Save
testSaveResult (saveResult)
shift.Name = "Shift_02"
MsgBox ("Edit shift context: Attempt to save modified shift name...")
saveResult = shift.Save
testSaveResult (saveResult)
shift.StartTime = Now()
shift.EndTime = Now() + (15 / 24)
MsgBox ("Edit shift context: Attempt to save modified shift range...")
saveResult = shift.Save
testSaveResult (saveResult)
shift.StartTime = Now()
shift.EndTime = Now()
MsgBox ("Edit shift context: Attempt to save invalid modified shift range...")
saveResult = shift.Save
testSaveResult (saveResult)
shift.Name = "gg/jkl"
MsgBox ("Edit shift context: Attempt to save invalid modified shift name...")
saveResult = shift.Save
testSaveResult (saveResult)
Dim delResult As tpShiftDeleteResult
MsgBox ("Delete shift context: Attempt to delete existing shift...")
delResult = shift.Delete
testDeleteResult (delResult)
MsgBox ("Delete shift context: Attempt to delete non-existant shift...")
delResult = shift.Delete
testDeleteResult (delResult)
shift.Name = "Shift_01"
shift.StartTime = Now()
shift.EndTime = Now() + (15 / 24)
MsgBox ("Edit shift context: Attempt to save non-existant shift...")
saveResult = shift.Save
testSaveResult (saveResult)
EndSub


CreateShiftFilter
ObjectModel COM [image] ShiftCalendar [image] Methods [image] CreateShiftFilter
Remarks

CreateShiftFilter creates a new ShiftFilter object which can be used to read the shifts which are stored in the shift calendar.

Datatype
IShiftFilter

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid MacroTraceUpcomingShiftsToCEL()
{
//create a shift filter
    zenOn.IShiftFilter shiftFilter = this.ShiftManagement.Calendar.CreateShiftFilter();

//set the filter to the next 24 hours
    shiftFilter.StartTime = DateTime.Now;
    shiftFilter.EndTime = DateTime.Now.AddDays(1);

//get shift list for filter
    zenOn.IShifts shifts = shiftFilter.GetShifts();

if (shifts != null)
    {
// interate shift list
for (int index = 0; index < shifts.Count; index++)
        {
            zenOn.IShift shift = shifts.GetItem(index);

//create string containing shift information
            String shiftString = "Name:" + shift.Name + " Description:" + shift.Description + " start:" + shift.StartTime.ToString() + " end:" + shift.EndTime.ToString();

//wirte shift into cel
            Cel().WriteCelString(shiftString);
        }
    }
}
VBA
Copy
Public Sub TraceUpcomingShiftsToCEL()
    'create a shift filter
    Dim filter As ShiftFilter
    Set filter = thisProject.ShiftManagement.Calendar.CreateShiftFilter
    'set the filter to the next 24 hours
    filter.StartTime = Now()
    filter.EndTime = Now() + 1
    'get shift list for filter
    Dim shiftList As Shifts
    Set shiftList = filter.GetShifts
    If Not shiftList Is Nothing Then
        'interate shift list
        For i = 0 To shiftList.Count - 1
            Dim currentShift As Shift
            Set currentShift = shiftList.GetItem(i)
            'create string containing shift information
            Dim shiftString As String
            s = "name:" & currentShift.Name & " desc:" & currentShift.Description & " begin:" & CStr(currentShift.StartTime) & " end:" & CStr(currentShift.EndTime)
            'write shift info to CEL
            thisProject.Cel.WriteCelString "shift:" & s
        Next
    End If
End Sub


CreateShiftModelInsertSettings
ObjectModel COM [image] ShiftCalendar [image] Methods [image] CreateShiftModelInsertSettings
Remarks

In order to insert a shift model in the calendar certain settings need to be defined. These are stored in a ShiftModelInsertSettings object. CreateShiftModelInsertSettings lets you create such an object.

Datatype
IShiftModelInsertSettings

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_InsertShiftModelSample()
{
    zenOn.IShiftCalendar calendar = this.ShiftManagement.Calendar;
    zenOn.IShiftModels models = this.ShiftManagement.Models;
    zenOn.IShiftModel model = models.GetItem(0);
    zenOn.IShiftFilter filter = calendar.CreateShiftFilter();
    zenOn.IShiftModelInsertSettings settings = calendar.CreateShiftModelInsertSettings();
    settings.StartDate = DateTime.Now + TimeSpan.FromDays(1);
    settings.EndDate = DateTime.Now + TimeSpan.FromDays(1);
    settings.ShiftModel = model;
    zenOn.IShiftModelInsertResult result;
    result = calendar.InsertShiftModel(settings);
    String text = "Inserting a shift model was called. \r\nErrorcode: " + result.Error.ToString();
    System.Windows.Forms.MessageBox.Show(text);
}
VBA
Copy
Public Sub InsertShiftModelSample()
Dim calendar As ShiftCalendar
Set calendar = thisProject.ShiftManagement.calendar
Dim models As ShiftModels
Set models = thisProject.ShiftManagement.models
Dim model As ShiftModel
Set model = models.GetItem(0)
Dim settings As ShiftModelInsertSettings
Set settings = calendar.CreateShiftModelInsertSettings()
settings.StartDate = DateAdd("d", 1, Now())
settings.EndDate = DateAdd("d", 1, Now())
settings.ShiftModel = model
Dim result As ShiftModelInsertResult
Set result = calendar.InsertShiftModel(settings)
output = "Inserting a shift model was called." & vbNewLine & "Errorcode: " + CStr(result.Error)
MsgBox output
End Sub


GetSelectionRange
ObjectModel COM [image] ShiftCalendar [image] Methods [image] GetSelectionRange
Remarks

GetSelectionRange returns start time and end time of the selected area in a calendar control in a specific shift management screen. It may be used in combination with the SelectionChanged event.

Datatype
ISelectionRange

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
pIPicture as IDynPicture

Example
VBA
Copy
Public Sub GetSelectedRange()
    Dim calendar As ShiftCalendar
    Set calendar = thisProject.ShiftManagement.calendar
    Dim screen As DynPicture
    Set screen = thisProject.DynPictures.Item("ShiftManagementScreen")
    Dim range As SelectionRange
    Set range = calendar.GetSelectionRange(screen)
    MsgBox "selectedTimeRange " & range.StartTime & " - " & range.EndTime
End Sub


GetSelectionShifts
ObjectModel COM [image] ShiftCalendar [image] Methods [image] GetSelectionShifts
Remarks

GetSelectionShifts returns all shifts which are currentle selected in the calendar control in a specific shift management screen. It may be used in combination with the SelectionChanged event.

Datatype
IShifts

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
pIPicture as IDynPicture

Example
VBA
Copy
Public Sub GetSelectedShifts()
    Dim calendar As ShiftCalendar
    Set calendar = thisProject.ShiftManagement.calendar
    Dim screen As DynPicture
    Set screen = thisProject.DynPictures.Item("ShiftManagementScreen ")
    Dim selectedShifts As shifts
    Set selectedShifts = calendar.GetSelectionShifts(screen)
    If selectedShifts.Count > 0 Then
        Dim message As String
        message = "selected shifts:" & vbNewLine
        For i = 0 To selectedShifts.Count - 1
            Dim currentShift As shift
            Set currentShift = selectedShifts.GetItem(i)
            message = message & "name:" & currentShift.Name & " desc:" & currentShift.Description & " begin:" & CStr(currentShift.StartTime) & " end:" & CStr(currentShift.EndTime) & vbNewLine
         Next i
         MsgBox message
    End If
End Sub


InsertShiftModel
ObjectModel COM [image] ShiftCalendar [image] Methods [image] InsertShiftModel
Remarks

InsertShiftModel inserts all shifts of a specific shift model in the shift calendar at a specific date and time and with specific equipment links.

Datatype
IShiftModelInsertResult

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
pIShiftModelInsertSettings as IShiftModelInsertSettings

Example
C#
Copy
publicvoid Macro_InsertShiftModelSample()
{
    zenOn.IShiftCalendar calendar = this.ShiftManagement.Calendar;
    zenOn.IShiftModels models = this.ShiftManagement.Models;
    zenOn.IShiftModel model = models.GetItem(0);
    zenOn.IShiftFilter filter = calendar.CreateShiftFilter();
    zenOn.IShiftModelInsertSettings settings = calendar.CreateShiftModelInsertSettings();
    settings.StartDate = DateTime.Now + TimeSpan.FromDays(1);
    settings.EndDate = DateTime.Now + TimeSpan.FromDays(1);
    settings.ShiftModel = model;
    zenOn.IShiftModelInsertResult result;
    result = calendar.InsertShiftModel(settings);
    String text = "Inserting a shift model was called. \r\nErrorcode: " + result.Error.ToString();
    System.Windows.Forms.MessageBox.Show(text);
}
VBA
Copy
Public Sub InsertShiftModelSample()
Dim calendar As ShiftCalendar
Set calendar = thisProject.ShiftManagement.calendar
Dim models As ShiftModels
Set models = thisProject.ShiftManagement.models
Dim model As ShiftModel
Set model = models.GetItem(0)
Dim settings As ShiftModelInsertSettings
Set settings = calendar.CreateShiftModelInsertSettings()
settings.StartDate = DateAdd("d", 1, Now())
settings.EndDate = DateAdd("d", 1, Now())
settings.ShiftModel = model
Dim result As ShiftModelInsertResult
Set result = calendar.InsertShiftModel(settings)
output = "Inserting a shift model was called." & vbNewLine & "Errorcode: " + CStr(result.Error)
MsgBox output
End Sub


Events
ObjectModel COM [image] ShiftCalendar [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Created | void | Event about a created shift in the calendar | Unused | Available | Available | Available
Deleted | void | Event about a deleted shift in the calendar | Unused | Available | Available | Available
Modified | void | Event about a modified shift in the calendar | Unused | Available | Available | Available
SelectionChanged | void | Event about the changed selection in a calendar view | Unused | Available | Available | Available


Created
ObjectModel COM [image] ShiftCalendar [image] Events [image] Created
Remarks

Ab sofort ist es möglich, eine Benachrichtigung über das Erstellen, Modifizieren oder Löschen von Schichten im Kalender zu erhalten. Die Events werden nur am Server (oder Standalone) gesendet.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_newShift as IShift

Example
C#
Copy
namespace ProjectAddin
{
    [System.AddIn.AddIn("ThisProject", Version = "1.0", Publisher = "", Description = "")]
publicpartialclass ThisProject
    {
        zenOn.IShiftCalendar myRcv = null;

        #region Addin-Context
        #endregion
        #region General
        #endregion
        #region Project-Context
        ///<summary>
        /// This event handler is executed:
        /// -When the RT was started and the project has been loaded.
        /// -After a Reload has been executed.
        /// USAGE:
        /// Create any API-Objects/Event handler/etc. in this event.
        ///</summary>
void ThisProject_Active()
        {
            myRcv = this.ShiftManagement.Calendar;
            myRcv.Created += new zenOn.CreatedEventHandler(myRcv_Created);
            myRcv.Modified += new zenOn.ModifiedEventHandler(myRcv_Modified);
            myRcv.Deleted += new zenOn.DeletedEventHandler(myRcv_Deleted);
        }

void myRcv_Created(zenOn.IShift pIShift)
        {
            String message = pIShift.Name + " created";
this.Cel().WriteCelString(message);
        }

void myRcv_Modified(zenOn.IShift pIShiftOld, zenOn.IShift pIShiftNew)
        {
            String message = pIShiftOld.Name + " changed to " + pIShiftNew.Name;
this.Cel().WriteCelString(message);
        }

void myRcv_Deleted(zenOn.IShift pIShift)
        {
            String message = pIShift.Name + " deleted";
this.Cel().WriteCelString(message);
        }        ///<summary>
        /// This event handler is executed:
        /// -Shortly before the RT is being terminated.
        /// -Shortly before a reload.
        /// And is a notification that all API-Objects are about to be destroyed.
        /// USAGE:
        /// Make sure that ALL API-Objects are released in this handler,
        /// before the Garbage collection is been triggered.
        ///</summary>
void ThisProject_Inactive()
        {
            myRcv.Created -= myRcv_Created;
            myRcv.Modified -= myRcv_Modified;
            myRcv.Deleted -= myRcv_Deleted;
            myRcv = null;

//Final release and garbage collection of any API-Objects.
            FreeObjects();
        }
      //…
   }
}
VBA
Copy
Private WithEvents MyShiftEv As ShiftCalendar
Private Sub MyShiftEv_Created(ByVal pIShift As IShift)
    thisProject.Cel.WriteCelString (pIShift.Name + " created")
End Sub
Private Sub MyShiftEv_Modified(ByVal pIShiftOld As IShift, ByVal pIShiftNew As IShift)
    thisProject.Cel.WriteCelString (pIShiftOld.Name + " modified to " + pIShiftNew.Name)
End Sub
Private Sub MyShiftEv_Deleted(ByVal pIShift As IShift)
    thisProject.Cel.WriteCelString (pIShift.Name + " deleted")
End Sub


Deleted
ObjectModel COM [image] ShiftCalendar [image] Events [image] Deleted
Remarks

Ab sofort ist es möglich, eine Benachrichtigung über das Erstellen, Modifizieren oder Löschen von Schichten im Kalender zu erhalten. Die Events werden nur am Server (oder Standalone) gesendet.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_deletedShift as IShift

Example
C#
Copy
namespace ProjectAddin
{
    [System.AddIn.AddIn("ThisProject", Version = "1.0", Publisher = "", Description = "")]
publicpartialclass ThisProject
    {
        zenOn.IShiftCalendar myRcv = null;

        #region Addin-Context
        #endregion
        #region General
        #endregion
        #region Project-Context
        ///<summary>
        /// This event handler is executed:
        /// -When the RT was started and the project has been loaded.
        /// -After a Reload has been executed.
        /// USAGE:
        /// Create any API-Objects/Event handler/etc. in this event.
        ///</summary>
void ThisProject_Active()
        {
            myRcv = this.ShiftManagement.Calendar;
            myRcv.Created += new zenOn.CreatedEventHandler(myRcv_Created);
            myRcv.Modified += new zenOn.ModifiedEventHandler(myRcv_Modified);
            myRcv.Deleted += new zenOn.DeletedEventHandler(myRcv_Deleted);
        }

void myRcv_Created(zenOn.IShift pIShift)
        {
            String message = pIShift.Name + " created";
this.Cel().WriteCelString(message);
        }

void myRcv_Modified(zenOn.IShift pIShiftOld, zenOn.IShift pIShiftNew)
        {
            String message = pIShiftOld.Name + " changed to " + pIShiftNew.Name;
this.Cel().WriteCelString(message);
        }

void myRcv_Deleted(zenOn.IShift pIShift)
        {
            String message = pIShift.Name + " deleted";
this.Cel().WriteCelString(message);
        }        ///<summary>
        /// This event handler is executed:
        /// -Shortly before the RT is being terminated.
        /// -Shortly before a reload.
        /// And is a notification that all API-Objects are about to be destroyed.
        /// USAGE:
        /// Make sure that ALL API-Objects are released in this handler,
        /// before the Garbage collection is been triggered.
        ///</summary>
void ThisProject_Inactive()
        {
            myRcv.Created -= myRcv_Created;
            myRcv.Modified -= myRcv_Modified;
            myRcv.Deleted -= myRcv_Deleted;
            myRcv = null;

//Final release and garbage collection of any API-Objects.
            FreeObjects();
        }
      //…
   }
}
VBA
Copy
Private WithEvents MyShiftEv As ShiftCalendar
Private Sub MyShiftEv_Created(ByVal pIShift As IShift)
    thisProject.Cel.WriteCelString (pIShift.Name + " created")
End Sub
Private Sub MyShiftEv_Modified(ByVal pIShiftOld As IShift, ByVal pIShiftNew As IShift)
    thisProject.Cel.WriteCelString (pIShiftOld.Name + " modified to " + pIShiftNew.Name)
End Sub
Private Sub MyShiftEv_Deleted(ByVal pIShift As IShift)
    thisProject.Cel.WriteCelString (pIShift.Name + " deleted")
End Sub


Modified
ObjectModel COM [image] ShiftCalendar [image] Events [image] Modified
Remarks

Ab sofort ist es möglich, eine Benachrichtigung über das Erstellen, Modifizieren oder Löschen von Schichten im Kalender zu erhalten. Die Events werden nur am Server (oder Standalone) gesendet.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_oldShift as IShift

p_newShift as IShift

Example
C#
Copy
namespace ProjectAddin
{
    [System.AddIn.AddIn("ThisProject", Version = "1.0", Publisher = "", Description = "")]
publicpartialclass ThisProject
    {
        zenOn.IShiftCalendar myRcv = null;

        #region Addin-Context
        #endregion
        #region General
        #endregion
        #region Project-Context
        ///<summary>
        /// This event handler is executed:
        /// -When the RT was started and the project has been loaded.
        /// -After a Reload has been executed.
        /// USAGE:
        /// Create any API-Objects/Event handler/etc. in this event.
        ///</summary>
void ThisProject_Active()
        {
            myRcv = this.ShiftManagement.Calendar;
            myRcv.Created += new zenOn.CreatedEventHandler(myRcv_Created);
            myRcv.Modified += new zenOn.ModifiedEventHandler(myRcv_Modified);
            myRcv.Deleted += new zenOn.DeletedEventHandler(myRcv_Deleted);
        }

void myRcv_Created(zenOn.IShift pIShift)
        {
            String message = pIShift.Name + " created";
this.Cel().WriteCelString(message);
        }

void myRcv_Modified(zenOn.IShift pIShiftOld, zenOn.IShift pIShiftNew)
        {
            String message = pIShiftOld.Name + " changed to " + pIShiftNew.Name;
this.Cel().WriteCelString(message);
        }

void myRcv_Deleted(zenOn.IShift pIShift)
        {
            String message = pIShift.Name + " deleted";
this.Cel().WriteCelString(message);
        }        ///<summary>
        /// This event handler is executed:
        /// -Shortly before the RT is being terminated.
        /// -Shortly before a reload.
        /// And is a notification that all API-Objects are about to be destroyed.
        /// USAGE:
        /// Make sure that ALL API-Objects are released in this handler,
        /// before the Garbage collection is been triggered.
        ///</summary>
void ThisProject_Inactive()
        {
            myRcv.Created -= myRcv_Created;
            myRcv.Modified -= myRcv_Modified;
            myRcv.Deleted -= myRcv_Deleted;
            myRcv = null;

//Final release and garbage collection of any API-Objects.
            FreeObjects();
        }
      //…
   }
}
VBA
Copy
Private WithEvents MyShiftEv As ShiftCalendar
Private Sub MyShiftEv_Created(ByVal pIShift As IShift)
    thisProject.Cel.WriteCelString (pIShift.Name + " created")
End Sub
Private Sub MyShiftEv_Modified(ByVal pIShiftOld As IShift, ByVal pIShiftNew As IShift)
    thisProject.Cel.WriteCelString (pIShiftOld.Name + " modified to " + pIShiftNew.Name)
End Sub
Private Sub MyShiftEv_Deleted(ByVal pIShift As IShift)
    thisProject.Cel.WriteCelString (pIShift.Name + " deleted")
End Sub


SelectionChanged
ObjectModel COM [image] ShiftCalendar [image] Events [image] SelectionChanged
Remarks

Ermöglicht eine Benachrichtigung über die Art der Selektionsänderung im Kalender-Control am Projekts VBA-Shiftskalender zu bekommen. Somit wird es mitgeteilt, ob die aktuelle Selektion eine Zeitspanne oder einen Satz der selektierten Schichte bezeichnet. Außerdem ist es möglich, von einem bestimmten Schichtverwaltung-Bild eine Art der aktuellen Selektion (Zeitspanne oder Schichtensatz) zu jeder Zeit zu holen.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
pISelChangedParameter as ISelectionChangedEventParameter

Example
C#
Copy
namespace ProjectAddin
{
    [System.AddIn.AddIn("ThisProject", Version = "1.0", Publisher = "", Description = "")]
publicpartialclass ThisProject
    {
        zenOn.IShiftCalendar myRcv = null;

        #region Addin-Context
        #endregion
        #region General
        #endregion
        #region Project-Context
        ///<summary>
        /// This event handler is executed:
        /// -When the RT was started and the project has been loaded.
        /// -After a Reload has been executed.
        /// USAGE:
        /// Create any API-Objects/Event handler/etc. in this event.
        ///</summary>
void ThisProject_Active()
        {
//Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )
// << TODO: Add Initialization code here >>
            myRcv = this.ShiftManagement.Calendar;
            myRcv.SelectionChanged += new zenOn.DShiftCalendarEvents_SelectionChangedEventHandler(myRcv_SelectionChanged);

        }

void myRcv_SelectionChanged(zenOn.ISelectionChangedEventParameter pISelChangedParameter)
        {
            String message = "The selection has been changed" + ", Source frame: " + pISelChangedParameter.SelectionPicture.Template + ", Source screen: " + pISelChangedParameter.SelectionPicture.Name + ", Selection kind: " + pISelChangedParameter.SelectionKind.ToString();
this.Cel().WriteCelString(message);
        }
        ///<summary>
        /// This event handler is executed:
        /// -Shortly before the RT is being terminated.
        /// -Shortly before a reload.
        /// And is a notification that all API-Objects are about to be destroyed.
        /// USAGE:
        /// Make sure that ALL API-Objects are released in this handler,
        /// before the Garbage collection is been triggered.
        ///</summary>
void ThisProject_Inactive()
        {
//Release all API-References here (Event handlers, OnlineContainers, local references, etc. )
// << TODO: Add Clean-up code here >>
            myRcv.SelectionChanged -= myRcv_SelectionChanged;
            myRcv = null;

//Final release and garbage collection of any API-Objects.
            FreeObjects();
        }
      //…
   }
}

publicvoid Macro_GetCalendarSelectedTimeRange()
{
zenOn.IShiftCalendar cal = this.ShiftManagement.Calendar;
zenOn.IDynPicture pic = this.DynPictures().Item("Shift management");
zenOn.ISelectionRange rng = cal.GetSelectionRange(pic);
System.Windows.Forms.MessageBox.Show("selectedTime Range" + rng.StartTime.ToString() + " – " + rng.EndTime.ToString());
}

publicvoid Macro_GetCalendarSelectedShifts()
        {
            zenOn.IShiftCalendar cal = this.ShiftManagement.Calendar;
            zenOn.IDynPicture pic = this.DynPictures().Item("Shift management");
            zenOn.IShifts shifts = cal.GetSelectionShifts(pic);
            String msg = "SelectedShifts";
for (int i = 0; i < shifts.Count; i++)
            {
                zenOn.IShift shift = shifts.GetItem(i);
                msg += ("\n--------\nName: " + shift.Name + "\nDescription: " + shift.Description + "\nBegin: " + shift.StartTime.ToString() + "\nEnd: " + shift.EndTime.ToString());
            }
            System.Windows.Forms.MessageBox.Show(msg);
        }
VBA
Copy
Private WithEvents MyEv As ShiftCalendar
Private Sub MyEv_SelectionChanged(ByVal pISelChangedParameter As ISelectionChangedEventParameter)
    Dim message As String
    message = "The selection has been changed" & ", Source frame: " & pISelChangedParameter.SelectionPicture.Template & ", Source screen: " & pISelChangedParameter.SelectionPicture.Name & ", Selection kind: " & pISelChangedParameter.SelectionKind
    thisProject.Cel.WriteCelString (message)
End Sub
Private Sub Project_Active()
    Set MyEv = thisProject.ShiftManagement.Calendar
End Sub

Private Sub Project_Inactive()
    Set MyEv = Nothing
End Sub
Public Sub GetSelectedRange()
    Dim calendar As ShiftCalendar
    Set calendar = thisProject.ShiftManagement.calendar
    Dim screen As DynPicture
    Set screen = thisProject.DynPictures.Item("Shift management")
    Dim range As SelectionRange
    Set range = calendar.GetSelectionRange(screen)
    MsgBox "selectedTimeRange " & range.StartTime & " - " & range.EndTime
End Sub
Public Sub GetSelectedEvents()
    Dim calendar As ShiftCalendar
    Set calendar = thisProject.ShiftManagement.calendar
    Dim screen As DynPicture
    Set screen = thisProject.DynPictures.Item("Shift management")
    Dim selectedShifts As Shifts
    Set selectedShifts = calendar.GetSelectionShifts(screen)
    Dim message As String
    message = "selected shifts:" & vbNewLine
    For i = 0 To selectedShifts.count - 1
        Dim currentShift As shift
        Set currentShift = selectedShifts.GetItem(i)
        Dim shiftString As String
        message = message & "name:" & currentShift.Name & " desc:" & currentShift.Description & " begin:" & CStr(currentShift.StartTime) & " end:" & CStr(currentShift.EndTime) & vbNewLine
    Next i
    MsgBox message
End Sub


ShiftFilter
ObjectModel COM [image] ShiftFilter
Remarks

ShiftFilter has to be used to access the shifts in the shift calendar. Filter options may be defined to access the required shifts.NOTE: start time and end time of the filter shall not be equal. Otherwise the result will be empty.If you want to find the currently active shift, set the filter to start=now, end=now+1secNOTE: start time and end time of the filter shall not be equal. Otherwise the result will be empty.If you want to find the currently active shift, set the filter to start=now, end=now+1sec

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid MacroTraceUpcomingShiftsToCEL()
{
//create a shift filter
    zenOn.IShiftFilter shiftFilter = this.ShiftManagement.Calendar.CreateShiftFilter();

//set the filter to the next 24 hours
    shiftFilter.StartTime = DateTime.Now;
    shiftFilter.EndTime = DateTime.Now.AddDays(1);

//get shift list for filter
    zenOn.IShifts shifts = shiftFilter.GetShifts();

if (shifts != null)
    {
// interate shift list
for (int index = 0; index < shifts.Count; index++)
        {
            zenOn.IShift shift = shifts.GetItem(index);

//create string containing shift information
            String shiftString = "Name:" + shift.Name + " Description:" + shift.Description + " start:" + shift.StartTime.ToString() + " end:" + shift.EndTime.ToString();

//wirte shift into cel
            Cel().WriteCelString(shiftString);
        }
    }
}
VBA
Copy
Public Sub TraceUpcomingShiftsToCEL()
    'create a shift filter
    Dim filter As ShiftFilter
    Set filter = thisProject.ShiftManagement.Calendar.CreateShiftFilter
    'set the filter to the next 24 hours
    filter.StartTime = Now()
    filter.EndTime = Now() + 1
    'get shift list for filter
    Dim shiftList As Shifts
    Set shiftList = filter.GetShifts
    If Not shiftList Is Nothing Then
        'interate shift list
        For i = 0 To shiftList.Count - 1
            Dim currentShift As Shift
            Set currentShift = shiftList.GetItem(i)
            'create string containing shift information
            Dim shiftString As String
            shiftString = "name:" & currentShift.Name & " desc:" & currentShift.Description & " begin:" & CStr(currentShift.StartTime) & " end:" & CStr(currentShift.EndTime)
            'write shift info to CEL
            thisProject.Cel.WriteCelString "shift:" & shiftString
        Next
    End If
End Sub


Properties
ObjectModel COM [image] ShiftFilter [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
EndTime | date | The shift filter end time | Unused | Available | Available | Available
StartTime | date | The shift filter start time | Unused | Available | Available | Available
SystemModelGroups | bstr | String containing a list of system model groups for which the shifts should be filtered | Unused | Available | Available | Available


EndTime
ObjectModel COM [image] ShiftFilter [image] Properties [image] EndTime
Remarks

EndTime defines the date and time of the end of the filter time range. Shifts which are partly in the filter time range will be included.NOTE: start time and end time of the filter shall not be equal. Otherwise the result will be empty.If you want to find the currently active shift, set the filter to start=now, end=now+1sec

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


StartTime
ObjectModel COM [image] ShiftFilter [image] Properties [image] StartTime
Remarks

StartTime defines the date and time of the begin of the filter time range. Shifts which are partly in the filter time range will be included.NOTE: start time and end time of the filter shall not be equal. Otherwise the result will be empty.If you want to find the currently active shift, set the filter to start=now, end=now+1sec

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


SystemModelGroups
ObjectModel COM [image] ShiftFilter [image] Properties [image] SystemModelGroups
Remarks

The equipment model groups are used to match the shifts when the GetShifts() Method of IShiftFilter is called. Shift will be included if:The filter has no equipment model group set, orThe shift has no equipment model group set, orThe shift and the filter have at least one equipment model group in common.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ShiftFilter [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
GetShifts | ishifts | Returns the all shifts in the shift calendar that fit the filter configuration | Unused | Available | Available | Available


GetShifts
ObjectModel COM [image] ShiftFilter [image] Methods [image] GetShifts
Remarks

GetShifts reads the shift calendar and applies the filter settings defined by the ShiftFilter. It returns a collection of all matching shifts.

Datatype
IShifts

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid MacroTraceUpcomingShiftsToCEL()
{
//create a shift filter
    zenOn.IShiftFilter shiftFilter = this.ShiftManagement.Calendar.CreateShiftFilter();

//set the filter to the next 24 hours
    shiftFilter.StartTime = DateTime.Now;
    shiftFilter.EndTime = DateTime.Now.AddDays(1);

//get shift list for filter
    zenOn.IShifts shifts = shiftFilter.GetShifts();

if (shifts != null)
    {
// interate shift list
for (int index = 0; index < shifts.Count; index++)
        {
            zenOn.IShift shift = shifts.GetItem(index);

//create string containing shift information
            String shiftString = "Name:" + shift.Name + " Description:" + shift.Description + " start:" + shift.StartTime.ToString() + " end:" + shift.EndTime.ToString();

//wirte shift into cel
            Cel().WriteCelString(shiftString);
        }
    }
}
VBA
Copy
Public Sub TraceUpcomingShiftsToCEL()
    'create a shift filter
    Dim filter As ShiftFilter
    Set filter = thisProject.ShiftManagement.Calendar.CreateShiftFilter
    'set the filter to the next 24 hours
    filter.StartTime = Now()
    filter.EndTime = Now() + 1
    'get shift list for filter
    Dim shiftList As Shifts
    Set shiftList = filter.GetShifts
    If Not shiftList Is Nothing Then
        'interate shift list
        For i = 0 To shiftList.Count - 1
            Dim currentShift As Shift
            Set currentShift = shiftList.GetItem(i)
            'create string containing shift information
            Dim shiftString As String
            shiftString = "name:" & currentShift.Name & " desc:" & currentShift.Description & " begin:" & CStr(currentShift.StartTime) & " end:" & CStr(currentShift.EndTime)
            'write shift info to CEL
            thisProject.Cel.WriteCelString "shift:" & shiftString
        Next
    End If
End Sub


ShiftManagement
ObjectModel COM [image] ShiftManagement
Remarks

ShiftManagement is the central entry point for accessing the shift management module in the zenon Runtime. It can be used to access and manage the shift calendar and to access the shift models.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid MacroTraceUpcomingShiftsToCEL()
{
//create a shift filter
    zenOn.IShiftFilter shiftFilter = this.ShiftManagement.Calendar.CreateShiftFilter();

//set the filter to the next 24 hours
    shiftFilter.StartTime = DateTime.Now;
    shiftFilter.EndTime = DateTime.Now.AddDays(1);

//get shift list for filter
    zenOn.IShifts shifts = shiftFilter.GetShifts();

if (shifts != null)
    {
// interate shift list
for (int index = 0; index < shifts.Count; index++)
        {
            zenOn.IShift shift = shifts.GetItem(index);

//create string containing shift information
            String shiftString = "Name:" + shift.Name + " Description:" + shift.Description + " start:" + shift.StartTime.ToString() + " end:" + shift.EndTime.ToString();

//wirte shift into cel
            Cel().WriteCelString(shiftString);
        }
    }
}
VBA
Copy
Public Sub TraceUpcomingShiftsToCEL()
    'create a shift filter
    Dim filter As ShiftFilter
    Set filter = thisProject.ShiftManagement.Calendar.CreateShiftFilter
    'set the filter to the next 24 hours
    filter.StartTime = Now()
    filter.EndTime = Now() + 1
    'get shift list for filter
    Dim shiftList As Shifts
    Set shiftList = filter.GetShifts
    If Not shiftList Is Nothing Then
        'interate shift list
        For i = 0 To shiftList.Count - 1
            Dim currentShift As Shift
            Set currentShift = shiftList.GetItem(i)
            'create string containing shift information
            Dim shiftString As String
            shiftString = "name:" & currentShift.Name & " desc:" & currentShift.Description & " begin:" & CStr(currentShift.StartTime) & " end:" & CStr(currentShift.EndTime)
            'write shift info to CEL
            thisProject.Cel.WriteCelString "shift:" & shiftString
        Next
    End If
End Sub


Properties
ObjectModel COM [image] ShiftManagement [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Calendar | ishiftcalendar | The shift calendar object | Unused | Available | Available | Available
Models | ishiftmodels | The shift models object | Unused | Available | Available | Available


Calendar
ObjectModel COM [image] ShiftManagement [image] Properties [image] Calendar
Remarks

Calendar is a container for all shifts.

Datatype
IShiftCalendar

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Models
ObjectModel COM [image] ShiftManagement [image] Properties [image] Models
Remarks

Models is a container for shift models.

Datatype
IShiftModels

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ShiftModel
ObjectModel COM [image] ShiftModel
Remarks

A ShiftModel may contain a defined set of shifts. These are, however, not connected to a specific date or equipment. The object model does not provide access to these shifts. However, it allows to read certain properties of shift models and to insert a shift model into the shift calendar using the InsertShiftModel method.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_InsertShiftModelSample()
{
    zenOn.IShiftCalendar calendar = this.ShiftManagement.Calendar;
    zenOn.IShiftModels models = this.ShiftManagement.Models;
    zenOn.IShiftModel model = models.GetItem(0);
    zenOn.IShiftFilter filter = calendar.CreateShiftFilter();
    zenOn.IShiftModelInsertSettings settings = calendar.CreateShiftModelInsertSettings();
    settings.StartDate = DateTime.Now + TimeSpan.FromDays(1);
    settings.EndDate = DateTime.Now + TimeSpan.FromDays(1);
    settings.ShiftModel = model;
    zenOn.IShiftModelInsertResult result;
    result = calendar.InsertShiftModel(settings);
    String text = "Inserting a shift model was called. \r\nErrorcode: " + result.Error.ToString();
    System.Windows.Forms.MessageBox.Show(text);
}
VBA
Copy
Public Sub InsertShiftModelSample()
Dim calendar As ShiftCalendar
Set calendar = thisProject.ShiftManagement.calendar
Dim models As ShiftModels
Set models = thisProject.ShiftManagement.models
Dim model As ShiftModel
Set model = models.GetItem(0)
Dim settings As ShiftModelInsertSettings
Set settings = calendar.CreateShiftModelInsertSettings()
settings.StartDate = DateAdd("d", 1, Now())
settings.EndDate = DateAdd("d", 1, Now())
settings.ShiftModel = model
Dim result As ShiftModelInsertResult
Set result = calendar.InsertShiftModel(settings)
output = "Inserting a shift model was called." & vbNewLine & "Errorcode: " + CStr(result.Error)
MsgBox output
End Sub


Properties
ObjectModel COM [image] ShiftModel [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Description | bstr | The shift model description | Unused | Available | Available | Available
Friday | variant_bool | Flag to make inserting on a Friday possible | Unused | Available | Available | Available
Monday | variant_bool | Flag to make inserting on a Monday possible | Unused | Available | Available | Available
Name | bstr | The shift model name | Unused | Available | Available | Available
Saturday | variant_bool | Flag to make inserting on a Saturday possible | Unused | Available | Available | Available
Sunday | variant_bool | Flag to make inserting on a Sunday possible | Unused | Available | Available | Available
Thursday | variant_bool | Flag to make inserting on a Thursday possible | Unused | Available | Available | Available
Tuesday | variant_bool | Flag to make inserting on a Tuesday possible | Unused | Available | Available | Available
Wednesday | variant_bool | Flag to make inserting on a Wednesday possible | Unused | Available | Available | Available


Description
ObjectModel COM [image] ShiftModel [image] Properties [image] Description
Remarks

The shift model´s description.Read only

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Friday
ObjectModel COM [image] ShiftModel [image] Properties [image] Friday
Remarks

These define whether the shift model can be inserted on either day of the week. When trying to insert the model on a day where the property is FALSE no shifts will be created in the calendar.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Monday
ObjectModel COM [image] ShiftModel [image] Properties [image] Monday
Remarks

These define whether the shift model can be inserted on either day of the week. When trying to insert the model on a day where the property is FALSE no shifts will be created in the calendar.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] ShiftModel [image] Properties [image] Name
Remarks

The shift model´s name.Read only

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Saturday
ObjectModel COM [image] ShiftModel [image] Properties [image] Saturday
Remarks

These define whether the shift model can be inserted on either day of the week. When trying to insert the model on a day where the property is FALSE no shifts will be created in the calendar.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Sunday
ObjectModel COM [image] ShiftModel [image] Properties [image] Sunday
Remarks

These define whether the shift model can be inserted on either day of the week. When trying to insert the model on a day where the property is FALSE no shifts will be created in the calendar.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Thursday
ObjectModel COM [image] ShiftModel [image] Properties [image] Thursday
Remarks

These define whether the shift model can be inserted on either day of the week. When trying to insert the model on a day where the property is FALSE no shifts will be created in the calendar.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Tuesday
ObjectModel COM [image] ShiftModel [image] Properties [image] Tuesday
Remarks

These define whether the shift model can be inserted on either day of the week. When trying to insert the model on a day where the property is FALSE no shifts will be created in the calendar.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Wednesday
ObjectModel COM [image] ShiftModel [image] Properties [image] Wednesday
Remarks

These define whether the shift model can be inserted on either day of the week. When trying to insert the model on a day where the property is FALSE no shifts will be created in the calendar.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ShiftModel [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
IsHolidayEnabled [GET] | variant_bool |  | Unused | Available | Available | Available


IsHolidayEnabled [GET]
ObjectModel COM [image] ShiftModel [image] Methods [image] IsHolidayEnabled [GET]
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ShiftModelInsertResult
ObjectModel COM [image] ShiftModelInsertResult
Remarks

ShiftModelInsertResult provides information about the result (success/error) of the InsertShiftModel.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_InsertShiftModelSample()
{
    zenOn.IShiftCalendar calendar = this.ShiftManagement.Calendar;
    zenOn.IShiftModels models = this.ShiftManagement.Models;
    zenOn.IShiftModel model = models.GetItem(0);
    zenOn.IShiftFilter filter = calendar.CreateShiftFilter();
    zenOn.IShiftModelInsertSettings settings = calendar.CreateShiftModelInsertSettings();
    settings.StartDate = DateTime.Now + TimeSpan.FromDays(1);
    settings.EndDate = DateTime.Now + TimeSpan.FromDays(1);
    settings.ShiftModel = model;
    zenOn.IShiftModelInsertResult result;
    result = calendar.InsertShiftModel(settings);
    String text = "Inserting a shift model was called. \r\nErrorcode: " + result.Error.ToString();
    System.Windows.Forms.MessageBox.Show(text);
}
VBA
Copy
Public Sub InsertShiftModelSample()
Dim calendar As ShiftCalendar
Set calendar = thisProject.ShiftManagement.calendar
Dim models As ShiftModels
Set models = thisProject.ShiftManagement.models
Dim model As ShiftModel
Set model = models.GetItem(0)
Dim settings As ShiftModelInsertSettings
Set settings = calendar.CreateShiftModelInsertSettings()
settings.StartDate = DateAdd("d", 1, Now())
settings.EndDate = DateAdd("d", 1, Now())
settings.ShiftModel = model
Dim result As ShiftModelInsertResult
Set result = calendar.InsertShiftModel(settings)
output = "Inserting a shift model was called." & vbNewLine & "Errorcode: " + CStr(result.Error)
MsgBox output
End Sub


Properties
ObjectModel COM [image] ShiftModelInsertResult [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Error | tpshiftmodelinsertresult | The error information for inserting a shift model | Unused | Available | Available | Available


Error
ObjectModel COM [image] ShiftModelInsertResult [image] Properties [image] Error
Remarks

ShiftModelInsertSettings may be used to define the required settings to insert a shift model into the shift calendar.

Datatype
tpShiftModelInsertResult

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ShiftModelInsertSettings
ObjectModel COM [image] ShiftModelInsertSettings
Remarks

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_InsertShiftModelSample()
{
    zenOn.IShiftCalendar calendar = this.ShiftManagement.Calendar;
    zenOn.IShiftModels models = this.ShiftManagement.Models;
    zenOn.IShiftModel model = models.GetItem(0);
    zenOn.IShiftFilter filter = calendar.CreateShiftFilter();
    zenOn.IShiftModelInsertSettings settings = calendar.CreateShiftModelInsertSettings();
    settings.StartDate = DateTime.Now + TimeSpan.FromDays(1);
    settings.EndDate = DateTime.Now + TimeSpan.FromDays(1);
    settings.ShiftModel = model;
    zenOn.IShiftModelInsertResult result;
    result = calendar.InsertShiftModel(settings);
    String text = "Inserting a shift model was called. \r\nErrorcode: " + result.Error.ToString();
    System.Windows.Forms.MessageBox.Show(text);
}
VBA
Copy
Public Sub InsertShiftModelSample()
Dim calendar As ShiftCalendar
Set calendar = thisProject.ShiftManagement.calendar
Dim models As ShiftModels
Set models = thisProject.ShiftManagement.models
Dim model As ShiftModel
Set model = models.GetItem(0)
Dim settings As ShiftModelInsertSettings
Set settings = calendar.CreateShiftModelInsertSettings()
settings.StartDate = DateAdd("d", 1, Now())
settings.EndDate = DateAdd("d", 1, Now())
settings.ShiftModel = model
Dim result As ShiftModelInsertResult
Set result = calendar.InsertShiftModel(settings)
output = "Inserting a shift model was called." & vbNewLine & "Errorcode: " + CStr(result.Error)
MsgBox output
End Sub


Properties
ObjectModel COM [image] ShiftModelInsertSettings [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
EndDate | date | The shift model insert end time | Unused | Available | Available | Available
ShiftModel | ishiftmodel | The shift model insert shift model template | Unused | Available | Available | Available
StartDate | date | The shift model insert start time | Unused | Available | Available | Available
SystemModelGroups | bstr | The shift model insert equipment model groups | Unused | Available | Available | Available
UseHierarchicEquipmentGroups | variant_bool |  | Unused | Available | Available | Available


EndDate
ObjectModel COM [image] ShiftModelInsertSettings [image] Properties [image] EndDate
Remarks

A shift model may not only be inserted on one single day but on multiple consecutive days. EndDate contains the last day on which the shift model shall be inserted.

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ShiftModel
ObjectModel COM [image] ShiftModelInsertSettings [image] Properties [image] ShiftModel
Remarks

Defines the shift model which shall be inserted when executing ShiftCalendar´s InsertShiftModel method.

Datatype
IShiftModel

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


StartDate
ObjectModel COM [image] ShiftModelInsertSettings [image] Properties [image] StartDate
Remarks

A shift model may not only be inserted on one single day but on multiple consecutive days. StartDate contains the first day on which the shift model shall be inserted.

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


SystemModelGroups
ObjectModel COM [image] ShiftModelInsertSettings [image] Properties [image] SystemModelGroups
Remarks

Defines which equipment model groups will be linked to the shifts which are created when executing ShiftCalendar´s InsertShiftModel method.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


UseHierarchicEquipmentGroups
ObjectModel COM [image] ShiftModelInsertSettings [image] Properties [image] UseHierarchicEquipmentGroups
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


ShiftModels
ObjectModel COM [image] ShiftModels
Remarks

Collection of all existing objects of type ShiftModel.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid Macro_InsertShiftModelSample()
{
    zenOn.IShiftCalendar calendar = this.ShiftManagement.Calendar;
    zenOn.IShiftModels models = this.ShiftManagement.Models;
    zenOn.IShiftModel model = models.GetItem(0);
    zenOn.IShiftFilter filter = calendar.CreateShiftFilter();
    zenOn.IShiftModelInsertSettings settings = calendar.CreateShiftModelInsertSettings();
    settings.StartDate = DateTime.Now + TimeSpan.FromDays(1);
    settings.EndDate = DateTime.Now + TimeSpan.FromDays(1);
    settings.ShiftModel = model;
    zenOn.IShiftModelInsertResult result;
    result = calendar.InsertShiftModel(settings);
    String text = "Inserting a shift model was called. \r\nErrorcode: " + result.Error.ToString();
    System.Windows.Forms.MessageBox.Show(text);
}
VBA
Copy
Public Sub InsertShiftModelSample()
Dim calendar As ShiftCalendar
Set calendar = thisProject.ShiftManagement.calendar
Dim models As ShiftModels
Set models = thisProject.ShiftManagement.models
Dim model As ShiftModel
Set model = models.GetItem(0)
Dim settings As ShiftModelInsertSettings
Set settings = calendar.CreateShiftModelInsertSettings()
settings.StartDate = DateAdd("d", 1, Now())
settings.EndDate = DateAdd("d", 1, Now())
settings.ShiftModel = model
Dim result As ShiftModelInsertResult
Set result = calendar.InsertShiftModel(settings)
output = "Inserting a shift model was called." & vbNewLine & "Errorcode: " + CStr(result.Error)
MsgBox output
End Sub


Properties
ObjectModel COM [image] ShiftModels [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | The amount of shift models | Unused | Available | Available | Available


Count
ObjectModel COM [image] ShiftModels [image] Properties [image] Count
Remarks

Number of shift models which exist in the project.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ShiftModels [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
GetItem | ishiftmodel | Returns a shift model from the list | Unused | Available | Available | Available


GetItem
ObjectModel COM [image] ShiftModels [image] Methods [image] GetItem
Remarks

Allows to select one shift model which is contained in ShiftModels. Note that the items are not sorted.

Datatype
IShiftModel

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lIdx as long

Example
C#
Copy
publicvoid Macro_InsertShiftModelSample()
{
    zenOn.IShiftCalendar calendar = this.ShiftManagement.Calendar;
    zenOn.IShiftModels models = this.ShiftManagement.Models;
    zenOn.IShiftModel model = models.GetItem(0);
    zenOn.IShiftFilter filter = calendar.CreateShiftFilter();
    zenOn.IShiftModelInsertSettings settings = calendar.CreateShiftModelInsertSettings();
    settings.StartDate = DateTime.Now + TimeSpan.FromDays(1);
    settings.EndDate = DateTime.Now + TimeSpan.FromDays(1);
    settings.ShiftModel = model;
    zenOn.IShiftModelInsertResult result;
    result = calendar.InsertShiftModel(settings);
    String text = "Inserting a shift model was called. \r\nErrorcode: " + result.Error.ToString();
    System.Windows.Forms.MessageBox.Show(text);
}
VBA
Copy
Public Sub InsertShiftModelSample()
Dim calendar As ShiftCalendar
Set calendar = thisProject.ShiftManagement.calendar
Dim models As ShiftModels
Set models = thisProject.ShiftManagement.models
Dim model As ShiftModel
Set model = models.GetItem(0)
Dim settings As ShiftModelInsertSettings
Set settings = calendar.CreateShiftModelInsertSettings()
settings.StartDate = DateAdd("d", 1, Now())
settings.EndDate = DateAdd("d", 1, Now())
settings.ShiftModel = model
Dim result As ShiftModelInsertResult
Set result = calendar.InsertShiftModel(settings)
output = "Inserting a shift model was called." & vbNewLine & "Errorcode: " + CStr(result.Error)
MsgBox output
End Sub


Shifts
ObjectModel COM [image] Shifts
Remarks

Shifts is a collection containing shifts, e.g. returned by the ShiftCalendar´s getShifts method.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
C#
Copy
publicvoid MacroTraceUpcomingShiftsToCEL()
{
//create a shift filter
    zenOn.IShiftFilter shiftFilter = this.ShiftManagement.Calendar.CreateShiftFilter();

//set the filter to the next 24 hours
    shiftFilter.StartTime = DateTime.Now;
    shiftFilter.EndTime = DateTime.Now.AddDays(1);

//get shift list for filter
    zenOn.IShifts shifts = shiftFilter.GetShifts();

if (shifts != null)
    {
// interate shift list
for (int index = 0; index < shifts.Count; index++)
        {
            zenOn.IShift shift = shifts.GetItem(index);

//create string containing shift information
            String shiftString = "Name:" + shift.Name + " Description:" + shift.Description + " start:" + shift.StartTime.ToString() + " end:" + shift.EndTime.ToString();

//wirte shift into cel
            Cel().WriteCelString(shiftString);
        }
    }
}
VBA
Copy
Public Sub TraceUpcomingShiftsToCEL()
    'create a shift filter
    Dim filter As ShiftFilter
    Set filter = thisProject.ShiftManagement.Calendar.CreateShiftFilter
    'set the filter to the next 24 hours
    filter.StartTime = Now()
    filter.EndTime = Now() + 1
    'get shift list for filter
    Dim shiftList As Shifts
    Set shiftList = filter.GetShifts
    If Not shiftList Is Nothing Then
        'interate shift list
        For i = 0 To shiftList.Count - 1
            Dim currentShift As Shift
            Set currentShift = shiftList.GetItem(i)
            'create string containing shift information
            Dim shiftString As String
            shiftString = "name:" & currentShift.Name & " desc:" & currentShift.Description & " begin:" & CStr(currentShift.StartTime) & " end:" & CStr(currentShift.EndTime)
            'write shift info to CEL
            thisProject.Cel.WriteCelString "shift:" & shiftString
        Next
    End If
End Sub


Properties
ObjectModel COM [image] Shifts [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | The amount of shifts | Unused | Available | Available | Available


Count
ObjectModel COM [image] Shifts [image] Properties [image] Count
Remarks

Number of shifts which are contained in the Shifts object.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Shifts [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
GetItem | ishift | Returns a shift from the list | Unused | Available | Available | Available


GetItem
ObjectModel COM [image] Shifts [image] Methods [image] GetItem
Remarks

Allows to select one shift which is contained in Shifts. Note: items are not sorted.

Datatype
IShift

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lIdx as long


ShiftUser
ObjectModel COM [image] ShiftUser
Remarks

User which is lined to a shift via the shift´s ShiftUserCollection.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub AddShiftUserToShift()
Dim calendar As ShiftCalendar
Set calendar = thisProject.ShiftManagement.calendar
Dim myshift As shift
Myshift = calendar.createShift
Dim shiftUsers As ShiftUserCollection
Set shiftUsers = Myshift.ShiftUserCollection
Dim newUser As String
newUser = "Jane"
Dim success As Boolean
success = shiftUsers.AddUser(newUser)
myshift.save
For i = 0 To shiftUsers.Count - 1
Set shiftUser = shiftUsers.GetItem(i)
output = output & vbNewLine & shiftUser.Name
Next i
MsgBox output
Dim userToRemove As String
userToRemove = "John"
success = shiftUsers.RemoveUser(userToRemove)
End Sub


Methods
ObjectModel COM [image] ShiftUser [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Name [GET] | bstr | Identification of the shift user | Unused | Readonly | Available | Available


Name [GET]
ObjectModel COM [image] ShiftUser [image] Methods [image] Name [GET]
Remarks

Name of a user which is lined to a shift via the shift´s ShiftUserCollection.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub AddShiftUserToShift()
Dim calendar As ShiftCalendar
Set calendar = thisProject.ShiftManagement.calendar
Dim myshift As shift
Myshift = calendar.createShift
Dim shiftUsers As ShiftUserCollection
Set shiftUsers = Myshift.ShiftUserCollection
Dim newUser As String
newUser = "Jane"
Dim success As Boolean
success = shiftUsers.AddUser(newUser)
myshift.save
For i = 0 To shiftUsers.Count - 1
Set shiftUser = shiftUsers.GetItem(i)
output = output & vbNewLine & shiftUser.Name
Next i
MsgBox output
Dim userToRemove As String
userToRemove = "John"
success = shiftUsers.RemoveUser(userToRemove)
End Sub


ShiftUserCollection
ObjectModel COM [image] ShiftUserCollection
Remarks

Shift Management allows to link users to shifts to indicate which users are available. These users are stored in the Shift´s ShiftUserCollection.

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub AddShiftUserToShift()
Dim calendar As ShiftCalendar
Set calendar = thisProject.ShiftManagement.calendar
Dim myshift As shift
Myshift = calendar.createShift
Dim shiftUsers As ShiftUserCollection
Set shiftUsers = Myshift.ShiftUserCollection
Dim newUser As String
newUser = "Jane"
Dim success As Boolean
success = shiftUsers.AddUser(newUser)
myshift.save
For i = 0 To shiftUsers.Count - 1
Set shiftUser = shiftUsers.GetItem(i)
output = output & vbNewLine & shiftUser.Name
Next i
MsgBox output
Dim userToRemove As String
userToRemove = "John"
success = shiftUsers.RemoveUser(userToRemove)
End Sub


Methods
ObjectModel COM [image] ShiftUserCollection [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AddUser | variant_bool | Adds a shift user to the list of shift users | Unused | Available | Available | Available
Count [GET] | long | The amount of shift users linke to the shift | Unused | Readonly | Available | Available
GetItem | ishiftuser | Returns the shift user | Unused | Available | Available | Available
RemoveUser | variant_bool | Removes a shift user from the list of shift users | Undefined | Undefined | Available | Available


AddUser
ObjectModel COM [image] ShiftUserCollection [image] Methods [image] AddUser
Remarks

Allows to add a user to the collection. The method requires the user´s name as a parameter.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_userName as BSTR

Example
VBA
Copy
Public Sub AddShiftUserToShift()
Dim calendar As ShiftCalendar
Set calendar = thisProject.ShiftManagement.calendar
Dim myshift As shift
Myshift = calendar.createShift
Dim shiftUsers As ShiftUserCollection
Set shiftUsers = Myshift.ShiftUserCollection
Dim newUser As String
newUser = "Jane"
Dim success As Boolean
success = shiftUsers.AddUser(newUser)
myshift.save
For i = 0 To shiftUsers.Count - 1
Set shiftUser = shiftUsers.GetItem(i)
output = output & vbNewLine & shiftUser.Name
Next i
MsgBox output
Dim userToRemove As String
userToRemove = "John"
success = shiftUsers.RemoveUser(userToRemove)
End Sub


Count [GET]
ObjectModel COM [image] ShiftUserCollection [image] Methods [image] Count [GET]
Remarks

Number of linked users in a shift.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


GetItem
ObjectModel COM [image] ShiftUserCollection [image] Methods [image] GetItem
Remarks

Allows to select one user which is contained in ShiftUserCollection. Note that the items are not sorted.

Datatype
IShiftUser

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
p_index as long


RemoveUser
ObjectModel COM [image] ShiftUserCollection [image] Methods [image] RemoveUser
Remarks

Allows to remove a user from the collection. The method requires the user´s name as a parameter.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Undefined
Runtime | Undefined
VBA | Available
VSTA | Available
Parameters
p_userName as BSTR

Example
VBA
Copy
Public Sub AddShiftUserToShift()
Dim calendar As ShiftCalendar
Set calendar = thisProject.ShiftManagement.calendar
Dim myshift As shift
Myshift = calendar.createShift
Dim shiftUsers As ShiftUserCollection
Set shiftUsers = Myshift.ShiftUserCollection
Dim newUser As String
newUser = "Jane"
Dim success As Boolean
success = shiftUsers.AddUser(newUser)
myshift.save
For i = 0 To shiftUsers.Count - 1
Set shiftUser = shiftUsers.GetItem(i)
output = output & vbNewLine & shiftUser.Name
Next i
MsgBox output
Dim userToRemove As String
userToRemove = "John"
success = shiftUsers.RemoveUser(userToRemove)
End Sub


ShowCreateDriverDialogResult
ObjectModel COM [image] ShowCreateDriverDialogResult
Remarks

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ShowCreateDriverDialogResult [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Driver [GET] | idriver |  | Readonly | Unused | Available | Available
Result [GET] | showcreatedriverdialogreturnresult |  | Readonly | Unused | Available | Available


Driver [GET]
ObjectModel COM [image] ShowCreateDriverDialogResult [image] Methods [image] Driver [GET]
Remarks

Datatype
IDriver

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Result [GET]
ObjectModel COM [image] ShowCreateDriverDialogResult [image] Methods [image] Result [GET]
Remarks

Datatype
ShowCreateDriverDialogReturnResult

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


ShowCreateFunctionDialogResult
ObjectModel COM [image] ShowCreateFunctionDialogResult
Remarks

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ShowCreateFunctionDialogResult [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Function [GET] | irtfunction |  | Readonly | Unused | Available | Available
Result [GET] | showcreatefunctiondialogreturnresult |  | Readonly | Unused | Available | Available


Function [GET]
ObjectModel COM [image] ShowCreateFunctionDialogResult [image] Methods [image] Function [GET]
Remarks

Datatype
IRtFunction

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Result [GET]
ObjectModel COM [image] ShowCreateFunctionDialogResult [image] Methods [image] Result [GET]
Remarks

Datatype
ShowCreateFunctionDialogReturnResult

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


ShowCreateScreenDialogResult
ObjectModel COM [image] ShowCreateScreenDialogResult
Remarks

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ShowCreateScreenDialogResult [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Result [GET] | showcreatescreendialogreturnresult |  | Readonly | Unused | Available | Available
Screen [GET] | idynpicture |  | Readonly | Unused | Available | Available


Result [GET]
ObjectModel COM [image] ShowCreateScreenDialogResult [image] Methods [image] Result [GET]
Remarks

Datatype
ShowCreateScreenDialogReturnResult

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Screen [GET]
ObjectModel COM [image] ShowCreateScreenDialogResult [image] Methods [image] Screen [GET]
Remarks

Datatype
IDynPicture

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


ShowCreateVariableDialogResult
ObjectModel COM [image] ShowCreateVariableDialogResult
Remarks

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ShowCreateVariableDialogResult [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Result [GET] | showcreatevariabledialogreturnresult |  | Readonly | Unused | Available | Available
Variable [GET] | ivariable |  | Readonly | Unused | Available | Available


Result [GET]
ObjectModel COM [image] ShowCreateVariableDialogResult [image] Methods [image] Result [GET]
Remarks

Datatype
ShowCreateVariableDialogReturnResult

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Variable [GET]
ObjectModel COM [image] ShowCreateVariableDialogResult [image] Methods [image] Variable [GET]
Remarks

Datatype
IVariable

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


State
ObjectModel COM [image] State
Remarks

States are utilized by Reaction Matrices, in order to define the characteristics.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub zenOn_SetStateForBinaryRema(ByRef zRema As Rema)
'Declaration zState
Dim zState As State
'Intialize zState with the first state inside the passed binary rema
Set zState = zRema.StateItem(1)
'Defines the matching bit combination
zState.ReaWert = &H89 'Sets Bit0, Bit3 and Bit7 TRUE
zState.ReaWertMaske = &H81 'Defines that Bit0 and Bit7 will be checked (Bit3 is ignored)
'User message that will be displayed when the event occurs
zState.Text = "Bit combination is matched!"
'Moreover, the first defined function will be called when the event occurs
zState.Function = MyWorkspace.ActiveDocument.RtFunctions.Item(0)
'The function will only be executed when the tpBitFkt is set. Additionaly the tpBitAlarm flag is set too.
zState.Status = tpBitFkt Or tpBitAlarm

End Sub
Private Sub zenOn_SetStateForAnalogRema(ByRef zRema As rema)
'Declaration zState
Dim zState As State
'Intialize zState with the first state inside the passed analog rema
Set zState = zRema.StateItem(1)
'Sets the comparision mode to "greater"
zState.CheckArt = 1
'This definition constitutes the threshold value, where the alarm will be triggered
zState.ReaAlarm = 11
'This definition means that the system will be set back to its normal configuration, when "ReaAlarm" goes below 10 (hysteresis)
zState.Hysterese = 1
'User message that will be displayed when the event occurs
zState.Text = "Limit is reached!"
'Moreover, the first defined function will be called when the event occurs
zState.Function = MyWorkspace.ActiveDocument.RtFunctions.Item(0)
'The function will only be executed when the tpBitFkt is set. Additionaly the tpBitAlarm flag is set too.
zState.Status = tpBitFkt Or tpBitAlarm

End Sub


Properties
ObjectModel COM [image] State [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
AllValues | long |  | Available | Readonly | Available | Available
char Zaehlerindex | unsigned |  | Available | Readonly | Available | Available
CheckArt | long |  | Available | Readonly | Available | Available
ClassIdx | long |  | Available | Readonly | Available | Available
Color | long |  | Available | Readonly | Available | Available
DelayTime | long |  | Available | Available | Available | Available
Function | long |  | Available | Readonly | Available | Available
GroupIdx | long |  | Available | Readonly | Available | Available
Hysterese | double |  | Available | Available | Available | Available
Parent | irema |  | Readonly | Readonly | Available | Available
ReaAlarm | double |  | Available | Readonly | Available | Available
ReaAlarmBis | double |  | Available | Readonly | Available | Available
ReaStatusExt | long |  | Available | Readonly | Available | Available
ReaStatusFlankeExt | long |  | Available | Readonly | Available | Available
ReaStatusFlankeStd | long |  | Available | Readonly | Available | Available
ReaStatusMaskeExt | long |  | Available | Readonly | Available | Available
ReaStatusMaskeStd | long |  | Available | Readonly | Available | Available
ReaStatusStd | long |  | Available | Readonly | Available | Available
ReaWert | long |  | Available | Readonly | Available | Available
ReaWertFlanke | long |  | Available | Readonly | Available | Available
ReaWertMaske | long |  | Available | Readonly | Available | Available
Status | tpstatebit |  | Available | Available | Available | Available
Text | bstr |  | Available | Readonly | Available | Available
TreatAllValueChangesAsNewLimitViolation | variant_bool |  | Available | Readonly | Available | Available


AllValues
ObjectModel COM [image] State [image] Properties [image] AllValues
Remarks

This Represents the checkbox 'Treat each change of value as new limit violation'

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


char Zaehlerindex
ObjectModel COM [image] State [image] Properties [image] char Zaehlerindex
Remarks

Datatype
unsigned

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


CheckArt
ObjectModel COM [image] State [image] Properties [image] CheckArt
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ClassIdx
ObjectModel COM [image] State [image] Properties [image] ClassIdx
Remarks

Gets or sets the class index.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Color
ObjectModel COM [image] State [image] Properties [image] Color
Remarks

Gets or sets the color.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


DelayTime
ObjectModel COM [image] State [image] Properties [image] DelayTime
Remarks

HIDDEN

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Function
ObjectModel COM [image] State [image] Properties [image] Function
Remarks

Assigns a function which will be called, when the Reaction Matrix matches.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


GroupIdx
ObjectModel COM [image] State [image] Properties [image] GroupIdx
Remarks

Gets or sets the group index

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Hysterese
ObjectModel COM [image] State [image] Properties [image] Hysterese
Remarks

Gets or sets the value when the system will be set back to the normal configuration. (Systems leaves triggered state)

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] State [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IRema

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ReaAlarm
ObjectModel COM [image] State [image] Properties [image] ReaAlarm
Remarks

Gets or sets the limit value. Hint: The comparision method is selected with the "CheckArt" property. This value constitutes the lower limit of the area, if "CheckArt" option 4 (Area) is selected.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ReaAlarmBis
ObjectModel COM [image] State [image] Properties [image] ReaAlarmBis
Remarks

This value constitutes the upper limit of the area, if "CheckArt" option 4 (Area) is selected. The lower limit is the "ReaAlarm" property.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ReaStatusExt
ObjectModel COM [image] State [image] Properties [image] ReaStatusExt
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ReaStatusFlankeExt
ObjectModel COM [image] State [image] Properties [image] ReaStatusFlankeExt
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ReaStatusFlankeStd
ObjectModel COM [image] State [image] Properties [image] ReaStatusFlankeStd
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ReaStatusMaskeExt
ObjectModel COM [image] State [image] Properties [image] ReaStatusMaskeExt
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ReaStatusMaskeStd
ObjectModel COM [image] State [image] Properties [image] ReaStatusMaskeStd
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ReaStatusStd
ObjectModel COM [image] State [image] Properties [image] ReaStatusStd
Remarks

The ReaStatusStd DWORD specifiecs which state bits are set.
e.g. ReaStatusStd = &H40000 (Hex-Value) means that the I-BIT is set TRUE.
Hint: Depending on the ReaStatusMaskeStd the bits will be checked or ignored.

In order to use state driven trigger (no triggering on edges) for the MultiBinary Rema, the ReaStatusFlankeStd has to be set to &h0.

To set more than one state bit, ORing (logical OR) have to be applied.
e.g. ReaStatusStd = &H100 Or &H4 'SELEC + ST_M3 are set TRUEThe following table gives an overview of common state bits.

Name | Description | Bit Number | Hex Value
ST_M1 | User status bit 1 | 0 | 0x00000001
ST_M2 | available | 1 | 0x00000002
ST_M3 | read only | 2 | 0x00000004
ST_M4 | yes | 3 | 0x00000008
ST_M5 | yes | 4 | 0x00000010
ST_M6 | User status bit 6 | 5 | 0x00000020
ST_M7 | User status bit 7 | 6 | 0x00000040
ST_M8 | User status bit 8 | 7 | 0x00000080
SELEC | Select bit | 8 | 0x00000100
REV | Revision bit | 9 | 0x00000200
DIREC | Desired direction bit | 10 | 0x00000400
RTE | Runtime exceeded bit | 11 | 0x00000800
I-BIT | Invalid bit | 18 | 0x00040000
N_UPDATE | Switched off bit | 20 | 0x00800000
DM_TR | Default message trafo value bit | 24 | 0x01000000
RM_TR | Run message trafo value bit | 25 | 0x02000000
AVALUE | Alternative value bit | 27 | 0x08000000

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ReaWert
ObjectModel COM [image] State [image] Properties [image] ReaWert
Remarks

The ReaWert DWORD specifies which bit combination (value) should be matched by the binary Reaction Matrices. Hint: Depending on the ReaWertMaske the bits of the DWORD will be checked or ignored.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ReaWertFlanke
ObjectModel COM [image] State [image] Properties [image] ReaWertFlanke
Remarks

Specifies, if the bit combination of the "ReaWert" used by a MultiBinary Rema trigger on edges.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ReaWertMaske
ObjectModel COM [image] State [image] Properties [image] ReaWertMaske
Remarks

Has to be set properly, if the bit combination in the ReaWert DWORD should be adhered. Otherwise it will be ingored.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Status
ObjectModel COM [image] State [image] Properties [image] Status
Remarks

Datatype
tpStateBit

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Text
ObjectModel COM [image] State [image] Properties [image] Text
Remarks

Gets or sets the text that will be displayed, if the defined limit is reached.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


TreatAllValueChangesAsNewLimitViolation
ObjectModel COM [image] State [image] Properties [image] TreatAllValueChangesAsNewLimitViolation
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] State [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateSubState | istate | - | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
GetSubStateCount | long | - | Readonly | Readonly | Available | Available
Move | variant_bool |  | Available | Unused | Available | Available
MoveSubState | bool | - | Available | Unused | Available | Available
SubStateItem | istate | - | Available | Available | Available | Available


CreateSubState
ObjectModel COM [image] State [image] Methods [image] CreateSubState
Remarks

Creates a new substate.

Datatype
IState

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub zenOn_CreateSubStateExample(ByRef zState As State)
Dim zSubState As State
'Initialize the zSubState by creating a new substate
Set zSubState = zState.CreateSubState
'e.g. change the color of the substate
zSubState.Color = RGB(0, 128, 128)

End Sub


DynProperties [GET]
ObjectModel COM [image] State [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] State [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] State [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] State [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


GetSubStateCount
ObjectModel COM [image] State [image] Methods [image] GetSubStateCount
Remarks

Get the amount of substates.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Move
ObjectModel COM [image] State [image] Methods [image] Move
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
p_index as long

p_moveUp as VARIANT_BOOL


MoveSubState
ObjectModel COM [image] State [image] Methods [image] MoveSubState
Remarks

Moves the substate within the state one position up- or downwards.<ul style="list-style-type:none;"><li>-1 &amp;rarr; upward</li><li>1 &amp;rarr; downward</li></ul>

Datatype
BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vID as VARIANT

bDirection as BOOL

Example
VBA
Copy
Sub zenOn_MoveSubStateExample()
Dim zRema As Rema
Dim zState As State
Dim i As Integer
Set zRema = MyWorkspace.ActiveDocument.Remas.Item(0)
Set zState = zRema.StateItem(1)
zState.MoveSubState 2, 0
For i = 0 To zState.GetSubStateCount - 1

Debug.Print zState.SubStateItem(i).Color
Next i

End Sub


SubStateItem
ObjectModel COM [image] State [image] Methods [image] SubStateItem
Remarks

Returns a state object, containing the selected substate of the current state.

Datatype
IState

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vID as VARIANT

Example
VBA
Copy
Sub zenOn_SubStateExample(ByRef zState As State)
Dim zSubState As State
'Initialize the zSubState with the first substate of zState
Set zSubState = zState.SubStateItem(1)
'e.g. change the color of the substate
zSubState.Color = RGB(0, 128, 128)

End Sub


StyleItem
ObjectModel COM [image] StyleItem
Remarks

A StyleItem can either be a style group or a style. A style group can contain an unlimited number of styles, but nesting a group within a group is not supported.The style can e.g. be a fill style, text style, … which can be managed in general and the style specific properties like e.g. fill color can be accessed by DynProperties.

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
‘ Prerequisites: A stylegroup with substyles in the active project
Sub TestStylesValuesSet()
    Set Manager = MyWorkspace.ActiveDocument.StyleManager
    Dim Group0 As StyleItem
    Set Group0 = Manager.Item(0)
    Dim Props() As String
    Props = Group0.DynPropertiesEnum("")
    For n = 0 To Group0.Count - 1
        Dim Item As StyleItem
        Set Item = Group0.Item(n)
        Props = Item.DynPropertiesEnum("")
        Debug.Print ">************ " & Item.DynProperties("StyleItemName") & " *************"
        For p = LBound(Props) To UBound(Props)
            Debug.Print Props(p)
        Next p
        Debug.Print "<************ " & Item.Name & " *************" & vbCrLf
        Item.DynProperties("StyleItemDescription") = "visited by me"
        Item.Name = "NewName"
    Next n
End Sub
‘ prerequisite:
‘     first screen has two elements
‘     first element has a style group set
Sub StyleDynPropItem()
    Dim pic As DynPicture
Set pic = MyWorkspace.ActiveDocument.DynPictures.Item(0)
    Dim elem(1) As Element
    Set elem(0) = pic.Elements.Item(0)
Set elem(1) = pic.Elements.Item(1)
    Dim Style As StyleItem
Set Style = elem(0).DynProperties("StyleGroup")
    elem(1).DynProperties("StyleGroup") = Style ‘ sets the style group
elem(0).DynProperties("StyleGroup") = Nothing ‘ sets the prop to "no style linked"
pic.Save
End Sub


Properties
ObjectModel COM [image] StyleItem [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Category | bstr | Returns the category of the item. | Available | Unused | Available | Available
Count | long |  | Readonly | Unused | Available | Available
Description | bstr |  | Available | Unused | Available | Available
ExternalReference | bstr | Returns the external reference of the item. | Available | Unused | Available | Available
Guid | bstr |  | Readonly | Unused | Available | Available
Name | bstr |  | Available | Unused | Available | Available
ParentItem | istyleitem |  | Readonly | Unused | Available | Available
Type | tpstyletype |  | Readonly | Unused | Available | Available


Category
ObjectModel COM [image] StyleItem [image] Properties [image] Category
Remarks

Freely definable text, which can be used for grouping styles.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Count
ObjectModel COM [image] StyleItem [image] Properties [image] Count
Remarks

The Count property returns the amount of "SubItems" of the object. This means: The amount of Styles if the object is a StyleGroup, or the amount of style properties in case of a Style object.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Description
ObjectModel COM [image] StyleItem [image] Properties [image] Description
Remarks

The Description property will return the defined description of the object.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


ExternalReference
ObjectModel COM [image] StyleItem [image] Properties [image] ExternalReference
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Guid
ObjectModel COM [image] StyleItem [image] Properties [image] Guid
Remarks

The Guid property will return the unique Guid of this object.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] StyleItem [image] Properties [image] Name
Remarks

The Name property will return the Name of the object.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


ParentItem
ObjectModel COM [image] StyleItem [image] Properties [image] ParentItem
Remarks

The ParentItem property will return null/nothing for StyleGroups (StyleGroups currently cannot be nested). When the item is a Style the property will return the StyleGroup in which the Style resides.

Datatype
IStyleItem

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] StyleItem [image] Properties [image] Type
Remarks

Using the Type property the type of the StyleItem can be determined. As explained before the StyleItem can be either a StyleGroup or a Style from a specific type. Therefore a new enum tpStyleType has been added to the API.

Datatype
tpStyleType

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] StyleItem [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant |  | Readonly | Unused | Available | Available
DynProperties [PUT] | void |  | Readonly | Unused | Available | Available
DynPropertiesEnum [GET] | variant |  | Readonly | Unused | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
Item | istyleitem |  | Readonly | Unused | Available | Available


DynProperties [GET]
ObjectModel COM [image] StyleItem [image] Methods [image] DynProperties [GET]
Remarks

The StyleItem api-Methodes DynPropertyParam, DynPropertiesEnum and DynProperties are working now and can be used as for other zenon API objects. The fortune of dyn-properties in case of styles is that every different StyleItem type (filling, line, text, …) has a different set of dyn-properties which can be read out by the DynPropertiesEnum methode.The properties StyleItem.Name and StyleItem.Description can be set now.After each setting of a value (dyn- or api-properties) the corresponding style-group gets saved automatically, a changelog is generated and the UI updates.The DynProperty Get and Set functions do now return and accept StyleItem API objects.A style-link is accepted during the Set if…… the StyleItem is valid (not a dangling reference referring to an already deleted style)… the StyleItem is located in the same project (where the e.g. screen belongs) or in the global project

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
‘ Prerequisites: A stylegroup with substyles in the active project
Sub TestStylesValuesSet()
    Set Manager = MyWorkspace.ActiveDocument.StyleManager
    Dim Group0 As StyleItem
    Set Group0 = Manager.Item(0)
    Dim Props() As String
    Props = Group0.DynPropertiesEnum("")
    For n = 0 To Group0.Count - 1
        Dim Item As StyleItem
        Set Item = Group0.Item(n)
        Props = Item.DynPropertiesEnum("")
        Debug.Print ">************ " & Item.DynProperties("StyleItemName") & " *************"
        For p = LBound(Props) To UBound(Props)
            Debug.Print Props(p)
        Next p
        Debug.Print "<************ " & Item.Name & " *************" & vbCrLf
        Item.DynProperties("StyleItemDescription") = "visited by me"
        Item.Name = "NewName"
    Next n
End Sub
‘ prerequisite:
‘     first screen has two elements
‘     first element has a style group set
Sub StyleDynPropItem()
    Dim pic As DynPicture
Set pic = MyWorkspace.ActiveDocument.DynPictures.Item(0)
    Dim elem(1) As Element
    Set elem(0) = pic.Elements.Item(0)
Set elem(1) = pic.Elements.Item(1)
    Dim Style As StyleItem
Set Style = elem(0).DynProperties("StyleGroup")
    elem(1).DynProperties("StyleGroup") = Style ‘ sets the style group
elem(0).DynProperties("StyleGroup") = Nothing ‘ sets the prop to "no style linked"
pic.Save
End Sub


DynProperties [PUT]
ObjectModel COM [image] StyleItem [image] Methods [image] DynProperties [PUT]
Remarks

The StyleItem api-Methodes DynPropertyParam, DynPropertiesEnum and DynProperties are working now and can be used as for other zenon API objects. The fortune of dyn-properties in case of styles is that every different StyleItem type (filling, line, text, …) has a different set of dyn-properties which can be read out by the DynPropertiesEnum methode.The properties StyleItem.Name and StyleItem.Description can be set now.After each setting of a value (dyn- or api-properties) the corresponding style-group gets saved automatically, a changelog is generated and the UI updates.The DynProperty Get and Set functions do now return and accept StyleItem API objects.A style-link is accepted during the Set if…… the StyleItem is valid (not a dangling reference referring to an already deleted style)… the StyleItem is located in the same project (where the e.g. screen belongs) or in the global project

Datatype
void

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
‘ Prerequisites: A stylegroup with substyles in the active project
Sub TestStylesValuesSet()
    Set Manager = MyWorkspace.ActiveDocument.StyleManager
    Dim Group0 As StyleItem
    Set Group0 = Manager.Item(0)
    Dim Props() As String
    Props = Group0.DynPropertiesEnum("")
    For n = 0 To Group0.Count - 1
        Dim Item As StyleItem
        Set Item = Group0.Item(n)
        Props = Item.DynPropertiesEnum("")
        Debug.Print ">************ " & Item.DynProperties("StyleItemName") & " *************"
        For p = LBound(Props) To UBound(Props)
            Debug.Print Props(p)
        Next p
        Debug.Print "<************ " & Item.Name & " *************" & vbCrLf
        Item.DynProperties("StyleItemDescription") = "visited by me"
        Item.Name = "NewName"
    Next n
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] StyleItem [image] Methods [image] DynPropertiesEnum [GET]
Remarks

The StyleItem api-Methodes DynPropertyParam, DynPropertiesEnum and DynProperties are working now and can be used as for other zenon API objects. The fortune of dyn-properties in case of styles is that every different StyleItem type (filling, line, text, …) has a different set of dyn-properties which can be read out by the DynPropertiesEnum methode.The properties StyleItem.Name and StyleItem.Description can be set now.After each setting of a value (dyn- or api-properties) the corresponding style-group gets saved automatically, a changelog is generated and the UI updates.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
‘ Prerequisites: A stylegroup with substyles in the active project
Sub TestStylesValuesSet()
    Set Manager = MyWorkspace.ActiveDocument.StyleManager
    Dim Group0 As StyleItem
    Set Group0 = Manager.Item(0)
    Dim Props() As String
    Props = Group0.DynPropertiesEnum("")
    For n = 0 To Group0.Count - 1
        Dim Item As StyleItem
        Set Item = Group0.Item(n)
        Props = Item.DynPropertiesEnum("")
        Debug.Print ">************ " & Item.DynProperties("StyleItemName") & " *************"
        For p = LBound(Props) To UBound(Props)
            Debug.Print Props(p)
        Next p
        Debug.Print "<************ " & Item.Name & " *************" & vbCrLf
        Item.DynProperties("StyleItemDescription") = "visited by me"
        Item.Name = "NewName"
    Next n
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] StyleItem [image] Methods [image] DynPropertyParam [GET]
Remarks

The StyleItem api-Methodes DynPropertyParam, DynPropertiesEnum and DynProperties are working now and can be used as for other zenon API objects. The fortune of dyn-properties in case of styles is that every different StyleItem type (filling, line, text, …) has a different set of dyn-properties which can be read out by the DynPropertiesEnum methode.The properties StyleItem.Name and StyleItem.Description can be set now.After each setting of a value (dyn- or api-properties) the corresponding style-group gets saved automatically, a changelog is generated and the UI updates.

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
‘ Prerequisites: A stylegroup with substyles in the active project
Sub TestStylesValuesSet()
    Set Manager = MyWorkspace.ActiveDocument.StyleManager
    Dim Group0 As StyleItem
    Set Group0 = Manager.Item(0)
    Dim Props() As String
    Props = Group0.DynPropertiesEnum("")
    For n = 0 To Group0.Count - 1
        Dim Item As StyleItem
        Set Item = Group0.Item(n)
        Props = Item.DynPropertiesEnum("")
        Debug.Print ">************ " & Item.DynProperties("StyleItemName") & " *************"
        For p = LBound(Props) To UBound(Props)
            Debug.Print Props(p)
        Next p
        Debug.Print "<************ " & Item.Name & " *************" & vbCrLf
        Item.DynProperties("StyleItemDescription") = "visited by me"
        Item.Name = "NewName"
    Next n
End Sub


Item
ObjectModel COM [image] StyleItem [image] Methods [image] Item
Remarks

The Item method of the StyleItem object can be used to access the subitems of the object. Note that this method only returns objects for StyleItems which represent a StyleGroup. Even though StyleItems representing a Style will return their amount of properties when using Count they will not return SubItems when using the Item method. The Item method can be used with either a name (representing the name of a style) or an index. If a StyleItem on the given index (or carrying the given name) exists, a StyleItem object will be returned.

Datatype
IStyleItem

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vPosOrName as VARIANT


StyleManager
ObjectModel COM [image] StyleManager
Remarks

The StyleManager is the central entry point for accessing the styles module in the zenon Editor. It can be used to access and manage StyleItems and to perform functions for distributed engineering. Furthermore it provides a method for extracting all available styles from a zenon screen element.

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub CreateStyleGroup()
    Dim Manager As StyleManager
    Set Manager = MyWorkspace.ActiveDocument.StyleManager
    Dim Group0 As StyleItem
    Set Group0 = Manager.CreateGroup("API_MyGroup")
    // you can do smth with the Group0 if u want
    Dim API_Style As StyleItem
    Set API_Style = Manager.Create("Fill_API", Group0, tpStyleType.tpStyleTypeFill)
    // you can do smth with the API_Style if u want
   Set API_Style = Manager.Create("RoundCorner_API2", Group0, tpStyleType.tpStyleTypeRoundCorner)
End Sub
Sub AddLineStyle()
    Dim Manager As StyleManager
    Set Manager = MyWorkspace.ActiveDocument.StyleManager
    Dim Group0 As StyleItem
    Set Group0 = Manager.Item("API_MyGroup")
    Dim API_Style As StyleItem
    Set API_Style = Manager.Create("Line_API", Group0, tpStyleType.tpStyleTypeLine)
    Set API_Style = Manager.Create("Line2_API", Group0, tpStyleType.tpStyleTypeLine)
End Sub


Properties
ObjectModel COM [image] StyleManager [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Unused | Available | Available
Parent | iproject |  | Readonly | Unused | Available | Available


Count
ObjectModel COM [image] StyleManager [image] Properties [image] Count
Remarks

The Count property returns the amount of "root" items (currently only StyleGroups) which are available in the StyleManager.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] StyleManager [image] Properties [image] Parent
Remarks

By use of the Parent property, the project to which the manager belongs can be determined.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] StyleManager [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckIn | variant_bool |  | Readonly | Unused | Available | Available
CheckOut | variant_bool |  | Readonly | Unused | Available | Available
Create | istyleitem |  | Available | Unused | Available | Available
CreateGroup | istyleitem |  | Available | Unused | Available | Available
Delete | variant_bool | Returns true, if the item was successfully deleted. | Readonly | Unused | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
ExtractStyleGroupFromElement | istyleitem | Returns a new style group from the given element | Readonly | Unused | Available | Available
Get | variant_bool |  | Readonly | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
IsCheckedOut | variant_bool |  | Readonly | Unused | Available | Available
IsDifferent | variant_bool |  | Readonly | Unused | Available | Available
IsLocked | variant_bool |  | Readonly | Unused | Available | Available
Item | istyleitem |  | Readonly | Unused | Available | Available
UndoCheckOut | variant_bool |  | Readonly | Unused | Available | Available


CheckIn
ObjectModel COM [image] StyleManager [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


CheckOut
ObjectModel COM [image] StyleManager [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Example
C#
Copy
/* In case of a multiuser project you need to checkout your StyleManager object
* before editing it and you have to check it in again as soon as you're done.
* To do soyou can use the provided methods CheckIn and CheckOut of the StyleManager
* object.*/

public void MacroStyleManager()
{
IStyleManager  zenonStyleManager  = this.ActiveDocument.StyleManager();
if (!zenonStyleManager.CheckOut())
{
//Some error occured, the user will be informed
this.Parent.DebugPrint("Error while checking out styles",
tpDebugPrintStyle.tpErr);
}
//Do something with the styles in the collection object
//Code...
zenonStyleManager.CheckIn();
}
VBA
Copy
' In case of a multiuser project you need to checkout your StyleManager object
' * before editing it and you have to check it in again as soon as you're done.
' * To do soyou can use the provided methods CheckIn and CheckOut of the StyleManager
' * object.
'
Public Sub MacroStyleManager()
Dim zenonStyleManager As IStyleManager = Me.ActiveDocument.StyleManager()
If Not zenonStyleManager.CheckOut() Then
'Some error occured, the user will be informed
Me.Parent.DebugPrint("Error while checking out styles", tpDebugPrintStyle.tpErr)
End If
'Do something with the stylesin the collection object
'Code...
zenonArchives.CheckIn()
End Sub


Create
ObjectModel COM [image] StyleManager [image] Methods [image] Create
Remarks

Only in style items of type "tpStyleTyle.Group" new subitems can be created.In style items of type "tpStyleTyle.Group" no new subitems of type "tpStyleTyle.Group" can be created.In multiuser projects a creation is not possible if the “Styles” were not checked out previously.

Datatype
IStyleItem

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
Name as BSTR

Parent as IStyleItem

Type as tpStyleType

Example
VBA
Copy
Sub CreateStyleGroup()
    Dim Manager As StyleManager
    Set Manager = MyWorkspace.ActiveDocument.StyleManager
    Dim Group0 As StyleItem
    Set Group0 = Manager.CreateGroup("API_MyGroup")
    // you can do smth with the Group0 if u want
    Dim API_Style As StyleItem
    Set API_Style = Manager.Create("Fill_API", Group0, tpStyleType.tpStyleTypeFill)
    // you can do smth with the API_Style if u want
   Set API_Style = Manager.Create("RoundCorner_API2", Group0, tpStyleType.tpStyleTypeRoundCorner)
End Sub
Sub AddLineStyle()
    Dim Manager As StyleManager
    Set Manager = MyWorkspace.ActiveDocument.StyleManager
    Dim Group0 As StyleItem
    Set Group0 = Manager.Item("API_MyGroup")
    Dim API_Style As StyleItem
    Set API_Style = Manager.Create("Line_API", Group0, tpStyleType.tpStyleTypeLine)
    Set API_Style = Manager.Create("Line2_API", Group0, tpStyleType.tpStyleTypeLine)
End Sub


CreateGroup
ObjectModel COM [image] StyleManager [image] Methods [image] CreateGroup
Remarks

Only in style items of type "tpStyleTyle.Group" new subitems can be created.In style items of type "tpStyleTyle.Group" no new subitems of type "tpStyleTyle.Group" can be created.In multiuser projects a creation is not possible if the “Styles” were not checked out previously.

Datatype
IStyleItem

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsGroupName as BSTR

Example
VBA
Copy
Sub CreateStyleGroup()
    Dim Manager As StyleManager
    Set Manager = MyWorkspace.ActiveDocument.StyleManager
    Dim Group0 As StyleItem
    Set Group0 = Manager.CreateGroup("API_MyGroup")
    // you can do smth with the Group0 if u want
    Dim API_Style As StyleItem
    Set API_Style = Manager.Create("Fill_API", Group0, tpStyleType.tpStyleTypeFill)
    // you can do smth with the API_Style if u want
   Set API_Style = Manager.Create("RoundCorner_API2", Group0, tpStyleType.tpStyleTypeRoundCorner)
End Sub
Sub AddLineStyle()
    Dim Manager As StyleManager
    Set Manager = MyWorkspace.ActiveDocument.StyleManager
    Dim Group0 As StyleItem
    Set Group0 = Manager.Item("API_MyGroup")
    Dim API_Style As StyleItem
    Set API_Style = Manager.Create("Line_API", Group0, tpStyleType.tpStyleTypeLine)
    Set API_Style = Manager.Create("Line2_API", Group0, tpStyleType.tpStyleTypeLine)
End Sub


Delete
ObjectModel COM [image] StyleManager [image] Methods [image] Delete
Remarks

At the StyleManager there is now a new API-function "Delete" which needs a StyleItem as a Parameter and returns true, if the item was successfully deleted.Same as in the GUI, if the given StyleItem to delete is a Group, all the substyles of the group will also be deleted.If the given StyleItem is a Style only the Style will be deleted.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
StyleItem as IStyleItem


Export
ObjectModel COM [image] StyleManager [image] Methods [image] Export
Remarks

exports all style Groups of the Manager into the given file as XML. Returns true if everything went ok and false otherwise, no popup dialogs should be displayed.sFileName = file location

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR


ExtractStyleGroupFromElement
ObjectModel COM [image] StyleManager [image] Methods [image] ExtractStyleGroupFromElement
Remarks

This function takes two parameters: a name for a stylegroup and a Zenon Element (API object), and it returns the StyleGroup with all the styles (API object) that was extracted from the element. In case the extraction is not possible it will return NULL. The extraction is not possible when the StyleGroup name already exists, or when the user tries to extract a style group from an element that is not contained in the project where the manager is in (extract from another project). An exception is the global project, in the StyleManager of it we can extract style groups from elements of different projects.

Datatype
IStyleItem

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsGroupName as BSTR

pElement as IElement

Example
VBA
Copy
Sub CodeExample()
    Dim Manager As StyleManager
    Set Manager = MyWorkspace.ActiveDocument.StyleManager
    Dim Screen As DynPicture
    Set Screen = MyWorkspace.ActiveDocument.DynPictures().Item("Another screen")
    Dim Elem As Element
    Set Elem = Screen.Elements().Item("Universalregler_1")
    Dim StyleGroup As StyleItem
    Set StyleGroup = Manager.ExtractStyleGroupFromElement("API_Group", Elem)
    // meanwhile the real Zenon object is deleted from the editor
// here now you do something else with the StyleGroup object, and it should not crash (maybe it throws an // exception? Check previous stories for understanding how it should behave)
End Sub


Get
ObjectModel COM [image] StyleManager [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Import
ObjectModel COM [image] StyleManager [image] Methods [image] Import
Remarks

imports the given file into the style manager. Returns true if everything went ok and false otherwise.no popup dialogs should be displayedsFileName = file locationIf the GUID of an imported StyleGroup is already taken by another existing StyleGroup, then the existing StyleGroup is overridden by the imported one (No dialog to ask the user is displayed).If the GUID of an imported Style is already taken by an existing Style in an existing StyleGroup, then the Style is not imported and a warning is written in the output window to give the user the information why the import for that single style failed. The style group itself and the other Styles of the StyleGroup will be correctly imported and will not be influenced by this conflict. (the above scenario can be reproduced via copy & paste between different Style managers).Note: If the GUID of an imported StyleGroup is already taken by an existing Style, this is considered an error in the XML file, because it cannot happen that the GUID of a Style and of a StyleGroup it is the same. It can happen only if the user manually sets it in the XML file to import, and that is a wrong configuration.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR


IsCheckedOut
ObjectModel COM [image] StyleManager [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDifferent
ObjectModel COM [image] StyleManager [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] StyleManager [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects. NOTE: In a multi-user project it is recommended to check for IsLocked == false before performing any modification changes at all.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Item
ObjectModel COM [image] StyleManager [image] Methods [image] Item
Remarks

The Item method can be used with either a name (representing the name of a style group) or an index. If a StyleItem on the given index (or carrying the given name) exists, a StyleItem object will be returned.Note: A StyleItem can be either a StyleGroup or a Style. The Item property of the StyleManager will (for now) always return a StyleItem representing a StyleGroup as Styles currently do not exist on the top level.

Datatype
IStyleItem

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vPosOrName as VARIANT


UndoCheckOut
ObjectModel COM [image] StyleManager [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


SymbolElements
ObjectModel COM [image] SymbolElements
Remarks

This collection contains the 'Element' objects within a symbol. It is possible, that there are symbols in symbols and so on, so it could be neccessary to enumerate the object recursive.

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub SymbolElem()
Dim zPIC As DynPicture
Dim zSymbol As Element
Dim zText As Element
Dim zCircle As Element
Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Item("START")
'create static text element
Set zText = zPIC.Elements.Create("MyStaticText", tpText)
zText.Top = 100
zText.Left = 100
'create circle
Set zCircle = zPIC.Elements.Create("MyStaticCircle", tpCircle)
zCircle.Top = 150
zCircle.Left = 150
'create symbol
Set zSymbol = zPIC.Elements.Create("MyNewSymbol", tpSymbol)
zSymbol.Elements.Add zText
zSymbol.Elements.Add zCircle
zPIC.Save
End Sub
Sub EnumSymbolElements()
Dim zPicture As DynPicture
Dim zSymbol As Element
Dim zSymElements As SymbolElements
Dim i As Integer
'get Picture,(embedded) Symbol, SymbolElements collection...
Set zPicture = MyWorkspace.ActiveDocument.DynPictures.Item("START")
Set zSymbol = zPicture.Elements.Item("MyNewSymbol")
Set zSymElements = zSymbol.Elements
'enumerate all elements within a (embedded) symbol
For i = 0 To zSymElements.Count - 1

Debug.Print zSymElements.Item(i).Name & " [" & zSymElements.Item(i).Top & "/" & zSymElements.Item(i).Left & "]"
Next

End Sub


Properties
ObjectModel COM [image] SymbolElements [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns count of the elements | Readonly | Readonly | Available | Available
Parent | ielement | The parent object of the current object | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] SymbolElements [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] SymbolElements [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IElement

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] SymbolElements [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Add | variant_bool | Creates and returns a new Object | Available | Unused | Available | Available
Item | ielement | Returns a object at a position or by a specified key | Available | Available | Available | Available
Remove | variant_bool | Deletes the objects from collection | Available | Unused | Available | Available


Add
ObjectModel COM [image] SymbolElements [image] Methods [image] Add
Remarks

This method will add an exisiting 'Element' object from the picture into the symbol.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
pElement as IElement


Item
ObjectModel COM [image] SymbolElements [image] Methods [image] Item
Remarks

Returns a 'Element' object at a position or by name

Datatype
IElement

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vElementID as VARIANT


Remove
ObjectModel COM [image] SymbolElements [image] Methods [image] Remove
Remarks

Deletes an Element objects from the Symbol.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
nElemId as BSTR


Symbols
ObjectModel COM [image] Symbols
Remarks

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] Symbols [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
SymbolList | variant | Returns a list of available symbols | Readonly | Unused | Available | Available


SymbolList
ObjectModel COM [image] Symbols [image] Properties [image] SymbolList
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Symbols [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index | Available | Unused | Available | Available


Export
ObjectModel COM [image] Symbols [image] Methods [image] Export
Remarks

Export a symbol library into a file.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsLibName as BSTR

bsFileName as BSTR

Example
VBA
Copy
Sub Symbol_IMEX()
'export project library
MyWorkspace.ActiveDocument.Symbols.Export "", "C:\TEMP\ProjectLib.xml"
'export specific global library
MyWorkspace.Symbols.Export "Symbolgroup 1", "C:\TEMP\GlobalLib_S1.xml"
'export single symbol
MyWorkspace.ActiveDocument.Symbols.SingleExport "Symbol 2", "",

"C:\TEMP\Symbol2.xml"
'import from file
MyWorkspace.ActiveDocument.Symbols.Import "", "C:\TEMP\ProjectLib.xml"

End Sub


Import
ObjectModel COM [image] Symbols [image] Methods [image] Import
Remarks

Import a symbol library from file. New settings are added, existing settings will be replaced.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsLibName as BSTR

bsFileName as BSTR

Example
VBA
Copy
Sub Symbol_IMEX()
'export project library
MyWorkspace.ActiveDocument.Symbols.Export "", "C:\TEMP\ProjectLib.xml"
'export specific global library
MyWorkspace.Symbols.Export "Symbolgroup 1", "C:\TEMP\GlobalLib_S1.xml"
'export single symbol
MyWorkspace.ActiveDocument.Symbols.SingleExport "Symbol 2", "", "C:\TEMP\Symbol2.xml"
'import from file
MyWorkspace.ActiveDocument.Symbols.Import "", "C:\TEMP\ProjectLib.xml"

End Sub


SingleExport
ObjectModel COM [image] Symbols [image] Methods [image] SingleExport
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vName as VARIANT

bsLibName as BSTR

bsFileName as BSTR


SystemModel
ObjectModel COM [image] SystemModel
Remarks

Create or edit Equipment modeling (SystemModel) .

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Private Sub SystemModel()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim i As Integer
Dim j As Integer
Dim zSystemModel As SystemModel
Dim zSystemModelGroup As SystemModelGroup
Set zProject = MyWorkspace.ActiveDocument
'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then

Exit Sub
End If
'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager
For i = 0 To zSystemModelManager.count - 1

'Get SystemModel

Set zSystemModel = zSystemModelManager.Item(i)

For j = 0 To zSystemModel.count - 1

'Get SystemModelGroup

Set zSystemModelGroup = zSystemModel.Item(j)

Debug.Print (zSystemModelGroup.DynProperties("Name"))

Next j
Next i
End Sub


Properties
ObjectModel COM [image] SystemModel [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Count of system groups. | Available | Unused | Available | Available


Count
ObjectModel COM [image] SystemModel [image] Properties [image] Count
Remarks

Returns the number of Equipment models(SystemModel) .

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] SystemModel [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateDynProperty | variant_bool | - | Unused | Available | Available | Available
DynProperties [GET] | variant | - | Available | Unused | Available | Available
DynProperties [PUT] | void | - | Available | Unused | Available | Available
DynPropertiesEnum [GET] | variant | - | Available | Unused | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
Item | isystemmodelgroup | Returns the system group at the given index. | Available | Unused | Available | Available


CreateDynProperty
ObjectModel COM [image] SystemModel [image] Methods [image] CreateDynProperty
Remarks

With this Methode it is possible to create a new Equipment Model (SystemModel).

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Private Sub CreateSystemModel()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zSystemModel As SystemModel
Set zProject = MyWorkspace.ActiveDocument
'Equipment Model ( SystemModel) only exist in the global project.
If Not zProject.IsGlobal Then

Exit Sub
End If
'Get the EquipmentModel (SystemModel)
Set zSystemModelManager = zProject.SystemModelManager
Stop
'Now we create a new SystemModel
zSystemModelManager.CreateDynProperty ("Modules[" & zSystemModelManager.count & "]")
'Set the name of the SystemModel
zSystemModelManager.DynProperties("Modules[" & (zSystemModelManager.count - 1) & "].Name") = "Test"
End Sub


DynProperties [GET]
ObjectModel COM [image] SystemModel [image] Methods [image] DynProperties [GET]
Remarks

With this Methode its possible to get DynProperties.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Private Sub CreateSystemModel()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zSystemModel As SystemModel
Set zProject = MyWorkspace.ActiveDocument
'Equipment Model ( SystemModel) only exist in the global project.
If Not zProject.IsGlobal Then

Exit Sub
End If
'Get the EquipmentModel (SystemModel)
Set zSystemModelManager = zProject.SystemModelManager
'Get the name of the SystemModel
Debug.Print(zSystemModelManager.DynProperties("Modules[" & (zSystemModelManager.count - 1) & "].Name"))

End Sub


DynProperties [PUT]
ObjectModel COM [image] SystemModel [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Private Sub CreateSystemModel()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zSystemModel As SystemModel
Set zProject = MyWorkspace.ActiveDocument
'Equipment Model ( SystemModel) only exist in the global project.
If Not zProject.IsGlobal Then

Exit Sub
End If
'Get the EquipmentModel (SystemModel)
Set zSystemModelManager = zProject.SystemModelManager
Stop
'Now we create a new SystemModel
zSystemModelManager.CreateDynProperty ("Modules[" & zSystemModelManager.count & "]")
'Set the name of the SystemModel
zSystemModelManager.DynProperties("Modules[" & (zSystemModelManager.count - 1) & "].Name") = "Test"
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] SystemModel [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Enumerate the Properties of the SystemModelManager collection.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
 Dim vProps As Variant
 Dim i As Integer
'get all DynProperties of the actual object (DynPicture, Element, ...)  vProps = zenOnObject.DynPropertiesEnum("") 'Print informations of    DynProperties into output window
 For i = 0 To UBound(vProps) Debug.Print vProps(i)
 Next i
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] SystemModel [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the property parameter as PropParam

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
C#
Copy
public void Macronew()
        {
            zenOn.IPropParam Param = this.ActiveDocument.get_DynPropertyParam("MultitouchMode");
 if (Param.OptionCount > 0)
            {
 for (int i = 0; i < Param.OptionCount; i++)
                {
 this.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);
 this.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);
                }
            }
        }
VB.NET
Copy
Public Sub Macronew()
    Dim Param As zenOn.IPropParam = Me.ActiveDocument.get_DynPropertyParam("MultitouchMode")
    If Param.OptionCount > 0 Then
        For i As Integer = 0 To Param.OptionCount - 1
            Me.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)
            Me.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)
        Next
    End If
End Sub
VBA
Copy
Public Sub VBAMacro()
Dim obparm As PropParam
Dim n As Integer
Set obparm = thisProject.DynPropertyParam("MultitouchMode")
If (Not obparm Is Nothing) Then
 If obparm.OptionCount > 0 Then
 For n = 0 To obparm.OptionCount - 1

 Debug.Print "Option:" & obparm.OptionText(n)

 Debug.Print "Option:" & obparm.OptionValue(n)
 Next
 End If
End If
End Sub


Item
ObjectModel COM [image] SystemModel [image] Methods [image] Item
Remarks

Get Equipment models group (SystemModelGroup) by index.

Datatype
ISystemModelGroup

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT

Example
VBA
Copy
Private Sub SystemModel()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim i As Integer
Dim j As Integer
Dim zSystemModel As SystemModel
Dim zSystemModelGroup As SystemModelGroup
Set zProject = MyWorkspace.ActiveDocument
'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then

Exit Sub
End If
'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager
For i = 0 To zSystemModelManager.count - 1

'Get SystemModel

Set zSystemModel = zSystemModelManager.Item(i)

For j = 0 To zSystemModel.count - 1

'Get SystemModelGroup

Set zSystemModelGroup = zSystemModel.Item(j)

Debug.Print (zSystemModelGroup.DynProperties("Name"))

Next j
Next i
End Sub


DynProperties
ObjectModel COM [image] SystemModel [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

System model


System model
ObjectModel COM [image] SystemModel [image] DynProperties [image] System model
Overview
External Name | Type | Display Name | Description
Guid | String | Guid |
Name | String | Name | Name of the model. Is assigned automatically with successive number during creation and can be changed at will.Default: ModelX (X stands for a successive number) .
RelevantForNetToken | Bool | Equipment model relevant for operating authorization | Checkbox for the activation of the equipment model for operating authorization by means of equipment model:Active : Equipment model is used for operating authorizations by means of equipment model. When activated, the selected equipment model is offered for selection in the dialog of the function.Inactive : Equipment model is not used for operating authorization..
SystemModelGroup | Node | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .


SystemModelGroup
ObjectModel COM [image] SystemModelGroup
Remarks

Create or edit Equipment modeling group(SystemModelGroup) .

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Private Sub SystemModelGroups()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zName As String
Dim zGuid As String
Dim i As Integer
Dim zSymModGuid As SystemModel
Dim zSymModGroupChild As SystemModelGroup
Dim zSymModGroup As SystemModelGroup
Set zProject = MyWorkspace.ActiveDocument
'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If
'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager
'Get SystemModelGroup (Equipment Group)by guid
Set zSymModGroup = zSystemModelManager.Item(0).Item(0)
If Not zSymModGroup Is Nothing Then

'Show SystemModelGroup

Debug.Print (zSymModGroup.DynProperties("Name"))
If zSymModGroup.count > 0 Then

Set zSymModGroupChild = zSymModGroup.Item(0)

'Show child SystemModelGroup

Debug.Print (zSymModGroupChild.DynProperties("Name"))
End If
Else
Debug.Print ("NOTHING")
End If
End Sub


Properties
ObjectModel COM [image] SystemModelGroup [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Count of system groups. | Available | Unused | Available | Available


Count
ObjectModel COM [image] SystemModelGroup [image] Properties [image] Count
Remarks

Returns the number of SystemModelGroup item.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] SystemModelGroup [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateDynProperty | variant_bool | - | Unused | Available | Available | Available
DynProperties [GET] | variant | - | Available | Unused | Available | Available
DynProperties [PUT] | void | - | Available | Unused | Available | Available
DynPropertiesEnum [GET] | variant | - | Available | Unused | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
Item | isystemmodelgroup | Returns the system group at the given index. | Available | Unused | Available | Available


CreateDynProperty
ObjectModel COM [image] SystemModelGroup [image] Methods [image] CreateDynProperty
Remarks

With this Methode it is possible to create a new Equipment Model groups (SystemModelGroup).

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zName As String
Dim zGuid As String
Dim i As Integer
Dim zSymModGuid As SystemModel
Dim zSymModGroupChild As SystemModelGroup
Dim zSymModGroup As SystemModelGroup
Set zProject = MyWorkspace.ActiveDocument
'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then
Exit SubEnd If
'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager
'Get SystemModelGroup (Equipment Group)by guid
Set zSymModGroup = zSystemModelManager.Item(0).Item(0)
If Not zSymModGroup Is Nothing Then
 'Show SystemModelGroup Debug.Print (zSymModGroup.DynProperties("Name"))
  If zSymModGroup.count > 0 Then
   Set zSymModGroupChild = zSymModGroup.Item(0)
  'Create a new child SystemModelGrou
   zSymModGroupChild.CreateDynProperty ("SystemModelGroup[" & zSymModGroup.count & "]")
  'Set Name'Set the name of the SystemModelGroup   zSymModGroupChild.DynProperties("SystemModelGroup[" & (zSymModGroup.count - 1) & "].Name") = "Test" 'Show the new child SystemModelGroup Debug.Print (zSymModGroupChild.DynProperties("SystemModelGroup[" & (zSymModGroup.count - 1) & "].Name"))
   End If
Else
   Debug.Print ("NOTHING")
End If
End Sub


DynProperties [GET]
ObjectModel COM [image] SystemModelGroup [image] Methods [image] DynProperties [GET]
Remarks

With this Methode its possible to get DynProperties.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zName As String
Dim zGuid As String
Dim i As Integer
Dim zSymModGuid As SystemModel
Dim zSymModGroupChild As SystemModelGroup
Dim zSymModGroup As SystemModelGroup
Set zProject = MyWorkspace.ActiveDocument
'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If
'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager
'Get SystemModelGroup (Equipment Group)by guid
Set zSymModGroup = zSystemModelManager.Item(0).Item(0)
If Not zSymModGroup Is Nothing Then
'Show SystemModelGroup Debug.Print (zSymModGroup.DynProperties("Name"))
If zSymModGroup.count > 0 Then
Set zSymModGroupChild = zSymModGroup.Item(0) 'Create a new child SystemModelGrou zSymModGroupChild.CreateDynProperty ("SystemModelGroup[" & zSymModGroup.count & "]") 'Set Name'Set the name of the SystemModelGroup zSymModGroupChild.DynProperties("SystemModelGroup[" & (zSymModGroup.count - 1) & "].Name") = "Test" 'Show the new child SystemModelGroup Debug.Print (zSymModGroupChild.DynProperties("SystemModelGroup[" & (zSymModGroup.count - 1) & "].Name"))
End If
Else
Debug.Print ("NOTHING")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] SystemModelGroup [image] Methods [image] DynProperties [PUT]
Remarks

With this Methode its possible to set DynProperties.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zName As String
Dim zGuid As String
Dim i As Integer
Dim zSymModGuid As SystemModel
Dim zSymModGroupChild As SystemModelGroup
Dim zSymModGroup As SystemModelGroup
Set zProject = MyWorkspace.ActiveDocument
'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If
'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager
'Get SystemModelGroup (Equipment Group)by guid
Set zSymModGroup = zSystemModelManager.Item(0).Item(0)
If Not zSymModGroup Is Nothing Then
'Show SystemModelGroup Debug.Print (zSymModGroup.DynProperties("Name"))
If zSymModGroup.count > 0 Then
Set zSymModGroupChild = zSymModGroup.Item(0) 'Create a new child SystemModelGrou zSymModGroupChild.CreateDynProperty ("SystemModelGroup[" & zSymModGroup.count & "]") 'Set Name'Set the name of the SystemModelGroup zSymModGroupChild.DynProperties("SystemModelGroup[" & (zSymModGroup.count - 1) & "].Name") = "Test" 'Show the new child SystemModelGroup Debug.Print (zSymModGroupChild.DynProperties("SystemModelGroup[" & (zSymModGroup.count - 1) & "].Name"))
End If
Else
Debug.Print ("NOTHING")
End If
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] SystemModelGroup [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Enumerate the Properties of the SystemModelGroup collection.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
Dim vProps As Variant
Dim i As Integer
'get all DynProperties of the actual object (DynPicture, Element, ...) vProps = zenOnObject.DynPropertiesEnum("") 'Print informations of DynProperties into output window
For i = 0 To UBound(vProps) Debug.Print vProps(i)
Next i
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] SystemModelGroup [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the property parameter as PropParam

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
C#
Copy
public void Macronew()
        {
            zenOn.IPropParam Param = this.ActiveDocument.get_DynPropertyParam("MultitouchMode");
 if (Param.OptionCount > 0)
            {
 for (int i = 0; i < Param.OptionCount; i++)
                {
 this.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);
 this.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);
                }
            }
        }
VB.NET
Copy
Public Sub Macronew()
    Dim Param As zenOn.IPropParam = Me.ActiveDocument.get_DynPropertyParam("MultitouchMode")
    If Param.OptionCount > 0 Then
        For i As Integer = 0 To Param.OptionCount - 1
            Me.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)
            Me.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)
        Next
    End If
End Sub
VBA
Copy
Public Sub VBAMacro()
Dim obparm As PropParam
Dim n As Integer
Set obparm = thisProject.DynPropertyParam("MultitouchMode")
If (Not obparm Is Nothing) Then
 If obparm.OptionCount > 0 Then
 For n = 0 To obparm.OptionCount - 1

 Debug.Print "Option:" & obparm.OptionText(n)

 Debug.Print "Option:" & obparm.OptionValue(n)
 Next
 End If
End If
End Sub


Item
ObjectModel COM [image] SystemModelGroup [image] Methods [image] Item
Remarks

Child SystemModelGroup.

Datatype
ISystemModelGroup

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT

Example
VBA
Copy
Private Sub SystemModelGroups()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zName As String
Dim zGuid As String
Dim i As Integer
Dim zSymModGuid As SystemModel
Dim zSymModGroupChild As SystemModelGroup
Dim zSymModGroup As SystemModelGroup
Set zProject = MyWorkspace.ActiveDocument
'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then

Exit Sub
End If
'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager
'Get SystemModelGroup (Equipment Group)by guid
Set zSymModGroup = zSystemModelManager.Item(0).Item(0)
If Not zSymModGroup Is Nothing Then

'Show SystemModelGroup

Debug.Print (zSymModGroup.DynProperties("Name"))

If zSymModGroup.count > 0 Then

Set zSymModGroupChild = zSymModGroup.Item(0)

'Show child SystemModelGroup

Debug.Print (zSymModGroupChild.DynProperties("Name"))

End If
Else

Debug.Print ("NOTHING")
End If
End Sub


DynProperties
ObjectModel COM [image] SystemModelGroup [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

System model group


System model group
ObjectModel COM [image] SystemModelGroup [image] DynProperties [image] System model group
Overview
External Name | Type | Display Name | Description
AlarmVar | CProjektVariable | Number of active alarms | Variable that contains the number of active alarms in this alarm area as a value. Clicking on ... opens the dialog to select variables. .
AuthorizationAvailable | CProjektVariable | Available at this computer | Variable for the display of the computer to be called up for this equipment group by means of the corresponding operating authorization.Click on button ... in order to open the dialog for selecting variables. Only variables from the local project and of the BOOL data type can be selected for linking. It is recommended that these linked variables are created for the internal driver . Configure the property for this variable too, in the variable properties group with the value local . .
AuthorizationOwner | CProjektVariable | Operating authorization at computer | Variable for the display of the computer name that currently has the corresponding operating authorization for this equipment group.Click on button ... in order to open the dialog for selecting variables. Only variables from the local project and of the STRING data type can be selected for linking. It is recommended that these linked variables are created for the Internen Treiber . Configure the property for this variable too, in the variable properties group with the value network . .
Guid | String | Guid |
Items | Node | Class linking | Sums up status variable, number of active alarms and number of unacknowledged alarms. .
Name | String | Name | Name of the group. Is assigned automatically with successive number during creation and can be changed at will.Default: GroupX (X stands for a successive number) .
QuitVar | CProjektVariable | Number of unacknowledged alarms | Variable that contains the number of unacknowledged alarms in this alarm area as a value. Clicking on ... opens the dialog to select variables. .
StatusVar | CProjektVariable | Status variable | Variable to stipulate whether there are alarms present in the alarm area.The first bit of this byte variable shows whether there are any active alarms in this alarm area.The second bit of this byte variable shows whether there are any unacknowledged alarms in this alarm area.Click on ... to open the variable selection dialog. .
SystemModelGroup | Node | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .


CBereichItem
ObjectModel COM [image] SystemModelGroup [image] DynProperties [image] System model group [image] CBereichItem
Overview
External Name | Type | Display Name | Description
AlarmVar | CProjektVariable | Number of active alarms | Variable which contains the number of active alarms of the selected alarm/event class in this alarm area as value. Opens the dialog to select variables.
Class | UInt16 | Alarm/event class | Alarm/event class for the area entry. .
ClassName | String | ClassName |
QuitVar | CProjektVariable | Number of unacknowledged alarms | Variable which contains the number of unacknowledged alarms of the selected alarm/event class in this alarm area as value. Opens the dialog to select variables. .
StatusVar | CProjektVariable | Status variable | The first bit of this byte variable shows if there are active alarms of the selected alarm/event class in this alarm area. The second bit of this byte variable shows if there are unacknowledged alarms of the selected alarm/event class in this alarm area. .


SystemModelManager
ObjectModel COM [image] SystemModelManager
Remarks

The SystemModelManager represent the project node Equipment modeling from a global project.
Create or edit Equipment modeling (SystemModel) and Equipment group (SystemModelGroup) are possible.

A global project is needed!

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Private Sub SystemModelManager()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zName As String
Dim zGuid As String
Dim i As Integer
Dim zSymModGuid As SystemModel
Dim zSymModGroupChild As SystemModelGroup
Dim zSymModGroup As SystemModelGroup
Stop
Set zProject = MyWorkspace.ActiveDocument
'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then

Exit Sub
End If
'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager
Debug.Print ("Number of System Models : " & zSystemModelManager.count)
'SystemModel (First node in the Equipment Model)
Debug.Print (zSystemModelManager.Item(0).DynProperties("Name"))
Debug.Print (zSystemModelManager.Item(0).DynProperties("Guid"))
zName = zSystemModelManager.Item(0).DynProperties("Name")
'Get the SystemModel by Name
Set zSymModGuid = zSystemModelManager.ModelByName(zName)
If Not zSymModGuid Is Nothing Then

Debug.Print (zSymModGuid.DynProperties("Name"))
Else

Debug.Print ("NOTHING")
End If
'SystemModelGroup (Equipment Group)
Debug.Print (zSystemModelManager.Item(0).Item(0).DynProperties("Name"))
Debug.Print (zSystemModelManager.Item(0).Item(0).DynProperties("Guid"))
zGuid = zSystemModelManager.Item(0).Item(0).DynProperties("Guid")
'Get SystemModelGroup (Equipment Group)by guid
Set zSymModGroup = zSystemModelManager.GroupByGuid(zGuid)
If Not zSymModGroup Is Nothing Then

Debug.Print (zSymModGroup.DynProperties("Name"))
If zSymModGroup.count > 0 Then

Set zSymModGroupChild = zSymModGroup.Item(0)

Debug.Print (zSymModGroupChild.DynProperties("Name"))
End If
Else

Debug.Print ("NOTHING")
End If
End Sub


Properties
ObjectModel COM [image] SystemModelManager [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | - | Available | Unused | Available | Available


Count
ObjectModel COM [image] SystemModelManager [image] Properties [image] Count
Remarks

Number of Equipment Models (SystemModel)

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] SystemModelManager [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateDynProperty | variant_bool | - | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Unused | Available | Available
DynProperties [PUT] | void | - | Available | Unused | Available | Available
DynPropertiesEnum [GET] | variant | - | Available | Unused | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
Export | variant_bool | Exports system model list | Available | Unused | Available | Available
GroupByGuid | isystemmodelgroup | Returns the system group with the given id (guid). | Available | Unused | Available | Available
Import | variant_bool | Imports system model list | Available | Unused | Available | Available
Item | isystemmodel | Returns the system model at the given index. | Available | Unused | Available | Available
ModelByName | isystemmodel | Returns the system model with the given id (guid). | Available | Unused | Available | Available


CreateDynProperty
ObjectModel COM [image] SystemModelManager [image] Methods [image] CreateDynProperty
Remarks

Create Subitems of the SystemModelManager collection. See: SystemModelManager

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties [GET]
ObjectModel COM [image] SystemModelManager [image] Methods [image] DynProperties [GET]
Remarks

Read and/or change the Properties of the SystemModelManager collection. See: SystemModelManager

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties [PUT]
ObjectModel COM [image] SystemModelManager [image] Methods [image] DynProperties [PUT]
Remarks

Set the Properties of the SystemModelManager collection. See: SystemModelManager

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT


DynPropertiesEnum [GET]
ObjectModel COM [image] SystemModelManager [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Enumerate the Properties of the SystemModelManager collection.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
Dim vProps As Variant
Dim i As Integer
'get all DynProperties of the actual object (DynPicture, Element, ...) vProps = zenOnObject.DynPropertiesEnum("") 'Print informations of DynProperties into output window
For i = 0 To UBound(vProps) Debug.Print vProps(i)
Next i
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] SystemModelManager [image] Methods [image] DynPropertyParam [GET]
Remarks

Returns the property parameter as PropParam

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
C#
Copy
public void Macronew()
        {
            zenOn.IPropParam Param = this.ActiveDocument.get_DynPropertyParam("MultitouchMode");
 if (Param.OptionCount > 0)
            {
 for (int i = 0; i < Param.OptionCount; i++)
                {
 this.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);
 this.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);
                }
            }
        }
VB.NET
Copy
Public Sub Macronew()
    Dim Param As zenOn.IPropParam = Me.ActiveDocument.get_DynPropertyParam("MultitouchMode")
    If Param.OptionCount > 0 Then
        For i As Integer = 0 To Param.OptionCount - 1
            Me.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)
            Me.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)
        Next
    End If
End Sub
VBA
Copy
Public Sub VBAMacro()
Dim obparm As PropParam
Dim n As Integer
Set obparm = thisProject.DynPropertyParam("MultitouchMode")
If (Not obparm Is Nothing) Then
 If obparm.OptionCount > 0 Then
 For n = 0 To obparm.OptionCount - 1

 Debug.Print "Option:" & obparm.OptionText(n)

 Debug.Print "Option:" & obparm.OptionValue(n)
 Next
 End If
End If
End Sub


Export
ObjectModel COM [image] SystemModelManager [image] Methods [image] Export
Remarks

Export settings to an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Public Sub ExportEquipmentModel()

Dim Exported As Boolean
Exported = MyWorkspace.ActiveDocument.SystemModelManager.Export("C:\Equipment.xml")

End Sub


GroupByGuid
ObjectModel COM [image] SystemModelManager [image] Methods [image] GroupByGuid
Remarks

Returns the Guid of the Equipment Model Group (SystemModelGroup).

Datatype
ISystemModelGroup

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsGuid as BSTR

Example
VBA
Copy
Private Sub SystemModelManager()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zGuid As String
Dim i As Integer
Dim zSymModGuid As SystemModel
Dim zSymModGroup As SystemModelGroup
Stop
Set zProject = MyWorkspace.ActiveDocument
'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then

Exit Sub
End If
'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager
'Get guid of any SystemModelGroup (Equipment Group)
zGuid = zSystemModelManager.Item(0).Item(0).DynProperties("Guid")
'Get SystemModelGroup (Equipment Group)by guid
Set zSymModGroup = zSystemModelManager.GroupByGuid(zGuid)
If Not zSymModGroup Is Nothing Then

Debug.Print (zSymModGroup.DynProperties("Name"))
Else

Debug.Print ("NOTHING")
End If
End Sub


Import
ObjectModel COM [image] SystemModelManager [image] Methods [image] Import
Remarks

Import settings from an xml file. Existing settings will be replaced/merged.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub Project Active()
Set mypicevents = thisProject.Dynpictures
Stop
thisProject.SystemModelManager.Export("AnlagenmodellEditorB.xml")
thisProject.SystemModelManager.Import("AnlagenmodellEditorB.xml")
End Sub


Item
ObjectModel COM [image] SystemModelManager [image] Methods [image] Item
Remarks

Returns the Equipment Model (SystemModel) by index.

Datatype
ISystemModel

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT

Example
VBA
Copy
Private Sub SystemModelManagerItem()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim i As Integer
Set zProject = MyWorkspace.ActiveDocument
'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then

Exit Sub
End If
'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager
For i = 0 To zSystemModelManager.count - 1

'Show the name of the SystemModel

Debug.Print (zSystemModelManager.Item(i).DynProperties("Name"))
Next i
End Sub


ModelByName
ObjectModel COM [image] SystemModelManager [image] Methods [image] ModelByName
Remarks

Returns the Name of the Equipment Model (SystemModel).

Datatype
ISystemModel

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

Example
VBA
Copy
Private Sub SystemModelManager()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zName As String
Dim zSymModGuid As SystemModel

Stop
Set zProject = MyWorkspace.ActiveDocument
'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then

Exit Sub
End If
'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager
Debug.Print ("Number of System Models : " & zSystemModelManager.count)
'SystemModel (First node in the Equipment Model)
Debug.Print (zSystemModelManager.Item(0).DynProperties("Name"))
Debug.Print (zSystemModelManager.Item(0).DynProperties("Guid"))
zName = zSystemModelManager.Item(0).DynProperties("Name")
'Get the SystemModel by Name
Set zSymModGuid = zSystemModelManager.ModelByName(zName)
If Not zSymModGuid Is Nothing Then

Debug.Print (zSymModGuid.DynProperties("Name"))
Else

Debug.Print ("NOTHING")
End If

End Sub


Events
ObjectModel COM [image] SystemModelManager [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ModelGroupSelected | void |  | Unused | Available | Available | Available


ModelGroupSelected
ObjectModel COM [image] SystemModelManager [image] Events [image] ModelGroupSelected
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsGuid as BSTR

bsName as BSTR


DynProperties
ObjectModel COM [image] SystemModelManager [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

System model manager


System model manager
ObjectModel COM [image] SystemModelManager [image] DynProperties [image] System model manager
Overview
External Name | Type | Display Name | Description
Modules | Node | Modules | Node


Task
ObjectModel COM [image] Task
Remarks

A task is a VisualBasicScript file and can be executed over the Tasks/Task object model.Here is a sample how to configure a task to run only once and starts event triggered:<img src="../../../private/task_settings.jpg"></img>Tasks can also be configured cyclic, then VBA is not needed to use them...

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub StartTask()
Dim zTask As Task
'get task by its name...
Set zTask = thisProject.Tasks.Item("Task1")
'get task properties...
Debug.Print "CountVariable: " & zTask.CountVariable
Debug.Print "ActualCycleTime: " & zTask.ActualCycleTime
Debug.Print "CycleTime: " & zTask.CycleTime
Debug.Print "ErrorNumber: " & zTask.ErrorNumber
Debug.Print "ErrorString: " & zTask.ErrorString
Debug.Print "Priority: " & zTask.Priority
Debug.Print "Status: " & zTask.Status
'run task
zTask.Run

End Sub


Properties
ObjectModel COM [image] Task [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ActualCycleTime | long |  | Available | Readonly | Available | Available
CountVariable | long |  | Available | Readonly | Available | Available
CycleTime | long |  | Available | Readonly | Available | Available
ErrorNumber | long |  | Available | Available | Available | Available
ErrorString | bstr |  | Available | Available | Available | Available
Name | bstr |  | Available | Readonly | Available | Available
Parent | itasks |  | Readonly | Readonly | Available | Available
Priority | long |  | Available | Readonly | Available | Available
Status | tptaskstatus |  | Readonly | Readonly | Available | Available
Type | tptasktyp |  | Available | Readonly | Available | Available


ActualCycleTime
ObjectModel COM [image] Task [image] Properties [image] ActualCycleTime
Remarks

Currently achieved cycle time of the task

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


CountVariable
ObjectModel COM [image] Task [image] Properties [image] CountVariable
Remarks

Number of variables linked to the task

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


CycleTime
ObjectModel COM [image] Task [image] Properties [image] CycleTime
Remarks

Defined cycle time of the task

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ErrorNumber
ObjectModel COM [image] Task [image] Properties [image] ErrorNumber
Remarks

Contains an error number.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


ErrorString
ObjectModel COM [image] Task [image] Properties [image] ErrorString
Remarks

Contains an error message as string.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] Task [image] Properties [image] Name
Remarks

Unique name of the task.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Task [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
ITasks

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Priority
ObjectModel COM [image] Task [image] Properties [image] Priority
Remarks

Process priority for the operating system multi-threading (idle, low, normal, high, highest, time critical) Default: normal Main process: the task runs in the same thread as the Runtime. If the task gets into a waiting loop or crashes, that also influences the Runtime.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Status
ObjectModel COM [image] Task [image] Properties [image] Status
Remarks

Returns the status of a task.

Datatype
tpTaskStatus

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] Task [image] Properties [image] Type
Remarks

Tasks can be executed "cyclic" or "once".

Datatype
tpTaskTyp

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Task [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
ItemVariable | ivariable | - | Available | Available | Available | Available
MemValue [GET] | variant | - | Available | Available | Available | Available
MemValue [PUT] | void | - | Available | Available | Available | Available
Run | void | - | Available | Available | Available | Available
Sleep | void | - | Available | Available | Available | Available
StartTimer | variant_bool | - | Available | Available | Available | Available
Stop | void | - | Available | Available | Available | Available
StopTimer | variant_bool | - | Available | Available | Available | Available
Value [GET] | variant | - | Available | Available | Available | Available
Value [PUT] | void | - | Available | Available | Available | Available


DynProperties [GET]
ObjectModel COM [image] Task [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] Task [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] Task [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] Task [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


ItemVariable
ObjectModel COM [image] Task [image] Methods [image] ItemVariable
Remarks

Returns a variable object.

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPv as VARIANT


MemValue [GET]
ObjectModel COM [image] Task [image] Methods [image] MemValue [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR


MemValue [PUT]
ObjectModel COM [image] Task [image] Methods [image] MemValue [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR

newValue as VARIANT


Run
ObjectModel COM [image] Task [image] Methods [image] Run
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Sleep
ObjectModel COM [image] Task [image] Methods [image] Sleep
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
msTime as long


StartTimer
ObjectModel COM [image] Task [image] Methods [image] StartTimer
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lId as long

msTime as long


Stop
ObjectModel COM [image] Task [image] Methods [image] Stop
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


StopTimer
ObjectModel COM [image] Task [image] Methods [image] StopTimer
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lId as long


Value [GET]
ObjectModel COM [image] Task [image] Methods [image] Value [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR

vIndex as VARIANT


Value [PUT]
ObjectModel COM [image] Task [image] Methods [image] Value [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR

vIndex as VARIANT

newValue as VARIANT


Events
ObjectModel COM [image] Task [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Exit | void |  | Available | Available | Available | Available
Init | void |  | Available | Available | Available | Available
Main | void |  | Available | Available | Available | Available
Timer | void |  | Available | Available | Available | Available


Exit
ObjectModel COM [image] Task [image] Events [image] Exit
Remarks

This event is automatically executed when stopping the task.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Init
ObjectModel COM [image] Task [image] Events [image] Init
Remarks

This event is automatically executed when starting the task.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Main
ObjectModel COM [image] Task [image] Events [image] Main
Remarks

This event is either executed once (type once) or cyclically (type cyclic).

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Timer
ObjectModel COM [image] Task [image] Events [image] Timer
Remarks

This event is executed cyclically, as long as the according time is running. The cycle time is defined as a parameter with the starting of the timer.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lId as long


Tasks
ObjectModel COM [image] Tasks
Remarks

This object contains a collection of tasks, tasks can be defined with the 'Process Control Engine' (PCE).A task is a VisualBasicScript file and can be executed over the Tasks/Task object model.Here is a sample how to configure a task to run only once and starts event triggered:<img src="../../../private/task_settings.jpg"></img>Tasks can also be configured cyclic, then VBA is not needed to use them...

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub StartTask()
Dim zTask As Task
'get task by its name...
Set zTask = thisProject.Tasks.Item("Task1")
'get task properties...
Debug.Print "CountVariable: " & zTask.CountVariable
Debug.Print "ActualCycleTime: " & zTask.ActualCycleTime
Debug.Print "CycleTime: " & zTask.CycleTime
Debug.Print "ErrorNumber: " & zTask.ErrorNumber
Debug.Print "ErrorString: " & zTask.ErrorString
Debug.Print "Priority: " & zTask.Priority
Debug.Print "Status: " & zTask.Status
'run task
zTask.Run

End Sub


Properties
ObjectModel COM [image] Tasks [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Readonly | Available | Available
Parent | iproject |  | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] Tasks [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Tasks [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Tasks [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Item | itask | - | Available | Available | Available | Available


Item
ObjectModel COM [image] Tasks [image] Methods [image] Item
Remarks

Single Task Item represents a vbs file.

Datatype
ITask

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Name as BSTR


Template
ObjectModel COM [image] Template
Remarks

The Frame contains general information on the outer appearance of the Screens. Each Screen is linked to a Frame. The VBA object for the Frames contains the most important information, e.g. name and position on the screen.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Private Sub GetTemplates()
Dim IMDITemplates As MDITemplates
Dim IMDITemplate As MDITemplate
Dim Count As Integer
Dim Ok As Boolean
Dim i As Integer
' --- Selection by Name
Set IMDITemplates = MyWorkspace.GetMDiTemplates("Keyboard")
If Not IMDITemplates Is Nothing Then

Set IMDITemplate = IMDITemplates.Item("Test 3")

Ok = PrintTemplate(IMDITemplate)
End If
' --- Selection by index (zenon Constant)
Set IMDITemplates = MyWorkspace.GetMDiTemplates(tpKeyboard)
If Not IMDITemplates Is Nothing Then

Count = IMDITemplates.Count

For i = 0 To Count - 1

Set IMDITemplate = IMDITemplates.Item(i)

Ok = PrintTemplate(IMDITemplate)

Next
End If
End Sub
Private Function PrintTemplate(IMDITemplate As MDITemplate) As Boolean
If Not IMDITemplate Is Nothing Then

Debug.Print ("Name: " & IMDITemplate.DynProperties("Name"))

Debug.Print ("GUID: " & IMDITemplate.DynProperties("GUID"))

Debug.Print ("ImportPath: " & IMDITemplate.DynProperties("ImportPath"))

Debug.Print ("Folder: " & IMDITemplate.DynProperties("Folder"))

Debug.Print ("MDIType: " & IMDITemplate.DynProperties("MDIType"))

Debug.Print ("Language: " & IMDITemplate.DynProperties("Language"))

Debug.Print ("Description: " & IMDITemplate.DynProperties("Description"))

Debug.Print ("CopaDataTemplate: " & IMDITemplate.DynProperties("CopaDataTemplate"))
Debug.Print ("DefaultTemplate: " &
IMDITemplate.DynProperties("DefaultTemplate"))

PrintTemplate = True
Else

PrintTemplate = False
End If
End Function


Properties
ObjectModel COM [image] Template [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
BackgroundColor | long | BackColor | Available | Readonly | Available | Available
BackgroundGraphicAlignment | backgroundgraphicalignment |  | Available | Readonly | Available | Available
BackgroundImage | bstr | Image for the Template | Available | Readonly | Available | Available
BackgroundImageStyle | short | Style for the Image | Available | Readonly | Available | Available
BorderStyle | short | Style of the template-border (for resizing) | Available | Readonly | Available | Available
Bottom | long | Bottom-coordinate of the template | Available | Readonly | Available | Available
FrameBorderStyle | frameborderstyle |  | Available | Readonly | Available | Available
Height | long | Height of the template | Available | Readonly | Available | Available
Left | long | Left-coordinate of the template | Available | Readonly | Available | Available
Name | bstr | Name of the template (unique) | Available | Readonly | Available | Available
OpenMultiple | variant_bool | Open a template multiple times | Available | Readonly | Available | Available
Parent | itemplates | Returns the parent object | Readonly | Readonly | Available | Available
Right | long | Right-coordinate of the template | Available | Readonly | Available | Available
ShowForeground | variant_bool | Shows template always in the foreground | Available | Readonly | Available | Available
ShowMinimize | variant_bool | Shows the windows minimize button | Available | Readonly | Available | Available
ShowSysMenu | variant_bool | Shows the windows system menu | Available | Readonly | Available | Available
ShowTitle | variant_bool | Shows titlebar for the template | Available | Readonly | Available | Available
Style | long | Style of the template-window | Available | Readonly | Available | Available
Top | long | Top-coordinate of the template | Available | Readonly | Available | Available
Width | long | Width of the template | Available | Readonly | Available | Available


BackgroundColor
ObjectModel COM [image] Template [image] Properties [image] BackgroundColor
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


BackgroundGraphicAlignment
ObjectModel COM [image] Template [image] Properties [image] BackgroundGraphicAlignment
Remarks

Datatype
BackgroundGraphicAlignment

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


BackgroundImage
ObjectModel COM [image] Template [image] Properties [image] BackgroundImage
Remarks

Gets or sets the path to the background image for the Frame.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


BackgroundImageStyle
ObjectModel COM [image] Template [image] Properties [image] BackgroundImageStyle
Remarks

Datatype
short

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


BorderStyle
ObjectModel COM [image] Template [image] Properties [image] BorderStyle
Remarks

Datatype
short

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Bottom
ObjectModel COM [image] Template [image] Properties [image] Bottom
Remarks

Gets or sets the position of the bottom Frame border in pixel. The value defines the distance from the top border of the screen.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


FrameBorderStyle
ObjectModel COM [image] Template [image] Properties [image] FrameBorderStyle
Remarks

Datatype
FrameBorderStyle

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Height
ObjectModel COM [image] Template [image] Properties [image] Height
Remarks

The height of the template.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Left
ObjectModel COM [image] Template [image] Properties [image] Left
Remarks

Gets or sets the position of the left Frame border in pixel. The value defines the distance from the left border of the screen. If this value is 0, then the Frame starts at the left border of the screen.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] Template [image] Properties [image] Name
Remarks

Returns the unique name of the Frame. With this name the Frame can be found in the central Frame list of the project. This name is always unique.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


OpenMultiple
ObjectModel COM [image] Template [image] Properties [image] OpenMultiple
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Template [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
ITemplates

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Right
ObjectModel COM [image] Template [image] Properties [image] Right
Remarks

Gets or sets the position of the right Frame border in pixel. The value defines the distance from the left border of the screen.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ShowForeground
ObjectModel COM [image] Template [image] Properties [image] ShowForeground
Remarks

Shows the Frame always in the foreground, if set TRUE.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ShowMinimize
ObjectModel COM [image] Template [image] Properties [image] ShowMinimize
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ShowSysMenu
ObjectModel COM [image] Template [image] Properties [image] ShowSysMenu
Remarks

Shows the Windows system menu, if set TRUE. <span style="color:red">Only available, if property "ShowTitle" is set TRUE.</span>

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ShowTitle
ObjectModel COM [image] Template [image] Properties [image] ShowTitle
Remarks

Shows the titlebar for the Frame, if set TRUE. <span style="color:red">Only available, if property "BorderStyle" is set other than 0 (No frame).</span>

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Style
ObjectModel COM [image] Template [image] Properties [image] Style
Remarks

Gets or sets the style of the Frame window. The returned value comprises all style settings.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Top
ObjectModel COM [image] Template [image] Properties [image] Top
Remarks

Gets or sets the position of the top Frame border in pixel. The value defines the distance from the top border of the screen. If this value is 0, then the Frame starts at the top border of the screen.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Width
ObjectModel COM [image] Template [image] Properties [image] Width
Remarks

The width of the template.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Template [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
Copy | variant_bool | Copies the template | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
Export | variant_bool | Export the given template | Available | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
Import | variant_bool | Import a template | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
Save | variant_bool | Save changes | Available | Unused | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


CheckIn
ObjectModel COM [image] Template [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckOut
ObjectModel COM [image] Template [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Copy
ObjectModel COM [image] Template [image] Methods [image] Copy
Remarks

Copies the settings from an existing Frame to the own Frame.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
pSource as ITemplate


DynProperties [GET]
ObjectModel COM [image] Template [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] Template [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] Template [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] Template [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Export
ObjectModel COM [image] Template [image] Methods [image] Export
Remarks

Export settings to an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
szFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Get
ObjectModel COM [image] Template [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Import
ObjectModel COM [image] Template [image] Methods [image] Import
Remarks

Import settings from an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
szFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


IsCheckedOut
ObjectModel COM [image] Template [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDifferent
ObjectModel COM [image] Template [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] Template [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Save
ObjectModel COM [image] Template [image] Methods [image] Save
Remarks

Save changes.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


UndoCheckOut
ObjectModel COM [image] Template [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


DynProperties
ObjectModel COM [image] Template [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Alarm template
Frame template


Alarm template
ObjectModel COM [image] Template [image] DynProperties [image] Alarm template
Overview
External Name | Type | Display Name | Description
BackgroundColor | UInt32 | Background color | Proposed background color for all screens that are newly defined on this frame .
BackgroundGraphicAlignment | Int16 | BackgroundGraphicAlignment | Description
BackgroundPicture | String | Graphics File | Selection of the background graphics for all newly-defined screens that are based on this frame.Click on the ... selection button to open the dialog for selecting a file. A change of the graphics file does not affect already existing screens which are based on this frame. .
BackgroundPictureStyle | Int16 | Alignment | Only available after you have selected a .Possible display types: tiled : Original size in tiles side by side.stretched : stretched to fill the whole screen.normal : Original size positioned in the top left corner. Centered : Original size, centered in the middle of the screen.Default: normal .You cannot move it freely.Note: A change of the orientation does not affect already existing screens which are based on this frame. .
BorderStyle | Int16 | Border type | Setting the type of frame. This also defines whether the size of the frame can be changed in Runtime.Size adjustable : The size of the frame can be changed in Runtime. A thick border is displayed around the frame.Size fixed : The size cannot be changed. A thin border is displayed around the frame.No border : The size cannot be changed. No border is displayed around the screen.Default: No border .
FrameBorderStyle | Int16 | FrameBorderStyle | Description
LimitationArea | UInt32 | Limitation | Only available if, for the property, the entry restrict to display borders has been selected.Defines the type of limit for the moving of frames:Frame border : The frame cannot be moved beyond the monitor limit.Frame border area : The frame can be moved beyond the monitor limit. However there must be an area on the monitor that can be accessed for further actions. The size of this border area can be configured with the property. .
LimitationContactPointSize | UInt32 | Minimum frame margin | Only available if the value for the property has been set to restrict to display borders and the property has been set to Frame border area .Defines the size of the frame border area in pixels. This area cannot be moved beyond the edge of the monitor. The defined range thus remains as an area to grab and move the frame in the visible area.Minimum: 0 Maximum: not defined If this area is defined as larger than the screen size or zoomed accordingly in Runtime, the screen acts as a limit on the frame border.Default: 30 .
LimitationType | UInt32 | Move | Defines possible settings when moving the object:without restrictionrestrict to display borders Note: The type of limitation is defined using the propertyNot available under Windows CE. .
MinSizeType | UInt32 | Limitation Minimum | Type of limit for the minimum value: .
MinSizeValue | UInt32 | Value (minimum) | Value for the setting selected in the property. .
OpeningSizeType | UInt32 | Opening size | Defines the size with which a screen based on this frame is called up in Runtime. .
OpeningSizeValue | UInt32 | Value (Opening size) | Value for the size setting when called up in Runtime in the property. .
OpenMultiple | Bool | Frame can be opened multiple times | Active : Multiple frames can be switched in runtime: Screens that are based on this frame are loaded when called up with a new frame instead of the same one. If it is the same screen, the screen is also loaded once again.Default: Inactive .
PosBottom | Int32 | Bottom [pixels] | Y coordinates of the lower right corner point of the template in pixels (based on the set monitor resolution). Minimum: -2147483648. Maximum: 2147483647. Default: Maximum current screen resolution. ATTENTION : We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring. .
PosHeight | Int32 | Height (maximum) [pixels] | Defines the maximum height of the frame in pixels, starting from the top anchor point.Maximum: 10000 Not present under CE .
PosLeft | Int32 | Left [pixels] | X coordinates of the upper left corner point of the template in pixels (based on the set resolution). Minimum: -2147483648. Maximum: 2147483647. Default: 0. ATTENTION : We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring. .
PosRight | Int32 | Right [pixels] | X coordinates of the lower right corner point of the template in pixels (based on the set monitor resolution). Minimum: -2147483648. Maximum: 2147483647. Default: Maximum current screen resolution. ATTENTION : We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring. .
PosTop | Int32 | Top [pixels] | Y coordinates of the upper left corner point of the template in pixels (based on the set resolution). Minimum: -2147483648. Maximum: 2147483647. Default: 0. ATTENTION : We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring. .
PosWidth | Int32 | Width (maximum) [pixels] | Defines the maximum width of the frame in pixels, starting from the left anchor point. Maximum: 10000 Not present under CE .
ShowForeground | Bool | Always in the foreground | Active: No other screen overlaps this area in on-line operation Screens in the background can be operated however. Inactive: Screens of this template can be covered by other screens. Default: inactive. .
ShowMinimize | Bool | Min./Max. buttons | Only available if the title is active. Active: Show Windows symbol field in the title bar. Inactive: Do not show the symbol field. Default: inactive. .
ShowSysMenu | Bool | System menu | Only available if the title is active. Active: Show Windows system menu in the title bar. Inactive: Do not show the system menu. Default: inactive. .
ShowTitle | Bool | Title | Only available if a border has been selected for the template : Active: Use Windows title bars for the screens of this template. The screens can be moved in Runtime. Inactive : Do not use a title bar. Default: inactive. .
StandardPosition | Bool | Use standard position | active: Places the frame for the alarm status line on the top border of the screen.Default: active .
Style | UInt32 | Window style | Window style
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
TemplateName | String | Name | Distinct name of the template.Maximum length:Project: 28 characters Global project: 27 characters Default: Template_x (x means a successive number). Note: If the name is changed, this must be entered again if required in the property. Otherwise the system driver variable [Project summary] Last screen open can no longer identify screens based on this frame. .


Frame template
ObjectModel COM [image] Template [image] DynProperties [image] Frame template
Overview
External Name | Type | Display Name | Description
BackgroundColor | UInt32 | Background color | Proposed background color for all screens that are newly defined on this frame .
BackgroundGraphicAlignment | Int16 | BackgroundGraphicAlignment | Description
BackgroundPicture | String | Graphics File | Selection of the background graphics for all newly-defined screens that are based on this frame.Click on the ... selection button to open the dialog for selecting a file. A change of the graphics file does not affect already existing screens which are based on this frame. .
BackgroundPictureStyle | Int16 | Alignment | Only available after you have selected a .Possible display types: tiled : Original size in tiles side by side.stretched : stretched to fill the whole screen.normal : Original size positioned in the top left corner. Centered : Original size, centered in the middle of the screen.Default: normal .You cannot move it freely.Note: A change of the orientation does not affect already existing screens which are based on this frame. .
BorderStyle | Int16 | Border type | Setting the type of frame. This also defines whether the size of the frame can be changed in Runtime.Size adjustable : The size of the frame can be changed in Runtime. A thick border is displayed around the frame.Size fixed : The size cannot be changed. A thin border is displayed around the frame.No border : The size cannot be changed. No border is displayed around the screen.Default: No border .
FrameBorderStyle | Int16 | FrameBorderStyle | Description
LimitationArea | UInt32 | Limitation | Only available if, for the property, the entry restrict to display borders has been selected.Defines the type of limit for the moving of frames:Frame border : The frame cannot be moved beyond the monitor limit.Frame border area : The frame can be moved beyond the monitor limit. However there must be an area on the monitor that can be accessed for further actions. The size of this border area can be configured with the property. .
LimitationContactPointSize | UInt32 | Minimum frame margin | Only available if the value for the property has been set to restrict to display borders and the property has been set to Frame border area .Defines the size of the frame border area in pixels. This area cannot be moved beyond the edge of the monitor. The defined range thus remains as an area to grab and move the frame in the visible area.Minimum: 0 Maximum: not defined If this area is defined as larger than the screen size or zoomed accordingly in Runtime, the screen acts as a limit on the frame border.Default: 30 .
LimitationType | UInt32 | Move | Defines possible settings when moving the object:without restrictionrestrict to display borders Note: The type of limitation is defined using the propertyNot available under Windows CE. .
MinSizeType | UInt32 | Limitation Minimum | Type of limit for the minimum value: .
MinSizeValue | UInt32 | Value (minimum) | Value for the setting selected in the property. .
OpeningSizeType | UInt32 | Opening size | Defines the size with which a screen based on this frame is called up in Runtime. .
OpeningSizeValue | UInt32 | Value (Opening size) | Value for the size setting when called up in Runtime in the property. .
OpenMultiple | Bool | Frame can be opened multiple times | Active : Multiple frames can be switched in runtime: Screens that are based on this frame are loaded when called up with a new frame instead of the same one. If it is the same screen, the screen is also loaded once again.Default: Inactive .
PosBottom | Int32 | Bottom [pixels] | Y coordinates of the lower right corner point of the template in pixels (based on the set monitor resolution). Minimum: -2147483648. Maximum: 2147483647. Default: Maximum current screen resolution. ATTENTION : We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring. .
PosHeight | Int32 | Height (maximum) [pixels] | Defines the maximum height of the frame in pixels, starting from the top anchor point.Maximum: 10000 Not present under CE .
PosLeft | Int32 | Left [pixels] | X coordinates of the upper left corner point of the template in pixels (based on the set resolution). Minimum: -2147483648. Maximum: 2147483647. Default: 0. ATTENTION : We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring. .
PosRight | Int32 | Right [pixels] | X coordinates of the lower right corner point of the template in pixels (based on the set monitor resolution). Minimum: -2147483648. Maximum: 2147483647. Default: Maximum current screen resolution. ATTENTION : We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring. .
PosTop | Int32 | Top [pixels] | Y coordinates of the upper left corner point of the template in pixels (based on the set resolution). Minimum: -2147483648. Maximum: 2147483647. Default: 0. ATTENTION : We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring. .
PosWidth | Int32 | Width (maximum) [pixels] | Defines the maximum width of the frame in pixels, starting from the left anchor point. Maximum: 10000 Not present under CE .
ShowForeground | Bool | Always in the foreground | Active: No other screen overlaps this area in on-line operation Screens in the background can be operated however. Inactive: Screens of this template can be covered by other screens. Default: inactive. .
ShowMinimize | Bool | Min./Max. buttons | Only available if the title is active. Active: Show Windows symbol field in the title bar. Inactive: Do not show the symbol field. Default: inactive. .
ShowSysMenu | Bool | System menu | Only available if the title is active. Active: Show Windows system menu in the title bar. Inactive: Do not show the system menu. Default: inactive. .
ShowTitle | Bool | Title | Only available if a border has been selected for the template : Active: Use Windows title bars for the screens of this template. The screens can be moved in Runtime. Inactive : Do not use a title bar. Default: inactive. .
Style | UInt32 | Window style | Window style
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
TemplateName | String | Name | Distinct name of the template.Maximum length:Project: 28 characters Global project: 27 characters Default: Template_x (x means a successive number). Note: If the name is changed, this must be entered again if required in the property. Otherwise the system driver variable [Project summary] Last screen open can no longer identify screens based on this frame. .


Templates
ObjectModel COM [image] Templates
Remarks

This collection contains the defined Frames. Each Screen is linked to a Frame, which holds general settings as the position, the name, ...The Frames of the global project are also available in this collection.The single Frames can be found in the collection by their unique names or their indices. Each Frame has to have a unique name.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Private Sub GetTemplates()
Dim IMDITemplates As MDITemplates
Dim IMDITemplate As MDITemplate
Dim Count As Integer
Dim Ok As Boolean
Dim i As Integer
' --- Selection by Name
Set IMDITemplates = MyWorkspace.GetMDiTemplates("Keyboard")
If Not IMDITemplates Is Nothing Then

Set IMDITemplate = IMDITemplates.Item("Test 3")

Ok = PrintTemplate(IMDITemplate)
End If
' --- Selection by index (zenon Constant)
Set IMDITemplates = MyWorkspace.GetMDiTemplates(tpKeyboard)
If Not IMDITemplates Is Nothing Then

Count = IMDITemplates.Count

For i = 0 To Count - 1

Set IMDITemplate = IMDITemplates.Item(i)

Ok = PrintTemplate(IMDITemplate)

Next
End If
End Sub
Private Function PrintTemplate(IMDITemplate As MDITemplate) As Boolean
If Not IMDITemplate Is Nothing Then

Debug.Print ("Name: " & IMDITemplate.DynProperties("Name"))

Debug.Print ("GUID: " & IMDITemplate.DynProperties("GUID"))

Debug.Print ("ImportPath: " & IMDITemplate.DynProperties("ImportPath"))

Debug.Print ("Folder: " & IMDITemplate.DynProperties("Folder"))

Debug.Print ("MDIType: " & IMDITemplate.DynProperties("MDIType"))

Debug.Print ("Language: " & IMDITemplate.DynProperties("Language"))

Debug.Print ("Description: " & IMDITemplate.DynProperties("Description"))

Debug.Print ("CopaDataTemplate: " & IMDITemplate.DynProperties("CopaDataTemplate"))

Debug.Print ("DefaultTemplate: " & IMDITemplate.DynProperties("DefaultTemplate"))

PrintTemplate = True
Else

PrintTemplate = False
End If
End Function


Properties
ObjectModel COM [image] Templates [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns count of the elements | Readonly | Readonly | Available | Available
Parent | iproject | The parent object of the current object | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] Templates [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Templates [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Templates [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | itemplate | Creates and returns a new Object | Available | Unused | Available | Available
Delete | variant_bool | Deletes the objects from collection | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
ExportToXmlByIndex | variant_bool |  | Available | Unused | Available | Available
ExportToXmlByName | variant_bool |  | Available | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
Item | itemplate | Returns a object at a position or by a specified key | Available | Available | Available | Available


Create
ObjectModel COM [image] Templates [image] Methods [image] Create
Remarks

Creates a new Frame and returns 'Template' object.

Datatype
ITemplate

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
szFileName as BSTR

bAddToCollection as VARIANT


Delete
ObjectModel COM [image] Templates [image] Methods [image] Delete
Remarks

Deletes the 'Template' object from the 'Templates' collection.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
szIdentification as BSTR


DynProperties [GET]
ObjectModel COM [image] Templates [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] Templates [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] Templates [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] Templates [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Export
ObjectModel COM [image] Templates [image] Methods [image] Export
Remarks

Export settings to an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


ExportToXmlByIndex
ObjectModel COM [image] Templates [image] Methods [image] ExportToXmlByIndex
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
p_index as long

p_fileNameOrFilePath as BSTR


ExportToXmlByName
ObjectModel COM [image] Templates [image] Methods [image] ExportToXmlByName
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
p_name as BSTR

p_fileNameOrFilePath as BSTR


Import
ObjectModel COM [image] Templates [image] Methods [image] Import
Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Item
ObjectModel COM [image] Templates [image] Methods [image] Item
Remarks

Returns the object Template from the collection, which is identified by the parameter vID. Hint: The Frames defined in the global project are added to the Frames of the current project. On accessing a Frame with its name it is first searched for in the current project. If it cannot be found there, it is searched for in the global project. The parameter vID can have two values: <ul> <li>Index: Access with an index mostly is used in combination with the property "Count" to find out the position of the variable object in the list.</li> <li>Frame name: The Frame can also be accessed with its unique name.</li> </ul> Hint: The returned object should be checked on Nothing, for the case that no object was found with the search criteria.

Datatype
ITemplate

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vID as VARIANT


TextList
ObjectModel COM [image] TextList
Remarks

TextList Class for the Text Lists API

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] TextList [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the amount of Text-List items | Unused | Available | Available | Available
Description | bstr | Returns the description of the Text-List | Unused | Available | Available | Available
Guid | bstr | Returns the Guid of the Text-List | Unused | Available | Available | Available
Name | bstr | Returns the name of the Text-List | Unused | Available | Available | Available
Parent | itextlist | Returns the parent object of the current object | Unused | Available | Available | Available
Removed | variant_bool | Returns the Removed status of the Text-List | Unused | Available | Available | Available


Count
ObjectModel COM [image] TextList [image] Properties [image] Count
Remarks

Returns the amount of Text-List Items (Read only)

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Description
ObjectModel COM [image] TextList [image] Properties [image] Description
Remarks

Returns the description of the Text-List

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Guid
ObjectModel COM [image] TextList [image] Properties [image] Guid
Remarks

Returns the ID of the Text-List

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] TextList [image] Properties [image] Name
Remarks

Returns the name of the Text-List

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] TextList [image] Properties [image] Parent
Remarks

Access to the parent Text-List

Datatype
ITextList

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Removed
ObjectModel COM [image] TextList [image] Properties [image] Removed
Remarks

Returns the Removed status of the Text-List

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] TextList [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | itextlist | Creates and returns new Text-List object | Unused | Available | Available | Available
Item | itextlist | Returns a object at a position or by a specified key | Unused | Available | Available | Available


Create
ObjectModel COM [image] TextList [image] Methods [image] Create
Remarks

Creates and returns new Text-List object

Datatype
ITextList

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

bsDescription as BSTR


Item
ObjectModel COM [image] TextList [image] Methods [image] Item
Remarks

Returns an object at a position or by a specified key

Datatype
ITextList

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT


TextListManager
ObjectModel COM [image] TextListManager
Remarks

Access to the Text Lists API in the Project

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] TextListManager [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns the amount of Text-List Items | Unused | Available | Available | Available
Parent | iproject | Returns the parent object of the current object | Unused | Available | Available | Available


Count
ObjectModel COM [image] TextListManager [image] Properties [image] Count
Remarks

Returns the amount of Text-List Items (Read only)

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] TextListManager [image] Properties [image] Parent
Remarks

Access to the parent project

Datatype
IProject

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] TextListManager [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | itextlist | Creates and returns new Text-List object | Unused | Available | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Unused | Available | Available | Available
Import | variant_bool | Imports the selected XML file | Unused | Available | Available | Available
Item | itextlist | Returns a object at a position or by a specified key | Unused | Available | Available | Available
Save | variant_bool | Saves the Text-List | Unused | Available | Available | Available


Create
ObjectModel COM [image] TextListManager [image] Methods [image] Create
Remarks

Creates and returns new Text-List object

Datatype
ITextList

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

bsDescription as BSTR


Export
ObjectModel COM [image] TextListManager [image] Methods [image] Export
Remarks

Exports the whole text list into the given file as XML. No popup dialog.sFileName = file location

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
C#
Copy
public void Macro_ExportTextLists()
{
  ITextListManager TextListManager = Project.TextListManager;
  string FileName = @"C:\Users\Oltion.Kuka\Desktop\ TextListToExport.XML ";
  TextListManager.Export(FileName); // the function returns a bool
}


Import
ObjectModel COM [image] TextListManager [image] Methods [image] Import
Remarks

Imports the given file into the text list, no popup dialogs. All existing textlists are removed from memory (RAM, from disk they are removed when textlists are saved)sFileName = file location

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
C#
Copy
public void Macro_ImportTextLists()
{
  ITextListManager TextListManager = Project.TextListManager;
  string FileName = @"C:\Users\Oltion.Kuka\Desktop\TextListToImport.XML";
  TextListManager.Import(FileName); // the function returns a bool
}


Item
ObjectModel COM [image] TextListManager [image] Methods [image] Item
Remarks

Returns an object at a position or by a specified key

Datatype
ITextList

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT


Save
ObjectModel COM [image] TextListManager [image] Methods [image] Save
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


Events
ObjectModel COM [image] TextListManager [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
SelectionChanged | void | This event is fired when the selection in the Text-List screen changes | Unused | Available | Available | Available
TextListsChanged | void | This event is fired when the data or structure from Text-List Items has changed | Unused | Available | Available | Available


SelectionChanged
ObjectModel COM [image] TextListManager [image] Events [image] SelectionChanged
Remarks

An event is fired when one or more entries of a textlist are selected. The parameter of the event is an array of all selected textlists.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
arrSelection as LPVARIANT

Example
C#
Copy
publicvoid Macro_EnableTextListEvents()
        {
            TextListManager.SelectionChanged += TextListManager_SelectionChanged;
            Project.Cel().WriteCelString("TextList events enabled");
        }

void TextListManager_SelectionChanged(refobject arrSelection)
        {
if (null == arrSelection)
            {
                Project.Cel().WriteCelString("Text list: no selection");
return;
            }

            Object[] selectedItems = (Object[])arrSelection;
for (int i = 0; i < selectedItems.Length; i++)
            {
                ITextList list = (ITextList)selectedItems[i];
                Project.Cel().WriteCelString(list.Name);
            }
        }

publicvoid Macro_DisbleTextListEvents()
        {
            TextListManager.SelectionChanged -= TextListManager_SelectionChanged;
            Project.Cel().WriteCelString("TextList events disabled");
        }
VBA
Copy
Option Explicit
Private WithEvents myEvent As TextListManager
Private Sub Project_Active()
 Set myEvent = thisProject.TextListManager
End Sub
Private Sub Project_Inactive()
Set myEvent = Nothing
End Sub
Private Sub myEvent_SelectionChanged(arrSelection As Variant)
Dim R As Long
If IsEmpty(arrSelection) Then
Else
    For R = 0 To UBound(arrSelection, 1)
        thisProject.Cel.WriteCelString (R)
        Dim TextToTest As TextList
        Set TextToTest = arrSelection(R)
        thisProject.Cel.WriteCelString (TextToTest.Name())
    Next R
End If
End Sub


TextListsChanged
ObjectModel COM [image] TextListManager [image] Events [image] TextListsChanged
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


TimeFunction
ObjectModel COM [image] TimeFunction
Remarks

The "TimeFunction" object, also called "Time control" in zenOn, enables the user to define function calls which should be executed at a defined (fixed) time or cyclically.When defining the time control functions for the month or year changes it is important to define the date correctly because this lays down the day after the month or year change on which the function is executed.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub CreateTimeFunction()
End Sub


Properties
ObjectModel COM [image] TimeFunction [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Active | variant_bool |  | Available | Readonly | Available | Available
Cycled | variant_bool |  | Available | Readonly | Available | Available
ID | long | Returns count of contained objects | Readonly | Readonly | Available | Available
IntervalTime | long | Returns count of contained objects | Available | Readonly | Available | Available
MonthSwitch | variant_bool | Returns time-function by position or ID | Available | Readonly | Available | Available
Name | bstr | Returns time-function by position or ID | Available | Readonly | Available | Available
Parent | itimefunctions | Parent of object | Readonly | Readonly | Available | Available
StartTime | date | Parent of object | Available | Readonly | Available | Available
YearSwitch | variant_bool |  | Available | Readonly | Available | Available


Active
ObjectModel COM [image] TimeFunction [image] Properties [image] Active
Remarks

If set TRUE, the time-function will be executed in the Runtime. Otherwise, the time-function is not executed in the Runtime. Hint: Time specific properties of the "TimeFunction" object can only be set if this property is set TRUE.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Cycled
ObjectModel COM [image] TimeFunction [image] Properties [image] Cycled
Remarks

Gets or sets if the execution of the function is done cyclic. Hint: In combination with the property "Cycled" the execution type for the "TimeFunction" object can be set. For further information please have a look at the "SetDaySelected" method.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ID
ObjectModel COM [image] TimeFunction [image] Properties [image] ID
Remarks

Returns the unique ID for the "TimeFunction" object.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


IntervalTime
ObjectModel COM [image] TimeFunction [image] Properties [image] IntervalTime
Remarks

Time interval, in which the function should be executed. The interval is defined in seconds. Hint: This property is only available, if the property "Cycled" is set to TRUE and the properties "MonthSwitch" and "YearSwitch" are deactivated.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


MonthSwitch
ObjectModel COM [image] TimeFunction [image] Properties [image] MonthSwitch
Remarks

If set TRUE, the function will only be executed on the turn of a month (Length of interval: 1 month). Otherwise, the setting from the property "IntervalTime" is used for the execution of the function. Hint: This property is only available, if the property "Cycled" is set to TRUE and property "YearSwitch" is deactivated.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] TimeFunction [image] Properties [image] Name
Remarks

Gets or sets the name of the "TimeFunction" object as string.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] TimeFunction [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
ITimeFunctions

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


StartTime
ObjectModel COM [image] TimeFunction [image] Properties [image] StartTime
Remarks

Gets or sets the start time when the function should be executed.

Datatype
DATE

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


YearSwitch
ObjectModel COM [image] TimeFunction [image] Properties [image] YearSwitch
Remarks

If set TRUE, the function will only be executed at the turn of a year (Length of interval: 1 year). Otherwise, the setting from the property "IntervalTime" is used for the execution of the function. Hint: This property is only available, if the property "Cycled" is set to TRUE and property "MonthSwitch" is deactivated.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] TimeFunction [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDaySelected | variant_bool | - | Available | Available | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
ItemRtFunction | irtfunction | - | Readonly | Readonly | Available | Available
SetDaySelected | void | - | Available | Available | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


CheckIn
ObjectModel COM [image] TimeFunction [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckOut
ObjectModel COM [image] TimeFunction [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


DynProperties [GET]
ObjectModel COM [image] TimeFunction [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] TimeFunction [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] TimeFunction [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] TimeFunction [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Get
ObjectModel COM [image] TimeFunction [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


IsCheckedOut
ObjectModel COM [image] TimeFunction [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDaySelected
ObjectModel COM [image] TimeFunction [image] Methods [image] IsDaySelected
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lDay as long


IsDifferent
ObjectModel COM [image] TimeFunction [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] TimeFunction [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


ItemRtFunction
ObjectModel COM [image] TimeFunction [image] Methods [image] ItemRtFunction
Remarks

Returns a "RtFunction" object with the function that was assigned by the creation of the "TimeFunction" object.

Datatype
IRtFunction

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


SetDaySelected
ObjectModel COM [image] TimeFunction [image] Methods [image] SetDaySelected
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lDay as long

bValue as VARIANT_BOOL

Example
VBA
Copy
Sub zenOn_TimeFunction_SetExecutionType(ByRef zTime As TimeFunction)
'Set execution type: "cyclic only on that day"
zTime.SetDaySelected 8, True
zTime.Cycled = True
'Set execution type: "only on that day"
zTime.SetDaySelected 8, True
zTime.Cycled = False
'Set execution type: "cyclic from that day"
zTime.SetDaySelected 8, False
zTime.Cycled = True
'Set execution type: "from that day"
zTime.SetDaySelected 8, False
zTime.Cycled = False

End Sub


UndoCheckOut
ObjectModel COM [image] TimeFunction [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


DynProperties
ObjectModel COM [image] TimeFunction [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Time function entry


Time function entry
ObjectModel COM [image] TimeFunction [image] DynProperties [image] Time function entry
Overview
External Name | Type | Display Name | Description
Active | Bool | Active | Active: The time function is active in Runtime. Inactive: The time function will not be displayed in Runtime Default: active. .
ExecuteDate | UInt32 | Start time | Date on which or from which the time function should be carried out. .
Friday | Bool | Friday | Active: Function is (also) executed on Fridays. Inactive: Function is not executed on Fridays. Default: active. .
Function | CProjektFunktion | Function | Selection of the function that is to be executed in a time-triggered manner. Clicking on the ... button opens the function selection dialog.If more than function is to be executed, then:Create a script that executes the functions.Link the function to execute the script. .
Interval | UInt32 | interval | Time interval in which the function is to be executed Default: 00:15:00 repeats the time function every 15 minutes.Note: This property is only suitable for intervals within 24 hours. To repeat a time function on several days, configure the desired days of the week in the group of properties. .
Monday | Bool | Monday | Active: Function is (also) executed on Mondays. Inactive: Function is not executed on Mondays. Default: active. .
Monthly | Bool | Interval one month | Only available if, for the the property, the cyclic value was selected.Active: The function is executed from the start time in intervals of one month.Inactive: The settings for the property are used.Default: Inactive .
Name | String | Name | Unique name of the time function.Default: Time function x (whereby x is a consecutive number). .
Saturday | Bool | Saturday | Active: Function is (also) executed on Saturdays. Inactive: Function is not executed on Saturdays. Default: active. .
Sunday | Bool | Sunday | Active: Function is (also) executed on Sundays. Inactive: Function is not executed on Sundays. Default: active. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Thursday | Bool | Thursday | Active: Function is (also) executed on Thursdays. Inactive: Function is not executed on Thursdays. Default: active. .
Tuesday | Bool | Tuesday | Active: Function is (also) executed on Tuesdays. Inactive: Function is not executed on Tuesdays. Default: active. .
Type | Int32 | Execution type | Selection of the type of execution:from that day : The function is executed from the set day, at the set time.only on that day : The function is only executed once on the set day, at the set time.cyclic from that day on : The function is executed from the set day, cyclically at the defined interval.cyclic only on that day : The function is only executed on the set working day, cyclically at the defined interval.Default: cyclic from that day on .
Wednesday | Bool | Wednesday | Active: Function is (also) executed on Wednesdays. Inactive: Function is not executed on Wednesdays. Default: active. .
Yearly | Bool | Interval one year | Only available if the property the value cyclic was selected.Active: The function is executed from the start time in intervals of one year.Inactive: The settings for the property are used.Default: Inactive .


TimeFunctions
ObjectModel COM [image] TimeFunctions
Remarks

This object manages "TimeFunction" objects.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub zenOn_TimeFunctions()
'Declarations
Dim zProject As Project
Dim zTimeFcts As TimeFunctions
Dim i As Integer
'Initialize zProject with the current project
Set zProject = MyWorkspace.ActiveDocument
'Initialize zTimeFcts with the "TimeFunction" object collection of the project
Set zTimeFcts = zProject.TimeFunctions
'Create a new "TimeFunction" object and assign the first available function to it
zTimeFcts.Create "zenOn_TimeFunction", zProject.RtFunctions.Item(0).ID
'For every "TimeFunction" object within the collection...
For i = 0 To zTimeFcts.Count - 1

'... output the name

Debug.Print zTimeFcts.Item(i).Name

Next i
'Delete the former created "TimeFunction" object
zTimeFcts.Delete "zenOn_TimeFunction"

End Sub


Properties
ObjectModel COM [image] TimeFunctions [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns count of contained objects | Readonly | Readonly | Available | Available
Parent | iproject | Parent of object | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] TimeFunctions [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] TimeFunctions [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] TimeFunctions [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | itimefunction | Creates and returns a new Object | Available | Unused | Available | Available
Delete | variant_bool | Deletes the objects from collection | Available | Unused | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
Item | itimefunction | Returns a object at a position or by a specified key | Available | Available | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index | Available | Unused | Available | Available


Create
ObjectModel COM [image] TimeFunctions [image] Methods [image] Create
Remarks

Creates a new "TimeFunction" object by its name as string and the unique ID of the function that should be assigned to the object.

Datatype
ITimeFunction

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

nFunctionID as long


Delete
ObjectModel COM [image] TimeFunctions [image] Methods [image] Delete
Remarks

Deletes an existing "TimeFunction" object by its name as string.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR


Export
ObjectModel COM [image] TimeFunctions [image] Methods [image] Export
Remarks

Export settings to an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Import
ObjectModel COM [image] TimeFunctions [image] Methods [image] Import
Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Item
ObjectModel COM [image] TimeFunctions [image] Methods [image] Item
Remarks

Returns the "TimeFunction" object from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "TimeFunction" object in the list.
Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype
ITimeFunction

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrPos as VARIANT


SingleExport
ObjectModel COM [image] TimeFunctions [image] Methods [image] SingleExport
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR


Units
ObjectModel COM [image] Units
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Units [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateDynProperty | variant_bool | - | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Unused | Available | Available
DynProperties [PUT] | void | - | Available | Unused | Available | Available
DynPropertiesEnum [GET] | variant | - | Available | Unused | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available


CreateDynProperty
ObjectModel COM [image] Units [image] Methods [image] CreateDynProperty
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties [GET]
ObjectModel COM [image] Units [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties [PUT]
ObjectModel COM [image] Units [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT


DynPropertiesEnum [GET]
ObjectModel COM [image] Units [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynPropertyParam [GET]
ObjectModel COM [image] Units [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Export
ObjectModel COM [image] Units [image] Methods [image] Export
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Import
ObjectModel COM [image] Units [image] Methods [image] Import
Remarks

Import setting using a xml file. New settings are added, existing settings will be replaced.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


DynProperties
ObjectModel COM [image] Units [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Unit manager


Unit manager
ObjectModel COM [image] Units [image] DynProperties [image] Unit manager
Overview
External Name | Type | Display Name | Description
Units | Node | Measuring Units | Node


CPrimaryUnit
ObjectModel COM [image] Units [image] DynProperties [image] Unit manager [image] CPrimaryUnit
Overview
External Name | Type | Display Name | Description
Name | String | Measuring unit | Statement of the base unit from which the conversion is carried out or the conversion unit in which the conversion carried out. For example C°, K, m, y, Celsius, Kelvin, meter, yard etc.You can use up to 50 characters. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
Units | Node | Measuring Units | Node


CSecondaryUnit
ObjectModel COM [image] Units [image] DynProperties [image] Unit manager [image] CPrimaryUnit [image] CSecondaryUnit
Overview
External Name | Type | Display Name | Description
DecShift | Int16 | Shift of the decimal point | Correction of the decimal places. This is the value about which the quantity of the decimal places is offset in the conversion unit compared with the case unit. .
Factor | double | Factor | Statement of the conversion factor with which the value of the base unit is converted to the value of the conversion unit (m for y=mx+b ). .
Name | String | Measuring unit | Statement of the base unit from which the conversion is carried out or the conversion unit in which the conversion carried out. For example C°, K, m, y, Celsius, Kelvin, meter, yard etc.You can use up to 50 characters. .
Offset | double | Offset | from primary unit (b for y=mx+b)Statement of the conversion offset with which the value of the base unit is converted to the value of the conversion unit (b for y=mx+b ). .


User
ObjectModel COM [image] User
Remarks

This object represents an user from the central user administration of the current project. The most important settings of the single users are available with this object.All available settings can be edited with VBA.The critical properties Identification and Password can only be edited with a method, whereas the properties Name and Level can be edited directly in the property.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub ChangeUser()
Dim zUser As User
Dim vResult As Variant
Set zUser = thisProject.Passwords.ItemUser(0)
Debug.Print zUser.Name & " will be changed"
'change the identification of the user
vResult = zUser.IdentificationChange("NewLogonName")
'change the password for the user
vResult = zUser.PasswordChange("P@ssword", "NewPassword")

End Sub


Properties
ObjectModel COM [image] User [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Active | variant_bool | Activate/Deactivate user | Available | Available | Available | Available
Admin | variant_bool | User has admin rights | Available | Available | Available | Available
CanPowerUserModifyPowerUsers | variant_bool |  | Available | Available | Available | Available
Identification | bstr | TagName | Readonly | Readonly | Available | Available
Level | long | Rights/Password-Levels 0 | Available | Available | Available | Available
Level1 | long | Rights/Password-Levels 1 | Available | Available | Available | Available
Level2 | long | Rights/Password-Levels 2 | Available | Available | Available | Available
Level3 | long | Rights/Password-Levels 3 | Available | Available | Available | Available
Locked | variant_bool | Lock/Unlock user | Available | Readonly | Available | Available
Name | bstr | Name | Available | Available | Available | Available
Parent | ipasswords | Parent-object | Readonly | Readonly | Available | Available
UserType | useradministrationusertype |  | Available | Available | Available | Available


Active
ObjectModel COM [image] User [image] Properties [image] Active
Remarks

Activate/Deactivate user

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Admin
ObjectModel COM [image] User [image] Properties [image] Admin
Remarks

User has admin rights

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


CanPowerUserModifyPowerUsers
ObjectModel COM [image] User [image] Properties [image] CanPowerUserModifyPowerUsers
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Identification
ObjectModel COM [image] User [image] Properties [image] Identification
Remarks

Returns the unique identification of the user. With this identification the user can be found in the central user administration. This property cannot be written directly – instead the method IdentificationChange is available, with which the identification of a user can be changed.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Level
ObjectModel COM [image] User [image] Properties [image] Level
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Level1
ObjectModel COM [image] User [image] Properties [image] Level1
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Level2
ObjectModel COM [image] User [image] Properties [image] Level2
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Level3
ObjectModel COM [image] User [image] Properties [image] Level3
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Locked
ObjectModel COM [image] User [image] Properties [image] Locked
Remarks

Lock/Unlock user

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] User [image] Properties [image] Name
Remarks

This property operates the name of the user. The name can be read as well as written. But be aware, that the name cannot have more than 30 characters.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] User [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IPasswords

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


UserType
ObjectModel COM [image] User [image] Properties [image] UserType
Remarks

Datatype
UserAdministrationUserType

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] User [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
IdentificationChange | variant_bool | Changes the TagName | Available | Unused | Available | Available
PasswordChange | variant_bool | Changes the password | Available | Available | Available | Available


DynProperties [GET]
ObjectModel COM [image] User [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] User [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] User [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] User [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


IdentificationChange
ObjectModel COM [image] User [image] Methods [image] IdentificationChange
Remarks

This method changes the unique identification of the user. If the same identification already exists, False is returned. If the identification does not exist yet, it is linked to the current user and saved. In this case the method returns True.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
szIdentification as BSTR


PasswordChange
ObjectModel COM [image] User [image] Methods [image] PasswordChange
Remarks

This method changes the password of the current user. If the parameter szOld is not true for the current password, False is returned. Otherwise the new password is confirmed and the cange is saved.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
szOld as BSTR

szNew as BSTR


DynProperties
ObjectModel COM [image] User [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

User
User list


User
ObjectModel COM [image] User [image] DynProperties [image] User
Overview
External Name | Type | Display Name | Description
Admin | Bool | Administrator | User is administrator. Selection with checkbox:Active: The user is administrator. As a result, this administrator can edit other users in Runtime and unlock the system. Inactive: This user is not an administrator and has configured user authorizations.Default: Inactive Attention: An administrator can only unlock authorization groups, which he also owns, for other users. .
CanPowerUserModifyPowerUsers | Bool | Power user can create/edit other power users | Only available if, for the property, Power user has been selected. .
GUID | String | GUID |
IsMsgCtrlUser | Bool | Message Control user | Active : User is used by Message Control. .
LockCode | String | Lock code | Four-digit PIN code.This code is used by the user to lock and unlock different areas. Using this code for locking avoids unintentionally unlocking a lock and therefore unnecessary accidents.
LoginRTP | Int32 | Runtime profile | Selection of the Runtime profile which should be allocated to the user at log in. Possible profiles:none: No profile is allocatedDEFAULT: Profile DEFAULT is allocated LAST: Profile LAST is allocatedDefault: none .
MsgEmail | String | Mail | E-mail address of the user .
MsgErsatzUser | String | Substitute person | Person which replaces the user if he cannot be reached. Click the ... button and a dialog opens to select a user. Only users who have been activated as Message Control users are offered for selection (see property ). .
MsgGSM | String | GSM | Cellphone number of the user. Used for messages via GSM and SMS (text messages).Enter numbers, the prefix + abbreviating 00 of the international area code is permitted. .
MsgNACKCode | String | NA code | Not-available code with which the user rejects the receipt of the message. Note: This code should differ considerably from the code of property . .
MsgPhone | String | Telephone | Fixed network telephone number of the user. Used for text to speech.Enter numbers, the prefix + abbreviating 00 of the international area code is permitted. .
MsgPinCode | String | PIN code | PIN code with which the user confirms the receipt of the message. Note: This code should differ considerably from the code of property . .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
UserActive | Bool | User active | Active: The user is accepted in Runtime. Inactive: The user is not accepted in Runtime Default: active. .
UserGroupsOrderImExpo | String | UserGroupsOrderImExpo |
UserLevel0 | UInt32 | UserLevel0 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
UserLevel1 | UInt32 | UserLevel1 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
UserLevel2 | UInt32 | UserLevel2 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
UserLevel3 | UInt32 | UserLevel3 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
UserLocked | Bool | Locked | Active: The user is blocked. Inactive: The user is not blocked. Default: inactive. A user is automatically blocked after a defined number of incorrect password entries. The block can be lifted here. Only an administrator can unblock a user, because only an administrator can edit a user. .
UserName | String | Complete name | Name of the user. For several user actions, the character string can be displayed in the Chronological Event List (CEL). It should be the full name of the user. In the CEL there is a column for the display of this information. In addition, this information can be displayed with the help of a system driver variable. More in the online manual .
UserType | Int32 | User type | Selection of the user type from a drop-down list:User : Can carry out actions according to the authorization levels they have been assigned.Power user : Can also create and edit users. Whether this is also applicable for other power users is configured using the Power user can create/edit other power users option.Administrator : Can create and edit all other users, and can cancel blocks.Default: User .


User list
ObjectModel COM [image] User [image] DynProperties [image] User list
Overview
External Name | Type | Display Name | Description
Admin | Bool | Administrator | User is administrator. Selection with checkbox:Active: The user is administrator. As a result, this administrator can edit other users in Runtime and unlock the system. Inactive: This user is not an administrator and has configured user authorizations.Default: Inactive Attention: An administrator can only unlock authorization groups, which he also owns, for other users. .
CanPowerUserModifyPowerUsers | Bool | Power user can create/edit other power users | Only available if, for the property, Power user has been selected. .
GUID | String | GUID |
IsMsgCtrlUser | Bool | Message Control user | Active : User is used by Message Control. .
LoginRTP | Int32 | Runtime profile | Selection of the Runtime profile which should be allocated to the user at log in. Possible profiles:none: No profile is allocatedDEFAULT: Profile DEFAULT is allocated LAST: Profile LAST is allocatedDefault: none .
MsgEmail | String | Mail | E-mail address of the user .
MsgErsatzUser | String | Substitute person | Person which replaces the user if he cannot be reached. Click the ... button and a dialog opens to select a user. Only users who have been activated as Message Control users are offered for selection (see property ). .
MsgGSM | String | GSM | Cellphone number of the user. Used for messages via GSM and SMS (text messages).Enter numbers, the prefix + abbreviating 00 of the international area code is permitted. .
MsgPhone | String | Telephone | Fixed network telephone number of the user. Used for text to speech.Enter numbers, the prefix + abbreviating 00 of the international area code is permitted. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
UserActive | Bool | User active | Active: The user is accepted in Runtime. Inactive: The user is not accepted in Runtime Default: active. .
UserGroupsOrderImExpo | String | UserGroupsOrderImExpo |
UserLevel0 | UInt32 | UserLevel0 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
UserLevel1 | UInt32 | UserLevel1 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
UserLevel2 | UInt32 | UserLevel2 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
UserLevel3 | UInt32 | UserLevel3 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
UserLocked | Bool | Locked | Active: The user is blocked. Inactive: The user is not blocked. Default: inactive. A user is automatically blocked after a defined number of incorrect password entries. The block can be lifted here. Only an administrator can unblock a user, because only an administrator can edit a user. .
UserName | String | Complete name | Name of the user. For several user actions, the character string can be displayed in the Chronological Event List (CEL). It should be the full name of the user. In the CEL there is a column for the display of this information. In addition, this information can be displayed with the help of a system driver variable. More in the online manual .
UserType | Int32 | User type | Selection of the user type from a drop-down list:User : Can carry out actions according to the authorization levels they have been assigned.Power user : Can also create and edit users. Whether this is also applicable for other power users is configured using the Power user can create/edit other power users option.Administrator : Can create and edit all other users, and can cancel blocks.Default: User .


UserGroup
ObjectModel COM [image] UserGroup
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Public Sub EnumUserGroup()
Dim zPRJ As Project
Dim zUGP As UserGroup
Dim i As Integer
Set zPRJ = MyWorkspace.ActiveDocument
For i = 0 To zPRJ.Passwords.CountUserGroup - 1

Set zUGP = zPRJ.Passwords.ItemUserGroup(i)

Debug.Print "Usergroup >>> " & zUGP.DynProperties("UserGroupName")

Debug.Print " Level 0-31 : " & zUGP.DynProperties("UserGroupLevel0")

Debug.Print " Level 32-63 : " & zUGP.DynProperties("UserGroupLevel1")

Debug.Print " Level 64-91 : " & zUGP.DynProperties("UserGroupLevel2")

Debug.Print " Level 92-127: " & zUGP.DynProperties("UserGroupLevel3")
Next i
End Sub
Public Sub CreateUserGroup()
Dim zPRJ As Project
Dim zUGP As UserGroup
Set zPRJ = MyWorkspace.ActiveDocument
Set zUGP = zPRJ.Passwords.CreateUserGroup("MyGroup", 255) 'Level 0-7
With zUGP

.DynProperties("UserGroupLevel0") = 255 'Level 0-7

.DynProperties("UserGroupLevel1") = 255 'Level 32-39

.DynProperties("UserGroupLevel2") = 255 'Level 64-71

.DynProperties("UserGroupLevel3") = 255 'Level 96-103
End With
End Sub


Methods
ObjectModel COM [image] UserGroup [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CreateDynProperty | variant_bool | - | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Unused | Available | Available
DynProperties [PUT] | void | - | Available | Unused | Available | Available
DynPropertiesEnum [GET] | variant | - | Available | Unused | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available


CreateDynProperty
ObjectModel COM [image] UserGroup [image] Methods [image] CreateDynProperty
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties [GET]
ObjectModel COM [image] UserGroup [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties [PUT]
ObjectModel COM [image] UserGroup [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT


DynPropertiesEnum [GET]
ObjectModel COM [image] UserGroup [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynPropertyParam [GET]
ObjectModel COM [image] UserGroup [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties
ObjectModel COM [image] UserGroup [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

UserGroup


UserGroup
ObjectModel COM [image] UserGroup [image] DynProperties [image] UserGroup
Overview
External Name | Type | Display Name | Description
GUID | String | GUID |
IsMsgCtrlGroup | Bool | Message Control group | Active : User group is used by Message Control. .
UserGroupLevel0 | UInt32 | UserGroupLevel0 |
UserGroupLevel1 | UInt32 | UserGroupLevel1 |
UserGroupLevel2 | UInt32 | UserGroupLevel2 |
UserGroupLevel3 | UInt32 | UserGroupLevel3 |
UserGroupName | String | Name | Name of the selected user group.Click in the input filed in order to change the name.Note: @ is not a valid character for a user group. .


VarAssignment
ObjectModel COM [image] VarAssignment
Remarks

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Example
VBA
Copy
'Create a new VarAssignment (Allocation)
Sub CreateAssignment()
Dim zVarAssign As VarAssignment
'create by NAME
Set zVarAssign = MyWorkspace.ActiveDocument.VarAssignments.Create("MyAssignment3", "WIZ_VAR_10", "WIZ_VAR_11")
'change settings
With zVarAssign

'set trigger type

.DynProperties("TriggerType") = 1

'set trigger variable by Name

.DynProperties("TriggerVariable") = "MyTrigger"
End With
End Sub


Properties
ObjectModel COM [image] VarAssignment [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ID | long | Set/Get unique ID for the object | Readonly | Readonly | Available | Available
Name | bstr | Set/Get the user-defined name | Available | Readonly | Available | Available
Parent | ivarassignments | Parent of object | Readonly | Readonly | Available | Available


ID
ObjectModel COM [image] VarAssignment [image] Properties [image] ID
Remarks

Get unique ID for the object

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] VarAssignment [image] Properties [image] Name
Remarks

Set/Get the user-defined name

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] VarAssignment [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IVarAssignments

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] VarAssignment [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ChangeSourceVariable | variant_bool | Change source (can be member of another project) | Available | Unused | Available | Available
ChangeTargetVariable | variant_bool | Change target (can be member of another project) | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
ItemSourceVariable | ivariable | Get the linked source variable | Readonly | Readonly | Available | Available
ItemTargetVariable | ivariable | Get the linked target variable | Readonly | Readonly | Available | Available


ChangeSourceVariable
ObjectModel COM [image] VarAssignment [image] Methods [image] ChangeSourceVariable
Remarks

Change source (can be member of another project).

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsProject as BSTR

nNewSourceID as long

Example
VBA
Copy
Sub CallChange()
ChangeAssignment MyWorkspace.ActiveDocument.VarAssignments.Item("MyAssignment")
End Sub
Sub ChangeAssignment(zVarAssign As VarAssignment)
Dim zSrcVar As Variable
Dim zDstVar As Variable
Dim strProject As String
Set zSrcVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_11")
Set zDstVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_12")
strProject = MyWorkspace.ActiveDocument.Name
'change the source and target variable
With zVarAssign

.ChangeSourceVariable strProject, zSrcVar.PvID

.ChangeTargetVariable strProject, zDstVar.PvID

End With
End Sub


ChangeTargetVariable
ObjectModel COM [image] VarAssignment [image] Methods [image] ChangeTargetVariable
Remarks

Change target (can be member of another project).

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsProject as BSTR

nNewTargetID as long

Example
VBA
Copy
Sub CallChange()
ChangeAssignment MyWorkspace.ActiveDocument.VarAssignments.Item("MyAssignment")
End Sub
Sub ChangeAssignment(zVarAssign As VarAssignment)
Dim zSrcVar As Variable
Dim zDstVar As Variable
Dim strProject As String
Set zSrcVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_11")
Set zDstVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_12")
strProject = MyWorkspace.ActiveDocument.Name
'change the source and target variable
With zVarAssign

.ChangeSourceVariable strProject, zSrcVar.PvID

.ChangeTargetVariable strProject, zDstVar.PvID
End With
End Sub


DynProperties [GET]
ObjectModel COM [image] VarAssignment [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] VarAssignment [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] VarAssignment [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] VarAssignment [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


ItemSourceVariable
ObjectModel COM [image] VarAssignment [image] Methods [image] ItemSourceVariable
Remarks

Datatype
IVariable

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ItemTargetVariable
ObjectModel COM [image] VarAssignment [image] Methods [image] ItemTargetVariable
Remarks

Datatype
IVariable

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


DynProperties
ObjectModel COM [image] VarAssignment [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Allocation entry


Allocation entry
ObjectModel COM [image] VarAssignment [image] DynProperties [image] Allocation entry
Overview
External Name | Type | Display Name | Description
Name | String | Name | Distinct name of the allocation. Default: Allocation x (where x means a successive number). .
SourceVariable | CProjektVariable | Source variable | Name of the variable whose value should be allocated to the target variable. Opens the dialog for selecting variables. .
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
TargetVariable | CProjektVariable | Target variable | Name of the variable whose value should be allocated to the source variable. Opens the dialog for selecting variables. .
TriggerType | UInt16 | Trigger type | Edge : The allocation is carried out if the value of the linked trigger variable changes from 0 to 1. Gage : The allocation is carried out as long as the value of the linked trigger variable is 1. Default: Edge. .
TriggerVariable | CProjektVariable | Trigger variable | The bit variable linked here triggers the allocation. If no variable is linked, the allocation is spontaneous. This means that whenever the value of the source variable changes, it is automatically written to the target variable. Opens the variable selection dialog, filtered for bit variables. .


VarAssignments
ObjectModel COM [image] VarAssignments
Remarks

The VarAssignments collection contains all existing allocations of the current project. With this collection you can access all or certain allocations.Additional to the access via the index the allocations can also be accessed via the unique name or the position.

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Example
VBA
Copy
'Create a new VarAssignment (Allocation)
Sub CreateAssignment()
Dim zVarAssign As VarAssignment
Dim zSrcVar As Variable
Dim zDstVar As Variable
'by NAME
Set zVarAssign = MyWorkspace.ActiveDocument.VarAssignments.Create("MyAssignment", "WIZ_VAR_10", "WIZ_VAR_11")
'OR by ID
Set zSrcVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_10")
Set zDstVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_11")
Set zVarAssign = MyWorkspace.ActiveDocument.VarAssignments.CreateByID("MyAssignment", zSrcVar.PvID, zDstVar.PvID)
End Sub
'Delete an VarAssignment (Allocation)
Sub DeleteAssignment()
Dim bResult As Boolean
'by NAME
bResult = MyWorkspace.ActiveDocument.VarAssignments.Delete("MyAssignment")
End Sub
'Enumerate all Assignements of the active project
Sub EnumAssignments()
Dim zVarAssign As VarAssignment
Dim zVarAssigns As VarAssignments
Dim i As Integer
'get collection of VarAssignements
Set zVarAssigns = MyWorkspace.ActiveDocument.VarAssignments
'enum all VarAssignments
For i = 0 To zVarAssigns.Count - 1

'get VarAssignment

Set zVarAssign = zVarAssigns.Item(i)

Debug.Print zVarAssign.Name & " [" & _

zVarAssign.DynProperties("SourceVariable").Name & " > " & _

zVarAssign.DynProperties("TargetVariable").Name & "]"
Next i
End Sub


Properties
ObjectModel COM [image] VarAssignments [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Returns count of contained objects | Readonly | Readonly | Available | Available
Parent | iproject | Parent of object | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] VarAssignments [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] VarAssignments [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] VarAssignments [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
Create | ivarassignment | Creates and returns a new Object | Available | Unused | Available | Available
CreateByID | ivarassignment | Creates and returns a new Object | Available | Unused | Available | Available
Delete | variant_bool | Deletes the objects from collection | Available | Unused | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
Item | ivarassignment | Returns a object at a position or by a specified key | Available | Unused | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index | Available | Unused | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


CheckIn
ObjectModel COM [image] VarAssignments [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckOut
ObjectModel COM [image] VarAssignments [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Create
ObjectModel COM [image] VarAssignments [image] Methods [image] Create
Remarks

Creates and returns a new Object

Datatype
IVarAssignment

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

bsSource as BSTR

bsTarget as BSTR

Example
VBA
Copy
'Create a new VarAssignment (Allocation)
Sub CreateAssignment()
Dim zVarAssign As VarAssignment
'by NAME
Set zVarAssign = MyWorkspace.ActiveDocument.VarAssignments.Create("MyAssignment",

"WIZ_VAR_10", "WIZ_VAR_11")
End Sub


CreateByID
ObjectModel COM [image] VarAssignments [image] Methods [image] CreateByID
Remarks

Creates and returns a new Object.

Datatype
IVarAssignment

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

nSourceID as long

nTargetID as long

Example
VBA
Copy
'Create a new VarAssignment (Allocation)
Sub CreateAssignment()
Dim zVarAssign As VarAssignment
Dim zSrcVar As Variable
Dim zDstVar As Variable
'OR by ID
Set zSrcVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_10")
Set zDstVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_11")
Set zVarAssign = MyWorkspace.ActiveDocument.VarAssignments.CreateByID("MyAssignment", zSrcVar.PvID, zDstVar.PvID)
End Sub


Delete
ObjectModel COM [image] VarAssignments [image] Methods [image] Delete
Remarks

Deletes the objects from collection

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

Example
VBA
Copy
'Delete an VarAssignment (Allocation)
Sub DeleteAssignment()
Dim bResult As Boolean
'by NAME
bResult = MyWorkspace.ActiveDocument.VarAssignments.Delete("MyAssignment")
End Sub


Export
ObjectModel COM [image] VarAssignments [image] Methods [image] Export
Remarks

Export settings to an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Get
ObjectModel COM [image] VarAssignments [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Import
ObjectModel COM [image] VarAssignments [image] Methods [image] Import
Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


IsCheckedOut
ObjectModel COM [image] VarAssignments [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDifferent
ObjectModel COM [image] VarAssignments [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] VarAssignments [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Item
ObjectModel COM [image] VarAssignments [image] Methods [image] Item
Remarks

Returns a object at a position or by a specified key

Datatype
IVarAssignment

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vID as VARIANT

Example
VBA
Copy
'Enumerate all Assignements of the active project
Sub EnumAssignments()
Dim zVarAssign As VarAssignment
Dim zVarAssigns As VarAssignments
Dim i As Integer
Set zVarAssigns = MyWorkspace.ActiveDocument.VarAssignments
For i = 0 To zVarAssigns.Count - 1

Set zVarAssign = zVarAssigns.Item(i)

Debug.Print zVarAssign.Name & " [" & _

zVarAssign.DynProperties("SourceVariable").Name & " > " & _

zVarAssign.DynProperties("TargetVariable").Name & "]"
Next i
End Sub


SingleExport
ObjectModel COM [image] VarAssignments [image] Methods [image] SingleExport
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR


UndoCheckOut
ObjectModel COM [image] VarAssignments [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


DynProperties
ObjectModel COM [image] VarAssignments [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Assignments


Assignments
ObjectModel COM [image] VarAssignments [image] DynProperties [image] Assignments
Overview

External Name

Type

Display Name

Description


Variable
ObjectModel COM [image] Variable
Remarks

The collection Variables contains all defined variables of the current project. With this collection you can access all or selected variables.Beside the access via the index a variable also can be found with its unique name or the unique channel Id.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub CreateVariable()
Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim zDrivers As Drivers 'Object from type Drivers
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zEdLimit As EdLimit 'Object from type EdLimit
'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Create a "intern driver" variable called "TestVariable" with object type "internal variable" and datatype "INT"
Set zVariable = zVariables.CreateVar("TestVariable", zDrivers.Item(0), 33, zVarTypes.Item("INT"))
'Create a limit at the "TestVariable"
zVariable.CreateEdLimit
'Select the first limit of the variable
Set zEdLimit = zVariable.EDLimitItem(0)
'Set the limit active
zEdLimit.Active = True
'Set limit text
zEdLimit.Text = "Limit reached"
'Set limit value to 10
zEdLimit.LimitValue = 10
'Set the limit as maximum
zEdLimit.IsMax = True
'Set the limit as alarm
zEdLimit.Alarm = True
'Limit should be recognized in the CEL
zEdLimit.Cel = True
Call CreateArrayVariable

End Sub
Sub CreateArrayVariable()
Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim zArrEl As Variable 'Object from type Variables
Dim zEdLimit As EdLimit 'Object from type EdLimit
Dim i As Integer
'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Create a "intern driver" array variable called "ArrayVar" from object type "internal variable", datatype "INT", start at index 1,
'dimension of 5 and automatic addressing
Set zVariable = zVariables.CreateArrayVar("ArrayVar", zDrivers.Item(0), 33,

zVarTypes.Item("INT"), 1, 5, 0, 0, True, False, False)
'Activate all array elements
For i = 0 To 4

zVariable.ActivateSubItem (i)
Next i
'Read the first array element
Set zArrEl = zVariable.SubItem(0)
'Create a limit at the array element
zArrEl.CreateEdLimit
'Select the first limit of the variable
Set zEdLimit = zArrEl.EDLimitItem(0)
'Set the limit active
zEdLimit.Active = True
'Set limit text
zEdLimit.Text = "Limit reached"
'Set limit value to 10
zEdLimit.LimitValue = 10
'Set the limit as maximum
zEdLimit.IsMax = True
'Set the limit as alarm
zEdLimit.Alarm = True
'Limit should be recognized in the CEL
zEdLimit.Cel = True

End Sub


Properties
ObjectModel COM [image] Variable [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Alignment | long |  | Available | Readonly | Available | Available
AlternateArchiveValue | variant |  | Available | Readonly | Available | Available
AlternateValue | variant | For internal use only | Available | Readonly | Available | Available
ArraySize | long |  | Available | Readonly | Available | Available
BaseType | ivartype |  | Readonly | Readonly | Available | Available
BitAddr | long |  | Available | Readonly | Available | Available
DataBlock | long |  | Available | Readonly | Available | Available
DataType | iec_types |  | Readonly | Readonly | Available | Available
Digits | short |  | Available | Available | Available | Available
IsArray | variant_bool |  | Readonly | Readonly | Available | Available
LastUpdateTime | date |  | Readonly | Readonly | Available | Available
LastUpdateTimeMilliSeconds | short |  | Readonly | Readonly | Available | Available
Name | bstr |  | Available | Readonly | Available | Available
NetAddr | long |  | Available | Readonly | Available | Available
Offset | long |  | Available | Readonly | Available | Available
Parent | ivariables |  | Readonly | Readonly | Available | Available
PvID | long |  | Readonly | Readonly | Available | Available
RangeMax | variant |  | Available | Available | Available | Available
RangeMin | variant |  | Available | Available | Available | Available
ReadOnly | variant_bool |  | Available | Readonly | Available | Available
Recourceslabel | bstr |  | Available | Readonly | Available | Available
SignalMax | variant |  | Available | Readonly | Available | Available
SignalMin | variant |  | Available | Readonly | Available | Available
StatusExtValue | long |  | Unused | Readonly | Available | Available
StatusString | bstr |  | Unused | Available | Available | Available
StatusValue | long |  | Unused | Readonly | Available | Available
StringLength | long |  | Available | Readonly | Available | Available
Tagname | bstr |  | Available | Readonly | Available | Available
Unit | bstr |  | Available | Available | Available | Available
UserValue | variant |  | Available | Available | Available | Available


Alignment
ObjectModel COM [image] Variable [image] Properties [image] Alignment
Remarks

Returns the alignment item of the addressing settings.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


AlternateArchiveValue
ObjectModel COM [image] Variable [image] Properties [image] AlternateArchiveValue
Remarks

Returns the alternate value of the variable. The alternate value of a variable is used in archives and the recipe group manager, if the current value is needed but not available, e.g. automatic filling of archives, no connection to the PLC, ...

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


AlternateValue
ObjectModel COM [image] Variable [image] Properties [image] AlternateValue
Remarks

Returns the alternate value of the variable. The alternate value of a variable is used in archives and the recipe group manager, if the current value is needed but not available, e.g. automatic filling of archives, no connection to the PLC, ...

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ArraySize
ObjectModel COM [image] Variable [image] Properties [image] ArraySize
Remarks

Returns the number of indices of the variable. A standard variable has no index. With array variables this property returns the defined size of the array.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


BaseType
ObjectModel COM [image] Variable [image] Properties [image] BaseType
Remarks

Returns informations about the datatype which is used at the variable.

Datatype
IVarType

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


BitAddr
ObjectModel COM [image] Variable [image] Properties [image] BitAddr
Remarks

Returns the bit number of a variable.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


DataBlock
ObjectModel COM [image] Variable [image] Properties [image] DataBlock
Remarks

Returns the number of the used data block.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


DataType
ObjectModel COM [image] Variable [image] Properties [image] DataType
Remarks

Returns the defined data type of the variable as a constant.

Datatype
IEC_TYPES

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Digits
ObjectModel COM [image] Variable [image] Properties [image] Digits
Remarks

Returns the number of digits from a real or lreal variable.

Datatype
short

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


IsArray
ObjectModel COM [image] Variable [image] Properties [image] IsArray
Remarks

Returns true if the variable is an array (ArraySize > 1).

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


LastUpdateTime
ObjectModel COM [image] Variable [image] Properties [image] LastUpdateTime
Remarks

Returns the time of the last update of the value.

NOTE:
Check the property IsOnline to make sure that the variable is advised, when you want to read this property to avoid errors! (> 6.21)

Datatype
DATE

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


LastUpdateTimeMilliSeconds
ObjectModel COM [image] Variable [image] Properties [image] LastUpdateTimeMilliSeconds
Remarks

Returns the milliseconds since the last update time.

NOTE:
Check the property IsOnline to make sure that the variable is advised, when you want to read this property to avoid errors! (> 6.21)

Datatype
short

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] Variable [image] Properties [image] Name
Remarks

Returns the name of a variable.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


NetAddr
ObjectModel COM [image] Variable [image] Properties [image] NetAddr
Remarks

Returns the net address of a variable.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Offset
ObjectModel COM [image] Variable [image] Properties [image] Offset
Remarks

Returns the offset of a variable.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Variable [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IVariables

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


PvID
ObjectModel COM [image] Variable [image] Properties [image] PvID
Remarks

Returns the unique variable ID (per project). With this ID a variable can be found in the central variables list of the project.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


RangeMax
ObjectModel COM [image] Variable [image] Properties [image] RangeMax
Remarks

Returns the maximal measuring range of a variable.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


RangeMin
ObjectModel COM [image] Variable [image] Properties [image] RangeMin
Remarks

Returns the minimal measuring range of a variable.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


ReadOnly
ObjectModel COM [image] Variable [image] Properties [image] ReadOnly
Remarks

Returns true if the variable is read only and false if it is readable+writeable.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Recourceslabel
ObjectModel COM [image] Variable [image] Properties [image] Recourceslabel
Remarks

Returns the resources label of the variable.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


SignalMax
ObjectModel COM [image] Variable [image] Properties [image] SignalMax
Remarks

Returns the maximal signal range of a variable.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


SignalMin
ObjectModel COM [image] Variable [image] Properties [image] SignalMin
Remarks

Returns the minimal signal range of a variable.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


StatusExtValue
ObjectModel COM [image] Variable [image] Properties [image] StatusExtValue
Remarks

Returns the status value for states where the higher 32 bits are set.For definition of Statis see StatusValueNOTE:
Check the property IsOnline to make sure that the variable is advised, when you want to read this property to avoid errors! (> 6.21)

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


StatusString
ObjectModel COM [image] Variable [image] Properties [image] StatusString
Remarks

Returns the status of a variable.

For definition of Statis see StatusValue

NOTE:
Check the property IsOnline to make sure that the variable is advised, when you want to read this property to avoid errors! (> 6.21)

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


StatusValue
ObjectModel COM [image] Variable [image] Properties [image] StatusValue
Remarks

The returned value corresponds to the status of a variable.

Status | Abbreviations in editor | Value (hex)
Invalid | I-BIT | 0x00040000
Not updated | not used | 0x20000000
Alternative value | read only | 0x08000000
General request | yes | 0x00010000
Spontaneous | yes | 0x00020000
Summer/winter time announcement | SU/WI | 0x00080000
Switched off | N_UPDATE | 0x00080000
Realtime external | RT_E | 0x00200000
Realtime internal | RT_I | 0x00400000
Winter time | WINTER | 0x80000000
Manual value | MVALUE | 0x00001000
User status 1 .. 8 | ST_M1 .. ST_M8 | 0x00000001- 0x00000080
Select | SELEC | 0x00000100
Revision | REV | 0x00000200
Desired direction | DIREC | 0x00000400
Runtime exceeded | RTE | 0x00000800
Default message trafo value | DM_TR | 0x01000000
Not sortable | NSORT | 0x00800000
Info for variable | INFO | 0x04000000
Transmission cause | TCBx | 0x0000003F00000000
P/N bit | PN_BIT | 0x0000004000000000
Test bit | T_BIT | 0x0000008000000000
Normal status | NORM | 0x0000040000000000
Deviation normal status | ABNORM | 0x0000080000000000
NOTE:
Check the property IsOnline to make sure that the variable is advised, when you want to read this property to avoid errors! (> 6.21)

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


StringLength
ObjectModel COM [image] Variable [image] Properties [image] StringLength
Remarks

Returns the length of a string variable.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Tagname
ObjectModel COM [image] Variable [image] Properties [image] Tagname
Remarks

Returns the identification of the variable.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Unit
ObjectModel COM [image] Variable [image] Properties [image] Unit
Remarks

Returns the defined unit of the variable. The unit specifies the value of the variable, e.g. degrees Celcius, .... The configuration of most modules allows the display of the unit, e.g. numerical value, archive picture, ... This property can be changed in the Runtime.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


UserValue
ObjectModel COM [image] Variable [image] Properties [image] UserValue
Remarks

This property can get a user defined value and is not used for the Runtime. In VBA a variant can be linked with the variable, that is needed at a later moment. This variant could e.g. be the Id for a record in a SQL database, that contains further information on the variable.

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Variable [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ActivateSubItem | variant_bool | - | Available | Unused | Available | Available
CalcPrimaryUnitValue | double | - | Unused | Available | Available | Available
CalcSecondaryUnitValue | double | - | Unused | Available | Available | Available
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
CreateDynProperty | variant_bool | - | Available | Unused | Available | Available
CreateEdLimit | iedlimit | - | Available | Unused | Available | Available
DeactivateSubItem | variant_bool | - | Available | Unused | Available | Available
DeleteEdLimit | variant_bool | - | Available | Unused | Available | Available
Driver | idriver |  | Available | Available | Available | Available
DynProperties [GET] | variant |  | Available | Available | Available | Available
DynProperties [PUT] | void |  | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant |  | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
EdLimitCount | long |  | Readonly | Unused | Available | Available
EdLimitItem | iedlimit |  | Available | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
GetCurrentViolatedLimit | ilimit | Returns the current violated limit, if there is one. | Unused | Available | Available | Available
GetCurrentViolatedRema | istate | Returns the current violated rema state. | Unused | Available | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLimitActiv | variant_bool | - | Available | Available | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
IsOnline | variant_bool | - | Unused | Readonly | Available | Available
IsRDAActiv | variant_bool | - | Readonly | Readonly | Available | Available
IsRemaActiv | variant_bool | - | Readonly | Readonly | Available | Available
Limits | ilimits | - | Unused | Available | Available | Available
ModifyAlternateValue | void | - | Available | Available | Available | Available
SecondaryUnitDigits [GET] | short | - | Unused | Available | Available | Available
SecondaryUnitName [GET] | bstr | - | Unused | Available | Available | Available
SetValueWithStatus | void | - | Unused | Available | Available | Available
SubItem | ivariable | - | Available | Readonly | Available | Available
SubItemCount | long | - | Readonly | Readonly | Available | Available
SubItemName | bstr | - | Available | Readonly | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available
Value [GET] | variant | - | Unused | Available | Available | Available
Value [PUT] | void | - | Unused | Available | Available | Available


ActivateSubItem
ObjectModel COM [image] Variable [image] Methods [image] ActivateSubItem
Remarks

This method activates an array or a structure element. Returns true when element has been activated, false if no change has been done.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vSubItem as VARIANT

Example
VBA
Copy
Sub ActiveSubItem()
Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim actSubItem As Boolean 'Status variable
'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
'Array variable called "array" with some elements should be available
Set zVariable = zVariables.Item("array")
'Element "array[2]" is activated
actSubItem = zVariable.ActivateSubItem("array[2]")
Debug.Print "Activated = " & actSubItem

End Sub


CalcPrimaryUnitValue
ObjectModel COM [image] Variable [image] Methods [image] CalcPrimaryUnitValue
Remarks

Datatype
double

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
dfSecondaryValue as double


CalcSecondaryUnitValue
ObjectModel COM [image] Variable [image] Methods [image] CalcSecondaryUnitValue
Remarks

Datatype
double

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
dfPrimaryValue as double


CheckIn
ObjectModel COM [image] Variable [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckOut
ObjectModel COM [image] Variable [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CreateDynProperty
ObjectModel COM [image] Variable [image] Methods [image] CreateDynProperty
Remarks

This method creates a dynamic property.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub EdLimDynProp()
Dim zVariable As Variable 'Child object from type Variables
'Take the first variable from the variables list
Set zVariable = MyWorkspace.ActiveDocument.Variables.Item(0)
'Create a limit
zVariable.CreateDynProperty ("Limits")
'Set the limit text
zVariable.DynProperties("Limits[0].Text") = "Limit reached"
'Set the limit value
zVariable.DynProperties("Limits[0].LimitValue") = 10
'Set the value as maximum
zVariable.DynProperties("Limits[0].IsMax") = True

End Sub


CreateEdLimit
ObjectModel COM [image] Variable [image] Methods [image] CreateEdLimit
Remarks

This method creates a limit at a variable.

Datatype
IEdLimit

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub CreateEDLimit()
Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim zDrivers As Drivers 'Object from type Drivers
Dim zVarTypes As VarTypes 'Object from type VarTypes
'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Create a "intern driver" variable called "TestVariable" with object type "internal variable" and datatype "INT"
Set zVariable = zVariables.CreateVar("TestVariable", zDrivers.Item(0), 33, zVarTypes.Item("INT"))
'Create a editor limit at the "TestVariable"
zVariable.CreateEdLimit

End Sub


DeactivateSubItem
ObjectModel COM [image] Variable [image] Methods [image] DeactivateSubItem
Remarks

This method deactivates array or structure elements.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vSubItem as VARIANT

Example
VBA
Copy
Sub DeActivateSubItem()
Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim actSubItem As Boolean 'Status variable
'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
'Array variable called "array" with some elements should be available
Set zVariable = zVariables.Item("array")
'Element "array[2]" is deactivated
actSubItem = zVariable.DeActivateSubItem("array[2]")
Debug.Print "Activated = " & actSubItem

End Sub


DeleteEdLimit
ObjectModel COM [image] Variable [image] Methods [image] DeleteEdLimit
Remarks

This method deletes selected limits of a variable.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT

Example
VBA
Copy
Sub DeleteEDLimit()
Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim zDrivers As Drivers 'Object from type Drivers
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim i As Integer
'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Create a "intern driver" variable called "TestVariable" with object type "internal variable" and datatype "INT"
Set zVariable = zVariables.CreateVar("TestVariable", zDrivers.Item(0), 33, zVarTypes.Item("INT"))
'Create 5 editor limits at the "TestVariable"
For i = 0 To 4

zVariable.CreateEdLimit
Next i
'Delete the 2nd limit
zVariable.DeleteEDLimit (1)

End Sub


Driver
ObjectModel COM [image] Variable [image] Methods [image] Driver
Remarks

Datatype
IDriver

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


DynProperties [GET]
ObjectModel COM [image] Variable [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynProperties [PUT]
ObjectModel COM [image] Variable [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT


DynPropertiesEnum [GET]
ObjectModel COM [image] Variable [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


DynPropertyParam [GET]
ObjectModel COM [image] Variable [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


EdLimitCount
ObjectModel COM [image] Variable [image] Methods [image] EdLimitCount
Remarks

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


EdLimitItem
ObjectModel COM [image] Variable [image] Methods [image] EdLimitItem
Remarks

Datatype
IEdLimit

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT


Get
ObjectModel COM [image] Variable [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


GetCurrentViolatedLimit
ObjectModel COM [image] Variable [image] Methods [image] GetCurrentViolatedLimit
Remarks

Returns the currently violated limit of a Variable (returns a Limit object – works only in case, that no REMA is linked) If a REMA is linked or there’s no currently violated limit the function will return "NULL"/ "NOTHING"

Datatype
ILimit

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Variable1.GetCurrentViolatedLimit.DynProperties("Status")
Variable1.GetCurrentViolatedLimit.DynProperties("UserProperty1")
Variable1.GetCurrentViolatedLimit.DynProperties("UserProperty2")
Variable1.GetCurrentViolatedLimit.DynProperties("HelpFile")
Variable1.GetCurrentViolatedLimit.DynProperties("HelpTopic")
Variable1.GetCurrentViolatedLimit.DynProperties("FunctionID")


GetCurrentViolatedRema
ObjectModel COM [image] Variable [image] Methods [image] GetCurrentViolatedRema
Remarks

Returns the currently violated state of a Rema (returns a State object – works only if a REMA is linked at the Variable). If no REMA is linked "NULL/NOTHING" will be returned. If none of the "limit" states is violated the Defaultstate will be returned.

Datatype
IState

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


IsCheckedOut
ObjectModel COM [image] Variable [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDifferent
ObjectModel COM [image] Variable [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLimitActiv
ObjectModel COM [image] Variable [image] Methods [image] IsLimitActiv
Remarks

This method returns true for limits activated and false for reaction matrix activated.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] Variable [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsOnline
ObjectModel COM [image] Variable [image] Methods [image] IsOnline
Remarks

This method checks, if the current variable is advised and has a valid value.A variable will be advised when: - the variable is actually displayed in a picture... - the variable has defined alarms... - the variable is used within VBA (OnlineVariable)... - the variable has set the option "DDE"... - ...

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


IsRDAActiv
ObjectModel COM [image] Variable [image] Methods [image] IsRDAActiv
Remarks

This method returns true if RDA is activated at a variable.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


IsRemaActiv
ObjectModel COM [image] Variable [image] Methods [image] IsRemaActiv
Remarks

This method returns true if a variable is linked to a reaction matrix.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Limits
ObjectModel COM [image] Variable [image] Methods [image] Limits
Remarks

Returns the limit administration of the variable. In the limit administration you can access the single limits with their most important information.

Datatype
ILimits

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub Limit()
Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim zLimit As Limit 'Object from type Limit
'Fill the objects
Set zVariables = thisProject.Variables
'Read the "TestVariable" variable
Set zVariable = zVariables.Item("TestVariable")
'Read the first limit of the variable
Set zLimit = zVariable.Limits.Item(0)
'Show the alarm class
Debug.Print "AlarmClass = " & zLimit.AlarmClass
'Show the limit text
Debug.Print "Limit text = " & zLimit.Text
'Show the limit value
Debug.Print "Limit value = " & zLimit.Value
'Show if the value is the maximum
Debug.Print "Acts on maximum = " & zLimit.IsMax

End Sub


ModifyAlternateValue
ObjectModel COM [image] Variable [image] Methods [image] ModifyAlternateValue
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
newValue as VARIANT


SecondaryUnitDigits [GET]
ObjectModel COM [image] Variable [image] Methods [image] SecondaryUnitDigits [GET]
Remarks

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


SecondaryUnitName [GET]
ObjectModel COM [image] Variable [image] Methods [image] SecondaryUnitName [GET]
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available


SetValueWithStatus
ObjectModel COM [image] Variable [image] Methods [image] SetValueWithStatus
Remarks

This method sets a value in combination with a status and a timestamp.

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
Value as VARIANT

Status as long

Time as long

TimeMilliSec as short

Example
VBA
Copy
Sub SetValue()
Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
'Fill the objects
Set zVariables = thisProject.Variables
'Take the first variable
Set zVariable = zVariables.Item(0)
'Write value 10, status I-BIT, with the actual time and 333 ms onto the variable
zVariable.SetValueWithStatus 10, 262144, Now, 333

End Sub


SubItem
ObjectModel COM [image] Variable [image] Methods [image] SubItem
Remarks

With this method you get array and structure elements by index.

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lIndex as long

Example
VBA
Copy
Sub SubItem()
Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim cacheElement As Variable 'Child object from type Variables
Dim zEdLimit As EdLimit 'Object form type EdLimit
Dim zDrivers As Drivers 'Object from type Drivers
Dim zVarTypes As VarTypes 'Object from type VarTypes
'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Create a "intern driver" array variable called "array" from object type "internal variable", datatype "INT", start at index 1,
'dimension of 5 and automatic addressing
Set zVariable = zVariables.CreateArrayVar("array", zDrivers.Item(0), 33, zVarTypes.Item("INT"), 1, 5, 0, 0, True, False, False)
'Activate all array elements
For i = 0 To 4

zVariable.ActivateSubItem (i)
Next i
'Read the first element from the array
Set cacheElement = zVariable.SubItem(0)
'Create a limit at the array element
cacheElement.CreateEdLimit
'Select the first limit of the variable
Set zEdLimit = cacheElement.EDLimitItem(0)
'Set the limit active
zEdLimit.Active = True
'Set limit text
zEdLimit.Text = "Limit reached"
'Set limit value to 10
zEdLimit.LimitValue = 10
'Set the limit as maximum
zEdLimit.IsMax = True
'Set the limit as alarm
zEdLimit.Alarm = True
'Limit should be recognized in the CEL
zEdLimit.Cel = True

End Sub


SubItemCount
ObjectModel COM [image] Variable [image] Methods [image] SubItemCount
Remarks

This method returns the number of sub items in an array or structure.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub CountItems()
Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim zDrivers As Drivers 'Object from type Drivers
Dim zVarTypes As VarTypes 'Object from type VarTypes
'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Create a "intern driver" array variable called "array" from object type "internal variable", datatype "INT", start at index 1,
'dimension of 5 and automatic addressing
Set zVariable = zVariables.CreateArrayVar("array", zDrivers.Item(0), 33, zVarTypes.Item("INT"), 1, 5, 0, 0, True, False, False)
'Activate all array elements
For i = 0 To 4
zVariable.ActivateSubItem (i)
Next i
Debug.Print "Count items = " & zVariable.SubItemCount

End Sub


SubItemName
ObjectModel COM [image] Variable [image] Methods [image] SubItemName
Remarks

This method returns the name of an array or structure item.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
lIndex as long

Example
VBA
Copy
Sub SubItemNames()
Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim zDrivers As Drivers 'Object from type Drivers
Dim zVarTypes As VarTypes 'Object from type VarTypes
'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Create a "intern driver" array variable called "array" from object type "internal variable", datatype "INT", start at index 1,
'dimension of 5 and automatic addressing
Set zVariable = zVariables.CreateArrayVar("array", zDrivers.Item(0), 33, zVarTypes.Item("INT"), 1, 5, 0, 0, True, False, False)
'Activate all array elements
For i = 0 To 4

zVariable.ActivateSubItem (i)
Next i
'Show the name of all array elements

For i = 0 To zVariable.SubItemCount - 1
Debug.Print "Name of first sub item = " & zVariable.SubItemName(i)
Next i

End Sub


UndoCheckOut
ObjectModel COM [image] Variable [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Value [GET]
ObjectModel COM [image] Variable [image] Methods [image] Value [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT


Value [PUT]
ObjectModel COM [image] Variable [image] Methods [image] Value [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT

newValue as VARIANT


DynProperties
ObjectModel COM [image] Variable [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

3S_Arti_NG variable ED
ADP variable ED
AKDrv variable ED
AMISTS variable ED
BACnetNG variable ED
Base class variable
BeckhoffNG variable ED
Biffi variable ED
BURPVI variable ED
CISPIPVarED
CPhloemVarED
CTI variable ED
DNP1 variable ED
DNP3 variable ED
Driver name variable ED
EibV2 variable ED
Elrest variable ED
IEC61850 variable ED
IEC62056 variable ED
IEC870 variable ED
IEC870_103 variable ED
iLon100 variable ED
Internal variable ED
Internal variable RT
Lon32 - variable ED
MathDr32 - variable ED
Mathematical variable RT
NWMDRV32 - variable ED
OPCUA variable ED
Sample32 variable ED
SE_32 variable ED
SE_32 variable ED function
SPRECON870 variable ED
Sys2000 variable ED
SysDrv variable ED
Syskron variable ED
Variable ED
Variable RT


3S_Arti_NG variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] 3S_Arti_NG variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] 3S_Arti_NG variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


ADP variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] ADP variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SourceVariables

Node

SourceVariables

Description

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VarSelector

CProjektVariable

Selector

The linked variable contains the information of which variable of a process driver is used. The value of the linked variable calls up a source variable configured in the property for the real process.Click on ... to open the variable selection dialog.Default: Empty With continuous project configuration: The last linked variable More in the driver manual for the ADP driver .

VarSelectorStatus

CProjektVariable

State variable

The value of the variable contains the information of which source variable is used in the real process.Click on ... to open the variable selection dialog.More in the driver manual for the ADP driver .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CADPSourceVariable
ObjectModel COM [image] Variable [image] DynProperties [image] ADP variable ED [image] CADPSourceVariable
Overview
External Name | Type | Display Name | Description
Priority | UInt32 | Priority | Description
Source | CProjektVariable | Source | Description


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] ADP variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


AKDrv variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] AKDrv variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

B_NR

SByte

B_NR

Baugruppennummer bzw. Octet 3 (IOA1)

B_NR

SByte

B_NR

Board number or Octet 3 (IOA1)

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DA

SByte

DA

Datenart bzw. Octet 5 (IOA3)

DA

SByte

DA

Data type or Octet 5 (IOA3)

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

DP_TYPE

UInt16

DP_TYPE

Telegrammtyp, Typkennung

DP_TYPE

UInt16

DP_TYPE

Telegram type, Message type

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

EW

double

EW

Ersatzwert auf den umgeschaltet wird.

EW

double

EW

Substitute value to be switched on

EW_INI

Bool

EW_INI

Ersatzwert Initialisierung Aktiv: Ersatzwert in der Runtime wird durch Normalzustand überschriebenInaktiv: Ersatzwert wird beibehalten

EW_INI

Bool

EW_INI

Initialization of substitute value Active: Substitute value will be overwritten in runtime by normal stateInactive: Substitute value will be kept

EWB

Bool

EWB

Auf Ersatzwert schalten Aktiv: Ersatzwert wird verwendetInaktiv: Ersatzwert wird nicht verwendet

EWB

Bool

EWB

Switch to substitute value Active : Substitute value will be usedInactive : Substitute value will not be used

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

K_2

SByte

K_2

Redundante PeripherieadresseKomponentennummer bzw. Octet 2 (CASDU2)

K_2

SByte

K_2

Redundant datapoint addressRegion number or Octet 2 (CASDU2)

K_NR

SByte

K_NR

Komponentennummer bzw. Octet 2 (CASDU2)

K_NR

SByte

K_NR

Component number or Octet 2 (CASDU2)

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

MERKER

Bool

MERKER

Aktiv: Variable ohne Prozessbezug (Adresse wird nicht geprüft; für interne Verwendung)siehe auch Interntreiber Inaktiv: Variable wird vom Prozess aktualisiert

MERKER

Bool

MERKER

Active: Datapoint will not be updated by process value (can be used as internal variable, doesn't need a datapoint address)Inactive: Datapoint will be updated by process valuesee also Driver Intern

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

PT

SByte

PT

Pointnummer bzw. Octet 6

PT

SByte

PT

Point number or Octet 6

R_2

SByte

R_2

Redundante PeripherieadresseRegionsnummer bzw. Octet 1 (CASDU1)

R_2

SByte

R_2

Redundant datapoint addressRegion number or Octet 1 (CASDU1)

R_NR

SByte

R_NR

Regionsnummer bzw. Octet 1 (CASDU1)

R_NR

SByte

R_NR

Region number or Octet 1 (CASDU1)

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

RED

Bool

RED

Redundante Adresse Aktiv: Redundante Adresse verwendenInaktiv: Keine redundante Adresse

RED

Bool

RED

Redundant address Active : Use redundant addressInactive : No redundant address

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

Send

Bool

Send

Prozessrichtung Empfangen: Datenpunkt wird nur empfangen (z.B. Meldungen, Messwerte)Senden: Datenpunkt wird gesendet (z.B. Befehle, Sollwerte).Damit ein Datenpunkt gesendet werden kann, muss auch SW setzen aktiv aktiviert sein (siehe "Sollwert setzen").

Send

Bool

Send

Process direction Receive: Datapoint will be received only (e.g. messages, measuring values)Send: Datapoint will be sent (e.g. commands, setpoints).To be able to be sent, the datapoint has to have also the Set value active property active (see "Set value").

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

VTA

Bool

VTA

Adresstyp Muss mit Parametrierung in GW1703.ini und der Gegenstelle übereinstimmen.STA: SystemtechnischVTA: Verfahrenstechnisch

VTA

Bool

VTA

Address type In accordance to parameterization of GW1703.ini and remote station.STA: System technicalVTA: Process technical (PTA in GW1703.ini)

W_NR

SByte

W_NR

Wertnummer bzw. Octet 4 (IOA2)

W_NR

SByte

W_NR

Value number or Octet 4 (IOA2)

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

Z_NR

SByte

Z_NR

LAN-Stations- oder LAN-Gruppennummer Bei serieller Ankopplung Linkadresse

Z_NR

SByte

Z_NR

LAN station or LAN group number Link address if serial connection

Z_TYP

Bool

Z_TYP

Auswahl LAN-Station oder LAN-Gruppe

Z_TYP

Bool

Z_TYP

Selection of LAN station or LAN group

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] AKDrv variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


AMISTS variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] AMISTS variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] AMISTS variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


BACnetNG variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] BACnetNG variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BACnetDataType

UInt32

BACnetDataType

Define how a numeric variable or a string variable is mapped onto a BACnet property. Select the desired data type from the drop-down list. You can find the description of the possible data types in the manual for the BACnet NG driver in the "Data types supported by the driver for BACnet object properties" chapter.More in the driver manual for the BACnet NG driver .

BACnetEventState

Int32

BACnetEventState

Display state of the event state as number. In this case you can freely define the text for the event state .Values:-1: Text is used 0: Normal 1: Fault 2: Off-normal 3: High-limit 4: Low-limit 5: Life-safety-alarm Default: -1 More in the driver manual for the BACnet NG driver .

BACnetObjectInstanceID

UInt32

BACnetObjectInstanceID

BACnetObjectName

String

BACnetObjectName

BACnetObjectType

UInt16

BACnetObjectType

BACnetPropertyID

Int32

BACnetPropertyID

Set the parameters for the Property ID for user-specific properties or if you do not want to state the property in the name or identification.Note : Only if you set -1 , the property is determined via the name or identification.More in the driver manual for the BACnet NG driver .

BACnetStringLength

UInt32

BACnetStringLength

Only available if you have selected the BITSTRING data type for the property.Define the length of the bit strings in bit.More in the driver manual for the BACnet NG driver .

BACnetTrendVarType

Int32

BACnetTrendVarType

BACnetWritePriority

Byte

BACnetWritePriority

Enter the writing priority with which the variable is written. If you enter 0, the variable is written without a writing priority.16 Lowest priority:1 Highest priority:Possible values are 0 - 16.Default: 0 More in the driver manual for the BACnet NG driver .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] BACnetNG variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Base class variable
ObjectModel COM [image] Variable [image] DynProperties [image] Base class variable
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] Base class variable [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


BeckhoffNG variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] BeckhoffNG variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] BeckhoffNG variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Biffi variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] Biffi variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

NV-Index

Int16

NV-Index

The NV index is only relevant for node data.Enter the network variable index (NVI/NVO) of the variable here. .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

Send_direct

Bool

Send_direct

This setting is only relevant for node data.Here you can specify whether a set value will be transfered to the DCM directly or via a buffer. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Transient

Bool

Transient

This setting is only relevant for node data.Here you can specifiy whether an actual value received via a command event will automatically be reset to 0 by the driver (transient information, e.g. ICON2K Open, Close, Stop) .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] Biffi variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


BURPVI variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] BURPVI variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

BURPVI_ADDRESS

String

BURPVI_ADDRESS

The name of the PLC variable. The name is created from Task name/variable name .Note: Global variables can only be used if they are integrated in a task. Global variables are therefore always displayed with the task variables during online import and also addressed as task variables: Task name/variable name . .

BURPVI_OD

String

BURPVI_OD

BURPVI_VL_LENGTH

UInt32

BURPVI_VL_LENGTH

Variable length in bytes. For single variables the variable length equals the process data length. For field variables the variable length defines the element length. .

BURPVI_VN_ELEMENTS

UInt32

BURPVI_VN_ELEMENTS

Number of elements at field variables. For multi-dimensional field variables the number of the elements of all field dimensions is quoted (Example: var[10][5] => VN =50). .

BURPVI_VT_TYPE

String

BURPVI_VT_TYPE

Variable type in the PLC. The possible values are described in the online manual. By using a deviant data type in zenon a type casting can ensue. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] BURPVI variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


CISPIPVarED
ObjectModel COM [image] Variable [image] DynProperties [image] CISPIPVarED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

ISPIPElementNumber

SByte

ISPIPElementNumber

ISPIPElementSubNumber

SByte

ISPIPElementSubNumber

ISPIPElementSubType_AV

SByte

ISPIPElementSubType_AV

ISPIPElementSubType_CMD

SByte

ISPIPElementSubType_CMD

ISPIPElementSubType_ST

SByte

ISPIPElementSubType_ST

ISPIPElementType

UInt16

ISPIPElementType

ISPIPNetworkNumber

SByte

ISPIPNetworkNumber

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] CISPIPVarED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


CPhloemVarED
ObjectModel COM [image] Variable [image] DynProperties [image] CPhloemVarED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

PhloemParameterGroup

SByte

PhloemParameterGroup

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] CPhloemVarED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


CTI variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] CTI variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SecondaryObject

UInt32

SecondaryObject

States the secondary object type for- Time/Counter- Drum- Loop variable- Alarm variable .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] CTI variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


DNP1 variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] DNP1 variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

Command_Mode

UInt16

Command_Mode

Description as text.

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] DNP1 variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


DNP3 variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] DNP3 variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

Classless_Read

Bool

Classless_Read

Assignment of the values to the variable with explicit read queries:Inactive : Values that are received from an Integrity-Poll , Event-Poll oder unsolicited responses are assigned to the variable. Values that are received as a response to an explicit read request are not assignedActive : The variables are only assigned values that are received as a response to an explicit read query.More in the online driver help.

Command_Mode

UInt16

Command_Mode

Only for the Binary Output and Analog Output driver object types. Selection of the Command Mode from a drop-down list:Automatic SBO : A Select is carried out when writing. Once the Selects has been confirmed by the outstation, an Operate follows. The status of the variables is set to CoT_actterm . This applies for binary Outputs and analog Outputs . A BOOL binary Output can also be used for Close and Trip via command processing, by setting the QoC to 2 . Direct Operate : Function Code 0x5 - Direct Operate is used for writing binary Outputs and analog Outputs . Direct Operate NoAck : Function Code 0x5 - Direct Operate is used for writing binary Outputs and analog Outputs . There is no response from the controller; the success of writing is not confirmed.Default: Direct Operate More in the online driver help.

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] DNP3 variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Driver name variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] Driver name variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] Driver name variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


EibV2 variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] EibV2 variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

CyclicReading

Bool

CyclicReading

Specifies how the value will be acquired from the PLC.active : The value will be acquired from the PLC cyclically.Default: Inactive Note : This option should be selected with care, as it increases the bus load enormously. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ETS2Database

String

ETS2Database

Selection of an ETS project configuration file. Click on the ... button to open the dialog to select the database. Configured variables can thus be subsequently overwritten with information from an ESF file. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MainGroup

UInt16

MainGroup

Enter the number of the desired main group.Minimum: 0 Maximum: 31 Default: 0 .

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

MiddleGroup

UInt16

MiddleGroup

Enter the number of the desired middle group.Minimum: 0 Maximum: 7 Default: 0 .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SubGroup

UInt16

SubGroup

Enter the number of the desired subgroup.Minimum: 0 Maximum: 255 Default: 0 .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] EibV2 variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Elrest variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] Elrest variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Device parameter

String

Device parameter

The following properties are used for addressing the ELREST32 driver. .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] Elrest variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


IEC61850 variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] IEC61850 variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

EW

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

EW_INI

Bool

EW_INI

Initialize alternate value/normal state Active: alternate value in the Runtime will be overwritten by process state.Inactive: alternate value will be retained.

EWB

Bool

EWB

Switch to alternate value Active: Current value = Alternate valueInactive: Current value = Process value

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

GOOSE_ATTR1

SByte

GOOSE_ATTR1

GOOSE_ATTR1_POS

SByte

GOOSE_ATTR1_POS

GOOSE_ATTR2

SByte

GOOSE_ATTR2

GOOSE_ATTR2_POS

SByte

GOOSE_ATTR2_POS

GOOSE_ATTR3

SByte

GOOSE_ATTR3

GOOSE_ATTR3_POS

SByte

GOOSE_ATTR3_POS

GOOSE_ATTR4

SByte

GOOSE_ATTR4

GOOSE_ATTR4_POS

SByte

GOOSE_ATTR4_POS

GOOSE_ATTR5

SByte

GOOSE_ATTR5

GOOSE_ATTR5_POS

SByte

GOOSE_ATTR5_POS

GOOSE_INDEX

SByte

GOOSE_INDEX

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

I_BIT

SByte

I_BIT

invalid handling None: no handlinglast valid value: Switch to alternate value image with the last valid valueSwitch to alternate value: Switch to alternate value image; value of parameterized alternate value.Switch to alternate PV: Switch to alternate value image; value of substitute PV.Manual correction of alternate value: Switch to alternate value image; value must be updated manually

I61850_ADR

String

I61850_ADR

IEC 61850-address

I61850_CDC

SByte

I61850_CDC

CDC Specifies the CDC for the extension "Logical node"Default: Default

I61850_LAN

UInt16

I61850_LAN

IEC61850 station number

I61850_VAL

UInt16

I61850_VAL

IEC61850 value This value defines which single message/single command will be processed for the CDCs INS, INC, SGCB and ACD.

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

MERKER

Bool

MERKER

Marker Active: Variable without process reference (address will not be checked; for internal use)Inactive: variable will be updated by the process

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ST_SAVE

Bool

ST_SAVE

Save status Active: The status of the variables will be stored on the hard diskIt will be loaded after restarting the Runtime.Inactive: The status will not be stored.Default: Inactive

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

VAL_SLAVE

Bool

VAL_SLAVE

Save value Active: The value of the variables will be stored on the hard diskIt will be loaded after restarting the Runtime.Inactive: The value will not be stored.Default: Inactive

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] IEC61850 variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


IEC62056 variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] IEC62056 variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

IEC62056_ADDRESS

String

IEC62056_ADDRESS

Entry of the OBIS address.

IEC62056_TIMEADJUST

SByte

IEC62056_TIMEADJUST

Correction of the time stamp. Selection of the type of time adjustment from a drop-down list.None : There is no correction.Begin of interval : Correction has an effect on the start time stamp. End of interval : Correction has an effect on the end time stamp. Default: None The interval that is applicable for changes is configured with the property.

IEC62056_TIMEINTERVAL

UInt16

IEC62056_TIMEINTERVAL

Entry of the time interval in minutes. Only available if, for the property, none has been selected.Maximum: 65535 Default: 15 Example: With interval 15 and End of interval for , the time stamp is always set to the end of a quarter of an hour.

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] IEC62056 variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


IEC870 variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] IEC870 variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

IEC870_COA1

UInt16

IEC870_COA1

Enter the Common Object Address (COA). The limits of the available value range are determined by the driver settings. .

IEC870_IOA1

UInt32

IEC870_IOA1

Enter the Information Object Address (IOA). The limits of the available value range are determined by the driver settings. .

IEC870_PRIVATEINDEX

SByte

IEC870_PRIVATEINDEX

IEC870_TYPE

SByte

IEC870_TYPE

Choose the ASDU type of the data point from the drop-down list.default: T00 internal state .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] IEC870 variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


IEC870_103 variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] IEC870_103 variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

IEC870_103_FktType

UInt32

IEC870_103_FktType

Enter a value. Matches FUN considering the standard. .

IEC870_103_Index

UInt32

IEC870_103_Index

Enter a value. Matches the sequence of MEA in ASDU 3 or 9 . .

IEC870_103_InfNo

UInt32

IEC870_103_InfNo

Enter a value. Matches INF considering the standard. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] IEC870_103 variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


iLon100 variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] iLon100 variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] iLon100 variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Internal variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] Internal variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

Initial_value

String

Initial value

The value defined here is used as the current value of the variable when Runtime is started if the property is set to initial value . Note: Both periods and commas are permitted as decimal separators. The value is always converted internally to a number with a period as a separator. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

Local

Bool

Calculation

Setting of whether internal driver variable is distributed in the zenon network.Local : For the network projects the internal variable is assessed and administrated locally i.e. on the client. The value is not distributed in the zenon network. This means that the value of the variable can be different on any client and the limit values are also evaluated locally.Network : With network projects, the internal variable is evaluated and administered on the project's server. It has the same value on the server and all clients.Default: local . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

Remanenz

SByte

Remanence

Off : When starting Runtime, the alternate value of the variable or an empty string for string variables is used as the current value. Initial value : The current value is the value entered in the property “Initial value”. Remanent : The last value of the variable is used as the current value when restarting the Runtime. Default: off. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] Internal variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Internal variable RT
ObjectModel COM [image] Variable [image] DynProperties [image] Internal variable RT
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

Initial_value

String

Initial value

The value defined here is used as the current value of the variable when Runtime is started if the property is set to initial value . Note: Both periods and commas are permitted as decimal separators. The value is always converted internally to a number with a period as a separator. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

LastUpdateTime

UInt32

LastUpdateTime

This property returns the date and time when the value of a variable has been changed.

LastUpdateTimeMilliSeconds

UInt16

LastUpdateTimeMilliSeconds

This property returns the update time in milliseconds.

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

Local

Bool

Calculation

Setting of whether internal driver variable is distributed in the zenon network.Local : For the network projects the internal variable is assessed and administrated locally i.e. on the client. The value is not distributed in the zenon network. This means that the value of the variable can be different on any client and the limit values are also evaluated locally.Network : With network projects, the internal variable is evaluated and administered on the project's server. It has the same value on the server and all clients.Default: local . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

Remanenz

SByte

Remanence

Off : When starting Runtime, the alternate value of the variable or an empty string for string variables is used as the current value. Initial value : The current value is the value entered in the property “Initial value”. Remanent : The last value of the variable is used as the current value when restarting the Runtime. Default: off. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StatusString

String

StatusString

This property returns the status of a variable.

StatusValue

UInt64

StatusValue

This property returns the status of a variable as a value.

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

UserValue

VT_VARIANT

UserValue

Value

VT_VARIANT

Value

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] Internal variable RT [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Lon32 - variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] Lon32 - variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] Lon32 - variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


MathDr32 - variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] MathDr32 - variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MathInfo

Node

MathInfo

Contains information if e.g. var is used to determine a sum (as in data reduction)

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CMathInfo
ObjectModel COM [image] Variable [image] DynProperties [image] MathDr32 - variable ED [image] CMathInfo
Overview
External Name | Type | Display Name | Description
EnableCalc | CProjektVariable | Calculaton active | Assigns a variable to the mathematics variable. The value of the variable controls whether the calculation is carried out. The property is activated when a variable is assigned.A click on button ... or in the field with the variable opens the dialog for selecting a variable.Default: deactivated, no variable assigned. .
Formula | String | Formula | Opens the dialog to enter the formula for calculation of the variables. .
MathInfo | CD_CMemFile | MathInfo |
SourceVars | Node | SourceVars | Node
Type | UInt16 | Type |


CProjektVariableProp
ObjectModel COM [image] Variable [image] DynProperties [image] MathDr32 - variable ED [image] CMathInfo [image] CProjektVariableProp
Overview
External Name | Type | Display Name | Description
Title | CProjektVariable | Title | Gets or sets a variable object.


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] MathDr32 - variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Mathematical variable RT
ObjectModel COM [image] Variable [image] DynProperties [image] Mathematical variable RT
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

LastUpdateTime

UInt32

LastUpdateTime

This property returns the date and time when the value of a variable has been changed.

LastUpdateTimeMilliSeconds

UInt16

LastUpdateTimeMilliSeconds

This property returns the update time in milliseconds.

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MathInfo

Node

MathInfo

Contains information if e.g. var is used to determine a sum (as in data reduction)

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StatusString

String

StatusString

This property returns the status of a variable.

StatusValue

UInt64

StatusValue

This property returns the status of a variable as a value.

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

UserValue

VT_VARIANT

UserValue

Value

VT_VARIANT

Value

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CMathInfo
ObjectModel COM [image] Variable [image] DynProperties [image] Mathematical variable RT [image] CMathInfo
Overview
External Name | Type | Display Name | Description
EnableCalc | CProjektVariable | Calculaton active | Assigns a variable to the mathematics variable. The value of the variable controls whether the calculation is carried out. The property is activated when a variable is assigned.A click on button ... or in the field with the variable opens the dialog for selecting a variable.Default: deactivated, no variable assigned. .
Formula | String | Formula | Opens the dialog to enter the formula for calculation of the variables. .
MathInfo | CD_CMemFile | MathInfo |
SourceVars | Node | SourceVars | Node
Type | UInt16 | Type |


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] Mathematical variable RT [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


NWMDRV32 - variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] NWMDRV32 - variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] NWMDRV32 - variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


OPCUA variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] OPCUA variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

BrowseName

String

BrowseName

Equals the Browse name of the OPC UA specification.Only hierarchic references (forward) starting from the object folder are allowed. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

ParentNodeId

String

ParentNodeId

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StructureRelativePath

String

StructureRelativePath

StructureTypeNodeId

String

StructureTypeNodeId

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] OPCUA variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Sample32 variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] Sample32 variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SampleButton

String

SampleButton

Examples for sample driver.

SampleTest

String

SampleTest

Examples for sample driver.

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] Sample32 variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


SE_32 variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] SE_32 variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] SE_32 variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


SE_32 variable ED function
ObjectModel COM [image] Variable [image] DynProperties [image] SE_32 variable ED function
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] SE_32 variable ED function [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


SPRECON870 variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] SPRECON870 variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

IEC870_COA1

UInt16

IEC870_COA1

Enter the Common Object Address (COA). The limits of the available value range are determined by the driver settings. .

IEC870_IOA1

UInt32

IEC870_IOA1

Enter the Information Object Address (IOA). The limits of the available value range are determined by the driver settings. .

IEC870_TYPE

SByte

IEC870_TYPE

Choose the ASDU type of the data point from the drop-down list.default: T00 internal state .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SPRECON870_CommandExecutionTime

UInt32

SPRECON870_CommandExecutionTime

SPRECON870_CounterActive

Bool

SPRECON870_CounterActive

Only available if a group has been created in the driver configuration.Activated : The counter processing is used by the driver. .

SPRECON870_CounterGroupID

UInt32

SPRECON870_CounterGroupID

Name for identifying counter group as defined in the driver.Via the allocation of the variable to a counter group, the behavior of the variable is defined. The counter group represents a kind of reaction matrix which controls the counter processing (e.g. changing absolute value to relative value).Default: < No group > .

SPRECON870_MaxCounterDifference

UInt16

SPRECON870_MaxCounterDifference

Defines the maximal difference between two transferred counting values. The maximum change refers to the normalized counter value (value calculation). If the maximum counting value difference is exceeded, the setting of property is executed.Minimum: 0 - deactivated; maximum change is not monitored.Maximum: 65535 Default: 0 .

SPRECON870_OnMaxCounterDifference

SByte

SPRECON870_OnMaxCounterDifference

Treatment of counter values (relative/absolute) for which the monitoring from reacts.Select from drop-down list:- Disabled - Set INVALID state: Status is set and thus - if configured - property is activated. This treatment is also true for the counter overflow of absolute values. If the error state is reached, the status INVALID is set and the current counting value is discarded. The last received counter value is highlighted as invalid. Calculations which need a previous counting value can only be carried out again after two counter values have been received. The status INVALID is reset as soon as a new counting value with difference smaller than the settings for property is received.Default: Disabled .

SPRECON870_OnNoUpdate

SByte

SPRECON870_OnNoUpdate

Defines the behavior for counting values which are not updated within the time window or the alternate value handling is activated. Select from drop-down list: - Disabled : Settings from property are used.- Set INVALID state : Status INVALID is set.Default: Disabled .

SPRECON870_Position

SByte

SPRECON870_Position

SPRECON870_ReplacementType

SByte

SPRECON870_ReplacementType

Selection for alternate value handling if variable has status INALVID or NT_870 . Select from drop-down list:- Disabled : No alternate value handling.- Last valid value : Switch to last value which was not interrupted. For this a process image must be saved from this value. If there is nor such value, the value available is used (e.g. 0 + INVALID).- Use replacement value : Value of property is written to the variable.- Use replacement variable : The value and the status from property are written to the variable. Exception: If the alternate value variable itself has status INVALID or status NT_870 , it is not switched to this variable but the own variable is kept with its value and status. Special case status GI: As during a General Interrogation the alternate value must not yet be available, a variable can go to INVALID for a short time until the alternate value is received.All settings except for Disabled set the status bit ALT_VAL . As soon as the reason for the alternate value handling (INVALID or NT_870 ) disappears, the variable takes over the process value again and the status bit ALT_VAL is set back.Default: Disabled .

SPRECON870_ReplacementValue

UInt32

SPRECON870_ReplacementValue

Value which should be written on the variable if you selected Use replacement value for property .Minimum: 4294967295 Maximum: 0 Default: 0 .

SPRECON870_ReplacementVariable

CProjektVariable

SPRECON870_ReplacementVariable

Variable whose value and state are taken over if you selected Use replacement value for property . Each value change of the alternate value variable is depicted on the interrupted variable. A click on the ... button opens the variable selection dialog.Attention: As a variable you may only chose a variable of the same driver. If you select a variable of another driver in the dialog, the dialog is closed but the setting is not applied.Default: empty .

SPRECON870_ReverseDirectionEnable

Bool

SPRECON870_ReverseDirectionEnable

Activation of Reverse- direction .Active : Variable is sent in Reverse- direction after a corresponding general query.

SPRECON870_ReverseDirectionInitialValue

double

SPRECON870_ReverseDirectionInitialValue

The initial value is only used if the property has been activated or the network address of the variable refers to a connection that has been highlighted as an Internal connection . For String data variables, no initial value can be established. If Runtime is started and no value from the remanant image has been assigned to the variable, the initial value and the status NT is written to this variable.

SPRECON870_ReverseDirectionOnly

Bool

SPRECON870_ReverseDirectionOnly

Only available if the property has been activated. Active This variable is never assigned a value received from the PLC. After starting Runtime, the variable of the configured initial value or a value from the remanent image is assigned. After this, the variable can only be changed by writing a set value.

SPRECON870_ReverseDirectionRemanent

Bool

SPRECON870_ReverseDirectionRemanent

Only available if property is active. Last value, time stamp and status of the variable are saved in the remanent image. After restarting, the value, time stamp and status are read from the remanent image and assigned to the variable.

SPRECON870_TriggerCommand

Bool

SPRECON870_TriggerCommand

SPRECON870_TriggerCount

UInt32

SPRECON870_TriggerCount

SPRECON870_TriggerCycle

UInt32

SPRECON870_TriggerCycle

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] SPRECON870 variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Sys2000 variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] Sys2000 variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

Log ID

UInt32

Log ID

Enter the address of the log (log ID) in the PLC. .

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

Node

UInt32

Node

Enter the node address of the PLC. .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] Sys2000 variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


SysDrv variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] SysDrv variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] SysDrv variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Syskron variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] Syskron variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

Syskron_LDS_FKT_RD

Int32

Syskron_LDS_FKT_RD

Define the access function for reading here. Clicking on the button opens a dialog for selecting the access function. Alternatively, you can manually enter the name of the access function in the text field. .

Syskron_LDS_FKT_WR

Int32

Syskron_LDS_FKT_WR

Define the access function for writing here. Clicking on the button opens a dialog for selecting the access function. Alternatively, you can manually enter the name of the access function in the text field. .

Syskron_LDS_PARAM_RD

String

Syskron_LDS_PARAM_RD

Define all parameters of the function here. Click on the button to open the dialog for entering all parameters that will be passed to the function for reading during Runtime. .

Syskron_LDS_PARAM_WR

String

Syskron_LDS_PARAM_WR

Define all parameters of the function here. Click on the button to open the dialog for entering all parameters that will be passed to the function for writing during Runtime. The last parameter is always the set value sent by zenon. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] Syskron variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Variable ED
ObjectModel COM [image] Variable [image] DynProperties [image] Variable ED
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsLocalAdjustHW

Bool

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAdjustZenon

Bool

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain

Bool

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmDomain2

Bool

IsLocalAlarmDomain2

Description as text.

IsLocalAlarmDomain3

Bool

IsLocalAlarmDomain3

Description as text.

IsLocalAlarmDomain4

Bool

IsLocalAlarmDomain4

Description as text.

IsLocalAlarmPV0

Bool

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV1

Bool

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmPV2

Bool

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAlarmViaEquipmentModel

Bool

IsLocalAlarmViaEquipmentModel

Description

IsLocalAlternateValue

Bool

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalAltValString

Bool

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalArchHystNeg

Bool

IsLocalArchHystNeg

IsLocalArchHystPos

Bool

IsLocalArchHystPos

IsLocalArraySize

Bool

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalCancelOperate

Bool

IsLocalCancelOperate

Description

IsLocalCounterGroup

Bool

IsLocalCounterGroup

IsLocalDDEaktiv

Bool

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalDigits

Bool

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDActive

Bool

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDSize

Bool

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHDUpdate

Bool

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystNeg

Bool

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalHystPos

Bool

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalInOut

Bool

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalKDAActiv

Bool

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalLocking

Bool

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalMaxGradient

Bool

IsLocalMaxGradient

IsLocalNormalState

Bool

IsLocalNormalState

IsLocalNormalStateActive

Bool

IsLocalNormalStateActive

IsLocalQuitPV

Bool

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalQuitValue

Bool

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMax

Bool

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRangeMin

Bool

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRecLabel

Bool

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRema

Bool

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalRemaActiv

Bool

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSBO

Bool

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMax

Bool

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalSignalMin

Bool

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStandby

Bool

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStingLength

Bool

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalStyleUsed

Bool

IsLocalStyleUsed

Description

IsLocalTagname

Bool

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUnit

Bool

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUpdatePriority

Bool

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalUsedInProcRec

Bool

IsLocalUsedInProcRec

Description

IsLocalUseMacro

Bool

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMax

Bool

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalValueMin

Bool

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalVarInASM

Bool

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not. FALSE = It should be linked, TRUE = It shouldn't be linked."

IsLocalViewQuitPV

Bool

IsLocalViewQuitPV

Description as text.

IsLocalZeroClamping

Bool

IsLocalZeroClamping

Description

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

IsSW_Akt

Bool

IsSW_Akt

IsSW_VBA

Bool

IsSW_VBA

IsSWProtokol

SByte

IsSWProtokol

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] Variable ED [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Variable RT
ObjectModel COM [image] Variable [image] DynProperties [image] Variable RT
Overview

External Name

Type

Display Name

Description

AdjustHardware

UInt32

AdjustHardware

Only available if the property is active.Macro that is called up each time there is a change to the raw value in the PLC and amends the value in zenon. Clicking on the ... button opens the dialog to select a macro. .

AdjustZenon

UInt32

AdjustZenon

Only available if the property is active.Macro is called up when writing a value from zenon and amends the raw value on the PLC. Clicking on the ... button opens the dialog to select a macro. .

Adressparam

String

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).Property is only displayed for information. Editing with zenon Logic only. .

AlarmDomain

UInt16

Alarm area 1

First alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain2

UInt16

Alarm area 2

Second alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain3

UInt16

Alarm area 3

Third alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmDomain4

UInt16

Alarm area 4

Fourth alarm area that is assigned to a variable, a structure or a data type. Select from drop-down list. .

AlarmPV0

CProjektVariable

Alarm variable 1

Only available in SICAM 230. First variable for screen alarming .

AlarmPV1

CProjektVariable

Alarm variable 2

Only available in SICAM 230. Second variable for screen alarming .

AlarmPV2

CProjektVariable

Alarm variable 3

Only available in SICAM 230. Third variable for screen alarming .

AlarmQuitPV

CProjektVariable

Acknowledgement variable

If an alarm of the controlling variable is acknowledged, the value of this acknowledging variable is sent to the value defined under .Click on the ... button in order to open the dialog for selecting a binary variable. .

AlarmQuitPVValue

UInt32

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under or is set to this value.Selection 0 or 1 . .

AlarmViaEquipmentModel

Bool

Use hierarchical alarming of the Equipment Model

Type of assignment of the variable to an alarm area.active : Alarm area for the variable is transferred by the equipment model. The alarm on the variable is applicable to alarm areas that are defined in the equipment model. In doing so, the equipment group of the variable and the higher-level equipment group of the equipment model are taken into account.inactive : The alarm on the variable is applicable for alarm areas 1 - 4 of the alarm handling .Note: If this property is activated for a data type, the settings for all variables that come from that are passed on. .

AlarmViewQuitPV

CProjektVariable

Visual acknowledgement variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under .Click on the ... button to open the dialog to select a binary variable. .

Alignment

UInt16

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset. For byte variables: HiByte : High byte in the word offset. LoByte : Low byte in the word offset. HiWord-HiByte High byte in the high word in the double-word offset. HiWord-LoByte : Low byte in the high word in the double-word offset. LoWord-HiByte : High byte in the low word in the double-word offset. LoWord-LoByte : Low byte in the low word in the double-word offset. For word variables: HiWord : High word in the double-word offset. LoWord : Low word in the double-word offset. .

AlternateValue

double

Archive filler value

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up. .

AlternateValueString

String

String archive filler value

Is used for string variables in order to fill up cyclic archives. If there are intervals in cyclical archives in which there were no connections to the hardware, the is used as long as no value is transferred from the hardware. Otherwise the last valid value is used for filling up.Maximum length: 128 characters .

ArchHystNeg

double

Negative for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

ArchHystPos

double

Positive for archive

Hysteresis for archiving on change applied to the measuring range.Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

AreaName

UInt32

AreaName

Description as text.

AreaName2

UInt32

AreaName2

Description as text.

AreaName3

UInt32

AreaName3

Description as text.

AreaName4

UInt32

AreaName4

Description as text.

ArraySizeOld

UInt32

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipegroup Manager or via the programming interface. Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0 ). .

BitAddr

UInt16

Bit number

Number of the bit within the configured offset. Minimum: 0. Maximum: 65535. Default: 0. .

CancelOperate

Bool

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate in the Command Processing.Note: The property is only available in the Energy Edition.Default: Inactive .

CounterGroup

UInt32

Counter group

Only available in SICAM 230.

CurveStyle

Guid

Curve style

Style of the curve for display in Runtime.Clicking on the ... button opens the dialog to select a configured curve style. .

DataBlock

UInt32

Data block

Number of the data block. Minimum: 0. Maximum: 4294967295. Default: 0. .

DDEActive

Bool

Permanently read variable

Setting for the reading of the variable and its availability via DDE in Runtime:Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s Activation of this option has the advantages that, for example, variable values in the function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.Default: Inactive .

Digits

UInt16

Decimals

Number of decimal places of the variable values for the display in the control system.Minimum: 0 Maximum: 10 Default: 0 .

Driver

UInt32

Drivers

Driver for the variable. It is selected during the creation of the variable and can be changed here later.Note: Driver for zenon Logic projects cannot be changed later. .

ExternalReference

String

External reference

Note: XML import and export is supported. If a variable is created using copy&paste , this property is empty.

ExternVisible

Bool

Externally visible

Property in order to also be able to evaluate the zenon variables in zenon Logic. Not for variables of the integrated zenon Logic project that is already available for example via stratonNG drivers. Active: The variable is also visible in zenon Logic Workbench and can therefore be used in zenon Logic projects. The variable definition cannot be changed in zenon Logic. The values can be updated to the Runtime over a so called Shared-Memory connection. Therefore, you have to create the driver 'Logic to SCADA connection ' in the zenon Logic field bus configuration. The value of the variable can be determined either in zenon - by a PLC or in zenon Logic Runtime and then written to the PLC. However the values must be neither updated at he same time nor in every zenon Logic cycle. Attention: If no 'Logic to SCADA connection ' driver has been set up in zenon Logic, the variables in Workbench are visible but the values are not updated in Runtime!Note: Regard interactions with property . .Inactive: The variable is not visible in zenon Logic.Default: Inactive Attention : In zenon Logic, variable names must be in accordance with IEC 61131-3 regulations. This means: Only figures, letters from A to Z (no umlauts) and underscores are permitted. In addition the name must not start with a number. This also includes that structures and arrays of the control system cannot be visible externally as they contain brackets or dots..

ExternVisibleFor

String

Externally visible for

Only available if property is active.Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Note: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.The number of characters is limited to 64 characters.Default: - .

HDActive

Bool

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.Inactive: No variable values are saved.Default: inactive.HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved: - Time at which measurement was taken. - milliseconds when reading the value. - Amend status of the value to elements accordingly. - Counter for unique identification of the value (spontaneous driver).Note : The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed. Variables of type string are not supported by the hard disk data storage. .

HDSize

UInt32

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of values. .

HDUpdate

float

Cycle time [s]

Only available if the property is active: Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend , for online data in the Extended Trend or the export/import of the values. .

HystNeg

double

Negative for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at declining value change. Values are only interpreted as limit value violations if the change is below the hysteresis area defined here. Default: 0 (no hysteresis) .

HystPos

double

Positive for signal

Hysteresis for limit values based on the signal area.Hysteresis area for entry at increasing value change. Values are only interpreted as limit value violations if the change is above the hysteresis area defined here. Default: 0 (no hysteresis) .

ID_ComplexVariable

UInt32

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

ID_DataTyp

UInt32

Data Type

Data type of the variable. It is selected during the creation of the variable and can be changed here later. Note: For structure variables, the data type can no longer be changed after the creation of the variables. Attention: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary. .

ID_DriverTyp

UInt32

Driver Object Type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later. Siemens: Data block, marker, input/output. Modbus: Coil and holding register. .

InitialValue

String

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Initial value of the variable in zenon Logic during a cold start or warm start. The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work. The control system does not check the validity of the input here. This can lead to an error message in zenon Logic. ATTENTION : When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables. .

InOut

Bool

Write set value

Active: Release this variable for action "Write set value". Inactive: This variable is write-protected. Default: active .

IsKDAActiv

Bool

Recording type

Only available if property is active: Hard disk data (zyklisch) : Cyclical writing of values to the hard disk. Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.) .

IsRemaActiv

Bool

Reaction matrix active

Active: A reaction matrix is used instead of the limit values. Inactive: Limit values can be defined for the variable. Default: inactive. .

LastUpdateTime

UInt32

LastUpdateTime

This property returns the date and time when the value of a variable has been changed.

LastUpdateTimeMilliSeconds

UInt16

LastUpdateTimeMilliSeconds

This property returns the update time in milliseconds.

Limits

Node

Limit Values

Properties about the limit value handling or alarm handling of the variable.Properties of this group are only available if you activated property . .

LockingName

String

LockingName

"With this property you have the opportunity to assign an interlocking via its name. zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

MaxGradient

UInt32

Maximum gradient

Only available in SICAM 230.

Meaning

String

Meaning

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma. Syntax: [Meaning1],[Meaning2],…,[MeaningN] .

Name

String

Name

Distinct name of the variable. The following is applicable for naming:Maximum length: 128 characters Non-permitted characters: # and @ Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual. Changes of the variable name must then also be made in the programming environments (VBA, VSTA). .

NetAddr

UInt32

Net address

Bus address or of the variable.Minimum: 0 Maximum: 4294967295 Default: 0 .

NormalState

Bool

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off . Available for variables and data types of the type BOOL , UINT and WORD for all drivers.Default: Off .

NormalStateActive

Bool

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.Active : A normal status can be defined.Default: Inactive .

Offset

UInt32

Offset

Offset of the variable. For linearly-addressed control units : the memory range. For name-resolved control units : the assignment address. Minimum: 0. Maximum: 4294967295. Default: 0. .

Profilename

String

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver. Name of the profile set in zenon Logic (STRATON, ProfDP, for example).Property is only displayed for information. Editing with zenon Logic only. .

RangeMax

double

Measuring range max.

Maximum value of the variables in zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

RangeMin

double

Measuring range min.

Minimum value of the variables zenon. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

ReadWrite

Bool

Enable external write set value

External property for zenon Logic. Only affects variables that are not of the straton driver. Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic. Inactive: The variable cannot be changed in zenon Logic. Default: active. .

Recourceslabel

String

Resources label

Any desired string. Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).Maximum length: 255 characters .

Rema

UInt32

Reaction matrix

Selection of a reaction matrix for linking to the selected variables or the selected data type. Click on the ... button to open the dialog for selecting a reaction matrix. Reaction matrices can also be copied, configured and newly created in this dialog. It is not possible to delete reaction matrices here. If you want to remove a reaction matrix, click on the None button in the dialog.Default: <No reaction matrix linked> Note: The property shows a preview of the linked reaction matrix. .

SBO

Bool

Select Before Operate

Attention: This functionality is only supported by the IEC870 and IEC850 drivers, and only if switching command was selected for the action type property in Command Processing and the action is implemented as two stage . Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.Active: Before the value of the variable is written to the hardware, zenon checks during the first stage of the switching command whether the variable in the hardware is ready for this action =Select before Operate (SBO) . Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command .Inactive: The value of the variable is transferred to the driver without a previous check.Note : in iec870 driver it means Direct execute . The iec850 driver can however trigger a Select before Operate automatically - due to Control Model . Default: inactive .

ScaleStyle

Guid

Scales style

Display and selection of the scale style that is assigned to the element. .

SetValueProtocol

SByte

Logging

Defines how write set value should be logged in the CEL.All : All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).Nothing : No "write set value" actions are logged in the CEL.Only via dynamic element : Only actions via dynamic elements are logged in the CEL.Default: Only via dynamic element .

SignalMax

double

Signal range max.

Maximum value of the variable in the PLC.Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

SignalMin

double

Signal range min.

Minimum value of the variable in the PLC. Unless defined differently in , the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limit values, set value limits, representation area, setpoint inputs, ...). .

Standby

Bool

Read from Standby Server only

Source of the variable value for display in Runtime if the project is used in a zenon network.Active: The variable visualizes the value from the standby server.Inactive: The variable visualizes the value from the primary server.Note: If this property is activated and the variable value cannot be read by the standby server (shown in Runtime with a blue dot), this is set to the N_UPDATE status bit. .

StatusString

String

StatusString

This property returns the status of a variable.

StatusValue

UInt64

StatusValue

This property returns the status of a variable as a value.

StringLength

UInt16

String length

Only available for String variables. Maximum number of characters that the variable can take. Minimum: 1 character If the non-permitted value 0 is entered, the last valid configured value is used automatically. If no valid value has been configured, the entry is replaced with the default value. Maximum: 65535 characters . Default: 5 characters Note: the default value is 65535 for String data type system variables. .

StyleGroup

Guid

Style group

Display and selection of the style group linked to this element. Click on button ... in order to open the dialog for selecting a style group. If several elements are selected, they can be assigned to a joint style group.Note: Only properties that are supported by the respective element are supported. .

SV_Act

Bool

Old and new value

Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).Inactive: Only the new value is logged.Default: inactive Recommendation: Activate the property. This ensures that the value is always available and does not need to be specially queried. .

SV_VBA

Bool

Write set value via VBA

Active : Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL). inactive: Write set value of this variable via VBA macro is not logged. Default: Active Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated. .

SymbAddr

String

Symbolic address

Character sequence for symbolic address of the variables.Maximum length: 1024 characters.Note: The symbolic address is not supported by all drivers. When importing the variables into drivers that support symbolic addressing, the property is entered automatically. .

SystemModelGroup

Equipment Groups

Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .

Tagname

String

Identification

Freely-definable string for the identification of the variable or the data type. Note: Because the language of the variable name ( property) cannot be switched, this property can be used for online language switching.Maximum length: 128 characters .

Unit

String

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list. Maximum: 50 characters Default: empty .

UpdatePriority

SByte

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. A variable is assigned a priority in this property. .

Use_in_ProcRec

Bool

Activate recording

Activates/deactivates variable or data type for recording for the Process Recorder module. Multiple selection of variables is possible.Active: Value changes of the variable are recorded in the Process Recorder. Attention: Ensure that the general activation of the recording has been activated in the property.Inactive: Variable value changes are not recorded in the Process Recorder.Default: Setting is applied by the data type used..

UseMacro

Bool

Non linear value adjustment with macros

The non-linear value adjustment is used for variables, whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.Active: Raw values are scaled to zenon on a non-linear basis with VBA macros.Inactive: Raw values are scaled to zenon.Note: When activating the property, the and properties must also be configured. In doing so, the property must be configured inversely to as an inverse function. Default: Inactive .

UserValue

VT_VARIANT

UserValue

Value

VT_VARIANT

Value

ValueMax

double

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

ValueMin

double

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately. This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element. .

Vargroup

String

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables. Variable groups in zenon Logic ("Global", "Retain" or empty).Property is only displayed for information. Editing with zenon Logic only. .

VarInASM

Bool

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA). Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA). Default: Inactive Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here. .

VisualName

String

Display name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard .Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer. .

WaterfallParam

String

Parameters for waterfall diagram

Parameters of a variable for a waterfall diagram in zenon Analyzer. The entries can be created for line-based reports or machine-based reports . When exporting, Depending on the structure of the entries, a decision is made on whether it is entries for machine-based or line-based diagrams.The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon. Syntax machine-based: [model name],[line index],[column index],[color code code]; Syntax line-based: [model name],[line index],[column index],[color code],[loss of auxiliary machine],[add loss of auxiliary machine],[subtract loss of auxiliary machine]; .

ZeroClamping

double

Zero-point suppression


CVarGrenze
ObjectModel COM [image] Variable [image] DynProperties [image] Variable RT [image] CVarGrenze
Overview

External Name

Type

Display Name

Description

Active

Bool

Limit value active

Active: The limit value is taken into account in Runtime. Inactive: The limit value is ignored in Runtime. Default: active. .

Alarm

Bool

In Alarm Message List

Active: At a limit value violation an entry is created in the Alarm Message List. Inactive: In the Alarm Message list no entry is created. Default: Inactive .

AlarmAcknowledge

Bool

To acknowledge

Only available for alarms. Active: The alarm must be acknowledged before it is removed from the ring buffer . Inactive: Acknowledging not necessary. Default for alarms: active, otherwise inactive .

AlarmCause

Bool

Alarm cause required

Only available if the property is active.Active : Before an alarm can be acknowledged, an alarm cause must be linked.Default: Inactive .

AlarmComment

Bool

Comment required

Only available if property is active.Active : Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment .Default: Inactive .

AlarmDelete

Bool

Two-stage acknowledgement

Only available if property is active.Active: The alarm is only removed from the ring buffer if it has been acknowledged and cleared and the removal from the ring buffer has been confirmed.Inactive: The alarm is removed from the ring buffer if it has been acknowledged and cleared.Default: Inactive .

AML_Call

Bool

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.Inactive: The function is carried out spontaneously as soon as the alarm occurs.Default: inactive. .

Blinking

Bool

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit value is violated. You can acknowledge the flashing with a right double click. Inactive: The limit value does not cause flashing. Default: inactive. .

Cel

Bool

In Chronological Event List

Active: In the event that a limit value is violated, an entry is made in the Chronological Event List (CEL). Inactive: No entry is made in the Chronological Event List. Default: inactive. .

Class

UInt16

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit value when using it as alarm. The alarm/event class assignment is carried out by means of selection in the list. Default: 0 - (not used). .

ClassName

UInt32

ClassName

Gets/Sets the alarm class which is linked to a limit.

Color

UInt32

Limit value color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition: .

Delay

UInt32

Delay time [s]

Duration (in seconds) that the limit value violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit value violation. AML/CEL:The time of the first violation is used as the time stamp for the limit value violation in the AML or the CEL.The first value after the delay time is entered as value, not the value that triggers the alarm.Minimum: 0 Maximum: 4294967295 Default: 0 .

Function

CProjektFunktion

Function

Function that is to be automatically executed in Runtime if the limit value is violated. If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the option. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .

Group

UInt16

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit value when using it as an alarm. The assignment to an alarm/event group is carried out by means of selection in the list. Default: 0 - (not used). .

GroupName

UInt32

GroupName

Gets/Sets the alarm group of a limit.

HelpCapture

String

Help chapter

Only available if the property has been activated for the limit value. Help chapter that is to be displayed for this alarm in the alarm list. To do this, a CHM file must be defined in the property. .

HelpFile

String

Help file

Only available if the property has been activated for the limit value.Selection of CHM file from which a help chapter for this alarm is to be displayed in the Alarm Information List.Engineering for EPLAN : It is possible to call up a page from EPLAN . To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in thezenon6.ini file. Configuration:Entry of the character sequence. $PRG: xxxxxx xxxxxx is the placeholder for the parameters to be transferredthe property is ignored, but must not be empty .

Invisible

Bool

Invisible

Setting for visibility. Determines whether an element or status is shown in Runtime.Active: Status is not displayed in the Status element dynamic element or elements are not displayed if their visibility is controlled by this variable.Inactive: The visibility is not influenced by the limit value violation.Default: Inactive .

IsMax

Bool

Minimum/Maximum

Minimum : Limit value violation when reaching or going below the defined limit value. Maximum : Limit value violation when reaching or exceeding the defined limit value. Default: Minimum..

IsVariable

Bool

Dynamic limit value active

Specifies whether the limit value text is fixed or whether it is dynamically determined via a variable.Inactive: The limit value is defined using a fixed value assignment.Active: The limit value is defined using the value of a different variable. AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit value violation in the AML or the CEL.Default: Inactive Attention: If the variable limit value changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit value violation. .

LimitValue

double

Limit Value

Not available if no dynamic limit value is defined : Defines the value from which the limit value is violated. Whether values above this or below this trigger a violation is defined by the "Minimum / Maximum" property. .

Print

Bool

Print

Active: Alarm or limit value violation is online printed for this variable depending on the setting in property in group in the project settings. Inactive: No online printing. Default: Inactive .

Text

String

Limit value text

This text will be shown in the Alarm Message List, the Chronological Event List or the alarm status line (depending on the configuration) after a limit value violation.Dynamic limit value text: Makes it possible to include the current values of other variables, as well as additional variable information, in the limit value text of a variable and in the limit value text of reaction matrices. You can also link a fixed text with keywords from a language table via an index.The use of dynamic limit value texts leads to limitations: static text is stored in the memory area for the limit value text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters. No comments can then be entered in the Alarm Message List or the Chronological Event ListThese limitations can be amended by the enhancement for long dynamic limit value texts. For this, you need to activate and . Variable values for dynamic limit value texts are then evacuated to a separate file and the comment field is available for comments again. .

ThresholdValue

double

Threshold value

A threshold value can be defined that will be used for clearing a limit value violation. Unwanted reactions for quickly-changing (e.g. fluctuating) numerical values can thus be avoided.Example 1: Maximum value = 900, threshold = 10, results in 890 The limit value will be violated from a value of 900 and the critical area will be left again when falling under 890.Example 2: Minimum value = 900, threshold = 10, results in 910 The limit value will be violated from a value of 900 and the critical area will be left again when it goes above 910.In contrast to hysteresis, this property does not influence the display of the value, only the alarm behavior. .

UserProperty1

String

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

UserProperty2

String

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.Mehr im Online-Handbuch

Variable

CProjektVariable

Variable

Only available if the dynamic limit value is active : Variable that is to be used as a dynamic limit value. .


Variables
ObjectModel COM [image] Variables
Remarks

The collection Variables contains all defined variables of the current project. With this collection you can access, create and delete variables.Beside the access via the index a variable also can be found with its unique name or the unique channel Id.

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub CreateVars()
Dim zPRJ As Project
Dim zDRV As Driver
Dim zVTp As VarType
Dim i
'part of the Variablename...
Const VarNamePart As String = "TEST_"
Set zPRJ = MyWorkspace.ActiveDocument
'set first created driver....
Set zDRV = zPRJ.Drivers.Item(0)
'check if driver is the "INTERNAL" driver
If InStr(1, zDRV.Name, "Intern", vbTextCompare) = 0 Then Exit Sub
'set vartype (UINT)
Set zVTp = zPRJ.VarTypes.Item("UINT")
For i = 0 To 9

zPRJ.Variables.CreateVar VarNamePart & i, zDRV, tpSystemVariable, zVTp
Next i
End Sub
Sub DeleteVars()
Dim zPRJ As Project
Dim i
'part of the Variablename...
Const VarNamePart As String = "TEST"
Set zPRJ = MyWorkspace.ActiveDocument
'run trough all variables of the active project
For i = zPRJ.Variables.Count - 1 To 0 Step -1 'reverse loop!

'search part of the varname

If InStr(1, zPRJ.Variables.Item(i).Name, VarNamePart) <> 0 Then

'delete variable

If zPRJ.Variables.DeleteVar(zPRJ.Variables.Item(i).Name) = False Then

Debug.Print "ERROR deleting: " & zPRJ.Variables.Item(i).Name

End If

End If
Next i
End Sub


Properties
ObjectModel COM [image] Variables [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Readonly | Available | Available
Parent | iproject |  | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] Variables [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] Variables [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] Variables [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckInModule | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
CheckOutModule | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
CreateArrayVar | ivariable | - | Available | Unused | Available | Available
CreateArrayVarEx | ivariable | - | Available | Unused | Available | Available
CreateVar | ivariable | - | Available | Unused | Available | Available
DeleteVar | variant_bool | - | Available | Unused | Available | Available
DoAutoSave | void | - | Available | Unused | Available | Available
Export | variant_bool | - | Available | Unused | Available | Available
Import | variant_bool | - | Available | Unused | Available | Available
ImportDirect | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
Item | ivariable | - | Available | Available | Available | Available
ItemPvID | ivariable | - | Available | Available | Available | Available
ModifyArrayVariable | variant_bool | Modify the given array variable to match the new configuration. | Available | Unused | Available | Available
ModifyVariable | variant_bool | Modify the given variable to match the new configuration. | Available | Unused | Available | Available
ShowCreateDialog | ishowcreatevariabledialogresult | Opens the zenon standard dialog "Create variable". | Available | Unused | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index | Available | Unused | Available | Available


CheckInModule
ObjectModel COM [image] Variables [image] Methods [image] CheckInModule
Remarks

This function executes a check in at a multiuser project when a variable is checked out or the variable administration is completely checked out.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckOutModule
ObjectModel COM [image] Variables [image] Methods [image] CheckOutModule
Remarks

This function executes a check out of the whole variable administration at a multiuser project.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CreateArrayVar
ObjectModel COM [image] Variables [image] Methods [image] CreateArrayVar
Remarks

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
strName as BSTR

lpDriver as LPDISPATCH

kTypes as tpKanaltypes

lpVarType as LPDISPATCH

lLBound as long

lDimension1 as long

lDimension2 as long

Dimension3 as long

bPacked as VARIANT_BOOL

bStartAtNewOffset as VARIANT_BOOL

bReserved as VARIANT_BOOL


CreateArrayVarEx
ObjectModel COM [image] Variables [image] Methods [image] CreateArrayVarEx
Remarks

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
strName as BSTR

lpDriver as LPDISPATCH

kTypes as tpKanaltypes

lpVarType as LPDISPATCH

lLBound as long

lDimension1 as long

lDimension2 as long

Dimension3 as long

lAdrMode as tpAdrMode

bStartAtNewOffset as VARIANT_BOOL


CreateVar
ObjectModel COM [image] Variables [image] Methods [image] CreateVar
Remarks

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
strName as BSTR

lpDriver as LPDISPATCH

kTypes as tpKanaltypes

lpVarType as LPDISPATCH


DeleteVar
ObjectModel COM [image] Variables [image] Methods [image] DeleteVar
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
Name as BSTR


DoAutoSave
ObjectModel COM [image] Variables [image] Methods [image] DoAutoSave
Remarks

With this method you have the opportunity to stop writting changes on properties into the database. This should bring up performance improvements. Hint: Don't forget to make a .DoAutoSave(True) after a .DoAutoSave(False) otherwise data which has been typed in VBA won't be saved. The function doesn't work when the editor loses his focus (for example when the VBA code gets debugged).

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bSave as VARIANT_BOOL

Example
VBA
Copy
Sub DoAutoSave()
Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
'Changes on properties should not be written into the database
zVariables.DoAutoSave (False)
'Read the first variable in list
Set zVariable = zVariables.Item(0)
'Changes on properties
zVariable.DynProperties("Unit") = "Volt"
zVariable.DynProperties("Name") = "Var_1"
'Now changes should be written into the database
zVariables.DoAutoSave (True)

End Sub


Export
ObjectModel COM [image] Variables [image] Methods [image] Export
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR


Import
ObjectModel COM [image] Variables [image] Methods [image] Import
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR


ImportDirect
ObjectModel COM [image] Variables [image] Methods [image] ImportDirect
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

bIECDTOvw as VARIANT_BOOL

bUDTOvw as VARIANT_BOOL


Item
ObjectModel COM [image] Variables [image] Methods [image] Item
Remarks

Returns the object Variable from the collection, which is identified by the parameter vID.The parameter vID can have two values:

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPv as VARIANT


ItemPvID
ObjectModel COM [image] Variables [image] Methods [image] ItemPvID
Remarks

Returns the object Variable from the collection, identified with the parameter vID. The parameter vID contains the unique channel Id of the variable. The returned object should be checked on Nothing.

Datatype
IVariable

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPvID as VARIANT


ModifyArrayVariable
ObjectModel COM [image] Variables [image] Methods [image] ModifyArrayVariable
Remarks

Can be used to modify the dimension of the array. Also driver, channeltypes, datatypes, adressmode, offset calculation and lower bound (0 or 1) can be modified.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
strName as BSTR

lpDriver as LPDISPATCH

kTypes as tpKanaltypes

lpVarType as LPDISPATCH

lLBound as long

lDimension1 as long

lDimension2 as long

Dimension3 as long

lAdrMode as tpAdrMode

bStartAtNewOffset as VARIANT_BOOL

Example
C#
Copy
publicvoid Macro_ExtendArray()
{
string VarName = "TestArray[1]";
// element

zenOn.IVariables zVars = this.ActiveDocument.Variables();
zenOn.IVariable zVar = zVars.Item(VarName);
zenOn.IDriver zDriver = zVar.Driver();

var zKanal = zVar.get_DynProperties("ID_DriverTyp");
zenOn.IVarType zVarType = zVar.BaseType;
int zBound = 1;
int zDim1 = 5;
int zDim2 = 0;
int zDim3 = 0;
zenOn.tpAdrMode zAdrMode = zenOn.tpAdrMode.tpAdrManual;
bool zStartNewOffset = true;

zVars.ModifyArrayVariable("TestArray", zDriver, (zenOn.tpKanaltypes)Enum.ToObject(typeof(zenOn.tpKanaltypes),zKanal),

zVarType, zBound, zDim1, zDim2, zDim3, zAdrMode, zStartNewOffset);
}


ModifyVariable
ObjectModel COM [image] Variables [image] Methods [image] ModifyVariable
Remarks

Can be used to modify driver, channeltypes, datatypes, adressmode, and the settings of a non array variable.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
strName as BSTR

lpDriver as LPDISPATCH

kTypes as tpKanaltypes

lpVarType as LPDISPATCH

lAdrMode as tpAdrMode

bStartAtNewOffset as VARIANT_BOOL


ShowCreateDialog
ObjectModel COM [image] Variables [image] Methods [image] ShowCreateDialog
Remarks

Opens the zenon standard dialog "Create variable". After the dialog is closed the object ShowCreateVariableDialogResult is returned which contains an enumerator (ShowCreateVariableDialogReturnResult) – returns if successful or notvariable object (Variable) – created variable object (if successful)

Datatype
IShowCreateVariableDialogResult

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub showVariableDialog()
Dim obVariables As Variables
Dim obVariable As Variable
Dim enumVarRet As ShowCreateVariableDialogReturnResult
Dim obVarResult As ShowCreateVariableDialogResult
    Set obVariables = MyWorkspace.ActiveDocument.Variables
    Set obVarResult = obVariables.ShowCreateDialog
    enumVarRet = obVarResult.ShowCreateVariableDialogReturnResult
    If enumVarRet = ShowCreateVariableDialogReturnResult_Successful Then
        Set obVariable = obVarResult.Variable
        Debug.Print "Variable " & obVariable.Name & " successfully created"
    ElseIf enumVarRet = ShowCreateVariableDialogReturnResult_UndefinedFailure Then
    'just to test the enum (elseif instead of else)
        Debug.Print "Aborted or unkown error occured"
    End If
End Sub


SingleExport
ObjectModel COM [image] Variables [image] Methods [image] SingleExport
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR


VariableValue
ObjectModel COM [image] VariableValue
Remarks

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Properties
ObjectModel COM [image] VariableValue [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Status | long | First 32 bits of the variable state | Unused | Readonly | Available | Available
StatusExt | long | Last 32 bits of the variable state | Unused | Readonly | Available | Available
Time | date | Timestamp of the value | Unused | Readonly | Available | Available
TimeMilliseconds | short | Milliseconds of the timestamp | Unused | Readonly | Available | Available
Value | variant | Value of the variable | Unused | Readonly | Available | Available


Status
ObjectModel COM [image] VariableValue [image] Properties [image] Status
Remarks

First 32 Bits of the variable state.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


StatusExt
ObjectModel COM [image] VariableValue [image] Properties [image] StatusExt
Remarks

last 32 Bits for the variable state.

Datatype
long

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Time
ObjectModel COM [image] VariableValue [image] Properties [image] Time
Remarks

Timestamp of the value

Datatype
DATE

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


TimeMilliseconds
ObjectModel COM [image] VariableValue [image] Properties [image] TimeMilliseconds
Remarks

Milliseconds for the timestamp.

Datatype
short

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


Value
ObjectModel COM [image] VariableValue [image] Properties [image] Value
Remarks

Value for the Variable

Datatype
VARIANT

Availability
Environment | Availability
Editor | Unused
Runtime | Readonly
VBA | Available
VSTA | Available


VarType
ObjectModel COM [image] VarType
Remarks

With the object VarType you have the opportunity to edit selected datatypes.

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub CreateComplexType()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Create a structure datatype called "Structure_1"
Set zVarType = zVarTypes.CreateComplexType("Structure_1")
Call NewSubItem

End Sub
Sub NewSubItem()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
Dim zVarType_1 As VarType 'Child object from type VarTypes
Dim zDrivers As Drivers 'Object from type Drivers
Dim zComplexItem As ComplexItem 'Child object from type ComplexItem
Dim i As Integer
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the own created structure datatype "struct"
Set zVarType = zVarTypes.Item("Structure_1")
'Read the INT datatype as base type for the structure element
Set zVarType_1 = zVarTypes.Item("INT")
'Create 5 structure elements called "Element_" from type INT which should be embedded
For i = 1 To 5

Set zComplexItem = zVarType.NewSubItem("Element_" & i, zVarType_1, False, 1, 0, 0, 0)
Next i

End Sub


Properties
ObjectModel COM [image] VarType [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ID | long |  | Readonly | Readonly | Available | Available
Name | bstr |  | Readonly | Readonly | Available | Available
Parent | ivartypes |  | Readonly | Readonly | Available | Available


ID
ObjectModel COM [image] VarType [image] Properties [image] ID
Remarks

internal uniqe ID as long

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] VarType [image] Properties [image] Name
Remarks

Returns the name of the datatype.

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] VarType [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IVarTypes

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] VarType [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CanDeleteType | variant_bool | - | Available | Unused | Available | Available
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
CreateEdLimit | iedlimit | - | Available | Unused | Available | Available
DeleteEdLimit | variant_bool | - | Available | Unused | Available | Available
DeleteSubItem | variant_bool | - | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
EdLimitCount | long | - | Available | Unused | Available | Available
EdLimitItem | iedlimit | - | Available | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
GetDataType | long | - | Available | Unused | Available | Available
IsAllowed | bool | - | Available | Available | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
IsSimple | bool | - | Available | Available | Available | Available
IsSimpleDataType [GET] | variant_bool |  | Readonly | Readonly | Available | Available
IsSupportedByDriver | variant_bool |  | Readonly | Readonly | Available | Available
NewSubItem | icomplexitem | - | Available | Unused | Available | Available
SubItem | icomplexitem | - | Available | Unused | Available | Available
SubItemCount | long | - | Available | Unused | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


CanDeleteType
ObjectModel COM [image] VarType [image] Methods [image] CanDeleteType
Remarks

This method returns true if a selected datatype can be deleted and false if it can't be deleted.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub CanDeleteType()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the INT datatype from the list
Set zVarType = zVarTypes.Item("INT")
'Check if the selected datatype can be deleted
Debug.Print "Can delete type = " & zVarType.CanDeleteType

End Sub


CheckIn
ObjectModel COM [image] VarType [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckOut
ObjectModel COM [image] VarType [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CreateEdLimit
ObjectModel COM [image] VarType [image] Methods [image] CreateEdLimit
Remarks

This method creates a limit at a datatype.

Datatype
IEdLimit

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub CreateEdLimit()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the INT datatype from the list
Set zVarType = zVarTypes.Item("INT")
'Creates a limit at the INT datatype
zVarType.CreateEdLimit

End Sub


DeleteEdLimit
ObjectModel COM [image] VarType [image] Methods [image] DeleteEdLimit
Remarks

This method deletes a selected limit from a datatype.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT

Example
VBA
Copy
Sub DeleteEdLimit()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the INT datatype from the list.Some limits should be projected at the datatype
Set zVarType = zVarTypes.Item("INT")
'Delete "Limit[1]" at the INT datatype
zVarType.DeleteEdLimit ("Limit[1]")

End Sub


DeleteSubItem
ObjectModel COM [image] VarType [image] Methods [image] DeleteSubItem
Remarks

With this method you can delete an item from a structure datatype.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vNameOrIndex as VARIANT

Example
VBA
Copy
Sub DeleteSubItem()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the own created structure datatype "structure" from the list
Set zVarType = zVarTypes.Item("structure")
'Delete an item called "element_1" from the structure datatype
Debug.Print "Sub item has been deleted = " & zVarType.DeleteSubItem("element_1")
End Sub


DynProperties [GET]
ObjectModel COM [image] VarType [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] VarType [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] VarType [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] VarType [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


EdLimitCount
ObjectModel COM [image] VarType [image] Methods [image] EdLimitCount
Remarks

This method returns the number of limits from a datatype.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub CountEdLimits()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the datatype INT from the list.Project some limits at the datatype.
Set zVarType = zVarTypes.Item("INT")
'Count the number of limits from a datatype
Debug.Print "Number of limits at the datatype = " & zVarType.EdLimitCount

End Sub


EdLimitItem
ObjectModel COM [image] VarType [image] Methods [image] EdLimitItem
Remarks

This method returns an "EdLimit" object from a datatype.

Datatype
IEdLimit

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndex as VARIANT

Example
VBA
Copy
Sub EdLimitItem()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
Dim zEdLimit As EdLimit 'Object from type EdLimit
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the datatype INT from the list.Project some limits at the datatype.
Set zVarType = zVarTypes.Item("INT")
'Create a Limit at the INT datatype
zVarType.CreateEdLimit
'Returns a EdLimit object from the first limit
Set zEdLimit = zVarType.EdLimitItem(0)
'Set the limit active
zEdLimit.Active = True
'Set limit text
zEdLimit.Text = "Limit reached"
'Set limit value to 10
zEdLimit.LimitValue = 10
'Set the limit as maximum
zEdLimit.IsMax = True
'Set the limit as alarm
zEdLimit.Alarm = True
'Limit should be recognized in the CEL
zEdLimit.Cel = True

End Sub


Get
ObjectModel COM [image] VarType [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


GetDataType
ObjectModel COM [image] VarType [image] Methods [image] GetDataType
Remarks

This method returns the number of the datatype.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub GetDataType()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the datatype INT from the list.
Set zVarType = zVarTypes.Item("INT")
'Get the number of the datatype
Debug.Print "Datatype = " & zVarType.GetDataType

End Sub


IsAllowed
ObjectModel COM [image] VarType [image] Methods [image] IsAllowed
Remarks

Datatype
BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
lpDriver as LPDISPATCH

kTypes as tpKanaltypes


IsCheckedOut
ObjectModel COM [image] VarType [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDifferent
ObjectModel COM [image] VarType [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] VarType [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsSimple
ObjectModel COM [image] VarType [image] Methods [image] IsSimple
Remarks

This method returns -1 when the datatype is a simple datatype and 0 when it is a complex datatype.

Datatype
BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub IsSimple()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
Dim zDrivers As Drivers 'Object from type Drivers
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
'Read the datatype INT from the list.
Set zVarType = zVarTypes.Item("INT")
'Check if it is a simple or a complex datatype
Debug.Print "Is Simple = " & zVarType.IsSimple

End Sub


IsSimpleDataType [GET]
ObjectModel COM [image] VarType [image] Methods [image] IsSimpleDataType [GET]
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


IsSupportedByDriver
ObjectModel COM [image] VarType [image] Methods [image] IsSupportedByDriver
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
p_driver as IDriver

p_channelType as tpKanaltypes


NewSubItem
ObjectModel COM [image] VarType [image] Methods [image] NewSubItem
Remarks

With this method you can create new sub items for a structure datatype.

Datatype
IComplexItem

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bstrTypeName as BSTR

pBaseType as IVarType

bReferenz as VARIANT_BOOL

lLBound as long

lDim1 as long

lDim2 as long

lDim3 as long

Example
VBA
Copy
Sub NewSubItem()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
Dim zVarType_1 As VarType 'Child object from type VarTypes
Dim zDrivers As Drivers 'Object from type Drivers
Dim zComplexItem As ComplexItem 'Child object from type ComplexItem
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the own created structure datatype "struct"
Set zVarType = zVarTypes.Item("struct")
'Read the INT datatype as base type for the structure element
Set zVarType_1 = zVarTypes.Item("INT")
'Create a new structure element called "Element_1" from type INT which should be embedded
Set zComplexItem = zVarType.NewSubItem("Element_1", zVarType_1, False, 0, 0, 0, 0)

End Sub


SubItem
ObjectModel COM [image] VarType [image] Methods [image] SubItem
Remarks

This method returns a sub item of a structure datatype.

Datatype
IComplexItem

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
lIndex as long

Example
VBA
Copy
Sub SubItem()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
Dim zComplexItem As ComplexItem 'Child object from type ComplexItem
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the own created structure datatype "struct"
Set zVarType = zVarTypes.Item("struct")
'Read the first item of this structure datatype
Set zComplexItem = zVarType.SubItem(0)
'Move the first item one position downwards
zComplexItem.MoveItemDown

End Sub


SubItemCount
ObjectModel COM [image] VarType [image] Methods [image] SubItemCount
Remarks

This method returns the number of items in a structure datatype.

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


UndoCheckOut
ObjectModel COM [image] VarType [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


VarTypes
ObjectModel COM [image] VarTypes
Remarks

With the object VarTypes you have the opportunity to create, delete and edit datatypes from the list of datatypes.

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub CreateComplexType()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Create a structure datatype called "Structure_1"
Set zVarType = zVarTypes.CreateComplexType("Structure_1")
Call CreateSimpleType

End Sub
Sub CreateSimpleType()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
Dim zVarTypes_1 As VarTypes
Dim zVarType_1 As VarType
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
Set zVarTypes_1 = MyWorkspace.ActiveDocument.VarTypes
'Read datatype "UINT"
Set zVarType_1 = zVarTypes_1.Item(1)
'Create a simple datatype from type "UINT" called "SimpleType_1"
Set zVarType = zVarTypes.CreateSimpleType("SimpleType_1", zVarType_1)

End Sub


Properties
ObjectModel COM [image] VarTypes [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long |  | Readonly | Readonly | Available | Available
Parent | iproject |  | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] VarTypes [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] VarTypes [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] VarTypes [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CanDeleteType | variant_bool | - | Available | Available | Available | Available
CreateComplexType | ivartype | - | Available | Unused | Available | Available
CreateSimpleType | ivartype | - | Available | Unused | Available | Available
DeleteType | variant_bool | - | Available | Unused | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
ImportDirect | variant_bool | - | Available | Unused | Available | Available
Item | ivartype | - | Available | Available | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index | Available | Available | Available | Available


CanDeleteType
ObjectModel COM [image] VarTypes [image] Methods [image] CanDeleteType
Remarks

This method returns true if a selected datatype can be deleted and false if it can't be deleted.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrIndex as VARIANT

Example
VBA
Copy
Sub CanDeleteTypes()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Try if this datatype can be deleted
Debug.Print "Can this type be deleted = " & zVarTypes.CanDeleteType("INT")

End Sub


CreateComplexType
ObjectModel COM [image] VarTypes [image] Methods [image] CreateComplexType
Remarks

With this method a structure datatype can be created.

Datatype
IVarType

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bstrTypeName as BSTR

Example
VBA
Copy
Sub CreateComplexType()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Create a structure datatype called "Structure_1"
Set zVarType = zVarTypes.CreateComplexType("Structure_1")

End Sub


CreateSimpleType
ObjectModel COM [image] VarTypes [image] Methods [image] CreateSimpleType
Remarks

With this method a simple datatype can be created.

Datatype
IVarType

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bstrTypeName as BSTR

pBaseType as IVarType

Example
VBA
Copy
Sub CreateSimpleType()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
Dim zVarTypes_1 As VarTypes
Dim zVarType_1 As VarType
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
Set zVarTypes_1 = MyWorkspace.ActiveDocument.VarTypes
'Read datatype "UINT"
Set zVarType_1 = zVarTypes_1.Item(1)
'Create a simple datatype from type "UINT" called "SimpleType_1"
Set zVarType = zVarTypes.CreateSimpleType("SimpleType_1", zVarType_1)

End Sub


DeleteType
ObjectModel COM [image] VarTypes [image] Methods [image] DeleteType
Remarks

With this method an own created datatype can be deleted.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vNameOrIndex as VARIANT

Example
VBA
Copy
Sub DeleteType()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Delete an own created datatype called "own_simple"
zVarTypes.DeleteType ("own_simple")

End Sub


Export
ObjectModel COM [image] VarTypes [image] Methods [image] Export
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR


Import
ObjectModel COM [image] VarTypes [image] Methods [image] Import
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR


ImportDirect
ObjectModel COM [image] VarTypes [image] Methods [image] ImportDirect
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

bIECDTOvw as VARIANT_BOOL

bUDTOvw as VARIANT_BOOL


Item
ObjectModel COM [image] VarTypes [image] Methods [image] Item
Remarks

With this method you can access datatypes out of the list.

Datatype
IVarType

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vNameOrID as VARIANT

Example
VBA
Copy
Sub Item()
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read all settings from the "INT" datatype
Set zVarType = zVarTypes.Item("INT")
Debug.Print "Name of item = " & zVarType.Name

End Sub


SingleExport
ObjectModel COM [image] VarTypes [image] Methods [image] SingleExport
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR


ZenMenu
ObjectModel COM [image] ZenMenu
Remarks

With an object of this type a context or main menu item can be edited, deleted, created,...

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Example
VBA
Copy
'This sample creates a main menu with 5 items and sets the backcolor of the menu.
Sub ZenMenu()
Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim zMenuItem As ZenMenuItem 'Child object of ZenMenu
Dim i As Integer 'Loop variable
Set zMenus = MyWorkspace.ActiveDocument.ZenMenus
'Create a main menu
Set zMenu = zMenus.Create("Main_1")
'Is true for main menu and false for context menu
zMenu.IsPulldown = True
'Create 5 main menu items
For i = 0 To 4

Set zMenuItem = zMenu.Create("ID_" & i, False)

'Set the text of the main menu item

zMenuItem.Caption = "Item_" & i
Next i
'Set Background color of the main menu
zMenu.BackColor = 12345678
'Check how many items are available in this main menu
Debug.Print "Count = " & zMenu.Count

End Sub


Properties
ObjectModel COM [image] ZenMenu [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
BackColor | ole_color | BackColor | Available | Available | Available | Available
Count | long | Count of defined menu-items | Readonly | Readonly | Available | Available
ID | long | Returns the unique ID for the menu | Readonly | Readonly | Available | Available
IsPulldown | variant_bool | Is the menu a pulldown menu (true) or a popup menu (false) | Available | Readonly | Available | Available
Name | bstr | Name of the menu | Available | Readonly | Available | Available
Notes | bstr | Notes to the menu | Available | Available | Available | Available
Parent | izenmenus | Parent-object | Readonly | Readonly | Available | Available
TextColor | ole_color | TextColor | Available | Readonly | Available | Available


BackColor
ObjectModel COM [image] ZenMenu [image] Properties [image] BackColor
Remarks

With this property you can set the back color of the menu.

Datatype
OLE_COLOR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Count
ObjectModel COM [image] ZenMenu [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ID
ObjectModel COM [image] ZenMenu [image] Properties [image] ID
Remarks

Returns the unique ID for the menu item.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


IsPulldown
ObjectModel COM [image] ZenMenu [image] Properties [image] IsPulldown
Remarks

Returns true for a main menu and false for a context menu. It can also be used to change a main menu to a context menu and vice versa.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] ZenMenu [image] Properties [image] Name
Remarks

Returns the name of the context or main menu.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Notes
ObjectModel COM [image] ZenMenu [image] Properties [image] Notes
Remarks

Returns a string with some notes. This property is not visible in zenOn.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] ZenMenu [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IZenMenus

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


TextColor
ObjectModel COM [image] ZenMenu [image] Properties [image] TextColor
Remarks

With this property you can set the text color of a menu.

Datatype
OLE_COLOR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ZenMenu [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | izenmenuitem | Creates a new menu-item | Available | Unused | Available | Available
Delete | variant_bool | Deletes the given menu-item | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
Item | izenmenuitem | Returns a menu-item by position or name | Available | Available | Available | Available


Create
ObjectModel COM [image] ZenMenu [image] Methods [image] Create
Remarks

With this function new context and main menu items can be created.

Datatype
IZenMenuItem

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

bPulldown as VARIANT_BOOL

Example
VBA
Copy
Sub CreateMenuItem()
Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim zMenuItem As ZenMenuItem 'Child object of ZenMenu
Set zMenus = MyWorkspace.ActiveDocument.ZenMenus
'Select a context or main menu
Set zMenu = zMenus.Item(0)
'Create an item with the name "Test" in the selected menu
Set zMenuItem = zMenu.Create("Test", True)

End Sub


Delete
ObjectModel COM [image] ZenMenu [image] Methods [image] Delete
Remarks

With this function a menu item can be deleted.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

Example
VBA
Copy
Sub DeleteMenuItem()
Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim deleted As Boolean
Set zMenus = MyWorkspace.ActiveDocument.ZenMenus
'Select a context or main menu
Set zMenu = zMenus.Item(1)
'Delete a main menu item and return true or false for deleted or not deleted
deleted = zMenu.Delete("ID_FIRST")
Debug.Print "Deleted = " & deleted

End Sub


DynProperties [GET]
ObjectModel COM [image] ZenMenu [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] ZenMenu [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] ZenMenu [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] ZenMenu [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Item
ObjectModel COM [image] ZenMenu [image] Methods [image] Item
Remarks

Returns a menu item by position or name of item.

Datatype
IZenMenuItem

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosition as VARIANT

Example
VBA
Copy
Sub ItemMenus()
Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim zMenuItem As ZenMenuItem 'Child object of ZenMenu
Set zMenus = MyWorkspace.ActiveDocument.ZenMenus
'Select a main menu
Set zMenu = zMenus.Item(1)
'Select the first item of the main menu
Set zMenuItem = zMenu.Item(0)
Debug.Print "Name of menu item = " & zMenuItem.Name

End Sub


DynProperties
ObjectModel COM [image] ZenMenu [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Menu


Menu
ObjectModel COM [image] ZenMenu [image] DynProperties [image] Menu
Overview
External Name | Type | Display Name | Description
BackColor | UInt32 | Background color | Background color for the selected menu. .
Font | UInt16 | Font | Font type of the menus. Is valid for all menu entries. .
Name | String | Name | Distinct name of the menu. Default: New main menu x or new context menu x (whereby x is a successive number). .
Notes | String | Notes | With this property you have the opportunity to get/set notes from a menu.
Pulldown | Bool | Pulldown | "With this property you have the opportunity to select wheter the menu is a main or a context menu. TRUE = It's a main menu, FALSE = It's a context menu. "
SystemModelGroup |  | Equipment Groups | Links element with an equipment model. Clicking on the ... button opens the dialog to select an equipment group. The display of the selected equipment group also includes the levels above it. The levels are separated by a period in the display.With multiple selection, the individual equipment groups are separated by a semicolon (;). .
TextColor | UInt32 | Text color | Text color for the selected menu. .


ZenMenuItem
ObjectModel COM [image] ZenMenuItem
Remarks

With an object of this type items of a context menu and main menu submenus can be edited, deleted, created,...

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Example
VBA
Copy
'This sample creates a context and a main menu with one item each.
'The main menu item can execute a set value function.
'The context menu item can execute a vba makro.
'Preparation: A variable and a makro have to be available
Sub ZenMenuItem()
Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim zMenuItem As ZenMenuItem 'Child object of ZenMenu
Set zMenus = MyWorkspace.ActiveDocument.ZenMenus
'Create a main menu
Set zMenu = zMenus.Create("Main_1")
zMenu.IsPulldown = True
'Create a main menu item
Set zMenuItem = zMenu.Create("ID_1", True)
'Set text of menu item
zMenuItem.Caption = "First"
'Create a context menu
Set zMenu = zMenus.Create("Context_1")
zMenu.IsPulldown = False
'Create a context menu item
Set zMenuItem = zMenu.Create("id_1", True)
'Set text of menu item
zMenuItem.Caption = "first"
'Projects the set value action at the main menu item
Call setValue(zMenus)
'Projects the makro action at the context menu item
Call setMakro(zMenus)

End Sub
Sub setValue(Menus As ZenMenus)
Dim zVar As Variable 'Variable for the set value function
Dim Menu As ZenMenu 'Child object of ZenMenus
Dim MenuItem As ZenMenuItem 'Child object of ZenMenu
'Select the main menu
Set Menu = Menus.Item(0)
'Select the first main menu item
Set MenuItem = Menu.Item(0)
'Object of variable "test" is assigned
Set zVar = MyWorkspace.ActiveDocument.Variables.Item("test")
'Deactivate the submenus
MenuItem.Popup = False
'Select set value as the action type of the menu item
MenuItem.Type = tpVariable
'The variable of the set value function is assigned via Ids
MenuItem.ActionID = zVar.PvID
'Set the "change by" value to 5
MenuItem.setValue = 5

End Sub
Sub setMakro(Menus As ZenMenus)
Dim zVar As Variable 'Variable for the set value function
Dim Menu As ZenMenu
Dim MenuItem As ZenMenuItem
'Select the context menu
Set Menu = Menus.Item(1)
'Select the first context menu item
Set MenuItem = Menu.Item(0)
'Deactivate the submenus
MenuItem.Popup = False
'Select set value as the action type of the menu item
MenuItem.Type = tpVbaMacro
'Set the Macro via the dynProperties
MenuItem.DynProperties("VBA-Macro") = "Init_Default"

End Sub


Properties
ObjectModel COM [image] ZenMenuItem [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ActionID | long | ID of the variable/rt-function/macro/help-ID | Available | Readonly | Available | Available
Caption | bstr | Caption of the menu-item | Available | Readonly | Available | Available
Checked | variant_bool | Menu-item has checkbox | Available | Readonly | Available | Available
Count | long | Count of defined menu-items | Readonly | Readonly | Available | Available
Enabled | variant_bool | Enables/Disables the menu-item | Available | Readonly | Available | Available
Guid | bstr | Project-GUID by variables of a other project | Unused | Unused | Available | Available
HelpFile | bstr | Helpfile for execution (Type = tpZenHelp) | Available | Readonly | Available | Available
HelpTopic | bstr | Help-ID for execution (Type = tpZenHelp) | Available | Readonly | Available | Available
ID | long | Returns the unique ID for the menu-item | Readonly | Readonly | Available | Available
MenuID | long | Returns the unique ID for the menu | Readonly | Readonly | Available | Available
Name | bstr | Unique Name of the menu-item | Available | Readonly | Available | Available
Parent | izenmenuitem | Parent-object | Readonly | Readonly | Available | Available
ParentID | long | Returns the unique ID for the parent menu-item | Readonly | Readonly | Available | Available
Password | short | Password-level for execution | Available | Readonly | Available | Available
Picture | bstr | Bitmap-file of the menu-item | Available | Readonly | Available | Available
Popup | variant_bool | Menu-item contains sub-items | Available | Readonly | Available | Available
Seperator | variant_bool | Menu-item is a seperator (no execution) | Available | Readonly | Available | Available
SetValue | double | Defined SetValue (Type = tpVariable) | Available | Readonly | Available | Available
ShowSetValueDlg | variant_bool | Show set-value dialog (Type = tpVariable) | Available | Readonly | Available | Available
ToolTip | bstr | Tooltip-Text for the menu-item | Unused | Unused | Available | Available
Type | tpzenmenus | Type of the menu-item (Variable/RtFunction/Help/Macro) | Available | Readonly | Available | Available
UseCurValue | variant_bool | Use current set-value of the variable (Type = tpVariable) | Available | Readonly | Available | Available
VarFromElement | variant_bool | Use Variable from the linked element (Type = tpVariable) | Available | Readonly | Available | Available
Visible | variant_bool | Shows/hides the menu-item | Available | Readonly | Available | Available


ActionID
ObjectModel COM [image] ZenMenuItem [image] Properties [image] ActionID
Remarks

Returns the ID of the chosen action. Depending on the chosen action type the ID of the variable, of the function or of the help chapter (if a string is used it is set to -1) is returned. Assign variable: zMenuItem.ActionID = zVar.PvID Assign function: zMenuItem.ActionID = zFunc.ID

Datatype
long

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Caption
ObjectModel COM [image] ZenMenuItem [image] Properties [image] Caption
Remarks

Returns the text of a menu item.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Checked
ObjectModel COM [image] ZenMenuItem [image] Properties [image] Checked
Remarks

Returns if the "check mark" item is set or not.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Count
ObjectModel COM [image] ZenMenuItem [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Enabled
ObjectModel COM [image] ZenMenuItem [image] Properties [image] Enabled
Remarks

Returns if the menu item is set active or not in the runtime.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Guid
ObjectModel COM [image] ZenMenuItem [image] Properties [image] Guid
Remarks

Not in use.

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


HelpFile
ObjectModel COM [image] ZenMenuItem [image] Properties [image] HelpFile
Remarks

A helpfile can be set via a case sensitive string (directory + file). Hint: To set this property the action typ of the menu item should be set to help.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


HelpTopic
ObjectModel COM [image] ZenMenuItem [image] Properties [image] HelpTopic
Remarks

Returns or sets the selected chapter for the helpfile. The given parameter is case sensitive!

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ID
ObjectModel COM [image] ZenMenuItem [image] Properties [image] ID
Remarks

Returns the unique ID for the submenu item.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


MenuID
ObjectModel COM [image] ZenMenuItem [image] Properties [image] MenuID
Remarks

Returns the unique ID for the menu.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] ZenMenuItem [image] Properties [image] Name
Remarks

Returns the name of a menu item.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] ZenMenuItem [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IZenMenuItem

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


ParentID
ObjectModel COM [image] ZenMenuItem [image] Properties [image] ParentID
Remarks

Returns the unique ID for the parent menu item.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Password
ObjectModel COM [image] ZenMenuItem [image] Properties [image] Password
Remarks

Returns the password level of the menu item. Hint: This value can only be set when an action typ is active.

Datatype
short

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Picture
ObjectModel COM [image] ZenMenuItem [image] Properties [image] Picture
Remarks

A bitmap can be set via a string (directory + file). Hint: A bitmap can only be set at a context menu.

Datatype
BSTR

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Popup
ObjectModel COM [image] ZenMenuItem [image] Properties [image] Popup
Remarks

Submenus for a menu item can be set active or inactive.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Seperator
ObjectModel COM [image] ZenMenuItem [image] Properties [image] Seperator
Remarks

Returns if the "seperator" item is set or not.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


SetValue
ObjectModel COM [image] ZenMenuItem [image] Properties [image] SetValue
Remarks

Returns the "change by" value of a change value action. Hint: The action type set value has to be activated.

Datatype
double

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ShowSetValueDlg
ObjectModel COM [image] ZenMenuItem [image] Properties [image] ShowSetValueDlg
Remarks

Returns the state of the set value "dialog" item.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


ToolTip
ObjectModel COM [image] ZenMenuItem [image] Properties [image] ToolTip
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


Type
ObjectModel COM [image] ZenMenuItem [image] Properties [image] Type
Remarks

Returns action type of menu item. Following numbers are allocated to the parameters: tpRtFunction = 1; tpVariable = 2; tpVbaMacro = 3; tpZenHelp = 6.

Datatype
tpZenMenus

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


UseCurValue
ObjectModel COM [image] ZenMenuItem [image] Properties [image] UseCurValue
Remarks

Returns the state of the set value "Propose current value" item. Hint: The action type set value has to be activated.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


VarFromElement
ObjectModel COM [image] ZenMenuItem [image] Properties [image] VarFromElement
Remarks

Returns the state of the set value "Variable from element" item. Hint: The action type set value has to be activated. This option is only available at context menus.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Visible
ObjectModel COM [image] ZenMenuItem [image] Properties [image] Visible
Remarks

Returns the state of the "visible" item of a menu.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ZenMenuItem [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Create | izenmenuitem | Creates a new menu-item | Available | Unused | Available | Available
Delete | variant_bool | Deletes the given menu-item | Available | Unused | Available | Available
DynProperties [GET] | variant | - | Available | Available | Available | Available
DynProperties [PUT] | void | - | Available | Available | Available | Available
DynPropertiesEnum [GET] | variant | - | Readonly | Readonly | Available | Available
DynPropertyParam [GET] | ipropparam | Returns the PropParam objekt of the given DynProperty | Readonly | Unused | Available | Available
Item | izenmenuitem | Returns a menu-item by position or name | Available | Available | Available | Available


Create
ObjectModel COM [image] ZenMenuItem [image] Methods [image] Create
Remarks

This function creates a new submenu item.

Datatype
IZenMenuItem

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

bPulldown as VARIANT_BOOL

Example
VBA
Copy
Sub CreateSubmenu()
Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim zMenuItem As ZenMenuItem 'Child object of ZenMenu
Dim zMenuItem_1 As ZenMenuItem 'Child object of ZenMenu
Set zMenus = MyWorkspace.ActiveDocument.ZenMenus
'Select a context or main menu
Set zMenu = zMenus.Item(0)
'Select the first menu item in the main menu
Set zMenuItem = zMenu.Item(0)
'Create a new submenu
Set zMenuItem_1 = zMenuItem.Create("Test", False)

End Sub


Delete
ObjectModel COM [image] ZenMenuItem [image] Methods [image] Delete
Remarks

The function deletes a submenu.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

Example
VBA
Copy
Sub DeleteSubMenus()
Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim zMenuItem As ZenMenuItem 'Child object of ZenMenu
Dim deleted As Boolean
Set zMenus = MyWorkspace.ActiveDocument.ZenMenus
'Select a menu
Set zMenu = zMenus.Item(1)
'Select the first menu item in the main menu
Set zMenuItem = zMenu.Item(0)
'Deletes a submenu
deleted = zMenuItem.Delete("ID_1")
Debug.Print "Deleted = " & deleted

End Sub


DynProperties [GET]
ObjectModel COM [image] ZenMenuItem [image] Methods [image] DynProperties [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then

'read the server - computername...

Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]
ObjectModel COM [image] ZenMenuItem [image] Methods [image] DynProperties [PUT]
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

vValue as VARIANT

Example
VBA
Copy
Sub SetDynProp()
End Sub


DynPropertiesEnum [GET]
ObjectModel COM [image] ZenMenuItem [image] Methods [image] DynPropertiesEnum [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR

Example
VBA
Copy
Sub ReadDynProps()
End Sub


DynPropertyParam [GET]
ObjectModel COM [image] ZenMenuItem [image] Methods [image] DynPropertyParam [GET]
Remarks

Datatype
IPropParam

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsPath as BSTR


Item
ObjectModel COM [image] ZenMenuItem [image] Methods [image] Item
Remarks

This function returns a submenu object via position or name.

Datatype
IZenMenuItem

Availability
Environment | Availability
Editor | Available
Runtime | Available
VBA | Available
VSTA | Available
Parameters
vPosition as VARIANT

Example
VBA
Copy
Sub ItemMenus()
Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim zMenuItem As ZenMenuItem 'Child object of ZenMenu
Dim zMenuItem_1 As ZenMenuItem 'Child object of ZenMenu
Set zMenus = MyWorkspace.ActiveDocument.ZenMenus
'Select a menu
Set zMenu = zMenus.Item(1)
'Select the first menu item in the main menu
Set zMenuItem = zMenu.Item(0)
'Select the first submenu
Set zMenuItem_1 = zMenuItem.Item(0)
Debug.Print "Name = " & zMenuItem_1.Name

End Sub


DynProperties
ObjectModel COM [image] ZenMenuItem [image] DynProperties
Remarks

List of all Dyproperties in this class.

Overview

Dynproperties

Base menu item


Base menu item
ObjectModel COM [image] ZenMenuItem [image] DynProperties [image] Base menu item
Overview
External Name | Type | Display Name | Description
ActValue | Bool | Propose current value | Only available for action type "Write set value" : Active: The current value of the variable is proposed as the set value. Inactive: The set is provided directly in the properties of the menu entry. Default: inactive. .
BackgroundPicRepres | Int16 | Alignment | Size of the background graphics file for the menu item. Original size : The graphics file is displayed in its original size. The menu item is adjusted to the size of the graphics file. Stretched : The graphics file is stretched to the size of the menu item. Default: Original size . Example: Menus should be used in a touch screen project. As a default for the size of the single menu items, the settings of the operation system are used. With a background graphics file in original size however you can define the size of the menu item individually. .
BackgroundPicture | String | Graphics File | Background graphics file for the menu item. .
Caption | String | Text | Label of the menu entry in the menu. The entry name must be unique. If there are several entries with the same text, only the first menu entry is displayed in the Runtime. Note: If, in the Action type property, the value Command Processing is selected with the drop-down list, the value of the Text: property is pre-filled with $ALL$ . .
Checked | Bool | Check mark | Left to the menu item a tick mark is displayed. This only serves the graphic display.Default: Inactive . .
DiagramStyle | Guid | Style group chart | Allows the selection of a pre-defined style group that is applied in Runtime in the diagram of the ETM screen. .
Enabled | Bool | Active | Active: The menu entry is normally displayed and the action linked to this is executed when this entry is selected. Inactive: The entry is normally shown as grayed out and the action linked to this is not executed. .
FromElem | Bool | Variable from element | Only available for "write set value" and context menu action type : Active: The variable for writing the set value is taken from the dynamic element. Inactive: Set variable for set value is given in the properties of the menu entry. Default: inactive. .
Function | CProjektFunktion | Function | Only available for "function" action Function that is executed by means of the selected menu entry. If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here. .
HelpCapture | String | Chapter | Only available if, under of the , Help has been selected. Chapter of the linked file. Note: When configuring, the name of the subchapter of the linked help file is to be stated. If the linked file only consists of a main page without a subchapter, the main page is shown in Runtime. Caution: This entry is case sensitive. .
HelpFile | String | File | Only available if, under of the , Help has been selected. Help file from which a chapter is to be shown. .
Locking | UInt32 | Interlocking | Selection of an interlocking for the menu entry. .
Name | String | Menu ID | Name of the menu entry.At Command processing you can select the already defined actions from a drop-down list. .
Password | Int16 | Authorization level | Password level for the execution of this menu entry. .
Picture | String | Graphics File | Graphics file which is displayed in the left-most area. .
Popup-Menu | Bool | Submenu | The menu item does not carry out a function but opens a sub-menu.Default: Inactive . .
RelativeTimeFilter | DateTime | Time filter relative | Configuration of the relative time filter that is to be applied in Runtime for the configured ETM screen. .
Screen | String | Screen | Allows the selection of the ETM screen that is to be used on opening. .
SeparatorColor | UInt32 | Color | Defines the fill color of the separator. Default: black .
SeparatorWidth | SByte | Width | Defines the width of the separator in pixels.Default: 0 .
Seperator | Bool | Separator active | Active : Instead of a menu entry a horizontal separator is added. Width and color of the line can be defined.Default: Inactive .
Signature | Bool | Signature necessary | Active: A signature is necessary to operate the element.For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.Inactive: No signature is required.Default: inactive. .
SignatureEditModus | Int16 | Signature text editable | Defines whether the signature text can be edited. Select from drop-down list:Apply project settings : The settings of the project property are applicable.Yes : Text can be edited.No : Text cannot be edited.Default: Apply project settings .
SignatureText | String | Signature text | This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties. .
Sollwert | double | Set value/Change by | Only available for action type "Write set value" : Numeric value which should be written as set value to the variable. Only numeric values are expected and accepted. The values are taken over with up to 6 decimal places. If property is activated, the current value of the variable is increased (positive value) or decreased (negative value) by this amount. .
SWDialog | Bool | Dialog | Only available for action type "Write set value" : Active: When executing the action, a dialog box is opened before setting the set value, which makes it possible for the user to change the set value before writing. If there are screen keyboards (such as SETVALUEKBD, SETSTRINGKBD or SETBOOLKBD), these are automatically called up instead of the dialog box. Inactive: The value defined in the properties of the menu entry is dent directly to the hardware. Default: inactive. .
Type | Int16 | Action type | Selection of the action type. The action types that are available depend on the menu type.Available in the main menu and context menu: Function : A function is carried out.Help : A entry from the help is displayed.No action : No action is executed.Write set value : A set value is set for a variable:Only available in the context menu: Alarms: Acknowledge : Acknowledges all alarms for variables which are linked to the dynamic element to which the context menu relates.Acknowledge flashing : Switches off the blinking of all alarms for variables that are linked to the dynamic element, which the context menu relates to. The alarms are not acknowledged by this.Show Extended Trend : Allows the calling up of an ETM screen by means of a context menu.Command processing : Carries out a command processing.VBA macro : A VBA macro is carried out. .
Variable | CProjektVariable | Variable | Only available for action type "Write set value" : Variable to which a set value is to be written via the selected menu entry. .
VBA-Macro | UInt32 | VBA macro | Only available for action type "VBA macro" : VBA macro that is to be executed via the selected menu entry. .
Visible | Bool | visible | Defines whether the menu item is displayed in the Runtime.Default: active .


ZenMenus
ObjectModel COM [image] ZenMenus
Remarks

This object manages context and main menus.

Availability
Environment | Availability
Editor | Available
Runtime | Readonly
VBA | Available
VSTA | Available
Example
VBA
Copy
Sub zenOnMenus()
Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object
Dim i As Integer 'Loop variable
Set zMenus = MyWorkspace.ActiveDocument.ZenMenus
'Loop creates five context and five main menus
For i = 1 To 5

'Creates a context menu

Set zMenu = zMenus.Create("context_" & i)

'False for context menu

zMenu.IsPulldown = False

'Creates a main menu

Set zMenu = zMenus.Create("main_" & i)

'True for main menu

zMenu.IsPulldown = True
Next i
'Check if all items have been created (Hint: counting starts at 0 until .count-1)
For i = 0 To zMenus.Count - 1

Debug.Print "Item " & i & " = " & zMenus.Item(i).Name
Next i

End Sub


Properties
ObjectModel COM [image] ZenMenus [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
Count | long | Count of defined menus | Readonly | Readonly | Available | Available
Parent | iproject | Parent-object | Readonly | Readonly | Available | Available


Count
ObjectModel COM [image] ZenMenus [image] Properties [image] Count
Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object. Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype
long

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] ZenMenus [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Readonly
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ZenMenus [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
CheckIn | variant_bool | Save module modifications to server (editor). | Available | Unused | Available | Available
CheckOut | variant_bool | Allow module modifications (editor). | Available | Unused | Available | Available
Create | izenmenu | Creates a new menu | Available | Unused | Available | Available
Delete | variant_bool | Deletes the given menu | Available | Unused | Available | Available
Export | variant_bool | Exports the selected object to a XML file | Available | Unused | Available | Available
Get | variant_bool | Get the latest version from the server (editor). | Available | Unused | Available | Available
Import | variant_bool | Imports the selected XML file | Available | Unused | Available | Available
IsCheckedOut | variant_bool | Returns true when the current module checked out by the current user (editor). | Readonly | Unused | Available | Available
IsDifferent | variant_bool | Returns true when the local and server version are different (editor). | Readonly | Unused | Available | Available
IsLocked | variant_bool | Returns true when the current module is Locked by another user (editor). | Readonly | Unused | Available | Available
Item | izenmenu | Returns the menu by name or position | Available | Unused | Available | Available
SingleExport | variant_bool | Exports the Item with given Name oder Index | Available | Unused | Available | Available
UndoCheckOut | variant_bool | Undo module modifications (editor). | Available | Unused | Available | Available


CheckIn
ObjectModel COM [image] ZenMenus [image] Methods [image] CheckIn
Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


CheckOut
ObjectModel COM [image] ZenMenus [image] Methods [image] CheckOut
Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Create
ObjectModel COM [image] ZenMenus [image] Methods [image] Create
Remarks

Creates a context menu or a main menu depending on the "IsPulldown" property of the zMenu object (False = context menu, True = main menu).

Datatype
IZenMenu

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

Example
VBA
Copy
Sub CreateMenus()
Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object
Set zMenus = MyWorkspace.ActiveDocument.ZenMenus
'Creates a context menu
Set zMenu = zMenus.Create("menu_1")
zMenu.IsPulldown = False
'Creates a main menu
Set zMenu = zMenus.Create("menu_2")
zMenu.IsPulldown = True

End Sub


Delete
ObjectModel COM [image] ZenMenus [image] Methods [image] Delete
Remarks

The defined menu will be deleted. As this function works via names there are no seperated properties for context or main menu selection. (context and main menu can not have the same names)

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsName as BSTR

Example
VBA
Copy
Sub DeleteMenus()
Dim zMenus As ZenMenus 'Parent object
Set zMenus = MyWorkspace.ActiveDocument.ZenMenus
'Delete context and main menus via their name
zMenus.Delete ("main_menu")
zMenus.Delete ("context_menu")

End Sub


Export
ObjectModel COM [image] ZenMenus [image] Methods [image] Export
Remarks

Export settings to an xml file

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Get
ObjectModel COM [image] ZenMenus [image] Methods [image] Get
Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Import
ObjectModel COM [image] ZenMenus [image] Methods [image] Import
Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileName as BSTR

Example
VBA
Copy
Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


IsCheckedOut
ObjectModel COM [image] ZenMenus [image] Methods [image] IsCheckedOut
Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsDifferent
ObjectModel COM [image] ZenMenus [image] Methods [image] IsDifferent
Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


IsLocked
ObjectModel COM [image] ZenMenus [image] Methods [image] IsLocked
Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Item
ObjectModel COM [image] ZenMenus [image] Methods [image] Item
Remarks

This function returns a ZenMenu item. If there are more context and main menu items available the counting works like this: Item(0) = "Main_1", Item(1) = "Context_1", Item(2) = "Main_2", …

Datatype
IZenMenu

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vPosition as VARIANT


SingleExport
ObjectModel COM [image] ZenMenus [image] Methods [image] SingleExport
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vIndexOrName as VARIANT

bsFileName as BSTR


UndoCheckOut
ObjectModel COM [image] ZenMenus [image] Methods [image] UndoCheckOut
Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


ZenWorkspace
ObjectModel COM [image] ZenWorkspace
Remarks

This ClassModule represents the actual workspace in the editor.There are several events to react on actions of the projects within the workspace.

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Option Explicit
Private Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Private Const VK_LSHIFT = &HA0
Private Const VK_RSHIFT = &HA1
Private Sub ZenWorkspace_OnPostBuild(ByVal obProject As IProject)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' are created!"
End Sub
Private Sub ZenWorkspace_OnPostTransport(ByVal obProject As IProject, ByVal bSuccess As Boolean)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' were transported succesfully (" & bSuccess & ")!"
End Sub
Private Sub ZenWorkspace_OnPreBuild(ByVal obProject As IProject)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' will be created!"
End Sub
Private Sub ZenWorkspace_OnPreTransport(ByVal obProject As IProject)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' will be transported!"
End Sub
Private Sub ZenWorkspace_OnProjectLoaded(ByVal obProject As IProject)
Debug.Print "Project '" & obProject.Name & "' is loaded!"
End Sub
Private Sub ZenWorkspace_Startup()
If GetAsyncKeyState(VK_LSHIFT) <> 0 Then

SaveSetting "zenOn", "StartupScreen", "ShowOnStartup", "YES"
End If
If GetAsyncKeyState(VK_RSHIFT) <> 0 Then

SaveSetting "zenOn", "StartupScreen", "ShowOnStartup", "YES"
End If
If GetSetting("zenOn", "StartupScreen", "ShowOnStartup", "YES") = "YES" Then

frmStartup.Show
End If
'check vba references...
Call CheckVBAReferences
End Sub
Private Sub ZenWorkspace_OnElementCreated(ByVal obElement As Element)
Dim obMpElem As CD_ManipulationElement
Set obMpElem = New CD_ManipulationElement
Set obMpElem.Parent = Me
Debug.Print "Element of Type " & obElement.Type & " created."
''>> The codeline below will set defaults to elements when they are created.
'obMpElem.SetDefault obElement
''>> The Defaultsettings are located in the classmodule "CD_ManipulationElement"
End Sub
Private Sub ZenWorkspace_OnElementDoubleClicked(ByVal obElement As Element)
'Show Symbol Wizard for linked Symbols,
'if the symbol has outlined properties.
If obElement.Type = 130 Then

'symbol...

If SymbolHasProps(obElement) = True Then

'start wizard...

frmSymbol.InitWizard obElement

frmSymbol.Show

End If
End If
End Sub
Function SymbolHasProps(zELE As Element) As Boolean
Dim v As Variant
Dim i As Integer
Dim s As String
'check DynProperties of Symbol...
v = zELE.DynPropertiesEnum("")
For i = 0 To UBound(v)

s = v(i)

s = Mid(s, 1, InStr(1, s, ",") - 1)

If InStr(1, s, "\") <> 0 Then

SymbolHasProps = True

Exit Function

End If
Next i
End Function
Private Sub ZenWorkspace_OnObjectCreated(ByVal obObject As Object)
'this Event is fired, when a new object is created within a project...
Dim strObjectType As String
Dim obTemplate As Template
Dim obPicture As DynPicture
Dim obFunction As RtFunction
Dim obElement As Element
Dim obUser As User
Dim obRema As Rema
Dim obScript As Script
Dim obEdLimit As EdLimit
Dim obRGMRecipe As RGMRecipe
Dim obRecipe As Recipe
Dim obVarAssignment As VarAssignment
Dim obVariable As Variable
Dim obTimeFunction As TimeFunction
Dim ErrH As Label
On Error GoTo ErrH
'depending to the type of the created object, different actions can be done...
strObjectType = TypeName(obObject)
Select Case strObjectType

Case "ITemplate"

Set obTemplate = obObject

Debug.Print "Template created......> " & obTemplate.Name

Debug.Print "----- in Project......> " & obTemplate.Parent.Parent.Name

Case "IDynPicture"

Set obPicture = obObject

Debug.Print "Picture created.......> " & obPicture.Name

Debug.Print "---- in Project.......> " & obPicture.Parent.Parent.Name

Case "IRtFunction"

Set obFunction = obObject

Debug.Print "Function created......> " & obFunction.Name

Debug.Print "----- in Project......> " & obFunction.Parent.Parent.Name

Case "IElement"

Set obElement = obObject

Debug.Print "Element created.......> " & obElement.Name

Debug.Print "---- in Picture.......> " & obElement.Parent.Parent.Name

Debug.Print "---- in Project.......> " & obElement.Parent.Parent.Parent.Parent.Name

Case "IScript"

Set obScript = obObject

Debug.Print "Script created........> " & obScript.Name

Debug.Print "--- in Project........> " & obScript.Parent.Parent.Name

Case "IRema"

Set obRema = obObject

Debug.Print "REMA created..........> " & obRema.Name

Debug.Print "- in Project..........> " & obRema.Parent.Parent.Name

Case "IUser"

Set obUser = obObject

Debug.Print "User created..........> " & obUser.Name

Debug.Print "- in Project..........> " & obUser.Parent.Parent.Name

Case "IEdLimit"

Set obEdLimit = obObject

Debug.Print "Limit created.........> "

Debug.Print "---- Variable.........> " & obEdLimit.Parent.Name

Debug.Print "-- in Project.........> " & obEdLimit.Parent.Parent.Parent.Name

Case "IRGMRecipe"

Set obRGMRecipe = obObject

Debug.Print "RMG Recipe created....> " & obRGMRecipe.DynProperties("RecipeName")

Debug.Print "----- in RGM Group....> " & obRGMRecipe.Parent.DynProperties("Name")

Debug.Print "------- in Project....> " & obRGMRecipe.Parent.Parent.Parent.Name

Case "IRecipe"

Set obRecipe = obObject

Debug.Print "Recipe created........> " & obRecipe.Name

Debug.Print "--- in Project........> " & obRecipe.Parent.Parent.Name

Case "ITimeFunction"

Set obTimeFunction = obObject

Debug.Print "TimeFunction created..> " & obTimeFunction.Name

Debug.Print "--------- in Project..> " & obTimeFunction.Parent.Parent.Name

Case "IVarAssignment"

Set obVarAssignment = obObject

Debug.Print "VarAssignment created.> " & obVarAssignment.Name

Debug.Print "---------- in Project.> " & obVarAssignment.Parent.Parent.Name

Case "IVariable"

Set obVariable = obObject

Debug.Print "Variable created......> " & obVariable.Name

Debug.Print "----- in Project......> " & obVariable.Parent.Parent.Name

Case Else

Debug.Print strObjectType
End Select
Exit Sub
ErrH:
Debug.Print "[ERROR] " & Err.Number & " - " & Err.Description
Resume Next
End Sub


Properties
ObjectModel COM [image] ZenWorkspace [image] Properties
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ActiveDocument | iproject |  | Readonly | Unused | Available | Available
Application | iapplication |  | Readonly | Unused | Available | Available
LoadedWorkspace | bstr |  | Readonly | Unused | Available | Available
Name | bstr |  | Readonly | Unused | Available | Available
Parent | iapplication |  | Readonly | Unused | Available | Available
Symbols | isymbols | Returns the Symbols object | Readonly | Unused | Available | Available
VBE | idispatch | Returns the VBE-extensibility object | Available | Unused | Available | Available


ActiveDocument
ObjectModel COM [image] ZenWorkspace [image] Properties [image] ActiveDocument
Remarks

Returns the activated project in the workspace as a project object.

Datatype
IProject

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Application
ObjectModel COM [image] ZenWorkspace [image] Properties [image] Application
Remarks

Returns the Application object of the editor...

Datatype
IApplication

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


LoadedWorkspace
ObjectModel COM [image] ZenWorkspace [image] Properties [image] LoadedWorkspace
Remarks

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Name
ObjectModel COM [image] ZenWorkspace [image] Properties [image] Name
Remarks

Returns the name of the ClassModule 'MyWorkspace' Always 'MyWorkspace'

Datatype
BSTR

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Parent
ObjectModel COM [image] ZenWorkspace [image] Properties [image] Parent
Remarks

Returns the parent object

Datatype
IApplication

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


Symbols
ObjectModel COM [image] ZenWorkspace [image] Properties [image] Symbols
Remarks

Datatype
ISymbols

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available


VBE
ObjectModel COM [image] ZenWorkspace [image] Properties [image] VBE
Remarks

Returns the VBE-extensibility object

Datatype
IDispatch

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


Methods
ObjectModel COM [image] ZenWorkspace [image] Methods
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ActivateProject | variant_bool | - | Available | Unused | Available | Available
CloseWorkspace | variant_bool | Closes the workspace. | Available | Unused | Available | Available
CopyProject | variant_bool | Creates a copy of the given Project at the given location. | Available | Unused | Available | Available
CreateBackup | variant_bool | Creates a backup of the currently workspace. | Available | Unused | Available | Available
CreateProjectBackup | variant_bool | Create a backup of the given project. | Available | Unused | Available | Available
CreateWorkspace | variant_bool | Creates a new workspace with the given name at the given location. | Available | Unused | Available | Available
GetArvTemplates | iarvtemplates | Returns a collection of Archive templates (either by name or by index). | Available | Unused | Available | Available
GetMDiTemplates | imditemplates | Returns a collection of MDI templates of the specified type (either by name or by index). | Available | Unused | Available | Available
InsertProject | variant_bool | Inserts the given project into the workspace. | Available | Unused | Available | Available
LoadProject | variant_bool | - | Available | Unused | Available | Available
LoadProjectByName | variant_bool | Loads the given project by Name. | Available | Unused | Available | Available
LoadWorkspace | variant_bool | Loads the given workspace file. | Available | Unused | Available | Available
RemoveProject | variant_bool | Removes the given project from the workspace. | Available | Unused | Available | Available
RestoreBackup | variant_bool | Restores the given workspace backup. | Available | Unused | Available | Available
RestoreProjectBackup | variant_bool | Restores the given backup. | Available | Unused | Available | Available
SaveWorkspace | variant_bool | Saves the current workspace. | Available | Unused | Available | Available
SetStartProject | variant_bool | - | Available | Unused | Available | Available
UnloadedProjects [GET] | variant | Returns a list of all unloaded projects available in the current workspace. | Available | Unused | Available | Available
UnloadProject | variant_bool | - | Available | Unused | Available | Available


ActivateProject
ObjectModel COM [image] ZenWorkspace [image] Methods [image] ActivateProject
Remarks

Activates a project in the workspace over its uniqe GUID.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsGuid as BSTR


CloseWorkspace
ObjectModel COM [image] ZenWorkspace [image] Methods [image] CloseWorkspace
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bHideCompileDialog as VARIANT_BOOL


CopyProject
ObjectModel COM [image] ZenWorkspace [image] Methods [image] CopyProject
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsSource as BSTR

bsDestinationName as BSTR


CreateBackup
ObjectModel COM [image] ZenWorkspace [image] Methods [image] CreateBackup
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileAndLocation as BSTR


CreateProjectBackup
ObjectModel COM [image] ZenWorkspace [image] Methods [image] CreateProjectBackup
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsProjectName as BSTR

bsFileAndLocation as BSTR

bsDescription as BSTR

bOverwrite as VARIANT_BOOL


CreateWorkspace
ObjectModel COM [image] ZenWorkspace [image] Methods [image] CreateWorkspace
Remarks

- opens the desired dialog if an empty parameter is passed.- creates a new workspace directly (without dialog) if a valid file path parameter (*.wsp6) is passed

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileAndLocation as BSTR

file path parameter

Example
VBA
Copy
Public Sub createNewWsp_Dialog()
Const strWspPath = ""
Dim bRet As Boolean
    bRet = MyWorkspace.CreateWorkspace(strWspPath)
    If bRet Then
        Debug.Print "Workspace created successfully"
    End If
End Sub


GetArvTemplates
ObjectModel COM [image] ZenWorkspace [image] Methods [image] GetArvTemplates
Remarks

Return a ArvTemplate collection.

Datatype
IArvTemplates

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Private Sub GetTemplates()
    Dim IArvTemplates As ArvTemplates
    Dim IArvTemplate As ArvTemplate
    Dim Count As Integer
    Dim Ok As Boolean
    ' --- Auswahl über den Namen
    Set IArvTemplates = MyWorkspace.GetArvTemplates()
    If Not IArvTemplates Is Nothing Then
        Set IArvTemplate = IArvTemplates.Item("Test 3")
        Ok = PrintTemplate(IArvTemplate)
    End If
    ' --- Auswahl über den Index
    Set IArvTemplates = MyWorkspace.GetArvTemplates()
    If Not IArvTemplates Is Nothing Then
        Count = IArvTemplates.Count
        For i = 0 To Count - 1
            Set IArvTemplate = IArvTemplates.Item(i)
            Ok = PrintTemplate(IArvTemplate)
        Next
    End If
End Sub
Private Function PrintTemplate(IArvTemplate As ArvTemplate) As Boolean
    If Not IArvTemplate Is Nothing Then
        Debug.Print ("Name: " & IArvTemplate.DynProperties("Name"))
        Debug.Print ("GUID: " & IArvTemplate.DynProperties("GUID"))
        Debug.Print ("ImportPath: " & IArvTemplate.DynProperties("ImportPath"))
        Debug.Print ("Folder: " & IArvTemplate.DynProperties("Folder"))
        Debug.Print ("Language: " & IArvTemplate.DynProperties("Language"))
        Debug.Print ("Description: " & IArvTemplate.DynProperties("Description"))
        Debug.Print ("CopaDataTemplate: " & IArvTemplate.DynProperties("CopaDataTemplate"))
        PrintTemplate = True
    Else
        PrintTemplate = False
    End If
End Function


GetMDiTemplates
ObjectModel COM [image] ZenWorkspace [image] Methods [image] GetMDiTemplates
Remarks

Datatype
IMDITemplates

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
vType as VARIANT


InsertProject
ObjectModel COM [image] ZenWorkspace [image] Methods [image] InsertProject
Remarks

opens the desired dialog if one of the passed parameter is emptyproject is inserted directly (without dialog) to the current loaded workspace if valid parameters are passed (ID_PROJEKT_GUID, ID_PROJEKT_NAME, localhost)

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsGuid as BSTR

Project GUID

bsName as BSTR

Project name

bsHost as BSTR

Host name

Example
VBA
Copy
Public Sub insertPrj_Dialog()
Const strGuid = ""
Const strName = ""
Const strHost = ""
Dim bRet As Boolean
    bRet = MyWorkspace.InsertProject(strGuid, strName, strHost)
    If bRet Then
        Debug.Print "Project inserted successfully"
    End If
End Sub


LoadProject
ObjectModel COM [image] ZenWorkspace [image] Methods [image] LoadProject
Remarks

Loads a project in the workspace over its uniqe GUID.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsGuid as BSTR


LoadProjectByName
ObjectModel COM [image] ZenWorkspace [image] Methods [image] LoadProjectByName
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsProjectName as BSTR


LoadWorkspace
ObjectModel COM [image] ZenWorkspace [image] Methods [image] LoadWorkspace
Remarks

opens the desired dialog if an empty parameter is passedopens an existing workspace directly (without dialog) if a valid file path parameter (*.wsp6) is passed

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileAndLocation as BSTR

File path parameter.

Example
VBA
Copy
Public Sub loadWsp_Dialog()
Const strWspPath = ""
Dim bRet As Boolean
    bRet = MyWorkspace.LoadWorkspace(strWspPath)
    If bRet Then
        Debug.Print "Workspace loaded successfully"
    End If
End Sub


RemoveProject
ObjectModel COM [image] ZenWorkspace [image] Methods [image] RemoveProject
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsProjectName as BSTR


RestoreBackup
ObjectModel COM [image] ZenWorkspace [image] Methods [image] RestoreBackup
Remarks

opens the desired dialog if an empty parameter is passedworkspace backup is restored directly (without dialog) if a valid file path parameter for the workspace file (*.wsp6) as well a valid file path parameter for the workspace backup is passed

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileAndLocation as BSTR

File path parameter for the workspace file.

bsWorkspaceLocation as BSTR

File path parameter for the workspace backup.

Example
VBA
Copy
Public Sub restoreWspBkp_Dialog()
Const strWspPath = ""
Const strWsbPath = ""
Dim bRet As Boolean
    bRet = MyWorkspace.RestoreBackup(strWspPath, strWspPath)
    If bRet Then
        Debug.Print "Workspace backup restored successfully"
    End If
End Sub


RestoreProjectBackup
ObjectModel COM [image] ZenWorkspace [image] Methods [image] RestoreProjectBackup
Remarks

opens the desired dialog when if an empty parameter is passedproject backup is restored directly (without dialog) if a valid file path parameter for the project backup file (*.zip) is passed

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsFileAndLocation as BSTR

File path parameter.

Example
VBA
Copy
Public Sub restorePrjBkp_Dialog()
Const strBkpPath = ""
Dim bRet As Boolean
    bRet = MyWorkspace.RestoreProjectBackup(strBkpPath)
    If bRet Then
        Debug.Print "Project backup restored successfully"
    End If
End Sub


SaveWorkspace
ObjectModel COM [image] ZenWorkspace [image] Methods [image] SaveWorkspace
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


SetStartProject
ObjectModel COM [image] ZenWorkspace [image] Methods [image] SetStartProject
Remarks

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsGuid as BSTR


UnloadedProjects [GET]
ObjectModel COM [image] ZenWorkspace [image] Methods [image] UnloadedProjects [GET]
Remarks

Datatype
VARIANT

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


UnloadProject
ObjectModel COM [image] ZenWorkspace [image] Methods [image] UnloadProject
Remarks

Unloads a project in the workspace over its uniqe GUID.

Datatype
VARIANT_BOOL

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsGuid as BSTR


Events
ObjectModel COM [image] ZenWorkspace [image] Events
Overview
Name | Type | Description | Editor | Runtime | VBA | VSTA
ActiveProjectChanged | void |  | Available | Unused | Available | Available
OnElementCreated | void |  | Readonly | Unused | Available | Available
OnElementDeleted | void |  | Available | Unused | Available | Available
OnElementDoubleClicked | void |  | Available | Unused | Available | Available
OnObjectCreated | void |  | Available | Unused | Available | Available
OnPostBackupProject | void | Event is fired after a project backup has been created. | Available | Unused | Available | Available
OnPostBuild | void | Event is fired after a project is compiled | Available | Unused | Available | Available
OnPostObjectDeleted | void |  | Available | Unused | Available | Available
OnPostRestoreProject | void | Event is fired after a project backup has been restored. | Available | Unused | Available | Available
OnPostTransport | void | Event is fired after a project is transported | Available | Unused | Available | Available
OnPostVSTAUpdate | void | For internal use only | Unused | Unused | Available | Available
OnPreBackupProject | void | Event is fired before a project backup is about to be created. | Available | Unused | Available | Available
OnPreBuild | void | Event is fired before a project is compiled | Available | Unused | Available | Available
OnPreProjectUnload | void | Event is fired when a project is about to be unloaded (editor only). | Available | Unused | Available | Available
OnPreRestoreProject | void | Event is fired before a project backup is about to be restored. | Available | Unused | Available | Available
OnPreTransport | void | Event is fired before a project is transported | Available | Unused | Available | Available
OnPreVSTADebugStart | void | For internal use only | Unused | Unused | Available | Available
OnPreVSTADebugStop | void | For internal use only | Unused | Unused | Available | Available
OnPreVSTAUpdate | void | For internal use only | Unused | Unused | Available | Available
OnProjectLoaded | void | Event is fired when a project has been loaded (editor only). | Available | Unused | Available | Available
OnRTConnect | void | Event is fired when a remote transport connection has been established. | Available | Unused | Available | Available
OnRTConnectionFailed | void | Event is fired when a connection timeout has occured, and a remote transport connection could not be established. | Available | Unused | Available | Available
OnRTConnectionTerminated | void | Event is fired when a remote transport connection has been terminated. | Available | Unused | Available | Available
OnVSTADebugStart | void | For internal use only | Unused | Unused | Available | Available
OnVSTADebugStopped | void | For internal use only | Unused | Unused | Available | Available
OnWorkspaceExit | void |  | Available | Unused | Available | Available
OnWorkspaceStartup | void |  | Available | Unused | Available | Available
WorkspaceChanged | void |  | Available | Unused | Available | Available


ActiveProjectChanged
ObjectModel COM [image] ZenWorkspace [image] Events [image] ActiveProjectChanged
Remarks

Is triggered after the active project in the workspace has changed in the zenon Editor.The new active project object is passed.This event is also fired on starting the zenon editor together with loading a workspace.SummaryIs triggered after the active project in the workspace has changed in the zenon Editor.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
p_project as IProject

Example
VBA
Copy
Private Sub ZenWorkspace_ActiveProjectChanged(ByVal obProject As IProject)
    Debug.Print "Active project in workspace has changed: " & obProject.Name
End Sub


OnElementCreated
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnElementCreated
Remarks

This event is fired, when a new element is created within a picture.

Datatype
void

Availability
Environment | Availability
Editor | Readonly
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
obElement as IElement

Example
VBA
Copy
Private Sub ZenWorkspace_OnElementCreated(ByVal obElement As Element)
Dim obMpElem As CD_ManipulationElement
Set obMpElem = New CD_ManipulationElement
Set obMpElem.Parent = Me
Debug.Print "Element of Type " & obElement.Type & " created."
''>> The codeline below will set defaults to elements when they are created.
'obMpElem.SetDefault obElement
''>> The Defaultsettings are located in the classmodule "CD_ManipulationElement"
End Sub


OnElementDeleted
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnElementDeleted
Remarks

This event is fired, when a element is deleted within a picture.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
obElement as IElement


OnElementDoubleClicked
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnElementDoubleClicked
Remarks

This event is fired, when a element has been double-clicked.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
obElement as IElement


OnObjectCreated
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnObjectCreated
Remarks

This event is fired when a new object is created.A new object could be:

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
obObject as IDispatch

Example
VBA
Copy
Private Sub ZenWorkspace_OnObjectCreated(ByVal obObject As Object)
'this Event is fired, when a new object is created within a project...
Dim strObjectType As String
Dim obTemplate As Template
Dim obPicture As DynPicture
Dim obFunction As RtFunction
Dim obElement As Element
Dim obUser As User
Dim obRema As Rema
Dim obScript As Script
Dim obEdLimit As EdLimit
Dim obRGMRecipe As RGMRecipe
Dim obRecipe As Recipe
Dim obVarAssignment As VarAssignment
Dim obVariable As Variable
Dim obTimeFunction As TimeFunction
Dim ErrH As Label
On Error GoTo ErrH
'depending to the type of the created object, different actions can be done...
strObjectType = TypeName(obObject)
Select Case strObjectType

Case "ITemplate"

Set obTemplate = obObject

Debug.Print "Template created......> " & obTemplate.Name

Debug.Print "----- in Project......> " & obTemplate.Parent.Parent.Name

Case "IDynPicture"

Set obPicture = obObject

Debug.Print "Picture created.......> " & obPicture.Name

Debug.Print "---- in Project.......> " & obPicture.Parent.Parent.Name

Case "IRtFunction"

Set obFunction = obObject

Debug.Print "Function created......> " & obFunction.Name

Debug.Print "----- in Project......> " & obFunction.Parent.Parent.Name

Case "IElement"

Set obElement = obObject

Debug.Print "Element created.......> " & obElement.Name

Debug.Print "---- in Picture.......> " & obElement.Parent.Parent.Name

Debug.Print "---- in Project.......> " & obElement.Parent.Parent.Parent.Parent.Name

Case "IScript"

Set obScript = obObject

Debug.Print "Script created........> " & obScript.Name

Debug.Print "--- in Project........> " & obScript.Parent.Parent.Name

Case "IRema"

Set obRema = obObject

Debug.Print "REMA created..........> " & obRema.Name

Debug.Print "- in Project..........> " & obRema.Parent.Parent.Name

Case "IUser"

Set obUser = obObject

Debug.Print "User created..........> " & obUser.Name

Debug.Print "- in Project..........> " & obUser.Parent.Parent.Name

Case "IEdLimit"

Set obEdLimit = obObject

Debug.Print "Limit created.........> "

Debug.Print "---- Variable.........> " & obEdLimit.Parent.Name

Debug.Print "-- in Project.........> " & obEdLimit.Parent.Parent.Parent.Name

Case "IRGMRecipe"

Set obRGMRecipe = obObject

Debug.Print "RMG Recipe created....> " & obRGMRecipe.DynProperties("RecipeName")

Debug.Print "----- in RGM Group....> " & obRGMRecipe.Parent.DynProperties("Name")

Debug.Print "------- in Project....> " & obRGMRecipe.Parent.Parent.Parent.Name

Case "IRecipe"

Set obRecipe = obObject

Debug.Print "Recipe created........> " & obRecipe.Name

Debug.Print "--- in Project........> " & obRecipe.Parent.Parent.Name

Case "ITimeFunction"

Set obTimeFunction = obObject

Debug.Print "TimeFunction created..> " & obTimeFunction.Name

Debug.Print "--------- in Project..> " & obTimeFunction.Parent.Parent.Name

Case "IVarAssignment"

Set obVarAssignment = obObject

Debug.Print "VarAssignment created.> " & obVarAssignment.Name

Debug.Print "---------- in Project.> " & obVarAssignment.Parent.Parent.Name

Case "IVariable"

Set obVariable = obObject

Debug.Print "Variable created......> " & obVariable.Name

Debug.Print "----- in Project......> " & obVariable.Parent.Parent.Name

Case Else

Debug.Print strObjectType
End Select
Exit Sub
ErrH:
Debug.Print "[ERROR] " & Err.Number & " - " & Err.Description
Resume Next
End Sub


OnPostBackupProject
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnPostBackupProject
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsGuid as BSTR

bsName as BSTR

bsFile as BSTR

bSuccess as VARIANT_BOOL


OnPostBuild
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnPostBuild
Remarks

This event is fired, when the runtimefiles for a project were built.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
obProject as IProject

Example
VBA
Copy
Private Sub ZenWorkspace_OnPostBuild(ByVal obProject As IProject)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' are created!"
End Sub


OnPostObjectDeleted
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnPostObjectDeleted
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
obParent as IDispatch

bsName as BSTR


OnPostRestoreProject
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnPostRestoreProject
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsGuid as BSTR

bsName as BSTR

bsFile as BSTR

bSuccess as VARIANT_BOOL


OnPostTransport
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnPostTransport
Remarks

This event is fired, when the runtimefiles have been transported to a remote pc.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
obProject as IProject

bSuccess as VARIANT_BOOL

Example
VBA
Copy
Private Sub ZenWorkspace_OnPostTransport(ByVal obProject As IProject, ByVal bSuccess As Boolean)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' were transported succesfully (" & bSuccess & ")!"
End Sub


OnPostVSTAUpdate
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnPostVSTAUpdate
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


OnPreBackupProject
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnPreBackupProject
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsGuid as BSTR

bsName as BSTR

bsFile as BSTR


OnPreBuild
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnPreBuild
Remarks

This event is fired, when the runtimefiles for a project will be built.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
obProject as IProject

Example
VBA
Copy
Private Sub ZenWorkspace_OnPreBuild(ByVal obProject As IProject)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' will be created!"
End Sub


OnPreProjectUnload
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnPreProjectUnload
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
obProject as IProject


OnPreRestoreProject
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnPreRestoreProject
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
bsGuid as BSTR

bsName as BSTR

bsFile as BSTR


OnPreTransport
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnPreTransport
Remarks

This event is fired, when the runtimefiles should be transported to a remote pc.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
obProject as IProject

Example
VBA
Copy
Private Sub ZenWorkspace_OnPreTransport(ByVal obProject As IProject)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' will be transported!"
End Sub


OnPreVSTADebugStart
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnPreVSTADebugStart
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


OnPreVSTADebugStop
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnPreVSTADebugStop
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


OnPreVSTAUpdate
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnPreVSTAUpdate
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


OnProjectLoaded
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnProjectLoaded
Remarks

This event is fired, when a project was loaded.

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
obProject as IProject


OnRTConnect
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnRTConnect
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
obProject as IProject


OnRTConnectionFailed
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnRTConnectionFailed
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
obProject as IProject


OnRTConnectionTerminated
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnRTConnectionTerminated
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
obProject as IProject


OnVSTADebugStart
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnVSTADebugStart
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


OnVSTADebugStopped
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnVSTADebugStopped
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Unused
Runtime | Unused
VBA | Available
VSTA | Available


OnWorkspaceExit
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnWorkspaceExit
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available


OnWorkspaceStartup
ObjectModel COM [image] ZenWorkspace [image] Events [image] OnWorkspaceStartup
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Example
VBA
Copy
Private Sub ZenWorkspace_OnWorkspaceStartup()
If GetAsyncKeyState(VK_LSHIFT) <> 0 Then

SaveSetting "zenOn", "StartupScreen", "ShowOnStartup", "YES"
End If
If GetAsyncKeyState(VK_RSHIFT) <> 0 Then

SaveSetting "zenOn", "StartupScreen", "ShowOnStartup", "YES"
End If
If GetSetting("zenOn", "StartupScreen", "ShowOnStartup", "YES") = "YES" Then

frmStartup.Show
End If
'check vba references...
Call CheckVBAReferences
End Sub


WorkspaceChanged
ObjectModel COM [image] ZenWorkspace [image] Events [image] WorkspaceChanged
Remarks

Datatype
void

Availability
Environment | Availability
Editor | Available
Runtime | Unused
VBA | Available
VSTA | Available
Parameters
p_filePath as BSTR